#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "ebebbdf31e78362af099d4a09ba52e11d415ff8e";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragme noTypeChecks",
  "#pragma ExtendedLineups",
  "import \"util\" as util",
  "import \"identifierKinds\" as k",
  "",
  "// This module contains classes and pseudo-classes for all the AST nodes used",
  "// in the parser. Because of the limitations of the class syntax, classes that",
  "// need more than one method are written as object literals containing methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is given by type ASTNode",
  "//",
  "// Most nodes also contain a \"value\" field, with varied type, holding the `main value`",
  "// in the node.  This field is confusing and should be appropriately re-named in",
  "// each case. Some nodes contain other fields for their specific use: while has",
  "// both a value (the condition) and a body, for example.",
  "",
  "def lineLength is public = 80",
  "def uninitialized = Singleton.named \"uninitialized\"",
  "method listMap(l, b) ancestors(as) is confidential {",
  "    def newList = [ ]",
  "    l.do { nd -> newList.addLast(nd.map(b) ancestors(as)) }",
  "    newList",
  "}",
  "method maybeMap(n, b) ancestors(as) is confidential {",
  "    if (false != n) then {",
  "        n.map(b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "method maybeListMap(n, b) ancestors(as) is confidential {",
  "    if (false != n) then {",
  "        listMap(n, b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "",
  "def ancestorChain = object {",
  "    class empty {",
  "        method isEmpty { true }",
  "        method asString { \"ancestorChain ▫\" }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "    method with(n) { empty.extend(n) }",
  "    class cons(p) onto(as) is confidential {",
  "        method forebears { as }",
  "        method isEmpty { false }",
  "        method parent { p }",
  "        method grandparent { forebears.parent }",
  "",
  "        method asString {",
  "            var a := self",
  "            var s := \"ancestorChain \"",
  "            while { a.isEmpty.not } do {",
  "                s := s ++ a.parent ++ \"➤\"",
  "                a := a.forebears",
  "            }",
  "            s ++ \"▫\"",
  "        }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "}",
  "",
  "def emptySeq = emptySequence",
  "",
  "type AstNode = type {",
  "    kind -> String",
  "        // Used for pseudo-instanceof tests.",
  "    register -> String",
  "        // Used in the code generator on to name the resulting object",
  "    line -> Number",
  "        // The source line the node came from",
  "    line:=(ln:Number)",
  "    linePos -> Number",
  "    linePos:=(lp:Number)",
  "    scope -> SymbolTable",
  "        // The symbolTable for names defined in this node and its sub-nodes",
  "    pretty(n:Number) -> String",
  "        // Pretty-print-string of node at depth n",
  "    comments -> AstNode",
  "        // Comments associated with this node",
  "}",
  "",
  "type SymbolTable = Unknown",
  "",
  "class baseNode {",
  "    // the superclass of all AST nodes",
  "    var register is public := \"\"",
  "    var line is public := util.linenum",
  "    var linePos is public := util.linepos",
  "    var symbolTable := fakeSymbolTable",
  "    var comments is public := false",
  "",
  "    method setLine (l) col (c) {",
  "        line := l",
  "        linePos := c",
  "        self",
  "    }",
  "    method setPositionFrom (token) {",
  "        line := token.line",
  "        linePos := token.linePos",
  "        self",
  "    }",
  "    method kind { abstract }",
  "    method ==(other) { self.isMe(other) }       // for usesAsType",
  "    method isAppliedOccurenceOfIdentifier { false }",
  "    method isMatchingBlock { false }",
  "    method isFieldDec { false }",
  "    method isInherits { false }",
  "    method isLegalInTrait { false }",
  "    method isMember { false }",
  "    method isMethod { false }",
  "    method isExecutable { true }",
  "    method isCall { false }",
  "    method isComment { false }",
  "    method isClass { false }    // is a method that returns a fresh object",
  "    method inClass { false }    // object in a syntactic class definiton",
  "    method isTrait { false }    // is a method that returns a trait object",
  "    method inTrait { false }    // object in a syntactic trait definition",
  "    method isBind { false }",
  "    method isSelf { false }",
  "    method isSuper { false }",
  "    method isPrelude { false }",
  "    method isOuter { false }",
  "    method isBlock { false }",
  "    method isObject { false }",
  "    method isIdentifier { false }",
  "    method isDialect { false }",
  "    method isImport { false }",
  "    method isTypeDec { false }",
  "    method isExternal { false }",
  "    method canInherit { false }",
  "    method returnsObject { false }",
  "    method isImplicit { false }",
  "    method usesAsType(aNode) { false }",
  "    method hash { line.hash * linePos.hash }",
  "    method asString { \"{kind} {nameString}\" }",
  "    method nameString { \"?\" }",
  "    method isWritable { true }",
  "    method isReadable { true }",
  "    method isPublic { true }",
  "    method isConfidential { isPublic.not }",
  "    method decType {",
  "        if (false == self.dtype) then {",
  "            return unknownType",
  "        }",
  "        return self.dtype",
  "    }",
  "    method isSimple { true }  // needs no parens when used as receiver",
  "    method isDelimited { false }  // needs no parens when used as argument",
  "    method description { kind }",
  "    method accept(visitor) {",
  "        self.accept(visitor) from (ancestorChain.empty)",
  "    }",
  "    method scope { symbolTable }",
  "",
  "    method scope:=(st) {",
  "        // override this method in subobjects that open a new scope. In such",
  "        // subobjects, and only in such subobjects, there should be a 2-way",
  "        // conection between the node and the symbol table that defines its scope.",
  "        symbolTable := st",
  "    }",
  "",
  "    method shallowCopyFieldsFrom(other) {",
  "        register := other.register",
  "        line := other.line",
  "        linePos := other.linePos",
  "        scope := other.scope",
  "        self",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        if ((scope.node == self) && {util.target == \"symbols\"}) then {",
  "            \"{line}:{linePos} {description}\\n{spc}Symbols({scope.variety}): {scope}{scope.elementScopesAsString}\"",
  "        } elseif {scope.variety == \"fake\"} then {",
  "            \"{line}:{linePos} {description}\"",
  "        } else {",
  "            \"{line}:{linePos} {description} {scope.asDebugString}\"",
  "        }",
  "    }",
  "    method deepCopy {",
  "        self.map { each -> each } ancestors(ancestorChain.empty)",
  "    }",
  "    method enclosingObject {",
  "        def obj = scope.enclosingObjectScope.node",
  "        obj",
  "    }",
  "    method addComment(cmtNode) {",
  "        if (false == comments) then {",
  "            comments := cmtNode",
  "        } else {",
  "            comments.extendCommentUsing(cmtNode)",
  "        }",
  "    }",
  "    method addComments(cmtNodeList) {",
  "        cmtNodeList.do { each -> addComment(each) }",
  "    }",
  "    method statementName { kind }",
  "}",
  "",
  "def implicit is public = object {",
  "    inherits baseNode",
  "    line := 0",
  "    linePos := 0",
  "    def kind is public = \"implicit\"",
  "    def nameString is public = \"implicit\"",
  "    method isImplicit { true }",
  "    method toGrace(depth) { \"implicit\" }",
  "    method asString { \"the implicit receiver\" }",
  "    method == (other) { self.isMe(other) }",
  "    method map(blk) ancestors(as) { self }",
  "    method accept(visitor) from (as) {",
  "        visitor.visitImplicit(self) up (as)",
  "    }",
  "    method pretty(depth) { \"implicit\" }",
  "}",
  "",
  "def nullNode is public = object {",
  "    inherits baseNode",
  "    def kind is public = \"null\"",
  "    method toGrace(depth) {",
  "        \"// null\"",
  "    }",
  "    method asString { \"the nullNode\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "def fakeSymbolTable = object {",
  "    var node is public := nullNode",
  "    method asString { \"the fakeSymbolTable\" }",
  "    method addNode (n) as (kind) {",
  "        ProgrammingError.raise \"fakeSymbolTable(on node {node}).addNode({n}) as \\\"{kind}\\\" requested\"",
  "    }",
  "    method thatDefines (name) ifNone (action) {",
  "        ProgrammingError.raise \"fakeSymbolTable.thatDefines({name}).\"",
  "    }",
  "    method enclosingObjectScope {",
  "        ProgrammingError.raise \"fakeSymbolTable.enclosingObjectScope on node {node}\"",
  "    }",
  "    method variety { \"fake\" }",
  "    method ==(other) { self.isMe(other) }",
  "}",
  "",
  "def ifNode is public = object {",
  "  class new(cond, thenblock', elseblock') {",
  "    inherits baseNode",
  "    def kind is public = \"if\"",
  "    var value is public := cond",
  "    var thenblock is public := thenblock'",
  "    var elseblock is public := elseblock'",
  "    var handledIdentifiers is public := false",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitIf(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            value.accept(visitor) from(newChain)",
  "            thenblock.accept(visitor) from(newChain)",
  "            elseblock.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.thenblock := thenblock.map(blk) ancestors(newChain)",
  "        n.elseblock := elseblock.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ spc ++ \"Then: {thenblock.pretty(depth+2)}\\n\"",
  "            s := s ++ spc ++ \"Else: {elseblock.pretty(depth+2)}\"",
  "        } else {",
  "            s := s ++ spc ++ \"Then:\"",
  "            for (self.thenblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Else:\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock.body) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.isntEmpty) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        ifNode.new(nullNode, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        handledIdentifiers := other.handledIdentifiers",
  "        self",
  "    }",
  "  }",
  "}",
  "def blockNode is public = object {",
  "  class new(params', body') {",
  "    inherits baseNode",
  "    def kind is public = \"block\"",
  "    def value is public = \"block\"",
  "    var params is public := params'",
  "    var body is public := body'",
  "    def selfclosure is public = true",
  "    var matchingPattern is public := false",
  "    var extraRuntimeData is public := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor) from(ancestorChain.with(self))",
  "    }",
  "    method isBlock { true }",
  "    method isDelimited { true }",
  "    method isEmpty { body.size == 0 }",
  "    method isntEmpty { body.size > 0 }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.parameter }",
  "    method isMatchingBlock { params.size == 1 }",
  "    method returnsObject {",
  "        (body.size > 0) && { body.last.returnsObject }",
  "    }",
  "    method returnedObjectScope {",
  "        // precondition: returnsObject",
  "        body.last.returnedObjectScope",
  "    }",
  "    method parametersDo(b) {",
  "        params.do(b)",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBlock(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.matchingPattern) then {",
  "                self.matchingPattern.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        n.body := listMap(body, blk) ancestors(newChain)",
  "        n.matchingPattern := maybeMap(matchingPattern, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+1)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+1)",
  "        }",
  "        if (false != self.matchingPattern) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params.at(i)",
  "                if (false != self.matchingPattern) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" →\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        repeat (depth - 1) times { s := s ++ \"    \" }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        blockNode.new(params, body).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        matchingPattern := other.matchingPattern",
  "        extraRuntimeData := other.extraRuntimeData",
  "        self",
  "    }",
  "  }",
  "}",
  "def tryCatchNode is public = object {",
  "  class new(block, cases', finally') {",
  "    inherits baseNode",
  "    def kind is public = \"trycatch\"",
  "    var value is public := block",
  "    var cases is public := cases'",
  "    var finally is public := finally'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTryCatch(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.finally) then {",
  "                self.finally.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.finally := maybeMap(finally, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"try \" ++ self.value.toGrace(depth + 1) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"catch \" ++ case.toGrace(depth + 1)",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        tryCatchNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def matchCaseNode is public = object {",
  "  class new(matchee', cases', elsecase') {",
  "    inherits baseNode",
  "    def kind is public = \"matchcase\"",
  "    var value is public := matchee'",
  "    var cases is public := cases'",
  "    var elsecase is public := elsecase'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method matchee { value }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMatchCase(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.elsecase) then {",
  "                self.elsecase.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.elsecase := maybeMap(elsecase, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n{spc}Else:\\n{spc}  {self.elsecase.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"else \" ++ self.elsecase.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        matchCaseNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def methodTypeNode is public = object {",
  "  class new(signature', rtype') {",
  "    // Represents the signature of a method in a type literal",
  "    // signature' is an Iterable of requestPart objects, which contain",
  "    // the parts of the name and the parameter lists.",
  "",
  "    inherits baseNode",
  "    def kind is public = \"methodtype\"",
  "    var signature is public := signature'",
  "    var rtype is public := rtype'",
  "    var typeParams is public := false",
  "    var cachedIdentifier := uninitialized",
  "",
  "    method nameString {",
  "        signature.fold { acc, each -> acc ++ each.nameString }",
  "            startingWith \"\"",
  "    }",
  "    method value {",
  "        if (uninitialized == cachedIdentifier) then {",
  "            cachedIdentifier := identifierNode.new(nameString, false)",
  "            cachedIdentifier.line := signature.first.line",
  "            cachedIdentifier.linePos := signature.first.linePos",
  "            cachedIdentifier.isBindingOccurrence := true",
  "        }",
  "        cachedIdentifier",
  "    }",
  "    method isExecutable { false }",
  "    method parametersDo(b) {",
  "        signature.do { part ->",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the symbol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMethodType(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            if (false != rtype) then {",
  "                rtype.accept(visitor) from(newChain)",
  "            }",
  "            for (signature) do { part ->",
  "                part.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.rtype := maybeMap(rtype, blk) ancestors(newChain)",
  "        n.signature := listMap(signature, blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (false != rtype) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\"",
  "        }",
  "        if (false != typeParams) then {",
  "            s := \"{s}\\n{spc}TypeParams:\\n\"",
  "            s := s ++ typeParams.pretty(depth + 2)",
  "        }",
  "        s := \"{s}\\n{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}{part.pretty(depth + 2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        signature.do { part -> s:= s ++ part.toGrace(depth + 1) }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        methodTypeNode.new(signature, rtype).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def typeLiteralNode is public = object {",
  "  class new(methods', types') {",
  "    inherits baseNode",
  "    def kind is public = \"typeliteral\"",
  "    var methods is public := methods'",
  "    var types is public := types'",
  "    var nominal is public := false",
  "    var anonymous is public := true",
  "    var value is public := \"‹anon›\"",
  "",
  "    method name { value }",
  "    method name:=(n) {",
  "        value := n",
  "        anonymous := false",
  "    }",
  "    method asString {",
  "        \"typeliteral: methods = {methods}, types = {types}\"",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method isExecutable { false }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeLiteral(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.methods) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "            for (self.types) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.methods := listMap(methods, blk) ancestors (as)",
  "        n.types := listMap(types, blk) ancestors (as)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ \"Types:\"",
  "        for (types) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Methods:\"",
  "        for (methods) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"type\"",
  "        s := s ++ \" = \\{\"",
  "        for (self.methods) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        for (self.types) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        typeLiteralNode.new(emptySeq, emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        nominal := other.nominal",
  "        anonymous := other.anonymous",
  "        value := other.value",
  "        self",
  "    }",
  "  }",
  "}",
  "",
  "def typeDecNode is public = object {",
  "  class new(name', typeValue) {",
  "    inherits baseNode",
  "    def kind is public = \"typedec\"",
  "    var name is public := name'",
  "    var value is public := typeValue",
  "    def nameString is public = name.value",
  "    var annotations is public := [ ]",
  "    var typeParams is public := false",
  "",
  "    method isLegalInTrait { true }",
  "    method isTypeDec { true }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "",
  "    method isExecutable { true }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "    method isConfidential {",
  "        if (annotations.size == 0) then { return false }",
  "        findAnnotation(self, \"confidential\")",
  "    }",
  "    method isPublic { isConfidential.not }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            name.accept(visitor) from(newChain)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            annotations.do { each -> each.accept(visitor) from(newChain) }",
  "            value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1) ++ \"\\n\"",
  "        if (false != typeParams) then {",
  "            s := \"{s}{spc}Type parameters:\\n{typeParams.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Value:\"",
  "        s := s ++ value.pretty(depth+2)",
  "        s := s ++ \"\\n\"",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        s := \"type {self.name}\"",
  "        if (false != typeParams) then {",
  "            typeParams.toGrace(0)",
  "        }",
  "        s ++ \" = \" ++ value.toGrace(depth + 2)",
  "    }",
  "    method shallowCopy {",
  "        typeDecNode.new(name, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def methodNode = object {",
  "    method new(signature, body, dtype) scope(s) {",
  "        def result = new(signature, body, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(signature', body', dtype') {",
  "        // Represents a method declaration",
  "        // The name of the method is constructed from signature',",
  "        // which is a sequence of signatureParts;",
  "        // body is a sequence of statements and declarations.",
  "        // dtype is the declared return type of the method, or false.",
  "",
  "        inherits baseNode",
  "        def kind is public = \"method\"",
  "        var signature is public := signature'",
  "        var body is public := body'",
  "        var dtype is public := dtype'",
  "        var typeParams is public := false",
  "        var selfclosure is public := false",
  "        var annotations is public := [ ]",
  "        var isFresh is public := false      // a method is 'fresh' if it answers a new object",
  "        var usesClassSyntax is public := false",
  "        var cachedIdentifier := uninitialized",
  "        var isBindingOccurence is readable := true",
  "            // the only exception is the oldMethodName in an alias clause",
  "",
  "        method appliedOccurence {",
  "            isBindingOccurence := false",
  "            if (uninitialized ≠ cachedIdentifier) then {",
  "                cachedIdentifier.isBindingOccurence := false",
  "            }",
  "            self",
  "        }",
  "        method numParams {",
  "            signature.fold { acc, p -> acc + p.numParams } startingWith 0",
  "        }",
  "        method endPos {",
  "            def lastPart = signature.last",
  "            lastPart.linePos + lastPart.name.size - 1",
  "        }",
  "",
  "        method nameString {",
  "            signature.fold { acc, each -> acc ++ each.nameString }",
  "                startingWith \"\"",
  "        }",
  "        method asIdentifier {",
  "            if (uninitialized == cachedIdentifier) then {",
  "                cachedIdentifier := identifierNode.new(nameString, false)",
  "                cachedIdentifier.line := signature.first.line",
  "                cachedIdentifier.linePos := signature.first.linePos",
  "                cachedIdentifier.isBindingOccurrence := isBindingOccurence",
  "            }",
  "            cachedIdentifier",
  "        }",
  "        method value { asIdentifier }",
  "        method canonicalName {",
  "            signature.fold { acc, each -> acc ++ each.canonicalName }",
  "                startingWith \"\"",
  "        }",
  "        method hasParams { signature.first.params.isEmpty.not }",
  "        method numParamLists {",
  "            // the number of my parameter lists.  If I have a single",
  "            // part to my name, there may be 0 or 1",
  "            def sigSz = signature.size",
  "            if (sigSz > 1) then { return sigSz }",
  "            if {signature.first.params.isEmpty} then { return 0 }",
  "            return 1",
  "        }",
  "        method hasTypeParams { false ≠ signature.first.typeParams }",
  "        method isMethod { true }",
  "        method isExecutable { false }",
  "        method isLegalInTrait { true }",
  "        method isClass { isFresh || usesClassSyntax }",
  "        method isTrait {",
  "            if (isFresh) then {",
  "                body.last.isTrait",
  "            } else {",
  "                false",
  "            }",
  "        }",
  "        method needsArgChecks {",
  "            signature.do { part ->",
  "                part.params.do { p ->",
  "                    if ((false != p.dtype) && {",
  "                            p.dtype.nameString != \"Unknown\" }) then {",
  "                        return true",
  "                    }",
  "                }",
  "            }",
  "            return false",
  "        }",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the synmol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method isConfidential {",
  "            if (annotations.size == 0) then { return false }",
  "            findAnnotation(self, \"confidential\")",
  "        }",
  "        method isPublic { isConfidential.not }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method returnsObject {",
  "            body.isEmpty.not && {body.last.returnsObject}",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            body.last.returnedObjectScope",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMethod(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "                for (self.signature) do { part ->",
  "                    for (part.params) do { p ->",
  "                        p.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != dtype) then {",
  "                    dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                for (self.body) do { mx ->",
  "                    mx.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as){",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.body := listMap(body, blk) ancestors(newChain)",
  "            n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            n.signature := listMap(signature, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Name: \" ++ value.pretty(depth+1) ++ \"\\n\"",
  "            if (false != self.dtype) then {",
  "                s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "                s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "            }",
  "            if (isBindingOccurence.not) then { s := s ++ spc ++ \"Applied\\n\" }",
  "            if (isFresh) then { s := s ++ spc ++ \"Fresh\\n\" }",
  "            s := \"{s}{spc}Signature:\"",
  "            for (signature) do { part ->",
  "                s := \"{s}\\n  {spc}Part: {part.name}\"",
  "                s := \"{s}\\n    {spc}Parameters:\"",
  "                for (part.params) do { p ->",
  "                    s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "                }",
  "            }",
  "            s := s ++ \"\\n\"",
  "            if (false != typeParams) then {",
  "                s := \"{s}{spc}Generics:\"",
  "                typeParams.do {g->",
  "                    s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            if (annotations.size > 0) then {",
  "                s := \"{s}{spc}Annotations:\"",
  "                for (annotations) do {an->",
  "                    s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            s := s ++ spc ++ \"Body:\"",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"method \"",
  "            var firstPart := true",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart && {false != typeParams}) then {",
  "                    s := s ++ typeParams.toGrace(depth + 1)",
  "                }",
  "                firstPart := false",
  "                if (part.params.size > 0) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params.at(pnr)",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if (pnr < part.params.size) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            s := s ++ \" \\{\"",
  "            if (false != comments) then {",
  "                s := s ++ comments.toGrace(depth + 1)",
  "            }",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            methodNode.new(signature, body, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isFresh := other.isFresh",
  "            selfclosure := other.selfclosure",
  "            if (other.isBindingOccurence.not) then {",
  "                self.appliedOccurence",
  "            }",
  "            self",
  "        }",
  "    }",
  "}",
  "def callNode = object {",
  "    method new(receiver, parts) scope(s) {",
  "        def result = new(receiver, parts)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(receiver', parts) {",
  "        // requested as callNode.new(receiver':AstNode, parts:List)",
  "        // Represents a method request with arguments.",
  "        // The argument list is in `with`, as a sequence of `requestPart`s.",
  "",
  "        inherits baseNode",
  "        def kind is public = \"call\"",
  "        var with is public := parts            // [ argument parts ]",
  "        var generics is public := false",
  "        var isPattern is public := false",
  "        var receiver is public := receiver'    // formerly `value`",
  "        var isSelfRequest is public := false",
  "",
  "        method onSelf {",
  "            // mark as a self-request.  Answers self for chaining.",
  "            isSelfRequest := true",
  "            self",
  "        }",
  "",
  "        method nameString {",
  "            // the name of the method being requested, in numeric form",
  "            with.fold { acc, each -> acc ++ each.nameString } startingWith \"\"",
  "        }",
  "",
  "        method canonicalName {",
  "            // the name of the method being requested, in underscore form",
  "            with.fold { acc, each -> acc ++ each.canonicalName }",
  "                startingWith \"\"",
  "        }",
  "",
  "        method isCall { true }",
  "        method returnsObject {",
  "            // we recognize two special calls as returning a fresh object",
  "            // self.copy, and prelude.clone(_)",
  "            if ((receiver.isImplicit || receiver.isPrelude) &&",
  "                  (nameString == \"clone(1)\")) then {return true}",
  "            if ((receiver.isImplicit || receiver.isSelf) &&",
  "                  (nameString == \"copy\")) then {return true}",
  "            return false",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            self.scope",
  "        }",
  "        method arguments {",
  "            def result = [ ]",
  "            for (self.with) do { part ->",
  "                for (part.args) do { arg -> result.push(arg) }",
  "            }",
  "            result",
  "        }",
  "",
  "        method argumentsDo(action) {",
  "            for (self.with) do { part ->",
  "                for (part.args) do { arg -> action.apply(arg) }",
  "            }",
  "        }",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitCall(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.receiver.accept(visitor) from(newChain)",
  "                for (self.with) do { part ->",
  "                    for (part.args) do { arg ->",
  "                        arg.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != generics) then {",
  "                    generics.do { each ->",
  "                        each.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.receiver := receiver.map(blk) ancestors(newChain)",
  "            n.with := listMap(with, blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            s := s ++ if (isSelfRequest) then { \" on self\\n\" } else { \"\\n\" }",
  "            s := s ++ spc ++ \"Receiver: {receiver.pretty(depth + 1)}\\n\"",
  "            s := s ++ spc ++ \"Method Name: {nameString}\\n\"",
  "            if (false != generics) then {",
  "                s := s ++ spc ++ \"  Generics:\\n\"",
  "                for (generics) do {g->",
  "                    s := s ++ spc ++ \"    \" ++ g.pretty(depth + 2) ++ \"\\n\"",
  "                }",
  "            }",
  "            s := s ++ spc ++ \"Arguments:\"",
  "            for (self.with) do { part ->",
  "                s := s ++ \"\\n  \" ++ spc ++ \"Part: \" ++ part.name",
  "                for (part.args) do { arg ->",
  "                    s := s ++ \"\\n      \" ++ spc ++ arg.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            if (receiver.isImplicit.not) then {",
  "                if (receiver.isSimple) then {",
  "                    s := \"{receiver.toGrace (depth + 1)}.\"",
  "                } else {",
  "                    s := \"({receiver.toGrace (depth + 1)}).\"",
  "                }",
  "            }",
  "            with.do { part -> s := s ++ part.toGrace(depth + 1) }",
  "                separatedBy { s := s ++ \" \" }",
  "            s",
  "        }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "            if (fakeSymbolTable == scope) then {",
  "                ProgrammingError.raise \"asIdentifier requested on {pretty 0} when scope was fake\"",
  "            }",
  "            def resultNode = identifierNode.new (nameString, false) scope (scope)",
  "            resultNode.inRequest := true",
  "            resultNode.line := line",
  "            resultNode.linePos := linePos",
  "            return resultNode",
  "        }",
  "        method asString { \"call {receiver.pretty(0)}\" }",
  "        method shallowCopy {",
  "            callNode.new(receiver, with).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isPattern := other.isPattern",
  "            isSelfRequest := other.isSelfRequest",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "def moduleNode = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result",
  "    }",
  "    class body(b) {",
  "        inherits objectNode.new(b, false)",
  "        def kind is public = \"module\"",
  "        def sourceLines = util.lines",
  "        line := 0       // because the module is always implicit",
  "        linePos := 0",
  "        var imports is public := [ ]",
  "",
  "        method isModule { true }",
  "        method returnsObject { false }",
  "        method externalsDo(action) {",
  "            value.do { o ->",
  "                if (o.isExternal) then { action.apply(o) }",
  "            }",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitModule(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != self.superclass) then {",
  "                    self.superclass.accept(visitor) from(newChain)",
  "                }",
  "                for (self.value) do { x ->",
  "                    x.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            moduleNode.body(emptySeq).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            imports := other.imports",
  "            self",
  "        }",
  "    }",
  "}",
  "def objectNode is public = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = new(b, false)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        body(b) named(n) scope(fakeSymbolTable)",
  "    }",
  "    class new(b, superclass') {",
  "        inherits baseNode",
  "        def kind is public = \"object\"",
  "        var value is public := b",
  "        var superclass is public := superclass'",
  "        var usedTraits is public := [ ]",
  "        var name is public := \"object\"",
  "        var inClass is public := false",
  "        var inTrait is public := false",
  "        var myLocalNames := false",
  "        var annotations is public := [ ]",
  "",
  "        method description -> String {",
  "            if (isTrait) then {",
  "                \"{kind} (trait)\"",
  "            } elseif { inClass } then {",
  "                \"{kind} (class)\"",
  "            } else {",
  "                kind",
  "            }",
  "        }",
  "        method isTrait {",
  "            // answers true if this object qualifies to be a trait, whether",
  "            // or not it was declared with the trait syntax",
  "            if (inTrait) then { return true }",
  "            if (false != superclass) then { return false }",
  "            value.do { each ->",
  "                if (each.isLegalInTrait.not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "",
  "        method localNames -> Set⟦String⟧ {",
  "            // answers the names of all of the methods defined directly in",
  "            // this object.  Inherited names are _not_ included.",
  "            if (false == myLocalNames) then {",
  "                myLocalNames := emptySet",
  "                value.do { node ->",
  "                    if (node.isFieldDec || node.isMethod) then {",
  "                        myLocalNames.add(node.nameString)",
  "                    }",
  "                }",
  "            }",
  "            myLocalNames",
  "        }",
  "",
  "        method parentsDo(action) {",
  "            // iterate over my superclass and my used traits",
  "",
  "            if (false != superclass) then { action.apply(superclass) }",
  "            usedTraits.do { t -> action.apply(t) }",
  "        }",
  "",
  "        method methodsDo(action) {",
  "            // iterate over my method declarations",
  "",
  "            value.do { o ->",
  "                if (o.isMethod) then { action.apply(o) }",
  "            }",
  "        }",
  "",
  "        method executableComponentsDo(action) {",
  "            // iterate over my executable code, including",
  "            // field declarations (since they may have initializers)",
  "            value.do { o ->",
  "                if (o.isExecutable) then { action.apply(o) }",
  "            }",
  "        }",
  "",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the symbol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method body { value }",
  "        method returnsObject { true }",
  "        method returnedObjectScope { scope }",
  "        method canInherit { inTrait.not }   // an object can inherit if not in a trait",
  "        method canUse { true }",
  "        method isObject { true }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitObject(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != superclass) then {",
  "                    superclass.accept(visitor) from(newChain)",
  "                }",
  "                usedTraits.do { t -> t.accept(visitor) from(newChain) }",
  "                value.do { x -> x.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method nameString {",
  "            if (name == \"object\") then {",
  "                \"object_on_line_{line}\"",
  "            } else {",
  "                name",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := listMap(value, blk) ancestors(newChain)",
  "            n.superclass := maybeMap(superclass, blk) ancestors(newChain)",
  "            n.usedTraits := listMap(usedTraits, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth') {",
  "            var depth := depth'",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            s := \"{s}\\n{spc}Name: {self.name}\"",
  "            if (false != self.superclass) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Superclass: \" ++",
  "                        self.superclass.pretty(depth + 1)",
  "            }",
  "            if (usedTraits.isEmpty.not) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Traits:\"",
  "                usedTraits.do { t ->",
  "                    s := \"{s}\\n{spc}  {t.pretty(depth + 1)}\"",
  "                }",
  "            }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\"++ spc ++ x.pretty(depth + 1)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"object \\{\"",
  "            if (inTrait) then { s := s ++ \"   // trait\" }",
  "            if (inClass) then { s := s ++ \"   // class\" }",
  "            if (false != superclass) then {",
  "                s := s ++ \"\\n\" ++ superclass.toGrace(depth + 1)",
  "            }",
  "            usedTraits.do { t -> s := s ++ \"\\n\" ++ t.toGrace(depth + 1) }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            objectNode.new(emptySeq, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            name := other.name",
  "            value := other.value",
  "            superclass := other.superclass",
  "            usedTraits := other.usedTraits",
  "            inClass := other.inClass",
  "            inTrait := other.inTrait",
  "            annotations := other.annotations",
  "            self",
  "        }",
  "        method asString {",
  "            \"object {nameString}\"",
  "        }",
  "    }",
  "}",
  "def arrayNode is public = object {",
  "  class new(values) {",
  "    inherits baseNode",
  "    def kind is public = \"array\"",
  "    var value is public := values",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitArray(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := listMap(value, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { ai ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth)",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value.at(i).toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        arrayNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def memberNode = object {",
  "    method new(request, receiver) scope(s) {",
  "        // Represents a dotted request ‹receiver›.‹request› with no arguments.",
  "        def result = new(request, receiver)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(request, receiver') {",
  "        // Represents a dotted request ‹receiver›.‹request› with no arguments.",
  "        inherits baseNode",
  "        def kind is public = \"member\"",
  "        var value is public := request  // NB: value is a String, not an Identifier",
  "        var receiver is public := receiver'",
  "        var generics is public := false",
  "        var isSelfRequest is public := false",
  "        ",
  "        method onSelf {",
  "            isSelfRequest := true",
  "            self",
  "        }",
  "        method nameString { value }",
  "        method canonicalName { value }",
  "        method isMember { true }",
  "        method isCall { true }",
  "",
  "        method with { emptySeq }",
  "        method arguments { emptySeq }",
  "        method argumentsDo { }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMember(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != generics) then {",
  "                    generics.do { each -> each.accept(visitor) from(newChain) }",
  "                }",
  "                receiver.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.receiver := receiver.map(blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            s := s ++ if (isSelfRequest) then { \" on self \" } else { \" \" }",
  "            s := s ++ \"‹\" ++ self.value ++ \"›\\n\"",
  "            s := s ++ spc ++ receiver.pretty(depth)",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"    \" ++ g.pretty(0)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            if (self.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                s := self.value.substringFrom(7)to(value.size)",
  "                s := s ++ \" \" ++ self.receiver.toGrace(0)",
  "            } else {",
  "                s := self.receiver.toGrace(depth) ++ \".\" ++ self.value",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "        method asString { \"{receiver}.{value}\" }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "            if (fakeSymbolTable == scope) then {",
  "                ProgrammingError.raise \"asIdentifier requested on {pretty 0} when scope was fake\"",
  "            }",
  "            def resultNode = identifierNode.new (value, false) scope (scope)",
  "            resultNode.inRequest := true",
  "            resultNode.line := line",
  "            resultNode.linePos := linePos",
  "            return resultNode",
  "        }",
  "        method shallowCopy {",
  "            memberNode.new(nameString, receiver).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            generics := other.generics",
  "            isSelfRequest := other.isSelfRequest",
  "            self",
  "        }",
  "    }",
  "}",
  "def genericNode is public = object {",
  "  class new(base, arguments) {",
  "    // represents an application of a parameterized type to some arguments.",
  "    inherits baseNode",
  "    def kind is public = \"generic\"",
  "    var value is public := base",
  "        // in a generic application, `value` is the applied type",
  "        // e.g. in List⟦Number⟧, value is Identifier‹List›",
  "    var args is public := arguments",
  "    method nameString { value.nameString }",
  "    method asString { toGrace 0 }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitGeneric(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.args) do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.args := listMap(args, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"{super.pretty(depth)}({value.pretty(depth)})<\"",
  "        args.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := nameString ++ \"<\"",
  "        args.do { each -> s := s ++ each.toGrace(0) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method shallowCopy {",
  "        genericNode.new(value, args).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def typeParametersNode is public = object {",
  "  class new(params') {",
  "    inherits baseNode",
  "    def kind is public = \"typeparams\"",
  "    var params is public := params'",
  "    method asString { toGrace 0 }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeParameters(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            params.do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method do(blk) {",
  "        params.do(blk)",
  "    }",
  "    method size { params.size }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := spc ++ super.pretty(depth) ++ \"<\"",
  "        params.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method toGrace(depth:Number) -> String {",
  "        var s := \"<\"",
  "        params.do { each -> s := \"{s}{each.toGrace(depth)}\" }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method shallowCopy {",
  "        typeParametersNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def identifierNode = object {",
  "",
  "    method new(name, dtype) scope(s) {",
  "        def result = new(name, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name, dtype') {",
  "        inherits baseNode",
  "        def kind is public = \"identifier\"",
  "        var value is public := name",
  "        var wildcard is public := false",
  "        var dtype is public := dtype'",
  "        var isBindingOccurrence is public := false",
  "        var isAssigned is public := false",
  "        var inRequest is public := false",
  "        var generics is public := false",
  "        var isDeclaredByParent is public := false",
  "",
  "        method nameString { value }",
  "        method canonicalName { value }",
  "        method quoted { value.quoted }",
  "        method isIdentifier { true }",
  "        ",
  "        method isSelf { \"self\" == value }",
  "        method isSuper { \"super\" == value }",
  "        method isPrelude { \"prelude\" == value }",
  "        method isOuter { \"outer\" == value }",
  "",
  "        method isAppliedOccurenceOfIdentifier {",
  "            if (wildcard) then {",
  "                false",
  "            } else {",
  "                isBindingOccurrence.not",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            as.parent.declarationKindWithAncestors(as)",
  "        }",
  "        method inTypePositionWithAncestors(as) {",
  "            // am I used by my parent node as a type?",
  "            // This is a hack, used as a subsitute for having information in the .gct",
  "            // telling us which identifiers represent types",
  "            if (as.isEmpty) then { return false }",
  "            as.parent.usesAsType(self)",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitIdentifier(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != self.dtype) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if ( wildcard ) then {",
  "                s := s ++ \" Wildcard\"",
  "            } elseif { isBindingOccurrence } then {",
  "                s := s ++ \"Binding‹{value}›\"",
  "            } else {",
  "                s := s ++ \"‹{value}›\"",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Type: \"",
  "                s := s ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"  \" ++ g.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s",
  "            if(self.wildcard) then {",
  "                s := \"_\"",
  "            } else {",
  "                s := self.value",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(depth + 1)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "",
  "        method asString {",
  "            if (isBindingOccurrence) then {",
  "                \"identifierBinding‹{value}›\"",
  "            } else {",
  "                \"identifier‹{value}›\"",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            identifierNode.new(value, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            wildcard := other.wildcard",
  "            isBindingOccurrence := other.isBindingOccurrence",
  "            isDeclaredByParent := other.isDeclaredByParent",
  "            isAssigned := other.isAssigned",
  "            inRequest := other.inRequest",
  "            self",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "",
  "def typeType is public = identifierNode.new(\"Type\", false)",
  "def unknownType is public = identifierNode.new(\"Unknown\", typeType)",
  "",
  "def stringNode = object {",
  "    method new(v) scope(s) {",
  "        def result = new(v)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(v) {",
  "        inherits baseNode",
  "        def kind is public = \"string\"",
  "        var value is public := v",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitString(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            def q = \"\\\"\"",
  "            q ++ value.quoted ++ q",
  "        }",
  "        method asString { \"string {toGrace 0}\" }",
  "        method shallowCopy {",
  "            stringNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "        method isDelimited { true }",
  "    }",
  "}",
  "def numNode is public = object {",
  "    class new(val) {",
  "        inherits baseNode",
  "        def kind is public = \"num\"",
  "        var value is public := val",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitNum(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            self.value.asString",
  "        }",
  "        method asString { \"num {value}\" }",
  "        method shallowCopy {",
  "            numNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "        method isDelimited { true }",
  "    }",
  "}",
  "def opNode is public = object {",
  "  class new(op, l, r) {",
  "    inherits baseNode",
  "    def kind is public = \"op\"",
  "    def value is public = op     // a String",
  "    var left is public := l",
  "    var right is public := r",
  "    method isSimple { false }    // needs parens when used as reciever",
  "    method nameString { value ++ \"(1)\" }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitOp(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.left.accept(visitor) from(newChain)",
  "            self.right.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.left := left.map(blk) ancestors(newChain)",
  "        n.right := right.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}‹\" ++ self.nameString ++ \"›\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && {self.left.value != self.value}) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && {self.right.value != self.value}) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "    method asIdentifier {",
  "        // make an identifiderNode with the same properties as me",
  "        def resultNode = identifierNode.new (nameString, false) scope (scope)",
  "        resultNode.inRequest := true",
  "        resultNode.line := line",
  "        resultNode.linePos := linePos",
  "        return resultNode",
  "    }",
  "    method shallowCopy {",
  "        opNode.new(value, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def bindNode is public = object {",
  "  class new(dest', val') {",
  "    // an assignment, or a request of a setter-method",
  "    inherits baseNode",
  "    def kind is public = \"bind\"",
  "    var dest is public := dest'",
  "    var value is public := val'",
  "",
  "    method isBind { true }",
  "    method asString { \"bind {value}\" }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBind(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.dest.accept(visitor) from(newChain)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.dest := dest.map(blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        bindNode.new(dest, value).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"assignment or assigment request\" }",
  "  }",
  "}",
  "def defDecNode = object {",
  "    method new(name', val, dtype') scope(s) {",
  "        def result = new(name', val, dtype')",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name', val, dtype') {",
  "        inherits baseNode",
  "        def kind is public = \"defdec\"",
  "        var name is public := name'",
  "        var value is public := val",
  "        var dtype is public := dtype'",
  "        def nameString is public = name.nameString",
  "        var annotations is public := [ ]",
  "        var startToken is public := false",
  "",
  "        method isPublic {",
  "            // defs are confidential by default",
  "            if (annotations.size == 0) then { return false }",
  "            if (findAnnotation(self, \"public\")) then { return true }",
  "            findAnnotation(self, \"readable\")",
  "        }",
  "        method isFieldDec { true }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "",
  "        method returnsObject {",
  "            value.returnsObject",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            value.returnedObjectScope",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method declarationKindWithAncestors(as) { k.defdec }",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitDefDec(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.name.accept(visitor) from(newChain)",
  "                if (false != self.dtype) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.name := name.map(blk) ancestors(newChain)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ self.name.pretty(depth)",
  "            if (false != dtype) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Type: \" ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != value) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Value: \" ++ value.pretty(depth + 2)",
  "            }",
  "            if (annotations.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Annotations:\"",
  "                annotations.do { ann ->",
  "                    s := \"{s} {ann.pretty(depth + 2)}\"",
  "                }",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"def {self.name.toGrace(0)}\"",
  "            if ( (false != self.dtype) && {",
  "                    self.dtype.value != \"Unknown\" }) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            if (false != self.value) then {",
  "                s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            defDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            startToken := other.startToken",
  "            self",
  "        }",
  "        method statementName { \"definition\" }",
  "    }",
  "}",
  "def varDecNode is public = object {",
  "  class new(name', val', dtype') {",
  "    inherits baseNode",
  "    def kind is public = \"vardec\"",
  "    var name is public := name'",
  "    var value is public := val'",
  "    var dtype is public := dtype'",
  "    def nameString is public = name.value",
  "    var annotations is public := [ ]",
  "",
  "    method isPublic {",
  "        // vars are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method isWritable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"writable\")) then { return true }",
  "        false",
  "    }",
  "    method isReadable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"readable\")) then { return true }",
  "        false",
  "    }",
  "    method isFieldDec { true }",
  "",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "",
  "    method declarationKindWithAncestors(as) { k.vardec }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitVarDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.name.accept(visitor) from(newChain)",
  "            if (false != self.dtype) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.value) then {",
  "                self.value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.value := maybeMap(value, blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for ((0..depth)) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (false != self.dtype) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type: \"",
  "            s := s ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Value: \"",
  "            s := s ++ self.value.pretty(depth + 2)",
  "        }",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if ( (false != self.dtype) && {",
  "                self.dtype.value != \"Unknown\" }) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.fold{ a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                    startingWith \"\"",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        varDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"variable declaration\" }",
  "",
  "  }",
  "}",
  "def importNode is public = object {",
  "  class new(path', name', dtype') {",
  "    inherits baseNode",
  "    def kind is public = \"import\"",
  "    var value is public := name'",
  "    var path is public := path'",
  "    var annotations is public := [ ]",
  "    var dtype is public := dtype'",
  "    method isImport { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method name { value }",
  "    method nameString { value.nameString }",
  "    method isPublic {",
  "        // imports, like defs, are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (path) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method declarationKindWithAncestors(as) { k.defdec }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitImport(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            self.value.accept(visitor) from(newChain)",
  "            if (false != self.dtype) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {value}\\n\"",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"{spc}Anotations: {annotations}\\n\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {nameString}\"",
  "    }",
  "    method shallowCopy {",
  "        importNode.new(path, nullNode, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def dialectNode is public = object {",
  "  class new(path') {",
  "    inherits baseNode",
  "    def kind is public = \"dialect\"",
  "    var value is public := path'",
  "",
  "    method isDialect { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (value) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method path {",
  "        value",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        visitor.visitDialect(self) up(as)",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "    method shallowCopy {",
  "        dialectNode.new(value).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def returnNode is public = object {",
  "  class new(expr) {",
  "    inherits baseNode",
  "    def kind is public = \"return\"",
  "    var value is public := expr",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitReturn(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "    method shallowCopy {",
  "        returnNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def inheritsNode = object {",
  "    method new(expr) scope(s) {",
  "        def result = new(expr)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(expr) {",
  "        inherits baseNode",
  "        def kind is public = \"inherits\"",
  "        var value is public := expr",
  "        var providedNames is public := emptySet",
  "        var aliases is public := [ ]",
  "        var exclusions is public := [ ]",
  "        var isUse is public := false  // this is a `use trait` clause, not an inherits",
  "",
  "        method isLegalInTrait { isUse }",
  "        method isInherits { true }",
  "        method inheritsFromMember { value.isMember }",
  "        method inheritsFromCall { value.isCall }",
  "        method isExecutable { false }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitInherits(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                value.accept(visitor) from(newChain)",
  "                aliases.do { a ->",
  "                    a.newName.accept(visitor) from(newChain)",
  "                    a.oldName.accept(visitor) from(newChain)",
  "                }",
  "                exclusions.do { e -> e.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            // identifiers declared in an inherits statement are aliases for",
  "            // methods.  We treat them as methods, because (unlike inherited names)",
  "            // they can't be overridden by local methods.",
  "            k.methdec",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if (isUse) then { s := \"{s} (use)\" }",
  "            s := s ++ \"\\n\" ++ spc ++ self.value.pretty(depth + 1)",
  "            aliases.do { a ->",
  "                s := \"{s}\\n{a.pretty(depth)}\"",
  "            }",
  "            if (exclusions.isEmpty.not) then { s := \"{s}\\n{spc}\" }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e} \"",
  "            }",
  "            if (providedNames.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Provided names: {providedNames.asList.sort}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            repeat (depth) times {",
  "                s := s ++ \"    \"",
  "            }",
  "            s := s ++ if (isUse) then { \"use \" } else { \"inherit \" }",
  "            s := s ++ self.value.toGrace(0)",
  "            aliases.do { a ->",
  "                s := \"{s} {a} \"",
  "            }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e.nameString} \"",
  "            }",
  "            s",
  "        }",
  "        method asString {",
  "            if (isUse) then { \"use \" } else { \"inherit \" } ++ value.toGrace 0",
  "        }",
  "        method nameString { value.toGrace(0) }",
  "        method addAlias (newName) for (oldName) {",
  "            aliases.push(aliasNew(newName) old(oldName))",
  "        }",
  "        method addExclusion(ident) {",
  "            exclusions.push(ident)",
  "        }",
  "        method shallowCopy {",
  "            inheritsNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            providedNames := other.providedNames",
  "            aliases := other.aliases",
  "            exclusions := other.exclusions",
  "            isUse := other.isUse",
  "            self",
  "        }",
  "        method statementName {",
  "            if (isUse) then { \"use\" } else { \"inherit\" }",
  "        }",
  "    }",
  "}",
  "type AliasPair = {",
  "    newName",
  "    oldName",
  "}",
  "",
  "class aliasNew(n) old(o) {",
  "    method newName {n}",
  "    method oldName {o}",
  "    method asString { \"alias {n.nameString} = {o.nameString}\" }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        \"{spc}  alias {n.pretty(depth)} = {o.pretty(depth)}\"",
  "    }",
  "    method hash { (n.hash * 1171) + o.hash }",
  "    method isExecutable { false }",
  "    method == (other) {",
  "        match (other)",
  "            case { that:AliasPair -> (n == that.newName) && (o == that.oldName) }",
  "            case { _ -> false }",
  "    }",
  "}",
  "def blankNode is public = object {",
  "    class new {",
  "        inherits baseNode",
  "        def kind is public = \"blank\"",
  "        def value is public = \"blank\"",
  "        method isExecutable { false }",
  "",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitBlank(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method nameString { \"\" }",
  "        method asString { \"blank\" }",
  "        method toGrace(depth : Number) -> String { \"\" }",
  "        method shallowCopy {",
  "            blankNode.new.shallowCopyFieldsFrom(self)",
  "        }",
  "    }",
  "}",
  "def signaturePart = object {",
  "    method new {",
  "        partName \"\" params []",
  "    }",
  "    method partName(n) scope(s) {",
  "        def result = partName(n) params []",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) params(ps) scope(s) {",
  "        def result = partName(n) params(ps)",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) {",
  "        partName(n) params []",
  "    }",
  "    class partName(n) params(ps) {",
  "        inherits baseNode",
  "        def kind is public = \"signaturepart\"",
  "        var name is public := n",
  "        var params is public := ps",
  "        var typeParams is public := false",
  "        var lineLength is public := 0",
  "",
  "        method nameString {",
  "            if (params.isEmpty) then {return name}",
  "            name ++ \"(\" ++ params.size ++ \")\"",
  "        }",
  "        method numParams { params.size }",
  "        method canonicalName {",
  "            if (params.size == 0) then {return name}",
  "            var underScores := \"\"",
  "            params.do { _ -> underScores := underScores ++ \"_\" }",
  "                separatedBy { underScores := underScores ++ \",\" }",
  "            name ++ \"(\" ++ underScores ++ \")\"",
  "        }",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitSignaturePart(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                params.do { p -> p.accept(visitor) from(newChain) }",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method map(blk) ancestors(as) {",
  "            var nd := shallowCopy",
  "            def newChain = as.extend(nd)",
  "            nd.params := listMap(params, blk) ancestors(newChain)",
  "            nd.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            blk.apply(nd, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            if (params.isEmpty.not) then { s := \"{s}\\n{spc}Parameters:\" }",
  "            for (params) do { p ->",
  "                s := \"{s}\\n  {spc}{p.pretty(depth + 2)}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth) {",
  "            var s := name",
  "            if (params.isEmpty.not) then {",
  "                s := s ++ \"(\"",
  "                params.do { each -> s := each.toGrace(depth + 1) }",
  "                    separatedBy { s := s ++ \", \" }",
  "                s := s ++ \")\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            signaturePart.partName(name) params(params)",
  "                .shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            typeParams := other.typeParams",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method asString {",
  "            \"part: {nameString}\"",
  "        }",
  "    }",
  "}",
  "",
  "def requestPart = object {",
  "    method new {",
  "        request \"\" withArgs( [] )",
  "    }",
  "    method request(name) withArgs(argList) scope (s) {",
  "        def result = request(name) withArgs(argList)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class request(rPart) withArgs(xs) {",
  "        inherits baseNode",
  "        def kind is public = \"callwithpart\"",
  "        var name is public := rPart",
  "        var args is public := xs",
  "        var typeArgs := emptySeq",
  "        var lineLength is public := 0",
  "",
  "        method nameString {",
  "            if (args.size == 0) then {return name}",
  "            name ++ \"(\" ++ args.size ++ \")\"",
  "        }",
  "",
  "        method canonicalName {",
  "            if (args.size == 0) then {return name}",
  "            var underScores := \"\"",
  "            args.do { _ -> underScores := underScores ++ \"_\" }",
  "                separatedBy { underScores := underScores ++ \",\" }",
  "            name ++ \"(\" ++ underScores ++ \")\"",
  "        }",
  "",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.args := listMap(args, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            repeat (depth+1) times {",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            s := \"{s}\\n    {spc}Args:\"",
  "            for (args) do { a ->",
  "                s := \"{s}\\n    {spc}{a.pretty(depth + 4)}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth) {",
  "            var s := name",
  "            if (typeArgs.size > 0) then {",
  "                s := s ++ \"⟦\"",
  "                typeArgs.do { tArg ->",
  "                    s := s ++ tArg.toGrace(depth + 1)",
  "                } separatedBy { s := s ++ \", \" }",
  "                s := s ++ \"⟧\"",
  "            }",
  "            if (args.size > 0) then {",
  "                def needsParens = (args.size > 1) || (args.first.isDelimited.not)",
  "                s := s ++ if (needsParens) then { \"(\" } else { \" \" }",
  "                args.do { arg ->",
  "                    s := s ++ arg.toGrace(depth)",
  "                } separatedBy {",
  "                    s := s ++ \", \"",
  "                }",
  "                if (needsParens) then { s := s ++ \")\" }",
  "            }",
  "            s",
  "        }",
  "",
  "        method shallowCopy {",
  "            requestPart.request(name) withArgs(args).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "",
  "def commentNode = object {",
  "    class new(val') {",
  "        inherits baseNode",
  "        def kind is public = \"comment\"",
  "        var value is public := val'",
  "        var isPartialLine:Boolean is public := false",
  "        var isPreceededByBlankLine is public := false",
  "        var endLine is public := util.linenum",
  "        method isComment { true }",
  "        method isLegalInTrait { true }",
  "        method isExecutable { false }",
  "        method asString { \"comment ({line}–{endLine}): {value}\" }",
  "        method extendCommentUsing(cmtNode) {",
  "            value := value ++ \" \" ++ cmtNode.value",
  "            endLine := cmtNode.endLine",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitComment(self) up(as)",
  "        }",
  "        method pretty(depth) {",
  "            var s := \"\\n\"",
  "            repeat (depth-1) times {",
  "                s := s ++ \"  \"",
  "            }",
  "            def pb = if (isPreceededByBlankLine) then { \" > blank\" } else { \"\" }",
  "            \"{s}Comment{pb}({line}–{endLine}): ‹{value}›\"",
  "        }",
  "        method toGrace(depth) {",
  "            // Partial line comments don't start with a newline, whereas",
  "            // full-line comments do.  No newline at end in either case.",
  "            if (isPartialLine) then {",
  "                \"// (partial) {value}\"",
  "            } else {",
  "                var spc := \"\"",
  "                repeat (depth) times { spc := spc ++ \"    \" }",
  "                wrap(value) to (lineLength) prefix (spc ++ \"// \")",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            commentNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            value := other.value",
  "            isPartialLine := other.isPartialLine",
  "            endLine := other.endLine",
  "            self",
  "        }",
  "    }",
  "}",
  "",
  "method wrap(str) to (l:Number) prefix (margin) {",
  "    def ind = margin.size",
  "    def len = max(ind + 4, l)",
  "    if ((ind + str.size) <= len) then {",
  "        return \"\\n\" ++ margin ++ str",
  "    }",
  "    var currBreak",
  "    var trimmedLine",
  "",
  "    try {",
  "        currBreak := str.lastIndexOf \" \" startingAt (len - ind)",
  "            ifAbsent {len - ind}",
  "        trimmedLine := str.substringFrom (1) to (currBreak).trim",
  "    } catch { ex:NoSuchMethod ->  // C string libraries lack methods",
  "        currBreak := min(len - ind, str.size)",
  "        (1..currBreak).do { ix ->",
  "            if (str.at(ix) == \" \") then { currBreak := ix }",
  "        }",
  "        var end := currBreak",
  "        while {(end >= 1) && {str.at(end) == \" \"}} do {",
  "            end := end - 1",
  "        }",
  "        var start := 1",
  "        while {(start <= str.size) && {str.at(start) == \" \"}} do {",
  "            start := start + 1",
  "        }",
  "        trimmedLine := str.substringFrom (start) to (end)",
  "    }",
  "    \"\\n\" ++ margin ++ trimmedLine ++",
  "        wrap(str.substringFrom (currBreak+1) to (str.size))",
  "            to (l) prefix (margin)",
  "}",
  "",
  "",
  "type ASTVisitor = {",
  "    visitIf(o) up(as) -> Boolean",
  "    visitBlock(o) up(as) -> Boolean",
  "    visitMatchCase(o) up(as) -> Boolean",
  "    visitTryCatch(o) up(as) -> Boolean",
  "    visitMethodType(o) up(as) -> Boolean",
  "    visitSignaturePart(o) up(as) -> Boolean",
  "    visitTypeLiteral(o) up(as) -> Boolean",
  "    visitTypeParameters(o) up(as) -> Boolean",
  "    visitTypeDec(o) up(as) -> Boolean",
  "    visitMethod(o) up(as) -> Boolean",
  "    visitCall(o) up(as) -> Boolean",
  "    visitObject(o) up(as) -> Boolean",
  "    visitModule(o) up(as) -> Boolean",
  "    visitArray(o) up(as) -> Boolean",
  "    visitMember(o) up(as) -> Boolean",
  "    visitGeneric(o) up(as) -> Boolean",
  "    visitIdentifier(o) up(as) -> Boolean",
  "    visitString(o) up(as) -> Boolean",
  "    visitNum(o) up(as) -> Boolean",
  "    visitOp(o) up(as) -> Boolean",
  "    visitBind(o) up(as) -> Boolean",
  "    visitDefDec(o) up(as) -> Boolean",
  "    visitVarDec(o) up(as) -> Boolean",
  "    visitImport(o) up(as) -> Boolean",
  "    visitReturn(o) up(as) -> Boolean",
  "    visitInherits(o) up(as) -> Boolean",
  "    visitDialect(o) up(as) -> Boolean",
  "    visitBlank(o) up(as) -> Boolean",
  "    visitComment(o) up(as) -> Boolean",
  "    visitImplicit(o) up(as) -> Boolean",
  "}",
  "",
  "class baseVisitor -> ASTVisitor {",
  "    method visitIf(o) up(as) { visitIf(o) }",
  "    method visitBlock(o) up(as) { visitBlock(o) }",
  "    method visitMatchCase(o) up(as) { visitMatchCase(o) }",
  "    method visitTryCatch(o) up(as) { visitTryCatch(o) }",
  "    method visitMethodType(o) up(as) { visitMethodType(o) }",
  "    method visitSignaturePart(o) up(as) { visitSignaturePart(o) }",
  "    method visitTypeDec(o) up(as) { visitTypeDec(o) }",
  "    method visitTypeLiteral(o) up(as) { visitTypeLiteral(o) }",
  "    method visitTypeParameters(o) up(as) { visitTypeParameters(o) }",
  "    method visitMethod(o) up(as) { visitMethod(o) }",
  "    method visitCall(o) up(as) { visitCall(o) }",
  "    method visitObject(o) up(as) { visitObject(o) }",
  "    method visitModule(o) up(as) { visitObject(o) }",
  "    method visitArray(o) up(as) { visitArray(o) }",
  "    method visitMember(o) up(as) { visitMember(o) }",
  "    method visitGeneric(o) up(as) { visitGeneric(o) }",
  "    method visitIdentifier(o) up(as) { visitIdentifier(o) }",
  "    method visitString(o) up(as) { visitString(o) }",
  "    method visitNum(o) up(as) { visitNum(o) }",
  "    method visitOp(o) up(as) { visitOp(o) }",
  "    method visitBind(o) up(as) { visitBind(o) }",
  "    method visitDefDec(o) up(as) { visitDefDec(o) }",
  "    method visitVarDec(o) up(as) { visitVarDec(o) }",
  "    method visitImport(o) up(as) { visitImport(o) }",
  "    method visitReturn(o) up(as) { visitReturn(o) }",
  "    method visitInherits(o) up(as) { visitInherits(o) }",
  "    method visitDialect(o) up(as) { visitDialect(o) }",
  "    method visitBlank(o) up(as) { visitBlank(o) }",
  "    method visitComment(o) up(as) { visitComment(o) }",
  "    method visitImplicit(o) up(as) { visitImplicit(o) }",
  "",
  "    method visitIf(o) -> Boolean { true }",
  "    method visitBlock(o) -> Boolean { true }",
  "    method visitMatchCase(o) -> Boolean { true }",
  "    method visitTryCatch(o) -> Boolean { true }",
  "    method visitMethodType(o) -> Boolean { true }",
  "    method visitSignaturePart(o) -> Boolean { true }",
  "    method visitTypeDec(o) -> Boolean { true }",
  "    method visitTypeLiteral(o) -> Boolean { true }",
  "    method visitTypeParameters(o) -> Boolean { true }",
  "    method visitMethod(o) -> Boolean { true }",
  "    method visitCall(o) -> Boolean { true }",
  "    method visitObject(o) -> Boolean { true }",
  "    method visitModule(o) -> Boolean { true }",
  "    method visitArray(o) -> Boolean { true }",
  "    method visitMember(o) -> Boolean { true }",
  "    method visitGeneric(o) -> Boolean { true }",
  "    method visitIdentifier(o) -> Boolean { true }",
  "    method visitString(o) -> Boolean { true }",
  "    method visitNum(o) -> Boolean { true }",
  "    method visitOp(o) -> Boolean { true }",
  "    method visitBind(o) -> Boolean { true }",
  "    method visitDefDec(o) -> Boolean { true }",
  "    method visitVarDec(o) -> Boolean { true }",
  "    method visitImport(o) -> Boolean { true }",
  "    method visitReturn(o) -> Boolean { true }",
  "    method visitInherits(o) -> Boolean { true }",
  "    method visitDialect(o) -> Boolean { true }",
  "    method visitBlank(o) -> Boolean { true }",
  "    method visitComment(o) -> Boolean { true }",
  "    method visitImplicit(o) -> Boolean { true }",
  "",
  "    method asString { \"an AST visitor\" }",
  "}",
  "",
  "class pluggableVisitor(visitation:Block2) -> ASTVisitor {",
  "    // Manufactures a default visitor, given a 2-parameter block.",
  "    // Typically, some of the methods will be overridden.",
  "    // The block will be applied with the AST node as the first argument",
  "    // and the ancestor chain as the second, and should answer true if",
  "    // the visitation is to continue and false if it is to go no deeper.",
  "",
  "    method visitIf(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlock(o) up(as) { visitation.apply (o, as) }",
  "    method visitMatchCase(o) up(as) { visitation.apply (o, as) }",
  "    method visitTryCatch(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethodType(o) up(as) { visitation.apply (o, as) }",
  "    method visitSignaturePart(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeLiteral(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethod(o) up(as) { visitation.apply (o, as) }",
  "    method visitCall(o) up(as) { visitation.apply (o, as) }",
  "    method visitObject(o) up(as) { visitation.apply (o, as) }",
  "    method visitModule(o) up(as) { visitation.apply (o, as) }",
  "    method visitArray(o) up(as) { visitation.apply (o, as) }",
  "    method visitMember(o) up(as) { visitation.apply (o, as) }",
  "    method visitGeneric(o) up(as) { visitation.apply (o, as) }",
  "    method visitIdentifier(o) up(as) { visitation.apply (o, as) }",
  "    method visitString(o) up(as) { visitation.apply (o, as) }",
  "    method visitNum(o) up(as) { visitation.apply (o, as) }",
  "    method visitOp(o) up(as) { visitation.apply (o, as) }",
  "    method visitBind(o) up(as) { visitation.apply (o, as) }",
  "    method visitDefDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitVarDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitImport(o) up(as) { visitation.apply (o, as) }",
  "    method visitReturn(o) up(as) { visitation.apply (o, as) }",
  "    method visitInherits(o) up(as) { visitation.apply (o, as) }",
  "    method visitDialect(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlank(o) up(as) { visitation.apply (o, as) }",
  "    method visitComment(o) up(as) { visitation.apply (o, as) }",
  "    method visitImplicit(o) up(as) { visitation.apply (o, as) }",
  "",
  "    method asString { \"a pluggable AST visitor\" }",
  "}",
  "",
  "",
  "def patternMarkVisitor = object {",
  "    inherits baseVisitor",
  "    method visitCall(c) up(as) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\") && {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherits true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  NULL
};
Object reader_ast_outer_30(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_31(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_31(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_32(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_32(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_33(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_33(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_symbolTable_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_symbolTable_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_comments_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_comments_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_433(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_716(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_1003(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1006(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1081(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1082(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_nameString_1083(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_1113(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1114(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_1129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_node_1130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_node_1130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_outer_1197(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1200(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1201(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_thenblock_1203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_thenblock_1203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elseblock_1204(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elseblock_1204(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_handledIdentifiers_1205(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_1205(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_1556(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1560(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1561(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_1562(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_1562(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_1563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_1563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_selfclosure_1564(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_1565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_1565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_1566(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_1566(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_2018(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2021(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2022(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_finally_2025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_finally_2025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2330(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2333(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elsecase_2337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elsecase_2337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2638(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2641(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2642(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_signature_2643(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_signature_2643(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_rtype_2644(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_rtype_2644(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeParams_2645(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeParams_2645(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_cachedIdentifier_2646(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_cachedIdentifier_2646(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_3021(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_methods_3026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_methods_3026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_types_3027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_types_3027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nominal_3028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_nominal_3028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_anonymous_3029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_anonymous_3029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_value_3030(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_value_3030(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3338(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_3339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_3339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_3340(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_3340(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nameString_3341(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_annotations_3342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_annotations_3342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_typeParams_3343(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_typeParams_3343(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3664(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3672(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3673(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_signature_3674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_signature_3674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_body_3675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_body_3675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_3676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_3676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_typeParams_3677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_typeParams_3677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_selfclosure_3678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_selfclosure_3678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_annotations_3679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_annotations_3679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_isFresh_3680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_isFresh_3680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_usesClassSyntax_3681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_usesClassSyntax_3681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_cachedIdentifier_3682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_cachedIdentifier_3682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_isBindingOccurence_3683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_isBindingOccurence_3683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_4783(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4791(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4792(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_with_4793(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_with_4793(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_generics_4794(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_generics_4794(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPattern_4795(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPattern_4795(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_receiver_4796(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_receiver_4796(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isSelfRequest_4797(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isSelfRequest_4797(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_5319(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_sourceLines_5336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_imports_5337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_imports_5337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_5409(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5423(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5424(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5425(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5425(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_superclass_5426(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_superclass_5426(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_usedTraits_5427(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_usedTraits_5427(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_name_5428(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_name_5428(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_inClass_5429(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_inClass_5429(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inTrait_5430(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inTrait_5430(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_myLocalNames_5431(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_myLocalNames_5431(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_5432(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_annotations_5432(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_6022(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6157(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6165(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6166(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6167(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6167(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_receiver_6168(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_receiver_6168(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_6169(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_6169(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isSelfRequest_6170(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isSelfRequest_6170(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_6538(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6541(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6542(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6543(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6543(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_6544(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_6544(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_6699(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6702(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6703(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_params_6704(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_params_6704(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6862(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6870(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6871(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_6873(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_6873(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_6874(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_6874(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isBindingOccurrence_6875(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isBindingOccurrence_6875(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isAssigned_6876(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isAssigned_6876(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inRequest_6877(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inRequest_6877(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_generics_6878(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_generics_6878(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_isDeclaredByParent_6879(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_isDeclaredByParent_6879(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_7294(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7302(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7303(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7304(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7304(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7383(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7384(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7453(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7456(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7457(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7458(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_7459(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_left_7459(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_right_7460(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_right_7460(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_7737(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7740(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7741(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_7742(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_dest_7742(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7743(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7743(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7912(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7920(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7921(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7922(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_7922(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7923(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7923(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_7924(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7924(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_7925(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_7926(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_7926(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_startToken_7927(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_startToken_7927(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_8378(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8382(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_8383(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_8383(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8384(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8384(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_8385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_8385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_8386(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_8387(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_8387(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_8836(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8839(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8840(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8841(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8841(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_path_8842(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_path_8842(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_annotations_8843(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_annotations_8843(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_8844(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_8844(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_9116(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9119(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9120(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9121(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9121(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9322(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9330(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9331(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9332(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9332(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_providedNames_9333(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_providedNames_9333(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_aliases_9334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_aliases_9334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_exclusions_9335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_exclusions_9335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isUse_9336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isUse_9336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_9718(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9721(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9722(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9723(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_9758(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9781(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9782(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_9783(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_9783(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_9784(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_9784(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeParams_9785(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeParams_9785(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_lineLength_9786(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_lineLength_9786(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10098(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10112(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_10113(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_10113(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_10114(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_10114(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeArgs_10115(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeArgs_10115(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_lineLength_10116(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_lineLength_10116(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10434(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10437(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10438(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_10439(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_10439(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_isPartialLine_10440(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_isPartialLine_10440(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPreceededByBlankLine_10441(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPreceededByBlankLine_10441(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_endLine_10442(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_endLine_10442(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10643(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static ClassData objclass29;
static Object strlit130;
static Object strlit137;
static Object strlit143;
static Object strlit149;
static Object strlit207;
static Object strlit216;
static Object strlit227;
static Object strlit243;
static Object strlit252;
static Object strlit259;
static Object strlit268;
static Object strlit273;
static Object strlit280;
static Object strlit287;
static Object strlit293;
static Object strlit310;
static Object strlit318;
static Object strlit325;
static Object strlit332;
static Object strlit338;
static Object strlit346;
static Object strlit355;
static Object strlit362;
static Object strlit369;
static Object strlit375;
static Object strlit424;
static ClassData objclass432;
static Object strlit438;
static Object strlit445;
static Object strlit451;
static Object strlit457;
static Object strlit466;
static Object strlit473;
static Object strlit480;
static Object strlit487;
static Object strlit491;
static Object strlit532;
static Object strlit566;
static Object strlit573;
static Object strlit607;
static Object strlit626;
static Object strlit656;
static Object strlit685;
static Object strlit710;
static ClassData objclass715;
static Object strlit868;
static ClassData objclass871;
static Object strlit961;
static Object strlit981;
static ClassData objclass987;
Object module_util;
Object module_util_init();
Object module_identifierKinds;
Object module_identifierKinds_init();
static Object strlit997;
static ClassData objclass1002;
static ClassData objclass1005;
static Object strlit1010;
static ClassData objclass1023;
static Object strlit1035;
static Object strlit1047;
static Object strlit1062;
static ClassData objclass1080;
static Object strlit1087;
static Object strlit1089;
static Object strlit1098;
static Object strlit1109;
static Object strlit1110;
static ClassData objclass1112;
static Object strlit1116;
static Object strlit1118;
static Object strlit1126;
static ClassData objclass1128;
static Object strlit1132;
static Object strlit1136;
static Object strlit1141;
static Object strlit1146;
static Object strlit1152;
static Object strlit1165;
static Object strlit1169;
static Object strlit1178;
static Object strlit1184;
static Object strlit1191;
static ClassData objclass1196;
static ClassData objclass1199;
static Object strlit1252;
static Object strlit1261;
static Object strlit1268;
static Object strlit1289;
static Object strlit1295;
static Object strlit1302;
static Object strlit1314;
static Object strlit1325;
static Object strlit1337;
static Object strlit1347;
static Object strlit1372;
static Object strlit1381;
static Object strlit1386;
static Object strlit1411;
static Object strlit1420;
static Object strlit1425;
static Object strlit1432;
static Object strlit1441;
static Object strlit1460;
static Object strlit1465;
static Object strlit1480;
static Object strlit1485;
static Object strlit1507;
static Object strlit1512;
static Object strlit1522;
static Object strlit1527;
static Object strlit1551;
static ClassData objclass1555;
static ClassData objclass1558;
static Object strlit1712;
static Object strlit1721;
static Object strlit1728;
static Object strlit1734;
static Object strlit1757;
static Object strlit1766;
static Object strlit1771;
static Object strlit1794;
static Object strlit1810;
static Object strlit1815;
static Object strlit1835;
static Object strlit1842;
static Object strlit1847;
static Object strlit1853;
static Object strlit1864;
static Object strlit1887;
static Object strlit1895;
static Object strlit1917;
static Object strlit1922;
static Object strlit1944;
static Object strlit1953;
static Object strlit1965;
static Object strlit1972;
static Object strlit2001;
static Object strlit2002;
static ClassData objclass2017;
static ClassData objclass2020;
static Object strlit2092;
static Object strlit2101;
static Object strlit2108;
static Object strlit2114;
static Object strlit2139;
static Object strlit2150;
static Object strlit2155;
static Object strlit2159;
static Object strlit2180;
static Object strlit2193;
static Object strlit2198;
static Object strlit2202;
static Object strlit2213;
static Object strlit2226;
static Object strlit2233;
static Object strlit2245;
static Object strlit2262;
static Object strlit2265;
static Object strlit2270;
static Object strlit2298;
static Object strlit2301;
static Object strlit2306;
static Object strlit2326;
static ClassData objclass2329;
static ClassData objclass2332;
static Object strlit2407;
static Object strlit2416;
static Object strlit2423;
static Object strlit2450;
static Object strlit2461;
static Object strlit2466;
static Object strlit2470;
static Object strlit2491;
static Object strlit2504;
static Object strlit2509;
static Object strlit2513;
static Object strlit2524;
static Object strlit2537;
static Object strlit2544;
static Object strlit2553;
static Object strlit2570;
static Object strlit2573;
static Object strlit2578;
static Object strlit2606;
static Object strlit2609;
static Object strlit2614;
static Object strlit2634;
static ClassData objclass2637;
static ClassData objclass2640;
static Object strlit2657;
static Object strlit2804;
static Object strlit2813;
static Object strlit2820;
static Object strlit2826;
static Object strlit2833;
static Object strlit2838;
static Object strlit2842;
static Object strlit2858;
static Object strlit2871;
static Object strlit2876;
static Object strlit2881;
static Object strlit2885;
static Object strlit2903;
static Object strlit2908;
static Object strlit2912;
static Object strlit2931;
static Object strlit2936;
static Object strlit2940;
static Object strlit2952;
static Object strlit2963;
static Object strlit2968;
static Object strlit2972;
static Object strlit2983;
static Object strlit3016;
static ClassData objclass3020;
static ClassData objclass3023;
static Object strlit3042;
static Object strlit3049;
static Object strlit3055;
static Object strlit3117;
static Object strlit3126;
static Object strlit3133;
static Object strlit3139;
static Object strlit3143;
static Object strlit3166;
static Object strlit3175;
static Object strlit3180;
static Object strlit3202;
static Object strlit3211;
static Object strlit3216;
static Object strlit3229;
static Object strlit3235;
static Object strlit3237;
static Object strlit3255;
static Object strlit3260;
static Object strlit3283;
static Object strlit3288;
static Object strlit3298;
static Object strlit3327;
static Object strlit3330;
static ClassData objclass3333;
static ClassData objclass3336;
static Object strlit3370;
static Object strlit3460;
static Object strlit3469;
static Object strlit3476;
static Object strlit3482;
static Object strlit3508;
static Object strlit3521;
static Object strlit3526;
static Object strlit3530;
static Object strlit3539;
static Object strlit3559;
static Object strlit3583;
static Object strlit3596;
static Object strlit3602;
static Object strlit3604;
static Object strlit3610;
static Object strlit3637;
static Object strlit3654;
static ClassData objclass3663;
static ClassData objclass3671;
static Object strlit3741;
static Object strlit3800;
static Object strlit3884;
static Object strlit3930;
static Object strlit4102;
static Object strlit4111;
static Object strlit4118;
static Object strlit4124;
static Object strlit4137;
static Object strlit4154;
static Object strlit4159;
static Object strlit4169;
static Object strlit4190;
static Object strlit4201;
static Object strlit4209;
static Object strlit4214;
static Object strlit4218;
static Object strlit4230;
static Object strlit4237;
static Object strlit4242;
static Object strlit4246;
static Object strlit4255;
static Object strlit4260;
static Object strlit4264;
static Object strlit4276;
static Object strlit4287;
static Object strlit4292;
static Object strlit4296;
static Object strlit4309;
static Object strlit4321;
static Object strlit4326;
static Object strlit4330;
static Object strlit4340;
static Object strlit4348;
static Object strlit4353;
static Object strlit4357;
static Object strlit4370;
static Object strlit4384;
static Object strlit4389;
static Object strlit4393;
static Object strlit4405;
static Object strlit4416;
static Object strlit4421;
static Object strlit4425;
static Object strlit4436;
static Object strlit4441;
static Object strlit4464;
static Object strlit4492;
static Object strlit4505;
static Object strlit4511;
static Object strlit4561;
static Object strlit4595;
static Object strlit4602;
static Object strlit4617;
static Object strlit4626;
static Object strlit4642;
static Object strlit4657;
static Object strlit4661;
static Object strlit4664;
static Object strlit4667;
static Object strlit4675;
static Object strlit4712;
static Object strlit4717;
static Object strlit4727;
static Object strlit4732;
static Object strlit4773;
static ClassData objclass4782;
static ClassData objclass4790;
static Object strlit4812;
static Object strlit4826;
static Object strlit4836;
static Object strlit4858;
static Object strlit4992;
static Object strlit5001;
static Object strlit5013;
static Object strlit5014;
static Object strlit5020;
static Object strlit5032;
static Object strlit5043;
static Object strlit5049;
static Object strlit5066;
static Object strlit5079;
static Object strlit5090;
static Object strlit5102;
static Object strlit5119;
static Object strlit5124;
static Object strlit5147;
static Object strlit5158;
static Object strlit5172;
static Object strlit5184;
static Object strlit5189;
static Object strlit5201;
static Object strlit5222;
static Object strlit5239;
static Object strlit5246;
static Object strlit5272;
static Object strlit5281;
static Object strlit5305;
static Object strlit5312;
static ClassData objclass5318;
static ClassData objclass5333;
static Object strlit5396;
static ClassData objclass5408;
static ClassData objclass5422;
static Object strlit5438;
static Object strlit5444;
static Object strlit5451;
static Object strlit5457;
static Object strlit5631;
static Object strlit5637;
static Object strlit5643;
static Object strlit5686;
static Object strlit5695;
static Object strlit5704;
static Object strlit5711;
static Object strlit5716;
static Object strlit5720;
static Object strlit5746;
static Object strlit5751;
static Object strlit5766;
static Object strlit5771;
static Object strlit5781;
static Object strlit5792;
static Object strlit5797;
static Object strlit5801;
static Object strlit5827;
static Object strlit5838;
static Object strlit5851;
static Object strlit5857;
static Object strlit5862;
static Object strlit5870;
static Object strlit5892;
static Object strlit5909;
static Object strlit5930;
static Object strlit5935;
static Object strlit5947;
static Object strlit5952;
static Object strlit5997;
static Object strlit6003;
static Object strlit6012;
static Object strlit6014;
static ClassData objclass6021;
static ClassData objclass6024;
static Object strlit6061;
static Object strlit6070;
static Object strlit6094;
static Object strlit6103;
static Object strlit6131;
static Object strlit6138;
static Object strlit6153;
static ClassData objclass6156;
static ClassData objclass6164;
static Object strlit6238;
static Object strlit6247;
static Object strlit6259;
static Object strlit6260;
static Object strlit6265;
static Object strlit6272;
static Object strlit6297;
static Object strlit6302;
static Object strlit6319;
static Object strlit6324;
static Object strlit6334;
static Object strlit6337;
static Object strlit6364;
static Object strlit6374;
static Object strlit6391;
static Object strlit6427;
static Object strlit6446;
static Object strlit6453;
static Object strlit6459;
static Object strlit6473;
static Object strlit6480;
static Object strlit6514;
static Object strlit6532;
static ClassData objclass6537;
static ClassData objclass6540;
static Object strlit6598;
static Object strlit6607;
static Object strlit6613;
static Object strlit6635;
static Object strlit6644;
static Object strlit6649;
static Object strlit6668;
static Object strlit6677;
static Object strlit6695;
static ClassData objclass6698;
static ClassData objclass6701;
static Object strlit6755;
static Object strlit6764;
static Object strlit6771;
static Object strlit6796;
static Object strlit6805;
static Object strlit6809;
static Object strlit6814;
static Object strlit6821;
static Object strlit6825;
static Object strlit6835;
static Object strlit6844;
static Object strlit6858;
static ClassData objclass6861;
static ClassData objclass6869;
static Object strlit6898;
static Object strlit6905;
static Object strlit6912;
static Object strlit6919;
static Object strlit6985;
static Object strlit6994;
static Object strlit7006;
static Object strlit7015;
static Object strlit7021;
static Object strlit7029;
static Object strlit7035;
static Object strlit7049;
static Object strlit7054;
static Object strlit7080;
static Object strlit7085;
static Object strlit7105;
static Object strlit7110;
static Object strlit7123;
static Object strlit7146;
static Object strlit7159;
static Object strlit7195;
static Object strlit7217;
static Object strlit7223;
static Object strlit7227;
static Object strlit7233;
static Object strlit7268;
static Object strlit7275;
static Object strlit7285;
static Object strlit7290;
static ClassData objclass7293;
static ClassData objclass7301;
static Object strlit7317;
static Object strlit7324;
static Object strlit7330;
static Object strlit7336;
static Object strlit7349;
static Object strlit7356;
static Object strlit7367;
static Object strlit7376;
static ClassData objclass7379;
static ClassData objclass7382;
static Object strlit7398;
static Object strlit7405;
static Object strlit7411;
static Object strlit7423;
static Object strlit7429;
static Object strlit7440;
static Object strlit7449;
static ClassData objclass7452;
static ClassData objclass7455;
static Object strlit7465;
static Object strlit7504;
static Object strlit7513;
static Object strlit7520;
static Object strlit7527;
static Object strlit7533;
static Object strlit7539;
static Object strlit7559;
static Object strlit7579;
static Object strlit7596;
static Object strlit7605;
static Object strlit7614;
static Object strlit7626;
static Object strlit7638;
static Object strlit7645;
static Object strlit7667;
static Object strlit7676;
static Object strlit7686;
static Object strlit7733;
static ClassData objclass7736;
static ClassData objclass7739;
static Object strlit7748;
static Object strlit7754;
static Object strlit7791;
static Object strlit7800;
static Object strlit7807;
static Object strlit7828;
static Object strlit7848;
static Object strlit7861;
static Object strlit7886;
static Object strlit7901;
static Object strlit7908;
static ClassData objclass7911;
static ClassData objclass7919;
static Object strlit7941;
static Object strlit7949;
static Object strlit8055;
static Object strlit8064;
static Object strlit8071;
static Object strlit8105;
static Object strlit8110;
static Object strlit8135;
static Object strlit8140;
static Object strlit8156;
static Object strlit8160;
static Object strlit8170;
static Object strlit8181;
static Object strlit8185;
static Object strlit8215;
static Object strlit8228;
static Object strlit8235;
static Object strlit8244;
static Object strlit8252;
static Object strlit8276;
static Object strlit8291;
static Object strlit8306;
static Object strlit8310;
static Object strlit8313;
static Object strlit8316;
static Object strlit8337;
static Object strlit8361;
static Object strlit8368;
static ClassData objclass8377;
static ClassData objclass8380;
static Object strlit8401;
static Object strlit8409;
static Object strlit8428;
static Object strlit8437;
static Object strlit8458;
static Object strlit8467;
static Object strlit8571;
static Object strlit8580;
static Object strlit8587;
static Object strlit8615;
static Object strlit8620;
static Object strlit8646;
static Object strlit8651;
static Object strlit8689;
static Object strlit8694;
static Object strlit8701;
static Object strlit8710;
static Object strlit8718;
static Object strlit8742;
static Object strlit8757;
static Object strlit8772;
static Object strlit8776;
static Object strlit8779;
static Object strlit8782;
static Object strlit8803;
static Object strlit8820;
static Object strlit8827;
static ClassData objclass8835;
static ClassData objclass8838;
static Object strlit8872;
static Object strlit8880;
static Object strlit8887;
static Object strlit8895;
static Object strlit8898;
static Object strlit8984;
static Object strlit8993;
static Object strlit9000;
static Object strlit9007;
static Object strlit9014;
static Object strlit9018;
static Object strlit9028;
static Object strlit9035;
static Object strlit9039;
static Object strlit9058;
static Object strlit9065;
static Object strlit9069;
static Object strlit9079;
static Object strlit9086;
static Object strlit9092;
static Object strlit9111;
static ClassData objclass9115;
static ClassData objclass9118;
static Object strlit9129;
static Object strlit9137;
static Object strlit9140;
static Object strlit9162;
static Object strlit9171;
static Object strlit9178;
static Object strlit9185;
static Object strlit9192;
static Object strlit9196;
static Object strlit9206;
static Object strlit9212;
static Object strlit9228;
static ClassData objclass9231;
static ClassData objclass9234;
static Object strlit9262;
static Object strlit9271;
static Object strlit9278;
static Object strlit9305;
static Object strlit9318;
static ClassData objclass9321;
static ClassData objclass9329;
static Object strlit9405;
static Object strlit9414;
static Object strlit9426;
static Object strlit9430;
static Object strlit9447;
static Object strlit9457;
static Object strlit9464;
static Object strlit9468;
static Object strlit9486;
static Object strlit9491;
static Object strlit9495;
static Object strlit9505;
static Object strlit9510;
static Object strlit9514;
static Object strlit9533;
static Object strlit9544;
static Object strlit9548;
static Object strlit9557;
static Object strlit9562;
static Object strlit9572;
static Object strlit9573;
static Object strlit9590;
static Object strlit9595;
static Object strlit9599;
static Object strlit9613;
static Object strlit9620;
static Object strlit9624;
static Object strlit9645;
static Object strlit9646;
static Object strlit9698;
static Object strlit9699;
static Object strlit9706;
static ClassData objclass9717;
static ClassData objclass9720;
static Object strlit9737;
static Object strlit9739;
static Object strlit9741;
static Object strlit9753;
static Object strlit9754;
static ClassData objclass9757;
static Object strlit9761;
static ClassData objclass9780;
static Object strlit9796;
static Object strlit9805;
static Object strlit9829;
static Object strlit9834;
static Object strlit9842;
static Object strlit9851;
static Object strlit9856;
static Object strlit9920;
static Object strlit9929;
static Object strlit9936;
static Object strlit9943;
static Object strlit9949;
static Object strlit9962;
static Object strlit9967;
static Object strlit9971;
static Object strlit9983;
static Object strlit9994;
static Object strlit9999;
static Object strlit10003;
static Object strlit10024;
static Object strlit10042;
static Object strlit10051;
static Object strlit10077;
static Object strlit10083;
static Object strlit10092;
static ClassData objclass10097;
static Object strlit10101;
static ClassData objclass10110;
static Object strlit10130;
static Object strlit10139;
static Object strlit10158;
static Object strlit10163;
static Object strlit10171;
static Object strlit10180;
static Object strlit10185;
static Object strlit10210;
static Object strlit10219;
static Object strlit10226;
static Object strlit10233;
static Object strlit10239;
static Object strlit10245;
static Object strlit10250;
static Object strlit10254;
static Object strlit10266;
static Object strlit10277;
static Object strlit10282;
static Object strlit10286;
static Object strlit10309;
static Object strlit10330;
static Object strlit10339;
static Object strlit10373;
static Object strlit10374;
static Object strlit10391;
static Object strlit10401;
static Object strlit10422;
static Object strlit10429;
static ClassData objclass10433;
static ClassData objclass10436;
static Object strlit10451;
static Object strlit10458;
static Object strlit10465;
static Object strlit10471;
static Object strlit10485;
static Object strlit10507;
static Object strlit10516;
static Object strlit10525;
static Object strlit10526;
static Object strlit10528;
static Object strlit10535;
static Object strlit10542;
static Object strlit10549;
static Object strlit10554;
static Object strlit10558;
static Object strlit10574;
static Object strlit10580;
static Object strlit10583;
static Object strlit10588;
static Object strlit10598;
static Object strlit10632;
static ClassData objclass10642;
Object meth_ast__apply_40_1_41_5(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_as = getfromclosure(closure, 1);
  Object *var_newList = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_nd = &(stackframe->slots[0]);
  *var_nd = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe7 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nd (depth = 6)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8 = callmethodflags(*var_nd, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7);
// compiled call node returning call8 (depth = 5)
  gc_frame_newslot(call8);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newList (depth = 5)
  params[0] = call8;
  partcv[0] = 1;
  Object call9 = callmethodflags(*var_newList, "addLast(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6);
// compiled call node returning call9 (depth = 4)
  gc_frame_end(frame);
  return call9;
}
Object meth_ast_listMap_40_2_41_ancestors_40_1_41_1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "listMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method listMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method listMap(_,_)ancestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for listMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part listMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newList = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newList");
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array2 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2 (depth = 3)
  *var_newList = array2;
  if (array2 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4 = alloc_Block(NULL, NULL, "ast", 21);
  gc_frame_newslot(block4);
// method "_apply(_)"
  block_savedest(block4);
  Object closure5 = createclosure(4, "_apply(1)");
  setclosureframe(closure5, stackframe);
  addtoclosure(closure5, var_b);
  addtoclosure(closure5, var_as);
  addtoclosure(closure5, var_newList);
  addtoclosure(closure5, selfslot);
  struct UserObject *uo5 = (struct UserObject*)block4;
  uo5->data[0] = (Object)closure5;
  Method *meth_meth_ast__apply_40_1_41_5 = addmethod2pos(block4, "_apply(1)", &meth_ast__apply_40_1_41_5, 0);
  int argcv_meth_ast__apply_40_1_41_5[] = {1};
  meth_meth_ast__apply_40_1_41_5->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5);
  meth_meth_ast__apply_40_1_41_5->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5->definitionLine = 2969;
// compiled block node returning block4 (depth = 3)
  gc_frame_newslot(block4);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = block4;
  partcv[0] = 1;
  Object call11 = callmethodflags(*var_l, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3);
// compiled call node returning call11 (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newList (depth = 2)
  gc_frame_end(frame);
  return *var_newList;
}
Object meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap(_,_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part maybeMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_right_14 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
  Object bool16 = alloc_Boolean(0);
// compiled identifier node returning bool16 (depth = 4)
  int op_slot_left_14 = gc_frame_newslot(bool16);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult17 = callmethod(bool16, "≠(1)", 1, partcv, params);
// compiled op node returning opresult17 (depth = 3)
  Object if13 = done;
  if (istrue(opresult17)) {
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe18 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call19 = callmethodflags(*var_n, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe18);
// compiled call node returning call19 (depth = 3)
    gc_frame_newslot(call19);
    if13 = call19;
  } else {
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if13 = *var_n;
  }
// compiled if node returning if13 (depth = 2)
  gc_frame_end(frame);
  return if13;
}
Object meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeListMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap(_,_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeListMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part maybeListMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_right_22 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
  Object bool24 = alloc_Boolean(0);
// compiled identifier node returning bool24 (depth = 4)
  int op_slot_left_22 = gc_frame_newslot(bool24);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult25 = callmethod(bool24, "≠(1)", 1, partcv, params);
// compiled op node returning opresult25 (depth = 3)
  Object if21 = done;
  if (istrue(opresult25)) {
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe26 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_b;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call27 = callmethodflags(self, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe26);
// compiled call node returning call27 (depth = 3)
    gc_frame_newslot(call27);
    if21 = call27;
  } else {
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if21 = *var_n;
  }
// compiled if node returning if21 (depth = 2)
  gc_frame_end(frame);
  return if21;
}
Object meth_ast_setLine_40_1_41_col_40_1_41_36(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setLine(1)col(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setLine(_)col(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setLine(_)col(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for setLine(_)col(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part setLine(_)");
  Object *var_c = &(stackframe->slots[1]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part col(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe37 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call38 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe37);
// compiled call node returning call38 (depth = 2)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe39 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 4: self request
  params[0] = *var_c;
  partcv[0] = 1;
  Object call40 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe39);
// compiled call node returning call40 (depth = 2)
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_setPositionFrom_40_1_41_41(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setPositionFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setPositionFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for setPositionFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part setPositionFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe42 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe43 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  Object call44 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe43);
// compiled member node returning call44 (depth = 3)
  gc_frame_newslot(call44);
// call case 4: self request
  params[0] = call44;
  partcv[0] = 1;
  Object call45 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe42);
// compiled call node returning call45 (depth = 2)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe46 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe47 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  Object call48 = callmethodflags(*var_token, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe47);
// compiled member node returning call48 (depth = 3)
  gc_frame_newslot(call48);
// call case 4: self request
  params[0] = call48;
  partcv[0] = 1;
  Object call49 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe46);
// compiled call node returning call49 (depth = 2)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_kind50(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "kind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe51 = gc_frame_new();
// call case 5: prelude request
  Object call52 = callmethodflags(prelude, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe51);
// compiled member node returning call52 (depth = 2)
  gc_frame_end(frame);
  return call52;
}
Object meth_ast__61__61__40_1_41_53(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe54 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call55 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe54);
// compiled call node returning call55 (depth = 2)
  gc_frame_end(frame);
  return call55;
}
Object meth_ast_isAppliedOccurenceOfIdentifier56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool57 = alloc_Boolean(0);
// compiled identifier node returning bool57 (depth = 2)
  gc_frame_end(frame);
  return bool57;
}
Object meth_ast_isMatchingBlock58(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool59 = alloc_Boolean(0);
// compiled identifier node returning bool59 (depth = 2)
  gc_frame_end(frame);
  return bool59;
}
Object meth_ast_isFieldDec60(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool61 = alloc_Boolean(0);
// compiled identifier node returning bool61 (depth = 2)
  gc_frame_end(frame);
  return bool61;
}
Object meth_ast_isInherits62(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool63 = alloc_Boolean(0);
// compiled identifier node returning bool63 (depth = 2)
  gc_frame_end(frame);
  return bool63;
}
Object meth_ast_isLegalInTrait64(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool65 = alloc_Boolean(0);
// compiled identifier node returning bool65 (depth = 2)
  gc_frame_end(frame);
  return bool65;
}
Object meth_ast_isMember66(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool67 = alloc_Boolean(0);
// compiled identifier node returning bool67 (depth = 2)
  gc_frame_end(frame);
  return bool67;
}
Object meth_ast_isMethod68(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool69 = alloc_Boolean(0);
// compiled identifier node returning bool69 (depth = 2)
  gc_frame_end(frame);
  return bool69;
}
Object meth_ast_isExecutable70(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool71 = alloc_Boolean(1);
// compiled identifier node returning bool71 (depth = 2)
  gc_frame_end(frame);
  return bool71;
}
Object meth_ast_isCall72(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool73 = alloc_Boolean(0);
// compiled identifier node returning bool73 (depth = 2)
  gc_frame_end(frame);
  return bool73;
}
Object meth_ast_isComment74(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool75 = alloc_Boolean(0);
// compiled identifier node returning bool75 (depth = 2)
  gc_frame_end(frame);
  return bool75;
}
Object meth_ast_isClass76(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool77 = alloc_Boolean(0);
// compiled identifier node returning bool77 (depth = 2)
  gc_frame_end(frame);
  return bool77;
}
Object meth_ast_inClass78(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool79 = alloc_Boolean(0);
// compiled identifier node returning bool79 (depth = 2)
  gc_frame_end(frame);
  return bool79;
}
Object meth_ast_isTrait80(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool81 = alloc_Boolean(0);
// compiled identifier node returning bool81 (depth = 2)
  gc_frame_end(frame);
  return bool81;
}
Object meth_ast_inTrait82(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 2)
  gc_frame_end(frame);
  return bool83;
}
Object meth_ast_isBind84(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool85 = alloc_Boolean(0);
// compiled identifier node returning bool85 (depth = 2)
  gc_frame_end(frame);
  return bool85;
}
Object meth_ast_isSelf86(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool87 = alloc_Boolean(0);
// compiled identifier node returning bool87 (depth = 2)
  gc_frame_end(frame);
  return bool87;
}
Object meth_ast_isSuper88(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuper");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool89 = alloc_Boolean(0);
// compiled identifier node returning bool89 (depth = 2)
  gc_frame_end(frame);
  return bool89;
}
Object meth_ast_isPrelude90(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPrelude");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool91 = alloc_Boolean(0);
// compiled identifier node returning bool91 (depth = 2)
  gc_frame_end(frame);
  return bool91;
}
Object meth_ast_isOuter92(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool93 = alloc_Boolean(0);
// compiled identifier node returning bool93 (depth = 2)
  gc_frame_end(frame);
  return bool93;
}
Object meth_ast_isBlock94(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool95 = alloc_Boolean(0);
// compiled identifier node returning bool95 (depth = 2)
  gc_frame_end(frame);
  return bool95;
}
Object meth_ast_isObject96(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool97 = alloc_Boolean(0);
// compiled identifier node returning bool97 (depth = 2)
  gc_frame_end(frame);
  return bool97;
}
Object meth_ast_isIdentifier98(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool99 = alloc_Boolean(0);
// compiled identifier node returning bool99 (depth = 2)
  gc_frame_end(frame);
  return bool99;
}
Object meth_ast_isDialect100(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool101 = alloc_Boolean(0);
// compiled identifier node returning bool101 (depth = 2)
  gc_frame_end(frame);
  return bool101;
}
Object meth_ast_isImport102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool103 = alloc_Boolean(0);
// compiled identifier node returning bool103 (depth = 2)
  gc_frame_end(frame);
  return bool103;
}
Object meth_ast_isTypeDec104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool105 = alloc_Boolean(0);
// compiled identifier node returning bool105 (depth = 2)
  gc_frame_end(frame);
  return bool105;
}
Object meth_ast_isExternal106(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool107 = alloc_Boolean(0);
// compiled identifier node returning bool107 (depth = 2)
  gc_frame_end(frame);
  return bool107;
}
Object meth_ast_canInherit108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool109 = alloc_Boolean(0);
// compiled identifier node returning bool109 (depth = 2)
  gc_frame_end(frame);
  return bool109;
}
Object meth_ast_returnsObject110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool111 = alloc_Boolean(0);
// compiled identifier node returning bool111 (depth = 2)
  gc_frame_end(frame);
  return bool111;
}
Object meth_ast_isImplicit112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImplicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool113 = alloc_Boolean(0);
// compiled identifier node returning bool113 (depth = 2)
  gc_frame_end(frame);
  return bool113;
}
Object meth_ast_usesAsType_40_1_41_114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool115 = alloc_Boolean(0);
// compiled identifier node returning bool115 (depth = 2)
  gc_frame_end(frame);
  return bool115;
}
Object meth_ast_hash116(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe118 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe119 = gc_frame_new();
// call case 4: self request
  Object call120 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe119);
// compiled member node returning call120 (depth = 4)
  Object call121 = callmethodflags(call120, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe118);
// compiled member node returning call121 (depth = 3)
  int op_slot_right_117 = gc_frame_newslot(call121);
// starting to compile member node (depth = 3)
  int callframe123 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe124 = gc_frame_new();
// call case 4: self request
  Object call125 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe124);
// compiled member node returning call125 (depth = 4)
  Object call126 = callmethodflags(call125, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe123);
// compiled member node returning call126 (depth = 3)
  int op_slot_left_117 = gc_frame_newslot(call126);
  params[0] = call121;
  partcv[0] = 1;
  Object prod127 = callmethod(call126, "*(1)", 1, partcv, params);
// compiled op node returning prod127 (depth = 2)
  gc_frame_end(frame);
  return prod127;
}
Object meth_ast_asString128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit130 == NULL) {
    strlit130 = alloc_String("");
    gc_root(strlit130);
  }
// compiled string node returning strlit130 (depth = 3)
  int op_slot_right_129 = gc_frame_newslot(strlit130);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe133 = gc_frame_new();
// call case 4: self request
  Object call134 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe133);
// compiled member node returning call134 (depth = 4)
  int op_slot_right_132 = gc_frame_newslot(call134);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit137 == NULL) {
    strlit137 = alloc_String(" ");
    gc_root(strlit137);
  }
// compiled string node returning strlit137 (depth = 5)
  int op_slot_right_136 = gc_frame_newslot(strlit137);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe140 = gc_frame_new();
// call case 4: self request
  Object call141 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe140);
// compiled member node returning call141 (depth = 6)
  int op_slot_right_139 = gc_frame_newslot(call141);
// starting to compile string node (depth = 6)
  if (strlit143 == NULL) {
    strlit143 = alloc_String("");
    gc_root(strlit143);
  }
// compiled string node returning strlit143 (depth = 6)
  int op_slot_left_139 = gc_frame_newslot(strlit143);
  params[0] = call141;
  partcv[0] = 1;
  Object opresult144 = callmethod(strlit143, "++(1)", 1, partcv, params);
// compiled op node returning opresult144 (depth = 5)
  int op_slot_left_136 = gc_frame_newslot(opresult144);
  params[0] = strlit137;
  partcv[0] = 1;
  Object opresult145 = callmethod(opresult144, "++(1)", 1, partcv, params);
// compiled op node returning opresult145 (depth = 4)
  int op_slot_left_132 = gc_frame_newslot(opresult145);
  params[0] = call134;
  partcv[0] = 1;
  Object opresult146 = callmethod(opresult145, "++(1)", 1, partcv, params);
// compiled op node returning opresult146 (depth = 3)
  int op_slot_left_129 = gc_frame_newslot(opresult146);
  params[0] = strlit130;
  partcv[0] = 1;
  Object opresult147 = callmethod(opresult146, "++(1)", 1, partcv, params);
// compiled op node returning opresult147 (depth = 2)
  gc_frame_end(frame);
  return opresult147;
}
Object meth_ast_nameString148(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit149 == NULL) {
    strlit149 = alloc_String("?");
    gc_root(strlit149);
  }
// compiled string node returning strlit149 (depth = 2)
  gc_frame_end(frame);
  return strlit149;
}
Object meth_ast_isWritable150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool151 = alloc_Boolean(1);
// compiled identifier node returning bool151 (depth = 2)
  gc_frame_end(frame);
  return bool151;
}
Object meth_ast_isReadable152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool153 = alloc_Boolean(1);
// compiled identifier node returning bool153 (depth = 2)
  gc_frame_end(frame);
  return bool153;
}
Object meth_ast_isPublic154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool155 = alloc_Boolean(1);
// compiled identifier node returning bool155 (depth = 2)
  gc_frame_end(frame);
  return bool155;
}
Object meth_ast_isConfidential156(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe157 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe158 = gc_frame_new();
// call case 4: self request
  Object call159 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe158);
// compiled member node returning call159 (depth = 3)
  Object call160 = callmethodflags(call159, "not", 0, partcv, params, 0);
  gc_frame_end(callframe157);
// compiled member node returning call160 (depth = 2)
  gc_frame_end(frame);
  return call160;
}
Object meth_ast_decType161(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe164 = gc_frame_new();
// call case 4: self request
  Object call165 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe164);
// compiled member node returning call165 (depth = 4)
  int op_slot_right_163 = gc_frame_newslot(call165);
// starting to compile identifier node (depth = 4)
  Object bool167 = alloc_Boolean(0);
// compiled identifier node returning bool167 (depth = 4)
  int op_slot_left_163 = gc_frame_newslot(bool167);
  params[0] = call165;
  partcv[0] = 1;
  Object opresult168 = callmethod(bool167, "==(1)", 1, partcv, params);
// compiled op node returning opresult168 (depth = 3)
  Object if162 = done;
  if (istrue(opresult168)) {
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unknownType (depth = 4)
  return *var_unknownType;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if162 = undefined;
  } else {
  }
// compiled if node returning if162 (depth = 2)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe169 = gc_frame_new();
// call case 4: self request
  Object call170 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe169);
// compiled member node returning call170 (depth = 3)
  return call170;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_isSimple171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool172 = alloc_Boolean(1);
// compiled identifier node returning bool172 (depth = 2)
  gc_frame_end(frame);
  return bool172;
}
Object meth_ast_isDelimited173(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool174 = alloc_Boolean(0);
// compiled identifier node returning bool174 (depth = 2)
  gc_frame_end(frame);
  return bool174;
}
Object meth_ast_description175(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe176 = gc_frame_new();
// call case 4: self request
  Object call177 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe176);
// compiled member node returning call177 (depth = 2)
  gc_frame_end(frame);
  return call177;
}
Object meth_ast_accept_40_1_41_178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)");
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe179 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitor (depth = 3)
  gc_frame_newslot(*var_visitor);
// starting to compile member node (depth = 3)
  int callframe180 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ancestorChain (depth = 4)
  Object call181 = callmethodflags(*var_ancestorChain, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe180);
// compiled member node returning call181 (depth = 3)
  gc_frame_newslot(call181);
// call case 4: self request
  params[0] = *var_visitor;
  params[1] = call181;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call182 = callmethodflags(self, "accept(1)from(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe179);
// compiled call node returning call182 (depth = 2)
  gc_frame_end(frame);
  return call182;
}
Object meth_ast_scope183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe184 = gc_frame_new();
// call case 4: self request
  Object call185 = callmethodflags(self, "symbolTable", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe184);
// compiled member node returning call185 (depth = 2)
  gc_frame_end(frame);
  return call185;
}
Object meth_ast_scope_58__61__40_1_41_186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe187 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_st (depth = 3)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call188 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe187);
// compiled call node returning call188 (depth = 2)
  gc_frame_end(frame);
  return call188;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_189(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe190 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe191 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  Object call192 = callmethodflags(*var_other, "register", 0, partcv, params, 0);
  gc_frame_end(callframe191);
// compiled member node returning call192 (depth = 3)
  gc_frame_newslot(call192);
// call case 4: self request
  params[0] = call192;
  partcv[0] = 1;
  Object call193 = callmethodflags(self, "register:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe190);
// compiled call node returning call193 (depth = 2)
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe194 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  Object call196 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe195);
// compiled member node returning call196 (depth = 3)
  gc_frame_newslot(call196);
// call case 4: self request
  params[0] = call196;
  partcv[0] = 1;
  Object call197 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe194);
// compiled call node returning call197 (depth = 2)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe198 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe199 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  Object call200 = callmethodflags(*var_other, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe199);
// compiled member node returning call200 (depth = 3)
  gc_frame_newslot(call200);
// call case 4: self request
  params[0] = call200;
  partcv[0] = 1;
  Object call201 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe198);
// compiled call node returning call201 (depth = 2)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe202 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe203 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  Object call204 = callmethodflags(*var_other, "scope", 0, partcv, params, 0);
  gc_frame_end(callframe203);
// compiled member node returning call204 (depth = 3)
  gc_frame_newslot(call204);
// call case 4: self request
  params[0] = call204;
  partcv[0] = 1;
  Object call205 = callmethodflags(self, "scope:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe202);
// compiled call node returning call205 (depth = 2)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply_40_1_41_214(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit216 == NULL) {
    strlit216 = alloc_String("  ");
    gc_root(strlit216);
  }
// compiled string node returning strlit216 (depth = 6)
  int op_slot_right_215 = gc_frame_newslot(strlit216);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_215 = gc_frame_newslot(*var_spc);
  params[0] = strlit216;
  partcv[0] = 1;
  Object opresult218 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult218 (depth = 5)
  *var_spc = opresult218;
  if (opresult218 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply225(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit227 == NULL) {
    strlit227 = alloc_String("symbols");
    gc_root(strlit227);
  }
// compiled string node returning strlit227 (depth = 6)
  int op_slot_right_226 = gc_frame_newslot(strlit227);
// starting to compile member node (depth = 6)
  int callframe229 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  Object call230 = callmethodflags(*var_util, "target", 0, partcv, params, 0);
  gc_frame_end(callframe229);
// compiled member node returning call230 (depth = 6)
  int op_slot_left_226 = gc_frame_newslot(call230);
  params[0] = strlit227;
  partcv[0] = 1;
  Object opresult231 = callmethod(call230, "==(1)", 1, partcv, params);
// compiled op node returning opresult231 (depth = 5)
  gc_frame_end(frame);
  return opresult231;
}
Object meth_ast_pretty_40_1_41_206(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit207 == NULL) {
    strlit207 = alloc_String("");
    gc_root(strlit207);
  }
// compiled string node returning strlit207 (depth = 3)
  *var_spc = strlit207;
  if (strlit207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe208 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  int op_slot_right_209 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 4)
  Object num211 = alloc_Float64(0);
// compiled num node returning num211 (depth = 4)
  int op_slot_left_209 = gc_frame_newslot(num211);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult212 = callmethod(num211, "..(1)", 1, partcv, params);
// compiled op node returning opresult212 (depth = 3)
  gc_frame_newslot(opresult212);
// starting to compile block node (depth = 3)
  Object block213 = alloc_Block(NULL, NULL, "ast", 174);
  gc_frame_newslot(block213);
// method "_apply(_)"
  block_savedest(block213);
  Object closure214 = createclosure(2, "_apply(1)");
  setclosureframe(closure214, stackframe);
  addtoclosure(closure214, var_spc);
  addtoclosure(closure214, selfslot);
  struct UserObject *uo214 = (struct UserObject*)block213;
  uo214->data[0] = (Object)closure214;
  Method *meth_meth_ast__apply_40_1_41_214 = addmethod2pos(block213, "_apply(1)", &meth_ast__apply_40_1_41_214, 0);
  int argcv_meth_ast__apply_40_1_41_214[] = {1};
  meth_meth_ast__apply_40_1_41_214->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_214);
  meth_meth_ast__apply_40_1_41_214->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_214->definitionLine = 2969;
// compiled block node returning block213 (depth = 3)
  gc_frame_newslot(block213);
// call case 5: prelude request
  params[0] = opresult212;
  params[1] = block213;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call221 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe208);
// compiled call node returning call221 (depth = 2)
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block224 = alloc_Block(NULL, NULL, "ast", 177);
  gc_frame_newslot(block224);
// method "_apply"
  block_savedest(block224);
  Object closure225 = createclosure(2, "_apply");
  setclosureframe(closure225, stackframe);
  addtoclosure(closure225, var_util);
  addtoclosure(closure225, selfslot);
  struct UserObject *uo225 = (struct UserObject*)block224;
  uo225->data[0] = (Object)closure225;
  Method *meth_meth_ast__apply225 = addmethod2pos(block224, "_apply", &meth_ast__apply225, 0);
  int argcv_meth_ast__apply225[] = {0};
  meth_meth_ast__apply225->type = alloc_MethodType(1, argcv_meth_ast__apply225);
  meth_meth_ast__apply225->definitionModule = modulename;
  meth_meth_ast__apply225->definitionLine = 2969;
// compiled block node returning block224 (depth = 4)
  int op_slot_right_223 = gc_frame_newslot(block224);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  int op_slot_right_234 = gc_frame_newslot(self);
// starting to compile member node (depth = 5)
  int callframe236 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe237 = gc_frame_new();
// call case 4: self request
  Object call238 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe237);
// compiled member node returning call238 (depth = 6)
  Object call239 = callmethodflags(call238, "node", 0, partcv, params, 0);
  gc_frame_end(callframe236);
// compiled member node returning call239 (depth = 5)
  int op_slot_left_234 = gc_frame_newslot(call239);
  params[0] = self;
  partcv[0] = 1;
  Object opresult240 = callmethod(call239, "==(1)", 1, partcv, params);
// compiled op node returning opresult240 (depth = 4)
  int op_slot_left_223 = gc_frame_newslot(opresult240);
  params[0] = block224;
  partcv[0] = 1;
  Object opresult241 = callmethod(opresult240, "&&(1)", 1, partcv, params);
// compiled op node returning opresult241 (depth = 3)
  Object if222 = done;
  if (istrue(opresult241)) {
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit243 == NULL) {
    strlit243 = alloc_String("");
    gc_root(strlit243);
  }
// compiled string node returning strlit243 (depth = 4)
  int op_slot_right_242 = gc_frame_newslot(strlit243);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe246 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe247 = gc_frame_new();
// call case 4: self request
  Object call248 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe247);
// compiled member node returning call248 (depth = 6)
  Object call249 = callmethodflags(call248, "elementScopesAsString", 0, partcv, params, 0);
  gc_frame_end(callframe246);
// compiled member node returning call249 (depth = 5)
  int op_slot_right_245 = gc_frame_newslot(call249);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit252 == NULL) {
    strlit252 = alloc_String("");
    gc_root(strlit252);
  }
// compiled string node returning strlit252 (depth = 6)
  int op_slot_right_251 = gc_frame_newslot(strlit252);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe255 = gc_frame_new();
// call case 4: self request
  Object call256 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe255);
// compiled member node returning call256 (depth = 7)
  int op_slot_right_254 = gc_frame_newslot(call256);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit259 == NULL) {
    strlit259 = alloc_String("): ");
    gc_root(strlit259);
  }
// compiled string node returning strlit259 (depth = 8)
  int op_slot_right_258 = gc_frame_newslot(strlit259);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe262 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe263 = gc_frame_new();
// call case 4: self request
  Object call264 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe263);
// compiled member node returning call264 (depth = 10)
  Object call265 = callmethodflags(call264, "variety", 0, partcv, params, 0);
  gc_frame_end(callframe262);
// compiled member node returning call265 (depth = 9)
  int op_slot_right_261 = gc_frame_newslot(call265);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit268 == NULL) {
    strlit268 = alloc_String("Symbols(");
    gc_root(strlit268);
  }
// compiled string node returning strlit268 (depth = 10)
  int op_slot_right_267 = gc_frame_newslot(strlit268);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_270 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit273 == NULL) {
    strlit273 = alloc_String("""\x0a""");
    gc_root(strlit273);
  }
// compiled string node returning strlit273 (depth = 12)
  int op_slot_right_272 = gc_frame_newslot(strlit273);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
  int callframe276 = gc_frame_new();
// call case 4: self request
  Object call277 = callmethodflags(self, "description", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe276);
// compiled member node returning call277 (depth = 13)
  int op_slot_right_275 = gc_frame_newslot(call277);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit280 == NULL) {
    strlit280 = alloc_String(" ");
    gc_root(strlit280);
  }
// compiled string node returning strlit280 (depth = 14)
  int op_slot_right_279 = gc_frame_newslot(strlit280);
// starting to compile op node (depth = 14)
// starting to compile member node (depth = 15)
  int callframe283 = gc_frame_new();
// call case 4: self request
  Object call284 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe283);
// compiled member node returning call284 (depth = 15)
  int op_slot_right_282 = gc_frame_newslot(call284);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit287 == NULL) {
    strlit287 = alloc_String(":");
    gc_root(strlit287);
  }
// compiled string node returning strlit287 (depth = 16)
  int op_slot_right_286 = gc_frame_newslot(strlit287);
// starting to compile op node (depth = 16)
// starting to compile member node (depth = 17)
  int callframe290 = gc_frame_new();
// call case 4: self request
  Object call291 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe290);
// compiled member node returning call291 (depth = 17)
  int op_slot_right_289 = gc_frame_newslot(call291);
// starting to compile string node (depth = 17)
  if (strlit293 == NULL) {
    strlit293 = alloc_String("");
    gc_root(strlit293);
  }
// compiled string node returning strlit293 (depth = 17)
  int op_slot_left_289 = gc_frame_newslot(strlit293);
  params[0] = call291;
  partcv[0] = 1;
  Object opresult294 = callmethod(strlit293, "++(1)", 1, partcv, params);
// compiled op node returning opresult294 (depth = 16)
  int op_slot_left_286 = gc_frame_newslot(opresult294);
  params[0] = strlit287;
  partcv[0] = 1;
  Object opresult295 = callmethod(opresult294, "++(1)", 1, partcv, params);
// compiled op node returning opresult295 (depth = 15)
  int op_slot_left_282 = gc_frame_newslot(opresult295);
  params[0] = call284;
  partcv[0] = 1;
  Object opresult296 = callmethod(opresult295, "++(1)", 1, partcv, params);
// compiled op node returning opresult296 (depth = 14)
  int op_slot_left_279 = gc_frame_newslot(opresult296);
  params[0] = strlit280;
  partcv[0] = 1;
  Object opresult297 = callmethod(opresult296, "++(1)", 1, partcv, params);
// compiled op node returning opresult297 (depth = 13)
  int op_slot_left_275 = gc_frame_newslot(opresult297);
  params[0] = call277;
  partcv[0] = 1;
  Object opresult298 = callmethod(opresult297, "++(1)", 1, partcv, params);
// compiled op node returning opresult298 (depth = 12)
  int op_slot_left_272 = gc_frame_newslot(opresult298);
  params[0] = strlit273;
  partcv[0] = 1;
  Object opresult299 = callmethod(opresult298, "++(1)", 1, partcv, params);
// compiled op node returning opresult299 (depth = 11)
  int op_slot_left_270 = gc_frame_newslot(opresult299);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult300 = callmethod(opresult299, "++(1)", 1, partcv, params);
// compiled op node returning opresult300 (depth = 10)
  int op_slot_left_267 = gc_frame_newslot(opresult300);
  params[0] = strlit268;
  partcv[0] = 1;
  Object opresult301 = callmethod(opresult300, "++(1)", 1, partcv, params);
// compiled op node returning opresult301 (depth = 9)
  int op_slot_left_261 = gc_frame_newslot(opresult301);
  params[0] = call265;
  partcv[0] = 1;
  Object opresult302 = callmethod(opresult301, "++(1)", 1, partcv, params);
// compiled op node returning opresult302 (depth = 8)
  int op_slot_left_258 = gc_frame_newslot(opresult302);
  params[0] = strlit259;
  partcv[0] = 1;
  Object opresult303 = callmethod(opresult302, "++(1)", 1, partcv, params);
// compiled op node returning opresult303 (depth = 7)
  int op_slot_left_254 = gc_frame_newslot(opresult303);
  params[0] = call256;
  partcv[0] = 1;
  Object opresult304 = callmethod(opresult303, "++(1)", 1, partcv, params);
// compiled op node returning opresult304 (depth = 6)
  int op_slot_left_251 = gc_frame_newslot(opresult304);
  params[0] = strlit252;
  partcv[0] = 1;
  Object opresult305 = callmethod(opresult304, "++(1)", 1, partcv, params);
// compiled op node returning opresult305 (depth = 5)
  int op_slot_left_245 = gc_frame_newslot(opresult305);
  params[0] = call249;
  partcv[0] = 1;
  Object opresult306 = callmethod(opresult305, "++(1)", 1, partcv, params);
// compiled op node returning opresult306 (depth = 4)
  int op_slot_left_242 = gc_frame_newslot(opresult306);
  params[0] = strlit243;
  partcv[0] = 1;
  Object opresult307 = callmethod(opresult306, "++(1)", 1, partcv, params);
// compiled op node returning opresult307 (depth = 3)
    gc_frame_newslot(opresult307);
    if222 = opresult307;
  } else {
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit310 == NULL) {
    strlit310 = alloc_String("fake");
    gc_root(strlit310);
  }
// compiled string node returning strlit310 (depth = 5)
  int op_slot_right_309 = gc_frame_newslot(strlit310);
// starting to compile member node (depth = 5)
  int callframe312 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe313 = gc_frame_new();
// call case 4: self request
  Object call314 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe313);
// compiled member node returning call314 (depth = 6)
  Object call315 = callmethodflags(call314, "variety", 0, partcv, params, 0);
  gc_frame_end(callframe312);
// compiled member node returning call315 (depth = 5)
  int op_slot_left_309 = gc_frame_newslot(call315);
  params[0] = strlit310;
  partcv[0] = 1;
  Object opresult316 = callmethod(call315, "==(1)", 1, partcv, params);
// compiled op node returning opresult316 (depth = 4)
  Object if308 = done;
  if (istrue(opresult316)) {
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit318 == NULL) {
    strlit318 = alloc_String("");
    gc_root(strlit318);
  }
// compiled string node returning strlit318 (depth = 5)
  int op_slot_right_317 = gc_frame_newslot(strlit318);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe321 = gc_frame_new();
// call case 4: self request
  Object call322 = callmethodflags(self, "description", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe321);
// compiled member node returning call322 (depth = 6)
  int op_slot_right_320 = gc_frame_newslot(call322);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit325 == NULL) {
    strlit325 = alloc_String(" ");
    gc_root(strlit325);
  }
// compiled string node returning strlit325 (depth = 7)
  int op_slot_right_324 = gc_frame_newslot(strlit325);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe328 = gc_frame_new();
// call case 4: self request
  Object call329 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe328);
// compiled member node returning call329 (depth = 8)
  int op_slot_right_327 = gc_frame_newslot(call329);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit332 == NULL) {
    strlit332 = alloc_String(":");
    gc_root(strlit332);
  }
// compiled string node returning strlit332 (depth = 9)
  int op_slot_right_331 = gc_frame_newslot(strlit332);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe335 = gc_frame_new();
// call case 4: self request
  Object call336 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe335);
// compiled member node returning call336 (depth = 10)
  int op_slot_right_334 = gc_frame_newslot(call336);
// starting to compile string node (depth = 10)
  if (strlit338 == NULL) {
    strlit338 = alloc_String("");
    gc_root(strlit338);
  }
// compiled string node returning strlit338 (depth = 10)
  int op_slot_left_334 = gc_frame_newslot(strlit338);
  params[0] = call336;
  partcv[0] = 1;
  Object opresult339 = callmethod(strlit338, "++(1)", 1, partcv, params);
// compiled op node returning opresult339 (depth = 9)
  int op_slot_left_331 = gc_frame_newslot(opresult339);
  params[0] = strlit332;
  partcv[0] = 1;
  Object opresult340 = callmethod(opresult339, "++(1)", 1, partcv, params);
// compiled op node returning opresult340 (depth = 8)
  int op_slot_left_327 = gc_frame_newslot(opresult340);
  params[0] = call329;
  partcv[0] = 1;
  Object opresult341 = callmethod(opresult340, "++(1)", 1, partcv, params);
// compiled op node returning opresult341 (depth = 7)
  int op_slot_left_324 = gc_frame_newslot(opresult341);
  params[0] = strlit325;
  partcv[0] = 1;
  Object opresult342 = callmethod(opresult341, "++(1)", 1, partcv, params);
// compiled op node returning opresult342 (depth = 6)
  int op_slot_left_320 = gc_frame_newslot(opresult342);
  params[0] = call322;
  partcv[0] = 1;
  Object opresult343 = callmethod(opresult342, "++(1)", 1, partcv, params);
// compiled op node returning opresult343 (depth = 5)
  int op_slot_left_317 = gc_frame_newslot(opresult343);
  params[0] = strlit318;
  partcv[0] = 1;
  Object opresult344 = callmethod(opresult343, "++(1)", 1, partcv, params);
// compiled op node returning opresult344 (depth = 4)
    gc_frame_newslot(opresult344);
    if308 = opresult344;
  } else {
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit346 == NULL) {
    strlit346 = alloc_String("");
    gc_root(strlit346);
  }
// compiled string node returning strlit346 (depth = 5)
  int op_slot_right_345 = gc_frame_newslot(strlit346);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe349 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe350 = gc_frame_new();
// call case 4: self request
  Object call351 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe350);
// compiled member node returning call351 (depth = 7)
  Object call352 = callmethodflags(call351, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe349);
// compiled member node returning call352 (depth = 6)
  int op_slot_right_348 = gc_frame_newslot(call352);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit355 == NULL) {
    strlit355 = alloc_String(" ");
    gc_root(strlit355);
  }
// compiled string node returning strlit355 (depth = 7)
  int op_slot_right_354 = gc_frame_newslot(strlit355);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe358 = gc_frame_new();
// call case 4: self request
  Object call359 = callmethodflags(self, "description", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe358);
// compiled member node returning call359 (depth = 8)
  int op_slot_right_357 = gc_frame_newslot(call359);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit362 == NULL) {
    strlit362 = alloc_String(" ");
    gc_root(strlit362);
  }
// compiled string node returning strlit362 (depth = 9)
  int op_slot_right_361 = gc_frame_newslot(strlit362);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe365 = gc_frame_new();
// call case 4: self request
  Object call366 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe365);
// compiled member node returning call366 (depth = 10)
  int op_slot_right_364 = gc_frame_newslot(call366);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit369 == NULL) {
    strlit369 = alloc_String(":");
    gc_root(strlit369);
  }
// compiled string node returning strlit369 (depth = 11)
  int op_slot_right_368 = gc_frame_newslot(strlit369);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe372 = gc_frame_new();
// call case 4: self request
  Object call373 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe372);
// compiled member node returning call373 (depth = 12)
  int op_slot_right_371 = gc_frame_newslot(call373);
// starting to compile string node (depth = 12)
  if (strlit375 == NULL) {
    strlit375 = alloc_String("");
    gc_root(strlit375);
  }
// compiled string node returning strlit375 (depth = 12)
  int op_slot_left_371 = gc_frame_newslot(strlit375);
  params[0] = call373;
  partcv[0] = 1;
  Object opresult376 = callmethod(strlit375, "++(1)", 1, partcv, params);
// compiled op node returning opresult376 (depth = 11)
  int op_slot_left_368 = gc_frame_newslot(opresult376);
  params[0] = strlit369;
  partcv[0] = 1;
  Object opresult377 = callmethod(opresult376, "++(1)", 1, partcv, params);
// compiled op node returning opresult377 (depth = 10)
  int op_slot_left_364 = gc_frame_newslot(opresult377);
  params[0] = call366;
  partcv[0] = 1;
  Object opresult378 = callmethod(opresult377, "++(1)", 1, partcv, params);
// compiled op node returning opresult378 (depth = 9)
  int op_slot_left_361 = gc_frame_newslot(opresult378);
  params[0] = strlit362;
  partcv[0] = 1;
  Object opresult379 = callmethod(opresult378, "++(1)", 1, partcv, params);
// compiled op node returning opresult379 (depth = 8)
  int op_slot_left_357 = gc_frame_newslot(opresult379);
  params[0] = call359;
  partcv[0] = 1;
  Object opresult380 = callmethod(opresult379, "++(1)", 1, partcv, params);
// compiled op node returning opresult380 (depth = 7)
  int op_slot_left_354 = gc_frame_newslot(opresult380);
  params[0] = strlit355;
  partcv[0] = 1;
  Object opresult381 = callmethod(opresult380, "++(1)", 1, partcv, params);
// compiled op node returning opresult381 (depth = 6)
  int op_slot_left_348 = gc_frame_newslot(opresult381);
  params[0] = call352;
  partcv[0] = 1;
  Object opresult382 = callmethod(opresult381, "++(1)", 1, partcv, params);
// compiled op node returning opresult382 (depth = 5)
  int op_slot_left_345 = gc_frame_newslot(opresult382);
  params[0] = strlit346;
  partcv[0] = 1;
  Object opresult383 = callmethod(opresult382, "++(1)", 1, partcv, params);
// compiled op node returning opresult383 (depth = 4)
    gc_frame_newslot(opresult383);
    if308 = opresult383;
  }
// compiled if node returning if308 (depth = 3)
    gc_frame_newslot(if308);
    if222 = if308;
  }
// compiled if node returning if222 (depth = 2)
  gc_frame_end(frame);
  return if222;
}
Object meth_ast__apply_40_1_41_387(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_each (depth = 4)
  gc_frame_end(frame);
  return *var_each;
}
Object meth_ast_deepCopy384(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "deepCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe385 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block386 = alloc_Block(NULL, NULL, "ast", 186);
  gc_frame_newslot(block386);
// method "_apply(_)"
  block_savedest(block386);
  Object closure387 = createclosure(1, "_apply(1)");
  setclosureframe(closure387, stackframe);
  addtoclosure(closure387, selfslot);
  struct UserObject *uo387 = (struct UserObject*)block386;
  uo387->data[0] = (Object)closure387;
  Method *meth_meth_ast__apply_40_1_41_387 = addmethod2pos(block386, "_apply(1)", &meth_ast__apply_40_1_41_387, 0);
  int argcv_meth_ast__apply_40_1_41_387[] = {1};
  meth_meth_ast__apply_40_1_41_387->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_387);
  meth_meth_ast__apply_40_1_41_387->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_387->definitionLine = 2969;
// compiled block node returning block386 (depth = 3)
  gc_frame_newslot(block386);
// starting to compile member node (depth = 3)
  int callframe389 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ancestorChain (depth = 4)
  Object call390 = callmethodflags(*var_ancestorChain, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe389);
// compiled member node returning call390 (depth = 3)
  gc_frame_newslot(call390);
// call case 4: self request
  params[0] = block386;
  params[1] = call390;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call391 = callmethodflags(self, "map(1)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe385);
// compiled call node returning call391 (depth = 2)
  gc_frame_end(frame);
  return call391;
}
Object meth_ast_enclosingObject392(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_obj = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "obj");
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe393 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe394 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe395 = gc_frame_new();
// call case 4: self request
  Object call396 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe395);
// compiled member node returning call396 (depth = 5)
  Object call397 = callmethodflags(call396, "enclosingObjectScope", 0, partcv, params, 0);
  gc_frame_end(callframe394);
// compiled member node returning call397 (depth = 4)
  Object call398 = callmethodflags(call397, "node", 0, partcv, params, 0);
  gc_frame_end(callframe393);
// compiled member node returning call398 (depth = 3)
  *var_obj = call398;
  if (call398 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_obj (depth = 2)
  gc_frame_end(frame);
  return *var_obj;
}
Object meth_ast_addComment_40_1_41_399(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComment(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComment(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComment(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addComment(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe402 = gc_frame_new();
// call case 4: self request
  Object call403 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe402);
// compiled member node returning call403 (depth = 4)
  int op_slot_right_401 = gc_frame_newslot(call403);
// starting to compile identifier node (depth = 4)
  Object bool405 = alloc_Boolean(0);
// compiled identifier node returning bool405 (depth = 4)
  int op_slot_left_401 = gc_frame_newslot(bool405);
  params[0] = call403;
  partcv[0] = 1;
  Object opresult406 = callmethod(bool405, "==(1)", 1, partcv, params);
// compiled op node returning opresult406 (depth = 3)
  Object if400 = done;
  if (istrue(opresult406)) {
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe407 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 4: self request
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call408 = callmethodflags(self, "comments:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe407);
// compiled call node returning call408 (depth = 3)
    gc_frame_newslot(call408);
    if400 = call408;
  } else {
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe409 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe410 = gc_frame_new();
// call case 4: self request
  Object call411 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe410);
// compiled member node returning call411 (depth = 4)
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call412 = callmethodflags(call411, "extendCommentUsing(1)", 1, partcv, params, 0);
  gc_frame_end(callframe409);
// compiled call node returning call412 (depth = 3)
    gc_frame_newslot(call412);
    if400 = call412;
  }
// compiled if node returning if400 (depth = 2)
  gc_frame_end(frame);
  return if400;
}
Object meth_ast__apply_40_1_41_416(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe417 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call418 = callmethodflags(self, "addComment(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe417);
// compiled call node returning call418 (depth = 4)
  gc_frame_end(frame);
  return call418;
}
Object meth_ast_addComments_40_1_41_413(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComments(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComments(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComments(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNodeList = &(stackframe->slots[0]);
  *var_cmtNodeList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addComments(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe414 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block415 = alloc_Block(NULL, NULL, "ast", 200);
  gc_frame_newslot(block415);
// method "_apply(_)"
  block_savedest(block415);
  Object closure416 = createclosure(1, "_apply(1)");
  setclosureframe(closure416, stackframe);
  addtoclosure(closure416, selfslot);
  struct UserObject *uo416 = (struct UserObject*)block415;
  uo416->data[0] = (Object)closure416;
  Method *meth_meth_ast__apply_40_1_41_416 = addmethod2pos(block415, "_apply(1)", &meth_ast__apply_40_1_41_416, 0);
  int argcv_meth_ast__apply_40_1_41_416[] = {1};
  meth_meth_ast__apply_40_1_41_416->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_416);
  meth_meth_ast__apply_40_1_41_416->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_416->definitionLine = 2969;
// compiled block node returning block415 (depth = 3)
  gc_frame_newslot(block415);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cmtNodeList (depth = 3)
  params[0] = block415;
  partcv[0] = 1;
  Object call420 = callmethodflags(*var_cmtNodeList, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe414);
// compiled call node returning call420 (depth = 2)
  gc_frame_end(frame);
  return call420;
}
Object meth_ast_statementName421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe422 = gc_frame_new();
// call case 4: self request
  Object call423 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe422);
// compiled member node returning call423 (depth = 2)
  gc_frame_end(frame);
  return call423;
}
Object meth_ast_baseNode28(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject29 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj29 = alloc_userobj2(65,61, objclass29);
  gc_frame_newslot(obj29);
if (objclass29 == NULL) {
  glfree(obj29->class->name);
  obj29->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj29, self, 0);
  addmethodreal(obj29,"outer", &reader_ast_outer_30);
  Object oldself29 = self;
  struct StackFrameObject *oldstackframe29 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe29);
  gc_frame_newslot((Object)stackframe);
  self = obj29;
  Object *oldselfslot29 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter29 = (*(struct UserObject *)self).data[0], lowerouter29 = thisouter29;
  if (inheritingObject29) {
    struct UserObject *inho29 = (struct UserObject *)inheritingObject29;
    while (inho29->super != GraceDefaultObject) inho29 = (struct UserObject *)inho29->super;
    inho29->super = obj29;
    self = inheritingObject29;
    *selfslot = self;
    lowerouter29 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter29;
  }
if (objclass29 == NULL) {
  Method *reader31 = addmethodrealflags(obj29, "register", &reader_ast_register_31, 0);
  Method *writer31 = addmethodrealflags(obj29, "register:=(1)", &writer_ast_register_31, 0);
  reader31->definitionModule = modulename;
  writer31->definitionModule = modulename;
  reader31->definitionLine = 89;
  writer31->definitionLine = 89;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 1);
if (objclass29 == NULL) {
  Method *reader32 = addmethodrealflags(obj29, "line", &reader_ast_line_32, 0);
  Method *writer32 = addmethodrealflags(obj29, "line:=(1)", &writer_ast_line_32, 0);
  reader32->definitionModule = modulename;
  writer32->definitionModule = modulename;
  reader32->definitionLine = 90;
  writer32->definitionLine = 90;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 2);
if (objclass29 == NULL) {
  Method *reader33 = addmethodrealflags(obj29, "linePos", &reader_ast_linePos_33, 0);
  Method *writer33 = addmethodrealflags(obj29, "linePos:=(1)", &writer_ast_linePos_33, 0);
  reader33->definitionModule = modulename;
  writer33->definitionModule = modulename;
  reader33->definitionLine = 91;
  writer33->definitionLine = 91;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 3);
if (objclass29 == NULL) {
  Method *reader34 = addmethodrealflags(obj29, "symbolTable", &reader_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  Method *writer34 = addmethodrealflags(obj29, "symbolTable:=(1)", &writer_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  reader34->definitionModule = modulename;
  writer34->definitionModule = modulename;
  reader34->definitionLine = 92;
  writer34->definitionLine = 92;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 4);
if (objclass29 == NULL) {
  Method *reader35 = addmethodrealflags(obj29, "comments", &reader_ast_comments_35, 0);
  Method *writer35 = addmethodrealflags(obj29, "comments:=(1)", &writer_ast_comments_35, 0);
  reader35->definitionModule = modulename;
  writer35->definitionModule = modulename;
  reader35->definitionLine = 93;
  writer35->definitionLine = 93;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 5);
// method "setLine(_)col(_)"
  struct UserObject *uo36 = (struct UserObject*)obj29;
  uo36->data[6] = emptyclosure;
  Method *meth_meth_ast_setLine_40_1_41_col_40_1_41_36 = addmethod2pos(obj29, "setLine(1)col(1)", &meth_ast_setLine_40_1_41_col_40_1_41_36, 6);
  int argcv_meth_ast_setLine_40_1_41_col_40_1_41_36[] = {1, 1};
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->type = alloc_MethodType(2, argcv_meth_ast_setLine_40_1_41_col_40_1_41_36);
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->definitionModule = modulename;
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->definitionLine = 95;
// method "setPositionFrom(_)"
  struct UserObject *uo41 = (struct UserObject*)obj29;
  uo41->data[7] = emptyclosure;
  Method *meth_meth_ast_setPositionFrom_40_1_41_41 = addmethod2pos(obj29, "setPositionFrom(1)", &meth_ast_setPositionFrom_40_1_41_41, 7);
  int argcv_meth_ast_setPositionFrom_40_1_41_41[] = {1};
  meth_meth_ast_setPositionFrom_40_1_41_41->type = alloc_MethodType(1, argcv_meth_ast_setPositionFrom_40_1_41_41);
  meth_meth_ast_setPositionFrom_40_1_41_41->definitionModule = modulename;
  meth_meth_ast_setPositionFrom_40_1_41_41->definitionLine = 100;
// method "kind"
  struct UserObject *uo50 = (struct UserObject*)obj29;
  uo50->data[8] = emptyclosure;
  Method *meth_meth_ast_kind50 = addmethod2pos(obj29, "kind", &meth_ast_kind50, 8);
  int argcv_meth_ast_kind50[] = {0};
  meth_meth_ast_kind50->type = alloc_MethodType(1, argcv_meth_ast_kind50);
  meth_meth_ast_kind50->definitionModule = modulename;
  meth_meth_ast_kind50->definitionLine = 105;
// method "==(_)"
  struct UserObject *uo53 = (struct UserObject*)obj29;
  uo53->data[9] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_53 = addmethod2pos(obj29, "==(1)", &meth_ast__61__61__40_1_41_53, 9);
  int argcv_meth_ast__61__61__40_1_41_53[] = {1};
  meth_meth_ast__61__61__40_1_41_53->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_53);
  meth_meth_ast__61__61__40_1_41_53->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_53->definitionLine = 106;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo56 = (struct UserObject*)obj29;
  uo56->data[10] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier56 = addmethod2pos(obj29, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier56, 10);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier56[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier56);
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->definitionLine = 107;
// method "isMatchingBlock"
  struct UserObject *uo58 = (struct UserObject*)obj29;
  uo58->data[11] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock58 = addmethod2pos(obj29, "isMatchingBlock", &meth_ast_isMatchingBlock58, 11);
  int argcv_meth_ast_isMatchingBlock58[] = {0};
  meth_meth_ast_isMatchingBlock58->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock58);
  meth_meth_ast_isMatchingBlock58->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock58->definitionLine = 108;
// method "isFieldDec"
  struct UserObject *uo60 = (struct UserObject*)obj29;
  uo60->data[12] = emptyclosure;
  Method *meth_meth_ast_isFieldDec60 = addmethod2pos(obj29, "isFieldDec", &meth_ast_isFieldDec60, 12);
  int argcv_meth_ast_isFieldDec60[] = {0};
  meth_meth_ast_isFieldDec60->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec60);
  meth_meth_ast_isFieldDec60->definitionModule = modulename;
  meth_meth_ast_isFieldDec60->definitionLine = 109;
// method "isInherits"
  struct UserObject *uo62 = (struct UserObject*)obj29;
  uo62->data[13] = emptyclosure;
  Method *meth_meth_ast_isInherits62 = addmethod2pos(obj29, "isInherits", &meth_ast_isInherits62, 13);
  int argcv_meth_ast_isInherits62[] = {0};
  meth_meth_ast_isInherits62->type = alloc_MethodType(1, argcv_meth_ast_isInherits62);
  meth_meth_ast_isInherits62->definitionModule = modulename;
  meth_meth_ast_isInherits62->definitionLine = 110;
// method "isLegalInTrait"
  struct UserObject *uo64 = (struct UserObject*)obj29;
  uo64->data[14] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait64 = addmethod2pos(obj29, "isLegalInTrait", &meth_ast_isLegalInTrait64, 14);
  int argcv_meth_ast_isLegalInTrait64[] = {0};
  meth_meth_ast_isLegalInTrait64->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait64);
  meth_meth_ast_isLegalInTrait64->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait64->definitionLine = 111;
// method "isMember"
  struct UserObject *uo66 = (struct UserObject*)obj29;
  uo66->data[15] = emptyclosure;
  Method *meth_meth_ast_isMember66 = addmethod2pos(obj29, "isMember", &meth_ast_isMember66, 15);
  int argcv_meth_ast_isMember66[] = {0};
  meth_meth_ast_isMember66->type = alloc_MethodType(1, argcv_meth_ast_isMember66);
  meth_meth_ast_isMember66->definitionModule = modulename;
  meth_meth_ast_isMember66->definitionLine = 112;
// method "isMethod"
  struct UserObject *uo68 = (struct UserObject*)obj29;
  uo68->data[16] = emptyclosure;
  Method *meth_meth_ast_isMethod68 = addmethod2pos(obj29, "isMethod", &meth_ast_isMethod68, 16);
  int argcv_meth_ast_isMethod68[] = {0};
  meth_meth_ast_isMethod68->type = alloc_MethodType(1, argcv_meth_ast_isMethod68);
  meth_meth_ast_isMethod68->definitionModule = modulename;
  meth_meth_ast_isMethod68->definitionLine = 113;
// method "isExecutable"
  struct UserObject *uo70 = (struct UserObject*)obj29;
  uo70->data[17] = emptyclosure;
  Method *meth_meth_ast_isExecutable70 = addmethod2pos(obj29, "isExecutable", &meth_ast_isExecutable70, 17);
  int argcv_meth_ast_isExecutable70[] = {0};
  meth_meth_ast_isExecutable70->type = alloc_MethodType(1, argcv_meth_ast_isExecutable70);
  meth_meth_ast_isExecutable70->definitionModule = modulename;
  meth_meth_ast_isExecutable70->definitionLine = 114;
// method "isCall"
  struct UserObject *uo72 = (struct UserObject*)obj29;
  uo72->data[18] = emptyclosure;
  Method *meth_meth_ast_isCall72 = addmethod2pos(obj29, "isCall", &meth_ast_isCall72, 18);
  int argcv_meth_ast_isCall72[] = {0};
  meth_meth_ast_isCall72->type = alloc_MethodType(1, argcv_meth_ast_isCall72);
  meth_meth_ast_isCall72->definitionModule = modulename;
  meth_meth_ast_isCall72->definitionLine = 115;
// method "isComment"
  struct UserObject *uo74 = (struct UserObject*)obj29;
  uo74->data[19] = emptyclosure;
  Method *meth_meth_ast_isComment74 = addmethod2pos(obj29, "isComment", &meth_ast_isComment74, 19);
  int argcv_meth_ast_isComment74[] = {0};
  meth_meth_ast_isComment74->type = alloc_MethodType(1, argcv_meth_ast_isComment74);
  meth_meth_ast_isComment74->definitionModule = modulename;
  meth_meth_ast_isComment74->definitionLine = 116;
// method "isClass"
  struct UserObject *uo76 = (struct UserObject*)obj29;
  uo76->data[20] = emptyclosure;
  Method *meth_meth_ast_isClass76 = addmethod2pos(obj29, "isClass", &meth_ast_isClass76, 20);
  int argcv_meth_ast_isClass76[] = {0};
  meth_meth_ast_isClass76->type = alloc_MethodType(1, argcv_meth_ast_isClass76);
  meth_meth_ast_isClass76->definitionModule = modulename;
  meth_meth_ast_isClass76->definitionLine = 117;
// method "inClass"
  struct UserObject *uo78 = (struct UserObject*)obj29;
  uo78->data[21] = emptyclosure;
  Method *meth_meth_ast_inClass78 = addmethod2pos(obj29, "inClass", &meth_ast_inClass78, 21);
  int argcv_meth_ast_inClass78[] = {0};
  meth_meth_ast_inClass78->type = alloc_MethodType(1, argcv_meth_ast_inClass78);
  meth_meth_ast_inClass78->definitionModule = modulename;
  meth_meth_ast_inClass78->definitionLine = 118;
// method "isTrait"
  struct UserObject *uo80 = (struct UserObject*)obj29;
  uo80->data[22] = emptyclosure;
  Method *meth_meth_ast_isTrait80 = addmethod2pos(obj29, "isTrait", &meth_ast_isTrait80, 22);
  int argcv_meth_ast_isTrait80[] = {0};
  meth_meth_ast_isTrait80->type = alloc_MethodType(1, argcv_meth_ast_isTrait80);
  meth_meth_ast_isTrait80->definitionModule = modulename;
  meth_meth_ast_isTrait80->definitionLine = 119;
// method "inTrait"
  struct UserObject *uo82 = (struct UserObject*)obj29;
  uo82->data[23] = emptyclosure;
  Method *meth_meth_ast_inTrait82 = addmethod2pos(obj29, "inTrait", &meth_ast_inTrait82, 23);
  int argcv_meth_ast_inTrait82[] = {0};
  meth_meth_ast_inTrait82->type = alloc_MethodType(1, argcv_meth_ast_inTrait82);
  meth_meth_ast_inTrait82->definitionModule = modulename;
  meth_meth_ast_inTrait82->definitionLine = 120;
// method "isBind"
  struct UserObject *uo84 = (struct UserObject*)obj29;
  uo84->data[24] = emptyclosure;
  Method *meth_meth_ast_isBind84 = addmethod2pos(obj29, "isBind", &meth_ast_isBind84, 24);
  int argcv_meth_ast_isBind84[] = {0};
  meth_meth_ast_isBind84->type = alloc_MethodType(1, argcv_meth_ast_isBind84);
  meth_meth_ast_isBind84->definitionModule = modulename;
  meth_meth_ast_isBind84->definitionLine = 121;
// method "isSelf"
  struct UserObject *uo86 = (struct UserObject*)obj29;
  uo86->data[25] = emptyclosure;
  Method *meth_meth_ast_isSelf86 = addmethod2pos(obj29, "isSelf", &meth_ast_isSelf86, 25);
  int argcv_meth_ast_isSelf86[] = {0};
  meth_meth_ast_isSelf86->type = alloc_MethodType(1, argcv_meth_ast_isSelf86);
  meth_meth_ast_isSelf86->definitionModule = modulename;
  meth_meth_ast_isSelf86->definitionLine = 122;
// method "isSuper"
  struct UserObject *uo88 = (struct UserObject*)obj29;
  uo88->data[26] = emptyclosure;
  Method *meth_meth_ast_isSuper88 = addmethod2pos(obj29, "isSuper", &meth_ast_isSuper88, 26);
  int argcv_meth_ast_isSuper88[] = {0};
  meth_meth_ast_isSuper88->type = alloc_MethodType(1, argcv_meth_ast_isSuper88);
  meth_meth_ast_isSuper88->definitionModule = modulename;
  meth_meth_ast_isSuper88->definitionLine = 123;
// method "isPrelude"
  struct UserObject *uo90 = (struct UserObject*)obj29;
  uo90->data[27] = emptyclosure;
  Method *meth_meth_ast_isPrelude90 = addmethod2pos(obj29, "isPrelude", &meth_ast_isPrelude90, 27);
  int argcv_meth_ast_isPrelude90[] = {0};
  meth_meth_ast_isPrelude90->type = alloc_MethodType(1, argcv_meth_ast_isPrelude90);
  meth_meth_ast_isPrelude90->definitionModule = modulename;
  meth_meth_ast_isPrelude90->definitionLine = 124;
// method "isOuter"
  struct UserObject *uo92 = (struct UserObject*)obj29;
  uo92->data[28] = emptyclosure;
  Method *meth_meth_ast_isOuter92 = addmethod2pos(obj29, "isOuter", &meth_ast_isOuter92, 28);
  int argcv_meth_ast_isOuter92[] = {0};
  meth_meth_ast_isOuter92->type = alloc_MethodType(1, argcv_meth_ast_isOuter92);
  meth_meth_ast_isOuter92->definitionModule = modulename;
  meth_meth_ast_isOuter92->definitionLine = 125;
// method "isBlock"
  struct UserObject *uo94 = (struct UserObject*)obj29;
  uo94->data[29] = emptyclosure;
  Method *meth_meth_ast_isBlock94 = addmethod2pos(obj29, "isBlock", &meth_ast_isBlock94, 29);
  int argcv_meth_ast_isBlock94[] = {0};
  meth_meth_ast_isBlock94->type = alloc_MethodType(1, argcv_meth_ast_isBlock94);
  meth_meth_ast_isBlock94->definitionModule = modulename;
  meth_meth_ast_isBlock94->definitionLine = 126;
// method "isObject"
  struct UserObject *uo96 = (struct UserObject*)obj29;
  uo96->data[30] = emptyclosure;
  Method *meth_meth_ast_isObject96 = addmethod2pos(obj29, "isObject", &meth_ast_isObject96, 30);
  int argcv_meth_ast_isObject96[] = {0};
  meth_meth_ast_isObject96->type = alloc_MethodType(1, argcv_meth_ast_isObject96);
  meth_meth_ast_isObject96->definitionModule = modulename;
  meth_meth_ast_isObject96->definitionLine = 127;
// method "isIdentifier"
  struct UserObject *uo98 = (struct UserObject*)obj29;
  uo98->data[31] = emptyclosure;
  Method *meth_meth_ast_isIdentifier98 = addmethod2pos(obj29, "isIdentifier", &meth_ast_isIdentifier98, 31);
  int argcv_meth_ast_isIdentifier98[] = {0};
  meth_meth_ast_isIdentifier98->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier98);
  meth_meth_ast_isIdentifier98->definitionModule = modulename;
  meth_meth_ast_isIdentifier98->definitionLine = 128;
// method "isDialect"
  struct UserObject *uo100 = (struct UserObject*)obj29;
  uo100->data[32] = emptyclosure;
  Method *meth_meth_ast_isDialect100 = addmethod2pos(obj29, "isDialect", &meth_ast_isDialect100, 32);
  int argcv_meth_ast_isDialect100[] = {0};
  meth_meth_ast_isDialect100->type = alloc_MethodType(1, argcv_meth_ast_isDialect100);
  meth_meth_ast_isDialect100->definitionModule = modulename;
  meth_meth_ast_isDialect100->definitionLine = 129;
// method "isImport"
  struct UserObject *uo102 = (struct UserObject*)obj29;
  uo102->data[33] = emptyclosure;
  Method *meth_meth_ast_isImport102 = addmethod2pos(obj29, "isImport", &meth_ast_isImport102, 33);
  int argcv_meth_ast_isImport102[] = {0};
  meth_meth_ast_isImport102->type = alloc_MethodType(1, argcv_meth_ast_isImport102);
  meth_meth_ast_isImport102->definitionModule = modulename;
  meth_meth_ast_isImport102->definitionLine = 130;
// method "isTypeDec"
  struct UserObject *uo104 = (struct UserObject*)obj29;
  uo104->data[34] = emptyclosure;
  Method *meth_meth_ast_isTypeDec104 = addmethod2pos(obj29, "isTypeDec", &meth_ast_isTypeDec104, 34);
  int argcv_meth_ast_isTypeDec104[] = {0};
  meth_meth_ast_isTypeDec104->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec104);
  meth_meth_ast_isTypeDec104->definitionModule = modulename;
  meth_meth_ast_isTypeDec104->definitionLine = 131;
// method "isExternal"
  struct UserObject *uo106 = (struct UserObject*)obj29;
  uo106->data[35] = emptyclosure;
  Method *meth_meth_ast_isExternal106 = addmethod2pos(obj29, "isExternal", &meth_ast_isExternal106, 35);
  int argcv_meth_ast_isExternal106[] = {0};
  meth_meth_ast_isExternal106->type = alloc_MethodType(1, argcv_meth_ast_isExternal106);
  meth_meth_ast_isExternal106->definitionModule = modulename;
  meth_meth_ast_isExternal106->definitionLine = 132;
// method "canInherit"
  struct UserObject *uo108 = (struct UserObject*)obj29;
  uo108->data[36] = emptyclosure;
  Method *meth_meth_ast_canInherit108 = addmethod2pos(obj29, "canInherit", &meth_ast_canInherit108, 36);
  int argcv_meth_ast_canInherit108[] = {0};
  meth_meth_ast_canInherit108->type = alloc_MethodType(1, argcv_meth_ast_canInherit108);
  meth_meth_ast_canInherit108->definitionModule = modulename;
  meth_meth_ast_canInherit108->definitionLine = 133;
// method "returnsObject"
  struct UserObject *uo110 = (struct UserObject*)obj29;
  uo110->data[37] = emptyclosure;
  Method *meth_meth_ast_returnsObject110 = addmethod2pos(obj29, "returnsObject", &meth_ast_returnsObject110, 37);
  int argcv_meth_ast_returnsObject110[] = {0};
  meth_meth_ast_returnsObject110->type = alloc_MethodType(1, argcv_meth_ast_returnsObject110);
  meth_meth_ast_returnsObject110->definitionModule = modulename;
  meth_meth_ast_returnsObject110->definitionLine = 134;
// method "isImplicit"
  struct UserObject *uo112 = (struct UserObject*)obj29;
  uo112->data[38] = emptyclosure;
  Method *meth_meth_ast_isImplicit112 = addmethod2pos(obj29, "isImplicit", &meth_ast_isImplicit112, 38);
  int argcv_meth_ast_isImplicit112[] = {0};
  meth_meth_ast_isImplicit112->type = alloc_MethodType(1, argcv_meth_ast_isImplicit112);
  meth_meth_ast_isImplicit112->definitionModule = modulename;
  meth_meth_ast_isImplicit112->definitionLine = 135;
// method "usesAsType(_)"
  struct UserObject *uo114 = (struct UserObject*)obj29;
  uo114->data[39] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_114 = addmethod2pos(obj29, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_114, 39);
  int argcv_meth_ast_usesAsType_40_1_41_114[] = {1};
  meth_meth_ast_usesAsType_40_1_41_114->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_114);
  meth_meth_ast_usesAsType_40_1_41_114->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_114->definitionLine = 136;
// method "hash"
  struct UserObject *uo116 = (struct UserObject*)obj29;
  uo116->data[40] = emptyclosure;
  Method *meth_meth_ast_hash116 = addmethod2pos(obj29, "hash", &meth_ast_hash116, 40);
  int argcv_meth_ast_hash116[] = {0};
  meth_meth_ast_hash116->type = alloc_MethodType(1, argcv_meth_ast_hash116);
  meth_meth_ast_hash116->definitionModule = modulename;
  meth_meth_ast_hash116->definitionLine = 137;
// method "asString"
  struct UserObject *uo128 = (struct UserObject*)obj29;
  uo128->data[41] = emptyclosure;
  Method *meth_meth_ast_asString128 = addmethod2pos(obj29, "asString", &meth_ast_asString128, 41);
  int argcv_meth_ast_asString128[] = {0};
  meth_meth_ast_asString128->type = alloc_MethodType(1, argcv_meth_ast_asString128);
  meth_meth_ast_asString128->definitionModule = modulename;
  meth_meth_ast_asString128->definitionLine = 138;
// method "nameString"
  struct UserObject *uo148 = (struct UserObject*)obj29;
  uo148->data[42] = emptyclosure;
  Method *meth_meth_ast_nameString148 = addmethod2pos(obj29, "nameString", &meth_ast_nameString148, 42);
  int argcv_meth_ast_nameString148[] = {0};
  meth_meth_ast_nameString148->type = alloc_MethodType(1, argcv_meth_ast_nameString148);
  meth_meth_ast_nameString148->definitionModule = modulename;
  meth_meth_ast_nameString148->definitionLine = 139;
// method "isWritable"
  struct UserObject *uo150 = (struct UserObject*)obj29;
  uo150->data[43] = emptyclosure;
  Method *meth_meth_ast_isWritable150 = addmethod2pos(obj29, "isWritable", &meth_ast_isWritable150, 43);
  int argcv_meth_ast_isWritable150[] = {0};
  meth_meth_ast_isWritable150->type = alloc_MethodType(1, argcv_meth_ast_isWritable150);
  meth_meth_ast_isWritable150->definitionModule = modulename;
  meth_meth_ast_isWritable150->definitionLine = 140;
// method "isReadable"
  struct UserObject *uo152 = (struct UserObject*)obj29;
  uo152->data[44] = emptyclosure;
  Method *meth_meth_ast_isReadable152 = addmethod2pos(obj29, "isReadable", &meth_ast_isReadable152, 44);
  int argcv_meth_ast_isReadable152[] = {0};
  meth_meth_ast_isReadable152->type = alloc_MethodType(1, argcv_meth_ast_isReadable152);
  meth_meth_ast_isReadable152->definitionModule = modulename;
  meth_meth_ast_isReadable152->definitionLine = 141;
// method "isPublic"
  struct UserObject *uo154 = (struct UserObject*)obj29;
  uo154->data[45] = emptyclosure;
  Method *meth_meth_ast_isPublic154 = addmethod2pos(obj29, "isPublic", &meth_ast_isPublic154, 45);
  int argcv_meth_ast_isPublic154[] = {0};
  meth_meth_ast_isPublic154->type = alloc_MethodType(1, argcv_meth_ast_isPublic154);
  meth_meth_ast_isPublic154->definitionModule = modulename;
  meth_meth_ast_isPublic154->definitionLine = 142;
// method "isConfidential"
  struct UserObject *uo156 = (struct UserObject*)obj29;
  uo156->data[46] = emptyclosure;
  Method *meth_meth_ast_isConfidential156 = addmethod2pos(obj29, "isConfidential", &meth_ast_isConfidential156, 46);
  int argcv_meth_ast_isConfidential156[] = {0};
  meth_meth_ast_isConfidential156->type = alloc_MethodType(1, argcv_meth_ast_isConfidential156);
  meth_meth_ast_isConfidential156->definitionModule = modulename;
  meth_meth_ast_isConfidential156->definitionLine = 143;
// method "decType"
  block_savedest(obj29);
  Object closure161 = createclosure(1, "decType");
  setclosureframe(closure161, stackframe);
  addtoclosure(closure161, var_unknownType);
  struct UserObject *uo161 = (struct UserObject*)obj29;
  uo161->data[47] = (Object)closure161;
  Method *meth_meth_ast_decType161 = addmethod2pos(obj29, "decType", &meth_ast_decType161, 47);
  int argcv_meth_ast_decType161[] = {0};
  meth_meth_ast_decType161->type = alloc_MethodType(1, argcv_meth_ast_decType161);
  meth_meth_ast_decType161->definitionModule = modulename;
  meth_meth_ast_decType161->definitionLine = 144;
// method "isSimple"
  struct UserObject *uo171 = (struct UserObject*)obj29;
  uo171->data[48] = emptyclosure;
  Method *meth_meth_ast_isSimple171 = addmethod2pos(obj29, "isSimple", &meth_ast_isSimple171, 48);
  int argcv_meth_ast_isSimple171[] = {0};
  meth_meth_ast_isSimple171->type = alloc_MethodType(1, argcv_meth_ast_isSimple171);
  meth_meth_ast_isSimple171->definitionModule = modulename;
  meth_meth_ast_isSimple171->definitionLine = 150;
// method "isDelimited"
  struct UserObject *uo173 = (struct UserObject*)obj29;
  uo173->data[49] = emptyclosure;
  Method *meth_meth_ast_isDelimited173 = addmethod2pos(obj29, "isDelimited", &meth_ast_isDelimited173, 49);
  int argcv_meth_ast_isDelimited173[] = {0};
  meth_meth_ast_isDelimited173->type = alloc_MethodType(1, argcv_meth_ast_isDelimited173);
  meth_meth_ast_isDelimited173->definitionModule = modulename;
  meth_meth_ast_isDelimited173->definitionLine = 151;
// method "description"
  struct UserObject *uo175 = (struct UserObject*)obj29;
  uo175->data[50] = emptyclosure;
  Method *meth_meth_ast_description175 = addmethod2pos(obj29, "description", &meth_ast_description175, 50);
  int argcv_meth_ast_description175[] = {0};
  meth_meth_ast_description175->type = alloc_MethodType(1, argcv_meth_ast_description175);
  meth_meth_ast_description175->definitionModule = modulename;
  meth_meth_ast_description175->definitionLine = 152;
// method "accept(_)"
  block_savedest(obj29);
  Object closure178 = createclosure(1, "accept(1)");
  setclosureframe(closure178, stackframe);
  addtoclosure(closure178, var_ancestorChain);
  struct UserObject *uo178 = (struct UserObject*)obj29;
  uo178->data[51] = (Object)closure178;
  Method *meth_meth_ast_accept_40_1_41_178 = addmethod2pos(obj29, "accept(1)", &meth_ast_accept_40_1_41_178, 51);
  int argcv_meth_ast_accept_40_1_41_178[] = {1};
  meth_meth_ast_accept_40_1_41_178->type = alloc_MethodType(1, argcv_meth_ast_accept_40_1_41_178);
  meth_meth_ast_accept_40_1_41_178->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_178->definitionLine = 153;
// method "scope"
  struct UserObject *uo183 = (struct UserObject*)obj29;
  uo183->data[52] = emptyclosure;
  Method *meth_meth_ast_scope183 = addmethod2pos(obj29, "scope", &meth_ast_scope183, 52);
  int argcv_meth_ast_scope183[] = {0};
  meth_meth_ast_scope183->type = alloc_MethodType(1, argcv_meth_ast_scope183);
  meth_meth_ast_scope183->definitionModule = modulename;
  meth_meth_ast_scope183->definitionLine = 156;
// method "scope:=(_)"
  struct UserObject *uo186 = (struct UserObject*)obj29;
  uo186->data[53] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_186 = addmethod2pos(obj29, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_186, 53);
  int argcv_meth_ast_scope_58__61__40_1_41_186[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_186->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_186);
  meth_meth_ast_scope_58__61__40_1_41_186->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_186->definitionLine = 158;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo189 = (struct UserObject*)obj29;
  uo189->data[54] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_189 = addmethod2pos(obj29, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_189, 54);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_189[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_189->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_189);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_189->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_189->definitionLine = 165;
// method "pretty(_)"
  block_savedest(obj29);
  Object closure206 = createclosure(1, "pretty(1)");
  setclosureframe(closure206, stackframe);
  addtoclosure(closure206, var_util);
  struct UserObject *uo206 = (struct UserObject*)obj29;
  uo206->data[55] = (Object)closure206;
  Method *meth_meth_ast_pretty_40_1_41_206 = addmethod2pos(obj29, "pretty(1)", &meth_ast_pretty_40_1_41_206, 55);
  int argcv_meth_ast_pretty_40_1_41_206[] = {1};
  meth_meth_ast_pretty_40_1_41_206->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_206);
  meth_meth_ast_pretty_40_1_41_206->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_206->definitionLine = 172;
// method "deepCopy"
  block_savedest(obj29);
  Object closure384 = createclosure(1, "deepCopy");
  setclosureframe(closure384, stackframe);
  addtoclosure(closure384, var_ancestorChain);
  struct UserObject *uo384 = (struct UserObject*)obj29;
  uo384->data[56] = (Object)closure384;
  Method *meth_meth_ast_deepCopy384 = addmethod2pos(obj29, "deepCopy", &meth_ast_deepCopy384, 56);
  int argcv_meth_ast_deepCopy384[] = {0};
  meth_meth_ast_deepCopy384->type = alloc_MethodType(1, argcv_meth_ast_deepCopy384);
  meth_meth_ast_deepCopy384->definitionModule = modulename;
  meth_meth_ast_deepCopy384->definitionLine = 185;
// method "enclosingObject"
  struct UserObject *uo392 = (struct UserObject*)obj29;
  uo392->data[57] = emptyclosure;
  Method *meth_meth_ast_enclosingObject392 = addmethod2pos(obj29, "enclosingObject", &meth_ast_enclosingObject392, 57);
  int argcv_meth_ast_enclosingObject392[] = {0};
  meth_meth_ast_enclosingObject392->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject392);
  meth_meth_ast_enclosingObject392->definitionModule = modulename;
  meth_meth_ast_enclosingObject392->definitionLine = 188;
// method "addComment(_)"
  struct UserObject *uo399 = (struct UserObject*)obj29;
  uo399->data[58] = emptyclosure;
  Method *meth_meth_ast_addComment_40_1_41_399 = addmethod2pos(obj29, "addComment(1)", &meth_ast_addComment_40_1_41_399, 58);
  int argcv_meth_ast_addComment_40_1_41_399[] = {1};
  meth_meth_ast_addComment_40_1_41_399->type = alloc_MethodType(1, argcv_meth_ast_addComment_40_1_41_399);
  meth_meth_ast_addComment_40_1_41_399->definitionModule = modulename;
  meth_meth_ast_addComment_40_1_41_399->definitionLine = 192;
// method "addComments(_)"
  struct UserObject *uo413 = (struct UserObject*)obj29;
  uo413->data[59] = emptyclosure;
  Method *meth_meth_ast_addComments_40_1_41_413 = addmethod2pos(obj29, "addComments(1)", &meth_ast_addComments_40_1_41_413, 59);
  int argcv_meth_ast_addComments_40_1_41_413[] = {1};
  meth_meth_ast_addComments_40_1_41_413->type = alloc_MethodType(1, argcv_meth_ast_addComments_40_1_41_413);
  meth_meth_ast_addComments_40_1_41_413->definitionModule = modulename;
  meth_meth_ast_addComments_40_1_41_413->definitionLine = 199;
// method "statementName"
  struct UserObject *uo421 = (struct UserObject*)obj29;
  uo421->data[60] = emptyclosure;
  Method *meth_meth_ast_statementName421 = addmethod2pos(obj29, "statementName", &meth_ast_statementName421, 60);
  int argcv_meth_ast_statementName421[] = {0};
  meth_meth_ast_statementName421->type = alloc_MethodType(1, argcv_meth_ast_statementName421);
  meth_meth_ast_statementName421->definitionModule = modulename;
  meth_meth_ast_statementName421->definitionLine = 202;
  sourceObject = obj29;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit424 == NULL) {
    strlit424 = alloc_String("");
    gc_root(strlit424);
  }
// compiled string node returning strlit424 (depth = 2)
  adddatum2(obj29, strlit424, 1);
  sourceObject = obj29;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe425 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  Object call426 = callmethodflags(*var_util, "linenum", 0, partcv, params, 0);
  gc_frame_end(callframe425);
// compiled member node returning call426 (depth = 2)
  adddatum2(obj29, call426, 2);
  sourceObject = obj29;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe427 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  Object call428 = callmethodflags(*var_util, "linepos", 0, partcv, params, 0);
  gc_frame_end(callframe427);
// compiled member node returning call428 (depth = 2)
  adddatum2(obj29, call428, 3);
  sourceObject = obj29;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj29, *var_fakeSymbolTable, 4);
  sourceObject = obj29;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool429 = alloc_Boolean(0);
// compiled identifier node returning bool429 (depth = 2)
  adddatum2(obj29, bool429, 5);
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  objclass29 = obj29->class;
  objclass29->definitionModule = modulename;
  objclass29->definitionLine = 87;
  (*(struct UserObject *)self).data[0] = lowerouter29;
  self = oldself29;
  selfslot = oldselfslot29;
  stackframe = oldstackframe29;
  gc_frame_end(frame);
  return obj29;
}
Object meth_ast_baseNode28_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject29 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj29 = alloc_userobj2(65,61, objclass29);
  gc_frame_newslot(obj29);
if (objclass29 == NULL) {
  glfree(obj29->class->name);
  obj29->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj29, self, 0);
  addmethodreal(obj29,"outer", &reader_ast_outer_30);
  Object oldself29 = self;
  struct StackFrameObject *oldstackframe29 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe29);
  gc_frame_newslot((Object)stackframe);
  self = obj29;
  Object *oldselfslot29 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter29 = (*(struct UserObject *)self).data[0], lowerouter29 = thisouter29;
  if (inheritingObject29) {
    struct UserObject *inho29 = (struct UserObject *)inheritingObject29;
    while (inho29->super != GraceDefaultObject) inho29 = (struct UserObject *)inho29->super;
    inho29->super = obj29;
    self = inheritingObject29;
    *selfslot = self;
    lowerouter29 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter29;
  }
if (objclass29 == NULL) {
  Method *reader31 = addmethodrealflags(obj29, "register", &reader_ast_register_31, 0);
  Method *writer31 = addmethodrealflags(obj29, "register:=(1)", &writer_ast_register_31, 0);
  reader31->definitionModule = modulename;
  writer31->definitionModule = modulename;
  reader31->definitionLine = 89;
  writer31->definitionLine = 89;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 1);
if (objclass29 == NULL) {
  Method *reader32 = addmethodrealflags(obj29, "line", &reader_ast_line_32, 0);
  Method *writer32 = addmethodrealflags(obj29, "line:=(1)", &writer_ast_line_32, 0);
  reader32->definitionModule = modulename;
  writer32->definitionModule = modulename;
  reader32->definitionLine = 90;
  writer32->definitionLine = 90;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 2);
if (objclass29 == NULL) {
  Method *reader33 = addmethodrealflags(obj29, "linePos", &reader_ast_linePos_33, 0);
  Method *writer33 = addmethodrealflags(obj29, "linePos:=(1)", &writer_ast_linePos_33, 0);
  reader33->definitionModule = modulename;
  writer33->definitionModule = modulename;
  reader33->definitionLine = 91;
  writer33->definitionLine = 91;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 3);
if (objclass29 == NULL) {
  Method *reader34 = addmethodrealflags(obj29, "symbolTable", &reader_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  Method *writer34 = addmethodrealflags(obj29, "symbolTable:=(1)", &writer_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  reader34->definitionModule = modulename;
  writer34->definitionModule = modulename;
  reader34->definitionLine = 92;
  writer34->definitionLine = 92;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 4);
if (objclass29 == NULL) {
  Method *reader35 = addmethodrealflags(obj29, "comments", &reader_ast_comments_35, 0);
  Method *writer35 = addmethodrealflags(obj29, "comments:=(1)", &writer_ast_comments_35, 0);
  reader35->definitionModule = modulename;
  writer35->definitionModule = modulename;
  reader35->definitionLine = 93;
  writer35->definitionLine = 93;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 5);
// method "setLine(_)col(_)"
  struct UserObject *uo36 = (struct UserObject*)obj29;
  uo36->data[6] = emptyclosure;
  Method *meth_meth_ast_setLine_40_1_41_col_40_1_41_36 = addmethod2pos(obj29, "setLine(1)col(1)", &meth_ast_setLine_40_1_41_col_40_1_41_36, 6);
  int argcv_meth_ast_setLine_40_1_41_col_40_1_41_36[] = {1, 1};
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->type = alloc_MethodType(2, argcv_meth_ast_setLine_40_1_41_col_40_1_41_36);
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->definitionModule = modulename;
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->definitionLine = 95;
// method "setPositionFrom(_)"
  struct UserObject *uo41 = (struct UserObject*)obj29;
  uo41->data[7] = emptyclosure;
  Method *meth_meth_ast_setPositionFrom_40_1_41_41 = addmethod2pos(obj29, "setPositionFrom(1)", &meth_ast_setPositionFrom_40_1_41_41, 7);
  int argcv_meth_ast_setPositionFrom_40_1_41_41[] = {1};
  meth_meth_ast_setPositionFrom_40_1_41_41->type = alloc_MethodType(1, argcv_meth_ast_setPositionFrom_40_1_41_41);
  meth_meth_ast_setPositionFrom_40_1_41_41->definitionModule = modulename;
  meth_meth_ast_setPositionFrom_40_1_41_41->definitionLine = 100;
// method "kind"
  struct UserObject *uo50 = (struct UserObject*)obj29;
  uo50->data[8] = emptyclosure;
  Method *meth_meth_ast_kind50 = addmethod2pos(obj29, "kind", &meth_ast_kind50, 8);
  int argcv_meth_ast_kind50[] = {0};
  meth_meth_ast_kind50->type = alloc_MethodType(1, argcv_meth_ast_kind50);
  meth_meth_ast_kind50->definitionModule = modulename;
  meth_meth_ast_kind50->definitionLine = 105;
// method "==(_)"
  struct UserObject *uo53 = (struct UserObject*)obj29;
  uo53->data[9] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_53 = addmethod2pos(obj29, "==(1)", &meth_ast__61__61__40_1_41_53, 9);
  int argcv_meth_ast__61__61__40_1_41_53[] = {1};
  meth_meth_ast__61__61__40_1_41_53->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_53);
  meth_meth_ast__61__61__40_1_41_53->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_53->definitionLine = 106;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo56 = (struct UserObject*)obj29;
  uo56->data[10] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier56 = addmethod2pos(obj29, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier56, 10);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier56[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier56);
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->definitionLine = 107;
// method "isMatchingBlock"
  struct UserObject *uo58 = (struct UserObject*)obj29;
  uo58->data[11] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock58 = addmethod2pos(obj29, "isMatchingBlock", &meth_ast_isMatchingBlock58, 11);
  int argcv_meth_ast_isMatchingBlock58[] = {0};
  meth_meth_ast_isMatchingBlock58->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock58);
  meth_meth_ast_isMatchingBlock58->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock58->definitionLine = 108;
// method "isFieldDec"
  struct UserObject *uo60 = (struct UserObject*)obj29;
  uo60->data[12] = emptyclosure;
  Method *meth_meth_ast_isFieldDec60 = addmethod2pos(obj29, "isFieldDec", &meth_ast_isFieldDec60, 12);
  int argcv_meth_ast_isFieldDec60[] = {0};
  meth_meth_ast_isFieldDec60->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec60);
  meth_meth_ast_isFieldDec60->definitionModule = modulename;
  meth_meth_ast_isFieldDec60->definitionLine = 109;
// method "isInherits"
  struct UserObject *uo62 = (struct UserObject*)obj29;
  uo62->data[13] = emptyclosure;
  Method *meth_meth_ast_isInherits62 = addmethod2pos(obj29, "isInherits", &meth_ast_isInherits62, 13);
  int argcv_meth_ast_isInherits62[] = {0};
  meth_meth_ast_isInherits62->type = alloc_MethodType(1, argcv_meth_ast_isInherits62);
  meth_meth_ast_isInherits62->definitionModule = modulename;
  meth_meth_ast_isInherits62->definitionLine = 110;
// method "isLegalInTrait"
  struct UserObject *uo64 = (struct UserObject*)obj29;
  uo64->data[14] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait64 = addmethod2pos(obj29, "isLegalInTrait", &meth_ast_isLegalInTrait64, 14);
  int argcv_meth_ast_isLegalInTrait64[] = {0};
  meth_meth_ast_isLegalInTrait64->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait64);
  meth_meth_ast_isLegalInTrait64->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait64->definitionLine = 111;
// method "isMember"
  struct UserObject *uo66 = (struct UserObject*)obj29;
  uo66->data[15] = emptyclosure;
  Method *meth_meth_ast_isMember66 = addmethod2pos(obj29, "isMember", &meth_ast_isMember66, 15);
  int argcv_meth_ast_isMember66[] = {0};
  meth_meth_ast_isMember66->type = alloc_MethodType(1, argcv_meth_ast_isMember66);
  meth_meth_ast_isMember66->definitionModule = modulename;
  meth_meth_ast_isMember66->definitionLine = 112;
// method "isMethod"
  struct UserObject *uo68 = (struct UserObject*)obj29;
  uo68->data[16] = emptyclosure;
  Method *meth_meth_ast_isMethod68 = addmethod2pos(obj29, "isMethod", &meth_ast_isMethod68, 16);
  int argcv_meth_ast_isMethod68[] = {0};
  meth_meth_ast_isMethod68->type = alloc_MethodType(1, argcv_meth_ast_isMethod68);
  meth_meth_ast_isMethod68->definitionModule = modulename;
  meth_meth_ast_isMethod68->definitionLine = 113;
// method "isExecutable"
  struct UserObject *uo70 = (struct UserObject*)obj29;
  uo70->data[17] = emptyclosure;
  Method *meth_meth_ast_isExecutable70 = addmethod2pos(obj29, "isExecutable", &meth_ast_isExecutable70, 17);
  int argcv_meth_ast_isExecutable70[] = {0};
  meth_meth_ast_isExecutable70->type = alloc_MethodType(1, argcv_meth_ast_isExecutable70);
  meth_meth_ast_isExecutable70->definitionModule = modulename;
  meth_meth_ast_isExecutable70->definitionLine = 114;
// method "isCall"
  struct UserObject *uo72 = (struct UserObject*)obj29;
  uo72->data[18] = emptyclosure;
  Method *meth_meth_ast_isCall72 = addmethod2pos(obj29, "isCall", &meth_ast_isCall72, 18);
  int argcv_meth_ast_isCall72[] = {0};
  meth_meth_ast_isCall72->type = alloc_MethodType(1, argcv_meth_ast_isCall72);
  meth_meth_ast_isCall72->definitionModule = modulename;
  meth_meth_ast_isCall72->definitionLine = 115;
// method "isComment"
  struct UserObject *uo74 = (struct UserObject*)obj29;
  uo74->data[19] = emptyclosure;
  Method *meth_meth_ast_isComment74 = addmethod2pos(obj29, "isComment", &meth_ast_isComment74, 19);
  int argcv_meth_ast_isComment74[] = {0};
  meth_meth_ast_isComment74->type = alloc_MethodType(1, argcv_meth_ast_isComment74);
  meth_meth_ast_isComment74->definitionModule = modulename;
  meth_meth_ast_isComment74->definitionLine = 116;
// method "isClass"
  struct UserObject *uo76 = (struct UserObject*)obj29;
  uo76->data[20] = emptyclosure;
  Method *meth_meth_ast_isClass76 = addmethod2pos(obj29, "isClass", &meth_ast_isClass76, 20);
  int argcv_meth_ast_isClass76[] = {0};
  meth_meth_ast_isClass76->type = alloc_MethodType(1, argcv_meth_ast_isClass76);
  meth_meth_ast_isClass76->definitionModule = modulename;
  meth_meth_ast_isClass76->definitionLine = 117;
// method "inClass"
  struct UserObject *uo78 = (struct UserObject*)obj29;
  uo78->data[21] = emptyclosure;
  Method *meth_meth_ast_inClass78 = addmethod2pos(obj29, "inClass", &meth_ast_inClass78, 21);
  int argcv_meth_ast_inClass78[] = {0};
  meth_meth_ast_inClass78->type = alloc_MethodType(1, argcv_meth_ast_inClass78);
  meth_meth_ast_inClass78->definitionModule = modulename;
  meth_meth_ast_inClass78->definitionLine = 118;
// method "isTrait"
  struct UserObject *uo80 = (struct UserObject*)obj29;
  uo80->data[22] = emptyclosure;
  Method *meth_meth_ast_isTrait80 = addmethod2pos(obj29, "isTrait", &meth_ast_isTrait80, 22);
  int argcv_meth_ast_isTrait80[] = {0};
  meth_meth_ast_isTrait80->type = alloc_MethodType(1, argcv_meth_ast_isTrait80);
  meth_meth_ast_isTrait80->definitionModule = modulename;
  meth_meth_ast_isTrait80->definitionLine = 119;
// method "inTrait"
  struct UserObject *uo82 = (struct UserObject*)obj29;
  uo82->data[23] = emptyclosure;
  Method *meth_meth_ast_inTrait82 = addmethod2pos(obj29, "inTrait", &meth_ast_inTrait82, 23);
  int argcv_meth_ast_inTrait82[] = {0};
  meth_meth_ast_inTrait82->type = alloc_MethodType(1, argcv_meth_ast_inTrait82);
  meth_meth_ast_inTrait82->definitionModule = modulename;
  meth_meth_ast_inTrait82->definitionLine = 120;
// method "isBind"
  struct UserObject *uo84 = (struct UserObject*)obj29;
  uo84->data[24] = emptyclosure;
  Method *meth_meth_ast_isBind84 = addmethod2pos(obj29, "isBind", &meth_ast_isBind84, 24);
  int argcv_meth_ast_isBind84[] = {0};
  meth_meth_ast_isBind84->type = alloc_MethodType(1, argcv_meth_ast_isBind84);
  meth_meth_ast_isBind84->definitionModule = modulename;
  meth_meth_ast_isBind84->definitionLine = 121;
// method "isSelf"
  struct UserObject *uo86 = (struct UserObject*)obj29;
  uo86->data[25] = emptyclosure;
  Method *meth_meth_ast_isSelf86 = addmethod2pos(obj29, "isSelf", &meth_ast_isSelf86, 25);
  int argcv_meth_ast_isSelf86[] = {0};
  meth_meth_ast_isSelf86->type = alloc_MethodType(1, argcv_meth_ast_isSelf86);
  meth_meth_ast_isSelf86->definitionModule = modulename;
  meth_meth_ast_isSelf86->definitionLine = 122;
// method "isSuper"
  struct UserObject *uo88 = (struct UserObject*)obj29;
  uo88->data[26] = emptyclosure;
  Method *meth_meth_ast_isSuper88 = addmethod2pos(obj29, "isSuper", &meth_ast_isSuper88, 26);
  int argcv_meth_ast_isSuper88[] = {0};
  meth_meth_ast_isSuper88->type = alloc_MethodType(1, argcv_meth_ast_isSuper88);
  meth_meth_ast_isSuper88->definitionModule = modulename;
  meth_meth_ast_isSuper88->definitionLine = 123;
// method "isPrelude"
  struct UserObject *uo90 = (struct UserObject*)obj29;
  uo90->data[27] = emptyclosure;
  Method *meth_meth_ast_isPrelude90 = addmethod2pos(obj29, "isPrelude", &meth_ast_isPrelude90, 27);
  int argcv_meth_ast_isPrelude90[] = {0};
  meth_meth_ast_isPrelude90->type = alloc_MethodType(1, argcv_meth_ast_isPrelude90);
  meth_meth_ast_isPrelude90->definitionModule = modulename;
  meth_meth_ast_isPrelude90->definitionLine = 124;
// method "isOuter"
  struct UserObject *uo92 = (struct UserObject*)obj29;
  uo92->data[28] = emptyclosure;
  Method *meth_meth_ast_isOuter92 = addmethod2pos(obj29, "isOuter", &meth_ast_isOuter92, 28);
  int argcv_meth_ast_isOuter92[] = {0};
  meth_meth_ast_isOuter92->type = alloc_MethodType(1, argcv_meth_ast_isOuter92);
  meth_meth_ast_isOuter92->definitionModule = modulename;
  meth_meth_ast_isOuter92->definitionLine = 125;
// method "isBlock"
  struct UserObject *uo94 = (struct UserObject*)obj29;
  uo94->data[29] = emptyclosure;
  Method *meth_meth_ast_isBlock94 = addmethod2pos(obj29, "isBlock", &meth_ast_isBlock94, 29);
  int argcv_meth_ast_isBlock94[] = {0};
  meth_meth_ast_isBlock94->type = alloc_MethodType(1, argcv_meth_ast_isBlock94);
  meth_meth_ast_isBlock94->definitionModule = modulename;
  meth_meth_ast_isBlock94->definitionLine = 126;
// method "isObject"
  struct UserObject *uo96 = (struct UserObject*)obj29;
  uo96->data[30] = emptyclosure;
  Method *meth_meth_ast_isObject96 = addmethod2pos(obj29, "isObject", &meth_ast_isObject96, 30);
  int argcv_meth_ast_isObject96[] = {0};
  meth_meth_ast_isObject96->type = alloc_MethodType(1, argcv_meth_ast_isObject96);
  meth_meth_ast_isObject96->definitionModule = modulename;
  meth_meth_ast_isObject96->definitionLine = 127;
// method "isIdentifier"
  struct UserObject *uo98 = (struct UserObject*)obj29;
  uo98->data[31] = emptyclosure;
  Method *meth_meth_ast_isIdentifier98 = addmethod2pos(obj29, "isIdentifier", &meth_ast_isIdentifier98, 31);
  int argcv_meth_ast_isIdentifier98[] = {0};
  meth_meth_ast_isIdentifier98->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier98);
  meth_meth_ast_isIdentifier98->definitionModule = modulename;
  meth_meth_ast_isIdentifier98->definitionLine = 128;
// method "isDialect"
  struct UserObject *uo100 = (struct UserObject*)obj29;
  uo100->data[32] = emptyclosure;
  Method *meth_meth_ast_isDialect100 = addmethod2pos(obj29, "isDialect", &meth_ast_isDialect100, 32);
  int argcv_meth_ast_isDialect100[] = {0};
  meth_meth_ast_isDialect100->type = alloc_MethodType(1, argcv_meth_ast_isDialect100);
  meth_meth_ast_isDialect100->definitionModule = modulename;
  meth_meth_ast_isDialect100->definitionLine = 129;
// method "isImport"
  struct UserObject *uo102 = (struct UserObject*)obj29;
  uo102->data[33] = emptyclosure;
  Method *meth_meth_ast_isImport102 = addmethod2pos(obj29, "isImport", &meth_ast_isImport102, 33);
  int argcv_meth_ast_isImport102[] = {0};
  meth_meth_ast_isImport102->type = alloc_MethodType(1, argcv_meth_ast_isImport102);
  meth_meth_ast_isImport102->definitionModule = modulename;
  meth_meth_ast_isImport102->definitionLine = 130;
// method "isTypeDec"
  struct UserObject *uo104 = (struct UserObject*)obj29;
  uo104->data[34] = emptyclosure;
  Method *meth_meth_ast_isTypeDec104 = addmethod2pos(obj29, "isTypeDec", &meth_ast_isTypeDec104, 34);
  int argcv_meth_ast_isTypeDec104[] = {0};
  meth_meth_ast_isTypeDec104->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec104);
  meth_meth_ast_isTypeDec104->definitionModule = modulename;
  meth_meth_ast_isTypeDec104->definitionLine = 131;
// method "isExternal"
  struct UserObject *uo106 = (struct UserObject*)obj29;
  uo106->data[35] = emptyclosure;
  Method *meth_meth_ast_isExternal106 = addmethod2pos(obj29, "isExternal", &meth_ast_isExternal106, 35);
  int argcv_meth_ast_isExternal106[] = {0};
  meth_meth_ast_isExternal106->type = alloc_MethodType(1, argcv_meth_ast_isExternal106);
  meth_meth_ast_isExternal106->definitionModule = modulename;
  meth_meth_ast_isExternal106->definitionLine = 132;
// method "canInherit"
  struct UserObject *uo108 = (struct UserObject*)obj29;
  uo108->data[36] = emptyclosure;
  Method *meth_meth_ast_canInherit108 = addmethod2pos(obj29, "canInherit", &meth_ast_canInherit108, 36);
  int argcv_meth_ast_canInherit108[] = {0};
  meth_meth_ast_canInherit108->type = alloc_MethodType(1, argcv_meth_ast_canInherit108);
  meth_meth_ast_canInherit108->definitionModule = modulename;
  meth_meth_ast_canInherit108->definitionLine = 133;
// method "returnsObject"
  struct UserObject *uo110 = (struct UserObject*)obj29;
  uo110->data[37] = emptyclosure;
  Method *meth_meth_ast_returnsObject110 = addmethod2pos(obj29, "returnsObject", &meth_ast_returnsObject110, 37);
  int argcv_meth_ast_returnsObject110[] = {0};
  meth_meth_ast_returnsObject110->type = alloc_MethodType(1, argcv_meth_ast_returnsObject110);
  meth_meth_ast_returnsObject110->definitionModule = modulename;
  meth_meth_ast_returnsObject110->definitionLine = 134;
// method "isImplicit"
  struct UserObject *uo112 = (struct UserObject*)obj29;
  uo112->data[38] = emptyclosure;
  Method *meth_meth_ast_isImplicit112 = addmethod2pos(obj29, "isImplicit", &meth_ast_isImplicit112, 38);
  int argcv_meth_ast_isImplicit112[] = {0};
  meth_meth_ast_isImplicit112->type = alloc_MethodType(1, argcv_meth_ast_isImplicit112);
  meth_meth_ast_isImplicit112->definitionModule = modulename;
  meth_meth_ast_isImplicit112->definitionLine = 135;
// method "usesAsType(_)"
  struct UserObject *uo114 = (struct UserObject*)obj29;
  uo114->data[39] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_114 = addmethod2pos(obj29, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_114, 39);
  int argcv_meth_ast_usesAsType_40_1_41_114[] = {1};
  meth_meth_ast_usesAsType_40_1_41_114->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_114);
  meth_meth_ast_usesAsType_40_1_41_114->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_114->definitionLine = 136;
// method "hash"
  struct UserObject *uo116 = (struct UserObject*)obj29;
  uo116->data[40] = emptyclosure;
  Method *meth_meth_ast_hash116 = addmethod2pos(obj29, "hash", &meth_ast_hash116, 40);
  int argcv_meth_ast_hash116[] = {0};
  meth_meth_ast_hash116->type = alloc_MethodType(1, argcv_meth_ast_hash116);
  meth_meth_ast_hash116->definitionModule = modulename;
  meth_meth_ast_hash116->definitionLine = 137;
// method "asString"
  struct UserObject *uo128 = (struct UserObject*)obj29;
  uo128->data[41] = emptyclosure;
  Method *meth_meth_ast_asString128 = addmethod2pos(obj29, "asString", &meth_ast_asString128, 41);
  int argcv_meth_ast_asString128[] = {0};
  meth_meth_ast_asString128->type = alloc_MethodType(1, argcv_meth_ast_asString128);
  meth_meth_ast_asString128->definitionModule = modulename;
  meth_meth_ast_asString128->definitionLine = 138;
// method "nameString"
  struct UserObject *uo148 = (struct UserObject*)obj29;
  uo148->data[42] = emptyclosure;
  Method *meth_meth_ast_nameString148 = addmethod2pos(obj29, "nameString", &meth_ast_nameString148, 42);
  int argcv_meth_ast_nameString148[] = {0};
  meth_meth_ast_nameString148->type = alloc_MethodType(1, argcv_meth_ast_nameString148);
  meth_meth_ast_nameString148->definitionModule = modulename;
  meth_meth_ast_nameString148->definitionLine = 139;
// method "isWritable"
  struct UserObject *uo150 = (struct UserObject*)obj29;
  uo150->data[43] = emptyclosure;
  Method *meth_meth_ast_isWritable150 = addmethod2pos(obj29, "isWritable", &meth_ast_isWritable150, 43);
  int argcv_meth_ast_isWritable150[] = {0};
  meth_meth_ast_isWritable150->type = alloc_MethodType(1, argcv_meth_ast_isWritable150);
  meth_meth_ast_isWritable150->definitionModule = modulename;
  meth_meth_ast_isWritable150->definitionLine = 140;
// method "isReadable"
  struct UserObject *uo152 = (struct UserObject*)obj29;
  uo152->data[44] = emptyclosure;
  Method *meth_meth_ast_isReadable152 = addmethod2pos(obj29, "isReadable", &meth_ast_isReadable152, 44);
  int argcv_meth_ast_isReadable152[] = {0};
  meth_meth_ast_isReadable152->type = alloc_MethodType(1, argcv_meth_ast_isReadable152);
  meth_meth_ast_isReadable152->definitionModule = modulename;
  meth_meth_ast_isReadable152->definitionLine = 141;
// method "isPublic"
  struct UserObject *uo154 = (struct UserObject*)obj29;
  uo154->data[45] = emptyclosure;
  Method *meth_meth_ast_isPublic154 = addmethod2pos(obj29, "isPublic", &meth_ast_isPublic154, 45);
  int argcv_meth_ast_isPublic154[] = {0};
  meth_meth_ast_isPublic154->type = alloc_MethodType(1, argcv_meth_ast_isPublic154);
  meth_meth_ast_isPublic154->definitionModule = modulename;
  meth_meth_ast_isPublic154->definitionLine = 142;
// method "isConfidential"
  struct UserObject *uo156 = (struct UserObject*)obj29;
  uo156->data[46] = emptyclosure;
  Method *meth_meth_ast_isConfidential156 = addmethod2pos(obj29, "isConfidential", &meth_ast_isConfidential156, 46);
  int argcv_meth_ast_isConfidential156[] = {0};
  meth_meth_ast_isConfidential156->type = alloc_MethodType(1, argcv_meth_ast_isConfidential156);
  meth_meth_ast_isConfidential156->definitionModule = modulename;
  meth_meth_ast_isConfidential156->definitionLine = 143;
// method "decType"
  block_savedest(obj29);
  Object closure161 = createclosure(1, "decType");
  setclosureframe(closure161, stackframe);
  addtoclosure(closure161, var_unknownType);
  struct UserObject *uo161 = (struct UserObject*)obj29;
  uo161->data[47] = (Object)closure161;
  Method *meth_meth_ast_decType161 = addmethod2pos(obj29, "decType", &meth_ast_decType161, 47);
  int argcv_meth_ast_decType161[] = {0};
  meth_meth_ast_decType161->type = alloc_MethodType(1, argcv_meth_ast_decType161);
  meth_meth_ast_decType161->definitionModule = modulename;
  meth_meth_ast_decType161->definitionLine = 144;
// method "isSimple"
  struct UserObject *uo171 = (struct UserObject*)obj29;
  uo171->data[48] = emptyclosure;
  Method *meth_meth_ast_isSimple171 = addmethod2pos(obj29, "isSimple", &meth_ast_isSimple171, 48);
  int argcv_meth_ast_isSimple171[] = {0};
  meth_meth_ast_isSimple171->type = alloc_MethodType(1, argcv_meth_ast_isSimple171);
  meth_meth_ast_isSimple171->definitionModule = modulename;
  meth_meth_ast_isSimple171->definitionLine = 150;
// method "isDelimited"
  struct UserObject *uo173 = (struct UserObject*)obj29;
  uo173->data[49] = emptyclosure;
  Method *meth_meth_ast_isDelimited173 = addmethod2pos(obj29, "isDelimited", &meth_ast_isDelimited173, 49);
  int argcv_meth_ast_isDelimited173[] = {0};
  meth_meth_ast_isDelimited173->type = alloc_MethodType(1, argcv_meth_ast_isDelimited173);
  meth_meth_ast_isDelimited173->definitionModule = modulename;
  meth_meth_ast_isDelimited173->definitionLine = 151;
// method "description"
  struct UserObject *uo175 = (struct UserObject*)obj29;
  uo175->data[50] = emptyclosure;
  Method *meth_meth_ast_description175 = addmethod2pos(obj29, "description", &meth_ast_description175, 50);
  int argcv_meth_ast_description175[] = {0};
  meth_meth_ast_description175->type = alloc_MethodType(1, argcv_meth_ast_description175);
  meth_meth_ast_description175->definitionModule = modulename;
  meth_meth_ast_description175->definitionLine = 152;
// method "accept(_)"
  block_savedest(obj29);
  Object closure178 = createclosure(1, "accept(1)");
  setclosureframe(closure178, stackframe);
  addtoclosure(closure178, var_ancestorChain);
  struct UserObject *uo178 = (struct UserObject*)obj29;
  uo178->data[51] = (Object)closure178;
  Method *meth_meth_ast_accept_40_1_41_178 = addmethod2pos(obj29, "accept(1)", &meth_ast_accept_40_1_41_178, 51);
  int argcv_meth_ast_accept_40_1_41_178[] = {1};
  meth_meth_ast_accept_40_1_41_178->type = alloc_MethodType(1, argcv_meth_ast_accept_40_1_41_178);
  meth_meth_ast_accept_40_1_41_178->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_178->definitionLine = 153;
// method "scope"
  struct UserObject *uo183 = (struct UserObject*)obj29;
  uo183->data[52] = emptyclosure;
  Method *meth_meth_ast_scope183 = addmethod2pos(obj29, "scope", &meth_ast_scope183, 52);
  int argcv_meth_ast_scope183[] = {0};
  meth_meth_ast_scope183->type = alloc_MethodType(1, argcv_meth_ast_scope183);
  meth_meth_ast_scope183->definitionModule = modulename;
  meth_meth_ast_scope183->definitionLine = 156;
// method "scope:=(_)"
  struct UserObject *uo186 = (struct UserObject*)obj29;
  uo186->data[53] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_186 = addmethod2pos(obj29, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_186, 53);
  int argcv_meth_ast_scope_58__61__40_1_41_186[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_186->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_186);
  meth_meth_ast_scope_58__61__40_1_41_186->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_186->definitionLine = 158;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo189 = (struct UserObject*)obj29;
  uo189->data[54] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_189 = addmethod2pos(obj29, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_189, 54);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_189[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_189->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_189);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_189->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_189->definitionLine = 165;
// method "pretty(_)"
  block_savedest(obj29);
  Object closure206 = createclosure(1, "pretty(1)");
  setclosureframe(closure206, stackframe);
  addtoclosure(closure206, var_util);
  struct UserObject *uo206 = (struct UserObject*)obj29;
  uo206->data[55] = (Object)closure206;
  Method *meth_meth_ast_pretty_40_1_41_206 = addmethod2pos(obj29, "pretty(1)", &meth_ast_pretty_40_1_41_206, 55);
  int argcv_meth_ast_pretty_40_1_41_206[] = {1};
  meth_meth_ast_pretty_40_1_41_206->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_206);
  meth_meth_ast_pretty_40_1_41_206->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_206->definitionLine = 172;
// method "deepCopy"
  block_savedest(obj29);
  Object closure384 = createclosure(1, "deepCopy");
  setclosureframe(closure384, stackframe);
  addtoclosure(closure384, var_ancestorChain);
  struct UserObject *uo384 = (struct UserObject*)obj29;
  uo384->data[56] = (Object)closure384;
  Method *meth_meth_ast_deepCopy384 = addmethod2pos(obj29, "deepCopy", &meth_ast_deepCopy384, 56);
  int argcv_meth_ast_deepCopy384[] = {0};
  meth_meth_ast_deepCopy384->type = alloc_MethodType(1, argcv_meth_ast_deepCopy384);
  meth_meth_ast_deepCopy384->definitionModule = modulename;
  meth_meth_ast_deepCopy384->definitionLine = 185;
// method "enclosingObject"
  struct UserObject *uo392 = (struct UserObject*)obj29;
  uo392->data[57] = emptyclosure;
  Method *meth_meth_ast_enclosingObject392 = addmethod2pos(obj29, "enclosingObject", &meth_ast_enclosingObject392, 57);
  int argcv_meth_ast_enclosingObject392[] = {0};
  meth_meth_ast_enclosingObject392->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject392);
  meth_meth_ast_enclosingObject392->definitionModule = modulename;
  meth_meth_ast_enclosingObject392->definitionLine = 188;
// method "addComment(_)"
  struct UserObject *uo399 = (struct UserObject*)obj29;
  uo399->data[58] = emptyclosure;
  Method *meth_meth_ast_addComment_40_1_41_399 = addmethod2pos(obj29, "addComment(1)", &meth_ast_addComment_40_1_41_399, 58);
  int argcv_meth_ast_addComment_40_1_41_399[] = {1};
  meth_meth_ast_addComment_40_1_41_399->type = alloc_MethodType(1, argcv_meth_ast_addComment_40_1_41_399);
  meth_meth_ast_addComment_40_1_41_399->definitionModule = modulename;
  meth_meth_ast_addComment_40_1_41_399->definitionLine = 192;
// method "addComments(_)"
  struct UserObject *uo413 = (struct UserObject*)obj29;
  uo413->data[59] = emptyclosure;
  Method *meth_meth_ast_addComments_40_1_41_413 = addmethod2pos(obj29, "addComments(1)", &meth_ast_addComments_40_1_41_413, 59);
  int argcv_meth_ast_addComments_40_1_41_413[] = {1};
  meth_meth_ast_addComments_40_1_41_413->type = alloc_MethodType(1, argcv_meth_ast_addComments_40_1_41_413);
  meth_meth_ast_addComments_40_1_41_413->definitionModule = modulename;
  meth_meth_ast_addComments_40_1_41_413->definitionLine = 199;
// method "statementName"
  struct UserObject *uo421 = (struct UserObject*)obj29;
  uo421->data[60] = emptyclosure;
  Method *meth_meth_ast_statementName421 = addmethod2pos(obj29, "statementName", &meth_ast_statementName421, 60);
  int argcv_meth_ast_statementName421[] = {0};
  meth_meth_ast_statementName421->type = alloc_MethodType(1, argcv_meth_ast_statementName421);
  meth_meth_ast_statementName421->definitionModule = modulename;
  meth_meth_ast_statementName421->definitionLine = 202;
  sourceObject = obj29;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit424 == NULL) {
    strlit424 = alloc_String("");
    gc_root(strlit424);
  }
// compiled string node returning strlit424 (depth = 2)
  adddatum2(obj29, strlit424, 1);
  sourceObject = obj29;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe425 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  Object call426 = callmethodflags(*var_util, "linenum", 0, partcv, params, 0);
  gc_frame_end(callframe425);
// compiled member node returning call426 (depth = 2)
  adddatum2(obj29, call426, 2);
  sourceObject = obj29;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe427 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  Object call428 = callmethodflags(*var_util, "linepos", 0, partcv, params, 0);
  gc_frame_end(callframe427);
// compiled member node returning call428 (depth = 2)
  adddatum2(obj29, call428, 3);
  sourceObject = obj29;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj29, *var_fakeSymbolTable, 4);
  sourceObject = obj29;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool429 = alloc_Boolean(0);
// compiled identifier node returning bool429 (depth = 2)
  adddatum2(obj29, bool429, 5);
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  objclass29 = obj29->class;
  objclass29->definitionModule = modulename;
  objclass29->definitionLine = 87;
  (*(struct UserObject *)self).data[0] = lowerouter29;
  self = oldself29;
  selfslot = oldselfslot29;
  stackframe = oldstackframe29;
  gc_frame_end(frame);
  return obj29;
}
Object meth_ast_newName434(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_n (depth = 2)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_oldName435(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "oldName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_o (depth = 2)
  gc_frame_end(frame);
  return *var_o;
}
Object meth_ast_asString436(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit438 == NULL) {
    strlit438 = alloc_String("");
    gc_root(strlit438);
  }
// compiled string node returning strlit438 (depth = 3)
  int op_slot_right_437 = gc_frame_newslot(strlit438);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe441 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  Object call442 = callmethodflags(*var_o, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe441);
// compiled member node returning call442 (depth = 4)
  int op_slot_right_440 = gc_frame_newslot(call442);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit445 == NULL) {
    strlit445 = alloc_String(" = ");
    gc_root(strlit445);
  }
// compiled string node returning strlit445 (depth = 5)
  int op_slot_right_444 = gc_frame_newslot(strlit445);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe448 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call449 = callmethodflags(*var_n, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe448);
// compiled member node returning call449 (depth = 6)
  int op_slot_right_447 = gc_frame_newslot(call449);
// starting to compile string node (depth = 6)
  if (strlit451 == NULL) {
    strlit451 = alloc_String("alias ");
    gc_root(strlit451);
  }
// compiled string node returning strlit451 (depth = 6)
  int op_slot_left_447 = gc_frame_newslot(strlit451);
  params[0] = call449;
  partcv[0] = 1;
  Object opresult452 = callmethod(strlit451, "++(1)", 1, partcv, params);
// compiled op node returning opresult452 (depth = 5)
  int op_slot_left_444 = gc_frame_newslot(opresult452);
  params[0] = strlit445;
  partcv[0] = 1;
  Object opresult453 = callmethod(opresult452, "++(1)", 1, partcv, params);
// compiled op node returning opresult453 (depth = 4)
  int op_slot_left_440 = gc_frame_newslot(opresult453);
  params[0] = call442;
  partcv[0] = 1;
  Object opresult454 = callmethod(opresult453, "++(1)", 1, partcv, params);
// compiled op node returning opresult454 (depth = 3)
  int op_slot_left_437 = gc_frame_newslot(opresult454);
  params[0] = strlit438;
  partcv[0] = 1;
  Object opresult455 = callmethod(opresult454, "++(1)", 1, partcv, params);
// compiled op node returning opresult455 (depth = 2)
  gc_frame_end(frame);
  return opresult455;
}
Object meth_ast__apply_40_1_41_464(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit466 == NULL) {
    strlit466 = alloc_String("  ");
    gc_root(strlit466);
  }
// compiled string node returning strlit466 (depth = 6)
  int op_slot_right_465 = gc_frame_newslot(strlit466);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_465 = gc_frame_newslot(*var_spc);
  params[0] = strlit466;
  partcv[0] = 1;
  Object opresult468 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult468 (depth = 5)
  *var_spc = opresult468;
  if (opresult468 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_456(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit457 == NULL) {
    strlit457 = alloc_String("");
    gc_root(strlit457);
  }
// compiled string node returning strlit457 (depth = 3)
  *var_spc = strlit457;
  if (strlit457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe458 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  int op_slot_right_459 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 4)
  Object num461 = alloc_Float64(0);
// compiled num node returning num461 (depth = 4)
  int op_slot_left_459 = gc_frame_newslot(num461);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult462 = callmethod(num461, "..(1)", 1, partcv, params);
// compiled op node returning opresult462 (depth = 3)
  gc_frame_newslot(opresult462);
// starting to compile block node (depth = 3)
  Object block463 = alloc_Block(NULL, NULL, "ast", 2509);
  gc_frame_newslot(block463);
// method "_apply(_)"
  block_savedest(block463);
  Object closure464 = createclosure(2, "_apply(1)");
  setclosureframe(closure464, stackframe);
  addtoclosure(closure464, var_spc);
  addtoclosure(closure464, selfslot);
  struct UserObject *uo464 = (struct UserObject*)block463;
  uo464->data[0] = (Object)closure464;
  Method *meth_meth_ast__apply_40_1_41_464 = addmethod2pos(block463, "_apply(1)", &meth_ast__apply_40_1_41_464, 0);
  int argcv_meth_ast__apply_40_1_41_464[] = {1};
  meth_meth_ast__apply_40_1_41_464->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_464);
  meth_meth_ast__apply_40_1_41_464->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_464->definitionLine = 2969;
// compiled block node returning block463 (depth = 3)
  gc_frame_newslot(block463);
// call case 5: prelude request
  params[0] = opresult462;
  params[1] = block463;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call471 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe458);
// compiled call node returning call471 (depth = 2)
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit473 == NULL) {
    strlit473 = alloc_String("");
    gc_root(strlit473);
  }
// compiled string node returning strlit473 (depth = 3)
  int op_slot_right_472 = gc_frame_newslot(strlit473);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe476 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call477 = callmethodflags(*var_o, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe476);
// compiled call node returning call477 (depth = 4)
  int op_slot_right_475 = gc_frame_newslot(call477);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit480 == NULL) {
    strlit480 = alloc_String(" = ");
    gc_root(strlit480);
  }
// compiled string node returning strlit480 (depth = 5)
  int op_slot_right_479 = gc_frame_newslot(strlit480);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe483 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call484 = callmethodflags(*var_n, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe483);
// compiled call node returning call484 (depth = 6)
  int op_slot_right_482 = gc_frame_newslot(call484);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit487 == NULL) {
    strlit487 = alloc_String("  alias ");
    gc_root(strlit487);
  }
// compiled string node returning strlit487 (depth = 7)
  int op_slot_right_486 = gc_frame_newslot(strlit487);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_489 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit491 == NULL) {
    strlit491 = alloc_String("");
    gc_root(strlit491);
  }
// compiled string node returning strlit491 (depth = 8)
  int op_slot_left_489 = gc_frame_newslot(strlit491);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult492 = callmethod(strlit491, "++(1)", 1, partcv, params);
// compiled op node returning opresult492 (depth = 7)
  int op_slot_left_486 = gc_frame_newslot(opresult492);
  params[0] = strlit487;
  partcv[0] = 1;
  Object opresult493 = callmethod(opresult492, "++(1)", 1, partcv, params);
// compiled op node returning opresult493 (depth = 6)
  int op_slot_left_482 = gc_frame_newslot(opresult493);
  params[0] = call484;
  partcv[0] = 1;
  Object opresult494 = callmethod(opresult493, "++(1)", 1, partcv, params);
// compiled op node returning opresult494 (depth = 5)
  int op_slot_left_479 = gc_frame_newslot(opresult494);
  params[0] = strlit480;
  partcv[0] = 1;
  Object opresult495 = callmethod(opresult494, "++(1)", 1, partcv, params);
// compiled op node returning opresult495 (depth = 4)
  int op_slot_left_475 = gc_frame_newslot(opresult495);
  params[0] = call477;
  partcv[0] = 1;
  Object opresult496 = callmethod(opresult495, "++(1)", 1, partcv, params);
// compiled op node returning opresult496 (depth = 3)
  int op_slot_left_472 = gc_frame_newslot(opresult496);
  params[0] = strlit473;
  partcv[0] = 1;
  Object opresult497 = callmethod(opresult496, "++(1)", 1, partcv, params);
// compiled op node returning opresult497 (depth = 2)
  gc_frame_end(frame);
  return opresult497;
}
Object meth_ast_hash498(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe500 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  Object call501 = callmethodflags(*var_o, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe500);
// compiled member node returning call501 (depth = 3)
  int op_slot_right_499 = gc_frame_newslot(call501);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num504 = alloc_Float64(1171);
// compiled num node returning num504 (depth = 4)
  int op_slot_right_503 = gc_frame_newslot(num504);
// starting to compile member node (depth = 4)
  int callframe506 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  Object call507 = callmethodflags(*var_n, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe506);
// compiled member node returning call507 (depth = 4)
  int op_slot_left_503 = gc_frame_newslot(call507);
  params[0] = num504;
  partcv[0] = 1;
  Object prod508 = callmethod(call507, "*(1)", 1, partcv, params);
// compiled op node returning prod508 (depth = 3)
  int op_slot_left_499 = gc_frame_newslot(prod508);
  params[0] = call501;
  partcv[0] = 1;
  Object sum509 = callmethod(prod508, "+(1)", 1, partcv, params);
// compiled op node returning sum509 (depth = 2)
  gc_frame_end(frame);
  return sum509;
}
Object meth_ast_isExecutable510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool511 = alloc_Boolean(0);
// compiled identifier node returning bool511 (depth = 2)
  gc_frame_end(frame);
  return bool511;
}
Object meth_ast__apply_40_1_41_515(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_that = &(stackframe->slots[0]);
  *var_that = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe518 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_that (depth = 7)
  Object call519 = callmethodflags(*var_that, "oldName", 0, partcv, params, 0);
  gc_frame_end(callframe518);
// compiled member node returning call519 (depth = 6)
  int op_slot_right_517 = gc_frame_newslot(call519);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  int op_slot_left_517 = gc_frame_newslot(*var_o);
  params[0] = call519;
  partcv[0] = 1;
  Object opresult521 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult521 (depth = 5)
  int op_slot_right_516 = gc_frame_newslot(opresult521);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe524 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_that (depth = 7)
  Object call525 = callmethodflags(*var_that, "newName", 0, partcv, params, 0);
  gc_frame_end(callframe524);
// compiled member node returning call525 (depth = 6)
  int op_slot_right_523 = gc_frame_newslot(call525);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_523 = gc_frame_newslot(*var_n);
  params[0] = call525;
  partcv[0] = 1;
  Object opresult527 = callmethod(*var_n, "==(1)", 1, partcv, params);
// compiled op node returning opresult527 (depth = 5)
  int op_slot_left_516 = gc_frame_newslot(opresult527);
  params[0] = opresult521;
  partcv[0] = 1;
  Object opresult528 = callmethod(opresult527, "&&(1)", 1, partcv, params);
// compiled op node returning opresult528 (depth = 4)
  gc_frame_end(frame);
  return opresult528;
}
Object meth_ast__apply_40_1_41_540(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool541 = alloc_Boolean(0);
// compiled identifier node returning bool541 (depth = 4)
  gc_frame_end(frame);
  return bool541;
}
Object meth_ast__61__61__40_1_41_512(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_AliasPair = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame513 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block514 = alloc_Block(NULL, NULL, "ast", 2518);
  gc_frame_newslot(block514);
// method "_apply(_)"
  block_savedest(block514);
  Object closure515 = createclosure(3, "_apply(1)");
  setclosureframe(closure515, stackframe);
  addtoclosure(closure515, var_o);
  addtoclosure(closure515, var_n);
  addtoclosure(closure515, selfslot);
  struct UserObject *uo515 = (struct UserObject*)block514;
  uo515->data[0] = (Object)closure515;
  Method *meth_meth_ast__apply_40_1_41_515 = addmethod2pos(block514, "_apply(1)", &meth_ast__apply_40_1_41_515, 0);
  int argcv_meth_ast__apply_40_1_41_515[] = {1};
  meth_meth_ast__apply_40_1_41_515->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_515);
  meth_meth_ast__apply_40_1_41_515->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_515->definitionLine = 2969;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe530 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe531 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit532 == NULL) {
    strlit532 = alloc_String("that");
    gc_root(strlit532);
  }
// compiled string node returning strlit532 (depth = 6)
  gc_frame_newslot(strlit532);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe533 = gc_frame_new();
// call case 5: prelude request
  Object call534 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe533);
// compiled member node returning call534 (depth = 6)
  params[0] = strlit532;
  partcv[0] = 1;
  Object call535 = callmethodflags(call534, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe531);
// compiled call node returning call535 (depth = 5)
  gc_frame_newslot(call535);
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AliasPair (depth = 5)
  gc_frame_newslot(*var_AliasPair);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe536 = gc_frame_new();
// call case 5: prelude request
  Object call537 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe536);
// compiled member node returning call537 (depth = 5)
  params[0] = call535;
  params[1] = *var_AliasPair;
  partcv[0] = 2;
  Object call538 = callmethodflags(call537, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe530);
// compiled call node returning call538 (depth = 4)
((struct UserObject *)block514)->data[1] = call538;
// compiled block node returning block514 (depth = 3)
  gc_frame_newslot(block514);
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block539 = alloc_Block(NULL, NULL, "ast", 2519);
  gc_frame_newslot(block539);
// method "_apply(_)"
  block_savedest(block539);
  Object closure540 = createclosure(1, "_apply(1)");
  setclosureframe(closure540, stackframe);
  addtoclosure(closure540, selfslot);
  struct UserObject *uo540 = (struct UserObject*)block539;
  uo540->data[0] = (Object)closure540;
  Method *meth_meth_ast__apply_40_1_41_540 = addmethod2pos(block539, "_apply(1)", &meth_ast__apply_40_1_41_540, 0);
  int argcv_meth_ast__apply_40_1_41_540[] = {1};
  meth_meth_ast__apply_40_1_41_540->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_540);
  meth_meth_ast__apply_40_1_41_540->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_540->definitionLine = 2969;
// compiled block node returning block539 (depth = 3)
  gc_frame_newslot(block539);
  params[0] = block514;
  params[1] = block539;
  Object matchres513 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame513);
// compiled matchcase node returning matchres513 (depth = 2)
  gc_frame_end(frame);
  return matchres513;
}
Object meth_ast_aliasNew_40_1_41_old_40_1_41_431(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew(1)old(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew(_)old(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew(_)old(_)");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew(_)old(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part aliasNew(_)");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part old(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject432 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj432 = alloc_userobj2(7,8, objclass432);
  gc_frame_newslot(obj432);
if (objclass432 == NULL) {
  glfree(obj432->class->name);
  obj432->class->name = "aliasNew(_)old(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj432, self, 0);
  addmethodreal(obj432,"outer", &reader_ast_outer_433);
  Object oldself432 = self;
  struct StackFrameObject *oldstackframe432 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe432);
  gc_frame_newslot((Object)stackframe);
  self = obj432;
  Object *oldselfslot432 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter432 = (*(struct UserObject *)self).data[0], lowerouter432 = thisouter432;
  if (inheritingObject432) {
    struct UserObject *inho432 = (struct UserObject *)inheritingObject432;
    while (inho432->super != GraceDefaultObject) inho432 = (struct UserObject *)inho432->super;
    inho432->super = obj432;
    self = inheritingObject432;
    *selfslot = self;
    lowerouter432 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter432;
  }
// method "newName"
  block_savedest(obj432);
  Object closure434 = createclosure(1, "newName");
  setclosureframe(closure434, stackframe);
  addtoclosure(closure434, var_n);
  struct UserObject *uo434 = (struct UserObject*)obj432;
  uo434->data[1] = (Object)closure434;
  Method *meth_meth_ast_newName434 = addmethod2pos(obj432, "newName", &meth_ast_newName434, 1);
  int argcv_meth_ast_newName434[] = {0};
  meth_meth_ast_newName434->type = alloc_MethodType(1, argcv_meth_ast_newName434);
  meth_meth_ast_newName434->definitionModule = modulename;
  meth_meth_ast_newName434->definitionLine = 2504;
// method "oldName"
  block_savedest(obj432);
  Object closure435 = createclosure(1, "oldName");
  setclosureframe(closure435, stackframe);
  addtoclosure(closure435, var_o);
  struct UserObject *uo435 = (struct UserObject*)obj432;
  uo435->data[2] = (Object)closure435;
  Method *meth_meth_ast_oldName435 = addmethod2pos(obj432, "oldName", &meth_ast_oldName435, 2);
  int argcv_meth_ast_oldName435[] = {0};
  meth_meth_ast_oldName435->type = alloc_MethodType(1, argcv_meth_ast_oldName435);
  meth_meth_ast_oldName435->definitionModule = modulename;
  meth_meth_ast_oldName435->definitionLine = 2505;
// method "asString"
  block_savedest(obj432);
  Object closure436 = createclosure(2, "asString");
  setclosureframe(closure436, stackframe);
  addtoclosure(closure436, var_o);
  addtoclosure(closure436, var_n);
  struct UserObject *uo436 = (struct UserObject*)obj432;
  uo436->data[3] = (Object)closure436;
  Method *meth_meth_ast_asString436 = addmethod2pos(obj432, "asString", &meth_ast_asString436, 3);
  int argcv_meth_ast_asString436[] = {0};
  meth_meth_ast_asString436->type = alloc_MethodType(1, argcv_meth_ast_asString436);
  meth_meth_ast_asString436->definitionModule = modulename;
  meth_meth_ast_asString436->definitionLine = 2506;
// method "pretty(_)"
  block_savedest(obj432);
  Object closure456 = createclosure(2, "pretty(1)");
  setclosureframe(closure456, stackframe);
  addtoclosure(closure456, var_o);
  addtoclosure(closure456, var_n);
  struct UserObject *uo456 = (struct UserObject*)obj432;
  uo456->data[4] = (Object)closure456;
  Method *meth_meth_ast_pretty_40_1_41_456 = addmethod2pos(obj432, "pretty(1)", &meth_ast_pretty_40_1_41_456, 4);
  int argcv_meth_ast_pretty_40_1_41_456[] = {1};
  meth_meth_ast_pretty_40_1_41_456->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_456);
  meth_meth_ast_pretty_40_1_41_456->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_456->definitionLine = 2507;
// method "hash"
  block_savedest(obj432);
  Object closure498 = createclosure(2, "hash");
  setclosureframe(closure498, stackframe);
  addtoclosure(closure498, var_o);
  addtoclosure(closure498, var_n);
  struct UserObject *uo498 = (struct UserObject*)obj432;
  uo498->data[5] = (Object)closure498;
  Method *meth_meth_ast_hash498 = addmethod2pos(obj432, "hash", &meth_ast_hash498, 5);
  int argcv_meth_ast_hash498[] = {0};
  meth_meth_ast_hash498->type = alloc_MethodType(1, argcv_meth_ast_hash498);
  meth_meth_ast_hash498->definitionModule = modulename;
  meth_meth_ast_hash498->definitionLine = 2514;
// method "isExecutable"
  struct UserObject *uo510 = (struct UserObject*)obj432;
  uo510->data[6] = emptyclosure;
  Method *meth_meth_ast_isExecutable510 = addmethod2pos(obj432, "isExecutable", &meth_ast_isExecutable510, 6);
  int argcv_meth_ast_isExecutable510[] = {0};
  meth_meth_ast_isExecutable510->type = alloc_MethodType(1, argcv_meth_ast_isExecutable510);
  meth_meth_ast_isExecutable510->definitionModule = modulename;
  meth_meth_ast_isExecutable510->definitionLine = 2515;
// method "==(_)"
  block_savedest(obj432);
  Object closure512 = createclosure(3, "==(1)");
  setclosureframe(closure512, stackframe);
  addtoclosure(closure512, var_o);
  addtoclosure(closure512, var_n);
  addtoclosure(closure512, var_AliasPair);
  struct UserObject *uo512 = (struct UserObject*)obj432;
  uo512->data[7] = (Object)closure512;
  Method *meth_meth_ast__61__61__40_1_41_512 = addmethod2pos(obj432, "==(1)", &meth_ast__61__61__40_1_41_512, 7);
  int argcv_meth_ast__61__61__40_1_41_512[] = {1};
  meth_meth_ast__61__61__40_1_41_512->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_512);
  meth_meth_ast__61__61__40_1_41_512->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_512->definitionLine = 2516;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  objclass432 = obj432->class;
  objclass432->definitionModule = modulename;
  objclass432->definitionLine = 2503;
  (*(struct UserObject *)self).data[0] = lowerouter432;
  self = oldself432;
  selfslot = oldselfslot432;
  stackframe = oldstackframe432;
  gc_frame_end(frame);
  return obj432;
}
Object meth_ast_aliasNew_40_1_41_old_40_1_41_431_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew(1)old(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method aliasNew(_)old(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method aliasNew(_)old(_)");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew(_)old(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part aliasNew(_)");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part old(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject432 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj432 = alloc_userobj2(7,8, objclass432);
  gc_frame_newslot(obj432);
if (objclass432 == NULL) {
  glfree(obj432->class->name);
  obj432->class->name = "aliasNew(_)old(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj432, self, 0);
  addmethodreal(obj432,"outer", &reader_ast_outer_433);
  Object oldself432 = self;
  struct StackFrameObject *oldstackframe432 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe432);
  gc_frame_newslot((Object)stackframe);
  self = obj432;
  Object *oldselfslot432 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter432 = (*(struct UserObject *)self).data[0], lowerouter432 = thisouter432;
  if (inheritingObject432) {
    struct UserObject *inho432 = (struct UserObject *)inheritingObject432;
    while (inho432->super != GraceDefaultObject) inho432 = (struct UserObject *)inho432->super;
    inho432->super = obj432;
    self = inheritingObject432;
    *selfslot = self;
    lowerouter432 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter432;
  }
// method "newName"
  block_savedest(obj432);
  Object closure434 = createclosure(1, "newName");
  setclosureframe(closure434, stackframe);
  addtoclosure(closure434, var_n);
  struct UserObject *uo434 = (struct UserObject*)obj432;
  uo434->data[1] = (Object)closure434;
  Method *meth_meth_ast_newName434 = addmethod2pos(obj432, "newName", &meth_ast_newName434, 1);
  int argcv_meth_ast_newName434[] = {0};
  meth_meth_ast_newName434->type = alloc_MethodType(1, argcv_meth_ast_newName434);
  meth_meth_ast_newName434->definitionModule = modulename;
  meth_meth_ast_newName434->definitionLine = 2504;
// method "oldName"
  block_savedest(obj432);
  Object closure435 = createclosure(1, "oldName");
  setclosureframe(closure435, stackframe);
  addtoclosure(closure435, var_o);
  struct UserObject *uo435 = (struct UserObject*)obj432;
  uo435->data[2] = (Object)closure435;
  Method *meth_meth_ast_oldName435 = addmethod2pos(obj432, "oldName", &meth_ast_oldName435, 2);
  int argcv_meth_ast_oldName435[] = {0};
  meth_meth_ast_oldName435->type = alloc_MethodType(1, argcv_meth_ast_oldName435);
  meth_meth_ast_oldName435->definitionModule = modulename;
  meth_meth_ast_oldName435->definitionLine = 2505;
// method "asString"
  block_savedest(obj432);
  Object closure436 = createclosure(2, "asString");
  setclosureframe(closure436, stackframe);
  addtoclosure(closure436, var_o);
  addtoclosure(closure436, var_n);
  struct UserObject *uo436 = (struct UserObject*)obj432;
  uo436->data[3] = (Object)closure436;
  Method *meth_meth_ast_asString436 = addmethod2pos(obj432, "asString", &meth_ast_asString436, 3);
  int argcv_meth_ast_asString436[] = {0};
  meth_meth_ast_asString436->type = alloc_MethodType(1, argcv_meth_ast_asString436);
  meth_meth_ast_asString436->definitionModule = modulename;
  meth_meth_ast_asString436->definitionLine = 2506;
// method "pretty(_)"
  block_savedest(obj432);
  Object closure456 = createclosure(2, "pretty(1)");
  setclosureframe(closure456, stackframe);
  addtoclosure(closure456, var_o);
  addtoclosure(closure456, var_n);
  struct UserObject *uo456 = (struct UserObject*)obj432;
  uo456->data[4] = (Object)closure456;
  Method *meth_meth_ast_pretty_40_1_41_456 = addmethod2pos(obj432, "pretty(1)", &meth_ast_pretty_40_1_41_456, 4);
  int argcv_meth_ast_pretty_40_1_41_456[] = {1};
  meth_meth_ast_pretty_40_1_41_456->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_456);
  meth_meth_ast_pretty_40_1_41_456->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_456->definitionLine = 2507;
// method "hash"
  block_savedest(obj432);
  Object closure498 = createclosure(2, "hash");
  setclosureframe(closure498, stackframe);
  addtoclosure(closure498, var_o);
  addtoclosure(closure498, var_n);
  struct UserObject *uo498 = (struct UserObject*)obj432;
  uo498->data[5] = (Object)closure498;
  Method *meth_meth_ast_hash498 = addmethod2pos(obj432, "hash", &meth_ast_hash498, 5);
  int argcv_meth_ast_hash498[] = {0};
  meth_meth_ast_hash498->type = alloc_MethodType(1, argcv_meth_ast_hash498);
  meth_meth_ast_hash498->definitionModule = modulename;
  meth_meth_ast_hash498->definitionLine = 2514;
// method "isExecutable"
  struct UserObject *uo510 = (struct UserObject*)obj432;
  uo510->data[6] = emptyclosure;
  Method *meth_meth_ast_isExecutable510 = addmethod2pos(obj432, "isExecutable", &meth_ast_isExecutable510, 6);
  int argcv_meth_ast_isExecutable510[] = {0};
  meth_meth_ast_isExecutable510->type = alloc_MethodType(1, argcv_meth_ast_isExecutable510);
  meth_meth_ast_isExecutable510->definitionModule = modulename;
  meth_meth_ast_isExecutable510->definitionLine = 2515;
// method "==(_)"
  block_savedest(obj432);
  Object closure512 = createclosure(3, "==(1)");
  setclosureframe(closure512, stackframe);
  addtoclosure(closure512, var_o);
  addtoclosure(closure512, var_n);
  addtoclosure(closure512, var_AliasPair);
  struct UserObject *uo512 = (struct UserObject*)obj432;
  uo512->data[7] = (Object)closure512;
  Method *meth_meth_ast__61__61__40_1_41_512 = addmethod2pos(obj432, "==(1)", &meth_ast__61__61__40_1_41_512, 7);
  int argcv_meth_ast__61__61__40_1_41_512[] = {1};
  meth_meth_ast__61__61__40_1_41_512->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_512);
  meth_meth_ast__61__61__40_1_41_512->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_512->definitionLine = 2516;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  sourceObject = obj432;
  objclass432 = obj432->class;
  objclass432->definitionModule = modulename;
  objclass432->definitionLine = 2503;
  (*(struct UserObject *)self).data[0] = lowerouter432;
  self = oldself432;
  selfslot = oldselfslot432;
  stackframe = oldstackframe432;
  gc_frame_end(frame);
  return obj432;
}
Object meth_ast__apply578(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ind (depth = 8)
  int op_slot_right_579 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_len (depth = 8)
  int op_slot_left_579 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff581 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff581 (depth = 7)
  gc_frame_end(frame);
  return diff581;
}
Object meth_ast__apply571(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe572 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit573 == NULL) {
    strlit573 = alloc_String(" ");
    gc_root(strlit573);
  }
// compiled string node returning strlit573 (depth = 6)
  gc_frame_newslot(strlit573);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_574 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_574 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff576 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff576 (depth = 6)
  gc_frame_newslot(diff576);
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block577 = alloc_Block(NULL, NULL, "ast", 2788);
  gc_frame_newslot(block577);
// method "_apply"
  block_savedest(block577);
  Object closure578 = createclosure(3, "_apply");
  setclosureframe(closure578, stackframe);
  addtoclosure(closure578, var_ind);
  addtoclosure(closure578, var_len);
  addtoclosure(closure578, selfslot);
  struct UserObject *uo578 = (struct UserObject*)block577;
  uo578->data[0] = (Object)closure578;
  Method *meth_meth_ast__apply578 = addmethod2pos(block577, "_apply", &meth_ast__apply578, 0);
  int argcv_meth_ast__apply578[] = {0};
  meth_meth_ast__apply578->type = alloc_MethodType(1, argcv_meth_ast__apply578);
  meth_meth_ast__apply578->definitionModule = modulename;
  meth_meth_ast__apply578->definitionLine = 2969;
// compiled block node returning block577 (depth = 6)
  gc_frame_newslot(block577);
// call case 6: other requests
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = strlit573;
  params[1] = diff576;
  params[2] = block577;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call583 = callmethodflags(*var_str, "lastIndexOf(1)startingAt(1)ifAbsent(1)", 3, partcv, params, 0);
  gc_frame_end(callframe572);
// compiled call node returning call583 (depth = 5)
  *var_currBreak = call583;
  if (call583 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe585 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe586 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num587 = alloc_Float64(1);
// compiled num node returning num587 (depth = 7)
  gc_frame_newslot(num587);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_currBreak (depth = 7)
  gc_frame_newslot(*var_currBreak);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  params[0] = num587;
  params[1] = *var_currBreak;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call588 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe586);
// compiled call node returning call588 (depth = 6)
  Object call589 = callmethodflags(call588, "trim", 0, partcv, params, 0);
  gc_frame_end(callframe585);
// compiled member node returning call589 (depth = 5)
  *var_trimmedLine = call589;
  if (call589 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_604(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_str = getfromclosure(closure, 0);
  Object *var_currBreak = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit607 == NULL) {
    strlit607 = alloc_String(" ");
    gc_root(strlit607);
  }
// compiled string node returning strlit607 (depth = 8)
  int op_slot_right_606 = gc_frame_newslot(strlit607);
// starting to compile call node (depth = 8)
  int callframe609 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call610 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe609);
// compiled call node returning call610 (depth = 8)
  int op_slot_left_606 = gc_frame_newslot(call610);
  params[0] = strlit607;
  partcv[0] = 1;
  Object opresult611 = callmethod(call610, "==(1)", 1, partcv, params);
// compiled op node returning opresult611 (depth = 7)
  Object if605 = done;
  if (istrue(opresult611)) {
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  *var_currBreak = *var_ix;
  if (*var_ix == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if605 = done;
  } else {
  }
// compiled if node returning if605 (depth = 6)
  gc_frame_end(frame);
  return if605;
}
Object meth_ast__apply624(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit626 == NULL) {
    strlit626 = alloc_String(" ");
    gc_root(strlit626);
  }
// compiled string node returning strlit626 (depth = 9)
  int op_slot_right_625 = gc_frame_newslot(strlit626);
// starting to compile call node (depth = 9)
  int callframe628 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_end (depth = 10)
  gc_frame_newslot(*var_end);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_end;
  partcv[0] = 1;
  Object call629 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe628);
// compiled call node returning call629 (depth = 9)
  int op_slot_left_625 = gc_frame_newslot(call629);
  params[0] = strlit626;
  partcv[0] = 1;
  Object opresult630 = callmethod(call629, "==(1)", 1, partcv, params);
// compiled op node returning opresult630 (depth = 8)
  gc_frame_end(frame);
  return opresult630;
}
Object meth_ast__apply621(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block623 = alloc_Block(NULL, NULL, "ast", 2796);
  gc_frame_newslot(block623);
// method "_apply"
  block_savedest(block623);
  Object closure624 = createclosure(3, "_apply");
  setclosureframe(closure624, stackframe);
  addtoclosure(closure624, var_end);
  addtoclosure(closure624, var_str);
  addtoclosure(closure624, selfslot);
  struct UserObject *uo624 = (struct UserObject*)block623;
  uo624->data[0] = (Object)closure624;
  Method *meth_meth_ast__apply624 = addmethod2pos(block623, "_apply", &meth_ast__apply624, 0);
  int argcv_meth_ast__apply624[] = {0};
  meth_meth_ast__apply624->type = alloc_MethodType(1, argcv_meth_ast__apply624);
  meth_meth_ast__apply624->definitionModule = modulename;
  meth_meth_ast__apply624->definitionLine = 2969;
// compiled block node returning block623 (depth = 7)
  int op_slot_right_622 = gc_frame_newslot(block623);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num634 = alloc_Float64(1);
// compiled num node returning num634 (depth = 8)
  int op_slot_right_633 = gc_frame_newslot(num634);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_633 = gc_frame_newslot(*var_end);
  params[0] = num634;
  partcv[0] = 1;
  Object opresult636 = callmethod(*var_end, "≥(1)", 1, partcv, params);
// compiled op node returning opresult636 (depth = 7)
  int op_slot_left_622 = gc_frame_newslot(opresult636);
  params[0] = block623;
  partcv[0] = 1;
  Object opresult637 = callmethod(opresult636, "&&(1)", 1, partcv, params);
// compiled op node returning opresult637 (depth = 6)
  gc_frame_end(frame);
  return opresult637;
}
Object meth_ast__apply640(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num642 = alloc_Float64(1);
// compiled num node returning num642 (depth = 8)
  int op_slot_right_641 = gc_frame_newslot(num642);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_641 = gc_frame_newslot(*var_end);
  params[0] = num642;
  partcv[0] = 1;
  Object diff644 = callmethod(*var_end, "-(1)", 1, partcv, params);
// compiled op node returning diff644 (depth = 7)
  *var_end = diff644;
  if (diff644 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply654(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit656 == NULL) {
    strlit656 = alloc_String(" ");
    gc_root(strlit656);
  }
// compiled string node returning strlit656 (depth = 9)
  int op_slot_right_655 = gc_frame_newslot(strlit656);
// starting to compile call node (depth = 9)
  int callframe658 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_start (depth = 10)
  gc_frame_newslot(*var_start);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_start;
  partcv[0] = 1;
  Object call659 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe658);
// compiled call node returning call659 (depth = 9)
  int op_slot_left_655 = gc_frame_newslot(call659);
  params[0] = strlit656;
  partcv[0] = 1;
  Object opresult660 = callmethod(call659, "==(1)", 1, partcv, params);
// compiled op node returning opresult660 (depth = 8)
  gc_frame_end(frame);
  return opresult660;
}
Object meth_ast__apply651(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block653 = alloc_Block(NULL, NULL, "ast", 2800);
  gc_frame_newslot(block653);
// method "_apply"
  block_savedest(block653);
  Object closure654 = createclosure(3, "_apply");
  setclosureframe(closure654, stackframe);
  addtoclosure(closure654, var_start);
  addtoclosure(closure654, var_str);
  addtoclosure(closure654, selfslot);
  struct UserObject *uo654 = (struct UserObject*)block653;
  uo654->data[0] = (Object)closure654;
  Method *meth_meth_ast__apply654 = addmethod2pos(block653, "_apply", &meth_ast__apply654, 0);
  int argcv_meth_ast__apply654[] = {0};
  meth_meth_ast__apply654->type = alloc_MethodType(1, argcv_meth_ast__apply654);
  meth_meth_ast__apply654->definitionModule = modulename;
  meth_meth_ast__apply654->definitionLine = 2969;
// compiled block node returning block653 (depth = 7)
  int op_slot_right_652 = gc_frame_newslot(block653);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe664 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  Object call665 = callmethodflags(*var_str, "size", 0, partcv, params, 0);
  gc_frame_end(callframe664);
// compiled member node returning call665 (depth = 8)
  int op_slot_right_663 = gc_frame_newslot(call665);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_663 = gc_frame_newslot(*var_start);
  params[0] = call665;
  partcv[0] = 1;
  Object opresult667 = callmethod(*var_start, "≤(1)", 1, partcv, params);
// compiled op node returning opresult667 (depth = 7)
  int op_slot_left_652 = gc_frame_newslot(opresult667);
  params[0] = block653;
  partcv[0] = 1;
  Object opresult668 = callmethod(opresult667, "&&(1)", 1, partcv, params);
// compiled op node returning opresult668 (depth = 6)
  gc_frame_end(frame);
  return opresult668;
}
Object meth_ast__apply671(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num673 = alloc_Float64(1);
// compiled num node returning num673 (depth = 8)
  int op_slot_right_672 = gc_frame_newslot(num673);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_672 = gc_frame_newslot(*var_start);
  params[0] = num673;
  partcv[0] = 1;
  Object sum675 = callmethod(*var_start, "+(1)", 1, partcv, params);
// compiled op node returning sum675 (depth = 7)
  *var_start = sum675;
  if (sum675 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_593(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_end = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "end");
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe594 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_595 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_595 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff597 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff597 (depth = 6)
  gc_frame_newslot(diff597);
// starting to compile member node (depth = 6)
  int callframe598 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  Object call599 = callmethodflags(*var_str, "size", 0, partcv, params, 0);
  gc_frame_end(callframe598);
// compiled member node returning call599 (depth = 6)
  gc_frame_newslot(call599);
// call case 5: prelude request
  params[0] = diff597;
  params[1] = call599;
  partcv[0] = 2;
  Object call600 = callmethodflags(prelude, "min(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe594);
// compiled call node returning call600 (depth = 5)
  *var_currBreak = call600;
  if (call600 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe602 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block603 = alloc_Block(NULL, NULL, "ast", 2792);
  gc_frame_newslot(block603);
// method "_apply(_)"
  block_savedest(block603);
  Object closure604 = createclosure(3, "_apply(1)");
  setclosureframe(closure604, stackframe);
  addtoclosure(closure604, var_str);
  addtoclosure(closure604, var_currBreak);
  addtoclosure(closure604, selfslot);
  struct UserObject *uo604 = (struct UserObject*)block603;
  uo604->data[0] = (Object)closure604;
  Method *meth_meth_ast__apply_40_1_41_604 = addmethod2pos(block603, "_apply(1)", &meth_ast__apply_40_1_41_604, 0);
  int argcv_meth_ast__apply_40_1_41_604[] = {1};
  meth_meth_ast__apply_40_1_41_604->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_604);
  meth_meth_ast__apply_40_1_41_604->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_604->definitionLine = 2969;
// compiled block node returning block603 (depth = 5)
  gc_frame_newslot(block603);
// call case 6: other requests
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_right_614 = gc_frame_newslot(*var_currBreak);
// starting to compile num node (depth = 6)
  Object num616 = alloc_Float64(1);
// compiled num node returning num616 (depth = 6)
  int op_slot_left_614 = gc_frame_newslot(num616);
  params[0] = *var_currBreak;
  partcv[0] = 1;
  Object opresult617 = callmethod(num616, "..(1)", 1, partcv, params);
// compiled op node returning opresult617 (depth = 5)
  params[0] = block603;
  partcv[0] = 1;
  Object call618 = callmethodflags(opresult617, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe602);
// compiled call node returning call618 (depth = 4)
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_currBreak (depth = 5)
  *var_end = *var_currBreak;
  if (*var_currBreak == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe619 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block620 = alloc_Block(NULL, NULL, "ast", 2796);
  gc_frame_newslot(block620);
// method "_apply"
  block_savedest(block620);
  Object closure621 = createclosure(3, "_apply");
  setclosureframe(closure621, stackframe);
  addtoclosure(closure621, var_end);
  addtoclosure(closure621, var_str);
  addtoclosure(closure621, selfslot);
  struct UserObject *uo621 = (struct UserObject*)block620;
  uo621->data[0] = (Object)closure621;
  Method *meth_meth_ast__apply621 = addmethod2pos(block620, "_apply", &meth_ast__apply621, 0);
  int argcv_meth_ast__apply621[] = {0};
  meth_meth_ast__apply621->type = alloc_MethodType(1, argcv_meth_ast__apply621);
  meth_meth_ast__apply621->definitionModule = modulename;
  meth_meth_ast__apply621->definitionLine = 2969;
// compiled block node returning block620 (depth = 5)
  gc_frame_newslot(block620);
// starting to compile block node (depth = 5)
  Object block639 = alloc_Block(NULL, NULL, "ast", 2796);
  gc_frame_newslot(block639);
// method "_apply"
  block_savedest(block639);
  Object closure640 = createclosure(2, "_apply");
  setclosureframe(closure640, stackframe);
  addtoclosure(closure640, var_end);
  addtoclosure(closure640, selfslot);
  struct UserObject *uo640 = (struct UserObject*)block639;
  uo640->data[0] = (Object)closure640;
  Method *meth_meth_ast__apply640 = addmethod2pos(block639, "_apply", &meth_ast__apply640, 0);
  int argcv_meth_ast__apply640[] = {0};
  meth_meth_ast__apply640->type = alloc_MethodType(1, argcv_meth_ast__apply640);
  meth_meth_ast__apply640->definitionModule = modulename;
  meth_meth_ast__apply640->definitionLine = 2969;
// compiled block node returning block639 (depth = 5)
  gc_frame_newslot(block639);
// call case 5: prelude request
  params[0] = block620;
  params[1] = block639;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call647 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe619);
// compiled call node returning call647 (depth = 4)
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num648 = alloc_Float64(1);
// compiled num node returning num648 (depth = 5)
  *var_start = num648;
  if (num648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe649 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block650 = alloc_Block(NULL, NULL, "ast", 2800);
  gc_frame_newslot(block650);
// method "_apply"
  block_savedest(block650);
  Object closure651 = createclosure(3, "_apply");
  setclosureframe(closure651, stackframe);
  addtoclosure(closure651, var_start);
  addtoclosure(closure651, var_str);
  addtoclosure(closure651, selfslot);
  struct UserObject *uo651 = (struct UserObject*)block650;
  uo651->data[0] = (Object)closure651;
  Method *meth_meth_ast__apply651 = addmethod2pos(block650, "_apply", &meth_ast__apply651, 0);
  int argcv_meth_ast__apply651[] = {0};
  meth_meth_ast__apply651->type = alloc_MethodType(1, argcv_meth_ast__apply651);
  meth_meth_ast__apply651->definitionModule = modulename;
  meth_meth_ast__apply651->definitionLine = 2969;
// compiled block node returning block650 (depth = 5)
  gc_frame_newslot(block650);
// starting to compile block node (depth = 5)
  Object block670 = alloc_Block(NULL, NULL, "ast", 2800);
  gc_frame_newslot(block670);
// method "_apply"
  block_savedest(block670);
  Object closure671 = createclosure(2, "_apply");
  setclosureframe(closure671, stackframe);
  addtoclosure(closure671, var_start);
  addtoclosure(closure671, selfslot);
  struct UserObject *uo671 = (struct UserObject*)block670;
  uo671->data[0] = (Object)closure671;
  Method *meth_meth_ast__apply671 = addmethod2pos(block670, "_apply", &meth_ast__apply671, 0);
  int argcv_meth_ast__apply671[] = {0};
  meth_meth_ast__apply671->type = alloc_MethodType(1, argcv_meth_ast__apply671);
  meth_meth_ast__apply671->definitionModule = modulename;
  meth_meth_ast__apply671->definitionLine = 2969;
// compiled block node returning block670 (depth = 5)
  gc_frame_newslot(block670);
// call case 5: prelude request
  params[0] = block650;
  params[1] = block670;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call678 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe649);
// compiled call node returning call678 (depth = 4)
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe679 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = *var_start;
  params[1] = *var_end;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call680 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe679);
// compiled call node returning call680 (depth = 5)
  *var_trimmedLine = call680;
  if (call680 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "wrap(1)to(1)prefix(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for wrap(_)to(_)prefix(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part wrap(_)");
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *var_margin = &(stackframe->slots[2]);
  *var_margin = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part prefix(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ind = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ind");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
  Object *var_currBreak = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "currBreak");
  Object *var_trimmedLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "trimmedLine");
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe545 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  Object call546 = callmethodflags(*var_margin, "size", 0, partcv, params, 0);
  gc_frame_end(callframe545);
// compiled member node returning call546 (depth = 3)
  *var_ind = call546;
  if (call546 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe547 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num549 = alloc_Float64(4);
// compiled num node returning num549 (depth = 5)
  int op_slot_right_548 = gc_frame_newslot(num549);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_548 = gc_frame_newslot(*var_ind);
  params[0] = num549;
  partcv[0] = 1;
  Object sum551 = callmethod(*var_ind, "+(1)", 1, partcv, params);
// compiled op node returning sum551 (depth = 4)
  gc_frame_newslot(sum551);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// call case 5: prelude request
  params[0] = sum551;
  params[1] = *var_l;
  partcv[0] = 2;
  Object call552 = callmethodflags(prelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe547);
// compiled call node returning call552 (depth = 3)
  *var_len = call552;
  if (call552 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_len (depth = 4)
  int op_slot_right_554 = gc_frame_newslot(*var_len);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe557 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  Object call558 = callmethodflags(*var_str, "size", 0, partcv, params, 0);
  gc_frame_end(callframe557);
// compiled member node returning call558 (depth = 5)
  int op_slot_right_556 = gc_frame_newslot(call558);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_556 = gc_frame_newslot(*var_ind);
  params[0] = call558;
  partcv[0] = 1;
  Object sum560 = callmethod(*var_ind, "+(1)", 1, partcv, params);
// compiled op node returning sum560 (depth = 4)
  int op_slot_left_554 = gc_frame_newslot(sum560);
  params[0] = *var_len;
  partcv[0] = 1;
  Object opresult561 = callmethod(sum560, "≤(1)", 1, partcv, params);
// compiled op node returning opresult561 (depth = 3)
  Object if553 = done;
  if (istrue(opresult561)) {
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  int op_slot_right_562 = gc_frame_newslot(*var_str);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_margin (depth = 6)
  int op_slot_right_564 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 6)
  if (strlit566 == NULL) {
    strlit566 = alloc_String("""\x0a""");
    gc_root(strlit566);
  }
// compiled string node returning strlit566 (depth = 6)
  int op_slot_left_564 = gc_frame_newslot(strlit566);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult567 = callmethod(strlit566, "++(1)", 1, partcv, params);
// compiled op node returning opresult567 (depth = 5)
  int op_slot_left_562 = gc_frame_newslot(opresult567);
  params[0] = *var_str;
  partcv[0] = 1;
  Object opresult568 = callmethod(opresult567, "++(1)", 1, partcv, params);
// compiled op node returning opresult568 (depth = 4)
  return opresult568;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if553 = undefined;
  } else {
  }
// compiled if node returning if553 (depth = 2)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_currBreak = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_trimmedLine = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block570 = alloc_Block(NULL, NULL, "ast", 2786);
  gc_frame_newslot(block570);
// method "_apply"
  block_savedest(block570);
  Object closure571 = createclosure(6, "_apply");
  setclosureframe(closure571, stackframe);
  addtoclosure(closure571, var_ind);
  addtoclosure(closure571, var_len);
  addtoclosure(closure571, var_str);
  addtoclosure(closure571, var_currBreak);
  addtoclosure(closure571, var_trimmedLine);
  addtoclosure(closure571, selfslot);
  struct UserObject *uo571 = (struct UserObject*)block570;
  uo571->data[0] = (Object)closure571;
  Method *meth_meth_ast__apply571 = addmethod2pos(block570, "_apply", &meth_ast__apply571, 0);
  int argcv_meth_ast__apply571[] = {0};
  meth_meth_ast__apply571->type = alloc_MethodType(1, argcv_meth_ast__apply571);
  meth_meth_ast__apply571->definitionModule = modulename;
  meth_meth_ast__apply571->definitionLine = 2969;
// compiled block node returning block570 (depth = 3)
  int frame569 = gc_frame_new();
  gc_frame_newslot(block570);
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block592 = alloc_Block(NULL, NULL, "ast", 2790);
  gc_frame_newslot(block592);
// method "_apply(_)"
  block_savedest(block592);
  Object closure593 = createclosure(6, "_apply(1)");
  setclosureframe(closure593, stackframe);
  addtoclosure(closure593, var_ind);
  addtoclosure(closure593, var_len);
  addtoclosure(closure593, var_str);
  addtoclosure(closure593, var_currBreak);
  addtoclosure(closure593, var_trimmedLine);
  addtoclosure(closure593, selfslot);
  struct UserObject *uo593 = (struct UserObject*)block592;
  uo593->data[0] = (Object)closure593;
  Method *meth_meth_ast__apply_40_1_41_593 = addmethod2pos(block592, "_apply(1)", &meth_ast__apply_40_1_41_593, 0);
  int argcv_meth_ast__apply_40_1_41_593[] = {1};
  meth_meth_ast__apply_40_1_41_593->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_593);
  meth_meth_ast__apply_40_1_41_593->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_593->definitionLine = 2969;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe683 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe684 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit685 == NULL) {
    strlit685 = alloc_String("ex");
    gc_root(strlit685);
  }
// compiled string node returning strlit685 (depth = 6)
  gc_frame_newslot(strlit685);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe686 = gc_frame_new();
// call case 5: prelude request
  Object call687 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe686);
// compiled member node returning call687 (depth = 6)
  params[0] = strlit685;
  partcv[0] = 1;
  Object call688 = callmethodflags(call687, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe684);
// compiled call node returning call688 (depth = 5)
  gc_frame_newslot(call688);
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe689 = gc_frame_new();
// call case 5: prelude request
  Object call690 = callmethodflags(prelude, "NoSuchMethod", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe689);
// compiled member node returning call690 (depth = 5)
  gc_frame_newslot(call690);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe691 = gc_frame_new();
// call case 5: prelude request
  Object call692 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe691);
// compiled member node returning call692 (depth = 5)
  params[0] = call688;
  params[1] = call690;
  partcv[0] = 2;
  Object call693 = callmethodflags(call692, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe683);
// compiled call node returning call693 (depth = 4)
((struct UserObject *)block592)->data[1] = call693;
// compiled block node returning block592 (depth = 3)
  gc_frame_newslot(block592);
  params[0] = block592;
  setline(2786);
  Object catchres569 = tryCatch(block570, params, 1,NULL);
  gc_frame_end(frame569);
// compiled trycatch node returning catchres569 (depth = 2)
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe695 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe696 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num698 = alloc_Float64(1);
// compiled num node returning num698 (depth = 6)
  int op_slot_right_697 = gc_frame_newslot(num698);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_left_697 = gc_frame_newslot(*var_currBreak);
  params[0] = num698;
  partcv[0] = 1;
  Object sum700 = callmethod(*var_currBreak, "+(1)", 1, partcv, params);
// compiled op node returning sum700 (depth = 5)
  gc_frame_newslot(sum700);
// starting to compile member node (depth = 5)
  int callframe701 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  Object call702 = callmethodflags(*var_str, "size", 0, partcv, params, 0);
  gc_frame_end(callframe701);
// compiled member node returning call702 (depth = 5)
  gc_frame_newslot(call702);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  params[0] = sum700;
  params[1] = call702;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call703 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe696);
// compiled call node returning call703 (depth = 4)
  gc_frame_newslot(call703);
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  gc_frame_newslot(*var_margin);
// call case 4: self request
  params[0] = call703;
  params[1] = *var_l;
  params[2] = *var_margin;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call704 = callmethodflags(self, "wrap(1)to(1)prefix(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe695);
// compiled call node returning call704 (depth = 3)
  int op_slot_right_694 = gc_frame_newslot(call704);
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_trimmedLine (depth = 4)
  int op_slot_right_706 = gc_frame_newslot(*var_trimmedLine);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  int op_slot_right_708 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 5)
  if (strlit710 == NULL) {
    strlit710 = alloc_String("""\x0a""");
    gc_root(strlit710);
  }
// compiled string node returning strlit710 (depth = 5)
  int op_slot_left_708 = gc_frame_newslot(strlit710);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult711 = callmethod(strlit710, "++(1)", 1, partcv, params);
// compiled op node returning opresult711 (depth = 4)
  int op_slot_left_706 = gc_frame_newslot(opresult711);
  params[0] = *var_trimmedLine;
  partcv[0] = 1;
  Object opresult712 = callmethod(opresult711, "++(1)", 1, partcv, params);
// compiled op node returning opresult712 (depth = 3)
  int op_slot_left_694 = gc_frame_newslot(opresult712);
  params[0] = call704;
  partcv[0] = 1;
  Object opresult713 = callmethod(opresult712, "++(1)", 1, partcv, params);
// compiled op node returning opresult713 (depth = 2)
  gc_frame_end(frame);
  return opresult713;
}
Object meth_ast_visitIf_40_1_41_up_40_1_41_717(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe718 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call719 = callmethodflags(self, "visitIf(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe718);
// compiled call node returning call719 (depth = 2)
  gc_frame_end(frame);
  return call719;
}
Object meth_ast_visitBlock_40_1_41_up_40_1_41_720(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe721 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call722 = callmethodflags(self, "visitBlock(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe721);
// compiled call node returning call722 (depth = 2)
  gc_frame_end(frame);
  return call722;
}
Object meth_ast_visitMatchCase_40_1_41_up_40_1_41_723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2847
  setline(2847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe724 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call725 = callmethodflags(self, "visitMatchCase(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe724);
// compiled call node returning call725 (depth = 2)
  gc_frame_end(frame);
  return call725;
}
Object meth_ast_visitTryCatch_40_1_41_up_40_1_41_726(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe727 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call728 = callmethodflags(self, "visitTryCatch(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe727);
// compiled call node returning call728 (depth = 2)
  gc_frame_end(frame);
  return call728;
}
Object meth_ast_visitMethodType_40_1_41_up_40_1_41_729(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe730 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call731 = callmethodflags(self, "visitMethodType(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe730);
// compiled call node returning call731 (depth = 2)
  gc_frame_end(frame);
  return call731;
}
Object meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe733 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call734 = callmethodflags(self, "visitSignaturePart(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe733);
// compiled call node returning call734 (depth = 2)
  gc_frame_end(frame);
  return call734;
}
Object meth_ast_visitTypeDec_40_1_41_up_40_1_41_735(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe736 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call737 = callmethodflags(self, "visitTypeDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe736);
// compiled call node returning call737 (depth = 2)
  gc_frame_end(frame);
  return call737;
}
Object meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe739 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call740 = callmethodflags(self, "visitTypeLiteral(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe739);
// compiled call node returning call740 (depth = 2)
  gc_frame_end(frame);
  return call740;
}
Object meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeParameters(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe742 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call743 = callmethodflags(self, "visitTypeParameters(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe742);
// compiled call node returning call743 (depth = 2)
  gc_frame_end(frame);
  return call743;
}
Object meth_ast_visitMethod_40_1_41_up_40_1_41_744(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe745 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call746 = callmethodflags(self, "visitMethod(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe745);
// compiled call node returning call746 (depth = 2)
  gc_frame_end(frame);
  return call746;
}
Object meth_ast_visitCall_40_1_41_up_40_1_41_747(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe748 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call749 = callmethodflags(self, "visitCall(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe748);
// compiled call node returning call749 (depth = 2)
  gc_frame_end(frame);
  return call749;
}
Object meth_ast_visitObject_40_1_41_up_40_1_41_750(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe751 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call752 = callmethodflags(self, "visitObject(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe751);
// compiled call node returning call752 (depth = 2)
  gc_frame_end(frame);
  return call752;
}
Object meth_ast_visitModule_40_1_41_up_40_1_41_753(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe754 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call755 = callmethodflags(self, "visitObject(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe754);
// compiled call node returning call755 (depth = 2)
  gc_frame_end(frame);
  return call755;
}
Object meth_ast_visitArray_40_1_41_up_40_1_41_756(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe757 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call758 = callmethodflags(self, "visitArray(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe757);
// compiled call node returning call758 (depth = 2)
  gc_frame_end(frame);
  return call758;
}
Object meth_ast_visitMember_40_1_41_up_40_1_41_759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe760 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call761 = callmethodflags(self, "visitMember(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe760);
// compiled call node returning call761 (depth = 2)
  gc_frame_end(frame);
  return call761;
}
Object meth_ast_visitGeneric_40_1_41_up_40_1_41_762(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe763 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call764 = callmethodflags(self, "visitGeneric(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe763);
// compiled call node returning call764 (depth = 2)
  gc_frame_end(frame);
  return call764;
}
Object meth_ast_visitIdentifier_40_1_41_up_40_1_41_765(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe766 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call767 = callmethodflags(self, "visitIdentifier(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe766);
// compiled call node returning call767 (depth = 2)
  gc_frame_end(frame);
  return call767;
}
Object meth_ast_visitString_40_1_41_up_40_1_41_768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe769 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call770 = callmethodflags(self, "visitString(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe769);
// compiled call node returning call770 (depth = 2)
  gc_frame_end(frame);
  return call770;
}
Object meth_ast_visitNum_40_1_41_up_40_1_41_771(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe772 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call773 = callmethodflags(self, "visitNum(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe772);
// compiled call node returning call773 (depth = 2)
  gc_frame_end(frame);
  return call773;
}
Object meth_ast_visitOp_40_1_41_up_40_1_41_774(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe775 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call776 = callmethodflags(self, "visitOp(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe775);
// compiled call node returning call776 (depth = 2)
  gc_frame_end(frame);
  return call776;
}
Object meth_ast_visitBind_40_1_41_up_40_1_41_777(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe778 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call779 = callmethodflags(self, "visitBind(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe778);
// compiled call node returning call779 (depth = 2)
  gc_frame_end(frame);
  return call779;
}
Object meth_ast_visitDefDec_40_1_41_up_40_1_41_780(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe781 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call782 = callmethodflags(self, "visitDefDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe781);
// compiled call node returning call782 (depth = 2)
  gc_frame_end(frame);
  return call782;
}
Object meth_ast_visitVarDec_40_1_41_up_40_1_41_783(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe784 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call785 = callmethodflags(self, "visitVarDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe784);
// compiled call node returning call785 (depth = 2)
  gc_frame_end(frame);
  return call785;
}
Object meth_ast_visitImport_40_1_41_up_40_1_41_786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe787 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call788 = callmethodflags(self, "visitImport(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe787);
// compiled call node returning call788 (depth = 2)
  gc_frame_end(frame);
  return call788;
}
Object meth_ast_visitReturn_40_1_41_up_40_1_41_789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe790 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call791 = callmethodflags(self, "visitReturn(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe790);
// compiled call node returning call791 (depth = 2)
  gc_frame_end(frame);
  return call791;
}
Object meth_ast_visitInherits_40_1_41_up_40_1_41_792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe793 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call794 = callmethodflags(self, "visitInherits(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe793);
// compiled call node returning call794 (depth = 2)
  gc_frame_end(frame);
  return call794;
}
Object meth_ast_visitDialect_40_1_41_up_40_1_41_795(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe796 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call797 = callmethodflags(self, "visitDialect(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe796);
// compiled call node returning call797 (depth = 2)
  gc_frame_end(frame);
  return call797;
}
Object meth_ast_visitBlank_40_1_41_up_40_1_41_798(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlank(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe799 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call800 = callmethodflags(self, "visitBlank(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe799);
// compiled call node returning call800 (depth = 2)
  gc_frame_end(frame);
  return call800;
}
Object meth_ast_visitComment_40_1_41_up_40_1_41_801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe802 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call803 = callmethodflags(self, "visitComment(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe802);
// compiled call node returning call803 (depth = 2)
  gc_frame_end(frame);
  return call803;
}
Object meth_ast_visitImplicit_40_1_41_up_40_1_41_804(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImplicit(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe805 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call806 = callmethodflags(self, "visitImplicit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe805);
// compiled call node returning call806 (depth = 2)
  gc_frame_end(frame);
  return call806;
}
Object meth_ast_visitIf_40_1_41_807(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool808 = alloc_Boolean(1);
// compiled identifier node returning bool808 (depth = 2)
  gc_frame_end(frame);
  return bool808;
}
Object meth_ast_visitBlock_40_1_41_809(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool810 = alloc_Boolean(1);
// compiled identifier node returning bool810 (depth = 2)
  gc_frame_end(frame);
  return bool810;
}
Object meth_ast_visitMatchCase_40_1_41_811(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool812 = alloc_Boolean(1);
// compiled identifier node returning bool812 (depth = 2)
  gc_frame_end(frame);
  return bool812;
}
Object meth_ast_visitTryCatch_40_1_41_813(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool814 = alloc_Boolean(1);
// compiled identifier node returning bool814 (depth = 2)
  gc_frame_end(frame);
  return bool814;
}
Object meth_ast_visitMethodType_40_1_41_815(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool816 = alloc_Boolean(1);
// compiled identifier node returning bool816 (depth = 2)
  gc_frame_end(frame);
  return bool816;
}
Object meth_ast_visitSignaturePart_40_1_41_817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool818 = alloc_Boolean(1);
// compiled identifier node returning bool818 (depth = 2)
  gc_frame_end(frame);
  return bool818;
}
Object meth_ast_visitTypeDec_40_1_41_819(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool820 = alloc_Boolean(1);
// compiled identifier node returning bool820 (depth = 2)
  gc_frame_end(frame);
  return bool820;
}
Object meth_ast_visitTypeLiteral_40_1_41_821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2883
  setline(2883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool822 = alloc_Boolean(1);
// compiled identifier node returning bool822 (depth = 2)
  gc_frame_end(frame);
  return bool822;
}
Object meth_ast_visitTypeParameters_40_1_41_823(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeParameters(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2884
  setline(2884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool824 = alloc_Boolean(1);
// compiled identifier node returning bool824 (depth = 2)
  gc_frame_end(frame);
  return bool824;
}
Object meth_ast_visitMethod_40_1_41_825(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool826 = alloc_Boolean(1);
// compiled identifier node returning bool826 (depth = 2)
  gc_frame_end(frame);
  return bool826;
}
Object meth_ast_visitCall_40_1_41_827(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool828 = alloc_Boolean(1);
// compiled identifier node returning bool828 (depth = 2)
  gc_frame_end(frame);
  return bool828;
}
Object meth_ast_visitObject_40_1_41_829(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool830 = alloc_Boolean(1);
// compiled identifier node returning bool830 (depth = 2)
  gc_frame_end(frame);
  return bool830;
}
Object meth_ast_visitModule_40_1_41_831(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool832 = alloc_Boolean(1);
// compiled identifier node returning bool832 (depth = 2)
  gc_frame_end(frame);
  return bool832;
}
Object meth_ast_visitArray_40_1_41_833(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool834 = alloc_Boolean(1);
// compiled identifier node returning bool834 (depth = 2)
  gc_frame_end(frame);
  return bool834;
}
Object meth_ast_visitMember_40_1_41_835(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2890
  setline(2890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool836 = alloc_Boolean(1);
// compiled identifier node returning bool836 (depth = 2)
  gc_frame_end(frame);
  return bool836;
}
Object meth_ast_visitGeneric_40_1_41_837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool838 = alloc_Boolean(1);
// compiled identifier node returning bool838 (depth = 2)
  gc_frame_end(frame);
  return bool838;
}
Object meth_ast_visitIdentifier_40_1_41_839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool840 = alloc_Boolean(1);
// compiled identifier node returning bool840 (depth = 2)
  gc_frame_end(frame);
  return bool840;
}
Object meth_ast_visitString_40_1_41_841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool842 = alloc_Boolean(1);
// compiled identifier node returning bool842 (depth = 2)
  gc_frame_end(frame);
  return bool842;
}
Object meth_ast_visitNum_40_1_41_843(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool844 = alloc_Boolean(1);
// compiled identifier node returning bool844 (depth = 2)
  gc_frame_end(frame);
  return bool844;
}
Object meth_ast_visitOp_40_1_41_845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool846 = alloc_Boolean(1);
// compiled identifier node returning bool846 (depth = 2)
  gc_frame_end(frame);
  return bool846;
}
Object meth_ast_visitBind_40_1_41_847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool848 = alloc_Boolean(1);
// compiled identifier node returning bool848 (depth = 2)
  gc_frame_end(frame);
  return bool848;
}
Object meth_ast_visitDefDec_40_1_41_849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2897
  setline(2897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool850 = alloc_Boolean(1);
// compiled identifier node returning bool850 (depth = 2)
  gc_frame_end(frame);
  return bool850;
}
Object meth_ast_visitVarDec_40_1_41_851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool852 = alloc_Boolean(1);
// compiled identifier node returning bool852 (depth = 2)
  gc_frame_end(frame);
  return bool852;
}
Object meth_ast_visitImport_40_1_41_853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool854 = alloc_Boolean(1);
// compiled identifier node returning bool854 (depth = 2)
  gc_frame_end(frame);
  return bool854;
}
Object meth_ast_visitReturn_40_1_41_855(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2900
  setline(2900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool856 = alloc_Boolean(1);
// compiled identifier node returning bool856 (depth = 2)
  gc_frame_end(frame);
  return bool856;
}
Object meth_ast_visitInherits_40_1_41_857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool858 = alloc_Boolean(1);
// compiled identifier node returning bool858 (depth = 2)
  gc_frame_end(frame);
  return bool858;
}
Object meth_ast_visitDialect_40_1_41_859(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool860 = alloc_Boolean(1);
// compiled identifier node returning bool860 (depth = 2)
  gc_frame_end(frame);
  return bool860;
}
Object meth_ast_visitBlank_40_1_41_861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlank(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool862 = alloc_Boolean(1);
// compiled identifier node returning bool862 (depth = 2)
  gc_frame_end(frame);
  return bool862;
}
Object meth_ast_visitComment_40_1_41_863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2904
  setline(2904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool864 = alloc_Boolean(1);
// compiled identifier node returning bool864 (depth = 2)
  gc_frame_end(frame);
  return bool864;
}
Object meth_ast_visitImplicit_40_1_41_865(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImplicit(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool866 = alloc_Boolean(1);
// compiled identifier node returning bool866 (depth = 2)
  gc_frame_end(frame);
  return bool866;
}
Object meth_ast_asString867(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit868 == NULL) {
    strlit868 = alloc_String("an AST visitor");
    gc_root(strlit868);
  }
// compiled string node returning strlit868 (depth = 2)
  gc_frame_end(frame);
  return strlit868;
}
Object meth_ast_baseVisitor714(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject715 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj715 = alloc_userobj2(61,62, objclass715);
  gc_frame_newslot(obj715);
if (objclass715 == NULL) {
  glfree(obj715->class->name);
  obj715->class->name = "baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj715, self, 0);
  addmethodreal(obj715,"outer", &reader_ast_outer_716);
  Object oldself715 = self;
  struct StackFrameObject *oldstackframe715 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe715);
  gc_frame_newslot((Object)stackframe);
  self = obj715;
  Object *oldselfslot715 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter715 = (*(struct UserObject *)self).data[0], lowerouter715 = thisouter715;
  if (inheritingObject715) {
    struct UserObject *inho715 = (struct UserObject *)inheritingObject715;
    while (inho715->super != GraceDefaultObject) inho715 = (struct UserObject *)inho715->super;
    inho715->super = obj715;
    self = inheritingObject715;
    *selfslot = self;
    lowerouter715 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter715;
  }
// method "visitIf(_)up(_)"
  struct UserObject *uo717 = (struct UserObject*)obj715;
  uo717->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40_1_41_up_40_1_41_717 = addmethod2pos(obj715, "visitIf(1)up(1)", &meth_ast_visitIf_40_1_41_up_40_1_41_717, 1);
  int argcv_meth_ast_visitIf_40_1_41_up_40_1_41_717[] = {1, 1};
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_717->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40_1_41_up_40_1_41_717);
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_717->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_717->definitionLine = 2845;
// method "visitBlock(_)up(_)"
  struct UserObject *uo720 = (struct UserObject*)obj715;
  uo720->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40_1_41_up_40_1_41_720 = addmethod2pos(obj715, "visitBlock(1)up(1)", &meth_ast_visitBlock_40_1_41_up_40_1_41_720, 2);
  int argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_720[] = {1, 1};
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_720->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_720);
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_720->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_720->definitionLine = 2846;
// method "visitMatchCase(_)up(_)"
  struct UserObject *uo723 = (struct UserObject*)obj715;
  uo723->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723 = addmethod2pos(obj715, "visitMatchCase(1)up(1)", &meth_ast_visitMatchCase_40_1_41_up_40_1_41_723, 3);
  int argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723[] = {1, 1};
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723);
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723->definitionLine = 2847;
// method "visitTryCatch(_)up(_)"
  struct UserObject *uo726 = (struct UserObject*)obj715;
  uo726->data[4] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726 = addmethod2pos(obj715, "visitTryCatch(1)up(1)", &meth_ast_visitTryCatch_40_1_41_up_40_1_41_726, 4);
  int argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726[] = {1, 1};
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726);
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726->definitionLine = 2848;
// method "visitMethodType(_)up(_)"
  struct UserObject *uo729 = (struct UserObject*)obj715;
  uo729->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_729 = addmethod2pos(obj715, "visitMethodType(1)up(1)", &meth_ast_visitMethodType_40_1_41_up_40_1_41_729, 5);
  int argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_729[] = {1, 1};
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_729->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_729);
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_729->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_729->definitionLine = 2849;
// method "visitSignaturePart(_)up(_)"
  struct UserObject *uo732 = (struct UserObject*)obj715;
  uo732->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732 = addmethod2pos(obj715, "visitSignaturePart(1)up(1)", &meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732, 6);
  int argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732);
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732->definitionLine = 2850;
// method "visitTypeDec(_)up(_)"
  struct UserObject *uo735 = (struct UserObject*)obj715;
  uo735->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735 = addmethod2pos(obj715, "visitTypeDec(1)up(1)", &meth_ast_visitTypeDec_40_1_41_up_40_1_41_735, 7);
  int argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735[] = {1, 1};
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735);
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735->definitionLine = 2851;
// method "visitTypeLiteral(_)up(_)"
  struct UserObject *uo738 = (struct UserObject*)obj715;
  uo738->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738 = addmethod2pos(obj715, "visitTypeLiteral(1)up(1)", &meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738, 8);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738);
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738->definitionLine = 2852;
// method "visitTypeParameters(_)up(_)"
  struct UserObject *uo741 = (struct UserObject*)obj715;
  uo741->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741 = addmethod2pos(obj715, "visitTypeParameters(1)up(1)", &meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741, 9);
  int argcv_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741);
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741->definitionLine = 2853;
// method "visitMethod(_)up(_)"
  struct UserObject *uo744 = (struct UserObject*)obj715;
  uo744->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40_1_41_up_40_1_41_744 = addmethod2pos(obj715, "visitMethod(1)up(1)", &meth_ast_visitMethod_40_1_41_up_40_1_41_744, 10);
  int argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_744[] = {1, 1};
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_744->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_744);
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_744->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_744->definitionLine = 2854;
// method "visitCall(_)up(_)"
  struct UserObject *uo747 = (struct UserObject*)obj715;
  uo747->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_747 = addmethod2pos(obj715, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_747, 11);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_747[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_747->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_747);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_747->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_747->definitionLine = 2855;
// method "visitObject(_)up(_)"
  struct UserObject *uo750 = (struct UserObject*)obj715;
  uo750->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40_1_41_up_40_1_41_750 = addmethod2pos(obj715, "visitObject(1)up(1)", &meth_ast_visitObject_40_1_41_up_40_1_41_750, 12);
  int argcv_meth_ast_visitObject_40_1_41_up_40_1_41_750[] = {1, 1};
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_750->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40_1_41_up_40_1_41_750);
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_750->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_750->definitionLine = 2856;
// method "visitModule(_)up(_)"
  struct UserObject *uo753 = (struct UserObject*)obj715;
  uo753->data[13] = emptyclosure;
  Method *meth_meth_ast_visitModule_40_1_41_up_40_1_41_753 = addmethod2pos(obj715, "visitModule(1)up(1)", &meth_ast_visitModule_40_1_41_up_40_1_41_753, 13);
  int argcv_meth_ast_visitModule_40_1_41_up_40_1_41_753[] = {1, 1};
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_753->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40_1_41_up_40_1_41_753);
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_753->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_753->definitionLine = 2857;
// method "visitArray(_)up(_)"
  struct UserObject *uo756 = (struct UserObject*)obj715;
  uo756->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40_1_41_up_40_1_41_756 = addmethod2pos(obj715, "visitArray(1)up(1)", &meth_ast_visitArray_40_1_41_up_40_1_41_756, 14);
  int argcv_meth_ast_visitArray_40_1_41_up_40_1_41_756[] = {1, 1};
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_756->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40_1_41_up_40_1_41_756);
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_756->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_756->definitionLine = 2858;
// method "visitMember(_)up(_)"
  struct UserObject *uo759 = (struct UserObject*)obj715;
  uo759->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40_1_41_up_40_1_41_759 = addmethod2pos(obj715, "visitMember(1)up(1)", &meth_ast_visitMember_40_1_41_up_40_1_41_759, 15);
  int argcv_meth_ast_visitMember_40_1_41_up_40_1_41_759[] = {1, 1};
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_759->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40_1_41_up_40_1_41_759);
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_759->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_759->definitionLine = 2859;
// method "visitGeneric(_)up(_)"
  struct UserObject *uo762 = (struct UserObject*)obj715;
  uo762->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_762 = addmethod2pos(obj715, "visitGeneric(1)up(1)", &meth_ast_visitGeneric_40_1_41_up_40_1_41_762, 16);
  int argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_762[] = {1, 1};
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_762->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_762);
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_762->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_762->definitionLine = 2860;
// method "visitIdentifier(_)up(_)"
  struct UserObject *uo765 = (struct UserObject*)obj715;
  uo765->data[17] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765 = addmethod2pos(obj715, "visitIdentifier(1)up(1)", &meth_ast_visitIdentifier_40_1_41_up_40_1_41_765, 17);
  int argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765[] = {1, 1};
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765);
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765->definitionLine = 2861;
// method "visitString(_)up(_)"
  struct UserObject *uo768 = (struct UserObject*)obj715;
  uo768->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40_1_41_up_40_1_41_768 = addmethod2pos(obj715, "visitString(1)up(1)", &meth_ast_visitString_40_1_41_up_40_1_41_768, 18);
  int argcv_meth_ast_visitString_40_1_41_up_40_1_41_768[] = {1, 1};
  meth_meth_ast_visitString_40_1_41_up_40_1_41_768->type = alloc_MethodType(2, argcv_meth_ast_visitString_40_1_41_up_40_1_41_768);
  meth_meth_ast_visitString_40_1_41_up_40_1_41_768->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_up_40_1_41_768->definitionLine = 2862;
// method "visitNum(_)up(_)"
  struct UserObject *uo771 = (struct UserObject*)obj715;
  uo771->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40_1_41_up_40_1_41_771 = addmethod2pos(obj715, "visitNum(1)up(1)", &meth_ast_visitNum_40_1_41_up_40_1_41_771, 19);
  int argcv_meth_ast_visitNum_40_1_41_up_40_1_41_771[] = {1, 1};
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_771->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40_1_41_up_40_1_41_771);
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_771->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_771->definitionLine = 2863;
// method "visitOp(_)up(_)"
  struct UserObject *uo774 = (struct UserObject*)obj715;
  uo774->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40_1_41_up_40_1_41_774 = addmethod2pos(obj715, "visitOp(1)up(1)", &meth_ast_visitOp_40_1_41_up_40_1_41_774, 20);
  int argcv_meth_ast_visitOp_40_1_41_up_40_1_41_774[] = {1, 1};
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_774->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40_1_41_up_40_1_41_774);
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_774->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_774->definitionLine = 2864;
// method "visitBind(_)up(_)"
  struct UserObject *uo777 = (struct UserObject*)obj715;
  uo777->data[21] = emptyclosure;
  Method *meth_meth_ast_visitBind_40_1_41_up_40_1_41_777 = addmethod2pos(obj715, "visitBind(1)up(1)", &meth_ast_visitBind_40_1_41_up_40_1_41_777, 21);
  int argcv_meth_ast_visitBind_40_1_41_up_40_1_41_777[] = {1, 1};
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_777->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40_1_41_up_40_1_41_777);
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_777->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_777->definitionLine = 2865;
// method "visitDefDec(_)up(_)"
  struct UserObject *uo780 = (struct UserObject*)obj715;
  uo780->data[22] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_780 = addmethod2pos(obj715, "visitDefDec(1)up(1)", &meth_ast_visitDefDec_40_1_41_up_40_1_41_780, 22);
  int argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_780[] = {1, 1};
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_780->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_780);
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_780->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_780->definitionLine = 2866;
// method "visitVarDec(_)up(_)"
  struct UserObject *uo783 = (struct UserObject*)obj715;
  uo783->data[23] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_783 = addmethod2pos(obj715, "visitVarDec(1)up(1)", &meth_ast_visitVarDec_40_1_41_up_40_1_41_783, 23);
  int argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_783[] = {1, 1};
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_783->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_783);
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_783->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_783->definitionLine = 2867;
// method "visitImport(_)up(_)"
  struct UserObject *uo786 = (struct UserObject*)obj715;
  uo786->data[24] = emptyclosure;
  Method *meth_meth_ast_visitImport_40_1_41_up_40_1_41_786 = addmethod2pos(obj715, "visitImport(1)up(1)", &meth_ast_visitImport_40_1_41_up_40_1_41_786, 24);
  int argcv_meth_ast_visitImport_40_1_41_up_40_1_41_786[] = {1, 1};
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_786->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40_1_41_up_40_1_41_786);
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_786->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_786->definitionLine = 2868;
// method "visitReturn(_)up(_)"
  struct UserObject *uo789 = (struct UserObject*)obj715;
  uo789->data[25] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40_1_41_up_40_1_41_789 = addmethod2pos(obj715, "visitReturn(1)up(1)", &meth_ast_visitReturn_40_1_41_up_40_1_41_789, 25);
  int argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_789[] = {1, 1};
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_789->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_789);
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_789->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_789->definitionLine = 2869;
// method "visitInherits(_)up(_)"
  struct UserObject *uo792 = (struct UserObject*)obj715;
  uo792->data[26] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40_1_41_up_40_1_41_792 = addmethod2pos(obj715, "visitInherits(1)up(1)", &meth_ast_visitInherits_40_1_41_up_40_1_41_792, 26);
  int argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_792[] = {1, 1};
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_792->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_792);
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_792->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_792->definitionLine = 2870;
// method "visitDialect(_)up(_)"
  struct UserObject *uo795 = (struct UserObject*)obj715;
  uo795->data[27] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40_1_41_up_40_1_41_795 = addmethod2pos(obj715, "visitDialect(1)up(1)", &meth_ast_visitDialect_40_1_41_up_40_1_41_795, 27);
  int argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_795[] = {1, 1};
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_795->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_795);
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_795->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_795->definitionLine = 2871;
// method "visitBlank(_)up(_)"
  struct UserObject *uo798 = (struct UserObject*)obj715;
  uo798->data[28] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40_1_41_up_40_1_41_798 = addmethod2pos(obj715, "visitBlank(1)up(1)", &meth_ast_visitBlank_40_1_41_up_40_1_41_798, 28);
  int argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_798[] = {1, 1};
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_798->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_798);
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_798->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_798->definitionLine = 2872;
// method "visitComment(_)up(_)"
  struct UserObject *uo801 = (struct UserObject*)obj715;
  uo801->data[29] = emptyclosure;
  Method *meth_meth_ast_visitComment_40_1_41_up_40_1_41_801 = addmethod2pos(obj715, "visitComment(1)up(1)", &meth_ast_visitComment_40_1_41_up_40_1_41_801, 29);
  int argcv_meth_ast_visitComment_40_1_41_up_40_1_41_801[] = {1, 1};
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_801->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40_1_41_up_40_1_41_801);
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_801->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_801->definitionLine = 2873;
// method "visitImplicit(_)up(_)"
  struct UserObject *uo804 = (struct UserObject*)obj715;
  uo804->data[30] = emptyclosure;
  Method *meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_804 = addmethod2pos(obj715, "visitImplicit(1)up(1)", &meth_ast_visitImplicit_40_1_41_up_40_1_41_804, 30);
  int argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_804[] = {1, 1};
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_804->type = alloc_MethodType(2, argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_804);
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_804->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_804->definitionLine = 2874;
// method "visitIf(_)"
  struct UserObject *uo807 = (struct UserObject*)obj715;
  uo807->data[31] = emptyclosure;
  Method *meth_meth_ast_visitIf_40_1_41_807 = addmethod2pos(obj715, "visitIf(1)", &meth_ast_visitIf_40_1_41_807, 31);
  int argcv_meth_ast_visitIf_40_1_41_807[] = {1};
  meth_meth_ast_visitIf_40_1_41_807->type = alloc_MethodType(1, argcv_meth_ast_visitIf_40_1_41_807);
  meth_meth_ast_visitIf_40_1_41_807->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_807->definitionLine = 2876;
// method "visitBlock(_)"
  struct UserObject *uo809 = (struct UserObject*)obj715;
  uo809->data[32] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40_1_41_809 = addmethod2pos(obj715, "visitBlock(1)", &meth_ast_visitBlock_40_1_41_809, 32);
  int argcv_meth_ast_visitBlock_40_1_41_809[] = {1};
  meth_meth_ast_visitBlock_40_1_41_809->type = alloc_MethodType(1, argcv_meth_ast_visitBlock_40_1_41_809);
  meth_meth_ast_visitBlock_40_1_41_809->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_809->definitionLine = 2877;
// method "visitMatchCase(_)"
  struct UserObject *uo811 = (struct UserObject*)obj715;
  uo811->data[33] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40_1_41_811 = addmethod2pos(obj715, "visitMatchCase(1)", &meth_ast_visitMatchCase_40_1_41_811, 33);
  int argcv_meth_ast_visitMatchCase_40_1_41_811[] = {1};
  meth_meth_ast_visitMatchCase_40_1_41_811->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase_40_1_41_811);
  meth_meth_ast_visitMatchCase_40_1_41_811->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_811->definitionLine = 2878;
// method "visitTryCatch(_)"
  struct UserObject *uo813 = (struct UserObject*)obj715;
  uo813->data[34] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40_1_41_813 = addmethod2pos(obj715, "visitTryCatch(1)", &meth_ast_visitTryCatch_40_1_41_813, 34);
  int argcv_meth_ast_visitTryCatch_40_1_41_813[] = {1};
  meth_meth_ast_visitTryCatch_40_1_41_813->type = alloc_MethodType(1, argcv_meth_ast_visitTryCatch_40_1_41_813);
  meth_meth_ast_visitTryCatch_40_1_41_813->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_813->definitionLine = 2879;
// method "visitMethodType(_)"
  struct UserObject *uo815 = (struct UserObject*)obj715;
  uo815->data[35] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40_1_41_815 = addmethod2pos(obj715, "visitMethodType(1)", &meth_ast_visitMethodType_40_1_41_815, 35);
  int argcv_meth_ast_visitMethodType_40_1_41_815[] = {1};
  meth_meth_ast_visitMethodType_40_1_41_815->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType_40_1_41_815);
  meth_meth_ast_visitMethodType_40_1_41_815->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_815->definitionLine = 2880;
// method "visitSignaturePart(_)"
  struct UserObject *uo817 = (struct UserObject*)obj715;
  uo817->data[36] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_817 = addmethod2pos(obj715, "visitSignaturePart(1)", &meth_ast_visitSignaturePart_40_1_41_817, 36);
  int argcv_meth_ast_visitSignaturePart_40_1_41_817[] = {1};
  meth_meth_ast_visitSignaturePart_40_1_41_817->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart_40_1_41_817);
  meth_meth_ast_visitSignaturePart_40_1_41_817->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_817->definitionLine = 2881;
// method "visitTypeDec(_)"
  struct UserObject *uo819 = (struct UserObject*)obj715;
  uo819->data[37] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40_1_41_819 = addmethod2pos(obj715, "visitTypeDec(1)", &meth_ast_visitTypeDec_40_1_41_819, 37);
  int argcv_meth_ast_visitTypeDec_40_1_41_819[] = {1};
  meth_meth_ast_visitTypeDec_40_1_41_819->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec_40_1_41_819);
  meth_meth_ast_visitTypeDec_40_1_41_819->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_819->definitionLine = 2882;
// method "visitTypeLiteral(_)"
  struct UserObject *uo821 = (struct UserObject*)obj715;
  uo821->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_821 = addmethod2pos(obj715, "visitTypeLiteral(1)", &meth_ast_visitTypeLiteral_40_1_41_821, 38);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_821[] = {1};
  meth_meth_ast_visitTypeLiteral_40_1_41_821->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral_40_1_41_821);
  meth_meth_ast_visitTypeLiteral_40_1_41_821->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_821->definitionLine = 2883;
// method "visitTypeParameters(_)"
  struct UserObject *uo823 = (struct UserObject*)obj715;
  uo823->data[39] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40_1_41_823 = addmethod2pos(obj715, "visitTypeParameters(1)", &meth_ast_visitTypeParameters_40_1_41_823, 39);
  int argcv_meth_ast_visitTypeParameters_40_1_41_823[] = {1};
  meth_meth_ast_visitTypeParameters_40_1_41_823->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters_40_1_41_823);
  meth_meth_ast_visitTypeParameters_40_1_41_823->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40_1_41_823->definitionLine = 2884;
// method "visitMethod(_)"
  struct UserObject *uo825 = (struct UserObject*)obj715;
  uo825->data[40] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40_1_41_825 = addmethod2pos(obj715, "visitMethod(1)", &meth_ast_visitMethod_40_1_41_825, 40);
  int argcv_meth_ast_visitMethod_40_1_41_825[] = {1};
  meth_meth_ast_visitMethod_40_1_41_825->type = alloc_MethodType(1, argcv_meth_ast_visitMethod_40_1_41_825);
  meth_meth_ast_visitMethod_40_1_41_825->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_825->definitionLine = 2885;
// method "visitCall(_)"
  struct UserObject *uo827 = (struct UserObject*)obj715;
  uo827->data[41] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_827 = addmethod2pos(obj715, "visitCall(1)", &meth_ast_visitCall_40_1_41_827, 41);
  int argcv_meth_ast_visitCall_40_1_41_827[] = {1};
  meth_meth_ast_visitCall_40_1_41_827->type = alloc_MethodType(1, argcv_meth_ast_visitCall_40_1_41_827);
  meth_meth_ast_visitCall_40_1_41_827->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_827->definitionLine = 2886;
// method "visitObject(_)"
  struct UserObject *uo829 = (struct UserObject*)obj715;
  uo829->data[42] = emptyclosure;
  Method *meth_meth_ast_visitObject_40_1_41_829 = addmethod2pos(obj715, "visitObject(1)", &meth_ast_visitObject_40_1_41_829, 42);
  int argcv_meth_ast_visitObject_40_1_41_829[] = {1};
  meth_meth_ast_visitObject_40_1_41_829->type = alloc_MethodType(1, argcv_meth_ast_visitObject_40_1_41_829);
  meth_meth_ast_visitObject_40_1_41_829->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_829->definitionLine = 2887;
// method "visitModule(_)"
  struct UserObject *uo831 = (struct UserObject*)obj715;
  uo831->data[43] = emptyclosure;
  Method *meth_meth_ast_visitModule_40_1_41_831 = addmethod2pos(obj715, "visitModule(1)", &meth_ast_visitModule_40_1_41_831, 43);
  int argcv_meth_ast_visitModule_40_1_41_831[] = {1};
  meth_meth_ast_visitModule_40_1_41_831->type = alloc_MethodType(1, argcv_meth_ast_visitModule_40_1_41_831);
  meth_meth_ast_visitModule_40_1_41_831->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_831->definitionLine = 2888;
// method "visitArray(_)"
  struct UserObject *uo833 = (struct UserObject*)obj715;
  uo833->data[44] = emptyclosure;
  Method *meth_meth_ast_visitArray_40_1_41_833 = addmethod2pos(obj715, "visitArray(1)", &meth_ast_visitArray_40_1_41_833, 44);
  int argcv_meth_ast_visitArray_40_1_41_833[] = {1};
  meth_meth_ast_visitArray_40_1_41_833->type = alloc_MethodType(1, argcv_meth_ast_visitArray_40_1_41_833);
  meth_meth_ast_visitArray_40_1_41_833->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_833->definitionLine = 2889;
// method "visitMember(_)"
  struct UserObject *uo835 = (struct UserObject*)obj715;
  uo835->data[45] = emptyclosure;
  Method *meth_meth_ast_visitMember_40_1_41_835 = addmethod2pos(obj715, "visitMember(1)", &meth_ast_visitMember_40_1_41_835, 45);
  int argcv_meth_ast_visitMember_40_1_41_835[] = {1};
  meth_meth_ast_visitMember_40_1_41_835->type = alloc_MethodType(1, argcv_meth_ast_visitMember_40_1_41_835);
  meth_meth_ast_visitMember_40_1_41_835->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_835->definitionLine = 2890;
// method "visitGeneric(_)"
  struct UserObject *uo837 = (struct UserObject*)obj715;
  uo837->data[46] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40_1_41_837 = addmethod2pos(obj715, "visitGeneric(1)", &meth_ast_visitGeneric_40_1_41_837, 46);
  int argcv_meth_ast_visitGeneric_40_1_41_837[] = {1};
  meth_meth_ast_visitGeneric_40_1_41_837->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric_40_1_41_837);
  meth_meth_ast_visitGeneric_40_1_41_837->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_837->definitionLine = 2891;
// method "visitIdentifier(_)"
  struct UserObject *uo839 = (struct UserObject*)obj715;
  uo839->data[47] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40_1_41_839 = addmethod2pos(obj715, "visitIdentifier(1)", &meth_ast_visitIdentifier_40_1_41_839, 47);
  int argcv_meth_ast_visitIdentifier_40_1_41_839[] = {1};
  meth_meth_ast_visitIdentifier_40_1_41_839->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier_40_1_41_839);
  meth_meth_ast_visitIdentifier_40_1_41_839->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_839->definitionLine = 2892;
// method "visitString(_)"
  struct UserObject *uo841 = (struct UserObject*)obj715;
  uo841->data[48] = emptyclosure;
  Method *meth_meth_ast_visitString_40_1_41_841 = addmethod2pos(obj715, "visitString(1)", &meth_ast_visitString_40_1_41_841, 48);
  int argcv_meth_ast_visitString_40_1_41_841[] = {1};
  meth_meth_ast_visitString_40_1_41_841->type = alloc_MethodType(1, argcv_meth_ast_visitString_40_1_41_841);
  meth_meth_ast_visitString_40_1_41_841->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_841->definitionLine = 2893;
// method "visitNum(_)"
  struct UserObject *uo843 = (struct UserObject*)obj715;
  uo843->data[49] = emptyclosure;
  Method *meth_meth_ast_visitNum_40_1_41_843 = addmethod2pos(obj715, "visitNum(1)", &meth_ast_visitNum_40_1_41_843, 49);
  int argcv_meth_ast_visitNum_40_1_41_843[] = {1};
  meth_meth_ast_visitNum_40_1_41_843->type = alloc_MethodType(1, argcv_meth_ast_visitNum_40_1_41_843);
  meth_meth_ast_visitNum_40_1_41_843->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_843->definitionLine = 2894;
// method "visitOp(_)"
  struct UserObject *uo845 = (struct UserObject*)obj715;
  uo845->data[50] = emptyclosure;
  Method *meth_meth_ast_visitOp_40_1_41_845 = addmethod2pos(obj715, "visitOp(1)", &meth_ast_visitOp_40_1_41_845, 50);
  int argcv_meth_ast_visitOp_40_1_41_845[] = {1};
  meth_meth_ast_visitOp_40_1_41_845->type = alloc_MethodType(1, argcv_meth_ast_visitOp_40_1_41_845);
  meth_meth_ast_visitOp_40_1_41_845->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_845->definitionLine = 2895;
// method "visitBind(_)"
  struct UserObject *uo847 = (struct UserObject*)obj715;
  uo847->data[51] = emptyclosure;
  Method *meth_meth_ast_visitBind_40_1_41_847 = addmethod2pos(obj715, "visitBind(1)", &meth_ast_visitBind_40_1_41_847, 51);
  int argcv_meth_ast_visitBind_40_1_41_847[] = {1};
  meth_meth_ast_visitBind_40_1_41_847->type = alloc_MethodType(1, argcv_meth_ast_visitBind_40_1_41_847);
  meth_meth_ast_visitBind_40_1_41_847->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_847->definitionLine = 2896;
// method "visitDefDec(_)"
  struct UserObject *uo849 = (struct UserObject*)obj715;
  uo849->data[52] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40_1_41_849 = addmethod2pos(obj715, "visitDefDec(1)", &meth_ast_visitDefDec_40_1_41_849, 52);
  int argcv_meth_ast_visitDefDec_40_1_41_849[] = {1};
  meth_meth_ast_visitDefDec_40_1_41_849->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec_40_1_41_849);
  meth_meth_ast_visitDefDec_40_1_41_849->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_849->definitionLine = 2897;
// method "visitVarDec(_)"
  struct UserObject *uo851 = (struct UserObject*)obj715;
  uo851->data[53] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40_1_41_851 = addmethod2pos(obj715, "visitVarDec(1)", &meth_ast_visitVarDec_40_1_41_851, 53);
  int argcv_meth_ast_visitVarDec_40_1_41_851[] = {1};
  meth_meth_ast_visitVarDec_40_1_41_851->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec_40_1_41_851);
  meth_meth_ast_visitVarDec_40_1_41_851->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_851->definitionLine = 2898;
// method "visitImport(_)"
  struct UserObject *uo853 = (struct UserObject*)obj715;
  uo853->data[54] = emptyclosure;
  Method *meth_meth_ast_visitImport_40_1_41_853 = addmethod2pos(obj715, "visitImport(1)", &meth_ast_visitImport_40_1_41_853, 54);
  int argcv_meth_ast_visitImport_40_1_41_853[] = {1};
  meth_meth_ast_visitImport_40_1_41_853->type = alloc_MethodType(1, argcv_meth_ast_visitImport_40_1_41_853);
  meth_meth_ast_visitImport_40_1_41_853->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_853->definitionLine = 2899;
// method "visitReturn(_)"
  struct UserObject *uo855 = (struct UserObject*)obj715;
  uo855->data[55] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40_1_41_855 = addmethod2pos(obj715, "visitReturn(1)", &meth_ast_visitReturn_40_1_41_855, 55);
  int argcv_meth_ast_visitReturn_40_1_41_855[] = {1};
  meth_meth_ast_visitReturn_40_1_41_855->type = alloc_MethodType(1, argcv_meth_ast_visitReturn_40_1_41_855);
  meth_meth_ast_visitReturn_40_1_41_855->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_855->definitionLine = 2900;
// method "visitInherits(_)"
  struct UserObject *uo857 = (struct UserObject*)obj715;
  uo857->data[56] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40_1_41_857 = addmethod2pos(obj715, "visitInherits(1)", &meth_ast_visitInherits_40_1_41_857, 56);
  int argcv_meth_ast_visitInherits_40_1_41_857[] = {1};
  meth_meth_ast_visitInherits_40_1_41_857->type = alloc_MethodType(1, argcv_meth_ast_visitInherits_40_1_41_857);
  meth_meth_ast_visitInherits_40_1_41_857->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_857->definitionLine = 2901;
// method "visitDialect(_)"
  struct UserObject *uo859 = (struct UserObject*)obj715;
  uo859->data[57] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40_1_41_859 = addmethod2pos(obj715, "visitDialect(1)", &meth_ast_visitDialect_40_1_41_859, 57);
  int argcv_meth_ast_visitDialect_40_1_41_859[] = {1};
  meth_meth_ast_visitDialect_40_1_41_859->type = alloc_MethodType(1, argcv_meth_ast_visitDialect_40_1_41_859);
  meth_meth_ast_visitDialect_40_1_41_859->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_859->definitionLine = 2902;
// method "visitBlank(_)"
  struct UserObject *uo861 = (struct UserObject*)obj715;
  uo861->data[58] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40_1_41_861 = addmethod2pos(obj715, "visitBlank(1)", &meth_ast_visitBlank_40_1_41_861, 58);
  int argcv_meth_ast_visitBlank_40_1_41_861[] = {1};
  meth_meth_ast_visitBlank_40_1_41_861->type = alloc_MethodType(1, argcv_meth_ast_visitBlank_40_1_41_861);
  meth_meth_ast_visitBlank_40_1_41_861->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_861->definitionLine = 2903;
// method "visitComment(_)"
  struct UserObject *uo863 = (struct UserObject*)obj715;
  uo863->data[59] = emptyclosure;
  Method *meth_meth_ast_visitComment_40_1_41_863 = addmethod2pos(obj715, "visitComment(1)", &meth_ast_visitComment_40_1_41_863, 59);
  int argcv_meth_ast_visitComment_40_1_41_863[] = {1};
  meth_meth_ast_visitComment_40_1_41_863->type = alloc_MethodType(1, argcv_meth_ast_visitComment_40_1_41_863);
  meth_meth_ast_visitComment_40_1_41_863->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_863->definitionLine = 2904;
// method "visitImplicit(_)"
  struct UserObject *uo865 = (struct UserObject*)obj715;
  uo865->data[60] = emptyclosure;
  Method *meth_meth_ast_visitImplicit_40_1_41_865 = addmethod2pos(obj715, "visitImplicit(1)", &meth_ast_visitImplicit_40_1_41_865, 60);
  int argcv_meth_ast_visitImplicit_40_1_41_865[] = {1};
  meth_meth_ast_visitImplicit_40_1_41_865->type = alloc_MethodType(1, argcv_meth_ast_visitImplicit_40_1_41_865);
  meth_meth_ast_visitImplicit_40_1_41_865->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_865->definitionLine = 2905;
// method "asString"
  struct UserObject *uo867 = (struct UserObject*)obj715;
  uo867->data[61] = emptyclosure;
  Method *meth_meth_ast_asString867 = addmethod2pos(obj715, "asString", &meth_ast_asString867, 61);
  int argcv_meth_ast_asString867[] = {0};
  meth_meth_ast_asString867->type = alloc_MethodType(1, argcv_meth_ast_asString867);
  meth_meth_ast_asString867->definitionModule = modulename;
  meth_meth_ast_asString867->definitionLine = 2907;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  objclass715 = obj715->class;
  objclass715->definitionModule = modulename;
  objclass715->definitionLine = 2844;
  (*(struct UserObject *)self).data[0] = lowerouter715;
  self = oldself715;
  selfslot = oldselfslot715;
  stackframe = oldstackframe715;
  gc_frame_end(frame);
  return obj715;
}
Object meth_ast_baseVisitor714_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject715 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj715 = alloc_userobj2(61,62, objclass715);
  gc_frame_newslot(obj715);
if (objclass715 == NULL) {
  glfree(obj715->class->name);
  obj715->class->name = "baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj715, self, 0);
  addmethodreal(obj715,"outer", &reader_ast_outer_716);
  Object oldself715 = self;
  struct StackFrameObject *oldstackframe715 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe715);
  gc_frame_newslot((Object)stackframe);
  self = obj715;
  Object *oldselfslot715 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter715 = (*(struct UserObject *)self).data[0], lowerouter715 = thisouter715;
  if (inheritingObject715) {
    struct UserObject *inho715 = (struct UserObject *)inheritingObject715;
    while (inho715->super != GraceDefaultObject) inho715 = (struct UserObject *)inho715->super;
    inho715->super = obj715;
    self = inheritingObject715;
    *selfslot = self;
    lowerouter715 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter715;
  }
// method "visitIf(_)up(_)"
  struct UserObject *uo717 = (struct UserObject*)obj715;
  uo717->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40_1_41_up_40_1_41_717 = addmethod2pos(obj715, "visitIf(1)up(1)", &meth_ast_visitIf_40_1_41_up_40_1_41_717, 1);
  int argcv_meth_ast_visitIf_40_1_41_up_40_1_41_717[] = {1, 1};
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_717->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40_1_41_up_40_1_41_717);
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_717->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_717->definitionLine = 2845;
// method "visitBlock(_)up(_)"
  struct UserObject *uo720 = (struct UserObject*)obj715;
  uo720->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40_1_41_up_40_1_41_720 = addmethod2pos(obj715, "visitBlock(1)up(1)", &meth_ast_visitBlock_40_1_41_up_40_1_41_720, 2);
  int argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_720[] = {1, 1};
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_720->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_720);
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_720->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_720->definitionLine = 2846;
// method "visitMatchCase(_)up(_)"
  struct UserObject *uo723 = (struct UserObject*)obj715;
  uo723->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723 = addmethod2pos(obj715, "visitMatchCase(1)up(1)", &meth_ast_visitMatchCase_40_1_41_up_40_1_41_723, 3);
  int argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723[] = {1, 1};
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723);
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_723->definitionLine = 2847;
// method "visitTryCatch(_)up(_)"
  struct UserObject *uo726 = (struct UserObject*)obj715;
  uo726->data[4] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726 = addmethod2pos(obj715, "visitTryCatch(1)up(1)", &meth_ast_visitTryCatch_40_1_41_up_40_1_41_726, 4);
  int argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726[] = {1, 1};
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726);
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_726->definitionLine = 2848;
// method "visitMethodType(_)up(_)"
  struct UserObject *uo729 = (struct UserObject*)obj715;
  uo729->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_729 = addmethod2pos(obj715, "visitMethodType(1)up(1)", &meth_ast_visitMethodType_40_1_41_up_40_1_41_729, 5);
  int argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_729[] = {1, 1};
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_729->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_729);
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_729->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_729->definitionLine = 2849;
// method "visitSignaturePart(_)up(_)"
  struct UserObject *uo732 = (struct UserObject*)obj715;
  uo732->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732 = addmethod2pos(obj715, "visitSignaturePart(1)up(1)", &meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732, 6);
  int argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732);
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_732->definitionLine = 2850;
// method "visitTypeDec(_)up(_)"
  struct UserObject *uo735 = (struct UserObject*)obj715;
  uo735->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735 = addmethod2pos(obj715, "visitTypeDec(1)up(1)", &meth_ast_visitTypeDec_40_1_41_up_40_1_41_735, 7);
  int argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735[] = {1, 1};
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735);
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_735->definitionLine = 2851;
// method "visitTypeLiteral(_)up(_)"
  struct UserObject *uo738 = (struct UserObject*)obj715;
  uo738->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738 = addmethod2pos(obj715, "visitTypeLiteral(1)up(1)", &meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738, 8);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738);
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_738->definitionLine = 2852;
// method "visitTypeParameters(_)up(_)"
  struct UserObject *uo741 = (struct UserObject*)obj715;
  uo741->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741 = addmethod2pos(obj715, "visitTypeParameters(1)up(1)", &meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741, 9);
  int argcv_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741);
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_741->definitionLine = 2853;
// method "visitMethod(_)up(_)"
  struct UserObject *uo744 = (struct UserObject*)obj715;
  uo744->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40_1_41_up_40_1_41_744 = addmethod2pos(obj715, "visitMethod(1)up(1)", &meth_ast_visitMethod_40_1_41_up_40_1_41_744, 10);
  int argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_744[] = {1, 1};
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_744->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_744);
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_744->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_744->definitionLine = 2854;
// method "visitCall(_)up(_)"
  struct UserObject *uo747 = (struct UserObject*)obj715;
  uo747->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_747 = addmethod2pos(obj715, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_747, 11);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_747[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_747->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_747);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_747->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_747->definitionLine = 2855;
// method "visitObject(_)up(_)"
  struct UserObject *uo750 = (struct UserObject*)obj715;
  uo750->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40_1_41_up_40_1_41_750 = addmethod2pos(obj715, "visitObject(1)up(1)", &meth_ast_visitObject_40_1_41_up_40_1_41_750, 12);
  int argcv_meth_ast_visitObject_40_1_41_up_40_1_41_750[] = {1, 1};
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_750->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40_1_41_up_40_1_41_750);
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_750->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_750->definitionLine = 2856;
// method "visitModule(_)up(_)"
  struct UserObject *uo753 = (struct UserObject*)obj715;
  uo753->data[13] = emptyclosure;
  Method *meth_meth_ast_visitModule_40_1_41_up_40_1_41_753 = addmethod2pos(obj715, "visitModule(1)up(1)", &meth_ast_visitModule_40_1_41_up_40_1_41_753, 13);
  int argcv_meth_ast_visitModule_40_1_41_up_40_1_41_753[] = {1, 1};
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_753->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40_1_41_up_40_1_41_753);
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_753->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_753->definitionLine = 2857;
// method "visitArray(_)up(_)"
  struct UserObject *uo756 = (struct UserObject*)obj715;
  uo756->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40_1_41_up_40_1_41_756 = addmethod2pos(obj715, "visitArray(1)up(1)", &meth_ast_visitArray_40_1_41_up_40_1_41_756, 14);
  int argcv_meth_ast_visitArray_40_1_41_up_40_1_41_756[] = {1, 1};
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_756->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40_1_41_up_40_1_41_756);
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_756->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_756->definitionLine = 2858;
// method "visitMember(_)up(_)"
  struct UserObject *uo759 = (struct UserObject*)obj715;
  uo759->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40_1_41_up_40_1_41_759 = addmethod2pos(obj715, "visitMember(1)up(1)", &meth_ast_visitMember_40_1_41_up_40_1_41_759, 15);
  int argcv_meth_ast_visitMember_40_1_41_up_40_1_41_759[] = {1, 1};
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_759->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40_1_41_up_40_1_41_759);
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_759->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_759->definitionLine = 2859;
// method "visitGeneric(_)up(_)"
  struct UserObject *uo762 = (struct UserObject*)obj715;
  uo762->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_762 = addmethod2pos(obj715, "visitGeneric(1)up(1)", &meth_ast_visitGeneric_40_1_41_up_40_1_41_762, 16);
  int argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_762[] = {1, 1};
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_762->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_762);
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_762->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_762->definitionLine = 2860;
// method "visitIdentifier(_)up(_)"
  struct UserObject *uo765 = (struct UserObject*)obj715;
  uo765->data[17] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765 = addmethod2pos(obj715, "visitIdentifier(1)up(1)", &meth_ast_visitIdentifier_40_1_41_up_40_1_41_765, 17);
  int argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765[] = {1, 1};
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765);
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_765->definitionLine = 2861;
// method "visitString(_)up(_)"
  struct UserObject *uo768 = (struct UserObject*)obj715;
  uo768->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40_1_41_up_40_1_41_768 = addmethod2pos(obj715, "visitString(1)up(1)", &meth_ast_visitString_40_1_41_up_40_1_41_768, 18);
  int argcv_meth_ast_visitString_40_1_41_up_40_1_41_768[] = {1, 1};
  meth_meth_ast_visitString_40_1_41_up_40_1_41_768->type = alloc_MethodType(2, argcv_meth_ast_visitString_40_1_41_up_40_1_41_768);
  meth_meth_ast_visitString_40_1_41_up_40_1_41_768->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_up_40_1_41_768->definitionLine = 2862;
// method "visitNum(_)up(_)"
  struct UserObject *uo771 = (struct UserObject*)obj715;
  uo771->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40_1_41_up_40_1_41_771 = addmethod2pos(obj715, "visitNum(1)up(1)", &meth_ast_visitNum_40_1_41_up_40_1_41_771, 19);
  int argcv_meth_ast_visitNum_40_1_41_up_40_1_41_771[] = {1, 1};
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_771->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40_1_41_up_40_1_41_771);
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_771->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_771->definitionLine = 2863;
// method "visitOp(_)up(_)"
  struct UserObject *uo774 = (struct UserObject*)obj715;
  uo774->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40_1_41_up_40_1_41_774 = addmethod2pos(obj715, "visitOp(1)up(1)", &meth_ast_visitOp_40_1_41_up_40_1_41_774, 20);
  int argcv_meth_ast_visitOp_40_1_41_up_40_1_41_774[] = {1, 1};
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_774->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40_1_41_up_40_1_41_774);
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_774->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_774->definitionLine = 2864;
// method "visitBind(_)up(_)"
  struct UserObject *uo777 = (struct UserObject*)obj715;
  uo777->data[21] = emptyclosure;
  Method *meth_meth_ast_visitBind_40_1_41_up_40_1_41_777 = addmethod2pos(obj715, "visitBind(1)up(1)", &meth_ast_visitBind_40_1_41_up_40_1_41_777, 21);
  int argcv_meth_ast_visitBind_40_1_41_up_40_1_41_777[] = {1, 1};
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_777->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40_1_41_up_40_1_41_777);
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_777->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_777->definitionLine = 2865;
// method "visitDefDec(_)up(_)"
  struct UserObject *uo780 = (struct UserObject*)obj715;
  uo780->data[22] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_780 = addmethod2pos(obj715, "visitDefDec(1)up(1)", &meth_ast_visitDefDec_40_1_41_up_40_1_41_780, 22);
  int argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_780[] = {1, 1};
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_780->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_780);
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_780->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_780->definitionLine = 2866;
// method "visitVarDec(_)up(_)"
  struct UserObject *uo783 = (struct UserObject*)obj715;
  uo783->data[23] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_783 = addmethod2pos(obj715, "visitVarDec(1)up(1)", &meth_ast_visitVarDec_40_1_41_up_40_1_41_783, 23);
  int argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_783[] = {1, 1};
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_783->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_783);
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_783->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_783->definitionLine = 2867;
// method "visitImport(_)up(_)"
  struct UserObject *uo786 = (struct UserObject*)obj715;
  uo786->data[24] = emptyclosure;
  Method *meth_meth_ast_visitImport_40_1_41_up_40_1_41_786 = addmethod2pos(obj715, "visitImport(1)up(1)", &meth_ast_visitImport_40_1_41_up_40_1_41_786, 24);
  int argcv_meth_ast_visitImport_40_1_41_up_40_1_41_786[] = {1, 1};
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_786->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40_1_41_up_40_1_41_786);
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_786->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_786->definitionLine = 2868;
// method "visitReturn(_)up(_)"
  struct UserObject *uo789 = (struct UserObject*)obj715;
  uo789->data[25] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40_1_41_up_40_1_41_789 = addmethod2pos(obj715, "visitReturn(1)up(1)", &meth_ast_visitReturn_40_1_41_up_40_1_41_789, 25);
  int argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_789[] = {1, 1};
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_789->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_789);
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_789->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_789->definitionLine = 2869;
// method "visitInherits(_)up(_)"
  struct UserObject *uo792 = (struct UserObject*)obj715;
  uo792->data[26] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40_1_41_up_40_1_41_792 = addmethod2pos(obj715, "visitInherits(1)up(1)", &meth_ast_visitInherits_40_1_41_up_40_1_41_792, 26);
  int argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_792[] = {1, 1};
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_792->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_792);
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_792->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_792->definitionLine = 2870;
// method "visitDialect(_)up(_)"
  struct UserObject *uo795 = (struct UserObject*)obj715;
  uo795->data[27] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40_1_41_up_40_1_41_795 = addmethod2pos(obj715, "visitDialect(1)up(1)", &meth_ast_visitDialect_40_1_41_up_40_1_41_795, 27);
  int argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_795[] = {1, 1};
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_795->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_795);
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_795->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_795->definitionLine = 2871;
// method "visitBlank(_)up(_)"
  struct UserObject *uo798 = (struct UserObject*)obj715;
  uo798->data[28] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40_1_41_up_40_1_41_798 = addmethod2pos(obj715, "visitBlank(1)up(1)", &meth_ast_visitBlank_40_1_41_up_40_1_41_798, 28);
  int argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_798[] = {1, 1};
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_798->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_798);
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_798->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_798->definitionLine = 2872;
// method "visitComment(_)up(_)"
  struct UserObject *uo801 = (struct UserObject*)obj715;
  uo801->data[29] = emptyclosure;
  Method *meth_meth_ast_visitComment_40_1_41_up_40_1_41_801 = addmethod2pos(obj715, "visitComment(1)up(1)", &meth_ast_visitComment_40_1_41_up_40_1_41_801, 29);
  int argcv_meth_ast_visitComment_40_1_41_up_40_1_41_801[] = {1, 1};
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_801->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40_1_41_up_40_1_41_801);
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_801->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_801->definitionLine = 2873;
// method "visitImplicit(_)up(_)"
  struct UserObject *uo804 = (struct UserObject*)obj715;
  uo804->data[30] = emptyclosure;
  Method *meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_804 = addmethod2pos(obj715, "visitImplicit(1)up(1)", &meth_ast_visitImplicit_40_1_41_up_40_1_41_804, 30);
  int argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_804[] = {1, 1};
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_804->type = alloc_MethodType(2, argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_804);
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_804->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_804->definitionLine = 2874;
// method "visitIf(_)"
  struct UserObject *uo807 = (struct UserObject*)obj715;
  uo807->data[31] = emptyclosure;
  Method *meth_meth_ast_visitIf_40_1_41_807 = addmethod2pos(obj715, "visitIf(1)", &meth_ast_visitIf_40_1_41_807, 31);
  int argcv_meth_ast_visitIf_40_1_41_807[] = {1};
  meth_meth_ast_visitIf_40_1_41_807->type = alloc_MethodType(1, argcv_meth_ast_visitIf_40_1_41_807);
  meth_meth_ast_visitIf_40_1_41_807->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_807->definitionLine = 2876;
// method "visitBlock(_)"
  struct UserObject *uo809 = (struct UserObject*)obj715;
  uo809->data[32] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40_1_41_809 = addmethod2pos(obj715, "visitBlock(1)", &meth_ast_visitBlock_40_1_41_809, 32);
  int argcv_meth_ast_visitBlock_40_1_41_809[] = {1};
  meth_meth_ast_visitBlock_40_1_41_809->type = alloc_MethodType(1, argcv_meth_ast_visitBlock_40_1_41_809);
  meth_meth_ast_visitBlock_40_1_41_809->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_809->definitionLine = 2877;
// method "visitMatchCase(_)"
  struct UserObject *uo811 = (struct UserObject*)obj715;
  uo811->data[33] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40_1_41_811 = addmethod2pos(obj715, "visitMatchCase(1)", &meth_ast_visitMatchCase_40_1_41_811, 33);
  int argcv_meth_ast_visitMatchCase_40_1_41_811[] = {1};
  meth_meth_ast_visitMatchCase_40_1_41_811->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase_40_1_41_811);
  meth_meth_ast_visitMatchCase_40_1_41_811->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_811->definitionLine = 2878;
// method "visitTryCatch(_)"
  struct UserObject *uo813 = (struct UserObject*)obj715;
  uo813->data[34] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40_1_41_813 = addmethod2pos(obj715, "visitTryCatch(1)", &meth_ast_visitTryCatch_40_1_41_813, 34);
  int argcv_meth_ast_visitTryCatch_40_1_41_813[] = {1};
  meth_meth_ast_visitTryCatch_40_1_41_813->type = alloc_MethodType(1, argcv_meth_ast_visitTryCatch_40_1_41_813);
  meth_meth_ast_visitTryCatch_40_1_41_813->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_813->definitionLine = 2879;
// method "visitMethodType(_)"
  struct UserObject *uo815 = (struct UserObject*)obj715;
  uo815->data[35] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40_1_41_815 = addmethod2pos(obj715, "visitMethodType(1)", &meth_ast_visitMethodType_40_1_41_815, 35);
  int argcv_meth_ast_visitMethodType_40_1_41_815[] = {1};
  meth_meth_ast_visitMethodType_40_1_41_815->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType_40_1_41_815);
  meth_meth_ast_visitMethodType_40_1_41_815->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_815->definitionLine = 2880;
// method "visitSignaturePart(_)"
  struct UserObject *uo817 = (struct UserObject*)obj715;
  uo817->data[36] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_817 = addmethod2pos(obj715, "visitSignaturePart(1)", &meth_ast_visitSignaturePart_40_1_41_817, 36);
  int argcv_meth_ast_visitSignaturePart_40_1_41_817[] = {1};
  meth_meth_ast_visitSignaturePart_40_1_41_817->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart_40_1_41_817);
  meth_meth_ast_visitSignaturePart_40_1_41_817->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_817->definitionLine = 2881;
// method "visitTypeDec(_)"
  struct UserObject *uo819 = (struct UserObject*)obj715;
  uo819->data[37] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40_1_41_819 = addmethod2pos(obj715, "visitTypeDec(1)", &meth_ast_visitTypeDec_40_1_41_819, 37);
  int argcv_meth_ast_visitTypeDec_40_1_41_819[] = {1};
  meth_meth_ast_visitTypeDec_40_1_41_819->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec_40_1_41_819);
  meth_meth_ast_visitTypeDec_40_1_41_819->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_819->definitionLine = 2882;
// method "visitTypeLiteral(_)"
  struct UserObject *uo821 = (struct UserObject*)obj715;
  uo821->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_821 = addmethod2pos(obj715, "visitTypeLiteral(1)", &meth_ast_visitTypeLiteral_40_1_41_821, 38);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_821[] = {1};
  meth_meth_ast_visitTypeLiteral_40_1_41_821->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral_40_1_41_821);
  meth_meth_ast_visitTypeLiteral_40_1_41_821->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_821->definitionLine = 2883;
// method "visitTypeParameters(_)"
  struct UserObject *uo823 = (struct UserObject*)obj715;
  uo823->data[39] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40_1_41_823 = addmethod2pos(obj715, "visitTypeParameters(1)", &meth_ast_visitTypeParameters_40_1_41_823, 39);
  int argcv_meth_ast_visitTypeParameters_40_1_41_823[] = {1};
  meth_meth_ast_visitTypeParameters_40_1_41_823->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters_40_1_41_823);
  meth_meth_ast_visitTypeParameters_40_1_41_823->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40_1_41_823->definitionLine = 2884;
// method "visitMethod(_)"
  struct UserObject *uo825 = (struct UserObject*)obj715;
  uo825->data[40] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40_1_41_825 = addmethod2pos(obj715, "visitMethod(1)", &meth_ast_visitMethod_40_1_41_825, 40);
  int argcv_meth_ast_visitMethod_40_1_41_825[] = {1};
  meth_meth_ast_visitMethod_40_1_41_825->type = alloc_MethodType(1, argcv_meth_ast_visitMethod_40_1_41_825);
  meth_meth_ast_visitMethod_40_1_41_825->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_825->definitionLine = 2885;
// method "visitCall(_)"
  struct UserObject *uo827 = (struct UserObject*)obj715;
  uo827->data[41] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_827 = addmethod2pos(obj715, "visitCall(1)", &meth_ast_visitCall_40_1_41_827, 41);
  int argcv_meth_ast_visitCall_40_1_41_827[] = {1};
  meth_meth_ast_visitCall_40_1_41_827->type = alloc_MethodType(1, argcv_meth_ast_visitCall_40_1_41_827);
  meth_meth_ast_visitCall_40_1_41_827->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_827->definitionLine = 2886;
// method "visitObject(_)"
  struct UserObject *uo829 = (struct UserObject*)obj715;
  uo829->data[42] = emptyclosure;
  Method *meth_meth_ast_visitObject_40_1_41_829 = addmethod2pos(obj715, "visitObject(1)", &meth_ast_visitObject_40_1_41_829, 42);
  int argcv_meth_ast_visitObject_40_1_41_829[] = {1};
  meth_meth_ast_visitObject_40_1_41_829->type = alloc_MethodType(1, argcv_meth_ast_visitObject_40_1_41_829);
  meth_meth_ast_visitObject_40_1_41_829->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_829->definitionLine = 2887;
// method "visitModule(_)"
  struct UserObject *uo831 = (struct UserObject*)obj715;
  uo831->data[43] = emptyclosure;
  Method *meth_meth_ast_visitModule_40_1_41_831 = addmethod2pos(obj715, "visitModule(1)", &meth_ast_visitModule_40_1_41_831, 43);
  int argcv_meth_ast_visitModule_40_1_41_831[] = {1};
  meth_meth_ast_visitModule_40_1_41_831->type = alloc_MethodType(1, argcv_meth_ast_visitModule_40_1_41_831);
  meth_meth_ast_visitModule_40_1_41_831->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_831->definitionLine = 2888;
// method "visitArray(_)"
  struct UserObject *uo833 = (struct UserObject*)obj715;
  uo833->data[44] = emptyclosure;
  Method *meth_meth_ast_visitArray_40_1_41_833 = addmethod2pos(obj715, "visitArray(1)", &meth_ast_visitArray_40_1_41_833, 44);
  int argcv_meth_ast_visitArray_40_1_41_833[] = {1};
  meth_meth_ast_visitArray_40_1_41_833->type = alloc_MethodType(1, argcv_meth_ast_visitArray_40_1_41_833);
  meth_meth_ast_visitArray_40_1_41_833->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_833->definitionLine = 2889;
// method "visitMember(_)"
  struct UserObject *uo835 = (struct UserObject*)obj715;
  uo835->data[45] = emptyclosure;
  Method *meth_meth_ast_visitMember_40_1_41_835 = addmethod2pos(obj715, "visitMember(1)", &meth_ast_visitMember_40_1_41_835, 45);
  int argcv_meth_ast_visitMember_40_1_41_835[] = {1};
  meth_meth_ast_visitMember_40_1_41_835->type = alloc_MethodType(1, argcv_meth_ast_visitMember_40_1_41_835);
  meth_meth_ast_visitMember_40_1_41_835->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_835->definitionLine = 2890;
// method "visitGeneric(_)"
  struct UserObject *uo837 = (struct UserObject*)obj715;
  uo837->data[46] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40_1_41_837 = addmethod2pos(obj715, "visitGeneric(1)", &meth_ast_visitGeneric_40_1_41_837, 46);
  int argcv_meth_ast_visitGeneric_40_1_41_837[] = {1};
  meth_meth_ast_visitGeneric_40_1_41_837->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric_40_1_41_837);
  meth_meth_ast_visitGeneric_40_1_41_837->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_837->definitionLine = 2891;
// method "visitIdentifier(_)"
  struct UserObject *uo839 = (struct UserObject*)obj715;
  uo839->data[47] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40_1_41_839 = addmethod2pos(obj715, "visitIdentifier(1)", &meth_ast_visitIdentifier_40_1_41_839, 47);
  int argcv_meth_ast_visitIdentifier_40_1_41_839[] = {1};
  meth_meth_ast_visitIdentifier_40_1_41_839->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier_40_1_41_839);
  meth_meth_ast_visitIdentifier_40_1_41_839->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_839->definitionLine = 2892;
// method "visitString(_)"
  struct UserObject *uo841 = (struct UserObject*)obj715;
  uo841->data[48] = emptyclosure;
  Method *meth_meth_ast_visitString_40_1_41_841 = addmethod2pos(obj715, "visitString(1)", &meth_ast_visitString_40_1_41_841, 48);
  int argcv_meth_ast_visitString_40_1_41_841[] = {1};
  meth_meth_ast_visitString_40_1_41_841->type = alloc_MethodType(1, argcv_meth_ast_visitString_40_1_41_841);
  meth_meth_ast_visitString_40_1_41_841->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_841->definitionLine = 2893;
// method "visitNum(_)"
  struct UserObject *uo843 = (struct UserObject*)obj715;
  uo843->data[49] = emptyclosure;
  Method *meth_meth_ast_visitNum_40_1_41_843 = addmethod2pos(obj715, "visitNum(1)", &meth_ast_visitNum_40_1_41_843, 49);
  int argcv_meth_ast_visitNum_40_1_41_843[] = {1};
  meth_meth_ast_visitNum_40_1_41_843->type = alloc_MethodType(1, argcv_meth_ast_visitNum_40_1_41_843);
  meth_meth_ast_visitNum_40_1_41_843->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_843->definitionLine = 2894;
// method "visitOp(_)"
  struct UserObject *uo845 = (struct UserObject*)obj715;
  uo845->data[50] = emptyclosure;
  Method *meth_meth_ast_visitOp_40_1_41_845 = addmethod2pos(obj715, "visitOp(1)", &meth_ast_visitOp_40_1_41_845, 50);
  int argcv_meth_ast_visitOp_40_1_41_845[] = {1};
  meth_meth_ast_visitOp_40_1_41_845->type = alloc_MethodType(1, argcv_meth_ast_visitOp_40_1_41_845);
  meth_meth_ast_visitOp_40_1_41_845->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_845->definitionLine = 2895;
// method "visitBind(_)"
  struct UserObject *uo847 = (struct UserObject*)obj715;
  uo847->data[51] = emptyclosure;
  Method *meth_meth_ast_visitBind_40_1_41_847 = addmethod2pos(obj715, "visitBind(1)", &meth_ast_visitBind_40_1_41_847, 51);
  int argcv_meth_ast_visitBind_40_1_41_847[] = {1};
  meth_meth_ast_visitBind_40_1_41_847->type = alloc_MethodType(1, argcv_meth_ast_visitBind_40_1_41_847);
  meth_meth_ast_visitBind_40_1_41_847->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_847->definitionLine = 2896;
// method "visitDefDec(_)"
  struct UserObject *uo849 = (struct UserObject*)obj715;
  uo849->data[52] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40_1_41_849 = addmethod2pos(obj715, "visitDefDec(1)", &meth_ast_visitDefDec_40_1_41_849, 52);
  int argcv_meth_ast_visitDefDec_40_1_41_849[] = {1};
  meth_meth_ast_visitDefDec_40_1_41_849->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec_40_1_41_849);
  meth_meth_ast_visitDefDec_40_1_41_849->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_849->definitionLine = 2897;
// method "visitVarDec(_)"
  struct UserObject *uo851 = (struct UserObject*)obj715;
  uo851->data[53] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40_1_41_851 = addmethod2pos(obj715, "visitVarDec(1)", &meth_ast_visitVarDec_40_1_41_851, 53);
  int argcv_meth_ast_visitVarDec_40_1_41_851[] = {1};
  meth_meth_ast_visitVarDec_40_1_41_851->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec_40_1_41_851);
  meth_meth_ast_visitVarDec_40_1_41_851->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_851->definitionLine = 2898;
// method "visitImport(_)"
  struct UserObject *uo853 = (struct UserObject*)obj715;
  uo853->data[54] = emptyclosure;
  Method *meth_meth_ast_visitImport_40_1_41_853 = addmethod2pos(obj715, "visitImport(1)", &meth_ast_visitImport_40_1_41_853, 54);
  int argcv_meth_ast_visitImport_40_1_41_853[] = {1};
  meth_meth_ast_visitImport_40_1_41_853->type = alloc_MethodType(1, argcv_meth_ast_visitImport_40_1_41_853);
  meth_meth_ast_visitImport_40_1_41_853->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_853->definitionLine = 2899;
// method "visitReturn(_)"
  struct UserObject *uo855 = (struct UserObject*)obj715;
  uo855->data[55] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40_1_41_855 = addmethod2pos(obj715, "visitReturn(1)", &meth_ast_visitReturn_40_1_41_855, 55);
  int argcv_meth_ast_visitReturn_40_1_41_855[] = {1};
  meth_meth_ast_visitReturn_40_1_41_855->type = alloc_MethodType(1, argcv_meth_ast_visitReturn_40_1_41_855);
  meth_meth_ast_visitReturn_40_1_41_855->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_855->definitionLine = 2900;
// method "visitInherits(_)"
  struct UserObject *uo857 = (struct UserObject*)obj715;
  uo857->data[56] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40_1_41_857 = addmethod2pos(obj715, "visitInherits(1)", &meth_ast_visitInherits_40_1_41_857, 56);
  int argcv_meth_ast_visitInherits_40_1_41_857[] = {1};
  meth_meth_ast_visitInherits_40_1_41_857->type = alloc_MethodType(1, argcv_meth_ast_visitInherits_40_1_41_857);
  meth_meth_ast_visitInherits_40_1_41_857->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_857->definitionLine = 2901;
// method "visitDialect(_)"
  struct UserObject *uo859 = (struct UserObject*)obj715;
  uo859->data[57] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40_1_41_859 = addmethod2pos(obj715, "visitDialect(1)", &meth_ast_visitDialect_40_1_41_859, 57);
  int argcv_meth_ast_visitDialect_40_1_41_859[] = {1};
  meth_meth_ast_visitDialect_40_1_41_859->type = alloc_MethodType(1, argcv_meth_ast_visitDialect_40_1_41_859);
  meth_meth_ast_visitDialect_40_1_41_859->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_859->definitionLine = 2902;
// method "visitBlank(_)"
  struct UserObject *uo861 = (struct UserObject*)obj715;
  uo861->data[58] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40_1_41_861 = addmethod2pos(obj715, "visitBlank(1)", &meth_ast_visitBlank_40_1_41_861, 58);
  int argcv_meth_ast_visitBlank_40_1_41_861[] = {1};
  meth_meth_ast_visitBlank_40_1_41_861->type = alloc_MethodType(1, argcv_meth_ast_visitBlank_40_1_41_861);
  meth_meth_ast_visitBlank_40_1_41_861->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_861->definitionLine = 2903;
// method "visitComment(_)"
  struct UserObject *uo863 = (struct UserObject*)obj715;
  uo863->data[59] = emptyclosure;
  Method *meth_meth_ast_visitComment_40_1_41_863 = addmethod2pos(obj715, "visitComment(1)", &meth_ast_visitComment_40_1_41_863, 59);
  int argcv_meth_ast_visitComment_40_1_41_863[] = {1};
  meth_meth_ast_visitComment_40_1_41_863->type = alloc_MethodType(1, argcv_meth_ast_visitComment_40_1_41_863);
  meth_meth_ast_visitComment_40_1_41_863->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_863->definitionLine = 2904;
// method "visitImplicit(_)"
  struct UserObject *uo865 = (struct UserObject*)obj715;
  uo865->data[60] = emptyclosure;
  Method *meth_meth_ast_visitImplicit_40_1_41_865 = addmethod2pos(obj715, "visitImplicit(1)", &meth_ast_visitImplicit_40_1_41_865, 60);
  int argcv_meth_ast_visitImplicit_40_1_41_865[] = {1};
  meth_meth_ast_visitImplicit_40_1_41_865->type = alloc_MethodType(1, argcv_meth_ast_visitImplicit_40_1_41_865);
  meth_meth_ast_visitImplicit_40_1_41_865->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_865->definitionLine = 2905;
// method "asString"
  struct UserObject *uo867 = (struct UserObject*)obj715;
  uo867->data[61] = emptyclosure;
  Method *meth_meth_ast_asString867 = addmethod2pos(obj715, "asString", &meth_ast_asString867, 61);
  int argcv_meth_ast_asString867[] = {0};
  meth_meth_ast_asString867->type = alloc_MethodType(1, argcv_meth_ast_asString867);
  meth_meth_ast_asString867->definitionModule = modulename;
  meth_meth_ast_asString867->definitionLine = 2907;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  objclass715 = obj715->class;
  objclass715->definitionModule = modulename;
  objclass715->definitionLine = 2844;
  (*(struct UserObject *)self).data[0] = lowerouter715;
  self = oldself715;
  selfslot = oldselfslot715;
  stackframe = oldstackframe715;
  gc_frame_end(frame);
  return obj715;
}
Object meth_ast_visitIf_40_1_41_up_40_1_41_873(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIf(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe874 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call875 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe874);
// compiled call node returning call875 (depth = 2)
  gc_frame_end(frame);
  return call875;
}
Object meth_ast_visitBlock_40_1_41_up_40_1_41_876(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlock(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe877 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call878 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe877);
// compiled call node returning call878 (depth = 2)
  gc_frame_end(frame);
  return call878;
}
Object meth_ast_visitMatchCase_40_1_41_up_40_1_41_879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMatchCase(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe880 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call881 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe880);
// compiled call node returning call881 (depth = 2)
  gc_frame_end(frame);
  return call881;
}
Object meth_ast_visitTryCatch_40_1_41_up_40_1_41_882(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTryCatch(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe883 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call884 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe883);
// compiled call node returning call884 (depth = 2)
  gc_frame_end(frame);
  return call884;
}
Object meth_ast_visitMethodType_40_1_41_up_40_1_41_885(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethodType(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe886 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call887 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe886);
// compiled call node returning call887 (depth = 2)
  gc_frame_end(frame);
  return call887;
}
Object meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitSignaturePart(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe889 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call890 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe889);
// compiled call node returning call890 (depth = 2)
  gc_frame_end(frame);
  return call890;
}
Object meth_ast_visitTypeDec_40_1_41_up_40_1_41_891(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe892 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call893 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe892);
// compiled call node returning call893 (depth = 2)
  gc_frame_end(frame);
  return call893;
}
Object meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeLiteral(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe895 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call896 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe895);
// compiled call node returning call896 (depth = 2)
  gc_frame_end(frame);
  return call896;
}
Object meth_ast_visitMethod_40_1_41_up_40_1_41_897(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethod(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe898 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call899 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe898);
// compiled call node returning call899 (depth = 2)
  gc_frame_end(frame);
  return call899;
}
Object meth_ast_visitCall_40_1_41_up_40_1_41_900(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe901 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call902 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe901);
// compiled call node returning call902 (depth = 2)
  gc_frame_end(frame);
  return call902;
}
Object meth_ast_visitObject_40_1_41_up_40_1_41_903(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitObject(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe904 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call905 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe904);
// compiled call node returning call905 (depth = 2)
  gc_frame_end(frame);
  return call905;
}
Object meth_ast_visitModule_40_1_41_up_40_1_41_906(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitModule(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe907 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call908 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe907);
// compiled call node returning call908 (depth = 2)
  gc_frame_end(frame);
  return call908;
}
Object meth_ast_visitArray_40_1_41_up_40_1_41_909(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitArray(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe910 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call911 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe910);
// compiled call node returning call911 (depth = 2)
  gc_frame_end(frame);
  return call911;
}
Object meth_ast_visitMember_40_1_41_up_40_1_41_912(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMember(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe913 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call914 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe913);
// compiled call node returning call914 (depth = 2)
  gc_frame_end(frame);
  return call914;
}
Object meth_ast_visitGeneric_40_1_41_up_40_1_41_915(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitGeneric(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe916 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call917 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe916);
// compiled call node returning call917 (depth = 2)
  gc_frame_end(frame);
  return call917;
}
Object meth_ast_visitIdentifier_40_1_41_up_40_1_41_918(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIdentifier(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe919 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call920 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe919);
// compiled call node returning call920 (depth = 2)
  gc_frame_end(frame);
  return call920;
}
Object meth_ast_visitString_40_1_41_up_40_1_41_921(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitString(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2933
  setline(2933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe922 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call923 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe922);
// compiled call node returning call923 (depth = 2)
  gc_frame_end(frame);
  return call923;
}
Object meth_ast_visitNum_40_1_41_up_40_1_41_924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitNum(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe925 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call926 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe925);
// compiled call node returning call926 (depth = 2)
  gc_frame_end(frame);
  return call926;
}
Object meth_ast_visitOp_40_1_41_up_40_1_41_927(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitOp(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe928 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call929 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe928);
// compiled call node returning call929 (depth = 2)
  gc_frame_end(frame);
  return call929;
}
Object meth_ast_visitBind_40_1_41_up_40_1_41_930(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBind(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe931 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call932 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe931);
// compiled call node returning call932 (depth = 2)
  gc_frame_end(frame);
  return call932;
}
Object meth_ast_visitDefDec_40_1_41_up_40_1_41_933(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDefDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe934 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call935 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe934);
// compiled call node returning call935 (depth = 2)
  gc_frame_end(frame);
  return call935;
}
Object meth_ast_visitVarDec_40_1_41_up_40_1_41_936(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitVarDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe937 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call938 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe937);
// compiled call node returning call938 (depth = 2)
  gc_frame_end(frame);
  return call938;
}
Object meth_ast_visitImport_40_1_41_up_40_1_41_939(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImport(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe940 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call941 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe940);
// compiled call node returning call941 (depth = 2)
  gc_frame_end(frame);
  return call941;
}
Object meth_ast_visitReturn_40_1_41_up_40_1_41_942(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitReturn(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe943 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call944 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe943);
// compiled call node returning call944 (depth = 2)
  gc_frame_end(frame);
  return call944;
}
Object meth_ast_visitInherits_40_1_41_up_40_1_41_945(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitInherits(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2941
  setline(2941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe946 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call947 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe946);
// compiled call node returning call947 (depth = 2)
  gc_frame_end(frame);
  return call947;
}
Object meth_ast_visitDialect_40_1_41_up_40_1_41_948(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDialect(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe949 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call950 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe949);
// compiled call node returning call950 (depth = 2)
  gc_frame_end(frame);
  return call950;
}
Object meth_ast_visitBlank_40_1_41_up_40_1_41_951(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlank(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlank(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe952 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call953 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe952);
// compiled call node returning call953 (depth = 2)
  gc_frame_end(frame);
  return call953;
}
Object meth_ast_visitComment_40_1_41_up_40_1_41_954(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitComment(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe955 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call956 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe955);
// compiled call node returning call956 (depth = 2)
  gc_frame_end(frame);
  return call956;
}
Object meth_ast_visitImplicit_40_1_41_up_40_1_41_957(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImplicit(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe958 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call959 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe958);
// compiled call node returning call959 (depth = 2)
  gc_frame_end(frame);
  return call959;
}
Object meth_ast_asString960(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit961 == NULL) {
    strlit961 = alloc_String("a pluggable AST visitor");
    gc_root(strlit961);
  }
// compiled string node returning strlit961 (depth = 2)
  gc_frame_end(frame);
  return strlit961;
}
Object meth_ast_pluggableVisitor_40_1_41_870(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pluggableVisitor(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pluggableVisitor(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject871 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj871 = alloc_userobj2(30,31, objclass871);
  gc_frame_newslot(obj871);
if (objclass871 == NULL) {
  glfree(obj871->class->name);
  obj871->class->name = "pluggableVisitor(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj871, self, 0);
  addmethodreal(obj871,"outer", &reader_ast_outer_872);
  Object oldself871 = self;
  struct StackFrameObject *oldstackframe871 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe871);
  gc_frame_newslot((Object)stackframe);
  self = obj871;
  Object *oldselfslot871 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter871 = (*(struct UserObject *)self).data[0], lowerouter871 = thisouter871;
  if (inheritingObject871) {
    struct UserObject *inho871 = (struct UserObject *)inheritingObject871;
    while (inho871->super != GraceDefaultObject) inho871 = (struct UserObject *)inho871->super;
    inho871->super = obj871;
    self = inheritingObject871;
    *selfslot = self;
    lowerouter871 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter871;
  }
// method "visitIf(_)up(_)"
  block_savedest(obj871);
  Object closure873 = createclosure(1, "visitIf(1)up(1)");
  setclosureframe(closure873, stackframe);
  addtoclosure(closure873, var_visitation);
  struct UserObject *uo873 = (struct UserObject*)obj871;
  uo873->data[1] = (Object)closure873;
  Method *meth_meth_ast_visitIf_40_1_41_up_40_1_41_873 = addmethod2pos(obj871, "visitIf(1)up(1)", &meth_ast_visitIf_40_1_41_up_40_1_41_873, 1);
  int argcv_meth_ast_visitIf_40_1_41_up_40_1_41_873[] = {1, 1};
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_873->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40_1_41_up_40_1_41_873);
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_873->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_873->definitionLine = 2917;
// method "visitBlock(_)up(_)"
  block_savedest(obj871);
  Object closure876 = createclosure(1, "visitBlock(1)up(1)");
  setclosureframe(closure876, stackframe);
  addtoclosure(closure876, var_visitation);
  struct UserObject *uo876 = (struct UserObject*)obj871;
  uo876->data[2] = (Object)closure876;
  Method *meth_meth_ast_visitBlock_40_1_41_up_40_1_41_876 = addmethod2pos(obj871, "visitBlock(1)up(1)", &meth_ast_visitBlock_40_1_41_up_40_1_41_876, 2);
  int argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_876[] = {1, 1};
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_876->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_876);
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_876->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_876->definitionLine = 2918;
// method "visitMatchCase(_)up(_)"
  block_savedest(obj871);
  Object closure879 = createclosure(1, "visitMatchCase(1)up(1)");
  setclosureframe(closure879, stackframe);
  addtoclosure(closure879, var_visitation);
  struct UserObject *uo879 = (struct UserObject*)obj871;
  uo879->data[3] = (Object)closure879;
  Method *meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879 = addmethod2pos(obj871, "visitMatchCase(1)up(1)", &meth_ast_visitMatchCase_40_1_41_up_40_1_41_879, 3);
  int argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879[] = {1, 1};
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879);
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879->definitionLine = 2919;
// method "visitTryCatch(_)up(_)"
  block_savedest(obj871);
  Object closure882 = createclosure(1, "visitTryCatch(1)up(1)");
  setclosureframe(closure882, stackframe);
  addtoclosure(closure882, var_visitation);
  struct UserObject *uo882 = (struct UserObject*)obj871;
  uo882->data[4] = (Object)closure882;
  Method *meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882 = addmethod2pos(obj871, "visitTryCatch(1)up(1)", &meth_ast_visitTryCatch_40_1_41_up_40_1_41_882, 4);
  int argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882[] = {1, 1};
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882);
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882->definitionLine = 2920;
// method "visitMethodType(_)up(_)"
  block_savedest(obj871);
  Object closure885 = createclosure(1, "visitMethodType(1)up(1)");
  setclosureframe(closure885, stackframe);
  addtoclosure(closure885, var_visitation);
  struct UserObject *uo885 = (struct UserObject*)obj871;
  uo885->data[5] = (Object)closure885;
  Method *meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_885 = addmethod2pos(obj871, "visitMethodType(1)up(1)", &meth_ast_visitMethodType_40_1_41_up_40_1_41_885, 5);
  int argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_885[] = {1, 1};
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_885->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_885);
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_885->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_885->definitionLine = 2921;
// method "visitSignaturePart(_)up(_)"
  block_savedest(obj871);
  Object closure888 = createclosure(1, "visitSignaturePart(1)up(1)");
  setclosureframe(closure888, stackframe);
  addtoclosure(closure888, var_visitation);
  struct UserObject *uo888 = (struct UserObject*)obj871;
  uo888->data[6] = (Object)closure888;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888 = addmethod2pos(obj871, "visitSignaturePart(1)up(1)", &meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888, 6);
  int argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888);
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888->definitionLine = 2922;
// method "visitTypeDec(_)up(_)"
  block_savedest(obj871);
  Object closure891 = createclosure(1, "visitTypeDec(1)up(1)");
  setclosureframe(closure891, stackframe);
  addtoclosure(closure891, var_visitation);
  struct UserObject *uo891 = (struct UserObject*)obj871;
  uo891->data[7] = (Object)closure891;
  Method *meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891 = addmethod2pos(obj871, "visitTypeDec(1)up(1)", &meth_ast_visitTypeDec_40_1_41_up_40_1_41_891, 7);
  int argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891[] = {1, 1};
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891);
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891->definitionLine = 2923;
// method "visitTypeLiteral(_)up(_)"
  block_savedest(obj871);
  Object closure894 = createclosure(1, "visitTypeLiteral(1)up(1)");
  setclosureframe(closure894, stackframe);
  addtoclosure(closure894, var_visitation);
  struct UserObject *uo894 = (struct UserObject*)obj871;
  uo894->data[8] = (Object)closure894;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894 = addmethod2pos(obj871, "visitTypeLiteral(1)up(1)", &meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894, 8);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894);
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894->definitionLine = 2924;
// method "visitMethod(_)up(_)"
  block_savedest(obj871);
  Object closure897 = createclosure(1, "visitMethod(1)up(1)");
  setclosureframe(closure897, stackframe);
  addtoclosure(closure897, var_visitation);
  struct UserObject *uo897 = (struct UserObject*)obj871;
  uo897->data[9] = (Object)closure897;
  Method *meth_meth_ast_visitMethod_40_1_41_up_40_1_41_897 = addmethod2pos(obj871, "visitMethod(1)up(1)", &meth_ast_visitMethod_40_1_41_up_40_1_41_897, 9);
  int argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_897[] = {1, 1};
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_897->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_897);
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_897->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_897->definitionLine = 2925;
// method "visitCall(_)up(_)"
  block_savedest(obj871);
  Object closure900 = createclosure(1, "visitCall(1)up(1)");
  setclosureframe(closure900, stackframe);
  addtoclosure(closure900, var_visitation);
  struct UserObject *uo900 = (struct UserObject*)obj871;
  uo900->data[10] = (Object)closure900;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_900 = addmethod2pos(obj871, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_900, 10);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_900[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_900->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_900);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_900->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_900->definitionLine = 2926;
// method "visitObject(_)up(_)"
  block_savedest(obj871);
  Object closure903 = createclosure(1, "visitObject(1)up(1)");
  setclosureframe(closure903, stackframe);
  addtoclosure(closure903, var_visitation);
  struct UserObject *uo903 = (struct UserObject*)obj871;
  uo903->data[11] = (Object)closure903;
  Method *meth_meth_ast_visitObject_40_1_41_up_40_1_41_903 = addmethod2pos(obj871, "visitObject(1)up(1)", &meth_ast_visitObject_40_1_41_up_40_1_41_903, 11);
  int argcv_meth_ast_visitObject_40_1_41_up_40_1_41_903[] = {1, 1};
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_903->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40_1_41_up_40_1_41_903);
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_903->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_903->definitionLine = 2927;
// method "visitModule(_)up(_)"
  block_savedest(obj871);
  Object closure906 = createclosure(1, "visitModule(1)up(1)");
  setclosureframe(closure906, stackframe);
  addtoclosure(closure906, var_visitation);
  struct UserObject *uo906 = (struct UserObject*)obj871;
  uo906->data[12] = (Object)closure906;
  Method *meth_meth_ast_visitModule_40_1_41_up_40_1_41_906 = addmethod2pos(obj871, "visitModule(1)up(1)", &meth_ast_visitModule_40_1_41_up_40_1_41_906, 12);
  int argcv_meth_ast_visitModule_40_1_41_up_40_1_41_906[] = {1, 1};
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_906->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40_1_41_up_40_1_41_906);
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_906->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_906->definitionLine = 2928;
// method "visitArray(_)up(_)"
  block_savedest(obj871);
  Object closure909 = createclosure(1, "visitArray(1)up(1)");
  setclosureframe(closure909, stackframe);
  addtoclosure(closure909, var_visitation);
  struct UserObject *uo909 = (struct UserObject*)obj871;
  uo909->data[13] = (Object)closure909;
  Method *meth_meth_ast_visitArray_40_1_41_up_40_1_41_909 = addmethod2pos(obj871, "visitArray(1)up(1)", &meth_ast_visitArray_40_1_41_up_40_1_41_909, 13);
  int argcv_meth_ast_visitArray_40_1_41_up_40_1_41_909[] = {1, 1};
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_909->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40_1_41_up_40_1_41_909);
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_909->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_909->definitionLine = 2929;
// method "visitMember(_)up(_)"
  block_savedest(obj871);
  Object closure912 = createclosure(1, "visitMember(1)up(1)");
  setclosureframe(closure912, stackframe);
  addtoclosure(closure912, var_visitation);
  struct UserObject *uo912 = (struct UserObject*)obj871;
  uo912->data[14] = (Object)closure912;
  Method *meth_meth_ast_visitMember_40_1_41_up_40_1_41_912 = addmethod2pos(obj871, "visitMember(1)up(1)", &meth_ast_visitMember_40_1_41_up_40_1_41_912, 14);
  int argcv_meth_ast_visitMember_40_1_41_up_40_1_41_912[] = {1, 1};
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_912->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40_1_41_up_40_1_41_912);
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_912->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_912->definitionLine = 2930;
// method "visitGeneric(_)up(_)"
  block_savedest(obj871);
  Object closure915 = createclosure(1, "visitGeneric(1)up(1)");
  setclosureframe(closure915, stackframe);
  addtoclosure(closure915, var_visitation);
  struct UserObject *uo915 = (struct UserObject*)obj871;
  uo915->data[15] = (Object)closure915;
  Method *meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_915 = addmethod2pos(obj871, "visitGeneric(1)up(1)", &meth_ast_visitGeneric_40_1_41_up_40_1_41_915, 15);
  int argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_915[] = {1, 1};
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_915->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_915);
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_915->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_915->definitionLine = 2931;
// method "visitIdentifier(_)up(_)"
  block_savedest(obj871);
  Object closure918 = createclosure(1, "visitIdentifier(1)up(1)");
  setclosureframe(closure918, stackframe);
  addtoclosure(closure918, var_visitation);
  struct UserObject *uo918 = (struct UserObject*)obj871;
  uo918->data[16] = (Object)closure918;
  Method *meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918 = addmethod2pos(obj871, "visitIdentifier(1)up(1)", &meth_ast_visitIdentifier_40_1_41_up_40_1_41_918, 16);
  int argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918[] = {1, 1};
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918);
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918->definitionLine = 2932;
// method "visitString(_)up(_)"
  block_savedest(obj871);
  Object closure921 = createclosure(1, "visitString(1)up(1)");
  setclosureframe(closure921, stackframe);
  addtoclosure(closure921, var_visitation);
  struct UserObject *uo921 = (struct UserObject*)obj871;
  uo921->data[17] = (Object)closure921;
  Method *meth_meth_ast_visitString_40_1_41_up_40_1_41_921 = addmethod2pos(obj871, "visitString(1)up(1)", &meth_ast_visitString_40_1_41_up_40_1_41_921, 17);
  int argcv_meth_ast_visitString_40_1_41_up_40_1_41_921[] = {1, 1};
  meth_meth_ast_visitString_40_1_41_up_40_1_41_921->type = alloc_MethodType(2, argcv_meth_ast_visitString_40_1_41_up_40_1_41_921);
  meth_meth_ast_visitString_40_1_41_up_40_1_41_921->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_up_40_1_41_921->definitionLine = 2933;
// method "visitNum(_)up(_)"
  block_savedest(obj871);
  Object closure924 = createclosure(1, "visitNum(1)up(1)");
  setclosureframe(closure924, stackframe);
  addtoclosure(closure924, var_visitation);
  struct UserObject *uo924 = (struct UserObject*)obj871;
  uo924->data[18] = (Object)closure924;
  Method *meth_meth_ast_visitNum_40_1_41_up_40_1_41_924 = addmethod2pos(obj871, "visitNum(1)up(1)", &meth_ast_visitNum_40_1_41_up_40_1_41_924, 18);
  int argcv_meth_ast_visitNum_40_1_41_up_40_1_41_924[] = {1, 1};
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_924->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40_1_41_up_40_1_41_924);
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_924->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_924->definitionLine = 2934;
// method "visitOp(_)up(_)"
  block_savedest(obj871);
  Object closure927 = createclosure(1, "visitOp(1)up(1)");
  setclosureframe(closure927, stackframe);
  addtoclosure(closure927, var_visitation);
  struct UserObject *uo927 = (struct UserObject*)obj871;
  uo927->data[19] = (Object)closure927;
  Method *meth_meth_ast_visitOp_40_1_41_up_40_1_41_927 = addmethod2pos(obj871, "visitOp(1)up(1)", &meth_ast_visitOp_40_1_41_up_40_1_41_927, 19);
  int argcv_meth_ast_visitOp_40_1_41_up_40_1_41_927[] = {1, 1};
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_927->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40_1_41_up_40_1_41_927);
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_927->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_927->definitionLine = 2935;
// method "visitBind(_)up(_)"
  block_savedest(obj871);
  Object closure930 = createclosure(1, "visitBind(1)up(1)");
  setclosureframe(closure930, stackframe);
  addtoclosure(closure930, var_visitation);
  struct UserObject *uo930 = (struct UserObject*)obj871;
  uo930->data[20] = (Object)closure930;
  Method *meth_meth_ast_visitBind_40_1_41_up_40_1_41_930 = addmethod2pos(obj871, "visitBind(1)up(1)", &meth_ast_visitBind_40_1_41_up_40_1_41_930, 20);
  int argcv_meth_ast_visitBind_40_1_41_up_40_1_41_930[] = {1, 1};
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_930->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40_1_41_up_40_1_41_930);
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_930->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_930->definitionLine = 2936;
// method "visitDefDec(_)up(_)"
  block_savedest(obj871);
  Object closure933 = createclosure(1, "visitDefDec(1)up(1)");
  setclosureframe(closure933, stackframe);
  addtoclosure(closure933, var_visitation);
  struct UserObject *uo933 = (struct UserObject*)obj871;
  uo933->data[21] = (Object)closure933;
  Method *meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_933 = addmethod2pos(obj871, "visitDefDec(1)up(1)", &meth_ast_visitDefDec_40_1_41_up_40_1_41_933, 21);
  int argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_933[] = {1, 1};
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_933->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_933);
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_933->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_933->definitionLine = 2937;
// method "visitVarDec(_)up(_)"
  block_savedest(obj871);
  Object closure936 = createclosure(1, "visitVarDec(1)up(1)");
  setclosureframe(closure936, stackframe);
  addtoclosure(closure936, var_visitation);
  struct UserObject *uo936 = (struct UserObject*)obj871;
  uo936->data[22] = (Object)closure936;
  Method *meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_936 = addmethod2pos(obj871, "visitVarDec(1)up(1)", &meth_ast_visitVarDec_40_1_41_up_40_1_41_936, 22);
  int argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_936[] = {1, 1};
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_936->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_936);
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_936->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_936->definitionLine = 2938;
// method "visitImport(_)up(_)"
  block_savedest(obj871);
  Object closure939 = createclosure(1, "visitImport(1)up(1)");
  setclosureframe(closure939, stackframe);
  addtoclosure(closure939, var_visitation);
  struct UserObject *uo939 = (struct UserObject*)obj871;
  uo939->data[23] = (Object)closure939;
  Method *meth_meth_ast_visitImport_40_1_41_up_40_1_41_939 = addmethod2pos(obj871, "visitImport(1)up(1)", &meth_ast_visitImport_40_1_41_up_40_1_41_939, 23);
  int argcv_meth_ast_visitImport_40_1_41_up_40_1_41_939[] = {1, 1};
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_939->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40_1_41_up_40_1_41_939);
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_939->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_939->definitionLine = 2939;
// method "visitReturn(_)up(_)"
  block_savedest(obj871);
  Object closure942 = createclosure(1, "visitReturn(1)up(1)");
  setclosureframe(closure942, stackframe);
  addtoclosure(closure942, var_visitation);
  struct UserObject *uo942 = (struct UserObject*)obj871;
  uo942->data[24] = (Object)closure942;
  Method *meth_meth_ast_visitReturn_40_1_41_up_40_1_41_942 = addmethod2pos(obj871, "visitReturn(1)up(1)", &meth_ast_visitReturn_40_1_41_up_40_1_41_942, 24);
  int argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_942[] = {1, 1};
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_942->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_942);
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_942->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_942->definitionLine = 2940;
// method "visitInherits(_)up(_)"
  block_savedest(obj871);
  Object closure945 = createclosure(1, "visitInherits(1)up(1)");
  setclosureframe(closure945, stackframe);
  addtoclosure(closure945, var_visitation);
  struct UserObject *uo945 = (struct UserObject*)obj871;
  uo945->data[25] = (Object)closure945;
  Method *meth_meth_ast_visitInherits_40_1_41_up_40_1_41_945 = addmethod2pos(obj871, "visitInherits(1)up(1)", &meth_ast_visitInherits_40_1_41_up_40_1_41_945, 25);
  int argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_945[] = {1, 1};
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_945->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_945);
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_945->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_945->definitionLine = 2941;
// method "visitDialect(_)up(_)"
  block_savedest(obj871);
  Object closure948 = createclosure(1, "visitDialect(1)up(1)");
  setclosureframe(closure948, stackframe);
  addtoclosure(closure948, var_visitation);
  struct UserObject *uo948 = (struct UserObject*)obj871;
  uo948->data[26] = (Object)closure948;
  Method *meth_meth_ast_visitDialect_40_1_41_up_40_1_41_948 = addmethod2pos(obj871, "visitDialect(1)up(1)", &meth_ast_visitDialect_40_1_41_up_40_1_41_948, 26);
  int argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_948[] = {1, 1};
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_948->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_948);
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_948->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_948->definitionLine = 2942;
// method "visitBlank(_)up(_)"
  block_savedest(obj871);
  Object closure951 = createclosure(1, "visitBlank(1)up(1)");
  setclosureframe(closure951, stackframe);
  addtoclosure(closure951, var_visitation);
  struct UserObject *uo951 = (struct UserObject*)obj871;
  uo951->data[27] = (Object)closure951;
  Method *meth_meth_ast_visitBlank_40_1_41_up_40_1_41_951 = addmethod2pos(obj871, "visitBlank(1)up(1)", &meth_ast_visitBlank_40_1_41_up_40_1_41_951, 27);
  int argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_951[] = {1, 1};
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_951->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_951);
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_951->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_951->definitionLine = 2943;
// method "visitComment(_)up(_)"
  block_savedest(obj871);
  Object closure954 = createclosure(1, "visitComment(1)up(1)");
  setclosureframe(closure954, stackframe);
  addtoclosure(closure954, var_visitation);
  struct UserObject *uo954 = (struct UserObject*)obj871;
  uo954->data[28] = (Object)closure954;
  Method *meth_meth_ast_visitComment_40_1_41_up_40_1_41_954 = addmethod2pos(obj871, "visitComment(1)up(1)", &meth_ast_visitComment_40_1_41_up_40_1_41_954, 28);
  int argcv_meth_ast_visitComment_40_1_41_up_40_1_41_954[] = {1, 1};
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_954->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40_1_41_up_40_1_41_954);
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_954->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_954->definitionLine = 2944;
// method "visitImplicit(_)up(_)"
  block_savedest(obj871);
  Object closure957 = createclosure(1, "visitImplicit(1)up(1)");
  setclosureframe(closure957, stackframe);
  addtoclosure(closure957, var_visitation);
  struct UserObject *uo957 = (struct UserObject*)obj871;
  uo957->data[29] = (Object)closure957;
  Method *meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_957 = addmethod2pos(obj871, "visitImplicit(1)up(1)", &meth_ast_visitImplicit_40_1_41_up_40_1_41_957, 29);
  int argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_957[] = {1, 1};
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_957->type = alloc_MethodType(2, argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_957);
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_957->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_957->definitionLine = 2945;
// method "asString"
  struct UserObject *uo960 = (struct UserObject*)obj871;
  uo960->data[30] = emptyclosure;
  Method *meth_meth_ast_asString960 = addmethod2pos(obj871, "asString", &meth_ast_asString960, 30);
  int argcv_meth_ast_asString960[] = {0};
  meth_meth_ast_asString960->type = alloc_MethodType(1, argcv_meth_ast_asString960);
  meth_meth_ast_asString960->definitionModule = modulename;
  meth_meth_ast_asString960->definitionLine = 2947;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  objclass871 = obj871->class;
  objclass871->definitionModule = modulename;
  objclass871->definitionLine = 2910;
  (*(struct UserObject *)self).data[0] = lowerouter871;
  self = oldself871;
  selfslot = oldselfslot871;
  stackframe = oldstackframe871;
  gc_frame_end(frame);
  return obj871;
}
Object meth_ast_pluggableVisitor_40_1_41_870_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method pluggableVisitor(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pluggableVisitor(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject871 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj871 = alloc_userobj2(30,31, objclass871);
  gc_frame_newslot(obj871);
if (objclass871 == NULL) {
  glfree(obj871->class->name);
  obj871->class->name = "pluggableVisitor(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj871, self, 0);
  addmethodreal(obj871,"outer", &reader_ast_outer_872);
  Object oldself871 = self;
  struct StackFrameObject *oldstackframe871 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe871);
  gc_frame_newslot((Object)stackframe);
  self = obj871;
  Object *oldselfslot871 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter871 = (*(struct UserObject *)self).data[0], lowerouter871 = thisouter871;
  if (inheritingObject871) {
    struct UserObject *inho871 = (struct UserObject *)inheritingObject871;
    while (inho871->super != GraceDefaultObject) inho871 = (struct UserObject *)inho871->super;
    inho871->super = obj871;
    self = inheritingObject871;
    *selfslot = self;
    lowerouter871 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter871;
  }
// method "visitIf(_)up(_)"
  block_savedest(obj871);
  Object closure873 = createclosure(1, "visitIf(1)up(1)");
  setclosureframe(closure873, stackframe);
  addtoclosure(closure873, var_visitation);
  struct UserObject *uo873 = (struct UserObject*)obj871;
  uo873->data[1] = (Object)closure873;
  Method *meth_meth_ast_visitIf_40_1_41_up_40_1_41_873 = addmethod2pos(obj871, "visitIf(1)up(1)", &meth_ast_visitIf_40_1_41_up_40_1_41_873, 1);
  int argcv_meth_ast_visitIf_40_1_41_up_40_1_41_873[] = {1, 1};
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_873->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40_1_41_up_40_1_41_873);
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_873->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_873->definitionLine = 2917;
// method "visitBlock(_)up(_)"
  block_savedest(obj871);
  Object closure876 = createclosure(1, "visitBlock(1)up(1)");
  setclosureframe(closure876, stackframe);
  addtoclosure(closure876, var_visitation);
  struct UserObject *uo876 = (struct UserObject*)obj871;
  uo876->data[2] = (Object)closure876;
  Method *meth_meth_ast_visitBlock_40_1_41_up_40_1_41_876 = addmethod2pos(obj871, "visitBlock(1)up(1)", &meth_ast_visitBlock_40_1_41_up_40_1_41_876, 2);
  int argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_876[] = {1, 1};
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_876->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_876);
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_876->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_876->definitionLine = 2918;
// method "visitMatchCase(_)up(_)"
  block_savedest(obj871);
  Object closure879 = createclosure(1, "visitMatchCase(1)up(1)");
  setclosureframe(closure879, stackframe);
  addtoclosure(closure879, var_visitation);
  struct UserObject *uo879 = (struct UserObject*)obj871;
  uo879->data[3] = (Object)closure879;
  Method *meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879 = addmethod2pos(obj871, "visitMatchCase(1)up(1)", &meth_ast_visitMatchCase_40_1_41_up_40_1_41_879, 3);
  int argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879[] = {1, 1};
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879);
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_879->definitionLine = 2919;
// method "visitTryCatch(_)up(_)"
  block_savedest(obj871);
  Object closure882 = createclosure(1, "visitTryCatch(1)up(1)");
  setclosureframe(closure882, stackframe);
  addtoclosure(closure882, var_visitation);
  struct UserObject *uo882 = (struct UserObject*)obj871;
  uo882->data[4] = (Object)closure882;
  Method *meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882 = addmethod2pos(obj871, "visitTryCatch(1)up(1)", &meth_ast_visitTryCatch_40_1_41_up_40_1_41_882, 4);
  int argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882[] = {1, 1};
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882);
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_882->definitionLine = 2920;
// method "visitMethodType(_)up(_)"
  block_savedest(obj871);
  Object closure885 = createclosure(1, "visitMethodType(1)up(1)");
  setclosureframe(closure885, stackframe);
  addtoclosure(closure885, var_visitation);
  struct UserObject *uo885 = (struct UserObject*)obj871;
  uo885->data[5] = (Object)closure885;
  Method *meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_885 = addmethod2pos(obj871, "visitMethodType(1)up(1)", &meth_ast_visitMethodType_40_1_41_up_40_1_41_885, 5);
  int argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_885[] = {1, 1};
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_885->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_885);
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_885->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_885->definitionLine = 2921;
// method "visitSignaturePart(_)up(_)"
  block_savedest(obj871);
  Object closure888 = createclosure(1, "visitSignaturePart(1)up(1)");
  setclosureframe(closure888, stackframe);
  addtoclosure(closure888, var_visitation);
  struct UserObject *uo888 = (struct UserObject*)obj871;
  uo888->data[6] = (Object)closure888;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888 = addmethod2pos(obj871, "visitSignaturePart(1)up(1)", &meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888, 6);
  int argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888);
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_888->definitionLine = 2922;
// method "visitTypeDec(_)up(_)"
  block_savedest(obj871);
  Object closure891 = createclosure(1, "visitTypeDec(1)up(1)");
  setclosureframe(closure891, stackframe);
  addtoclosure(closure891, var_visitation);
  struct UserObject *uo891 = (struct UserObject*)obj871;
  uo891->data[7] = (Object)closure891;
  Method *meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891 = addmethod2pos(obj871, "visitTypeDec(1)up(1)", &meth_ast_visitTypeDec_40_1_41_up_40_1_41_891, 7);
  int argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891[] = {1, 1};
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891);
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_891->definitionLine = 2923;
// method "visitTypeLiteral(_)up(_)"
  block_savedest(obj871);
  Object closure894 = createclosure(1, "visitTypeLiteral(1)up(1)");
  setclosureframe(closure894, stackframe);
  addtoclosure(closure894, var_visitation);
  struct UserObject *uo894 = (struct UserObject*)obj871;
  uo894->data[8] = (Object)closure894;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894 = addmethod2pos(obj871, "visitTypeLiteral(1)up(1)", &meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894, 8);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894);
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_894->definitionLine = 2924;
// method "visitMethod(_)up(_)"
  block_savedest(obj871);
  Object closure897 = createclosure(1, "visitMethod(1)up(1)");
  setclosureframe(closure897, stackframe);
  addtoclosure(closure897, var_visitation);
  struct UserObject *uo897 = (struct UserObject*)obj871;
  uo897->data[9] = (Object)closure897;
  Method *meth_meth_ast_visitMethod_40_1_41_up_40_1_41_897 = addmethod2pos(obj871, "visitMethod(1)up(1)", &meth_ast_visitMethod_40_1_41_up_40_1_41_897, 9);
  int argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_897[] = {1, 1};
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_897->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_897);
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_897->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_897->definitionLine = 2925;
// method "visitCall(_)up(_)"
  block_savedest(obj871);
  Object closure900 = createclosure(1, "visitCall(1)up(1)");
  setclosureframe(closure900, stackframe);
  addtoclosure(closure900, var_visitation);
  struct UserObject *uo900 = (struct UserObject*)obj871;
  uo900->data[10] = (Object)closure900;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_900 = addmethod2pos(obj871, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_900, 10);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_900[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_900->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_900);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_900->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_900->definitionLine = 2926;
// method "visitObject(_)up(_)"
  block_savedest(obj871);
  Object closure903 = createclosure(1, "visitObject(1)up(1)");
  setclosureframe(closure903, stackframe);
  addtoclosure(closure903, var_visitation);
  struct UserObject *uo903 = (struct UserObject*)obj871;
  uo903->data[11] = (Object)closure903;
  Method *meth_meth_ast_visitObject_40_1_41_up_40_1_41_903 = addmethod2pos(obj871, "visitObject(1)up(1)", &meth_ast_visitObject_40_1_41_up_40_1_41_903, 11);
  int argcv_meth_ast_visitObject_40_1_41_up_40_1_41_903[] = {1, 1};
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_903->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40_1_41_up_40_1_41_903);
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_903->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_903->definitionLine = 2927;
// method "visitModule(_)up(_)"
  block_savedest(obj871);
  Object closure906 = createclosure(1, "visitModule(1)up(1)");
  setclosureframe(closure906, stackframe);
  addtoclosure(closure906, var_visitation);
  struct UserObject *uo906 = (struct UserObject*)obj871;
  uo906->data[12] = (Object)closure906;
  Method *meth_meth_ast_visitModule_40_1_41_up_40_1_41_906 = addmethod2pos(obj871, "visitModule(1)up(1)", &meth_ast_visitModule_40_1_41_up_40_1_41_906, 12);
  int argcv_meth_ast_visitModule_40_1_41_up_40_1_41_906[] = {1, 1};
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_906->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40_1_41_up_40_1_41_906);
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_906->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_906->definitionLine = 2928;
// method "visitArray(_)up(_)"
  block_savedest(obj871);
  Object closure909 = createclosure(1, "visitArray(1)up(1)");
  setclosureframe(closure909, stackframe);
  addtoclosure(closure909, var_visitation);
  struct UserObject *uo909 = (struct UserObject*)obj871;
  uo909->data[13] = (Object)closure909;
  Method *meth_meth_ast_visitArray_40_1_41_up_40_1_41_909 = addmethod2pos(obj871, "visitArray(1)up(1)", &meth_ast_visitArray_40_1_41_up_40_1_41_909, 13);
  int argcv_meth_ast_visitArray_40_1_41_up_40_1_41_909[] = {1, 1};
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_909->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40_1_41_up_40_1_41_909);
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_909->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_909->definitionLine = 2929;
// method "visitMember(_)up(_)"
  block_savedest(obj871);
  Object closure912 = createclosure(1, "visitMember(1)up(1)");
  setclosureframe(closure912, stackframe);
  addtoclosure(closure912, var_visitation);
  struct UserObject *uo912 = (struct UserObject*)obj871;
  uo912->data[14] = (Object)closure912;
  Method *meth_meth_ast_visitMember_40_1_41_up_40_1_41_912 = addmethod2pos(obj871, "visitMember(1)up(1)", &meth_ast_visitMember_40_1_41_up_40_1_41_912, 14);
  int argcv_meth_ast_visitMember_40_1_41_up_40_1_41_912[] = {1, 1};
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_912->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40_1_41_up_40_1_41_912);
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_912->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_912->definitionLine = 2930;
// method "visitGeneric(_)up(_)"
  block_savedest(obj871);
  Object closure915 = createclosure(1, "visitGeneric(1)up(1)");
  setclosureframe(closure915, stackframe);
  addtoclosure(closure915, var_visitation);
  struct UserObject *uo915 = (struct UserObject*)obj871;
  uo915->data[15] = (Object)closure915;
  Method *meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_915 = addmethod2pos(obj871, "visitGeneric(1)up(1)", &meth_ast_visitGeneric_40_1_41_up_40_1_41_915, 15);
  int argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_915[] = {1, 1};
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_915->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_915);
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_915->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_915->definitionLine = 2931;
// method "visitIdentifier(_)up(_)"
  block_savedest(obj871);
  Object closure918 = createclosure(1, "visitIdentifier(1)up(1)");
  setclosureframe(closure918, stackframe);
  addtoclosure(closure918, var_visitation);
  struct UserObject *uo918 = (struct UserObject*)obj871;
  uo918->data[16] = (Object)closure918;
  Method *meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918 = addmethod2pos(obj871, "visitIdentifier(1)up(1)", &meth_ast_visitIdentifier_40_1_41_up_40_1_41_918, 16);
  int argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918[] = {1, 1};
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918);
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_918->definitionLine = 2932;
// method "visitString(_)up(_)"
  block_savedest(obj871);
  Object closure921 = createclosure(1, "visitString(1)up(1)");
  setclosureframe(closure921, stackframe);
  addtoclosure(closure921, var_visitation);
  struct UserObject *uo921 = (struct UserObject*)obj871;
  uo921->data[17] = (Object)closure921;
  Method *meth_meth_ast_visitString_40_1_41_up_40_1_41_921 = addmethod2pos(obj871, "visitString(1)up(1)", &meth_ast_visitString_40_1_41_up_40_1_41_921, 17);
  int argcv_meth_ast_visitString_40_1_41_up_40_1_41_921[] = {1, 1};
  meth_meth_ast_visitString_40_1_41_up_40_1_41_921->type = alloc_MethodType(2, argcv_meth_ast_visitString_40_1_41_up_40_1_41_921);
  meth_meth_ast_visitString_40_1_41_up_40_1_41_921->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_up_40_1_41_921->definitionLine = 2933;
// method "visitNum(_)up(_)"
  block_savedest(obj871);
  Object closure924 = createclosure(1, "visitNum(1)up(1)");
  setclosureframe(closure924, stackframe);
  addtoclosure(closure924, var_visitation);
  struct UserObject *uo924 = (struct UserObject*)obj871;
  uo924->data[18] = (Object)closure924;
  Method *meth_meth_ast_visitNum_40_1_41_up_40_1_41_924 = addmethod2pos(obj871, "visitNum(1)up(1)", &meth_ast_visitNum_40_1_41_up_40_1_41_924, 18);
  int argcv_meth_ast_visitNum_40_1_41_up_40_1_41_924[] = {1, 1};
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_924->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40_1_41_up_40_1_41_924);
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_924->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_924->definitionLine = 2934;
// method "visitOp(_)up(_)"
  block_savedest(obj871);
  Object closure927 = createclosure(1, "visitOp(1)up(1)");
  setclosureframe(closure927, stackframe);
  addtoclosure(closure927, var_visitation);
  struct UserObject *uo927 = (struct UserObject*)obj871;
  uo927->data[19] = (Object)closure927;
  Method *meth_meth_ast_visitOp_40_1_41_up_40_1_41_927 = addmethod2pos(obj871, "visitOp(1)up(1)", &meth_ast_visitOp_40_1_41_up_40_1_41_927, 19);
  int argcv_meth_ast_visitOp_40_1_41_up_40_1_41_927[] = {1, 1};
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_927->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40_1_41_up_40_1_41_927);
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_927->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_927->definitionLine = 2935;
// method "visitBind(_)up(_)"
  block_savedest(obj871);
  Object closure930 = createclosure(1, "visitBind(1)up(1)");
  setclosureframe(closure930, stackframe);
  addtoclosure(closure930, var_visitation);
  struct UserObject *uo930 = (struct UserObject*)obj871;
  uo930->data[20] = (Object)closure930;
  Method *meth_meth_ast_visitBind_40_1_41_up_40_1_41_930 = addmethod2pos(obj871, "visitBind(1)up(1)", &meth_ast_visitBind_40_1_41_up_40_1_41_930, 20);
  int argcv_meth_ast_visitBind_40_1_41_up_40_1_41_930[] = {1, 1};
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_930->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40_1_41_up_40_1_41_930);
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_930->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_930->definitionLine = 2936;
// method "visitDefDec(_)up(_)"
  block_savedest(obj871);
  Object closure933 = createclosure(1, "visitDefDec(1)up(1)");
  setclosureframe(closure933, stackframe);
  addtoclosure(closure933, var_visitation);
  struct UserObject *uo933 = (struct UserObject*)obj871;
  uo933->data[21] = (Object)closure933;
  Method *meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_933 = addmethod2pos(obj871, "visitDefDec(1)up(1)", &meth_ast_visitDefDec_40_1_41_up_40_1_41_933, 21);
  int argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_933[] = {1, 1};
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_933->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_933);
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_933->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_933->definitionLine = 2937;
// method "visitVarDec(_)up(_)"
  block_savedest(obj871);
  Object closure936 = createclosure(1, "visitVarDec(1)up(1)");
  setclosureframe(closure936, stackframe);
  addtoclosure(closure936, var_visitation);
  struct UserObject *uo936 = (struct UserObject*)obj871;
  uo936->data[22] = (Object)closure936;
  Method *meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_936 = addmethod2pos(obj871, "visitVarDec(1)up(1)", &meth_ast_visitVarDec_40_1_41_up_40_1_41_936, 22);
  int argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_936[] = {1, 1};
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_936->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_936);
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_936->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_936->definitionLine = 2938;
// method "visitImport(_)up(_)"
  block_savedest(obj871);
  Object closure939 = createclosure(1, "visitImport(1)up(1)");
  setclosureframe(closure939, stackframe);
  addtoclosure(closure939, var_visitation);
  struct UserObject *uo939 = (struct UserObject*)obj871;
  uo939->data[23] = (Object)closure939;
  Method *meth_meth_ast_visitImport_40_1_41_up_40_1_41_939 = addmethod2pos(obj871, "visitImport(1)up(1)", &meth_ast_visitImport_40_1_41_up_40_1_41_939, 23);
  int argcv_meth_ast_visitImport_40_1_41_up_40_1_41_939[] = {1, 1};
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_939->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40_1_41_up_40_1_41_939);
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_939->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_939->definitionLine = 2939;
// method "visitReturn(_)up(_)"
  block_savedest(obj871);
  Object closure942 = createclosure(1, "visitReturn(1)up(1)");
  setclosureframe(closure942, stackframe);
  addtoclosure(closure942, var_visitation);
  struct UserObject *uo942 = (struct UserObject*)obj871;
  uo942->data[24] = (Object)closure942;
  Method *meth_meth_ast_visitReturn_40_1_41_up_40_1_41_942 = addmethod2pos(obj871, "visitReturn(1)up(1)", &meth_ast_visitReturn_40_1_41_up_40_1_41_942, 24);
  int argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_942[] = {1, 1};
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_942->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_942);
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_942->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_942->definitionLine = 2940;
// method "visitInherits(_)up(_)"
  block_savedest(obj871);
  Object closure945 = createclosure(1, "visitInherits(1)up(1)");
  setclosureframe(closure945, stackframe);
  addtoclosure(closure945, var_visitation);
  struct UserObject *uo945 = (struct UserObject*)obj871;
  uo945->data[25] = (Object)closure945;
  Method *meth_meth_ast_visitInherits_40_1_41_up_40_1_41_945 = addmethod2pos(obj871, "visitInherits(1)up(1)", &meth_ast_visitInherits_40_1_41_up_40_1_41_945, 25);
  int argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_945[] = {1, 1};
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_945->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_945);
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_945->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_945->definitionLine = 2941;
// method "visitDialect(_)up(_)"
  block_savedest(obj871);
  Object closure948 = createclosure(1, "visitDialect(1)up(1)");
  setclosureframe(closure948, stackframe);
  addtoclosure(closure948, var_visitation);
  struct UserObject *uo948 = (struct UserObject*)obj871;
  uo948->data[26] = (Object)closure948;
  Method *meth_meth_ast_visitDialect_40_1_41_up_40_1_41_948 = addmethod2pos(obj871, "visitDialect(1)up(1)", &meth_ast_visitDialect_40_1_41_up_40_1_41_948, 26);
  int argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_948[] = {1, 1};
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_948->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_948);
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_948->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_948->definitionLine = 2942;
// method "visitBlank(_)up(_)"
  block_savedest(obj871);
  Object closure951 = createclosure(1, "visitBlank(1)up(1)");
  setclosureframe(closure951, stackframe);
  addtoclosure(closure951, var_visitation);
  struct UserObject *uo951 = (struct UserObject*)obj871;
  uo951->data[27] = (Object)closure951;
  Method *meth_meth_ast_visitBlank_40_1_41_up_40_1_41_951 = addmethod2pos(obj871, "visitBlank(1)up(1)", &meth_ast_visitBlank_40_1_41_up_40_1_41_951, 27);
  int argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_951[] = {1, 1};
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_951->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_951);
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_951->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_951->definitionLine = 2943;
// method "visitComment(_)up(_)"
  block_savedest(obj871);
  Object closure954 = createclosure(1, "visitComment(1)up(1)");
  setclosureframe(closure954, stackframe);
  addtoclosure(closure954, var_visitation);
  struct UserObject *uo954 = (struct UserObject*)obj871;
  uo954->data[28] = (Object)closure954;
  Method *meth_meth_ast_visitComment_40_1_41_up_40_1_41_954 = addmethod2pos(obj871, "visitComment(1)up(1)", &meth_ast_visitComment_40_1_41_up_40_1_41_954, 28);
  int argcv_meth_ast_visitComment_40_1_41_up_40_1_41_954[] = {1, 1};
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_954->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40_1_41_up_40_1_41_954);
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_954->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_954->definitionLine = 2944;
// method "visitImplicit(_)up(_)"
  block_savedest(obj871);
  Object closure957 = createclosure(1, "visitImplicit(1)up(1)");
  setclosureframe(closure957, stackframe);
  addtoclosure(closure957, var_visitation);
  struct UserObject *uo957 = (struct UserObject*)obj871;
  uo957->data[29] = (Object)closure957;
  Method *meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_957 = addmethod2pos(obj871, "visitImplicit(1)up(1)", &meth_ast_visitImplicit_40_1_41_up_40_1_41_957, 29);
  int argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_957[] = {1, 1};
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_957->type = alloc_MethodType(2, argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_957);
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_957->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_957->definitionLine = 2945;
// method "asString"
  struct UserObject *uo960 = (struct UserObject*)obj871;
  uo960->data[30] = emptyclosure;
  Method *meth_meth_ast_asString960 = addmethod2pos(obj871, "asString", &meth_ast_asString960, 30);
  int argcv_meth_ast_asString960[] = {0};
  meth_meth_ast_asString960->type = alloc_MethodType(1, argcv_meth_ast_asString960);
  meth_meth_ast_asString960->definitionModule = modulename;
  meth_meth_ast_asString960->definitionLine = 2947;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  sourceObject = obj871;
  objclass871 = obj871->class;
  objclass871->definitionModule = modulename;
  objclass871->definitionLine = 2910;
  (*(struct UserObject *)self).data[0] = lowerouter871;
  self = oldself871;
  selfslot = oldselfslot871;
  stackframe = oldstackframe871;
  gc_frame_end(frame);
  return obj871;
}
Object meth_ast__apply972(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_annName (depth = 8)
  int op_slot_right_973 = gc_frame_newslot(*var_annName);
// starting to compile member node (depth = 8)
  int callframe975 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ann (depth = 9)
  Object call976 = callmethodflags(*var_ann, "value", 0, partcv, params, 0);
  gc_frame_end(callframe975);
// compiled member node returning call976 (depth = 8)
  int op_slot_left_973 = gc_frame_newslot(call976);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult977 = callmethod(call976, "==(1)", 1, partcv, params);
// compiled op node returning opresult977 (depth = 7)
  gc_frame_end(frame);
  return opresult977;
}
Object meth_ast__apply_40_1_41_968(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block971 = alloc_Block(NULL, NULL, "ast", 2961);
  gc_frame_newslot(block971);
// method "_apply"
  block_savedest(block971);
  Object closure972 = createclosure(3, "_apply");
  setclosureframe(closure972, stackframe);
  addtoclosure(closure972, var_annName);
  addtoclosure(closure972, var_ann);
  addtoclosure(closure972, selfslot);
  struct UserObject *uo972 = (struct UserObject*)block971;
  uo972->data[0] = (Object)closure972;
  Method *meth_meth_ast__apply972 = addmethod2pos(block971, "_apply", &meth_ast__apply972, 0);
  int argcv_meth_ast__apply972[] = {0};
  meth_meth_ast__apply972->type = alloc_MethodType(1, argcv_meth_ast__apply972);
  meth_meth_ast__apply972->definitionModule = modulename;
  meth_meth_ast__apply972->definitionLine = 2969;
// compiled block node returning block971 (depth = 6)
  int op_slot_right_970 = gc_frame_newslot(block971);
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit981 == NULL) {
    strlit981 = alloc_String("identifier");
    gc_root(strlit981);
  }
// compiled string node returning strlit981 (depth = 7)
  int op_slot_right_980 = gc_frame_newslot(strlit981);
// starting to compile member node (depth = 7)
  int callframe983 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ann (depth = 8)
  Object call984 = callmethodflags(*var_ann, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe983);
// compiled member node returning call984 (depth = 7)
  int op_slot_left_980 = gc_frame_newslot(call984);
  params[0] = strlit981;
  partcv[0] = 1;
  Object opresult985 = callmethod(call984, "==(1)", 1, partcv, params);
// compiled op node returning opresult985 (depth = 6)
  int op_slot_left_970 = gc_frame_newslot(opresult985);
  params[0] = block971;
  partcv[0] = 1;
  Object opresult986 = callmethod(opresult985, "&&(1)", 1, partcv, params);
// compiled op node returning opresult986 (depth = 5)
  Object if969 = done;
  if (istrue(opresult986)) {
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile object node (depth = 6)
  Object inheritingObject987 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj987 = alloc_userobj2(1,2, objclass987);
  gc_frame_newslot(obj987);
// OBJECT OUTER DEC outer
  adddatum2(obj987, self, 0);
  addmethodreal(obj987,"outer", &reader_ast_outer_988);
  Object oldself987 = self;
  struct StackFrameObject *oldstackframe987 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe987);
  gc_frame_newslot((Object)stackframe);
  self = obj987;
  Object *oldselfslot987 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter987 = (*(struct UserObject *)self).data[0], lowerouter987 = thisouter987;
  if (inheritingObject987) {
    struct UserObject *inho987 = (struct UserObject *)inheritingObject987;
    while (inho987->super != GraceDefaultObject) inho987 = (struct UserObject *)inho987->super;
    inho987->super = obj987;
    self = inheritingObject987;
    *selfslot = self;
    lowerouter987 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter987;
  }
if (objclass987 == NULL) {
  Method *reader989 = addmethodrealflags(obj987, "value",&reader_ast_value_989, MFLAG_DEF);
  reader989->definitionModule = modulename;
  reader989->definitionLine = 2965;
}
adddatum2(obj987, alloc_Undefined(), 1);
  sourceObject = obj987;
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool990 = alloc_Boolean(1);
// compiled identifier node returning bool990 (depth = 7)
  struct UserObject *obj987_uo = (struct UserObject *)obj987;
  obj987_uo->super = bool990;
  sourceObject = obj987;
// Begin line 2965
  setline(2965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  adddatum2(obj987, *var_ann, 1);
  objclass987 = obj987->class;
  objclass987->definitionModule = modulename;
  objclass987->definitionLine = 2963;
  (*(struct UserObject *)self).data[0] = lowerouter987;
  self = oldself987;
  selfslot = oldselfslot987;
  stackframe = oldstackframe987;
// compiled object node returning obj987 (depth = 6)
  block_return(realself, obj987);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if969 = undefined;
  } else {
  }
// compiled if node returning if969 (depth = 4)
  gc_frame_end(frame);
  return if969;
}
Object meth_ast_findAnnotation_40_2_41_963(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findAnnotation(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findAnnotation(_,_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findAnnotation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part findAnnotation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe964 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe965 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  Object call966 = callmethodflags(*var_node, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe965);
// compiled member node returning call966 (depth = 3)
  gc_frame_newslot(call966);
// starting to compile block node (depth = 3)
  Object block967 = alloc_Block(NULL, NULL, "ast", 2960);
  gc_frame_newslot(block967);
// method "_apply(_)"
  block_savedest(block967);
  Object closure968 = createclosure(2, "_apply(1)");
  setclosureframe(closure968, stackframe);
  addtoclosure(closure968, var_annName);
  addtoclosure(closure968, selfslot);
  struct UserObject *uo968 = (struct UserObject*)block967;
  uo968->data[0] = (Object)closure968;
  Method *meth_meth_ast__apply_40_1_41_968 = addmethod2pos(block967, "_apply(1)", &meth_ast__apply_40_1_41_968, 0);
  int argcv_meth_ast__apply_40_1_41_968[] = {1};
  meth_meth_ast__apply_40_1_41_968->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_968);
  meth_meth_ast__apply_40_1_41_968->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_968->definitionLine = 2969;
// compiled block node returning block967 (depth = 3)
  gc_frame_newslot(block967);
// call case 5: prelude request
  params[0] = call966;
  params[1] = block967;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call992 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe964);
// compiled call node returning call992 (depth = 2)
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool993 = alloc_Boolean(0);
// compiled identifier node returning bool993 (depth = 2)
  gc_frame_end(frame);
  return bool993;
}
Object meth_ast_lineLength995(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lineLength");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lineLength (depth = 3)
  gc_frame_end(frame);
  return *var_lineLength;
}
Object meth_ast_uninitialized1001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uninitialized");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  gc_frame_end(frame);
  return *var_uninitialized;
}
Object meth_ast_isEmpty1007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1008 = alloc_Boolean(1);
// compiled identifier node returning bool1008 (depth = 3)
  gc_frame_end(frame);
  return bool1008;
}
Object meth_ast_asString1009(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1010 == NULL) {
    strlit1010 = alloc_String("ancestorChain ""\xe2""""\x96""""\xab""");
    gc_root(strlit1010);
  }
// compiled string node returning strlit1010 (depth = 3)
  gc_frame_end(frame);
  return strlit1010;
}
Object meth_ast_extend_40_1_41_1011(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1012 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1013 = gc_frame_new();
// call case 3: self.outer request
  Object call1014 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1013);
// compiled member node returning call1014 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1015 = callmethodflags(call1014, "cons(1)onto(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1012);
// compiled call node returning call1015 (depth = 3)
  gc_frame_end(frame);
  return call1015;
}
Object meth_ast_empty1004(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1005 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1005 = alloc_userobj2(3,4, objclass1005);
  gc_frame_newslot(obj1005);
if (objclass1005 == NULL) {
  glfree(obj1005->class->name);
  obj1005->class->name = "ancestorChain.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1005, self, 0);
  addmethodreal(obj1005,"outer", &reader_ast_outer_1006);
  Object oldself1005 = self;
  struct StackFrameObject *oldstackframe1005 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1005);
  gc_frame_newslot((Object)stackframe);
  self = obj1005;
  Object *oldselfslot1005 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1005 = (*(struct UserObject *)self).data[0], lowerouter1005 = thisouter1005;
  if (inheritingObject1005) {
    struct UserObject *inho1005 = (struct UserObject *)inheritingObject1005;
    while (inho1005->super != GraceDefaultObject) inho1005 = (struct UserObject *)inho1005->super;
    inho1005->super = obj1005;
    self = inheritingObject1005;
    *selfslot = self;
    lowerouter1005 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1005;
  }
// method "isEmpty"
  struct UserObject *uo1007 = (struct UserObject*)obj1005;
  uo1007->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty1007 = addmethod2pos(obj1005, "isEmpty", &meth_ast_isEmpty1007, 1);
  int argcv_meth_ast_isEmpty1007[] = {0};
  meth_meth_ast_isEmpty1007->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1007);
  meth_meth_ast_isEmpty1007->definitionModule = modulename;
  meth_meth_ast_isEmpty1007->definitionLine = 41;
// method "asString"
  struct UserObject *uo1009 = (struct UserObject*)obj1005;
  uo1009->data[2] = emptyclosure;
  Method *meth_meth_ast_asString1009 = addmethod2pos(obj1005, "asString", &meth_ast_asString1009, 2);
  int argcv_meth_ast_asString1009[] = {0};
  meth_meth_ast_asString1009->type = alloc_MethodType(1, argcv_meth_ast_asString1009);
  meth_meth_ast_asString1009->definitionModule = modulename;
  meth_meth_ast_asString1009->definitionLine = 42;
// method "extend(_)"
  struct UserObject *uo1011 = (struct UserObject*)obj1005;
  uo1011->data[3] = emptyclosure;
  Method *meth_meth_ast_extend_40_1_41_1011 = addmethod2pos(obj1005, "extend(1)", &meth_ast_extend_40_1_41_1011, 3);
  int argcv_meth_ast_extend_40_1_41_1011[] = {1};
  meth_meth_ast_extend_40_1_41_1011->type = alloc_MethodType(1, argcv_meth_ast_extend_40_1_41_1011);
  meth_meth_ast_extend_40_1_41_1011->definitionModule = modulename;
  meth_meth_ast_extend_40_1_41_1011->definitionLine = 43;
  sourceObject = obj1005;
  sourceObject = obj1005;
  sourceObject = obj1005;
  objclass1005 = obj1005->class;
  objclass1005->definitionModule = modulename;
  objclass1005->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter1005;
  self = oldself1005;
  selfslot = oldselfslot1005;
  stackframe = oldstackframe1005;
  gc_frame_end(frame);
  return obj1005;
}
Object meth_ast_empty1004_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1005 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1005 = alloc_userobj2(3,4, objclass1005);
  gc_frame_newslot(obj1005);
if (objclass1005 == NULL) {
  glfree(obj1005->class->name);
  obj1005->class->name = "ancestorChain.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1005, self, 0);
  addmethodreal(obj1005,"outer", &reader_ast_outer_1006);
  Object oldself1005 = self;
  struct StackFrameObject *oldstackframe1005 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1005);
  gc_frame_newslot((Object)stackframe);
  self = obj1005;
  Object *oldselfslot1005 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1005 = (*(struct UserObject *)self).data[0], lowerouter1005 = thisouter1005;
  if (inheritingObject1005) {
    struct UserObject *inho1005 = (struct UserObject *)inheritingObject1005;
    while (inho1005->super != GraceDefaultObject) inho1005 = (struct UserObject *)inho1005->super;
    inho1005->super = obj1005;
    self = inheritingObject1005;
    *selfslot = self;
    lowerouter1005 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1005;
  }
// method "isEmpty"
  struct UserObject *uo1007 = (struct UserObject*)obj1005;
  uo1007->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty1007 = addmethod2pos(obj1005, "isEmpty", &meth_ast_isEmpty1007, 1);
  int argcv_meth_ast_isEmpty1007[] = {0};
  meth_meth_ast_isEmpty1007->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1007);
  meth_meth_ast_isEmpty1007->definitionModule = modulename;
  meth_meth_ast_isEmpty1007->definitionLine = 41;
// method "asString"
  struct UserObject *uo1009 = (struct UserObject*)obj1005;
  uo1009->data[2] = emptyclosure;
  Method *meth_meth_ast_asString1009 = addmethod2pos(obj1005, "asString", &meth_ast_asString1009, 2);
  int argcv_meth_ast_asString1009[] = {0};
  meth_meth_ast_asString1009->type = alloc_MethodType(1, argcv_meth_ast_asString1009);
  meth_meth_ast_asString1009->definitionModule = modulename;
  meth_meth_ast_asString1009->definitionLine = 42;
// method "extend(_)"
  struct UserObject *uo1011 = (struct UserObject*)obj1005;
  uo1011->data[3] = emptyclosure;
  Method *meth_meth_ast_extend_40_1_41_1011 = addmethod2pos(obj1005, "extend(1)", &meth_ast_extend_40_1_41_1011, 3);
  int argcv_meth_ast_extend_40_1_41_1011[] = {1};
  meth_meth_ast_extend_40_1_41_1011->type = alloc_MethodType(1, argcv_meth_ast_extend_40_1_41_1011);
  meth_meth_ast_extend_40_1_41_1011->definitionModule = modulename;
  meth_meth_ast_extend_40_1_41_1011->definitionLine = 43;
  sourceObject = obj1005;
  sourceObject = obj1005;
  sourceObject = obj1005;
  objclass1005 = obj1005->class;
  objclass1005->definitionModule = modulename;
  objclass1005->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter1005;
  self = oldself1005;
  selfslot = oldselfslot1005;
  stackframe = oldstackframe1005;
  gc_frame_end(frame);
  return obj1005;
}
Object meth_ast_with_40_1_41_1017(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method with(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for with(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1018 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1019 = gc_frame_new();
// call case 4: self request
  Object call1020 = callmethodflags(self, "empty", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1019);
// compiled member node returning call1020 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1021 = callmethodflags(call1020, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1018);
// compiled call node returning call1021 (depth = 3)
  gc_frame_end(frame);
  return call1021;
}
Object meth_ast_forebears1025(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "forebears");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_as = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_end(frame);
  return *var_as;
}
Object meth_ast_isEmpty1026(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1027 = alloc_Boolean(0);
// compiled identifier node returning bool1027 (depth = 3)
  gc_frame_end(frame);
  return bool1027;
}
Object meth_ast_parent1028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_p (depth = 3)
  gc_frame_end(frame);
  return *var_p;
}
Object meth_ast_grandparent1029(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "grandparent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1030 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1031 = gc_frame_new();
// call case 4: self request
  Object call1032 = callmethodflags(self, "forebears", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1031);
// compiled member node returning call1032 (depth = 4)
  Object call1033 = callmethodflags(call1032, "parent", 0, partcv, params, 0);
  gc_frame_end(callframe1030);
// compiled member node returning call1033 (depth = 3)
  gc_frame_end(frame);
  return call1033;
}
Object meth_ast__apply1038(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe1039 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1040 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call1041 = callmethodflags(*var_a, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe1040);
// compiled member node returning call1041 (depth = 6)
  Object call1042 = callmethodflags(call1041, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1039);
// compiled member node returning call1042 (depth = 5)
  gc_frame_end(frame);
  return call1042;
}
Object meth_ast__apply1045(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1047 == NULL) {
    strlit1047 = alloc_String("""\xe2""""\x9e""""\xa4""");
    gc_root(strlit1047);
  }
// compiled string node returning strlit1047 (depth = 7)
  int op_slot_right_1046 = gc_frame_newslot(strlit1047);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  Object call1051 = callmethodflags(*var_a, "parent", 0, partcv, params, 0);
  gc_frame_end(callframe1050);
// compiled member node returning call1051 (depth = 8)
  int op_slot_right_1049 = gc_frame_newslot(call1051);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1049 = gc_frame_newslot(*var_s);
  params[0] = call1051;
  partcv[0] = 1;
  Object opresult1053 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1053 (depth = 7)
  int op_slot_left_1046 = gc_frame_newslot(opresult1053);
  params[0] = strlit1047;
  partcv[0] = 1;
  Object opresult1054 = callmethod(opresult1053, "++(1)", 1, partcv, params);
// compiled op node returning opresult1054 (depth = 6)
  *var_s = opresult1054;
  if (opresult1054 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1056 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call1057 = callmethodflags(*var_a, "forebears", 0, partcv, params, 0);
  gc_frame_end(callframe1056);
// compiled member node returning call1057 (depth = 6)
  *var_a = call1057;
  if (call1057 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString1034(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "a");
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  *var_a = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1035 == NULL) {
    strlit1035 = alloc_String("ancestorChain ");
    gc_root(strlit1035);
  }
// compiled string node returning strlit1035 (depth = 4)
  *var_s = strlit1035;
  if (strlit1035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1036 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1037 = alloc_Block(NULL, NULL, "ast", 55);
  gc_frame_newslot(block1037);
// method "_apply"
  block_savedest(block1037);
  Object closure1038 = createclosure(2, "_apply");
  setclosureframe(closure1038, stackframe);
  addtoclosure(closure1038, var_a);
  addtoclosure(closure1038, selfslot);
  struct UserObject *uo1038 = (struct UserObject*)block1037;
  uo1038->data[0] = (Object)closure1038;
  Method *meth_meth_ast__apply1038 = addmethod2pos(block1037, "_apply", &meth_ast__apply1038, 0);
  int argcv_meth_ast__apply1038[] = {0};
  meth_meth_ast__apply1038->type = alloc_MethodType(1, argcv_meth_ast__apply1038);
  meth_meth_ast__apply1038->definitionModule = modulename;
  meth_meth_ast__apply1038->definitionLine = 2969;
// compiled block node returning block1037 (depth = 4)
  gc_frame_newslot(block1037);
// starting to compile block node (depth = 4)
  Object block1044 = alloc_Block(NULL, NULL, "ast", 55);
  gc_frame_newslot(block1044);
// method "_apply"
  block_savedest(block1044);
  Object closure1045 = createclosure(3, "_apply");
  setclosureframe(closure1045, stackframe);
  addtoclosure(closure1045, var_a);
  addtoclosure(closure1045, var_s);
  addtoclosure(closure1045, selfslot);
  struct UserObject *uo1045 = (struct UserObject*)block1044;
  uo1045->data[0] = (Object)closure1045;
  Method *meth_meth_ast__apply1045 = addmethod2pos(block1044, "_apply", &meth_ast__apply1045, 0);
  int argcv_meth_ast__apply1045[] = {0};
  meth_meth_ast__apply1045->type = alloc_MethodType(1, argcv_meth_ast__apply1045);
  meth_meth_ast__apply1045->definitionModule = modulename;
  meth_meth_ast__apply1045->definitionLine = 2969;
// compiled block node returning block1044 (depth = 4)
  gc_frame_newslot(block1044);
// call case 5: prelude request
  params[0] = block1037;
  params[1] = block1044;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1060 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1036);
// compiled call node returning call1060 (depth = 3)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1062 == NULL) {
    strlit1062 = alloc_String("""\xe2""""\x96""""\xab""");
    gc_root(strlit1062);
  }
// compiled string node returning strlit1062 (depth = 4)
  int op_slot_right_1061 = gc_frame_newslot(strlit1062);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_1061 = gc_frame_newslot(*var_s);
  params[0] = strlit1062;
  partcv[0] = 1;
  Object opresult1064 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1064 (depth = 3)
  gc_frame_end(frame);
  return opresult1064;
}
Object meth_ast_extend_40_1_41_1065(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1066 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1067 = gc_frame_new();
// call case 3: self.outer request
  Object call1068 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1067);
// compiled member node returning call1068 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1069 = callmethodflags(call1068, "cons(1)onto(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1066);
// compiled call node returning call1069 (depth = 3)
  gc_frame_end(frame);
  return call1069;
}
Object meth_ast_cons_40_1_41_onto_40_1_41_1022(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons(1)onto(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons(_)onto(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons(_)onto(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons(_)onto(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part cons(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onto(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1023 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1023 = alloc_userobj2(6,7, objclass1023);
  gc_frame_newslot(obj1023);
if (objclass1023 == NULL) {
  glfree(obj1023->class->name);
  obj1023->class->name = "ancestorChain.cons(_)onto(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1023, self, 0);
  addmethodreal(obj1023,"outer", &reader_ast_outer_1024);
  Object oldself1023 = self;
  struct StackFrameObject *oldstackframe1023 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1023);
  gc_frame_newslot((Object)stackframe);
  self = obj1023;
  Object *oldselfslot1023 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1023 = (*(struct UserObject *)self).data[0], lowerouter1023 = thisouter1023;
  if (inheritingObject1023) {
    struct UserObject *inho1023 = (struct UserObject *)inheritingObject1023;
    while (inho1023->super != GraceDefaultObject) inho1023 = (struct UserObject *)inho1023->super;
    inho1023->super = obj1023;
    self = inheritingObject1023;
    *selfslot = self;
    lowerouter1023 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1023;
  }
// method "forebears"
  block_savedest(obj1023);
  Object closure1025 = createclosure(1, "forebears");
  setclosureframe(closure1025, stackframe);
  addtoclosure(closure1025, var_as);
  struct UserObject *uo1025 = (struct UserObject*)obj1023;
  uo1025->data[1] = (Object)closure1025;
  Method *meth_meth_ast_forebears1025 = addmethod2pos(obj1023, "forebears", &meth_ast_forebears1025, 1);
  int argcv_meth_ast_forebears1025[] = {0};
  meth_meth_ast_forebears1025->type = alloc_MethodType(1, argcv_meth_ast_forebears1025);
  meth_meth_ast_forebears1025->definitionModule = modulename;
  meth_meth_ast_forebears1025->definitionLine = 47;
// method "isEmpty"
  struct UserObject *uo1026 = (struct UserObject*)obj1023;
  uo1026->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty1026 = addmethod2pos(obj1023, "isEmpty", &meth_ast_isEmpty1026, 2);
  int argcv_meth_ast_isEmpty1026[] = {0};
  meth_meth_ast_isEmpty1026->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1026);
  meth_meth_ast_isEmpty1026->definitionModule = modulename;
  meth_meth_ast_isEmpty1026->definitionLine = 48;
// method "parent"
  block_savedest(obj1023);
  Object closure1028 = createclosure(1, "parent");
  setclosureframe(closure1028, stackframe);
  addtoclosure(closure1028, var_p);
  struct UserObject *uo1028 = (struct UserObject*)obj1023;
  uo1028->data[3] = (Object)closure1028;
  Method *meth_meth_ast_parent1028 = addmethod2pos(obj1023, "parent", &meth_ast_parent1028, 3);
  int argcv_meth_ast_parent1028[] = {0};
  meth_meth_ast_parent1028->type = alloc_MethodType(1, argcv_meth_ast_parent1028);
  meth_meth_ast_parent1028->definitionModule = modulename;
  meth_meth_ast_parent1028->definitionLine = 49;
// method "grandparent"
  struct UserObject *uo1029 = (struct UserObject*)obj1023;
  uo1029->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent1029 = addmethod2pos(obj1023, "grandparent", &meth_ast_grandparent1029, 4);
  int argcv_meth_ast_grandparent1029[] = {0};
  meth_meth_ast_grandparent1029->type = alloc_MethodType(1, argcv_meth_ast_grandparent1029);
  meth_meth_ast_grandparent1029->definitionModule = modulename;
  meth_meth_ast_grandparent1029->definitionLine = 50;
// method "asString"
  struct UserObject *uo1034 = (struct UserObject*)obj1023;
  uo1034->data[5] = emptyclosure;
  Method *meth_meth_ast_asString1034 = addmethod2pos(obj1023, "asString", &meth_ast_asString1034, 5);
  int argcv_meth_ast_asString1034[] = {0};
  meth_meth_ast_asString1034->type = alloc_MethodType(1, argcv_meth_ast_asString1034);
  meth_meth_ast_asString1034->definitionModule = modulename;
  meth_meth_ast_asString1034->definitionLine = 52;
// method "extend(_)"
  struct UserObject *uo1065 = (struct UserObject*)obj1023;
  uo1065->data[6] = emptyclosure;
  Method *meth_meth_ast_extend_40_1_41_1065 = addmethod2pos(obj1023, "extend(1)", &meth_ast_extend_40_1_41_1065, 6);
  int argcv_meth_ast_extend_40_1_41_1065[] = {1};
  meth_meth_ast_extend_40_1_41_1065->type = alloc_MethodType(1, argcv_meth_ast_extend_40_1_41_1065);
  meth_meth_ast_extend_40_1_41_1065->definitionModule = modulename;
  meth_meth_ast_extend_40_1_41_1065->definitionLine = 61;
  sourceObject = obj1023;
  sourceObject = obj1023;
  sourceObject = obj1023;
  sourceObject = obj1023;
  sourceObject = obj1023;
  sourceObject = obj1023;
  objclass1023 = obj1023->class;
  objclass1023->definitionModule = modulename;
  objclass1023->definitionLine = 46;
  (*(struct UserObject *)self).data[0] = lowerouter1023;
  self = oldself1023;
  selfslot = oldselfslot1023;
  stackframe = oldstackframe1023;
  gc_frame_end(frame);
  return obj1023;
}
Object meth_ast_cons_40_1_41_onto_40_1_41_1022_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons(1)onto(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method cons(_)onto(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method cons(_)onto(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons(_)onto(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part cons(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onto(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1023 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1023 = alloc_userobj2(6,7, objclass1023);
  gc_frame_newslot(obj1023);
if (objclass1023 == NULL) {
  glfree(obj1023->class->name);
  obj1023->class->name = "ancestorChain.cons(_)onto(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1023, self, 0);
  addmethodreal(obj1023,"outer", &reader_ast_outer_1024);
  Object oldself1023 = self;
  struct StackFrameObject *oldstackframe1023 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1023);
  gc_frame_newslot((Object)stackframe);
  self = obj1023;
  Object *oldselfslot1023 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1023 = (*(struct UserObject *)self).data[0], lowerouter1023 = thisouter1023;
  if (inheritingObject1023) {
    struct UserObject *inho1023 = (struct UserObject *)inheritingObject1023;
    while (inho1023->super != GraceDefaultObject) inho1023 = (struct UserObject *)inho1023->super;
    inho1023->super = obj1023;
    self = inheritingObject1023;
    *selfslot = self;
    lowerouter1023 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1023;
  }
// method "forebears"
  block_savedest(obj1023);
  Object closure1025 = createclosure(1, "forebears");
  setclosureframe(closure1025, stackframe);
  addtoclosure(closure1025, var_as);
  struct UserObject *uo1025 = (struct UserObject*)obj1023;
  uo1025->data[1] = (Object)closure1025;
  Method *meth_meth_ast_forebears1025 = addmethod2pos(obj1023, "forebears", &meth_ast_forebears1025, 1);
  int argcv_meth_ast_forebears1025[] = {0};
  meth_meth_ast_forebears1025->type = alloc_MethodType(1, argcv_meth_ast_forebears1025);
  meth_meth_ast_forebears1025->definitionModule = modulename;
  meth_meth_ast_forebears1025->definitionLine = 47;
// method "isEmpty"
  struct UserObject *uo1026 = (struct UserObject*)obj1023;
  uo1026->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty1026 = addmethod2pos(obj1023, "isEmpty", &meth_ast_isEmpty1026, 2);
  int argcv_meth_ast_isEmpty1026[] = {0};
  meth_meth_ast_isEmpty1026->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1026);
  meth_meth_ast_isEmpty1026->definitionModule = modulename;
  meth_meth_ast_isEmpty1026->definitionLine = 48;
// method "parent"
  block_savedest(obj1023);
  Object closure1028 = createclosure(1, "parent");
  setclosureframe(closure1028, stackframe);
  addtoclosure(closure1028, var_p);
  struct UserObject *uo1028 = (struct UserObject*)obj1023;
  uo1028->data[3] = (Object)closure1028;
  Method *meth_meth_ast_parent1028 = addmethod2pos(obj1023, "parent", &meth_ast_parent1028, 3);
  int argcv_meth_ast_parent1028[] = {0};
  meth_meth_ast_parent1028->type = alloc_MethodType(1, argcv_meth_ast_parent1028);
  meth_meth_ast_parent1028->definitionModule = modulename;
  meth_meth_ast_parent1028->definitionLine = 49;
// method "grandparent"
  struct UserObject *uo1029 = (struct UserObject*)obj1023;
  uo1029->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent1029 = addmethod2pos(obj1023, "grandparent", &meth_ast_grandparent1029, 4);
  int argcv_meth_ast_grandparent1029[] = {0};
  meth_meth_ast_grandparent1029->type = alloc_MethodType(1, argcv_meth_ast_grandparent1029);
  meth_meth_ast_grandparent1029->definitionModule = modulename;
  meth_meth_ast_grandparent1029->definitionLine = 50;
// method "asString"
  struct UserObject *uo1034 = (struct UserObject*)obj1023;
  uo1034->data[5] = emptyclosure;
  Method *meth_meth_ast_asString1034 = addmethod2pos(obj1023, "asString", &meth_ast_asString1034, 5);
  int argcv_meth_ast_asString1034[] = {0};
  meth_meth_ast_asString1034->type = alloc_MethodType(1, argcv_meth_ast_asString1034);
  meth_meth_ast_asString1034->definitionModule = modulename;
  meth_meth_ast_asString1034->definitionLine = 52;
// method "extend(_)"
  struct UserObject *uo1065 = (struct UserObject*)obj1023;
  uo1065->data[6] = emptyclosure;
  Method *meth_meth_ast_extend_40_1_41_1065 = addmethod2pos(obj1023, "extend(1)", &meth_ast_extend_40_1_41_1065, 6);
  int argcv_meth_ast_extend_40_1_41_1065[] = {1};
  meth_meth_ast_extend_40_1_41_1065->type = alloc_MethodType(1, argcv_meth_ast_extend_40_1_41_1065);
  meth_meth_ast_extend_40_1_41_1065->definitionModule = modulename;
  meth_meth_ast_extend_40_1_41_1065->definitionLine = 61;
  sourceObject = obj1023;
  sourceObject = obj1023;
  sourceObject = obj1023;
  sourceObject = obj1023;
  sourceObject = obj1023;
  sourceObject = obj1023;
  objclass1023 = obj1023->class;
  objclass1023->definitionModule = modulename;
  objclass1023->definitionLine = 46;
  (*(struct UserObject *)self).data[0] = lowerouter1023;
  self = oldself1023;
  selfslot = oldselfslot1023;
  stackframe = oldstackframe1023;
  gc_frame_end(frame);
  return obj1023;
}
Object meth_ast_ancestorChain1071(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ancestorChain");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ancestorChain (depth = 3)
  gc_frame_end(frame);
  return *var_ancestorChain;
}
Object meth_ast_emptySeq1074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySeq");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_AstNode1077(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AstNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AstNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AstNode (depth = 3)
  gc_frame_end(frame);
  return *var_AstNode;
}
Object meth_ast_SymbolTable1079(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_SymbolTable;
}
Object meth_ast_isImplicit1084(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImplicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1085 = alloc_Boolean(1);
// compiled identifier node returning bool1085 (depth = 3)
  gc_frame_end(frame);
  return bool1085;
}
Object meth_ast_toGrace_40_1_41_1086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1087 == NULL) {
    strlit1087 = alloc_String("implicit");
    gc_root(strlit1087);
  }
// compiled string node returning strlit1087 (depth = 3)
  gc_frame_end(frame);
  return strlit1087;
}
Object meth_ast_asString1088(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1089 == NULL) {
    strlit1089 = alloc_String("the implicit receiver");
    gc_root(strlit1089);
  }
// compiled string node returning strlit1089 (depth = 3)
  gc_frame_end(frame);
  return strlit1089;
}
Object meth_ast__61__61__40_1_41_1090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1091 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1092 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1091);
// compiled call node returning call1092 (depth = 3)
  gc_frame_end(frame);
  return call1092;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_1093(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_accept_40_1_41_from_40_1_41_1094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1095 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1096 = callmethodflags(*var_visitor, "visitImplicit(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1095);
// compiled call node returning call1096 (depth = 3)
  gc_frame_end(frame);
  return call1096;
}
Object meth_ast_pretty_40_1_41_1097(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1098 == NULL) {
    strlit1098 = alloc_String("implicit");
    gc_root(strlit1098);
  }
// compiled string node returning strlit1098 (depth = 3)
  gc_frame_end(frame);
  return strlit1098;
}
Object meth_ast_implicit1111(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "implicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_implicit = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_implicit (depth = 3)
  gc_frame_end(frame);
  return *var_implicit;
}
Object meth_ast_toGrace_40_1_41_1115(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1116 == NULL) {
    strlit1116 = alloc_String("// null");
    gc_root(strlit1116);
  }
// compiled string node returning strlit1116 (depth = 3)
  gc_frame_end(frame);
  return strlit1116;
}
Object meth_ast_asString1117(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1118 == NULL) {
    strlit1118 = alloc_String("the nullNode");
    gc_root(strlit1118);
  }
// compiled string node returning strlit1118 (depth = 3)
  gc_frame_end(frame);
  return strlit1118;
}
Object meth_ast__61__61__40_1_41_1119(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1120 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1121 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1120);
// compiled call node returning call1121 (depth = 3)
  gc_frame_end(frame);
  return call1121;
}
Object meth_ast_nullNode1127(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nullNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  gc_frame_end(frame);
  return *var_nullNode;
}
Object meth_ast_asString1131(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1132 == NULL) {
    strlit1132 = alloc_String("the fakeSymbolTable");
    gc_root(strlit1132);
  }
// compiled string node returning strlit1132 (depth = 3)
  gc_frame_end(frame);
  return strlit1132;
}
Object meth_ast_addNode_40_1_41_as_40_1_41_1133(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addNode(1)as(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode(_)as(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode(_)as(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addNode(_)as(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addNode(_)");
  Object *var_kind = &(stackframe->slots[1]);
  *var_kind = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part as(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1134 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1136 == NULL) {
    strlit1136 = alloc_String("""\x22"" requested");
    gc_root(strlit1136);
  }
// compiled string node returning strlit1136 (depth = 5)
  int op_slot_right_1135 = gc_frame_newslot(strlit1136);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_kind (depth = 6)
  int op_slot_right_1138 = gc_frame_newslot(*var_kind);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1141 == NULL) {
    strlit1141 = alloc_String(") as ""\x22""");
    gc_root(strlit1141);
  }
// compiled string node returning strlit1141 (depth = 7)
  int op_slot_right_1140 = gc_frame_newslot(strlit1141);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1143 = gc_frame_newslot(*var_n);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1146 == NULL) {
    strlit1146 = alloc_String(").addNode(");
    gc_root(strlit1146);
  }
// compiled string node returning strlit1146 (depth = 9)
  int op_slot_right_1145 = gc_frame_newslot(strlit1146);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1149 = gc_frame_new();
// call case 4: self request
  Object call1150 = callmethodflags(self, "node", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1149);
// compiled member node returning call1150 (depth = 10)
  int op_slot_right_1148 = gc_frame_newslot(call1150);
// starting to compile string node (depth = 10)
  if (strlit1152 == NULL) {
    strlit1152 = alloc_String("fakeSymbolTable(on node ");
    gc_root(strlit1152);
  }
// compiled string node returning strlit1152 (depth = 10)
  int op_slot_left_1148 = gc_frame_newslot(strlit1152);
  params[0] = call1150;
  partcv[0] = 1;
  Object opresult1153 = callmethod(strlit1152, "++(1)", 1, partcv, params);
// compiled op node returning opresult1153 (depth = 9)
  int op_slot_left_1145 = gc_frame_newslot(opresult1153);
  params[0] = strlit1146;
  partcv[0] = 1;
  Object opresult1154 = callmethod(opresult1153, "++(1)", 1, partcv, params);
// compiled op node returning opresult1154 (depth = 8)
  int op_slot_left_1143 = gc_frame_newslot(opresult1154);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1155 = callmethod(opresult1154, "++(1)", 1, partcv, params);
// compiled op node returning opresult1155 (depth = 7)
  int op_slot_left_1140 = gc_frame_newslot(opresult1155);
  params[0] = strlit1141;
  partcv[0] = 1;
  Object opresult1156 = callmethod(opresult1155, "++(1)", 1, partcv, params);
// compiled op node returning opresult1156 (depth = 6)
  int op_slot_left_1138 = gc_frame_newslot(opresult1156);
  params[0] = *var_kind;
  partcv[0] = 1;
  Object opresult1157 = callmethod(opresult1156, "++(1)", 1, partcv, params);
// compiled op node returning opresult1157 (depth = 5)
  int op_slot_left_1135 = gc_frame_newslot(opresult1157);
  params[0] = strlit1136;
  partcv[0] = 1;
  Object opresult1158 = callmethod(opresult1157, "++(1)", 1, partcv, params);
// compiled op node returning opresult1158 (depth = 4)
  gc_frame_newslot(opresult1158);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1159 = gc_frame_new();
// call case 5: prelude request
  Object call1160 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1159);
// compiled member node returning call1160 (depth = 4)
  params[0] = opresult1158;
  partcv[0] = 1;
  Object call1161 = callmethodflags(call1160, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1134);
// compiled call node returning call1161 (depth = 3)
  gc_frame_end(frame);
  return call1161;
}
Object meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "thatDefines(1)ifNone(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines(_)ifNone(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines(_)ifNone(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for thatDefines(_)ifNone(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part thatDefines(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifNone(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1163 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1165 == NULL) {
    strlit1165 = alloc_String(").");
    gc_root(strlit1165);
  }
// compiled string node returning strlit1165 (depth = 5)
  int op_slot_right_1164 = gc_frame_newslot(strlit1165);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_name (depth = 6)
  int op_slot_right_1167 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 6)
  if (strlit1169 == NULL) {
    strlit1169 = alloc_String("fakeSymbolTable.thatDefines(");
    gc_root(strlit1169);
  }
// compiled string node returning strlit1169 (depth = 6)
  int op_slot_left_1167 = gc_frame_newslot(strlit1169);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult1170 = callmethod(strlit1169, "++(1)", 1, partcv, params);
// compiled op node returning opresult1170 (depth = 5)
  int op_slot_left_1164 = gc_frame_newslot(opresult1170);
  params[0] = strlit1165;
  partcv[0] = 1;
  Object opresult1171 = callmethod(opresult1170, "++(1)", 1, partcv, params);
// compiled op node returning opresult1171 (depth = 4)
  gc_frame_newslot(opresult1171);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1172 = gc_frame_new();
// call case 5: prelude request
  Object call1173 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1172);
// compiled member node returning call1173 (depth = 4)
  params[0] = opresult1171;
  partcv[0] = 1;
  Object call1174 = callmethodflags(call1173, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1163);
// compiled call node returning call1174 (depth = 3)
  gc_frame_end(frame);
  return call1174;
}
Object meth_ast_enclosingObjectScope1175(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1176 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1178 == NULL) {
    strlit1178 = alloc_String("");
    gc_root(strlit1178);
  }
// compiled string node returning strlit1178 (depth = 5)
  int op_slot_right_1177 = gc_frame_newslot(strlit1178);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1181 = gc_frame_new();
// call case 4: self request
  Object call1182 = callmethodflags(self, "node", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1181);
// compiled member node returning call1182 (depth = 6)
  int op_slot_right_1180 = gc_frame_newslot(call1182);
// starting to compile string node (depth = 6)
  if (strlit1184 == NULL) {
    strlit1184 = alloc_String("fakeSymbolTable.enclosingObjectScope on node ");
    gc_root(strlit1184);
  }
// compiled string node returning strlit1184 (depth = 6)
  int op_slot_left_1180 = gc_frame_newslot(strlit1184);
  params[0] = call1182;
  partcv[0] = 1;
  Object opresult1185 = callmethod(strlit1184, "++(1)", 1, partcv, params);
// compiled op node returning opresult1185 (depth = 5)
  int op_slot_left_1177 = gc_frame_newslot(opresult1185);
  params[0] = strlit1178;
  partcv[0] = 1;
  Object opresult1186 = callmethod(opresult1185, "++(1)", 1, partcv, params);
// compiled op node returning opresult1186 (depth = 4)
  gc_frame_newslot(opresult1186);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1187 = gc_frame_new();
// call case 5: prelude request
  Object call1188 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1187);
// compiled member node returning call1188 (depth = 4)
  params[0] = opresult1186;
  partcv[0] = 1;
  Object call1189 = callmethodflags(call1188, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1176);
// compiled call node returning call1189 (depth = 3)
  gc_frame_end(frame);
  return call1189;
}
Object meth_ast_variety1190(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "variety");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1191 == NULL) {
    strlit1191 = alloc_String("fake");
    gc_root(strlit1191);
  }
// compiled string node returning strlit1191 (depth = 3)
  gc_frame_end(frame);
  return strlit1191;
}
Object meth_ast__61__61__40_1_41_1192(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1193 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1194 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1193);
// compiled call node returning call1194 (depth = 3)
  gc_frame_end(frame);
  return call1194;
}
Object meth_ast_fakeSymbolTable1195(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fakeSymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_fakeSymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_fakeSymbolTable;
}
Object meth_ast_isSimple1206(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1207 = alloc_Boolean(0);
// compiled identifier node returning bool1207 (depth = 3)
  gc_frame_end(frame);
  return bool1207;
}
Object meth_ast_accept_40_1_41_from_40_1_41_1208(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1210 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1211 = callmethodflags(*var_visitor, "visitIf(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1210);
// compiled call node returning call1211 (depth = 4)
  Object if1209 = done;
  if (istrue(call1211)) {
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1212 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1213 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1212);
// compiled call node returning call1213 (depth = 5)
  *var_newChain = call1213;
  if (call1213 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1214 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1215 = gc_frame_new();
// call case 4: self request
  Object call1216 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1215);
// compiled member node returning call1216 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1217 = callmethodflags(call1216, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1214);
// compiled call node returning call1217 (depth = 4)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1218 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1219 = gc_frame_new();
// call case 4: self request
  Object call1220 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1219);
// compiled member node returning call1220 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1221 = callmethodflags(call1220, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1218);
// compiled call node returning call1221 (depth = 4)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1222 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1223 = gc_frame_new();
// call case 4: self request
  Object call1224 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1223);
// compiled member node returning call1224 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1225 = callmethodflags(call1224, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1222);
// compiled call node returning call1225 (depth = 4)
    gc_frame_newslot(call1225);
    if1209 = call1225;
  } else {
  }
// compiled if node returning if1209 (depth = 3)
  gc_frame_end(frame);
  return if1209;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_1226(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1227 = gc_frame_new();
// call case 4: self request
  Object call1228 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1227);
// compiled member node returning call1228 (depth = 4)
  *var_n = call1228;
  if (call1228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1229 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1230 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1229);
// compiled call node returning call1230 (depth = 4)
  *var_newChain = call1230;
  if (call1230 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1231 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1232 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1233 = gc_frame_new();
// call case 4: self request
  Object call1234 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1233);
// compiled member node returning call1234 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1235 = callmethodflags(call1234, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1232);
// compiled call node returning call1235 (depth = 4)
  gc_frame_newslot(call1235);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1235;
  partcv[0] = 1;
  Object call1236 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1231);
// compiled call node returning call1236 (depth = 3)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1237 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1238 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1239 = gc_frame_new();
// call case 4: self request
  Object call1240 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1239);
// compiled member node returning call1240 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1241 = callmethodflags(call1240, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1238);
// compiled call node returning call1241 (depth = 4)
  gc_frame_newslot(call1241);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1241;
  partcv[0] = 1;
  Object call1242 = callmethodflags(*var_n, "thenblock:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1237);
// compiled call node returning call1242 (depth = 3)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1243 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1244 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1245 = gc_frame_new();
// call case 4: self request
  Object call1246 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1245);
// compiled member node returning call1246 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1247 = callmethodflags(call1246, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1244);
// compiled call node returning call1247 (depth = 4)
  gc_frame_newslot(call1247);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1247;
  partcv[0] = 1;
  Object call1248 = callmethodflags(*var_n, "elseblock:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1243);
// compiled call node returning call1248 (depth = 3)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1249 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1250 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1249);
// compiled call node returning call1250 (depth = 3)
  gc_frame_end(frame);
  return call1250;
}
Object meth_ast__apply_40_1_41_1259(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1261 == NULL) {
    strlit1261 = alloc_String("  ");
    gc_root(strlit1261);
  }
// compiled string node returning strlit1261 (depth = 7)
  int op_slot_right_1260 = gc_frame_newslot(strlit1261);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1260 = gc_frame_newslot(*var_spc);
  params[0] = strlit1261;
  partcv[0] = 1;
  Object opresult1263 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult1263 (depth = 6)
  *var_spc = opresult1263;
  if (opresult1263 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1360(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1362 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1364 = alloc_Float64(2);
// compiled num node returning num1364 (depth = 10)
  int op_slot_right_1363 = gc_frame_newslot(num1364);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1363 = gc_frame_newslot(*var_depth);
  params[0] = num1364;
  partcv[0] = 1;
  Object sum1366 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1366 (depth = 9)
  gc_frame_newslot(sum1366);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1366;
  partcv[0] = 1;
  Object call1367 = callmethodflags(*var_ix, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1362);
// compiled call node returning call1367 (depth = 8)
  int op_slot_right_1361 = gc_frame_newslot(call1367);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1369 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1372 == NULL) {
    strlit1372 = alloc_String("""\x0a""  ");
    gc_root(strlit1372);
  }
// compiled string node returning strlit1372 (depth = 10)
  int op_slot_right_1371 = gc_frame_newslot(strlit1372);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1371 = gc_frame_newslot(*var_s);
  params[0] = strlit1372;
  partcv[0] = 1;
  Object opresult1374 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1374 (depth = 9)
  int op_slot_left_1369 = gc_frame_newslot(opresult1374);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1375 = callmethod(opresult1374, "++(1)", 1, partcv, params);
// compiled op node returning opresult1375 (depth = 8)
  int op_slot_left_1361 = gc_frame_newslot(opresult1375);
  params[0] = call1367;
  partcv[0] = 1;
  Object opresult1376 = callmethod(opresult1375, "++(1)", 1, partcv, params);
// compiled op node returning opresult1376 (depth = 7)
  *var_s = opresult1376;
  if (opresult1376 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1399(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1401 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1403 = alloc_Float64(2);
// compiled num node returning num1403 (depth = 10)
  int op_slot_right_1402 = gc_frame_newslot(num1403);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1402 = gc_frame_newslot(*var_depth);
  params[0] = num1403;
  partcv[0] = 1;
  Object sum1405 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1405 (depth = 9)
  gc_frame_newslot(sum1405);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1405;
  partcv[0] = 1;
  Object call1406 = callmethodflags(*var_ix, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1401);
// compiled call node returning call1406 (depth = 8)
  int op_slot_right_1400 = gc_frame_newslot(call1406);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1408 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1411 == NULL) {
    strlit1411 = alloc_String("""\x0a""  ");
    gc_root(strlit1411);
  }
// compiled string node returning strlit1411 (depth = 10)
  int op_slot_right_1410 = gc_frame_newslot(strlit1411);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1410 = gc_frame_newslot(*var_s);
  params[0] = strlit1411;
  partcv[0] = 1;
  Object opresult1413 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1413 (depth = 9)
  int op_slot_left_1408 = gc_frame_newslot(opresult1413);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1414 = callmethod(opresult1413, "++(1)", 1, partcv, params);
// compiled op node returning opresult1414 (depth = 8)
  int op_slot_left_1400 = gc_frame_newslot(opresult1414);
  params[0] = call1406;
  partcv[0] = 1;
  Object opresult1415 = callmethod(opresult1414, "++(1)", 1, partcv, params);
// compiled op node returning opresult1415 (depth = 7)
  *var_s = opresult1415;
  if (opresult1415 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_1251(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1252 == NULL) {
    strlit1252 = alloc_String("");
    gc_root(strlit1252);
  }
// compiled string node returning strlit1252 (depth = 4)
  *var_spc = strlit1252;
  if (strlit1252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1253 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1254 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num1256 = alloc_Float64(0);
// compiled num node returning num1256 (depth = 5)
  int op_slot_left_1254 = gc_frame_newslot(num1256);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1257 = callmethod(num1256, "..(1)", 1, partcv, params);
// compiled op node returning opresult1257 (depth = 4)
  gc_frame_newslot(opresult1257);
// starting to compile block node (depth = 4)
  Object block1258 = alloc_Block(NULL, NULL, "ast", 275);
  gc_frame_newslot(block1258);
// method "_apply(_)"
  block_savedest(block1258);
  Object closure1259 = createclosure(2, "_apply(1)");
  setclosureframe(closure1259, stackframe);
  addtoclosure(closure1259, var_spc);
  addtoclosure(closure1259, selfslot);
  struct UserObject *uo1259 = (struct UserObject*)block1258;
  uo1259->data[0] = (Object)closure1259;
  Method *meth_meth_ast__apply_40_1_41_1259 = addmethod2pos(block1258, "_apply(1)", &meth_ast__apply_40_1_41_1259, 0);
  int argcv_meth_ast__apply_40_1_41_1259[] = {1};
  meth_meth_ast__apply_40_1_41_1259->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1259);
  meth_meth_ast__apply_40_1_41_1259->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1259->definitionLine = 2969;
// compiled block node returning block1258 (depth = 4)
  gc_frame_newslot(block1258);
// call case 5: prelude request
  params[0] = opresult1257;
  params[1] = block1258;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1266 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1253);
// compiled call node returning call1266 (depth = 3)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1268 == NULL) {
    strlit1268 = alloc_String("""\x0a""");
    gc_root(strlit1268);
  }
// compiled string node returning strlit1268 (depth = 5)
  int op_slot_right_1267 = gc_frame_newslot(strlit1268);
// starting to compile call node (depth = 5)
  int callframe1270 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1271 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1270);
// compiled call node returning call1271 (depth = 5)
  int op_slot_left_1267 = gc_frame_newslot(call1271);
  params[0] = strlit1268;
  partcv[0] = 1;
  Object opresult1272 = callmethod(call1271, "++(1)", 1, partcv, params);
// compiled op node returning opresult1272 (depth = 4)
  *var_s = opresult1272;
  if (opresult1272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1274 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1276 = alloc_Float64(1);
// compiled num node returning num1276 (depth = 7)
  int op_slot_right_1275 = gc_frame_newslot(num1276);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1275 = gc_frame_newslot(*var_depth);
  params[0] = num1276;
  partcv[0] = 1;
  Object sum1278 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1278 (depth = 6)
  gc_frame_newslot(sum1278);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1279 = gc_frame_new();
// call case 4: self request
  Object call1280 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1279);
// compiled member node returning call1280 (depth = 6)
  params[0] = sum1278;
  partcv[0] = 1;
  Object call1281 = callmethodflags(call1280, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1274);
// compiled call node returning call1281 (depth = 5)
  int op_slot_right_1273 = gc_frame_newslot(call1281);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1283 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1283 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1285 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1285 (depth = 5)
  int op_slot_left_1273 = gc_frame_newslot(opresult1285);
  params[0] = call1281;
  partcv[0] = 1;
  Object opresult1286 = callmethod(opresult1285, "++(1)", 1, partcv, params);
// compiled op node returning opresult1286 (depth = 4)
  *var_s = opresult1286;
  if (opresult1286 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1289 == NULL) {
    strlit1289 = alloc_String("""\x0a""");
    gc_root(strlit1289);
  }
// compiled string node returning strlit1289 (depth = 5)
  int op_slot_right_1288 = gc_frame_newslot(strlit1289);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1288 = gc_frame_newslot(*var_s);
  params[0] = strlit1289;
  partcv[0] = 1;
  Object opresult1291 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1291 (depth = 4)
  *var_s = opresult1291;
  if (opresult1291 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1295 == NULL) {
    strlit1295 = alloc_String("symbols");
    gc_root(strlit1295);
  }
// compiled string node returning strlit1295 (depth = 5)
  int op_slot_right_1294 = gc_frame_newslot(strlit1295);
// starting to compile member node (depth = 5)
  int callframe1297 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  Object call1298 = callmethodflags(*var_util, "target", 0, partcv, params, 0);
  gc_frame_end(callframe1297);
// compiled member node returning call1298 (depth = 5)
  int op_slot_left_1294 = gc_frame_newslot(call1298);
  params[0] = strlit1295;
  partcv[0] = 1;
  Object opresult1299 = callmethod(call1298, "==(1)", 1, partcv, params);
// compiled op node returning opresult1299 (depth = 4)
  Object if1293 = done;
  if (istrue(opresult1299)) {
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1302 == NULL) {
    strlit1302 = alloc_String("""\x0a""");
    gc_root(strlit1302);
  }
// compiled string node returning strlit1302 (depth = 7)
  int op_slot_right_1301 = gc_frame_newslot(strlit1302);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1305 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1307 = alloc_Float64(2);
// compiled num node returning num1307 (depth = 10)
  int op_slot_right_1306 = gc_frame_newslot(num1307);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1306 = gc_frame_newslot(*var_depth);
  params[0] = num1307;
  partcv[0] = 1;
  Object sum1309 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1309 (depth = 9)
  gc_frame_newslot(sum1309);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1310 = gc_frame_new();
// call case 4: self request
  Object call1311 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1310);
// compiled member node returning call1311 (depth = 9)
  params[0] = sum1309;
  partcv[0] = 1;
  Object call1312 = callmethodflags(call1311, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1305);
// compiled call node returning call1312 (depth = 8)
  int op_slot_right_1304 = gc_frame_newslot(call1312);
// starting to compile string node (depth = 8)
  if (strlit1314 == NULL) {
    strlit1314 = alloc_String("Then: ");
    gc_root(strlit1314);
  }
// compiled string node returning strlit1314 (depth = 8)
  int op_slot_left_1304 = gc_frame_newslot(strlit1314);
  params[0] = call1312;
  partcv[0] = 1;
  Object opresult1315 = callmethod(strlit1314, "++(1)", 1, partcv, params);
// compiled op node returning opresult1315 (depth = 7)
  int op_slot_left_1301 = gc_frame_newslot(opresult1315);
  params[0] = strlit1302;
  partcv[0] = 1;
  Object opresult1316 = callmethod(opresult1315, "++(1)", 1, partcv, params);
// compiled op node returning opresult1316 (depth = 6)
  int op_slot_right_1300 = gc_frame_newslot(opresult1316);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1318 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1318 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1320 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1320 (depth = 6)
  int op_slot_left_1300 = gc_frame_newslot(opresult1320);
  params[0] = opresult1316;
  partcv[0] = 1;
  Object opresult1321 = callmethod(opresult1320, "++(1)", 1, partcv, params);
// compiled op node returning opresult1321 (depth = 5)
  *var_s = opresult1321;
  if (opresult1321 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1325 == NULL) {
    strlit1325 = alloc_String("");
    gc_root(strlit1325);
  }
// compiled string node returning strlit1325 (depth = 7)
  int op_slot_right_1324 = gc_frame_newslot(strlit1325);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1328 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1330 = alloc_Float64(2);
// compiled num node returning num1330 (depth = 10)
  int op_slot_right_1329 = gc_frame_newslot(num1330);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1329 = gc_frame_newslot(*var_depth);
  params[0] = num1330;
  partcv[0] = 1;
  Object sum1332 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1332 (depth = 9)
  gc_frame_newslot(sum1332);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1333 = gc_frame_new();
// call case 4: self request
  Object call1334 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1333);
// compiled member node returning call1334 (depth = 9)
  params[0] = sum1332;
  partcv[0] = 1;
  Object call1335 = callmethodflags(call1334, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1328);
// compiled call node returning call1335 (depth = 8)
  int op_slot_right_1327 = gc_frame_newslot(call1335);
// starting to compile string node (depth = 8)
  if (strlit1337 == NULL) {
    strlit1337 = alloc_String("Else: ");
    gc_root(strlit1337);
  }
// compiled string node returning strlit1337 (depth = 8)
  int op_slot_left_1327 = gc_frame_newslot(strlit1337);
  params[0] = call1335;
  partcv[0] = 1;
  Object opresult1338 = callmethod(strlit1337, "++(1)", 1, partcv, params);
// compiled op node returning opresult1338 (depth = 7)
  int op_slot_left_1324 = gc_frame_newslot(opresult1338);
  params[0] = strlit1325;
  partcv[0] = 1;
  Object opresult1339 = callmethod(opresult1338, "++(1)", 1, partcv, params);
// compiled op node returning opresult1339 (depth = 6)
  int op_slot_right_1323 = gc_frame_newslot(opresult1339);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1341 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1341 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1343 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1343 (depth = 6)
  int op_slot_left_1323 = gc_frame_newslot(opresult1343);
  params[0] = opresult1339;
  partcv[0] = 1;
  Object opresult1344 = callmethod(opresult1343, "++(1)", 1, partcv, params);
// compiled op node returning opresult1344 (depth = 5)
  *var_s = opresult1344;
  if (opresult1344 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1293 = done;
  } else {
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1347 == NULL) {
    strlit1347 = alloc_String("Then:");
    gc_root(strlit1347);
  }
// compiled string node returning strlit1347 (depth = 6)
  int op_slot_right_1346 = gc_frame_newslot(strlit1347);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1349 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1349 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1351 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1351 (depth = 6)
  int op_slot_left_1346 = gc_frame_newslot(opresult1351);
  params[0] = strlit1347;
  partcv[0] = 1;
  Object opresult1352 = callmethod(opresult1351, "++(1)", 1, partcv, params);
// compiled op node returning opresult1352 (depth = 5)
  *var_s = opresult1352;
  if (opresult1352 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1354 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1355 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1356 = gc_frame_new();
// call case 4: self request
  Object call1357 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1356);
// compiled member node returning call1357 (depth = 6)
  Object call1358 = callmethodflags(call1357, "body", 0, partcv, params, 0);
  gc_frame_end(callframe1355);
// compiled member node returning call1358 (depth = 5)
  gc_frame_newslot(call1358);
// starting to compile block node (depth = 5)
  Object block1359 = alloc_Block(NULL, NULL, "ast", 286);
  gc_frame_newslot(block1359);
// method "_apply(_)"
  block_savedest(block1359);
  Object closure1360 = createclosure(4, "_apply(1)");
  setclosureframe(closure1360, stackframe);
  addtoclosure(closure1360, var_depth);
  addtoclosure(closure1360, var_spc);
  addtoclosure(closure1360, var_s);
  addtoclosure(closure1360, selfslot);
  struct UserObject *uo1360 = (struct UserObject*)block1359;
  uo1360->data[0] = (Object)closure1360;
  Method *meth_meth_ast__apply_40_1_41_1360 = addmethod2pos(block1359, "_apply(1)", &meth_ast__apply_40_1_41_1360, 0);
  int argcv_meth_ast__apply_40_1_41_1360[] = {1};
  meth_meth_ast__apply_40_1_41_1360->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1360);
  meth_meth_ast__apply_40_1_41_1360->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1360->definitionLine = 2969;
// compiled block node returning block1359 (depth = 5)
  gc_frame_newslot(block1359);
// call case 5: prelude request
  params[0] = call1358;
  params[1] = block1359;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1379 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1354);
// compiled call node returning call1379 (depth = 4)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1381 == NULL) {
    strlit1381 = alloc_String("""\x0a""");
    gc_root(strlit1381);
  }
// compiled string node returning strlit1381 (depth = 6)
  int op_slot_right_1380 = gc_frame_newslot(strlit1381);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1380 = gc_frame_newslot(*var_s);
  params[0] = strlit1381;
  partcv[0] = 1;
  Object opresult1383 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1383 (depth = 5)
  *var_s = opresult1383;
  if (opresult1383 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1386 == NULL) {
    strlit1386 = alloc_String("Else:");
    gc_root(strlit1386);
  }
// compiled string node returning strlit1386 (depth = 6)
  int op_slot_right_1385 = gc_frame_newslot(strlit1386);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1388 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1388 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1390 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1390 (depth = 6)
  int op_slot_left_1385 = gc_frame_newslot(opresult1390);
  params[0] = strlit1386;
  partcv[0] = 1;
  Object opresult1391 = callmethod(opresult1390, "++(1)", 1, partcv, params);
// compiled op node returning opresult1391 (depth = 5)
  *var_s = opresult1391;
  if (opresult1391 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1393 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1394 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1395 = gc_frame_new();
// call case 4: self request
  Object call1396 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1395);
// compiled member node returning call1396 (depth = 6)
  Object call1397 = callmethodflags(call1396, "body", 0, partcv, params, 0);
  gc_frame_end(callframe1394);
// compiled member node returning call1397 (depth = 5)
  gc_frame_newslot(call1397);
// starting to compile block node (depth = 5)
  Object block1398 = alloc_Block(NULL, NULL, "ast", 291);
  gc_frame_newslot(block1398);
// method "_apply(_)"
  block_savedest(block1398);
  Object closure1399 = createclosure(4, "_apply(1)");
  setclosureframe(closure1399, stackframe);
  addtoclosure(closure1399, var_depth);
  addtoclosure(closure1399, var_spc);
  addtoclosure(closure1399, var_s);
  addtoclosure(closure1399, selfslot);
  struct UserObject *uo1399 = (struct UserObject*)block1398;
  uo1399->data[0] = (Object)closure1399;
  Method *meth_meth_ast__apply_40_1_41_1399 = addmethod2pos(block1398, "_apply(1)", &meth_ast__apply_40_1_41_1399, 0);
  int argcv_meth_ast__apply_40_1_41_1399[] = {1};
  meth_meth_ast__apply_40_1_41_1399->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1399);
  meth_meth_ast__apply_40_1_41_1399->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1399->definitionLine = 2969;
// compiled block node returning block1398 (depth = 5)
  gc_frame_newslot(block1398);
// call case 5: prelude request
  params[0] = call1397;
  params[1] = block1398;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1418 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1393);
// compiled call node returning call1418 (depth = 4)
    gc_frame_newslot(call1418);
    if1293 = call1418;
  }
// compiled if node returning if1293 (depth = 3)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1423(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1425 == NULL) {
    strlit1425 = alloc_String("    ");
    gc_root(strlit1425);
  }
// compiled string node returning strlit1425 (depth = 7)
  int op_slot_right_1424 = gc_frame_newslot(strlit1425);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1424 = gc_frame_newslot(*var_spc);
  params[0] = strlit1425;
  partcv[0] = 1;
  Object opresult1427 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult1427 (depth = 6)
  *var_spc = opresult1427;
  if (opresult1427 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1450(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1452 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1454 = alloc_Float64(1);
// compiled num node returning num1454 (depth = 9)
  int op_slot_right_1453 = gc_frame_newslot(num1454);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1453 = gc_frame_newslot(*var_depth);
  params[0] = num1454;
  partcv[0] = 1;
  Object sum1456 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1456 (depth = 8)
  gc_frame_newslot(sum1456);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  params[0] = sum1456;
  partcv[0] = 1;
  Object call1457 = callmethodflags(*var_ix, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1452);
// compiled call node returning call1457 (depth = 7)
  int op_slot_right_1451 = gc_frame_newslot(call1457);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1460 == NULL) {
    strlit1460 = alloc_String("    ");
    gc_root(strlit1460);
  }
// compiled string node returning strlit1460 (depth = 8)
  int op_slot_right_1459 = gc_frame_newslot(strlit1460);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1462 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1465 == NULL) {
    strlit1465 = alloc_String("""\x0a""");
    gc_root(strlit1465);
  }
// compiled string node returning strlit1465 (depth = 10)
  int op_slot_right_1464 = gc_frame_newslot(strlit1465);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1464 = gc_frame_newslot(*var_s);
  params[0] = strlit1465;
  partcv[0] = 1;
  Object opresult1467 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1467 (depth = 9)
  int op_slot_left_1462 = gc_frame_newslot(opresult1467);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1468 = callmethod(opresult1467, "++(1)", 1, partcv, params);
// compiled op node returning opresult1468 (depth = 8)
  int op_slot_left_1459 = gc_frame_newslot(opresult1468);
  params[0] = strlit1460;
  partcv[0] = 1;
  Object opresult1469 = callmethod(opresult1468, "++(1)", 1, partcv, params);
// compiled op node returning opresult1469 (depth = 7)
  int op_slot_left_1451 = gc_frame_newslot(opresult1469);
  params[0] = call1457;
  partcv[0] = 1;
  Object opresult1470 = callmethod(opresult1469, "++(1)", 1, partcv, params);
// compiled op node returning opresult1470 (depth = 6)
  *var_s = opresult1470;
  if (opresult1470 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1497(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1499 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1501 = alloc_Float64(1);
// compiled num node returning num1501 (depth = 10)
  int op_slot_right_1500 = gc_frame_newslot(num1501);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1500 = gc_frame_newslot(*var_depth);
  params[0] = num1501;
  partcv[0] = 1;
  Object sum1503 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1503 (depth = 9)
  gc_frame_newslot(sum1503);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1503;
  partcv[0] = 1;
  Object call1504 = callmethodflags(*var_ix, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1499);
// compiled call node returning call1504 (depth = 8)
  int op_slot_right_1498 = gc_frame_newslot(call1504);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1507 == NULL) {
    strlit1507 = alloc_String("    ");
    gc_root(strlit1507);
  }
// compiled string node returning strlit1507 (depth = 9)
  int op_slot_right_1506 = gc_frame_newslot(strlit1507);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1509 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1512 == NULL) {
    strlit1512 = alloc_String("""\x0a""");
    gc_root(strlit1512);
  }
// compiled string node returning strlit1512 (depth = 11)
  int op_slot_right_1511 = gc_frame_newslot(strlit1512);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1511 = gc_frame_newslot(*var_s);
  params[0] = strlit1512;
  partcv[0] = 1;
  Object opresult1514 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1514 (depth = 10)
  int op_slot_left_1509 = gc_frame_newslot(opresult1514);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1515 = callmethod(opresult1514, "++(1)", 1, partcv, params);
// compiled op node returning opresult1515 (depth = 9)
  int op_slot_left_1506 = gc_frame_newslot(opresult1515);
  params[0] = strlit1507;
  partcv[0] = 1;
  Object opresult1516 = callmethod(opresult1515, "++(1)", 1, partcv, params);
// compiled op node returning opresult1516 (depth = 8)
  int op_slot_left_1498 = gc_frame_newslot(opresult1516);
  params[0] = call1504;
  partcv[0] = 1;
  Object opresult1517 = callmethod(opresult1516, "++(1)", 1, partcv, params);
// compiled op node returning opresult1517 (depth = 7)
  *var_s = opresult1517;
  if (opresult1517 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_1419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1420 == NULL) {
    strlit1420 = alloc_String("");
    gc_root(strlit1420);
  }
// compiled string node returning strlit1420 (depth = 4)
  *var_spc = strlit1420;
  if (strlit1420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1421 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block1422 = alloc_Block(NULL, NULL, "ast", 299);
  gc_frame_newslot(block1422);
// method "_apply"
  block_savedest(block1422);
  Object closure1423 = createclosure(2, "_apply");
  setclosureframe(closure1423, stackframe);
  addtoclosure(closure1423, var_spc);
  addtoclosure(closure1423, selfslot);
  struct UserObject *uo1423 = (struct UserObject*)block1422;
  uo1423->data[0] = (Object)closure1423;
  Method *meth_meth_ast__apply1423 = addmethod2pos(block1422, "_apply", &meth_ast__apply1423, 0);
  int argcv_meth_ast__apply1423[] = {0};
  meth_meth_ast__apply1423->type = alloc_MethodType(1, argcv_meth_ast__apply1423);
  meth_meth_ast__apply1423->definitionModule = modulename;
  meth_meth_ast__apply1423->definitionLine = 2969;
// compiled block node returning block1422 (depth = 4)
  gc_frame_newslot(block1422);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block1422;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1430 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1421);
// compiled call node returning call1430 (depth = 3)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1432 == NULL) {
    strlit1432 = alloc_String(") then {");
    gc_root(strlit1432);
  }
// compiled string node returning strlit1432 (depth = 5)
  int op_slot_right_1431 = gc_frame_newslot(strlit1432);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1435 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num1436 = alloc_Float64(0);
// compiled num node returning num1436 (depth = 7)
  gc_frame_newslot(num1436);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1437 = gc_frame_new();
// call case 4: self request
  Object call1438 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1437);
// compiled member node returning call1438 (depth = 7)
  params[0] = num1436;
  partcv[0] = 1;
  Object call1439 = callmethodflags(call1438, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1435);
// compiled call node returning call1439 (depth = 6)
  int op_slot_right_1434 = gc_frame_newslot(call1439);
// starting to compile string node (depth = 6)
  if (strlit1441 == NULL) {
    strlit1441 = alloc_String("if (");
    gc_root(strlit1441);
  }
// compiled string node returning strlit1441 (depth = 6)
  int op_slot_left_1434 = gc_frame_newslot(strlit1441);
  params[0] = call1439;
  partcv[0] = 1;
  Object opresult1442 = callmethod(strlit1441, "++(1)", 1, partcv, params);
// compiled op node returning opresult1442 (depth = 5)
  int op_slot_left_1431 = gc_frame_newslot(opresult1442);
  params[0] = strlit1432;
  partcv[0] = 1;
  Object opresult1443 = callmethod(opresult1442, "++(1)", 1, partcv, params);
// compiled op node returning opresult1443 (depth = 4)
  *var_s = opresult1443;
  if (opresult1443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1444 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1445 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1446 = gc_frame_new();
// call case 4: self request
  Object call1447 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1446);
// compiled member node returning call1447 (depth = 5)
  Object call1448 = callmethodflags(call1447, "body", 0, partcv, params, 0);
  gc_frame_end(callframe1445);
// compiled member node returning call1448 (depth = 4)
  gc_frame_newslot(call1448);
// starting to compile block node (depth = 4)
  Object block1449 = alloc_Block(NULL, NULL, "ast", 303);
  gc_frame_newslot(block1449);
// method "_apply(_)"
  block_savedest(block1449);
  Object closure1450 = createclosure(4, "_apply(1)");
  setclosureframe(closure1450, stackframe);
  addtoclosure(closure1450, var_depth);
  addtoclosure(closure1450, var_spc);
  addtoclosure(closure1450, var_s);
  addtoclosure(closure1450, selfslot);
  struct UserObject *uo1450 = (struct UserObject*)block1449;
  uo1450->data[0] = (Object)closure1450;
  Method *meth_meth_ast__apply_40_1_41_1450 = addmethod2pos(block1449, "_apply(1)", &meth_ast__apply_40_1_41_1450, 0);
  int argcv_meth_ast__apply_40_1_41_1450[] = {1};
  meth_meth_ast__apply_40_1_41_1450->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1450);
  meth_meth_ast__apply_40_1_41_1450->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1450->definitionLine = 2969;
// compiled block node returning block1449 (depth = 4)
  gc_frame_newslot(block1449);
// call case 5: prelude request
  params[0] = call1448;
  params[1] = block1449;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1473 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1444);
// compiled call node returning call1473 (depth = 3)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1475 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1476 = gc_frame_new();
// call case 4: self request
  Object call1477 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1476);
// compiled member node returning call1477 (depth = 5)
  Object call1478 = callmethodflags(call1477, "isntEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe1475);
// compiled member node returning call1478 (depth = 4)
  Object if1474 = done;
  if (istrue(call1478)) {
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1480 == NULL) {
    strlit1480 = alloc_String("} else {");
    gc_root(strlit1480);
  }
// compiled string node returning strlit1480 (depth = 6)
  int op_slot_right_1479 = gc_frame_newslot(strlit1480);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1482 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1485 == NULL) {
    strlit1485 = alloc_String("""\x0a""");
    gc_root(strlit1485);
  }
// compiled string node returning strlit1485 (depth = 8)
  int op_slot_right_1484 = gc_frame_newslot(strlit1485);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1484 = gc_frame_newslot(*var_s);
  params[0] = strlit1485;
  partcv[0] = 1;
  Object opresult1487 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1487 (depth = 7)
  int op_slot_left_1482 = gc_frame_newslot(opresult1487);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1488 = callmethod(opresult1487, "++(1)", 1, partcv, params);
// compiled op node returning opresult1488 (depth = 6)
  int op_slot_left_1479 = gc_frame_newslot(opresult1488);
  params[0] = strlit1480;
  partcv[0] = 1;
  Object opresult1489 = callmethod(opresult1488, "++(1)", 1, partcv, params);
// compiled op node returning opresult1489 (depth = 5)
  *var_s = opresult1489;
  if (opresult1489 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1491 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1492 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1493 = gc_frame_new();
// call case 4: self request
  Object call1494 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1493);
// compiled member node returning call1494 (depth = 6)
  Object call1495 = callmethodflags(call1494, "body", 0, partcv, params, 0);
  gc_frame_end(callframe1492);
// compiled member node returning call1495 (depth = 5)
  gc_frame_newslot(call1495);
// starting to compile block node (depth = 5)
  Object block1496 = alloc_Block(NULL, NULL, "ast", 308);
  gc_frame_newslot(block1496);
// method "_apply(_)"
  block_savedest(block1496);
  Object closure1497 = createclosure(4, "_apply(1)");
  setclosureframe(closure1497, stackframe);
  addtoclosure(closure1497, var_depth);
  addtoclosure(closure1497, var_spc);
  addtoclosure(closure1497, var_s);
  addtoclosure(closure1497, selfslot);
  struct UserObject *uo1497 = (struct UserObject*)block1496;
  uo1497->data[0] = (Object)closure1497;
  Method *meth_meth_ast__apply_40_1_41_1497 = addmethod2pos(block1496, "_apply(1)", &meth_ast__apply_40_1_41_1497, 0);
  int argcv_meth_ast__apply_40_1_41_1497[] = {1};
  meth_meth_ast__apply_40_1_41_1497->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1497);
  meth_meth_ast__apply_40_1_41_1497->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1497->definitionLine = 2969;
// compiled block node returning block1496 (depth = 5)
  gc_frame_newslot(block1496);
// call case 5: prelude request
  params[0] = call1495;
  params[1] = block1496;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1520 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1491);
// compiled call node returning call1520 (depth = 4)
    gc_frame_newslot(call1520);
    if1474 = call1520;
  } else {
  }
// compiled if node returning if1474 (depth = 3)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1522 == NULL) {
    strlit1522 = alloc_String("}");
    gc_root(strlit1522);
  }
// compiled string node returning strlit1522 (depth = 5)
  int op_slot_right_1521 = gc_frame_newslot(strlit1522);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1524 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1527 == NULL) {
    strlit1527 = alloc_String("""\x0a""");
    gc_root(strlit1527);
  }
// compiled string node returning strlit1527 (depth = 7)
  int op_slot_right_1526 = gc_frame_newslot(strlit1527);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1526 = gc_frame_newslot(*var_s);
  params[0] = strlit1527;
  partcv[0] = 1;
  Object opresult1529 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1529 (depth = 6)
  int op_slot_left_1524 = gc_frame_newslot(opresult1529);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1530 = callmethod(opresult1529, "++(1)", 1, partcv, params);
// compiled op node returning opresult1530 (depth = 5)
  int op_slot_left_1521 = gc_frame_newslot(opresult1530);
  params[0] = strlit1522;
  partcv[0] = 1;
  Object opresult1531 = callmethod(opresult1530, "++(1)", 1, partcv, params);
// compiled op node returning opresult1531 (depth = 4)
  *var_s = opresult1531;
  if (opresult1531 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy1533(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_ifNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1534 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe1535 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ifNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call1536 = callmethodflags(*var_ifNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe1535);
// compiled call node returning call1536 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1537 = callmethodflags(call1536, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1534);
// compiled call node returning call1537 (depth = 3)
  gc_frame_end(frame);
  return call1537;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_1538(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1539 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1540 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1539);
// compiled call node returning call1540 (depth = 3)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1541 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1542 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call1543 = callmethodflags(*var_other, "handledIdentifiers", 0, partcv, params, 0);
  gc_frame_end(callframe1542);
// compiled member node returning call1543 (depth = 4)
  gc_frame_newslot(call1543);
// call case 4: self request
  params[0] = call1543;
  partcv[0] = 1;
  Object call1544 = callmethodflags(self, "handledIdentifiers:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1541);
// compiled call node returning call1544 (depth = 3)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_3_41_1198(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1199 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1199 = alloc_userobj2(16,13, objclass1199);
  gc_frame_newslot(obj1199);
if (objclass1199 == NULL) {
  glfree(obj1199->class->name);
  obj1199->class->name = "ifNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1199, self, 0);
  addmethodreal(obj1199,"outer", &reader_ast_outer_1200);
  Object oldself1199 = self;
  struct StackFrameObject *oldstackframe1199 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1199);
  gc_frame_newslot((Object)stackframe);
  self = obj1199;
  Object *oldselfslot1199 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1199 = (*(struct UserObject *)self).data[0], lowerouter1199 = thisouter1199;
  if (inheritingObject1199) {
    struct UserObject *inho1199 = (struct UserObject *)inheritingObject1199;
    while (inho1199->super != GraceDefaultObject) inho1199 = (struct UserObject *)inho1199->super;
    inho1199->super = obj1199;
    self = inheritingObject1199;
    *selfslot = self;
    lowerouter1199 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1199;
  }
if (objclass1199 == NULL) {
  Method *reader1201 = addmethodrealflags(obj1199, "kind",&reader_ast_kind_1201, MFLAG_DEF);
  reader1201->definitionModule = modulename;
  reader1201->definitionLine = 251;
}
adddatum2(obj1199, alloc_Undefined(), 1);
if (objclass1199 == NULL) {
  Method *reader1202 = addmethodrealflags(obj1199, "value", &reader_ast_value_1202, 0);
  Method *writer1202 = addmethodrealflags(obj1199, "value:=(1)", &writer_ast_value_1202, 0);
  reader1202->definitionModule = modulename;
  writer1202->definitionModule = modulename;
  reader1202->definitionLine = 252;
  writer1202->definitionLine = 252;
}
obj1199->flags |= OFLAG_MUTABLE;
adddatum2(obj1199, alloc_Undefined(), 2);
if (objclass1199 == NULL) {
  Method *reader1203 = addmethodrealflags(obj1199, "thenblock", &reader_ast_thenblock_1203, 0);
  Method *writer1203 = addmethodrealflags(obj1199, "thenblock:=(1)", &writer_ast_thenblock_1203, 0);
  reader1203->definitionModule = modulename;
  writer1203->definitionModule = modulename;
  reader1203->definitionLine = 253;
  writer1203->definitionLine = 253;
}
obj1199->flags |= OFLAG_MUTABLE;
adddatum2(obj1199, alloc_Undefined(), 3);
if (objclass1199 == NULL) {
  Method *reader1204 = addmethodrealflags(obj1199, "elseblock", &reader_ast_elseblock_1204, 0);
  Method *writer1204 = addmethodrealflags(obj1199, "elseblock:=(1)", &writer_ast_elseblock_1204, 0);
  reader1204->definitionModule = modulename;
  writer1204->definitionModule = modulename;
  reader1204->definitionLine = 254;
  writer1204->definitionLine = 254;
}
obj1199->flags |= OFLAG_MUTABLE;
adddatum2(obj1199, alloc_Undefined(), 4);
if (objclass1199 == NULL) {
  Method *reader1205 = addmethodrealflags(obj1199, "handledIdentifiers", &reader_ast_handledIdentifiers_1205, 0);
  Method *writer1205 = addmethodrealflags(obj1199, "handledIdentifiers:=(1)", &writer_ast_handledIdentifiers_1205, 0);
  reader1205->definitionModule = modulename;
  writer1205->definitionModule = modulename;
  reader1205->definitionLine = 255;
  writer1205->definitionLine = 255;
}
obj1199->flags |= OFLAG_MUTABLE;
adddatum2(obj1199, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1206 = (struct UserObject*)obj1199;
  uo1206->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1206 = addmethod2pos(obj1199, "isSimple", &meth_ast_isSimple1206, 6);
  int argcv_meth_ast_isSimple1206[] = {0};
  meth_meth_ast_isSimple1206->type = alloc_MethodType(1, argcv_meth_ast_isSimple1206);
  meth_meth_ast_isSimple1206->definitionModule = modulename;
  meth_meth_ast_isSimple1206->definitionLine = 256;
// method "accept(_)from(_)"
  struct UserObject *uo1208 = (struct UserObject*)obj1199;
  uo1208->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1208 = addmethod2pos(obj1199, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1208, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1208[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1208->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1208);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1208->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1208->definitionLine = 257;
// method "map(_)ancestors(_)"
  struct UserObject *uo1226 = (struct UserObject*)obj1199;
  uo1226->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1226 = addmethod2pos(obj1199, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1226, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1226[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1226->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1226);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1226->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1226->definitionLine = 265;
// method "pretty(_)"
  block_savedest(obj1199);
  Object closure1251 = createclosure(1, "pretty(1)");
  setclosureframe(closure1251, stackframe);
  addtoclosure(closure1251, var_util);
  struct UserObject *uo1251 = (struct UserObject*)obj1199;
  uo1251->data[9] = (Object)closure1251;
  Method *meth_meth_ast_pretty_40_1_41_1251 = addmethod2pos(obj1199, "pretty(1)", &meth_ast_pretty_40_1_41_1251, 9);
  int argcv_meth_ast_pretty_40_1_41_1251[] = {1};
  meth_meth_ast_pretty_40_1_41_1251->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1251);
  meth_meth_ast_pretty_40_1_41_1251->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1251->definitionLine = 273;
// method "toGrace(_)"
  struct UserObject *uo1419 = (struct UserObject*)obj1199;
  uo1419->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1419 = addmethod2pos(obj1199, "toGrace(1)", &meth_ast_toGrace_40_1_41_1419, 10);
  int argcv_meth_ast_toGrace_40_1_41_1419[] = {1};
  meth_meth_ast_toGrace_40_1_41_1419->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1419);
meth_meth_ast_toGrace_40_1_41_1419->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_1419->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_1419->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1419->definitionLine = 297;
// method "shallowCopy"
  block_savedest(obj1199);
  Object closure1533 = createclosure(2, "shallowCopy");
  setclosureframe(closure1533, stackframe);
  addtoclosure(closure1533, var_nullNode);
  addtoclosure(closure1533, var_ifNode);
  struct UserObject *uo1533 = (struct UserObject*)obj1199;
  uo1533->data[11] = (Object)closure1533;
  Method *meth_meth_ast_shallowCopy1533 = addmethod2pos(obj1199, "shallowCopy", &meth_ast_shallowCopy1533, 11);
  int argcv_meth_ast_shallowCopy1533[] = {0};
  meth_meth_ast_shallowCopy1533->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1533);
  meth_meth_ast_shallowCopy1533->definitionModule = modulename;
  meth_meth_ast_shallowCopy1533->definitionLine = 315;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo1538 = (struct UserObject*)obj1199;
  uo1538->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1538 = addmethod2pos(obj1199, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_1538, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1538[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1538->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1538);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1538->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1538->definitionLine = 318;
  sourceObject = obj1199;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1545 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1546 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1547 = gc_frame_new();
// call case 3: self.outer request
  Object call1548 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1547);
// compiled member node returning call1548 (depth = 5)
  Object call1549 = callmethodflags(call1548, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1546);
// compiled member node returning call1549 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1550 = callmethodflags(call1549, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1545);
// compiled call node returning call1550 (depth = 3)
  struct UserObject *obj1199_uo = (struct UserObject *)obj1199;
  obj1199_uo->super = call1550;
  sourceObject = obj1199;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1551 == NULL) {
    strlit1551 = alloc_String("if");
    gc_root(strlit1551);
  }
// compiled string node returning strlit1551 (depth = 3)
  adddatum2(obj1199, strlit1551, 1);
  sourceObject = obj1199;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1199, *var_cond, 2);
  sourceObject = obj1199;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1199, *var_thenblock_39_, 3);
  sourceObject = obj1199;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1199, *var_elseblock_39_, 4);
  sourceObject = obj1199;
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1552 = alloc_Boolean(0);
// compiled identifier node returning bool1552 (depth = 3)
  adddatum2(obj1199, bool1552, 5);
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  objclass1199 = obj1199->class;
  objclass1199->definitionModule = modulename;
  objclass1199->definitionLine = 249;
  (*(struct UserObject *)self).data[0] = lowerouter1199;
  self = oldself1199;
  selfslot = oldselfslot1199;
  stackframe = oldstackframe1199;
  gc_frame_end(frame);
  return obj1199;
}
Object meth_ast_new_40_3_41_1198_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1199 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1199 = alloc_userobj2(16,13, objclass1199);
  gc_frame_newslot(obj1199);
if (objclass1199 == NULL) {
  glfree(obj1199->class->name);
  obj1199->class->name = "ifNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1199, self, 0);
  addmethodreal(obj1199,"outer", &reader_ast_outer_1200);
  Object oldself1199 = self;
  struct StackFrameObject *oldstackframe1199 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1199);
  gc_frame_newslot((Object)stackframe);
  self = obj1199;
  Object *oldselfslot1199 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1199 = (*(struct UserObject *)self).data[0], lowerouter1199 = thisouter1199;
  if (inheritingObject1199) {
    struct UserObject *inho1199 = (struct UserObject *)inheritingObject1199;
    while (inho1199->super != GraceDefaultObject) inho1199 = (struct UserObject *)inho1199->super;
    inho1199->super = obj1199;
    self = inheritingObject1199;
    *selfslot = self;
    lowerouter1199 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1199;
  }
if (objclass1199 == NULL) {
  Method *reader1201 = addmethodrealflags(obj1199, "kind",&reader_ast_kind_1201, MFLAG_DEF);
  reader1201->definitionModule = modulename;
  reader1201->definitionLine = 251;
}
adddatum2(obj1199, alloc_Undefined(), 1);
if (objclass1199 == NULL) {
  Method *reader1202 = addmethodrealflags(obj1199, "value", &reader_ast_value_1202, 0);
  Method *writer1202 = addmethodrealflags(obj1199, "value:=(1)", &writer_ast_value_1202, 0);
  reader1202->definitionModule = modulename;
  writer1202->definitionModule = modulename;
  reader1202->definitionLine = 252;
  writer1202->definitionLine = 252;
}
obj1199->flags |= OFLAG_MUTABLE;
adddatum2(obj1199, alloc_Undefined(), 2);
if (objclass1199 == NULL) {
  Method *reader1203 = addmethodrealflags(obj1199, "thenblock", &reader_ast_thenblock_1203, 0);
  Method *writer1203 = addmethodrealflags(obj1199, "thenblock:=(1)", &writer_ast_thenblock_1203, 0);
  reader1203->definitionModule = modulename;
  writer1203->definitionModule = modulename;
  reader1203->definitionLine = 253;
  writer1203->definitionLine = 253;
}
obj1199->flags |= OFLAG_MUTABLE;
adddatum2(obj1199, alloc_Undefined(), 3);
if (objclass1199 == NULL) {
  Method *reader1204 = addmethodrealflags(obj1199, "elseblock", &reader_ast_elseblock_1204, 0);
  Method *writer1204 = addmethodrealflags(obj1199, "elseblock:=(1)", &writer_ast_elseblock_1204, 0);
  reader1204->definitionModule = modulename;
  writer1204->definitionModule = modulename;
  reader1204->definitionLine = 254;
  writer1204->definitionLine = 254;
}
obj1199->flags |= OFLAG_MUTABLE;
adddatum2(obj1199, alloc_Undefined(), 4);
if (objclass1199 == NULL) {
  Method *reader1205 = addmethodrealflags(obj1199, "handledIdentifiers", &reader_ast_handledIdentifiers_1205, 0);
  Method *writer1205 = addmethodrealflags(obj1199, "handledIdentifiers:=(1)", &writer_ast_handledIdentifiers_1205, 0);
  reader1205->definitionModule = modulename;
  writer1205->definitionModule = modulename;
  reader1205->definitionLine = 255;
  writer1205->definitionLine = 255;
}
obj1199->flags |= OFLAG_MUTABLE;
adddatum2(obj1199, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1206 = (struct UserObject*)obj1199;
  uo1206->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1206 = addmethod2pos(obj1199, "isSimple", &meth_ast_isSimple1206, 6);
  int argcv_meth_ast_isSimple1206[] = {0};
  meth_meth_ast_isSimple1206->type = alloc_MethodType(1, argcv_meth_ast_isSimple1206);
  meth_meth_ast_isSimple1206->definitionModule = modulename;
  meth_meth_ast_isSimple1206->definitionLine = 256;
// method "accept(_)from(_)"
  struct UserObject *uo1208 = (struct UserObject*)obj1199;
  uo1208->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1208 = addmethod2pos(obj1199, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1208, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1208[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1208->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1208);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1208->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1208->definitionLine = 257;
// method "map(_)ancestors(_)"
  struct UserObject *uo1226 = (struct UserObject*)obj1199;
  uo1226->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1226 = addmethod2pos(obj1199, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1226, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1226[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1226->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1226);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1226->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1226->definitionLine = 265;
// method "pretty(_)"
  block_savedest(obj1199);
  Object closure1251 = createclosure(1, "pretty(1)");
  setclosureframe(closure1251, stackframe);
  addtoclosure(closure1251, var_util);
  struct UserObject *uo1251 = (struct UserObject*)obj1199;
  uo1251->data[9] = (Object)closure1251;
  Method *meth_meth_ast_pretty_40_1_41_1251 = addmethod2pos(obj1199, "pretty(1)", &meth_ast_pretty_40_1_41_1251, 9);
  int argcv_meth_ast_pretty_40_1_41_1251[] = {1};
  meth_meth_ast_pretty_40_1_41_1251->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1251);
  meth_meth_ast_pretty_40_1_41_1251->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1251->definitionLine = 273;
// method "toGrace(_)"
  struct UserObject *uo1419 = (struct UserObject*)obj1199;
  uo1419->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1419 = addmethod2pos(obj1199, "toGrace(1)", &meth_ast_toGrace_40_1_41_1419, 10);
  int argcv_meth_ast_toGrace_40_1_41_1419[] = {1};
  meth_meth_ast_toGrace_40_1_41_1419->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1419);
meth_meth_ast_toGrace_40_1_41_1419->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_1419->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_1419->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1419->definitionLine = 297;
// method "shallowCopy"
  block_savedest(obj1199);
  Object closure1533 = createclosure(2, "shallowCopy");
  setclosureframe(closure1533, stackframe);
  addtoclosure(closure1533, var_nullNode);
  addtoclosure(closure1533, var_ifNode);
  struct UserObject *uo1533 = (struct UserObject*)obj1199;
  uo1533->data[11] = (Object)closure1533;
  Method *meth_meth_ast_shallowCopy1533 = addmethod2pos(obj1199, "shallowCopy", &meth_ast_shallowCopy1533, 11);
  int argcv_meth_ast_shallowCopy1533[] = {0};
  meth_meth_ast_shallowCopy1533->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1533);
  meth_meth_ast_shallowCopy1533->definitionModule = modulename;
  meth_meth_ast_shallowCopy1533->definitionLine = 315;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo1538 = (struct UserObject*)obj1199;
  uo1538->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1538 = addmethod2pos(obj1199, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_1538, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1538[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1538->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1538);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1538->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1538->definitionLine = 318;
  sourceObject = obj1199;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1545 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1546 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1547 = gc_frame_new();
// call case 3: self.outer request
  Object call1548 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1547);
// compiled member node returning call1548 (depth = 5)
  Object call1549 = callmethodflags(call1548, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1546);
// compiled member node returning call1549 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1550 = callmethodflags(call1549, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1545);
// compiled call node returning call1550 (depth = 3)
  struct UserObject *obj1199_uo = (struct UserObject *)obj1199;
  obj1199_uo->super = call1550;
  sourceObject = obj1199;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1551 == NULL) {
    strlit1551 = alloc_String("if");
    gc_root(strlit1551);
  }
// compiled string node returning strlit1551 (depth = 3)
  adddatum2(obj1199, strlit1551, 1);
  sourceObject = obj1199;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1199, *var_cond, 2);
  sourceObject = obj1199;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1199, *var_thenblock_39_, 3);
  sourceObject = obj1199;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1199, *var_elseblock_39_, 4);
  sourceObject = obj1199;
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1552 = alloc_Boolean(0);
// compiled identifier node returning bool1552 (depth = 3)
  adddatum2(obj1199, bool1552, 5);
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  sourceObject = obj1199;
  objclass1199 = obj1199->class;
  objclass1199->definitionModule = modulename;
  objclass1199->definitionLine = 249;
  (*(struct UserObject *)self).data[0] = lowerouter1199;
  self = oldself1199;
  selfslot = oldselfslot1199;
  stackframe = oldstackframe1199;
  gc_frame_end(frame);
  return obj1199;
}
Object meth_ast_ifNode1554(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ifNode (depth = 3)
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast_isBlock1567(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1568 = alloc_Boolean(1);
// compiled identifier node returning bool1568 (depth = 3)
  gc_frame_end(frame);
  return bool1568;
}
Object meth_ast_isDelimited1569(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1570 = alloc_Boolean(1);
// compiled identifier node returning bool1570 (depth = 3)
  gc_frame_end(frame);
  return bool1570;
}
Object meth_ast_isEmpty1571(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1573 = alloc_Float64(0);
// compiled num node returning num1573 (depth = 4)
  int op_slot_right_1572 = gc_frame_newslot(num1573);
// starting to compile member node (depth = 4)
  int callframe1575 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1576 = gc_frame_new();
// call case 4: self request
  Object call1577 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1576);
// compiled member node returning call1577 (depth = 5)
  Object call1578 = callmethodflags(call1577, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1575);
// compiled member node returning call1578 (depth = 4)
  int op_slot_left_1572 = gc_frame_newslot(call1578);
  params[0] = num1573;
  partcv[0] = 1;
  Object opresult1579 = callmethod(call1578, "==(1)", 1, partcv, params);
// compiled op node returning opresult1579 (depth = 3)
  gc_frame_end(frame);
  return opresult1579;
}
Object meth_ast_isntEmpty1580(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isntEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1582 = alloc_Float64(0);
// compiled num node returning num1582 (depth = 4)
  int op_slot_right_1581 = gc_frame_newslot(num1582);
// starting to compile member node (depth = 4)
  int callframe1584 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1585 = gc_frame_new();
// call case 4: self request
  Object call1586 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1585);
// compiled member node returning call1586 (depth = 5)
  Object call1587 = callmethodflags(call1586, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1584);
// compiled member node returning call1587 (depth = 4)
  int op_slot_left_1581 = gc_frame_newslot(call1587);
  params[0] = num1582;
  partcv[0] = 1;
  Object opresult1588 = callmethod(call1587, ">(1)", 1, partcv, params);
// compiled op node returning opresult1588 (depth = 3)
  gc_frame_end(frame);
  return opresult1588;
}
Object meth_ast_scope_58__61__40_1_41_1589(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1590 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call1591 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1590);
// compiled call node returning call1591 (depth = 3)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1592 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1593 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1592);
// compiled call node returning call1593 (depth = 3)
  gc_frame_end(frame);
  return call1593;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_1594(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1595 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call1596 = callmethodflags(*var_k, "parameter", 0, partcv, params, 0);
  gc_frame_end(callframe1595);
// compiled member node returning call1596 (depth = 3)
  gc_frame_end(frame);
  return call1596;
}
Object meth_ast_isMatchingBlock1597(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1599 = alloc_Float64(1);
// compiled num node returning num1599 (depth = 4)
  int op_slot_right_1598 = gc_frame_newslot(num1599);
// starting to compile member node (depth = 4)
  int callframe1601 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1602 = gc_frame_new();
// call case 4: self request
  Object call1603 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1602);
// compiled member node returning call1603 (depth = 5)
  Object call1604 = callmethodflags(call1603, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1601);
// compiled member node returning call1604 (depth = 4)
  int op_slot_left_1598 = gc_frame_newslot(call1604);
  params[0] = num1599;
  partcv[0] = 1;
  Object opresult1605 = callmethod(call1604, "==(1)", 1, partcv, params);
// compiled op node returning opresult1605 (depth = 3)
  gc_frame_end(frame);
  return opresult1605;
}
Object meth_ast__apply1609(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe1610 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1611 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1612 = gc_frame_new();
// call case 4: self request
  Object call1613 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1612);
// compiled member node returning call1613 (depth = 7)
  Object call1614 = callmethodflags(call1613, "last", 0, partcv, params, 0);
  gc_frame_end(callframe1611);
// compiled member node returning call1614 (depth = 6)
  Object call1615 = callmethodflags(call1614, "returnsObject", 0, partcv, params, 0);
  gc_frame_end(callframe1610);
// compiled member node returning call1615 (depth = 5)
  gc_frame_end(frame);
  return call1615;
}
Object meth_ast_returnsObject1606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block1608 = alloc_Block(NULL, NULL, "ast", 351);
  gc_frame_newslot(block1608);
// method "_apply"
  block_savedest(block1608);
  Object closure1609 = createclosure(1, "_apply");
  setclosureframe(closure1609, stackframe);
  addtoclosure(closure1609, selfslot);
  struct UserObject *uo1609 = (struct UserObject*)block1608;
  uo1609->data[0] = (Object)closure1609;
  Method *meth_meth_ast__apply1609 = addmethod2pos(block1608, "_apply", &meth_ast__apply1609, 0);
  int argcv_meth_ast__apply1609[] = {0};
  meth_meth_ast__apply1609->type = alloc_MethodType(1, argcv_meth_ast__apply1609);
  meth_meth_ast__apply1609->definitionModule = modulename;
  meth_meth_ast__apply1609->definitionLine = 2969;
// compiled block node returning block1608 (depth = 4)
  int op_slot_right_1607 = gc_frame_newslot(block1608);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1619 = alloc_Float64(0);
// compiled num node returning num1619 (depth = 5)
  int op_slot_right_1618 = gc_frame_newslot(num1619);
// starting to compile member node (depth = 5)
  int callframe1621 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1622 = gc_frame_new();
// call case 4: self request
  Object call1623 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1622);
// compiled member node returning call1623 (depth = 6)
  Object call1624 = callmethodflags(call1623, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1621);
// compiled member node returning call1624 (depth = 5)
  int op_slot_left_1618 = gc_frame_newslot(call1624);
  params[0] = num1619;
  partcv[0] = 1;
  Object opresult1625 = callmethod(call1624, ">(1)", 1, partcv, params);
// compiled op node returning opresult1625 (depth = 4)
  int op_slot_left_1607 = gc_frame_newslot(opresult1625);
  params[0] = block1608;
  partcv[0] = 1;
  Object opresult1626 = callmethod(opresult1625, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1626 (depth = 3)
  gc_frame_end(frame);
  return opresult1626;
}
Object meth_ast_returnedObjectScope1627(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1628 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1630 = gc_frame_new();
// call case 4: self request
  Object call1631 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1630);
// compiled member node returning call1631 (depth = 5)
  Object call1632 = callmethodflags(call1631, "last", 0, partcv, params, 0);
  gc_frame_end(callframe1629);
// compiled member node returning call1632 (depth = 4)
  Object call1633 = callmethodflags(call1632, "returnedObjectScope", 0, partcv, params, 0);
  gc_frame_end(callframe1628);
// compiled member node returning call1633 (depth = 3)
  gc_frame_end(frame);
  return call1633;
}
Object meth_ast_parametersDo_40_1_41_1634(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parametersDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1635 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1636 = gc_frame_new();
// call case 4: self request
  Object call1637 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1636);
// compiled member node returning call1637 (depth = 4)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call1638 = callmethodflags(call1637, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1635);
// compiled call node returning call1638 (depth = 3)
  gc_frame_end(frame);
  return call1638;
}
Object meth_ast__apply_40_1_41_1649(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1650 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1651 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1650);
// compiled call node returning call1651 (depth = 6)
  gc_frame_end(frame);
  return call1651;
}
Object meth_ast__apply_40_1_41_1658(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1659 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1660 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1659);
// compiled call node returning call1660 (depth = 6)
  gc_frame_end(frame);
  return call1660;
}
Object meth_ast_accept_40_1_41_from_40_1_41_1639(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1641 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1642 = callmethodflags(*var_visitor, "visitBlock(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1641);
// compiled call node returning call1642 (depth = 4)
  Object if1640 = done;
  if (istrue(call1642)) {
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1643 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1644 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1643);
// compiled call node returning call1644 (depth = 5)
  *var_newChain = call1644;
  if (call1644 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1645 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1646 = gc_frame_new();
// call case 4: self request
  Object call1647 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1646);
// compiled member node returning call1647 (depth = 5)
  gc_frame_newslot(call1647);
// starting to compile block node (depth = 5)
  Object block1648 = alloc_Block(NULL, NULL, "ast", 363);
  gc_frame_newslot(block1648);
// method "_apply(_)"
  block_savedest(block1648);
  Object closure1649 = createclosure(3, "_apply(1)");
  setclosureframe(closure1649, stackframe);
  addtoclosure(closure1649, var_visitor);
  addtoclosure(closure1649, var_newChain);
  addtoclosure(closure1649, selfslot);
  struct UserObject *uo1649 = (struct UserObject*)block1648;
  uo1649->data[0] = (Object)closure1649;
  Method *meth_meth_ast__apply_40_1_41_1649 = addmethod2pos(block1648, "_apply(1)", &meth_ast__apply_40_1_41_1649, 0);
  int argcv_meth_ast__apply_40_1_41_1649[] = {1};
  meth_meth_ast__apply_40_1_41_1649->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1649);
  meth_meth_ast__apply_40_1_41_1649->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1649->definitionLine = 2969;
// compiled block node returning block1648 (depth = 5)
  gc_frame_newslot(block1648);
// call case 5: prelude request
  params[0] = call1647;
  params[1] = block1648;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1653 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1645);
// compiled call node returning call1653 (depth = 4)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1654 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1655 = gc_frame_new();
// call case 4: self request
  Object call1656 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1655);
// compiled member node returning call1656 (depth = 5)
  gc_frame_newslot(call1656);
// starting to compile block node (depth = 5)
  Object block1657 = alloc_Block(NULL, NULL, "ast", 366);
  gc_frame_newslot(block1657);
// method "_apply(_)"
  block_savedest(block1657);
  Object closure1658 = createclosure(3, "_apply(1)");
  setclosureframe(closure1658, stackframe);
  addtoclosure(closure1658, var_visitor);
  addtoclosure(closure1658, var_newChain);
  addtoclosure(closure1658, selfslot);
  struct UserObject *uo1658 = (struct UserObject*)block1657;
  uo1658->data[0] = (Object)closure1658;
  Method *meth_meth_ast__apply_40_1_41_1658 = addmethod2pos(block1657, "_apply(1)", &meth_ast__apply_40_1_41_1658, 0);
  int argcv_meth_ast__apply_40_1_41_1658[] = {1};
  meth_meth_ast__apply_40_1_41_1658->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1658);
  meth_meth_ast__apply_40_1_41_1658->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1658->definitionLine = 2969;
// compiled block node returning block1657 (depth = 5)
  gc_frame_newslot(block1657);
// call case 5: prelude request
  params[0] = call1656;
  params[1] = block1657;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1662 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1654);
// compiled call node returning call1662 (depth = 4)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1665 = gc_frame_new();
// call case 4: self request
  Object call1666 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1665);
// compiled member node returning call1666 (depth = 6)
  int op_slot_right_1664 = gc_frame_newslot(call1666);
// starting to compile identifier node (depth = 6)
  Object bool1668 = alloc_Boolean(0);
// compiled identifier node returning bool1668 (depth = 6)
  int op_slot_left_1664 = gc_frame_newslot(bool1668);
  params[0] = call1666;
  partcv[0] = 1;
  Object opresult1669 = callmethod(bool1668, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1669 (depth = 5)
  Object if1663 = done;
  if (istrue(opresult1669)) {
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1670 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1671 = gc_frame_new();
// call case 4: self request
  Object call1672 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1671);
// compiled member node returning call1672 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1673 = callmethodflags(call1672, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1670);
// compiled call node returning call1673 (depth = 5)
    gc_frame_newslot(call1673);
    if1663 = call1673;
  } else {
  }
// compiled if node returning if1663 (depth = 4)
    gc_frame_newslot(if1663);
    if1640 = if1663;
  } else {
  }
// compiled if node returning if1640 (depth = 3)
  gc_frame_end(frame);
  return if1640;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_1674(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1675 = gc_frame_new();
// call case 4: self request
  Object call1676 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1675);
// compiled member node returning call1676 (depth = 4)
  *var_n = call1676;
  if (call1676 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1677 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1678 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1677);
// compiled call node returning call1678 (depth = 4)
  *var_newChain = call1678;
  if (call1678 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1679 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1680 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1681 = gc_frame_new();
// call case 4: self request
  Object call1682 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1681);
// compiled member node returning call1682 (depth = 5)
  gc_frame_newslot(call1682);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1683 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1684 = gc_frame_new();
// call case 3: self.outer request
  Object call1685 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1684);
// compiled member node returning call1685 (depth = 6)
  Object call1686 = callmethodflags(call1685, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1683);
// compiled member node returning call1686 (depth = 5)
  params[0] = call1682;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1687 = callmethodflags(call1686, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1680);
// compiled call node returning call1687 (depth = 4)
  gc_frame_newslot(call1687);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1687;
  partcv[0] = 1;
  Object call1688 = callmethodflags(*var_n, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1679);
// compiled call node returning call1688 (depth = 3)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1689 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1690 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1691 = gc_frame_new();
// call case 4: self request
  Object call1692 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1691);
// compiled member node returning call1692 (depth = 5)
  gc_frame_newslot(call1692);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1693 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1694 = gc_frame_new();
// call case 3: self.outer request
  Object call1695 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1694);
// compiled member node returning call1695 (depth = 6)
  Object call1696 = callmethodflags(call1695, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1693);
// compiled member node returning call1696 (depth = 5)
  params[0] = call1692;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1697 = callmethodflags(call1696, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1690);
// compiled call node returning call1697 (depth = 4)
  gc_frame_newslot(call1697);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1697;
  partcv[0] = 1;
  Object call1698 = callmethodflags(*var_n, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1689);
// compiled call node returning call1698 (depth = 3)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1699 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1700 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1701 = gc_frame_new();
// call case 4: self request
  Object call1702 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1701);
// compiled member node returning call1702 (depth = 5)
  gc_frame_newslot(call1702);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1703 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1704 = gc_frame_new();
// call case 3: self.outer request
  Object call1705 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1704);
// compiled member node returning call1705 (depth = 6)
  Object call1706 = callmethodflags(call1705, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1703);
// compiled member node returning call1706 (depth = 5)
  params[0] = call1702;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1707 = callmethodflags(call1706, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1700);
// compiled call node returning call1707 (depth = 4)
  gc_frame_newslot(call1707);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1707;
  partcv[0] = 1;
  Object call1708 = callmethodflags(*var_n, "matchingPattern:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1699);
// compiled call node returning call1708 (depth = 3)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1709 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1710 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1709);
// compiled call node returning call1710 (depth = 3)
  gc_frame_end(frame);
  return call1710;
}
Object meth_ast__apply_40_1_41_1719(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1721 == NULL) {
    strlit1721 = alloc_String("  ");
    gc_root(strlit1721);
  }
// compiled string node returning strlit1721 (depth = 7)
  int op_slot_right_1720 = gc_frame_newslot(strlit1721);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1720 = gc_frame_newslot(*var_spc);
  params[0] = strlit1721;
  partcv[0] = 1;
  Object opresult1723 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult1723 (depth = 6)
  *var_spc = opresult1723;
  if (opresult1723 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1745(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1747 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1749 = alloc_Float64(1);
// compiled num node returning num1749 (depth = 9)
  int op_slot_right_1748 = gc_frame_newslot(num1749);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1748 = gc_frame_newslot(*var_depth);
  params[0] = num1749;
  partcv[0] = 1;
  Object sum1751 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1751 (depth = 8)
  gc_frame_newslot(sum1751);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1751;
  partcv[0] = 1;
  Object call1752 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1747);
// compiled call node returning call1752 (depth = 7)
  int op_slot_right_1746 = gc_frame_newslot(call1752);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1754 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1757 == NULL) {
    strlit1757 = alloc_String("""\x0a""  ");
    gc_root(strlit1757);
  }
// compiled string node returning strlit1757 (depth = 9)
  int op_slot_right_1756 = gc_frame_newslot(strlit1757);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1756 = gc_frame_newslot(*var_s);
  params[0] = strlit1757;
  partcv[0] = 1;
  Object opresult1759 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1759 (depth = 8)
  int op_slot_left_1754 = gc_frame_newslot(opresult1759);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1760 = callmethod(opresult1759, "++(1)", 1, partcv, params);
// compiled op node returning opresult1760 (depth = 7)
  int op_slot_left_1746 = gc_frame_newslot(opresult1760);
  params[0] = call1752;
  partcv[0] = 1;
  Object opresult1761 = callmethod(opresult1760, "++(1)", 1, partcv, params);
// compiled op node returning opresult1761 (depth = 6)
  *var_s = opresult1761;
  if (opresult1761 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1782(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1784 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1786 = alloc_Float64(1);
// compiled num node returning num1786 (depth = 9)
  int op_slot_right_1785 = gc_frame_newslot(num1786);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1785 = gc_frame_newslot(*var_depth);
  params[0] = num1786;
  partcv[0] = 1;
  Object sum1788 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1788 (depth = 8)
  gc_frame_newslot(sum1788);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1788;
  partcv[0] = 1;
  Object call1789 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1784);
// compiled call node returning call1789 (depth = 7)
  int op_slot_right_1783 = gc_frame_newslot(call1789);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1791 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1794 == NULL) {
    strlit1794 = alloc_String("""\x0a""  ");
    gc_root(strlit1794);
  }
// compiled string node returning strlit1794 (depth = 9)
  int op_slot_right_1793 = gc_frame_newslot(strlit1794);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1793 = gc_frame_newslot(*var_s);
  params[0] = strlit1794;
  partcv[0] = 1;
  Object opresult1796 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1796 (depth = 8)
  int op_slot_left_1791 = gc_frame_newslot(opresult1796);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1797 = callmethod(opresult1796, "++(1)", 1, partcv, params);
// compiled op node returning opresult1797 (depth = 7)
  int op_slot_left_1783 = gc_frame_newslot(opresult1797);
  params[0] = call1789;
  partcv[0] = 1;
  Object opresult1798 = callmethod(opresult1797, "++(1)", 1, partcv, params);
// compiled op node returning opresult1798 (depth = 6)
  *var_s = opresult1798;
  if (opresult1798 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_1711(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1712 == NULL) {
    strlit1712 = alloc_String("");
    gc_root(strlit1712);
  }
// compiled string node returning strlit1712 (depth = 4)
  *var_spc = strlit1712;
  if (strlit1712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1713 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1714 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num1716 = alloc_Float64(0);
// compiled num node returning num1716 (depth = 5)
  int op_slot_left_1714 = gc_frame_newslot(num1716);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1717 = callmethod(num1716, "..(1)", 1, partcv, params);
// compiled op node returning opresult1717 (depth = 4)
  gc_frame_newslot(opresult1717);
// starting to compile block node (depth = 4)
  Object block1718 = alloc_Block(NULL, NULL, "ast", 384);
  gc_frame_newslot(block1718);
// method "_apply(_)"
  block_savedest(block1718);
  Object closure1719 = createclosure(2, "_apply(1)");
  setclosureframe(closure1719, stackframe);
  addtoclosure(closure1719, var_spc);
  addtoclosure(closure1719, selfslot);
  struct UserObject *uo1719 = (struct UserObject*)block1718;
  uo1719->data[0] = (Object)closure1719;
  Method *meth_meth_ast__apply_40_1_41_1719 = addmethod2pos(block1718, "_apply(1)", &meth_ast__apply_40_1_41_1719, 0);
  int argcv_meth_ast__apply_40_1_41_1719[] = {1};
  meth_meth_ast__apply_40_1_41_1719->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1719);
  meth_meth_ast__apply_40_1_41_1719->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1719->definitionLine = 2969;
// compiled block node returning block1718 (depth = 4)
  gc_frame_newslot(block1718);
// call case 5: prelude request
  params[0] = opresult1717;
  params[1] = block1718;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1726 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1713);
// compiled call node returning call1726 (depth = 3)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1728 == NULL) {
    strlit1728 = alloc_String("""\x0a""");
    gc_root(strlit1728);
  }
// compiled string node returning strlit1728 (depth = 5)
  int op_slot_right_1727 = gc_frame_newslot(strlit1728);
// starting to compile call node (depth = 5)
  int callframe1730 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1731 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1730);
// compiled call node returning call1731 (depth = 5)
  int op_slot_left_1727 = gc_frame_newslot(call1731);
  params[0] = strlit1728;
  partcv[0] = 1;
  Object opresult1732 = callmethod(call1731, "++(1)", 1, partcv, params);
// compiled op node returning opresult1732 (depth = 4)
  *var_s = opresult1732;
  if (opresult1732 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1734 == NULL) {
    strlit1734 = alloc_String("Parameters:");
    gc_root(strlit1734);
  }
// compiled string node returning strlit1734 (depth = 5)
  int op_slot_right_1733 = gc_frame_newslot(strlit1734);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1736 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1736 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1738 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1738 (depth = 5)
  int op_slot_left_1733 = gc_frame_newslot(opresult1738);
  params[0] = strlit1734;
  partcv[0] = 1;
  Object opresult1739 = callmethod(opresult1738, "++(1)", 1, partcv, params);
// compiled op node returning opresult1739 (depth = 4)
  *var_s = opresult1739;
  if (opresult1739 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1741 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1742 = gc_frame_new();
// call case 4: self request
  Object call1743 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1742);
// compiled member node returning call1743 (depth = 4)
  gc_frame_newslot(call1743);
// starting to compile block node (depth = 4)
  Object block1744 = alloc_Block(NULL, NULL, "ast", 389);
  gc_frame_newslot(block1744);
// method "_apply(_)"
  block_savedest(block1744);
  Object closure1745 = createclosure(4, "_apply(1)");
  setclosureframe(closure1745, stackframe);
  addtoclosure(closure1745, var_depth);
  addtoclosure(closure1745, var_spc);
  addtoclosure(closure1745, var_s);
  addtoclosure(closure1745, selfslot);
  struct UserObject *uo1745 = (struct UserObject*)block1744;
  uo1745->data[0] = (Object)closure1745;
  Method *meth_meth_ast__apply_40_1_41_1745 = addmethod2pos(block1744, "_apply(1)", &meth_ast__apply_40_1_41_1745, 0);
  int argcv_meth_ast__apply_40_1_41_1745[] = {1};
  meth_meth_ast__apply_40_1_41_1745->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1745);
  meth_meth_ast__apply_40_1_41_1745->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1745->definitionLine = 2969;
// compiled block node returning block1744 (depth = 4)
  gc_frame_newslot(block1744);
// call case 5: prelude request
  params[0] = call1743;
  params[1] = block1744;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1764 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1741);
// compiled call node returning call1764 (depth = 3)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1766 == NULL) {
    strlit1766 = alloc_String("""\x0a""");
    gc_root(strlit1766);
  }
// compiled string node returning strlit1766 (depth = 5)
  int op_slot_right_1765 = gc_frame_newslot(strlit1766);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1765 = gc_frame_newslot(*var_s);
  params[0] = strlit1766;
  partcv[0] = 1;
  Object opresult1768 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1768 (depth = 4)
  *var_s = opresult1768;
  if (opresult1768 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1771 == NULL) {
    strlit1771 = alloc_String("Body:");
    gc_root(strlit1771);
  }
// compiled string node returning strlit1771 (depth = 5)
  int op_slot_right_1770 = gc_frame_newslot(strlit1771);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1773 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1773 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1775 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1775 (depth = 5)
  int op_slot_left_1770 = gc_frame_newslot(opresult1775);
  params[0] = strlit1771;
  partcv[0] = 1;
  Object opresult1776 = callmethod(opresult1775, "++(1)", 1, partcv, params);
// compiled op node returning opresult1776 (depth = 4)
  *var_s = opresult1776;
  if (opresult1776 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1778 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1779 = gc_frame_new();
// call case 4: self request
  Object call1780 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1779);
// compiled member node returning call1780 (depth = 4)
  gc_frame_newslot(call1780);
// starting to compile block node (depth = 4)
  Object block1781 = alloc_Block(NULL, NULL, "ast", 394);
  gc_frame_newslot(block1781);
// method "_apply(_)"
  block_savedest(block1781);
  Object closure1782 = createclosure(4, "_apply(1)");
  setclosureframe(closure1782, stackframe);
  addtoclosure(closure1782, var_depth);
  addtoclosure(closure1782, var_spc);
  addtoclosure(closure1782, var_s);
  addtoclosure(closure1782, selfslot);
  struct UserObject *uo1782 = (struct UserObject*)block1781;
  uo1782->data[0] = (Object)closure1782;
  Method *meth_meth_ast__apply_40_1_41_1782 = addmethod2pos(block1781, "_apply(1)", &meth_ast__apply_40_1_41_1782, 0);
  int argcv_meth_ast__apply_40_1_41_1782[] = {1};
  meth_meth_ast__apply_40_1_41_1782->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1782);
  meth_meth_ast__apply_40_1_41_1782->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1782->definitionLine = 2969;
// compiled block node returning block1781 (depth = 4)
  gc_frame_newslot(block1781);
// call case 5: prelude request
  params[0] = call1780;
  params[1] = block1781;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1801 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1778);
// compiled call node returning call1801 (depth = 3)
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1804 = gc_frame_new();
// call case 4: self request
  Object call1805 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1804);
// compiled member node returning call1805 (depth = 5)
  int op_slot_right_1803 = gc_frame_newslot(call1805);
// starting to compile identifier node (depth = 5)
  Object bool1807 = alloc_Boolean(0);
// compiled identifier node returning bool1807 (depth = 5)
  int op_slot_left_1803 = gc_frame_newslot(bool1807);
  params[0] = call1805;
  partcv[0] = 1;
  Object opresult1808 = callmethod(bool1807, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1808 (depth = 4)
  Object if1802 = done;
  if (istrue(opresult1808)) {
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1810 == NULL) {
    strlit1810 = alloc_String("""\x0a""");
    gc_root(strlit1810);
  }
// compiled string node returning strlit1810 (depth = 6)
  int op_slot_right_1809 = gc_frame_newslot(strlit1810);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1809 = gc_frame_newslot(*var_s);
  params[0] = strlit1810;
  partcv[0] = 1;
  Object opresult1812 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1812 (depth = 5)
  *var_s = opresult1812;
  if (opresult1812 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1815 == NULL) {
    strlit1815 = alloc_String("Pattern:");
    gc_root(strlit1815);
  }
// compiled string node returning strlit1815 (depth = 6)
  int op_slot_right_1814 = gc_frame_newslot(strlit1815);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1817 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1817 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1819 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1819 (depth = 6)
  int op_slot_left_1814 = gc_frame_newslot(opresult1819);
  params[0] = strlit1815;
  partcv[0] = 1;
  Object opresult1820 = callmethod(opresult1819, "++(1)", 1, partcv, params);
// compiled op node returning opresult1820 (depth = 5)
  *var_s = opresult1820;
  if (opresult1820 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1823 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1825 = alloc_Float64(1);
// compiled num node returning num1825 (depth = 8)
  int op_slot_right_1824 = gc_frame_newslot(num1825);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_1824 = gc_frame_newslot(*var_depth);
  params[0] = num1825;
  partcv[0] = 1;
  Object sum1827 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1827 (depth = 7)
  gc_frame_newslot(sum1827);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1828 = gc_frame_new();
// call case 4: self request
  Object call1829 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1828);
// compiled member node returning call1829 (depth = 7)
  params[0] = sum1827;
  partcv[0] = 1;
  Object call1830 = callmethodflags(call1829, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1823);
// compiled call node returning call1830 (depth = 6)
  int op_slot_right_1822 = gc_frame_newslot(call1830);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1832 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1835 == NULL) {
    strlit1835 = alloc_String("""\x0a""  ");
    gc_root(strlit1835);
  }
// compiled string node returning strlit1835 (depth = 8)
  int op_slot_right_1834 = gc_frame_newslot(strlit1835);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1834 = gc_frame_newslot(*var_s);
  params[0] = strlit1835;
  partcv[0] = 1;
  Object opresult1837 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1837 (depth = 7)
  int op_slot_left_1832 = gc_frame_newslot(opresult1837);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1838 = callmethod(opresult1837, "++(1)", 1, partcv, params);
// compiled op node returning opresult1838 (depth = 6)
  int op_slot_left_1822 = gc_frame_newslot(opresult1838);
  params[0] = call1830;
  partcv[0] = 1;
  Object opresult1839 = callmethod(opresult1838, "++(1)", 1, partcv, params);
// compiled op node returning opresult1839 (depth = 5)
  *var_s = opresult1839;
  if (opresult1839 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1802 = done;
  } else {
  }
// compiled if node returning if1802 (depth = 3)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1845(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1847 == NULL) {
    strlit1847 = alloc_String("    ");
    gc_root(strlit1847);
  }
// compiled string node returning strlit1847 (depth = 7)
  int op_slot_right_1846 = gc_frame_newslot(strlit1847);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1846 = gc_frame_newslot(*var_spc);
  params[0] = strlit1847;
  partcv[0] = 1;
  Object opresult1849 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult1849 (depth = 6)
  *var_spc = opresult1849;
  if (opresult1849 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1874(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1875 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1876 = gc_frame_new();
// call case 4: self request
  Object call1877 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1876);
// compiled member node returning call1877 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1878 = callmethodflags(call1877, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1875);
// compiled call node returning call1878 (depth = 7)
  *var_p = call1878;
  if (call1878 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1881 = gc_frame_new();
// call case 4: self request
  Object call1882 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1881);
// compiled member node returning call1882 (depth = 8)
  int op_slot_right_1880 = gc_frame_newslot(call1882);
// starting to compile identifier node (depth = 8)
  Object bool1884 = alloc_Boolean(0);
// compiled identifier node returning bool1884 (depth = 8)
  int op_slot_left_1880 = gc_frame_newslot(bool1884);
  params[0] = call1882;
  partcv[0] = 1;
  Object opresult1885 = callmethod(bool1884, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1885 (depth = 7)
  Object if1879 = done;
  if (istrue(opresult1885)) {
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1887 == NULL) {
    strlit1887 = alloc_String(")");
    gc_root(strlit1887);
  }
// compiled string node returning strlit1887 (depth = 9)
  int op_slot_right_1886 = gc_frame_newslot(strlit1887);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1890 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num1891 = alloc_Float64(0);
// compiled num node returning num1891 (depth = 11)
  gc_frame_newslot(num1891);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = num1891;
  partcv[0] = 1;
  Object call1892 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1890);
// compiled call node returning call1892 (depth = 10)
  int op_slot_right_1889 = gc_frame_newslot(call1892);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1895 == NULL) {
    strlit1895 = alloc_String("(");
    gc_root(strlit1895);
  }
// compiled string node returning strlit1895 (depth = 11)
  int op_slot_right_1894 = gc_frame_newslot(strlit1895);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1894 = gc_frame_newslot(*var_s);
  params[0] = strlit1895;
  partcv[0] = 1;
  Object opresult1897 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1897 (depth = 10)
  int op_slot_left_1889 = gc_frame_newslot(opresult1897);
  params[0] = call1892;
  partcv[0] = 1;
  Object opresult1898 = callmethod(opresult1897, "++(1)", 1, partcv, params);
// compiled op node returning opresult1898 (depth = 9)
  int op_slot_left_1886 = gc_frame_newslot(opresult1898);
  params[0] = strlit1887;
  partcv[0] = 1;
  Object opresult1899 = callmethod(opresult1898, "++(1)", 1, partcv, params);
// compiled op node returning opresult1899 (depth = 8)
  *var_s = opresult1899;
  if (opresult1899 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1879 = done;
  } else {
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1902 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num1903 = alloc_Float64(0);
// compiled num node returning num1903 (depth = 10)
  gc_frame_newslot(num1903);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  params[0] = num1903;
  partcv[0] = 1;
  Object call1904 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1902);
// compiled call node returning call1904 (depth = 9)
  int op_slot_right_1901 = gc_frame_newslot(call1904);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1901 = gc_frame_newslot(*var_s);
  params[0] = call1904;
  partcv[0] = 1;
  Object opresult1906 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1906 (depth = 8)
  *var_s = opresult1906;
  if (opresult1906 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1879 = done;
  }
// compiled if node returning if1879 (depth = 6)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1910 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1911 = gc_frame_new();
// call case 4: self request
  Object call1912 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1911);
// compiled member node returning call1912 (depth = 9)
  Object call1913 = callmethodflags(call1912, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1910);
// compiled member node returning call1913 (depth = 8)
  int op_slot_right_1909 = gc_frame_newslot(call1913);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_1909 = gc_frame_newslot(*var_i);
  params[0] = call1913;
  partcv[0] = 1;
  Object opresult1915 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1915 (depth = 7)
  Object if1908 = done;
  if (istrue(opresult1915)) {
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1917 == NULL) {
    strlit1917 = alloc_String(", ");
    gc_root(strlit1917);
  }
// compiled string node returning strlit1917 (depth = 9)
  int op_slot_right_1916 = gc_frame_newslot(strlit1917);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1916 = gc_frame_newslot(*var_s);
  params[0] = strlit1917;
  partcv[0] = 1;
  Object opresult1919 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1919 (depth = 8)
  *var_s = opresult1919;
  if (opresult1919 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1908 = done;
  } else {
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1922 == NULL) {
    strlit1922 = alloc_String(" ""\xe2""""\x86""""\x92""");
    gc_root(strlit1922);
  }
// compiled string node returning strlit1922 (depth = 9)
  int op_slot_right_1921 = gc_frame_newslot(strlit1922);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1921 = gc_frame_newslot(*var_s);
  params[0] = strlit1922;
  partcv[0] = 1;
  Object opresult1924 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1924 (depth = 8)
  *var_s = opresult1924;
  if (opresult1924 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1908 = done;
  }
// compiled if node returning if1908 (depth = 6)
  gc_frame_end(frame);
  return if1908;
}
Object meth_ast__apply_40_1_41_1932(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1934 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1936 = alloc_Float64(1);
// compiled num node returning num1936 (depth = 9)
  int op_slot_right_1935 = gc_frame_newslot(num1936);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1935 = gc_frame_newslot(*var_depth);
  params[0] = num1936;
  partcv[0] = 1;
  Object sum1938 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1938 (depth = 8)
  gc_frame_newslot(sum1938);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1938;
  partcv[0] = 1;
  Object call1939 = callmethodflags(*var_mx, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1934);
// compiled call node returning call1939 (depth = 7)
  int op_slot_right_1933 = gc_frame_newslot(call1939);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1941 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1944 == NULL) {
    strlit1944 = alloc_String("""\x0a""");
    gc_root(strlit1944);
  }
// compiled string node returning strlit1944 (depth = 9)
  int op_slot_right_1943 = gc_frame_newslot(strlit1944);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1943 = gc_frame_newslot(*var_s);
  params[0] = strlit1944;
  partcv[0] = 1;
  Object opresult1946 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1946 (depth = 8)
  int op_slot_left_1941 = gc_frame_newslot(opresult1946);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1947 = callmethod(opresult1946, "++(1)", 1, partcv, params);
// compiled op node returning opresult1947 (depth = 7)
  int op_slot_left_1933 = gc_frame_newslot(opresult1947);
  params[0] = call1939;
  partcv[0] = 1;
  Object opresult1948 = callmethod(opresult1947, "++(1)", 1, partcv, params);
// compiled op node returning opresult1948 (depth = 6)
  *var_s = opresult1948;
  if (opresult1948 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1963(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1965 == NULL) {
    strlit1965 = alloc_String("    ");
    gc_root(strlit1965);
  }
// compiled string node returning strlit1965 (depth = 7)
  int op_slot_right_1964 = gc_frame_newslot(strlit1965);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1964 = gc_frame_newslot(*var_s);
  params[0] = strlit1965;
  partcv[0] = 1;
  Object opresult1967 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1967 (depth = 6)
  *var_s = opresult1967;
  if (opresult1967 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_1841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1842 == NULL) {
    strlit1842 = alloc_String("");
    gc_root(strlit1842);
  }
// compiled string node returning strlit1842 (depth = 4)
  *var_spc = strlit1842;
  if (strlit1842 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1843 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block1844 = alloc_Block(NULL, NULL, "ast", 406);
  gc_frame_newslot(block1844);
// method "_apply"
  block_savedest(block1844);
  Object closure1845 = createclosure(2, "_apply");
  setclosureframe(closure1845, stackframe);
  addtoclosure(closure1845, var_spc);
  addtoclosure(closure1845, selfslot);
  struct UserObject *uo1845 = (struct UserObject*)block1844;
  uo1845->data[0] = (Object)closure1845;
  Method *meth_meth_ast__apply1845 = addmethod2pos(block1844, "_apply", &meth_ast__apply1845, 0);
  int argcv_meth_ast__apply1845[] = {0};
  meth_meth_ast__apply1845->type = alloc_MethodType(1, argcv_meth_ast__apply1845);
  meth_meth_ast__apply1845->definitionModule = modulename;
  meth_meth_ast__apply1845->definitionLine = 2969;
// compiled block node returning block1844 (depth = 4)
  gc_frame_newslot(block1844);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block1844;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1852 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1843);
// compiled call node returning call1852 (depth = 3)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1853 == NULL) {
    strlit1853 = alloc_String("{");
    gc_root(strlit1853);
  }
// compiled string node returning strlit1853 (depth = 4)
  *var_s = strlit1853;
  if (strlit1853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1856 = alloc_Float64(0);
// compiled num node returning num1856 (depth = 5)
  int op_slot_right_1855 = gc_frame_newslot(num1856);
// starting to compile member node (depth = 5)
  int callframe1858 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1859 = gc_frame_new();
// call case 4: self request
  Object call1860 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1859);
// compiled member node returning call1860 (depth = 6)
  Object call1861 = callmethodflags(call1860, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1858);
// compiled member node returning call1861 (depth = 5)
  int op_slot_left_1855 = gc_frame_newslot(call1861);
  params[0] = num1856;
  partcv[0] = 1;
  Object opresult1862 = callmethod(call1861, ">(1)", 1, partcv, params);
// compiled op node returning opresult1862 (depth = 4)
  Object if1854 = done;
  if (istrue(opresult1862)) {
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1864 == NULL) {
    strlit1864 = alloc_String(" ");
    gc_root(strlit1864);
  }
// compiled string node returning strlit1864 (depth = 6)
  int op_slot_right_1863 = gc_frame_newslot(strlit1864);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1863 = gc_frame_newslot(*var_s);
  params[0] = strlit1864;
  partcv[0] = 1;
  Object opresult1866 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1866 (depth = 5)
  *var_s = opresult1866;
  if (opresult1866 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1868 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1869 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1870 = gc_frame_new();
// call case 4: self request
  Object call1871 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1870);
// compiled member node returning call1871 (depth = 6)
  Object call1872 = callmethodflags(call1871, "indices", 0, partcv, params, 0);
  gc_frame_end(callframe1869);
// compiled member node returning call1872 (depth = 5)
  gc_frame_newslot(call1872);
// starting to compile block node (depth = 5)
  Object block1873 = alloc_Block(NULL, NULL, "ast", 412);
  gc_frame_newslot(block1873);
// method "_apply(_)"
  block_savedest(block1873);
  Object closure1874 = createclosure(2, "_apply(1)");
  setclosureframe(closure1874, stackframe);
  addtoclosure(closure1874, var_s);
  addtoclosure(closure1874, selfslot);
  struct UserObject *uo1874 = (struct UserObject*)block1873;
  uo1874->data[0] = (Object)closure1874;
  Method *meth_meth_ast__apply_40_1_41_1874 = addmethod2pos(block1873, "_apply(1)", &meth_ast__apply_40_1_41_1874, 0);
  int argcv_meth_ast__apply_40_1_41_1874[] = {1};
  meth_meth_ast__apply_40_1_41_1874->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1874);
  meth_meth_ast__apply_40_1_41_1874->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1874->definitionLine = 2969;
// compiled block node returning block1873 (depth = 5)
  gc_frame_newslot(block1873);
// call case 5: prelude request
  params[0] = call1872;
  params[1] = block1873;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1927 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1868);
// compiled call node returning call1927 (depth = 4)
    gc_frame_newslot(call1927);
    if1854 = call1927;
  } else {
  }
// compiled if node returning if1854 (depth = 3)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1928 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1929 = gc_frame_new();
// call case 4: self request
  Object call1930 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1929);
// compiled member node returning call1930 (depth = 4)
  gc_frame_newslot(call1930);
// starting to compile block node (depth = 4)
  Object block1931 = alloc_Block(NULL, NULL, "ast", 426);
  gc_frame_newslot(block1931);
// method "_apply(_)"
  block_savedest(block1931);
  Object closure1932 = createclosure(4, "_apply(1)");
  setclosureframe(closure1932, stackframe);
  addtoclosure(closure1932, var_depth);
  addtoclosure(closure1932, var_spc);
  addtoclosure(closure1932, var_s);
  addtoclosure(closure1932, selfslot);
  struct UserObject *uo1932 = (struct UserObject*)block1931;
  uo1932->data[0] = (Object)closure1932;
  Method *meth_meth_ast__apply_40_1_41_1932 = addmethod2pos(block1931, "_apply(1)", &meth_ast__apply_40_1_41_1932, 0);
  int argcv_meth_ast__apply_40_1_41_1932[] = {1};
  meth_meth_ast__apply_40_1_41_1932->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1932);
  meth_meth_ast__apply_40_1_41_1932->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1932->definitionLine = 2969;
// compiled block node returning block1931 (depth = 4)
  gc_frame_newslot(block1931);
// call case 5: prelude request
  params[0] = call1930;
  params[1] = block1931;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1951 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1928);
// compiled call node returning call1951 (depth = 3)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1953 == NULL) {
    strlit1953 = alloc_String("""\x0a""");
    gc_root(strlit1953);
  }
// compiled string node returning strlit1953 (depth = 5)
  int op_slot_right_1952 = gc_frame_newslot(strlit1953);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1952 = gc_frame_newslot(*var_s);
  params[0] = strlit1953;
  partcv[0] = 1;
  Object opresult1955 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1955 (depth = 4)
  *var_s = opresult1955;
  if (opresult1955 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1957 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1959 = alloc_Float64(1);
// compiled num node returning num1959 (depth = 5)
  int op_slot_right_1958 = gc_frame_newslot(num1959);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_1958 = gc_frame_newslot(*var_depth);
  params[0] = num1959;
  partcv[0] = 1;
  Object diff1961 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff1961 (depth = 4)
  gc_frame_newslot(diff1961);
// starting to compile block node (depth = 4)
  Object block1962 = alloc_Block(NULL, NULL, "ast", 430);
  gc_frame_newslot(block1962);
// method "_apply"
  block_savedest(block1962);
  Object closure1963 = createclosure(2, "_apply");
  setclosureframe(closure1963, stackframe);
  addtoclosure(closure1963, var_s);
  addtoclosure(closure1963, selfslot);
  struct UserObject *uo1963 = (struct UserObject*)block1962;
  uo1963->data[0] = (Object)closure1963;
  Method *meth_meth_ast__apply1963 = addmethod2pos(block1962, "_apply", &meth_ast__apply1963, 0);
  int argcv_meth_ast__apply1963[] = {0};
  meth_meth_ast__apply1963->type = alloc_MethodType(1, argcv_meth_ast__apply1963);
  meth_meth_ast__apply1963->definitionModule = modulename;
  meth_meth_ast__apply1963->definitionLine = 2969;
// compiled block node returning block1962 (depth = 4)
  gc_frame_newslot(block1962);
// call case 5: prelude request
  params[0] = diff1961;
  params[1] = block1962;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1970 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1957);
// compiled call node returning call1970 (depth = 3)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1972 == NULL) {
    strlit1972 = alloc_String("}");
    gc_root(strlit1972);
  }
// compiled string node returning strlit1972 (depth = 4)
  int op_slot_right_1971 = gc_frame_newslot(strlit1972);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_1971 = gc_frame_newslot(*var_s);
  params[0] = strlit1972;
  partcv[0] = 1;
  Object opresult1974 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1974 (depth = 3)
  gc_frame_end(frame);
  return opresult1974;
}
Object meth_ast_shallowCopy1975(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1976 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe1977 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1978 = gc_frame_new();
// call case 4: self request
  Object call1979 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1978);
// compiled member node returning call1979 (depth = 5)
  gc_frame_newslot(call1979);
// starting to compile member node (depth = 5)
  int callframe1980 = gc_frame_new();
// call case 4: self request
  Object call1981 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1980);
// compiled member node returning call1981 (depth = 5)
  gc_frame_newslot(call1981);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blockNode (depth = 5)
  params[0] = call1979;
  params[1] = call1981;
  partcv[0] = 2;
  Object call1982 = callmethodflags(*var_blockNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1977);
// compiled call node returning call1982 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1983 = callmethodflags(call1982, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1976);
// compiled call node returning call1983 (depth = 3)
  gc_frame_end(frame);
  return call1983;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_1984(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1985 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1986 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1985);
// compiled call node returning call1986 (depth = 3)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1987 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call1989 = callmethodflags(*var_other, "matchingPattern", 0, partcv, params, 0);
  gc_frame_end(callframe1988);
// compiled member node returning call1989 (depth = 4)
  gc_frame_newslot(call1989);
// call case 4: self request
  params[0] = call1989;
  partcv[0] = 1;
  Object call1990 = callmethodflags(self, "matchingPattern:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1987);
// compiled call node returning call1990 (depth = 3)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1991 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1992 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call1993 = callmethodflags(*var_other, "extraRuntimeData", 0, partcv, params, 0);
  gc_frame_end(callframe1992);
// compiled member node returning call1993 (depth = 4)
  gc_frame_newslot(call1993);
// call case 4: self request
  params[0] = call1993;
  partcv[0] = 1;
  Object call1994 = callmethodflags(self, "extraRuntimeData:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1991);
// compiled call node returning call1994 (depth = 3)
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply_40_1_41_2008(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2009 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_patternMarkVisitor (depth = 6)
  gc_frame_newslot(*var_patternMarkVisitor);
// starting to compile call node (depth = 6)
  int callframe2010 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ancestorChain (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call2011 = callmethodflags(*var_ancestorChain, "with(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2010);
// compiled call node returning call2011 (depth = 6)
  gc_frame_newslot(call2011);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  params[0] = *var_patternMarkVisitor;
  params[1] = call2011;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2012 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2009);
// compiled call node returning call2012 (depth = 5)
  gc_frame_end(frame);
  return call2012;
}
Object meth_ast_new_40_2_41_1557(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1558 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1558 = alloc_userobj2(28,25, objclass1558);
  gc_frame_newslot(obj1558);
if (objclass1558 == NULL) {
  glfree(obj1558->class->name);
  obj1558->class->name = "blockNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1558, self, 0);
  addmethodreal(obj1558,"outer", &reader_ast_outer_1559);
  Object oldself1558 = self;
  struct StackFrameObject *oldstackframe1558 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1558);
  gc_frame_newslot((Object)stackframe);
  self = obj1558;
  Object *oldselfslot1558 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1558 = (*(struct UserObject *)self).data[0], lowerouter1558 = thisouter1558;
  if (inheritingObject1558) {
    struct UserObject *inho1558 = (struct UserObject *)inheritingObject1558;
    while (inho1558->super != GraceDefaultObject) inho1558 = (struct UserObject *)inho1558->super;
    inho1558->super = obj1558;
    self = inheritingObject1558;
    *selfslot = self;
    lowerouter1558 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1558;
  }
if (objclass1558 == NULL) {
  Method *reader1560 = addmethodrealflags(obj1558, "kind",&reader_ast_kind_1560, MFLAG_DEF);
  reader1560->definitionModule = modulename;
  reader1560->definitionLine = 328;
}
adddatum2(obj1558, alloc_Undefined(), 1);
if (objclass1558 == NULL) {
  Method *reader1561 = addmethodrealflags(obj1558, "value",&reader_ast_value_1561, MFLAG_DEF);
  reader1561->definitionModule = modulename;
  reader1561->definitionLine = 329;
}
adddatum2(obj1558, alloc_Undefined(), 2);
if (objclass1558 == NULL) {
  Method *reader1562 = addmethodrealflags(obj1558, "params", &reader_ast_params_1562, 0);
  Method *writer1562 = addmethodrealflags(obj1558, "params:=(1)", &writer_ast_params_1562, 0);
  reader1562->definitionModule = modulename;
  writer1562->definitionModule = modulename;
  reader1562->definitionLine = 330;
  writer1562->definitionLine = 330;
}
obj1558->flags |= OFLAG_MUTABLE;
adddatum2(obj1558, alloc_Undefined(), 3);
if (objclass1558 == NULL) {
  Method *reader1563 = addmethodrealflags(obj1558, "body", &reader_ast_body_1563, 0);
  Method *writer1563 = addmethodrealflags(obj1558, "body:=(1)", &writer_ast_body_1563, 0);
  reader1563->definitionModule = modulename;
  writer1563->definitionModule = modulename;
  reader1563->definitionLine = 331;
  writer1563->definitionLine = 331;
}
obj1558->flags |= OFLAG_MUTABLE;
adddatum2(obj1558, alloc_Undefined(), 4);
if (objclass1558 == NULL) {
  Method *reader1564 = addmethodrealflags(obj1558, "selfclosure",&reader_ast_selfclosure_1564, MFLAG_DEF);
  reader1564->definitionModule = modulename;
  reader1564->definitionLine = 332;
}
adddatum2(obj1558, alloc_Undefined(), 5);
if (objclass1558 == NULL) {
  Method *reader1565 = addmethodrealflags(obj1558, "matchingPattern", &reader_ast_matchingPattern_1565, 0);
  Method *writer1565 = addmethodrealflags(obj1558, "matchingPattern:=(1)", &writer_ast_matchingPattern_1565, 0);
  reader1565->definitionModule = modulename;
  writer1565->definitionModule = modulename;
  reader1565->definitionLine = 333;
  writer1565->definitionLine = 333;
}
obj1558->flags |= OFLAG_MUTABLE;
adddatum2(obj1558, alloc_Undefined(), 6);
if (objclass1558 == NULL) {
  Method *reader1566 = addmethodrealflags(obj1558, "extraRuntimeData", &reader_ast_extraRuntimeData_1566, 0);
  Method *writer1566 = addmethodrealflags(obj1558, "extraRuntimeData:=(1)", &writer_ast_extraRuntimeData_1566, 0);
  reader1566->definitionModule = modulename;
  writer1566->definitionModule = modulename;
  reader1566->definitionLine = 334;
  writer1566->definitionLine = 334;
}
obj1558->flags |= OFLAG_MUTABLE;
adddatum2(obj1558, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo1567 = (struct UserObject*)obj1558;
  uo1567->data[8] = emptyclosure;
  Method *meth_meth_ast_isBlock1567 = addmethod2pos(obj1558, "isBlock", &meth_ast_isBlock1567, 8);
  int argcv_meth_ast_isBlock1567[] = {0};
  meth_meth_ast_isBlock1567->type = alloc_MethodType(1, argcv_meth_ast_isBlock1567);
  meth_meth_ast_isBlock1567->definitionModule = modulename;
  meth_meth_ast_isBlock1567->definitionLine = 338;
// method "isDelimited"
  struct UserObject *uo1569 = (struct UserObject*)obj1558;
  uo1569->data[9] = emptyclosure;
  Method *meth_meth_ast_isDelimited1569 = addmethod2pos(obj1558, "isDelimited", &meth_ast_isDelimited1569, 9);
  int argcv_meth_ast_isDelimited1569[] = {0};
  meth_meth_ast_isDelimited1569->type = alloc_MethodType(1, argcv_meth_ast_isDelimited1569);
  meth_meth_ast_isDelimited1569->definitionModule = modulename;
  meth_meth_ast_isDelimited1569->definitionLine = 339;
// method "isEmpty"
  struct UserObject *uo1571 = (struct UserObject*)obj1558;
  uo1571->data[10] = emptyclosure;
  Method *meth_meth_ast_isEmpty1571 = addmethod2pos(obj1558, "isEmpty", &meth_ast_isEmpty1571, 10);
  int argcv_meth_ast_isEmpty1571[] = {0};
  meth_meth_ast_isEmpty1571->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1571);
  meth_meth_ast_isEmpty1571->definitionModule = modulename;
  meth_meth_ast_isEmpty1571->definitionLine = 340;
// method "isntEmpty"
  struct UserObject *uo1580 = (struct UserObject*)obj1558;
  uo1580->data[11] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1580 = addmethod2pos(obj1558, "isntEmpty", &meth_ast_isntEmpty1580, 11);
  int argcv_meth_ast_isntEmpty1580[] = {0};
  meth_meth_ast_isntEmpty1580->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1580);
  meth_meth_ast_isntEmpty1580->definitionModule = modulename;
  meth_meth_ast_isntEmpty1580->definitionLine = 341;
// method "scope:=(_)"
  struct UserObject *uo1589 = (struct UserObject*)obj1558;
  uo1589->data[12] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_1589 = addmethod2pos(obj1558, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_1589, 12);
  int argcv_meth_ast_scope_58__61__40_1_41_1589[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_1589->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_1589);
  meth_meth_ast_scope_58__61__40_1_41_1589->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_1589->definitionLine = 342;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj1558);
  Object closure1594 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure1594, stackframe);
  addtoclosure(closure1594, var_k);
  struct UserObject *uo1594 = (struct UserObject*)obj1558;
  uo1594->data[13] = (Object)closure1594;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_1594 = addmethod2pos(obj1558, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_1594, 13);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_1594[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1594->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_1594);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1594->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1594->definitionLine = 348;
// method "isMatchingBlock"
  struct UserObject *uo1597 = (struct UserObject*)obj1558;
  uo1597->data[14] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1597 = addmethod2pos(obj1558, "isMatchingBlock", &meth_ast_isMatchingBlock1597, 14);
  int argcv_meth_ast_isMatchingBlock1597[] = {0};
  meth_meth_ast_isMatchingBlock1597->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1597);
  meth_meth_ast_isMatchingBlock1597->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1597->definitionLine = 349;
// method "returnsObject"
  struct UserObject *uo1606 = (struct UserObject*)obj1558;
  uo1606->data[15] = emptyclosure;
  Method *meth_meth_ast_returnsObject1606 = addmethod2pos(obj1558, "returnsObject", &meth_ast_returnsObject1606, 15);
  int argcv_meth_ast_returnsObject1606[] = {0};
  meth_meth_ast_returnsObject1606->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1606);
  meth_meth_ast_returnsObject1606->definitionModule = modulename;
  meth_meth_ast_returnsObject1606->definitionLine = 350;
// method "returnedObjectScope"
  struct UserObject *uo1627 = (struct UserObject*)obj1558;
  uo1627->data[16] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1627 = addmethod2pos(obj1558, "returnedObjectScope", &meth_ast_returnedObjectScope1627, 16);
  int argcv_meth_ast_returnedObjectScope1627[] = {0};
  meth_meth_ast_returnedObjectScope1627->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1627);
  meth_meth_ast_returnedObjectScope1627->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1627->definitionLine = 353;
// method "parametersDo(_)"
  struct UserObject *uo1634 = (struct UserObject*)obj1558;
  uo1634->data[17] = emptyclosure;
  Method *meth_meth_ast_parametersDo_40_1_41_1634 = addmethod2pos(obj1558, "parametersDo(1)", &meth_ast_parametersDo_40_1_41_1634, 17);
  int argcv_meth_ast_parametersDo_40_1_41_1634[] = {1};
  meth_meth_ast_parametersDo_40_1_41_1634->type = alloc_MethodType(1, argcv_meth_ast_parametersDo_40_1_41_1634);
  meth_meth_ast_parametersDo_40_1_41_1634->definitionModule = modulename;
  meth_meth_ast_parametersDo_40_1_41_1634->definitionLine = 357;
// method "accept(_)from(_)"
  struct UserObject *uo1639 = (struct UserObject*)obj1558;
  uo1639->data[18] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1639 = addmethod2pos(obj1558, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1639, 18);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1639[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1639->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1639);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1639->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1639->definitionLine = 360;
// method "map(_)ancestors(_)"
  struct UserObject *uo1674 = (struct UserObject*)obj1558;
  uo1674->data[19] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1674 = addmethod2pos(obj1558, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1674, 19);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1674[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1674->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1674);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1674->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1674->definitionLine = 374;
// method "pretty(_)"
  struct UserObject *uo1711 = (struct UserObject*)obj1558;
  uo1711->data[20] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_1711 = addmethod2pos(obj1558, "pretty(1)", &meth_ast_pretty_40_1_41_1711, 20);
  int argcv_meth_ast_pretty_40_1_41_1711[] = {1};
  meth_meth_ast_pretty_40_1_41_1711->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1711);
  meth_meth_ast_pretty_40_1_41_1711->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1711->definitionLine = 382;
// method "toGrace(_)"
  struct UserObject *uo1841 = (struct UserObject*)obj1558;
  uo1841->data[21] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1841 = addmethod2pos(obj1558, "toGrace(1)", &meth_ast_toGrace_40_1_41_1841, 21);
  int argcv_meth_ast_toGrace_40_1_41_1841[] = {1};
  meth_meth_ast_toGrace_40_1_41_1841->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1841);
meth_meth_ast_toGrace_40_1_41_1841->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_1841->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_1841->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1841->definitionLine = 404;
// method "shallowCopy"
  block_savedest(obj1558);
  Object closure1975 = createclosure(1, "shallowCopy");
  setclosureframe(closure1975, stackframe);
  addtoclosure(closure1975, var_blockNode);
  struct UserObject *uo1975 = (struct UserObject*)obj1558;
  uo1975->data[22] = (Object)closure1975;
  Method *meth_meth_ast_shallowCopy1975 = addmethod2pos(obj1558, "shallowCopy", &meth_ast_shallowCopy1975, 22);
  int argcv_meth_ast_shallowCopy1975[] = {0};
  meth_meth_ast_shallowCopy1975->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1975);
  meth_meth_ast_shallowCopy1975->definitionModule = modulename;
  meth_meth_ast_shallowCopy1975->definitionLine = 433;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo1984 = (struct UserObject*)obj1558;
  uo1984->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1984 = addmethod2pos(obj1558, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_1984, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1984[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1984->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1984);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1984->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1984->definitionLine = 436;
  sourceObject = obj1558;
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1995 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1996 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1997 = gc_frame_new();
// call case 3: self.outer request
  Object call1998 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1997);
// compiled member node returning call1998 (depth = 5)
  Object call1999 = callmethodflags(call1998, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1996);
// compiled member node returning call1999 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2000 = callmethodflags(call1999, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1995);
// compiled call node returning call2000 (depth = 3)
  struct UserObject *obj1558_uo = (struct UserObject *)obj1558;
  obj1558_uo->super = call2000;
  sourceObject = obj1558;
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2001 == NULL) {
    strlit2001 = alloc_String("block");
    gc_root(strlit2001);
  }
// compiled string node returning strlit2001 (depth = 3)
  adddatum2(obj1558, strlit2001, 1);
  sourceObject = obj1558;
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2002 == NULL) {
    strlit2002 = alloc_String("block");
    gc_root(strlit2002);
  }
// compiled string node returning strlit2002 (depth = 3)
  adddatum2(obj1558, strlit2002, 2);
  sourceObject = obj1558;
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj1558, *var_params_39_, 3);
  sourceObject = obj1558;
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj1558, *var_body_39_, 4);
  sourceObject = obj1558;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2003 = alloc_Boolean(1);
// compiled identifier node returning bool2003 (depth = 3)
  adddatum2(obj1558, bool2003, 5);
  sourceObject = obj1558;
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2004 = alloc_Boolean(0);
// compiled identifier node returning bool2004 (depth = 3)
  adddatum2(obj1558, bool2004, 6);
  sourceObject = obj1558;
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2005 = alloc_Boolean(0);
// compiled identifier node returning bool2005 (depth = 3)
  adddatum2(obj1558, bool2005, 7);
  sourceObject = obj1558;
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2006 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block2007 = alloc_Block(NULL, NULL, "ast", 335);
  gc_frame_newslot(block2007);
// method "_apply(_)"
  block_savedest(block2007);
  Object closure2008 = createclosure(3, "_apply(1)");
  setclosureframe(closure2008, stackframe);
  addtoclosure(closure2008, var_patternMarkVisitor);
  addtoclosure(closure2008, var_ancestorChain);
  addtoclosure(closure2008, selfslot);
  struct UserObject *uo2008 = (struct UserObject*)block2007;
  uo2008->data[0] = (Object)closure2008;
  Method *meth_meth_ast__apply_40_1_41_2008 = addmethod2pos(block2007, "_apply(1)", &meth_ast__apply_40_1_41_2008, 0);
  int argcv_meth_ast__apply_40_1_41_2008[] = {1};
  meth_meth_ast__apply_40_1_41_2008->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2008);
  meth_meth_ast__apply_40_1_41_2008->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2008->definitionLine = 2969;
// compiled block node returning block2007 (depth = 4)
  gc_frame_newslot(block2007);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block2007;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2014 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2006);
// compiled call node returning call2014 (depth = 3)
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  objclass1558 = obj1558->class;
  objclass1558->definitionModule = modulename;
  objclass1558->definitionLine = 326;
  (*(struct UserObject *)self).data[0] = lowerouter1558;
  self = oldself1558;
  selfslot = oldselfslot1558;
  stackframe = oldstackframe1558;
  gc_frame_end(frame);
  return obj1558;
}
Object meth_ast_new_40_2_41_1557_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1558 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1558 = alloc_userobj2(28,25, objclass1558);
  gc_frame_newslot(obj1558);
if (objclass1558 == NULL) {
  glfree(obj1558->class->name);
  obj1558->class->name = "blockNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1558, self, 0);
  addmethodreal(obj1558,"outer", &reader_ast_outer_1559);
  Object oldself1558 = self;
  struct StackFrameObject *oldstackframe1558 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1558);
  gc_frame_newslot((Object)stackframe);
  self = obj1558;
  Object *oldselfslot1558 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1558 = (*(struct UserObject *)self).data[0], lowerouter1558 = thisouter1558;
  if (inheritingObject1558) {
    struct UserObject *inho1558 = (struct UserObject *)inheritingObject1558;
    while (inho1558->super != GraceDefaultObject) inho1558 = (struct UserObject *)inho1558->super;
    inho1558->super = obj1558;
    self = inheritingObject1558;
    *selfslot = self;
    lowerouter1558 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1558;
  }
if (objclass1558 == NULL) {
  Method *reader1560 = addmethodrealflags(obj1558, "kind",&reader_ast_kind_1560, MFLAG_DEF);
  reader1560->definitionModule = modulename;
  reader1560->definitionLine = 328;
}
adddatum2(obj1558, alloc_Undefined(), 1);
if (objclass1558 == NULL) {
  Method *reader1561 = addmethodrealflags(obj1558, "value",&reader_ast_value_1561, MFLAG_DEF);
  reader1561->definitionModule = modulename;
  reader1561->definitionLine = 329;
}
adddatum2(obj1558, alloc_Undefined(), 2);
if (objclass1558 == NULL) {
  Method *reader1562 = addmethodrealflags(obj1558, "params", &reader_ast_params_1562, 0);
  Method *writer1562 = addmethodrealflags(obj1558, "params:=(1)", &writer_ast_params_1562, 0);
  reader1562->definitionModule = modulename;
  writer1562->definitionModule = modulename;
  reader1562->definitionLine = 330;
  writer1562->definitionLine = 330;
}
obj1558->flags |= OFLAG_MUTABLE;
adddatum2(obj1558, alloc_Undefined(), 3);
if (objclass1558 == NULL) {
  Method *reader1563 = addmethodrealflags(obj1558, "body", &reader_ast_body_1563, 0);
  Method *writer1563 = addmethodrealflags(obj1558, "body:=(1)", &writer_ast_body_1563, 0);
  reader1563->definitionModule = modulename;
  writer1563->definitionModule = modulename;
  reader1563->definitionLine = 331;
  writer1563->definitionLine = 331;
}
obj1558->flags |= OFLAG_MUTABLE;
adddatum2(obj1558, alloc_Undefined(), 4);
if (objclass1558 == NULL) {
  Method *reader1564 = addmethodrealflags(obj1558, "selfclosure",&reader_ast_selfclosure_1564, MFLAG_DEF);
  reader1564->definitionModule = modulename;
  reader1564->definitionLine = 332;
}
adddatum2(obj1558, alloc_Undefined(), 5);
if (objclass1558 == NULL) {
  Method *reader1565 = addmethodrealflags(obj1558, "matchingPattern", &reader_ast_matchingPattern_1565, 0);
  Method *writer1565 = addmethodrealflags(obj1558, "matchingPattern:=(1)", &writer_ast_matchingPattern_1565, 0);
  reader1565->definitionModule = modulename;
  writer1565->definitionModule = modulename;
  reader1565->definitionLine = 333;
  writer1565->definitionLine = 333;
}
obj1558->flags |= OFLAG_MUTABLE;
adddatum2(obj1558, alloc_Undefined(), 6);
if (objclass1558 == NULL) {
  Method *reader1566 = addmethodrealflags(obj1558, "extraRuntimeData", &reader_ast_extraRuntimeData_1566, 0);
  Method *writer1566 = addmethodrealflags(obj1558, "extraRuntimeData:=(1)", &writer_ast_extraRuntimeData_1566, 0);
  reader1566->definitionModule = modulename;
  writer1566->definitionModule = modulename;
  reader1566->definitionLine = 334;
  writer1566->definitionLine = 334;
}
obj1558->flags |= OFLAG_MUTABLE;
adddatum2(obj1558, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo1567 = (struct UserObject*)obj1558;
  uo1567->data[8] = emptyclosure;
  Method *meth_meth_ast_isBlock1567 = addmethod2pos(obj1558, "isBlock", &meth_ast_isBlock1567, 8);
  int argcv_meth_ast_isBlock1567[] = {0};
  meth_meth_ast_isBlock1567->type = alloc_MethodType(1, argcv_meth_ast_isBlock1567);
  meth_meth_ast_isBlock1567->definitionModule = modulename;
  meth_meth_ast_isBlock1567->definitionLine = 338;
// method "isDelimited"
  struct UserObject *uo1569 = (struct UserObject*)obj1558;
  uo1569->data[9] = emptyclosure;
  Method *meth_meth_ast_isDelimited1569 = addmethod2pos(obj1558, "isDelimited", &meth_ast_isDelimited1569, 9);
  int argcv_meth_ast_isDelimited1569[] = {0};
  meth_meth_ast_isDelimited1569->type = alloc_MethodType(1, argcv_meth_ast_isDelimited1569);
  meth_meth_ast_isDelimited1569->definitionModule = modulename;
  meth_meth_ast_isDelimited1569->definitionLine = 339;
// method "isEmpty"
  struct UserObject *uo1571 = (struct UserObject*)obj1558;
  uo1571->data[10] = emptyclosure;
  Method *meth_meth_ast_isEmpty1571 = addmethod2pos(obj1558, "isEmpty", &meth_ast_isEmpty1571, 10);
  int argcv_meth_ast_isEmpty1571[] = {0};
  meth_meth_ast_isEmpty1571->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1571);
  meth_meth_ast_isEmpty1571->definitionModule = modulename;
  meth_meth_ast_isEmpty1571->definitionLine = 340;
// method "isntEmpty"
  struct UserObject *uo1580 = (struct UserObject*)obj1558;
  uo1580->data[11] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1580 = addmethod2pos(obj1558, "isntEmpty", &meth_ast_isntEmpty1580, 11);
  int argcv_meth_ast_isntEmpty1580[] = {0};
  meth_meth_ast_isntEmpty1580->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1580);
  meth_meth_ast_isntEmpty1580->definitionModule = modulename;
  meth_meth_ast_isntEmpty1580->definitionLine = 341;
// method "scope:=(_)"
  struct UserObject *uo1589 = (struct UserObject*)obj1558;
  uo1589->data[12] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_1589 = addmethod2pos(obj1558, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_1589, 12);
  int argcv_meth_ast_scope_58__61__40_1_41_1589[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_1589->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_1589);
  meth_meth_ast_scope_58__61__40_1_41_1589->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_1589->definitionLine = 342;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj1558);
  Object closure1594 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure1594, stackframe);
  addtoclosure(closure1594, var_k);
  struct UserObject *uo1594 = (struct UserObject*)obj1558;
  uo1594->data[13] = (Object)closure1594;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_1594 = addmethod2pos(obj1558, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_1594, 13);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_1594[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1594->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_1594);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1594->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1594->definitionLine = 348;
// method "isMatchingBlock"
  struct UserObject *uo1597 = (struct UserObject*)obj1558;
  uo1597->data[14] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1597 = addmethod2pos(obj1558, "isMatchingBlock", &meth_ast_isMatchingBlock1597, 14);
  int argcv_meth_ast_isMatchingBlock1597[] = {0};
  meth_meth_ast_isMatchingBlock1597->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1597);
  meth_meth_ast_isMatchingBlock1597->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1597->definitionLine = 349;
// method "returnsObject"
  struct UserObject *uo1606 = (struct UserObject*)obj1558;
  uo1606->data[15] = emptyclosure;
  Method *meth_meth_ast_returnsObject1606 = addmethod2pos(obj1558, "returnsObject", &meth_ast_returnsObject1606, 15);
  int argcv_meth_ast_returnsObject1606[] = {0};
  meth_meth_ast_returnsObject1606->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1606);
  meth_meth_ast_returnsObject1606->definitionModule = modulename;
  meth_meth_ast_returnsObject1606->definitionLine = 350;
// method "returnedObjectScope"
  struct UserObject *uo1627 = (struct UserObject*)obj1558;
  uo1627->data[16] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1627 = addmethod2pos(obj1558, "returnedObjectScope", &meth_ast_returnedObjectScope1627, 16);
  int argcv_meth_ast_returnedObjectScope1627[] = {0};
  meth_meth_ast_returnedObjectScope1627->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1627);
  meth_meth_ast_returnedObjectScope1627->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1627->definitionLine = 353;
// method "parametersDo(_)"
  struct UserObject *uo1634 = (struct UserObject*)obj1558;
  uo1634->data[17] = emptyclosure;
  Method *meth_meth_ast_parametersDo_40_1_41_1634 = addmethod2pos(obj1558, "parametersDo(1)", &meth_ast_parametersDo_40_1_41_1634, 17);
  int argcv_meth_ast_parametersDo_40_1_41_1634[] = {1};
  meth_meth_ast_parametersDo_40_1_41_1634->type = alloc_MethodType(1, argcv_meth_ast_parametersDo_40_1_41_1634);
  meth_meth_ast_parametersDo_40_1_41_1634->definitionModule = modulename;
  meth_meth_ast_parametersDo_40_1_41_1634->definitionLine = 357;
// method "accept(_)from(_)"
  struct UserObject *uo1639 = (struct UserObject*)obj1558;
  uo1639->data[18] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1639 = addmethod2pos(obj1558, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1639, 18);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1639[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1639->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1639);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1639->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1639->definitionLine = 360;
// method "map(_)ancestors(_)"
  struct UserObject *uo1674 = (struct UserObject*)obj1558;
  uo1674->data[19] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1674 = addmethod2pos(obj1558, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1674, 19);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1674[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1674->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1674);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1674->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1674->definitionLine = 374;
// method "pretty(_)"
  struct UserObject *uo1711 = (struct UserObject*)obj1558;
  uo1711->data[20] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_1711 = addmethod2pos(obj1558, "pretty(1)", &meth_ast_pretty_40_1_41_1711, 20);
  int argcv_meth_ast_pretty_40_1_41_1711[] = {1};
  meth_meth_ast_pretty_40_1_41_1711->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1711);
  meth_meth_ast_pretty_40_1_41_1711->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1711->definitionLine = 382;
// method "toGrace(_)"
  struct UserObject *uo1841 = (struct UserObject*)obj1558;
  uo1841->data[21] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1841 = addmethod2pos(obj1558, "toGrace(1)", &meth_ast_toGrace_40_1_41_1841, 21);
  int argcv_meth_ast_toGrace_40_1_41_1841[] = {1};
  meth_meth_ast_toGrace_40_1_41_1841->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1841);
meth_meth_ast_toGrace_40_1_41_1841->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_1841->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_1841->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1841->definitionLine = 404;
// method "shallowCopy"
  block_savedest(obj1558);
  Object closure1975 = createclosure(1, "shallowCopy");
  setclosureframe(closure1975, stackframe);
  addtoclosure(closure1975, var_blockNode);
  struct UserObject *uo1975 = (struct UserObject*)obj1558;
  uo1975->data[22] = (Object)closure1975;
  Method *meth_meth_ast_shallowCopy1975 = addmethod2pos(obj1558, "shallowCopy", &meth_ast_shallowCopy1975, 22);
  int argcv_meth_ast_shallowCopy1975[] = {0};
  meth_meth_ast_shallowCopy1975->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1975);
  meth_meth_ast_shallowCopy1975->definitionModule = modulename;
  meth_meth_ast_shallowCopy1975->definitionLine = 433;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo1984 = (struct UserObject*)obj1558;
  uo1984->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1984 = addmethod2pos(obj1558, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_1984, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1984[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1984->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1984);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1984->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1984->definitionLine = 436;
  sourceObject = obj1558;
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1995 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1996 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1997 = gc_frame_new();
// call case 3: self.outer request
  Object call1998 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1997);
// compiled member node returning call1998 (depth = 5)
  Object call1999 = callmethodflags(call1998, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1996);
// compiled member node returning call1999 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2000 = callmethodflags(call1999, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1995);
// compiled call node returning call2000 (depth = 3)
  struct UserObject *obj1558_uo = (struct UserObject *)obj1558;
  obj1558_uo->super = call2000;
  sourceObject = obj1558;
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2001 == NULL) {
    strlit2001 = alloc_String("block");
    gc_root(strlit2001);
  }
// compiled string node returning strlit2001 (depth = 3)
  adddatum2(obj1558, strlit2001, 1);
  sourceObject = obj1558;
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2002 == NULL) {
    strlit2002 = alloc_String("block");
    gc_root(strlit2002);
  }
// compiled string node returning strlit2002 (depth = 3)
  adddatum2(obj1558, strlit2002, 2);
  sourceObject = obj1558;
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj1558, *var_params_39_, 3);
  sourceObject = obj1558;
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj1558, *var_body_39_, 4);
  sourceObject = obj1558;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2003 = alloc_Boolean(1);
// compiled identifier node returning bool2003 (depth = 3)
  adddatum2(obj1558, bool2003, 5);
  sourceObject = obj1558;
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2004 = alloc_Boolean(0);
// compiled identifier node returning bool2004 (depth = 3)
  adddatum2(obj1558, bool2004, 6);
  sourceObject = obj1558;
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2005 = alloc_Boolean(0);
// compiled identifier node returning bool2005 (depth = 3)
  adddatum2(obj1558, bool2005, 7);
  sourceObject = obj1558;
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2006 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block2007 = alloc_Block(NULL, NULL, "ast", 335);
  gc_frame_newslot(block2007);
// method "_apply(_)"
  block_savedest(block2007);
  Object closure2008 = createclosure(3, "_apply(1)");
  setclosureframe(closure2008, stackframe);
  addtoclosure(closure2008, var_patternMarkVisitor);
  addtoclosure(closure2008, var_ancestorChain);
  addtoclosure(closure2008, selfslot);
  struct UserObject *uo2008 = (struct UserObject*)block2007;
  uo2008->data[0] = (Object)closure2008;
  Method *meth_meth_ast__apply_40_1_41_2008 = addmethod2pos(block2007, "_apply(1)", &meth_ast__apply_40_1_41_2008, 0);
  int argcv_meth_ast__apply_40_1_41_2008[] = {1};
  meth_meth_ast__apply_40_1_41_2008->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2008);
  meth_meth_ast__apply_40_1_41_2008->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2008->definitionLine = 2969;
// compiled block node returning block2007 (depth = 4)
  gc_frame_newslot(block2007);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block2007;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2014 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2006);
// compiled call node returning call2014 (depth = 3)
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  sourceObject = obj1558;
  objclass1558 = obj1558->class;
  objclass1558->definitionModule = modulename;
  objclass1558->definitionLine = 326;
  (*(struct UserObject *)self).data[0] = lowerouter1558;
  self = oldself1558;
  selfslot = oldselfslot1558;
  stackframe = oldstackframe1558;
  gc_frame_end(frame);
  return obj1558;
}
Object meth_ast_blockNode2016(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blockNode (depth = 3)
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast_isSimple2026(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2027 = alloc_Boolean(0);
// compiled identifier node returning bool2027 (depth = 3)
  gc_frame_end(frame);
  return bool2027;
}
Object meth_ast__apply_40_1_41_2042(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2043 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2044 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2043);
// compiled call node returning call2044 (depth = 6)
  gc_frame_end(frame);
  return call2044;
}
Object meth_ast_accept_40_1_41_from_40_1_41_2028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2030 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2031 = callmethodflags(*var_visitor, "visitTryCatch(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2030);
// compiled call node returning call2031 (depth = 4)
  Object if2029 = done;
  if (istrue(call2031)) {
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2032 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2033 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2032);
// compiled call node returning call2033 (depth = 5)
  *var_newChain = call2033;
  if (call2033 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2034 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2035 = gc_frame_new();
// call case 4: self request
  Object call2036 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2035);
// compiled member node returning call2036 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2037 = callmethodflags(call2036, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2034);
// compiled call node returning call2037 (depth = 4)
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2038 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2039 = gc_frame_new();
// call case 4: self request
  Object call2040 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2039);
// compiled member node returning call2040 (depth = 5)
  gc_frame_newslot(call2040);
// starting to compile block node (depth = 5)
  Object block2041 = alloc_Block(NULL, NULL, "ast", 457);
  gc_frame_newslot(block2041);
// method "_apply(_)"
  block_savedest(block2041);
  Object closure2042 = createclosure(3, "_apply(1)");
  setclosureframe(closure2042, stackframe);
  addtoclosure(closure2042, var_visitor);
  addtoclosure(closure2042, var_newChain);
  addtoclosure(closure2042, selfslot);
  struct UserObject *uo2042 = (struct UserObject*)block2041;
  uo2042->data[0] = (Object)closure2042;
  Method *meth_meth_ast__apply_40_1_41_2042 = addmethod2pos(block2041, "_apply(1)", &meth_ast__apply_40_1_41_2042, 0);
  int argcv_meth_ast__apply_40_1_41_2042[] = {1};
  meth_meth_ast__apply_40_1_41_2042->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2042);
  meth_meth_ast__apply_40_1_41_2042->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2042->definitionLine = 2969;
// compiled block node returning block2041 (depth = 5)
  gc_frame_newslot(block2041);
// call case 5: prelude request
  params[0] = call2040;
  params[1] = block2041;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2046 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2038);
// compiled call node returning call2046 (depth = 4)
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2049 = gc_frame_new();
// call case 4: self request
  Object call2050 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2049);
// compiled member node returning call2050 (depth = 6)
  int op_slot_right_2048 = gc_frame_newslot(call2050);
// starting to compile identifier node (depth = 6)
  Object bool2052 = alloc_Boolean(0);
// compiled identifier node returning bool2052 (depth = 6)
  int op_slot_left_2048 = gc_frame_newslot(bool2052);
  params[0] = call2050;
  partcv[0] = 1;
  Object opresult2053 = callmethod(bool2052, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2053 (depth = 5)
  Object if2047 = done;
  if (istrue(opresult2053)) {
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2054 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2055 = gc_frame_new();
// call case 4: self request
  Object call2056 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2055);
// compiled member node returning call2056 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2057 = callmethodflags(call2056, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2054);
// compiled call node returning call2057 (depth = 5)
    gc_frame_newslot(call2057);
    if2047 = call2057;
  } else {
  }
// compiled if node returning if2047 (depth = 4)
    gc_frame_newslot(if2047);
    if2029 = if2047;
  } else {
  }
// compiled if node returning if2029 (depth = 3)
  gc_frame_end(frame);
  return if2029;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_2058(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2059 = gc_frame_new();
// call case 4: self request
  Object call2060 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2059);
// compiled member node returning call2060 (depth = 4)
  *var_n = call2060;
  if (call2060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2061 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2062 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2061);
// compiled call node returning call2062 (depth = 4)
  *var_newChain = call2062;
  if (call2062 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2063 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2064 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2065 = gc_frame_new();
// call case 4: self request
  Object call2066 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2065);
// compiled member node returning call2066 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2067 = callmethodflags(call2066, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2064);
// compiled call node returning call2067 (depth = 4)
  gc_frame_newslot(call2067);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2067;
  partcv[0] = 1;
  Object call2068 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2063);
// compiled call node returning call2068 (depth = 3)
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2069 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2070 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2071 = gc_frame_new();
// call case 4: self request
  Object call2072 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2071);
// compiled member node returning call2072 (depth = 5)
  gc_frame_newslot(call2072);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2073 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2074 = gc_frame_new();
// call case 3: self.outer request
  Object call2075 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2074);
// compiled member node returning call2075 (depth = 6)
  Object call2076 = callmethodflags(call2075, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2073);
// compiled member node returning call2076 (depth = 5)
  params[0] = call2072;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2077 = callmethodflags(call2076, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2070);
// compiled call node returning call2077 (depth = 4)
  gc_frame_newslot(call2077);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2077;
  partcv[0] = 1;
  Object call2078 = callmethodflags(*var_n, "cases:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2069);
// compiled call node returning call2078 (depth = 3)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2079 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2080 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2081 = gc_frame_new();
// call case 4: self request
  Object call2082 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2081);
// compiled member node returning call2082 (depth = 5)
  gc_frame_newslot(call2082);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2083 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2084 = gc_frame_new();
// call case 3: self.outer request
  Object call2085 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2084);
// compiled member node returning call2085 (depth = 6)
  Object call2086 = callmethodflags(call2085, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2083);
// compiled member node returning call2086 (depth = 5)
  params[0] = call2082;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2087 = callmethodflags(call2086, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2080);
// compiled call node returning call2087 (depth = 4)
  gc_frame_newslot(call2087);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2087;
  partcv[0] = 1;
  Object call2088 = callmethodflags(*var_n, "finally:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2079);
// compiled call node returning call2088 (depth = 3)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2089 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2090 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2089);
// compiled call node returning call2090 (depth = 3)
  gc_frame_end(frame);
  return call2090;
}
Object meth_ast__apply_40_1_41_2099(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2101 == NULL) {
    strlit2101 = alloc_String("  ");
    gc_root(strlit2101);
  }
// compiled string node returning strlit2101 (depth = 7)
  int op_slot_right_2100 = gc_frame_newslot(strlit2101);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2100 = gc_frame_newslot(*var_spc);
  params[0] = strlit2101;
  partcv[0] = 1;
  Object opresult2103 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2103 (depth = 6)
  *var_spc = opresult2103;
  if (opresult2103 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2136(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2139 == NULL) {
    strlit2139 = alloc_String("");
    gc_root(strlit2139);
  }
// compiled string node returning strlit2139 (depth = 8)
  int op_slot_right_2138 = gc_frame_newslot(strlit2139);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2142 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2144 = alloc_Float64(2);
// compiled num node returning num2144 (depth = 11)
  int op_slot_right_2143 = gc_frame_newslot(num2144);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2143 = gc_frame_newslot(*var_depth);
  params[0] = num2144;
  partcv[0] = 1;
  Object sum2146 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2146 (depth = 10)
  gc_frame_newslot(sum2146);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2146;
  partcv[0] = 1;
  Object call2147 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2142);
// compiled call node returning call2147 (depth = 9)
  int op_slot_right_2141 = gc_frame_newslot(call2147);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2150 == NULL) {
    strlit2150 = alloc_String("  ");
    gc_root(strlit2150);
  }
// compiled string node returning strlit2150 (depth = 10)
  int op_slot_right_2149 = gc_frame_newslot(strlit2150);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2152 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2155 == NULL) {
    strlit2155 = alloc_String("Case:""\x0a""");
    gc_root(strlit2155);
  }
// compiled string node returning strlit2155 (depth = 12)
  int op_slot_right_2154 = gc_frame_newslot(strlit2155);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2157 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2159 == NULL) {
    strlit2159 = alloc_String("""\x0a""");
    gc_root(strlit2159);
  }
// compiled string node returning strlit2159 (depth = 13)
  int op_slot_left_2157 = gc_frame_newslot(strlit2159);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2160 = callmethod(strlit2159, "++(1)", 1, partcv, params);
// compiled op node returning opresult2160 (depth = 12)
  int op_slot_left_2154 = gc_frame_newslot(opresult2160);
  params[0] = strlit2155;
  partcv[0] = 1;
  Object opresult2161 = callmethod(opresult2160, "++(1)", 1, partcv, params);
// compiled op node returning opresult2161 (depth = 11)
  int op_slot_left_2152 = gc_frame_newslot(opresult2161);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2162 = callmethod(opresult2161, "++(1)", 1, partcv, params);
// compiled op node returning opresult2162 (depth = 10)
  int op_slot_left_2149 = gc_frame_newslot(opresult2162);
  params[0] = strlit2150;
  partcv[0] = 1;
  Object opresult2163 = callmethod(opresult2162, "++(1)", 1, partcv, params);
// compiled op node returning opresult2163 (depth = 9)
  int op_slot_left_2141 = gc_frame_newslot(opresult2163);
  params[0] = call2147;
  partcv[0] = 1;
  Object opresult2164 = callmethod(opresult2163, "++(1)", 1, partcv, params);
// compiled op node returning opresult2164 (depth = 8)
  int op_slot_left_2138 = gc_frame_newslot(opresult2164);
  params[0] = strlit2139;
  partcv[0] = 1;
  Object opresult2165 = callmethod(opresult2164, "++(1)", 1, partcv, params);
// compiled op node returning opresult2165 (depth = 7)
  int op_slot_right_2137 = gc_frame_newslot(opresult2165);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2137 = gc_frame_newslot(*var_s);
  params[0] = opresult2165;
  partcv[0] = 1;
  Object opresult2167 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2167 (depth = 6)
  *var_s = opresult2167;
  if (opresult2167 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_2091(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2092 == NULL) {
    strlit2092 = alloc_String("");
    gc_root(strlit2092);
  }
// compiled string node returning strlit2092 (depth = 4)
  *var_spc = strlit2092;
  if (strlit2092 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2093 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2094 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2096 = alloc_Float64(0);
// compiled num node returning num2096 (depth = 5)
  int op_slot_left_2094 = gc_frame_newslot(num2096);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2097 = callmethod(num2096, "..(1)", 1, partcv, params);
// compiled op node returning opresult2097 (depth = 4)
  gc_frame_newslot(opresult2097);
// starting to compile block node (depth = 4)
  Object block2098 = alloc_Block(NULL, NULL, "ast", 475);
  gc_frame_newslot(block2098);
// method "_apply(_)"
  block_savedest(block2098);
  Object closure2099 = createclosure(2, "_apply(1)");
  setclosureframe(closure2099, stackframe);
  addtoclosure(closure2099, var_spc);
  addtoclosure(closure2099, selfslot);
  struct UserObject *uo2099 = (struct UserObject*)block2098;
  uo2099->data[0] = (Object)closure2099;
  Method *meth_meth_ast__apply_40_1_41_2099 = addmethod2pos(block2098, "_apply(1)", &meth_ast__apply_40_1_41_2099, 0);
  int argcv_meth_ast__apply_40_1_41_2099[] = {1};
  meth_meth_ast__apply_40_1_41_2099->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2099);
  meth_meth_ast__apply_40_1_41_2099->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2099->definitionLine = 2969;
// compiled block node returning block2098 (depth = 4)
  gc_frame_newslot(block2098);
// call case 5: prelude request
  params[0] = opresult2097;
  params[1] = block2098;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2106 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2093);
// compiled call node returning call2106 (depth = 3)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2108 == NULL) {
    strlit2108 = alloc_String("""\x0a""");
    gc_root(strlit2108);
  }
// compiled string node returning strlit2108 (depth = 5)
  int op_slot_right_2107 = gc_frame_newslot(strlit2108);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2111 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2112 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2111);
// compiled call node returning call2112 (depth = 6)
  int op_slot_right_2110 = gc_frame_newslot(call2112);
// starting to compile string node (depth = 6)
  if (strlit2114 == NULL) {
    strlit2114 = alloc_String("");
    gc_root(strlit2114);
  }
// compiled string node returning strlit2114 (depth = 6)
  int op_slot_left_2110 = gc_frame_newslot(strlit2114);
  params[0] = call2112;
  partcv[0] = 1;
  Object opresult2115 = callmethod(strlit2114, "++(1)", 1, partcv, params);
// compiled op node returning opresult2115 (depth = 5)
  int op_slot_left_2107 = gc_frame_newslot(opresult2115);
  params[0] = strlit2108;
  partcv[0] = 1;
  Object opresult2116 = callmethod(opresult2115, "++(1)", 1, partcv, params);
// compiled op node returning opresult2116 (depth = 4)
  *var_s = opresult2116;
  if (opresult2116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2118 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2120 = alloc_Float64(2);
// compiled num node returning num2120 (depth = 7)
  int op_slot_right_2119 = gc_frame_newslot(num2120);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2119 = gc_frame_newslot(*var_depth);
  params[0] = num2120;
  partcv[0] = 1;
  Object sum2122 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2122 (depth = 6)
  gc_frame_newslot(sum2122);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2123 = gc_frame_new();
// call case 4: self request
  Object call2124 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2123);
// compiled member node returning call2124 (depth = 6)
  params[0] = sum2122;
  partcv[0] = 1;
  Object call2125 = callmethodflags(call2124, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2118);
// compiled call node returning call2125 (depth = 5)
  int op_slot_right_2117 = gc_frame_newslot(call2125);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2127 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2127 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2129 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2129 (depth = 5)
  int op_slot_left_2117 = gc_frame_newslot(opresult2129);
  params[0] = call2125;
  partcv[0] = 1;
  Object opresult2130 = callmethod(opresult2129, "++(1)", 1, partcv, params);
// compiled op node returning opresult2130 (depth = 4)
  *var_s = opresult2130;
  if (opresult2130 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2132 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2133 = gc_frame_new();
// call case 4: self request
  Object call2134 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2133);
// compiled member node returning call2134 (depth = 4)
  gc_frame_newslot(call2134);
// starting to compile block node (depth = 4)
  Object block2135 = alloc_Block(NULL, NULL, "ast", 480);
  gc_frame_newslot(block2135);
// method "_apply(_)"
  block_savedest(block2135);
  Object closure2136 = createclosure(4, "_apply(1)");
  setclosureframe(closure2136, stackframe);
  addtoclosure(closure2136, var_depth);
  addtoclosure(closure2136, var_spc);
  addtoclosure(closure2136, var_s);
  addtoclosure(closure2136, selfslot);
  struct UserObject *uo2136 = (struct UserObject*)block2135;
  uo2136->data[0] = (Object)closure2136;
  Method *meth_meth_ast__apply_40_1_41_2136 = addmethod2pos(block2135, "_apply(1)", &meth_ast__apply_40_1_41_2136, 0);
  int argcv_meth_ast__apply_40_1_41_2136[] = {1};
  meth_meth_ast__apply_40_1_41_2136->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2136);
  meth_meth_ast__apply_40_1_41_2136->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2136->definitionLine = 2969;
// compiled block node returning block2135 (depth = 4)
  gc_frame_newslot(block2135);
// call case 5: prelude request
  params[0] = call2134;
  params[1] = block2135;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2170 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2132);
// compiled call node returning call2170 (depth = 3)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2173 = gc_frame_new();
// call case 4: self request
  Object call2174 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2173);
// compiled member node returning call2174 (depth = 5)
  int op_slot_right_2172 = gc_frame_newslot(call2174);
// starting to compile identifier node (depth = 5)
  Object bool2176 = alloc_Boolean(0);
// compiled identifier node returning bool2176 (depth = 5)
  int op_slot_left_2172 = gc_frame_newslot(bool2176);
  params[0] = call2174;
  partcv[0] = 1;
  Object opresult2177 = callmethod(bool2176, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2177 (depth = 4)
  Object if2171 = done;
  if (istrue(opresult2177)) {
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2180 == NULL) {
    strlit2180 = alloc_String("");
    gc_root(strlit2180);
  }
// compiled string node returning strlit2180 (depth = 7)
  int op_slot_right_2179 = gc_frame_newslot(strlit2180);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2183 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2185 = alloc_Float64(2);
// compiled num node returning num2185 (depth = 10)
  int op_slot_right_2184 = gc_frame_newslot(num2185);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2184 = gc_frame_newslot(*var_depth);
  params[0] = num2185;
  partcv[0] = 1;
  Object sum2187 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2187 (depth = 9)
  gc_frame_newslot(sum2187);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2188 = gc_frame_new();
// call case 4: self request
  Object call2189 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2188);
// compiled member node returning call2189 (depth = 9)
  params[0] = sum2187;
  partcv[0] = 1;
  Object call2190 = callmethodflags(call2189, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2183);
// compiled call node returning call2190 (depth = 8)
  int op_slot_right_2182 = gc_frame_newslot(call2190);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2193 == NULL) {
    strlit2193 = alloc_String("  ");
    gc_root(strlit2193);
  }
// compiled string node returning strlit2193 (depth = 9)
  int op_slot_right_2192 = gc_frame_newslot(strlit2193);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2195 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2198 == NULL) {
    strlit2198 = alloc_String("Finally:""\x0a""");
    gc_root(strlit2198);
  }
// compiled string node returning strlit2198 (depth = 11)
  int op_slot_right_2197 = gc_frame_newslot(strlit2198);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2200 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2202 == NULL) {
    strlit2202 = alloc_String("""\x0a""");
    gc_root(strlit2202);
  }
// compiled string node returning strlit2202 (depth = 12)
  int op_slot_left_2200 = gc_frame_newslot(strlit2202);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2203 = callmethod(strlit2202, "++(1)", 1, partcv, params);
// compiled op node returning opresult2203 (depth = 11)
  int op_slot_left_2197 = gc_frame_newslot(opresult2203);
  params[0] = strlit2198;
  partcv[0] = 1;
  Object opresult2204 = callmethod(opresult2203, "++(1)", 1, partcv, params);
// compiled op node returning opresult2204 (depth = 10)
  int op_slot_left_2195 = gc_frame_newslot(opresult2204);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2205 = callmethod(opresult2204, "++(1)", 1, partcv, params);
// compiled op node returning opresult2205 (depth = 9)
  int op_slot_left_2192 = gc_frame_newslot(opresult2205);
  params[0] = strlit2193;
  partcv[0] = 1;
  Object opresult2206 = callmethod(opresult2205, "++(1)", 1, partcv, params);
// compiled op node returning opresult2206 (depth = 8)
  int op_slot_left_2182 = gc_frame_newslot(opresult2206);
  params[0] = call2190;
  partcv[0] = 1;
  Object opresult2207 = callmethod(opresult2206, "++(1)", 1, partcv, params);
// compiled op node returning opresult2207 (depth = 7)
  int op_slot_left_2179 = gc_frame_newslot(opresult2207);
  params[0] = strlit2180;
  partcv[0] = 1;
  Object opresult2208 = callmethod(opresult2207, "++(1)", 1, partcv, params);
// compiled op node returning opresult2208 (depth = 6)
  int op_slot_right_2178 = gc_frame_newslot(opresult2208);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2178 = gc_frame_newslot(*var_s);
  params[0] = opresult2208;
  partcv[0] = 1;
  Object opresult2210 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2210 (depth = 5)
  *var_s = opresult2210;
  if (opresult2210 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2171 = done;
  } else {
  }
// compiled if node returning if2171 (depth = 3)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_2224(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2226 == NULL) {
    strlit2226 = alloc_String("    ");
    gc_root(strlit2226);
  }
// compiled string node returning strlit2226 (depth = 7)
  int op_slot_right_2225 = gc_frame_newslot(strlit2226);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2225 = gc_frame_newslot(*var_spc);
  params[0] = strlit2226;
  partcv[0] = 1;
  Object opresult2228 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2228 (depth = 6)
  *var_spc = opresult2228;
  if (opresult2228 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2252(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2254 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2256 = alloc_Float64(1);
// compiled num node returning num2256 (depth = 9)
  int op_slot_right_2255 = gc_frame_newslot(num2256);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2255 = gc_frame_newslot(*var_depth);
  params[0] = num2256;
  partcv[0] = 1;
  Object sum2258 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2258 (depth = 8)
  gc_frame_newslot(sum2258);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2258;
  partcv[0] = 1;
  Object call2259 = callmethodflags(*var_case, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2254);
// compiled call node returning call2259 (depth = 7)
  int op_slot_right_2253 = gc_frame_newslot(call2259);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2262 == NULL) {
    strlit2262 = alloc_String("catch ");
    gc_root(strlit2262);
  }
// compiled string node returning strlit2262 (depth = 8)
  int op_slot_right_2261 = gc_frame_newslot(strlit2262);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2265 == NULL) {
    strlit2265 = alloc_String("    ");
    gc_root(strlit2265);
  }
// compiled string node returning strlit2265 (depth = 9)
  int op_slot_right_2264 = gc_frame_newslot(strlit2265);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2267 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2270 == NULL) {
    strlit2270 = alloc_String("""\x0a""");
    gc_root(strlit2270);
  }
// compiled string node returning strlit2270 (depth = 11)
  int op_slot_right_2269 = gc_frame_newslot(strlit2270);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2269 = gc_frame_newslot(*var_s);
  params[0] = strlit2270;
  partcv[0] = 1;
  Object opresult2272 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2272 (depth = 10)
  int op_slot_left_2267 = gc_frame_newslot(opresult2272);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2273 = callmethod(opresult2272, "++(1)", 1, partcv, params);
// compiled op node returning opresult2273 (depth = 9)
  int op_slot_left_2264 = gc_frame_newslot(opresult2273);
  params[0] = strlit2265;
  partcv[0] = 1;
  Object opresult2274 = callmethod(opresult2273, "++(1)", 1, partcv, params);
// compiled op node returning opresult2274 (depth = 8)
  int op_slot_left_2261 = gc_frame_newslot(opresult2274);
  params[0] = strlit2262;
  partcv[0] = 1;
  Object opresult2275 = callmethod(opresult2274, "++(1)", 1, partcv, params);
// compiled op node returning opresult2275 (depth = 7)
  int op_slot_left_2253 = gc_frame_newslot(opresult2275);
  params[0] = call2259;
  partcv[0] = 1;
  Object opresult2276 = callmethod(opresult2275, "++(1)", 1, partcv, params);
// compiled op node returning opresult2276 (depth = 6)
  *var_s = opresult2276;
  if (opresult2276 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_2212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2213 == NULL) {
    strlit2213 = alloc_String("");
    gc_root(strlit2213);
  }
// compiled string node returning strlit2213 (depth = 4)
  *var_spc = strlit2213;
  if (strlit2213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2214 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2217 = alloc_Float64(1);
// compiled num node returning num2217 (depth = 6)
  int op_slot_right_2216 = gc_frame_newslot(num2217);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2216 = gc_frame_newslot(*var_depth);
  params[0] = num2217;
  partcv[0] = 1;
  Object diff2219 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff2219 (depth = 5)
  int op_slot_right_2215 = gc_frame_newslot(diff2219);
// starting to compile num node (depth = 5)
  Object num2221 = alloc_Float64(0);
// compiled num node returning num2221 (depth = 5)
  int op_slot_left_2215 = gc_frame_newslot(num2221);
  params[0] = diff2219;
  partcv[0] = 1;
  Object opresult2222 = callmethod(num2221, "..(1)", 1, partcv, params);
// compiled op node returning opresult2222 (depth = 4)
  gc_frame_newslot(opresult2222);
// starting to compile block node (depth = 4)
  Object block2223 = alloc_Block(NULL, NULL, "ast", 490);
  gc_frame_newslot(block2223);
// method "_apply(_)"
  block_savedest(block2223);
  Object closure2224 = createclosure(2, "_apply(1)");
  setclosureframe(closure2224, stackframe);
  addtoclosure(closure2224, var_spc);
  addtoclosure(closure2224, selfslot);
  struct UserObject *uo2224 = (struct UserObject*)block2223;
  uo2224->data[0] = (Object)closure2224;
  Method *meth_meth_ast__apply_40_1_41_2224 = addmethod2pos(block2223, "_apply(1)", &meth_ast__apply_40_1_41_2224, 0);
  int argcv_meth_ast__apply_40_1_41_2224[] = {1};
  meth_meth_ast__apply_40_1_41_2224->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2224);
  meth_meth_ast__apply_40_1_41_2224->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2224->definitionLine = 2969;
// compiled block node returning block2223 (depth = 4)
  gc_frame_newslot(block2223);
// call case 5: prelude request
  params[0] = opresult2222;
  params[1] = block2223;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2231 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2214);
// compiled call node returning call2231 (depth = 3)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2233 == NULL) {
    strlit2233 = alloc_String(" ");
    gc_root(strlit2233);
  }
// compiled string node returning strlit2233 (depth = 5)
  int op_slot_right_2232 = gc_frame_newslot(strlit2233);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2236 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2238 = alloc_Float64(1);
// compiled num node returning num2238 (depth = 8)
  int op_slot_right_2237 = gc_frame_newslot(num2238);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2237 = gc_frame_newslot(*var_depth);
  params[0] = num2238;
  partcv[0] = 1;
  Object sum2240 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2240 (depth = 7)
  gc_frame_newslot(sum2240);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2241 = gc_frame_new();
// call case 4: self request
  Object call2242 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2241);
// compiled member node returning call2242 (depth = 7)
  params[0] = sum2240;
  partcv[0] = 1;
  Object call2243 = callmethodflags(call2242, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2236);
// compiled call node returning call2243 (depth = 6)
  int op_slot_right_2235 = gc_frame_newslot(call2243);
// starting to compile string node (depth = 6)
  if (strlit2245 == NULL) {
    strlit2245 = alloc_String("try ");
    gc_root(strlit2245);
  }
// compiled string node returning strlit2245 (depth = 6)
  int op_slot_left_2235 = gc_frame_newslot(strlit2245);
  params[0] = call2243;
  partcv[0] = 1;
  Object opresult2246 = callmethod(strlit2245, "++(1)", 1, partcv, params);
// compiled op node returning opresult2246 (depth = 5)
  int op_slot_left_2232 = gc_frame_newslot(opresult2246);
  params[0] = strlit2233;
  partcv[0] = 1;
  Object opresult2247 = callmethod(opresult2246, "++(1)", 1, partcv, params);
// compiled op node returning opresult2247 (depth = 4)
  *var_s = opresult2247;
  if (opresult2247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2248 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2249 = gc_frame_new();
// call case 4: self request
  Object call2250 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2249);
// compiled member node returning call2250 (depth = 4)
  gc_frame_newslot(call2250);
// starting to compile block node (depth = 4)
  Object block2251 = alloc_Block(NULL, NULL, "ast", 494);
  gc_frame_newslot(block2251);
// method "_apply(_)"
  block_savedest(block2251);
  Object closure2252 = createclosure(4, "_apply(1)");
  setclosureframe(closure2252, stackframe);
  addtoclosure(closure2252, var_depth);
  addtoclosure(closure2252, var_spc);
  addtoclosure(closure2252, var_s);
  addtoclosure(closure2252, selfslot);
  struct UserObject *uo2252 = (struct UserObject*)block2251;
  uo2252->data[0] = (Object)closure2252;
  Method *meth_meth_ast__apply_40_1_41_2252 = addmethod2pos(block2251, "_apply(1)", &meth_ast__apply_40_1_41_2252, 0);
  int argcv_meth_ast__apply_40_1_41_2252[] = {1};
  meth_meth_ast__apply_40_1_41_2252->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2252);
  meth_meth_ast__apply_40_1_41_2252->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2252->definitionLine = 2969;
// compiled block node returning block2251 (depth = 4)
  gc_frame_newslot(block2251);
// call case 5: prelude request
  params[0] = call2250;
  params[1] = block2251;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2279 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2248);
// compiled call node returning call2279 (depth = 3)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2282 = gc_frame_new();
// call case 4: self request
  Object call2283 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2282);
// compiled member node returning call2283 (depth = 5)
  int op_slot_right_2281 = gc_frame_newslot(call2283);
// starting to compile identifier node (depth = 5)
  Object bool2285 = alloc_Boolean(0);
// compiled identifier node returning bool2285 (depth = 5)
  int op_slot_left_2281 = gc_frame_newslot(bool2285);
  params[0] = call2283;
  partcv[0] = 1;
  Object opresult2286 = callmethod(bool2285, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2286 (depth = 4)
  Object if2280 = done;
  if (istrue(opresult2286)) {
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2288 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2290 = alloc_Float64(1);
// compiled num node returning num2290 (depth = 8)
  int op_slot_right_2289 = gc_frame_newslot(num2290);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2289 = gc_frame_newslot(*var_depth);
  params[0] = num2290;
  partcv[0] = 1;
  Object sum2292 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2292 (depth = 7)
  gc_frame_newslot(sum2292);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2293 = gc_frame_new();
// call case 4: self request
  Object call2294 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2293);
// compiled member node returning call2294 (depth = 7)
  params[0] = sum2292;
  partcv[0] = 1;
  Object call2295 = callmethodflags(call2294, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2288);
// compiled call node returning call2295 (depth = 6)
  int op_slot_right_2287 = gc_frame_newslot(call2295);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2298 == NULL) {
    strlit2298 = alloc_String("finally ");
    gc_root(strlit2298);
  }
// compiled string node returning strlit2298 (depth = 7)
  int op_slot_right_2297 = gc_frame_newslot(strlit2298);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2301 == NULL) {
    strlit2301 = alloc_String("    ");
    gc_root(strlit2301);
  }
// compiled string node returning strlit2301 (depth = 8)
  int op_slot_right_2300 = gc_frame_newslot(strlit2301);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2303 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2306 == NULL) {
    strlit2306 = alloc_String("""\x0a""");
    gc_root(strlit2306);
  }
// compiled string node returning strlit2306 (depth = 10)
  int op_slot_right_2305 = gc_frame_newslot(strlit2306);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2305 = gc_frame_newslot(*var_s);
  params[0] = strlit2306;
  partcv[0] = 1;
  Object opresult2308 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2308 (depth = 9)
  int op_slot_left_2303 = gc_frame_newslot(opresult2308);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2309 = callmethod(opresult2308, "++(1)", 1, partcv, params);
// compiled op node returning opresult2309 (depth = 8)
  int op_slot_left_2300 = gc_frame_newslot(opresult2309);
  params[0] = strlit2301;
  partcv[0] = 1;
  Object opresult2310 = callmethod(opresult2309, "++(1)", 1, partcv, params);
// compiled op node returning opresult2310 (depth = 7)
  int op_slot_left_2297 = gc_frame_newslot(opresult2310);
  params[0] = strlit2298;
  partcv[0] = 1;
  Object opresult2311 = callmethod(opresult2310, "++(1)", 1, partcv, params);
// compiled op node returning opresult2311 (depth = 6)
  int op_slot_left_2287 = gc_frame_newslot(opresult2311);
  params[0] = call2295;
  partcv[0] = 1;
  Object opresult2312 = callmethod(opresult2311, "++(1)", 1, partcv, params);
// compiled op node returning opresult2312 (depth = 5)
  *var_s = opresult2312;
  if (opresult2312 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2280 = done;
  } else {
  }
// compiled if node returning if2280 (depth = 3)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2314(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2315 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2316 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2317 = alloc_Boolean(0);
// compiled identifier node returning bool2317 (depth = 5)
  gc_frame_newslot(bool2317);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tryCatchNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2317;
  partcv[0] = 3;
  Object call2318 = callmethodflags(*var_tryCatchNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe2316);
// compiled call node returning call2318 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2319 = callmethodflags(call2318, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2315);
// compiled call node returning call2319 (depth = 3)
  gc_frame_end(frame);
  return call2319;
}
Object meth_ast_new_40_3_41_2019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2020 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2020 = alloc_userobj2(13,11, objclass2020);
  gc_frame_newslot(obj2020);
if (objclass2020 == NULL) {
  glfree(obj2020->class->name);
  obj2020->class->name = "tryCatchNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2020, self, 0);
  addmethodreal(obj2020,"outer", &reader_ast_outer_2021);
  Object oldself2020 = self;
  struct StackFrameObject *oldstackframe2020 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2020);
  gc_frame_newslot((Object)stackframe);
  self = obj2020;
  Object *oldselfslot2020 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2020 = (*(struct UserObject *)self).data[0], lowerouter2020 = thisouter2020;
  if (inheritingObject2020) {
    struct UserObject *inho2020 = (struct UserObject *)inheritingObject2020;
    while (inho2020->super != GraceDefaultObject) inho2020 = (struct UserObject *)inho2020->super;
    inho2020->super = obj2020;
    self = inheritingObject2020;
    *selfslot = self;
    lowerouter2020 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2020;
  }
if (objclass2020 == NULL) {
  Method *reader2022 = addmethodrealflags(obj2020, "kind",&reader_ast_kind_2022, MFLAG_DEF);
  reader2022->definitionModule = modulename;
  reader2022->definitionLine = 447;
}
adddatum2(obj2020, alloc_Undefined(), 1);
if (objclass2020 == NULL) {
  Method *reader2023 = addmethodrealflags(obj2020, "value", &reader_ast_value_2023, 0);
  Method *writer2023 = addmethodrealflags(obj2020, "value:=(1)", &writer_ast_value_2023, 0);
  reader2023->definitionModule = modulename;
  writer2023->definitionModule = modulename;
  reader2023->definitionLine = 448;
  writer2023->definitionLine = 448;
}
obj2020->flags |= OFLAG_MUTABLE;
adddatum2(obj2020, alloc_Undefined(), 2);
if (objclass2020 == NULL) {
  Method *reader2024 = addmethodrealflags(obj2020, "cases", &reader_ast_cases_2024, 0);
  Method *writer2024 = addmethodrealflags(obj2020, "cases:=(1)", &writer_ast_cases_2024, 0);
  reader2024->definitionModule = modulename;
  writer2024->definitionModule = modulename;
  reader2024->definitionLine = 449;
  writer2024->definitionLine = 449;
}
obj2020->flags |= OFLAG_MUTABLE;
adddatum2(obj2020, alloc_Undefined(), 3);
if (objclass2020 == NULL) {
  Method *reader2025 = addmethodrealflags(obj2020, "finally", &reader_ast_finally_2025, 0);
  Method *writer2025 = addmethodrealflags(obj2020, "finally:=(1)", &writer_ast_finally_2025, 0);
  reader2025->definitionModule = modulename;
  writer2025->definitionModule = modulename;
  reader2025->definitionLine = 450;
  writer2025->definitionLine = 450;
}
obj2020->flags |= OFLAG_MUTABLE;
adddatum2(obj2020, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2026 = (struct UserObject*)obj2020;
  uo2026->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2026 = addmethod2pos(obj2020, "isSimple", &meth_ast_isSimple2026, 5);
  int argcv_meth_ast_isSimple2026[] = {0};
  meth_meth_ast_isSimple2026->type = alloc_MethodType(1, argcv_meth_ast_isSimple2026);
  meth_meth_ast_isSimple2026->definitionModule = modulename;
  meth_meth_ast_isSimple2026->definitionLine = 451;
// method "accept(_)from(_)"
  struct UserObject *uo2028 = (struct UserObject*)obj2020;
  uo2028->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2028 = addmethod2pos(obj2020, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2028, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2028[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2028->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2028);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2028->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2028->definitionLine = 453;
// method "map(_)ancestors(_)"
  struct UserObject *uo2058 = (struct UserObject*)obj2020;
  uo2058->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2058 = addmethod2pos(obj2020, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2058, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2058[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2058->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2058);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2058->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2058->definitionLine = 465;
// method "pretty(_)"
  struct UserObject *uo2091 = (struct UserObject*)obj2020;
  uo2091->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2091 = addmethod2pos(obj2020, "pretty(1)", &meth_ast_pretty_40_1_41_2091, 8);
  int argcv_meth_ast_pretty_40_1_41_2091[] = {1};
  meth_meth_ast_pretty_40_1_41_2091->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2091);
  meth_meth_ast_pretty_40_1_41_2091->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2091->definitionLine = 473;
// method "toGrace(_)"
  struct UserObject *uo2212 = (struct UserObject*)obj2020;
  uo2212->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2212 = addmethod2pos(obj2020, "toGrace(1)", &meth_ast_toGrace_40_1_41_2212, 9);
  int argcv_meth_ast_toGrace_40_1_41_2212[] = {1};
  meth_meth_ast_toGrace_40_1_41_2212->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2212);
meth_meth_ast_toGrace_40_1_41_2212->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2212->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2212->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2212->definitionLine = 488;
// method "shallowCopy"
  block_savedest(obj2020);
  Object closure2314 = createclosure(3, "shallowCopy");
  setclosureframe(closure2314, stackframe);
  addtoclosure(closure2314, var_nullNode);
  addtoclosure(closure2314, var_emptySeq);
  addtoclosure(closure2314, var_tryCatchNode);
  struct UserObject *uo2314 = (struct UserObject*)obj2020;
  uo2314->data[10] = (Object)closure2314;
  Method *meth_meth_ast_shallowCopy2314 = addmethod2pos(obj2020, "shallowCopy", &meth_ast_shallowCopy2314, 10);
  int argcv_meth_ast_shallowCopy2314[] = {0};
  meth_meth_ast_shallowCopy2314->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2314);
  meth_meth_ast_shallowCopy2314->definitionModule = modulename;
  meth_meth_ast_shallowCopy2314->definitionLine = 502;
  sourceObject = obj2020;
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2320 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2321 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2322 = gc_frame_new();
// call case 3: self.outer request
  Object call2323 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2322);
// compiled member node returning call2323 (depth = 5)
  Object call2324 = callmethodflags(call2323, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2321);
// compiled member node returning call2324 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2325 = callmethodflags(call2324, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2320);
// compiled call node returning call2325 (depth = 3)
  struct UserObject *obj2020_uo = (struct UserObject *)obj2020;
  obj2020_uo->super = call2325;
  sourceObject = obj2020;
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2326 == NULL) {
    strlit2326 = alloc_String("trycatch");
    gc_root(strlit2326);
  }
// compiled string node returning strlit2326 (depth = 3)
  adddatum2(obj2020, strlit2326, 1);
  sourceObject = obj2020;
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj2020, *var_block, 2);
  sourceObject = obj2020;
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2020, *var_cases_39_, 3);
  sourceObject = obj2020;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj2020, *var_finally_39_, 4);
  sourceObject = obj2020;
  sourceObject = obj2020;
  sourceObject = obj2020;
  sourceObject = obj2020;
  sourceObject = obj2020;
  sourceObject = obj2020;
  objclass2020 = obj2020->class;
  objclass2020->definitionModule = modulename;
  objclass2020->definitionLine = 445;
  (*(struct UserObject *)self).data[0] = lowerouter2020;
  self = oldself2020;
  selfslot = oldselfslot2020;
  stackframe = oldstackframe2020;
  gc_frame_end(frame);
  return obj2020;
}
Object meth_ast_new_40_3_41_2019_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2020 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2020 = alloc_userobj2(13,11, objclass2020);
  gc_frame_newslot(obj2020);
if (objclass2020 == NULL) {
  glfree(obj2020->class->name);
  obj2020->class->name = "tryCatchNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2020, self, 0);
  addmethodreal(obj2020,"outer", &reader_ast_outer_2021);
  Object oldself2020 = self;
  struct StackFrameObject *oldstackframe2020 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2020);
  gc_frame_newslot((Object)stackframe);
  self = obj2020;
  Object *oldselfslot2020 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2020 = (*(struct UserObject *)self).data[0], lowerouter2020 = thisouter2020;
  if (inheritingObject2020) {
    struct UserObject *inho2020 = (struct UserObject *)inheritingObject2020;
    while (inho2020->super != GraceDefaultObject) inho2020 = (struct UserObject *)inho2020->super;
    inho2020->super = obj2020;
    self = inheritingObject2020;
    *selfslot = self;
    lowerouter2020 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2020;
  }
if (objclass2020 == NULL) {
  Method *reader2022 = addmethodrealflags(obj2020, "kind",&reader_ast_kind_2022, MFLAG_DEF);
  reader2022->definitionModule = modulename;
  reader2022->definitionLine = 447;
}
adddatum2(obj2020, alloc_Undefined(), 1);
if (objclass2020 == NULL) {
  Method *reader2023 = addmethodrealflags(obj2020, "value", &reader_ast_value_2023, 0);
  Method *writer2023 = addmethodrealflags(obj2020, "value:=(1)", &writer_ast_value_2023, 0);
  reader2023->definitionModule = modulename;
  writer2023->definitionModule = modulename;
  reader2023->definitionLine = 448;
  writer2023->definitionLine = 448;
}
obj2020->flags |= OFLAG_MUTABLE;
adddatum2(obj2020, alloc_Undefined(), 2);
if (objclass2020 == NULL) {
  Method *reader2024 = addmethodrealflags(obj2020, "cases", &reader_ast_cases_2024, 0);
  Method *writer2024 = addmethodrealflags(obj2020, "cases:=(1)", &writer_ast_cases_2024, 0);
  reader2024->definitionModule = modulename;
  writer2024->definitionModule = modulename;
  reader2024->definitionLine = 449;
  writer2024->definitionLine = 449;
}
obj2020->flags |= OFLAG_MUTABLE;
adddatum2(obj2020, alloc_Undefined(), 3);
if (objclass2020 == NULL) {
  Method *reader2025 = addmethodrealflags(obj2020, "finally", &reader_ast_finally_2025, 0);
  Method *writer2025 = addmethodrealflags(obj2020, "finally:=(1)", &writer_ast_finally_2025, 0);
  reader2025->definitionModule = modulename;
  writer2025->definitionModule = modulename;
  reader2025->definitionLine = 450;
  writer2025->definitionLine = 450;
}
obj2020->flags |= OFLAG_MUTABLE;
adddatum2(obj2020, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2026 = (struct UserObject*)obj2020;
  uo2026->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2026 = addmethod2pos(obj2020, "isSimple", &meth_ast_isSimple2026, 5);
  int argcv_meth_ast_isSimple2026[] = {0};
  meth_meth_ast_isSimple2026->type = alloc_MethodType(1, argcv_meth_ast_isSimple2026);
  meth_meth_ast_isSimple2026->definitionModule = modulename;
  meth_meth_ast_isSimple2026->definitionLine = 451;
// method "accept(_)from(_)"
  struct UserObject *uo2028 = (struct UserObject*)obj2020;
  uo2028->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2028 = addmethod2pos(obj2020, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2028, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2028[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2028->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2028);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2028->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2028->definitionLine = 453;
// method "map(_)ancestors(_)"
  struct UserObject *uo2058 = (struct UserObject*)obj2020;
  uo2058->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2058 = addmethod2pos(obj2020, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2058, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2058[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2058->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2058);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2058->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2058->definitionLine = 465;
// method "pretty(_)"
  struct UserObject *uo2091 = (struct UserObject*)obj2020;
  uo2091->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2091 = addmethod2pos(obj2020, "pretty(1)", &meth_ast_pretty_40_1_41_2091, 8);
  int argcv_meth_ast_pretty_40_1_41_2091[] = {1};
  meth_meth_ast_pretty_40_1_41_2091->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2091);
  meth_meth_ast_pretty_40_1_41_2091->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2091->definitionLine = 473;
// method "toGrace(_)"
  struct UserObject *uo2212 = (struct UserObject*)obj2020;
  uo2212->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2212 = addmethod2pos(obj2020, "toGrace(1)", &meth_ast_toGrace_40_1_41_2212, 9);
  int argcv_meth_ast_toGrace_40_1_41_2212[] = {1};
  meth_meth_ast_toGrace_40_1_41_2212->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2212);
meth_meth_ast_toGrace_40_1_41_2212->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2212->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2212->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2212->definitionLine = 488;
// method "shallowCopy"
  block_savedest(obj2020);
  Object closure2314 = createclosure(3, "shallowCopy");
  setclosureframe(closure2314, stackframe);
  addtoclosure(closure2314, var_nullNode);
  addtoclosure(closure2314, var_emptySeq);
  addtoclosure(closure2314, var_tryCatchNode);
  struct UserObject *uo2314 = (struct UserObject*)obj2020;
  uo2314->data[10] = (Object)closure2314;
  Method *meth_meth_ast_shallowCopy2314 = addmethod2pos(obj2020, "shallowCopy", &meth_ast_shallowCopy2314, 10);
  int argcv_meth_ast_shallowCopy2314[] = {0};
  meth_meth_ast_shallowCopy2314->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2314);
  meth_meth_ast_shallowCopy2314->definitionModule = modulename;
  meth_meth_ast_shallowCopy2314->definitionLine = 502;
  sourceObject = obj2020;
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2320 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2321 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2322 = gc_frame_new();
// call case 3: self.outer request
  Object call2323 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2322);
// compiled member node returning call2323 (depth = 5)
  Object call2324 = callmethodflags(call2323, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2321);
// compiled member node returning call2324 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2325 = callmethodflags(call2324, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2320);
// compiled call node returning call2325 (depth = 3)
  struct UserObject *obj2020_uo = (struct UserObject *)obj2020;
  obj2020_uo->super = call2325;
  sourceObject = obj2020;
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2326 == NULL) {
    strlit2326 = alloc_String("trycatch");
    gc_root(strlit2326);
  }
// compiled string node returning strlit2326 (depth = 3)
  adddatum2(obj2020, strlit2326, 1);
  sourceObject = obj2020;
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj2020, *var_block, 2);
  sourceObject = obj2020;
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2020, *var_cases_39_, 3);
  sourceObject = obj2020;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj2020, *var_finally_39_, 4);
  sourceObject = obj2020;
  sourceObject = obj2020;
  sourceObject = obj2020;
  sourceObject = obj2020;
  sourceObject = obj2020;
  sourceObject = obj2020;
  objclass2020 = obj2020->class;
  objclass2020->definitionModule = modulename;
  objclass2020->definitionLine = 445;
  (*(struct UserObject *)self).data[0] = lowerouter2020;
  self = oldself2020;
  selfslot = oldselfslot2020;
  stackframe = oldstackframe2020;
  gc_frame_end(frame);
  return obj2020;
}
Object meth_ast_tryCatchNode2328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tryCatchNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tryCatchNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tryCatchNode (depth = 3)
  gc_frame_end(frame);
  return *var_tryCatchNode;
}
Object meth_ast_isSimple2338(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2339 = alloc_Boolean(0);
// compiled identifier node returning bool2339 (depth = 3)
  gc_frame_end(frame);
  return bool2339;
}
Object meth_ast_matchee2340(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "matchee");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2341 = gc_frame_new();
// call case 4: self request
  Object call2342 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2341);
// compiled member node returning call2342 (depth = 3)
  gc_frame_end(frame);
  return call2342;
}
Object meth_ast__apply_40_1_41_2357(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2358 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2359 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2358);
// compiled call node returning call2359 (depth = 6)
  gc_frame_end(frame);
  return call2359;
}
Object meth_ast_accept_40_1_41_from_40_1_41_2343(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2345 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2346 = callmethodflags(*var_visitor, "visitMatchCase(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2345);
// compiled call node returning call2346 (depth = 4)
  Object if2344 = done;
  if (istrue(call2346)) {
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2347 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2348 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2347);
// compiled call node returning call2348 (depth = 5)
  *var_newChain = call2348;
  if (call2348 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2349 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2350 = gc_frame_new();
// call case 4: self request
  Object call2351 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2350);
// compiled member node returning call2351 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2352 = callmethodflags(call2351, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2349);
// compiled call node returning call2352 (depth = 4)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2353 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2354 = gc_frame_new();
// call case 4: self request
  Object call2355 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2354);
// compiled member node returning call2355 (depth = 5)
  gc_frame_newslot(call2355);
// starting to compile block node (depth = 5)
  Object block2356 = alloc_Block(NULL, NULL, "ast", 520);
  gc_frame_newslot(block2356);
// method "_apply(_)"
  block_savedest(block2356);
  Object closure2357 = createclosure(3, "_apply(1)");
  setclosureframe(closure2357, stackframe);
  addtoclosure(closure2357, var_visitor);
  addtoclosure(closure2357, var_newChain);
  addtoclosure(closure2357, selfslot);
  struct UserObject *uo2357 = (struct UserObject*)block2356;
  uo2357->data[0] = (Object)closure2357;
  Method *meth_meth_ast__apply_40_1_41_2357 = addmethod2pos(block2356, "_apply(1)", &meth_ast__apply_40_1_41_2357, 0);
  int argcv_meth_ast__apply_40_1_41_2357[] = {1};
  meth_meth_ast__apply_40_1_41_2357->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2357);
  meth_meth_ast__apply_40_1_41_2357->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2357->definitionLine = 2969;
// compiled block node returning block2356 (depth = 5)
  gc_frame_newslot(block2356);
// call case 5: prelude request
  params[0] = call2355;
  params[1] = block2356;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2361 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2353);
// compiled call node returning call2361 (depth = 4)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2364 = gc_frame_new();
// call case 4: self request
  Object call2365 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2364);
// compiled member node returning call2365 (depth = 6)
  int op_slot_right_2363 = gc_frame_newslot(call2365);
// starting to compile identifier node (depth = 6)
  Object bool2367 = alloc_Boolean(0);
// compiled identifier node returning bool2367 (depth = 6)
  int op_slot_left_2363 = gc_frame_newslot(bool2367);
  params[0] = call2365;
  partcv[0] = 1;
  Object opresult2368 = callmethod(bool2367, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2368 (depth = 5)
  Object if2362 = done;
  if (istrue(opresult2368)) {
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2369 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2370 = gc_frame_new();
// call case 4: self request
  Object call2371 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2370);
// compiled member node returning call2371 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2372 = callmethodflags(call2371, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2369);
// compiled call node returning call2372 (depth = 5)
    gc_frame_newslot(call2372);
    if2362 = call2372;
  } else {
  }
// compiled if node returning if2362 (depth = 4)
    gc_frame_newslot(if2362);
    if2344 = if2362;
  } else {
  }
// compiled if node returning if2344 (depth = 3)
  gc_frame_end(frame);
  return if2344;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_2373(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2374 = gc_frame_new();
// call case 4: self request
  Object call2375 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2374);
// compiled member node returning call2375 (depth = 4)
  *var_n = call2375;
  if (call2375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2376 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2377 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2376);
// compiled call node returning call2377 (depth = 4)
  *var_newChain = call2377;
  if (call2377 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2378 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2379 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2380 = gc_frame_new();
// call case 4: self request
  Object call2381 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2380);
// compiled member node returning call2381 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2382 = callmethodflags(call2381, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2379);
// compiled call node returning call2382 (depth = 4)
  gc_frame_newslot(call2382);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2382;
  partcv[0] = 1;
  Object call2383 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2378);
// compiled call node returning call2383 (depth = 3)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2384 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2385 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2386 = gc_frame_new();
// call case 4: self request
  Object call2387 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2386);
// compiled member node returning call2387 (depth = 5)
  gc_frame_newslot(call2387);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2388 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2389 = gc_frame_new();
// call case 3: self.outer request
  Object call2390 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2389);
// compiled member node returning call2390 (depth = 6)
  Object call2391 = callmethodflags(call2390, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2388);
// compiled member node returning call2391 (depth = 5)
  params[0] = call2387;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2392 = callmethodflags(call2391, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2385);
// compiled call node returning call2392 (depth = 4)
  gc_frame_newslot(call2392);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2392;
  partcv[0] = 1;
  Object call2393 = callmethodflags(*var_n, "cases:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2384);
// compiled call node returning call2393 (depth = 3)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2394 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2395 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2396 = gc_frame_new();
// call case 4: self request
  Object call2397 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2396);
// compiled member node returning call2397 (depth = 5)
  gc_frame_newslot(call2397);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2398 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2399 = gc_frame_new();
// call case 3: self.outer request
  Object call2400 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2399);
// compiled member node returning call2400 (depth = 6)
  Object call2401 = callmethodflags(call2400, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2398);
// compiled member node returning call2401 (depth = 5)
  params[0] = call2397;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2402 = callmethodflags(call2401, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2395);
// compiled call node returning call2402 (depth = 4)
  gc_frame_newslot(call2402);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2402;
  partcv[0] = 1;
  Object call2403 = callmethodflags(*var_n, "elsecase:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2394);
// compiled call node returning call2403 (depth = 3)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2404 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2405 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2404);
// compiled call node returning call2405 (depth = 3)
  gc_frame_end(frame);
  return call2405;
}
Object meth_ast__apply_40_1_41_2414(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2416 == NULL) {
    strlit2416 = alloc_String("  ");
    gc_root(strlit2416);
  }
// compiled string node returning strlit2416 (depth = 7)
  int op_slot_right_2415 = gc_frame_newslot(strlit2416);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2415 = gc_frame_newslot(*var_spc);
  params[0] = strlit2416;
  partcv[0] = 1;
  Object opresult2418 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2418 (depth = 6)
  *var_spc = opresult2418;
  if (opresult2418 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2447(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2450 == NULL) {
    strlit2450 = alloc_String("");
    gc_root(strlit2450);
  }
// compiled string node returning strlit2450 (depth = 8)
  int op_slot_right_2449 = gc_frame_newslot(strlit2450);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2453 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2455 = alloc_Float64(2);
// compiled num node returning num2455 (depth = 11)
  int op_slot_right_2454 = gc_frame_newslot(num2455);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2454 = gc_frame_newslot(*var_depth);
  params[0] = num2455;
  partcv[0] = 1;
  Object sum2457 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2457 (depth = 10)
  gc_frame_newslot(sum2457);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2457;
  partcv[0] = 1;
  Object call2458 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2453);
// compiled call node returning call2458 (depth = 9)
  int op_slot_right_2452 = gc_frame_newslot(call2458);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2461 == NULL) {
    strlit2461 = alloc_String("  ");
    gc_root(strlit2461);
  }
// compiled string node returning strlit2461 (depth = 10)
  int op_slot_right_2460 = gc_frame_newslot(strlit2461);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2463 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2466 == NULL) {
    strlit2466 = alloc_String("Case:""\x0a""");
    gc_root(strlit2466);
  }
// compiled string node returning strlit2466 (depth = 12)
  int op_slot_right_2465 = gc_frame_newslot(strlit2466);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2468 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2470 == NULL) {
    strlit2470 = alloc_String("""\x0a""");
    gc_root(strlit2470);
  }
// compiled string node returning strlit2470 (depth = 13)
  int op_slot_left_2468 = gc_frame_newslot(strlit2470);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2471 = callmethod(strlit2470, "++(1)", 1, partcv, params);
// compiled op node returning opresult2471 (depth = 12)
  int op_slot_left_2465 = gc_frame_newslot(opresult2471);
  params[0] = strlit2466;
  partcv[0] = 1;
  Object opresult2472 = callmethod(opresult2471, "++(1)", 1, partcv, params);
// compiled op node returning opresult2472 (depth = 11)
  int op_slot_left_2463 = gc_frame_newslot(opresult2472);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2473 = callmethod(opresult2472, "++(1)", 1, partcv, params);
// compiled op node returning opresult2473 (depth = 10)
  int op_slot_left_2460 = gc_frame_newslot(opresult2473);
  params[0] = strlit2461;
  partcv[0] = 1;
  Object opresult2474 = callmethod(opresult2473, "++(1)", 1, partcv, params);
// compiled op node returning opresult2474 (depth = 9)
  int op_slot_left_2452 = gc_frame_newslot(opresult2474);
  params[0] = call2458;
  partcv[0] = 1;
  Object opresult2475 = callmethod(opresult2474, "++(1)", 1, partcv, params);
// compiled op node returning opresult2475 (depth = 8)
  int op_slot_left_2449 = gc_frame_newslot(opresult2475);
  params[0] = strlit2450;
  partcv[0] = 1;
  Object opresult2476 = callmethod(opresult2475, "++(1)", 1, partcv, params);
// compiled op node returning opresult2476 (depth = 7)
  int op_slot_right_2448 = gc_frame_newslot(opresult2476);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2448 = gc_frame_newslot(*var_s);
  params[0] = opresult2476;
  partcv[0] = 1;
  Object opresult2478 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2478 (depth = 6)
  *var_s = opresult2478;
  if (opresult2478 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_2406(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2407 == NULL) {
    strlit2407 = alloc_String("");
    gc_root(strlit2407);
  }
// compiled string node returning strlit2407 (depth = 4)
  *var_spc = strlit2407;
  if (strlit2407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2408 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2409 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2411 = alloc_Float64(0);
// compiled num node returning num2411 (depth = 5)
  int op_slot_left_2409 = gc_frame_newslot(num2411);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2412 = callmethod(num2411, "..(1)", 1, partcv, params);
// compiled op node returning opresult2412 (depth = 4)
  gc_frame_newslot(opresult2412);
// starting to compile block node (depth = 4)
  Object block2413 = alloc_Block(NULL, NULL, "ast", 538);
  gc_frame_newslot(block2413);
// method "_apply(_)"
  block_savedest(block2413);
  Object closure2414 = createclosure(2, "_apply(1)");
  setclosureframe(closure2414, stackframe);
  addtoclosure(closure2414, var_spc);
  addtoclosure(closure2414, selfslot);
  struct UserObject *uo2414 = (struct UserObject*)block2413;
  uo2414->data[0] = (Object)closure2414;
  Method *meth_meth_ast__apply_40_1_41_2414 = addmethod2pos(block2413, "_apply(1)", &meth_ast__apply_40_1_41_2414, 0);
  int argcv_meth_ast__apply_40_1_41_2414[] = {1};
  meth_meth_ast__apply_40_1_41_2414->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2414);
  meth_meth_ast__apply_40_1_41_2414->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2414->definitionLine = 2969;
// compiled block node returning block2413 (depth = 4)
  gc_frame_newslot(block2413);
// call case 5: prelude request
  params[0] = opresult2412;
  params[1] = block2413;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2421 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2408);
// compiled call node returning call2421 (depth = 3)
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2423 == NULL) {
    strlit2423 = alloc_String("""\x0a""");
    gc_root(strlit2423);
  }
// compiled string node returning strlit2423 (depth = 5)
  int op_slot_right_2422 = gc_frame_newslot(strlit2423);
// starting to compile call node (depth = 5)
  int callframe2425 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2426 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2425);
// compiled call node returning call2426 (depth = 5)
  int op_slot_left_2422 = gc_frame_newslot(call2426);
  params[0] = strlit2423;
  partcv[0] = 1;
  Object opresult2427 = callmethod(call2426, "++(1)", 1, partcv, params);
// compiled op node returning opresult2427 (depth = 4)
  *var_s = opresult2427;
  if (opresult2427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2429 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2431 = alloc_Float64(2);
// compiled num node returning num2431 (depth = 7)
  int op_slot_right_2430 = gc_frame_newslot(num2431);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2430 = gc_frame_newslot(*var_depth);
  params[0] = num2431;
  partcv[0] = 1;
  Object sum2433 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2433 (depth = 6)
  gc_frame_newslot(sum2433);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2434 = gc_frame_new();
// call case 4: self request
  Object call2435 = callmethodflags(self, "matchee", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2434);
// compiled member node returning call2435 (depth = 6)
  params[0] = sum2433;
  partcv[0] = 1;
  Object call2436 = callmethodflags(call2435, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2429);
// compiled call node returning call2436 (depth = 5)
  int op_slot_right_2428 = gc_frame_newslot(call2436);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2438 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2438 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2440 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2440 (depth = 5)
  int op_slot_left_2428 = gc_frame_newslot(opresult2440);
  params[0] = call2436;
  partcv[0] = 1;
  Object opresult2441 = callmethod(opresult2440, "++(1)", 1, partcv, params);
// compiled op node returning opresult2441 (depth = 4)
  *var_s = opresult2441;
  if (opresult2441 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2443 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2444 = gc_frame_new();
// call case 4: self request
  Object call2445 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2444);
// compiled member node returning call2445 (depth = 4)
  gc_frame_newslot(call2445);
// starting to compile block node (depth = 4)
  Object block2446 = alloc_Block(NULL, NULL, "ast", 543);
  gc_frame_newslot(block2446);
// method "_apply(_)"
  block_savedest(block2446);
  Object closure2447 = createclosure(4, "_apply(1)");
  setclosureframe(closure2447, stackframe);
  addtoclosure(closure2447, var_depth);
  addtoclosure(closure2447, var_spc);
  addtoclosure(closure2447, var_s);
  addtoclosure(closure2447, selfslot);
  struct UserObject *uo2447 = (struct UserObject*)block2446;
  uo2447->data[0] = (Object)closure2447;
  Method *meth_meth_ast__apply_40_1_41_2447 = addmethod2pos(block2446, "_apply(1)", &meth_ast__apply_40_1_41_2447, 0);
  int argcv_meth_ast__apply_40_1_41_2447[] = {1};
  meth_meth_ast__apply_40_1_41_2447->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2447);
  meth_meth_ast__apply_40_1_41_2447->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2447->definitionLine = 2969;
// compiled block node returning block2446 (depth = 4)
  gc_frame_newslot(block2446);
// call case 5: prelude request
  params[0] = call2445;
  params[1] = block2446;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2481 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2443);
// compiled call node returning call2481 (depth = 3)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2484 = gc_frame_new();
// call case 4: self request
  Object call2485 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2484);
// compiled member node returning call2485 (depth = 5)
  int op_slot_right_2483 = gc_frame_newslot(call2485);
// starting to compile identifier node (depth = 5)
  Object bool2487 = alloc_Boolean(0);
// compiled identifier node returning bool2487 (depth = 5)
  int op_slot_left_2483 = gc_frame_newslot(bool2487);
  params[0] = call2485;
  partcv[0] = 1;
  Object opresult2488 = callmethod(bool2487, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2488 (depth = 4)
  Object if2482 = done;
  if (istrue(opresult2488)) {
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2491 == NULL) {
    strlit2491 = alloc_String("");
    gc_root(strlit2491);
  }
// compiled string node returning strlit2491 (depth = 7)
  int op_slot_right_2490 = gc_frame_newslot(strlit2491);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2494 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2496 = alloc_Float64(2);
// compiled num node returning num2496 (depth = 10)
  int op_slot_right_2495 = gc_frame_newslot(num2496);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2495 = gc_frame_newslot(*var_depth);
  params[0] = num2496;
  partcv[0] = 1;
  Object sum2498 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2498 (depth = 9)
  gc_frame_newslot(sum2498);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2499 = gc_frame_new();
// call case 4: self request
  Object call2500 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2499);
// compiled member node returning call2500 (depth = 9)
  params[0] = sum2498;
  partcv[0] = 1;
  Object call2501 = callmethodflags(call2500, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2494);
// compiled call node returning call2501 (depth = 8)
  int op_slot_right_2493 = gc_frame_newslot(call2501);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2504 == NULL) {
    strlit2504 = alloc_String("  ");
    gc_root(strlit2504);
  }
// compiled string node returning strlit2504 (depth = 9)
  int op_slot_right_2503 = gc_frame_newslot(strlit2504);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2506 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2509 == NULL) {
    strlit2509 = alloc_String("Else:""\x0a""");
    gc_root(strlit2509);
  }
// compiled string node returning strlit2509 (depth = 11)
  int op_slot_right_2508 = gc_frame_newslot(strlit2509);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2511 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2513 == NULL) {
    strlit2513 = alloc_String("""\x0a""");
    gc_root(strlit2513);
  }
// compiled string node returning strlit2513 (depth = 12)
  int op_slot_left_2511 = gc_frame_newslot(strlit2513);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2514 = callmethod(strlit2513, "++(1)", 1, partcv, params);
// compiled op node returning opresult2514 (depth = 11)
  int op_slot_left_2508 = gc_frame_newslot(opresult2514);
  params[0] = strlit2509;
  partcv[0] = 1;
  Object opresult2515 = callmethod(opresult2514, "++(1)", 1, partcv, params);
// compiled op node returning opresult2515 (depth = 10)
  int op_slot_left_2506 = gc_frame_newslot(opresult2515);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2516 = callmethod(opresult2515, "++(1)", 1, partcv, params);
// compiled op node returning opresult2516 (depth = 9)
  int op_slot_left_2503 = gc_frame_newslot(opresult2516);
  params[0] = strlit2504;
  partcv[0] = 1;
  Object opresult2517 = callmethod(opresult2516, "++(1)", 1, partcv, params);
// compiled op node returning opresult2517 (depth = 8)
  int op_slot_left_2493 = gc_frame_newslot(opresult2517);
  params[0] = call2501;
  partcv[0] = 1;
  Object opresult2518 = callmethod(opresult2517, "++(1)", 1, partcv, params);
// compiled op node returning opresult2518 (depth = 7)
  int op_slot_left_2490 = gc_frame_newslot(opresult2518);
  params[0] = strlit2491;
  partcv[0] = 1;
  Object opresult2519 = callmethod(opresult2518, "++(1)", 1, partcv, params);
// compiled op node returning opresult2519 (depth = 6)
  int op_slot_right_2489 = gc_frame_newslot(opresult2519);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2489 = gc_frame_newslot(*var_s);
  params[0] = opresult2519;
  partcv[0] = 1;
  Object opresult2521 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2521 (depth = 5)
  *var_s = opresult2521;
  if (opresult2521 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2482 = done;
  } else {
  }
// compiled if node returning if2482 (depth = 3)
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_2535(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2537 == NULL) {
    strlit2537 = alloc_String("    ");
    gc_root(strlit2537);
  }
// compiled string node returning strlit2537 (depth = 7)
  int op_slot_right_2536 = gc_frame_newslot(strlit2537);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2536 = gc_frame_newslot(*var_spc);
  params[0] = strlit2537;
  partcv[0] = 1;
  Object opresult2539 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2539 (depth = 6)
  *var_spc = opresult2539;
  if (opresult2539 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2560(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2562 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2564 = alloc_Float64(2);
// compiled num node returning num2564 (depth = 9)
  int op_slot_right_2563 = gc_frame_newslot(num2564);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2563 = gc_frame_newslot(*var_depth);
  params[0] = num2564;
  partcv[0] = 1;
  Object sum2566 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2566 (depth = 8)
  gc_frame_newslot(sum2566);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2566;
  partcv[0] = 1;
  Object call2567 = callmethodflags(*var_case, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2562);
// compiled call node returning call2567 (depth = 7)
  int op_slot_right_2561 = gc_frame_newslot(call2567);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2570 == NULL) {
    strlit2570 = alloc_String("case ");
    gc_root(strlit2570);
  }
// compiled string node returning strlit2570 (depth = 8)
  int op_slot_right_2569 = gc_frame_newslot(strlit2570);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2573 == NULL) {
    strlit2573 = alloc_String("    ");
    gc_root(strlit2573);
  }
// compiled string node returning strlit2573 (depth = 9)
  int op_slot_right_2572 = gc_frame_newslot(strlit2573);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2575 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2578 == NULL) {
    strlit2578 = alloc_String("""\x0a""");
    gc_root(strlit2578);
  }
// compiled string node returning strlit2578 (depth = 11)
  int op_slot_right_2577 = gc_frame_newslot(strlit2578);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2577 = gc_frame_newslot(*var_s);
  params[0] = strlit2578;
  partcv[0] = 1;
  Object opresult2580 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2580 (depth = 10)
  int op_slot_left_2575 = gc_frame_newslot(opresult2580);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2581 = callmethod(opresult2580, "++(1)", 1, partcv, params);
// compiled op node returning opresult2581 (depth = 9)
  int op_slot_left_2572 = gc_frame_newslot(opresult2581);
  params[0] = strlit2573;
  partcv[0] = 1;
  Object opresult2582 = callmethod(opresult2581, "++(1)", 1, partcv, params);
// compiled op node returning opresult2582 (depth = 8)
  int op_slot_left_2569 = gc_frame_newslot(opresult2582);
  params[0] = strlit2570;
  partcv[0] = 1;
  Object opresult2583 = callmethod(opresult2582, "++(1)", 1, partcv, params);
// compiled op node returning opresult2583 (depth = 7)
  int op_slot_left_2561 = gc_frame_newslot(opresult2583);
  params[0] = call2567;
  partcv[0] = 1;
  Object opresult2584 = callmethod(opresult2583, "++(1)", 1, partcv, params);
// compiled op node returning opresult2584 (depth = 6)
  *var_s = opresult2584;
  if (opresult2584 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_2523(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2524 == NULL) {
    strlit2524 = alloc_String("");
    gc_root(strlit2524);
  }
// compiled string node returning strlit2524 (depth = 4)
  *var_spc = strlit2524;
  if (strlit2524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2525 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2528 = alloc_Float64(1);
// compiled num node returning num2528 (depth = 6)
  int op_slot_right_2527 = gc_frame_newslot(num2528);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2527 = gc_frame_newslot(*var_depth);
  params[0] = num2528;
  partcv[0] = 1;
  Object diff2530 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff2530 (depth = 5)
  int op_slot_right_2526 = gc_frame_newslot(diff2530);
// starting to compile num node (depth = 5)
  Object num2532 = alloc_Float64(0);
// compiled num node returning num2532 (depth = 5)
  int op_slot_left_2526 = gc_frame_newslot(num2532);
  params[0] = diff2530;
  partcv[0] = 1;
  Object opresult2533 = callmethod(num2532, "..(1)", 1, partcv, params);
// compiled op node returning opresult2533 (depth = 4)
  gc_frame_newslot(opresult2533);
// starting to compile block node (depth = 4)
  Object block2534 = alloc_Block(NULL, NULL, "ast", 553);
  gc_frame_newslot(block2534);
// method "_apply(_)"
  block_savedest(block2534);
  Object closure2535 = createclosure(2, "_apply(1)");
  setclosureframe(closure2535, stackframe);
  addtoclosure(closure2535, var_spc);
  addtoclosure(closure2535, selfslot);
  struct UserObject *uo2535 = (struct UserObject*)block2534;
  uo2535->data[0] = (Object)closure2535;
  Method *meth_meth_ast__apply_40_1_41_2535 = addmethod2pos(block2534, "_apply(1)", &meth_ast__apply_40_1_41_2535, 0);
  int argcv_meth_ast__apply_40_1_41_2535[] = {1};
  meth_meth_ast__apply_40_1_41_2535->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2535);
  meth_meth_ast__apply_40_1_41_2535->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2535->definitionLine = 2969;
// compiled block node returning block2534 (depth = 4)
  gc_frame_newslot(block2534);
// call case 5: prelude request
  params[0] = opresult2533;
  params[1] = block2534;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2542 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2525);
// compiled call node returning call2542 (depth = 3)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2544 == NULL) {
    strlit2544 = alloc_String(")");
    gc_root(strlit2544);
  }
// compiled string node returning strlit2544 (depth = 5)
  int op_slot_right_2543 = gc_frame_newslot(strlit2544);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2547 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num2548 = alloc_Float64(0);
// compiled num node returning num2548 (depth = 7)
  gc_frame_newslot(num2548);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2549 = gc_frame_new();
// call case 4: self request
  Object call2550 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2549);
// compiled member node returning call2550 (depth = 7)
  params[0] = num2548;
  partcv[0] = 1;
  Object call2551 = callmethodflags(call2550, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2547);
// compiled call node returning call2551 (depth = 6)
  int op_slot_right_2546 = gc_frame_newslot(call2551);
// starting to compile string node (depth = 6)
  if (strlit2553 == NULL) {
    strlit2553 = alloc_String("match(");
    gc_root(strlit2553);
  }
// compiled string node returning strlit2553 (depth = 6)
  int op_slot_left_2546 = gc_frame_newslot(strlit2553);
  params[0] = call2551;
  partcv[0] = 1;
  Object opresult2554 = callmethod(strlit2553, "++(1)", 1, partcv, params);
// compiled op node returning opresult2554 (depth = 5)
  int op_slot_left_2543 = gc_frame_newslot(opresult2554);
  params[0] = strlit2544;
  partcv[0] = 1;
  Object opresult2555 = callmethod(opresult2554, "++(1)", 1, partcv, params);
// compiled op node returning opresult2555 (depth = 4)
  *var_s = opresult2555;
  if (opresult2555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2556 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2557 = gc_frame_new();
// call case 4: self request
  Object call2558 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2557);
// compiled member node returning call2558 (depth = 4)
  gc_frame_newslot(call2558);
// starting to compile block node (depth = 4)
  Object block2559 = alloc_Block(NULL, NULL, "ast", 557);
  gc_frame_newslot(block2559);
// method "_apply(_)"
  block_savedest(block2559);
  Object closure2560 = createclosure(4, "_apply(1)");
  setclosureframe(closure2560, stackframe);
  addtoclosure(closure2560, var_depth);
  addtoclosure(closure2560, var_spc);
  addtoclosure(closure2560, var_s);
  addtoclosure(closure2560, selfslot);
  struct UserObject *uo2560 = (struct UserObject*)block2559;
  uo2560->data[0] = (Object)closure2560;
  Method *meth_meth_ast__apply_40_1_41_2560 = addmethod2pos(block2559, "_apply(1)", &meth_ast__apply_40_1_41_2560, 0);
  int argcv_meth_ast__apply_40_1_41_2560[] = {1};
  meth_meth_ast__apply_40_1_41_2560->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2560);
  meth_meth_ast__apply_40_1_41_2560->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2560->definitionLine = 2969;
// compiled block node returning block2559 (depth = 4)
  gc_frame_newslot(block2559);
// call case 5: prelude request
  params[0] = call2558;
  params[1] = block2559;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2587 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2556);
// compiled call node returning call2587 (depth = 3)
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2590 = gc_frame_new();
// call case 4: self request
  Object call2591 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2590);
// compiled member node returning call2591 (depth = 5)
  int op_slot_right_2589 = gc_frame_newslot(call2591);
// starting to compile identifier node (depth = 5)
  Object bool2593 = alloc_Boolean(0);
// compiled identifier node returning bool2593 (depth = 5)
  int op_slot_left_2589 = gc_frame_newslot(bool2593);
  params[0] = call2591;
  partcv[0] = 1;
  Object opresult2594 = callmethod(bool2593, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2594 (depth = 4)
  Object if2588 = done;
  if (istrue(opresult2594)) {
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2596 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2598 = alloc_Float64(2);
// compiled num node returning num2598 (depth = 8)
  int op_slot_right_2597 = gc_frame_newslot(num2598);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2597 = gc_frame_newslot(*var_depth);
  params[0] = num2598;
  partcv[0] = 1;
  Object sum2600 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2600 (depth = 7)
  gc_frame_newslot(sum2600);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2601 = gc_frame_new();
// call case 4: self request
  Object call2602 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2601);
// compiled member node returning call2602 (depth = 7)
  params[0] = sum2600;
  partcv[0] = 1;
  Object call2603 = callmethodflags(call2602, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2596);
// compiled call node returning call2603 (depth = 6)
  int op_slot_right_2595 = gc_frame_newslot(call2603);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2606 == NULL) {
    strlit2606 = alloc_String("else ");
    gc_root(strlit2606);
  }
// compiled string node returning strlit2606 (depth = 7)
  int op_slot_right_2605 = gc_frame_newslot(strlit2606);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2609 == NULL) {
    strlit2609 = alloc_String("    ");
    gc_root(strlit2609);
  }
// compiled string node returning strlit2609 (depth = 8)
  int op_slot_right_2608 = gc_frame_newslot(strlit2609);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2611 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2614 == NULL) {
    strlit2614 = alloc_String("""\x0a""");
    gc_root(strlit2614);
  }
// compiled string node returning strlit2614 (depth = 10)
  int op_slot_right_2613 = gc_frame_newslot(strlit2614);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2613 = gc_frame_newslot(*var_s);
  params[0] = strlit2614;
  partcv[0] = 1;
  Object opresult2616 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2616 (depth = 9)
  int op_slot_left_2611 = gc_frame_newslot(opresult2616);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2617 = callmethod(opresult2616, "++(1)", 1, partcv, params);
// compiled op node returning opresult2617 (depth = 8)
  int op_slot_left_2608 = gc_frame_newslot(opresult2617);
  params[0] = strlit2609;
  partcv[0] = 1;
  Object opresult2618 = callmethod(opresult2617, "++(1)", 1, partcv, params);
// compiled op node returning opresult2618 (depth = 7)
  int op_slot_left_2605 = gc_frame_newslot(opresult2618);
  params[0] = strlit2606;
  partcv[0] = 1;
  Object opresult2619 = callmethod(opresult2618, "++(1)", 1, partcv, params);
// compiled op node returning opresult2619 (depth = 6)
  int op_slot_left_2595 = gc_frame_newslot(opresult2619);
  params[0] = call2603;
  partcv[0] = 1;
  Object opresult2620 = callmethod(opresult2619, "++(1)", 1, partcv, params);
// compiled op node returning opresult2620 (depth = 5)
  *var_s = opresult2620;
  if (opresult2620 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2588 = done;
  } else {
  }
// compiled if node returning if2588 (depth = 3)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2622(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2623 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2624 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2625 = alloc_Boolean(0);
// compiled identifier node returning bool2625 (depth = 5)
  gc_frame_newslot(bool2625);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchCaseNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2625;
  partcv[0] = 3;
  Object call2626 = callmethodflags(*var_matchCaseNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe2624);
// compiled call node returning call2626 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2627 = callmethodflags(call2626, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2623);
// compiled call node returning call2627 (depth = 3)
  gc_frame_end(frame);
  return call2627;
}
Object meth_ast_new_40_3_41_2331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2332 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2332 = alloc_userobj2(14,12, objclass2332);
  gc_frame_newslot(obj2332);
if (objclass2332 == NULL) {
  glfree(obj2332->class->name);
  obj2332->class->name = "matchCaseNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2332, self, 0);
  addmethodreal(obj2332,"outer", &reader_ast_outer_2333);
  Object oldself2332 = self;
  struct StackFrameObject *oldstackframe2332 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2332);
  gc_frame_newslot((Object)stackframe);
  self = obj2332;
  Object *oldselfslot2332 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2332 = (*(struct UserObject *)self).data[0], lowerouter2332 = thisouter2332;
  if (inheritingObject2332) {
    struct UserObject *inho2332 = (struct UserObject *)inheritingObject2332;
    while (inho2332->super != GraceDefaultObject) inho2332 = (struct UserObject *)inho2332->super;
    inho2332->super = obj2332;
    self = inheritingObject2332;
    *selfslot = self;
    lowerouter2332 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2332;
  }
if (objclass2332 == NULL) {
  Method *reader2334 = addmethodrealflags(obj2332, "kind",&reader_ast_kind_2334, MFLAG_DEF);
  reader2334->definitionModule = modulename;
  reader2334->definitionLine = 510;
}
adddatum2(obj2332, alloc_Undefined(), 1);
if (objclass2332 == NULL) {
  Method *reader2335 = addmethodrealflags(obj2332, "value", &reader_ast_value_2335, 0);
  Method *writer2335 = addmethodrealflags(obj2332, "value:=(1)", &writer_ast_value_2335, 0);
  reader2335->definitionModule = modulename;
  writer2335->definitionModule = modulename;
  reader2335->definitionLine = 511;
  writer2335->definitionLine = 511;
}
obj2332->flags |= OFLAG_MUTABLE;
adddatum2(obj2332, alloc_Undefined(), 2);
if (objclass2332 == NULL) {
  Method *reader2336 = addmethodrealflags(obj2332, "cases", &reader_ast_cases_2336, 0);
  Method *writer2336 = addmethodrealflags(obj2332, "cases:=(1)", &writer_ast_cases_2336, 0);
  reader2336->definitionModule = modulename;
  writer2336->definitionModule = modulename;
  reader2336->definitionLine = 512;
  writer2336->definitionLine = 512;
}
obj2332->flags |= OFLAG_MUTABLE;
adddatum2(obj2332, alloc_Undefined(), 3);
if (objclass2332 == NULL) {
  Method *reader2337 = addmethodrealflags(obj2332, "elsecase", &reader_ast_elsecase_2337, 0);
  Method *writer2337 = addmethodrealflags(obj2332, "elsecase:=(1)", &writer_ast_elsecase_2337, 0);
  reader2337->definitionModule = modulename;
  writer2337->definitionModule = modulename;
  reader2337->definitionLine = 513;
  writer2337->definitionLine = 513;
}
obj2332->flags |= OFLAG_MUTABLE;
adddatum2(obj2332, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2338 = (struct UserObject*)obj2332;
  uo2338->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2338 = addmethod2pos(obj2332, "isSimple", &meth_ast_isSimple2338, 5);
  int argcv_meth_ast_isSimple2338[] = {0};
  meth_meth_ast_isSimple2338->type = alloc_MethodType(1, argcv_meth_ast_isSimple2338);
  meth_meth_ast_isSimple2338->definitionModule = modulename;
  meth_meth_ast_isSimple2338->definitionLine = 514;
// method "matchee"
  struct UserObject *uo2340 = (struct UserObject*)obj2332;
  uo2340->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2340 = addmethod2pos(obj2332, "matchee", &meth_ast_matchee2340, 6);
  int argcv_meth_ast_matchee2340[] = {0};
  meth_meth_ast_matchee2340->type = alloc_MethodType(1, argcv_meth_ast_matchee2340);
  meth_meth_ast_matchee2340->definitionModule = modulename;
  meth_meth_ast_matchee2340->definitionLine = 515;
// method "accept(_)from(_)"
  struct UserObject *uo2343 = (struct UserObject*)obj2332;
  uo2343->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2343 = addmethod2pos(obj2332, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2343, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2343[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2343->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2343);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2343->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2343->definitionLine = 516;
// method "map(_)ancestors(_)"
  struct UserObject *uo2373 = (struct UserObject*)obj2332;
  uo2373->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2373 = addmethod2pos(obj2332, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2373, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2373[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2373->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2373);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2373->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2373->definitionLine = 528;
// method "pretty(_)"
  struct UserObject *uo2406 = (struct UserObject*)obj2332;
  uo2406->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2406 = addmethod2pos(obj2332, "pretty(1)", &meth_ast_pretty_40_1_41_2406, 9);
  int argcv_meth_ast_pretty_40_1_41_2406[] = {1};
  meth_meth_ast_pretty_40_1_41_2406->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2406);
  meth_meth_ast_pretty_40_1_41_2406->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2406->definitionLine = 536;
// method "toGrace(_)"
  struct UserObject *uo2523 = (struct UserObject*)obj2332;
  uo2523->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2523 = addmethod2pos(obj2332, "toGrace(1)", &meth_ast_toGrace_40_1_41_2523, 10);
  int argcv_meth_ast_toGrace_40_1_41_2523[] = {1};
  meth_meth_ast_toGrace_40_1_41_2523->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2523);
meth_meth_ast_toGrace_40_1_41_2523->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2523->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2523->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2523->definitionLine = 551;
// method "shallowCopy"
  block_savedest(obj2332);
  Object closure2622 = createclosure(3, "shallowCopy");
  setclosureframe(closure2622, stackframe);
  addtoclosure(closure2622, var_nullNode);
  addtoclosure(closure2622, var_emptySeq);
  addtoclosure(closure2622, var_matchCaseNode);
  struct UserObject *uo2622 = (struct UserObject*)obj2332;
  uo2622->data[11] = (Object)closure2622;
  Method *meth_meth_ast_shallowCopy2622 = addmethod2pos(obj2332, "shallowCopy", &meth_ast_shallowCopy2622, 11);
  int argcv_meth_ast_shallowCopy2622[] = {0};
  meth_meth_ast_shallowCopy2622->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2622);
  meth_meth_ast_shallowCopy2622->definitionModule = modulename;
  meth_meth_ast_shallowCopy2622->definitionLine = 565;
  sourceObject = obj2332;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2628 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2630 = gc_frame_new();
// call case 3: self.outer request
  Object call2631 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2630);
// compiled member node returning call2631 (depth = 5)
  Object call2632 = callmethodflags(call2631, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2629);
// compiled member node returning call2632 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2633 = callmethodflags(call2632, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2628);
// compiled call node returning call2633 (depth = 3)
  struct UserObject *obj2332_uo = (struct UserObject *)obj2332;
  obj2332_uo->super = call2633;
  sourceObject = obj2332;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2634 == NULL) {
    strlit2634 = alloc_String("matchcase");
    gc_root(strlit2634);
  }
// compiled string node returning strlit2634 (depth = 3)
  adddatum2(obj2332, strlit2634, 1);
  sourceObject = obj2332;
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2332, *var_matchee_39_, 2);
  sourceObject = obj2332;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2332, *var_cases_39_, 3);
  sourceObject = obj2332;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elsecase_39_ (depth = 3)
  adddatum2(obj2332, *var_elsecase_39_, 4);
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  objclass2332 = obj2332->class;
  objclass2332->definitionModule = modulename;
  objclass2332->definitionLine = 508;
  (*(struct UserObject *)self).data[0] = lowerouter2332;
  self = oldself2332;
  selfslot = oldselfslot2332;
  stackframe = oldstackframe2332;
  gc_frame_end(frame);
  return obj2332;
}
Object meth_ast_new_40_3_41_2331_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2332 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2332 = alloc_userobj2(14,12, objclass2332);
  gc_frame_newslot(obj2332);
if (objclass2332 == NULL) {
  glfree(obj2332->class->name);
  obj2332->class->name = "matchCaseNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2332, self, 0);
  addmethodreal(obj2332,"outer", &reader_ast_outer_2333);
  Object oldself2332 = self;
  struct StackFrameObject *oldstackframe2332 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2332);
  gc_frame_newslot((Object)stackframe);
  self = obj2332;
  Object *oldselfslot2332 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2332 = (*(struct UserObject *)self).data[0], lowerouter2332 = thisouter2332;
  if (inheritingObject2332) {
    struct UserObject *inho2332 = (struct UserObject *)inheritingObject2332;
    while (inho2332->super != GraceDefaultObject) inho2332 = (struct UserObject *)inho2332->super;
    inho2332->super = obj2332;
    self = inheritingObject2332;
    *selfslot = self;
    lowerouter2332 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2332;
  }
if (objclass2332 == NULL) {
  Method *reader2334 = addmethodrealflags(obj2332, "kind",&reader_ast_kind_2334, MFLAG_DEF);
  reader2334->definitionModule = modulename;
  reader2334->definitionLine = 510;
}
adddatum2(obj2332, alloc_Undefined(), 1);
if (objclass2332 == NULL) {
  Method *reader2335 = addmethodrealflags(obj2332, "value", &reader_ast_value_2335, 0);
  Method *writer2335 = addmethodrealflags(obj2332, "value:=(1)", &writer_ast_value_2335, 0);
  reader2335->definitionModule = modulename;
  writer2335->definitionModule = modulename;
  reader2335->definitionLine = 511;
  writer2335->definitionLine = 511;
}
obj2332->flags |= OFLAG_MUTABLE;
adddatum2(obj2332, alloc_Undefined(), 2);
if (objclass2332 == NULL) {
  Method *reader2336 = addmethodrealflags(obj2332, "cases", &reader_ast_cases_2336, 0);
  Method *writer2336 = addmethodrealflags(obj2332, "cases:=(1)", &writer_ast_cases_2336, 0);
  reader2336->definitionModule = modulename;
  writer2336->definitionModule = modulename;
  reader2336->definitionLine = 512;
  writer2336->definitionLine = 512;
}
obj2332->flags |= OFLAG_MUTABLE;
adddatum2(obj2332, alloc_Undefined(), 3);
if (objclass2332 == NULL) {
  Method *reader2337 = addmethodrealflags(obj2332, "elsecase", &reader_ast_elsecase_2337, 0);
  Method *writer2337 = addmethodrealflags(obj2332, "elsecase:=(1)", &writer_ast_elsecase_2337, 0);
  reader2337->definitionModule = modulename;
  writer2337->definitionModule = modulename;
  reader2337->definitionLine = 513;
  writer2337->definitionLine = 513;
}
obj2332->flags |= OFLAG_MUTABLE;
adddatum2(obj2332, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2338 = (struct UserObject*)obj2332;
  uo2338->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2338 = addmethod2pos(obj2332, "isSimple", &meth_ast_isSimple2338, 5);
  int argcv_meth_ast_isSimple2338[] = {0};
  meth_meth_ast_isSimple2338->type = alloc_MethodType(1, argcv_meth_ast_isSimple2338);
  meth_meth_ast_isSimple2338->definitionModule = modulename;
  meth_meth_ast_isSimple2338->definitionLine = 514;
// method "matchee"
  struct UserObject *uo2340 = (struct UserObject*)obj2332;
  uo2340->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2340 = addmethod2pos(obj2332, "matchee", &meth_ast_matchee2340, 6);
  int argcv_meth_ast_matchee2340[] = {0};
  meth_meth_ast_matchee2340->type = alloc_MethodType(1, argcv_meth_ast_matchee2340);
  meth_meth_ast_matchee2340->definitionModule = modulename;
  meth_meth_ast_matchee2340->definitionLine = 515;
// method "accept(_)from(_)"
  struct UserObject *uo2343 = (struct UserObject*)obj2332;
  uo2343->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2343 = addmethod2pos(obj2332, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2343, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2343[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2343->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2343);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2343->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2343->definitionLine = 516;
// method "map(_)ancestors(_)"
  struct UserObject *uo2373 = (struct UserObject*)obj2332;
  uo2373->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2373 = addmethod2pos(obj2332, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2373, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2373[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2373->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2373);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2373->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2373->definitionLine = 528;
// method "pretty(_)"
  struct UserObject *uo2406 = (struct UserObject*)obj2332;
  uo2406->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2406 = addmethod2pos(obj2332, "pretty(1)", &meth_ast_pretty_40_1_41_2406, 9);
  int argcv_meth_ast_pretty_40_1_41_2406[] = {1};
  meth_meth_ast_pretty_40_1_41_2406->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2406);
  meth_meth_ast_pretty_40_1_41_2406->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2406->definitionLine = 536;
// method "toGrace(_)"
  struct UserObject *uo2523 = (struct UserObject*)obj2332;
  uo2523->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2523 = addmethod2pos(obj2332, "toGrace(1)", &meth_ast_toGrace_40_1_41_2523, 10);
  int argcv_meth_ast_toGrace_40_1_41_2523[] = {1};
  meth_meth_ast_toGrace_40_1_41_2523->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2523);
meth_meth_ast_toGrace_40_1_41_2523->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2523->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2523->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2523->definitionLine = 551;
// method "shallowCopy"
  block_savedest(obj2332);
  Object closure2622 = createclosure(3, "shallowCopy");
  setclosureframe(closure2622, stackframe);
  addtoclosure(closure2622, var_nullNode);
  addtoclosure(closure2622, var_emptySeq);
  addtoclosure(closure2622, var_matchCaseNode);
  struct UserObject *uo2622 = (struct UserObject*)obj2332;
  uo2622->data[11] = (Object)closure2622;
  Method *meth_meth_ast_shallowCopy2622 = addmethod2pos(obj2332, "shallowCopy", &meth_ast_shallowCopy2622, 11);
  int argcv_meth_ast_shallowCopy2622[] = {0};
  meth_meth_ast_shallowCopy2622->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2622);
  meth_meth_ast_shallowCopy2622->definitionModule = modulename;
  meth_meth_ast_shallowCopy2622->definitionLine = 565;
  sourceObject = obj2332;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2628 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2630 = gc_frame_new();
// call case 3: self.outer request
  Object call2631 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2630);
// compiled member node returning call2631 (depth = 5)
  Object call2632 = callmethodflags(call2631, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2629);
// compiled member node returning call2632 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2633 = callmethodflags(call2632, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2628);
// compiled call node returning call2633 (depth = 3)
  struct UserObject *obj2332_uo = (struct UserObject *)obj2332;
  obj2332_uo->super = call2633;
  sourceObject = obj2332;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2634 == NULL) {
    strlit2634 = alloc_String("matchcase");
    gc_root(strlit2634);
  }
// compiled string node returning strlit2634 (depth = 3)
  adddatum2(obj2332, strlit2634, 1);
  sourceObject = obj2332;
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2332, *var_matchee_39_, 2);
  sourceObject = obj2332;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2332, *var_cases_39_, 3);
  sourceObject = obj2332;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elsecase_39_ (depth = 3)
  adddatum2(obj2332, *var_elsecase_39_, 4);
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  sourceObject = obj2332;
  objclass2332 = obj2332->class;
  objclass2332->definitionModule = modulename;
  objclass2332->definitionLine = 508;
  (*(struct UserObject *)self).data[0] = lowerouter2332;
  self = oldself2332;
  selfslot = oldselfslot2332;
  stackframe = oldstackframe2332;
  gc_frame_end(frame);
  return obj2332;
}
Object meth_ast_matchCaseNode2636(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast__apply_40_2_41_2650(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2652 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call2653 = callmethodflags(*var_each, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe2652);
// compiled member node returning call2653 (depth = 6)
  int op_slot_right_2651 = gc_frame_newslot(call2653);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_2651 = gc_frame_newslot(*var_acc);
  params[0] = call2653;
  partcv[0] = 1;
  Object opresult2655 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2655 (depth = 5)
  gc_frame_end(frame);
  return opresult2655;
}
Object meth_ast_nameString2647(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2648 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2649 = alloc_Block(NULL, NULL, "ast", 584);
  gc_frame_newslot(block2649);
// method "_apply(_,_)"
  block_savedest(block2649);
  Object closure2650 = createclosure(1, "_apply(2)");
  setclosureframe(closure2650, stackframe);
  addtoclosure(closure2650, selfslot);
  struct UserObject *uo2650 = (struct UserObject*)block2649;
  uo2650->data[0] = (Object)closure2650;
  Method *meth_meth_ast__apply_40_2_41_2650 = addmethod2pos(block2649, "_apply(2)", &meth_ast__apply_40_2_41_2650, 0);
  int argcv_meth_ast__apply_40_2_41_2650[] = {2};
  meth_meth_ast__apply_40_2_41_2650->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_2650);
  meth_meth_ast__apply_40_2_41_2650->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_2650->definitionLine = 2969;
// compiled block node returning block2649 (depth = 4)
  gc_frame_newslot(block2649);
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2657 == NULL) {
    strlit2657 = alloc_String("");
    gc_root(strlit2657);
  }
// compiled string node returning strlit2657 (depth = 4)
  gc_frame_newslot(strlit2657);
// call case 6: other requests
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2658 = gc_frame_new();
// call case 4: self request
  Object call2659 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2658);
// compiled member node returning call2659 (depth = 4)
  params[0] = block2649;
  params[1] = strlit2657;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2660 = callmethodflags(call2659, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2648);
// compiled call node returning call2660 (depth = 3)
  gc_frame_end(frame);
  return call2660;
}
Object meth_ast_value2661(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2664 = gc_frame_new();
// call case 4: self request
  Object call2665 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2664);
// compiled member node returning call2665 (depth = 5)
  int op_slot_right_2663 = gc_frame_newslot(call2665);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_2663 = gc_frame_newslot(*var_uninitialized);
  params[0] = call2665;
  partcv[0] = 1;
  Object opresult2667 = callmethod(*var_uninitialized, "==(1)", 1, partcv, params);
// compiled op node returning opresult2667 (depth = 4)
  Object if2662 = done;
  if (istrue(opresult2667)) {
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2668 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe2669 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2670 = gc_frame_new();
// call case 4: self request
  Object call2671 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2670);
// compiled member node returning call2671 (depth = 6)
  gc_frame_newslot(call2671);
// starting to compile identifier node (depth = 6)
  Object bool2672 = alloc_Boolean(0);
// compiled identifier node returning bool2672 (depth = 6)
  gc_frame_newslot(bool2672);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call2671;
  params[1] = bool2672;
  partcv[0] = 2;
  Object call2673 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2669);
// compiled call node returning call2673 (depth = 5)
  gc_frame_newslot(call2673);
// call case 4: self request
  params[0] = call2673;
  partcv[0] = 1;
  Object call2674 = callmethodflags(self, "cachedIdentifier:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2668);
// compiled call node returning call2674 (depth = 4)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2675 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2676 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2677 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2678 = gc_frame_new();
// call case 4: self request
  Object call2679 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2678);
// compiled member node returning call2679 (depth = 7)
  Object call2680 = callmethodflags(call2679, "first", 0, partcv, params, 0);
  gc_frame_end(callframe2677);
// compiled member node returning call2680 (depth = 6)
  Object call2681 = callmethodflags(call2680, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2676);
// compiled member node returning call2681 (depth = 5)
  gc_frame_newslot(call2681);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2682 = gc_frame_new();
// call case 4: self request
  Object call2683 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2682);
// compiled member node returning call2683 (depth = 5)
  params[0] = call2681;
  partcv[0] = 1;
  Object call2684 = callmethodflags(call2683, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2675);
// compiled call node returning call2684 (depth = 4)
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2685 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2686 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2687 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2688 = gc_frame_new();
// call case 4: self request
  Object call2689 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2688);
// compiled member node returning call2689 (depth = 7)
  Object call2690 = callmethodflags(call2689, "first", 0, partcv, params, 0);
  gc_frame_end(callframe2687);
// compiled member node returning call2690 (depth = 6)
  Object call2691 = callmethodflags(call2690, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2686);
// compiled member node returning call2691 (depth = 5)
  gc_frame_newslot(call2691);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2692 = gc_frame_new();
// call case 4: self request
  Object call2693 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2692);
// compiled member node returning call2693 (depth = 5)
  params[0] = call2691;
  partcv[0] = 1;
  Object call2694 = callmethodflags(call2693, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2685);
// compiled call node returning call2694 (depth = 4)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2695 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool2696 = alloc_Boolean(1);
// compiled identifier node returning bool2696 (depth = 5)
  gc_frame_newslot(bool2696);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2697 = gc_frame_new();
// call case 4: self request
  Object call2698 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2697);
// compiled member node returning call2698 (depth = 5)
  params[0] = bool2696;
  partcv[0] = 1;
  Object call2699 = callmethodflags(call2698, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2695);
// compiled call node returning call2699 (depth = 4)
    gc_frame_newslot(call2699);
    if2662 = call2699;
  } else {
  }
// compiled if node returning if2662 (depth = 3)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2700 = gc_frame_new();
// call case 4: self request
  Object call2701 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2700);
// compiled member node returning call2701 (depth = 3)
  gc_frame_end(frame);
  return call2701;
}
Object meth_ast_isExecutable2702(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2703 = alloc_Boolean(0);
// compiled identifier node returning bool2703 (depth = 3)
  gc_frame_end(frame);
  return bool2703;
}
Object meth_ast__apply_40_1_41_2710(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe2711 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2712 = callmethodflags(*var_b, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2711);
// compiled call node returning call2712 (depth = 7)
  gc_frame_end(frame);
  return call2712;
}
Object meth_ast__apply_40_1_41_2707(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2708 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2709 = alloc_Block(NULL, NULL, "ast", 599);
  gc_frame_newslot(block2709);
// method "_apply(_)"
  block_savedest(block2709);
  Object closure2710 = createclosure(2, "_apply(1)");
  setclosureframe(closure2710, stackframe);
  addtoclosure(closure2710, var_b);
  addtoclosure(closure2710, selfslot);
  struct UserObject *uo2710 = (struct UserObject*)block2709;
  uo2710->data[0] = (Object)closure2710;
  Method *meth_meth_ast__apply_40_1_41_2710 = addmethod2pos(block2709, "_apply(1)", &meth_ast__apply_40_1_41_2710, 0);
  int argcv_meth_ast__apply_40_1_41_2710[] = {1};
  meth_meth_ast__apply_40_1_41_2710->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2710);
  meth_meth_ast__apply_40_1_41_2710->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2710->definitionLine = 2969;
// compiled block node returning block2709 (depth = 6)
  gc_frame_newslot(block2709);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2714 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call2715 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe2714);
// compiled member node returning call2715 (depth = 6)
  params[0] = block2709;
  partcv[0] = 1;
  Object call2716 = callmethodflags(call2715, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2708);
// compiled call node returning call2716 (depth = 5)
  gc_frame_end(frame);
  return call2716;
}
Object meth_ast_parametersDo_40_1_41_2704(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parametersDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2705 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2706 = alloc_Block(NULL, NULL, "ast", 598);
  gc_frame_newslot(block2706);
// method "_apply(_)"
  block_savedest(block2706);
  Object closure2707 = createclosure(2, "_apply(1)");
  setclosureframe(closure2707, stackframe);
  addtoclosure(closure2707, var_b);
  addtoclosure(closure2707, selfslot);
  struct UserObject *uo2707 = (struct UserObject*)block2706;
  uo2707->data[0] = (Object)closure2707;
  Method *meth_meth_ast__apply_40_1_41_2707 = addmethod2pos(block2706, "_apply(1)", &meth_ast__apply_40_1_41_2707, 0);
  int argcv_meth_ast__apply_40_1_41_2707[] = {1};
  meth_meth_ast__apply_40_1_41_2707->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2707);
  meth_meth_ast__apply_40_1_41_2707->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2707->definitionLine = 2969;
// compiled block node returning block2706 (depth = 4)
  gc_frame_newslot(block2706);
// call case 6: other requests
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2718 = gc_frame_new();
// call case 4: self request
  Object call2719 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2718);
// compiled member node returning call2719 (depth = 4)
  params[0] = block2706;
  partcv[0] = 1;
  Object call2720 = callmethodflags(call2719, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2705);
// compiled call node returning call2720 (depth = 3)
  gc_frame_end(frame);
  return call2720;
}
Object meth_ast_scope_58__61__40_1_41_2721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2722 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call2723 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2722);
// compiled call node returning call2723 (depth = 3)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2724 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2725 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2724);
// compiled call node returning call2725 (depth = 3)
  gc_frame_end(frame);
  return call2725;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_2726(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2727 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call2728 = callmethodflags(*var_k, "typedec", 0, partcv, params, 0);
  gc_frame_end(callframe2727);
// compiled member node returning call2728 (depth = 3)
  gc_frame_end(frame);
  return call2728;
}
Object meth_ast__apply_40_1_41_2761(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2762 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2763 = callmethodflags(*var_part, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2762);
// compiled call node returning call2763 (depth = 6)
  gc_frame_end(frame);
  return call2763;
}
Object meth_ast_accept_40_1_41_from_40_1_41_2729(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2731 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2732 = callmethodflags(*var_visitor, "visitMethodType(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2731);
// compiled call node returning call2732 (depth = 4)
  Object if2730 = done;
  if (istrue(call2732)) {
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2733 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2734 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2733);
// compiled call node returning call2734 (depth = 5)
  *var_newChain = call2734;
  if (call2734 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2737 = gc_frame_new();
// call case 4: self request
  Object call2738 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2737);
// compiled member node returning call2738 (depth = 6)
  int op_slot_right_2736 = gc_frame_newslot(call2738);
// starting to compile identifier node (depth = 6)
  Object bool2740 = alloc_Boolean(0);
// compiled identifier node returning bool2740 (depth = 6)
  int op_slot_left_2736 = gc_frame_newslot(bool2740);
  params[0] = call2738;
  partcv[0] = 1;
  Object opresult2741 = callmethod(bool2740, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2741 (depth = 5)
  Object if2735 = done;
  if (istrue(opresult2741)) {
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2742 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2743 = gc_frame_new();
// call case 4: self request
  Object call2744 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2743);
// compiled member node returning call2744 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2745 = callmethodflags(call2744, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2742);
// compiled call node returning call2745 (depth = 5)
    gc_frame_newslot(call2745);
    if2735 = call2745;
  } else {
  }
// compiled if node returning if2735 (depth = 4)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2748 = gc_frame_new();
// call case 4: self request
  Object call2749 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2748);
// compiled member node returning call2749 (depth = 6)
  int op_slot_right_2747 = gc_frame_newslot(call2749);
// starting to compile identifier node (depth = 6)
  Object bool2751 = alloc_Boolean(0);
// compiled identifier node returning bool2751 (depth = 6)
  int op_slot_left_2747 = gc_frame_newslot(bool2751);
  params[0] = call2749;
  partcv[0] = 1;
  Object opresult2752 = callmethod(bool2751, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2752 (depth = 5)
  Object if2746 = done;
  if (istrue(opresult2752)) {
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2753 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2754 = gc_frame_new();
// call case 4: self request
  Object call2755 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2754);
// compiled member node returning call2755 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2756 = callmethodflags(call2755, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2753);
// compiled call node returning call2756 (depth = 5)
    gc_frame_newslot(call2756);
    if2746 = call2756;
  } else {
  }
// compiled if node returning if2746 (depth = 4)
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2757 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2758 = gc_frame_new();
// call case 4: self request
  Object call2759 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2758);
// compiled member node returning call2759 (depth = 5)
  gc_frame_newslot(call2759);
// starting to compile block node (depth = 5)
  Object block2760 = alloc_Block(NULL, NULL, "ast", 618);
  gc_frame_newslot(block2760);
// method "_apply(_)"
  block_savedest(block2760);
  Object closure2761 = createclosure(3, "_apply(1)");
  setclosureframe(closure2761, stackframe);
  addtoclosure(closure2761, var_visitor);
  addtoclosure(closure2761, var_newChain);
  addtoclosure(closure2761, selfslot);
  struct UserObject *uo2761 = (struct UserObject*)block2760;
  uo2761->data[0] = (Object)closure2761;
  Method *meth_meth_ast__apply_40_1_41_2761 = addmethod2pos(block2760, "_apply(1)", &meth_ast__apply_40_1_41_2761, 0);
  int argcv_meth_ast__apply_40_1_41_2761[] = {1};
  meth_meth_ast__apply_40_1_41_2761->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2761);
  meth_meth_ast__apply_40_1_41_2761->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2761->definitionLine = 2969;
// compiled block node returning block2760 (depth = 5)
  gc_frame_newslot(block2760);
// call case 5: prelude request
  params[0] = call2759;
  params[1] = block2760;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2765 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2757);
// compiled call node returning call2765 (depth = 4)
    gc_frame_newslot(call2765);
    if2730 = call2765;
  } else {
  }
// compiled if node returning if2730 (depth = 3)
  gc_frame_end(frame);
  return if2730;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_2766(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2767 = gc_frame_new();
// call case 4: self request
  Object call2768 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2767);
// compiled member node returning call2768 (depth = 4)
  *var_n = call2768;
  if (call2768 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2769 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2770 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2769);
// compiled call node returning call2770 (depth = 4)
  *var_newChain = call2770;
  if (call2770 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2771 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2772 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2773 = gc_frame_new();
// call case 4: self request
  Object call2774 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2773);
// compiled member node returning call2774 (depth = 5)
  gc_frame_newslot(call2774);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2775 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2776 = gc_frame_new();
// call case 3: self.outer request
  Object call2777 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2776);
// compiled member node returning call2777 (depth = 6)
  Object call2778 = callmethodflags(call2777, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2775);
// compiled member node returning call2778 (depth = 5)
  params[0] = call2774;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2779 = callmethodflags(call2778, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2772);
// compiled call node returning call2779 (depth = 4)
  gc_frame_newslot(call2779);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2779;
  partcv[0] = 1;
  Object call2780 = callmethodflags(*var_n, "rtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2771);
// compiled call node returning call2780 (depth = 3)
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2781 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2782 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2783 = gc_frame_new();
// call case 4: self request
  Object call2784 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2783);
// compiled member node returning call2784 (depth = 5)
  gc_frame_newslot(call2784);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2785 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2786 = gc_frame_new();
// call case 3: self.outer request
  Object call2787 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2786);
// compiled member node returning call2787 (depth = 6)
  Object call2788 = callmethodflags(call2787, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2785);
// compiled member node returning call2788 (depth = 5)
  params[0] = call2784;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2789 = callmethodflags(call2788, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2782);
// compiled call node returning call2789 (depth = 4)
  gc_frame_newslot(call2789);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2789;
  partcv[0] = 1;
  Object call2790 = callmethodflags(*var_n, "signature:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2781);
// compiled call node returning call2790 (depth = 3)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2791 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2792 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2793 = gc_frame_new();
// call case 4: self request
  Object call2794 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2793);
// compiled member node returning call2794 (depth = 5)
  gc_frame_newslot(call2794);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2795 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2796 = gc_frame_new();
// call case 3: self.outer request
  Object call2797 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2796);
// compiled member node returning call2797 (depth = 6)
  Object call2798 = callmethodflags(call2797, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2795);
// compiled member node returning call2798 (depth = 5)
  params[0] = call2794;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2799 = callmethodflags(call2798, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2792);
// compiled call node returning call2799 (depth = 4)
  gc_frame_newslot(call2799);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2799;
  partcv[0] = 1;
  Object call2800 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2791);
// compiled call node returning call2800 (depth = 3)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2801 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2802 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2801);
// compiled call node returning call2802 (depth = 3)
  gc_frame_end(frame);
  return call2802;
}
Object meth_ast__apply_40_1_41_2811(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2813 == NULL) {
    strlit2813 = alloc_String("  ");
    gc_root(strlit2813);
  }
// compiled string node returning strlit2813 (depth = 7)
  int op_slot_right_2812 = gc_frame_newslot(strlit2813);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2812 = gc_frame_newslot(*var_spc);
  params[0] = strlit2813;
  partcv[0] = 1;
  Object opresult2815 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2815 (depth = 6)
  *var_spc = opresult2815;
  if (opresult2815 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2950(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2952 == NULL) {
    strlit2952 = alloc_String("");
    gc_root(strlit2952);
  }
// compiled string node returning strlit2952 (depth = 7)
  int op_slot_right_2951 = gc_frame_newslot(strlit2952);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2955 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2957 = alloc_Float64(2);
// compiled num node returning num2957 (depth = 10)
  int op_slot_right_2956 = gc_frame_newslot(num2957);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2956 = gc_frame_newslot(*var_depth);
  params[0] = num2957;
  partcv[0] = 1;
  Object sum2959 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2959 (depth = 9)
  gc_frame_newslot(sum2959);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  params[0] = sum2959;
  partcv[0] = 1;
  Object call2960 = callmethodflags(*var_part, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2955);
// compiled call node returning call2960 (depth = 8)
  int op_slot_right_2954 = gc_frame_newslot(call2960);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2963 == NULL) {
    strlit2963 = alloc_String("");
    gc_root(strlit2963);
  }
// compiled string node returning strlit2963 (depth = 9)
  int op_slot_right_2962 = gc_frame_newslot(strlit2963);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2965 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2968 == NULL) {
    strlit2968 = alloc_String("""\x0a""  ");
    gc_root(strlit2968);
  }
// compiled string node returning strlit2968 (depth = 11)
  int op_slot_right_2967 = gc_frame_newslot(strlit2968);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_2970 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit2972 == NULL) {
    strlit2972 = alloc_String("");
    gc_root(strlit2972);
  }
// compiled string node returning strlit2972 (depth = 12)
  int op_slot_left_2970 = gc_frame_newslot(strlit2972);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2973 = callmethod(strlit2972, "++(1)", 1, partcv, params);
// compiled op node returning opresult2973 (depth = 11)
  int op_slot_left_2967 = gc_frame_newslot(opresult2973);
  params[0] = strlit2968;
  partcv[0] = 1;
  Object opresult2974 = callmethod(opresult2973, "++(1)", 1, partcv, params);
// compiled op node returning opresult2974 (depth = 10)
  int op_slot_left_2965 = gc_frame_newslot(opresult2974);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2975 = callmethod(opresult2974, "++(1)", 1, partcv, params);
// compiled op node returning opresult2975 (depth = 9)
  int op_slot_left_2962 = gc_frame_newslot(opresult2975);
  params[0] = strlit2963;
  partcv[0] = 1;
  Object opresult2976 = callmethod(opresult2975, "++(1)", 1, partcv, params);
// compiled op node returning opresult2976 (depth = 8)
  int op_slot_left_2954 = gc_frame_newslot(opresult2976);
  params[0] = call2960;
  partcv[0] = 1;
  Object opresult2977 = callmethod(opresult2976, "++(1)", 1, partcv, params);
// compiled op node returning opresult2977 (depth = 7)
  int op_slot_left_2951 = gc_frame_newslot(opresult2977);
  params[0] = strlit2952;
  partcv[0] = 1;
  Object opresult2978 = callmethod(opresult2977, "++(1)", 1, partcv, params);
// compiled op node returning opresult2978 (depth = 6)
  *var_s = opresult2978;
  if (opresult2978 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_2803(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2804 == NULL) {
    strlit2804 = alloc_String("");
    gc_root(strlit2804);
  }
// compiled string node returning strlit2804 (depth = 4)
  *var_spc = strlit2804;
  if (strlit2804 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2805 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2806 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2808 = alloc_Float64(0);
// compiled num node returning num2808 (depth = 5)
  int op_slot_left_2806 = gc_frame_newslot(num2808);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2809 = callmethod(num2808, "..(1)", 1, partcv, params);
// compiled op node returning opresult2809 (depth = 4)
  gc_frame_newslot(opresult2809);
// starting to compile block node (depth = 4)
  Object block2810 = alloc_Block(NULL, NULL, "ast", 633);
  gc_frame_newslot(block2810);
// method "_apply(_)"
  block_savedest(block2810);
  Object closure2811 = createclosure(2, "_apply(1)");
  setclosureframe(closure2811, stackframe);
  addtoclosure(closure2811, var_spc);
  addtoclosure(closure2811, selfslot);
  struct UserObject *uo2811 = (struct UserObject*)block2810;
  uo2811->data[0] = (Object)closure2811;
  Method *meth_meth_ast__apply_40_1_41_2811 = addmethod2pos(block2810, "_apply(1)", &meth_ast__apply_40_1_41_2811, 0);
  int argcv_meth_ast__apply_40_1_41_2811[] = {1};
  meth_meth_ast__apply_40_1_41_2811->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2811);
  meth_meth_ast__apply_40_1_41_2811->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2811->definitionLine = 2969;
// compiled block node returning block2810 (depth = 4)
  gc_frame_newslot(block2810);
// call case 5: prelude request
  params[0] = opresult2809;
  params[1] = block2810;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2818 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2805);
// compiled call node returning call2818 (depth = 3)
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2820 == NULL) {
    strlit2820 = alloc_String("""\x0a""");
    gc_root(strlit2820);
  }
// compiled string node returning strlit2820 (depth = 5)
  int op_slot_right_2819 = gc_frame_newslot(strlit2820);
// starting to compile call node (depth = 5)
  int callframe2822 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2823 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2822);
// compiled call node returning call2823 (depth = 5)
  int op_slot_left_2819 = gc_frame_newslot(call2823);
  params[0] = strlit2820;
  partcv[0] = 1;
  Object opresult2824 = callmethod(call2823, "++(1)", 1, partcv, params);
// compiled op node returning opresult2824 (depth = 4)
  *var_s = opresult2824;
  if (opresult2824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2826 == NULL) {
    strlit2826 = alloc_String("""\x0a""");
    gc_root(strlit2826);
  }
// compiled string node returning strlit2826 (depth = 5)
  int op_slot_right_2825 = gc_frame_newslot(strlit2826);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2829 = gc_frame_new();
// call case 4: self request
  Object call2830 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2829);
// compiled member node returning call2830 (depth = 6)
  int op_slot_right_2828 = gc_frame_newslot(call2830);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2833 == NULL) {
    strlit2833 = alloc_String("Name: ");
    gc_root(strlit2833);
  }
// compiled string node returning strlit2833 (depth = 7)
  int op_slot_right_2832 = gc_frame_newslot(strlit2833);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2835 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2838 == NULL) {
    strlit2838 = alloc_String("");
    gc_root(strlit2838);
  }
// compiled string node returning strlit2838 (depth = 9)
  int op_slot_right_2837 = gc_frame_newslot(strlit2838);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_2840 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit2842 == NULL) {
    strlit2842 = alloc_String("");
    gc_root(strlit2842);
  }
// compiled string node returning strlit2842 (depth = 10)
  int op_slot_left_2840 = gc_frame_newslot(strlit2842);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2843 = callmethod(strlit2842, "++(1)", 1, partcv, params);
// compiled op node returning opresult2843 (depth = 9)
  int op_slot_left_2837 = gc_frame_newslot(opresult2843);
  params[0] = strlit2838;
  partcv[0] = 1;
  Object opresult2844 = callmethod(opresult2843, "++(1)", 1, partcv, params);
// compiled op node returning opresult2844 (depth = 8)
  int op_slot_left_2835 = gc_frame_newslot(opresult2844);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2845 = callmethod(opresult2844, "++(1)", 1, partcv, params);
// compiled op node returning opresult2845 (depth = 7)
  int op_slot_left_2832 = gc_frame_newslot(opresult2845);
  params[0] = strlit2833;
  partcv[0] = 1;
  Object opresult2846 = callmethod(opresult2845, "++(1)", 1, partcv, params);
// compiled op node returning opresult2846 (depth = 6)
  int op_slot_left_2828 = gc_frame_newslot(opresult2846);
  params[0] = call2830;
  partcv[0] = 1;
  Object opresult2847 = callmethod(opresult2846, "++(1)", 1, partcv, params);
// compiled op node returning opresult2847 (depth = 5)
  int op_slot_left_2825 = gc_frame_newslot(opresult2847);
  params[0] = strlit2826;
  partcv[0] = 1;
  Object opresult2848 = callmethod(opresult2847, "++(1)", 1, partcv, params);
// compiled op node returning opresult2848 (depth = 4)
  *var_s = opresult2848;
  if (opresult2848 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2852 = gc_frame_new();
// call case 4: self request
  Object call2853 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2852);
// compiled member node returning call2853 (depth = 5)
  int op_slot_right_2851 = gc_frame_newslot(call2853);
// starting to compile identifier node (depth = 5)
  Object bool2855 = alloc_Boolean(0);
// compiled identifier node returning bool2855 (depth = 5)
  int op_slot_left_2851 = gc_frame_newslot(bool2855);
  params[0] = call2853;
  partcv[0] = 1;
  Object opresult2856 = callmethod(bool2855, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2856 (depth = 4)
  Object if2850 = done;
  if (istrue(opresult2856)) {
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2858 == NULL) {
    strlit2858 = alloc_String("");
    gc_root(strlit2858);
  }
// compiled string node returning strlit2858 (depth = 6)
  int op_slot_right_2857 = gc_frame_newslot(strlit2858);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2861 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2863 = alloc_Float64(2);
// compiled num node returning num2863 (depth = 9)
  int op_slot_right_2862 = gc_frame_newslot(num2863);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2862 = gc_frame_newslot(*var_depth);
  params[0] = num2863;
  partcv[0] = 1;
  Object sum2865 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2865 (depth = 8)
  gc_frame_newslot(sum2865);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2866 = gc_frame_new();
// call case 4: self request
  Object call2867 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2866);
// compiled member node returning call2867 (depth = 8)
  params[0] = sum2865;
  partcv[0] = 1;
  Object call2868 = callmethodflags(call2867, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2861);
// compiled call node returning call2868 (depth = 7)
  int op_slot_right_2860 = gc_frame_newslot(call2868);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2871 == NULL) {
    strlit2871 = alloc_String("");
    gc_root(strlit2871);
  }
// compiled string node returning strlit2871 (depth = 8)
  int op_slot_right_2870 = gc_frame_newslot(strlit2871);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2873 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2876 == NULL) {
    strlit2876 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit2876);
  }
// compiled string node returning strlit2876 (depth = 10)
  int op_slot_right_2875 = gc_frame_newslot(strlit2876);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2878 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2881 == NULL) {
    strlit2881 = alloc_String("");
    gc_root(strlit2881);
  }
// compiled string node returning strlit2881 (depth = 12)
  int op_slot_right_2880 = gc_frame_newslot(strlit2881);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_2883 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit2885 == NULL) {
    strlit2885 = alloc_String("");
    gc_root(strlit2885);
  }
// compiled string node returning strlit2885 (depth = 13)
  int op_slot_left_2883 = gc_frame_newslot(strlit2885);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2886 = callmethod(strlit2885, "++(1)", 1, partcv, params);
// compiled op node returning opresult2886 (depth = 12)
  int op_slot_left_2880 = gc_frame_newslot(opresult2886);
  params[0] = strlit2881;
  partcv[0] = 1;
  Object opresult2887 = callmethod(opresult2886, "++(1)", 1, partcv, params);
// compiled op node returning opresult2887 (depth = 11)
  int op_slot_left_2878 = gc_frame_newslot(opresult2887);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2888 = callmethod(opresult2887, "++(1)", 1, partcv, params);
// compiled op node returning opresult2888 (depth = 10)
  int op_slot_left_2875 = gc_frame_newslot(opresult2888);
  params[0] = strlit2876;
  partcv[0] = 1;
  Object opresult2889 = callmethod(opresult2888, "++(1)", 1, partcv, params);
// compiled op node returning opresult2889 (depth = 9)
  int op_slot_left_2873 = gc_frame_newslot(opresult2889);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2890 = callmethod(opresult2889, "++(1)", 1, partcv, params);
// compiled op node returning opresult2890 (depth = 8)
  int op_slot_left_2870 = gc_frame_newslot(opresult2890);
  params[0] = strlit2871;
  partcv[0] = 1;
  Object opresult2891 = callmethod(opresult2890, "++(1)", 1, partcv, params);
// compiled op node returning opresult2891 (depth = 7)
  int op_slot_left_2860 = gc_frame_newslot(opresult2891);
  params[0] = call2868;
  partcv[0] = 1;
  Object opresult2892 = callmethod(opresult2891, "++(1)", 1, partcv, params);
// compiled op node returning opresult2892 (depth = 6)
  int op_slot_left_2857 = gc_frame_newslot(opresult2892);
  params[0] = strlit2858;
  partcv[0] = 1;
  Object opresult2893 = callmethod(opresult2892, "++(1)", 1, partcv, params);
// compiled op node returning opresult2893 (depth = 5)
  *var_s = opresult2893;
  if (opresult2893 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2850 = done;
  } else {
  }
// compiled if node returning if2850 (depth = 3)
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2897 = gc_frame_new();
// call case 4: self request
  Object call2898 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2897);
// compiled member node returning call2898 (depth = 5)
  int op_slot_right_2896 = gc_frame_newslot(call2898);
// starting to compile identifier node (depth = 5)
  Object bool2900 = alloc_Boolean(0);
// compiled identifier node returning bool2900 (depth = 5)
  int op_slot_left_2896 = gc_frame_newslot(bool2900);
  params[0] = call2898;
  partcv[0] = 1;
  Object opresult2901 = callmethod(bool2900, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2901 (depth = 4)
  Object if2895 = done;
  if (istrue(opresult2901)) {
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2903 == NULL) {
    strlit2903 = alloc_String("TypeParams:""\x0a""");
    gc_root(strlit2903);
  }
// compiled string node returning strlit2903 (depth = 6)
  int op_slot_right_2902 = gc_frame_newslot(strlit2903);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2905 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2908 == NULL) {
    strlit2908 = alloc_String("""\x0a""");
    gc_root(strlit2908);
  }
// compiled string node returning strlit2908 (depth = 8)
  int op_slot_right_2907 = gc_frame_newslot(strlit2908);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_2910 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit2912 == NULL) {
    strlit2912 = alloc_String("");
    gc_root(strlit2912);
  }
// compiled string node returning strlit2912 (depth = 9)
  int op_slot_left_2910 = gc_frame_newslot(strlit2912);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2913 = callmethod(strlit2912, "++(1)", 1, partcv, params);
// compiled op node returning opresult2913 (depth = 8)
  int op_slot_left_2907 = gc_frame_newslot(opresult2913);
  params[0] = strlit2908;
  partcv[0] = 1;
  Object opresult2914 = callmethod(opresult2913, "++(1)", 1, partcv, params);
// compiled op node returning opresult2914 (depth = 7)
  int op_slot_left_2905 = gc_frame_newslot(opresult2914);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2915 = callmethod(opresult2914, "++(1)", 1, partcv, params);
// compiled op node returning opresult2915 (depth = 6)
  int op_slot_left_2902 = gc_frame_newslot(opresult2915);
  params[0] = strlit2903;
  partcv[0] = 1;
  Object opresult2916 = callmethod(opresult2915, "++(1)", 1, partcv, params);
// compiled op node returning opresult2916 (depth = 5)
  *var_s = opresult2916;
  if (opresult2916 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2919 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2921 = alloc_Float64(2);
// compiled num node returning num2921 (depth = 8)
  int op_slot_right_2920 = gc_frame_newslot(num2921);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2920 = gc_frame_newslot(*var_depth);
  params[0] = num2921;
  partcv[0] = 1;
  Object sum2923 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2923 (depth = 7)
  gc_frame_newslot(sum2923);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2924 = gc_frame_new();
// call case 4: self request
  Object call2925 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2924);
// compiled member node returning call2925 (depth = 7)
  params[0] = sum2923;
  partcv[0] = 1;
  Object call2926 = callmethodflags(call2925, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2919);
// compiled call node returning call2926 (depth = 6)
  int op_slot_right_2918 = gc_frame_newslot(call2926);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2918 = gc_frame_newslot(*var_s);
  params[0] = call2926;
  partcv[0] = 1;
  Object opresult2928 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2928 (depth = 5)
  *var_s = opresult2928;
  if (opresult2928 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2895 = done;
  } else {
  }
// compiled if node returning if2895 (depth = 3)
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2931 == NULL) {
    strlit2931 = alloc_String("Signature:");
    gc_root(strlit2931);
  }
// compiled string node returning strlit2931 (depth = 5)
  int op_slot_right_2930 = gc_frame_newslot(strlit2931);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2933 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2936 == NULL) {
    strlit2936 = alloc_String("""\x0a""");
    gc_root(strlit2936);
  }
// compiled string node returning strlit2936 (depth = 7)
  int op_slot_right_2935 = gc_frame_newslot(strlit2936);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_2938 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit2940 == NULL) {
    strlit2940 = alloc_String("");
    gc_root(strlit2940);
  }
// compiled string node returning strlit2940 (depth = 8)
  int op_slot_left_2938 = gc_frame_newslot(strlit2940);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2941 = callmethod(strlit2940, "++(1)", 1, partcv, params);
// compiled op node returning opresult2941 (depth = 7)
  int op_slot_left_2935 = gc_frame_newslot(opresult2941);
  params[0] = strlit2936;
  partcv[0] = 1;
  Object opresult2942 = callmethod(opresult2941, "++(1)", 1, partcv, params);
// compiled op node returning opresult2942 (depth = 6)
  int op_slot_left_2933 = gc_frame_newslot(opresult2942);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2943 = callmethod(opresult2942, "++(1)", 1, partcv, params);
// compiled op node returning opresult2943 (depth = 5)
  int op_slot_left_2930 = gc_frame_newslot(opresult2943);
  params[0] = strlit2931;
  partcv[0] = 1;
  Object opresult2944 = callmethod(opresult2943, "++(1)", 1, partcv, params);
// compiled op node returning opresult2944 (depth = 4)
  *var_s = opresult2944;
  if (opresult2944 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2946 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2947 = gc_frame_new();
// call case 4: self request
  Object call2948 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2947);
// compiled member node returning call2948 (depth = 4)
  gc_frame_newslot(call2948);
// starting to compile block node (depth = 4)
  Object block2949 = alloc_Block(NULL, NULL, "ast", 646);
  gc_frame_newslot(block2949);
// method "_apply(_)"
  block_savedest(block2949);
  Object closure2950 = createclosure(4, "_apply(1)");
  setclosureframe(closure2950, stackframe);
  addtoclosure(closure2950, var_depth);
  addtoclosure(closure2950, var_spc);
  addtoclosure(closure2950, var_s);
  addtoclosure(closure2950, selfslot);
  struct UserObject *uo2950 = (struct UserObject*)block2949;
  uo2950->data[0] = (Object)closure2950;
  Method *meth_meth_ast__apply_40_1_41_2950 = addmethod2pos(block2949, "_apply(1)", &meth_ast__apply_40_1_41_2950, 0);
  int argcv_meth_ast__apply_40_1_41_2950[] = {1};
  meth_meth_ast__apply_40_1_41_2950->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2950);
  meth_meth_ast__apply_40_1_41_2950->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2950->definitionLine = 2969;
// compiled block node returning block2949 (depth = 4)
  gc_frame_newslot(block2949);
// call case 5: prelude request
  params[0] = call2948;
  params[1] = block2949;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2981 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2946);
// compiled call node returning call2981 (depth = 3)
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_2986(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2988 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2990 = alloc_Float64(1);
// compiled num node returning num2990 (depth = 9)
  int op_slot_right_2989 = gc_frame_newslot(num2990);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2989 = gc_frame_newslot(*var_depth);
  params[0] = num2990;
  partcv[0] = 1;
  Object sum2992 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2992 (depth = 8)
  gc_frame_newslot(sum2992);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = sum2992;
  partcv[0] = 1;
  Object call2993 = callmethodflags(*var_part, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2988);
// compiled call node returning call2993 (depth = 7)
  int op_slot_right_2987 = gc_frame_newslot(call2993);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2987 = gc_frame_newslot(*var_s);
  params[0] = call2993;
  partcv[0] = 1;
  Object opresult2995 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2995 (depth = 6)
  *var_s = opresult2995;
  if (opresult2995 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_2982(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2983 == NULL) {
    strlit2983 = alloc_String("");
    gc_root(strlit2983);
  }
// compiled string node returning strlit2983 (depth = 4)
  *var_s = strlit2983;
  if (strlit2983 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2984 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2985 = alloc_Block(NULL, NULL, "ast", 653);
  gc_frame_newslot(block2985);
// method "_apply(_)"
  block_savedest(block2985);
  Object closure2986 = createclosure(3, "_apply(1)");
  setclosureframe(closure2986, stackframe);
  addtoclosure(closure2986, var_depth);
  addtoclosure(closure2986, var_s);
  addtoclosure(closure2986, selfslot);
  struct UserObject *uo2986 = (struct UserObject*)block2985;
  uo2986->data[0] = (Object)closure2986;
  Method *meth_meth_ast__apply_40_1_41_2986 = addmethod2pos(block2985, "_apply(1)", &meth_ast__apply_40_1_41_2986, 0);
  int argcv_meth_ast__apply_40_1_41_2986[] = {1};
  meth_meth_ast__apply_40_1_41_2986->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2986);
  meth_meth_ast__apply_40_1_41_2986->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2986->definitionLine = 2969;
// compiled block node returning block2985 (depth = 4)
  gc_frame_newslot(block2985);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2998 = gc_frame_new();
// call case 4: self request
  Object call2999 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2998);
// compiled member node returning call2999 (depth = 4)
  params[0] = block2985;
  partcv[0] = 1;
  Object call3000 = callmethodflags(call2999, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2984);
// compiled call node returning call3000 (depth = 3)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy3001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3002 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3003 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3004 = gc_frame_new();
// call case 4: self request
  Object call3005 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3004);
// compiled member node returning call3005 (depth = 5)
  gc_frame_newslot(call3005);
// starting to compile member node (depth = 5)
  int callframe3006 = gc_frame_new();
// call case 4: self request
  Object call3007 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3006);
// compiled member node returning call3007 (depth = 5)
  gc_frame_newslot(call3007);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeNode (depth = 5)
  params[0] = call3005;
  params[1] = call3007;
  partcv[0] = 2;
  Object call3008 = callmethodflags(*var_methodTypeNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3003);
// compiled call node returning call3008 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3009 = callmethodflags(call3008, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3002);
// compiled call node returning call3009 (depth = 3)
  gc_frame_end(frame);
  return call3009;
}
Object meth_ast_new_40_2_41_2639(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodTypeNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[1]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2640 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2640 = alloc_userobj2(20,17, objclass2640);
  gc_frame_newslot(obj2640);
if (objclass2640 == NULL) {
  glfree(obj2640->class->name);
  obj2640->class->name = "methodTypeNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2640, self, 0);
  addmethodreal(obj2640,"outer", &reader_ast_outer_2641);
  Object oldself2640 = self;
  struct StackFrameObject *oldstackframe2640 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2640);
  gc_frame_newslot((Object)stackframe);
  self = obj2640;
  Object *oldselfslot2640 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2640 = (*(struct UserObject *)self).data[0], lowerouter2640 = thisouter2640;
  if (inheritingObject2640) {
    struct UserObject *inho2640 = (struct UserObject *)inheritingObject2640;
    while (inho2640->super != GraceDefaultObject) inho2640 = (struct UserObject *)inho2640->super;
    inho2640->super = obj2640;
    self = inheritingObject2640;
    *selfslot = self;
    lowerouter2640 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2640;
  }
if (objclass2640 == NULL) {
  Method *reader2642 = addmethodrealflags(obj2640, "kind",&reader_ast_kind_2642, MFLAG_DEF);
  reader2642->definitionModule = modulename;
  reader2642->definitionLine = 577;
}
adddatum2(obj2640, alloc_Undefined(), 1);
if (objclass2640 == NULL) {
  Method *reader2643 = addmethodrealflags(obj2640, "signature", &reader_ast_signature_2643, 0);
  Method *writer2643 = addmethodrealflags(obj2640, "signature:=(1)", &writer_ast_signature_2643, 0);
  reader2643->definitionModule = modulename;
  writer2643->definitionModule = modulename;
  reader2643->definitionLine = 578;
  writer2643->definitionLine = 578;
}
obj2640->flags |= OFLAG_MUTABLE;
adddatum2(obj2640, alloc_Undefined(), 2);
if (objclass2640 == NULL) {
  Method *reader2644 = addmethodrealflags(obj2640, "rtype", &reader_ast_rtype_2644, 0);
  Method *writer2644 = addmethodrealflags(obj2640, "rtype:=(1)", &writer_ast_rtype_2644, 0);
  reader2644->definitionModule = modulename;
  writer2644->definitionModule = modulename;
  reader2644->definitionLine = 579;
  writer2644->definitionLine = 579;
}
obj2640->flags |= OFLAG_MUTABLE;
adddatum2(obj2640, alloc_Undefined(), 3);
if (objclass2640 == NULL) {
  Method *reader2645 = addmethodrealflags(obj2640, "typeParams", &reader_ast_typeParams_2645, 0);
  Method *writer2645 = addmethodrealflags(obj2640, "typeParams:=(1)", &writer_ast_typeParams_2645, 0);
  reader2645->definitionModule = modulename;
  writer2645->definitionModule = modulename;
  reader2645->definitionLine = 580;
  writer2645->definitionLine = 580;
}
obj2640->flags |= OFLAG_MUTABLE;
adddatum2(obj2640, alloc_Undefined(), 4);
if (objclass2640 == NULL) {
  Method *reader2646 = addmethodrealflags(obj2640, "cachedIdentifier", &reader_ast_cachedIdentifier_2646, MFLAG_CONFIDENTIAL);
  Method *writer2646 = addmethodrealflags(obj2640, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_2646, MFLAG_CONFIDENTIAL);
  reader2646->definitionModule = modulename;
  writer2646->definitionModule = modulename;
  reader2646->definitionLine = 581;
  writer2646->definitionLine = 581;
}
obj2640->flags |= OFLAG_MUTABLE;
adddatum2(obj2640, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo2647 = (struct UserObject*)obj2640;
  uo2647->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString2647 = addmethod2pos(obj2640, "nameString", &meth_ast_nameString2647, 6);
  int argcv_meth_ast_nameString2647[] = {0};
  meth_meth_ast_nameString2647->type = alloc_MethodType(1, argcv_meth_ast_nameString2647);
  meth_meth_ast_nameString2647->definitionModule = modulename;
  meth_meth_ast_nameString2647->definitionLine = 583;
// method "value"
  block_savedest(obj2640);
  Object closure2661 = createclosure(2, "value");
  setclosureframe(closure2661, stackframe);
  addtoclosure(closure2661, var_uninitialized);
  addtoclosure(closure2661, var_identifierNode);
  struct UserObject *uo2661 = (struct UserObject*)obj2640;
  uo2661->data[7] = (Object)closure2661;
  Method *meth_meth_ast_value2661 = addmethod2pos(obj2640, "value", &meth_ast_value2661, 7);
  int argcv_meth_ast_value2661[] = {0};
  meth_meth_ast_value2661->type = alloc_MethodType(1, argcv_meth_ast_value2661);
  meth_meth_ast_value2661->definitionModule = modulename;
  meth_meth_ast_value2661->definitionLine = 587;
// method "isExecutable"
  struct UserObject *uo2702 = (struct UserObject*)obj2640;
  uo2702->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable2702 = addmethod2pos(obj2640, "isExecutable", &meth_ast_isExecutable2702, 8);
  int argcv_meth_ast_isExecutable2702[] = {0};
  meth_meth_ast_isExecutable2702->type = alloc_MethodType(1, argcv_meth_ast_isExecutable2702);
  meth_meth_ast_isExecutable2702->definitionModule = modulename;
  meth_meth_ast_isExecutable2702->definitionLine = 596;
// method "parametersDo(_)"
  struct UserObject *uo2704 = (struct UserObject*)obj2640;
  uo2704->data[9] = emptyclosure;
  Method *meth_meth_ast_parametersDo_40_1_41_2704 = addmethod2pos(obj2640, "parametersDo(1)", &meth_ast_parametersDo_40_1_41_2704, 9);
  int argcv_meth_ast_parametersDo_40_1_41_2704[] = {1};
  meth_meth_ast_parametersDo_40_1_41_2704->type = alloc_MethodType(1, argcv_meth_ast_parametersDo_40_1_41_2704);
  meth_meth_ast_parametersDo_40_1_41_2704->definitionModule = modulename;
  meth_meth_ast_parametersDo_40_1_41_2704->definitionLine = 597;
// method "scope:=(_)"
  struct UserObject *uo2721 = (struct UserObject*)obj2640;
  uo2721->data[10] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_2721 = addmethod2pos(obj2640, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_2721, 10);
  int argcv_meth_ast_scope_58__61__40_1_41_2721[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_2721->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_2721);
  meth_meth_ast_scope_58__61__40_1_41_2721->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_2721->definitionLine = 602;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj2640);
  Object closure2726 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure2726, stackframe);
  addtoclosure(closure2726, var_k);
  struct UserObject *uo2726 = (struct UserObject*)obj2640;
  uo2726->data[11] = (Object)closure2726;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_2726 = addmethod2pos(obj2640, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_2726, 11);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_2726[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2726->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_2726);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2726->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2726->definitionLine = 608;
// method "accept(_)from(_)"
  struct UserObject *uo2729 = (struct UserObject*)obj2640;
  uo2729->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2729 = addmethod2pos(obj2640, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2729, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2729[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2729->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2729);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2729->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2729->definitionLine = 609;
// method "map(_)ancestors(_)"
  struct UserObject *uo2766 = (struct UserObject*)obj2640;
  uo2766->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2766 = addmethod2pos(obj2640, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2766, 13);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2766[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2766->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2766);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2766->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2766->definitionLine = 623;
// method "pretty(_)"
  struct UserObject *uo2803 = (struct UserObject*)obj2640;
  uo2803->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2803 = addmethod2pos(obj2640, "pretty(1)", &meth_ast_pretty_40_1_41_2803, 14);
  int argcv_meth_ast_pretty_40_1_41_2803[] = {1};
  meth_meth_ast_pretty_40_1_41_2803->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2803);
  meth_meth_ast_pretty_40_1_41_2803->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2803->definitionLine = 631;
// method "toGrace(_)"
  struct UserObject *uo2982 = (struct UserObject*)obj2640;
  uo2982->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2982 = addmethod2pos(obj2640, "toGrace(1)", &meth_ast_toGrace_40_1_41_2982, 15);
  int argcv_meth_ast_toGrace_40_1_41_2982[] = {1};
  meth_meth_ast_toGrace_40_1_41_2982->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2982);
meth_meth_ast_toGrace_40_1_41_2982->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2982->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2982->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2982->definitionLine = 651;
// method "shallowCopy"
  block_savedest(obj2640);
  Object closure3001 = createclosure(1, "shallowCopy");
  setclosureframe(closure3001, stackframe);
  addtoclosure(closure3001, var_methodTypeNode);
  struct UserObject *uo3001 = (struct UserObject*)obj2640;
  uo3001->data[16] = (Object)closure3001;
  Method *meth_meth_ast_shallowCopy3001 = addmethod2pos(obj2640, "shallowCopy", &meth_ast_shallowCopy3001, 16);
  int argcv_meth_ast_shallowCopy3001[] = {0};
  meth_meth_ast_shallowCopy3001->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3001);
  meth_meth_ast_shallowCopy3001->definitionModule = modulename;
  meth_meth_ast_shallowCopy3001->definitionLine = 656;
  sourceObject = obj2640;
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3010 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3011 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3012 = gc_frame_new();
// call case 3: self.outer request
  Object call3013 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3012);
// compiled member node returning call3013 (depth = 5)
  Object call3014 = callmethodflags(call3013, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3011);
// compiled member node returning call3014 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3015 = callmethodflags(call3014, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3010);
// compiled call node returning call3015 (depth = 3)
  struct UserObject *obj2640_uo = (struct UserObject *)obj2640;
  obj2640_uo->super = call3015;
  sourceObject = obj2640;
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3016 == NULL) {
    strlit3016 = alloc_String("methodtype");
    gc_root(strlit3016);
  }
// compiled string node returning strlit3016 (depth = 3)
  adddatum2(obj2640, strlit3016, 1);
  sourceObject = obj2640;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2640, *var_signature_39_, 2);
  sourceObject = obj2640;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2640, *var_rtype_39_, 3);
  sourceObject = obj2640;
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3017 = alloc_Boolean(0);
// compiled identifier node returning bool3017 (depth = 3)
  adddatum2(obj2640, bool3017, 4);
  sourceObject = obj2640;
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj2640, *var_uninitialized, 5);
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  objclass2640 = obj2640->class;
  objclass2640->definitionModule = modulename;
  objclass2640->definitionLine = 571;
  (*(struct UserObject *)self).data[0] = lowerouter2640;
  self = oldself2640;
  selfslot = oldselfslot2640;
  stackframe = oldstackframe2640;
  gc_frame_end(frame);
  return obj2640;
}
Object meth_ast_new_40_2_41_2639_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodTypeNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[1]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2640 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2640 = alloc_userobj2(20,17, objclass2640);
  gc_frame_newslot(obj2640);
if (objclass2640 == NULL) {
  glfree(obj2640->class->name);
  obj2640->class->name = "methodTypeNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2640, self, 0);
  addmethodreal(obj2640,"outer", &reader_ast_outer_2641);
  Object oldself2640 = self;
  struct StackFrameObject *oldstackframe2640 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2640);
  gc_frame_newslot((Object)stackframe);
  self = obj2640;
  Object *oldselfslot2640 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2640 = (*(struct UserObject *)self).data[0], lowerouter2640 = thisouter2640;
  if (inheritingObject2640) {
    struct UserObject *inho2640 = (struct UserObject *)inheritingObject2640;
    while (inho2640->super != GraceDefaultObject) inho2640 = (struct UserObject *)inho2640->super;
    inho2640->super = obj2640;
    self = inheritingObject2640;
    *selfslot = self;
    lowerouter2640 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2640;
  }
if (objclass2640 == NULL) {
  Method *reader2642 = addmethodrealflags(obj2640, "kind",&reader_ast_kind_2642, MFLAG_DEF);
  reader2642->definitionModule = modulename;
  reader2642->definitionLine = 577;
}
adddatum2(obj2640, alloc_Undefined(), 1);
if (objclass2640 == NULL) {
  Method *reader2643 = addmethodrealflags(obj2640, "signature", &reader_ast_signature_2643, 0);
  Method *writer2643 = addmethodrealflags(obj2640, "signature:=(1)", &writer_ast_signature_2643, 0);
  reader2643->definitionModule = modulename;
  writer2643->definitionModule = modulename;
  reader2643->definitionLine = 578;
  writer2643->definitionLine = 578;
}
obj2640->flags |= OFLAG_MUTABLE;
adddatum2(obj2640, alloc_Undefined(), 2);
if (objclass2640 == NULL) {
  Method *reader2644 = addmethodrealflags(obj2640, "rtype", &reader_ast_rtype_2644, 0);
  Method *writer2644 = addmethodrealflags(obj2640, "rtype:=(1)", &writer_ast_rtype_2644, 0);
  reader2644->definitionModule = modulename;
  writer2644->definitionModule = modulename;
  reader2644->definitionLine = 579;
  writer2644->definitionLine = 579;
}
obj2640->flags |= OFLAG_MUTABLE;
adddatum2(obj2640, alloc_Undefined(), 3);
if (objclass2640 == NULL) {
  Method *reader2645 = addmethodrealflags(obj2640, "typeParams", &reader_ast_typeParams_2645, 0);
  Method *writer2645 = addmethodrealflags(obj2640, "typeParams:=(1)", &writer_ast_typeParams_2645, 0);
  reader2645->definitionModule = modulename;
  writer2645->definitionModule = modulename;
  reader2645->definitionLine = 580;
  writer2645->definitionLine = 580;
}
obj2640->flags |= OFLAG_MUTABLE;
adddatum2(obj2640, alloc_Undefined(), 4);
if (objclass2640 == NULL) {
  Method *reader2646 = addmethodrealflags(obj2640, "cachedIdentifier", &reader_ast_cachedIdentifier_2646, MFLAG_CONFIDENTIAL);
  Method *writer2646 = addmethodrealflags(obj2640, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_2646, MFLAG_CONFIDENTIAL);
  reader2646->definitionModule = modulename;
  writer2646->definitionModule = modulename;
  reader2646->definitionLine = 581;
  writer2646->definitionLine = 581;
}
obj2640->flags |= OFLAG_MUTABLE;
adddatum2(obj2640, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo2647 = (struct UserObject*)obj2640;
  uo2647->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString2647 = addmethod2pos(obj2640, "nameString", &meth_ast_nameString2647, 6);
  int argcv_meth_ast_nameString2647[] = {0};
  meth_meth_ast_nameString2647->type = alloc_MethodType(1, argcv_meth_ast_nameString2647);
  meth_meth_ast_nameString2647->definitionModule = modulename;
  meth_meth_ast_nameString2647->definitionLine = 583;
// method "value"
  block_savedest(obj2640);
  Object closure2661 = createclosure(2, "value");
  setclosureframe(closure2661, stackframe);
  addtoclosure(closure2661, var_uninitialized);
  addtoclosure(closure2661, var_identifierNode);
  struct UserObject *uo2661 = (struct UserObject*)obj2640;
  uo2661->data[7] = (Object)closure2661;
  Method *meth_meth_ast_value2661 = addmethod2pos(obj2640, "value", &meth_ast_value2661, 7);
  int argcv_meth_ast_value2661[] = {0};
  meth_meth_ast_value2661->type = alloc_MethodType(1, argcv_meth_ast_value2661);
  meth_meth_ast_value2661->definitionModule = modulename;
  meth_meth_ast_value2661->definitionLine = 587;
// method "isExecutable"
  struct UserObject *uo2702 = (struct UserObject*)obj2640;
  uo2702->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable2702 = addmethod2pos(obj2640, "isExecutable", &meth_ast_isExecutable2702, 8);
  int argcv_meth_ast_isExecutable2702[] = {0};
  meth_meth_ast_isExecutable2702->type = alloc_MethodType(1, argcv_meth_ast_isExecutable2702);
  meth_meth_ast_isExecutable2702->definitionModule = modulename;
  meth_meth_ast_isExecutable2702->definitionLine = 596;
// method "parametersDo(_)"
  struct UserObject *uo2704 = (struct UserObject*)obj2640;
  uo2704->data[9] = emptyclosure;
  Method *meth_meth_ast_parametersDo_40_1_41_2704 = addmethod2pos(obj2640, "parametersDo(1)", &meth_ast_parametersDo_40_1_41_2704, 9);
  int argcv_meth_ast_parametersDo_40_1_41_2704[] = {1};
  meth_meth_ast_parametersDo_40_1_41_2704->type = alloc_MethodType(1, argcv_meth_ast_parametersDo_40_1_41_2704);
  meth_meth_ast_parametersDo_40_1_41_2704->definitionModule = modulename;
  meth_meth_ast_parametersDo_40_1_41_2704->definitionLine = 597;
// method "scope:=(_)"
  struct UserObject *uo2721 = (struct UserObject*)obj2640;
  uo2721->data[10] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_2721 = addmethod2pos(obj2640, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_2721, 10);
  int argcv_meth_ast_scope_58__61__40_1_41_2721[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_2721->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_2721);
  meth_meth_ast_scope_58__61__40_1_41_2721->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_2721->definitionLine = 602;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj2640);
  Object closure2726 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure2726, stackframe);
  addtoclosure(closure2726, var_k);
  struct UserObject *uo2726 = (struct UserObject*)obj2640;
  uo2726->data[11] = (Object)closure2726;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_2726 = addmethod2pos(obj2640, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_2726, 11);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_2726[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2726->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_2726);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2726->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2726->definitionLine = 608;
// method "accept(_)from(_)"
  struct UserObject *uo2729 = (struct UserObject*)obj2640;
  uo2729->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2729 = addmethod2pos(obj2640, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2729, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2729[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2729->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2729);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2729->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2729->definitionLine = 609;
// method "map(_)ancestors(_)"
  struct UserObject *uo2766 = (struct UserObject*)obj2640;
  uo2766->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2766 = addmethod2pos(obj2640, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2766, 13);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2766[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2766->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2766);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2766->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2766->definitionLine = 623;
// method "pretty(_)"
  struct UserObject *uo2803 = (struct UserObject*)obj2640;
  uo2803->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2803 = addmethod2pos(obj2640, "pretty(1)", &meth_ast_pretty_40_1_41_2803, 14);
  int argcv_meth_ast_pretty_40_1_41_2803[] = {1};
  meth_meth_ast_pretty_40_1_41_2803->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2803);
  meth_meth_ast_pretty_40_1_41_2803->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2803->definitionLine = 631;
// method "toGrace(_)"
  struct UserObject *uo2982 = (struct UserObject*)obj2640;
  uo2982->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2982 = addmethod2pos(obj2640, "toGrace(1)", &meth_ast_toGrace_40_1_41_2982, 15);
  int argcv_meth_ast_toGrace_40_1_41_2982[] = {1};
  meth_meth_ast_toGrace_40_1_41_2982->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2982);
meth_meth_ast_toGrace_40_1_41_2982->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2982->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2982->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2982->definitionLine = 651;
// method "shallowCopy"
  block_savedest(obj2640);
  Object closure3001 = createclosure(1, "shallowCopy");
  setclosureframe(closure3001, stackframe);
  addtoclosure(closure3001, var_methodTypeNode);
  struct UserObject *uo3001 = (struct UserObject*)obj2640;
  uo3001->data[16] = (Object)closure3001;
  Method *meth_meth_ast_shallowCopy3001 = addmethod2pos(obj2640, "shallowCopy", &meth_ast_shallowCopy3001, 16);
  int argcv_meth_ast_shallowCopy3001[] = {0};
  meth_meth_ast_shallowCopy3001->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3001);
  meth_meth_ast_shallowCopy3001->definitionModule = modulename;
  meth_meth_ast_shallowCopy3001->definitionLine = 656;
  sourceObject = obj2640;
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3010 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3011 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3012 = gc_frame_new();
// call case 3: self.outer request
  Object call3013 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3012);
// compiled member node returning call3013 (depth = 5)
  Object call3014 = callmethodflags(call3013, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3011);
// compiled member node returning call3014 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3015 = callmethodflags(call3014, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3010);
// compiled call node returning call3015 (depth = 3)
  struct UserObject *obj2640_uo = (struct UserObject *)obj2640;
  obj2640_uo->super = call3015;
  sourceObject = obj2640;
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3016 == NULL) {
    strlit3016 = alloc_String("methodtype");
    gc_root(strlit3016);
  }
// compiled string node returning strlit3016 (depth = 3)
  adddatum2(obj2640, strlit3016, 1);
  sourceObject = obj2640;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2640, *var_signature_39_, 2);
  sourceObject = obj2640;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2640, *var_rtype_39_, 3);
  sourceObject = obj2640;
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3017 = alloc_Boolean(0);
// compiled identifier node returning bool3017 (depth = 3)
  adddatum2(obj2640, bool3017, 4);
  sourceObject = obj2640;
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj2640, *var_uninitialized, 5);
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  sourceObject = obj2640;
  objclass2640 = obj2640->class;
  objclass2640->definitionModule = modulename;
  objclass2640->definitionLine = 571;
  (*(struct UserObject *)self).data[0] = lowerouter2640;
  self = oldself2640;
  selfslot = oldselfslot2640;
  stackframe = oldstackframe2640;
  gc_frame_end(frame);
  return obj2640;
}
Object meth_ast_methodTypeNode3019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodTypeNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast_name3031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3032 = gc_frame_new();
// call case 4: self request
  Object call3033 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3032);
// compiled member node returning call3033 (depth = 3)
  gc_frame_end(frame);
  return call3033;
}
Object meth_ast_name_58__61__40_1_41_3034(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part name:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3035 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3036 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3035);
// compiled call node returning call3036 (depth = 3)
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3037 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3038 = alloc_Boolean(0);
// compiled identifier node returning bool3038 (depth = 4)
  gc_frame_newslot(bool3038);
// call case 4: self request
  params[0] = bool3038;
  partcv[0] = 1;
  Object call3039 = callmethodflags(self, "anonymous:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3037);
// compiled call node returning call3039 (depth = 3)
  gc_frame_end(frame);
  return call3039;
}
Object meth_ast_asString3040(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3042 == NULL) {
    strlit3042 = alloc_String("");
    gc_root(strlit3042);
  }
// compiled string node returning strlit3042 (depth = 4)
  int op_slot_right_3041 = gc_frame_newslot(strlit3042);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3045 = gc_frame_new();
// call case 4: self request
  Object call3046 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3045);
// compiled member node returning call3046 (depth = 5)
  int op_slot_right_3044 = gc_frame_newslot(call3046);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3049 == NULL) {
    strlit3049 = alloc_String(", types = ");
    gc_root(strlit3049);
  }
// compiled string node returning strlit3049 (depth = 6)
  int op_slot_right_3048 = gc_frame_newslot(strlit3049);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3052 = gc_frame_new();
// call case 4: self request
  Object call3053 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3052);
// compiled member node returning call3053 (depth = 7)
  int op_slot_right_3051 = gc_frame_newslot(call3053);
// starting to compile string node (depth = 7)
  if (strlit3055 == NULL) {
    strlit3055 = alloc_String("typeliteral: methods = ");
    gc_root(strlit3055);
  }
// compiled string node returning strlit3055 (depth = 7)
  int op_slot_left_3051 = gc_frame_newslot(strlit3055);
  params[0] = call3053;
  partcv[0] = 1;
  Object opresult3056 = callmethod(strlit3055, "++(1)", 1, partcv, params);
// compiled op node returning opresult3056 (depth = 6)
  int op_slot_left_3048 = gc_frame_newslot(opresult3056);
  params[0] = strlit3049;
  partcv[0] = 1;
  Object opresult3057 = callmethod(opresult3056, "++(1)", 1, partcv, params);
// compiled op node returning opresult3057 (depth = 5)
  int op_slot_left_3044 = gc_frame_newslot(opresult3057);
  params[0] = call3046;
  partcv[0] = 1;
  Object opresult3058 = callmethod(opresult3057, "++(1)", 1, partcv, params);
// compiled op node returning opresult3058 (depth = 4)
  int op_slot_left_3041 = gc_frame_newslot(opresult3058);
  params[0] = strlit3042;
  partcv[0] = 1;
  Object opresult3059 = callmethod(opresult3058, "++(1)", 1, partcv, params);
// compiled op node returning opresult3059 (depth = 3)
  gc_frame_end(frame);
  return opresult3059;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_3060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3061 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call3062 = callmethodflags(*var_k, "typedec", 0, partcv, params, 0);
  gc_frame_end(callframe3061);
// compiled member node returning call3062 (depth = 3)
  gc_frame_end(frame);
  return call3062;
}
Object meth_ast_isExecutable3063(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3064 = alloc_Boolean(0);
// compiled identifier node returning bool3064 (depth = 3)
  gc_frame_end(frame);
  return bool3064;
}
Object meth_ast__apply_40_1_41_3075(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3076 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3077 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3076);
// compiled call node returning call3077 (depth = 6)
  gc_frame_end(frame);
  return call3077;
}
Object meth_ast__apply_40_1_41_3084(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3085 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3086 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3085);
// compiled call node returning call3086 (depth = 6)
  gc_frame_end(frame);
  return call3086;
}
Object meth_ast_accept_40_1_41_from_40_1_41_3065(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3067 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3068 = callmethodflags(*var_visitor, "visitTypeLiteral(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3067);
// compiled call node returning call3068 (depth = 4)
  Object if3066 = done;
  if (istrue(call3068)) {
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3069 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3070 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3069);
// compiled call node returning call3070 (depth = 5)
  *var_newChain = call3070;
  if (call3070 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3071 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3072 = gc_frame_new();
// call case 4: self request
  Object call3073 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3072);
// compiled member node returning call3073 (depth = 5)
  gc_frame_newslot(call3073);
// starting to compile block node (depth = 5)
  Object block3074 = alloc_Block(NULL, NULL, "ast", 685);
  gc_frame_newslot(block3074);
// method "_apply(_)"
  block_savedest(block3074);
  Object closure3075 = createclosure(3, "_apply(1)");
  setclosureframe(closure3075, stackframe);
  addtoclosure(closure3075, var_visitor);
  addtoclosure(closure3075, var_newChain);
  addtoclosure(closure3075, selfslot);
  struct UserObject *uo3075 = (struct UserObject*)block3074;
  uo3075->data[0] = (Object)closure3075;
  Method *meth_meth_ast__apply_40_1_41_3075 = addmethod2pos(block3074, "_apply(1)", &meth_ast__apply_40_1_41_3075, 0);
  int argcv_meth_ast__apply_40_1_41_3075[] = {1};
  meth_meth_ast__apply_40_1_41_3075->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3075);
  meth_meth_ast__apply_40_1_41_3075->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3075->definitionLine = 2969;
// compiled block node returning block3074 (depth = 5)
  gc_frame_newslot(block3074);
// call case 5: prelude request
  params[0] = call3073;
  params[1] = block3074;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3079 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3071);
// compiled call node returning call3079 (depth = 4)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3080 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3081 = gc_frame_new();
// call case 4: self request
  Object call3082 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3081);
// compiled member node returning call3082 (depth = 5)
  gc_frame_newslot(call3082);
// starting to compile block node (depth = 5)
  Object block3083 = alloc_Block(NULL, NULL, "ast", 688);
  gc_frame_newslot(block3083);
// method "_apply(_)"
  block_savedest(block3083);
  Object closure3084 = createclosure(3, "_apply(1)");
  setclosureframe(closure3084, stackframe);
  addtoclosure(closure3084, var_visitor);
  addtoclosure(closure3084, var_newChain);
  addtoclosure(closure3084, selfslot);
  struct UserObject *uo3084 = (struct UserObject*)block3083;
  uo3084->data[0] = (Object)closure3084;
  Method *meth_meth_ast__apply_40_1_41_3084 = addmethod2pos(block3083, "_apply(1)", &meth_ast__apply_40_1_41_3084, 0);
  int argcv_meth_ast__apply_40_1_41_3084[] = {1};
  meth_meth_ast__apply_40_1_41_3084->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3084);
  meth_meth_ast__apply_40_1_41_3084->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3084->definitionLine = 2969;
// compiled block node returning block3083 (depth = 5)
  gc_frame_newslot(block3083);
// call case 5: prelude request
  params[0] = call3082;
  params[1] = block3083;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3088 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3080);
// compiled call node returning call3088 (depth = 4)
    gc_frame_newslot(call3088);
    if3066 = call3088;
  } else {
  }
// compiled if node returning if3066 (depth = 3)
  gc_frame_end(frame);
  return if3066;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_3089(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3090 = gc_frame_new();
// call case 4: self request
  Object call3091 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3090);
// compiled member node returning call3091 (depth = 4)
  *var_n = call3091;
  if (call3091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3092 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3093 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3092);
// compiled call node returning call3093 (depth = 4)
  *var_newChain = call3093;
  if (call3093 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3094 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3095 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3096 = gc_frame_new();
// call case 4: self request
  Object call3097 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3096);
// compiled member node returning call3097 (depth = 5)
  gc_frame_newslot(call3097);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3098 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3099 = gc_frame_new();
// call case 3: self.outer request
  Object call3100 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3099);
// compiled member node returning call3100 (depth = 6)
  Object call3101 = callmethodflags(call3100, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3098);
// compiled member node returning call3101 (depth = 5)
  params[0] = call3097;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3102 = callmethodflags(call3101, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3095);
// compiled call node returning call3102 (depth = 4)
  gc_frame_newslot(call3102);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3102;
  partcv[0] = 1;
  Object call3103 = callmethodflags(*var_n, "methods:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3094);
// compiled call node returning call3103 (depth = 3)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3104 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3105 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3106 = gc_frame_new();
// call case 4: self request
  Object call3107 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3106);
// compiled member node returning call3107 (depth = 5)
  gc_frame_newslot(call3107);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3108 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3109 = gc_frame_new();
// call case 3: self.outer request
  Object call3110 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3109);
// compiled member node returning call3110 (depth = 6)
  Object call3111 = callmethodflags(call3110, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3108);
// compiled member node returning call3111 (depth = 5)
  params[0] = call3107;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3112 = callmethodflags(call3111, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3105);
// compiled call node returning call3112 (depth = 4)
  gc_frame_newslot(call3112);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3112;
  partcv[0] = 1;
  Object call3113 = callmethodflags(*var_n, "types:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3104);
// compiled call node returning call3113 (depth = 3)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3114 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3115 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3114);
// compiled call node returning call3115 (depth = 3)
  gc_frame_end(frame);
  return call3115;
}
Object meth_ast__apply_40_1_41_3124(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3126 == NULL) {
    strlit3126 = alloc_String("  ");
    gc_root(strlit3126);
  }
// compiled string node returning strlit3126 (depth = 7)
  int op_slot_right_3125 = gc_frame_newslot(strlit3126);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3125 = gc_frame_newslot(*var_spc);
  params[0] = strlit3126;
  partcv[0] = 1;
  Object opresult3128 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3128 (depth = 6)
  *var_spc = opresult3128;
  if (opresult3128 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_3154(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3156 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3158 = alloc_Float64(2);
// compiled num node returning num3158 (depth = 9)
  int op_slot_right_3157 = gc_frame_newslot(num3158);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3157 = gc_frame_newslot(*var_depth);
  params[0] = num3158;
  partcv[0] = 1;
  Object sum3160 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3160 (depth = 8)
  gc_frame_newslot(sum3160);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3160;
  partcv[0] = 1;
  Object call3161 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3156);
// compiled call node returning call3161 (depth = 7)
  int op_slot_right_3155 = gc_frame_newslot(call3161);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3163 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3166 == NULL) {
    strlit3166 = alloc_String("""\x0a""  ");
    gc_root(strlit3166);
  }
// compiled string node returning strlit3166 (depth = 9)
  int op_slot_right_3165 = gc_frame_newslot(strlit3166);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3165 = gc_frame_newslot(*var_s);
  params[0] = strlit3166;
  partcv[0] = 1;
  Object opresult3168 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3168 (depth = 8)
  int op_slot_left_3163 = gc_frame_newslot(opresult3168);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3169 = callmethod(opresult3168, "++(1)", 1, partcv, params);
// compiled op node returning opresult3169 (depth = 7)
  int op_slot_left_3155 = gc_frame_newslot(opresult3169);
  params[0] = call3161;
  partcv[0] = 1;
  Object opresult3170 = callmethod(opresult3169, "++(1)", 1, partcv, params);
// compiled op node returning opresult3170 (depth = 6)
  *var_s = opresult3170;
  if (opresult3170 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_3190(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3192 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3194 = alloc_Float64(2);
// compiled num node returning num3194 (depth = 9)
  int op_slot_right_3193 = gc_frame_newslot(num3194);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3193 = gc_frame_newslot(*var_depth);
  params[0] = num3194;
  partcv[0] = 1;
  Object sum3196 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3196 (depth = 8)
  gc_frame_newslot(sum3196);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3196;
  partcv[0] = 1;
  Object call3197 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3192);
// compiled call node returning call3197 (depth = 7)
  int op_slot_right_3191 = gc_frame_newslot(call3197);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3199 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3202 == NULL) {
    strlit3202 = alloc_String("""\x0a""  ");
    gc_root(strlit3202);
  }
// compiled string node returning strlit3202 (depth = 9)
  int op_slot_right_3201 = gc_frame_newslot(strlit3202);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3201 = gc_frame_newslot(*var_s);
  params[0] = strlit3202;
  partcv[0] = 1;
  Object opresult3204 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3204 (depth = 8)
  int op_slot_left_3199 = gc_frame_newslot(opresult3204);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3205 = callmethod(opresult3204, "++(1)", 1, partcv, params);
// compiled op node returning opresult3205 (depth = 7)
  int op_slot_left_3191 = gc_frame_newslot(opresult3205);
  params[0] = call3197;
  partcv[0] = 1;
  Object opresult3206 = callmethod(opresult3205, "++(1)", 1, partcv, params);
// compiled op node returning opresult3206 (depth = 6)
  *var_s = opresult3206;
  if (opresult3206 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_3116(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3117 == NULL) {
    strlit3117 = alloc_String("");
    gc_root(strlit3117);
  }
// compiled string node returning strlit3117 (depth = 4)
  *var_spc = strlit3117;
  if (strlit3117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3118 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3119 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3121 = alloc_Float64(0);
// compiled num node returning num3121 (depth = 5)
  int op_slot_left_3119 = gc_frame_newslot(num3121);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3122 = callmethod(num3121, "..(1)", 1, partcv, params);
// compiled op node returning opresult3122 (depth = 4)
  gc_frame_newslot(opresult3122);
// starting to compile block node (depth = 4)
  Object block3123 = alloc_Block(NULL, NULL, "ast", 702);
  gc_frame_newslot(block3123);
// method "_apply(_)"
  block_savedest(block3123);
  Object closure3124 = createclosure(2, "_apply(1)");
  setclosureframe(closure3124, stackframe);
  addtoclosure(closure3124, var_spc);
  addtoclosure(closure3124, selfslot);
  struct UserObject *uo3124 = (struct UserObject*)block3123;
  uo3124->data[0] = (Object)closure3124;
  Method *meth_meth_ast__apply_40_1_41_3124 = addmethod2pos(block3123, "_apply(1)", &meth_ast__apply_40_1_41_3124, 0);
  int argcv_meth_ast__apply_40_1_41_3124[] = {1};
  meth_meth_ast__apply_40_1_41_3124->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3124);
  meth_meth_ast__apply_40_1_41_3124->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3124->definitionLine = 2969;
// compiled block node returning block3123 (depth = 4)
  gc_frame_newslot(block3123);
// call case 5: prelude request
  params[0] = opresult3122;
  params[1] = block3123;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3131 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3118);
// compiled call node returning call3131 (depth = 3)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3133 == NULL) {
    strlit3133 = alloc_String("""\x0a""");
    gc_root(strlit3133);
  }
// compiled string node returning strlit3133 (depth = 5)
  int op_slot_right_3132 = gc_frame_newslot(strlit3133);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3136 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3137 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3136);
// compiled call node returning call3137 (depth = 6)
  int op_slot_right_3135 = gc_frame_newslot(call3137);
// starting to compile string node (depth = 6)
  if (strlit3139 == NULL) {
    strlit3139 = alloc_String("");
    gc_root(strlit3139);
  }
// compiled string node returning strlit3139 (depth = 6)
  int op_slot_left_3135 = gc_frame_newslot(strlit3139);
  params[0] = call3137;
  partcv[0] = 1;
  Object opresult3140 = callmethod(strlit3139, "++(1)", 1, partcv, params);
// compiled op node returning opresult3140 (depth = 5)
  int op_slot_left_3132 = gc_frame_newslot(opresult3140);
  params[0] = strlit3133;
  partcv[0] = 1;
  Object opresult3141 = callmethod(opresult3140, "++(1)", 1, partcv, params);
// compiled op node returning opresult3141 (depth = 4)
  *var_s = opresult3141;
  if (opresult3141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3143 == NULL) {
    strlit3143 = alloc_String("Types:");
    gc_root(strlit3143);
  }
// compiled string node returning strlit3143 (depth = 5)
  int op_slot_right_3142 = gc_frame_newslot(strlit3143);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3145 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3145 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3147 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3147 (depth = 5)
  int op_slot_left_3142 = gc_frame_newslot(opresult3147);
  params[0] = strlit3143;
  partcv[0] = 1;
  Object opresult3148 = callmethod(opresult3147, "++(1)", 1, partcv, params);
// compiled op node returning opresult3148 (depth = 4)
  *var_s = opresult3148;
  if (opresult3148 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3150 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3151 = gc_frame_new();
// call case 4: self request
  Object call3152 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3151);
// compiled member node returning call3152 (depth = 4)
  gc_frame_newslot(call3152);
// starting to compile block node (depth = 4)
  Object block3153 = alloc_Block(NULL, NULL, "ast", 707);
  gc_frame_newslot(block3153);
// method "_apply(_)"
  block_savedest(block3153);
  Object closure3154 = createclosure(4, "_apply(1)");
  setclosureframe(closure3154, stackframe);
  addtoclosure(closure3154, var_depth);
  addtoclosure(closure3154, var_spc);
  addtoclosure(closure3154, var_s);
  addtoclosure(closure3154, selfslot);
  struct UserObject *uo3154 = (struct UserObject*)block3153;
  uo3154->data[0] = (Object)closure3154;
  Method *meth_meth_ast__apply_40_1_41_3154 = addmethod2pos(block3153, "_apply(1)", &meth_ast__apply_40_1_41_3154, 0);
  int argcv_meth_ast__apply_40_1_41_3154[] = {1};
  meth_meth_ast__apply_40_1_41_3154->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3154);
  meth_meth_ast__apply_40_1_41_3154->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3154->definitionLine = 2969;
// compiled block node returning block3153 (depth = 4)
  gc_frame_newslot(block3153);
// call case 5: prelude request
  params[0] = call3152;
  params[1] = block3153;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3173 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3150);
// compiled call node returning call3173 (depth = 3)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3175 == NULL) {
    strlit3175 = alloc_String("Methods:");
    gc_root(strlit3175);
  }
// compiled string node returning strlit3175 (depth = 5)
  int op_slot_right_3174 = gc_frame_newslot(strlit3175);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3177 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3180 == NULL) {
    strlit3180 = alloc_String("""\x0a""");
    gc_root(strlit3180);
  }
// compiled string node returning strlit3180 (depth = 7)
  int op_slot_right_3179 = gc_frame_newslot(strlit3180);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3179 = gc_frame_newslot(*var_s);
  params[0] = strlit3180;
  partcv[0] = 1;
  Object opresult3182 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3182 (depth = 6)
  int op_slot_left_3177 = gc_frame_newslot(opresult3182);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3183 = callmethod(opresult3182, "++(1)", 1, partcv, params);
// compiled op node returning opresult3183 (depth = 5)
  int op_slot_left_3174 = gc_frame_newslot(opresult3183);
  params[0] = strlit3175;
  partcv[0] = 1;
  Object opresult3184 = callmethod(opresult3183, "++(1)", 1, partcv, params);
// compiled op node returning opresult3184 (depth = 4)
  *var_s = opresult3184;
  if (opresult3184 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3186 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3187 = gc_frame_new();
// call case 4: self request
  Object call3188 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3187);
// compiled member node returning call3188 (depth = 4)
  gc_frame_newslot(call3188);
// starting to compile block node (depth = 4)
  Object block3189 = alloc_Block(NULL, NULL, "ast", 711);
  gc_frame_newslot(block3189);
// method "_apply(_)"
  block_savedest(block3189);
  Object closure3190 = createclosure(4, "_apply(1)");
  setclosureframe(closure3190, stackframe);
  addtoclosure(closure3190, var_depth);
  addtoclosure(closure3190, var_spc);
  addtoclosure(closure3190, var_s);
  addtoclosure(closure3190, selfslot);
  struct UserObject *uo3190 = (struct UserObject*)block3189;
  uo3190->data[0] = (Object)closure3190;
  Method *meth_meth_ast__apply_40_1_41_3190 = addmethod2pos(block3189, "_apply(1)", &meth_ast__apply_40_1_41_3190, 0);
  int argcv_meth_ast__apply_40_1_41_3190[] = {1};
  meth_meth_ast__apply_40_1_41_3190->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3190);
  meth_meth_ast__apply_40_1_41_3190->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3190->definitionLine = 2969;
// compiled block node returning block3189 (depth = 4)
  gc_frame_newslot(block3189);
// call case 5: prelude request
  params[0] = call3188;
  params[1] = block3189;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3209 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3186);
// compiled call node returning call3209 (depth = 3)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3211 == NULL) {
    strlit3211 = alloc_String("""\x0a""");
    gc_root(strlit3211);
  }
// compiled string node returning strlit3211 (depth = 5)
  int op_slot_right_3210 = gc_frame_newslot(strlit3211);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3210 = gc_frame_newslot(*var_s);
  params[0] = strlit3211;
  partcv[0] = 1;
  Object opresult3213 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3213 (depth = 4)
  *var_s = opresult3213;
  if (opresult3213 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_3227(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3229 == NULL) {
    strlit3229 = alloc_String("    ");
    gc_root(strlit3229);
  }
// compiled string node returning strlit3229 (depth = 7)
  int op_slot_right_3228 = gc_frame_newslot(strlit3229);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3228 = gc_frame_newslot(*var_spc);
  params[0] = strlit3229;
  partcv[0] = 1;
  Object opresult3231 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3231 (depth = 6)
  *var_spc = opresult3231;
  if (opresult3231 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_3245(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3247 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3249 = alloc_Float64(1);
// compiled num node returning num3249 (depth = 9)
  int op_slot_right_3248 = gc_frame_newslot(num3249);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3248 = gc_frame_newslot(*var_depth);
  params[0] = num3249;
  partcv[0] = 1;
  Object sum3251 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3251 (depth = 8)
  gc_frame_newslot(sum3251);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3251;
  partcv[0] = 1;
  Object call3252 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3247);
// compiled call node returning call3252 (depth = 7)
  int op_slot_right_3246 = gc_frame_newslot(call3252);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3255 == NULL) {
    strlit3255 = alloc_String("    ");
    gc_root(strlit3255);
  }
// compiled string node returning strlit3255 (depth = 8)
  int op_slot_right_3254 = gc_frame_newslot(strlit3255);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3257 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3260 == NULL) {
    strlit3260 = alloc_String("""\x0a""");
    gc_root(strlit3260);
  }
// compiled string node returning strlit3260 (depth = 10)
  int op_slot_right_3259 = gc_frame_newslot(strlit3260);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3259 = gc_frame_newslot(*var_s);
  params[0] = strlit3260;
  partcv[0] = 1;
  Object opresult3262 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3262 (depth = 9)
  int op_slot_left_3257 = gc_frame_newslot(opresult3262);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3263 = callmethod(opresult3262, "++(1)", 1, partcv, params);
// compiled op node returning opresult3263 (depth = 8)
  int op_slot_left_3254 = gc_frame_newslot(opresult3263);
  params[0] = strlit3255;
  partcv[0] = 1;
  Object opresult3264 = callmethod(opresult3263, "++(1)", 1, partcv, params);
// compiled op node returning opresult3264 (depth = 7)
  int op_slot_left_3246 = gc_frame_newslot(opresult3264);
  params[0] = call3252;
  partcv[0] = 1;
  Object opresult3265 = callmethod(opresult3264, "++(1)", 1, partcv, params);
// compiled op node returning opresult3265 (depth = 6)
  *var_s = opresult3265;
  if (opresult3265 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_3273(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3275 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3277 = alloc_Float64(1);
// compiled num node returning num3277 (depth = 9)
  int op_slot_right_3276 = gc_frame_newslot(num3277);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3276 = gc_frame_newslot(*var_depth);
  params[0] = num3277;
  partcv[0] = 1;
  Object sum3279 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3279 (depth = 8)
  gc_frame_newslot(sum3279);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3279;
  partcv[0] = 1;
  Object call3280 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3275);
// compiled call node returning call3280 (depth = 7)
  int op_slot_right_3274 = gc_frame_newslot(call3280);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3283 == NULL) {
    strlit3283 = alloc_String("    ");
    gc_root(strlit3283);
  }
// compiled string node returning strlit3283 (depth = 8)
  int op_slot_right_3282 = gc_frame_newslot(strlit3283);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3285 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3288 == NULL) {
    strlit3288 = alloc_String("""\x0a""");
    gc_root(strlit3288);
  }
// compiled string node returning strlit3288 (depth = 10)
  int op_slot_right_3287 = gc_frame_newslot(strlit3288);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3287 = gc_frame_newslot(*var_s);
  params[0] = strlit3288;
  partcv[0] = 1;
  Object opresult3290 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3290 (depth = 9)
  int op_slot_left_3285 = gc_frame_newslot(opresult3290);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3291 = callmethod(opresult3290, "++(1)", 1, partcv, params);
// compiled op node returning opresult3291 (depth = 8)
  int op_slot_left_3282 = gc_frame_newslot(opresult3291);
  params[0] = strlit3283;
  partcv[0] = 1;
  Object opresult3292 = callmethod(opresult3291, "++(1)", 1, partcv, params);
// compiled op node returning opresult3292 (depth = 7)
  int op_slot_left_3274 = gc_frame_newslot(opresult3292);
  params[0] = call3280;
  partcv[0] = 1;
  Object opresult3293 = callmethod(opresult3292, "++(1)", 1, partcv, params);
// compiled op node returning opresult3293 (depth = 6)
  *var_s = opresult3293;
  if (opresult3293 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_3215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3216 == NULL) {
    strlit3216 = alloc_String("");
    gc_root(strlit3216);
  }
// compiled string node returning strlit3216 (depth = 4)
  *var_spc = strlit3216;
  if (strlit3216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3217 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3220 = alloc_Float64(1);
// compiled num node returning num3220 (depth = 6)
  int op_slot_right_3219 = gc_frame_newslot(num3220);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3219 = gc_frame_newslot(*var_depth);
  params[0] = num3220;
  partcv[0] = 1;
  Object diff3222 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff3222 (depth = 5)
  int op_slot_right_3218 = gc_frame_newslot(diff3222);
// starting to compile num node (depth = 5)
  Object num3224 = alloc_Float64(0);
// compiled num node returning num3224 (depth = 5)
  int op_slot_left_3218 = gc_frame_newslot(num3224);
  params[0] = diff3222;
  partcv[0] = 1;
  Object opresult3225 = callmethod(num3224, "..(1)", 1, partcv, params);
// compiled op node returning opresult3225 (depth = 4)
  gc_frame_newslot(opresult3225);
// starting to compile block node (depth = 4)
  Object block3226 = alloc_Block(NULL, NULL, "ast", 719);
  gc_frame_newslot(block3226);
// method "_apply(_)"
  block_savedest(block3226);
  Object closure3227 = createclosure(2, "_apply(1)");
  setclosureframe(closure3227, stackframe);
  addtoclosure(closure3227, var_spc);
  addtoclosure(closure3227, selfslot);
  struct UserObject *uo3227 = (struct UserObject*)block3226;
  uo3227->data[0] = (Object)closure3227;
  Method *meth_meth_ast__apply_40_1_41_3227 = addmethod2pos(block3226, "_apply(1)", &meth_ast__apply_40_1_41_3227, 0);
  int argcv_meth_ast__apply_40_1_41_3227[] = {1};
  meth_meth_ast__apply_40_1_41_3227->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3227);
  meth_meth_ast__apply_40_1_41_3227->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3227->definitionLine = 2969;
// compiled block node returning block3226 (depth = 4)
  gc_frame_newslot(block3226);
// call case 5: prelude request
  params[0] = opresult3225;
  params[1] = block3226;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3234 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3217);
// compiled call node returning call3234 (depth = 3)
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3235 == NULL) {
    strlit3235 = alloc_String("type");
    gc_root(strlit3235);
  }
// compiled string node returning strlit3235 (depth = 4)
  *var_s = strlit3235;
  if (strlit3235 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3237 == NULL) {
    strlit3237 = alloc_String(" = {");
    gc_root(strlit3237);
  }
// compiled string node returning strlit3237 (depth = 5)
  int op_slot_right_3236 = gc_frame_newslot(strlit3237);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3236 = gc_frame_newslot(*var_s);
  params[0] = strlit3237;
  partcv[0] = 1;
  Object opresult3239 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3239 (depth = 4)
  *var_s = opresult3239;
  if (opresult3239 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3241 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3242 = gc_frame_new();
// call case 4: self request
  Object call3243 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3242);
// compiled member node returning call3243 (depth = 4)
  gc_frame_newslot(call3243);
// starting to compile block node (depth = 4)
  Object block3244 = alloc_Block(NULL, NULL, "ast", 724);
  gc_frame_newslot(block3244);
// method "_apply(_)"
  block_savedest(block3244);
  Object closure3245 = createclosure(4, "_apply(1)");
  setclosureframe(closure3245, stackframe);
  addtoclosure(closure3245, var_depth);
  addtoclosure(closure3245, var_spc);
  addtoclosure(closure3245, var_s);
  addtoclosure(closure3245, selfslot);
  struct UserObject *uo3245 = (struct UserObject*)block3244;
  uo3245->data[0] = (Object)closure3245;
  Method *meth_meth_ast__apply_40_1_41_3245 = addmethod2pos(block3244, "_apply(1)", &meth_ast__apply_40_1_41_3245, 0);
  int argcv_meth_ast__apply_40_1_41_3245[] = {1};
  meth_meth_ast__apply_40_1_41_3245->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3245);
  meth_meth_ast__apply_40_1_41_3245->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3245->definitionLine = 2969;
// compiled block node returning block3244 (depth = 4)
  gc_frame_newslot(block3244);
// call case 5: prelude request
  params[0] = call3243;
  params[1] = block3244;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3268 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3241);
// compiled call node returning call3268 (depth = 3)
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3269 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3270 = gc_frame_new();
// call case 4: self request
  Object call3271 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3270);
// compiled member node returning call3271 (depth = 4)
  gc_frame_newslot(call3271);
// starting to compile block node (depth = 4)
  Object block3272 = alloc_Block(NULL, NULL, "ast", 727);
  gc_frame_newslot(block3272);
// method "_apply(_)"
  block_savedest(block3272);
  Object closure3273 = createclosure(4, "_apply(1)");
  setclosureframe(closure3273, stackframe);
  addtoclosure(closure3273, var_depth);
  addtoclosure(closure3273, var_spc);
  addtoclosure(closure3273, var_s);
  addtoclosure(closure3273, selfslot);
  struct UserObject *uo3273 = (struct UserObject*)block3272;
  uo3273->data[0] = (Object)closure3273;
  Method *meth_meth_ast__apply_40_1_41_3273 = addmethod2pos(block3272, "_apply(1)", &meth_ast__apply_40_1_41_3273, 0);
  int argcv_meth_ast__apply_40_1_41_3273[] = {1};
  meth_meth_ast__apply_40_1_41_3273->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3273);
  meth_meth_ast__apply_40_1_41_3273->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3273->definitionLine = 2969;
// compiled block node returning block3272 (depth = 4)
  gc_frame_newslot(block3272);
// call case 5: prelude request
  params[0] = call3271;
  params[1] = block3272;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3296 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3269);
// compiled call node returning call3296 (depth = 3)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3298 == NULL) {
    strlit3298 = alloc_String("}");
    gc_root(strlit3298);
  }
// compiled string node returning strlit3298 (depth = 4)
  int op_slot_right_3297 = gc_frame_newslot(strlit3298);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_3297 = gc_frame_newslot(*var_s);
  params[0] = strlit3298;
  partcv[0] = 1;
  Object opresult3300 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3300 (depth = 3)
  gc_frame_end(frame);
  return opresult3300;
}
Object meth_ast_shallowCopy3301(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3302 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3303 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call3304 = callmethodflags(*var_typeLiteralNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3303);
// compiled call node returning call3304 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3305 = callmethodflags(call3304, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3302);
// compiled call node returning call3305 (depth = 3)
  gc_frame_end(frame);
  return call3305;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_3306(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3307 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call3308 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3307);
// compiled call node returning call3308 (depth = 3)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3309 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3310 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call3311 = callmethodflags(*var_other, "nominal", 0, partcv, params, 0);
  gc_frame_end(callframe3310);
// compiled member node returning call3311 (depth = 4)
  gc_frame_newslot(call3311);
// call case 4: self request
  params[0] = call3311;
  partcv[0] = 1;
  Object call3312 = callmethodflags(self, "nominal:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3309);
// compiled call node returning call3312 (depth = 3)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3313 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3314 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call3315 = callmethodflags(*var_other, "anonymous", 0, partcv, params, 0);
  gc_frame_end(callframe3314);
// compiled member node returning call3315 (depth = 4)
  gc_frame_newslot(call3315);
// call case 4: self request
  params[0] = call3315;
  partcv[0] = 1;
  Object call3316 = callmethodflags(self, "anonymous:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3313);
// compiled call node returning call3316 (depth = 3)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3317 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3318 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call3319 = callmethodflags(*var_other, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3318);
// compiled member node returning call3319 (depth = 4)
  gc_frame_newslot(call3319);
// call case 4: self request
  params[0] = call3319;
  partcv[0] = 1;
  Object call3320 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3317);
// compiled call node returning call3320 (depth = 3)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_2_41_3022(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeLiteralNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3023 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3023 = alloc_userobj2(22,18, objclass3023);
  gc_frame_newslot(obj3023);
if (objclass3023 == NULL) {
  glfree(obj3023->class->name);
  obj3023->class->name = "typeLiteralNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3023, self, 0);
  addmethodreal(obj3023,"outer", &reader_ast_outer_3024);
  Object oldself3023 = self;
  struct StackFrameObject *oldstackframe3023 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3023);
  gc_frame_newslot((Object)stackframe);
  self = obj3023;
  Object *oldselfslot3023 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3023 = (*(struct UserObject *)self).data[0], lowerouter3023 = thisouter3023;
  if (inheritingObject3023) {
    struct UserObject *inho3023 = (struct UserObject *)inheritingObject3023;
    while (inho3023->super != GraceDefaultObject) inho3023 = (struct UserObject *)inho3023->super;
    inho3023->super = obj3023;
    self = inheritingObject3023;
    *selfslot = self;
    lowerouter3023 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3023;
  }
if (objclass3023 == NULL) {
  Method *reader3025 = addmethodrealflags(obj3023, "kind",&reader_ast_kind_3025, MFLAG_DEF);
  reader3025->definitionModule = modulename;
  reader3025->definitionLine = 664;
}
adddatum2(obj3023, alloc_Undefined(), 1);
if (objclass3023 == NULL) {
  Method *reader3026 = addmethodrealflags(obj3023, "methods", &reader_ast_methods_3026, 0);
  Method *writer3026 = addmethodrealflags(obj3023, "methods:=(1)", &writer_ast_methods_3026, 0);
  reader3026->definitionModule = modulename;
  writer3026->definitionModule = modulename;
  reader3026->definitionLine = 665;
  writer3026->definitionLine = 665;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 2);
if (objclass3023 == NULL) {
  Method *reader3027 = addmethodrealflags(obj3023, "types", &reader_ast_types_3027, 0);
  Method *writer3027 = addmethodrealflags(obj3023, "types:=(1)", &writer_ast_types_3027, 0);
  reader3027->definitionModule = modulename;
  writer3027->definitionModule = modulename;
  reader3027->definitionLine = 666;
  writer3027->definitionLine = 666;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 3);
if (objclass3023 == NULL) {
  Method *reader3028 = addmethodrealflags(obj3023, "nominal", &reader_ast_nominal_3028, 0);
  Method *writer3028 = addmethodrealflags(obj3023, "nominal:=(1)", &writer_ast_nominal_3028, 0);
  reader3028->definitionModule = modulename;
  writer3028->definitionModule = modulename;
  reader3028->definitionLine = 667;
  writer3028->definitionLine = 667;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 4);
if (objclass3023 == NULL) {
  Method *reader3029 = addmethodrealflags(obj3023, "anonymous", &reader_ast_anonymous_3029, 0);
  Method *writer3029 = addmethodrealflags(obj3023, "anonymous:=(1)", &writer_ast_anonymous_3029, 0);
  reader3029->definitionModule = modulename;
  writer3029->definitionModule = modulename;
  reader3029->definitionLine = 668;
  writer3029->definitionLine = 668;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 5);
if (objclass3023 == NULL) {
  Method *reader3030 = addmethodrealflags(obj3023, "value", &reader_ast_value_3030, 0);
  Method *writer3030 = addmethodrealflags(obj3023, "value:=(1)", &writer_ast_value_3030, 0);
  reader3030->definitionModule = modulename;
  writer3030->definitionModule = modulename;
  reader3030->definitionLine = 669;
  writer3030->definitionLine = 669;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo3031 = (struct UserObject*)obj3023;
  uo3031->data[7] = emptyclosure;
  Method *meth_meth_ast_name3031 = addmethod2pos(obj3023, "name", &meth_ast_name3031, 7);
  int argcv_meth_ast_name3031[] = {0};
  meth_meth_ast_name3031->type = alloc_MethodType(1, argcv_meth_ast_name3031);
  meth_meth_ast_name3031->definitionModule = modulename;
  meth_meth_ast_name3031->definitionLine = 671;
// method "name:=(_)"
  struct UserObject *uo3034 = (struct UserObject*)obj3023;
  uo3034->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61__40_1_41_3034 = addmethod2pos(obj3023, "name:=(1)", &meth_ast_name_58__61__40_1_41_3034, 8);
  int argcv_meth_ast_name_58__61__40_1_41_3034[] = {1};
  meth_meth_ast_name_58__61__40_1_41_3034->type = alloc_MethodType(1, argcv_meth_ast_name_58__61__40_1_41_3034);
  meth_meth_ast_name_58__61__40_1_41_3034->definitionModule = modulename;
  meth_meth_ast_name_58__61__40_1_41_3034->definitionLine = 672;
// method "asString"
  struct UserObject *uo3040 = (struct UserObject*)obj3023;
  uo3040->data[9] = emptyclosure;
  Method *meth_meth_ast_asString3040 = addmethod2pos(obj3023, "asString", &meth_ast_asString3040, 9);
  int argcv_meth_ast_asString3040[] = {0};
  meth_meth_ast_asString3040->type = alloc_MethodType(1, argcv_meth_ast_asString3040);
  meth_meth_ast_asString3040->definitionModule = modulename;
  meth_meth_ast_asString3040->definitionLine = 676;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3023);
  Object closure3060 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3060, stackframe);
  addtoclosure(closure3060, var_k);
  struct UserObject *uo3060 = (struct UserObject*)obj3023;
  uo3060->data[10] = (Object)closure3060;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3060 = addmethod2pos(obj3023, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3060, 10);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3060[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3060->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3060);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3060->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3060->definitionLine = 679;
// method "isExecutable"
  struct UserObject *uo3063 = (struct UserObject*)obj3023;
  uo3063->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable3063 = addmethod2pos(obj3023, "isExecutable", &meth_ast_isExecutable3063, 11);
  int argcv_meth_ast_isExecutable3063[] = {0};
  meth_meth_ast_isExecutable3063->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3063);
  meth_meth_ast_isExecutable3063->definitionModule = modulename;
  meth_meth_ast_isExecutable3063->definitionLine = 680;
// method "accept(_)from(_)"
  struct UserObject *uo3065 = (struct UserObject*)obj3023;
  uo3065->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3065 = addmethod2pos(obj3023, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3065, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3065[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3065->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3065);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3065->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3065->definitionLine = 682;
// method "map(_)ancestors(_)"
  struct UserObject *uo3089 = (struct UserObject*)obj3023;
  uo3089->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_3089 = addmethod2pos(obj3023, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_3089, 13);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3089[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3089->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3089);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3089->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3089->definitionLine = 693;
// method "pretty(_)"
  struct UserObject *uo3116 = (struct UserObject*)obj3023;
  uo3116->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_3116 = addmethod2pos(obj3023, "pretty(1)", &meth_ast_pretty_40_1_41_3116, 14);
  int argcv_meth_ast_pretty_40_1_41_3116[] = {1};
  meth_meth_ast_pretty_40_1_41_3116->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_3116);
  meth_meth_ast_pretty_40_1_41_3116->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_3116->definitionLine = 700;
// method "toGrace(_)"
  struct UserObject *uo3215 = (struct UserObject*)obj3023;
  uo3215->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_3215 = addmethod2pos(obj3023, "toGrace(1)", &meth_ast_toGrace_40_1_41_3215, 15);
  int argcv_meth_ast_toGrace_40_1_41_3215[] = {1};
  meth_meth_ast_toGrace_40_1_41_3215->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_3215);
meth_meth_ast_toGrace_40_1_41_3215->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_3215->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_3215->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_3215->definitionLine = 717;
// method "shallowCopy"
  block_savedest(obj3023);
  Object closure3301 = createclosure(2, "shallowCopy");
  setclosureframe(closure3301, stackframe);
  addtoclosure(closure3301, var_emptySeq);
  addtoclosure(closure3301, var_typeLiteralNode);
  struct UserObject *uo3301 = (struct UserObject*)obj3023;
  uo3301->data[16] = (Object)closure3301;
  Method *meth_meth_ast_shallowCopy3301 = addmethod2pos(obj3023, "shallowCopy", &meth_ast_shallowCopy3301, 16);
  int argcv_meth_ast_shallowCopy3301[] = {0};
  meth_meth_ast_shallowCopy3301->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3301);
  meth_meth_ast_shallowCopy3301->definitionModule = modulename;
  meth_meth_ast_shallowCopy3301->definitionLine = 732;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo3306 = (struct UserObject*)obj3023;
  uo3306->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3306 = addmethod2pos(obj3023, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_3306, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_3306[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3306->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_3306);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3306->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3306->definitionLine = 735;
  sourceObject = obj3023;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3321 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3322 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3323 = gc_frame_new();
// call case 3: self.outer request
  Object call3324 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3323);
// compiled member node returning call3324 (depth = 5)
  Object call3325 = callmethodflags(call3324, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3322);
// compiled member node returning call3325 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3326 = callmethodflags(call3325, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3321);
// compiled call node returning call3326 (depth = 3)
  struct UserObject *obj3023_uo = (struct UserObject *)obj3023;
  obj3023_uo->super = call3326;
  sourceObject = obj3023;
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3327 == NULL) {
    strlit3327 = alloc_String("typeliteral");
    gc_root(strlit3327);
  }
// compiled string node returning strlit3327 (depth = 3)
  adddatum2(obj3023, strlit3327, 1);
  sourceObject = obj3023;
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj3023, *var_methods_39_, 2);
  sourceObject = obj3023;
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj3023, *var_types_39_, 3);
  sourceObject = obj3023;
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3328 = alloc_Boolean(0);
// compiled identifier node returning bool3328 (depth = 3)
  adddatum2(obj3023, bool3328, 4);
  sourceObject = obj3023;
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3329 = alloc_Boolean(1);
// compiled identifier node returning bool3329 (depth = 3)
  adddatum2(obj3023, bool3329, 5);
  sourceObject = obj3023;
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3330 == NULL) {
    strlit3330 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3330);
  }
// compiled string node returning strlit3330 (depth = 3)
  adddatum2(obj3023, strlit3330, 6);
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  objclass3023 = obj3023->class;
  objclass3023->definitionModule = modulename;
  objclass3023->definitionLine = 662;
  (*(struct UserObject *)self).data[0] = lowerouter3023;
  self = oldself3023;
  selfslot = oldselfslot3023;
  stackframe = oldstackframe3023;
  gc_frame_end(frame);
  return obj3023;
}
Object meth_ast_new_40_2_41_3022_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeLiteralNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3023 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3023 = alloc_userobj2(22,18, objclass3023);
  gc_frame_newslot(obj3023);
if (objclass3023 == NULL) {
  glfree(obj3023->class->name);
  obj3023->class->name = "typeLiteralNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3023, self, 0);
  addmethodreal(obj3023,"outer", &reader_ast_outer_3024);
  Object oldself3023 = self;
  struct StackFrameObject *oldstackframe3023 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3023);
  gc_frame_newslot((Object)stackframe);
  self = obj3023;
  Object *oldselfslot3023 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3023 = (*(struct UserObject *)self).data[0], lowerouter3023 = thisouter3023;
  if (inheritingObject3023) {
    struct UserObject *inho3023 = (struct UserObject *)inheritingObject3023;
    while (inho3023->super != GraceDefaultObject) inho3023 = (struct UserObject *)inho3023->super;
    inho3023->super = obj3023;
    self = inheritingObject3023;
    *selfslot = self;
    lowerouter3023 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3023;
  }
if (objclass3023 == NULL) {
  Method *reader3025 = addmethodrealflags(obj3023, "kind",&reader_ast_kind_3025, MFLAG_DEF);
  reader3025->definitionModule = modulename;
  reader3025->definitionLine = 664;
}
adddatum2(obj3023, alloc_Undefined(), 1);
if (objclass3023 == NULL) {
  Method *reader3026 = addmethodrealflags(obj3023, "methods", &reader_ast_methods_3026, 0);
  Method *writer3026 = addmethodrealflags(obj3023, "methods:=(1)", &writer_ast_methods_3026, 0);
  reader3026->definitionModule = modulename;
  writer3026->definitionModule = modulename;
  reader3026->definitionLine = 665;
  writer3026->definitionLine = 665;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 2);
if (objclass3023 == NULL) {
  Method *reader3027 = addmethodrealflags(obj3023, "types", &reader_ast_types_3027, 0);
  Method *writer3027 = addmethodrealflags(obj3023, "types:=(1)", &writer_ast_types_3027, 0);
  reader3027->definitionModule = modulename;
  writer3027->definitionModule = modulename;
  reader3027->definitionLine = 666;
  writer3027->definitionLine = 666;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 3);
if (objclass3023 == NULL) {
  Method *reader3028 = addmethodrealflags(obj3023, "nominal", &reader_ast_nominal_3028, 0);
  Method *writer3028 = addmethodrealflags(obj3023, "nominal:=(1)", &writer_ast_nominal_3028, 0);
  reader3028->definitionModule = modulename;
  writer3028->definitionModule = modulename;
  reader3028->definitionLine = 667;
  writer3028->definitionLine = 667;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 4);
if (objclass3023 == NULL) {
  Method *reader3029 = addmethodrealflags(obj3023, "anonymous", &reader_ast_anonymous_3029, 0);
  Method *writer3029 = addmethodrealflags(obj3023, "anonymous:=(1)", &writer_ast_anonymous_3029, 0);
  reader3029->definitionModule = modulename;
  writer3029->definitionModule = modulename;
  reader3029->definitionLine = 668;
  writer3029->definitionLine = 668;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 5);
if (objclass3023 == NULL) {
  Method *reader3030 = addmethodrealflags(obj3023, "value", &reader_ast_value_3030, 0);
  Method *writer3030 = addmethodrealflags(obj3023, "value:=(1)", &writer_ast_value_3030, 0);
  reader3030->definitionModule = modulename;
  writer3030->definitionModule = modulename;
  reader3030->definitionLine = 669;
  writer3030->definitionLine = 669;
}
obj3023->flags |= OFLAG_MUTABLE;
adddatum2(obj3023, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo3031 = (struct UserObject*)obj3023;
  uo3031->data[7] = emptyclosure;
  Method *meth_meth_ast_name3031 = addmethod2pos(obj3023, "name", &meth_ast_name3031, 7);
  int argcv_meth_ast_name3031[] = {0};
  meth_meth_ast_name3031->type = alloc_MethodType(1, argcv_meth_ast_name3031);
  meth_meth_ast_name3031->definitionModule = modulename;
  meth_meth_ast_name3031->definitionLine = 671;
// method "name:=(_)"
  struct UserObject *uo3034 = (struct UserObject*)obj3023;
  uo3034->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61__40_1_41_3034 = addmethod2pos(obj3023, "name:=(1)", &meth_ast_name_58__61__40_1_41_3034, 8);
  int argcv_meth_ast_name_58__61__40_1_41_3034[] = {1};
  meth_meth_ast_name_58__61__40_1_41_3034->type = alloc_MethodType(1, argcv_meth_ast_name_58__61__40_1_41_3034);
  meth_meth_ast_name_58__61__40_1_41_3034->definitionModule = modulename;
  meth_meth_ast_name_58__61__40_1_41_3034->definitionLine = 672;
// method "asString"
  struct UserObject *uo3040 = (struct UserObject*)obj3023;
  uo3040->data[9] = emptyclosure;
  Method *meth_meth_ast_asString3040 = addmethod2pos(obj3023, "asString", &meth_ast_asString3040, 9);
  int argcv_meth_ast_asString3040[] = {0};
  meth_meth_ast_asString3040->type = alloc_MethodType(1, argcv_meth_ast_asString3040);
  meth_meth_ast_asString3040->definitionModule = modulename;
  meth_meth_ast_asString3040->definitionLine = 676;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3023);
  Object closure3060 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3060, stackframe);
  addtoclosure(closure3060, var_k);
  struct UserObject *uo3060 = (struct UserObject*)obj3023;
  uo3060->data[10] = (Object)closure3060;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3060 = addmethod2pos(obj3023, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3060, 10);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3060[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3060->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3060);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3060->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3060->definitionLine = 679;
// method "isExecutable"
  struct UserObject *uo3063 = (struct UserObject*)obj3023;
  uo3063->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable3063 = addmethod2pos(obj3023, "isExecutable", &meth_ast_isExecutable3063, 11);
  int argcv_meth_ast_isExecutable3063[] = {0};
  meth_meth_ast_isExecutable3063->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3063);
  meth_meth_ast_isExecutable3063->definitionModule = modulename;
  meth_meth_ast_isExecutable3063->definitionLine = 680;
// method "accept(_)from(_)"
  struct UserObject *uo3065 = (struct UserObject*)obj3023;
  uo3065->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3065 = addmethod2pos(obj3023, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3065, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3065[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3065->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3065);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3065->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3065->definitionLine = 682;
// method "map(_)ancestors(_)"
  struct UserObject *uo3089 = (struct UserObject*)obj3023;
  uo3089->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_3089 = addmethod2pos(obj3023, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_3089, 13);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3089[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3089->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3089);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3089->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3089->definitionLine = 693;
// method "pretty(_)"
  struct UserObject *uo3116 = (struct UserObject*)obj3023;
  uo3116->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_3116 = addmethod2pos(obj3023, "pretty(1)", &meth_ast_pretty_40_1_41_3116, 14);
  int argcv_meth_ast_pretty_40_1_41_3116[] = {1};
  meth_meth_ast_pretty_40_1_41_3116->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_3116);
  meth_meth_ast_pretty_40_1_41_3116->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_3116->definitionLine = 700;
// method "toGrace(_)"
  struct UserObject *uo3215 = (struct UserObject*)obj3023;
  uo3215->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_3215 = addmethod2pos(obj3023, "toGrace(1)", &meth_ast_toGrace_40_1_41_3215, 15);
  int argcv_meth_ast_toGrace_40_1_41_3215[] = {1};
  meth_meth_ast_toGrace_40_1_41_3215->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_3215);
meth_meth_ast_toGrace_40_1_41_3215->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_3215->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_3215->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_3215->definitionLine = 717;
// method "shallowCopy"
  block_savedest(obj3023);
  Object closure3301 = createclosure(2, "shallowCopy");
  setclosureframe(closure3301, stackframe);
  addtoclosure(closure3301, var_emptySeq);
  addtoclosure(closure3301, var_typeLiteralNode);
  struct UserObject *uo3301 = (struct UserObject*)obj3023;
  uo3301->data[16] = (Object)closure3301;
  Method *meth_meth_ast_shallowCopy3301 = addmethod2pos(obj3023, "shallowCopy", &meth_ast_shallowCopy3301, 16);
  int argcv_meth_ast_shallowCopy3301[] = {0};
  meth_meth_ast_shallowCopy3301->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3301);
  meth_meth_ast_shallowCopy3301->definitionModule = modulename;
  meth_meth_ast_shallowCopy3301->definitionLine = 732;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo3306 = (struct UserObject*)obj3023;
  uo3306->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3306 = addmethod2pos(obj3023, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_3306, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_3306[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3306->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_3306);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3306->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3306->definitionLine = 735;
  sourceObject = obj3023;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3321 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3322 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3323 = gc_frame_new();
// call case 3: self.outer request
  Object call3324 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3323);
// compiled member node returning call3324 (depth = 5)
  Object call3325 = callmethodflags(call3324, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3322);
// compiled member node returning call3325 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3326 = callmethodflags(call3325, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3321);
// compiled call node returning call3326 (depth = 3)
  struct UserObject *obj3023_uo = (struct UserObject *)obj3023;
  obj3023_uo->super = call3326;
  sourceObject = obj3023;
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3327 == NULL) {
    strlit3327 = alloc_String("typeliteral");
    gc_root(strlit3327);
  }
// compiled string node returning strlit3327 (depth = 3)
  adddatum2(obj3023, strlit3327, 1);
  sourceObject = obj3023;
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj3023, *var_methods_39_, 2);
  sourceObject = obj3023;
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj3023, *var_types_39_, 3);
  sourceObject = obj3023;
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3328 = alloc_Boolean(0);
// compiled identifier node returning bool3328 (depth = 3)
  adddatum2(obj3023, bool3328, 4);
  sourceObject = obj3023;
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3329 = alloc_Boolean(1);
// compiled identifier node returning bool3329 (depth = 3)
  adddatum2(obj3023, bool3329, 5);
  sourceObject = obj3023;
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3330 == NULL) {
    strlit3330 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3330);
  }
// compiled string node returning strlit3330 (depth = 3)
  adddatum2(obj3023, strlit3330, 6);
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  sourceObject = obj3023;
  objclass3023 = obj3023->class;
  objclass3023->definitionModule = modulename;
  objclass3023->definitionLine = 662;
  (*(struct UserObject *)self).data[0] = lowerouter3023;
  self = oldself3023;
  selfslot = oldselfslot3023;
  stackframe = oldstackframe3023;
  gc_frame_end(frame);
  return obj3023;
}
Object meth_ast_typeLiteralNode3332(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeLiteralNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeLiteralNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeLiteralNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeLiteralNode;
}
Object meth_ast_isLegalInTrait3344(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3345 = alloc_Boolean(1);
// compiled identifier node returning bool3345 (depth = 3)
  gc_frame_end(frame);
  return bool3345;
}
Object meth_ast_isTypeDec3346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3347 = alloc_Boolean(1);
// compiled identifier node returning bool3347 (depth = 3)
  gc_frame_end(frame);
  return bool3347;
}
Object meth_ast_scope_58__61__40_1_41_3348(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3349 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3350 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3349);
// compiled call node returning call3350 (depth = 3)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3351 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3352 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3351);
// compiled call node returning call3352 (depth = 3)
  gc_frame_end(frame);
  return call3352;
}
Object meth_ast_isExecutable3353(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3354 = alloc_Boolean(1);
// compiled identifier node returning bool3354 (depth = 3)
  gc_frame_end(frame);
  return bool3354;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_3355(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3356 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call3357 = callmethodflags(*var_k, "typeparam", 0, partcv, params, 0);
  gc_frame_end(callframe3356);
// compiled member node returning call3357 (depth = 3)
  gc_frame_end(frame);
  return call3357;
}
Object meth_ast_isConfidential3358(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3361 = alloc_Float64(0);
// compiled num node returning num3361 (depth = 5)
  int op_slot_right_3360 = gc_frame_newslot(num3361);
// starting to compile member node (depth = 5)
  int callframe3363 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3364 = gc_frame_new();
// call case 4: self request
  Object call3365 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3364);
// compiled member node returning call3365 (depth = 6)
  Object call3366 = callmethodflags(call3365, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3363);
// compiled member node returning call3366 (depth = 5)
  int op_slot_left_3360 = gc_frame_newslot(call3366);
  params[0] = num3361;
  partcv[0] = 1;
  Object opresult3367 = callmethod(call3366, "==(1)", 1, partcv, params);
// compiled op node returning opresult3367 (depth = 4)
  Object if3359 = done;
  if (istrue(opresult3367)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3368 = alloc_Boolean(0);
// compiled identifier node returning bool3368 (depth = 5)
  return bool3368;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3359 = undefined;
  } else {
  }
// compiled if node returning if3359 (depth = 3)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3369 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3370 == NULL) {
    strlit3370 = alloc_String("confidential");
    gc_root(strlit3370);
  }
// compiled string node returning strlit3370 (depth = 4)
  gc_frame_newslot(strlit3370);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3371 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3372 = gc_frame_new();
// call case 3: self.outer request
  Object call3373 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3372);
// compiled member node returning call3373 (depth = 5)
  Object call3374 = callmethodflags(call3373, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3371);
// compiled member node returning call3374 (depth = 4)
  params[0] = self;
  params[1] = strlit3370;
  partcv[0] = 2;
  Object call3375 = callmethodflags(call3374, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3369);
// compiled call node returning call3375 (depth = 3)
  gc_frame_end(frame);
  return call3375;
}
Object meth_ast_isPublic3376(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3377 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3378 = gc_frame_new();
// call case 4: self request
  Object call3379 = callmethodflags(self, "isConfidential", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3378);
// compiled member node returning call3379 (depth = 4)
  Object call3380 = callmethodflags(call3379, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3377);
// compiled member node returning call3380 (depth = 3)
  gc_frame_end(frame);
  return call3380;
}
Object meth_ast_isWritable3381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3382 = alloc_Boolean(0);
// compiled identifier node returning bool3382 (depth = 3)
  gc_frame_end(frame);
  return bool3382;
}
Object meth_ast_isReadable3383(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3384 = gc_frame_new();
// call case 4: self request
  Object call3385 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3384);
// compiled member node returning call3385 (depth = 3)
  gc_frame_end(frame);
  return call3385;
}
Object meth_ast__apply_40_1_41_3409(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe3410 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3411 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3410);
// compiled call node returning call3411 (depth = 6)
  gc_frame_end(frame);
  return call3411;
}
Object meth_ast_accept_40_1_41_from_40_1_41_3386(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3388 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3389 = callmethodflags(*var_visitor, "visitTypeDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3388);
// compiled call node returning call3389 (depth = 4)
  Object if3387 = done;
  if (istrue(call3389)) {
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3390 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3391 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3390);
// compiled call node returning call3391 (depth = 5)
  *var_newChain = call3391;
  if (call3391 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3392 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3393 = gc_frame_new();
// call case 4: self request
  Object call3394 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3393);
// compiled member node returning call3394 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3395 = callmethodflags(call3394, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3392);
// compiled call node returning call3395 (depth = 4)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3398 = gc_frame_new();
// call case 4: self request
  Object call3399 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3398);
// compiled member node returning call3399 (depth = 6)
  int op_slot_right_3397 = gc_frame_newslot(call3399);
// starting to compile identifier node (depth = 6)
  Object bool3401 = alloc_Boolean(0);
// compiled identifier node returning bool3401 (depth = 6)
  int op_slot_left_3397 = gc_frame_newslot(bool3401);
  params[0] = call3399;
  partcv[0] = 1;
  Object opresult3402 = callmethod(bool3401, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3402 (depth = 5)
  Object if3396 = done;
  if (istrue(opresult3402)) {
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3403 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3404 = gc_frame_new();
// call case 4: self request
  Object call3405 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3404);
// compiled member node returning call3405 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3406 = callmethodflags(call3405, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3403);
// compiled call node returning call3406 (depth = 5)
    gc_frame_newslot(call3406);
    if3396 = call3406;
  } else {
  }
// compiled if node returning if3396 (depth = 4)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3407 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3408 = alloc_Block(NULL, NULL, "ast", 781);
  gc_frame_newslot(block3408);
// method "_apply(_)"
  block_savedest(block3408);
  Object closure3409 = createclosure(3, "_apply(1)");
  setclosureframe(closure3409, stackframe);
  addtoclosure(closure3409, var_visitor);
  addtoclosure(closure3409, var_newChain);
  addtoclosure(closure3409, selfslot);
  struct UserObject *uo3409 = (struct UserObject*)block3408;
  uo3409->data[0] = (Object)closure3409;
  Method *meth_meth_ast__apply_40_1_41_3409 = addmethod2pos(block3408, "_apply(1)", &meth_ast__apply_40_1_41_3409, 0);
  int argcv_meth_ast__apply_40_1_41_3409[] = {1};
  meth_meth_ast__apply_40_1_41_3409->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3409);
  meth_meth_ast__apply_40_1_41_3409->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3409->definitionLine = 2969;
// compiled block node returning block3408 (depth = 5)
  gc_frame_newslot(block3408);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3413 = gc_frame_new();
// call case 4: self request
  Object call3414 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3413);
// compiled member node returning call3414 (depth = 5)
  params[0] = block3408;
  partcv[0] = 1;
  Object call3415 = callmethodflags(call3414, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3407);
// compiled call node returning call3415 (depth = 4)
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3416 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3417 = gc_frame_new();
// call case 4: self request
  Object call3418 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3417);
// compiled member node returning call3418 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3419 = callmethodflags(call3418, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3416);
// compiled call node returning call3419 (depth = 4)
    gc_frame_newslot(call3419);
    if3387 = call3419;
  } else {
  }
// compiled if node returning if3387 (depth = 3)
  gc_frame_end(frame);
  return if3387;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_3420(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3421 = gc_frame_new();
// call case 4: self request
  Object call3422 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3421);
// compiled member node returning call3422 (depth = 4)
  *var_n = call3422;
  if (call3422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3423 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3424 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3423);
// compiled call node returning call3424 (depth = 4)
  *var_newChain = call3424;
  if (call3424 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3425 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3426 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3427 = gc_frame_new();
// call case 4: self request
  Object call3428 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3427);
// compiled member node returning call3428 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3429 = callmethodflags(call3428, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3426);
// compiled call node returning call3429 (depth = 4)
  gc_frame_newslot(call3429);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3429;
  partcv[0] = 1;
  Object call3430 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3425);
// compiled call node returning call3430 (depth = 3)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3431 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3432 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3433 = gc_frame_new();
// call case 4: self request
  Object call3434 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3433);
// compiled member node returning call3434 (depth = 5)
  gc_frame_newslot(call3434);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3435 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3436 = gc_frame_new();
// call case 3: self.outer request
  Object call3437 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3436);
// compiled member node returning call3437 (depth = 6)
  Object call3438 = callmethodflags(call3437, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3435);
// compiled member node returning call3438 (depth = 5)
  params[0] = call3434;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3439 = callmethodflags(call3438, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3432);
// compiled call node returning call3439 (depth = 4)
  gc_frame_newslot(call3439);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3439;
  partcv[0] = 1;
  Object call3440 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3431);
// compiled call node returning call3440 (depth = 3)
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3441 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3442 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3443 = gc_frame_new();
// call case 4: self request
  Object call3444 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3443);
// compiled member node returning call3444 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3445 = callmethodflags(call3444, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3442);
// compiled call node returning call3445 (depth = 4)
  gc_frame_newslot(call3445);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3445;
  partcv[0] = 1;
  Object call3446 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3441);
// compiled call node returning call3446 (depth = 3)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3447 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3448 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3449 = gc_frame_new();
// call case 4: self request
  Object call3450 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3449);
// compiled member node returning call3450 (depth = 5)
  gc_frame_newslot(call3450);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3451 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3452 = gc_frame_new();
// call case 3: self.outer request
  Object call3453 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3452);
// compiled member node returning call3453 (depth = 6)
  Object call3454 = callmethodflags(call3453, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3451);
// compiled member node returning call3454 (depth = 5)
  params[0] = call3450;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3455 = callmethodflags(call3454, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3448);
// compiled call node returning call3455 (depth = 4)
  gc_frame_newslot(call3455);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3455;
  partcv[0] = 1;
  Object call3456 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3447);
// compiled call node returning call3456 (depth = 3)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3457 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3458 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3457);
// compiled call node returning call3458 (depth = 3)
  gc_frame_end(frame);
  return call3458;
}
Object meth_ast__apply_40_1_41_3467(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3469 == NULL) {
    strlit3469 = alloc_String("  ");
    gc_root(strlit3469);
  }
// compiled string node returning strlit3469 (depth = 7)
  int op_slot_right_3468 = gc_frame_newslot(strlit3469);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3468 = gc_frame_newslot(*var_spc);
  params[0] = strlit3469;
  partcv[0] = 1;
  Object opresult3471 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3471 (depth = 6)
  *var_spc = opresult3471;
  if (opresult3471 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_3459(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3460 == NULL) {
    strlit3460 = alloc_String("");
    gc_root(strlit3460);
  }
// compiled string node returning strlit3460 (depth = 4)
  *var_spc = strlit3460;
  if (strlit3460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3461 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3462 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3464 = alloc_Float64(0);
// compiled num node returning num3464 (depth = 5)
  int op_slot_left_3462 = gc_frame_newslot(num3464);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3465 = callmethod(num3464, "..(1)", 1, partcv, params);
// compiled op node returning opresult3465 (depth = 4)
  gc_frame_newslot(opresult3465);
// starting to compile block node (depth = 4)
  Object block3466 = alloc_Block(NULL, NULL, "ast", 796);
  gc_frame_newslot(block3466);
// method "_apply(_)"
  block_savedest(block3466);
  Object closure3467 = createclosure(2, "_apply(1)");
  setclosureframe(closure3467, stackframe);
  addtoclosure(closure3467, var_spc);
  addtoclosure(closure3467, selfslot);
  struct UserObject *uo3467 = (struct UserObject*)block3466;
  uo3467->data[0] = (Object)closure3467;
  Method *meth_meth_ast__apply_40_1_41_3467 = addmethod2pos(block3466, "_apply(1)", &meth_ast__apply_40_1_41_3467, 0);
  int argcv_meth_ast__apply_40_1_41_3467[] = {1};
  meth_meth_ast__apply_40_1_41_3467->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3467);
  meth_meth_ast__apply_40_1_41_3467->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3467->definitionLine = 2969;
// compiled block node returning block3466 (depth = 4)
  gc_frame_newslot(block3466);
// call case 5: prelude request
  params[0] = opresult3465;
  params[1] = block3466;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3474 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3461);
// compiled call node returning call3474 (depth = 3)
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3476 == NULL) {
    strlit3476 = alloc_String("""\x0a""");
    gc_root(strlit3476);
  }
// compiled string node returning strlit3476 (depth = 5)
  int op_slot_right_3475 = gc_frame_newslot(strlit3476);
// starting to compile call node (depth = 5)
  int callframe3478 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3479 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3478);
// compiled call node returning call3479 (depth = 5)
  int op_slot_left_3475 = gc_frame_newslot(call3479);
  params[0] = strlit3476;
  partcv[0] = 1;
  Object opresult3480 = callmethod(call3479, "++(1)", 1, partcv, params);
// compiled op node returning opresult3480 (depth = 4)
  *var_s = opresult3480;
  if (opresult3480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3482 == NULL) {
    strlit3482 = alloc_String("""\x0a""");
    gc_root(strlit3482);
  }
// compiled string node returning strlit3482 (depth = 5)
  int op_slot_right_3481 = gc_frame_newslot(strlit3482);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3485 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3487 = alloc_Float64(1);
// compiled num node returning num3487 (depth = 8)
  int op_slot_right_3486 = gc_frame_newslot(num3487);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3486 = gc_frame_newslot(*var_depth);
  params[0] = num3487;
  partcv[0] = 1;
  Object sum3489 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3489 (depth = 7)
  gc_frame_newslot(sum3489);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3490 = gc_frame_new();
// call case 4: self request
  Object call3491 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3490);
// compiled member node returning call3491 (depth = 7)
  params[0] = sum3489;
  partcv[0] = 1;
  Object call3492 = callmethodflags(call3491, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3485);
// compiled call node returning call3492 (depth = 6)
  int op_slot_right_3484 = gc_frame_newslot(call3492);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3494 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3494 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3496 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3496 (depth = 6)
  int op_slot_left_3484 = gc_frame_newslot(opresult3496);
  params[0] = call3492;
  partcv[0] = 1;
  Object opresult3497 = callmethod(opresult3496, "++(1)", 1, partcv, params);
// compiled op node returning opresult3497 (depth = 5)
  int op_slot_left_3481 = gc_frame_newslot(opresult3497);
  params[0] = strlit3482;
  partcv[0] = 1;
  Object opresult3498 = callmethod(opresult3497, "++(1)", 1, partcv, params);
// compiled op node returning opresult3498 (depth = 4)
  *var_s = opresult3498;
  if (opresult3498 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3502 = gc_frame_new();
// call case 4: self request
  Object call3503 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3502);
// compiled member node returning call3503 (depth = 5)
  int op_slot_right_3501 = gc_frame_newslot(call3503);
// starting to compile identifier node (depth = 5)
  Object bool3505 = alloc_Boolean(0);
// compiled identifier node returning bool3505 (depth = 5)
  int op_slot_left_3501 = gc_frame_newslot(bool3505);
  params[0] = call3503;
  partcv[0] = 1;
  Object opresult3506 = callmethod(bool3505, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3506 (depth = 4)
  Object if3500 = done;
  if (istrue(opresult3506)) {
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3508 == NULL) {
    strlit3508 = alloc_String("""\x0a""");
    gc_root(strlit3508);
  }
// compiled string node returning strlit3508 (depth = 6)
  int op_slot_right_3507 = gc_frame_newslot(strlit3508);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3511 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3513 = alloc_Float64(2);
// compiled num node returning num3513 (depth = 9)
  int op_slot_right_3512 = gc_frame_newslot(num3513);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3512 = gc_frame_newslot(*var_depth);
  params[0] = num3513;
  partcv[0] = 1;
  Object sum3515 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3515 (depth = 8)
  gc_frame_newslot(sum3515);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3516 = gc_frame_new();
// call case 4: self request
  Object call3517 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3516);
// compiled member node returning call3517 (depth = 8)
  params[0] = sum3515;
  partcv[0] = 1;
  Object call3518 = callmethodflags(call3517, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3511);
// compiled call node returning call3518 (depth = 7)
  int op_slot_right_3510 = gc_frame_newslot(call3518);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3521 == NULL) {
    strlit3521 = alloc_String("Type parameters:""\x0a""");
    gc_root(strlit3521);
  }
// compiled string node returning strlit3521 (depth = 8)
  int op_slot_right_3520 = gc_frame_newslot(strlit3521);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3523 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3526 == NULL) {
    strlit3526 = alloc_String("");
    gc_root(strlit3526);
  }
// compiled string node returning strlit3526 (depth = 10)
  int op_slot_right_3525 = gc_frame_newslot(strlit3526);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_3528 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit3530 == NULL) {
    strlit3530 = alloc_String("");
    gc_root(strlit3530);
  }
// compiled string node returning strlit3530 (depth = 11)
  int op_slot_left_3528 = gc_frame_newslot(strlit3530);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3531 = callmethod(strlit3530, "++(1)", 1, partcv, params);
// compiled op node returning opresult3531 (depth = 10)
  int op_slot_left_3525 = gc_frame_newslot(opresult3531);
  params[0] = strlit3526;
  partcv[0] = 1;
  Object opresult3532 = callmethod(opresult3531, "++(1)", 1, partcv, params);
// compiled op node returning opresult3532 (depth = 9)
  int op_slot_left_3523 = gc_frame_newslot(opresult3532);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3533 = callmethod(opresult3532, "++(1)", 1, partcv, params);
// compiled op node returning opresult3533 (depth = 8)
  int op_slot_left_3520 = gc_frame_newslot(opresult3533);
  params[0] = strlit3521;
  partcv[0] = 1;
  Object opresult3534 = callmethod(opresult3533, "++(1)", 1, partcv, params);
// compiled op node returning opresult3534 (depth = 7)
  int op_slot_left_3510 = gc_frame_newslot(opresult3534);
  params[0] = call3518;
  partcv[0] = 1;
  Object opresult3535 = callmethod(opresult3534, "++(1)", 1, partcv, params);
// compiled op node returning opresult3535 (depth = 6)
  int op_slot_left_3507 = gc_frame_newslot(opresult3535);
  params[0] = strlit3508;
  partcv[0] = 1;
  Object opresult3536 = callmethod(opresult3535, "++(1)", 1, partcv, params);
// compiled op node returning opresult3536 (depth = 5)
  *var_s = opresult3536;
  if (opresult3536 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3500 = done;
  } else {
  }
// compiled if node returning if3500 (depth = 3)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3539 == NULL) {
    strlit3539 = alloc_String("Value:");
    gc_root(strlit3539);
  }
// compiled string node returning strlit3539 (depth = 5)
  int op_slot_right_3538 = gc_frame_newslot(strlit3539);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3541 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3541 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3543 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3543 (depth = 5)
  int op_slot_left_3538 = gc_frame_newslot(opresult3543);
  params[0] = strlit3539;
  partcv[0] = 1;
  Object opresult3544 = callmethod(opresult3543, "++(1)", 1, partcv, params);
// compiled op node returning opresult3544 (depth = 4)
  *var_s = opresult3544;
  if (opresult3544 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3547 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3549 = alloc_Float64(2);
// compiled num node returning num3549 (depth = 7)
  int op_slot_right_3548 = gc_frame_newslot(num3549);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3548 = gc_frame_newslot(*var_depth);
  params[0] = num3549;
  partcv[0] = 1;
  Object sum3551 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3551 (depth = 6)
  gc_frame_newslot(sum3551);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3552 = gc_frame_new();
// call case 4: self request
  Object call3553 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3552);
// compiled member node returning call3553 (depth = 6)
  params[0] = sum3551;
  partcv[0] = 1;
  Object call3554 = callmethodflags(call3553, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3547);
// compiled call node returning call3554 (depth = 5)
  int op_slot_right_3546 = gc_frame_newslot(call3554);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3546 = gc_frame_newslot(*var_s);
  params[0] = call3554;
  partcv[0] = 1;
  Object opresult3556 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3556 (depth = 4)
  *var_s = opresult3556;
  if (opresult3556 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3559 == NULL) {
    strlit3559 = alloc_String("""\x0a""");
    gc_root(strlit3559);
  }
// compiled string node returning strlit3559 (depth = 5)
  int op_slot_right_3558 = gc_frame_newslot(strlit3559);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3558 = gc_frame_newslot(*var_s);
  params[0] = strlit3559;
  partcv[0] = 1;
  Object opresult3561 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3561 (depth = 4)
  *var_s = opresult3561;
  if (opresult3561 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3565 = gc_frame_new();
// call case 4: self request
  Object call3566 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3565);
// compiled member node returning call3566 (depth = 5)
  int op_slot_right_3564 = gc_frame_newslot(call3566);
// starting to compile identifier node (depth = 5)
  Object bool3568 = alloc_Boolean(0);
// compiled identifier node returning bool3568 (depth = 5)
  int op_slot_left_3564 = gc_frame_newslot(bool3568);
  params[0] = call3566;
  partcv[0] = 1;
  Object opresult3569 = callmethod(bool3568, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3569 (depth = 4)
  Object if3563 = done;
  if (istrue(opresult3569)) {
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3571 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3573 = alloc_Float64(2);
// compiled num node returning num3573 (depth = 8)
  int op_slot_right_3572 = gc_frame_newslot(num3573);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3572 = gc_frame_newslot(*var_depth);
  params[0] = num3573;
  partcv[0] = 1;
  Object sum3575 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3575 (depth = 7)
  gc_frame_newslot(sum3575);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3576 = gc_frame_new();
// call case 4: self request
  Object call3577 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3576);
// compiled member node returning call3577 (depth = 7)
  params[0] = sum3575;
  partcv[0] = 1;
  Object call3578 = callmethodflags(call3577, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3571);
// compiled call node returning call3578 (depth = 6)
  int op_slot_right_3570 = gc_frame_newslot(call3578);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3570 = gc_frame_newslot(*var_s);
  params[0] = call3578;
  partcv[0] = 1;
  Object opresult3580 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3580 (depth = 5)
  *var_s = opresult3580;
  if (opresult3580 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3563 = done;
  } else {
  }
// compiled if node returning if3563 (depth = 3)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_3594(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3596 == NULL) {
    strlit3596 = alloc_String("    ");
    gc_root(strlit3596);
  }
// compiled string node returning strlit3596 (depth = 7)
  int op_slot_right_3595 = gc_frame_newslot(strlit3596);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3595 = gc_frame_newslot(*var_spc);
  params[0] = strlit3596;
  partcv[0] = 1;
  Object opresult3598 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3598 (depth = 6)
  *var_spc = opresult3598;
  if (opresult3598 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_3582(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3583 == NULL) {
    strlit3583 = alloc_String("");
    gc_root(strlit3583);
  }
// compiled string node returning strlit3583 (depth = 4)
  *var_spc = strlit3583;
  if (strlit3583 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3584 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3587 = alloc_Float64(1);
// compiled num node returning num3587 (depth = 6)
  int op_slot_right_3586 = gc_frame_newslot(num3587);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3586 = gc_frame_newslot(*var_depth);
  params[0] = num3587;
  partcv[0] = 1;
  Object diff3589 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff3589 (depth = 5)
  int op_slot_right_3585 = gc_frame_newslot(diff3589);
// starting to compile num node (depth = 5)
  Object num3591 = alloc_Float64(0);
// compiled num node returning num3591 (depth = 5)
  int op_slot_left_3585 = gc_frame_newslot(num3591);
  params[0] = diff3589;
  partcv[0] = 1;
  Object opresult3592 = callmethod(num3591, "..(1)", 1, partcv, params);
// compiled op node returning opresult3592 (depth = 4)
  gc_frame_newslot(opresult3592);
// starting to compile block node (depth = 4)
  Object block3593 = alloc_Block(NULL, NULL, "ast", 814);
  gc_frame_newslot(block3593);
// method "_apply(_)"
  block_savedest(block3593);
  Object closure3594 = createclosure(2, "_apply(1)");
  setclosureframe(closure3594, stackframe);
  addtoclosure(closure3594, var_spc);
  addtoclosure(closure3594, selfslot);
  struct UserObject *uo3594 = (struct UserObject*)block3593;
  uo3594->data[0] = (Object)closure3594;
  Method *meth_meth_ast__apply_40_1_41_3594 = addmethod2pos(block3593, "_apply(1)", &meth_ast__apply_40_1_41_3594, 0);
  int argcv_meth_ast__apply_40_1_41_3594[] = {1};
  meth_meth_ast__apply_40_1_41_3594->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3594);
  meth_meth_ast__apply_40_1_41_3594->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3594->definitionLine = 2969;
// compiled block node returning block3593 (depth = 4)
  gc_frame_newslot(block3593);
// call case 5: prelude request
  params[0] = opresult3592;
  params[1] = block3593;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3601 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3584);
// compiled call node returning call3601 (depth = 3)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3602 == NULL) {
    strlit3602 = alloc_String("");
    gc_root(strlit3602);
  }
// compiled string node returning strlit3602 (depth = 4)
  *var_s = strlit3602;
  if (strlit3602 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3604 == NULL) {
    strlit3604 = alloc_String("");
    gc_root(strlit3604);
  }
// compiled string node returning strlit3604 (depth = 5)
  int op_slot_right_3603 = gc_frame_newslot(strlit3604);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3607 = gc_frame_new();
// call case 4: self request
  Object call3608 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3607);
// compiled member node returning call3608 (depth = 6)
  int op_slot_right_3606 = gc_frame_newslot(call3608);
// starting to compile string node (depth = 6)
  if (strlit3610 == NULL) {
    strlit3610 = alloc_String("type ");
    gc_root(strlit3610);
  }
// compiled string node returning strlit3610 (depth = 6)
  int op_slot_left_3606 = gc_frame_newslot(strlit3610);
  params[0] = call3608;
  partcv[0] = 1;
  Object opresult3611 = callmethod(strlit3610, "++(1)", 1, partcv, params);
// compiled op node returning opresult3611 (depth = 5)
  int op_slot_left_3603 = gc_frame_newslot(opresult3611);
  params[0] = strlit3604;
  partcv[0] = 1;
  Object opresult3612 = callmethod(opresult3611, "++(1)", 1, partcv, params);
// compiled op node returning opresult3612 (depth = 4)
  *var_s = opresult3612;
  if (opresult3612 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3616 = gc_frame_new();
// call case 4: self request
  Object call3617 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3616);
// compiled member node returning call3617 (depth = 5)
  int op_slot_right_3615 = gc_frame_newslot(call3617);
// starting to compile identifier node (depth = 5)
  Object bool3619 = alloc_Boolean(0);
// compiled identifier node returning bool3619 (depth = 5)
  int op_slot_left_3615 = gc_frame_newslot(bool3619);
  params[0] = call3617;
  partcv[0] = 1;
  Object opresult3620 = callmethod(bool3619, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3620 (depth = 4)
  Object if3614 = done;
  if (istrue(opresult3620)) {
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3621 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num3622 = alloc_Float64(0);
// compiled num node returning num3622 (depth = 5)
  gc_frame_newslot(num3622);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3623 = gc_frame_new();
// call case 4: self request
  Object call3624 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3623);
// compiled member node returning call3624 (depth = 5)
  params[0] = num3622;
  partcv[0] = 1;
  Object call3625 = callmethodflags(call3624, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3621);
// compiled call node returning call3625 (depth = 4)
    gc_frame_newslot(call3625);
    if3614 = call3625;
  } else {
  }
// compiled if node returning if3614 (depth = 3)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3627 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3629 = alloc_Float64(2);
// compiled num node returning num3629 (depth = 6)
  int op_slot_right_3628 = gc_frame_newslot(num3629);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3628 = gc_frame_newslot(*var_depth);
  params[0] = num3629;
  partcv[0] = 1;
  Object sum3631 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3631 (depth = 5)
  gc_frame_newslot(sum3631);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3632 = gc_frame_new();
// call case 4: self request
  Object call3633 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3632);
// compiled member node returning call3633 (depth = 5)
  params[0] = sum3631;
  partcv[0] = 1;
  Object call3634 = callmethodflags(call3633, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3627);
// compiled call node returning call3634 (depth = 4)
  int op_slot_right_3626 = gc_frame_newslot(call3634);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3637 == NULL) {
    strlit3637 = alloc_String(" = ");
    gc_root(strlit3637);
  }
// compiled string node returning strlit3637 (depth = 5)
  int op_slot_right_3636 = gc_frame_newslot(strlit3637);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3636 = gc_frame_newslot(*var_s);
  params[0] = strlit3637;
  partcv[0] = 1;
  Object opresult3639 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3639 (depth = 4)
  int op_slot_left_3626 = gc_frame_newslot(opresult3639);
  params[0] = call3634;
  partcv[0] = 1;
  Object opresult3640 = callmethod(opresult3639, "++(1)", 1, partcv, params);
// compiled op node returning opresult3640 (depth = 3)
  gc_frame_end(frame);
  return opresult3640;
}
Object meth_ast_shallowCopy3641(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3642 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3643 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3644 = gc_frame_new();
// call case 4: self request
  Object call3645 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3644);
// compiled member node returning call3645 (depth = 5)
  gc_frame_newslot(call3645);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeDecNode (depth = 5)
  params[0] = call3645;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call3646 = callmethodflags(*var_typeDecNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3643);
// compiled call node returning call3646 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3647 = callmethodflags(call3646, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3642);
// compiled call node returning call3647 (depth = 3)
  gc_frame_end(frame);
  return call3647;
}
Object meth_ast_new_40_2_41_3335(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3336 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3336 = alloc_userobj2(24,21, objclass3336);
  gc_frame_newslot(obj3336);
if (objclass3336 == NULL) {
  glfree(obj3336->class->name);
  obj3336->class->name = "typeDecNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3336, self, 0);
  addmethodreal(obj3336,"outer", &reader_ast_outer_3337);
  Object oldself3336 = self;
  struct StackFrameObject *oldstackframe3336 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3336);
  gc_frame_newslot((Object)stackframe);
  self = obj3336;
  Object *oldselfslot3336 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3336 = (*(struct UserObject *)self).data[0], lowerouter3336 = thisouter3336;
  if (inheritingObject3336) {
    struct UserObject *inho3336 = (struct UserObject *)inheritingObject3336;
    while (inho3336->super != GraceDefaultObject) inho3336 = (struct UserObject *)inho3336->super;
    inho3336->super = obj3336;
    self = inheritingObject3336;
    *selfslot = self;
    lowerouter3336 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3336;
  }
if (objclass3336 == NULL) {
  Method *reader3338 = addmethodrealflags(obj3336, "kind",&reader_ast_kind_3338, MFLAG_DEF);
  reader3338->definitionModule = modulename;
  reader3338->definitionLine = 748;
}
adddatum2(obj3336, alloc_Undefined(), 1);
if (objclass3336 == NULL) {
  Method *reader3339 = addmethodrealflags(obj3336, "name", &reader_ast_name_3339, 0);
  Method *writer3339 = addmethodrealflags(obj3336, "name:=(1)", &writer_ast_name_3339, 0);
  reader3339->definitionModule = modulename;
  writer3339->definitionModule = modulename;
  reader3339->definitionLine = 749;
  writer3339->definitionLine = 749;
}
obj3336->flags |= OFLAG_MUTABLE;
adddatum2(obj3336, alloc_Undefined(), 2);
if (objclass3336 == NULL) {
  Method *reader3340 = addmethodrealflags(obj3336, "value", &reader_ast_value_3340, 0);
  Method *writer3340 = addmethodrealflags(obj3336, "value:=(1)", &writer_ast_value_3340, 0);
  reader3340->definitionModule = modulename;
  writer3340->definitionModule = modulename;
  reader3340->definitionLine = 750;
  writer3340->definitionLine = 750;
}
obj3336->flags |= OFLAG_MUTABLE;
adddatum2(obj3336, alloc_Undefined(), 3);
if (objclass3336 == NULL) {
  Method *reader3341 = addmethodrealflags(obj3336, "nameString",&reader_ast_nameString_3341, MFLAG_DEF);
  reader3341->definitionModule = modulename;
  reader3341->definitionLine = 751;
}
adddatum2(obj3336, alloc_Undefined(), 4);
if (objclass3336 == NULL) {
  Method *reader3342 = addmethodrealflags(obj3336, "annotations", &reader_ast_annotations_3342, 0);
  Method *writer3342 = addmethodrealflags(obj3336, "annotations:=(1)", &writer_ast_annotations_3342, 0);
  reader3342->definitionModule = modulename;
  writer3342->definitionModule = modulename;
  reader3342->definitionLine = 752;
  writer3342->definitionLine = 752;
}
obj3336->flags |= OFLAG_MUTABLE;
adddatum2(obj3336, alloc_Undefined(), 5);
if (objclass3336 == NULL) {
  Method *reader3343 = addmethodrealflags(obj3336, "typeParams", &reader_ast_typeParams_3343, 0);
  Method *writer3343 = addmethodrealflags(obj3336, "typeParams:=(1)", &writer_ast_typeParams_3343, 0);
  reader3343->definitionModule = modulename;
  writer3343->definitionModule = modulename;
  reader3343->definitionLine = 753;
  writer3343->definitionLine = 753;
}
obj3336->flags |= OFLAG_MUTABLE;
adddatum2(obj3336, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo3344 = (struct UserObject*)obj3336;
  uo3344->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3344 = addmethod2pos(obj3336, "isLegalInTrait", &meth_ast_isLegalInTrait3344, 7);
  int argcv_meth_ast_isLegalInTrait3344[] = {0};
  meth_meth_ast_isLegalInTrait3344->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3344);
  meth_meth_ast_isLegalInTrait3344->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3344->definitionLine = 755;
// method "isTypeDec"
  struct UserObject *uo3346 = (struct UserObject*)obj3336;
  uo3346->data[8] = emptyclosure;
  Method *meth_meth_ast_isTypeDec3346 = addmethod2pos(obj3336, "isTypeDec", &meth_ast_isTypeDec3346, 8);
  int argcv_meth_ast_isTypeDec3346[] = {0};
  meth_meth_ast_isTypeDec3346->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec3346);
  meth_meth_ast_isTypeDec3346->definitionModule = modulename;
  meth_meth_ast_isTypeDec3346->definitionLine = 756;
// method "scope:=(_)"
  struct UserObject *uo3348 = (struct UserObject*)obj3336;
  uo3348->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_3348 = addmethod2pos(obj3336, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_3348, 9);
  int argcv_meth_ast_scope_58__61__40_1_41_3348[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_3348->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_3348);
  meth_meth_ast_scope_58__61__40_1_41_3348->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_3348->definitionLine = 757;
// method "isExecutable"
  struct UserObject *uo3353 = (struct UserObject*)obj3336;
  uo3353->data[10] = emptyclosure;
  Method *meth_meth_ast_isExecutable3353 = addmethod2pos(obj3336, "isExecutable", &meth_ast_isExecutable3353, 10);
  int argcv_meth_ast_isExecutable3353[] = {0};
  meth_meth_ast_isExecutable3353->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3353);
  meth_meth_ast_isExecutable3353->definitionModule = modulename;
  meth_meth_ast_isExecutable3353->definitionLine = 764;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3336);
  Object closure3355 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3355, stackframe);
  addtoclosure(closure3355, var_k);
  struct UserObject *uo3355 = (struct UserObject*)obj3336;
  uo3355->data[11] = (Object)closure3355;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3355 = addmethod2pos(obj3336, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3355, 11);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3355[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3355->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3355);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3355->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3355->definitionLine = 765;
// method "isConfidential"
  struct UserObject *uo3358 = (struct UserObject*)obj3336;
  uo3358->data[12] = emptyclosure;
  Method *meth_meth_ast_isConfidential3358 = addmethod2pos(obj3336, "isConfidential", &meth_ast_isConfidential3358, 12);
  int argcv_meth_ast_isConfidential3358[] = {0};
  meth_meth_ast_isConfidential3358->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3358);
  meth_meth_ast_isConfidential3358->definitionModule = modulename;
  meth_meth_ast_isConfidential3358->definitionLine = 766;
// method "isPublic"
  struct UserObject *uo3376 = (struct UserObject*)obj3336;
  uo3376->data[13] = emptyclosure;
  Method *meth_meth_ast_isPublic3376 = addmethod2pos(obj3336, "isPublic", &meth_ast_isPublic3376, 13);
  int argcv_meth_ast_isPublic3376[] = {0};
  meth_meth_ast_isPublic3376->type = alloc_MethodType(1, argcv_meth_ast_isPublic3376);
  meth_meth_ast_isPublic3376->definitionModule = modulename;
  meth_meth_ast_isPublic3376->definitionLine = 770;
// method "isWritable"
  struct UserObject *uo3381 = (struct UserObject*)obj3336;
  uo3381->data[14] = emptyclosure;
  Method *meth_meth_ast_isWritable3381 = addmethod2pos(obj3336, "isWritable", &meth_ast_isWritable3381, 14);
  int argcv_meth_ast_isWritable3381[] = {0};
  meth_meth_ast_isWritable3381->type = alloc_MethodType(1, argcv_meth_ast_isWritable3381);
  meth_meth_ast_isWritable3381->definitionModule = modulename;
  meth_meth_ast_isWritable3381->definitionLine = 771;
// method "isReadable"
  struct UserObject *uo3383 = (struct UserObject*)obj3336;
  uo3383->data[15] = emptyclosure;
  Method *meth_meth_ast_isReadable3383 = addmethod2pos(obj3336, "isReadable", &meth_ast_isReadable3383, 15);
  int argcv_meth_ast_isReadable3383[] = {0};
  meth_meth_ast_isReadable3383->type = alloc_MethodType(1, argcv_meth_ast_isReadable3383);
  meth_meth_ast_isReadable3383->definitionModule = modulename;
  meth_meth_ast_isReadable3383->definitionLine = 772;
// method "accept(_)from(_)"
  struct UserObject *uo3386 = (struct UserObject*)obj3336;
  uo3386->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3386 = addmethod2pos(obj3336, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3386, 16);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3386[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3386->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3386);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3386->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3386->definitionLine = 774;
// method "map(_)ancestors(_)"
  struct UserObject *uo3420 = (struct UserObject*)obj3336;
  uo3420->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_3420 = addmethod2pos(obj3336, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_3420, 17);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3420[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3420->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3420);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3420->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3420->definitionLine = 785;
// method "pretty(_)"
  struct UserObject *uo3459 = (struct UserObject*)obj3336;
  uo3459->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_3459 = addmethod2pos(obj3336, "pretty(1)", &meth_ast_pretty_40_1_41_3459, 18);
  int argcv_meth_ast_pretty_40_1_41_3459[] = {1};
  meth_meth_ast_pretty_40_1_41_3459->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_3459);
  meth_meth_ast_pretty_40_1_41_3459->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_3459->definitionLine = 794;
// method "toGrace(_)"
  struct UserObject *uo3582 = (struct UserObject*)obj3336;
  uo3582->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_3582 = addmethod2pos(obj3336, "toGrace(1)", &meth_ast_toGrace_40_1_41_3582, 19);
  int argcv_meth_ast_toGrace_40_1_41_3582[] = {1};
  meth_meth_ast_toGrace_40_1_41_3582->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_3582);
meth_meth_ast_toGrace_40_1_41_3582->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_3582->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_3582->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_3582->definitionLine = 812;
// method "shallowCopy"
  block_savedest(obj3336);
  Object closure3641 = createclosure(2, "shallowCopy");
  setclosureframe(closure3641, stackframe);
  addtoclosure(closure3641, var_nullNode);
  addtoclosure(closure3641, var_typeDecNode);
  struct UserObject *uo3641 = (struct UserObject*)obj3336;
  uo3641->data[20] = (Object)closure3641;
  Method *meth_meth_ast_shallowCopy3641 = addmethod2pos(obj3336, "shallowCopy", &meth_ast_shallowCopy3641, 20);
  int argcv_meth_ast_shallowCopy3641[] = {0};
  meth_meth_ast_shallowCopy3641->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3641);
  meth_meth_ast_shallowCopy3641->definitionModule = modulename;
  meth_meth_ast_shallowCopy3641->definitionLine = 824;
  sourceObject = obj3336;
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3648 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3649 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3650 = gc_frame_new();
// call case 3: self.outer request
  Object call3651 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3650);
// compiled member node returning call3651 (depth = 5)
  Object call3652 = callmethodflags(call3651, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3649);
// compiled member node returning call3652 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3653 = callmethodflags(call3652, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3648);
// compiled call node returning call3653 (depth = 3)
  struct UserObject *obj3336_uo = (struct UserObject *)obj3336;
  obj3336_uo->super = call3653;
  sourceObject = obj3336;
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3654 == NULL) {
    strlit3654 = alloc_String("typedec");
    gc_root(strlit3654);
  }
// compiled string node returning strlit3654 (depth = 3)
  adddatum2(obj3336, strlit3654, 1);
  sourceObject = obj3336;
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3336, *var_name_39_, 2);
  sourceObject = obj3336;
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3336, *var_typeValue, 3);
  sourceObject = obj3336;
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3655 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3656 = gc_frame_new();
// call case 4: self request
  Object call3657 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3656);
// compiled member node returning call3657 (depth = 4)
  Object call3658 = callmethodflags(call3657, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3655);
// compiled member node returning call3658 (depth = 3)
  adddatum2(obj3336, call3658, 4);
  sourceObject = obj3336;
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3659 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3659 (depth = 3)
  adddatum2(obj3336, array3659, 5);
  sourceObject = obj3336;
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3660 = alloc_Boolean(0);
// compiled identifier node returning bool3660 (depth = 3)
  adddatum2(obj3336, bool3660, 6);
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  objclass3336 = obj3336->class;
  objclass3336->definitionModule = modulename;
  objclass3336->definitionLine = 746;
  (*(struct UserObject *)self).data[0] = lowerouter3336;
  self = oldself3336;
  selfslot = oldselfslot3336;
  stackframe = oldstackframe3336;
  gc_frame_end(frame);
  return obj3336;
}
Object meth_ast_new_40_2_41_3335_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3336 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3336 = alloc_userobj2(24,21, objclass3336);
  gc_frame_newslot(obj3336);
if (objclass3336 == NULL) {
  glfree(obj3336->class->name);
  obj3336->class->name = "typeDecNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3336, self, 0);
  addmethodreal(obj3336,"outer", &reader_ast_outer_3337);
  Object oldself3336 = self;
  struct StackFrameObject *oldstackframe3336 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3336);
  gc_frame_newslot((Object)stackframe);
  self = obj3336;
  Object *oldselfslot3336 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3336 = (*(struct UserObject *)self).data[0], lowerouter3336 = thisouter3336;
  if (inheritingObject3336) {
    struct UserObject *inho3336 = (struct UserObject *)inheritingObject3336;
    while (inho3336->super != GraceDefaultObject) inho3336 = (struct UserObject *)inho3336->super;
    inho3336->super = obj3336;
    self = inheritingObject3336;
    *selfslot = self;
    lowerouter3336 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3336;
  }
if (objclass3336 == NULL) {
  Method *reader3338 = addmethodrealflags(obj3336, "kind",&reader_ast_kind_3338, MFLAG_DEF);
  reader3338->definitionModule = modulename;
  reader3338->definitionLine = 748;
}
adddatum2(obj3336, alloc_Undefined(), 1);
if (objclass3336 == NULL) {
  Method *reader3339 = addmethodrealflags(obj3336, "name", &reader_ast_name_3339, 0);
  Method *writer3339 = addmethodrealflags(obj3336, "name:=(1)", &writer_ast_name_3339, 0);
  reader3339->definitionModule = modulename;
  writer3339->definitionModule = modulename;
  reader3339->definitionLine = 749;
  writer3339->definitionLine = 749;
}
obj3336->flags |= OFLAG_MUTABLE;
adddatum2(obj3336, alloc_Undefined(), 2);
if (objclass3336 == NULL) {
  Method *reader3340 = addmethodrealflags(obj3336, "value", &reader_ast_value_3340, 0);
  Method *writer3340 = addmethodrealflags(obj3336, "value:=(1)", &writer_ast_value_3340, 0);
  reader3340->definitionModule = modulename;
  writer3340->definitionModule = modulename;
  reader3340->definitionLine = 750;
  writer3340->definitionLine = 750;
}
obj3336->flags |= OFLAG_MUTABLE;
adddatum2(obj3336, alloc_Undefined(), 3);
if (objclass3336 == NULL) {
  Method *reader3341 = addmethodrealflags(obj3336, "nameString",&reader_ast_nameString_3341, MFLAG_DEF);
  reader3341->definitionModule = modulename;
  reader3341->definitionLine = 751;
}
adddatum2(obj3336, alloc_Undefined(), 4);
if (objclass3336 == NULL) {
  Method *reader3342 = addmethodrealflags(obj3336, "annotations", &reader_ast_annotations_3342, 0);
  Method *writer3342 = addmethodrealflags(obj3336, "annotations:=(1)", &writer_ast_annotations_3342, 0);
  reader3342->definitionModule = modulename;
  writer3342->definitionModule = modulename;
  reader3342->definitionLine = 752;
  writer3342->definitionLine = 752;
}
obj3336->flags |= OFLAG_MUTABLE;
adddatum2(obj3336, alloc_Undefined(), 5);
if (objclass3336 == NULL) {
  Method *reader3343 = addmethodrealflags(obj3336, "typeParams", &reader_ast_typeParams_3343, 0);
  Method *writer3343 = addmethodrealflags(obj3336, "typeParams:=(1)", &writer_ast_typeParams_3343, 0);
  reader3343->definitionModule = modulename;
  writer3343->definitionModule = modulename;
  reader3343->definitionLine = 753;
  writer3343->definitionLine = 753;
}
obj3336->flags |= OFLAG_MUTABLE;
adddatum2(obj3336, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo3344 = (struct UserObject*)obj3336;
  uo3344->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3344 = addmethod2pos(obj3336, "isLegalInTrait", &meth_ast_isLegalInTrait3344, 7);
  int argcv_meth_ast_isLegalInTrait3344[] = {0};
  meth_meth_ast_isLegalInTrait3344->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3344);
  meth_meth_ast_isLegalInTrait3344->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3344->definitionLine = 755;
// method "isTypeDec"
  struct UserObject *uo3346 = (struct UserObject*)obj3336;
  uo3346->data[8] = emptyclosure;
  Method *meth_meth_ast_isTypeDec3346 = addmethod2pos(obj3336, "isTypeDec", &meth_ast_isTypeDec3346, 8);
  int argcv_meth_ast_isTypeDec3346[] = {0};
  meth_meth_ast_isTypeDec3346->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec3346);
  meth_meth_ast_isTypeDec3346->definitionModule = modulename;
  meth_meth_ast_isTypeDec3346->definitionLine = 756;
// method "scope:=(_)"
  struct UserObject *uo3348 = (struct UserObject*)obj3336;
  uo3348->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_3348 = addmethod2pos(obj3336, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_3348, 9);
  int argcv_meth_ast_scope_58__61__40_1_41_3348[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_3348->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_3348);
  meth_meth_ast_scope_58__61__40_1_41_3348->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_3348->definitionLine = 757;
// method "isExecutable"
  struct UserObject *uo3353 = (struct UserObject*)obj3336;
  uo3353->data[10] = emptyclosure;
  Method *meth_meth_ast_isExecutable3353 = addmethod2pos(obj3336, "isExecutable", &meth_ast_isExecutable3353, 10);
  int argcv_meth_ast_isExecutable3353[] = {0};
  meth_meth_ast_isExecutable3353->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3353);
  meth_meth_ast_isExecutable3353->definitionModule = modulename;
  meth_meth_ast_isExecutable3353->definitionLine = 764;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3336);
  Object closure3355 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3355, stackframe);
  addtoclosure(closure3355, var_k);
  struct UserObject *uo3355 = (struct UserObject*)obj3336;
  uo3355->data[11] = (Object)closure3355;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3355 = addmethod2pos(obj3336, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3355, 11);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3355[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3355->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3355);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3355->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3355->definitionLine = 765;
// method "isConfidential"
  struct UserObject *uo3358 = (struct UserObject*)obj3336;
  uo3358->data[12] = emptyclosure;
  Method *meth_meth_ast_isConfidential3358 = addmethod2pos(obj3336, "isConfidential", &meth_ast_isConfidential3358, 12);
  int argcv_meth_ast_isConfidential3358[] = {0};
  meth_meth_ast_isConfidential3358->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3358);
  meth_meth_ast_isConfidential3358->definitionModule = modulename;
  meth_meth_ast_isConfidential3358->definitionLine = 766;
// method "isPublic"
  struct UserObject *uo3376 = (struct UserObject*)obj3336;
  uo3376->data[13] = emptyclosure;
  Method *meth_meth_ast_isPublic3376 = addmethod2pos(obj3336, "isPublic", &meth_ast_isPublic3376, 13);
  int argcv_meth_ast_isPublic3376[] = {0};
  meth_meth_ast_isPublic3376->type = alloc_MethodType(1, argcv_meth_ast_isPublic3376);
  meth_meth_ast_isPublic3376->definitionModule = modulename;
  meth_meth_ast_isPublic3376->definitionLine = 770;
// method "isWritable"
  struct UserObject *uo3381 = (struct UserObject*)obj3336;
  uo3381->data[14] = emptyclosure;
  Method *meth_meth_ast_isWritable3381 = addmethod2pos(obj3336, "isWritable", &meth_ast_isWritable3381, 14);
  int argcv_meth_ast_isWritable3381[] = {0};
  meth_meth_ast_isWritable3381->type = alloc_MethodType(1, argcv_meth_ast_isWritable3381);
  meth_meth_ast_isWritable3381->definitionModule = modulename;
  meth_meth_ast_isWritable3381->definitionLine = 771;
// method "isReadable"
  struct UserObject *uo3383 = (struct UserObject*)obj3336;
  uo3383->data[15] = emptyclosure;
  Method *meth_meth_ast_isReadable3383 = addmethod2pos(obj3336, "isReadable", &meth_ast_isReadable3383, 15);
  int argcv_meth_ast_isReadable3383[] = {0};
  meth_meth_ast_isReadable3383->type = alloc_MethodType(1, argcv_meth_ast_isReadable3383);
  meth_meth_ast_isReadable3383->definitionModule = modulename;
  meth_meth_ast_isReadable3383->definitionLine = 772;
// method "accept(_)from(_)"
  struct UserObject *uo3386 = (struct UserObject*)obj3336;
  uo3386->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3386 = addmethod2pos(obj3336, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3386, 16);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3386[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3386->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3386);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3386->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3386->definitionLine = 774;
// method "map(_)ancestors(_)"
  struct UserObject *uo3420 = (struct UserObject*)obj3336;
  uo3420->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_3420 = addmethod2pos(obj3336, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_3420, 17);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3420[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3420->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3420);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3420->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3420->definitionLine = 785;
// method "pretty(_)"
  struct UserObject *uo3459 = (struct UserObject*)obj3336;
  uo3459->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_3459 = addmethod2pos(obj3336, "pretty(1)", &meth_ast_pretty_40_1_41_3459, 18);
  int argcv_meth_ast_pretty_40_1_41_3459[] = {1};
  meth_meth_ast_pretty_40_1_41_3459->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_3459);
  meth_meth_ast_pretty_40_1_41_3459->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_3459->definitionLine = 794;
// method "toGrace(_)"
  struct UserObject *uo3582 = (struct UserObject*)obj3336;
  uo3582->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_3582 = addmethod2pos(obj3336, "toGrace(1)", &meth_ast_toGrace_40_1_41_3582, 19);
  int argcv_meth_ast_toGrace_40_1_41_3582[] = {1};
  meth_meth_ast_toGrace_40_1_41_3582->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_3582);
meth_meth_ast_toGrace_40_1_41_3582->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_3582->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_3582->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_3582->definitionLine = 812;
// method "shallowCopy"
  block_savedest(obj3336);
  Object closure3641 = createclosure(2, "shallowCopy");
  setclosureframe(closure3641, stackframe);
  addtoclosure(closure3641, var_nullNode);
  addtoclosure(closure3641, var_typeDecNode);
  struct UserObject *uo3641 = (struct UserObject*)obj3336;
  uo3641->data[20] = (Object)closure3641;
  Method *meth_meth_ast_shallowCopy3641 = addmethod2pos(obj3336, "shallowCopy", &meth_ast_shallowCopy3641, 20);
  int argcv_meth_ast_shallowCopy3641[] = {0};
  meth_meth_ast_shallowCopy3641->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3641);
  meth_meth_ast_shallowCopy3641->definitionModule = modulename;
  meth_meth_ast_shallowCopy3641->definitionLine = 824;
  sourceObject = obj3336;
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3648 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3649 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3650 = gc_frame_new();
// call case 3: self.outer request
  Object call3651 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3650);
// compiled member node returning call3651 (depth = 5)
  Object call3652 = callmethodflags(call3651, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3649);
// compiled member node returning call3652 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3653 = callmethodflags(call3652, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3648);
// compiled call node returning call3653 (depth = 3)
  struct UserObject *obj3336_uo = (struct UserObject *)obj3336;
  obj3336_uo->super = call3653;
  sourceObject = obj3336;
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3654 == NULL) {
    strlit3654 = alloc_String("typedec");
    gc_root(strlit3654);
  }
// compiled string node returning strlit3654 (depth = 3)
  adddatum2(obj3336, strlit3654, 1);
  sourceObject = obj3336;
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3336, *var_name_39_, 2);
  sourceObject = obj3336;
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3336, *var_typeValue, 3);
  sourceObject = obj3336;
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3655 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3656 = gc_frame_new();
// call case 4: self request
  Object call3657 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3656);
// compiled member node returning call3657 (depth = 4)
  Object call3658 = callmethodflags(call3657, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3655);
// compiled member node returning call3658 (depth = 3)
  adddatum2(obj3336, call3658, 4);
  sourceObject = obj3336;
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3659 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3659 (depth = 3)
  adddatum2(obj3336, array3659, 5);
  sourceObject = obj3336;
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3660 = alloc_Boolean(0);
// compiled identifier node returning bool3660 (depth = 3)
  adddatum2(obj3336, bool3660, 6);
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  sourceObject = obj3336;
  objclass3336 = obj3336->class;
  objclass3336->definitionModule = modulename;
  objclass3336->definitionLine = 746;
  (*(struct UserObject *)self).data[0] = lowerouter3336;
  self = oldself3336;
  selfslot = oldselfslot3336;
  stackframe = oldstackframe3336;
  gc_frame_end(frame);
  return obj3336;
}
Object meth_ast_typeDecNode3662(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeDecNode;
}
Object meth_ast_new_40_3_41_scope_40_1_41_3665(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(3)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_signature = &(stackframe->slots[0]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_body = &(stackframe->slots[1]);
  *var_body = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[2]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3666 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_signature;
  params[1] = *var_body;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call3667 = callmethodflags(self, "new(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3666);
// compiled call node returning call3667 (depth = 4)
  *var_result = call3667;
  if (call3667 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3668 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call3669 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3668);
// compiled call node returning call3669 (depth = 3)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_appliedOccurence3684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "appliedOccurence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3685 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3686 = alloc_Boolean(0);
// compiled identifier node returning bool3686 (depth = 4)
  gc_frame_newslot(bool3686);
// call case 4: self request
  params[0] = bool3686;
  partcv[0] = 1;
  Object call3687 = callmethodflags(self, "isBindingOccurence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3685);
// compiled call node returning call3687 (depth = 3)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3690 = gc_frame_new();
// call case 4: self request
  Object call3691 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3690);
// compiled member node returning call3691 (depth = 5)
  int op_slot_right_3689 = gc_frame_newslot(call3691);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_3689 = gc_frame_newslot(*var_uninitialized);
  params[0] = call3691;
  partcv[0] = 1;
  Object opresult3693 = callmethod(*var_uninitialized, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3693 (depth = 4)
  Object if3688 = done;
  if (istrue(opresult3693)) {
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3694 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool3695 = alloc_Boolean(0);
// compiled identifier node returning bool3695 (depth = 5)
  gc_frame_newslot(bool3695);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3696 = gc_frame_new();
// call case 4: self request
  Object call3697 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3696);
// compiled member node returning call3697 (depth = 5)
  params[0] = bool3695;
  partcv[0] = 1;
  Object call3698 = callmethodflags(call3697, "isBindingOccurence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3694);
// compiled call node returning call3698 (depth = 4)
    gc_frame_newslot(call3698);
    if3688 = call3698;
  } else {
  }
// compiled if node returning if3688 (depth = 3)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply_40_2_41_3702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3704 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  Object call3705 = callmethodflags(*var_p, "numParams", 0, partcv, params, 0);
  gc_frame_end(callframe3704);
// compiled member node returning call3705 (depth = 6)
  int op_slot_right_3703 = gc_frame_newslot(call3705);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_3703 = gc_frame_newslot(*var_acc);
  params[0] = call3705;
  partcv[0] = 1;
  Object sum3707 = callmethod(*var_acc, "+(1)", 1, partcv, params);
// compiled op node returning sum3707 (depth = 5)
  gc_frame_end(frame);
  return sum3707;
}
Object meth_ast_numParams3699(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3700 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3701 = alloc_Block(NULL, NULL, "ast", 866);
  gc_frame_newslot(block3701);
// method "_apply(_,_)"
  block_savedest(block3701);
  Object closure3702 = createclosure(1, "_apply(2)");
  setclosureframe(closure3702, stackframe);
  addtoclosure(closure3702, selfslot);
  struct UserObject *uo3702 = (struct UserObject*)block3701;
  uo3702->data[0] = (Object)closure3702;
  Method *meth_meth_ast__apply_40_2_41_3702 = addmethod2pos(block3701, "_apply(2)", &meth_ast__apply_40_2_41_3702, 0);
  int argcv_meth_ast__apply_40_2_41_3702[] = {2};
  meth_meth_ast__apply_40_2_41_3702->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_3702);
  meth_meth_ast__apply_40_2_41_3702->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_3702->definitionLine = 2969;
// compiled block node returning block3701 (depth = 4)
  gc_frame_newslot(block3701);
// starting to compile num node (depth = 4)
  Object num3709 = alloc_Float64(0);
// compiled num node returning num3709 (depth = 4)
  gc_frame_newslot(num3709);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3710 = gc_frame_new();
// call case 4: self request
  Object call3711 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3710);
// compiled member node returning call3711 (depth = 4)
  params[0] = block3701;
  params[1] = num3709;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3712 = callmethodflags(call3711, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3700);
// compiled call node returning call3712 (depth = 3)
  gc_frame_end(frame);
  return call3712;
}
Object meth_ast_endPos3713(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "endPos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lastPart = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lastPart");
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3714 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3715 = gc_frame_new();
// call case 4: self request
  Object call3716 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3715);
// compiled member node returning call3716 (depth = 5)
  Object call3717 = callmethodflags(call3716, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3714);
// compiled member node returning call3717 (depth = 4)
  *var_lastPart = call3717;
  if (call3717 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3719 = alloc_Float64(1);
// compiled num node returning num3719 (depth = 4)
  int op_slot_right_3718 = gc_frame_newslot(num3719);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3722 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3723 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastPart (depth = 7)
  Object call3724 = callmethodflags(*var_lastPart, "name", 0, partcv, params, 0);
  gc_frame_end(callframe3723);
// compiled member node returning call3724 (depth = 6)
  Object call3725 = callmethodflags(call3724, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3722);
// compiled member node returning call3725 (depth = 5)
  int op_slot_right_3721 = gc_frame_newslot(call3725);
// starting to compile member node (depth = 5)
  int callframe3727 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastPart (depth = 6)
  Object call3728 = callmethodflags(*var_lastPart, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3727);
// compiled member node returning call3728 (depth = 5)
  int op_slot_left_3721 = gc_frame_newslot(call3728);
  params[0] = call3725;
  partcv[0] = 1;
  Object sum3729 = callmethod(call3728, "+(1)", 1, partcv, params);
// compiled op node returning sum3729 (depth = 4)
  int op_slot_left_3718 = gc_frame_newslot(sum3729);
  params[0] = num3719;
  partcv[0] = 1;
  Object diff3730 = callmethod(sum3729, "-(1)", 1, partcv, params);
// compiled op node returning diff3730 (depth = 3)
  gc_frame_end(frame);
  return diff3730;
}
Object meth_ast__apply_40_2_41_3734(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3736 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call3737 = callmethodflags(*var_each, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe3736);
// compiled member node returning call3737 (depth = 6)
  int op_slot_right_3735 = gc_frame_newslot(call3737);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_3735 = gc_frame_newslot(*var_acc);
  params[0] = call3737;
  partcv[0] = 1;
  Object opresult3739 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3739 (depth = 5)
  gc_frame_end(frame);
  return opresult3739;
}
Object meth_ast_nameString3731(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3732 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3733 = alloc_Block(NULL, NULL, "ast", 874);
  gc_frame_newslot(block3733);
// method "_apply(_,_)"
  block_savedest(block3733);
  Object closure3734 = createclosure(1, "_apply(2)");
  setclosureframe(closure3734, stackframe);
  addtoclosure(closure3734, selfslot);
  struct UserObject *uo3734 = (struct UserObject*)block3733;
  uo3734->data[0] = (Object)closure3734;
  Method *meth_meth_ast__apply_40_2_41_3734 = addmethod2pos(block3733, "_apply(2)", &meth_ast__apply_40_2_41_3734, 0);
  int argcv_meth_ast__apply_40_2_41_3734[] = {2};
  meth_meth_ast__apply_40_2_41_3734->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_3734);
  meth_meth_ast__apply_40_2_41_3734->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_3734->definitionLine = 2969;
// compiled block node returning block3733 (depth = 4)
  gc_frame_newslot(block3733);
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3741 == NULL) {
    strlit3741 = alloc_String("");
    gc_root(strlit3741);
  }
// compiled string node returning strlit3741 (depth = 4)
  gc_frame_newslot(strlit3741);
// call case 6: other requests
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3742 = gc_frame_new();
// call case 4: self request
  Object call3743 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3742);
// compiled member node returning call3743 (depth = 4)
  params[0] = block3733;
  params[1] = strlit3741;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3744 = callmethodflags(call3743, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3732);
// compiled call node returning call3744 (depth = 3)
  gc_frame_end(frame);
  return call3744;
}
Object meth_ast_asIdentifier3745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3748 = gc_frame_new();
// call case 4: self request
  Object call3749 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3748);
// compiled member node returning call3749 (depth = 5)
  int op_slot_right_3747 = gc_frame_newslot(call3749);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_3747 = gc_frame_newslot(*var_uninitialized);
  params[0] = call3749;
  partcv[0] = 1;
  Object opresult3751 = callmethod(*var_uninitialized, "==(1)", 1, partcv, params);
// compiled op node returning opresult3751 (depth = 4)
  Object if3746 = done;
  if (istrue(opresult3751)) {
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3752 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe3753 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3754 = gc_frame_new();
// call case 4: self request
  Object call3755 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3754);
// compiled member node returning call3755 (depth = 6)
  gc_frame_newslot(call3755);
// starting to compile identifier node (depth = 6)
  Object bool3756 = alloc_Boolean(0);
// compiled identifier node returning bool3756 (depth = 6)
  gc_frame_newslot(bool3756);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call3755;
  params[1] = bool3756;
  partcv[0] = 2;
  Object call3757 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3753);
// compiled call node returning call3757 (depth = 5)
  gc_frame_newslot(call3757);
// call case 4: self request
  params[0] = call3757;
  partcv[0] = 1;
  Object call3758 = callmethodflags(self, "cachedIdentifier:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3752);
// compiled call node returning call3758 (depth = 4)
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3759 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3760 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3761 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3762 = gc_frame_new();
// call case 4: self request
  Object call3763 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3762);
// compiled member node returning call3763 (depth = 7)
  Object call3764 = callmethodflags(call3763, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3761);
// compiled member node returning call3764 (depth = 6)
  Object call3765 = callmethodflags(call3764, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3760);
// compiled member node returning call3765 (depth = 5)
  gc_frame_newslot(call3765);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3766 = gc_frame_new();
// call case 4: self request
  Object call3767 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3766);
// compiled member node returning call3767 (depth = 5)
  params[0] = call3765;
  partcv[0] = 1;
  Object call3768 = callmethodflags(call3767, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3759);
// compiled call node returning call3768 (depth = 4)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3769 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3770 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3771 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3772 = gc_frame_new();
// call case 4: self request
  Object call3773 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3772);
// compiled member node returning call3773 (depth = 7)
  Object call3774 = callmethodflags(call3773, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3771);
// compiled member node returning call3774 (depth = 6)
  Object call3775 = callmethodflags(call3774, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3770);
// compiled member node returning call3775 (depth = 5)
  gc_frame_newslot(call3775);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3776 = gc_frame_new();
// call case 4: self request
  Object call3777 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3776);
// compiled member node returning call3777 (depth = 5)
  params[0] = call3775;
  partcv[0] = 1;
  Object call3778 = callmethodflags(call3777, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3769);
// compiled call node returning call3778 (depth = 4)
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3779 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3780 = gc_frame_new();
// call case 4: self request
  Object call3781 = callmethodflags(self, "isBindingOccurence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3780);
// compiled member node returning call3781 (depth = 5)
  gc_frame_newslot(call3781);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3782 = gc_frame_new();
// call case 4: self request
  Object call3783 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3782);
// compiled member node returning call3783 (depth = 5)
  params[0] = call3781;
  partcv[0] = 1;
  Object call3784 = callmethodflags(call3783, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3779);
// compiled call node returning call3784 (depth = 4)
    gc_frame_newslot(call3784);
    if3746 = call3784;
  } else {
  }
// compiled if node returning if3746 (depth = 3)
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3785 = gc_frame_new();
// call case 4: self request
  Object call3786 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3785);
// compiled member node returning call3786 (depth = 3)
  gc_frame_end(frame);
  return call3786;
}
Object meth_ast_value3787(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3788 = gc_frame_new();
// call case 4: self request
  Object call3789 = callmethodflags(self, "asIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3788);
// compiled member node returning call3789 (depth = 3)
  gc_frame_end(frame);
  return call3789;
}
Object meth_ast__apply_40_2_41_3793(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3795 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call3796 = callmethodflags(*var_each, "canonicalName", 0, partcv, params, 0);
  gc_frame_end(callframe3795);
// compiled member node returning call3796 (depth = 6)
  int op_slot_right_3794 = gc_frame_newslot(call3796);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_3794 = gc_frame_newslot(*var_acc);
  params[0] = call3796;
  partcv[0] = 1;
  Object opresult3798 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3798 (depth = 5)
  gc_frame_end(frame);
  return opresult3798;
}
Object meth_ast_canonicalName3790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3791 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3792 = alloc_Block(NULL, NULL, "ast", 888);
  gc_frame_newslot(block3792);
// method "_apply(_,_)"
  block_savedest(block3792);
  Object closure3793 = createclosure(1, "_apply(2)");
  setclosureframe(closure3793, stackframe);
  addtoclosure(closure3793, selfslot);
  struct UserObject *uo3793 = (struct UserObject*)block3792;
  uo3793->data[0] = (Object)closure3793;
  Method *meth_meth_ast__apply_40_2_41_3793 = addmethod2pos(block3792, "_apply(2)", &meth_ast__apply_40_2_41_3793, 0);
  int argcv_meth_ast__apply_40_2_41_3793[] = {2};
  meth_meth_ast__apply_40_2_41_3793->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_3793);
  meth_meth_ast__apply_40_2_41_3793->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_3793->definitionLine = 2969;
// compiled block node returning block3792 (depth = 4)
  gc_frame_newslot(block3792);
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3800 == NULL) {
    strlit3800 = alloc_String("");
    gc_root(strlit3800);
  }
// compiled string node returning strlit3800 (depth = 4)
  gc_frame_newslot(strlit3800);
// call case 6: other requests
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3801 = gc_frame_new();
// call case 4: self request
  Object call3802 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3801);
// compiled member node returning call3802 (depth = 4)
  params[0] = block3792;
  params[1] = strlit3800;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3803 = callmethodflags(call3802, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3791);
// compiled call node returning call3803 (depth = 3)
  gc_frame_end(frame);
  return call3803;
}
Object meth_ast_hasParams3804(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3805 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3806 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3807 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3808 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3809 = gc_frame_new();
// call case 4: self request
  Object call3810 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3809);
// compiled member node returning call3810 (depth = 7)
  Object call3811 = callmethodflags(call3810, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3808);
// compiled member node returning call3811 (depth = 6)
  Object call3812 = callmethodflags(call3811, "params", 0, partcv, params, 0);
  gc_frame_end(callframe3807);
// compiled member node returning call3812 (depth = 5)
  Object call3813 = callmethodflags(call3812, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe3806);
// compiled member node returning call3813 (depth = 4)
  Object call3814 = callmethodflags(call3813, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3805);
// compiled member node returning call3814 (depth = 3)
  gc_frame_end(frame);
  return call3814;
}
Object meth_ast_numParamLists3815(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParamLists");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sigSz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sigSz");
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3816 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3817 = gc_frame_new();
// call case 4: self request
  Object call3818 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3817);
// compiled member node returning call3818 (depth = 5)
  Object call3819 = callmethodflags(call3818, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3816);
// compiled member node returning call3819 (depth = 4)
  *var_sigSz = call3819;
  if (call3819 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3822 = alloc_Float64(1);
// compiled num node returning num3822 (depth = 5)
  int op_slot_right_3821 = gc_frame_newslot(num3822);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sigSz (depth = 5)
  int op_slot_left_3821 = gc_frame_newslot(*var_sigSz);
  params[0] = num3822;
  partcv[0] = 1;
  Object opresult3824 = callmethod(*var_sigSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult3824 (depth = 4)
  Object if3820 = done;
  if (istrue(opresult3824)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sigSz (depth = 5)
  return *var_sigSz;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3820 = undefined;
  } else {
  }
// compiled if node returning if3820 (depth = 3)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3826 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3827 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3828 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3829 = gc_frame_new();
// call case 4: self request
  Object call3830 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3829);
// compiled member node returning call3830 (depth = 7)
  Object call3831 = callmethodflags(call3830, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3828);
// compiled member node returning call3831 (depth = 6)
  Object call3832 = callmethodflags(call3831, "params", 0, partcv, params, 0);
  gc_frame_end(callframe3827);
// compiled member node returning call3832 (depth = 5)
  Object call3833 = callmethodflags(call3832, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe3826);
// compiled member node returning call3833 (depth = 4)
  Object if3825 = done;
  if (istrue(call3833)) {
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3834 = alloc_Float64(0);
// compiled num node returning num3834 (depth = 5)
  return num3834;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3825 = undefined;
  } else {
  }
// compiled if node returning if3825 (depth = 3)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3835 = alloc_Float64(1);
// compiled num node returning num3835 (depth = 4)
  return num3835;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_hasTypeParams3836(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasTypeParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3838 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3839 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3840 = gc_frame_new();
// call case 4: self request
  Object call3841 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3840);
// compiled member node returning call3841 (depth = 6)
  Object call3842 = callmethodflags(call3841, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3839);
// compiled member node returning call3842 (depth = 5)
  Object call3843 = callmethodflags(call3842, "typeParams", 0, partcv, params, 0);
  gc_frame_end(callframe3838);
// compiled member node returning call3843 (depth = 4)
  int op_slot_right_3837 = gc_frame_newslot(call3843);
// starting to compile identifier node (depth = 4)
  Object bool3845 = alloc_Boolean(0);
// compiled identifier node returning bool3845 (depth = 4)
  int op_slot_left_3837 = gc_frame_newslot(bool3845);
  params[0] = call3843;
  partcv[0] = 1;
  Object opresult3846 = callmethod(bool3845, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3846 (depth = 3)
  gc_frame_end(frame);
  return opresult3846;
}
Object meth_ast_isMethod3847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3848 = alloc_Boolean(1);
// compiled identifier node returning bool3848 (depth = 3)
  gc_frame_end(frame);
  return bool3848;
}
Object meth_ast_isExecutable3849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3850 = alloc_Boolean(0);
// compiled identifier node returning bool3850 (depth = 3)
  gc_frame_end(frame);
  return bool3850;
}
Object meth_ast_isLegalInTrait3851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3852 = alloc_Boolean(1);
// compiled identifier node returning bool3852 (depth = 3)
  gc_frame_end(frame);
  return bool3852;
}
Object meth_ast_isClass3853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3855 = gc_frame_new();
// call case 4: self request
  Object call3856 = callmethodflags(self, "usesClassSyntax", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3855);
// compiled member node returning call3856 (depth = 4)
  int op_slot_right_3854 = gc_frame_newslot(call3856);
// starting to compile member node (depth = 4)
  int callframe3858 = gc_frame_new();
// call case 4: self request
  Object call3859 = callmethodflags(self, "isFresh", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3858);
// compiled member node returning call3859 (depth = 4)
  int op_slot_left_3854 = gc_frame_newslot(call3859);
  params[0] = call3856;
  partcv[0] = 1;
  Object opresult3860 = callmethod(call3859, "||(1)", 1, partcv, params);
// compiled op node returning opresult3860 (depth = 3)
  gc_frame_end(frame);
  return opresult3860;
}
Object meth_ast_isTrait3861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3863 = gc_frame_new();
// call case 4: self request
  Object call3864 = callmethodflags(self, "isFresh", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3863);
// compiled member node returning call3864 (depth = 4)
  Object if3862 = done;
  if (istrue(call3864)) {
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3865 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3866 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3867 = gc_frame_new();
// call case 4: self request
  Object call3868 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3867);
// compiled member node returning call3868 (depth = 6)
  Object call3869 = callmethodflags(call3868, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3866);
// compiled member node returning call3869 (depth = 5)
  Object call3870 = callmethodflags(call3869, "isTrait", 0, partcv, params, 0);
  gc_frame_end(callframe3865);
// compiled member node returning call3870 (depth = 4)
    gc_frame_newslot(call3870);
    if3862 = call3870;
  } else {
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3871 = alloc_Boolean(0);
// compiled identifier node returning bool3871 (depth = 4)
    gc_frame_newslot(bool3871);
    if3862 = bool3871;
  }
// compiled if node returning if3862 (depth = 3)
  gc_frame_end(frame);
  return if3862;
}
Object meth_ast__apply3882(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3884 == NULL) {
    strlit3884 = alloc_String("Unknown");
    gc_root(strlit3884);
  }
// compiled string node returning strlit3884 (depth = 11)
  int op_slot_right_3883 = gc_frame_newslot(strlit3884);
// starting to compile member node (depth = 11)
  int callframe3886 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe3887 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_p (depth = 13)
  Object call3888 = callmethodflags(*var_p, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe3887);
// compiled member node returning call3888 (depth = 12)
  Object call3889 = callmethodflags(call3888, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe3886);
// compiled member node returning call3889 (depth = 11)
  int op_slot_left_3883 = gc_frame_newslot(call3889);
  params[0] = strlit3884;
  partcv[0] = 1;
  Object opresult3890 = callmethod(call3889, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3890 (depth = 10)
  gc_frame_end(frame);
  return opresult3890;
}
Object meth_ast__apply_40_1_41_3878(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block3881 = alloc_Block(NULL, NULL, "ast", 915);
  gc_frame_newslot(block3881);
// method "_apply"
  block_savedest(block3881);
  Object closure3882 = createclosure(2, "_apply");
  setclosureframe(closure3882, stackframe);
  addtoclosure(closure3882, var_p);
  addtoclosure(closure3882, selfslot);
  struct UserObject *uo3882 = (struct UserObject*)block3881;
  uo3882->data[0] = (Object)closure3882;
  Method *meth_meth_ast__apply3882 = addmethod2pos(block3881, "_apply", &meth_ast__apply3882, 0);
  int argcv_meth_ast__apply3882[] = {0};
  meth_meth_ast__apply3882->type = alloc_MethodType(1, argcv_meth_ast__apply3882);
  meth_meth_ast__apply3882->definitionModule = modulename;
  meth_meth_ast__apply3882->definitionLine = 2969;
// compiled block node returning block3881 (depth = 9)
  int op_slot_right_3880 = gc_frame_newslot(block3881);
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe3894 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  Object call3895 = callmethodflags(*var_p, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe3894);
// compiled member node returning call3895 (depth = 10)
  int op_slot_right_3893 = gc_frame_newslot(call3895);
// starting to compile identifier node (depth = 10)
  Object bool3897 = alloc_Boolean(0);
// compiled identifier node returning bool3897 (depth = 10)
  int op_slot_left_3893 = gc_frame_newslot(bool3897);
  params[0] = call3895;
  partcv[0] = 1;
  Object opresult3898 = callmethod(bool3897, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3898 (depth = 9)
  int op_slot_left_3880 = gc_frame_newslot(opresult3898);
  params[0] = block3881;
  partcv[0] = 1;
  Object opresult3899 = callmethod(opresult3898, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3899 (depth = 8)
  Object if3879 = done;
  if (istrue(opresult3899)) {
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool3900 = alloc_Boolean(1);
// compiled identifier node returning bool3900 (depth = 9)
  block_return(realself, bool3900);
// compiled return node returning undefined (depth = 8)
    gc_frame_newslot(undefined);
    if3879 = undefined;
  } else {
  }
// compiled if node returning if3879 (depth = 7)
  gc_frame_end(frame);
  return if3879;
}
Object meth_ast__apply_40_1_41_3875(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3876 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3877 = alloc_Block(NULL, NULL, "ast", 914);
  gc_frame_newslot(block3877);
// method "_apply(_)"
  block_savedest(block3877);
  Object closure3878 = createclosure(1, "_apply(1)");
  setclosureframe(closure3878, stackframe);
  addtoclosure(closure3878, selfslot);
  struct UserObject *uo3878 = (struct UserObject*)block3877;
  uo3878->data[0] = (Object)closure3878;
  Method *meth_meth_ast__apply_40_1_41_3878 = addmethod2pos(block3877, "_apply(1)", &meth_ast__apply_40_1_41_3878, 0);
  int argcv_meth_ast__apply_40_1_41_3878[] = {1};
  meth_meth_ast__apply_40_1_41_3878->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3878);
  meth_meth_ast__apply_40_1_41_3878->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3878->definitionLine = 2969;
// compiled block node returning block3877 (depth = 6)
  gc_frame_newslot(block3877);
// call case 6: other requests
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3902 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call3903 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe3902);
// compiled member node returning call3903 (depth = 6)
  params[0] = block3877;
  partcv[0] = 1;
  Object call3904 = callmethodflags(call3903, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3876);
// compiled call node returning call3904 (depth = 5)
  gc_frame_end(frame);
  return call3904;
}
Object meth_ast_needsArgChecks3872(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "needsArgChecks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3873 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3874 = alloc_Block(NULL, NULL, "ast", 913);
  gc_frame_newslot(block3874);
// method "_apply(_)"
  block_savedest(block3874);
  Object closure3875 = createclosure(1, "_apply(1)");
  setclosureframe(closure3875, stackframe);
  addtoclosure(closure3875, selfslot);
  struct UserObject *uo3875 = (struct UserObject*)block3874;
  uo3875->data[0] = (Object)closure3875;
  Method *meth_meth_ast__apply_40_1_41_3875 = addmethod2pos(block3874, "_apply(1)", &meth_ast__apply_40_1_41_3875, 0);
  int argcv_meth_ast__apply_40_1_41_3875[] = {1};
  meth_meth_ast__apply_40_1_41_3875->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3875);
  meth_meth_ast__apply_40_1_41_3875->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3875->definitionLine = 2969;
// compiled block node returning block3874 (depth = 4)
  gc_frame_newslot(block3874);
// call case 6: other requests
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3906 = gc_frame_new();
// call case 4: self request
  Object call3907 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3906);
// compiled member node returning call3907 (depth = 4)
  params[0] = block3874;
  partcv[0] = 1;
  Object call3908 = callmethodflags(call3907, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3873);
// compiled call node returning call3908 (depth = 3)
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3909 = alloc_Boolean(0);
// compiled identifier node returning bool3909 (depth = 4)
  return bool3909;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_scope_58__61__40_1_41_3910(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3911 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3912 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3911);
// compiled call node returning call3912 (depth = 3)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3913 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3914 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3913);
// compiled call node returning call3914 (depth = 3)
  gc_frame_end(frame);
  return call3914;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_3915(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3916 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call3917 = callmethodflags(*var_k, "parameter", 0, partcv, params, 0);
  gc_frame_end(callframe3916);
// compiled member node returning call3917 (depth = 3)
  gc_frame_end(frame);
  return call3917;
}
Object meth_ast_isConfidential3918(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3921 = alloc_Float64(0);
// compiled num node returning num3921 (depth = 5)
  int op_slot_right_3920 = gc_frame_newslot(num3921);
// starting to compile member node (depth = 5)
  int callframe3923 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3924 = gc_frame_new();
// call case 4: self request
  Object call3925 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3924);
// compiled member node returning call3925 (depth = 6)
  Object call3926 = callmethodflags(call3925, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3923);
// compiled member node returning call3926 (depth = 5)
  int op_slot_left_3920 = gc_frame_newslot(call3926);
  params[0] = num3921;
  partcv[0] = 1;
  Object opresult3927 = callmethod(call3926, "==(1)", 1, partcv, params);
// compiled op node returning opresult3927 (depth = 4)
  Object if3919 = done;
  if (istrue(opresult3927)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3928 = alloc_Boolean(0);
// compiled identifier node returning bool3928 (depth = 5)
  return bool3928;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3919 = undefined;
  } else {
  }
// compiled if node returning if3919 (depth = 3)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3929 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3930 == NULL) {
    strlit3930 = alloc_String("confidential");
    gc_root(strlit3930);
  }
// compiled string node returning strlit3930 (depth = 4)
  gc_frame_newslot(strlit3930);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3931 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3932 = gc_frame_new();
// call case 3: self.outer request
  Object call3933 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3932);
// compiled member node returning call3933 (depth = 5)
  Object call3934 = callmethodflags(call3933, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3931);
// compiled member node returning call3934 (depth = 4)
  params[0] = self;
  params[1] = strlit3930;
  partcv[0] = 2;
  Object call3935 = callmethodflags(call3934, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3929);
// compiled call node returning call3935 (depth = 3)
  gc_frame_end(frame);
  return call3935;
}
Object meth_ast_isPublic3936(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3937 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3938 = gc_frame_new();
// call case 4: self request
  Object call3939 = callmethodflags(self, "isConfidential", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3938);
// compiled member node returning call3939 (depth = 4)
  Object call3940 = callmethodflags(call3939, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3937);
// compiled member node returning call3940 (depth = 3)
  gc_frame_end(frame);
  return call3940;
}
Object meth_ast_isWritable3941(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3942 = alloc_Boolean(0);
// compiled identifier node returning bool3942 (depth = 3)
  gc_frame_end(frame);
  return bool3942;
}
Object meth_ast_isReadable3943(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3944 = gc_frame_new();
// call case 4: self request
  Object call3945 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3944);
// compiled member node returning call3945 (depth = 3)
  gc_frame_end(frame);
  return call3945;
}
Object meth_ast_usesAsType_40_1_41_3946(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3948 = gc_frame_new();
// call case 4: self request
  Object call3949 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3948);
// compiled member node returning call3949 (depth = 4)
  int op_slot_right_3947 = gc_frame_newslot(call3949);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_3947 = gc_frame_newslot(*var_aNode);
  params[0] = call3949;
  partcv[0] = 1;
  Object opresult3951 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult3951 (depth = 3)
  gc_frame_end(frame);
  return opresult3951;
}
Object meth_ast__apply3955(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe3956 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3957 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3958 = gc_frame_new();
// call case 4: self request
  Object call3959 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3958);
// compiled member node returning call3959 (depth = 7)
  Object call3960 = callmethodflags(call3959, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3957);
// compiled member node returning call3960 (depth = 6)
  Object call3961 = callmethodflags(call3960, "returnsObject", 0, partcv, params, 0);
  gc_frame_end(callframe3956);
// compiled member node returning call3961 (depth = 5)
  gc_frame_end(frame);
  return call3961;
}
Object meth_ast_returnsObject3952(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block3954 = alloc_Block(NULL, NULL, "ast", 941);
  gc_frame_newslot(block3954);
// method "_apply"
  block_savedest(block3954);
  Object closure3955 = createclosure(1, "_apply");
  setclosureframe(closure3955, stackframe);
  addtoclosure(closure3955, selfslot);
  struct UserObject *uo3955 = (struct UserObject*)block3954;
  uo3955->data[0] = (Object)closure3955;
  Method *meth_meth_ast__apply3955 = addmethod2pos(block3954, "_apply", &meth_ast__apply3955, 0);
  int argcv_meth_ast__apply3955[] = {0};
  meth_meth_ast__apply3955->type = alloc_MethodType(1, argcv_meth_ast__apply3955);
  meth_meth_ast__apply3955->definitionModule = modulename;
  meth_meth_ast__apply3955->definitionLine = 2969;
// compiled block node returning block3954 (depth = 4)
  int op_slot_right_3953 = gc_frame_newslot(block3954);
// starting to compile member node (depth = 4)
  int callframe3964 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3965 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3966 = gc_frame_new();
// call case 4: self request
  Object call3967 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3966);
// compiled member node returning call3967 (depth = 6)
  Object call3968 = callmethodflags(call3967, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe3965);
// compiled member node returning call3968 (depth = 5)
  Object call3969 = callmethodflags(call3968, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3964);
// compiled member node returning call3969 (depth = 4)
  int op_slot_left_3953 = gc_frame_newslot(call3969);
  params[0] = block3954;
  partcv[0] = 1;
  Object opresult3970 = callmethod(call3969, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3970 (depth = 3)
  gc_frame_end(frame);
  return opresult3970;
}
Object meth_ast_returnedObjectScope3971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3972 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3973 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3974 = gc_frame_new();
// call case 4: self request
  Object call3975 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3974);
// compiled member node returning call3975 (depth = 5)
  Object call3976 = callmethodflags(call3975, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3973);
// compiled member node returning call3976 (depth = 4)
  Object call3977 = callmethodflags(call3976, "returnedObjectScope", 0, partcv, params, 0);
  gc_frame_end(callframe3972);
// compiled member node returning call3977 (depth = 3)
  gc_frame_end(frame);
  return call3977;
}
Object meth_ast__apply_40_1_41_4008(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4009 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4010 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4009);
// compiled call node returning call4010 (depth = 8)
  gc_frame_end(frame);
  return call4010;
}
Object meth_ast__apply_40_1_41_4003(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4004 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4005 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call4006 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4005);
// compiled member node returning call4006 (depth = 7)
  gc_frame_newslot(call4006);
// starting to compile block node (depth = 7)
  Object block4007 = alloc_Block(NULL, NULL, "ast", 955);
  gc_frame_newslot(block4007);
// method "_apply(_)"
  block_savedest(block4007);
  Object closure4008 = createclosure(3, "_apply(1)");
  setclosureframe(closure4008, stackframe);
  addtoclosure(closure4008, var_visitor);
  addtoclosure(closure4008, var_newChain);
  addtoclosure(closure4008, selfslot);
  struct UserObject *uo4008 = (struct UserObject*)block4007;
  uo4008->data[0] = (Object)closure4008;
  Method *meth_meth_ast__apply_40_1_41_4008 = addmethod2pos(block4007, "_apply(1)", &meth_ast__apply_40_1_41_4008, 0);
  int argcv_meth_ast__apply_40_1_41_4008[] = {1};
  meth_meth_ast__apply_40_1_41_4008->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4008);
  meth_meth_ast__apply_40_1_41_4008->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4008->definitionLine = 2969;
// compiled block node returning block4007 (depth = 7)
  gc_frame_newslot(block4007);
// call case 5: prelude request
  params[0] = call4006;
  params[1] = block4007;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4012 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4004);
// compiled call node returning call4012 (depth = 6)
  gc_frame_end(frame);
  return call4012;
}
Object meth_ast__apply_40_1_41_4030(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4031 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4032 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4031);
// compiled call node returning call4032 (depth = 6)
  gc_frame_end(frame);
  return call4032;
}
Object meth_ast__apply_40_1_41_4039(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4040 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4041 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4040);
// compiled call node returning call4041 (depth = 6)
  gc_frame_end(frame);
  return call4041;
}
Object meth_ast_accept_40_1_41_from_40_1_41_3978(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3980 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3981 = callmethodflags(*var_visitor, "visitMethod(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3980);
// compiled call node returning call3981 (depth = 4)
  Object if3979 = done;
  if (istrue(call3981)) {
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3982 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3983 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3982);
// compiled call node returning call3983 (depth = 5)
  *var_newChain = call3983;
  if (call3983 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3984 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3985 = gc_frame_new();
// call case 4: self request
  Object call3986 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3985);
// compiled member node returning call3986 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3987 = callmethodflags(call3986, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3984);
// compiled call node returning call3987 (depth = 4)
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3990 = gc_frame_new();
// call case 4: self request
  Object call3991 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3990);
// compiled member node returning call3991 (depth = 6)
  int op_slot_right_3989 = gc_frame_newslot(call3991);
// starting to compile identifier node (depth = 6)
  Object bool3993 = alloc_Boolean(0);
// compiled identifier node returning bool3993 (depth = 6)
  int op_slot_left_3989 = gc_frame_newslot(bool3993);
  params[0] = call3991;
  partcv[0] = 1;
  Object opresult3994 = callmethod(bool3993, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3994 (depth = 5)
  Object if3988 = done;
  if (istrue(opresult3994)) {
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3995 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3996 = gc_frame_new();
// call case 4: self request
  Object call3997 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3996);
// compiled member node returning call3997 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3998 = callmethodflags(call3997, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3995);
// compiled call node returning call3998 (depth = 5)
    gc_frame_newslot(call3998);
    if3988 = call3998;
  } else {
  }
// compiled if node returning if3988 (depth = 4)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3999 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4000 = gc_frame_new();
// call case 4: self request
  Object call4001 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4000);
// compiled member node returning call4001 (depth = 5)
  gc_frame_newslot(call4001);
// starting to compile block node (depth = 5)
  Object block4002 = alloc_Block(NULL, NULL, "ast", 954);
  gc_frame_newslot(block4002);
// method "_apply(_)"
  block_savedest(block4002);
  Object closure4003 = createclosure(3, "_apply(1)");
  setclosureframe(closure4003, stackframe);
  addtoclosure(closure4003, var_visitor);
  addtoclosure(closure4003, var_newChain);
  addtoclosure(closure4003, selfslot);
  struct UserObject *uo4003 = (struct UserObject*)block4002;
  uo4003->data[0] = (Object)closure4003;
  Method *meth_meth_ast__apply_40_1_41_4003 = addmethod2pos(block4002, "_apply(1)", &meth_ast__apply_40_1_41_4003, 0);
  int argcv_meth_ast__apply_40_1_41_4003[] = {1};
  meth_meth_ast__apply_40_1_41_4003->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4003);
  meth_meth_ast__apply_40_1_41_4003->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4003->definitionLine = 2969;
// compiled block node returning block4002 (depth = 5)
  gc_frame_newslot(block4002);
// call case 5: prelude request
  params[0] = call4001;
  params[1] = block4002;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4014 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3999);
// compiled call node returning call4014 (depth = 4)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4017 = gc_frame_new();
// call case 4: self request
  Object call4018 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4017);
// compiled member node returning call4018 (depth = 6)
  int op_slot_right_4016 = gc_frame_newslot(call4018);
// starting to compile identifier node (depth = 6)
  Object bool4020 = alloc_Boolean(0);
// compiled identifier node returning bool4020 (depth = 6)
  int op_slot_left_4016 = gc_frame_newslot(bool4020);
  params[0] = call4018;
  partcv[0] = 1;
  Object opresult4021 = callmethod(bool4020, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4021 (depth = 5)
  Object if4015 = done;
  if (istrue(opresult4021)) {
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4022 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4023 = gc_frame_new();
// call case 4: self request
  Object call4024 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4023);
// compiled member node returning call4024 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4025 = callmethodflags(call4024, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4022);
// compiled call node returning call4025 (depth = 5)
    gc_frame_newslot(call4025);
    if4015 = call4025;
  } else {
  }
// compiled if node returning if4015 (depth = 4)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4026 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4027 = gc_frame_new();
// call case 4: self request
  Object call4028 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4027);
// compiled member node returning call4028 (depth = 5)
  gc_frame_newslot(call4028);
// starting to compile block node (depth = 5)
  Object block4029 = alloc_Block(NULL, NULL, "ast", 962);
  gc_frame_newslot(block4029);
// method "_apply(_)"
  block_savedest(block4029);
  Object closure4030 = createclosure(3, "_apply(1)");
  setclosureframe(closure4030, stackframe);
  addtoclosure(closure4030, var_visitor);
  addtoclosure(closure4030, var_newChain);
  addtoclosure(closure4030, selfslot);
  struct UserObject *uo4030 = (struct UserObject*)block4029;
  uo4030->data[0] = (Object)closure4030;
  Method *meth_meth_ast__apply_40_1_41_4030 = addmethod2pos(block4029, "_apply(1)", &meth_ast__apply_40_1_41_4030, 0);
  int argcv_meth_ast__apply_40_1_41_4030[] = {1};
  meth_meth_ast__apply_40_1_41_4030->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4030);
  meth_meth_ast__apply_40_1_41_4030->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4030->definitionLine = 2969;
// compiled block node returning block4029 (depth = 5)
  gc_frame_newslot(block4029);
// call case 5: prelude request
  params[0] = call4028;
  params[1] = block4029;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4034 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4026);
// compiled call node returning call4034 (depth = 4)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4035 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4036 = gc_frame_new();
// call case 4: self request
  Object call4037 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4036);
// compiled member node returning call4037 (depth = 5)
  gc_frame_newslot(call4037);
// starting to compile block node (depth = 5)
  Object block4038 = alloc_Block(NULL, NULL, "ast", 965);
  gc_frame_newslot(block4038);
// method "_apply(_)"
  block_savedest(block4038);
  Object closure4039 = createclosure(3, "_apply(1)");
  setclosureframe(closure4039, stackframe);
  addtoclosure(closure4039, var_visitor);
  addtoclosure(closure4039, var_newChain);
  addtoclosure(closure4039, selfslot);
  struct UserObject *uo4039 = (struct UserObject*)block4038;
  uo4039->data[0] = (Object)closure4039;
  Method *meth_meth_ast__apply_40_1_41_4039 = addmethod2pos(block4038, "_apply(1)", &meth_ast__apply_40_1_41_4039, 0);
  int argcv_meth_ast__apply_40_1_41_4039[] = {1};
  meth_meth_ast__apply_40_1_41_4039->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4039);
  meth_meth_ast__apply_40_1_41_4039->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4039->definitionLine = 2969;
// compiled block node returning block4038 (depth = 5)
  gc_frame_newslot(block4038);
// call case 5: prelude request
  params[0] = call4037;
  params[1] = block4038;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4043 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4035);
// compiled call node returning call4043 (depth = 4)
    gc_frame_newslot(call4043);
    if3979 = call4043;
  } else {
  }
// compiled if node returning if3979 (depth = 3)
  gc_frame_end(frame);
  return if3979;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_4044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4045 = gc_frame_new();
// call case 4: self request
  Object call4046 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4045);
// compiled member node returning call4046 (depth = 4)
  *var_n = call4046;
  if (call4046 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4047 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4048 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4047);
// compiled call node returning call4048 (depth = 4)
  *var_newChain = call4048;
  if (call4048 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4049 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4050 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4051 = gc_frame_new();
// call case 4: self request
  Object call4052 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4051);
// compiled member node returning call4052 (depth = 5)
  gc_frame_newslot(call4052);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4053 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4054 = gc_frame_new();
// call case 3: self.outer request
  Object call4055 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4054);
// compiled member node returning call4055 (depth = 6)
  Object call4056 = callmethodflags(call4055, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4053);
// compiled member node returning call4056 (depth = 5)
  params[0] = call4052;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4057 = callmethodflags(call4056, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4050);
// compiled call node returning call4057 (depth = 4)
  gc_frame_newslot(call4057);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4057;
  partcv[0] = 1;
  Object call4058 = callmethodflags(*var_n, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4049);
// compiled call node returning call4058 (depth = 3)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4059 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4060 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4061 = gc_frame_new();
// call case 4: self request
  Object call4062 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4061);
// compiled member node returning call4062 (depth = 5)
  gc_frame_newslot(call4062);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4063 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4064 = gc_frame_new();
// call case 3: self.outer request
  Object call4065 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4064);
// compiled member node returning call4065 (depth = 6)
  Object call4066 = callmethodflags(call4065, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4063);
// compiled member node returning call4066 (depth = 5)
  params[0] = call4062;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4067 = callmethodflags(call4066, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4060);
// compiled call node returning call4067 (depth = 4)
  gc_frame_newslot(call4067);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4067;
  partcv[0] = 1;
  Object call4068 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4059);
// compiled call node returning call4068 (depth = 3)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4069 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4070 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4071 = gc_frame_new();
// call case 4: self request
  Object call4072 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4071);
// compiled member node returning call4072 (depth = 5)
  gc_frame_newslot(call4072);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4073 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4074 = gc_frame_new();
// call case 3: self.outer request
  Object call4075 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4074);
// compiled member node returning call4075 (depth = 6)
  Object call4076 = callmethodflags(call4075, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4073);
// compiled member node returning call4076 (depth = 5)
  params[0] = call4072;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4077 = callmethodflags(call4076, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4070);
// compiled call node returning call4077 (depth = 4)
  gc_frame_newslot(call4077);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4077;
  partcv[0] = 1;
  Object call4078 = callmethodflags(*var_n, "signature:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4069);
// compiled call node returning call4078 (depth = 3)
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4079 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4080 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4081 = gc_frame_new();
// call case 4: self request
  Object call4082 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4081);
// compiled member node returning call4082 (depth = 5)
  gc_frame_newslot(call4082);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4083 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4084 = gc_frame_new();
// call case 3: self.outer request
  Object call4085 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4084);
// compiled member node returning call4085 (depth = 6)
  Object call4086 = callmethodflags(call4085, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4083);
// compiled member node returning call4086 (depth = 5)
  params[0] = call4082;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4087 = callmethodflags(call4086, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4080);
// compiled call node returning call4087 (depth = 4)
  gc_frame_newslot(call4087);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4087;
  partcv[0] = 1;
  Object call4088 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4079);
// compiled call node returning call4088 (depth = 3)
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4089 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4090 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4091 = gc_frame_new();
// call case 4: self request
  Object call4092 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4091);
// compiled member node returning call4092 (depth = 5)
  gc_frame_newslot(call4092);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4093 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4094 = gc_frame_new();
// call case 3: self.outer request
  Object call4095 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4094);
// compiled member node returning call4095 (depth = 6)
  Object call4096 = callmethodflags(call4095, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4093);
// compiled member node returning call4096 (depth = 5)
  params[0] = call4092;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4097 = callmethodflags(call4096, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4090);
// compiled call node returning call4097 (depth = 4)
  gc_frame_newslot(call4097);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4097;
  partcv[0] = 1;
  Object call4098 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4089);
// compiled call node returning call4098 (depth = 3)
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4099 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call4100 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4099);
// compiled call node returning call4100 (depth = 3)
  gc_frame_end(frame);
  return call4100;
}
Object meth_ast__apply_40_1_41_4109(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4111 == NULL) {
    strlit4111 = alloc_String("  ");
    gc_root(strlit4111);
  }
// compiled string node returning strlit4111 (depth = 7)
  int op_slot_right_4110 = gc_frame_newslot(strlit4111);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4110 = gc_frame_newslot(*var_spc);
  params[0] = strlit4111;
  partcv[0] = 1;
  Object opresult4113 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4113 (depth = 6)
  *var_spc = opresult4113;
  if (opresult4113 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_4274(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4276 == NULL) {
    strlit4276 = alloc_String("");
    gc_root(strlit4276);
  }
// compiled string node returning strlit4276 (depth = 9)
  int op_slot_right_4275 = gc_frame_newslot(strlit4276);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4279 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4281 = alloc_Float64(4);
// compiled num node returning num4281 (depth = 12)
  int op_slot_right_4280 = gc_frame_newslot(num4281);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4280 = gc_frame_newslot(*var_depth);
  params[0] = num4281;
  partcv[0] = 1;
  Object sum4283 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4283 (depth = 11)
  gc_frame_newslot(sum4283);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4283;
  partcv[0] = 1;
  Object call4284 = callmethodflags(*var_p, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4279);
// compiled call node returning call4284 (depth = 10)
  int op_slot_right_4278 = gc_frame_newslot(call4284);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4287 == NULL) {
    strlit4287 = alloc_String("");
    gc_root(strlit4287);
  }
// compiled string node returning strlit4287 (depth = 11)
  int op_slot_right_4286 = gc_frame_newslot(strlit4287);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_4289 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit4292 == NULL) {
    strlit4292 = alloc_String("""\x0a""      ");
    gc_root(strlit4292);
  }
// compiled string node returning strlit4292 (depth = 13)
  int op_slot_right_4291 = gc_frame_newslot(strlit4292);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_4294 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit4296 == NULL) {
    strlit4296 = alloc_String("");
    gc_root(strlit4296);
  }
// compiled string node returning strlit4296 (depth = 14)
  int op_slot_left_4294 = gc_frame_newslot(strlit4296);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4297 = callmethod(strlit4296, "++(1)", 1, partcv, params);
// compiled op node returning opresult4297 (depth = 13)
  int op_slot_left_4291 = gc_frame_newslot(opresult4297);
  params[0] = strlit4292;
  partcv[0] = 1;
  Object opresult4298 = callmethod(opresult4297, "++(1)", 1, partcv, params);
// compiled op node returning opresult4298 (depth = 12)
  int op_slot_left_4289 = gc_frame_newslot(opresult4298);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4299 = callmethod(opresult4298, "++(1)", 1, partcv, params);
// compiled op node returning opresult4299 (depth = 11)
  int op_slot_left_4286 = gc_frame_newslot(opresult4299);
  params[0] = strlit4287;
  partcv[0] = 1;
  Object opresult4300 = callmethod(opresult4299, "++(1)", 1, partcv, params);
// compiled op node returning opresult4300 (depth = 10)
  int op_slot_left_4278 = gc_frame_newslot(opresult4300);
  params[0] = call4284;
  partcv[0] = 1;
  Object opresult4301 = callmethod(opresult4300, "++(1)", 1, partcv, params);
// compiled op node returning opresult4301 (depth = 9)
  int op_slot_left_4275 = gc_frame_newslot(opresult4301);
  params[0] = strlit4276;
  partcv[0] = 1;
  Object opresult4302 = callmethod(opresult4301, "++(1)", 1, partcv, params);
// compiled op node returning opresult4302 (depth = 8)
  *var_s = opresult4302;
  if (opresult4302 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_4228(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4230 == NULL) {
    strlit4230 = alloc_String("");
    gc_root(strlit4230);
  }
// compiled string node returning strlit4230 (depth = 7)
  int op_slot_right_4229 = gc_frame_newslot(strlit4230);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4233 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  Object call4234 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe4233);
// compiled member node returning call4234 (depth = 8)
  int op_slot_right_4232 = gc_frame_newslot(call4234);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4237 == NULL) {
    strlit4237 = alloc_String("Part: ");
    gc_root(strlit4237);
  }
// compiled string node returning strlit4237 (depth = 9)
  int op_slot_right_4236 = gc_frame_newslot(strlit4237);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4239 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4242 == NULL) {
    strlit4242 = alloc_String("""\x0a""  ");
    gc_root(strlit4242);
  }
// compiled string node returning strlit4242 (depth = 11)
  int op_slot_right_4241 = gc_frame_newslot(strlit4242);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_4244 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit4246 == NULL) {
    strlit4246 = alloc_String("");
    gc_root(strlit4246);
  }
// compiled string node returning strlit4246 (depth = 12)
  int op_slot_left_4244 = gc_frame_newslot(strlit4246);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4247 = callmethod(strlit4246, "++(1)", 1, partcv, params);
// compiled op node returning opresult4247 (depth = 11)
  int op_slot_left_4241 = gc_frame_newslot(opresult4247);
  params[0] = strlit4242;
  partcv[0] = 1;
  Object opresult4248 = callmethod(opresult4247, "++(1)", 1, partcv, params);
// compiled op node returning opresult4248 (depth = 10)
  int op_slot_left_4239 = gc_frame_newslot(opresult4248);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4249 = callmethod(opresult4248, "++(1)", 1, partcv, params);
// compiled op node returning opresult4249 (depth = 9)
  int op_slot_left_4236 = gc_frame_newslot(opresult4249);
  params[0] = strlit4237;
  partcv[0] = 1;
  Object opresult4250 = callmethod(opresult4249, "++(1)", 1, partcv, params);
// compiled op node returning opresult4250 (depth = 8)
  int op_slot_left_4232 = gc_frame_newslot(opresult4250);
  params[0] = call4234;
  partcv[0] = 1;
  Object opresult4251 = callmethod(opresult4250, "++(1)", 1, partcv, params);
// compiled op node returning opresult4251 (depth = 7)
  int op_slot_left_4229 = gc_frame_newslot(opresult4251);
  params[0] = strlit4230;
  partcv[0] = 1;
  Object opresult4252 = callmethod(opresult4251, "++(1)", 1, partcv, params);
// compiled op node returning opresult4252 (depth = 6)
  *var_s = opresult4252;
  if (opresult4252 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4255 == NULL) {
    strlit4255 = alloc_String("Parameters:");
    gc_root(strlit4255);
  }
// compiled string node returning strlit4255 (depth = 7)
  int op_slot_right_4254 = gc_frame_newslot(strlit4255);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4257 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4260 == NULL) {
    strlit4260 = alloc_String("""\x0a""    ");
    gc_root(strlit4260);
  }
// compiled string node returning strlit4260 (depth = 9)
  int op_slot_right_4259 = gc_frame_newslot(strlit4260);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_4262 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit4264 == NULL) {
    strlit4264 = alloc_String("");
    gc_root(strlit4264);
  }
// compiled string node returning strlit4264 (depth = 10)
  int op_slot_left_4262 = gc_frame_newslot(strlit4264);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4265 = callmethod(strlit4264, "++(1)", 1, partcv, params);
// compiled op node returning opresult4265 (depth = 9)
  int op_slot_left_4259 = gc_frame_newslot(opresult4265);
  params[0] = strlit4260;
  partcv[0] = 1;
  Object opresult4266 = callmethod(opresult4265, "++(1)", 1, partcv, params);
// compiled op node returning opresult4266 (depth = 8)
  int op_slot_left_4257 = gc_frame_newslot(opresult4266);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4267 = callmethod(opresult4266, "++(1)", 1, partcv, params);
// compiled op node returning opresult4267 (depth = 7)
  int op_slot_left_4254 = gc_frame_newslot(opresult4267);
  params[0] = strlit4255;
  partcv[0] = 1;
  Object opresult4268 = callmethod(opresult4267, "++(1)", 1, partcv, params);
// compiled op node returning opresult4268 (depth = 6)
  *var_s = opresult4268;
  if (opresult4268 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4270 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4271 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call4272 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4271);
// compiled member node returning call4272 (depth = 6)
  gc_frame_newslot(call4272);
// starting to compile block node (depth = 6)
  Object block4273 = alloc_Block(NULL, NULL, "ast", 997);
  gc_frame_newslot(block4273);
// method "_apply(_)"
  block_savedest(block4273);
  Object closure4274 = createclosure(4, "_apply(1)");
  setclosureframe(closure4274, stackframe);
  addtoclosure(closure4274, var_depth);
  addtoclosure(closure4274, var_spc);
  addtoclosure(closure4274, var_s);
  addtoclosure(closure4274, selfslot);
  struct UserObject *uo4274 = (struct UserObject*)block4273;
  uo4274->data[0] = (Object)closure4274;
  Method *meth_meth_ast__apply_40_1_41_4274 = addmethod2pos(block4273, "_apply(1)", &meth_ast__apply_40_1_41_4274, 0);
  int argcv_meth_ast__apply_40_1_41_4274[] = {1};
  meth_meth_ast__apply_40_1_41_4274->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4274);
  meth_meth_ast__apply_40_1_41_4274->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4274->definitionLine = 2969;
// compiled block node returning block4273 (depth = 6)
  gc_frame_newslot(block4273);
// call case 5: prelude request
  params[0] = call4272;
  params[1] = block4273;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4305 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4270);
// compiled call node returning call4305 (depth = 5)
  gc_frame_end(frame);
  return call4305;
}
Object meth_ast__apply_40_1_41_4338(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4340 == NULL) {
    strlit4340 = alloc_String("");
    gc_root(strlit4340);
  }
// compiled string node returning strlit4340 (depth = 8)
  int op_slot_right_4339 = gc_frame_newslot(strlit4340);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4343 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4344 = alloc_Float64(0);
// compiled num node returning num4344 (depth = 10)
  gc_frame_newslot(num4344);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = num4344;
  partcv[0] = 1;
  Object call4345 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4343);
// compiled call node returning call4345 (depth = 9)
  int op_slot_right_4342 = gc_frame_newslot(call4345);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4348 == NULL) {
    strlit4348 = alloc_String("  ");
    gc_root(strlit4348);
  }
// compiled string node returning strlit4348 (depth = 10)
  int op_slot_right_4347 = gc_frame_newslot(strlit4348);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4350 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4353 == NULL) {
    strlit4353 = alloc_String("""\x0a""");
    gc_root(strlit4353);
  }
// compiled string node returning strlit4353 (depth = 12)
  int op_slot_right_4352 = gc_frame_newslot(strlit4353);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4355 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4357 == NULL) {
    strlit4357 = alloc_String("");
    gc_root(strlit4357);
  }
// compiled string node returning strlit4357 (depth = 13)
  int op_slot_left_4355 = gc_frame_newslot(strlit4357);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4358 = callmethod(strlit4357, "++(1)", 1, partcv, params);
// compiled op node returning opresult4358 (depth = 12)
  int op_slot_left_4352 = gc_frame_newslot(opresult4358);
  params[0] = strlit4353;
  partcv[0] = 1;
  Object opresult4359 = callmethod(opresult4358, "++(1)", 1, partcv, params);
// compiled op node returning opresult4359 (depth = 11)
  int op_slot_left_4350 = gc_frame_newslot(opresult4359);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4360 = callmethod(opresult4359, "++(1)", 1, partcv, params);
// compiled op node returning opresult4360 (depth = 10)
  int op_slot_left_4347 = gc_frame_newslot(opresult4360);
  params[0] = strlit4348;
  partcv[0] = 1;
  Object opresult4361 = callmethod(opresult4360, "++(1)", 1, partcv, params);
// compiled op node returning opresult4361 (depth = 9)
  int op_slot_left_4342 = gc_frame_newslot(opresult4361);
  params[0] = call4345;
  partcv[0] = 1;
  Object opresult4362 = callmethod(opresult4361, "++(1)", 1, partcv, params);
// compiled op node returning opresult4362 (depth = 8)
  int op_slot_left_4339 = gc_frame_newslot(opresult4362);
  params[0] = strlit4340;
  partcv[0] = 1;
  Object opresult4363 = callmethod(opresult4362, "++(1)", 1, partcv, params);
// compiled op node returning opresult4363 (depth = 7)
  *var_s = opresult4363;
  if (opresult4363 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_4403(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4405 == NULL) {
    strlit4405 = alloc_String("");
    gc_root(strlit4405);
  }
// compiled string node returning strlit4405 (depth = 8)
  int op_slot_right_4404 = gc_frame_newslot(strlit4405);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4408 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4410 = alloc_Float64(2);
// compiled num node returning num4410 (depth = 11)
  int op_slot_right_4409 = gc_frame_newslot(num4410);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4409 = gc_frame_newslot(*var_depth);
  params[0] = num4410;
  partcv[0] = 1;
  Object sum4412 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4412 (depth = 10)
  gc_frame_newslot(sum4412);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_an (depth = 10)
  params[0] = sum4412;
  partcv[0] = 1;
  Object call4413 = callmethodflags(*var_an, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4408);
// compiled call node returning call4413 (depth = 9)
  int op_slot_right_4407 = gc_frame_newslot(call4413);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4416 == NULL) {
    strlit4416 = alloc_String("  ");
    gc_root(strlit4416);
  }
// compiled string node returning strlit4416 (depth = 10)
  int op_slot_right_4415 = gc_frame_newslot(strlit4416);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4418 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4421 == NULL) {
    strlit4421 = alloc_String("""\x0a""");
    gc_root(strlit4421);
  }
// compiled string node returning strlit4421 (depth = 12)
  int op_slot_right_4420 = gc_frame_newslot(strlit4421);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4423 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4425 == NULL) {
    strlit4425 = alloc_String("");
    gc_root(strlit4425);
  }
// compiled string node returning strlit4425 (depth = 13)
  int op_slot_left_4423 = gc_frame_newslot(strlit4425);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4426 = callmethod(strlit4425, "++(1)", 1, partcv, params);
// compiled op node returning opresult4426 (depth = 12)
  int op_slot_left_4420 = gc_frame_newslot(opresult4426);
  params[0] = strlit4421;
  partcv[0] = 1;
  Object opresult4427 = callmethod(opresult4426, "++(1)", 1, partcv, params);
// compiled op node returning opresult4427 (depth = 11)
  int op_slot_left_4418 = gc_frame_newslot(opresult4427);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4428 = callmethod(opresult4427, "++(1)", 1, partcv, params);
// compiled op node returning opresult4428 (depth = 10)
  int op_slot_left_4415 = gc_frame_newslot(opresult4428);
  params[0] = strlit4416;
  partcv[0] = 1;
  Object opresult4429 = callmethod(opresult4428, "++(1)", 1, partcv, params);
// compiled op node returning opresult4429 (depth = 9)
  int op_slot_left_4407 = gc_frame_newslot(opresult4429);
  params[0] = call4413;
  partcv[0] = 1;
  Object opresult4430 = callmethod(opresult4429, "++(1)", 1, partcv, params);
// compiled op node returning opresult4430 (depth = 8)
  int op_slot_left_4404 = gc_frame_newslot(opresult4430);
  params[0] = strlit4405;
  partcv[0] = 1;
  Object opresult4431 = callmethod(opresult4430, "++(1)", 1, partcv, params);
// compiled op node returning opresult4431 (depth = 7)
  *var_s = opresult4431;
  if (opresult4431 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_4452(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4454 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4456 = alloc_Float64(2);
// compiled num node returning num4456 (depth = 9)
  int op_slot_right_4455 = gc_frame_newslot(num4456);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4455 = gc_frame_newslot(*var_depth);
  params[0] = num4456;
  partcv[0] = 1;
  Object sum4458 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4458 (depth = 8)
  gc_frame_newslot(sum4458);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4458;
  partcv[0] = 1;
  Object call4459 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4454);
// compiled call node returning call4459 (depth = 7)
  int op_slot_right_4453 = gc_frame_newslot(call4459);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4461 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4464 == NULL) {
    strlit4464 = alloc_String("""\x0a""  ");
    gc_root(strlit4464);
  }
// compiled string node returning strlit4464 (depth = 9)
  int op_slot_right_4463 = gc_frame_newslot(strlit4464);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4463 = gc_frame_newslot(*var_s);
  params[0] = strlit4464;
  partcv[0] = 1;
  Object opresult4466 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4466 (depth = 8)
  int op_slot_left_4461 = gc_frame_newslot(opresult4466);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4467 = callmethod(opresult4466, "++(1)", 1, partcv, params);
// compiled op node returning opresult4467 (depth = 7)
  int op_slot_left_4453 = gc_frame_newslot(opresult4467);
  params[0] = call4459;
  partcv[0] = 1;
  Object opresult4468 = callmethod(opresult4467, "++(1)", 1, partcv, params);
// compiled op node returning opresult4468 (depth = 6)
  *var_s = opresult4468;
  if (opresult4468 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_4101(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4102 == NULL) {
    strlit4102 = alloc_String("");
    gc_root(strlit4102);
  }
// compiled string node returning strlit4102 (depth = 4)
  *var_spc = strlit4102;
  if (strlit4102 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4103 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_4104 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num4106 = alloc_Float64(0);
// compiled num node returning num4106 (depth = 5)
  int op_slot_left_4104 = gc_frame_newslot(num4106);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4107 = callmethod(num4106, "..(1)", 1, partcv, params);
// compiled op node returning opresult4107 (depth = 4)
  gc_frame_newslot(opresult4107);
// starting to compile block node (depth = 4)
  Object block4108 = alloc_Block(NULL, NULL, "ast", 982);
  gc_frame_newslot(block4108);
// method "_apply(_)"
  block_savedest(block4108);
  Object closure4109 = createclosure(2, "_apply(1)");
  setclosureframe(closure4109, stackframe);
  addtoclosure(closure4109, var_spc);
  addtoclosure(closure4109, selfslot);
  struct UserObject *uo4109 = (struct UserObject*)block4108;
  uo4109->data[0] = (Object)closure4109;
  Method *meth_meth_ast__apply_40_1_41_4109 = addmethod2pos(block4108, "_apply(1)", &meth_ast__apply_40_1_41_4109, 0);
  int argcv_meth_ast__apply_40_1_41_4109[] = {1};
  meth_meth_ast__apply_40_1_41_4109->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4109);
  meth_meth_ast__apply_40_1_41_4109->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4109->definitionLine = 2969;
// compiled block node returning block4108 (depth = 4)
  gc_frame_newslot(block4108);
// call case 5: prelude request
  params[0] = opresult4107;
  params[1] = block4108;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4116 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4103);
// compiled call node returning call4116 (depth = 3)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4118 == NULL) {
    strlit4118 = alloc_String("""\x0a""");
    gc_root(strlit4118);
  }
// compiled string node returning strlit4118 (depth = 5)
  int op_slot_right_4117 = gc_frame_newslot(strlit4118);
// starting to compile call node (depth = 5)
  int callframe4120 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call4121 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4120);
// compiled call node returning call4121 (depth = 5)
  int op_slot_left_4117 = gc_frame_newslot(call4121);
  params[0] = strlit4118;
  partcv[0] = 1;
  Object opresult4122 = callmethod(call4121, "++(1)", 1, partcv, params);
// compiled op node returning opresult4122 (depth = 4)
  *var_s = opresult4122;
  if (opresult4122 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4124 == NULL) {
    strlit4124 = alloc_String("""\x0a""");
    gc_root(strlit4124);
  }
// compiled string node returning strlit4124 (depth = 5)
  int op_slot_right_4123 = gc_frame_newslot(strlit4124);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4127 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4129 = alloc_Float64(1);
// compiled num node returning num4129 (depth = 8)
  int op_slot_right_4128 = gc_frame_newslot(num4129);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4128 = gc_frame_newslot(*var_depth);
  params[0] = num4129;
  partcv[0] = 1;
  Object sum4131 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4131 (depth = 7)
  gc_frame_newslot(sum4131);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4132 = gc_frame_new();
// call case 4: self request
  Object call4133 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4132);
// compiled member node returning call4133 (depth = 7)
  params[0] = sum4131;
  partcv[0] = 1;
  Object call4134 = callmethodflags(call4133, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4127);
// compiled call node returning call4134 (depth = 6)
  int op_slot_right_4126 = gc_frame_newslot(call4134);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4137 == NULL) {
    strlit4137 = alloc_String("Name: ");
    gc_root(strlit4137);
  }
// compiled string node returning strlit4137 (depth = 7)
  int op_slot_right_4136 = gc_frame_newslot(strlit4137);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4139 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4139 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4141 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4141 (depth = 7)
  int op_slot_left_4136 = gc_frame_newslot(opresult4141);
  params[0] = strlit4137;
  partcv[0] = 1;
  Object opresult4142 = callmethod(opresult4141, "++(1)", 1, partcv, params);
// compiled op node returning opresult4142 (depth = 6)
  int op_slot_left_4126 = gc_frame_newslot(opresult4142);
  params[0] = call4134;
  partcv[0] = 1;
  Object opresult4143 = callmethod(opresult4142, "++(1)", 1, partcv, params);
// compiled op node returning opresult4143 (depth = 5)
  int op_slot_left_4123 = gc_frame_newslot(opresult4143);
  params[0] = strlit4124;
  partcv[0] = 1;
  Object opresult4144 = callmethod(opresult4143, "++(1)", 1, partcv, params);
// compiled op node returning opresult4144 (depth = 4)
  *var_s = opresult4144;
  if (opresult4144 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4148 = gc_frame_new();
// call case 4: self request
  Object call4149 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4148);
// compiled member node returning call4149 (depth = 5)
  int op_slot_right_4147 = gc_frame_newslot(call4149);
// starting to compile identifier node (depth = 5)
  Object bool4151 = alloc_Boolean(0);
// compiled identifier node returning bool4151 (depth = 5)
  int op_slot_left_4147 = gc_frame_newslot(bool4151);
  params[0] = call4149;
  partcv[0] = 1;
  Object opresult4152 = callmethod(bool4151, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4152 (depth = 4)
  Object if4146 = done;
  if (istrue(opresult4152)) {
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4154 == NULL) {
    strlit4154 = alloc_String("  ");
    gc_root(strlit4154);
  }
// compiled string node returning strlit4154 (depth = 6)
  int op_slot_right_4153 = gc_frame_newslot(strlit4154);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4156 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4159 == NULL) {
    strlit4159 = alloc_String("Returns:""\x0a""");
    gc_root(strlit4159);
  }
// compiled string node returning strlit4159 (depth = 8)
  int op_slot_right_4158 = gc_frame_newslot(strlit4159);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4161 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4161 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4163 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4163 (depth = 8)
  int op_slot_left_4158 = gc_frame_newslot(opresult4163);
  params[0] = strlit4159;
  partcv[0] = 1;
  Object opresult4164 = callmethod(opresult4163, "++(1)", 1, partcv, params);
// compiled op node returning opresult4164 (depth = 7)
  int op_slot_left_4156 = gc_frame_newslot(opresult4164);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4165 = callmethod(opresult4164, "++(1)", 1, partcv, params);
// compiled op node returning opresult4165 (depth = 6)
  int op_slot_left_4153 = gc_frame_newslot(opresult4165);
  params[0] = strlit4154;
  partcv[0] = 1;
  Object opresult4166 = callmethod(opresult4165, "++(1)", 1, partcv, params);
// compiled op node returning opresult4166 (depth = 5)
  *var_s = opresult4166;
  if (opresult4166 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4169 == NULL) {
    strlit4169 = alloc_String("""\x0a""");
    gc_root(strlit4169);
  }
// compiled string node returning strlit4169 (depth = 6)
  int op_slot_right_4168 = gc_frame_newslot(strlit4169);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4172 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4174 = alloc_Float64(2);
// compiled num node returning num4174 (depth = 9)
  int op_slot_right_4173 = gc_frame_newslot(num4174);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4173 = gc_frame_newslot(*var_depth);
  params[0] = num4174;
  partcv[0] = 1;
  Object sum4176 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4176 (depth = 8)
  gc_frame_newslot(sum4176);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4177 = gc_frame_new();
// call case 4: self request
  Object call4178 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4177);
// compiled member node returning call4178 (depth = 8)
  params[0] = sum4176;
  partcv[0] = 1;
  Object call4179 = callmethodflags(call4178, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4172);
// compiled call node returning call4179 (depth = 7)
  int op_slot_right_4171 = gc_frame_newslot(call4179);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4171 = gc_frame_newslot(*var_s);
  params[0] = call4179;
  partcv[0] = 1;
  Object opresult4181 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4181 (depth = 6)
  int op_slot_left_4168 = gc_frame_newslot(opresult4181);
  params[0] = strlit4169;
  partcv[0] = 1;
  Object opresult4182 = callmethod(opresult4181, "++(1)", 1, partcv, params);
// compiled op node returning opresult4182 (depth = 5)
  *var_s = opresult4182;
  if (opresult4182 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4146 = done;
  } else {
  }
// compiled if node returning if4146 (depth = 3)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4185 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4186 = gc_frame_new();
// call case 4: self request
  Object call4187 = callmethodflags(self, "isBindingOccurence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4186);
// compiled member node returning call4187 (depth = 5)
  Object call4188 = callmethodflags(call4187, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4185);
// compiled member node returning call4188 (depth = 4)
  Object if4184 = done;
  if (istrue(call4188)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4190 == NULL) {
    strlit4190 = alloc_String("Applied""\x0a""");
    gc_root(strlit4190);
  }
// compiled string node returning strlit4190 (depth = 6)
  int op_slot_right_4189 = gc_frame_newslot(strlit4190);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4192 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4192 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4194 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4194 (depth = 6)
  int op_slot_left_4189 = gc_frame_newslot(opresult4194);
  params[0] = strlit4190;
  partcv[0] = 1;
  Object opresult4195 = callmethod(opresult4194, "++(1)", 1, partcv, params);
// compiled op node returning opresult4195 (depth = 5)
  *var_s = opresult4195;
  if (opresult4195 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4184 = done;
  } else {
  }
// compiled if node returning if4184 (depth = 3)
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4198 = gc_frame_new();
// call case 4: self request
  Object call4199 = callmethodflags(self, "isFresh", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4198);
// compiled member node returning call4199 (depth = 4)
  Object if4197 = done;
  if (istrue(call4199)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4201 == NULL) {
    strlit4201 = alloc_String("Fresh""\x0a""");
    gc_root(strlit4201);
  }
// compiled string node returning strlit4201 (depth = 6)
  int op_slot_right_4200 = gc_frame_newslot(strlit4201);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4203 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4203 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4205 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4205 (depth = 6)
  int op_slot_left_4200 = gc_frame_newslot(opresult4205);
  params[0] = strlit4201;
  partcv[0] = 1;
  Object opresult4206 = callmethod(opresult4205, "++(1)", 1, partcv, params);
// compiled op node returning opresult4206 (depth = 5)
  *var_s = opresult4206;
  if (opresult4206 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4197 = done;
  } else {
  }
// compiled if node returning if4197 (depth = 3)
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4209 == NULL) {
    strlit4209 = alloc_String("Signature:");
    gc_root(strlit4209);
  }
// compiled string node returning strlit4209 (depth = 5)
  int op_slot_right_4208 = gc_frame_newslot(strlit4209);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4211 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4214 == NULL) {
    strlit4214 = alloc_String("");
    gc_root(strlit4214);
  }
// compiled string node returning strlit4214 (depth = 7)
  int op_slot_right_4213 = gc_frame_newslot(strlit4214);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_4216 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit4218 == NULL) {
    strlit4218 = alloc_String("");
    gc_root(strlit4218);
  }
// compiled string node returning strlit4218 (depth = 8)
  int op_slot_left_4216 = gc_frame_newslot(strlit4218);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4219 = callmethod(strlit4218, "++(1)", 1, partcv, params);
// compiled op node returning opresult4219 (depth = 7)
  int op_slot_left_4213 = gc_frame_newslot(opresult4219);
  params[0] = strlit4214;
  partcv[0] = 1;
  Object opresult4220 = callmethod(opresult4219, "++(1)", 1, partcv, params);
// compiled op node returning opresult4220 (depth = 6)
  int op_slot_left_4211 = gc_frame_newslot(opresult4220);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4221 = callmethod(opresult4220, "++(1)", 1, partcv, params);
// compiled op node returning opresult4221 (depth = 5)
  int op_slot_left_4208 = gc_frame_newslot(opresult4221);
  params[0] = strlit4209;
  partcv[0] = 1;
  Object opresult4222 = callmethod(opresult4221, "++(1)", 1, partcv, params);
// compiled op node returning opresult4222 (depth = 4)
  *var_s = opresult4222;
  if (opresult4222 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4224 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4225 = gc_frame_new();
// call case 4: self request
  Object call4226 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4225);
// compiled member node returning call4226 (depth = 4)
  gc_frame_newslot(call4226);
// starting to compile block node (depth = 4)
  Object block4227 = alloc_Block(NULL, NULL, "ast", 994);
  gc_frame_newslot(block4227);
// method "_apply(_)"
  block_savedest(block4227);
  Object closure4228 = createclosure(4, "_apply(1)");
  setclosureframe(closure4228, stackframe);
  addtoclosure(closure4228, var_spc);
  addtoclosure(closure4228, var_s);
  addtoclosure(closure4228, var_depth);
  addtoclosure(closure4228, selfslot);
  struct UserObject *uo4228 = (struct UserObject*)block4227;
  uo4228->data[0] = (Object)closure4228;
  Method *meth_meth_ast__apply_40_1_41_4228 = addmethod2pos(block4227, "_apply(1)", &meth_ast__apply_40_1_41_4228, 0);
  int argcv_meth_ast__apply_40_1_41_4228[] = {1};
  meth_meth_ast__apply_40_1_41_4228->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4228);
  meth_meth_ast__apply_40_1_41_4228->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4228->definitionLine = 2969;
// compiled block node returning block4227 (depth = 4)
  gc_frame_newslot(block4227);
// call case 5: prelude request
  params[0] = call4226;
  params[1] = block4227;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4307 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4224);
// compiled call node returning call4307 (depth = 3)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4309 == NULL) {
    strlit4309 = alloc_String("""\x0a""");
    gc_root(strlit4309);
  }
// compiled string node returning strlit4309 (depth = 5)
  int op_slot_right_4308 = gc_frame_newslot(strlit4309);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4308 = gc_frame_newslot(*var_s);
  params[0] = strlit4309;
  partcv[0] = 1;
  Object opresult4311 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4311 (depth = 4)
  *var_s = opresult4311;
  if (opresult4311 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4315 = gc_frame_new();
// call case 4: self request
  Object call4316 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4315);
// compiled member node returning call4316 (depth = 5)
  int op_slot_right_4314 = gc_frame_newslot(call4316);
// starting to compile identifier node (depth = 5)
  Object bool4318 = alloc_Boolean(0);
// compiled identifier node returning bool4318 (depth = 5)
  int op_slot_left_4314 = gc_frame_newslot(bool4318);
  params[0] = call4316;
  partcv[0] = 1;
  Object opresult4319 = callmethod(bool4318, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4319 (depth = 4)
  Object if4313 = done;
  if (istrue(opresult4319)) {
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4321 == NULL) {
    strlit4321 = alloc_String("Generics:");
    gc_root(strlit4321);
  }
// compiled string node returning strlit4321 (depth = 6)
  int op_slot_right_4320 = gc_frame_newslot(strlit4321);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4323 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4326 == NULL) {
    strlit4326 = alloc_String("");
    gc_root(strlit4326);
  }
// compiled string node returning strlit4326 (depth = 8)
  int op_slot_right_4325 = gc_frame_newslot(strlit4326);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4328 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4330 == NULL) {
    strlit4330 = alloc_String("");
    gc_root(strlit4330);
  }
// compiled string node returning strlit4330 (depth = 9)
  int op_slot_left_4328 = gc_frame_newslot(strlit4330);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4331 = callmethod(strlit4330, "++(1)", 1, partcv, params);
// compiled op node returning opresult4331 (depth = 8)
  int op_slot_left_4325 = gc_frame_newslot(opresult4331);
  params[0] = strlit4326;
  partcv[0] = 1;
  Object opresult4332 = callmethod(opresult4331, "++(1)", 1, partcv, params);
// compiled op node returning opresult4332 (depth = 7)
  int op_slot_left_4323 = gc_frame_newslot(opresult4332);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4333 = callmethod(opresult4332, "++(1)", 1, partcv, params);
// compiled op node returning opresult4333 (depth = 6)
  int op_slot_left_4320 = gc_frame_newslot(opresult4333);
  params[0] = strlit4321;
  partcv[0] = 1;
  Object opresult4334 = callmethod(opresult4333, "++(1)", 1, partcv, params);
// compiled op node returning opresult4334 (depth = 5)
  *var_s = opresult4334;
  if (opresult4334 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4336 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4337 = alloc_Block(NULL, NULL, "ast", 1004);
  gc_frame_newslot(block4337);
// method "_apply(_)"
  block_savedest(block4337);
  Object closure4338 = createclosure(3, "_apply(1)");
  setclosureframe(closure4338, stackframe);
  addtoclosure(closure4338, var_spc);
  addtoclosure(closure4338, var_s);
  addtoclosure(closure4338, selfslot);
  struct UserObject *uo4338 = (struct UserObject*)block4337;
  uo4338->data[0] = (Object)closure4338;
  Method *meth_meth_ast__apply_40_1_41_4338 = addmethod2pos(block4337, "_apply(1)", &meth_ast__apply_40_1_41_4338, 0);
  int argcv_meth_ast__apply_40_1_41_4338[] = {1};
  meth_meth_ast__apply_40_1_41_4338->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4338);
  meth_meth_ast__apply_40_1_41_4338->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4338->definitionLine = 2969;
// compiled block node returning block4337 (depth = 5)
  gc_frame_newslot(block4337);
// call case 6: other requests
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4366 = gc_frame_new();
// call case 4: self request
  Object call4367 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4366);
// compiled member node returning call4367 (depth = 5)
  params[0] = block4337;
  partcv[0] = 1;
  Object call4368 = callmethodflags(call4367, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4336);
// compiled call node returning call4368 (depth = 4)
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4370 == NULL) {
    strlit4370 = alloc_String("""\x0a""");
    gc_root(strlit4370);
  }
// compiled string node returning strlit4370 (depth = 6)
  int op_slot_right_4369 = gc_frame_newslot(strlit4370);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4369 = gc_frame_newslot(*var_s);
  params[0] = strlit4370;
  partcv[0] = 1;
  Object opresult4372 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4372 (depth = 5)
  *var_s = opresult4372;
  if (opresult4372 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4313 = done;
  } else {
  }
// compiled if node returning if4313 (depth = 3)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4376 = alloc_Float64(0);
// compiled num node returning num4376 (depth = 5)
  int op_slot_right_4375 = gc_frame_newslot(num4376);
// starting to compile member node (depth = 5)
  int callframe4378 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4379 = gc_frame_new();
// call case 4: self request
  Object call4380 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4379);
// compiled member node returning call4380 (depth = 6)
  Object call4381 = callmethodflags(call4380, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4378);
// compiled member node returning call4381 (depth = 5)
  int op_slot_left_4375 = gc_frame_newslot(call4381);
  params[0] = num4376;
  partcv[0] = 1;
  Object opresult4382 = callmethod(call4381, ">(1)", 1, partcv, params);
// compiled op node returning opresult4382 (depth = 4)
  Object if4374 = done;
  if (istrue(opresult4382)) {
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4384 == NULL) {
    strlit4384 = alloc_String("Annotations:");
    gc_root(strlit4384);
  }
// compiled string node returning strlit4384 (depth = 6)
  int op_slot_right_4383 = gc_frame_newslot(strlit4384);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4386 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4389 == NULL) {
    strlit4389 = alloc_String("");
    gc_root(strlit4389);
  }
// compiled string node returning strlit4389 (depth = 8)
  int op_slot_right_4388 = gc_frame_newslot(strlit4389);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4391 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4393 == NULL) {
    strlit4393 = alloc_String("");
    gc_root(strlit4393);
  }
// compiled string node returning strlit4393 (depth = 9)
  int op_slot_left_4391 = gc_frame_newslot(strlit4393);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4394 = callmethod(strlit4393, "++(1)", 1, partcv, params);
// compiled op node returning opresult4394 (depth = 8)
  int op_slot_left_4388 = gc_frame_newslot(opresult4394);
  params[0] = strlit4389;
  partcv[0] = 1;
  Object opresult4395 = callmethod(opresult4394, "++(1)", 1, partcv, params);
// compiled op node returning opresult4395 (depth = 7)
  int op_slot_left_4386 = gc_frame_newslot(opresult4395);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4396 = callmethod(opresult4395, "++(1)", 1, partcv, params);
// compiled op node returning opresult4396 (depth = 6)
  int op_slot_left_4383 = gc_frame_newslot(opresult4396);
  params[0] = strlit4384;
  partcv[0] = 1;
  Object opresult4397 = callmethod(opresult4396, "++(1)", 1, partcv, params);
// compiled op node returning opresult4397 (depth = 5)
  *var_s = opresult4397;
  if (opresult4397 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4399 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4400 = gc_frame_new();
// call case 4: self request
  Object call4401 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4400);
// compiled member node returning call4401 (depth = 5)
  gc_frame_newslot(call4401);
// starting to compile block node (depth = 5)
  Object block4402 = alloc_Block(NULL, NULL, "ast", 1011);
  gc_frame_newslot(block4402);
// method "_apply(_)"
  block_savedest(block4402);
  Object closure4403 = createclosure(4, "_apply(1)");
  setclosureframe(closure4403, stackframe);
  addtoclosure(closure4403, var_depth);
  addtoclosure(closure4403, var_spc);
  addtoclosure(closure4403, var_s);
  addtoclosure(closure4403, selfslot);
  struct UserObject *uo4403 = (struct UserObject*)block4402;
  uo4403->data[0] = (Object)closure4403;
  Method *meth_meth_ast__apply_40_1_41_4403 = addmethod2pos(block4402, "_apply(1)", &meth_ast__apply_40_1_41_4403, 0);
  int argcv_meth_ast__apply_40_1_41_4403[] = {1};
  meth_meth_ast__apply_40_1_41_4403->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4403);
  meth_meth_ast__apply_40_1_41_4403->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4403->definitionLine = 2969;
// compiled block node returning block4402 (depth = 5)
  gc_frame_newslot(block4402);
// call case 5: prelude request
  params[0] = call4401;
  params[1] = block4402;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4434 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4399);
// compiled call node returning call4434 (depth = 4)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4436 == NULL) {
    strlit4436 = alloc_String("""\x0a""");
    gc_root(strlit4436);
  }
// compiled string node returning strlit4436 (depth = 6)
  int op_slot_right_4435 = gc_frame_newslot(strlit4436);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4435 = gc_frame_newslot(*var_s);
  params[0] = strlit4436;
  partcv[0] = 1;
  Object opresult4438 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4438 (depth = 5)
  *var_s = opresult4438;
  if (opresult4438 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4374 = done;
  } else {
  }
// compiled if node returning if4374 (depth = 3)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4441 == NULL) {
    strlit4441 = alloc_String("Body:");
    gc_root(strlit4441);
  }
// compiled string node returning strlit4441 (depth = 5)
  int op_slot_right_4440 = gc_frame_newslot(strlit4441);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4443 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4443 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4445 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4445 (depth = 5)
  int op_slot_left_4440 = gc_frame_newslot(opresult4445);
  params[0] = strlit4441;
  partcv[0] = 1;
  Object opresult4446 = callmethod(opresult4445, "++(1)", 1, partcv, params);
// compiled op node returning opresult4446 (depth = 4)
  *var_s = opresult4446;
  if (opresult4446 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4448 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4449 = gc_frame_new();
// call case 4: self request
  Object call4450 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4449);
// compiled member node returning call4450 (depth = 4)
  gc_frame_newslot(call4450);
// starting to compile block node (depth = 4)
  Object block4451 = alloc_Block(NULL, NULL, "ast", 1017);
  gc_frame_newslot(block4451);
// method "_apply(_)"
  block_savedest(block4451);
  Object closure4452 = createclosure(4, "_apply(1)");
  setclosureframe(closure4452, stackframe);
  addtoclosure(closure4452, var_depth);
  addtoclosure(closure4452, var_spc);
  addtoclosure(closure4452, var_s);
  addtoclosure(closure4452, selfslot);
  struct UserObject *uo4452 = (struct UserObject*)block4451;
  uo4452->data[0] = (Object)closure4452;
  Method *meth_meth_ast__apply_40_1_41_4452 = addmethod2pos(block4451, "_apply(1)", &meth_ast__apply_40_1_41_4452, 0);
  int argcv_meth_ast__apply_40_1_41_4452[] = {1};
  meth_meth_ast__apply_40_1_41_4452->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4452);
  meth_meth_ast__apply_40_1_41_4452->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4452->definitionLine = 2969;
// compiled block node returning block4451 (depth = 4)
  gc_frame_newslot(block4451);
// call case 5: prelude request
  params[0] = call4450;
  params[1] = block4451;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4471 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4448);
// compiled call node returning call4471 (depth = 3)
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4474 = gc_frame_new();
// call case 4: self request
  Object call4475 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4474);
// compiled member node returning call4475 (depth = 5)
  int op_slot_right_4473 = gc_frame_newslot(call4475);
// starting to compile identifier node (depth = 5)
  Object bool4477 = alloc_Boolean(0);
// compiled identifier node returning bool4477 (depth = 5)
  int op_slot_left_4473 = gc_frame_newslot(bool4477);
  params[0] = call4475;
  partcv[0] = 1;
  Object opresult4478 = callmethod(bool4477, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4478 (depth = 4)
  Object if4472 = done;
  if (istrue(opresult4478)) {
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4480 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4482 = alloc_Float64(2);
// compiled num node returning num4482 (depth = 8)
  int op_slot_right_4481 = gc_frame_newslot(num4482);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4481 = gc_frame_newslot(*var_depth);
  params[0] = num4482;
  partcv[0] = 1;
  Object sum4484 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4484 (depth = 7)
  gc_frame_newslot(sum4484);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4485 = gc_frame_new();
// call case 4: self request
  Object call4486 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4485);
// compiled member node returning call4486 (depth = 7)
  params[0] = sum4484;
  partcv[0] = 1;
  Object call4487 = callmethodflags(call4486, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4480);
// compiled call node returning call4487 (depth = 6)
  int op_slot_right_4479 = gc_frame_newslot(call4487);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4479 = gc_frame_newslot(*var_s);
  params[0] = call4487;
  partcv[0] = 1;
  Object opresult4489 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4489 (depth = 5)
  *var_s = opresult4489;
  if (opresult4489 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4472 = done;
  } else {
  }
// compiled if node returning if4472 (depth = 3)
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_4503(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4505 == NULL) {
    strlit4505 = alloc_String("    ");
    gc_root(strlit4505);
  }
// compiled string node returning strlit4505 (depth = 7)
  int op_slot_right_4504 = gc_frame_newslot(strlit4505);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4504 = gc_frame_newslot(*var_spc);
  params[0] = strlit4505;
  partcv[0] = 1;
  Object opresult4507 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4507 (depth = 6)
  *var_spc = opresult4507;
  if (opresult4507 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4527(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4529 = gc_frame_new();
// call case 4: self request
  Object call4530 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4529);
// compiled member node returning call4530 (depth = 9)
  int op_slot_right_4528 = gc_frame_newslot(call4530);
// starting to compile identifier node (depth = 9)
  Object bool4532 = alloc_Boolean(0);
// compiled identifier node returning bool4532 (depth = 9)
  int op_slot_left_4528 = gc_frame_newslot(bool4532);
  params[0] = call4530;
  partcv[0] = 1;
  Object opresult4533 = callmethod(bool4532, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4533 (depth = 8)
  gc_frame_end(frame);
  return opresult4533;
}
Object meth_ast__apply_40_1_41_4571(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4572 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  gc_frame_newslot(*var_pnr);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4573 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  Object call4574 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4573);
// compiled member node returning call4574 (depth = 10)
  params[0] = *var_pnr;
  partcv[0] = 1;
  Object call4575 = callmethodflags(call4574, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4572);
// compiled call node returning call4575 (depth = 9)
  *var_p = call4575;
  if (call4575 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4577 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4579 = alloc_Float64(1);
// compiled num node returning num4579 (depth = 12)
  int op_slot_right_4578 = gc_frame_newslot(num4579);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4578 = gc_frame_newslot(*var_depth);
  params[0] = num4579;
  partcv[0] = 1;
  Object sum4581 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4581 (depth = 11)
  gc_frame_newslot(sum4581);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4581;
  partcv[0] = 1;
  Object call4582 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4577);
// compiled call node returning call4582 (depth = 10)
  int op_slot_right_4576 = gc_frame_newslot(call4582);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4576 = gc_frame_newslot(*var_s);
  params[0] = call4582;
  partcv[0] = 1;
  Object opresult4584 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4584 (depth = 9)
  *var_s = opresult4584;
  if (opresult4584 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe4588 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe4589 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  Object call4590 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4589);
// compiled member node returning call4590 (depth = 11)
  Object call4591 = callmethodflags(call4590, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4588);
// compiled member node returning call4591 (depth = 10)
  int op_slot_right_4587 = gc_frame_newslot(call4591);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  int op_slot_left_4587 = gc_frame_newslot(*var_pnr);
  params[0] = call4591;
  partcv[0] = 1;
  Object opresult4593 = callmethod(*var_pnr, "<(1)", 1, partcv, params);
// compiled op node returning opresult4593 (depth = 9)
  Object if4586 = done;
  if (istrue(opresult4593)) {
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4595 == NULL) {
    strlit4595 = alloc_String(", ");
    gc_root(strlit4595);
  }
// compiled string node returning strlit4595 (depth = 11)
  int op_slot_right_4594 = gc_frame_newslot(strlit4595);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4594 = gc_frame_newslot(*var_s);
  params[0] = strlit4595;
  partcv[0] = 1;
  Object opresult4597 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4597 (depth = 10)
  *var_s = opresult4597;
  if (opresult4597 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if4586 = done;
  } else {
  }
// compiled if node returning if4586 (depth = 8)
  gc_frame_end(frame);
  return if4586;
}
Object meth_ast__apply_40_1_41_4517(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4519 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call4520 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe4519);
// compiled member node returning call4520 (depth = 7)
  int op_slot_right_4518 = gc_frame_newslot(call4520);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4518 = gc_frame_newslot(*var_s);
  params[0] = call4520;
  partcv[0] = 1;
  Object opresult4522 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4522 (depth = 6)
  *var_s = opresult4522;
  if (opresult4522 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block4526 = alloc_Block(NULL, NULL, "ast", 1034);
  gc_frame_newslot(block4526);
// method "_apply"
  block_savedest(block4526);
  Object closure4527 = createclosure(1, "_apply");
  setclosureframe(closure4527, stackframe);
  addtoclosure(closure4527, selfslot);
  struct UserObject *uo4527 = (struct UserObject*)block4526;
  uo4527->data[0] = (Object)closure4527;
  Method *meth_meth_ast__apply4527 = addmethod2pos(block4526, "_apply", &meth_ast__apply4527, 0);
  int argcv_meth_ast__apply4527[] = {0};
  meth_meth_ast__apply4527->type = alloc_MethodType(1, argcv_meth_ast__apply4527);
  meth_meth_ast__apply4527->definitionModule = modulename;
  meth_meth_ast__apply4527->definitionLine = 2969;
// compiled block node returning block4526 (depth = 7)
  int op_slot_right_4525 = gc_frame_newslot(block4526);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  int op_slot_left_4525 = gc_frame_newslot(*var_firstPart);
  params[0] = block4526;
  partcv[0] = 1;
  Object opresult4536 = callmethod(*var_firstPart, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4536 (depth = 6)
  Object if4524 = done;
  if (istrue(opresult4536)) {
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4538 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num4540 = alloc_Float64(1);
// compiled num node returning num4540 (depth = 10)
  int op_slot_right_4539 = gc_frame_newslot(num4540);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_4539 = gc_frame_newslot(*var_depth);
  params[0] = num4540;
  partcv[0] = 1;
  Object sum4542 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4542 (depth = 9)
  gc_frame_newslot(sum4542);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4543 = gc_frame_new();
// call case 4: self request
  Object call4544 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4543);
// compiled member node returning call4544 (depth = 9)
  params[0] = sum4542;
  partcv[0] = 1;
  Object call4545 = callmethodflags(call4544, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4538);
// compiled call node returning call4545 (depth = 8)
  int op_slot_right_4537 = gc_frame_newslot(call4545);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4537 = gc_frame_newslot(*var_s);
  params[0] = call4545;
  partcv[0] = 1;
  Object opresult4547 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4547 (depth = 7)
  *var_s = opresult4547;
  if (opresult4547 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4524 = done;
  } else {
  }
// compiled if node returning if4524 (depth = 5)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4549 = alloc_Boolean(0);
// compiled identifier node returning bool4549 (depth = 6)
  *var_firstPart = bool4549;
  if (bool4549 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num4553 = alloc_Float64(0);
// compiled num node returning num4553 (depth = 7)
  int op_slot_right_4552 = gc_frame_newslot(num4553);
// starting to compile member node (depth = 7)
  int callframe4555 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4556 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  Object call4557 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4556);
// compiled member node returning call4557 (depth = 8)
  Object call4558 = callmethodflags(call4557, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4555);
// compiled member node returning call4558 (depth = 7)
  int op_slot_left_4552 = gc_frame_newslot(call4558);
  params[0] = num4553;
  partcv[0] = 1;
  Object opresult4559 = callmethod(call4558, ">(1)", 1, partcv, params);
// compiled op node returning opresult4559 (depth = 6)
  Object if4551 = done;
  if (istrue(opresult4559)) {
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4561 == NULL) {
    strlit4561 = alloc_String("(");
    gc_root(strlit4561);
  }
// compiled string node returning strlit4561 (depth = 8)
  int op_slot_right_4560 = gc_frame_newslot(strlit4561);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4560 = gc_frame_newslot(*var_s);
  params[0] = strlit4561;
  partcv[0] = 1;
  Object opresult4563 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4563 (depth = 7)
  *var_s = opresult4563;
  if (opresult4563 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4565 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4566 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4567 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  Object call4568 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4567);
// compiled member node returning call4568 (depth = 8)
  Object call4569 = callmethodflags(call4568, "indices", 0, partcv, params, 0);
  gc_frame_end(callframe4566);
// compiled member node returning call4569 (depth = 7)
  gc_frame_newslot(call4569);
// starting to compile block node (depth = 7)
  Object block4570 = alloc_Block(NULL, NULL, "ast", 1040);
  gc_frame_newslot(block4570);
// method "_apply(_)"
  block_savedest(block4570);
  Object closure4571 = createclosure(4, "_apply(1)");
  setclosureframe(closure4571, stackframe);
  addtoclosure(closure4571, var_part);
  addtoclosure(closure4571, var_depth);
  addtoclosure(closure4571, var_s);
  addtoclosure(closure4571, selfslot);
  struct UserObject *uo4571 = (struct UserObject*)block4570;
  uo4571->data[0] = (Object)closure4571;
  Method *meth_meth_ast__apply_40_1_41_4571 = addmethod2pos(block4570, "_apply(1)", &meth_ast__apply_40_1_41_4571, 0);
  int argcv_meth_ast__apply_40_1_41_4571[] = {1};
  meth_meth_ast__apply_40_1_41_4571->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4571);
  meth_meth_ast__apply_40_1_41_4571->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4571->definitionLine = 2969;
// compiled block node returning block4570 (depth = 7)
  gc_frame_newslot(block4570);
// call case 5: prelude request
  params[0] = call4569;
  params[1] = block4570;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4600 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4565);
// compiled call node returning call4600 (depth = 6)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4602 == NULL) {
    strlit4602 = alloc_String(")");
    gc_root(strlit4602);
  }
// compiled string node returning strlit4602 (depth = 8)
  int op_slot_right_4601 = gc_frame_newslot(strlit4602);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4601 = gc_frame_newslot(*var_s);
  params[0] = strlit4602;
  partcv[0] = 1;
  Object opresult4604 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4604 (depth = 7)
  *var_s = opresult4604;
  if (opresult4604 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4551 = done;
  } else {
  }
// compiled if node returning if4551 (depth = 5)
  gc_frame_end(frame);
  return if4551;
}
Object meth_ast__apply_40_2_41_4649(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4651 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4652 = alloc_Float64(0);
// compiled num node returning num4652 (depth = 10)
  gc_frame_newslot(num4652);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num4652;
  partcv[0] = 1;
  Object call4653 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4651);
// compiled call node returning call4653 (depth = 9)
  int op_slot_right_4650 = gc_frame_newslot(call4653);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4657 == NULL) {
    strlit4657 = alloc_String("");
    gc_root(strlit4657);
  }
// compiled string node returning strlit4657 (depth = 11)
  int op_slot_right_4656 = gc_frame_newslot(strlit4657);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4656 = gc_frame_newslot(*var_a);
  params[0] = strlit4657;
  partcv[0] = 1;
  Object opresult4659 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4659 (depth = 10)
  Object if4655 = done;
struct StackFrameObject *iftmpstackframe4655 = stackframe;
  if (istrue(opresult4659)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4655);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4661 == NULL) {
    strlit4661 = alloc_String(", ");
    gc_root(strlit4661);
  }
// compiled string node returning strlit4661 (depth = 11)
  int op_slot_right_4660 = gc_frame_newslot(strlit4661);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4660 = gc_frame_newslot(*var_a);
  params[0] = strlit4661;
  partcv[0] = 1;
  Object opresult4663 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult4663 (depth = 10)
    gc_frame_newslot(opresult4663);
    if4655 = opresult4663;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4655);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit4664 == NULL) {
    strlit4664 = alloc_String("");
    gc_root(strlit4664);
  }
// compiled string node returning strlit4664 (depth = 10)
    gc_frame_newslot(strlit4664);
    if4655 = strlit4664;
  }
stackframe = iftmpstackframe4655;
// compiled if node returning if4655 (depth = 9)
  int op_slot_left_4650 = gc_frame_newslot(if4655);
  params[0] = call4653;
  partcv[0] = 1;
  Object opresult4665 = callmethod(if4655, "++(1)", 1, partcv, params);
// compiled op node returning opresult4665 (depth = 8)
  gc_frame_end(frame);
  return opresult4665;
}
Object meth_ast__apply_40_1_41_4702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4704 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4706 = alloc_Float64(1);
// compiled num node returning num4706 (depth = 9)
  int op_slot_right_4705 = gc_frame_newslot(num4706);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4705 = gc_frame_newslot(*var_depth);
  params[0] = num4706;
  partcv[0] = 1;
  Object sum4708 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4708 (depth = 8)
  gc_frame_newslot(sum4708);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4708;
  partcv[0] = 1;
  Object call4709 = callmethodflags(*var_mx, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4704);
// compiled call node returning call4709 (depth = 7)
  int op_slot_right_4703 = gc_frame_newslot(call4709);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4712 == NULL) {
    strlit4712 = alloc_String("    ");
    gc_root(strlit4712);
  }
// compiled string node returning strlit4712 (depth = 8)
  int op_slot_right_4711 = gc_frame_newslot(strlit4712);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4714 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4717 == NULL) {
    strlit4717 = alloc_String("""\x0a""");
    gc_root(strlit4717);
  }
// compiled string node returning strlit4717 (depth = 10)
  int op_slot_right_4716 = gc_frame_newslot(strlit4717);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4716 = gc_frame_newslot(*var_s);
  params[0] = strlit4717;
  partcv[0] = 1;
  Object opresult4719 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4719 (depth = 9)
  int op_slot_left_4714 = gc_frame_newslot(opresult4719);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4720 = callmethod(opresult4719, "++(1)", 1, partcv, params);
// compiled op node returning opresult4720 (depth = 8)
  int op_slot_left_4711 = gc_frame_newslot(opresult4720);
  params[0] = strlit4712;
  partcv[0] = 1;
  Object opresult4721 = callmethod(opresult4720, "++(1)", 1, partcv, params);
// compiled op node returning opresult4721 (depth = 7)
  int op_slot_left_4703 = gc_frame_newslot(opresult4721);
  params[0] = call4709;
  partcv[0] = 1;
  Object opresult4722 = callmethod(opresult4721, "++(1)", 1, partcv, params);
// compiled op node returning opresult4722 (depth = 6)
  *var_s = opresult4722;
  if (opresult4722 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_4491(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_firstPart = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "firstPart");
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4492 == NULL) {
    strlit4492 = alloc_String("");
    gc_root(strlit4492);
  }
// compiled string node returning strlit4492 (depth = 4)
  *var_spc = strlit4492;
  if (strlit4492 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4493 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4496 = alloc_Float64(1);
// compiled num node returning num4496 (depth = 6)
  int op_slot_right_4495 = gc_frame_newslot(num4496);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_4495 = gc_frame_newslot(*var_depth);
  params[0] = num4496;
  partcv[0] = 1;
  Object diff4498 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff4498 (depth = 5)
  int op_slot_right_4494 = gc_frame_newslot(diff4498);
// starting to compile num node (depth = 5)
  Object num4500 = alloc_Float64(0);
// compiled num node returning num4500 (depth = 5)
  int op_slot_left_4494 = gc_frame_newslot(num4500);
  params[0] = diff4498;
  partcv[0] = 1;
  Object opresult4501 = callmethod(num4500, "..(1)", 1, partcv, params);
// compiled op node returning opresult4501 (depth = 4)
  gc_frame_newslot(opresult4501);
// starting to compile block node (depth = 4)
  Object block4502 = alloc_Block(NULL, NULL, "ast", 1027);
  gc_frame_newslot(block4502);
// method "_apply(_)"
  block_savedest(block4502);
  Object closure4503 = createclosure(2, "_apply(1)");
  setclosureframe(closure4503, stackframe);
  addtoclosure(closure4503, var_spc);
  addtoclosure(closure4503, selfslot);
  struct UserObject *uo4503 = (struct UserObject*)block4502;
  uo4503->data[0] = (Object)closure4503;
  Method *meth_meth_ast__apply_40_1_41_4503 = addmethod2pos(block4502, "_apply(1)", &meth_ast__apply_40_1_41_4503, 0);
  int argcv_meth_ast__apply_40_1_41_4503[] = {1};
  meth_meth_ast__apply_40_1_41_4503->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4503);
  meth_meth_ast__apply_40_1_41_4503->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4503->definitionLine = 2969;
// compiled block node returning block4502 (depth = 4)
  gc_frame_newslot(block4502);
// call case 5: prelude request
  params[0] = opresult4501;
  params[1] = block4502;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4510 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4493);
// compiled call node returning call4510 (depth = 3)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4511 == NULL) {
    strlit4511 = alloc_String("method ");
    gc_root(strlit4511);
  }
// compiled string node returning strlit4511 (depth = 4)
  *var_s = strlit4511;
  if (strlit4511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4512 = alloc_Boolean(1);
// compiled identifier node returning bool4512 (depth = 4)
  *var_firstPart = bool4512;
  if (bool4512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4513 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4514 = gc_frame_new();
// call case 4: self request
  Object call4515 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4514);
// compiled member node returning call4515 (depth = 4)
  gc_frame_newslot(call4515);
// starting to compile block node (depth = 4)
  Object block4516 = alloc_Block(NULL, NULL, "ast", 1032);
  gc_frame_newslot(block4516);
// method "_apply(_)"
  block_savedest(block4516);
  Object closure4517 = createclosure(4, "_apply(1)");
  setclosureframe(closure4517, stackframe);
  addtoclosure(closure4517, var_s);
  addtoclosure(closure4517, var_firstPart);
  addtoclosure(closure4517, var_depth);
  addtoclosure(closure4517, selfslot);
  struct UserObject *uo4517 = (struct UserObject*)block4516;
  uo4517->data[0] = (Object)closure4517;
  Method *meth_meth_ast__apply_40_1_41_4517 = addmethod2pos(block4516, "_apply(1)", &meth_ast__apply_40_1_41_4517, 0);
  int argcv_meth_ast__apply_40_1_41_4517[] = {1};
  meth_meth_ast__apply_40_1_41_4517->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4517);
  meth_meth_ast__apply_40_1_41_4517->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4517->definitionLine = 2969;
// compiled block node returning block4516 (depth = 4)
  gc_frame_newslot(block4516);
// call case 5: prelude request
  params[0] = call4515;
  params[1] = block4516;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4607 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4513);
// compiled call node returning call4607 (depth = 3)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4610 = gc_frame_new();
// call case 4: self request
  Object call4611 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4610);
// compiled member node returning call4611 (depth = 5)
  int op_slot_right_4609 = gc_frame_newslot(call4611);
// starting to compile identifier node (depth = 5)
  Object bool4613 = alloc_Boolean(0);
// compiled identifier node returning bool4613 (depth = 5)
  int op_slot_left_4609 = gc_frame_newslot(bool4613);
  params[0] = call4611;
  partcv[0] = 1;
  Object opresult4614 = callmethod(bool4613, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4614 (depth = 4)
  Object if4608 = done;
  if (istrue(opresult4614)) {
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4617 == NULL) {
    strlit4617 = alloc_String("");
    gc_root(strlit4617);
  }
// compiled string node returning strlit4617 (depth = 7)
  int op_slot_right_4616 = gc_frame_newslot(strlit4617);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4620 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4621 = alloc_Float64(0);
// compiled num node returning num4621 (depth = 9)
  gc_frame_newslot(num4621);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4622 = gc_frame_new();
// call case 4: self request
  Object call4623 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4622);
// compiled member node returning call4623 (depth = 9)
  params[0] = num4621;
  partcv[0] = 1;
  Object call4624 = callmethodflags(call4623, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4620);
// compiled call node returning call4624 (depth = 8)
  int op_slot_right_4619 = gc_frame_newslot(call4624);
// starting to compile string node (depth = 8)
  if (strlit4626 == NULL) {
    strlit4626 = alloc_String(" -> ");
    gc_root(strlit4626);
  }
// compiled string node returning strlit4626 (depth = 8)
  int op_slot_left_4619 = gc_frame_newslot(strlit4626);
  params[0] = call4624;
  partcv[0] = 1;
  Object opresult4627 = callmethod(strlit4626, "++(1)", 1, partcv, params);
// compiled op node returning opresult4627 (depth = 7)
  int op_slot_left_4616 = gc_frame_newslot(opresult4627);
  params[0] = strlit4617;
  partcv[0] = 1;
  Object opresult4628 = callmethod(opresult4627, "++(1)", 1, partcv, params);
// compiled op node returning opresult4628 (depth = 6)
  int op_slot_right_4615 = gc_frame_newslot(opresult4628);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4615 = gc_frame_newslot(*var_s);
  params[0] = opresult4628;
  partcv[0] = 1;
  Object opresult4630 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4630 (depth = 5)
  *var_s = opresult4630;
  if (opresult4630 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4608 = done;
  } else {
  }
// compiled if node returning if4608 (depth = 3)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4634 = alloc_Float64(0);
// compiled num node returning num4634 (depth = 5)
  int op_slot_right_4633 = gc_frame_newslot(num4634);
// starting to compile member node (depth = 5)
  int callframe4636 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4637 = gc_frame_new();
// call case 4: self request
  Object call4638 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4637);
// compiled member node returning call4638 (depth = 6)
  Object call4639 = callmethodflags(call4638, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4636);
// compiled member node returning call4639 (depth = 5)
  int op_slot_left_4633 = gc_frame_newslot(call4639);
  params[0] = num4634;
  partcv[0] = 1;
  Object opresult4640 = callmethod(call4639, ">(1)", 1, partcv, params);
// compiled op node returning opresult4640 (depth = 4)
  Object if4632 = done;
  if (istrue(opresult4640)) {
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4642 == NULL) {
    strlit4642 = alloc_String(" is ");
    gc_root(strlit4642);
  }
// compiled string node returning strlit4642 (depth = 6)
  int op_slot_right_4641 = gc_frame_newslot(strlit4642);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4641 = gc_frame_newslot(*var_s);
  params[0] = strlit4642;
  partcv[0] = 1;
  Object opresult4644 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4644 (depth = 5)
  *var_s = opresult4644;
  if (opresult4644 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4647 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4648 = alloc_Block(NULL, NULL, "ast", 1055);
  gc_frame_newslot(block4648);
// method "_apply(_,_)"
  block_savedest(block4648);
  Object closure4649 = createclosure(1, "_apply(2)");
  setclosureframe(closure4649, stackframe);
  addtoclosure(closure4649, selfslot);
  struct UserObject *uo4649 = (struct UserObject*)block4648;
  uo4649->data[0] = (Object)closure4649;
  Method *meth_meth_ast__apply_40_2_41_4649 = addmethod2pos(block4648, "_apply(2)", &meth_ast__apply_40_2_41_4649, 0);
  int argcv_meth_ast__apply_40_2_41_4649[] = {2};
  meth_meth_ast__apply_40_2_41_4649->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_4649);
  meth_meth_ast__apply_40_2_41_4649->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_4649->definitionLine = 2969;
// compiled block node returning block4648 (depth = 7)
  gc_frame_newslot(block4648);
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4667 == NULL) {
    strlit4667 = alloc_String("");
    gc_root(strlit4667);
  }
// compiled string node returning strlit4667 (depth = 7)
  gc_frame_newslot(strlit4667);
// call case 6: other requests
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4668 = gc_frame_new();
// call case 4: self request
  Object call4669 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4668);
// compiled member node returning call4669 (depth = 7)
  params[0] = block4648;
  params[1] = strlit4667;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4670 = callmethodflags(call4669, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4647);
// compiled call node returning call4670 (depth = 6)
  int op_slot_right_4646 = gc_frame_newslot(call4670);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4646 = gc_frame_newslot(*var_s);
  params[0] = call4670;
  partcv[0] = 1;
  Object opresult4672 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4672 (depth = 5)
  *var_s = opresult4672;
  if (opresult4672 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4632 = done;
  } else {
  }
// compiled if node returning if4632 (depth = 3)
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4675 == NULL) {
    strlit4675 = alloc_String(" {");
    gc_root(strlit4675);
  }
// compiled string node returning strlit4675 (depth = 5)
  int op_slot_right_4674 = gc_frame_newslot(strlit4675);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4674 = gc_frame_newslot(*var_s);
  params[0] = strlit4675;
  partcv[0] = 1;
  Object opresult4677 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4677 (depth = 4)
  *var_s = opresult4677;
  if (opresult4677 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4681 = gc_frame_new();
// call case 4: self request
  Object call4682 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4681);
// compiled member node returning call4682 (depth = 5)
  int op_slot_right_4680 = gc_frame_newslot(call4682);
// starting to compile identifier node (depth = 5)
  Object bool4684 = alloc_Boolean(0);
// compiled identifier node returning bool4684 (depth = 5)
  int op_slot_left_4680 = gc_frame_newslot(bool4684);
  params[0] = call4682;
  partcv[0] = 1;
  Object opresult4685 = callmethod(bool4684, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4685 (depth = 4)
  Object if4679 = done;
  if (istrue(opresult4685)) {
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4687 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4689 = alloc_Float64(1);
// compiled num node returning num4689 (depth = 8)
  int op_slot_right_4688 = gc_frame_newslot(num4689);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4688 = gc_frame_newslot(*var_depth);
  params[0] = num4689;
  partcv[0] = 1;
  Object sum4691 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4691 (depth = 7)
  gc_frame_newslot(sum4691);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4692 = gc_frame_new();
// call case 4: self request
  Object call4693 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4692);
// compiled member node returning call4693 (depth = 7)
  params[0] = sum4691;
  partcv[0] = 1;
  Object call4694 = callmethodflags(call4693, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4687);
// compiled call node returning call4694 (depth = 6)
  int op_slot_right_4686 = gc_frame_newslot(call4694);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4686 = gc_frame_newslot(*var_s);
  params[0] = call4694;
  partcv[0] = 1;
  Object opresult4696 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4696 (depth = 5)
  *var_s = opresult4696;
  if (opresult4696 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4679 = done;
  } else {
  }
// compiled if node returning if4679 (depth = 3)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4698 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4699 = gc_frame_new();
// call case 4: self request
  Object call4700 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4699);
// compiled member node returning call4700 (depth = 4)
  gc_frame_newslot(call4700);
// starting to compile block node (depth = 4)
  Object block4701 = alloc_Block(NULL, NULL, "ast", 1063);
  gc_frame_newslot(block4701);
// method "_apply(_)"
  block_savedest(block4701);
  Object closure4702 = createclosure(4, "_apply(1)");
  setclosureframe(closure4702, stackframe);
  addtoclosure(closure4702, var_depth);
  addtoclosure(closure4702, var_spc);
  addtoclosure(closure4702, var_s);
  addtoclosure(closure4702, selfslot);
  struct UserObject *uo4702 = (struct UserObject*)block4701;
  uo4702->data[0] = (Object)closure4702;
  Method *meth_meth_ast__apply_40_1_41_4702 = addmethod2pos(block4701, "_apply(1)", &meth_ast__apply_40_1_41_4702, 0);
  int argcv_meth_ast__apply_40_1_41_4702[] = {1};
  meth_meth_ast__apply_40_1_41_4702->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4702);
  meth_meth_ast__apply_40_1_41_4702->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4702->definitionLine = 2969;
// compiled block node returning block4701 (depth = 4)
  gc_frame_newslot(block4701);
// call case 5: prelude request
  params[0] = call4700;
  params[1] = block4701;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4725 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4698);
// compiled call node returning call4725 (depth = 3)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4727 == NULL) {
    strlit4727 = alloc_String("}");
    gc_root(strlit4727);
  }
// compiled string node returning strlit4727 (depth = 5)
  int op_slot_right_4726 = gc_frame_newslot(strlit4727);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4729 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4732 == NULL) {
    strlit4732 = alloc_String("""\x0a""");
    gc_root(strlit4732);
  }
// compiled string node returning strlit4732 (depth = 7)
  int op_slot_right_4731 = gc_frame_newslot(strlit4732);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4731 = gc_frame_newslot(*var_s);
  params[0] = strlit4732;
  partcv[0] = 1;
  Object opresult4734 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4734 (depth = 6)
  int op_slot_left_4729 = gc_frame_newslot(opresult4734);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4735 = callmethod(opresult4734, "++(1)", 1, partcv, params);
// compiled op node returning opresult4735 (depth = 5)
  int op_slot_left_4726 = gc_frame_newslot(opresult4735);
  params[0] = strlit4727;
  partcv[0] = 1;
  Object opresult4736 = callmethod(opresult4735, "++(1)", 1, partcv, params);
// compiled op node returning opresult4736 (depth = 4)
  *var_s = opresult4736;
  if (opresult4736 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy4738(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4739 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe4740 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4741 = gc_frame_new();
// call case 4: self request
  Object call4742 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4741);
// compiled member node returning call4742 (depth = 5)
  gc_frame_newslot(call4742);
// starting to compile member node (depth = 5)
  int callframe4743 = gc_frame_new();
// call case 4: self request
  Object call4744 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4743);
// compiled member node returning call4744 (depth = 5)
  gc_frame_newslot(call4744);
// starting to compile member node (depth = 5)
  int callframe4745 = gc_frame_new();
// call case 4: self request
  Object call4746 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4745);
// compiled member node returning call4746 (depth = 5)
  gc_frame_newslot(call4746);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodNode (depth = 5)
  params[0] = call4742;
  params[1] = call4744;
  params[2] = call4746;
  partcv[0] = 3;
  Object call4747 = callmethodflags(*var_methodNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe4740);
// compiled call node returning call4747 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call4748 = callmethodflags(call4747, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4739);
// compiled call node returning call4748 (depth = 3)
  gc_frame_end(frame);
  return call4748;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_4749(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4750 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call4751 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4750);
// compiled call node returning call4751 (depth = 3)
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4752 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4753 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call4754 = callmethodflags(*var_other, "isFresh", 0, partcv, params, 0);
  gc_frame_end(callframe4753);
// compiled member node returning call4754 (depth = 4)
  gc_frame_newslot(call4754);
// call case 4: self request
  params[0] = call4754;
  partcv[0] = 1;
  Object call4755 = callmethodflags(self, "isFresh:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4752);
// compiled call node returning call4755 (depth = 3)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4756 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4757 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call4758 = callmethodflags(*var_other, "selfclosure", 0, partcv, params, 0);
  gc_frame_end(callframe4757);
// compiled member node returning call4758 (depth = 4)
  gc_frame_newslot(call4758);
// call case 4: self request
  params[0] = call4758;
  partcv[0] = 1;
  Object call4759 = callmethodflags(self, "selfclosure:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4756);
// compiled call node returning call4759 (depth = 3)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4761 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4762 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  Object call4763 = callmethodflags(*var_other, "isBindingOccurence", 0, partcv, params, 0);
  gc_frame_end(callframe4762);
// compiled member node returning call4763 (depth = 5)
  Object call4764 = callmethodflags(call4763, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4761);
// compiled member node returning call4764 (depth = 4)
  Object if4760 = done;
  if (istrue(call4764)) {
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4765 = gc_frame_new();
// call case 4: self request
  Object call4766 = callmethodflags(self, "appliedOccurence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4765);
// compiled member node returning call4766 (depth = 4)
    gc_frame_newslot(call4766);
    if4760 = call4766;
  } else {
  }
// compiled if node returning if4760 (depth = 3)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_3_41_3670(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3671 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3671 = alloc_userobj2(52,43, objclass3671);
  gc_frame_newslot(obj3671);
if (objclass3671 == NULL) {
  glfree(obj3671->class->name);
  obj3671->class->name = "methodNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3671, self, 0);
  addmethodreal(obj3671,"outer", &reader_ast_outer_3672);
  Object oldself3671 = self;
  struct StackFrameObject *oldstackframe3671 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3671);
  gc_frame_newslot((Object)stackframe);
  self = obj3671;
  Object *oldselfslot3671 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3671 = (*(struct UserObject *)self).data[0], lowerouter3671 = thisouter3671;
  if (inheritingObject3671) {
    struct UserObject *inho3671 = (struct UserObject *)inheritingObject3671;
    while (inho3671->super != GraceDefaultObject) inho3671 = (struct UserObject *)inho3671->super;
    inho3671->super = obj3671;
    self = inheritingObject3671;
    *selfslot = self;
    lowerouter3671 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3671;
  }
if (objclass3671 == NULL) {
  Method *reader3673 = addmethodrealflags(obj3671, "kind",&reader_ast_kind_3673, MFLAG_DEF);
  reader3673->definitionModule = modulename;
  reader3673->definitionLine = 845;
}
adddatum2(obj3671, alloc_Undefined(), 1);
if (objclass3671 == NULL) {
  Method *reader3674 = addmethodrealflags(obj3671, "signature", &reader_ast_signature_3674, 0);
  Method *writer3674 = addmethodrealflags(obj3671, "signature:=(1)", &writer_ast_signature_3674, 0);
  reader3674->definitionModule = modulename;
  writer3674->definitionModule = modulename;
  reader3674->definitionLine = 846;
  writer3674->definitionLine = 846;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 2);
if (objclass3671 == NULL) {
  Method *reader3675 = addmethodrealflags(obj3671, "body", &reader_ast_body_3675, 0);
  Method *writer3675 = addmethodrealflags(obj3671, "body:=(1)", &writer_ast_body_3675, 0);
  reader3675->definitionModule = modulename;
  writer3675->definitionModule = modulename;
  reader3675->definitionLine = 847;
  writer3675->definitionLine = 847;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 3);
if (objclass3671 == NULL) {
  Method *reader3676 = addmethodrealflags(obj3671, "dtype", &reader_ast_dtype_3676, 0);
  Method *writer3676 = addmethodrealflags(obj3671, "dtype:=(1)", &writer_ast_dtype_3676, 0);
  reader3676->definitionModule = modulename;
  writer3676->definitionModule = modulename;
  reader3676->definitionLine = 848;
  writer3676->definitionLine = 848;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 4);
if (objclass3671 == NULL) {
  Method *reader3677 = addmethodrealflags(obj3671, "typeParams", &reader_ast_typeParams_3677, 0);
  Method *writer3677 = addmethodrealflags(obj3671, "typeParams:=(1)", &writer_ast_typeParams_3677, 0);
  reader3677->definitionModule = modulename;
  writer3677->definitionModule = modulename;
  reader3677->definitionLine = 849;
  writer3677->definitionLine = 849;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 5);
if (objclass3671 == NULL) {
  Method *reader3678 = addmethodrealflags(obj3671, "selfclosure", &reader_ast_selfclosure_3678, 0);
  Method *writer3678 = addmethodrealflags(obj3671, "selfclosure:=(1)", &writer_ast_selfclosure_3678, 0);
  reader3678->definitionModule = modulename;
  writer3678->definitionModule = modulename;
  reader3678->definitionLine = 850;
  writer3678->definitionLine = 850;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 6);
if (objclass3671 == NULL) {
  Method *reader3679 = addmethodrealflags(obj3671, "annotations", &reader_ast_annotations_3679, 0);
  Method *writer3679 = addmethodrealflags(obj3671, "annotations:=(1)", &writer_ast_annotations_3679, 0);
  reader3679->definitionModule = modulename;
  writer3679->definitionModule = modulename;
  reader3679->definitionLine = 851;
  writer3679->definitionLine = 851;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 7);
if (objclass3671 == NULL) {
  Method *reader3680 = addmethodrealflags(obj3671, "isFresh", &reader_ast_isFresh_3680, 0);
  Method *writer3680 = addmethodrealflags(obj3671, "isFresh:=(1)", &writer_ast_isFresh_3680, 0);
  reader3680->definitionModule = modulename;
  writer3680->definitionModule = modulename;
  reader3680->definitionLine = 852;
  writer3680->definitionLine = 852;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 8);
if (objclass3671 == NULL) {
  Method *reader3681 = addmethodrealflags(obj3671, "usesClassSyntax", &reader_ast_usesClassSyntax_3681, 0);
  Method *writer3681 = addmethodrealflags(obj3671, "usesClassSyntax:=(1)", &writer_ast_usesClassSyntax_3681, 0);
  reader3681->definitionModule = modulename;
  writer3681->definitionModule = modulename;
  reader3681->definitionLine = 853;
  writer3681->definitionLine = 853;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 9);
if (objclass3671 == NULL) {
  Method *reader3682 = addmethodrealflags(obj3671, "cachedIdentifier", &reader_ast_cachedIdentifier_3682, MFLAG_CONFIDENTIAL);
  Method *writer3682 = addmethodrealflags(obj3671, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_3682, MFLAG_CONFIDENTIAL);
  reader3682->definitionModule = modulename;
  writer3682->definitionModule = modulename;
  reader3682->definitionLine = 854;
  writer3682->definitionLine = 854;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 10);
if (objclass3671 == NULL) {
  Method *reader3683 = addmethodrealflags(obj3671, "isBindingOccurence", &reader_ast_isBindingOccurence_3683, 0);
  Method *writer3683 = addmethodrealflags(obj3671, "isBindingOccurence:=(1)", &writer_ast_isBindingOccurence_3683, MFLAG_CONFIDENTIAL);
  reader3683->definitionModule = modulename;
  writer3683->definitionModule = modulename;
  reader3683->definitionLine = 855;
  writer3683->definitionLine = 855;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 11);
// method "appliedOccurence"
  block_savedest(obj3671);
  Object closure3684 = createclosure(1, "appliedOccurence");
  setclosureframe(closure3684, stackframe);
  addtoclosure(closure3684, var_uninitialized);
  struct UserObject *uo3684 = (struct UserObject*)obj3671;
  uo3684->data[12] = (Object)closure3684;
  Method *meth_meth_ast_appliedOccurence3684 = addmethod2pos(obj3671, "appliedOccurence", &meth_ast_appliedOccurence3684, 12);
  int argcv_meth_ast_appliedOccurence3684[] = {0};
  meth_meth_ast_appliedOccurence3684->type = alloc_MethodType(1, argcv_meth_ast_appliedOccurence3684);
  meth_meth_ast_appliedOccurence3684->definitionModule = modulename;
  meth_meth_ast_appliedOccurence3684->definitionLine = 858;
// method "numParams"
  struct UserObject *uo3699 = (struct UserObject*)obj3671;
  uo3699->data[13] = emptyclosure;
  Method *meth_meth_ast_numParams3699 = addmethod2pos(obj3671, "numParams", &meth_ast_numParams3699, 13);
  int argcv_meth_ast_numParams3699[] = {0};
  meth_meth_ast_numParams3699->type = alloc_MethodType(1, argcv_meth_ast_numParams3699);
  meth_meth_ast_numParams3699->definitionModule = modulename;
  meth_meth_ast_numParams3699->definitionLine = 865;
// method "endPos"
  struct UserObject *uo3713 = (struct UserObject*)obj3671;
  uo3713->data[14] = emptyclosure;
  Method *meth_meth_ast_endPos3713 = addmethod2pos(obj3671, "endPos", &meth_ast_endPos3713, 14);
  int argcv_meth_ast_endPos3713[] = {0};
  meth_meth_ast_endPos3713->type = alloc_MethodType(1, argcv_meth_ast_endPos3713);
  meth_meth_ast_endPos3713->definitionModule = modulename;
  meth_meth_ast_endPos3713->definitionLine = 868;
// method "nameString"
  struct UserObject *uo3731 = (struct UserObject*)obj3671;
  uo3731->data[15] = emptyclosure;
  Method *meth_meth_ast_nameString3731 = addmethod2pos(obj3671, "nameString", &meth_ast_nameString3731, 15);
  int argcv_meth_ast_nameString3731[] = {0};
  meth_meth_ast_nameString3731->type = alloc_MethodType(1, argcv_meth_ast_nameString3731);
  meth_meth_ast_nameString3731->definitionModule = modulename;
  meth_meth_ast_nameString3731->definitionLine = 873;
// method "asIdentifier"
  block_savedest(obj3671);
  Object closure3745 = createclosure(2, "asIdentifier");
  setclosureframe(closure3745, stackframe);
  addtoclosure(closure3745, var_uninitialized);
  addtoclosure(closure3745, var_identifierNode);
  struct UserObject *uo3745 = (struct UserObject*)obj3671;
  uo3745->data[16] = (Object)closure3745;
  Method *meth_meth_ast_asIdentifier3745 = addmethod2pos(obj3671, "asIdentifier", &meth_ast_asIdentifier3745, 16);
  int argcv_meth_ast_asIdentifier3745[] = {0};
  meth_meth_ast_asIdentifier3745->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier3745);
  meth_meth_ast_asIdentifier3745->definitionModule = modulename;
  meth_meth_ast_asIdentifier3745->definitionLine = 877;
// method "value"
  struct UserObject *uo3787 = (struct UserObject*)obj3671;
  uo3787->data[17] = emptyclosure;
  Method *meth_meth_ast_value3787 = addmethod2pos(obj3671, "value", &meth_ast_value3787, 17);
  int argcv_meth_ast_value3787[] = {0};
  meth_meth_ast_value3787->type = alloc_MethodType(1, argcv_meth_ast_value3787);
  meth_meth_ast_value3787->definitionModule = modulename;
  meth_meth_ast_value3787->definitionLine = 886;
// method "canonicalName"
  struct UserObject *uo3790 = (struct UserObject*)obj3671;
  uo3790->data[18] = emptyclosure;
  Method *meth_meth_ast_canonicalName3790 = addmethod2pos(obj3671, "canonicalName", &meth_ast_canonicalName3790, 18);
  int argcv_meth_ast_canonicalName3790[] = {0};
  meth_meth_ast_canonicalName3790->type = alloc_MethodType(1, argcv_meth_ast_canonicalName3790);
  meth_meth_ast_canonicalName3790->definitionModule = modulename;
  meth_meth_ast_canonicalName3790->definitionLine = 887;
// method "hasParams"
  struct UserObject *uo3804 = (struct UserObject*)obj3671;
  uo3804->data[19] = emptyclosure;
  Method *meth_meth_ast_hasParams3804 = addmethod2pos(obj3671, "hasParams", &meth_ast_hasParams3804, 19);
  int argcv_meth_ast_hasParams3804[] = {0};
  meth_meth_ast_hasParams3804->type = alloc_MethodType(1, argcv_meth_ast_hasParams3804);
  meth_meth_ast_hasParams3804->definitionModule = modulename;
  meth_meth_ast_hasParams3804->definitionLine = 891;
// method "numParamLists"
  struct UserObject *uo3815 = (struct UserObject*)obj3671;
  uo3815->data[20] = emptyclosure;
  Method *meth_meth_ast_numParamLists3815 = addmethod2pos(obj3671, "numParamLists", &meth_ast_numParamLists3815, 20);
  int argcv_meth_ast_numParamLists3815[] = {0};
  meth_meth_ast_numParamLists3815->type = alloc_MethodType(1, argcv_meth_ast_numParamLists3815);
  meth_meth_ast_numParamLists3815->definitionModule = modulename;
  meth_meth_ast_numParamLists3815->definitionLine = 892;
// method "hasTypeParams"
  struct UserObject *uo3836 = (struct UserObject*)obj3671;
  uo3836->data[21] = emptyclosure;
  Method *meth_meth_ast_hasTypeParams3836 = addmethod2pos(obj3671, "hasTypeParams", &meth_ast_hasTypeParams3836, 21);
  int argcv_meth_ast_hasTypeParams3836[] = {0};
  meth_meth_ast_hasTypeParams3836->type = alloc_MethodType(1, argcv_meth_ast_hasTypeParams3836);
  meth_meth_ast_hasTypeParams3836->definitionModule = modulename;
  meth_meth_ast_hasTypeParams3836->definitionLine = 900;
// method "isMethod"
  struct UserObject *uo3847 = (struct UserObject*)obj3671;
  uo3847->data[22] = emptyclosure;
  Method *meth_meth_ast_isMethod3847 = addmethod2pos(obj3671, "isMethod", &meth_ast_isMethod3847, 22);
  int argcv_meth_ast_isMethod3847[] = {0};
  meth_meth_ast_isMethod3847->type = alloc_MethodType(1, argcv_meth_ast_isMethod3847);
  meth_meth_ast_isMethod3847->definitionModule = modulename;
  meth_meth_ast_isMethod3847->definitionLine = 901;
// method "isExecutable"
  struct UserObject *uo3849 = (struct UserObject*)obj3671;
  uo3849->data[23] = emptyclosure;
  Method *meth_meth_ast_isExecutable3849 = addmethod2pos(obj3671, "isExecutable", &meth_ast_isExecutable3849, 23);
  int argcv_meth_ast_isExecutable3849[] = {0};
  meth_meth_ast_isExecutable3849->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3849);
  meth_meth_ast_isExecutable3849->definitionModule = modulename;
  meth_meth_ast_isExecutable3849->definitionLine = 902;
// method "isLegalInTrait"
  struct UserObject *uo3851 = (struct UserObject*)obj3671;
  uo3851->data[24] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3851 = addmethod2pos(obj3671, "isLegalInTrait", &meth_ast_isLegalInTrait3851, 24);
  int argcv_meth_ast_isLegalInTrait3851[] = {0};
  meth_meth_ast_isLegalInTrait3851->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3851);
  meth_meth_ast_isLegalInTrait3851->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3851->definitionLine = 903;
// method "isClass"
  struct UserObject *uo3853 = (struct UserObject*)obj3671;
  uo3853->data[25] = emptyclosure;
  Method *meth_meth_ast_isClass3853 = addmethod2pos(obj3671, "isClass", &meth_ast_isClass3853, 25);
  int argcv_meth_ast_isClass3853[] = {0};
  meth_meth_ast_isClass3853->type = alloc_MethodType(1, argcv_meth_ast_isClass3853);
  meth_meth_ast_isClass3853->definitionModule = modulename;
  meth_meth_ast_isClass3853->definitionLine = 904;
// method "isTrait"
  struct UserObject *uo3861 = (struct UserObject*)obj3671;
  uo3861->data[26] = emptyclosure;
  Method *meth_meth_ast_isTrait3861 = addmethod2pos(obj3671, "isTrait", &meth_ast_isTrait3861, 26);
  int argcv_meth_ast_isTrait3861[] = {0};
  meth_meth_ast_isTrait3861->type = alloc_MethodType(1, argcv_meth_ast_isTrait3861);
  meth_meth_ast_isTrait3861->definitionModule = modulename;
  meth_meth_ast_isTrait3861->definitionLine = 905;
// method "needsArgChecks"
  struct UserObject *uo3872 = (struct UserObject*)obj3671;
  uo3872->data[27] = emptyclosure;
  Method *meth_meth_ast_needsArgChecks3872 = addmethod2pos(obj3671, "needsArgChecks", &meth_ast_needsArgChecks3872, 27);
  int argcv_meth_ast_needsArgChecks3872[] = {0};
  meth_meth_ast_needsArgChecks3872->type = alloc_MethodType(1, argcv_meth_ast_needsArgChecks3872);
  meth_meth_ast_needsArgChecks3872->definitionModule = modulename;
  meth_meth_ast_needsArgChecks3872->definitionLine = 912;
// method "scope:=(_)"
  struct UserObject *uo3910 = (struct UserObject*)obj3671;
  uo3910->data[28] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_3910 = addmethod2pos(obj3671, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_3910, 28);
  int argcv_meth_ast_scope_58__61__40_1_41_3910[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_3910->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_3910);
  meth_meth_ast_scope_58__61__40_1_41_3910->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_3910->definitionLine = 923;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3671);
  Object closure3915 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3915, stackframe);
  addtoclosure(closure3915, var_k);
  struct UserObject *uo3915 = (struct UserObject*)obj3671;
  uo3915->data[29] = (Object)closure3915;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3915 = addmethod2pos(obj3671, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3915, 29);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3915[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3915->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3915);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3915->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3915->definitionLine = 929;
// method "isConfidential"
  struct UserObject *uo3918 = (struct UserObject*)obj3671;
  uo3918->data[30] = emptyclosure;
  Method *meth_meth_ast_isConfidential3918 = addmethod2pos(obj3671, "isConfidential", &meth_ast_isConfidential3918, 30);
  int argcv_meth_ast_isConfidential3918[] = {0};
  meth_meth_ast_isConfidential3918->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3918);
  meth_meth_ast_isConfidential3918->definitionModule = modulename;
  meth_meth_ast_isConfidential3918->definitionLine = 930;
// method "isPublic"
  struct UserObject *uo3936 = (struct UserObject*)obj3671;
  uo3936->data[31] = emptyclosure;
  Method *meth_meth_ast_isPublic3936 = addmethod2pos(obj3671, "isPublic", &meth_ast_isPublic3936, 31);
  int argcv_meth_ast_isPublic3936[] = {0};
  meth_meth_ast_isPublic3936->type = alloc_MethodType(1, argcv_meth_ast_isPublic3936);
  meth_meth_ast_isPublic3936->definitionModule = modulename;
  meth_meth_ast_isPublic3936->definitionLine = 934;
// method "isWritable"
  struct UserObject *uo3941 = (struct UserObject*)obj3671;
  uo3941->data[32] = emptyclosure;
  Method *meth_meth_ast_isWritable3941 = addmethod2pos(obj3671, "isWritable", &meth_ast_isWritable3941, 32);
  int argcv_meth_ast_isWritable3941[] = {0};
  meth_meth_ast_isWritable3941->type = alloc_MethodType(1, argcv_meth_ast_isWritable3941);
  meth_meth_ast_isWritable3941->definitionModule = modulename;
  meth_meth_ast_isWritable3941->definitionLine = 935;
// method "isReadable"
  struct UserObject *uo3943 = (struct UserObject*)obj3671;
  uo3943->data[33] = emptyclosure;
  Method *meth_meth_ast_isReadable3943 = addmethod2pos(obj3671, "isReadable", &meth_ast_isReadable3943, 33);
  int argcv_meth_ast_isReadable3943[] = {0};
  meth_meth_ast_isReadable3943->type = alloc_MethodType(1, argcv_meth_ast_isReadable3943);
  meth_meth_ast_isReadable3943->definitionModule = modulename;
  meth_meth_ast_isReadable3943->definitionLine = 936;
// method "usesAsType(_)"
  struct UserObject *uo3946 = (struct UserObject*)obj3671;
  uo3946->data[34] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_3946 = addmethod2pos(obj3671, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_3946, 34);
  int argcv_meth_ast_usesAsType_40_1_41_3946[] = {1};
  meth_meth_ast_usesAsType_40_1_41_3946->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_3946);
  meth_meth_ast_usesAsType_40_1_41_3946->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_3946->definitionLine = 937;
// method "returnsObject"
  struct UserObject *uo3952 = (struct UserObject*)obj3671;
  uo3952->data[35] = emptyclosure;
  Method *meth_meth_ast_returnsObject3952 = addmethod2pos(obj3671, "returnsObject", &meth_ast_returnsObject3952, 35);
  int argcv_meth_ast_returnsObject3952[] = {0};
  meth_meth_ast_returnsObject3952->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3952);
  meth_meth_ast_returnsObject3952->definitionModule = modulename;
  meth_meth_ast_returnsObject3952->definitionLine = 940;
// method "returnedObjectScope"
  struct UserObject *uo3971 = (struct UserObject*)obj3671;
  uo3971->data[36] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3971 = addmethod2pos(obj3671, "returnedObjectScope", &meth_ast_returnedObjectScope3971, 36);
  int argcv_meth_ast_returnedObjectScope3971[] = {0};
  meth_meth_ast_returnedObjectScope3971->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3971);
  meth_meth_ast_returnedObjectScope3971->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3971->definitionLine = 943;
// method "accept(_)from(_)"
  struct UserObject *uo3978 = (struct UserObject*)obj3671;
  uo3978->data[37] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3978 = addmethod2pos(obj3671, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3978, 37);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3978[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3978->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3978);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3978->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3978->definitionLine = 947;
// method "map(_)ancestors(_)"
  struct UserObject *uo4044 = (struct UserObject*)obj3671;
  uo4044->data[38] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_4044 = addmethod2pos(obj3671, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_4044, 38);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4044[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4044->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4044);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4044->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4044->definitionLine = 970;
// method "pretty(_)"
  struct UserObject *uo4101 = (struct UserObject*)obj3671;
  uo4101->data[39] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_4101 = addmethod2pos(obj3671, "pretty(1)", &meth_ast_pretty_40_1_41_4101, 39);
  int argcv_meth_ast_pretty_40_1_41_4101[] = {1};
  meth_meth_ast_pretty_40_1_41_4101->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_4101);
  meth_meth_ast_pretty_40_1_41_4101->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_4101->definitionLine = 980;
// method "toGrace(_)"
  struct UserObject *uo4491 = (struct UserObject*)obj3671;
  uo4491->data[40] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_4491 = addmethod2pos(obj3671, "toGrace(1)", &meth_ast_toGrace_40_1_41_4491, 40);
  int argcv_meth_ast_toGrace_40_1_41_4491[] = {1};
  meth_meth_ast_toGrace_40_1_41_4491->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_4491);
meth_meth_ast_toGrace_40_1_41_4491->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_4491->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_4491->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_4491->definitionLine = 1025;
// method "shallowCopy"
  block_savedest(obj3671);
  Object closure4738 = createclosure(1, "shallowCopy");
  setclosureframe(closure4738, stackframe);
  addtoclosure(closure4738, var_methodNode);
  struct UserObject *uo4738 = (struct UserObject*)obj3671;
  uo4738->data[41] = (Object)closure4738;
  Method *meth_meth_ast_shallowCopy4738 = addmethod2pos(obj3671, "shallowCopy", &meth_ast_shallowCopy4738, 41);
  int argcv_meth_ast_shallowCopy4738[] = {0};
  meth_meth_ast_shallowCopy4738->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4738);
  meth_meth_ast_shallowCopy4738->definitionModule = modulename;
  meth_meth_ast_shallowCopy4738->definitionLine = 1069;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo4749 = (struct UserObject*)obj3671;
  uo4749->data[42] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4749 = addmethod2pos(obj3671, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_4749, 42);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_4749[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4749->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_4749);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4749->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4749->definitionLine = 1072;
  sourceObject = obj3671;
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4767 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4768 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4769 = gc_frame_new();
// call case 3: self.outer request
  Object call4770 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4769);
// compiled member node returning call4770 (depth = 5)
  Object call4771 = callmethodflags(call4770, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4768);
// compiled member node returning call4771 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4772 = callmethodflags(call4771, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4767);
// compiled call node returning call4772 (depth = 3)
  struct UserObject *obj3671_uo = (struct UserObject *)obj3671;
  obj3671_uo->super = call4772;
  sourceObject = obj3671;
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4773 == NULL) {
    strlit4773 = alloc_String("method");
    gc_root(strlit4773);
  }
// compiled string node returning strlit4773 (depth = 3)
  adddatum2(obj3671, strlit4773, 1);
  sourceObject = obj3671;
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3671, *var_signature_39_, 2);
  sourceObject = obj3671;
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3671, *var_body_39_, 3);
  sourceObject = obj3671;
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3671, *var_dtype_39_, 4);
  sourceObject = obj3671;
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4774 = alloc_Boolean(0);
// compiled identifier node returning bool4774 (depth = 3)
  adddatum2(obj3671, bool4774, 5);
  sourceObject = obj3671;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4775 = alloc_Boolean(0);
// compiled identifier node returning bool4775 (depth = 3)
  adddatum2(obj3671, bool4775, 6);
  sourceObject = obj3671;
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array4776 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4776 (depth = 3)
  adddatum2(obj3671, array4776, 7);
  sourceObject = obj3671;
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4777 = alloc_Boolean(0);
// compiled identifier node returning bool4777 (depth = 3)
  adddatum2(obj3671, bool4777, 8);
  sourceObject = obj3671;
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4778 = alloc_Boolean(0);
// compiled identifier node returning bool4778 (depth = 3)
  adddatum2(obj3671, bool4778, 9);
  sourceObject = obj3671;
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj3671, *var_uninitialized, 10);
  sourceObject = obj3671;
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4779 = alloc_Boolean(1);
// compiled identifier node returning bool4779 (depth = 3)
  adddatum2(obj3671, bool4779, 11);
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  objclass3671 = obj3671->class;
  objclass3671->definitionModule = modulename;
  objclass3671->definitionLine = 837;
  (*(struct UserObject *)self).data[0] = lowerouter3671;
  self = oldself3671;
  selfslot = oldselfslot3671;
  stackframe = oldstackframe3671;
  gc_frame_end(frame);
  return obj3671;
}
Object meth_ast_new_40_3_41_3670_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3671 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3671 = alloc_userobj2(52,43, objclass3671);
  gc_frame_newslot(obj3671);
if (objclass3671 == NULL) {
  glfree(obj3671->class->name);
  obj3671->class->name = "methodNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3671, self, 0);
  addmethodreal(obj3671,"outer", &reader_ast_outer_3672);
  Object oldself3671 = self;
  struct StackFrameObject *oldstackframe3671 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3671);
  gc_frame_newslot((Object)stackframe);
  self = obj3671;
  Object *oldselfslot3671 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3671 = (*(struct UserObject *)self).data[0], lowerouter3671 = thisouter3671;
  if (inheritingObject3671) {
    struct UserObject *inho3671 = (struct UserObject *)inheritingObject3671;
    while (inho3671->super != GraceDefaultObject) inho3671 = (struct UserObject *)inho3671->super;
    inho3671->super = obj3671;
    self = inheritingObject3671;
    *selfslot = self;
    lowerouter3671 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3671;
  }
if (objclass3671 == NULL) {
  Method *reader3673 = addmethodrealflags(obj3671, "kind",&reader_ast_kind_3673, MFLAG_DEF);
  reader3673->definitionModule = modulename;
  reader3673->definitionLine = 845;
}
adddatum2(obj3671, alloc_Undefined(), 1);
if (objclass3671 == NULL) {
  Method *reader3674 = addmethodrealflags(obj3671, "signature", &reader_ast_signature_3674, 0);
  Method *writer3674 = addmethodrealflags(obj3671, "signature:=(1)", &writer_ast_signature_3674, 0);
  reader3674->definitionModule = modulename;
  writer3674->definitionModule = modulename;
  reader3674->definitionLine = 846;
  writer3674->definitionLine = 846;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 2);
if (objclass3671 == NULL) {
  Method *reader3675 = addmethodrealflags(obj3671, "body", &reader_ast_body_3675, 0);
  Method *writer3675 = addmethodrealflags(obj3671, "body:=(1)", &writer_ast_body_3675, 0);
  reader3675->definitionModule = modulename;
  writer3675->definitionModule = modulename;
  reader3675->definitionLine = 847;
  writer3675->definitionLine = 847;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 3);
if (objclass3671 == NULL) {
  Method *reader3676 = addmethodrealflags(obj3671, "dtype", &reader_ast_dtype_3676, 0);
  Method *writer3676 = addmethodrealflags(obj3671, "dtype:=(1)", &writer_ast_dtype_3676, 0);
  reader3676->definitionModule = modulename;
  writer3676->definitionModule = modulename;
  reader3676->definitionLine = 848;
  writer3676->definitionLine = 848;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 4);
if (objclass3671 == NULL) {
  Method *reader3677 = addmethodrealflags(obj3671, "typeParams", &reader_ast_typeParams_3677, 0);
  Method *writer3677 = addmethodrealflags(obj3671, "typeParams:=(1)", &writer_ast_typeParams_3677, 0);
  reader3677->definitionModule = modulename;
  writer3677->definitionModule = modulename;
  reader3677->definitionLine = 849;
  writer3677->definitionLine = 849;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 5);
if (objclass3671 == NULL) {
  Method *reader3678 = addmethodrealflags(obj3671, "selfclosure", &reader_ast_selfclosure_3678, 0);
  Method *writer3678 = addmethodrealflags(obj3671, "selfclosure:=(1)", &writer_ast_selfclosure_3678, 0);
  reader3678->definitionModule = modulename;
  writer3678->definitionModule = modulename;
  reader3678->definitionLine = 850;
  writer3678->definitionLine = 850;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 6);
if (objclass3671 == NULL) {
  Method *reader3679 = addmethodrealflags(obj3671, "annotations", &reader_ast_annotations_3679, 0);
  Method *writer3679 = addmethodrealflags(obj3671, "annotations:=(1)", &writer_ast_annotations_3679, 0);
  reader3679->definitionModule = modulename;
  writer3679->definitionModule = modulename;
  reader3679->definitionLine = 851;
  writer3679->definitionLine = 851;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 7);
if (objclass3671 == NULL) {
  Method *reader3680 = addmethodrealflags(obj3671, "isFresh", &reader_ast_isFresh_3680, 0);
  Method *writer3680 = addmethodrealflags(obj3671, "isFresh:=(1)", &writer_ast_isFresh_3680, 0);
  reader3680->definitionModule = modulename;
  writer3680->definitionModule = modulename;
  reader3680->definitionLine = 852;
  writer3680->definitionLine = 852;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 8);
if (objclass3671 == NULL) {
  Method *reader3681 = addmethodrealflags(obj3671, "usesClassSyntax", &reader_ast_usesClassSyntax_3681, 0);
  Method *writer3681 = addmethodrealflags(obj3671, "usesClassSyntax:=(1)", &writer_ast_usesClassSyntax_3681, 0);
  reader3681->definitionModule = modulename;
  writer3681->definitionModule = modulename;
  reader3681->definitionLine = 853;
  writer3681->definitionLine = 853;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 9);
if (objclass3671 == NULL) {
  Method *reader3682 = addmethodrealflags(obj3671, "cachedIdentifier", &reader_ast_cachedIdentifier_3682, MFLAG_CONFIDENTIAL);
  Method *writer3682 = addmethodrealflags(obj3671, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_3682, MFLAG_CONFIDENTIAL);
  reader3682->definitionModule = modulename;
  writer3682->definitionModule = modulename;
  reader3682->definitionLine = 854;
  writer3682->definitionLine = 854;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 10);
if (objclass3671 == NULL) {
  Method *reader3683 = addmethodrealflags(obj3671, "isBindingOccurence", &reader_ast_isBindingOccurence_3683, 0);
  Method *writer3683 = addmethodrealflags(obj3671, "isBindingOccurence:=(1)", &writer_ast_isBindingOccurence_3683, MFLAG_CONFIDENTIAL);
  reader3683->definitionModule = modulename;
  writer3683->definitionModule = modulename;
  reader3683->definitionLine = 855;
  writer3683->definitionLine = 855;
}
obj3671->flags |= OFLAG_MUTABLE;
adddatum2(obj3671, alloc_Undefined(), 11);
// method "appliedOccurence"
  block_savedest(obj3671);
  Object closure3684 = createclosure(1, "appliedOccurence");
  setclosureframe(closure3684, stackframe);
  addtoclosure(closure3684, var_uninitialized);
  struct UserObject *uo3684 = (struct UserObject*)obj3671;
  uo3684->data[12] = (Object)closure3684;
  Method *meth_meth_ast_appliedOccurence3684 = addmethod2pos(obj3671, "appliedOccurence", &meth_ast_appliedOccurence3684, 12);
  int argcv_meth_ast_appliedOccurence3684[] = {0};
  meth_meth_ast_appliedOccurence3684->type = alloc_MethodType(1, argcv_meth_ast_appliedOccurence3684);
  meth_meth_ast_appliedOccurence3684->definitionModule = modulename;
  meth_meth_ast_appliedOccurence3684->definitionLine = 858;
// method "numParams"
  struct UserObject *uo3699 = (struct UserObject*)obj3671;
  uo3699->data[13] = emptyclosure;
  Method *meth_meth_ast_numParams3699 = addmethod2pos(obj3671, "numParams", &meth_ast_numParams3699, 13);
  int argcv_meth_ast_numParams3699[] = {0};
  meth_meth_ast_numParams3699->type = alloc_MethodType(1, argcv_meth_ast_numParams3699);
  meth_meth_ast_numParams3699->definitionModule = modulename;
  meth_meth_ast_numParams3699->definitionLine = 865;
// method "endPos"
  struct UserObject *uo3713 = (struct UserObject*)obj3671;
  uo3713->data[14] = emptyclosure;
  Method *meth_meth_ast_endPos3713 = addmethod2pos(obj3671, "endPos", &meth_ast_endPos3713, 14);
  int argcv_meth_ast_endPos3713[] = {0};
  meth_meth_ast_endPos3713->type = alloc_MethodType(1, argcv_meth_ast_endPos3713);
  meth_meth_ast_endPos3713->definitionModule = modulename;
  meth_meth_ast_endPos3713->definitionLine = 868;
// method "nameString"
  struct UserObject *uo3731 = (struct UserObject*)obj3671;
  uo3731->data[15] = emptyclosure;
  Method *meth_meth_ast_nameString3731 = addmethod2pos(obj3671, "nameString", &meth_ast_nameString3731, 15);
  int argcv_meth_ast_nameString3731[] = {0};
  meth_meth_ast_nameString3731->type = alloc_MethodType(1, argcv_meth_ast_nameString3731);
  meth_meth_ast_nameString3731->definitionModule = modulename;
  meth_meth_ast_nameString3731->definitionLine = 873;
// method "asIdentifier"
  block_savedest(obj3671);
  Object closure3745 = createclosure(2, "asIdentifier");
  setclosureframe(closure3745, stackframe);
  addtoclosure(closure3745, var_uninitialized);
  addtoclosure(closure3745, var_identifierNode);
  struct UserObject *uo3745 = (struct UserObject*)obj3671;
  uo3745->data[16] = (Object)closure3745;
  Method *meth_meth_ast_asIdentifier3745 = addmethod2pos(obj3671, "asIdentifier", &meth_ast_asIdentifier3745, 16);
  int argcv_meth_ast_asIdentifier3745[] = {0};
  meth_meth_ast_asIdentifier3745->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier3745);
  meth_meth_ast_asIdentifier3745->definitionModule = modulename;
  meth_meth_ast_asIdentifier3745->definitionLine = 877;
// method "value"
  struct UserObject *uo3787 = (struct UserObject*)obj3671;
  uo3787->data[17] = emptyclosure;
  Method *meth_meth_ast_value3787 = addmethod2pos(obj3671, "value", &meth_ast_value3787, 17);
  int argcv_meth_ast_value3787[] = {0};
  meth_meth_ast_value3787->type = alloc_MethodType(1, argcv_meth_ast_value3787);
  meth_meth_ast_value3787->definitionModule = modulename;
  meth_meth_ast_value3787->definitionLine = 886;
// method "canonicalName"
  struct UserObject *uo3790 = (struct UserObject*)obj3671;
  uo3790->data[18] = emptyclosure;
  Method *meth_meth_ast_canonicalName3790 = addmethod2pos(obj3671, "canonicalName", &meth_ast_canonicalName3790, 18);
  int argcv_meth_ast_canonicalName3790[] = {0};
  meth_meth_ast_canonicalName3790->type = alloc_MethodType(1, argcv_meth_ast_canonicalName3790);
  meth_meth_ast_canonicalName3790->definitionModule = modulename;
  meth_meth_ast_canonicalName3790->definitionLine = 887;
// method "hasParams"
  struct UserObject *uo3804 = (struct UserObject*)obj3671;
  uo3804->data[19] = emptyclosure;
  Method *meth_meth_ast_hasParams3804 = addmethod2pos(obj3671, "hasParams", &meth_ast_hasParams3804, 19);
  int argcv_meth_ast_hasParams3804[] = {0};
  meth_meth_ast_hasParams3804->type = alloc_MethodType(1, argcv_meth_ast_hasParams3804);
  meth_meth_ast_hasParams3804->definitionModule = modulename;
  meth_meth_ast_hasParams3804->definitionLine = 891;
// method "numParamLists"
  struct UserObject *uo3815 = (struct UserObject*)obj3671;
  uo3815->data[20] = emptyclosure;
  Method *meth_meth_ast_numParamLists3815 = addmethod2pos(obj3671, "numParamLists", &meth_ast_numParamLists3815, 20);
  int argcv_meth_ast_numParamLists3815[] = {0};
  meth_meth_ast_numParamLists3815->type = alloc_MethodType(1, argcv_meth_ast_numParamLists3815);
  meth_meth_ast_numParamLists3815->definitionModule = modulename;
  meth_meth_ast_numParamLists3815->definitionLine = 892;
// method "hasTypeParams"
  struct UserObject *uo3836 = (struct UserObject*)obj3671;
  uo3836->data[21] = emptyclosure;
  Method *meth_meth_ast_hasTypeParams3836 = addmethod2pos(obj3671, "hasTypeParams", &meth_ast_hasTypeParams3836, 21);
  int argcv_meth_ast_hasTypeParams3836[] = {0};
  meth_meth_ast_hasTypeParams3836->type = alloc_MethodType(1, argcv_meth_ast_hasTypeParams3836);
  meth_meth_ast_hasTypeParams3836->definitionModule = modulename;
  meth_meth_ast_hasTypeParams3836->definitionLine = 900;
// method "isMethod"
  struct UserObject *uo3847 = (struct UserObject*)obj3671;
  uo3847->data[22] = emptyclosure;
  Method *meth_meth_ast_isMethod3847 = addmethod2pos(obj3671, "isMethod", &meth_ast_isMethod3847, 22);
  int argcv_meth_ast_isMethod3847[] = {0};
  meth_meth_ast_isMethod3847->type = alloc_MethodType(1, argcv_meth_ast_isMethod3847);
  meth_meth_ast_isMethod3847->definitionModule = modulename;
  meth_meth_ast_isMethod3847->definitionLine = 901;
// method "isExecutable"
  struct UserObject *uo3849 = (struct UserObject*)obj3671;
  uo3849->data[23] = emptyclosure;
  Method *meth_meth_ast_isExecutable3849 = addmethod2pos(obj3671, "isExecutable", &meth_ast_isExecutable3849, 23);
  int argcv_meth_ast_isExecutable3849[] = {0};
  meth_meth_ast_isExecutable3849->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3849);
  meth_meth_ast_isExecutable3849->definitionModule = modulename;
  meth_meth_ast_isExecutable3849->definitionLine = 902;
// method "isLegalInTrait"
  struct UserObject *uo3851 = (struct UserObject*)obj3671;
  uo3851->data[24] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3851 = addmethod2pos(obj3671, "isLegalInTrait", &meth_ast_isLegalInTrait3851, 24);
  int argcv_meth_ast_isLegalInTrait3851[] = {0};
  meth_meth_ast_isLegalInTrait3851->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3851);
  meth_meth_ast_isLegalInTrait3851->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3851->definitionLine = 903;
// method "isClass"
  struct UserObject *uo3853 = (struct UserObject*)obj3671;
  uo3853->data[25] = emptyclosure;
  Method *meth_meth_ast_isClass3853 = addmethod2pos(obj3671, "isClass", &meth_ast_isClass3853, 25);
  int argcv_meth_ast_isClass3853[] = {0};
  meth_meth_ast_isClass3853->type = alloc_MethodType(1, argcv_meth_ast_isClass3853);
  meth_meth_ast_isClass3853->definitionModule = modulename;
  meth_meth_ast_isClass3853->definitionLine = 904;
// method "isTrait"
  struct UserObject *uo3861 = (struct UserObject*)obj3671;
  uo3861->data[26] = emptyclosure;
  Method *meth_meth_ast_isTrait3861 = addmethod2pos(obj3671, "isTrait", &meth_ast_isTrait3861, 26);
  int argcv_meth_ast_isTrait3861[] = {0};
  meth_meth_ast_isTrait3861->type = alloc_MethodType(1, argcv_meth_ast_isTrait3861);
  meth_meth_ast_isTrait3861->definitionModule = modulename;
  meth_meth_ast_isTrait3861->definitionLine = 905;
// method "needsArgChecks"
  struct UserObject *uo3872 = (struct UserObject*)obj3671;
  uo3872->data[27] = emptyclosure;
  Method *meth_meth_ast_needsArgChecks3872 = addmethod2pos(obj3671, "needsArgChecks", &meth_ast_needsArgChecks3872, 27);
  int argcv_meth_ast_needsArgChecks3872[] = {0};
  meth_meth_ast_needsArgChecks3872->type = alloc_MethodType(1, argcv_meth_ast_needsArgChecks3872);
  meth_meth_ast_needsArgChecks3872->definitionModule = modulename;
  meth_meth_ast_needsArgChecks3872->definitionLine = 912;
// method "scope:=(_)"
  struct UserObject *uo3910 = (struct UserObject*)obj3671;
  uo3910->data[28] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_3910 = addmethod2pos(obj3671, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_3910, 28);
  int argcv_meth_ast_scope_58__61__40_1_41_3910[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_3910->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_3910);
  meth_meth_ast_scope_58__61__40_1_41_3910->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_3910->definitionLine = 923;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3671);
  Object closure3915 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3915, stackframe);
  addtoclosure(closure3915, var_k);
  struct UserObject *uo3915 = (struct UserObject*)obj3671;
  uo3915->data[29] = (Object)closure3915;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3915 = addmethod2pos(obj3671, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3915, 29);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3915[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3915->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3915);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3915->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3915->definitionLine = 929;
// method "isConfidential"
  struct UserObject *uo3918 = (struct UserObject*)obj3671;
  uo3918->data[30] = emptyclosure;
  Method *meth_meth_ast_isConfidential3918 = addmethod2pos(obj3671, "isConfidential", &meth_ast_isConfidential3918, 30);
  int argcv_meth_ast_isConfidential3918[] = {0};
  meth_meth_ast_isConfidential3918->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3918);
  meth_meth_ast_isConfidential3918->definitionModule = modulename;
  meth_meth_ast_isConfidential3918->definitionLine = 930;
// method "isPublic"
  struct UserObject *uo3936 = (struct UserObject*)obj3671;
  uo3936->data[31] = emptyclosure;
  Method *meth_meth_ast_isPublic3936 = addmethod2pos(obj3671, "isPublic", &meth_ast_isPublic3936, 31);
  int argcv_meth_ast_isPublic3936[] = {0};
  meth_meth_ast_isPublic3936->type = alloc_MethodType(1, argcv_meth_ast_isPublic3936);
  meth_meth_ast_isPublic3936->definitionModule = modulename;
  meth_meth_ast_isPublic3936->definitionLine = 934;
// method "isWritable"
  struct UserObject *uo3941 = (struct UserObject*)obj3671;
  uo3941->data[32] = emptyclosure;
  Method *meth_meth_ast_isWritable3941 = addmethod2pos(obj3671, "isWritable", &meth_ast_isWritable3941, 32);
  int argcv_meth_ast_isWritable3941[] = {0};
  meth_meth_ast_isWritable3941->type = alloc_MethodType(1, argcv_meth_ast_isWritable3941);
  meth_meth_ast_isWritable3941->definitionModule = modulename;
  meth_meth_ast_isWritable3941->definitionLine = 935;
// method "isReadable"
  struct UserObject *uo3943 = (struct UserObject*)obj3671;
  uo3943->data[33] = emptyclosure;
  Method *meth_meth_ast_isReadable3943 = addmethod2pos(obj3671, "isReadable", &meth_ast_isReadable3943, 33);
  int argcv_meth_ast_isReadable3943[] = {0};
  meth_meth_ast_isReadable3943->type = alloc_MethodType(1, argcv_meth_ast_isReadable3943);
  meth_meth_ast_isReadable3943->definitionModule = modulename;
  meth_meth_ast_isReadable3943->definitionLine = 936;
// method "usesAsType(_)"
  struct UserObject *uo3946 = (struct UserObject*)obj3671;
  uo3946->data[34] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_3946 = addmethod2pos(obj3671, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_3946, 34);
  int argcv_meth_ast_usesAsType_40_1_41_3946[] = {1};
  meth_meth_ast_usesAsType_40_1_41_3946->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_3946);
  meth_meth_ast_usesAsType_40_1_41_3946->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_3946->definitionLine = 937;
// method "returnsObject"
  struct UserObject *uo3952 = (struct UserObject*)obj3671;
  uo3952->data[35] = emptyclosure;
  Method *meth_meth_ast_returnsObject3952 = addmethod2pos(obj3671, "returnsObject", &meth_ast_returnsObject3952, 35);
  int argcv_meth_ast_returnsObject3952[] = {0};
  meth_meth_ast_returnsObject3952->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3952);
  meth_meth_ast_returnsObject3952->definitionModule = modulename;
  meth_meth_ast_returnsObject3952->definitionLine = 940;
// method "returnedObjectScope"
  struct UserObject *uo3971 = (struct UserObject*)obj3671;
  uo3971->data[36] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3971 = addmethod2pos(obj3671, "returnedObjectScope", &meth_ast_returnedObjectScope3971, 36);
  int argcv_meth_ast_returnedObjectScope3971[] = {0};
  meth_meth_ast_returnedObjectScope3971->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3971);
  meth_meth_ast_returnedObjectScope3971->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3971->definitionLine = 943;
// method "accept(_)from(_)"
  struct UserObject *uo3978 = (struct UserObject*)obj3671;
  uo3978->data[37] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3978 = addmethod2pos(obj3671, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3978, 37);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3978[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3978->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3978);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3978->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3978->definitionLine = 947;
// method "map(_)ancestors(_)"
  struct UserObject *uo4044 = (struct UserObject*)obj3671;
  uo4044->data[38] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_4044 = addmethod2pos(obj3671, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_4044, 38);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4044[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4044->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4044);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4044->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4044->definitionLine = 970;
// method "pretty(_)"
  struct UserObject *uo4101 = (struct UserObject*)obj3671;
  uo4101->data[39] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_4101 = addmethod2pos(obj3671, "pretty(1)", &meth_ast_pretty_40_1_41_4101, 39);
  int argcv_meth_ast_pretty_40_1_41_4101[] = {1};
  meth_meth_ast_pretty_40_1_41_4101->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_4101);
  meth_meth_ast_pretty_40_1_41_4101->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_4101->definitionLine = 980;
// method "toGrace(_)"
  struct UserObject *uo4491 = (struct UserObject*)obj3671;
  uo4491->data[40] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_4491 = addmethod2pos(obj3671, "toGrace(1)", &meth_ast_toGrace_40_1_41_4491, 40);
  int argcv_meth_ast_toGrace_40_1_41_4491[] = {1};
  meth_meth_ast_toGrace_40_1_41_4491->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_4491);
meth_meth_ast_toGrace_40_1_41_4491->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_4491->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_4491->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_4491->definitionLine = 1025;
// method "shallowCopy"
  block_savedest(obj3671);
  Object closure4738 = createclosure(1, "shallowCopy");
  setclosureframe(closure4738, stackframe);
  addtoclosure(closure4738, var_methodNode);
  struct UserObject *uo4738 = (struct UserObject*)obj3671;
  uo4738->data[41] = (Object)closure4738;
  Method *meth_meth_ast_shallowCopy4738 = addmethod2pos(obj3671, "shallowCopy", &meth_ast_shallowCopy4738, 41);
  int argcv_meth_ast_shallowCopy4738[] = {0};
  meth_meth_ast_shallowCopy4738->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4738);
  meth_meth_ast_shallowCopy4738->definitionModule = modulename;
  meth_meth_ast_shallowCopy4738->definitionLine = 1069;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo4749 = (struct UserObject*)obj3671;
  uo4749->data[42] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4749 = addmethod2pos(obj3671, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_4749, 42);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_4749[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4749->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_4749);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4749->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4749->definitionLine = 1072;
  sourceObject = obj3671;
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4767 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4768 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4769 = gc_frame_new();
// call case 3: self.outer request
  Object call4770 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4769);
// compiled member node returning call4770 (depth = 5)
  Object call4771 = callmethodflags(call4770, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4768);
// compiled member node returning call4771 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4772 = callmethodflags(call4771, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4767);
// compiled call node returning call4772 (depth = 3)
  struct UserObject *obj3671_uo = (struct UserObject *)obj3671;
  obj3671_uo->super = call4772;
  sourceObject = obj3671;
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4773 == NULL) {
    strlit4773 = alloc_String("method");
    gc_root(strlit4773);
  }
// compiled string node returning strlit4773 (depth = 3)
  adddatum2(obj3671, strlit4773, 1);
  sourceObject = obj3671;
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3671, *var_signature_39_, 2);
  sourceObject = obj3671;
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3671, *var_body_39_, 3);
  sourceObject = obj3671;
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3671, *var_dtype_39_, 4);
  sourceObject = obj3671;
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4774 = alloc_Boolean(0);
// compiled identifier node returning bool4774 (depth = 3)
  adddatum2(obj3671, bool4774, 5);
  sourceObject = obj3671;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4775 = alloc_Boolean(0);
// compiled identifier node returning bool4775 (depth = 3)
  adddatum2(obj3671, bool4775, 6);
  sourceObject = obj3671;
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array4776 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4776 (depth = 3)
  adddatum2(obj3671, array4776, 7);
  sourceObject = obj3671;
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4777 = alloc_Boolean(0);
// compiled identifier node returning bool4777 (depth = 3)
  adddatum2(obj3671, bool4777, 8);
  sourceObject = obj3671;
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4778 = alloc_Boolean(0);
// compiled identifier node returning bool4778 (depth = 3)
  adddatum2(obj3671, bool4778, 9);
  sourceObject = obj3671;
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj3671, *var_uninitialized, 10);
  sourceObject = obj3671;
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4779 = alloc_Boolean(1);
// compiled identifier node returning bool4779 (depth = 3)
  adddatum2(obj3671, bool4779, 11);
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  sourceObject = obj3671;
  objclass3671 = obj3671->class;
  objclass3671->definitionModule = modulename;
  objclass3671->definitionLine = 837;
  (*(struct UserObject *)self).data[0] = lowerouter3671;
  self = oldself3671;
  selfslot = oldselfslot3671;
  stackframe = oldstackframe3671;
  gc_frame_end(frame);
  return obj3671;
}
Object meth_ast_methodNode4781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast_new_40_2_41_scope_40_1_41_4784(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_receiver = &(stackframe->slots[0]);
  *var_receiver = args[curarg];
  curarg++;
  Object *var_parts = &(stackframe->slots[1]);
  *var_parts = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4785 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_parts (depth = 5)
  gc_frame_newslot(*var_parts);
// call case 4: self request
  params[0] = *var_receiver;
  params[1] = *var_parts;
  partcv[0] = 2;
  Object call4786 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4785);
// compiled call node returning call4786 (depth = 4)
  *var_result = call4786;
  if (call4786 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4787 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call4788 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4787);
// compiled call node returning call4788 (depth = 3)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_onSelf4798(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4799 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool4800 = alloc_Boolean(1);
// compiled identifier node returning bool4800 (depth = 4)
  gc_frame_newslot(bool4800);
// call case 4: self request
  params[0] = bool4800;
  partcv[0] = 1;
  Object call4801 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4799);
// compiled call node returning call4801 (depth = 3)
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply_40_2_41_4805(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4807 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call4808 = callmethodflags(*var_each, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe4807);
// compiled member node returning call4808 (depth = 6)
  int op_slot_right_4806 = gc_frame_newslot(call4808);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_4806 = gc_frame_newslot(*var_acc);
  params[0] = call4808;
  partcv[0] = 1;
  Object opresult4810 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4810 (depth = 5)
  gc_frame_end(frame);
  return opresult4810;
}
Object meth_ast_nameString4802(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4803 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4804 = alloc_Block(NULL, NULL, "ast", 1110);
  gc_frame_newslot(block4804);
// method "_apply(_,_)"
  block_savedest(block4804);
  Object closure4805 = createclosure(1, "_apply(2)");
  setclosureframe(closure4805, stackframe);
  addtoclosure(closure4805, selfslot);
  struct UserObject *uo4805 = (struct UserObject*)block4804;
  uo4805->data[0] = (Object)closure4805;
  Method *meth_meth_ast__apply_40_2_41_4805 = addmethod2pos(block4804, "_apply(2)", &meth_ast__apply_40_2_41_4805, 0);
  int argcv_meth_ast__apply_40_2_41_4805[] = {2};
  meth_meth_ast__apply_40_2_41_4805->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_4805);
  meth_meth_ast__apply_40_2_41_4805->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_4805->definitionLine = 2969;
// compiled block node returning block4804 (depth = 4)
  gc_frame_newslot(block4804);
// starting to compile string node (depth = 4)
  if (strlit4812 == NULL) {
    strlit4812 = alloc_String("");
    gc_root(strlit4812);
  }
// compiled string node returning strlit4812 (depth = 4)
  gc_frame_newslot(strlit4812);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4813 = gc_frame_new();
// call case 4: self request
  Object call4814 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4813);
// compiled member node returning call4814 (depth = 4)
  params[0] = block4804;
  params[1] = strlit4812;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4815 = callmethodflags(call4814, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4803);
// compiled call node returning call4815 (depth = 3)
  gc_frame_end(frame);
  return call4815;
}
Object meth_ast__apply_40_2_41_4819(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4821 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call4822 = callmethodflags(*var_each, "canonicalName", 0, partcv, params, 0);
  gc_frame_end(callframe4821);
// compiled member node returning call4822 (depth = 6)
  int op_slot_right_4820 = gc_frame_newslot(call4822);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_4820 = gc_frame_newslot(*var_acc);
  params[0] = call4822;
  partcv[0] = 1;
  Object opresult4824 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4824 (depth = 5)
  gc_frame_end(frame);
  return opresult4824;
}
Object meth_ast_canonicalName4816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4817 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4818 = alloc_Block(NULL, NULL, "ast", 1115);
  gc_frame_newslot(block4818);
// method "_apply(_,_)"
  block_savedest(block4818);
  Object closure4819 = createclosure(1, "_apply(2)");
  setclosureframe(closure4819, stackframe);
  addtoclosure(closure4819, selfslot);
  struct UserObject *uo4819 = (struct UserObject*)block4818;
  uo4819->data[0] = (Object)closure4819;
  Method *meth_meth_ast__apply_40_2_41_4819 = addmethod2pos(block4818, "_apply(2)", &meth_ast__apply_40_2_41_4819, 0);
  int argcv_meth_ast__apply_40_2_41_4819[] = {2};
  meth_meth_ast__apply_40_2_41_4819->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_4819);
  meth_meth_ast__apply_40_2_41_4819->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_4819->definitionLine = 2969;
// compiled block node returning block4818 (depth = 4)
  gc_frame_newslot(block4818);
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4826 == NULL) {
    strlit4826 = alloc_String("");
    gc_root(strlit4826);
  }
// compiled string node returning strlit4826 (depth = 4)
  gc_frame_newslot(strlit4826);
// call case 6: other requests
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4827 = gc_frame_new();
// call case 4: self request
  Object call4828 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4827);
// compiled member node returning call4828 (depth = 4)
  params[0] = block4818;
  params[1] = strlit4826;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4829 = callmethodflags(call4828, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4817);
// compiled call node returning call4829 (depth = 3)
  gc_frame_end(frame);
  return call4829;
}
Object meth_ast_isCall4830(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4831 = alloc_Boolean(1);
// compiled identifier node returning bool4831 (depth = 3)
  gc_frame_end(frame);
  return bool4831;
}
Object meth_ast_returnsObject4832(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4836 == NULL) {
    strlit4836 = alloc_String("clone(1)");
    gc_root(strlit4836);
  }
// compiled string node returning strlit4836 (depth = 6)
  int op_slot_right_4835 = gc_frame_newslot(strlit4836);
// starting to compile member node (depth = 6)
  int callframe4838 = gc_frame_new();
// call case 4: self request
  Object call4839 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4838);
// compiled member node returning call4839 (depth = 6)
  int op_slot_left_4835 = gc_frame_newslot(call4839);
  params[0] = strlit4836;
  partcv[0] = 1;
  Object opresult4840 = callmethod(call4839, "==(1)", 1, partcv, params);
// compiled op node returning opresult4840 (depth = 5)
  int op_slot_right_4834 = gc_frame_newslot(opresult4840);
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4843 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4844 = gc_frame_new();
// call case 4: self request
  Object call4845 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4844);
// compiled member node returning call4845 (depth = 7)
  Object call4846 = callmethodflags(call4845, "isPrelude", 0, partcv, params, 0);
  gc_frame_end(callframe4843);
// compiled member node returning call4846 (depth = 6)
  int op_slot_right_4842 = gc_frame_newslot(call4846);
// starting to compile member node (depth = 6)
  int callframe4848 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4849 = gc_frame_new();
// call case 4: self request
  Object call4850 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4849);
// compiled member node returning call4850 (depth = 7)
  Object call4851 = callmethodflags(call4850, "isImplicit", 0, partcv, params, 0);
  gc_frame_end(callframe4848);
// compiled member node returning call4851 (depth = 6)
  int op_slot_left_4842 = gc_frame_newslot(call4851);
  params[0] = call4846;
  partcv[0] = 1;
  Object opresult4852 = callmethod(call4851, "||(1)", 1, partcv, params);
// compiled op node returning opresult4852 (depth = 5)
  int op_slot_left_4834 = gc_frame_newslot(opresult4852);
  params[0] = opresult4840;
  partcv[0] = 1;
  Object opresult4853 = callmethod(opresult4852, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4853 (depth = 4)
  Object if4833 = done;
  if (istrue(opresult4853)) {
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4854 = alloc_Boolean(1);
// compiled identifier node returning bool4854 (depth = 5)
  return bool4854;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4833 = undefined;
  } else {
  }
// compiled if node returning if4833 (depth = 3)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4858 == NULL) {
    strlit4858 = alloc_String("copy");
    gc_root(strlit4858);
  }
// compiled string node returning strlit4858 (depth = 6)
  int op_slot_right_4857 = gc_frame_newslot(strlit4858);
// starting to compile member node (depth = 6)
  int callframe4860 = gc_frame_new();
// call case 4: self request
  Object call4861 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4860);
// compiled member node returning call4861 (depth = 6)
  int op_slot_left_4857 = gc_frame_newslot(call4861);
  params[0] = strlit4858;
  partcv[0] = 1;
  Object opresult4862 = callmethod(call4861, "==(1)", 1, partcv, params);
// compiled op node returning opresult4862 (depth = 5)
  int op_slot_right_4856 = gc_frame_newslot(opresult4862);
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4865 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4866 = gc_frame_new();
// call case 4: self request
  Object call4867 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4866);
// compiled member node returning call4867 (depth = 7)
  Object call4868 = callmethodflags(call4867, "isSelf", 0, partcv, params, 0);
  gc_frame_end(callframe4865);
// compiled member node returning call4868 (depth = 6)
  int op_slot_right_4864 = gc_frame_newslot(call4868);
// starting to compile member node (depth = 6)
  int callframe4870 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4871 = gc_frame_new();
// call case 4: self request
  Object call4872 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4871);
// compiled member node returning call4872 (depth = 7)
  Object call4873 = callmethodflags(call4872, "isImplicit", 0, partcv, params, 0);
  gc_frame_end(callframe4870);
// compiled member node returning call4873 (depth = 6)
  int op_slot_left_4864 = gc_frame_newslot(call4873);
  params[0] = call4868;
  partcv[0] = 1;
  Object opresult4874 = callmethod(call4873, "||(1)", 1, partcv, params);
// compiled op node returning opresult4874 (depth = 5)
  int op_slot_left_4856 = gc_frame_newslot(opresult4874);
  params[0] = opresult4862;
  partcv[0] = 1;
  Object opresult4875 = callmethod(opresult4874, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4875 (depth = 4)
  Object if4855 = done;
  if (istrue(opresult4875)) {
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4876 = alloc_Boolean(1);
// compiled identifier node returning bool4876 (depth = 5)
  return bool4876;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4855 = undefined;
  } else {
  }
// compiled if node returning if4855 (depth = 3)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4877 = alloc_Boolean(0);
// compiled identifier node returning bool4877 (depth = 4)
  return bool4877;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_returnedObjectScope4878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4879 = gc_frame_new();
// call case 4: self request
  Object call4880 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4879);
// compiled member node returning call4880 (depth = 3)
  gc_frame_end(frame);
  return call4880;
}
Object meth_ast__apply_40_1_41_4892(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4893 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call4894 = callmethodflags(*var_result, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4893);
// compiled call node returning call4894 (depth = 7)
  gc_frame_end(frame);
  return call4894;
}
Object meth_ast__apply_40_1_41_4887(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4888 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4889 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call4890 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe4889);
// compiled member node returning call4890 (depth = 6)
  gc_frame_newslot(call4890);
// starting to compile block node (depth = 6)
  Object block4891 = alloc_Block(NULL, NULL, "ast", 1136);
  gc_frame_newslot(block4891);
// method "_apply(_)"
  block_savedest(block4891);
  Object closure4892 = createclosure(2, "_apply(1)");
  setclosureframe(closure4892, stackframe);
  addtoclosure(closure4892, var_result);
  addtoclosure(closure4892, selfslot);
  struct UserObject *uo4892 = (struct UserObject*)block4891;
  uo4892->data[0] = (Object)closure4892;
  Method *meth_meth_ast__apply_40_1_41_4892 = addmethod2pos(block4891, "_apply(1)", &meth_ast__apply_40_1_41_4892, 0);
  int argcv_meth_ast__apply_40_1_41_4892[] = {1};
  meth_meth_ast__apply_40_1_41_4892->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4892);
  meth_meth_ast__apply_40_1_41_4892->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4892->definitionLine = 2969;
// compiled block node returning block4891 (depth = 6)
  gc_frame_newslot(block4891);
// call case 5: prelude request
  params[0] = call4890;
  params[1] = block4891;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4896 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4888);
// compiled call node returning call4896 (depth = 5)
  gc_frame_end(frame);
  return call4896;
}
Object meth_ast_arguments4881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "arguments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array4882 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4882 (depth = 4)
  *var_result = array4882;
  if (array4882 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4883 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4884 = gc_frame_new();
// call case 4: self request
  Object call4885 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4884);
// compiled member node returning call4885 (depth = 4)
  gc_frame_newslot(call4885);
// starting to compile block node (depth = 4)
  Object block4886 = alloc_Block(NULL, NULL, "ast", 1135);
  gc_frame_newslot(block4886);
// method "_apply(_)"
  block_savedest(block4886);
  Object closure4887 = createclosure(2, "_apply(1)");
  setclosureframe(closure4887, stackframe);
  addtoclosure(closure4887, var_result);
  addtoclosure(closure4887, selfslot);
  struct UserObject *uo4887 = (struct UserObject*)block4886;
  uo4887->data[0] = (Object)closure4887;
  Method *meth_meth_ast__apply_40_1_41_4887 = addmethod2pos(block4886, "_apply(1)", &meth_ast__apply_40_1_41_4887, 0);
  int argcv_meth_ast__apply_40_1_41_4887[] = {1};
  meth_meth_ast__apply_40_1_41_4887->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4887);
  meth_meth_ast__apply_40_1_41_4887->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4887->definitionLine = 2969;
// compiled block node returning block4886 (depth = 4)
  gc_frame_newslot(block4886);
// call case 5: prelude request
  params[0] = call4885;
  params[1] = block4886;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4898 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4883);
// compiled call node returning call4898 (depth = 3)
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast__apply_40_1_41_4909(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4910 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_action (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call4911 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4910);
// compiled call node returning call4911 (depth = 7)
  gc_frame_end(frame);
  return call4911;
}
Object meth_ast__apply_40_1_41_4904(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4905 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4906 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call4907 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe4906);
// compiled member node returning call4907 (depth = 6)
  gc_frame_newslot(call4907);
// starting to compile block node (depth = 6)
  Object block4908 = alloc_Block(NULL, NULL, "ast", 1143);
  gc_frame_newslot(block4908);
// method "_apply(_)"
  block_savedest(block4908);
  Object closure4909 = createclosure(2, "_apply(1)");
  setclosureframe(closure4909, stackframe);
  addtoclosure(closure4909, var_action);
  addtoclosure(closure4909, selfslot);
  struct UserObject *uo4909 = (struct UserObject*)block4908;
  uo4909->data[0] = (Object)closure4909;
  Method *meth_meth_ast__apply_40_1_41_4909 = addmethod2pos(block4908, "_apply(1)", &meth_ast__apply_40_1_41_4909, 0);
  int argcv_meth_ast__apply_40_1_41_4909[] = {1};
  meth_meth_ast__apply_40_1_41_4909->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4909);
  meth_meth_ast__apply_40_1_41_4909->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4909->definitionLine = 2969;
// compiled block node returning block4908 (depth = 6)
  gc_frame_newslot(block4908);
// call case 5: prelude request
  params[0] = call4907;
  params[1] = block4908;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4913 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4905);
// compiled call node returning call4913 (depth = 5)
  gc_frame_end(frame);
  return call4913;
}
Object meth_ast_argumentsDo_40_1_41_4899(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "argumentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method argumentsDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for argumentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part argumentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4900 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4901 = gc_frame_new();
// call case 4: self request
  Object call4902 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4901);
// compiled member node returning call4902 (depth = 4)
  gc_frame_newslot(call4902);
// starting to compile block node (depth = 4)
  Object block4903 = alloc_Block(NULL, NULL, "ast", 1142);
  gc_frame_newslot(block4903);
// method "_apply(_)"
  block_savedest(block4903);
  Object closure4904 = createclosure(2, "_apply(1)");
  setclosureframe(closure4904, stackframe);
  addtoclosure(closure4904, var_action);
  addtoclosure(closure4904, selfslot);
  struct UserObject *uo4904 = (struct UserObject*)block4903;
  uo4904->data[0] = (Object)closure4904;
  Method *meth_meth_ast__apply_40_1_41_4904 = addmethod2pos(block4903, "_apply(1)", &meth_ast__apply_40_1_41_4904, 0);
  int argcv_meth_ast__apply_40_1_41_4904[] = {1};
  meth_meth_ast__apply_40_1_41_4904->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4904);
  meth_meth_ast__apply_40_1_41_4904->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4904->definitionLine = 2969;
// compiled block node returning block4903 (depth = 4)
  gc_frame_newslot(block4903);
// call case 5: prelude request
  params[0] = call4902;
  params[1] = block4903;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4915 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4900);
// compiled call node returning call4915 (depth = 3)
  gc_frame_end(frame);
  return call4915;
}
Object meth_ast__apply_40_1_41_4935(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4936 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4937 = callmethodflags(*var_arg, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4936);
// compiled call node returning call4937 (depth = 8)
  gc_frame_end(frame);
  return call4937;
}
Object meth_ast__apply_40_1_41_4930(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4931 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4932 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call4933 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe4932);
// compiled member node returning call4933 (depth = 7)
  gc_frame_newslot(call4933);
// starting to compile block node (depth = 7)
  Object block4934 = alloc_Block(NULL, NULL, "ast", 1152);
  gc_frame_newslot(block4934);
// method "_apply(_)"
  block_savedest(block4934);
  Object closure4935 = createclosure(3, "_apply(1)");
  setclosureframe(closure4935, stackframe);
  addtoclosure(closure4935, var_visitor);
  addtoclosure(closure4935, var_newChain);
  addtoclosure(closure4935, selfslot);
  struct UserObject *uo4935 = (struct UserObject*)block4934;
  uo4935->data[0] = (Object)closure4935;
  Method *meth_meth_ast__apply_40_1_41_4935 = addmethod2pos(block4934, "_apply(1)", &meth_ast__apply_40_1_41_4935, 0);
  int argcv_meth_ast__apply_40_1_41_4935[] = {1};
  meth_meth_ast__apply_40_1_41_4935->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4935);
  meth_meth_ast__apply_40_1_41_4935->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4935->definitionLine = 2969;
// compiled block node returning block4934 (depth = 7)
  gc_frame_newslot(block4934);
// call case 5: prelude request
  params[0] = call4933;
  params[1] = block4934;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4939 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4931);
// compiled call node returning call4939 (depth = 6)
  gc_frame_end(frame);
  return call4939;
}
Object meth_ast__apply_40_1_41_4951(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4952 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4953 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4952);
// compiled call node returning call4953 (depth = 7)
  gc_frame_end(frame);
  return call4953;
}
Object meth_ast_accept_40_1_41_from_40_1_41_4916(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4918 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4919 = callmethodflags(*var_visitor, "visitCall(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4918);
// compiled call node returning call4919 (depth = 4)
  Object if4917 = done;
  if (istrue(call4919)) {
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4920 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call4921 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4920);
// compiled call node returning call4921 (depth = 5)
  *var_newChain = call4921;
  if (call4921 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4922 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4923 = gc_frame_new();
// call case 4: self request
  Object call4924 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4923);
// compiled member node returning call4924 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4925 = callmethodflags(call4924, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4922);
// compiled call node returning call4925 (depth = 4)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4926 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4927 = gc_frame_new();
// call case 4: self request
  Object call4928 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4927);
// compiled member node returning call4928 (depth = 5)
  gc_frame_newslot(call4928);
// starting to compile block node (depth = 5)
  Object block4929 = alloc_Block(NULL, NULL, "ast", 1151);
  gc_frame_newslot(block4929);
// method "_apply(_)"
  block_savedest(block4929);
  Object closure4930 = createclosure(3, "_apply(1)");
  setclosureframe(closure4930, stackframe);
  addtoclosure(closure4930, var_visitor);
  addtoclosure(closure4930, var_newChain);
  addtoclosure(closure4930, selfslot);
  struct UserObject *uo4930 = (struct UserObject*)block4929;
  uo4930->data[0] = (Object)closure4930;
  Method *meth_meth_ast__apply_40_1_41_4930 = addmethod2pos(block4929, "_apply(1)", &meth_ast__apply_40_1_41_4930, 0);
  int argcv_meth_ast__apply_40_1_41_4930[] = {1};
  meth_meth_ast__apply_40_1_41_4930->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4930);
  meth_meth_ast__apply_40_1_41_4930->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4930->definitionLine = 2969;
// compiled block node returning block4929 (depth = 5)
  gc_frame_newslot(block4929);
// call case 5: prelude request
  params[0] = call4928;
  params[1] = block4929;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4941 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4926);
// compiled call node returning call4941 (depth = 4)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4944 = gc_frame_new();
// call case 4: self request
  Object call4945 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4944);
// compiled member node returning call4945 (depth = 6)
  int op_slot_right_4943 = gc_frame_newslot(call4945);
// starting to compile identifier node (depth = 6)
  Object bool4947 = alloc_Boolean(0);
// compiled identifier node returning bool4947 (depth = 6)
  int op_slot_left_4943 = gc_frame_newslot(bool4947);
  params[0] = call4945;
  partcv[0] = 1;
  Object opresult4948 = callmethod(bool4947, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4948 (depth = 5)
  Object if4942 = done;
  if (istrue(opresult4948)) {
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4949 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4950 = alloc_Block(NULL, NULL, "ast", 1157);
  gc_frame_newslot(block4950);
// method "_apply(_)"
  block_savedest(block4950);
  Object closure4951 = createclosure(3, "_apply(1)");
  setclosureframe(closure4951, stackframe);
  addtoclosure(closure4951, var_visitor);
  addtoclosure(closure4951, var_newChain);
  addtoclosure(closure4951, selfslot);
  struct UserObject *uo4951 = (struct UserObject*)block4950;
  uo4951->data[0] = (Object)closure4951;
  Method *meth_meth_ast__apply_40_1_41_4951 = addmethod2pos(block4950, "_apply(1)", &meth_ast__apply_40_1_41_4951, 0);
  int argcv_meth_ast__apply_40_1_41_4951[] = {1};
  meth_meth_ast__apply_40_1_41_4951->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4951);
  meth_meth_ast__apply_40_1_41_4951->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4951->definitionLine = 2969;
// compiled block node returning block4950 (depth = 6)
  gc_frame_newslot(block4950);
// call case 6: other requests
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4955 = gc_frame_new();
// call case 4: self request
  Object call4956 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4955);
// compiled member node returning call4956 (depth = 6)
  params[0] = block4950;
  partcv[0] = 1;
  Object call4957 = callmethodflags(call4956, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4949);
// compiled call node returning call4957 (depth = 5)
    gc_frame_newslot(call4957);
    if4942 = call4957;
  } else {
  }
// compiled if node returning if4942 (depth = 4)
    gc_frame_newslot(if4942);
    if4917 = if4942;
  } else {
  }
// compiled if node returning if4917 (depth = 3)
  gc_frame_end(frame);
  return if4917;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_4958(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4959 = gc_frame_new();
// call case 4: self request
  Object call4960 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4959);
// compiled member node returning call4960 (depth = 4)
  *var_n = call4960;
  if (call4960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4961 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4962 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4961);
// compiled call node returning call4962 (depth = 4)
  *var_newChain = call4962;
  if (call4962 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4963 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4964 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4965 = gc_frame_new();
// call case 4: self request
  Object call4966 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4965);
// compiled member node returning call4966 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4967 = callmethodflags(call4966, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4964);
// compiled call node returning call4967 (depth = 4)
  gc_frame_newslot(call4967);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4967;
  partcv[0] = 1;
  Object call4968 = callmethodflags(*var_n, "receiver:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4963);
// compiled call node returning call4968 (depth = 3)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4969 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4970 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4971 = gc_frame_new();
// call case 4: self request
  Object call4972 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4971);
// compiled member node returning call4972 (depth = 5)
  gc_frame_newslot(call4972);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4973 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4974 = gc_frame_new();
// call case 3: self.outer request
  Object call4975 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4974);
// compiled member node returning call4975 (depth = 6)
  Object call4976 = callmethodflags(call4975, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4973);
// compiled member node returning call4976 (depth = 5)
  params[0] = call4972;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4977 = callmethodflags(call4976, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4970);
// compiled call node returning call4977 (depth = 4)
  gc_frame_newslot(call4977);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4977;
  partcv[0] = 1;
  Object call4978 = callmethodflags(*var_n, "with:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4969);
// compiled call node returning call4978 (depth = 3)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4979 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4980 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4981 = gc_frame_new();
// call case 4: self request
  Object call4982 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4981);
// compiled member node returning call4982 (depth = 5)
  gc_frame_newslot(call4982);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4983 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4984 = gc_frame_new();
// call case 3: self.outer request
  Object call4985 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4984);
// compiled member node returning call4985 (depth = 6)
  Object call4986 = callmethodflags(call4985, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4983);
// compiled member node returning call4986 (depth = 5)
  params[0] = call4982;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4987 = callmethodflags(call4986, "maybeListMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4980);
// compiled call node returning call4987 (depth = 4)
  gc_frame_newslot(call4987);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4987;
  partcv[0] = 1;
  Object call4988 = callmethodflags(*var_n, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4979);
// compiled call node returning call4988 (depth = 3)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4989 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call4990 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4989);
// compiled call node returning call4990 (depth = 3)
  gc_frame_end(frame);
  return call4990;
}
Object meth_ast__apply_40_1_41_4999(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5001 == NULL) {
    strlit5001 = alloc_String("  ");
    gc_root(strlit5001);
  }
// compiled string node returning strlit5001 (depth = 7)
  int op_slot_right_5000 = gc_frame_newslot(strlit5001);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5000 = gc_frame_newslot(*var_spc);
  params[0] = strlit5001;
  partcv[0] = 1;
  Object opresult5003 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult5003 (depth = 6)
  *var_spc = opresult5003;
  if (opresult5003 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5077(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5079 == NULL) {
    strlit5079 = alloc_String("""\x0a""");
    gc_root(strlit5079);
  }
// compiled string node returning strlit5079 (depth = 8)
  int op_slot_right_5078 = gc_frame_newslot(strlit5079);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5082 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5084 = alloc_Float64(2);
// compiled num node returning num5084 (depth = 11)
  int op_slot_right_5083 = gc_frame_newslot(num5084);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5083 = gc_frame_newslot(*var_depth);
  params[0] = num5084;
  partcv[0] = 1;
  Object sum5086 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5086 (depth = 10)
  gc_frame_newslot(sum5086);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = sum5086;
  partcv[0] = 1;
  Object call5087 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5082);
// compiled call node returning call5087 (depth = 9)
  int op_slot_right_5081 = gc_frame_newslot(call5087);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5090 == NULL) {
    strlit5090 = alloc_String("    ");
    gc_root(strlit5090);
  }
// compiled string node returning strlit5090 (depth = 10)
  int op_slot_right_5089 = gc_frame_newslot(strlit5090);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5092 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5092 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5094 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5094 (depth = 10)
  int op_slot_left_5089 = gc_frame_newslot(opresult5094);
  params[0] = strlit5090;
  partcv[0] = 1;
  Object opresult5095 = callmethod(opresult5094, "++(1)", 1, partcv, params);
// compiled op node returning opresult5095 (depth = 9)
  int op_slot_left_5081 = gc_frame_newslot(opresult5095);
  params[0] = call5087;
  partcv[0] = 1;
  Object opresult5096 = callmethod(opresult5095, "++(1)", 1, partcv, params);
// compiled op node returning opresult5096 (depth = 8)
  int op_slot_left_5078 = gc_frame_newslot(opresult5096);
  params[0] = strlit5079;
  partcv[0] = 1;
  Object opresult5097 = callmethod(opresult5096, "++(1)", 1, partcv, params);
// compiled op node returning opresult5097 (depth = 7)
  *var_s = opresult5097;
  if (opresult5097 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5135(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5137 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5139 = alloc_Float64(2);
// compiled num node returning num5139 (depth = 11)
  int op_slot_right_5138 = gc_frame_newslot(num5139);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5138 = gc_frame_newslot(*var_depth);
  params[0] = num5139;
  partcv[0] = 1;
  Object sum5141 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5141 (depth = 10)
  gc_frame_newslot(sum5141);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arg (depth = 10)
  params[0] = sum5141;
  partcv[0] = 1;
  Object call5142 = callmethodflags(*var_arg, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5137);
// compiled call node returning call5142 (depth = 9)
  int op_slot_right_5136 = gc_frame_newslot(call5142);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_5144 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5147 == NULL) {
    strlit5147 = alloc_String("""\x0a""      ");
    gc_root(strlit5147);
  }
// compiled string node returning strlit5147 (depth = 11)
  int op_slot_right_5146 = gc_frame_newslot(strlit5147);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5146 = gc_frame_newslot(*var_s);
  params[0] = strlit5147;
  partcv[0] = 1;
  Object opresult5149 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5149 (depth = 10)
  int op_slot_left_5144 = gc_frame_newslot(opresult5149);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5150 = callmethod(opresult5149, "++(1)", 1, partcv, params);
// compiled op node returning opresult5150 (depth = 9)
  int op_slot_left_5136 = gc_frame_newslot(opresult5150);
  params[0] = call5142;
  partcv[0] = 1;
  Object opresult5151 = callmethod(opresult5150, "++(1)", 1, partcv, params);
// compiled op node returning opresult5151 (depth = 8)
  *var_s = opresult5151;
  if (opresult5151 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5113(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5115 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call5116 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe5115);
// compiled member node returning call5116 (depth = 7)
  int op_slot_right_5114 = gc_frame_newslot(call5116);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5119 == NULL) {
    strlit5119 = alloc_String("Part: ");
    gc_root(strlit5119);
  }
// compiled string node returning strlit5119 (depth = 8)
  int op_slot_right_5118 = gc_frame_newslot(strlit5119);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5121 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5124 == NULL) {
    strlit5124 = alloc_String("""\x0a""  ");
    gc_root(strlit5124);
  }
// compiled string node returning strlit5124 (depth = 10)
  int op_slot_right_5123 = gc_frame_newslot(strlit5124);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5123 = gc_frame_newslot(*var_s);
  params[0] = strlit5124;
  partcv[0] = 1;
  Object opresult5126 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5126 (depth = 9)
  int op_slot_left_5121 = gc_frame_newslot(opresult5126);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5127 = callmethod(opresult5126, "++(1)", 1, partcv, params);
// compiled op node returning opresult5127 (depth = 8)
  int op_slot_left_5118 = gc_frame_newslot(opresult5127);
  params[0] = strlit5119;
  partcv[0] = 1;
  Object opresult5128 = callmethod(opresult5127, "++(1)", 1, partcv, params);
// compiled op node returning opresult5128 (depth = 7)
  int op_slot_left_5114 = gc_frame_newslot(opresult5128);
  params[0] = call5116;
  partcv[0] = 1;
  Object opresult5129 = callmethod(opresult5128, "++(1)", 1, partcv, params);
// compiled op node returning opresult5129 (depth = 6)
  *var_s = opresult5129;
  if (opresult5129 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5131 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5132 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call5133 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe5132);
// compiled member node returning call5133 (depth = 6)
  gc_frame_newslot(call5133);
// starting to compile block node (depth = 6)
  Object block5134 = alloc_Block(NULL, NULL, "ast", 1189);
  gc_frame_newslot(block5134);
// method "_apply(_)"
  block_savedest(block5134);
  Object closure5135 = createclosure(4, "_apply(1)");
  setclosureframe(closure5135, stackframe);
  addtoclosure(closure5135, var_depth);
  addtoclosure(closure5135, var_spc);
  addtoclosure(closure5135, var_s);
  addtoclosure(closure5135, selfslot);
  struct UserObject *uo5135 = (struct UserObject*)block5134;
  uo5135->data[0] = (Object)closure5135;
  Method *meth_meth_ast__apply_40_1_41_5135 = addmethod2pos(block5134, "_apply(1)", &meth_ast__apply_40_1_41_5135, 0);
  int argcv_meth_ast__apply_40_1_41_5135[] = {1};
  meth_meth_ast__apply_40_1_41_5135->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5135);
  meth_meth_ast__apply_40_1_41_5135->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5135->definitionLine = 2969;
// compiled block node returning block5134 (depth = 6)
  gc_frame_newslot(block5134);
// call case 5: prelude request
  params[0] = call5133;
  params[1] = block5134;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5154 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5131);
// compiled call node returning call5154 (depth = 5)
  gc_frame_end(frame);
  return call5154;
}
Object meth_ast_pretty_40_1_41_4991(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4992 == NULL) {
    strlit4992 = alloc_String("");
    gc_root(strlit4992);
  }
// compiled string node returning strlit4992 (depth = 4)
  *var_spc = strlit4992;
  if (strlit4992 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4993 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_4994 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num4996 = alloc_Float64(0);
// compiled num node returning num4996 (depth = 5)
  int op_slot_left_4994 = gc_frame_newslot(num4996);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4997 = callmethod(num4996, "..(1)", 1, partcv, params);
// compiled op node returning opresult4997 (depth = 4)
  gc_frame_newslot(opresult4997);
// starting to compile block node (depth = 4)
  Object block4998 = alloc_Block(NULL, NULL, "ast", 1173);
  gc_frame_newslot(block4998);
// method "_apply(_)"
  block_savedest(block4998);
  Object closure4999 = createclosure(2, "_apply(1)");
  setclosureframe(closure4999, stackframe);
  addtoclosure(closure4999, var_spc);
  addtoclosure(closure4999, selfslot);
  struct UserObject *uo4999 = (struct UserObject*)block4998;
  uo4999->data[0] = (Object)closure4999;
  Method *meth_meth_ast__apply_40_1_41_4999 = addmethod2pos(block4998, "_apply(1)", &meth_ast__apply_40_1_41_4999, 0);
  int argcv_meth_ast__apply_40_1_41_4999[] = {1};
  meth_meth_ast__apply_40_1_41_4999->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4999);
  meth_meth_ast__apply_40_1_41_4999->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4999->definitionLine = 2969;
// compiled block node returning block4998 (depth = 4)
  gc_frame_newslot(block4998);
// call case 5: prelude request
  params[0] = opresult4997;
  params[1] = block4998;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5006 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4993);
// compiled call node returning call5006 (depth = 3)
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5007 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5008 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5007);
// compiled call node returning call5008 (depth = 4)
  *var_s = call5008;
  if (call5008 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5011 = gc_frame_new();
// call case 4: self request
  Object call5012 = callmethodflags(self, "isSelfRequest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5011);
// compiled member node returning call5012 (depth = 6)
  Object if5010 = done;
struct StackFrameObject *iftmpstackframe5010 = stackframe;
  if (istrue(call5012)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5010);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit5013 == NULL) {
    strlit5013 = alloc_String(" on self""\x0a""");
    gc_root(strlit5013);
  }
// compiled string node returning strlit5013 (depth = 6)
    gc_frame_newslot(strlit5013);
    if5010 = strlit5013;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5010);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit5014 == NULL) {
    strlit5014 = alloc_String("""\x0a""");
    gc_root(strlit5014);
  }
// compiled string node returning strlit5014 (depth = 6)
    gc_frame_newslot(strlit5014);
    if5010 = strlit5014;
  }
stackframe = iftmpstackframe5010;
// compiled if node returning if5010 (depth = 5)
  int op_slot_right_5009 = gc_frame_newslot(if5010);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_5009 = gc_frame_newslot(*var_s);
  params[0] = if5010;
  partcv[0] = 1;
  Object opresult5016 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5016 (depth = 4)
  *var_s = opresult5016;
  if (opresult5016 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5020 == NULL) {
    strlit5020 = alloc_String("""\x0a""");
    gc_root(strlit5020);
  }
// compiled string node returning strlit5020 (depth = 6)
  int op_slot_right_5019 = gc_frame_newslot(strlit5020);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5023 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5025 = alloc_Float64(1);
// compiled num node returning num5025 (depth = 9)
  int op_slot_right_5024 = gc_frame_newslot(num5025);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5024 = gc_frame_newslot(*var_depth);
  params[0] = num5025;
  partcv[0] = 1;
  Object sum5027 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5027 (depth = 8)
  gc_frame_newslot(sum5027);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5028 = gc_frame_new();
// call case 4: self request
  Object call5029 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5028);
// compiled member node returning call5029 (depth = 8)
  params[0] = sum5027;
  partcv[0] = 1;
  Object call5030 = callmethodflags(call5029, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5023);
// compiled call node returning call5030 (depth = 7)
  int op_slot_right_5022 = gc_frame_newslot(call5030);
// starting to compile string node (depth = 7)
  if (strlit5032 == NULL) {
    strlit5032 = alloc_String("Receiver: ");
    gc_root(strlit5032);
  }
// compiled string node returning strlit5032 (depth = 7)
  int op_slot_left_5022 = gc_frame_newslot(strlit5032);
  params[0] = call5030;
  partcv[0] = 1;
  Object opresult5033 = callmethod(strlit5032, "++(1)", 1, partcv, params);
// compiled op node returning opresult5033 (depth = 6)
  int op_slot_left_5019 = gc_frame_newslot(opresult5033);
  params[0] = strlit5020;
  partcv[0] = 1;
  Object opresult5034 = callmethod(opresult5033, "++(1)", 1, partcv, params);
// compiled op node returning opresult5034 (depth = 5)
  int op_slot_right_5018 = gc_frame_newslot(opresult5034);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5036 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5036 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5038 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5038 (depth = 5)
  int op_slot_left_5018 = gc_frame_newslot(opresult5038);
  params[0] = opresult5034;
  partcv[0] = 1;
  Object opresult5039 = callmethod(opresult5038, "++(1)", 1, partcv, params);
// compiled op node returning opresult5039 (depth = 4)
  *var_s = opresult5039;
  if (opresult5039 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5043 == NULL) {
    strlit5043 = alloc_String("""\x0a""");
    gc_root(strlit5043);
  }
// compiled string node returning strlit5043 (depth = 6)
  int op_slot_right_5042 = gc_frame_newslot(strlit5043);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5046 = gc_frame_new();
// call case 4: self request
  Object call5047 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5046);
// compiled member node returning call5047 (depth = 7)
  int op_slot_right_5045 = gc_frame_newslot(call5047);
// starting to compile string node (depth = 7)
  if (strlit5049 == NULL) {
    strlit5049 = alloc_String("Method Name: ");
    gc_root(strlit5049);
  }
// compiled string node returning strlit5049 (depth = 7)
  int op_slot_left_5045 = gc_frame_newslot(strlit5049);
  params[0] = call5047;
  partcv[0] = 1;
  Object opresult5050 = callmethod(strlit5049, "++(1)", 1, partcv, params);
// compiled op node returning opresult5050 (depth = 6)
  int op_slot_left_5042 = gc_frame_newslot(opresult5050);
  params[0] = strlit5043;
  partcv[0] = 1;
  Object opresult5051 = callmethod(opresult5050, "++(1)", 1, partcv, params);
// compiled op node returning opresult5051 (depth = 5)
  int op_slot_right_5041 = gc_frame_newslot(opresult5051);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5053 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5053 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5055 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5055 (depth = 5)
  int op_slot_left_5041 = gc_frame_newslot(opresult5055);
  params[0] = opresult5051;
  partcv[0] = 1;
  Object opresult5056 = callmethod(opresult5055, "++(1)", 1, partcv, params);
// compiled op node returning opresult5056 (depth = 4)
  *var_s = opresult5056;
  if (opresult5056 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5060 = gc_frame_new();
// call case 4: self request
  Object call5061 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5060);
// compiled member node returning call5061 (depth = 5)
  int op_slot_right_5059 = gc_frame_newslot(call5061);
// starting to compile identifier node (depth = 5)
  Object bool5063 = alloc_Boolean(0);
// compiled identifier node returning bool5063 (depth = 5)
  int op_slot_left_5059 = gc_frame_newslot(bool5063);
  params[0] = call5061;
  partcv[0] = 1;
  Object opresult5064 = callmethod(bool5063, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5064 (depth = 4)
  Object if5058 = done;
  if (istrue(opresult5064)) {
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5066 == NULL) {
    strlit5066 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit5066);
  }
// compiled string node returning strlit5066 (depth = 6)
  int op_slot_right_5065 = gc_frame_newslot(strlit5066);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5068 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5068 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5070 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5070 (depth = 6)
  int op_slot_left_5065 = gc_frame_newslot(opresult5070);
  params[0] = strlit5066;
  partcv[0] = 1;
  Object opresult5071 = callmethod(opresult5070, "++(1)", 1, partcv, params);
// compiled op node returning opresult5071 (depth = 5)
  *var_s = opresult5071;
  if (opresult5071 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5073 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5074 = gc_frame_new();
// call case 4: self request
  Object call5075 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5074);
// compiled member node returning call5075 (depth = 5)
  gc_frame_newslot(call5075);
// starting to compile block node (depth = 5)
  Object block5076 = alloc_Block(NULL, NULL, "ast", 1182);
  gc_frame_newslot(block5076);
// method "_apply(_)"
  block_savedest(block5076);
  Object closure5077 = createclosure(4, "_apply(1)");
  setclosureframe(closure5077, stackframe);
  addtoclosure(closure5077, var_depth);
  addtoclosure(closure5077, var_spc);
  addtoclosure(closure5077, var_s);
  addtoclosure(closure5077, selfslot);
  struct UserObject *uo5077 = (struct UserObject*)block5076;
  uo5077->data[0] = (Object)closure5077;
  Method *meth_meth_ast__apply_40_1_41_5077 = addmethod2pos(block5076, "_apply(1)", &meth_ast__apply_40_1_41_5077, 0);
  int argcv_meth_ast__apply_40_1_41_5077[] = {1};
  meth_meth_ast__apply_40_1_41_5077->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5077);
  meth_meth_ast__apply_40_1_41_5077->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5077->definitionLine = 2969;
// compiled block node returning block5076 (depth = 5)
  gc_frame_newslot(block5076);
// call case 5: prelude request
  params[0] = call5075;
  params[1] = block5076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5100 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5073);
// compiled call node returning call5100 (depth = 4)
    gc_frame_newslot(call5100);
    if5058 = call5100;
  } else {
  }
// compiled if node returning if5058 (depth = 3)
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5102 == NULL) {
    strlit5102 = alloc_String("Arguments:");
    gc_root(strlit5102);
  }
// compiled string node returning strlit5102 (depth = 5)
  int op_slot_right_5101 = gc_frame_newslot(strlit5102);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5104 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5104 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5106 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5106 (depth = 5)
  int op_slot_left_5101 = gc_frame_newslot(opresult5106);
  params[0] = strlit5102;
  partcv[0] = 1;
  Object opresult5107 = callmethod(opresult5106, "++(1)", 1, partcv, params);
// compiled op node returning opresult5107 (depth = 4)
  *var_s = opresult5107;
  if (opresult5107 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5109 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5110 = gc_frame_new();
// call case 4: self request
  Object call5111 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5110);
// compiled member node returning call5111 (depth = 4)
  gc_frame_newslot(call5111);
// starting to compile block node (depth = 4)
  Object block5112 = alloc_Block(NULL, NULL, "ast", 1187);
  gc_frame_newslot(block5112);
// method "_apply(_)"
  block_savedest(block5112);
  Object closure5113 = createclosure(4, "_apply(1)");
  setclosureframe(closure5113, stackframe);
  addtoclosure(closure5113, var_spc);
  addtoclosure(closure5113, var_s);
  addtoclosure(closure5113, var_depth);
  addtoclosure(closure5113, selfslot);
  struct UserObject *uo5113 = (struct UserObject*)block5112;
  uo5113->data[0] = (Object)closure5113;
  Method *meth_meth_ast__apply_40_1_41_5113 = addmethod2pos(block5112, "_apply(1)", &meth_ast__apply_40_1_41_5113, 0);
  int argcv_meth_ast__apply_40_1_41_5113[] = {1};
  meth_meth_ast__apply_40_1_41_5113->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5113);
  meth_meth_ast__apply_40_1_41_5113->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5113->definitionLine = 2969;
// compiled block node returning block5112 (depth = 4)
  gc_frame_newslot(block5112);
// call case 5: prelude request
  params[0] = call5111;
  params[1] = block5112;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5156 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5109);
// compiled call node returning call5156 (depth = 3)
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_5207(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5209 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5211 = alloc_Float64(1);
// compiled num node returning num5211 (depth = 9)
  int op_slot_right_5210 = gc_frame_newslot(num5211);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5210 = gc_frame_newslot(*var_depth);
  params[0] = num5211;
  partcv[0] = 1;
  Object sum5213 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5213 (depth = 8)
  gc_frame_newslot(sum5213);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = sum5213;
  partcv[0] = 1;
  Object call5214 = callmethodflags(*var_part, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5209);
// compiled call node returning call5214 (depth = 7)
  int op_slot_right_5208 = gc_frame_newslot(call5214);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5208 = gc_frame_newslot(*var_s);
  params[0] = call5214;
  partcv[0] = 1;
  Object opresult5216 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5216 (depth = 6)
  *var_s = opresult5216;
  if (opresult5216 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5220(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5222 == NULL) {
    strlit5222 = alloc_String(" ");
    gc_root(strlit5222);
  }
// compiled string node returning strlit5222 (depth = 7)
  int op_slot_right_5221 = gc_frame_newslot(strlit5222);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5221 = gc_frame_newslot(*var_s);
  params[0] = strlit5222;
  partcv[0] = 1;
  Object opresult5224 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5224 (depth = 6)
  *var_s = opresult5224;
  if (opresult5224 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_5157(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5158 == NULL) {
    strlit5158 = alloc_String("");
    gc_root(strlit5158);
  }
// compiled string node returning strlit5158 (depth = 4)
  *var_s = strlit5158;
  if (strlit5158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5160 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5161 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5162 = gc_frame_new();
// call case 4: self request
  Object call5163 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5162);
// compiled member node returning call5163 (depth = 6)
  Object call5164 = callmethodflags(call5163, "isImplicit", 0, partcv, params, 0);
  gc_frame_end(callframe5161);
// compiled member node returning call5164 (depth = 5)
  Object call5165 = callmethodflags(call5164, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5160);
// compiled member node returning call5165 (depth = 4)
  Object if5159 = done;
  if (istrue(call5165)) {
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5167 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5168 = gc_frame_new();
// call case 4: self request
  Object call5169 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5168);
// compiled member node returning call5169 (depth = 6)
  Object call5170 = callmethodflags(call5169, "isSimple", 0, partcv, params, 0);
  gc_frame_end(callframe5167);
// compiled member node returning call5170 (depth = 5)
  Object if5166 = done;
  if (istrue(call5170)) {
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5172 == NULL) {
    strlit5172 = alloc_String(".");
    gc_root(strlit5172);
  }
// compiled string node returning strlit5172 (depth = 7)
  int op_slot_right_5171 = gc_frame_newslot(strlit5172);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5175 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5177 = alloc_Float64(1);
// compiled num node returning num5177 (depth = 10)
  int op_slot_right_5176 = gc_frame_newslot(num5177);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5176 = gc_frame_newslot(*var_depth);
  params[0] = num5177;
  partcv[0] = 1;
  Object sum5179 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5179 (depth = 9)
  gc_frame_newslot(sum5179);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5180 = gc_frame_new();
// call case 4: self request
  Object call5181 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5180);
// compiled member node returning call5181 (depth = 9)
  params[0] = sum5179;
  partcv[0] = 1;
  Object call5182 = callmethodflags(call5181, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5175);
// compiled call node returning call5182 (depth = 8)
  int op_slot_right_5174 = gc_frame_newslot(call5182);
// starting to compile string node (depth = 8)
  if (strlit5184 == NULL) {
    strlit5184 = alloc_String("");
    gc_root(strlit5184);
  }
// compiled string node returning strlit5184 (depth = 8)
  int op_slot_left_5174 = gc_frame_newslot(strlit5184);
  params[0] = call5182;
  partcv[0] = 1;
  Object opresult5185 = callmethod(strlit5184, "++(1)", 1, partcv, params);
// compiled op node returning opresult5185 (depth = 7)
  int op_slot_left_5171 = gc_frame_newslot(opresult5185);
  params[0] = strlit5172;
  partcv[0] = 1;
  Object opresult5186 = callmethod(opresult5185, "++(1)", 1, partcv, params);
// compiled op node returning opresult5186 (depth = 6)
  *var_s = opresult5186;
  if (opresult5186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5166 = done;
  } else {
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5189 == NULL) {
    strlit5189 = alloc_String(").");
    gc_root(strlit5189);
  }
// compiled string node returning strlit5189 (depth = 7)
  int op_slot_right_5188 = gc_frame_newslot(strlit5189);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5192 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5194 = alloc_Float64(1);
// compiled num node returning num5194 (depth = 10)
  int op_slot_right_5193 = gc_frame_newslot(num5194);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5193 = gc_frame_newslot(*var_depth);
  params[0] = num5194;
  partcv[0] = 1;
  Object sum5196 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5196 (depth = 9)
  gc_frame_newslot(sum5196);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5197 = gc_frame_new();
// call case 4: self request
  Object call5198 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5197);
// compiled member node returning call5198 (depth = 9)
  params[0] = sum5196;
  partcv[0] = 1;
  Object call5199 = callmethodflags(call5198, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5192);
// compiled call node returning call5199 (depth = 8)
  int op_slot_right_5191 = gc_frame_newslot(call5199);
// starting to compile string node (depth = 8)
  if (strlit5201 == NULL) {
    strlit5201 = alloc_String("(");
    gc_root(strlit5201);
  }
// compiled string node returning strlit5201 (depth = 8)
  int op_slot_left_5191 = gc_frame_newslot(strlit5201);
  params[0] = call5199;
  partcv[0] = 1;
  Object opresult5202 = callmethod(strlit5201, "++(1)", 1, partcv, params);
// compiled op node returning opresult5202 (depth = 7)
  int op_slot_left_5188 = gc_frame_newslot(opresult5202);
  params[0] = strlit5189;
  partcv[0] = 1;
  Object opresult5203 = callmethod(opresult5202, "++(1)", 1, partcv, params);
// compiled op node returning opresult5203 (depth = 6)
  *var_s = opresult5203;
  if (opresult5203 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5166 = done;
  }
// compiled if node returning if5166 (depth = 4)
    gc_frame_newslot(if5166);
    if5159 = if5166;
  } else {
  }
// compiled if node returning if5159 (depth = 3)
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5205 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5206 = alloc_Block(NULL, NULL, "ast", 1204);
  gc_frame_newslot(block5206);
// method "_apply(_)"
  block_savedest(block5206);
  Object closure5207 = createclosure(3, "_apply(1)");
  setclosureframe(closure5207, stackframe);
  addtoclosure(closure5207, var_depth);
  addtoclosure(closure5207, var_s);
  addtoclosure(closure5207, selfslot);
  struct UserObject *uo5207 = (struct UserObject*)block5206;
  uo5207->data[0] = (Object)closure5207;
  Method *meth_meth_ast__apply_40_1_41_5207 = addmethod2pos(block5206, "_apply(1)", &meth_ast__apply_40_1_41_5207, 0);
  int argcv_meth_ast__apply_40_1_41_5207[] = {1};
  meth_meth_ast__apply_40_1_41_5207->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5207);
  meth_meth_ast__apply_40_1_41_5207->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5207->definitionLine = 2969;
// compiled block node returning block5206 (depth = 4)
  gc_frame_newslot(block5206);
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5219 = alloc_Block(NULL, NULL, "ast", 1205);
  gc_frame_newslot(block5219);
// method "_apply"
  block_savedest(block5219);
  Object closure5220 = createclosure(2, "_apply");
  setclosureframe(closure5220, stackframe);
  addtoclosure(closure5220, var_s);
  addtoclosure(closure5220, selfslot);
  struct UserObject *uo5220 = (struct UserObject*)block5219;
  uo5220->data[0] = (Object)closure5220;
  Method *meth_meth_ast__apply5220 = addmethod2pos(block5219, "_apply", &meth_ast__apply5220, 0);
  int argcv_meth_ast__apply5220[] = {0};
  meth_meth_ast__apply5220->type = alloc_MethodType(1, argcv_meth_ast__apply5220);
  meth_meth_ast__apply5220->definitionModule = modulename;
  meth_meth_ast__apply5220->definitionLine = 2969;
// compiled block node returning block5219 (depth = 4)
  gc_frame_newslot(block5219);
// call case 6: other requests
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5227 = gc_frame_new();
// call case 4: self request
  Object call5228 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5227);
// compiled member node returning call5228 (depth = 4)
  params[0] = block5206;
  params[1] = block5219;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5229 = callmethodflags(call5228, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5205);
// compiled call node returning call5229 (depth = 3)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asIdentifier5230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5233 = gc_frame_new();
// call case 4: self request
  Object call5234 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5233);
// compiled member node returning call5234 (depth = 5)
  int op_slot_right_5232 = gc_frame_newslot(call5234);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_fakeSymbolTable (depth = 5)
  int op_slot_left_5232 = gc_frame_newslot(*var_fakeSymbolTable);
  params[0] = call5234;
  partcv[0] = 1;
  Object opresult5236 = callmethod(*var_fakeSymbolTable, "==(1)", 1, partcv, params);
// compiled op node returning opresult5236 (depth = 4)
  Object if5231 = done;
  if (istrue(opresult5236)) {
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5237 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5239 == NULL) {
    strlit5239 = alloc_String(" when scope was fake");
    gc_root(strlit5239);
  }
// compiled string node returning strlit5239 (depth = 6)
  int op_slot_right_5238 = gc_frame_newslot(strlit5239);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5242 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5243 = alloc_Float64(0);
// compiled num node returning num5243 (depth = 8)
  gc_frame_newslot(num5243);
// call case 4: self request
  params[0] = num5243;
  partcv[0] = 1;
  Object call5244 = callmethodflags(self, "pretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5242);
// compiled call node returning call5244 (depth = 7)
  int op_slot_right_5241 = gc_frame_newslot(call5244);
// starting to compile string node (depth = 7)
  if (strlit5246 == NULL) {
    strlit5246 = alloc_String("asIdentifier requested on ");
    gc_root(strlit5246);
  }
// compiled string node returning strlit5246 (depth = 7)
  int op_slot_left_5241 = gc_frame_newslot(strlit5246);
  params[0] = call5244;
  partcv[0] = 1;
  Object opresult5247 = callmethod(strlit5246, "++(1)", 1, partcv, params);
// compiled op node returning opresult5247 (depth = 6)
  int op_slot_left_5238 = gc_frame_newslot(opresult5247);
  params[0] = strlit5239;
  partcv[0] = 1;
  Object opresult5248 = callmethod(opresult5247, "++(1)", 1, partcv, params);
// compiled op node returning opresult5248 (depth = 5)
  gc_frame_newslot(opresult5248);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5249 = gc_frame_new();
// call case 5: prelude request
  Object call5250 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5249);
// compiled member node returning call5250 (depth = 5)
  params[0] = opresult5248;
  partcv[0] = 1;
  Object call5251 = callmethodflags(call5250, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5237);
// compiled call node returning call5251 (depth = 4)
    gc_frame_newslot(call5251);
    if5231 = call5251;
  } else {
  }
// compiled if node returning if5231 (depth = 3)
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5252 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5253 = gc_frame_new();
// call case 4: self request
  Object call5254 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5253);
// compiled member node returning call5254 (depth = 5)
  gc_frame_newslot(call5254);
// starting to compile identifier node (depth = 5)
  Object bool5255 = alloc_Boolean(0);
// compiled identifier node returning bool5255 (depth = 5)
  gc_frame_newslot(bool5255);
// starting to compile member node (depth = 5)
  int callframe5256 = gc_frame_new();
// call case 4: self request
  Object call5257 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5256);
// compiled member node returning call5257 (depth = 5)
  gc_frame_newslot(call5257);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call5254;
  params[1] = bool5255;
  params[2] = call5257;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5258 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5252);
// compiled call node returning call5258 (depth = 4)
  *var_resultNode = call5258;
  if (call5258 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5259 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool5260 = alloc_Boolean(1);
// compiled identifier node returning bool5260 (depth = 4)
  gc_frame_newslot(bool5260);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool5260;
  partcv[0] = 1;
  Object call5261 = callmethodflags(*var_resultNode, "inRequest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5259);
// compiled call node returning call5261 (depth = 3)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5262 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5263 = gc_frame_new();
// call case 4: self request
  Object call5264 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5263);
// compiled member node returning call5264 (depth = 4)
  gc_frame_newslot(call5264);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call5264;
  partcv[0] = 1;
  Object call5265 = callmethodflags(*var_resultNode, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5262);
// compiled call node returning call5265 (depth = 3)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5266 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5267 = gc_frame_new();
// call case 4: self request
  Object call5268 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5267);
// compiled member node returning call5268 (depth = 4)
  gc_frame_newslot(call5268);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call5268;
  partcv[0] = 1;
  Object call5269 = callmethodflags(*var_resultNode, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5266);
// compiled call node returning call5269 (depth = 3)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_asString5270(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5272 == NULL) {
    strlit5272 = alloc_String("");
    gc_root(strlit5272);
  }
// compiled string node returning strlit5272 (depth = 4)
  int op_slot_right_5271 = gc_frame_newslot(strlit5272);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5275 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num5276 = alloc_Float64(0);
// compiled num node returning num5276 (depth = 6)
  gc_frame_newslot(num5276);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5277 = gc_frame_new();
// call case 4: self request
  Object call5278 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5277);
// compiled member node returning call5278 (depth = 6)
  params[0] = num5276;
  partcv[0] = 1;
  Object call5279 = callmethodflags(call5278, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5275);
// compiled call node returning call5279 (depth = 5)
  int op_slot_right_5274 = gc_frame_newslot(call5279);
// starting to compile string node (depth = 5)
  if (strlit5281 == NULL) {
    strlit5281 = alloc_String("call ");
    gc_root(strlit5281);
  }
// compiled string node returning strlit5281 (depth = 5)
  int op_slot_left_5274 = gc_frame_newslot(strlit5281);
  params[0] = call5279;
  partcv[0] = 1;
  Object opresult5282 = callmethod(strlit5281, "++(1)", 1, partcv, params);
// compiled op node returning opresult5282 (depth = 4)
  int op_slot_left_5271 = gc_frame_newslot(opresult5282);
  params[0] = strlit5272;
  partcv[0] = 1;
  Object opresult5283 = callmethod(opresult5282, "++(1)", 1, partcv, params);
// compiled op node returning opresult5283 (depth = 3)
  gc_frame_end(frame);
  return opresult5283;
}
Object meth_ast_shallowCopy5284(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5285 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5286 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5287 = gc_frame_new();
// call case 4: self request
  Object call5288 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5287);
// compiled member node returning call5288 (depth = 5)
  gc_frame_newslot(call5288);
// starting to compile member node (depth = 5)
  int callframe5289 = gc_frame_new();
// call case 4: self request
  Object call5290 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5289);
// compiled member node returning call5290 (depth = 5)
  gc_frame_newslot(call5290);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callNode (depth = 5)
  params[0] = call5288;
  params[1] = call5290;
  partcv[0] = 2;
  Object call5291 = callmethodflags(*var_callNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5286);
// compiled call node returning call5291 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5292 = callmethodflags(call5291, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5285);
// compiled call node returning call5292 (depth = 3)
  gc_frame_end(frame);
  return call5292;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_5293(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5294 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5295 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5294);
// compiled call node returning call5295 (depth = 3)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5296 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5297 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5298 = callmethodflags(*var_other, "isPattern", 0, partcv, params, 0);
  gc_frame_end(callframe5297);
// compiled member node returning call5298 (depth = 4)
  gc_frame_newslot(call5298);
// call case 4: self request
  params[0] = call5298;
  partcv[0] = 1;
  Object call5299 = callmethodflags(self, "isPattern:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5296);
// compiled call node returning call5299 (depth = 3)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5300 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5301 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5302 = callmethodflags(*var_other, "isSelfRequest", 0, partcv, params, 0);
  gc_frame_end(callframe5301);
// compiled member node returning call5302 (depth = 4)
  gc_frame_newslot(call5302);
// call case 4: self request
  params[0] = call5302;
  partcv[0] = 1;
  Object call5303 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5300);
// compiled call node returning call5303 (depth = 3)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName5304(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5305 == NULL) {
    strlit5305 = alloc_String("request");
    gc_root(strlit5305);
  }
// compiled string node returning strlit5305 (depth = 3)
  gc_frame_end(frame);
  return strlit5305;
}
Object meth_ast_new_40_2_41_4789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_callNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_receiver_39_ = &(stackframe->slots[0]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  Object *var_parts = &(stackframe->slots[1]);
  *var_parts = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4790 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4790 = alloc_userobj2(28,24, objclass4790);
  gc_frame_newslot(obj4790);
if (objclass4790 == NULL) {
  glfree(obj4790->class->name);
  obj4790->class->name = "callNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4790, self, 0);
  addmethodreal(obj4790,"outer", &reader_ast_outer_4791);
  Object oldself4790 = self;
  struct StackFrameObject *oldstackframe4790 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4790);
  gc_frame_newslot((Object)stackframe);
  self = obj4790;
  Object *oldselfslot4790 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4790 = (*(struct UserObject *)self).data[0], lowerouter4790 = thisouter4790;
  if (inheritingObject4790) {
    struct UserObject *inho4790 = (struct UserObject *)inheritingObject4790;
    while (inho4790->super != GraceDefaultObject) inho4790 = (struct UserObject *)inho4790->super;
    inho4790->super = obj4790;
    self = inheritingObject4790;
    *selfslot = self;
    lowerouter4790 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4790;
  }
if (objclass4790 == NULL) {
  Method *reader4792 = addmethodrealflags(obj4790, "kind",&reader_ast_kind_4792, MFLAG_DEF);
  reader4792->definitionModule = modulename;
  reader4792->definitionLine = 1095;
}
adddatum2(obj4790, alloc_Undefined(), 1);
if (objclass4790 == NULL) {
  Method *reader4793 = addmethodrealflags(obj4790, "with", &reader_ast_with_4793, 0);
  Method *writer4793 = addmethodrealflags(obj4790, "with:=(1)", &writer_ast_with_4793, 0);
  reader4793->definitionModule = modulename;
  writer4793->definitionModule = modulename;
  reader4793->definitionLine = 1096;
  writer4793->definitionLine = 1096;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 2);
if (objclass4790 == NULL) {
  Method *reader4794 = addmethodrealflags(obj4790, "generics", &reader_ast_generics_4794, 0);
  Method *writer4794 = addmethodrealflags(obj4790, "generics:=(1)", &writer_ast_generics_4794, 0);
  reader4794->definitionModule = modulename;
  writer4794->definitionModule = modulename;
  reader4794->definitionLine = 1097;
  writer4794->definitionLine = 1097;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 3);
if (objclass4790 == NULL) {
  Method *reader4795 = addmethodrealflags(obj4790, "isPattern", &reader_ast_isPattern_4795, 0);
  Method *writer4795 = addmethodrealflags(obj4790, "isPattern:=(1)", &writer_ast_isPattern_4795, 0);
  reader4795->definitionModule = modulename;
  writer4795->definitionModule = modulename;
  reader4795->definitionLine = 1098;
  writer4795->definitionLine = 1098;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 4);
if (objclass4790 == NULL) {
  Method *reader4796 = addmethodrealflags(obj4790, "receiver", &reader_ast_receiver_4796, 0);
  Method *writer4796 = addmethodrealflags(obj4790, "receiver:=(1)", &writer_ast_receiver_4796, 0);
  reader4796->definitionModule = modulename;
  writer4796->definitionModule = modulename;
  reader4796->definitionLine = 1099;
  writer4796->definitionLine = 1099;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 5);
if (objclass4790 == NULL) {
  Method *reader4797 = addmethodrealflags(obj4790, "isSelfRequest", &reader_ast_isSelfRequest_4797, 0);
  Method *writer4797 = addmethodrealflags(obj4790, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_4797, 0);
  reader4797->definitionModule = modulename;
  writer4797->definitionModule = modulename;
  reader4797->definitionLine = 1100;
  writer4797->definitionLine = 1100;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 6);
// method "onSelf"
  struct UserObject *uo4798 = (struct UserObject*)obj4790;
  uo4798->data[7] = emptyclosure;
  Method *meth_meth_ast_onSelf4798 = addmethod2pos(obj4790, "onSelf", &meth_ast_onSelf4798, 7);
  int argcv_meth_ast_onSelf4798[] = {0};
  meth_meth_ast_onSelf4798->type = alloc_MethodType(1, argcv_meth_ast_onSelf4798);
  meth_meth_ast_onSelf4798->definitionModule = modulename;
  meth_meth_ast_onSelf4798->definitionLine = 1102;
// method "nameString"
  struct UserObject *uo4802 = (struct UserObject*)obj4790;
  uo4802->data[8] = emptyclosure;
  Method *meth_meth_ast_nameString4802 = addmethod2pos(obj4790, "nameString", &meth_ast_nameString4802, 8);
  int argcv_meth_ast_nameString4802[] = {0};
  meth_meth_ast_nameString4802->type = alloc_MethodType(1, argcv_meth_ast_nameString4802);
  meth_meth_ast_nameString4802->definitionModule = modulename;
  meth_meth_ast_nameString4802->definitionLine = 1108;
// method "canonicalName"
  struct UserObject *uo4816 = (struct UserObject*)obj4790;
  uo4816->data[9] = emptyclosure;
  Method *meth_meth_ast_canonicalName4816 = addmethod2pos(obj4790, "canonicalName", &meth_ast_canonicalName4816, 9);
  int argcv_meth_ast_canonicalName4816[] = {0};
  meth_meth_ast_canonicalName4816->type = alloc_MethodType(1, argcv_meth_ast_canonicalName4816);
  meth_meth_ast_canonicalName4816->definitionModule = modulename;
  meth_meth_ast_canonicalName4816->definitionLine = 1113;
// method "isCall"
  struct UserObject *uo4830 = (struct UserObject*)obj4790;
  uo4830->data[10] = emptyclosure;
  Method *meth_meth_ast_isCall4830 = addmethod2pos(obj4790, "isCall", &meth_ast_isCall4830, 10);
  int argcv_meth_ast_isCall4830[] = {0};
  meth_meth_ast_isCall4830->type = alloc_MethodType(1, argcv_meth_ast_isCall4830);
  meth_meth_ast_isCall4830->definitionModule = modulename;
  meth_meth_ast_isCall4830->definitionLine = 1119;
// method "returnsObject"
  struct UserObject *uo4832 = (struct UserObject*)obj4790;
  uo4832->data[11] = emptyclosure;
  Method *meth_meth_ast_returnsObject4832 = addmethod2pos(obj4790, "returnsObject", &meth_ast_returnsObject4832, 11);
  int argcv_meth_ast_returnsObject4832[] = {0};
  meth_meth_ast_returnsObject4832->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4832);
  meth_meth_ast_returnsObject4832->definitionModule = modulename;
  meth_meth_ast_returnsObject4832->definitionLine = 1120;
// method "returnedObjectScope"
  struct UserObject *uo4878 = (struct UserObject*)obj4790;
  uo4878->data[12] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4878 = addmethod2pos(obj4790, "returnedObjectScope", &meth_ast_returnedObjectScope4878, 12);
  int argcv_meth_ast_returnedObjectScope4878[] = {0};
  meth_meth_ast_returnedObjectScope4878->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4878);
  meth_meth_ast_returnedObjectScope4878->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4878->definitionLine = 1129;
// method "arguments"
  struct UserObject *uo4881 = (struct UserObject*)obj4790;
  uo4881->data[13] = emptyclosure;
  Method *meth_meth_ast_arguments4881 = addmethod2pos(obj4790, "arguments", &meth_ast_arguments4881, 13);
  int argcv_meth_ast_arguments4881[] = {0};
  meth_meth_ast_arguments4881->type = alloc_MethodType(1, argcv_meth_ast_arguments4881);
  meth_meth_ast_arguments4881->definitionModule = modulename;
  meth_meth_ast_arguments4881->definitionLine = 1133;
// method "argumentsDo(_)"
  struct UserObject *uo4899 = (struct UserObject*)obj4790;
  uo4899->data[14] = emptyclosure;
  Method *meth_meth_ast_argumentsDo_40_1_41_4899 = addmethod2pos(obj4790, "argumentsDo(1)", &meth_ast_argumentsDo_40_1_41_4899, 14);
  int argcv_meth_ast_argumentsDo_40_1_41_4899[] = {1};
  meth_meth_ast_argumentsDo_40_1_41_4899->type = alloc_MethodType(1, argcv_meth_ast_argumentsDo_40_1_41_4899);
  meth_meth_ast_argumentsDo_40_1_41_4899->definitionModule = modulename;
  meth_meth_ast_argumentsDo_40_1_41_4899->definitionLine = 1141;
// method "accept(_)from(_)"
  struct UserObject *uo4916 = (struct UserObject*)obj4790;
  uo4916->data[15] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_4916 = addmethod2pos(obj4790, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_4916, 15);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_4916[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_4916->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_4916);
  meth_meth_ast_accept_40_1_41_from_40_1_41_4916->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_4916->definitionLine = 1147;
// method "map(_)ancestors(_)"
  struct UserObject *uo4958 = (struct UserObject*)obj4790;
  uo4958->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_4958 = addmethod2pos(obj4790, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_4958, 16);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4958[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4958->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4958);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4958->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4958->definitionLine = 1163;
// method "pretty(_)"
  struct UserObject *uo4991 = (struct UserObject*)obj4790;
  uo4991->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_4991 = addmethod2pos(obj4790, "pretty(1)", &meth_ast_pretty_40_1_41_4991, 17);
  int argcv_meth_ast_pretty_40_1_41_4991[] = {1};
  meth_meth_ast_pretty_40_1_41_4991->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_4991);
  meth_meth_ast_pretty_40_1_41_4991->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_4991->definitionLine = 1171;
// method "toGrace(_)"
  struct UserObject *uo5157 = (struct UserObject*)obj4790;
  uo5157->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_5157 = addmethod2pos(obj4790, "toGrace(1)", &meth_ast_toGrace_40_1_41_5157, 18);
  int argcv_meth_ast_toGrace_40_1_41_5157[] = {1};
  meth_meth_ast_toGrace_40_1_41_5157->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_5157);
meth_meth_ast_toGrace_40_1_41_5157->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_5157->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_5157->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_5157->definitionLine = 1195;
// method "asIdentifier"
  block_savedest(obj4790);
  Object closure5230 = createclosure(2, "asIdentifier");
  setclosureframe(closure5230, stackframe);
  addtoclosure(closure5230, var_fakeSymbolTable);
  addtoclosure(closure5230, var_identifierNode);
  struct UserObject *uo5230 = (struct UserObject*)obj4790;
  uo5230->data[19] = (Object)closure5230;
  Method *meth_meth_ast_asIdentifier5230 = addmethod2pos(obj4790, "asIdentifier", &meth_ast_asIdentifier5230, 19);
  int argcv_meth_ast_asIdentifier5230[] = {0};
  meth_meth_ast_asIdentifier5230->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier5230);
  meth_meth_ast_asIdentifier5230->definitionModule = modulename;
  meth_meth_ast_asIdentifier5230->definitionLine = 1208;
// method "asString"
  struct UserObject *uo5270 = (struct UserObject*)obj4790;
  uo5270->data[20] = emptyclosure;
  Method *meth_meth_ast_asString5270 = addmethod2pos(obj4790, "asString", &meth_ast_asString5270, 20);
  int argcv_meth_ast_asString5270[] = {0};
  meth_meth_ast_asString5270->type = alloc_MethodType(1, argcv_meth_ast_asString5270);
  meth_meth_ast_asString5270->definitionModule = modulename;
  meth_meth_ast_asString5270->definitionLine = 1219;
// method "shallowCopy"
  block_savedest(obj4790);
  Object closure5284 = createclosure(1, "shallowCopy");
  setclosureframe(closure5284, stackframe);
  addtoclosure(closure5284, var_callNode);
  struct UserObject *uo5284 = (struct UserObject*)obj4790;
  uo5284->data[21] = (Object)closure5284;
  Method *meth_meth_ast_shallowCopy5284 = addmethod2pos(obj4790, "shallowCopy", &meth_ast_shallowCopy5284, 21);
  int argcv_meth_ast_shallowCopy5284[] = {0};
  meth_meth_ast_shallowCopy5284->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5284);
  meth_meth_ast_shallowCopy5284->definitionModule = modulename;
  meth_meth_ast_shallowCopy5284->definitionLine = 1220;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5293 = (struct UserObject*)obj4790;
  uo5293->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5293 = addmethod2pos(obj4790, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5293, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5293[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5293->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5293);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5293->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5293->definitionLine = 1223;
// method "statementName"
  struct UserObject *uo5304 = (struct UserObject*)obj4790;
  uo5304->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName5304 = addmethod2pos(obj4790, "statementName", &meth_ast_statementName5304, 23);
  int argcv_meth_ast_statementName5304[] = {0};
  meth_meth_ast_statementName5304->type = alloc_MethodType(1, argcv_meth_ast_statementName5304);
  meth_meth_ast_statementName5304->definitionModule = modulename;
  meth_meth_ast_statementName5304->definitionLine = 1229;
  sourceObject = obj4790;
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5306 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5307 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5308 = gc_frame_new();
// call case 3: self.outer request
  Object call5309 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5308);
// compiled member node returning call5309 (depth = 5)
  Object call5310 = callmethodflags(call5309, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5307);
// compiled member node returning call5310 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5311 = callmethodflags(call5310, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5306);
// compiled call node returning call5311 (depth = 3)
  struct UserObject *obj4790_uo = (struct UserObject *)obj4790;
  obj4790_uo->super = call5311;
  sourceObject = obj4790;
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5312 == NULL) {
    strlit5312 = alloc_String("call");
    gc_root(strlit5312);
  }
// compiled string node returning strlit5312 (depth = 3)
  adddatum2(obj4790, strlit5312, 1);
  sourceObject = obj4790;
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_parts (depth = 3)
  adddatum2(obj4790, *var_parts, 2);
  sourceObject = obj4790;
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5313 = alloc_Boolean(0);
// compiled identifier node returning bool5313 (depth = 3)
  adddatum2(obj4790, bool5313, 3);
  sourceObject = obj4790;
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5314 = alloc_Boolean(0);
// compiled identifier node returning bool5314 (depth = 3)
  adddatum2(obj4790, bool5314, 4);
  sourceObject = obj4790;
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj4790, *var_receiver_39_, 5);
  sourceObject = obj4790;
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5315 = alloc_Boolean(0);
// compiled identifier node returning bool5315 (depth = 3)
  adddatum2(obj4790, bool5315, 6);
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  objclass4790 = obj4790->class;
  objclass4790->definitionModule = modulename;
  objclass4790->definitionLine = 1089;
  (*(struct UserObject *)self).data[0] = lowerouter4790;
  self = oldself4790;
  selfslot = oldselfslot4790;
  stackframe = oldstackframe4790;
  gc_frame_end(frame);
  return obj4790;
}
Object meth_ast_new_40_2_41_4789_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_callNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_receiver_39_ = &(stackframe->slots[0]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  Object *var_parts = &(stackframe->slots[1]);
  *var_parts = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4790 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4790 = alloc_userobj2(28,24, objclass4790);
  gc_frame_newslot(obj4790);
if (objclass4790 == NULL) {
  glfree(obj4790->class->name);
  obj4790->class->name = "callNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4790, self, 0);
  addmethodreal(obj4790,"outer", &reader_ast_outer_4791);
  Object oldself4790 = self;
  struct StackFrameObject *oldstackframe4790 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4790);
  gc_frame_newslot((Object)stackframe);
  self = obj4790;
  Object *oldselfslot4790 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4790 = (*(struct UserObject *)self).data[0], lowerouter4790 = thisouter4790;
  if (inheritingObject4790) {
    struct UserObject *inho4790 = (struct UserObject *)inheritingObject4790;
    while (inho4790->super != GraceDefaultObject) inho4790 = (struct UserObject *)inho4790->super;
    inho4790->super = obj4790;
    self = inheritingObject4790;
    *selfslot = self;
    lowerouter4790 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4790;
  }
if (objclass4790 == NULL) {
  Method *reader4792 = addmethodrealflags(obj4790, "kind",&reader_ast_kind_4792, MFLAG_DEF);
  reader4792->definitionModule = modulename;
  reader4792->definitionLine = 1095;
}
adddatum2(obj4790, alloc_Undefined(), 1);
if (objclass4790 == NULL) {
  Method *reader4793 = addmethodrealflags(obj4790, "with", &reader_ast_with_4793, 0);
  Method *writer4793 = addmethodrealflags(obj4790, "with:=(1)", &writer_ast_with_4793, 0);
  reader4793->definitionModule = modulename;
  writer4793->definitionModule = modulename;
  reader4793->definitionLine = 1096;
  writer4793->definitionLine = 1096;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 2);
if (objclass4790 == NULL) {
  Method *reader4794 = addmethodrealflags(obj4790, "generics", &reader_ast_generics_4794, 0);
  Method *writer4794 = addmethodrealflags(obj4790, "generics:=(1)", &writer_ast_generics_4794, 0);
  reader4794->definitionModule = modulename;
  writer4794->definitionModule = modulename;
  reader4794->definitionLine = 1097;
  writer4794->definitionLine = 1097;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 3);
if (objclass4790 == NULL) {
  Method *reader4795 = addmethodrealflags(obj4790, "isPattern", &reader_ast_isPattern_4795, 0);
  Method *writer4795 = addmethodrealflags(obj4790, "isPattern:=(1)", &writer_ast_isPattern_4795, 0);
  reader4795->definitionModule = modulename;
  writer4795->definitionModule = modulename;
  reader4795->definitionLine = 1098;
  writer4795->definitionLine = 1098;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 4);
if (objclass4790 == NULL) {
  Method *reader4796 = addmethodrealflags(obj4790, "receiver", &reader_ast_receiver_4796, 0);
  Method *writer4796 = addmethodrealflags(obj4790, "receiver:=(1)", &writer_ast_receiver_4796, 0);
  reader4796->definitionModule = modulename;
  writer4796->definitionModule = modulename;
  reader4796->definitionLine = 1099;
  writer4796->definitionLine = 1099;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 5);
if (objclass4790 == NULL) {
  Method *reader4797 = addmethodrealflags(obj4790, "isSelfRequest", &reader_ast_isSelfRequest_4797, 0);
  Method *writer4797 = addmethodrealflags(obj4790, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_4797, 0);
  reader4797->definitionModule = modulename;
  writer4797->definitionModule = modulename;
  reader4797->definitionLine = 1100;
  writer4797->definitionLine = 1100;
}
obj4790->flags |= OFLAG_MUTABLE;
adddatum2(obj4790, alloc_Undefined(), 6);
// method "onSelf"
  struct UserObject *uo4798 = (struct UserObject*)obj4790;
  uo4798->data[7] = emptyclosure;
  Method *meth_meth_ast_onSelf4798 = addmethod2pos(obj4790, "onSelf", &meth_ast_onSelf4798, 7);
  int argcv_meth_ast_onSelf4798[] = {0};
  meth_meth_ast_onSelf4798->type = alloc_MethodType(1, argcv_meth_ast_onSelf4798);
  meth_meth_ast_onSelf4798->definitionModule = modulename;
  meth_meth_ast_onSelf4798->definitionLine = 1102;
// method "nameString"
  struct UserObject *uo4802 = (struct UserObject*)obj4790;
  uo4802->data[8] = emptyclosure;
  Method *meth_meth_ast_nameString4802 = addmethod2pos(obj4790, "nameString", &meth_ast_nameString4802, 8);
  int argcv_meth_ast_nameString4802[] = {0};
  meth_meth_ast_nameString4802->type = alloc_MethodType(1, argcv_meth_ast_nameString4802);
  meth_meth_ast_nameString4802->definitionModule = modulename;
  meth_meth_ast_nameString4802->definitionLine = 1108;
// method "canonicalName"
  struct UserObject *uo4816 = (struct UserObject*)obj4790;
  uo4816->data[9] = emptyclosure;
  Method *meth_meth_ast_canonicalName4816 = addmethod2pos(obj4790, "canonicalName", &meth_ast_canonicalName4816, 9);
  int argcv_meth_ast_canonicalName4816[] = {0};
  meth_meth_ast_canonicalName4816->type = alloc_MethodType(1, argcv_meth_ast_canonicalName4816);
  meth_meth_ast_canonicalName4816->definitionModule = modulename;
  meth_meth_ast_canonicalName4816->definitionLine = 1113;
// method "isCall"
  struct UserObject *uo4830 = (struct UserObject*)obj4790;
  uo4830->data[10] = emptyclosure;
  Method *meth_meth_ast_isCall4830 = addmethod2pos(obj4790, "isCall", &meth_ast_isCall4830, 10);
  int argcv_meth_ast_isCall4830[] = {0};
  meth_meth_ast_isCall4830->type = alloc_MethodType(1, argcv_meth_ast_isCall4830);
  meth_meth_ast_isCall4830->definitionModule = modulename;
  meth_meth_ast_isCall4830->definitionLine = 1119;
// method "returnsObject"
  struct UserObject *uo4832 = (struct UserObject*)obj4790;
  uo4832->data[11] = emptyclosure;
  Method *meth_meth_ast_returnsObject4832 = addmethod2pos(obj4790, "returnsObject", &meth_ast_returnsObject4832, 11);
  int argcv_meth_ast_returnsObject4832[] = {0};
  meth_meth_ast_returnsObject4832->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4832);
  meth_meth_ast_returnsObject4832->definitionModule = modulename;
  meth_meth_ast_returnsObject4832->definitionLine = 1120;
// method "returnedObjectScope"
  struct UserObject *uo4878 = (struct UserObject*)obj4790;
  uo4878->data[12] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4878 = addmethod2pos(obj4790, "returnedObjectScope", &meth_ast_returnedObjectScope4878, 12);
  int argcv_meth_ast_returnedObjectScope4878[] = {0};
  meth_meth_ast_returnedObjectScope4878->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4878);
  meth_meth_ast_returnedObjectScope4878->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4878->definitionLine = 1129;
// method "arguments"
  struct UserObject *uo4881 = (struct UserObject*)obj4790;
  uo4881->data[13] = emptyclosure;
  Method *meth_meth_ast_arguments4881 = addmethod2pos(obj4790, "arguments", &meth_ast_arguments4881, 13);
  int argcv_meth_ast_arguments4881[] = {0};
  meth_meth_ast_arguments4881->type = alloc_MethodType(1, argcv_meth_ast_arguments4881);
  meth_meth_ast_arguments4881->definitionModule = modulename;
  meth_meth_ast_arguments4881->definitionLine = 1133;
// method "argumentsDo(_)"
  struct UserObject *uo4899 = (struct UserObject*)obj4790;
  uo4899->data[14] = emptyclosure;
  Method *meth_meth_ast_argumentsDo_40_1_41_4899 = addmethod2pos(obj4790, "argumentsDo(1)", &meth_ast_argumentsDo_40_1_41_4899, 14);
  int argcv_meth_ast_argumentsDo_40_1_41_4899[] = {1};
  meth_meth_ast_argumentsDo_40_1_41_4899->type = alloc_MethodType(1, argcv_meth_ast_argumentsDo_40_1_41_4899);
  meth_meth_ast_argumentsDo_40_1_41_4899->definitionModule = modulename;
  meth_meth_ast_argumentsDo_40_1_41_4899->definitionLine = 1141;
// method "accept(_)from(_)"
  struct UserObject *uo4916 = (struct UserObject*)obj4790;
  uo4916->data[15] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_4916 = addmethod2pos(obj4790, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_4916, 15);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_4916[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_4916->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_4916);
  meth_meth_ast_accept_40_1_41_from_40_1_41_4916->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_4916->definitionLine = 1147;
// method "map(_)ancestors(_)"
  struct UserObject *uo4958 = (struct UserObject*)obj4790;
  uo4958->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_4958 = addmethod2pos(obj4790, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_4958, 16);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4958[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4958->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4958);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4958->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4958->definitionLine = 1163;
// method "pretty(_)"
  struct UserObject *uo4991 = (struct UserObject*)obj4790;
  uo4991->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_4991 = addmethod2pos(obj4790, "pretty(1)", &meth_ast_pretty_40_1_41_4991, 17);
  int argcv_meth_ast_pretty_40_1_41_4991[] = {1};
  meth_meth_ast_pretty_40_1_41_4991->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_4991);
  meth_meth_ast_pretty_40_1_41_4991->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_4991->definitionLine = 1171;
// method "toGrace(_)"
  struct UserObject *uo5157 = (struct UserObject*)obj4790;
  uo5157->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_5157 = addmethod2pos(obj4790, "toGrace(1)", &meth_ast_toGrace_40_1_41_5157, 18);
  int argcv_meth_ast_toGrace_40_1_41_5157[] = {1};
  meth_meth_ast_toGrace_40_1_41_5157->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_5157);
meth_meth_ast_toGrace_40_1_41_5157->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_5157->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_5157->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_5157->definitionLine = 1195;
// method "asIdentifier"
  block_savedest(obj4790);
  Object closure5230 = createclosure(2, "asIdentifier");
  setclosureframe(closure5230, stackframe);
  addtoclosure(closure5230, var_fakeSymbolTable);
  addtoclosure(closure5230, var_identifierNode);
  struct UserObject *uo5230 = (struct UserObject*)obj4790;
  uo5230->data[19] = (Object)closure5230;
  Method *meth_meth_ast_asIdentifier5230 = addmethod2pos(obj4790, "asIdentifier", &meth_ast_asIdentifier5230, 19);
  int argcv_meth_ast_asIdentifier5230[] = {0};
  meth_meth_ast_asIdentifier5230->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier5230);
  meth_meth_ast_asIdentifier5230->definitionModule = modulename;
  meth_meth_ast_asIdentifier5230->definitionLine = 1208;
// method "asString"
  struct UserObject *uo5270 = (struct UserObject*)obj4790;
  uo5270->data[20] = emptyclosure;
  Method *meth_meth_ast_asString5270 = addmethod2pos(obj4790, "asString", &meth_ast_asString5270, 20);
  int argcv_meth_ast_asString5270[] = {0};
  meth_meth_ast_asString5270->type = alloc_MethodType(1, argcv_meth_ast_asString5270);
  meth_meth_ast_asString5270->definitionModule = modulename;
  meth_meth_ast_asString5270->definitionLine = 1219;
// method "shallowCopy"
  block_savedest(obj4790);
  Object closure5284 = createclosure(1, "shallowCopy");
  setclosureframe(closure5284, stackframe);
  addtoclosure(closure5284, var_callNode);
  struct UserObject *uo5284 = (struct UserObject*)obj4790;
  uo5284->data[21] = (Object)closure5284;
  Method *meth_meth_ast_shallowCopy5284 = addmethod2pos(obj4790, "shallowCopy", &meth_ast_shallowCopy5284, 21);
  int argcv_meth_ast_shallowCopy5284[] = {0};
  meth_meth_ast_shallowCopy5284->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5284);
  meth_meth_ast_shallowCopy5284->definitionModule = modulename;
  meth_meth_ast_shallowCopy5284->definitionLine = 1220;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5293 = (struct UserObject*)obj4790;
  uo5293->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5293 = addmethod2pos(obj4790, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5293, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5293[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5293->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5293);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5293->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5293->definitionLine = 1223;
// method "statementName"
  struct UserObject *uo5304 = (struct UserObject*)obj4790;
  uo5304->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName5304 = addmethod2pos(obj4790, "statementName", &meth_ast_statementName5304, 23);
  int argcv_meth_ast_statementName5304[] = {0};
  meth_meth_ast_statementName5304->type = alloc_MethodType(1, argcv_meth_ast_statementName5304);
  meth_meth_ast_statementName5304->definitionModule = modulename;
  meth_meth_ast_statementName5304->definitionLine = 1229;
  sourceObject = obj4790;
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5306 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5307 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5308 = gc_frame_new();
// call case 3: self.outer request
  Object call5309 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5308);
// compiled member node returning call5309 (depth = 5)
  Object call5310 = callmethodflags(call5309, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5307);
// compiled member node returning call5310 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5311 = callmethodflags(call5310, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5306);
// compiled call node returning call5311 (depth = 3)
  struct UserObject *obj4790_uo = (struct UserObject *)obj4790;
  obj4790_uo->super = call5311;
  sourceObject = obj4790;
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5312 == NULL) {
    strlit5312 = alloc_String("call");
    gc_root(strlit5312);
  }
// compiled string node returning strlit5312 (depth = 3)
  adddatum2(obj4790, strlit5312, 1);
  sourceObject = obj4790;
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_parts (depth = 3)
  adddatum2(obj4790, *var_parts, 2);
  sourceObject = obj4790;
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5313 = alloc_Boolean(0);
// compiled identifier node returning bool5313 (depth = 3)
  adddatum2(obj4790, bool5313, 3);
  sourceObject = obj4790;
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5314 = alloc_Boolean(0);
// compiled identifier node returning bool5314 (depth = 3)
  adddatum2(obj4790, bool5314, 4);
  sourceObject = obj4790;
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj4790, *var_receiver_39_, 5);
  sourceObject = obj4790;
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5315 = alloc_Boolean(0);
// compiled identifier node returning bool5315 (depth = 3)
  adddatum2(obj4790, bool5315, 6);
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  sourceObject = obj4790;
  objclass4790 = obj4790->class;
  objclass4790->definitionModule = modulename;
  objclass4790->definitionLine = 1089;
  (*(struct UserObject *)self).data[0] = lowerouter4790;
  self = oldself4790;
  selfslot = oldselfslot4790;
  stackframe = oldstackframe4790;
  gc_frame_end(frame);
  return obj4790;
}
Object meth_ast_callNode5317(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callNode (depth = 3)
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5320(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5321 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5322 = callmethodflags(self, "body(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5321);
// compiled call node returning call5322 (depth = 4)
  *var_result = call5322;
  if (call5322 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5323 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5324 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5323);
// compiled call node returning call5324 (depth = 3)
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5325 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5326 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5325);
// compiled call node returning call5326 (depth = 3)
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40_1_41_named_40_1_41_5327(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5328 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5329 = callmethodflags(self, "body(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5328);
// compiled call node returning call5329 (depth = 4)
  *var_result = call5329;
  if (call5329 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5330 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5331 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5330);
// compiled call node returning call5331 (depth = 3)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isModule5338(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5339 = alloc_Boolean(1);
// compiled identifier node returning bool5339 (depth = 3)
  gc_frame_end(frame);
  return bool5339;
}
Object meth_ast_returnsObject5340(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5341 = alloc_Boolean(0);
// compiled identifier node returning bool5341 (depth = 3)
  gc_frame_end(frame);
  return bool5341;
}
Object meth_ast__apply_40_1_41_5345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5347 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  Object call5348 = callmethodflags(*var_o, "isExternal", 0, partcv, params, 0);
  gc_frame_end(callframe5347);
// compiled member node returning call5348 (depth = 6)
  Object if5346 = done;
  if (istrue(call5348)) {
// starting to compile call node (depth = 6)
  int callframe5349 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5350 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5349);
// compiled call node returning call5350 (depth = 6)
    gc_frame_newslot(call5350);
    if5346 = call5350;
  } else {
  }
// compiled if node returning if5346 (depth = 5)
  gc_frame_end(frame);
  return if5346;
}
Object meth_ast_externalsDo_40_1_41_5342(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "externalsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method externalsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for externalsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part externalsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5343 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5344 = alloc_Block(NULL, NULL, "ast", 1255);
  gc_frame_newslot(block5344);
// method "_apply(_)"
  block_savedest(block5344);
  Object closure5345 = createclosure(2, "_apply(1)");
  setclosureframe(closure5345, stackframe);
  addtoclosure(closure5345, var_action);
  addtoclosure(closure5345, selfslot);
  struct UserObject *uo5345 = (struct UserObject*)block5344;
  uo5345->data[0] = (Object)closure5345;
  Method *meth_meth_ast__apply_40_1_41_5345 = addmethod2pos(block5344, "_apply(1)", &meth_ast__apply_40_1_41_5345, 0);
  int argcv_meth_ast__apply_40_1_41_5345[] = {1};
  meth_meth_ast__apply_40_1_41_5345->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5345);
  meth_meth_ast__apply_40_1_41_5345->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5345->definitionLine = 2969;
// compiled block node returning block5344 (depth = 4)
  gc_frame_newslot(block5344);
// call case 6: other requests
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5352 = gc_frame_new();
// call case 4: self request
  Object call5353 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5352);
// compiled member node returning call5353 (depth = 4)
  params[0] = block5344;
  partcv[0] = 1;
  Object call5354 = callmethodflags(call5353, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5343);
// compiled call node returning call5354 (depth = 3)
  gc_frame_end(frame);
  return call5354;
}
Object meth_ast__apply_40_1_41_5376(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5377 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5378 = callmethodflags(*var_x, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5377);
// compiled call node returning call5378 (depth = 6)
  gc_frame_end(frame);
  return call5378;
}
Object meth_ast_accept_40_1_41_from_40_1_41_5355(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5357 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5358 = callmethodflags(*var_visitor, "visitModule(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5357);
// compiled call node returning call5358 (depth = 4)
  Object if5356 = done;
  if (istrue(call5358)) {
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5359 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5360 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5359);
// compiled call node returning call5360 (depth = 5)
  *var_newChain = call5360;
  if (call5360 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5363 = gc_frame_new();
// call case 4: self request
  Object call5364 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5363);
// compiled member node returning call5364 (depth = 6)
  int op_slot_right_5362 = gc_frame_newslot(call5364);
// starting to compile identifier node (depth = 6)
  Object bool5366 = alloc_Boolean(0);
// compiled identifier node returning bool5366 (depth = 6)
  int op_slot_left_5362 = gc_frame_newslot(bool5366);
  params[0] = call5364;
  partcv[0] = 1;
  Object opresult5367 = callmethod(bool5366, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5367 (depth = 5)
  Object if5361 = done;
  if (istrue(opresult5367)) {
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5368 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5369 = gc_frame_new();
// call case 4: self request
  Object call5370 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5369);
// compiled member node returning call5370 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5371 = callmethodflags(call5370, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5368);
// compiled call node returning call5371 (depth = 5)
    gc_frame_newslot(call5371);
    if5361 = call5371;
  } else {
  }
// compiled if node returning if5361 (depth = 4)
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5372 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5373 = gc_frame_new();
// call case 4: self request
  Object call5374 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5373);
// compiled member node returning call5374 (depth = 5)
  gc_frame_newslot(call5374);
// starting to compile block node (depth = 5)
  Object block5375 = alloc_Block(NULL, NULL, "ast", 1265);
  gc_frame_newslot(block5375);
// method "_apply(_)"
  block_savedest(block5375);
  Object closure5376 = createclosure(3, "_apply(1)");
  setclosureframe(closure5376, stackframe);
  addtoclosure(closure5376, var_visitor);
  addtoclosure(closure5376, var_newChain);
  addtoclosure(closure5376, selfslot);
  struct UserObject *uo5376 = (struct UserObject*)block5375;
  uo5376->data[0] = (Object)closure5376;
  Method *meth_meth_ast__apply_40_1_41_5376 = addmethod2pos(block5375, "_apply(1)", &meth_ast__apply_40_1_41_5376, 0);
  int argcv_meth_ast__apply_40_1_41_5376[] = {1};
  meth_meth_ast__apply_40_1_41_5376->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5376);
  meth_meth_ast__apply_40_1_41_5376->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5376->definitionLine = 2969;
// compiled block node returning block5375 (depth = 5)
  gc_frame_newslot(block5375);
// call case 5: prelude request
  params[0] = call5374;
  params[1] = block5375;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5380 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5372);
// compiled call node returning call5380 (depth = 4)
    gc_frame_newslot(call5380);
    if5356 = call5380;
  } else {
  }
// compiled if node returning if5356 (depth = 3)
  gc_frame_end(frame);
  return if5356;
}
Object meth_ast_shallowCopy5381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5382 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5383 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_moduleNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call5384 = callmethodflags(*var_moduleNode, "body(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5383);
// compiled call node returning call5384 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5385 = callmethodflags(call5384, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5382);
// compiled call node returning call5385 (depth = 3)
  gc_frame_end(frame);
  return call5385;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_5386(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5387 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5388 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5387);
// compiled call node returning call5388 (depth = 3)
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5389 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5390 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5391 = callmethodflags(*var_other, "imports", 0, partcv, params, 0);
  gc_frame_end(callframe5390);
// compiled member node returning call5391 (depth = 4)
  gc_frame_newslot(call5391);
// call case 4: self request
  params[0] = call5391;
  partcv[0] = 1;
  Object call5392 = callmethodflags(self, "imports:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5389);
// compiled call node returning call5392 (depth = 3)
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_body_40_1_41_5332(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5333 = alloc_userobj2(12,12, objclass5333);
  gc_frame_newslot(obj5333);
if (objclass5333 == NULL) {
  glfree(obj5333->class->name);
  obj5333->class->name = "moduleNode.body(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5333, self, 0);
  addmethodreal(obj5333,"outer", &reader_ast_outer_5334);
  Object oldself5333 = self;
  struct StackFrameObject *oldstackframe5333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5333);
  gc_frame_newslot((Object)stackframe);
  self = obj5333;
  Object *oldselfslot5333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5333 = (*(struct UserObject *)self).data[0], lowerouter5333 = thisouter5333;
  if (inheritingObject5333) {
    struct UserObject *inho5333 = (struct UserObject *)inheritingObject5333;
    while (inho5333->super != GraceDefaultObject) inho5333 = (struct UserObject *)inho5333->super;
    inho5333->super = obj5333;
    self = inheritingObject5333;
    *selfslot = self;
    lowerouter5333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5333;
  }
if (objclass5333 == NULL) {
  Method *reader5335 = addmethodrealflags(obj5333, "kind",&reader_ast_kind_5335, MFLAG_DEF);
  reader5335->definitionModule = modulename;
  reader5335->definitionLine = 1246;
}
adddatum2(obj5333, alloc_Undefined(), 1);
if (objclass5333 == NULL) {
  Method *reader5336 = addmethodrealflags(obj5333, "sourceLines",&reader_ast_sourceLines_5336, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5336->definitionModule = modulename;
  reader5336->definitionLine = 1247;
}
adddatum2(obj5333, alloc_Undefined(), 2);
if (objclass5333 == NULL) {
  Method *reader5337 = addmethodrealflags(obj5333, "imports", &reader_ast_imports_5337, 0);
  Method *writer5337 = addmethodrealflags(obj5333, "imports:=(1)", &writer_ast_imports_5337, 0);
  reader5337->definitionModule = modulename;
  writer5337->definitionModule = modulename;
  reader5337->definitionLine = 1250;
  writer5337->definitionLine = 1250;
}
obj5333->flags |= OFLAG_MUTABLE;
adddatum2(obj5333, alloc_Undefined(), 3);
// method "isModule"
  struct UserObject *uo5338 = (struct UserObject*)obj5333;
  uo5338->data[4] = emptyclosure;
  Method *meth_meth_ast_isModule5338 = addmethod2pos(obj5333, "isModule", &meth_ast_isModule5338, 4);
  int argcv_meth_ast_isModule5338[] = {0};
  meth_meth_ast_isModule5338->type = alloc_MethodType(1, argcv_meth_ast_isModule5338);
  meth_meth_ast_isModule5338->definitionModule = modulename;
  meth_meth_ast_isModule5338->definitionLine = 1252;
// method "returnsObject"
  struct UserObject *uo5340 = (struct UserObject*)obj5333;
  uo5340->data[5] = emptyclosure;
  Method *meth_meth_ast_returnsObject5340 = addmethod2pos(obj5333, "returnsObject", &meth_ast_returnsObject5340, 5);
  int argcv_meth_ast_returnsObject5340[] = {0};
  meth_meth_ast_returnsObject5340->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5340);
  meth_meth_ast_returnsObject5340->definitionModule = modulename;
  meth_meth_ast_returnsObject5340->definitionLine = 1253;
// method "externalsDo(_)"
  struct UserObject *uo5342 = (struct UserObject*)obj5333;
  uo5342->data[6] = emptyclosure;
  Method *meth_meth_ast_externalsDo_40_1_41_5342 = addmethod2pos(obj5333, "externalsDo(1)", &meth_ast_externalsDo_40_1_41_5342, 6);
  int argcv_meth_ast_externalsDo_40_1_41_5342[] = {1};
  meth_meth_ast_externalsDo_40_1_41_5342->type = alloc_MethodType(1, argcv_meth_ast_externalsDo_40_1_41_5342);
  meth_meth_ast_externalsDo_40_1_41_5342->definitionModule = modulename;
  meth_meth_ast_externalsDo_40_1_41_5342->definitionLine = 1254;
// method "accept(_)from(_)"
  struct UserObject *uo5355 = (struct UserObject*)obj5333;
  uo5355->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_5355 = addmethod2pos(obj5333, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_5355, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_5355[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_5355->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_5355);
  meth_meth_ast_accept_40_1_41_from_40_1_41_5355->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_5355->definitionLine = 1259;
// method "shallowCopy"
  block_savedest(obj5333);
  Object closure5381 = createclosure(2, "shallowCopy");
  setclosureframe(closure5381, stackframe);
  addtoclosure(closure5381, var_emptySeq);
  addtoclosure(closure5381, var_moduleNode);
  struct UserObject *uo5381 = (struct UserObject*)obj5333;
  uo5381->data[8] = (Object)closure5381;
  Method *meth_meth_ast_shallowCopy5381 = addmethod2pos(obj5333, "shallowCopy", &meth_ast_shallowCopy5381, 8);
  int argcv_meth_ast_shallowCopy5381[] = {0};
  meth_meth_ast_shallowCopy5381->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5381);
  meth_meth_ast_shallowCopy5381->definitionModule = modulename;
  meth_meth_ast_shallowCopy5381->definitionLine = 1270;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5386 = (struct UserObject*)obj5333;
  uo5386->data[9] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5386 = addmethod2pos(obj5333, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5386, 9);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5386[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5386->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5386);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5386->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5386->definitionLine = 1273;
  sourceObject = obj5333;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5393 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool5394 = alloc_Boolean(0);
// compiled identifier node returning bool5394 (depth = 4)
  gc_frame_newslot(bool5394);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool5394;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5395 = callmethodflags(*var_objectNode, "new(2)$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5393);
// compiled call node returning call5395 (depth = 3)
  struct UserObject *obj5333_uo = (struct UserObject *)obj5333;
  obj5333_uo->super = call5395;
  sourceObject = obj5333;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5396 == NULL) {
    strlit5396 = alloc_String("module");
    gc_root(strlit5396);
  }
// compiled string node returning strlit5396 (depth = 3)
  adddatum2(obj5333, strlit5396, 1);
  sourceObject = obj5333;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5397 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  Object call5398 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe5397);
// compiled member node returning call5398 (depth = 3)
  adddatum2(obj5333, call5398, 2);
  sourceObject = obj5333;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5399 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5400 = alloc_Float64(0);
// compiled num node returning num5400 (depth = 4)
  gc_frame_newslot(num5400);
// call case 4: self request
  params[0] = num5400;
  partcv[0] = 1;
  Object call5401 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5399);
// compiled call node returning call5401 (depth = 3)
  sourceObject = obj5333;
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5402 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5403 = alloc_Float64(0);
// compiled num node returning num5403 (depth = 4)
  gc_frame_newslot(num5403);
// call case 4: self request
  params[0] = num5403;
  partcv[0] = 1;
  Object call5404 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5402);
// compiled call node returning call5404 (depth = 3)
  sourceObject = obj5333;
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5405 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5405 (depth = 3)
  adddatum2(obj5333, array5405, 3);
  sourceObject = obj5333;
  sourceObject = obj5333;
  sourceObject = obj5333;
  sourceObject = obj5333;
  sourceObject = obj5333;
  sourceObject = obj5333;
  objclass5333 = obj5333->class;
  objclass5333->definitionModule = modulename;
  objclass5333->definitionLine = 1244;
  (*(struct UserObject *)self).data[0] = lowerouter5333;
  self = oldself5333;
  selfslot = oldselfslot5333;
  stackframe = oldstackframe5333;
  gc_frame_end(frame);
  return obj5333;
}
Object meth_ast_body_40_1_41_5332_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method body(_)");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5333 = alloc_userobj2(12,12, objclass5333);
  gc_frame_newslot(obj5333);
if (objclass5333 == NULL) {
  glfree(obj5333->class->name);
  obj5333->class->name = "moduleNode.body(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5333, self, 0);
  addmethodreal(obj5333,"outer", &reader_ast_outer_5334);
  Object oldself5333 = self;
  struct StackFrameObject *oldstackframe5333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5333);
  gc_frame_newslot((Object)stackframe);
  self = obj5333;
  Object *oldselfslot5333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5333 = (*(struct UserObject *)self).data[0], lowerouter5333 = thisouter5333;
  if (inheritingObject5333) {
    struct UserObject *inho5333 = (struct UserObject *)inheritingObject5333;
    while (inho5333->super != GraceDefaultObject) inho5333 = (struct UserObject *)inho5333->super;
    inho5333->super = obj5333;
    self = inheritingObject5333;
    *selfslot = self;
    lowerouter5333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5333;
  }
if (objclass5333 == NULL) {
  Method *reader5335 = addmethodrealflags(obj5333, "kind",&reader_ast_kind_5335, MFLAG_DEF);
  reader5335->definitionModule = modulename;
  reader5335->definitionLine = 1246;
}
adddatum2(obj5333, alloc_Undefined(), 1);
if (objclass5333 == NULL) {
  Method *reader5336 = addmethodrealflags(obj5333, "sourceLines",&reader_ast_sourceLines_5336, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5336->definitionModule = modulename;
  reader5336->definitionLine = 1247;
}
adddatum2(obj5333, alloc_Undefined(), 2);
if (objclass5333 == NULL) {
  Method *reader5337 = addmethodrealflags(obj5333, "imports", &reader_ast_imports_5337, 0);
  Method *writer5337 = addmethodrealflags(obj5333, "imports:=(1)", &writer_ast_imports_5337, 0);
  reader5337->definitionModule = modulename;
  writer5337->definitionModule = modulename;
  reader5337->definitionLine = 1250;
  writer5337->definitionLine = 1250;
}
obj5333->flags |= OFLAG_MUTABLE;
adddatum2(obj5333, alloc_Undefined(), 3);
// method "isModule"
  struct UserObject *uo5338 = (struct UserObject*)obj5333;
  uo5338->data[4] = emptyclosure;
  Method *meth_meth_ast_isModule5338 = addmethod2pos(obj5333, "isModule", &meth_ast_isModule5338, 4);
  int argcv_meth_ast_isModule5338[] = {0};
  meth_meth_ast_isModule5338->type = alloc_MethodType(1, argcv_meth_ast_isModule5338);
  meth_meth_ast_isModule5338->definitionModule = modulename;
  meth_meth_ast_isModule5338->definitionLine = 1252;
// method "returnsObject"
  struct UserObject *uo5340 = (struct UserObject*)obj5333;
  uo5340->data[5] = emptyclosure;
  Method *meth_meth_ast_returnsObject5340 = addmethod2pos(obj5333, "returnsObject", &meth_ast_returnsObject5340, 5);
  int argcv_meth_ast_returnsObject5340[] = {0};
  meth_meth_ast_returnsObject5340->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5340);
  meth_meth_ast_returnsObject5340->definitionModule = modulename;
  meth_meth_ast_returnsObject5340->definitionLine = 1253;
// method "externalsDo(_)"
  struct UserObject *uo5342 = (struct UserObject*)obj5333;
  uo5342->data[6] = emptyclosure;
  Method *meth_meth_ast_externalsDo_40_1_41_5342 = addmethod2pos(obj5333, "externalsDo(1)", &meth_ast_externalsDo_40_1_41_5342, 6);
  int argcv_meth_ast_externalsDo_40_1_41_5342[] = {1};
  meth_meth_ast_externalsDo_40_1_41_5342->type = alloc_MethodType(1, argcv_meth_ast_externalsDo_40_1_41_5342);
  meth_meth_ast_externalsDo_40_1_41_5342->definitionModule = modulename;
  meth_meth_ast_externalsDo_40_1_41_5342->definitionLine = 1254;
// method "accept(_)from(_)"
  struct UserObject *uo5355 = (struct UserObject*)obj5333;
  uo5355->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_5355 = addmethod2pos(obj5333, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_5355, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_5355[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_5355->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_5355);
  meth_meth_ast_accept_40_1_41_from_40_1_41_5355->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_5355->definitionLine = 1259;
// method "shallowCopy"
  block_savedest(obj5333);
  Object closure5381 = createclosure(2, "shallowCopy");
  setclosureframe(closure5381, stackframe);
  addtoclosure(closure5381, var_emptySeq);
  addtoclosure(closure5381, var_moduleNode);
  struct UserObject *uo5381 = (struct UserObject*)obj5333;
  uo5381->data[8] = (Object)closure5381;
  Method *meth_meth_ast_shallowCopy5381 = addmethod2pos(obj5333, "shallowCopy", &meth_ast_shallowCopy5381, 8);
  int argcv_meth_ast_shallowCopy5381[] = {0};
  meth_meth_ast_shallowCopy5381->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5381);
  meth_meth_ast_shallowCopy5381->definitionModule = modulename;
  meth_meth_ast_shallowCopy5381->definitionLine = 1270;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5386 = (struct UserObject*)obj5333;
  uo5386->data[9] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5386 = addmethod2pos(obj5333, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5386, 9);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5386[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5386->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5386);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5386->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5386->definitionLine = 1273;
  sourceObject = obj5333;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5393 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool5394 = alloc_Boolean(0);
// compiled identifier node returning bool5394 (depth = 4)
  gc_frame_newslot(bool5394);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool5394;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5395 = callmethodflags(*var_objectNode, "new(2)$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5393);
// compiled call node returning call5395 (depth = 3)
  struct UserObject *obj5333_uo = (struct UserObject *)obj5333;
  obj5333_uo->super = call5395;
  sourceObject = obj5333;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5396 == NULL) {
    strlit5396 = alloc_String("module");
    gc_root(strlit5396);
  }
// compiled string node returning strlit5396 (depth = 3)
  adddatum2(obj5333, strlit5396, 1);
  sourceObject = obj5333;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5397 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  Object call5398 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe5397);
// compiled member node returning call5398 (depth = 3)
  adddatum2(obj5333, call5398, 2);
  sourceObject = obj5333;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5399 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5400 = alloc_Float64(0);
// compiled num node returning num5400 (depth = 4)
  gc_frame_newslot(num5400);
// call case 4: self request
  params[0] = num5400;
  partcv[0] = 1;
  Object call5401 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5399);
// compiled call node returning call5401 (depth = 3)
  sourceObject = obj5333;
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5402 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5403 = alloc_Float64(0);
// compiled num node returning num5403 (depth = 4)
  gc_frame_newslot(num5403);
// call case 4: self request
  params[0] = num5403;
  partcv[0] = 1;
  Object call5404 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5402);
// compiled call node returning call5404 (depth = 3)
  sourceObject = obj5333;
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5405 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5405 (depth = 3)
  adddatum2(obj5333, array5405, 3);
  sourceObject = obj5333;
  sourceObject = obj5333;
  sourceObject = obj5333;
  sourceObject = obj5333;
  sourceObject = obj5333;
  sourceObject = obj5333;
  objclass5333 = obj5333->class;
  objclass5333->definitionModule = modulename;
  objclass5333->definitionLine = 1244;
  (*(struct UserObject *)self).data[0] = lowerouter5333;
  self = oldself5333;
  selfslot = oldselfslot5333;
  stackframe = oldstackframe5333;
  gc_frame_end(frame);
  return obj5333;
}
Object meth_ast_moduleNode5407(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleNode (depth = 3)
  gc_frame_end(frame);
  return *var_moduleNode;
}
Object meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5411 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
  Object bool5412 = alloc_Boolean(0);
// compiled identifier node returning bool5412 (depth = 5)
  gc_frame_newslot(bool5412);
// call case 4: self request
  params[0] = *var_b;
  params[1] = bool5412;
  partcv[0] = 2;
  Object call5413 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5411);
// compiled call node returning call5413 (depth = 4)
  *var_result = call5413;
  if (call5413 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5414 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5415 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5414);
// compiled call node returning call5415 (depth = 3)
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5416 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5417 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5416);
// compiled call node returning call5417 (depth = 3)
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40_1_41_named_40_1_41_5418(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)named(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  Object params[3];
  int partcv[3];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5419 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_fakeSymbolTable (depth = 4)
  gc_frame_newslot(*var_fakeSymbolTable);
// call case 4: self request
  params[0] = *var_b;
  params[1] = *var_n;
  params[2] = *var_fakeSymbolTable;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5420 = callmethodflags(self, "body(1)named(1)scope(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5419);
// compiled call node returning call5420 (depth = 3)
  gc_frame_end(frame);
  return call5420;
}
Object meth_ast_description5433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5435 = gc_frame_new();
// call case 4: self request
  Object call5436 = callmethodflags(self, "isTrait", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5435);
// compiled member node returning call5436 (depth = 4)
  Object if5434 = done;
  if (istrue(call5436)) {
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5438 == NULL) {
    strlit5438 = alloc_String(" (trait)");
    gc_root(strlit5438);
  }
// compiled string node returning strlit5438 (depth = 5)
  int op_slot_right_5437 = gc_frame_newslot(strlit5438);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5441 = gc_frame_new();
// call case 4: self request
  Object call5442 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5441);
// compiled member node returning call5442 (depth = 6)
  int op_slot_right_5440 = gc_frame_newslot(call5442);
// starting to compile string node (depth = 6)
  if (strlit5444 == NULL) {
    strlit5444 = alloc_String("");
    gc_root(strlit5444);
  }
// compiled string node returning strlit5444 (depth = 6)
  int op_slot_left_5440 = gc_frame_newslot(strlit5444);
  params[0] = call5442;
  partcv[0] = 1;
  Object opresult5445 = callmethod(strlit5444, "++(1)", 1, partcv, params);
// compiled op node returning opresult5445 (depth = 5)
  int op_slot_left_5437 = gc_frame_newslot(opresult5445);
  params[0] = strlit5438;
  partcv[0] = 1;
  Object opresult5446 = callmethod(opresult5445, "++(1)", 1, partcv, params);
// compiled op node returning opresult5446 (depth = 4)
    gc_frame_newslot(opresult5446);
    if5434 = opresult5446;
  } else {
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5448 = gc_frame_new();
// call case 4: self request
  Object call5449 = callmethodflags(self, "inClass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5448);
// compiled member node returning call5449 (depth = 5)
  Object if5447 = done;
  if (istrue(call5449)) {
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5451 == NULL) {
    strlit5451 = alloc_String(" (class)");
    gc_root(strlit5451);
  }
// compiled string node returning strlit5451 (depth = 6)
  int op_slot_right_5450 = gc_frame_newslot(strlit5451);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5454 = gc_frame_new();
// call case 4: self request
  Object call5455 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5454);
// compiled member node returning call5455 (depth = 7)
  int op_slot_right_5453 = gc_frame_newslot(call5455);
// starting to compile string node (depth = 7)
  if (strlit5457 == NULL) {
    strlit5457 = alloc_String("");
    gc_root(strlit5457);
  }
// compiled string node returning strlit5457 (depth = 7)
  int op_slot_left_5453 = gc_frame_newslot(strlit5457);
  params[0] = call5455;
  partcv[0] = 1;
  Object opresult5458 = callmethod(strlit5457, "++(1)", 1, partcv, params);
// compiled op node returning opresult5458 (depth = 6)
  int op_slot_left_5450 = gc_frame_newslot(opresult5458);
  params[0] = strlit5451;
  partcv[0] = 1;
  Object opresult5459 = callmethod(opresult5458, "++(1)", 1, partcv, params);
// compiled op node returning opresult5459 (depth = 5)
    gc_frame_newslot(opresult5459);
    if5447 = opresult5459;
  } else {
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5460 = gc_frame_new();
// call case 4: self request
  Object call5461 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5460);
// compiled member node returning call5461 (depth = 5)
    gc_frame_newslot(call5461);
    if5447 = call5461;
  }
// compiled if node returning if5447 (depth = 4)
    gc_frame_newslot(if5447);
    if5434 = if5447;
  }
// compiled if node returning if5434 (depth = 3)
  gc_frame_end(frame);
  return if5434;
}
Object meth_ast__apply_40_1_41_5477(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5479 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5480 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call5481 = callmethodflags(*var_each, "isLegalInTrait", 0, partcv, params, 0);
  gc_frame_end(callframe5480);
// compiled member node returning call5481 (depth = 7)
  Object call5482 = callmethodflags(call5481, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5479);
// compiled member node returning call5482 (depth = 6)
  Object if5478 = done;
  if (istrue(call5482)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5483 = alloc_Boolean(0);
// compiled identifier node returning bool5483 (depth = 7)
  block_return(realself, bool5483);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if5478 = undefined;
  } else {
  }
// compiled if node returning if5478 (depth = 5)
  gc_frame_end(frame);
  return if5478;
}
Object meth_ast_isTrait5462(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5464 = gc_frame_new();
// call case 4: self request
  Object call5465 = callmethodflags(self, "inTrait", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5464);
// compiled member node returning call5465 (depth = 4)
  Object if5463 = done;
  if (istrue(call5465)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5466 = alloc_Boolean(1);
// compiled identifier node returning bool5466 (depth = 5)
  return bool5466;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5463 = undefined;
  } else {
  }
// compiled if node returning if5463 (depth = 3)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5469 = gc_frame_new();
// call case 4: self request
  Object call5470 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5469);
// compiled member node returning call5470 (depth = 5)
  int op_slot_right_5468 = gc_frame_newslot(call5470);
// starting to compile identifier node (depth = 5)
  Object bool5472 = alloc_Boolean(0);
// compiled identifier node returning bool5472 (depth = 5)
  int op_slot_left_5468 = gc_frame_newslot(bool5472);
  params[0] = call5470;
  partcv[0] = 1;
  Object opresult5473 = callmethod(bool5472, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5473 (depth = 4)
  Object if5467 = done;
  if (istrue(opresult5473)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5474 = alloc_Boolean(0);
// compiled identifier node returning bool5474 (depth = 5)
  return bool5474;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5467 = undefined;
  } else {
  }
// compiled if node returning if5467 (depth = 3)
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5475 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5476 = alloc_Block(NULL, NULL, "ast", 1316);
  gc_frame_newslot(block5476);
// method "_apply(_)"
  block_savedest(block5476);
  Object closure5477 = createclosure(1, "_apply(1)");
  setclosureframe(closure5477, stackframe);
  addtoclosure(closure5477, selfslot);
  struct UserObject *uo5477 = (struct UserObject*)block5476;
  uo5477->data[0] = (Object)closure5477;
  Method *meth_meth_ast__apply_40_1_41_5477 = addmethod2pos(block5476, "_apply(1)", &meth_ast__apply_40_1_41_5477, 0);
  int argcv_meth_ast__apply_40_1_41_5477[] = {1};
  meth_meth_ast__apply_40_1_41_5477->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5477);
  meth_meth_ast__apply_40_1_41_5477->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5477->definitionLine = 2969;
// compiled block node returning block5476 (depth = 4)
  gc_frame_newslot(block5476);
// call case 6: other requests
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5485 = gc_frame_new();
// call case 4: self request
  Object call5486 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5485);
// compiled member node returning call5486 (depth = 4)
  params[0] = block5476;
  partcv[0] = 1;
  Object call5487 = callmethodflags(call5486, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5475);
// compiled call node returning call5487 (depth = 3)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5488 = alloc_Boolean(1);
// compiled identifier node returning bool5488 (depth = 4)
  return bool5488;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply_40_1_41_5503(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5506 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  Object call5507 = callmethodflags(*var_node, "isMethod", 0, partcv, params, 0);
  gc_frame_end(callframe5506);
// compiled member node returning call5507 (depth = 8)
  int op_slot_right_5505 = gc_frame_newslot(call5507);
// starting to compile member node (depth = 8)
  int callframe5509 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  Object call5510 = callmethodflags(*var_node, "isFieldDec", 0, partcv, params, 0);
  gc_frame_end(callframe5509);
// compiled member node returning call5510 (depth = 8)
  int op_slot_left_5505 = gc_frame_newslot(call5510);
  params[0] = call5507;
  partcv[0] = 1;
  Object opresult5511 = callmethod(call5510, "||(1)", 1, partcv, params);
// compiled op node returning opresult5511 (depth = 7)
  Object if5504 = done;
  if (istrue(opresult5511)) {
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5512 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe5513 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  Object call5514 = callmethodflags(*var_node, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe5513);
// compiled member node returning call5514 (depth = 8)
  gc_frame_newslot(call5514);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5515 = gc_frame_new();
// call case 4: self request
  Object call5516 = callmethodflags(self, "myLocalNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5515);
// compiled member node returning call5516 (depth = 8)
  params[0] = call5514;
  partcv[0] = 1;
  Object call5517 = callmethodflags(call5516, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5512);
// compiled call node returning call5517 (depth = 7)
    gc_frame_newslot(call5517);
    if5504 = call5517;
  } else {
  }
// compiled if node returning if5504 (depth = 6)
  gc_frame_end(frame);
  return if5504;
}
Object meth_ast_localNames5489(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "localNames");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5492 = gc_frame_new();
// call case 4: self request
  Object call5493 = callmethodflags(self, "myLocalNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5492);
// compiled member node returning call5493 (depth = 5)
  int op_slot_right_5491 = gc_frame_newslot(call5493);
// starting to compile identifier node (depth = 5)
  Object bool5495 = alloc_Boolean(0);
// compiled identifier node returning bool5495 (depth = 5)
  int op_slot_left_5491 = gc_frame_newslot(bool5495);
  params[0] = call5493;
  partcv[0] = 1;
  Object opresult5496 = callmethod(bool5495, "==(1)", 1, partcv, params);
// compiled op node returning opresult5496 (depth = 4)
  Object if5490 = done;
  if (istrue(opresult5496)) {
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5497 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5498 = gc_frame_new();
// call case 5: prelude request
  Object call5499 = callmethodflags(prelude, "emptySet", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5498);
// compiled member node returning call5499 (depth = 5)
  gc_frame_newslot(call5499);
// call case 4: self request
  params[0] = call5499;
  partcv[0] = 1;
  Object call5500 = callmethodflags(self, "myLocalNames:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5497);
// compiled call node returning call5500 (depth = 4)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5501 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5502 = alloc_Block(NULL, NULL, "ast", 1327);
  gc_frame_newslot(block5502);
// method "_apply(_)"
  block_savedest(block5502);
  Object closure5503 = createclosure(1, "_apply(1)");
  setclosureframe(closure5503, stackframe);
  addtoclosure(closure5503, selfslot);
  struct UserObject *uo5503 = (struct UserObject*)block5502;
  uo5503->data[0] = (Object)closure5503;
  Method *meth_meth_ast__apply_40_1_41_5503 = addmethod2pos(block5502, "_apply(1)", &meth_ast__apply_40_1_41_5503, 0);
  int argcv_meth_ast__apply_40_1_41_5503[] = {1};
  meth_meth_ast__apply_40_1_41_5503->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5503);
  meth_meth_ast__apply_40_1_41_5503->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5503->definitionLine = 2969;
// compiled block node returning block5502 (depth = 5)
  gc_frame_newslot(block5502);
// call case 6: other requests
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5519 = gc_frame_new();
// call case 4: self request
  Object call5520 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5519);
// compiled member node returning call5520 (depth = 5)
  params[0] = block5502;
  partcv[0] = 1;
  Object call5521 = callmethodflags(call5520, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5501);
// compiled call node returning call5521 (depth = 4)
    gc_frame_newslot(call5521);
    if5490 = call5521;
  } else {
  }
// compiled if node returning if5490 (depth = 3)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5522 = gc_frame_new();
// call case 4: self request
  Object call5523 = callmethodflags(self, "myLocalNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5522);
// compiled member node returning call5523 (depth = 3)
  gc_frame_end(frame);
  return call5523;
}
Object meth_ast__apply_40_1_41_5538(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5539 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call5540 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5539);
// compiled call node returning call5540 (depth = 5)
  gc_frame_end(frame);
  return call5540;
}
Object meth_ast_parentsDo_40_1_41_5524(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parentsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5527 = gc_frame_new();
// call case 4: self request
  Object call5528 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5527);
// compiled member node returning call5528 (depth = 5)
  int op_slot_right_5526 = gc_frame_newslot(call5528);
// starting to compile identifier node (depth = 5)
  Object bool5530 = alloc_Boolean(0);
// compiled identifier node returning bool5530 (depth = 5)
  int op_slot_left_5526 = gc_frame_newslot(bool5530);
  params[0] = call5528;
  partcv[0] = 1;
  Object opresult5531 = callmethod(bool5530, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5531 (depth = 4)
  Object if5525 = done;
  if (istrue(opresult5531)) {
// starting to compile call node (depth = 4)
  int callframe5532 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5533 = gc_frame_new();
// call case 4: self request
  Object call5534 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5533);
// compiled member node returning call5534 (depth = 5)
  gc_frame_newslot(call5534);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call5534;
  partcv[0] = 1;
  Object call5535 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5532);
// compiled call node returning call5535 (depth = 4)
    gc_frame_newslot(call5535);
    if5525 = call5535;
  } else {
  }
// compiled if node returning if5525 (depth = 3)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5536 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5537 = alloc_Block(NULL, NULL, "ast", 1340);
  gc_frame_newslot(block5537);
// method "_apply(_)"
  block_savedest(block5537);
  Object closure5538 = createclosure(2, "_apply(1)");
  setclosureframe(closure5538, stackframe);
  addtoclosure(closure5538, var_action);
  addtoclosure(closure5538, selfslot);
  struct UserObject *uo5538 = (struct UserObject*)block5537;
  uo5538->data[0] = (Object)closure5538;
  Method *meth_meth_ast__apply_40_1_41_5538 = addmethod2pos(block5537, "_apply(1)", &meth_ast__apply_40_1_41_5538, 0);
  int argcv_meth_ast__apply_40_1_41_5538[] = {1};
  meth_meth_ast__apply_40_1_41_5538->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5538);
  meth_meth_ast__apply_40_1_41_5538->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5538->definitionLine = 2969;
// compiled block node returning block5537 (depth = 4)
  gc_frame_newslot(block5537);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5542 = gc_frame_new();
// call case 4: self request
  Object call5543 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5542);
// compiled member node returning call5543 (depth = 4)
  params[0] = block5537;
  partcv[0] = 1;
  Object call5544 = callmethodflags(call5543, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5536);
// compiled call node returning call5544 (depth = 3)
  gc_frame_end(frame);
  return call5544;
}
Object meth_ast__apply_40_1_41_5548(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5550 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  Object call5551 = callmethodflags(*var_o, "isMethod", 0, partcv, params, 0);
  gc_frame_end(callframe5550);
// compiled member node returning call5551 (depth = 6)
  Object if5549 = done;
  if (istrue(call5551)) {
// starting to compile call node (depth = 6)
  int callframe5552 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5553 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5552);
// compiled call node returning call5553 (depth = 6)
    gc_frame_newslot(call5553);
    if5549 = call5553;
  } else {
  }
// compiled if node returning if5549 (depth = 5)
  gc_frame_end(frame);
  return if5549;
}
Object meth_ast_methodsDo_40_1_41_5545(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "methodsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part methodsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5546 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5547 = alloc_Block(NULL, NULL, "ast", 1346);
  gc_frame_newslot(block5547);
// method "_apply(_)"
  block_savedest(block5547);
  Object closure5548 = createclosure(2, "_apply(1)");
  setclosureframe(closure5548, stackframe);
  addtoclosure(closure5548, var_action);
  addtoclosure(closure5548, selfslot);
  struct UserObject *uo5548 = (struct UserObject*)block5547;
  uo5548->data[0] = (Object)closure5548;
  Method *meth_meth_ast__apply_40_1_41_5548 = addmethod2pos(block5547, "_apply(1)", &meth_ast__apply_40_1_41_5548, 0);
  int argcv_meth_ast__apply_40_1_41_5548[] = {1};
  meth_meth_ast__apply_40_1_41_5548->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5548);
  meth_meth_ast__apply_40_1_41_5548->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5548->definitionLine = 2969;
// compiled block node returning block5547 (depth = 4)
  gc_frame_newslot(block5547);
// call case 6: other requests
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5555 = gc_frame_new();
// call case 4: self request
  Object call5556 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5555);
// compiled member node returning call5556 (depth = 4)
  params[0] = block5547;
  partcv[0] = 1;
  Object call5557 = callmethodflags(call5556, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5546);
// compiled call node returning call5557 (depth = 3)
  gc_frame_end(frame);
  return call5557;
}
Object meth_ast__apply_40_1_41_5561(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5563 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  Object call5564 = callmethodflags(*var_o, "isExecutable", 0, partcv, params, 0);
  gc_frame_end(callframe5563);
// compiled member node returning call5564 (depth = 6)
  Object if5562 = done;
  if (istrue(call5564)) {
// starting to compile call node (depth = 6)
  int callframe5565 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5566 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5565);
// compiled call node returning call5566 (depth = 6)
    gc_frame_newslot(call5566);
    if5562 = call5566;
  } else {
  }
// compiled if node returning if5562 (depth = 5)
  gc_frame_end(frame);
  return if5562;
}
Object meth_ast_executableComponentsDo_40_1_41_5558(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "executableComponentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method executableComponentsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for executableComponentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part executableComponentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5559 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5560 = alloc_Block(NULL, NULL, "ast", 1354);
  gc_frame_newslot(block5560);
// method "_apply(_)"
  block_savedest(block5560);
  Object closure5561 = createclosure(2, "_apply(1)");
  setclosureframe(closure5561, stackframe);
  addtoclosure(closure5561, var_action);
  addtoclosure(closure5561, selfslot);
  struct UserObject *uo5561 = (struct UserObject*)block5560;
  uo5561->data[0] = (Object)closure5561;
  Method *meth_meth_ast__apply_40_1_41_5561 = addmethod2pos(block5560, "_apply(1)", &meth_ast__apply_40_1_41_5561, 0);
  int argcv_meth_ast__apply_40_1_41_5561[] = {1};
  meth_meth_ast__apply_40_1_41_5561->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5561);
  meth_meth_ast__apply_40_1_41_5561->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5561->definitionLine = 2969;
// compiled block node returning block5560 (depth = 4)
  gc_frame_newslot(block5560);
// call case 6: other requests
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5568 = gc_frame_new();
// call case 4: self request
  Object call5569 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5568);
// compiled member node returning call5569 (depth = 4)
  params[0] = block5560;
  partcv[0] = 1;
  Object call5570 = callmethodflags(call5569, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5559);
// compiled call node returning call5570 (depth = 3)
  gc_frame_end(frame);
  return call5570;
}
Object meth_ast_scope_58__61__40_1_41_5571(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5572 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call5573 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5572);
// compiled call node returning call5573 (depth = 3)
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5574 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5575 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5574);
// compiled call node returning call5575 (depth = 3)
  gc_frame_end(frame);
  return call5575;
}
Object meth_ast_body5576(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5577 = gc_frame_new();
// call case 4: self request
  Object call5578 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5577);
// compiled member node returning call5578 (depth = 3)
  gc_frame_end(frame);
  return call5578;
}
Object meth_ast_returnsObject5579(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5580 = alloc_Boolean(1);
// compiled identifier node returning bool5580 (depth = 3)
  gc_frame_end(frame);
  return bool5580;
}
Object meth_ast_returnedObjectScope5581(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5582 = gc_frame_new();
// call case 4: self request
  Object call5583 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5582);
// compiled member node returning call5583 (depth = 3)
  gc_frame_end(frame);
  return call5583;
}
Object meth_ast_canInherit5584(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5585 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5586 = gc_frame_new();
// call case 4: self request
  Object call5587 = callmethodflags(self, "inTrait", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5586);
// compiled member node returning call5587 (depth = 4)
  Object call5588 = callmethodflags(call5587, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5585);
// compiled member node returning call5588 (depth = 3)
  gc_frame_end(frame);
  return call5588;
}
Object meth_ast_canUse5589(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canUse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5590 = alloc_Boolean(1);
// compiled identifier node returning bool5590 (depth = 3)
  gc_frame_end(frame);
  return bool5590;
}
Object meth_ast_isObject5591(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5592 = alloc_Boolean(1);
// compiled identifier node returning bool5592 (depth = 3)
  gc_frame_end(frame);
  return bool5592;
}
Object meth_ast__apply_40_1_41_5612(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5613 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5614 = callmethodflags(*var_t, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5613);
// compiled call node returning call5614 (depth = 6)
  gc_frame_end(frame);
  return call5614;
}
Object meth_ast__apply_40_1_41_5621(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5622 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5623 = callmethodflags(*var_x, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5622);
// compiled call node returning call5623 (depth = 6)
  gc_frame_end(frame);
  return call5623;
}
Object meth_ast_accept_40_1_41_from_40_1_41_5593(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5595 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5596 = callmethodflags(*var_visitor, "visitObject(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5595);
// compiled call node returning call5596 (depth = 4)
  Object if5594 = done;
  if (istrue(call5596)) {
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5597 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5598 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5597);
// compiled call node returning call5598 (depth = 5)
  *var_newChain = call5598;
  if (call5598 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5601 = gc_frame_new();
// call case 4: self request
  Object call5602 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5601);
// compiled member node returning call5602 (depth = 6)
  int op_slot_right_5600 = gc_frame_newslot(call5602);
// starting to compile identifier node (depth = 6)
  Object bool5604 = alloc_Boolean(0);
// compiled identifier node returning bool5604 (depth = 6)
  int op_slot_left_5600 = gc_frame_newslot(bool5604);
  params[0] = call5602;
  partcv[0] = 1;
  Object opresult5605 = callmethod(bool5604, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5605 (depth = 5)
  Object if5599 = done;
  if (istrue(opresult5605)) {
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5606 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5607 = gc_frame_new();
// call case 4: self request
  Object call5608 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5607);
// compiled member node returning call5608 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5609 = callmethodflags(call5608, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5606);
// compiled call node returning call5609 (depth = 5)
    gc_frame_newslot(call5609);
    if5599 = call5609;
  } else {
  }
// compiled if node returning if5599 (depth = 4)
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5610 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5611 = alloc_Block(NULL, NULL, "ast", 1377);
  gc_frame_newslot(block5611);
// method "_apply(_)"
  block_savedest(block5611);
  Object closure5612 = createclosure(3, "_apply(1)");
  setclosureframe(closure5612, stackframe);
  addtoclosure(closure5612, var_visitor);
  addtoclosure(closure5612, var_newChain);
  addtoclosure(closure5612, selfslot);
  struct UserObject *uo5612 = (struct UserObject*)block5611;
  uo5612->data[0] = (Object)closure5612;
  Method *meth_meth_ast__apply_40_1_41_5612 = addmethod2pos(block5611, "_apply(1)", &meth_ast__apply_40_1_41_5612, 0);
  int argcv_meth_ast__apply_40_1_41_5612[] = {1};
  meth_meth_ast__apply_40_1_41_5612->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5612);
  meth_meth_ast__apply_40_1_41_5612->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5612->definitionLine = 2969;
// compiled block node returning block5611 (depth = 5)
  gc_frame_newslot(block5611);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5616 = gc_frame_new();
// call case 4: self request
  Object call5617 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5616);
// compiled member node returning call5617 (depth = 5)
  params[0] = block5611;
  partcv[0] = 1;
  Object call5618 = callmethodflags(call5617, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5610);
// compiled call node returning call5618 (depth = 4)
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5619 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5620 = alloc_Block(NULL, NULL, "ast", 1378);
  gc_frame_newslot(block5620);
// method "_apply(_)"
  block_savedest(block5620);
  Object closure5621 = createclosure(3, "_apply(1)");
  setclosureframe(closure5621, stackframe);
  addtoclosure(closure5621, var_visitor);
  addtoclosure(closure5621, var_newChain);
  addtoclosure(closure5621, selfslot);
  struct UserObject *uo5621 = (struct UserObject*)block5620;
  uo5621->data[0] = (Object)closure5621;
  Method *meth_meth_ast__apply_40_1_41_5621 = addmethod2pos(block5620, "_apply(1)", &meth_ast__apply_40_1_41_5621, 0);
  int argcv_meth_ast__apply_40_1_41_5621[] = {1};
  meth_meth_ast__apply_40_1_41_5621->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5621);
  meth_meth_ast__apply_40_1_41_5621->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5621->definitionLine = 2969;
// compiled block node returning block5620 (depth = 5)
  gc_frame_newslot(block5620);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5625 = gc_frame_new();
// call case 4: self request
  Object call5626 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5625);
// compiled member node returning call5626 (depth = 5)
  params[0] = block5620;
  partcv[0] = 1;
  Object call5627 = callmethodflags(call5626, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5619);
// compiled call node returning call5627 (depth = 4)
    gc_frame_newslot(call5627);
    if5594 = call5627;
  } else {
  }
// compiled if node returning if5594 (depth = 3)
  gc_frame_end(frame);
  return if5594;
}
Object meth_ast_nameString5628(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5631 == NULL) {
    strlit5631 = alloc_String("object");
    gc_root(strlit5631);
  }
// compiled string node returning strlit5631 (depth = 5)
  int op_slot_right_5630 = gc_frame_newslot(strlit5631);
// starting to compile member node (depth = 5)
  int callframe5633 = gc_frame_new();
// call case 4: self request
  Object call5634 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5633);
// compiled member node returning call5634 (depth = 5)
  int op_slot_left_5630 = gc_frame_newslot(call5634);
  params[0] = strlit5631;
  partcv[0] = 1;
  Object opresult5635 = callmethod(call5634, "==(1)", 1, partcv, params);
// compiled op node returning opresult5635 (depth = 4)
  Object if5629 = done;
  if (istrue(opresult5635)) {
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5637 == NULL) {
    strlit5637 = alloc_String("");
    gc_root(strlit5637);
  }
// compiled string node returning strlit5637 (depth = 5)
  int op_slot_right_5636 = gc_frame_newslot(strlit5637);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5640 = gc_frame_new();
// call case 4: self request
  Object call5641 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5640);
// compiled member node returning call5641 (depth = 6)
  int op_slot_right_5639 = gc_frame_newslot(call5641);
// starting to compile string node (depth = 6)
  if (strlit5643 == NULL) {
    strlit5643 = alloc_String("object_on_line_");
    gc_root(strlit5643);
  }
// compiled string node returning strlit5643 (depth = 6)
  int op_slot_left_5639 = gc_frame_newslot(strlit5643);
  params[0] = call5641;
  partcv[0] = 1;
  Object opresult5644 = callmethod(strlit5643, "++(1)", 1, partcv, params);
// compiled op node returning opresult5644 (depth = 5)
  int op_slot_left_5636 = gc_frame_newslot(opresult5644);
  params[0] = strlit5637;
  partcv[0] = 1;
  Object opresult5645 = callmethod(opresult5644, "++(1)", 1, partcv, params);
// compiled op node returning opresult5645 (depth = 4)
    gc_frame_newslot(opresult5645);
    if5629 = opresult5645;
  } else {
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5646 = gc_frame_new();
// call case 4: self request
  Object call5647 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5646);
// compiled member node returning call5647 (depth = 4)
    gc_frame_newslot(call5647);
    if5629 = call5647;
  }
// compiled if node returning if5629 (depth = 3)
  gc_frame_end(frame);
  return if5629;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_5648(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5649 = gc_frame_new();
// call case 4: self request
  Object call5650 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5649);
// compiled member node returning call5650 (depth = 4)
  *var_n = call5650;
  if (call5650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5651 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5652 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5651);
// compiled call node returning call5652 (depth = 4)
  *var_newChain = call5652;
  if (call5652 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5653 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5654 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5655 = gc_frame_new();
// call case 4: self request
  Object call5656 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5655);
// compiled member node returning call5656 (depth = 5)
  gc_frame_newslot(call5656);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5657 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5658 = gc_frame_new();
// call case 3: self.outer request
  Object call5659 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5658);
// compiled member node returning call5659 (depth = 6)
  Object call5660 = callmethodflags(call5659, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5657);
// compiled member node returning call5660 (depth = 5)
  params[0] = call5656;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5661 = callmethodflags(call5660, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5654);
// compiled call node returning call5661 (depth = 4)
  gc_frame_newslot(call5661);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5661;
  partcv[0] = 1;
  Object call5662 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5653);
// compiled call node returning call5662 (depth = 3)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5663 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5664 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5665 = gc_frame_new();
// call case 4: self request
  Object call5666 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5665);
// compiled member node returning call5666 (depth = 5)
  gc_frame_newslot(call5666);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5667 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5668 = gc_frame_new();
// call case 3: self.outer request
  Object call5669 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5668);
// compiled member node returning call5669 (depth = 6)
  Object call5670 = callmethodflags(call5669, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5667);
// compiled member node returning call5670 (depth = 5)
  params[0] = call5666;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5671 = callmethodflags(call5670, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5664);
// compiled call node returning call5671 (depth = 4)
  gc_frame_newslot(call5671);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5671;
  partcv[0] = 1;
  Object call5672 = callmethodflags(*var_n, "superclass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5663);
// compiled call node returning call5672 (depth = 3)
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5673 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5674 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5675 = gc_frame_new();
// call case 4: self request
  Object call5676 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5675);
// compiled member node returning call5676 (depth = 5)
  gc_frame_newslot(call5676);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5677 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5678 = gc_frame_new();
// call case 3: self.outer request
  Object call5679 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5678);
// compiled member node returning call5679 (depth = 6)
  Object call5680 = callmethodflags(call5679, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5677);
// compiled member node returning call5680 (depth = 5)
  params[0] = call5676;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5681 = callmethodflags(call5680, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5674);
// compiled call node returning call5681 (depth = 4)
  gc_frame_newslot(call5681);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5681;
  partcv[0] = 1;
  Object call5682 = callmethodflags(*var_n, "usedTraits:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5673);
// compiled call node returning call5682 (depth = 3)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5683 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call5684 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5683);
// compiled call node returning call5684 (depth = 3)
  gc_frame_end(frame);
  return call5684;
}
Object meth_ast__apply_40_1_41_5693(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5695 == NULL) {
    strlit5695 = alloc_String("  ");
    gc_root(strlit5695);
  }
// compiled string node returning strlit5695 (depth = 7)
  int op_slot_right_5694 = gc_frame_newslot(strlit5695);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5694 = gc_frame_newslot(*var_spc);
  params[0] = strlit5695;
  partcv[0] = 1;
  Object opresult5697 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult5697 (depth = 6)
  *var_spc = opresult5697;
  if (opresult5697 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5779(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5781 == NULL) {
    strlit5781 = alloc_String("");
    gc_root(strlit5781);
  }
// compiled string node returning strlit5781 (depth = 8)
  int op_slot_right_5780 = gc_frame_newslot(strlit5781);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5784 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5786 = alloc_Float64(1);
// compiled num node returning num5786 (depth = 11)
  int op_slot_right_5785 = gc_frame_newslot(num5786);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5785 = gc_frame_newslot(*var_depth);
  params[0] = num5786;
  partcv[0] = 1;
  Object sum5788 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5788 (depth = 10)
  gc_frame_newslot(sum5788);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  params[0] = sum5788;
  partcv[0] = 1;
  Object call5789 = callmethodflags(*var_t, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5784);
// compiled call node returning call5789 (depth = 9)
  int op_slot_right_5783 = gc_frame_newslot(call5789);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5792 == NULL) {
    strlit5792 = alloc_String("  ");
    gc_root(strlit5792);
  }
// compiled string node returning strlit5792 (depth = 10)
  int op_slot_right_5791 = gc_frame_newslot(strlit5792);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5794 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5797 == NULL) {
    strlit5797 = alloc_String("""\x0a""");
    gc_root(strlit5797);
  }
// compiled string node returning strlit5797 (depth = 12)
  int op_slot_right_5796 = gc_frame_newslot(strlit5797);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_5799 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit5801 == NULL) {
    strlit5801 = alloc_String("");
    gc_root(strlit5801);
  }
// compiled string node returning strlit5801 (depth = 13)
  int op_slot_left_5799 = gc_frame_newslot(strlit5801);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5802 = callmethod(strlit5801, "++(1)", 1, partcv, params);
// compiled op node returning opresult5802 (depth = 12)
  int op_slot_left_5796 = gc_frame_newslot(opresult5802);
  params[0] = strlit5797;
  partcv[0] = 1;
  Object opresult5803 = callmethod(opresult5802, "++(1)", 1, partcv, params);
// compiled op node returning opresult5803 (depth = 11)
  int op_slot_left_5794 = gc_frame_newslot(opresult5803);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5804 = callmethod(opresult5803, "++(1)", 1, partcv, params);
// compiled op node returning opresult5804 (depth = 10)
  int op_slot_left_5791 = gc_frame_newslot(opresult5804);
  params[0] = strlit5792;
  partcv[0] = 1;
  Object opresult5805 = callmethod(opresult5804, "++(1)", 1, partcv, params);
// compiled op node returning opresult5805 (depth = 9)
  int op_slot_left_5783 = gc_frame_newslot(opresult5805);
  params[0] = call5789;
  partcv[0] = 1;
  Object opresult5806 = callmethod(opresult5805, "++(1)", 1, partcv, params);
// compiled op node returning opresult5806 (depth = 8)
  int op_slot_left_5780 = gc_frame_newslot(opresult5806);
  params[0] = strlit5781;
  partcv[0] = 1;
  Object opresult5807 = callmethod(opresult5806, "++(1)", 1, partcv, params);
// compiled op node returning opresult5807 (depth = 7)
  *var_s = opresult5807;
  if (opresult5807 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5815(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5817 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5819 = alloc_Float64(1);
// compiled num node returning num5819 (depth = 9)
  int op_slot_right_5818 = gc_frame_newslot(num5819);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5818 = gc_frame_newslot(*var_depth);
  params[0] = num5819;
  partcv[0] = 1;
  Object sum5821 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5821 (depth = 8)
  gc_frame_newslot(sum5821);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum5821;
  partcv[0] = 1;
  Object call5822 = callmethodflags(*var_x, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5817);
// compiled call node returning call5822 (depth = 7)
  int op_slot_right_5816 = gc_frame_newslot(call5822);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5824 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5827 == NULL) {
    strlit5827 = alloc_String("""\x0a""");
    gc_root(strlit5827);
  }
// compiled string node returning strlit5827 (depth = 9)
  int op_slot_right_5826 = gc_frame_newslot(strlit5827);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5826 = gc_frame_newslot(*var_s);
  params[0] = strlit5827;
  partcv[0] = 1;
  Object opresult5829 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5829 (depth = 8)
  int op_slot_left_5824 = gc_frame_newslot(opresult5829);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5830 = callmethod(opresult5829, "++(1)", 1, partcv, params);
// compiled op node returning opresult5830 (depth = 7)
  int op_slot_left_5816 = gc_frame_newslot(opresult5830);
  params[0] = call5822;
  partcv[0] = 1;
  Object opresult5831 = callmethod(opresult5830, "++(1)", 1, partcv, params);
// compiled op node returning opresult5831 (depth = 6)
  *var_s = opresult5831;
  if (opresult5831 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_5685(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth_39_ (depth = 4)
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5686 == NULL) {
    strlit5686 = alloc_String("");
    gc_root(strlit5686);
  }
// compiled string node returning strlit5686 (depth = 4)
  *var_spc = strlit5686;
  if (strlit5686 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5687 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_5688 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num5690 = alloc_Float64(0);
// compiled num node returning num5690 (depth = 5)
  int op_slot_left_5688 = gc_frame_newslot(num5690);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5691 = callmethod(num5690, "..(1)", 1, partcv, params);
// compiled op node returning opresult5691 (depth = 4)
  gc_frame_newslot(opresult5691);
// starting to compile block node (depth = 4)
  Object block5692 = alloc_Block(NULL, NULL, "ast", 1399);
  gc_frame_newslot(block5692);
// method "_apply(_)"
  block_savedest(block5692);
  Object closure5693 = createclosure(2, "_apply(1)");
  setclosureframe(closure5693, stackframe);
  addtoclosure(closure5693, var_spc);
  addtoclosure(closure5693, selfslot);
  struct UserObject *uo5693 = (struct UserObject*)block5692;
  uo5693->data[0] = (Object)closure5693;
  Method *meth_meth_ast__apply_40_1_41_5693 = addmethod2pos(block5692, "_apply(1)", &meth_ast__apply_40_1_41_5693, 0);
  int argcv_meth_ast__apply_40_1_41_5693[] = {1};
  meth_meth_ast__apply_40_1_41_5693->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5693);
  meth_meth_ast__apply_40_1_41_5693->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5693->definitionLine = 2969;
// compiled block node returning block5692 (depth = 4)
  gc_frame_newslot(block5692);
// call case 5: prelude request
  params[0] = opresult5691;
  params[1] = block5692;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5700 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5687);
// compiled call node returning call5700 (depth = 3)
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5701 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5702 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5701);
// compiled call node returning call5702 (depth = 4)
  *var_s = call5702;
  if (call5702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5704 == NULL) {
    strlit5704 = alloc_String("");
    gc_root(strlit5704);
  }
// compiled string node returning strlit5704 (depth = 5)
  int op_slot_right_5703 = gc_frame_newslot(strlit5704);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5707 = gc_frame_new();
// call case 4: self request
  Object call5708 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5707);
// compiled member node returning call5708 (depth = 6)
  int op_slot_right_5706 = gc_frame_newslot(call5708);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5711 == NULL) {
    strlit5711 = alloc_String("Name: ");
    gc_root(strlit5711);
  }
// compiled string node returning strlit5711 (depth = 7)
  int op_slot_right_5710 = gc_frame_newslot(strlit5711);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5713 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5716 == NULL) {
    strlit5716 = alloc_String("""\x0a""");
    gc_root(strlit5716);
  }
// compiled string node returning strlit5716 (depth = 9)
  int op_slot_right_5715 = gc_frame_newslot(strlit5716);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_5718 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit5720 == NULL) {
    strlit5720 = alloc_String("");
    gc_root(strlit5720);
  }
// compiled string node returning strlit5720 (depth = 10)
  int op_slot_left_5718 = gc_frame_newslot(strlit5720);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5721 = callmethod(strlit5720, "++(1)", 1, partcv, params);
// compiled op node returning opresult5721 (depth = 9)
  int op_slot_left_5715 = gc_frame_newslot(opresult5721);
  params[0] = strlit5716;
  partcv[0] = 1;
  Object opresult5722 = callmethod(opresult5721, "++(1)", 1, partcv, params);
// compiled op node returning opresult5722 (depth = 8)
  int op_slot_left_5713 = gc_frame_newslot(opresult5722);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5723 = callmethod(opresult5722, "++(1)", 1, partcv, params);
// compiled op node returning opresult5723 (depth = 7)
  int op_slot_left_5710 = gc_frame_newslot(opresult5723);
  params[0] = strlit5711;
  partcv[0] = 1;
  Object opresult5724 = callmethod(opresult5723, "++(1)", 1, partcv, params);
// compiled op node returning opresult5724 (depth = 6)
  int op_slot_left_5706 = gc_frame_newslot(opresult5724);
  params[0] = call5708;
  partcv[0] = 1;
  Object opresult5725 = callmethod(opresult5724, "++(1)", 1, partcv, params);
// compiled op node returning opresult5725 (depth = 5)
  int op_slot_left_5703 = gc_frame_newslot(opresult5725);
  params[0] = strlit5704;
  partcv[0] = 1;
  Object opresult5726 = callmethod(opresult5725, "++(1)", 1, partcv, params);
// compiled op node returning opresult5726 (depth = 4)
  *var_s = opresult5726;
  if (opresult5726 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5730 = gc_frame_new();
// call case 4: self request
  Object call5731 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5730);
// compiled member node returning call5731 (depth = 5)
  int op_slot_right_5729 = gc_frame_newslot(call5731);
// starting to compile identifier node (depth = 5)
  Object bool5733 = alloc_Boolean(0);
// compiled identifier node returning bool5733 (depth = 5)
  int op_slot_left_5729 = gc_frame_newslot(bool5733);
  params[0] = call5731;
  partcv[0] = 1;
  Object opresult5734 = callmethod(bool5733, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5734 (depth = 4)
  Object if5728 = done;
  if (istrue(opresult5734)) {
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5736 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5738 = alloc_Float64(1);
// compiled num node returning num5738 (depth = 8)
  int op_slot_right_5737 = gc_frame_newslot(num5738);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5737 = gc_frame_newslot(*var_depth);
  params[0] = num5738;
  partcv[0] = 1;
  Object sum5740 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5740 (depth = 7)
  gc_frame_newslot(sum5740);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5741 = gc_frame_new();
// call case 4: self request
  Object call5742 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5741);
// compiled member node returning call5742 (depth = 7)
  params[0] = sum5740;
  partcv[0] = 1;
  Object call5743 = callmethodflags(call5742, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5736);
// compiled call node returning call5743 (depth = 6)
  int op_slot_right_5735 = gc_frame_newslot(call5743);
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5746 == NULL) {
    strlit5746 = alloc_String("Superclass: ");
    gc_root(strlit5746);
  }
// compiled string node returning strlit5746 (depth = 7)
  int op_slot_right_5745 = gc_frame_newslot(strlit5746);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5748 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5751 == NULL) {
    strlit5751 = alloc_String("""\x0a""");
    gc_root(strlit5751);
  }
// compiled string node returning strlit5751 (depth = 9)
  int op_slot_right_5750 = gc_frame_newslot(strlit5751);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5750 = gc_frame_newslot(*var_s);
  params[0] = strlit5751;
  partcv[0] = 1;
  Object opresult5753 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5753 (depth = 8)
  int op_slot_left_5748 = gc_frame_newslot(opresult5753);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5754 = callmethod(opresult5753, "++(1)", 1, partcv, params);
// compiled op node returning opresult5754 (depth = 7)
  int op_slot_left_5745 = gc_frame_newslot(opresult5754);
  params[0] = strlit5746;
  partcv[0] = 1;
  Object opresult5755 = callmethod(opresult5754, "++(1)", 1, partcv, params);
// compiled op node returning opresult5755 (depth = 6)
  int op_slot_left_5735 = gc_frame_newslot(opresult5755);
  params[0] = call5743;
  partcv[0] = 1;
  Object opresult5756 = callmethod(opresult5755, "++(1)", 1, partcv, params);
// compiled op node returning opresult5756 (depth = 5)
  *var_s = opresult5756;
  if (opresult5756 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5728 = done;
  } else {
  }
// compiled if node returning if5728 (depth = 3)
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5759 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5760 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5761 = gc_frame_new();
// call case 4: self request
  Object call5762 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5761);
// compiled member node returning call5762 (depth = 6)
  Object call5763 = callmethodflags(call5762, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe5760);
// compiled member node returning call5763 (depth = 5)
  Object call5764 = callmethodflags(call5763, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5759);
// compiled member node returning call5764 (depth = 4)
  Object if5758 = done;
  if (istrue(call5764)) {
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5766 == NULL) {
    strlit5766 = alloc_String("Traits:");
    gc_root(strlit5766);
  }
// compiled string node returning strlit5766 (depth = 6)
  int op_slot_right_5765 = gc_frame_newslot(strlit5766);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5768 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5771 == NULL) {
    strlit5771 = alloc_String("""\x0a""");
    gc_root(strlit5771);
  }
// compiled string node returning strlit5771 (depth = 8)
  int op_slot_right_5770 = gc_frame_newslot(strlit5771);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5770 = gc_frame_newslot(*var_s);
  params[0] = strlit5771;
  partcv[0] = 1;
  Object opresult5773 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5773 (depth = 7)
  int op_slot_left_5768 = gc_frame_newslot(opresult5773);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5774 = callmethod(opresult5773, "++(1)", 1, partcv, params);
// compiled op node returning opresult5774 (depth = 6)
  int op_slot_left_5765 = gc_frame_newslot(opresult5774);
  params[0] = strlit5766;
  partcv[0] = 1;
  Object opresult5775 = callmethod(opresult5774, "++(1)", 1, partcv, params);
// compiled op node returning opresult5775 (depth = 5)
  *var_s = opresult5775;
  if (opresult5775 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5777 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5778 = alloc_Block(NULL, NULL, "ast", 1410);
  gc_frame_newslot(block5778);
// method "_apply(_)"
  block_savedest(block5778);
  Object closure5779 = createclosure(4, "_apply(1)");
  setclosureframe(closure5779, stackframe);
  addtoclosure(closure5779, var_depth);
  addtoclosure(closure5779, var_spc);
  addtoclosure(closure5779, var_s);
  addtoclosure(closure5779, selfslot);
  struct UserObject *uo5779 = (struct UserObject*)block5778;
  uo5779->data[0] = (Object)closure5779;
  Method *meth_meth_ast__apply_40_1_41_5779 = addmethod2pos(block5778, "_apply(1)", &meth_ast__apply_40_1_41_5779, 0);
  int argcv_meth_ast__apply_40_1_41_5779[] = {1};
  meth_meth_ast__apply_40_1_41_5779->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5779);
  meth_meth_ast__apply_40_1_41_5779->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5779->definitionLine = 2969;
// compiled block node returning block5778 (depth = 5)
  gc_frame_newslot(block5778);
// call case 6: other requests
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5810 = gc_frame_new();
// call case 4: self request
  Object call5811 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5810);
// compiled member node returning call5811 (depth = 5)
  params[0] = block5778;
  partcv[0] = 1;
  Object call5812 = callmethodflags(call5811, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5777);
// compiled call node returning call5812 (depth = 4)
    gc_frame_newslot(call5812);
    if5758 = call5812;
  } else {
  }
// compiled if node returning if5758 (depth = 3)
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5813 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5814 = alloc_Block(NULL, NULL, "ast", 1414);
  gc_frame_newslot(block5814);
// method "_apply(_)"
  block_savedest(block5814);
  Object closure5815 = createclosure(4, "_apply(1)");
  setclosureframe(closure5815, stackframe);
  addtoclosure(closure5815, var_depth);
  addtoclosure(closure5815, var_spc);
  addtoclosure(closure5815, var_s);
  addtoclosure(closure5815, selfslot);
  struct UserObject *uo5815 = (struct UserObject*)block5814;
  uo5815->data[0] = (Object)closure5815;
  Method *meth_meth_ast__apply_40_1_41_5815 = addmethod2pos(block5814, "_apply(1)", &meth_ast__apply_40_1_41_5815, 0);
  int argcv_meth_ast__apply_40_1_41_5815[] = {1};
  meth_meth_ast__apply_40_1_41_5815->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5815);
  meth_meth_ast__apply_40_1_41_5815->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5815->definitionLine = 2969;
// compiled block node returning block5814 (depth = 4)
  gc_frame_newslot(block5814);
// call case 6: other requests
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5834 = gc_frame_new();
// call case 4: self request
  Object call5835 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5834);
// compiled member node returning call5835 (depth = 4)
  params[0] = block5814;
  partcv[0] = 1;
  Object call5836 = callmethodflags(call5835, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5813);
// compiled call node returning call5836 (depth = 3)
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_5849(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5851 == NULL) {
    strlit5851 = alloc_String("    ");
    gc_root(strlit5851);
  }
// compiled string node returning strlit5851 (depth = 7)
  int op_slot_right_5850 = gc_frame_newslot(strlit5851);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5850 = gc_frame_newslot(*var_spc);
  params[0] = strlit5851;
  partcv[0] = 1;
  Object opresult5853 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult5853 (depth = 6)
  *var_spc = opresult5853;
  if (opresult5853 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5899(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5901 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5903 = alloc_Float64(1);
// compiled num node returning num5903 (depth = 9)
  int op_slot_right_5902 = gc_frame_newslot(num5903);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5902 = gc_frame_newslot(*var_depth);
  params[0] = num5903;
  partcv[0] = 1;
  Object sum5905 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5905 (depth = 8)
  gc_frame_newslot(sum5905);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  params[0] = sum5905;
  partcv[0] = 1;
  Object call5906 = callmethodflags(*var_t, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5901);
// compiled call node returning call5906 (depth = 7)
  int op_slot_right_5900 = gc_frame_newslot(call5906);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5909 == NULL) {
    strlit5909 = alloc_String("""\x0a""");
    gc_root(strlit5909);
  }
// compiled string node returning strlit5909 (depth = 8)
  int op_slot_right_5908 = gc_frame_newslot(strlit5909);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5908 = gc_frame_newslot(*var_s);
  params[0] = strlit5909;
  partcv[0] = 1;
  Object opresult5911 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5911 (depth = 7)
  int op_slot_left_5900 = gc_frame_newslot(opresult5911);
  params[0] = call5906;
  partcv[0] = 1;
  Object opresult5912 = callmethod(opresult5911, "++(1)", 1, partcv, params);
// compiled op node returning opresult5912 (depth = 6)
  *var_s = opresult5912;
  if (opresult5912 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5920(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5922 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5924 = alloc_Float64(1);
// compiled num node returning num5924 (depth = 9)
  int op_slot_right_5923 = gc_frame_newslot(num5924);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5923 = gc_frame_newslot(*var_depth);
  params[0] = num5924;
  partcv[0] = 1;
  Object sum5926 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5926 (depth = 8)
  gc_frame_newslot(sum5926);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum5926;
  partcv[0] = 1;
  Object call5927 = callmethodflags(*var_x, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5922);
// compiled call node returning call5927 (depth = 7)
  int op_slot_right_5921 = gc_frame_newslot(call5927);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5930 == NULL) {
    strlit5930 = alloc_String("    ");
    gc_root(strlit5930);
  }
// compiled string node returning strlit5930 (depth = 8)
  int op_slot_right_5929 = gc_frame_newslot(strlit5930);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5932 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5935 == NULL) {
    strlit5935 = alloc_String("""\x0a""");
    gc_root(strlit5935);
  }
// compiled string node returning strlit5935 (depth = 10)
  int op_slot_right_5934 = gc_frame_newslot(strlit5935);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5934 = gc_frame_newslot(*var_s);
  params[0] = strlit5935;
  partcv[0] = 1;
  Object opresult5937 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5937 (depth = 9)
  int op_slot_left_5932 = gc_frame_newslot(opresult5937);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5938 = callmethod(opresult5937, "++(1)", 1, partcv, params);
// compiled op node returning opresult5938 (depth = 8)
  int op_slot_left_5929 = gc_frame_newslot(opresult5938);
  params[0] = strlit5930;
  partcv[0] = 1;
  Object opresult5939 = callmethod(opresult5938, "++(1)", 1, partcv, params);
// compiled op node returning opresult5939 (depth = 7)
  int op_slot_left_5921 = gc_frame_newslot(opresult5939);
  params[0] = call5927;
  partcv[0] = 1;
  Object opresult5940 = callmethod(opresult5939, "++(1)", 1, partcv, params);
// compiled op node returning opresult5940 (depth = 6)
  *var_s = opresult5940;
  if (opresult5940 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_5837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5838 == NULL) {
    strlit5838 = alloc_String("");
    gc_root(strlit5838);
  }
// compiled string node returning strlit5838 (depth = 4)
  *var_spc = strlit5838;
  if (strlit5838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5839 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5842 = alloc_Float64(1);
// compiled num node returning num5842 (depth = 6)
  int op_slot_right_5841 = gc_frame_newslot(num5842);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_5841 = gc_frame_newslot(*var_depth);
  params[0] = num5842;
  partcv[0] = 1;
  Object diff5844 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff5844 (depth = 5)
  int op_slot_right_5840 = gc_frame_newslot(diff5844);
// starting to compile num node (depth = 5)
  Object num5846 = alloc_Float64(0);
// compiled num node returning num5846 (depth = 5)
  int op_slot_left_5840 = gc_frame_newslot(num5846);
  params[0] = diff5844;
  partcv[0] = 1;
  Object opresult5847 = callmethod(num5846, "..(1)", 1, partcv, params);
// compiled op node returning opresult5847 (depth = 4)
  gc_frame_newslot(opresult5847);
// starting to compile block node (depth = 4)
  Object block5848 = alloc_Block(NULL, NULL, "ast", 1421);
  gc_frame_newslot(block5848);
// method "_apply(_)"
  block_savedest(block5848);
  Object closure5849 = createclosure(2, "_apply(1)");
  setclosureframe(closure5849, stackframe);
  addtoclosure(closure5849, var_spc);
  addtoclosure(closure5849, selfslot);
  struct UserObject *uo5849 = (struct UserObject*)block5848;
  uo5849->data[0] = (Object)closure5849;
  Method *meth_meth_ast__apply_40_1_41_5849 = addmethod2pos(block5848, "_apply(1)", &meth_ast__apply_40_1_41_5849, 0);
  int argcv_meth_ast__apply_40_1_41_5849[] = {1};
  meth_meth_ast__apply_40_1_41_5849->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5849);
  meth_meth_ast__apply_40_1_41_5849->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5849->definitionLine = 2969;
// compiled block node returning block5848 (depth = 4)
  gc_frame_newslot(block5848);
// call case 5: prelude request
  params[0] = opresult5847;
  params[1] = block5848;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5856 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5839);
// compiled call node returning call5856 (depth = 3)
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5857 == NULL) {
    strlit5857 = alloc_String("object {");
    gc_root(strlit5857);
  }
// compiled string node returning strlit5857 (depth = 4)
  *var_s = strlit5857;
  if (strlit5857 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5859 = gc_frame_new();
// call case 4: self request
  Object call5860 = callmethodflags(self, "inTrait", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5859);
// compiled member node returning call5860 (depth = 4)
  Object if5858 = done;
  if (istrue(call5860)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5862 == NULL) {
    strlit5862 = alloc_String("   // trait");
    gc_root(strlit5862);
  }
// compiled string node returning strlit5862 (depth = 6)
  int op_slot_right_5861 = gc_frame_newslot(strlit5862);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5861 = gc_frame_newslot(*var_s);
  params[0] = strlit5862;
  partcv[0] = 1;
  Object opresult5864 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5864 (depth = 5)
  *var_s = opresult5864;
  if (opresult5864 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5858 = done;
  } else {
  }
// compiled if node returning if5858 (depth = 3)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5867 = gc_frame_new();
// call case 4: self request
  Object call5868 = callmethodflags(self, "inClass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5867);
// compiled member node returning call5868 (depth = 4)
  Object if5866 = done;
  if (istrue(call5868)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5870 == NULL) {
    strlit5870 = alloc_String("   // class");
    gc_root(strlit5870);
  }
// compiled string node returning strlit5870 (depth = 6)
  int op_slot_right_5869 = gc_frame_newslot(strlit5870);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5869 = gc_frame_newslot(*var_s);
  params[0] = strlit5870;
  partcv[0] = 1;
  Object opresult5872 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5872 (depth = 5)
  *var_s = opresult5872;
  if (opresult5872 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5866 = done;
  } else {
  }
// compiled if node returning if5866 (depth = 3)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5876 = gc_frame_new();
// call case 4: self request
  Object call5877 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5876);
// compiled member node returning call5877 (depth = 5)
  int op_slot_right_5875 = gc_frame_newslot(call5877);
// starting to compile identifier node (depth = 5)
  Object bool5879 = alloc_Boolean(0);
// compiled identifier node returning bool5879 (depth = 5)
  int op_slot_left_5875 = gc_frame_newslot(bool5879);
  params[0] = call5877;
  partcv[0] = 1;
  Object opresult5880 = callmethod(bool5879, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5880 (depth = 4)
  Object if5874 = done;
  if (istrue(opresult5880)) {
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5882 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5884 = alloc_Float64(1);
// compiled num node returning num5884 (depth = 8)
  int op_slot_right_5883 = gc_frame_newslot(num5884);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5883 = gc_frame_newslot(*var_depth);
  params[0] = num5884;
  partcv[0] = 1;
  Object sum5886 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5886 (depth = 7)
  gc_frame_newslot(sum5886);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5887 = gc_frame_new();
// call case 4: self request
  Object call5888 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5887);
// compiled member node returning call5888 (depth = 7)
  params[0] = sum5886;
  partcv[0] = 1;
  Object call5889 = callmethodflags(call5888, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5882);
// compiled call node returning call5889 (depth = 6)
  int op_slot_right_5881 = gc_frame_newslot(call5889);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5892 == NULL) {
    strlit5892 = alloc_String("""\x0a""");
    gc_root(strlit5892);
  }
// compiled string node returning strlit5892 (depth = 7)
  int op_slot_right_5891 = gc_frame_newslot(strlit5892);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5891 = gc_frame_newslot(*var_s);
  params[0] = strlit5892;
  partcv[0] = 1;
  Object opresult5894 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5894 (depth = 6)
  int op_slot_left_5881 = gc_frame_newslot(opresult5894);
  params[0] = call5889;
  partcv[0] = 1;
  Object opresult5895 = callmethod(opresult5894, "++(1)", 1, partcv, params);
// compiled op node returning opresult5895 (depth = 5)
  *var_s = opresult5895;
  if (opresult5895 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5874 = done;
  } else {
  }
// compiled if node returning if5874 (depth = 3)
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5897 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5898 = alloc_Block(NULL, NULL, "ast", 1430);
  gc_frame_newslot(block5898);
// method "_apply(_)"
  block_savedest(block5898);
  Object closure5899 = createclosure(3, "_apply(1)");
  setclosureframe(closure5899, stackframe);
  addtoclosure(closure5899, var_depth);
  addtoclosure(closure5899, var_s);
  addtoclosure(closure5899, selfslot);
  struct UserObject *uo5899 = (struct UserObject*)block5898;
  uo5899->data[0] = (Object)closure5899;
  Method *meth_meth_ast__apply_40_1_41_5899 = addmethod2pos(block5898, "_apply(1)", &meth_ast__apply_40_1_41_5899, 0);
  int argcv_meth_ast__apply_40_1_41_5899[] = {1};
  meth_meth_ast__apply_40_1_41_5899->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5899);
  meth_meth_ast__apply_40_1_41_5899->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5899->definitionLine = 2969;
// compiled block node returning block5898 (depth = 4)
  gc_frame_newslot(block5898);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5915 = gc_frame_new();
// call case 4: self request
  Object call5916 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5915);
// compiled member node returning call5916 (depth = 4)
  params[0] = block5898;
  partcv[0] = 1;
  Object call5917 = callmethodflags(call5916, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5897);
// compiled call node returning call5917 (depth = 3)
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5918 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5919 = alloc_Block(NULL, NULL, "ast", 1431);
  gc_frame_newslot(block5919);
// method "_apply(_)"
  block_savedest(block5919);
  Object closure5920 = createclosure(4, "_apply(1)");
  setclosureframe(closure5920, stackframe);
  addtoclosure(closure5920, var_depth);
  addtoclosure(closure5920, var_spc);
  addtoclosure(closure5920, var_s);
  addtoclosure(closure5920, selfslot);
  struct UserObject *uo5920 = (struct UserObject*)block5919;
  uo5920->data[0] = (Object)closure5920;
  Method *meth_meth_ast__apply_40_1_41_5920 = addmethod2pos(block5919, "_apply(1)", &meth_ast__apply_40_1_41_5920, 0);
  int argcv_meth_ast__apply_40_1_41_5920[] = {1};
  meth_meth_ast__apply_40_1_41_5920->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5920);
  meth_meth_ast__apply_40_1_41_5920->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5920->definitionLine = 2969;
// compiled block node returning block5919 (depth = 4)
  gc_frame_newslot(block5919);
// call case 6: other requests
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5943 = gc_frame_new();
// call case 4: self request
  Object call5944 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5943);
// compiled member node returning call5944 (depth = 4)
  params[0] = block5919;
  partcv[0] = 1;
  Object call5945 = callmethodflags(call5944, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5918);
// compiled call node returning call5945 (depth = 3)
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5947 == NULL) {
    strlit5947 = alloc_String("}");
    gc_root(strlit5947);
  }
// compiled string node returning strlit5947 (depth = 5)
  int op_slot_right_5946 = gc_frame_newslot(strlit5947);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5949 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5952 == NULL) {
    strlit5952 = alloc_String("""\x0a""");
    gc_root(strlit5952);
  }
// compiled string node returning strlit5952 (depth = 7)
  int op_slot_right_5951 = gc_frame_newslot(strlit5952);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5951 = gc_frame_newslot(*var_s);
  params[0] = strlit5952;
  partcv[0] = 1;
  Object opresult5954 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5954 (depth = 6)
  int op_slot_left_5949 = gc_frame_newslot(opresult5954);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5955 = callmethod(opresult5954, "++(1)", 1, partcv, params);
// compiled op node returning opresult5955 (depth = 5)
  int op_slot_left_5946 = gc_frame_newslot(opresult5955);
  params[0] = strlit5947;
  partcv[0] = 1;
  Object opresult5956 = callmethod(opresult5955, "++(1)", 1, partcv, params);
// compiled op node returning opresult5956 (depth = 4)
  *var_s = opresult5956;
  if (opresult5956 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy5958(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5959 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5960 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool5961 = alloc_Boolean(0);
// compiled identifier node returning bool5961 (depth = 5)
  gc_frame_newslot(bool5961);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objectNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = bool5961;
  partcv[0] = 2;
  Object call5962 = callmethodflags(*var_objectNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5960);
// compiled call node returning call5962 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5963 = callmethodflags(call5962, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5959);
// compiled call node returning call5963 (depth = 3)
  gc_frame_end(frame);
  return call5963;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_5964(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5965 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5966 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5965);
// compiled call node returning call5966 (depth = 3)
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5967 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5968 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5969 = callmethodflags(*var_other, "name", 0, partcv, params, 0);
  gc_frame_end(callframe5968);
// compiled member node returning call5969 (depth = 4)
  gc_frame_newslot(call5969);
// call case 4: self request
  params[0] = call5969;
  partcv[0] = 1;
  Object call5970 = callmethodflags(self, "name:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5967);
// compiled call node returning call5970 (depth = 3)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5971 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5972 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5973 = callmethodflags(*var_other, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5972);
// compiled member node returning call5973 (depth = 4)
  gc_frame_newslot(call5973);
// call case 4: self request
  params[0] = call5973;
  partcv[0] = 1;
  Object call5974 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5971);
// compiled call node returning call5974 (depth = 3)
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5975 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5976 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5977 = callmethodflags(*var_other, "superclass", 0, partcv, params, 0);
  gc_frame_end(callframe5976);
// compiled member node returning call5977 (depth = 4)
  gc_frame_newslot(call5977);
// call case 4: self request
  params[0] = call5977;
  partcv[0] = 1;
  Object call5978 = callmethodflags(self, "superclass:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5975);
// compiled call node returning call5978 (depth = 3)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5979 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5980 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5981 = callmethodflags(*var_other, "usedTraits", 0, partcv, params, 0);
  gc_frame_end(callframe5980);
// compiled member node returning call5981 (depth = 4)
  gc_frame_newslot(call5981);
// call case 4: self request
  params[0] = call5981;
  partcv[0] = 1;
  Object call5982 = callmethodflags(self, "usedTraits:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5979);
// compiled call node returning call5982 (depth = 3)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5983 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5984 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5985 = callmethodflags(*var_other, "inClass", 0, partcv, params, 0);
  gc_frame_end(callframe5984);
// compiled member node returning call5985 (depth = 4)
  gc_frame_newslot(call5985);
// call case 4: self request
  params[0] = call5985;
  partcv[0] = 1;
  Object call5986 = callmethodflags(self, "inClass:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5983);
// compiled call node returning call5986 (depth = 3)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5987 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5989 = callmethodflags(*var_other, "inTrait", 0, partcv, params, 0);
  gc_frame_end(callframe5988);
// compiled member node returning call5989 (depth = 4)
  gc_frame_newslot(call5989);
// call case 4: self request
  params[0] = call5989;
  partcv[0] = 1;
  Object call5990 = callmethodflags(self, "inTrait:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5987);
// compiled call node returning call5990 (depth = 3)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5991 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5992 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5993 = callmethodflags(*var_other, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe5992);
// compiled member node returning call5993 (depth = 4)
  gc_frame_newslot(call5993);
// call case 4: self request
  params[0] = call5993;
  partcv[0] = 1;
  Object call5994 = callmethodflags(self, "annotations:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5991);
// compiled call node returning call5994 (depth = 3)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString5995(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5997 == NULL) {
    strlit5997 = alloc_String("");
    gc_root(strlit5997);
  }
// compiled string node returning strlit5997 (depth = 4)
  int op_slot_right_5996 = gc_frame_newslot(strlit5997);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6000 = gc_frame_new();
// call case 4: self request
  Object call6001 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6000);
// compiled member node returning call6001 (depth = 5)
  int op_slot_right_5999 = gc_frame_newslot(call6001);
// starting to compile string node (depth = 5)
  if (strlit6003 == NULL) {
    strlit6003 = alloc_String("object ");
    gc_root(strlit6003);
  }
// compiled string node returning strlit6003 (depth = 5)
  int op_slot_left_5999 = gc_frame_newslot(strlit6003);
  params[0] = call6001;
  partcv[0] = 1;
  Object opresult6004 = callmethod(strlit6003, "++(1)", 1, partcv, params);
// compiled op node returning opresult6004 (depth = 4)
  int op_slot_left_5996 = gc_frame_newslot(opresult6004);
  params[0] = strlit5997;
  partcv[0] = 1;
  Object opresult6005 = callmethod(opresult6004, "++(1)", 1, partcv, params);
// compiled op node returning opresult6005 (depth = 3)
  gc_frame_end(frame);
  return opresult6005;
}
Object meth_ast_new_40_2_41_5421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5422 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5422 = alloc_userobj2(38,31, objclass5422);
  gc_frame_newslot(obj5422);
if (objclass5422 == NULL) {
  glfree(obj5422->class->name);
  obj5422->class->name = "objectNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5422, self, 0);
  addmethodreal(obj5422,"outer", &reader_ast_outer_5423);
  Object oldself5422 = self;
  struct StackFrameObject *oldstackframe5422 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5422);
  gc_frame_newslot((Object)stackframe);
  self = obj5422;
  Object *oldselfslot5422 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5422 = (*(struct UserObject *)self).data[0], lowerouter5422 = thisouter5422;
  if (inheritingObject5422) {
    struct UserObject *inho5422 = (struct UserObject *)inheritingObject5422;
    while (inho5422->super != GraceDefaultObject) inho5422 = (struct UserObject *)inho5422->super;
    inho5422->super = obj5422;
    self = inheritingObject5422;
    *selfslot = self;
    lowerouter5422 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5422;
  }
if (objclass5422 == NULL) {
  Method *reader5424 = addmethodrealflags(obj5422, "kind",&reader_ast_kind_5424, MFLAG_DEF);
  reader5424->definitionModule = modulename;
  reader5424->definitionLine = 1292;
}
adddatum2(obj5422, alloc_Undefined(), 1);
if (objclass5422 == NULL) {
  Method *reader5425 = addmethodrealflags(obj5422, "value", &reader_ast_value_5425, 0);
  Method *writer5425 = addmethodrealflags(obj5422, "value:=(1)", &writer_ast_value_5425, 0);
  reader5425->definitionModule = modulename;
  writer5425->definitionModule = modulename;
  reader5425->definitionLine = 1293;
  writer5425->definitionLine = 1293;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 2);
if (objclass5422 == NULL) {
  Method *reader5426 = addmethodrealflags(obj5422, "superclass", &reader_ast_superclass_5426, 0);
  Method *writer5426 = addmethodrealflags(obj5422, "superclass:=(1)", &writer_ast_superclass_5426, 0);
  reader5426->definitionModule = modulename;
  writer5426->definitionModule = modulename;
  reader5426->definitionLine = 1294;
  writer5426->definitionLine = 1294;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 3);
if (objclass5422 == NULL) {
  Method *reader5427 = addmethodrealflags(obj5422, "usedTraits", &reader_ast_usedTraits_5427, 0);
  Method *writer5427 = addmethodrealflags(obj5422, "usedTraits:=(1)", &writer_ast_usedTraits_5427, 0);
  reader5427->definitionModule = modulename;
  writer5427->definitionModule = modulename;
  reader5427->definitionLine = 1295;
  writer5427->definitionLine = 1295;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 4);
if (objclass5422 == NULL) {
  Method *reader5428 = addmethodrealflags(obj5422, "name", &reader_ast_name_5428, 0);
  Method *writer5428 = addmethodrealflags(obj5422, "name:=(1)", &writer_ast_name_5428, 0);
  reader5428->definitionModule = modulename;
  writer5428->definitionModule = modulename;
  reader5428->definitionLine = 1296;
  writer5428->definitionLine = 1296;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 5);
if (objclass5422 == NULL) {
  Method *reader5429 = addmethodrealflags(obj5422, "inClass", &reader_ast_inClass_5429, 0);
  Method *writer5429 = addmethodrealflags(obj5422, "inClass:=(1)", &writer_ast_inClass_5429, 0);
  reader5429->definitionModule = modulename;
  writer5429->definitionModule = modulename;
  reader5429->definitionLine = 1297;
  writer5429->definitionLine = 1297;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 6);
if (objclass5422 == NULL) {
  Method *reader5430 = addmethodrealflags(obj5422, "inTrait", &reader_ast_inTrait_5430, 0);
  Method *writer5430 = addmethodrealflags(obj5422, "inTrait:=(1)", &writer_ast_inTrait_5430, 0);
  reader5430->definitionModule = modulename;
  writer5430->definitionModule = modulename;
  reader5430->definitionLine = 1298;
  writer5430->definitionLine = 1298;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 7);
if (objclass5422 == NULL) {
  Method *reader5431 = addmethodrealflags(obj5422, "myLocalNames", &reader_ast_myLocalNames_5431, MFLAG_CONFIDENTIAL);
  Method *writer5431 = addmethodrealflags(obj5422, "myLocalNames:=(1)", &writer_ast_myLocalNames_5431, MFLAG_CONFIDENTIAL);
  reader5431->definitionModule = modulename;
  writer5431->definitionModule = modulename;
  reader5431->definitionLine = 1299;
  writer5431->definitionLine = 1299;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 8);
if (objclass5422 == NULL) {
  Method *reader5432 = addmethodrealflags(obj5422, "annotations", &reader_ast_annotations_5432, 0);
  Method *writer5432 = addmethodrealflags(obj5422, "annotations:=(1)", &writer_ast_annotations_5432, 0);
  reader5432->definitionModule = modulename;
  writer5432->definitionModule = modulename;
  reader5432->definitionLine = 1300;
  writer5432->definitionLine = 1300;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 9);
// method "description"
  struct UserObject *uo5433 = (struct UserObject*)obj5422;
  uo5433->data[10] = emptyclosure;
  Method *meth_meth_ast_description5433 = addmethod2pos(obj5422, "description", &meth_ast_description5433, 10);
  int argcv_meth_ast_description5433[] = {0};
  meth_meth_ast_description5433->type = alloc_MethodType(1, argcv_meth_ast_description5433);
  meth_meth_ast_description5433->definitionModule = modulename;
  meth_meth_ast_description5433->definitionLine = 1302;
// method "isTrait"
  struct UserObject *uo5462 = (struct UserObject*)obj5422;
  uo5462->data[11] = emptyclosure;
  Method *meth_meth_ast_isTrait5462 = addmethod2pos(obj5422, "isTrait", &meth_ast_isTrait5462, 11);
  int argcv_meth_ast_isTrait5462[] = {0};
  meth_meth_ast_isTrait5462->type = alloc_MethodType(1, argcv_meth_ast_isTrait5462);
  meth_meth_ast_isTrait5462->definitionModule = modulename;
  meth_meth_ast_isTrait5462->definitionLine = 1311;
// method "localNames"
  struct UserObject *uo5489 = (struct UserObject*)obj5422;
  uo5489->data[12] = emptyclosure;
  Method *meth_meth_ast_localNames5489 = addmethod2pos(obj5422, "localNames", &meth_ast_localNames5489, 12);
  int argcv_meth_ast_localNames5489[] = {0};
  meth_meth_ast_localNames5489->type = alloc_MethodType(1, argcv_meth_ast_localNames5489);
  meth_meth_ast_localNames5489->definitionModule = modulename;
  meth_meth_ast_localNames5489->definitionLine = 1322;
// method "parentsDo(_)"
  struct UserObject *uo5524 = (struct UserObject*)obj5422;
  uo5524->data[13] = emptyclosure;
  Method *meth_meth_ast_parentsDo_40_1_41_5524 = addmethod2pos(obj5422, "parentsDo(1)", &meth_ast_parentsDo_40_1_41_5524, 13);
  int argcv_meth_ast_parentsDo_40_1_41_5524[] = {1};
  meth_meth_ast_parentsDo_40_1_41_5524->type = alloc_MethodType(1, argcv_meth_ast_parentsDo_40_1_41_5524);
  meth_meth_ast_parentsDo_40_1_41_5524->definitionModule = modulename;
  meth_meth_ast_parentsDo_40_1_41_5524->definitionLine = 1336;
// method "methodsDo(_)"
  struct UserObject *uo5545 = (struct UserObject*)obj5422;
  uo5545->data[14] = emptyclosure;
  Method *meth_meth_ast_methodsDo_40_1_41_5545 = addmethod2pos(obj5422, "methodsDo(1)", &meth_ast_methodsDo_40_1_41_5545, 14);
  int argcv_meth_ast_methodsDo_40_1_41_5545[] = {1};
  meth_meth_ast_methodsDo_40_1_41_5545->type = alloc_MethodType(1, argcv_meth_ast_methodsDo_40_1_41_5545);
  meth_meth_ast_methodsDo_40_1_41_5545->definitionModule = modulename;
  meth_meth_ast_methodsDo_40_1_41_5545->definitionLine = 1343;
// method "executableComponentsDo(_)"
  struct UserObject *uo5558 = (struct UserObject*)obj5422;
  uo5558->data[15] = emptyclosure;
  Method *meth_meth_ast_executableComponentsDo_40_1_41_5558 = addmethod2pos(obj5422, "executableComponentsDo(1)", &meth_ast_executableComponentsDo_40_1_41_5558, 15);
  int argcv_meth_ast_executableComponentsDo_40_1_41_5558[] = {1};
  meth_meth_ast_executableComponentsDo_40_1_41_5558->type = alloc_MethodType(1, argcv_meth_ast_executableComponentsDo_40_1_41_5558);
  meth_meth_ast_executableComponentsDo_40_1_41_5558->definitionModule = modulename;
  meth_meth_ast_executableComponentsDo_40_1_41_5558->definitionLine = 1351;
// method "scope:=(_)"
  struct UserObject *uo5571 = (struct UserObject*)obj5422;
  uo5571->data[16] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_5571 = addmethod2pos(obj5422, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_5571, 16);
  int argcv_meth_ast_scope_58__61__40_1_41_5571[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_5571->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_5571);
  meth_meth_ast_scope_58__61__40_1_41_5571->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_5571->definitionLine = 1359;
// method "body"
  struct UserObject *uo5576 = (struct UserObject*)obj5422;
  uo5576->data[17] = emptyclosure;
  Method *meth_meth_ast_body5576 = addmethod2pos(obj5422, "body", &meth_ast_body5576, 17);
  int argcv_meth_ast_body5576[] = {0};
  meth_meth_ast_body5576->type = alloc_MethodType(1, argcv_meth_ast_body5576);
  meth_meth_ast_body5576->definitionModule = modulename;
  meth_meth_ast_body5576->definitionLine = 1365;
// method "returnsObject"
  struct UserObject *uo5579 = (struct UserObject*)obj5422;
  uo5579->data[18] = emptyclosure;
  Method *meth_meth_ast_returnsObject5579 = addmethod2pos(obj5422, "returnsObject", &meth_ast_returnsObject5579, 18);
  int argcv_meth_ast_returnsObject5579[] = {0};
  meth_meth_ast_returnsObject5579->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5579);
  meth_meth_ast_returnsObject5579->definitionModule = modulename;
  meth_meth_ast_returnsObject5579->definitionLine = 1366;
// method "returnedObjectScope"
  struct UserObject *uo5581 = (struct UserObject*)obj5422;
  uo5581->data[19] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5581 = addmethod2pos(obj5422, "returnedObjectScope", &meth_ast_returnedObjectScope5581, 19);
  int argcv_meth_ast_returnedObjectScope5581[] = {0};
  meth_meth_ast_returnedObjectScope5581->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5581);
  meth_meth_ast_returnedObjectScope5581->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5581->definitionLine = 1367;
// method "canInherit"
  struct UserObject *uo5584 = (struct UserObject*)obj5422;
  uo5584->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit5584 = addmethod2pos(obj5422, "canInherit", &meth_ast_canInherit5584, 20);
  int argcv_meth_ast_canInherit5584[] = {0};
  meth_meth_ast_canInherit5584->type = alloc_MethodType(1, argcv_meth_ast_canInherit5584);
  meth_meth_ast_canInherit5584->definitionModule = modulename;
  meth_meth_ast_canInherit5584->definitionLine = 1368;
// method "canUse"
  struct UserObject *uo5589 = (struct UserObject*)obj5422;
  uo5589->data[21] = emptyclosure;
  Method *meth_meth_ast_canUse5589 = addmethod2pos(obj5422, "canUse", &meth_ast_canUse5589, 21);
  int argcv_meth_ast_canUse5589[] = {0};
  meth_meth_ast_canUse5589->type = alloc_MethodType(1, argcv_meth_ast_canUse5589);
  meth_meth_ast_canUse5589->definitionModule = modulename;
  meth_meth_ast_canUse5589->definitionLine = 1369;
// method "isObject"
  struct UserObject *uo5591 = (struct UserObject*)obj5422;
  uo5591->data[22] = emptyclosure;
  Method *meth_meth_ast_isObject5591 = addmethod2pos(obj5422, "isObject", &meth_ast_isObject5591, 22);
  int argcv_meth_ast_isObject5591[] = {0};
  meth_meth_ast_isObject5591->type = alloc_MethodType(1, argcv_meth_ast_isObject5591);
  meth_meth_ast_isObject5591->definitionModule = modulename;
  meth_meth_ast_isObject5591->definitionLine = 1370;
// method "accept(_)from(_)"
  struct UserObject *uo5593 = (struct UserObject*)obj5422;
  uo5593->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_5593 = addmethod2pos(obj5422, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_5593, 23);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_5593[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_5593->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_5593);
  meth_meth_ast_accept_40_1_41_from_40_1_41_5593->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_5593->definitionLine = 1371;
// method "nameString"
  struct UserObject *uo5628 = (struct UserObject*)obj5422;
  uo5628->data[24] = emptyclosure;
  Method *meth_meth_ast_nameString5628 = addmethod2pos(obj5422, "nameString", &meth_ast_nameString5628, 24);
  int argcv_meth_ast_nameString5628[] = {0};
  meth_meth_ast_nameString5628->type = alloc_MethodType(1, argcv_meth_ast_nameString5628);
  meth_meth_ast_nameString5628->definitionModule = modulename;
  meth_meth_ast_nameString5628->definitionLine = 1381;
// method "map(_)ancestors(_)"
  struct UserObject *uo5648 = (struct UserObject*)obj5422;
  uo5648->data[25] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_5648 = addmethod2pos(obj5422, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_5648, 25);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_5648[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5648->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_5648);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5648->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5648->definitionLine = 1388;
// method "pretty(_)"
  struct UserObject *uo5685 = (struct UserObject*)obj5422;
  uo5685->data[26] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_5685 = addmethod2pos(obj5422, "pretty(1)", &meth_ast_pretty_40_1_41_5685, 26);
  int argcv_meth_ast_pretty_40_1_41_5685[] = {1};
  meth_meth_ast_pretty_40_1_41_5685->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_5685);
  meth_meth_ast_pretty_40_1_41_5685->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_5685->definitionLine = 1396;
// method "toGrace(_)"
  struct UserObject *uo5837 = (struct UserObject*)obj5422;
  uo5837->data[27] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_5837 = addmethod2pos(obj5422, "toGrace(1)", &meth_ast_toGrace_40_1_41_5837, 27);
  int argcv_meth_ast_toGrace_40_1_41_5837[] = {1};
  meth_meth_ast_toGrace_40_1_41_5837->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_5837);
meth_meth_ast_toGrace_40_1_41_5837->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_5837->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_5837->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_5837->definitionLine = 1419;
// method "shallowCopy"
  block_savedest(obj5422);
  Object closure5958 = createclosure(2, "shallowCopy");
  setclosureframe(closure5958, stackframe);
  addtoclosure(closure5958, var_emptySeq);
  addtoclosure(closure5958, var_objectNode);
  struct UserObject *uo5958 = (struct UserObject*)obj5422;
  uo5958->data[28] = (Object)closure5958;
  Method *meth_meth_ast_shallowCopy5958 = addmethod2pos(obj5422, "shallowCopy", &meth_ast_shallowCopy5958, 28);
  int argcv_meth_ast_shallowCopy5958[] = {0};
  meth_meth_ast_shallowCopy5958->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5958);
  meth_meth_ast_shallowCopy5958->definitionModule = modulename;
  meth_meth_ast_shallowCopy5958->definitionLine = 1437;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5964 = (struct UserObject*)obj5422;
  uo5964->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5964 = addmethod2pos(obj5422, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5964, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5964[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5964->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5964);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5964->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5964->definitionLine = 1440;
// method "asString"
  struct UserObject *uo5995 = (struct UserObject*)obj5422;
  uo5995->data[30] = emptyclosure;
  Method *meth_meth_ast_asString5995 = addmethod2pos(obj5422, "asString", &meth_ast_asString5995, 30);
  int argcv_meth_ast_asString5995[] = {0};
  meth_meth_ast_asString5995->type = alloc_MethodType(1, argcv_meth_ast_asString5995);
  meth_meth_ast_asString5995->definitionModule = modulename;
  meth_meth_ast_asString5995->definitionLine = 1451;
  sourceObject = obj5422;
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6006 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6007 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6008 = gc_frame_new();
// call case 3: self.outer request
  Object call6009 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6008);
// compiled member node returning call6009 (depth = 5)
  Object call6010 = callmethodflags(call6009, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6007);
// compiled member node returning call6010 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6011 = callmethodflags(call6010, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6006);
// compiled call node returning call6011 (depth = 3)
  struct UserObject *obj5422_uo = (struct UserObject *)obj5422;
  obj5422_uo->super = call6011;
  sourceObject = obj5422;
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6012 == NULL) {
    strlit6012 = alloc_String("object");
    gc_root(strlit6012);
  }
// compiled string node returning strlit6012 (depth = 3)
  adddatum2(obj5422, strlit6012, 1);
  sourceObject = obj5422;
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj5422, *var_b, 2);
  sourceObject = obj5422;
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj5422, *var_superclass_39_, 3);
  sourceObject = obj5422;
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6013 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6013 (depth = 3)
  adddatum2(obj5422, array6013, 4);
  sourceObject = obj5422;
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6014 == NULL) {
    strlit6014 = alloc_String("object");
    gc_root(strlit6014);
  }
// compiled string node returning strlit6014 (depth = 3)
  adddatum2(obj5422, strlit6014, 5);
  sourceObject = obj5422;
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6015 = alloc_Boolean(0);
// compiled identifier node returning bool6015 (depth = 3)
  adddatum2(obj5422, bool6015, 6);
  sourceObject = obj5422;
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6016 = alloc_Boolean(0);
// compiled identifier node returning bool6016 (depth = 3)
  adddatum2(obj5422, bool6016, 7);
  sourceObject = obj5422;
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6017 = alloc_Boolean(0);
// compiled identifier node returning bool6017 (depth = 3)
  adddatum2(obj5422, bool6017, 8);
  sourceObject = obj5422;
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6018 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6018 (depth = 3)
  adddatum2(obj5422, array6018, 9);
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  objclass5422 = obj5422->class;
  objclass5422->definitionModule = modulename;
  objclass5422->definitionLine = 1290;
  (*(struct UserObject *)self).data[0] = lowerouter5422;
  self = oldself5422;
  selfslot = oldselfslot5422;
  stackframe = oldstackframe5422;
  gc_frame_end(frame);
  return obj5422;
}
Object meth_ast_new_40_2_41_5421_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5422 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5422 = alloc_userobj2(38,31, objclass5422);
  gc_frame_newslot(obj5422);
if (objclass5422 == NULL) {
  glfree(obj5422->class->name);
  obj5422->class->name = "objectNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5422, self, 0);
  addmethodreal(obj5422,"outer", &reader_ast_outer_5423);
  Object oldself5422 = self;
  struct StackFrameObject *oldstackframe5422 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5422);
  gc_frame_newslot((Object)stackframe);
  self = obj5422;
  Object *oldselfslot5422 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5422 = (*(struct UserObject *)self).data[0], lowerouter5422 = thisouter5422;
  if (inheritingObject5422) {
    struct UserObject *inho5422 = (struct UserObject *)inheritingObject5422;
    while (inho5422->super != GraceDefaultObject) inho5422 = (struct UserObject *)inho5422->super;
    inho5422->super = obj5422;
    self = inheritingObject5422;
    *selfslot = self;
    lowerouter5422 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5422;
  }
if (objclass5422 == NULL) {
  Method *reader5424 = addmethodrealflags(obj5422, "kind",&reader_ast_kind_5424, MFLAG_DEF);
  reader5424->definitionModule = modulename;
  reader5424->definitionLine = 1292;
}
adddatum2(obj5422, alloc_Undefined(), 1);
if (objclass5422 == NULL) {
  Method *reader5425 = addmethodrealflags(obj5422, "value", &reader_ast_value_5425, 0);
  Method *writer5425 = addmethodrealflags(obj5422, "value:=(1)", &writer_ast_value_5425, 0);
  reader5425->definitionModule = modulename;
  writer5425->definitionModule = modulename;
  reader5425->definitionLine = 1293;
  writer5425->definitionLine = 1293;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 2);
if (objclass5422 == NULL) {
  Method *reader5426 = addmethodrealflags(obj5422, "superclass", &reader_ast_superclass_5426, 0);
  Method *writer5426 = addmethodrealflags(obj5422, "superclass:=(1)", &writer_ast_superclass_5426, 0);
  reader5426->definitionModule = modulename;
  writer5426->definitionModule = modulename;
  reader5426->definitionLine = 1294;
  writer5426->definitionLine = 1294;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 3);
if (objclass5422 == NULL) {
  Method *reader5427 = addmethodrealflags(obj5422, "usedTraits", &reader_ast_usedTraits_5427, 0);
  Method *writer5427 = addmethodrealflags(obj5422, "usedTraits:=(1)", &writer_ast_usedTraits_5427, 0);
  reader5427->definitionModule = modulename;
  writer5427->definitionModule = modulename;
  reader5427->definitionLine = 1295;
  writer5427->definitionLine = 1295;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 4);
if (objclass5422 == NULL) {
  Method *reader5428 = addmethodrealflags(obj5422, "name", &reader_ast_name_5428, 0);
  Method *writer5428 = addmethodrealflags(obj5422, "name:=(1)", &writer_ast_name_5428, 0);
  reader5428->definitionModule = modulename;
  writer5428->definitionModule = modulename;
  reader5428->definitionLine = 1296;
  writer5428->definitionLine = 1296;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 5);
if (objclass5422 == NULL) {
  Method *reader5429 = addmethodrealflags(obj5422, "inClass", &reader_ast_inClass_5429, 0);
  Method *writer5429 = addmethodrealflags(obj5422, "inClass:=(1)", &writer_ast_inClass_5429, 0);
  reader5429->definitionModule = modulename;
  writer5429->definitionModule = modulename;
  reader5429->definitionLine = 1297;
  writer5429->definitionLine = 1297;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 6);
if (objclass5422 == NULL) {
  Method *reader5430 = addmethodrealflags(obj5422, "inTrait", &reader_ast_inTrait_5430, 0);
  Method *writer5430 = addmethodrealflags(obj5422, "inTrait:=(1)", &writer_ast_inTrait_5430, 0);
  reader5430->definitionModule = modulename;
  writer5430->definitionModule = modulename;
  reader5430->definitionLine = 1298;
  writer5430->definitionLine = 1298;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 7);
if (objclass5422 == NULL) {
  Method *reader5431 = addmethodrealflags(obj5422, "myLocalNames", &reader_ast_myLocalNames_5431, MFLAG_CONFIDENTIAL);
  Method *writer5431 = addmethodrealflags(obj5422, "myLocalNames:=(1)", &writer_ast_myLocalNames_5431, MFLAG_CONFIDENTIAL);
  reader5431->definitionModule = modulename;
  writer5431->definitionModule = modulename;
  reader5431->definitionLine = 1299;
  writer5431->definitionLine = 1299;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 8);
if (objclass5422 == NULL) {
  Method *reader5432 = addmethodrealflags(obj5422, "annotations", &reader_ast_annotations_5432, 0);
  Method *writer5432 = addmethodrealflags(obj5422, "annotations:=(1)", &writer_ast_annotations_5432, 0);
  reader5432->definitionModule = modulename;
  writer5432->definitionModule = modulename;
  reader5432->definitionLine = 1300;
  writer5432->definitionLine = 1300;
}
obj5422->flags |= OFLAG_MUTABLE;
adddatum2(obj5422, alloc_Undefined(), 9);
// method "description"
  struct UserObject *uo5433 = (struct UserObject*)obj5422;
  uo5433->data[10] = emptyclosure;
  Method *meth_meth_ast_description5433 = addmethod2pos(obj5422, "description", &meth_ast_description5433, 10);
  int argcv_meth_ast_description5433[] = {0};
  meth_meth_ast_description5433->type = alloc_MethodType(1, argcv_meth_ast_description5433);
  meth_meth_ast_description5433->definitionModule = modulename;
  meth_meth_ast_description5433->definitionLine = 1302;
// method "isTrait"
  struct UserObject *uo5462 = (struct UserObject*)obj5422;
  uo5462->data[11] = emptyclosure;
  Method *meth_meth_ast_isTrait5462 = addmethod2pos(obj5422, "isTrait", &meth_ast_isTrait5462, 11);
  int argcv_meth_ast_isTrait5462[] = {0};
  meth_meth_ast_isTrait5462->type = alloc_MethodType(1, argcv_meth_ast_isTrait5462);
  meth_meth_ast_isTrait5462->definitionModule = modulename;
  meth_meth_ast_isTrait5462->definitionLine = 1311;
// method "localNames"
  struct UserObject *uo5489 = (struct UserObject*)obj5422;
  uo5489->data[12] = emptyclosure;
  Method *meth_meth_ast_localNames5489 = addmethod2pos(obj5422, "localNames", &meth_ast_localNames5489, 12);
  int argcv_meth_ast_localNames5489[] = {0};
  meth_meth_ast_localNames5489->type = alloc_MethodType(1, argcv_meth_ast_localNames5489);
  meth_meth_ast_localNames5489->definitionModule = modulename;
  meth_meth_ast_localNames5489->definitionLine = 1322;
// method "parentsDo(_)"
  struct UserObject *uo5524 = (struct UserObject*)obj5422;
  uo5524->data[13] = emptyclosure;
  Method *meth_meth_ast_parentsDo_40_1_41_5524 = addmethod2pos(obj5422, "parentsDo(1)", &meth_ast_parentsDo_40_1_41_5524, 13);
  int argcv_meth_ast_parentsDo_40_1_41_5524[] = {1};
  meth_meth_ast_parentsDo_40_1_41_5524->type = alloc_MethodType(1, argcv_meth_ast_parentsDo_40_1_41_5524);
  meth_meth_ast_parentsDo_40_1_41_5524->definitionModule = modulename;
  meth_meth_ast_parentsDo_40_1_41_5524->definitionLine = 1336;
// method "methodsDo(_)"
  struct UserObject *uo5545 = (struct UserObject*)obj5422;
  uo5545->data[14] = emptyclosure;
  Method *meth_meth_ast_methodsDo_40_1_41_5545 = addmethod2pos(obj5422, "methodsDo(1)", &meth_ast_methodsDo_40_1_41_5545, 14);
  int argcv_meth_ast_methodsDo_40_1_41_5545[] = {1};
  meth_meth_ast_methodsDo_40_1_41_5545->type = alloc_MethodType(1, argcv_meth_ast_methodsDo_40_1_41_5545);
  meth_meth_ast_methodsDo_40_1_41_5545->definitionModule = modulename;
  meth_meth_ast_methodsDo_40_1_41_5545->definitionLine = 1343;
// method "executableComponentsDo(_)"
  struct UserObject *uo5558 = (struct UserObject*)obj5422;
  uo5558->data[15] = emptyclosure;
  Method *meth_meth_ast_executableComponentsDo_40_1_41_5558 = addmethod2pos(obj5422, "executableComponentsDo(1)", &meth_ast_executableComponentsDo_40_1_41_5558, 15);
  int argcv_meth_ast_executableComponentsDo_40_1_41_5558[] = {1};
  meth_meth_ast_executableComponentsDo_40_1_41_5558->type = alloc_MethodType(1, argcv_meth_ast_executableComponentsDo_40_1_41_5558);
  meth_meth_ast_executableComponentsDo_40_1_41_5558->definitionModule = modulename;
  meth_meth_ast_executableComponentsDo_40_1_41_5558->definitionLine = 1351;
// method "scope:=(_)"
  struct UserObject *uo5571 = (struct UserObject*)obj5422;
  uo5571->data[16] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_5571 = addmethod2pos(obj5422, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_5571, 16);
  int argcv_meth_ast_scope_58__61__40_1_41_5571[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_5571->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_5571);
  meth_meth_ast_scope_58__61__40_1_41_5571->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_5571->definitionLine = 1359;
// method "body"
  struct UserObject *uo5576 = (struct UserObject*)obj5422;
  uo5576->data[17] = emptyclosure;
  Method *meth_meth_ast_body5576 = addmethod2pos(obj5422, "body", &meth_ast_body5576, 17);
  int argcv_meth_ast_body5576[] = {0};
  meth_meth_ast_body5576->type = alloc_MethodType(1, argcv_meth_ast_body5576);
  meth_meth_ast_body5576->definitionModule = modulename;
  meth_meth_ast_body5576->definitionLine = 1365;
// method "returnsObject"
  struct UserObject *uo5579 = (struct UserObject*)obj5422;
  uo5579->data[18] = emptyclosure;
  Method *meth_meth_ast_returnsObject5579 = addmethod2pos(obj5422, "returnsObject", &meth_ast_returnsObject5579, 18);
  int argcv_meth_ast_returnsObject5579[] = {0};
  meth_meth_ast_returnsObject5579->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5579);
  meth_meth_ast_returnsObject5579->definitionModule = modulename;
  meth_meth_ast_returnsObject5579->definitionLine = 1366;
// method "returnedObjectScope"
  struct UserObject *uo5581 = (struct UserObject*)obj5422;
  uo5581->data[19] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5581 = addmethod2pos(obj5422, "returnedObjectScope", &meth_ast_returnedObjectScope5581, 19);
  int argcv_meth_ast_returnedObjectScope5581[] = {0};
  meth_meth_ast_returnedObjectScope5581->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5581);
  meth_meth_ast_returnedObjectScope5581->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5581->definitionLine = 1367;
// method "canInherit"
  struct UserObject *uo5584 = (struct UserObject*)obj5422;
  uo5584->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit5584 = addmethod2pos(obj5422, "canInherit", &meth_ast_canInherit5584, 20);
  int argcv_meth_ast_canInherit5584[] = {0};
  meth_meth_ast_canInherit5584->type = alloc_MethodType(1, argcv_meth_ast_canInherit5584);
  meth_meth_ast_canInherit5584->definitionModule = modulename;
  meth_meth_ast_canInherit5584->definitionLine = 1368;
// method "canUse"
  struct UserObject *uo5589 = (struct UserObject*)obj5422;
  uo5589->data[21] = emptyclosure;
  Method *meth_meth_ast_canUse5589 = addmethod2pos(obj5422, "canUse", &meth_ast_canUse5589, 21);
  int argcv_meth_ast_canUse5589[] = {0};
  meth_meth_ast_canUse5589->type = alloc_MethodType(1, argcv_meth_ast_canUse5589);
  meth_meth_ast_canUse5589->definitionModule = modulename;
  meth_meth_ast_canUse5589->definitionLine = 1369;
// method "isObject"
  struct UserObject *uo5591 = (struct UserObject*)obj5422;
  uo5591->data[22] = emptyclosure;
  Method *meth_meth_ast_isObject5591 = addmethod2pos(obj5422, "isObject", &meth_ast_isObject5591, 22);
  int argcv_meth_ast_isObject5591[] = {0};
  meth_meth_ast_isObject5591->type = alloc_MethodType(1, argcv_meth_ast_isObject5591);
  meth_meth_ast_isObject5591->definitionModule = modulename;
  meth_meth_ast_isObject5591->definitionLine = 1370;
// method "accept(_)from(_)"
  struct UserObject *uo5593 = (struct UserObject*)obj5422;
  uo5593->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_5593 = addmethod2pos(obj5422, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_5593, 23);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_5593[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_5593->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_5593);
  meth_meth_ast_accept_40_1_41_from_40_1_41_5593->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_5593->definitionLine = 1371;
// method "nameString"
  struct UserObject *uo5628 = (struct UserObject*)obj5422;
  uo5628->data[24] = emptyclosure;
  Method *meth_meth_ast_nameString5628 = addmethod2pos(obj5422, "nameString", &meth_ast_nameString5628, 24);
  int argcv_meth_ast_nameString5628[] = {0};
  meth_meth_ast_nameString5628->type = alloc_MethodType(1, argcv_meth_ast_nameString5628);
  meth_meth_ast_nameString5628->definitionModule = modulename;
  meth_meth_ast_nameString5628->definitionLine = 1381;
// method "map(_)ancestors(_)"
  struct UserObject *uo5648 = (struct UserObject*)obj5422;
  uo5648->data[25] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_5648 = addmethod2pos(obj5422, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_5648, 25);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_5648[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5648->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_5648);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5648->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5648->definitionLine = 1388;
// method "pretty(_)"
  struct UserObject *uo5685 = (struct UserObject*)obj5422;
  uo5685->data[26] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_5685 = addmethod2pos(obj5422, "pretty(1)", &meth_ast_pretty_40_1_41_5685, 26);
  int argcv_meth_ast_pretty_40_1_41_5685[] = {1};
  meth_meth_ast_pretty_40_1_41_5685->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_5685);
  meth_meth_ast_pretty_40_1_41_5685->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_5685->definitionLine = 1396;
// method "toGrace(_)"
  struct UserObject *uo5837 = (struct UserObject*)obj5422;
  uo5837->data[27] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_5837 = addmethod2pos(obj5422, "toGrace(1)", &meth_ast_toGrace_40_1_41_5837, 27);
  int argcv_meth_ast_toGrace_40_1_41_5837[] = {1};
  meth_meth_ast_toGrace_40_1_41_5837->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_5837);
meth_meth_ast_toGrace_40_1_41_5837->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_5837->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_5837->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_5837->definitionLine = 1419;
// method "shallowCopy"
  block_savedest(obj5422);
  Object closure5958 = createclosure(2, "shallowCopy");
  setclosureframe(closure5958, stackframe);
  addtoclosure(closure5958, var_emptySeq);
  addtoclosure(closure5958, var_objectNode);
  struct UserObject *uo5958 = (struct UserObject*)obj5422;
  uo5958->data[28] = (Object)closure5958;
  Method *meth_meth_ast_shallowCopy5958 = addmethod2pos(obj5422, "shallowCopy", &meth_ast_shallowCopy5958, 28);
  int argcv_meth_ast_shallowCopy5958[] = {0};
  meth_meth_ast_shallowCopy5958->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5958);
  meth_meth_ast_shallowCopy5958->definitionModule = modulename;
  meth_meth_ast_shallowCopy5958->definitionLine = 1437;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5964 = (struct UserObject*)obj5422;
  uo5964->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5964 = addmethod2pos(obj5422, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5964, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5964[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5964->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5964);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5964->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5964->definitionLine = 1440;
// method "asString"
  struct UserObject *uo5995 = (struct UserObject*)obj5422;
  uo5995->data[30] = emptyclosure;
  Method *meth_meth_ast_asString5995 = addmethod2pos(obj5422, "asString", &meth_ast_asString5995, 30);
  int argcv_meth_ast_asString5995[] = {0};
  meth_meth_ast_asString5995->type = alloc_MethodType(1, argcv_meth_ast_asString5995);
  meth_meth_ast_asString5995->definitionModule = modulename;
  meth_meth_ast_asString5995->definitionLine = 1451;
  sourceObject = obj5422;
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6006 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6007 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6008 = gc_frame_new();
// call case 3: self.outer request
  Object call6009 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6008);
// compiled member node returning call6009 (depth = 5)
  Object call6010 = callmethodflags(call6009, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6007);
// compiled member node returning call6010 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6011 = callmethodflags(call6010, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6006);
// compiled call node returning call6011 (depth = 3)
  struct UserObject *obj5422_uo = (struct UserObject *)obj5422;
  obj5422_uo->super = call6011;
  sourceObject = obj5422;
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6012 == NULL) {
    strlit6012 = alloc_String("object");
    gc_root(strlit6012);
  }
// compiled string node returning strlit6012 (depth = 3)
  adddatum2(obj5422, strlit6012, 1);
  sourceObject = obj5422;
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj5422, *var_b, 2);
  sourceObject = obj5422;
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj5422, *var_superclass_39_, 3);
  sourceObject = obj5422;
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6013 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6013 (depth = 3)
  adddatum2(obj5422, array6013, 4);
  sourceObject = obj5422;
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6014 == NULL) {
    strlit6014 = alloc_String("object");
    gc_root(strlit6014);
  }
// compiled string node returning strlit6014 (depth = 3)
  adddatum2(obj5422, strlit6014, 5);
  sourceObject = obj5422;
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6015 = alloc_Boolean(0);
// compiled identifier node returning bool6015 (depth = 3)
  adddatum2(obj5422, bool6015, 6);
  sourceObject = obj5422;
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6016 = alloc_Boolean(0);
// compiled identifier node returning bool6016 (depth = 3)
  adddatum2(obj5422, bool6016, 7);
  sourceObject = obj5422;
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6017 = alloc_Boolean(0);
// compiled identifier node returning bool6017 (depth = 3)
  adddatum2(obj5422, bool6017, 8);
  sourceObject = obj5422;
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6018 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6018 (depth = 3)
  adddatum2(obj5422, array6018, 9);
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  sourceObject = obj5422;
  objclass5422 = obj5422->class;
  objclass5422->definitionModule = modulename;
  objclass5422->definitionLine = 1290;
  (*(struct UserObject *)self).data[0] = lowerouter5422;
  self = oldself5422;
  selfslot = oldselfslot5422;
  stackframe = oldstackframe5422;
  gc_frame_end(frame);
  return obj5422;
}
Object meth_ast_objectNode6020(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objectNode (depth = 3)
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast__apply_40_1_41_6038(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6039 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ax (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6040 = callmethodflags(*var_ax, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6039);
// compiled call node returning call6040 (depth = 6)
  gc_frame_end(frame);
  return call6040;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6030 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6031 = callmethodflags(*var_visitor, "visitArray(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6030);
// compiled call node returning call6031 (depth = 4)
  Object if6029 = done;
  if (istrue(call6031)) {
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6032 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6033 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6032);
// compiled call node returning call6033 (depth = 5)
  *var_newChain = call6033;
  if (call6033 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6034 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6035 = gc_frame_new();
// call case 4: self request
  Object call6036 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6035);
// compiled member node returning call6036 (depth = 5)
  gc_frame_newslot(call6036);
// starting to compile block node (depth = 5)
  Object block6037 = alloc_Block(NULL, NULL, "ast", 1464);
  gc_frame_newslot(block6037);
// method "_apply(_)"
  block_savedest(block6037);
  Object closure6038 = createclosure(3, "_apply(1)");
  setclosureframe(closure6038, stackframe);
  addtoclosure(closure6038, var_visitor);
  addtoclosure(closure6038, var_newChain);
  addtoclosure(closure6038, selfslot);
  struct UserObject *uo6038 = (struct UserObject*)block6037;
  uo6038->data[0] = (Object)closure6038;
  Method *meth_meth_ast__apply_40_1_41_6038 = addmethod2pos(block6037, "_apply(1)", &meth_ast__apply_40_1_41_6038, 0);
  int argcv_meth_ast__apply_40_1_41_6038[] = {1};
  meth_meth_ast__apply_40_1_41_6038->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6038);
  meth_meth_ast__apply_40_1_41_6038->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6038->definitionLine = 2969;
// compiled block node returning block6037 (depth = 5)
  gc_frame_newslot(block6037);
// call case 5: prelude request
  params[0] = call6036;
  params[1] = block6037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6042 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6034);
// compiled call node returning call6042 (depth = 4)
    gc_frame_newslot(call6042);
    if6029 = call6042;
  } else {
  }
// compiled if node returning if6029 (depth = 3)
  gc_frame_end(frame);
  return if6029;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6043(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6044 = gc_frame_new();
// call case 4: self request
  Object call6045 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6044);
// compiled member node returning call6045 (depth = 4)
  *var_n = call6045;
  if (call6045 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6046 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6047 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6046);
// compiled call node returning call6047 (depth = 4)
  *var_newChain = call6047;
  if (call6047 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6048 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6049 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6050 = gc_frame_new();
// call case 4: self request
  Object call6051 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6050);
// compiled member node returning call6051 (depth = 5)
  gc_frame_newslot(call6051);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6052 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6053 = gc_frame_new();
// call case 3: self.outer request
  Object call6054 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6053);
// compiled member node returning call6054 (depth = 6)
  Object call6055 = callmethodflags(call6054, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6052);
// compiled member node returning call6055 (depth = 5)
  params[0] = call6051;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6056 = callmethodflags(call6055, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6049);
// compiled call node returning call6056 (depth = 4)
  gc_frame_newslot(call6056);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6056;
  partcv[0] = 1;
  Object call6057 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6048);
// compiled call node returning call6057 (depth = 3)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6058 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6059 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6058);
// compiled call node returning call6059 (depth = 3)
  gc_frame_end(frame);
  return call6059;
}
Object meth_ast__apply_40_1_41_6068(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ai = &(stackframe->slots[0]);
  *var_ai = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6070 == NULL) {
    strlit6070 = alloc_String("  ");
    gc_root(strlit6070);
  }
// compiled string node returning strlit6070 (depth = 7)
  int op_slot_right_6069 = gc_frame_newslot(strlit6070);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6069 = gc_frame_newslot(*var_spc);
  params[0] = strlit6070;
  partcv[0] = 1;
  Object opresult6072 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6072 (depth = 6)
  *var_spc = opresult6072;
  if (opresult6072 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_6082(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6084 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6086 = alloc_Float64(1);
// compiled num node returning num6086 (depth = 9)
  int op_slot_right_6085 = gc_frame_newslot(num6086);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6085 = gc_frame_newslot(*var_depth);
  params[0] = num6086;
  partcv[0] = 1;
  Object sum6088 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6088 (depth = 8)
  gc_frame_newslot(sum6088);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ax (depth = 8)
  params[0] = sum6088;
  partcv[0] = 1;
  Object call6089 = callmethodflags(*var_ax, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6084);
// compiled call node returning call6089 (depth = 7)
  int op_slot_right_6083 = gc_frame_newslot(call6089);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6091 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6094 == NULL) {
    strlit6094 = alloc_String("""\x0a""");
    gc_root(strlit6094);
  }
// compiled string node returning strlit6094 (depth = 9)
  int op_slot_right_6093 = gc_frame_newslot(strlit6094);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6093 = gc_frame_newslot(*var_s);
  params[0] = strlit6094;
  partcv[0] = 1;
  Object opresult6096 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6096 (depth = 8)
  int op_slot_left_6091 = gc_frame_newslot(opresult6096);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6097 = callmethod(opresult6096, "++(1)", 1, partcv, params);
// compiled op node returning opresult6097 (depth = 7)
  int op_slot_left_6083 = gc_frame_newslot(opresult6097);
  params[0] = call6089;
  partcv[0] = 1;
  Object opresult6098 = callmethod(opresult6097, "++(1)", 1, partcv, params);
// compiled op node returning opresult6098 (depth = 6)
  *var_s = opresult6098;
  if (opresult6098 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6061 == NULL) {
    strlit6061 = alloc_String("");
    gc_root(strlit6061);
  }
// compiled string node returning strlit6061 (depth = 4)
  *var_spc = strlit6061;
  if (strlit6061 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6062 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6063 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6065 = alloc_Float64(0);
// compiled num node returning num6065 (depth = 5)
  int op_slot_left_6063 = gc_frame_newslot(num6065);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6066 = callmethod(num6065, "..(1)", 1, partcv, params);
// compiled op node returning opresult6066 (depth = 4)
  gc_frame_newslot(opresult6066);
// starting to compile block node (depth = 4)
  Object block6067 = alloc_Block(NULL, NULL, "ast", 1477);
  gc_frame_newslot(block6067);
// method "_apply(_)"
  block_savedest(block6067);
  Object closure6068 = createclosure(2, "_apply(1)");
  setclosureframe(closure6068, stackframe);
  addtoclosure(closure6068, var_spc);
  addtoclosure(closure6068, selfslot);
  struct UserObject *uo6068 = (struct UserObject*)block6067;
  uo6068->data[0] = (Object)closure6068;
  Method *meth_meth_ast__apply_40_1_41_6068 = addmethod2pos(block6067, "_apply(1)", &meth_ast__apply_40_1_41_6068, 0);
  int argcv_meth_ast__apply_40_1_41_6068[] = {1};
  meth_meth_ast__apply_40_1_41_6068->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6068);
  meth_meth_ast__apply_40_1_41_6068->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6068->definitionLine = 2969;
// compiled block node returning block6067 (depth = 4)
  gc_frame_newslot(block6067);
// call case 5: prelude request
  params[0] = opresult6066;
  params[1] = block6067;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6075 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6062);
// compiled call node returning call6075 (depth = 3)
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6076 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6077 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6076);
// compiled call node returning call6077 (depth = 4)
  *var_s = call6077;
  if (call6077 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6078 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6079 = gc_frame_new();
// call case 4: self request
  Object call6080 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6079);
// compiled member node returning call6080 (depth = 4)
  gc_frame_newslot(call6080);
// starting to compile block node (depth = 4)
  Object block6081 = alloc_Block(NULL, NULL, "ast", 1481);
  gc_frame_newslot(block6081);
// method "_apply(_)"
  block_savedest(block6081);
  Object closure6082 = createclosure(4, "_apply(1)");
  setclosureframe(closure6082, stackframe);
  addtoclosure(closure6082, var_depth);
  addtoclosure(closure6082, var_spc);
  addtoclosure(closure6082, var_s);
  addtoclosure(closure6082, selfslot);
  struct UserObject *uo6082 = (struct UserObject*)block6081;
  uo6082->data[0] = (Object)closure6082;
  Method *meth_meth_ast__apply_40_1_41_6082 = addmethod2pos(block6081, "_apply(1)", &meth_ast__apply_40_1_41_6082, 0);
  int argcv_meth_ast__apply_40_1_41_6082[] = {1};
  meth_meth_ast__apply_40_1_41_6082->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6082);
  meth_meth_ast__apply_40_1_41_6082->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6082->definitionLine = 2969;
// compiled block node returning block6081 (depth = 4)
  gc_frame_newslot(block6081);
// call case 5: prelude request
  params[0] = call6080;
  params[1] = block6081;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6101 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6078);
// compiled call node returning call6101 (depth = 3)
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_6110(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6112 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6113 = alloc_Float64(0);
// compiled num node returning num6113 (depth = 8)
  gc_frame_newslot(num6113);
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe6114 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6115 = gc_frame_new();
// call case 4: self request
  Object call6116 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6115);
// compiled member node returning call6116 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call6117 = callmethodflags(call6116, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6114);
// compiled call node returning call6117 (depth = 8)
  params[0] = num6113;
  partcv[0] = 1;
  Object call6118 = callmethodflags(call6117, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6112);
// compiled call node returning call6118 (depth = 7)
  int op_slot_right_6111 = gc_frame_newslot(call6118);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6111 = gc_frame_newslot(*var_s);
  params[0] = call6118;
  partcv[0] = 1;
  Object opresult6120 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6120 (depth = 6)
  *var_s = opresult6120;
  if (opresult6120 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6124 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6125 = gc_frame_new();
// call case 4: self request
  Object call6126 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6125);
// compiled member node returning call6126 (depth = 8)
  Object call6127 = callmethodflags(call6126, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6124);
// compiled member node returning call6127 (depth = 7)
  int op_slot_right_6123 = gc_frame_newslot(call6127);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_6123 = gc_frame_newslot(*var_i);
  params[0] = call6127;
  partcv[0] = 1;
  Object opresult6129 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult6129 (depth = 6)
  Object if6122 = done;
  if (istrue(opresult6129)) {
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6131 == NULL) {
    strlit6131 = alloc_String(", ");
    gc_root(strlit6131);
  }
// compiled string node returning strlit6131 (depth = 8)
  int op_slot_right_6130 = gc_frame_newslot(strlit6131);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6130 = gc_frame_newslot(*var_s);
  params[0] = strlit6131;
  partcv[0] = 1;
  Object opresult6133 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6133 (depth = 7)
  *var_s = opresult6133;
  if (opresult6133 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6122 = done;
  } else {
  }
// compiled if node returning if6122 (depth = 5)
  gc_frame_end(frame);
  return if6122;
}
Object meth_ast_toGrace_40_1_41_6102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6103 == NULL) {
    strlit6103 = alloc_String("[");
    gc_root(strlit6103);
  }
// compiled string node returning strlit6103 (depth = 4)
  *var_s = strlit6103;
  if (strlit6103 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6104 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6105 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6106 = gc_frame_new();
// call case 4: self request
  Object call6107 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6106);
// compiled member node returning call6107 (depth = 5)
  Object call6108 = callmethodflags(call6107, "indices", 0, partcv, params, 0);
  gc_frame_end(callframe6105);
// compiled member node returning call6108 (depth = 4)
  gc_frame_newslot(call6108);
// starting to compile block node (depth = 4)
  Object block6109 = alloc_Block(NULL, NULL, "ast", 1488);
  gc_frame_newslot(block6109);
// method "_apply(_)"
  block_savedest(block6109);
  Object closure6110 = createclosure(2, "_apply(1)");
  setclosureframe(closure6110, stackframe);
  addtoclosure(closure6110, var_s);
  addtoclosure(closure6110, selfslot);
  struct UserObject *uo6110 = (struct UserObject*)block6109;
  uo6110->data[0] = (Object)closure6110;
  Method *meth_meth_ast__apply_40_1_41_6110 = addmethod2pos(block6109, "_apply(1)", &meth_ast__apply_40_1_41_6110, 0);
  int argcv_meth_ast__apply_40_1_41_6110[] = {1};
  meth_meth_ast__apply_40_1_41_6110->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6110);
  meth_meth_ast__apply_40_1_41_6110->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6110->definitionLine = 2969;
// compiled block node returning block6109 (depth = 4)
  gc_frame_newslot(block6109);
// call case 5: prelude request
  params[0] = call6108;
  params[1] = block6109;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6136 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6104);
// compiled call node returning call6136 (depth = 3)
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6138 == NULL) {
    strlit6138 = alloc_String("]");
    gc_root(strlit6138);
  }
// compiled string node returning strlit6138 (depth = 5)
  int op_slot_right_6137 = gc_frame_newslot(strlit6138);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_6137 = gc_frame_newslot(*var_s);
  params[0] = strlit6138;
  partcv[0] = 1;
  Object opresult6140 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6140 (depth = 4)
  *var_s = opresult6140;
  if (opresult6140 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy6142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6143 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6144 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_arrayNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6145 = callmethodflags(*var_arrayNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6144);
// compiled call node returning call6145 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6146 = callmethodflags(call6145, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6143);
// compiled call node returning call6146 (depth = 3)
  gc_frame_end(frame);
  return call6146;
}
Object meth_ast_new_40_1_41_6023(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6024 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6024 = alloc_userobj2(8,8, objclass6024);
  gc_frame_newslot(obj6024);
if (objclass6024 == NULL) {
  glfree(obj6024->class->name);
  obj6024->class->name = "arrayNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6024, self, 0);
  addmethodreal(obj6024,"outer", &reader_ast_outer_6025);
  Object oldself6024 = self;
  struct StackFrameObject *oldstackframe6024 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6024);
  gc_frame_newslot((Object)stackframe);
  self = obj6024;
  Object *oldselfslot6024 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6024 = (*(struct UserObject *)self).data[0], lowerouter6024 = thisouter6024;
  if (inheritingObject6024) {
    struct UserObject *inho6024 = (struct UserObject *)inheritingObject6024;
    while (inho6024->super != GraceDefaultObject) inho6024 = (struct UserObject *)inho6024->super;
    inho6024->super = obj6024;
    self = inheritingObject6024;
    *selfslot = self;
    lowerouter6024 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6024;
  }
if (objclass6024 == NULL) {
  Method *reader6026 = addmethodrealflags(obj6024, "kind",&reader_ast_kind_6026, MFLAG_DEF);
  reader6026->definitionModule = modulename;
  reader6026->definitionLine = 1459;
}
adddatum2(obj6024, alloc_Undefined(), 1);
if (objclass6024 == NULL) {
  Method *reader6027 = addmethodrealflags(obj6024, "value", &reader_ast_value_6027, 0);
  Method *writer6027 = addmethodrealflags(obj6024, "value:=(1)", &writer_ast_value_6027, 0);
  reader6027->definitionModule = modulename;
  writer6027->definitionModule = modulename;
  reader6027->definitionLine = 1460;
  writer6027->definitionLine = 1460;
}
obj6024->flags |= OFLAG_MUTABLE;
adddatum2(obj6024, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo6028 = (struct UserObject*)obj6024;
  uo6028->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6028 = addmethod2pos(obj6024, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6028, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6028[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6028->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6028);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6028->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6028->definitionLine = 1461;
// method "map(_)ancestors(_)"
  struct UserObject *uo6043 = (struct UserObject*)obj6024;
  uo6043->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6043 = addmethod2pos(obj6024, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6043, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6043[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6043->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6043);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6043->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6043->definitionLine = 1469;
// method "pretty(_)"
  struct UserObject *uo6060 = (struct UserObject*)obj6024;
  uo6060->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6060 = addmethod2pos(obj6024, "pretty(1)", &meth_ast_pretty_40_1_41_6060, 5);
  int argcv_meth_ast_pretty_40_1_41_6060[] = {1};
  meth_meth_ast_pretty_40_1_41_6060->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6060);
  meth_meth_ast_pretty_40_1_41_6060->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6060->definitionLine = 1475;
// method "toGrace(_)"
  struct UserObject *uo6102 = (struct UserObject*)obj6024;
  uo6102->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6102 = addmethod2pos(obj6024, "toGrace(1)", &meth_ast_toGrace_40_1_41_6102, 6);
  int argcv_meth_ast_toGrace_40_1_41_6102[] = {1};
  meth_meth_ast_toGrace_40_1_41_6102->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6102);
meth_meth_ast_toGrace_40_1_41_6102->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6102->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6102->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6102->definitionLine = 1486;
// method "shallowCopy"
  block_savedest(obj6024);
  Object closure6142 = createclosure(2, "shallowCopy");
  setclosureframe(closure6142, stackframe);
  addtoclosure(closure6142, var_emptySeq);
  addtoclosure(closure6142, var_arrayNode);
  struct UserObject *uo6142 = (struct UserObject*)obj6024;
  uo6142->data[7] = (Object)closure6142;
  Method *meth_meth_ast_shallowCopy6142 = addmethod2pos(obj6024, "shallowCopy", &meth_ast_shallowCopy6142, 7);
  int argcv_meth_ast_shallowCopy6142[] = {0};
  meth_meth_ast_shallowCopy6142->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6142);
  meth_meth_ast_shallowCopy6142->definitionModule = modulename;
  meth_meth_ast_shallowCopy6142->definitionLine = 1497;
  sourceObject = obj6024;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6147 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6148 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6149 = gc_frame_new();
// call case 3: self.outer request
  Object call6150 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6149);
// compiled member node returning call6150 (depth = 5)
  Object call6151 = callmethodflags(call6150, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6148);
// compiled member node returning call6151 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6152 = callmethodflags(call6151, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6147);
// compiled call node returning call6152 (depth = 3)
  struct UserObject *obj6024_uo = (struct UserObject *)obj6024;
  obj6024_uo->super = call6152;
  sourceObject = obj6024;
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6153 == NULL) {
    strlit6153 = alloc_String("array");
    gc_root(strlit6153);
  }
// compiled string node returning strlit6153 (depth = 3)
  adddatum2(obj6024, strlit6153, 1);
  sourceObject = obj6024;
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj6024, *var_values, 2);
  sourceObject = obj6024;
  sourceObject = obj6024;
  sourceObject = obj6024;
  sourceObject = obj6024;
  sourceObject = obj6024;
  objclass6024 = obj6024->class;
  objclass6024->definitionModule = modulename;
  objclass6024->definitionLine = 1457;
  (*(struct UserObject *)self).data[0] = lowerouter6024;
  self = oldself6024;
  selfslot = oldselfslot6024;
  stackframe = oldstackframe6024;
  gc_frame_end(frame);
  return obj6024;
}
Object meth_ast_new_40_1_41_6023_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6024 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6024 = alloc_userobj2(8,8, objclass6024);
  gc_frame_newslot(obj6024);
if (objclass6024 == NULL) {
  glfree(obj6024->class->name);
  obj6024->class->name = "arrayNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6024, self, 0);
  addmethodreal(obj6024,"outer", &reader_ast_outer_6025);
  Object oldself6024 = self;
  struct StackFrameObject *oldstackframe6024 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6024);
  gc_frame_newslot((Object)stackframe);
  self = obj6024;
  Object *oldselfslot6024 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6024 = (*(struct UserObject *)self).data[0], lowerouter6024 = thisouter6024;
  if (inheritingObject6024) {
    struct UserObject *inho6024 = (struct UserObject *)inheritingObject6024;
    while (inho6024->super != GraceDefaultObject) inho6024 = (struct UserObject *)inho6024->super;
    inho6024->super = obj6024;
    self = inheritingObject6024;
    *selfslot = self;
    lowerouter6024 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6024;
  }
if (objclass6024 == NULL) {
  Method *reader6026 = addmethodrealflags(obj6024, "kind",&reader_ast_kind_6026, MFLAG_DEF);
  reader6026->definitionModule = modulename;
  reader6026->definitionLine = 1459;
}
adddatum2(obj6024, alloc_Undefined(), 1);
if (objclass6024 == NULL) {
  Method *reader6027 = addmethodrealflags(obj6024, "value", &reader_ast_value_6027, 0);
  Method *writer6027 = addmethodrealflags(obj6024, "value:=(1)", &writer_ast_value_6027, 0);
  reader6027->definitionModule = modulename;
  writer6027->definitionModule = modulename;
  reader6027->definitionLine = 1460;
  writer6027->definitionLine = 1460;
}
obj6024->flags |= OFLAG_MUTABLE;
adddatum2(obj6024, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo6028 = (struct UserObject*)obj6024;
  uo6028->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6028 = addmethod2pos(obj6024, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6028, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6028[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6028->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6028);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6028->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6028->definitionLine = 1461;
// method "map(_)ancestors(_)"
  struct UserObject *uo6043 = (struct UserObject*)obj6024;
  uo6043->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6043 = addmethod2pos(obj6024, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6043, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6043[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6043->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6043);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6043->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6043->definitionLine = 1469;
// method "pretty(_)"
  struct UserObject *uo6060 = (struct UserObject*)obj6024;
  uo6060->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6060 = addmethod2pos(obj6024, "pretty(1)", &meth_ast_pretty_40_1_41_6060, 5);
  int argcv_meth_ast_pretty_40_1_41_6060[] = {1};
  meth_meth_ast_pretty_40_1_41_6060->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6060);
  meth_meth_ast_pretty_40_1_41_6060->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6060->definitionLine = 1475;
// method "toGrace(_)"
  struct UserObject *uo6102 = (struct UserObject*)obj6024;
  uo6102->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6102 = addmethod2pos(obj6024, "toGrace(1)", &meth_ast_toGrace_40_1_41_6102, 6);
  int argcv_meth_ast_toGrace_40_1_41_6102[] = {1};
  meth_meth_ast_toGrace_40_1_41_6102->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6102);
meth_meth_ast_toGrace_40_1_41_6102->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6102->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6102->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6102->definitionLine = 1486;
// method "shallowCopy"
  block_savedest(obj6024);
  Object closure6142 = createclosure(2, "shallowCopy");
  setclosureframe(closure6142, stackframe);
  addtoclosure(closure6142, var_emptySeq);
  addtoclosure(closure6142, var_arrayNode);
  struct UserObject *uo6142 = (struct UserObject*)obj6024;
  uo6142->data[7] = (Object)closure6142;
  Method *meth_meth_ast_shallowCopy6142 = addmethod2pos(obj6024, "shallowCopy", &meth_ast_shallowCopy6142, 7);
  int argcv_meth_ast_shallowCopy6142[] = {0};
  meth_meth_ast_shallowCopy6142->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6142);
  meth_meth_ast_shallowCopy6142->definitionModule = modulename;
  meth_meth_ast_shallowCopy6142->definitionLine = 1497;
  sourceObject = obj6024;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6147 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6148 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6149 = gc_frame_new();
// call case 3: self.outer request
  Object call6150 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6149);
// compiled member node returning call6150 (depth = 5)
  Object call6151 = callmethodflags(call6150, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6148);
// compiled member node returning call6151 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6152 = callmethodflags(call6151, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6147);
// compiled call node returning call6152 (depth = 3)
  struct UserObject *obj6024_uo = (struct UserObject *)obj6024;
  obj6024_uo->super = call6152;
  sourceObject = obj6024;
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6153 == NULL) {
    strlit6153 = alloc_String("array");
    gc_root(strlit6153);
  }
// compiled string node returning strlit6153 (depth = 3)
  adddatum2(obj6024, strlit6153, 1);
  sourceObject = obj6024;
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj6024, *var_values, 2);
  sourceObject = obj6024;
  sourceObject = obj6024;
  sourceObject = obj6024;
  sourceObject = obj6024;
  sourceObject = obj6024;
  objclass6024 = obj6024->class;
  objclass6024->definitionModule = modulename;
  objclass6024->definitionLine = 1457;
  (*(struct UserObject *)self).data[0] = lowerouter6024;
  self = oldself6024;
  selfslot = oldselfslot6024;
  stackframe = oldstackframe6024;
  gc_frame_end(frame);
  return obj6024;
}
Object meth_ast_arrayNode6155(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arrayNode (depth = 3)
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast_new_40_2_41_scope_40_1_41_6158(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6159 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_request (depth = 5)
  gc_frame_newslot(*var_request);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// call case 4: self request
  params[0] = *var_request;
  params[1] = *var_receiver;
  partcv[0] = 2;
  Object call6160 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6159);
// compiled call node returning call6160 (depth = 4)
  *var_result = call6160;
  if (call6160 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6161 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6162 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6161);
// compiled call node returning call6162 (depth = 3)
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_onSelf6171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6172 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6173 = alloc_Boolean(1);
// compiled identifier node returning bool6173 (depth = 4)
  gc_frame_newslot(bool6173);
// call case 4: self request
  params[0] = bool6173;
  partcv[0] = 1;
  Object call6174 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6172);
// compiled call node returning call6174 (depth = 3)
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_nameString6175(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6176 = gc_frame_new();
// call case 4: self request
  Object call6177 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6176);
// compiled member node returning call6177 (depth = 3)
  gc_frame_end(frame);
  return call6177;
}
Object meth_ast_canonicalName6178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6179 = gc_frame_new();
// call case 4: self request
  Object call6180 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6179);
// compiled member node returning call6180 (depth = 3)
  gc_frame_end(frame);
  return call6180;
}
Object meth_ast_isMember6181(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6182 = alloc_Boolean(1);
// compiled identifier node returning bool6182 (depth = 3)
  gc_frame_end(frame);
  return bool6182;
}
Object meth_ast_isCall6183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6184 = alloc_Boolean(1);
// compiled identifier node returning bool6184 (depth = 3)
  gc_frame_end(frame);
  return bool6184;
}
Object meth_ast_with6185(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_arguments6186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arguments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_argumentsDo6187(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "argumentsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_6203(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe6204 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6205 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6204);
// compiled call node returning call6205 (depth = 7)
  gc_frame_end(frame);
  return call6205;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6188(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6190 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6191 = callmethodflags(*var_visitor, "visitMember(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6190);
// compiled call node returning call6191 (depth = 4)
  Object if6189 = done;
  if (istrue(call6191)) {
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6192 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6193 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6192);
// compiled call node returning call6193 (depth = 5)
  *var_newChain = call6193;
  if (call6193 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6196 = gc_frame_new();
// call case 4: self request
  Object call6197 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6196);
// compiled member node returning call6197 (depth = 6)
  int op_slot_right_6195 = gc_frame_newslot(call6197);
// starting to compile identifier node (depth = 6)
  Object bool6199 = alloc_Boolean(0);
// compiled identifier node returning bool6199 (depth = 6)
  int op_slot_left_6195 = gc_frame_newslot(bool6199);
  params[0] = call6197;
  partcv[0] = 1;
  Object opresult6200 = callmethod(bool6199, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6200 (depth = 5)
  Object if6194 = done;
  if (istrue(opresult6200)) {
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6201 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6202 = alloc_Block(NULL, NULL, "ast", 1534);
  gc_frame_newslot(block6202);
// method "_apply(_)"
  block_savedest(block6202);
  Object closure6203 = createclosure(3, "_apply(1)");
  setclosureframe(closure6203, stackframe);
  addtoclosure(closure6203, var_visitor);
  addtoclosure(closure6203, var_newChain);
  addtoclosure(closure6203, selfslot);
  struct UserObject *uo6203 = (struct UserObject*)block6202;
  uo6203->data[0] = (Object)closure6203;
  Method *meth_meth_ast__apply_40_1_41_6203 = addmethod2pos(block6202, "_apply(1)", &meth_ast__apply_40_1_41_6203, 0);
  int argcv_meth_ast__apply_40_1_41_6203[] = {1};
  meth_meth_ast__apply_40_1_41_6203->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6203);
  meth_meth_ast__apply_40_1_41_6203->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6203->definitionLine = 2969;
// compiled block node returning block6202 (depth = 6)
  gc_frame_newslot(block6202);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6207 = gc_frame_new();
// call case 4: self request
  Object call6208 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6207);
// compiled member node returning call6208 (depth = 6)
  params[0] = block6202;
  partcv[0] = 1;
  Object call6209 = callmethodflags(call6208, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6201);
// compiled call node returning call6209 (depth = 5)
    gc_frame_newslot(call6209);
    if6194 = call6209;
  } else {
  }
// compiled if node returning if6194 (depth = 4)
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6210 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6211 = gc_frame_new();
// call case 4: self request
  Object call6212 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6211);
// compiled member node returning call6212 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6213 = callmethodflags(call6212, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6210);
// compiled call node returning call6213 (depth = 4)
    gc_frame_newslot(call6213);
    if6189 = call6213;
  } else {
  }
// compiled if node returning if6189 (depth = 3)
  gc_frame_end(frame);
  return if6189;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6215 = gc_frame_new();
// call case 4: self request
  Object call6216 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6215);
// compiled member node returning call6216 (depth = 4)
  *var_n = call6216;
  if (call6216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6217 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6218 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6217);
// compiled call node returning call6218 (depth = 4)
  *var_newChain = call6218;
  if (call6218 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6219 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6220 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6221 = gc_frame_new();
// call case 4: self request
  Object call6222 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6221);
// compiled member node returning call6222 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6223 = callmethodflags(call6222, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6220);
// compiled call node returning call6223 (depth = 4)
  gc_frame_newslot(call6223);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6223;
  partcv[0] = 1;
  Object call6224 = callmethodflags(*var_n, "receiver:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6219);
// compiled call node returning call6224 (depth = 3)
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6225 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6226 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6227 = gc_frame_new();
// call case 4: self request
  Object call6228 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6227);
// compiled member node returning call6228 (depth = 5)
  gc_frame_newslot(call6228);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6229 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6230 = gc_frame_new();
// call case 3: self.outer request
  Object call6231 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6230);
// compiled member node returning call6231 (depth = 6)
  Object call6232 = callmethodflags(call6231, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6229);
// compiled member node returning call6232 (depth = 5)
  params[0] = call6228;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6233 = callmethodflags(call6232, "maybeListMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6226);
// compiled call node returning call6233 (depth = 4)
  gc_frame_newslot(call6233);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6233;
  partcv[0] = 1;
  Object call6234 = callmethodflags(*var_n, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6225);
// compiled call node returning call6234 (depth = 3)
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6235 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6236 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6235);
// compiled call node returning call6236 (depth = 3)
  gc_frame_end(frame);
  return call6236;
}
Object meth_ast__apply_40_1_41_6245(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6247 == NULL) {
    strlit6247 = alloc_String("  ");
    gc_root(strlit6247);
  }
// compiled string node returning strlit6247 (depth = 7)
  int op_slot_right_6246 = gc_frame_newslot(strlit6247);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6246 = gc_frame_newslot(*var_spc);
  params[0] = strlit6247;
  partcv[0] = 1;
  Object opresult6249 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6249 (depth = 6)
  *var_spc = opresult6249;
  if (opresult6249 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_6312(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6314 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num6315 = alloc_Float64(0);
// compiled num node returning num6315 (depth = 9)
  gc_frame_newslot(num6315);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = num6315;
  partcv[0] = 1;
  Object call6316 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6314);
// compiled call node returning call6316 (depth = 8)
  int op_slot_right_6313 = gc_frame_newslot(call6316);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6319 == NULL) {
    strlit6319 = alloc_String("    ");
    gc_root(strlit6319);
  }
// compiled string node returning strlit6319 (depth = 9)
  int op_slot_right_6318 = gc_frame_newslot(strlit6319);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_6321 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6324 == NULL) {
    strlit6324 = alloc_String("""\x0a""");
    gc_root(strlit6324);
  }
// compiled string node returning strlit6324 (depth = 11)
  int op_slot_right_6323 = gc_frame_newslot(strlit6324);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6323 = gc_frame_newslot(*var_s);
  params[0] = strlit6324;
  partcv[0] = 1;
  Object opresult6326 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6326 (depth = 10)
  int op_slot_left_6321 = gc_frame_newslot(opresult6326);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6327 = callmethod(opresult6326, "++(1)", 1, partcv, params);
// compiled op node returning opresult6327 (depth = 9)
  int op_slot_left_6318 = gc_frame_newslot(opresult6327);
  params[0] = strlit6319;
  partcv[0] = 1;
  Object opresult6328 = callmethod(opresult6327, "++(1)", 1, partcv, params);
// compiled op node returning opresult6328 (depth = 8)
  int op_slot_left_6313 = gc_frame_newslot(opresult6328);
  params[0] = call6316;
  partcv[0] = 1;
  Object opresult6329 = callmethod(opresult6328, "++(1)", 1, partcv, params);
// compiled op node returning opresult6329 (depth = 7)
  *var_s = opresult6329;
  if (opresult6329 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6237(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6238 == NULL) {
    strlit6238 = alloc_String("");
    gc_root(strlit6238);
  }
// compiled string node returning strlit6238 (depth = 4)
  *var_spc = strlit6238;
  if (strlit6238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6239 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6240 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6242 = alloc_Float64(0);
// compiled num node returning num6242 (depth = 5)
  int op_slot_left_6240 = gc_frame_newslot(num6242);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6243 = callmethod(num6242, "..(1)", 1, partcv, params);
// compiled op node returning opresult6243 (depth = 4)
  gc_frame_newslot(opresult6243);
// starting to compile block node (depth = 4)
  Object block6244 = alloc_Block(NULL, NULL, "ast", 1548);
  gc_frame_newslot(block6244);
// method "_apply(_)"
  block_savedest(block6244);
  Object closure6245 = createclosure(2, "_apply(1)");
  setclosureframe(closure6245, stackframe);
  addtoclosure(closure6245, var_spc);
  addtoclosure(closure6245, selfslot);
  struct UserObject *uo6245 = (struct UserObject*)block6244;
  uo6245->data[0] = (Object)closure6245;
  Method *meth_meth_ast__apply_40_1_41_6245 = addmethod2pos(block6244, "_apply(1)", &meth_ast__apply_40_1_41_6245, 0);
  int argcv_meth_ast__apply_40_1_41_6245[] = {1};
  meth_meth_ast__apply_40_1_41_6245->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6245);
  meth_meth_ast__apply_40_1_41_6245->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6245->definitionLine = 2969;
// compiled block node returning block6244 (depth = 4)
  gc_frame_newslot(block6244);
// call case 5: prelude request
  params[0] = opresult6243;
  params[1] = block6244;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6252 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6239);
// compiled call node returning call6252 (depth = 3)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6253 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6254 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6253);
// compiled call node returning call6254 (depth = 4)
  *var_s = call6254;
  if (call6254 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6257 = gc_frame_new();
// call case 4: self request
  Object call6258 = callmethodflags(self, "isSelfRequest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6257);
// compiled member node returning call6258 (depth = 6)
  Object if6256 = done;
struct StackFrameObject *iftmpstackframe6256 = stackframe;
  if (istrue(call6258)) {
stackframe = alloc_StackFrame(0, iftmpstackframe6256);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit6259 == NULL) {
    strlit6259 = alloc_String(" on self ");
    gc_root(strlit6259);
  }
// compiled string node returning strlit6259 (depth = 6)
    gc_frame_newslot(strlit6259);
    if6256 = strlit6259;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe6256);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit6260 == NULL) {
    strlit6260 = alloc_String(" ");
    gc_root(strlit6260);
  }
// compiled string node returning strlit6260 (depth = 6)
    gc_frame_newslot(strlit6260);
    if6256 = strlit6260;
  }
stackframe = iftmpstackframe6256;
// compiled if node returning if6256 (depth = 5)
  int op_slot_right_6255 = gc_frame_newslot(if6256);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_6255 = gc_frame_newslot(*var_s);
  params[0] = if6256;
  partcv[0] = 1;
  Object opresult6262 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6262 (depth = 4)
  *var_s = opresult6262;
  if (opresult6262 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6265 == NULL) {
    strlit6265 = alloc_String("""\xe2""""\x80""""\xba""""\x0a""");
    gc_root(strlit6265);
  }
// compiled string node returning strlit6265 (depth = 5)
  int op_slot_right_6264 = gc_frame_newslot(strlit6265);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6268 = gc_frame_new();
// call case 4: self request
  Object call6269 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6268);
// compiled member node returning call6269 (depth = 6)
  int op_slot_right_6267 = gc_frame_newslot(call6269);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6272 == NULL) {
    strlit6272 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6272);
  }
// compiled string node returning strlit6272 (depth = 7)
  int op_slot_right_6271 = gc_frame_newslot(strlit6272);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6271 = gc_frame_newslot(*var_s);
  params[0] = strlit6272;
  partcv[0] = 1;
  Object opresult6274 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6274 (depth = 6)
  int op_slot_left_6267 = gc_frame_newslot(opresult6274);
  params[0] = call6269;
  partcv[0] = 1;
  Object opresult6275 = callmethod(opresult6274, "++(1)", 1, partcv, params);
// compiled op node returning opresult6275 (depth = 5)
  int op_slot_left_6264 = gc_frame_newslot(opresult6275);
  params[0] = strlit6265;
  partcv[0] = 1;
  Object opresult6276 = callmethod(opresult6275, "++(1)", 1, partcv, params);
// compiled op node returning opresult6276 (depth = 4)
  *var_s = opresult6276;
  if (opresult6276 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6279 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6280 = gc_frame_new();
// call case 4: self request
  Object call6281 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6280);
// compiled member node returning call6281 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6282 = callmethodflags(call6281, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6279);
// compiled call node returning call6282 (depth = 5)
  int op_slot_right_6278 = gc_frame_newslot(call6282);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_6284 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6284 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6286 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6286 (depth = 5)
  int op_slot_left_6278 = gc_frame_newslot(opresult6286);
  params[0] = call6282;
  partcv[0] = 1;
  Object opresult6287 = callmethod(opresult6286, "++(1)", 1, partcv, params);
// compiled op node returning opresult6287 (depth = 4)
  *var_s = opresult6287;
  if (opresult6287 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6291 = gc_frame_new();
// call case 4: self request
  Object call6292 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6291);
// compiled member node returning call6292 (depth = 5)
  int op_slot_right_6290 = gc_frame_newslot(call6292);
// starting to compile identifier node (depth = 5)
  Object bool6294 = alloc_Boolean(0);
// compiled identifier node returning bool6294 (depth = 5)
  int op_slot_left_6290 = gc_frame_newslot(bool6294);
  params[0] = call6292;
  partcv[0] = 1;
  Object opresult6295 = callmethod(bool6294, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6295 (depth = 4)
  Object if6289 = done;
  if (istrue(opresult6295)) {
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6297 == NULL) {
    strlit6297 = alloc_String("  Generics:");
    gc_root(strlit6297);
  }
// compiled string node returning strlit6297 (depth = 6)
  int op_slot_right_6296 = gc_frame_newslot(strlit6297);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6299 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6302 == NULL) {
    strlit6302 = alloc_String("""\x0a""");
    gc_root(strlit6302);
  }
// compiled string node returning strlit6302 (depth = 8)
  int op_slot_right_6301 = gc_frame_newslot(strlit6302);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6301 = gc_frame_newslot(*var_s);
  params[0] = strlit6302;
  partcv[0] = 1;
  Object opresult6304 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6304 (depth = 7)
  int op_slot_left_6299 = gc_frame_newslot(opresult6304);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6305 = callmethod(opresult6304, "++(1)", 1, partcv, params);
// compiled op node returning opresult6305 (depth = 6)
  int op_slot_left_6296 = gc_frame_newslot(opresult6305);
  params[0] = strlit6297;
  partcv[0] = 1;
  Object opresult6306 = callmethod(opresult6305, "++(1)", 1, partcv, params);
// compiled op node returning opresult6306 (depth = 5)
  *var_s = opresult6306;
  if (opresult6306 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6308 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6309 = gc_frame_new();
// call case 4: self request
  Object call6310 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6309);
// compiled member node returning call6310 (depth = 5)
  gc_frame_newslot(call6310);
// starting to compile block node (depth = 5)
  Object block6311 = alloc_Block(NULL, NULL, "ast", 1557);
  gc_frame_newslot(block6311);
// method "_apply(_)"
  block_savedest(block6311);
  Object closure6312 = createclosure(3, "_apply(1)");
  setclosureframe(closure6312, stackframe);
  addtoclosure(closure6312, var_spc);
  addtoclosure(closure6312, var_s);
  addtoclosure(closure6312, selfslot);
  struct UserObject *uo6312 = (struct UserObject*)block6311;
  uo6312->data[0] = (Object)closure6312;
  Method *meth_meth_ast__apply_40_1_41_6312 = addmethod2pos(block6311, "_apply(1)", &meth_ast__apply_40_1_41_6312, 0);
  int argcv_meth_ast__apply_40_1_41_6312[] = {1};
  meth_meth_ast__apply_40_1_41_6312->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6312);
  meth_meth_ast__apply_40_1_41_6312->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6312->definitionLine = 2969;
// compiled block node returning block6311 (depth = 5)
  gc_frame_newslot(block6311);
// call case 5: prelude request
  params[0] = call6310;
  params[1] = block6311;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6332 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6308);
// compiled call node returning call6332 (depth = 4)
    gc_frame_newslot(call6332);
    if6289 = call6332;
  } else {
  }
// compiled if node returning if6289 (depth = 3)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_6409(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6411 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6413 = alloc_Float64(1);
// compiled num node returning num6413 (depth = 10)
  int op_slot_right_6412 = gc_frame_newslot(num6413);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6412 = gc_frame_newslot(*var_depth);
  params[0] = num6413;
  partcv[0] = 1;
  Object sum6415 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6415 (depth = 9)
  gc_frame_newslot(sum6415);
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe6416 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe6417 = gc_frame_new();
// call case 4: self request
  Object call6418 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6417);
// compiled member node returning call6418 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call6419 = callmethodflags(call6418, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6416);
// compiled call node returning call6419 (depth = 9)
  params[0] = sum6415;
  partcv[0] = 1;
  Object call6420 = callmethodflags(call6419, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6411);
// compiled call node returning call6420 (depth = 8)
  int op_slot_right_6410 = gc_frame_newslot(call6420);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6410 = gc_frame_newslot(*var_s);
  params[0] = call6420;
  partcv[0] = 1;
  Object opresult6422 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6422 (depth = 7)
  *var_s = opresult6422;
  if (opresult6422 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_6333(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6334 == NULL) {
    strlit6334 = alloc_String("");
    gc_root(strlit6334);
  }
// compiled string node returning strlit6334 (depth = 4)
  *var_s = strlit6334;
  if (strlit6334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6337 == NULL) {
    strlit6337 = alloc_String("prefix");
    gc_root(strlit6337);
  }
// compiled string node returning strlit6337 (depth = 5)
  int op_slot_right_6336 = gc_frame_newslot(strlit6337);
// starting to compile call node (depth = 5)
  int callframe6339 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6340 = alloc_Float64(1);
// compiled num node returning num6340 (depth = 6)
  gc_frame_newslot(num6340);
// starting to compile num node (depth = 6)
  Object num6341 = alloc_Float64(6);
// compiled num node returning num6341 (depth = 6)
  gc_frame_newslot(num6341);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6342 = gc_frame_new();
// call case 4: self request
  Object call6343 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6342);
// compiled member node returning call6343 (depth = 6)
  params[0] = num6340;
  params[1] = num6341;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6344 = callmethodflags(call6343, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6339);
// compiled call node returning call6344 (depth = 5)
  int op_slot_left_6336 = gc_frame_newslot(call6344);
  params[0] = strlit6337;
  partcv[0] = 1;
  Object opresult6345 = callmethod(call6344, "==(1)", 1, partcv, params);
// compiled op node returning opresult6345 (depth = 4)
  Object if6335 = done;
  if (istrue(opresult6345)) {
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6346 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6347 = alloc_Float64(7);
// compiled num node returning num6347 (depth = 6)
  gc_frame_newslot(num6347);
// starting to compile member node (depth = 6)
  int callframe6348 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6349 = gc_frame_new();
// call case 4: self request
  Object call6350 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6349);
// compiled member node returning call6350 (depth = 7)
  Object call6351 = callmethodflags(call6350, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6348);
// compiled member node returning call6351 (depth = 6)
  gc_frame_newslot(call6351);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6352 = gc_frame_new();
// call case 4: self request
  Object call6353 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6352);
// compiled member node returning call6353 (depth = 6)
  params[0] = num6347;
  params[1] = call6351;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6354 = callmethodflags(call6353, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6346);
// compiled call node returning call6354 (depth = 5)
  *var_s = call6354;
  if (call6354 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6357 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num6358 = alloc_Float64(0);
// compiled num node returning num6358 (depth = 7)
  gc_frame_newslot(num6358);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6359 = gc_frame_new();
// call case 4: self request
  Object call6360 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6359);
// compiled member node returning call6360 (depth = 7)
  params[0] = num6358;
  partcv[0] = 1;
  Object call6361 = callmethodflags(call6360, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6357);
// compiled call node returning call6361 (depth = 6)
  int op_slot_right_6356 = gc_frame_newslot(call6361);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6364 == NULL) {
    strlit6364 = alloc_String(" ");
    gc_root(strlit6364);
  }
// compiled string node returning strlit6364 (depth = 7)
  int op_slot_right_6363 = gc_frame_newslot(strlit6364);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6363 = gc_frame_newslot(*var_s);
  params[0] = strlit6364;
  partcv[0] = 1;
  Object opresult6366 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6366 (depth = 6)
  int op_slot_left_6356 = gc_frame_newslot(opresult6366);
  params[0] = call6361;
  partcv[0] = 1;
  Object opresult6367 = callmethod(opresult6366, "++(1)", 1, partcv, params);
// compiled op node returning opresult6367 (depth = 5)
  *var_s = opresult6367;
  if (opresult6367 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6335 = done;
  } else {
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6370 = gc_frame_new();
// call case 4: self request
  Object call6371 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6370);
// compiled member node returning call6371 (depth = 6)
  int op_slot_right_6369 = gc_frame_newslot(call6371);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6374 == NULL) {
    strlit6374 = alloc_String(".");
    gc_root(strlit6374);
  }
// compiled string node returning strlit6374 (depth = 7)
  int op_slot_right_6373 = gc_frame_newslot(strlit6374);
// starting to compile call node (depth = 7)
  int callframe6376 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6377 = gc_frame_new();
// call case 4: self request
  Object call6378 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6377);
// compiled member node returning call6378 (depth = 8)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6379 = callmethodflags(call6378, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6376);
// compiled call node returning call6379 (depth = 7)
  int op_slot_left_6373 = gc_frame_newslot(call6379);
  params[0] = strlit6374;
  partcv[0] = 1;
  Object opresult6380 = callmethod(call6379, "++(1)", 1, partcv, params);
// compiled op node returning opresult6380 (depth = 6)
  int op_slot_left_6369 = gc_frame_newslot(opresult6380);
  params[0] = call6371;
  partcv[0] = 1;
  Object opresult6381 = callmethod(opresult6380, "++(1)", 1, partcv, params);
// compiled op node returning opresult6381 (depth = 5)
  *var_s = opresult6381;
  if (opresult6381 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6335 = done;
  }
// compiled if node returning if6335 (depth = 3)
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6385 = gc_frame_new();
// call case 4: self request
  Object call6386 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6385);
// compiled member node returning call6386 (depth = 5)
  int op_slot_right_6384 = gc_frame_newslot(call6386);
// starting to compile identifier node (depth = 5)
  Object bool6388 = alloc_Boolean(0);
// compiled identifier node returning bool6388 (depth = 5)
  int op_slot_left_6384 = gc_frame_newslot(bool6388);
  params[0] = call6386;
  partcv[0] = 1;
  Object opresult6389 = callmethod(bool6388, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6389 (depth = 4)
  Object if6383 = done;
  if (istrue(opresult6389)) {
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6391 == NULL) {
    strlit6391 = alloc_String("<");
    gc_root(strlit6391);
  }
// compiled string node returning strlit6391 (depth = 6)
  int op_slot_right_6390 = gc_frame_newslot(strlit6391);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6390 = gc_frame_newslot(*var_s);
  params[0] = strlit6391;
  partcv[0] = 1;
  Object opresult6393 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6393 (depth = 5)
  *var_s = opresult6393;
  if (opresult6393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6395 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6398 = alloc_Float64(1);
// compiled num node returning num6398 (depth = 7)
  int op_slot_right_6397 = gc_frame_newslot(num6398);
// starting to compile member node (depth = 7)
  int callframe6400 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6401 = gc_frame_new();
// call case 4: self request
  Object call6402 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6401);
// compiled member node returning call6402 (depth = 8)
  Object call6403 = callmethodflags(call6402, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6400);
// compiled member node returning call6403 (depth = 7)
  int op_slot_left_6397 = gc_frame_newslot(call6403);
  params[0] = num6398;
  partcv[0] = 1;
  Object diff6404 = callmethod(call6403, "-(1)", 1, partcv, params);
// compiled op node returning diff6404 (depth = 6)
  int op_slot_right_6396 = gc_frame_newslot(diff6404);
// starting to compile num node (depth = 6)
  Object num6406 = alloc_Float64(1);
// compiled num node returning num6406 (depth = 6)
  int op_slot_left_6396 = gc_frame_newslot(num6406);
  params[0] = diff6404;
  partcv[0] = 1;
  Object opresult6407 = callmethod(num6406, "..(1)", 1, partcv, params);
// compiled op node returning opresult6407 (depth = 5)
  gc_frame_newslot(opresult6407);
// starting to compile block node (depth = 5)
  Object block6408 = alloc_Block(NULL, NULL, "ast", 1573);
  gc_frame_newslot(block6408);
// method "_apply(_)"
  block_savedest(block6408);
  Object closure6409 = createclosure(3, "_apply(1)");
  setclosureframe(closure6409, stackframe);
  addtoclosure(closure6409, var_depth);
  addtoclosure(closure6409, var_s);
  addtoclosure(closure6409, selfslot);
  struct UserObject *uo6409 = (struct UserObject*)block6408;
  uo6409->data[0] = (Object)closure6409;
  Method *meth_meth_ast__apply_40_1_41_6409 = addmethod2pos(block6408, "_apply(1)", &meth_ast__apply_40_1_41_6409, 0);
  int argcv_meth_ast__apply_40_1_41_6409[] = {1};
  meth_meth_ast__apply_40_1_41_6409->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6409);
  meth_meth_ast__apply_40_1_41_6409->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6409->definitionLine = 2969;
// compiled block node returning block6408 (depth = 5)
  gc_frame_newslot(block6408);
// call case 5: prelude request
  params[0] = opresult6407;
  params[1] = block6408;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6425 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6395);
// compiled call node returning call6425 (depth = 4)
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6427 == NULL) {
    strlit6427 = alloc_String(">");
    gc_root(strlit6427);
  }
// compiled string node returning strlit6427 (depth = 6)
  int op_slot_right_6426 = gc_frame_newslot(strlit6427);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6430 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6432 = alloc_Float64(1);
// compiled num node returning num6432 (depth = 9)
  int op_slot_right_6431 = gc_frame_newslot(num6432);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6431 = gc_frame_newslot(*var_depth);
  params[0] = num6432;
  partcv[0] = 1;
  Object sum6434 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6434 (depth = 8)
  gc_frame_newslot(sum6434);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6435 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6436 = gc_frame_new();
// call case 4: self request
  Object call6437 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6436);
// compiled member node returning call6437 (depth = 9)
  Object call6438 = callmethodflags(call6437, "last", 0, partcv, params, 0);
  gc_frame_end(callframe6435);
// compiled member node returning call6438 (depth = 8)
  params[0] = sum6434;
  partcv[0] = 1;
  Object call6439 = callmethodflags(call6438, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6430);
// compiled call node returning call6439 (depth = 7)
  int op_slot_right_6429 = gc_frame_newslot(call6439);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6429 = gc_frame_newslot(*var_s);
  params[0] = call6439;
  partcv[0] = 1;
  Object opresult6441 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6441 (depth = 6)
  int op_slot_left_6426 = gc_frame_newslot(opresult6441);
  params[0] = strlit6427;
  partcv[0] = 1;
  Object opresult6442 = callmethod(opresult6441, "++(1)", 1, partcv, params);
// compiled op node returning opresult6442 (depth = 5)
  *var_s = opresult6442;
  if (opresult6442 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6383 = done;
  } else {
  }
// compiled if node returning if6383 (depth = 3)
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString6444(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6446 == NULL) {
    strlit6446 = alloc_String("");
    gc_root(strlit6446);
  }
// compiled string node returning strlit6446 (depth = 4)
  int op_slot_right_6445 = gc_frame_newslot(strlit6446);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6449 = gc_frame_new();
// call case 4: self request
  Object call6450 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6449);
// compiled member node returning call6450 (depth = 5)
  int op_slot_right_6448 = gc_frame_newslot(call6450);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6453 == NULL) {
    strlit6453 = alloc_String(".");
    gc_root(strlit6453);
  }
// compiled string node returning strlit6453 (depth = 6)
  int op_slot_right_6452 = gc_frame_newslot(strlit6453);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6456 = gc_frame_new();
// call case 4: self request
  Object call6457 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6456);
// compiled member node returning call6457 (depth = 7)
  int op_slot_right_6455 = gc_frame_newslot(call6457);
// starting to compile string node (depth = 7)
  if (strlit6459 == NULL) {
    strlit6459 = alloc_String("");
    gc_root(strlit6459);
  }
// compiled string node returning strlit6459 (depth = 7)
  int op_slot_left_6455 = gc_frame_newslot(strlit6459);
  params[0] = call6457;
  partcv[0] = 1;
  Object opresult6460 = callmethod(strlit6459, "++(1)", 1, partcv, params);
// compiled op node returning opresult6460 (depth = 6)
  int op_slot_left_6452 = gc_frame_newslot(opresult6460);
  params[0] = strlit6453;
  partcv[0] = 1;
  Object opresult6461 = callmethod(opresult6460, "++(1)", 1, partcv, params);
// compiled op node returning opresult6461 (depth = 5)
  int op_slot_left_6448 = gc_frame_newslot(opresult6461);
  params[0] = call6450;
  partcv[0] = 1;
  Object opresult6462 = callmethod(opresult6461, "++(1)", 1, partcv, params);
// compiled op node returning opresult6462 (depth = 4)
  int op_slot_left_6445 = gc_frame_newslot(opresult6462);
  params[0] = strlit6446;
  partcv[0] = 1;
  Object opresult6463 = callmethod(opresult6462, "++(1)", 1, partcv, params);
// compiled op node returning opresult6463 (depth = 3)
  gc_frame_end(frame);
  return opresult6463;
}
Object meth_ast_asIdentifier6464(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6467 = gc_frame_new();
// call case 4: self request
  Object call6468 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6467);
// compiled member node returning call6468 (depth = 5)
  int op_slot_right_6466 = gc_frame_newslot(call6468);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_fakeSymbolTable (depth = 5)
  int op_slot_left_6466 = gc_frame_newslot(*var_fakeSymbolTable);
  params[0] = call6468;
  partcv[0] = 1;
  Object opresult6470 = callmethod(*var_fakeSymbolTable, "==(1)", 1, partcv, params);
// compiled op node returning opresult6470 (depth = 4)
  Object if6465 = done;
  if (istrue(opresult6470)) {
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6471 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6473 == NULL) {
    strlit6473 = alloc_String(" when scope was fake");
    gc_root(strlit6473);
  }
// compiled string node returning strlit6473 (depth = 6)
  int op_slot_right_6472 = gc_frame_newslot(strlit6473);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6476 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6477 = alloc_Float64(0);
// compiled num node returning num6477 (depth = 8)
  gc_frame_newslot(num6477);
// call case 4: self request
  params[0] = num6477;
  partcv[0] = 1;
  Object call6478 = callmethodflags(self, "pretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6476);
// compiled call node returning call6478 (depth = 7)
  int op_slot_right_6475 = gc_frame_newslot(call6478);
// starting to compile string node (depth = 7)
  if (strlit6480 == NULL) {
    strlit6480 = alloc_String("asIdentifier requested on ");
    gc_root(strlit6480);
  }
// compiled string node returning strlit6480 (depth = 7)
  int op_slot_left_6475 = gc_frame_newslot(strlit6480);
  params[0] = call6478;
  partcv[0] = 1;
  Object opresult6481 = callmethod(strlit6480, "++(1)", 1, partcv, params);
// compiled op node returning opresult6481 (depth = 6)
  int op_slot_left_6472 = gc_frame_newslot(opresult6481);
  params[0] = strlit6473;
  partcv[0] = 1;
  Object opresult6482 = callmethod(opresult6481, "++(1)", 1, partcv, params);
// compiled op node returning opresult6482 (depth = 5)
  gc_frame_newslot(opresult6482);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6483 = gc_frame_new();
// call case 5: prelude request
  Object call6484 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6483);
// compiled member node returning call6484 (depth = 5)
  params[0] = opresult6482;
  partcv[0] = 1;
  Object call6485 = callmethodflags(call6484, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6471);
// compiled call node returning call6485 (depth = 4)
    gc_frame_newslot(call6485);
    if6465 = call6485;
  } else {
  }
// compiled if node returning if6465 (depth = 3)
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6486 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6487 = gc_frame_new();
// call case 4: self request
  Object call6488 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6487);
// compiled member node returning call6488 (depth = 5)
  gc_frame_newslot(call6488);
// starting to compile identifier node (depth = 5)
  Object bool6489 = alloc_Boolean(0);
// compiled identifier node returning bool6489 (depth = 5)
  gc_frame_newslot(bool6489);
// starting to compile member node (depth = 5)
  int callframe6490 = gc_frame_new();
// call case 4: self request
  Object call6491 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6490);
// compiled member node returning call6491 (depth = 5)
  gc_frame_newslot(call6491);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call6488;
  params[1] = bool6489;
  params[2] = call6491;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6492 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6486);
// compiled call node returning call6492 (depth = 4)
  *var_resultNode = call6492;
  if (call6492 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6493 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6494 = alloc_Boolean(1);
// compiled identifier node returning bool6494 (depth = 4)
  gc_frame_newslot(bool6494);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool6494;
  partcv[0] = 1;
  Object call6495 = callmethodflags(*var_resultNode, "inRequest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6493);
// compiled call node returning call6495 (depth = 3)
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6496 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6497 = gc_frame_new();
// call case 4: self request
  Object call6498 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6497);
// compiled member node returning call6498 (depth = 4)
  gc_frame_newslot(call6498);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call6498;
  partcv[0] = 1;
  Object call6499 = callmethodflags(*var_resultNode, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6496);
// compiled call node returning call6499 (depth = 3)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6500 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6501 = gc_frame_new();
// call case 4: self request
  Object call6502 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6501);
// compiled member node returning call6502 (depth = 4)
  gc_frame_newslot(call6502);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call6502;
  partcv[0] = 1;
  Object call6503 = callmethodflags(*var_resultNode, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6500);
// compiled call node returning call6503 (depth = 3)
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy6504(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6505 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6506 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6507 = gc_frame_new();
// call case 4: self request
  Object call6508 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6507);
// compiled member node returning call6508 (depth = 5)
  gc_frame_newslot(call6508);
// starting to compile member node (depth = 5)
  int callframe6509 = gc_frame_new();
// call case 4: self request
  Object call6510 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6509);
// compiled member node returning call6510 (depth = 5)
  gc_frame_newslot(call6510);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_memberNode (depth = 5)
  params[0] = call6508;
  params[1] = call6510;
  partcv[0] = 2;
  Object call6511 = callmethodflags(*var_memberNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6506);
// compiled call node returning call6511 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6512 = callmethodflags(call6511, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6505);
// compiled call node returning call6512 (depth = 3)
  gc_frame_end(frame);
  return call6512;
}
Object meth_ast_statementName6513(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6514 == NULL) {
    strlit6514 = alloc_String("expression");
    gc_root(strlit6514);
  }
// compiled string node returning strlit6514 (depth = 3)
  gc_frame_end(frame);
  return strlit6514;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_6515(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6516 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6517 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6516);
// compiled call node returning call6517 (depth = 3)
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6518 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6519 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call6520 = callmethodflags(*var_other, "generics", 0, partcv, params, 0);
  gc_frame_end(callframe6519);
// compiled member node returning call6520 (depth = 4)
  gc_frame_newslot(call6520);
// call case 4: self request
  params[0] = call6520;
  partcv[0] = 1;
  Object call6521 = callmethodflags(self, "generics:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6518);
// compiled call node returning call6521 (depth = 3)
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6522 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6523 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call6524 = callmethodflags(*var_other, "isSelfRequest", 0, partcv, params, 0);
  gc_frame_end(callframe6523);
// compiled member node returning call6524 (depth = 4)
  gc_frame_newslot(call6524);
// call case 4: self request
  params[0] = call6524;
  partcv[0] = 1;
  Object call6525 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6522);
// compiled call node returning call6525 (depth = 3)
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_2_41_6163(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_fakeSymbolTable = getfromclosure(closure, 1);
  Object *var_identifierNode = getfromclosure(closure, 2);
  Object *var_memberNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver_39_ = &(stackframe->slots[1]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6164 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6164 = alloc_userobj2(26,23, objclass6164);
  gc_frame_newslot(obj6164);
if (objclass6164 == NULL) {
  glfree(obj6164->class->name);
  obj6164->class->name = "memberNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6164, self, 0);
  addmethodreal(obj6164,"outer", &reader_ast_outer_6165);
  Object oldself6164 = self;
  struct StackFrameObject *oldstackframe6164 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6164);
  gc_frame_newslot((Object)stackframe);
  self = obj6164;
  Object *oldselfslot6164 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6164 = (*(struct UserObject *)self).data[0], lowerouter6164 = thisouter6164;
  if (inheritingObject6164) {
    struct UserObject *inho6164 = (struct UserObject *)inheritingObject6164;
    while (inho6164->super != GraceDefaultObject) inho6164 = (struct UserObject *)inho6164->super;
    inho6164->super = obj6164;
    self = inheritingObject6164;
    *selfslot = self;
    lowerouter6164 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6164;
  }
if (objclass6164 == NULL) {
  Method *reader6166 = addmethodrealflags(obj6164, "kind",&reader_ast_kind_6166, MFLAG_DEF);
  reader6166->definitionModule = modulename;
  reader6166->definitionLine = 1512;
}
adddatum2(obj6164, alloc_Undefined(), 1);
if (objclass6164 == NULL) {
  Method *reader6167 = addmethodrealflags(obj6164, "value", &reader_ast_value_6167, 0);
  Method *writer6167 = addmethodrealflags(obj6164, "value:=(1)", &writer_ast_value_6167, 0);
  reader6167->definitionModule = modulename;
  writer6167->definitionModule = modulename;
  reader6167->definitionLine = 1513;
  writer6167->definitionLine = 1513;
}
obj6164->flags |= OFLAG_MUTABLE;
adddatum2(obj6164, alloc_Undefined(), 2);
if (objclass6164 == NULL) {
  Method *reader6168 = addmethodrealflags(obj6164, "receiver", &reader_ast_receiver_6168, 0);
  Method *writer6168 = addmethodrealflags(obj6164, "receiver:=(1)", &writer_ast_receiver_6168, 0);
  reader6168->definitionModule = modulename;
  writer6168->definitionModule = modulename;
  reader6168->definitionLine = 1514;
  writer6168->definitionLine = 1514;
}
obj6164->flags |= OFLAG_MUTABLE;
adddatum2(obj6164, alloc_Undefined(), 3);
if (objclass6164 == NULL) {
  Method *reader6169 = addmethodrealflags(obj6164, "generics", &reader_ast_generics_6169, 0);
  Method *writer6169 = addmethodrealflags(obj6164, "generics:=(1)", &writer_ast_generics_6169, 0);
  reader6169->definitionModule = modulename;
  writer6169->definitionModule = modulename;
  reader6169->definitionLine = 1515;
  writer6169->definitionLine = 1515;
}
obj6164->flags |= OFLAG_MUTABLE;
adddatum2(obj6164, alloc_Undefined(), 4);
if (objclass6164 == NULL) {
  Method *reader6170 = addmethodrealflags(obj6164, "isSelfRequest", &reader_ast_isSelfRequest_6170, 0);
  Method *writer6170 = addmethodrealflags(obj6164, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_6170, 0);
  reader6170->definitionModule = modulename;
  writer6170->definitionModule = modulename;
  reader6170->definitionLine = 1516;
  writer6170->definitionLine = 1516;
}
obj6164->flags |= OFLAG_MUTABLE;
adddatum2(obj6164, alloc_Undefined(), 5);
// method "onSelf"
  struct UserObject *uo6171 = (struct UserObject*)obj6164;
  uo6171->data[6] = emptyclosure;
  Method *meth_meth_ast_onSelf6171 = addmethod2pos(obj6164, "onSelf", &meth_ast_onSelf6171, 6);
  int argcv_meth_ast_onSelf6171[] = {0};
  meth_meth_ast_onSelf6171->type = alloc_MethodType(1, argcv_meth_ast_onSelf6171);
  meth_meth_ast_onSelf6171->definitionModule = modulename;
  meth_meth_ast_onSelf6171->definitionLine = 1518;
// method "nameString"
  struct UserObject *uo6175 = (struct UserObject*)obj6164;
  uo6175->data[7] = emptyclosure;
  Method *meth_meth_ast_nameString6175 = addmethod2pos(obj6164, "nameString", &meth_ast_nameString6175, 7);
  int argcv_meth_ast_nameString6175[] = {0};
  meth_meth_ast_nameString6175->type = alloc_MethodType(1, argcv_meth_ast_nameString6175);
  meth_meth_ast_nameString6175->definitionModule = modulename;
  meth_meth_ast_nameString6175->definitionLine = 1522;
// method "canonicalName"
  struct UserObject *uo6178 = (struct UserObject*)obj6164;
  uo6178->data[8] = emptyclosure;
  Method *meth_meth_ast_canonicalName6178 = addmethod2pos(obj6164, "canonicalName", &meth_ast_canonicalName6178, 8);
  int argcv_meth_ast_canonicalName6178[] = {0};
  meth_meth_ast_canonicalName6178->type = alloc_MethodType(1, argcv_meth_ast_canonicalName6178);
  meth_meth_ast_canonicalName6178->definitionModule = modulename;
  meth_meth_ast_canonicalName6178->definitionLine = 1523;
// method "isMember"
  struct UserObject *uo6181 = (struct UserObject*)obj6164;
  uo6181->data[9] = emptyclosure;
  Method *meth_meth_ast_isMember6181 = addmethod2pos(obj6164, "isMember", &meth_ast_isMember6181, 9);
  int argcv_meth_ast_isMember6181[] = {0};
  meth_meth_ast_isMember6181->type = alloc_MethodType(1, argcv_meth_ast_isMember6181);
  meth_meth_ast_isMember6181->definitionModule = modulename;
  meth_meth_ast_isMember6181->definitionLine = 1524;
// method "isCall"
  struct UserObject *uo6183 = (struct UserObject*)obj6164;
  uo6183->data[10] = emptyclosure;
  Method *meth_meth_ast_isCall6183 = addmethod2pos(obj6164, "isCall", &meth_ast_isCall6183, 10);
  int argcv_meth_ast_isCall6183[] = {0};
  meth_meth_ast_isCall6183->type = alloc_MethodType(1, argcv_meth_ast_isCall6183);
  meth_meth_ast_isCall6183->definitionModule = modulename;
  meth_meth_ast_isCall6183->definitionLine = 1525;
// method "with"
  block_savedest(obj6164);
  Object closure6185 = createclosure(1, "with");
  setclosureframe(closure6185, stackframe);
  addtoclosure(closure6185, var_emptySeq);
  struct UserObject *uo6185 = (struct UserObject*)obj6164;
  uo6185->data[11] = (Object)closure6185;
  Method *meth_meth_ast_with6185 = addmethod2pos(obj6164, "with", &meth_ast_with6185, 11);
  int argcv_meth_ast_with6185[] = {0};
  meth_meth_ast_with6185->type = alloc_MethodType(1, argcv_meth_ast_with6185);
  meth_meth_ast_with6185->definitionModule = modulename;
  meth_meth_ast_with6185->definitionLine = 1527;
// method "arguments"
  block_savedest(obj6164);
  Object closure6186 = createclosure(1, "arguments");
  setclosureframe(closure6186, stackframe);
  addtoclosure(closure6186, var_emptySeq);
  struct UserObject *uo6186 = (struct UserObject*)obj6164;
  uo6186->data[12] = (Object)closure6186;
  Method *meth_meth_ast_arguments6186 = addmethod2pos(obj6164, "arguments", &meth_ast_arguments6186, 12);
  int argcv_meth_ast_arguments6186[] = {0};
  meth_meth_ast_arguments6186->type = alloc_MethodType(1, argcv_meth_ast_arguments6186);
  meth_meth_ast_arguments6186->definitionModule = modulename;
  meth_meth_ast_arguments6186->definitionLine = 1528;
// method "argumentsDo"
  struct UserObject *uo6187 = (struct UserObject*)obj6164;
  uo6187->data[13] = emptyclosure;
  Method *meth_meth_ast_argumentsDo6187 = addmethod2pos(obj6164, "argumentsDo", &meth_ast_argumentsDo6187, 13);
  int argcv_meth_ast_argumentsDo6187[] = {0};
  meth_meth_ast_argumentsDo6187->type = alloc_MethodType(1, argcv_meth_ast_argumentsDo6187);
  meth_meth_ast_argumentsDo6187->definitionModule = modulename;
  meth_meth_ast_argumentsDo6187->definitionLine = 1529;
// method "accept(_)from(_)"
  struct UserObject *uo6188 = (struct UserObject*)obj6164;
  uo6188->data[14] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6188 = addmethod2pos(obj6164, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6188, 14);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6188[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6188->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6188);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6188->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6188->definitionLine = 1530;
// method "map(_)ancestors(_)"
  struct UserObject *uo6214 = (struct UserObject*)obj6164;
  uo6214->data[15] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6214 = addmethod2pos(obj6164, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6214, 15);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6214[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6214->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6214);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6214->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6214->definitionLine = 1539;
// method "pretty(_)"
  struct UserObject *uo6237 = (struct UserObject*)obj6164;
  uo6237->data[16] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6237 = addmethod2pos(obj6164, "pretty(1)", &meth_ast_pretty_40_1_41_6237, 16);
  int argcv_meth_ast_pretty_40_1_41_6237[] = {1};
  meth_meth_ast_pretty_40_1_41_6237->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6237);
  meth_meth_ast_pretty_40_1_41_6237->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6237->definitionLine = 1546;
// method "toGrace(_)"
  struct UserObject *uo6333 = (struct UserObject*)obj6164;
  uo6333->data[17] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6333 = addmethod2pos(obj6164, "toGrace(1)", &meth_ast_toGrace_40_1_41_6333, 17);
  int argcv_meth_ast_toGrace_40_1_41_6333[] = {1};
  meth_meth_ast_toGrace_40_1_41_6333->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6333);
meth_meth_ast_toGrace_40_1_41_6333->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6333->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6333->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6333->definitionLine = 1563;
// method "asString"
  struct UserObject *uo6444 = (struct UserObject*)obj6164;
  uo6444->data[18] = emptyclosure;
  Method *meth_meth_ast_asString6444 = addmethod2pos(obj6164, "asString", &meth_ast_asString6444, 18);
  int argcv_meth_ast_asString6444[] = {0};
  meth_meth_ast_asString6444->type = alloc_MethodType(1, argcv_meth_ast_asString6444);
  meth_meth_ast_asString6444->definitionModule = modulename;
  meth_meth_ast_asString6444->definitionLine = 1580;
// method "asIdentifier"
  block_savedest(obj6164);
  Object closure6464 = createclosure(2, "asIdentifier");
  setclosureframe(closure6464, stackframe);
  addtoclosure(closure6464, var_fakeSymbolTable);
  addtoclosure(closure6464, var_identifierNode);
  struct UserObject *uo6464 = (struct UserObject*)obj6164;
  uo6464->data[19] = (Object)closure6464;
  Method *meth_meth_ast_asIdentifier6464 = addmethod2pos(obj6164, "asIdentifier", &meth_ast_asIdentifier6464, 19);
  int argcv_meth_ast_asIdentifier6464[] = {0};
  meth_meth_ast_asIdentifier6464->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6464);
  meth_meth_ast_asIdentifier6464->definitionModule = modulename;
  meth_meth_ast_asIdentifier6464->definitionLine = 1581;
// method "shallowCopy"
  block_savedest(obj6164);
  Object closure6504 = createclosure(1, "shallowCopy");
  setclosureframe(closure6504, stackframe);
  addtoclosure(closure6504, var_memberNode);
  struct UserObject *uo6504 = (struct UserObject*)obj6164;
  uo6504->data[20] = (Object)closure6504;
  Method *meth_meth_ast_shallowCopy6504 = addmethod2pos(obj6164, "shallowCopy", &meth_ast_shallowCopy6504, 20);
  int argcv_meth_ast_shallowCopy6504[] = {0};
  meth_meth_ast_shallowCopy6504->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6504);
  meth_meth_ast_shallowCopy6504->definitionModule = modulename;
  meth_meth_ast_shallowCopy6504->definitionLine = 1592;
// method "statementName"
  struct UserObject *uo6513 = (struct UserObject*)obj6164;
  uo6513->data[21] = emptyclosure;
  Method *meth_meth_ast_statementName6513 = addmethod2pos(obj6164, "statementName", &meth_ast_statementName6513, 21);
  int argcv_meth_ast_statementName6513[] = {0};
  meth_meth_ast_statementName6513->type = alloc_MethodType(1, argcv_meth_ast_statementName6513);
  meth_meth_ast_statementName6513->definitionModule = modulename;
  meth_meth_ast_statementName6513->definitionLine = 1595;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo6515 = (struct UserObject*)obj6164;
  uo6515->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6515 = addmethod2pos(obj6164, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_6515, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_6515[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6515->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_6515);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6515->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6515->definitionLine = 1596;
  sourceObject = obj6164;
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6526 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6527 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6528 = gc_frame_new();
// call case 3: self.outer request
  Object call6529 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6528);
// compiled member node returning call6529 (depth = 5)
  Object call6530 = callmethodflags(call6529, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6527);
// compiled member node returning call6530 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6531 = callmethodflags(call6530, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6526);
// compiled call node returning call6531 (depth = 3)
  struct UserObject *obj6164_uo = (struct UserObject *)obj6164;
  obj6164_uo->super = call6531;
  sourceObject = obj6164;
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6532 == NULL) {
    strlit6532 = alloc_String("member");
    gc_root(strlit6532);
  }
// compiled string node returning strlit6532 (depth = 3)
  adddatum2(obj6164, strlit6532, 1);
  sourceObject = obj6164;
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6164, *var_request, 2);
  sourceObject = obj6164;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj6164, *var_receiver_39_, 3);
  sourceObject = obj6164;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6533 = alloc_Boolean(0);
// compiled identifier node returning bool6533 (depth = 3)
  adddatum2(obj6164, bool6533, 4);
  sourceObject = obj6164;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6534 = alloc_Boolean(0);
// compiled identifier node returning bool6534 (depth = 3)
  adddatum2(obj6164, bool6534, 5);
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  objclass6164 = obj6164->class;
  objclass6164->definitionModule = modulename;
  objclass6164->definitionLine = 1509;
  (*(struct UserObject *)self).data[0] = lowerouter6164;
  self = oldself6164;
  selfslot = oldselfslot6164;
  stackframe = oldstackframe6164;
  gc_frame_end(frame);
  return obj6164;
}
Object meth_ast_new_40_2_41_6163_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_fakeSymbolTable = getfromclosure(closure, 1);
  Object *var_identifierNode = getfromclosure(closure, 2);
  Object *var_memberNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver_39_ = &(stackframe->slots[1]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6164 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6164 = alloc_userobj2(26,23, objclass6164);
  gc_frame_newslot(obj6164);
if (objclass6164 == NULL) {
  glfree(obj6164->class->name);
  obj6164->class->name = "memberNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6164, self, 0);
  addmethodreal(obj6164,"outer", &reader_ast_outer_6165);
  Object oldself6164 = self;
  struct StackFrameObject *oldstackframe6164 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6164);
  gc_frame_newslot((Object)stackframe);
  self = obj6164;
  Object *oldselfslot6164 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6164 = (*(struct UserObject *)self).data[0], lowerouter6164 = thisouter6164;
  if (inheritingObject6164) {
    struct UserObject *inho6164 = (struct UserObject *)inheritingObject6164;
    while (inho6164->super != GraceDefaultObject) inho6164 = (struct UserObject *)inho6164->super;
    inho6164->super = obj6164;
    self = inheritingObject6164;
    *selfslot = self;
    lowerouter6164 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6164;
  }
if (objclass6164 == NULL) {
  Method *reader6166 = addmethodrealflags(obj6164, "kind",&reader_ast_kind_6166, MFLAG_DEF);
  reader6166->definitionModule = modulename;
  reader6166->definitionLine = 1512;
}
adddatum2(obj6164, alloc_Undefined(), 1);
if (objclass6164 == NULL) {
  Method *reader6167 = addmethodrealflags(obj6164, "value", &reader_ast_value_6167, 0);
  Method *writer6167 = addmethodrealflags(obj6164, "value:=(1)", &writer_ast_value_6167, 0);
  reader6167->definitionModule = modulename;
  writer6167->definitionModule = modulename;
  reader6167->definitionLine = 1513;
  writer6167->definitionLine = 1513;
}
obj6164->flags |= OFLAG_MUTABLE;
adddatum2(obj6164, alloc_Undefined(), 2);
if (objclass6164 == NULL) {
  Method *reader6168 = addmethodrealflags(obj6164, "receiver", &reader_ast_receiver_6168, 0);
  Method *writer6168 = addmethodrealflags(obj6164, "receiver:=(1)", &writer_ast_receiver_6168, 0);
  reader6168->definitionModule = modulename;
  writer6168->definitionModule = modulename;
  reader6168->definitionLine = 1514;
  writer6168->definitionLine = 1514;
}
obj6164->flags |= OFLAG_MUTABLE;
adddatum2(obj6164, alloc_Undefined(), 3);
if (objclass6164 == NULL) {
  Method *reader6169 = addmethodrealflags(obj6164, "generics", &reader_ast_generics_6169, 0);
  Method *writer6169 = addmethodrealflags(obj6164, "generics:=(1)", &writer_ast_generics_6169, 0);
  reader6169->definitionModule = modulename;
  writer6169->definitionModule = modulename;
  reader6169->definitionLine = 1515;
  writer6169->definitionLine = 1515;
}
obj6164->flags |= OFLAG_MUTABLE;
adddatum2(obj6164, alloc_Undefined(), 4);
if (objclass6164 == NULL) {
  Method *reader6170 = addmethodrealflags(obj6164, "isSelfRequest", &reader_ast_isSelfRequest_6170, 0);
  Method *writer6170 = addmethodrealflags(obj6164, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_6170, 0);
  reader6170->definitionModule = modulename;
  writer6170->definitionModule = modulename;
  reader6170->definitionLine = 1516;
  writer6170->definitionLine = 1516;
}
obj6164->flags |= OFLAG_MUTABLE;
adddatum2(obj6164, alloc_Undefined(), 5);
// method "onSelf"
  struct UserObject *uo6171 = (struct UserObject*)obj6164;
  uo6171->data[6] = emptyclosure;
  Method *meth_meth_ast_onSelf6171 = addmethod2pos(obj6164, "onSelf", &meth_ast_onSelf6171, 6);
  int argcv_meth_ast_onSelf6171[] = {0};
  meth_meth_ast_onSelf6171->type = alloc_MethodType(1, argcv_meth_ast_onSelf6171);
  meth_meth_ast_onSelf6171->definitionModule = modulename;
  meth_meth_ast_onSelf6171->definitionLine = 1518;
// method "nameString"
  struct UserObject *uo6175 = (struct UserObject*)obj6164;
  uo6175->data[7] = emptyclosure;
  Method *meth_meth_ast_nameString6175 = addmethod2pos(obj6164, "nameString", &meth_ast_nameString6175, 7);
  int argcv_meth_ast_nameString6175[] = {0};
  meth_meth_ast_nameString6175->type = alloc_MethodType(1, argcv_meth_ast_nameString6175);
  meth_meth_ast_nameString6175->definitionModule = modulename;
  meth_meth_ast_nameString6175->definitionLine = 1522;
// method "canonicalName"
  struct UserObject *uo6178 = (struct UserObject*)obj6164;
  uo6178->data[8] = emptyclosure;
  Method *meth_meth_ast_canonicalName6178 = addmethod2pos(obj6164, "canonicalName", &meth_ast_canonicalName6178, 8);
  int argcv_meth_ast_canonicalName6178[] = {0};
  meth_meth_ast_canonicalName6178->type = alloc_MethodType(1, argcv_meth_ast_canonicalName6178);
  meth_meth_ast_canonicalName6178->definitionModule = modulename;
  meth_meth_ast_canonicalName6178->definitionLine = 1523;
// method "isMember"
  struct UserObject *uo6181 = (struct UserObject*)obj6164;
  uo6181->data[9] = emptyclosure;
  Method *meth_meth_ast_isMember6181 = addmethod2pos(obj6164, "isMember", &meth_ast_isMember6181, 9);
  int argcv_meth_ast_isMember6181[] = {0};
  meth_meth_ast_isMember6181->type = alloc_MethodType(1, argcv_meth_ast_isMember6181);
  meth_meth_ast_isMember6181->definitionModule = modulename;
  meth_meth_ast_isMember6181->definitionLine = 1524;
// method "isCall"
  struct UserObject *uo6183 = (struct UserObject*)obj6164;
  uo6183->data[10] = emptyclosure;
  Method *meth_meth_ast_isCall6183 = addmethod2pos(obj6164, "isCall", &meth_ast_isCall6183, 10);
  int argcv_meth_ast_isCall6183[] = {0};
  meth_meth_ast_isCall6183->type = alloc_MethodType(1, argcv_meth_ast_isCall6183);
  meth_meth_ast_isCall6183->definitionModule = modulename;
  meth_meth_ast_isCall6183->definitionLine = 1525;
// method "with"
  block_savedest(obj6164);
  Object closure6185 = createclosure(1, "with");
  setclosureframe(closure6185, stackframe);
  addtoclosure(closure6185, var_emptySeq);
  struct UserObject *uo6185 = (struct UserObject*)obj6164;
  uo6185->data[11] = (Object)closure6185;
  Method *meth_meth_ast_with6185 = addmethod2pos(obj6164, "with", &meth_ast_with6185, 11);
  int argcv_meth_ast_with6185[] = {0};
  meth_meth_ast_with6185->type = alloc_MethodType(1, argcv_meth_ast_with6185);
  meth_meth_ast_with6185->definitionModule = modulename;
  meth_meth_ast_with6185->definitionLine = 1527;
// method "arguments"
  block_savedest(obj6164);
  Object closure6186 = createclosure(1, "arguments");
  setclosureframe(closure6186, stackframe);
  addtoclosure(closure6186, var_emptySeq);
  struct UserObject *uo6186 = (struct UserObject*)obj6164;
  uo6186->data[12] = (Object)closure6186;
  Method *meth_meth_ast_arguments6186 = addmethod2pos(obj6164, "arguments", &meth_ast_arguments6186, 12);
  int argcv_meth_ast_arguments6186[] = {0};
  meth_meth_ast_arguments6186->type = alloc_MethodType(1, argcv_meth_ast_arguments6186);
  meth_meth_ast_arguments6186->definitionModule = modulename;
  meth_meth_ast_arguments6186->definitionLine = 1528;
// method "argumentsDo"
  struct UserObject *uo6187 = (struct UserObject*)obj6164;
  uo6187->data[13] = emptyclosure;
  Method *meth_meth_ast_argumentsDo6187 = addmethod2pos(obj6164, "argumentsDo", &meth_ast_argumentsDo6187, 13);
  int argcv_meth_ast_argumentsDo6187[] = {0};
  meth_meth_ast_argumentsDo6187->type = alloc_MethodType(1, argcv_meth_ast_argumentsDo6187);
  meth_meth_ast_argumentsDo6187->definitionModule = modulename;
  meth_meth_ast_argumentsDo6187->definitionLine = 1529;
// method "accept(_)from(_)"
  struct UserObject *uo6188 = (struct UserObject*)obj6164;
  uo6188->data[14] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6188 = addmethod2pos(obj6164, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6188, 14);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6188[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6188->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6188);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6188->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6188->definitionLine = 1530;
// method "map(_)ancestors(_)"
  struct UserObject *uo6214 = (struct UserObject*)obj6164;
  uo6214->data[15] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6214 = addmethod2pos(obj6164, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6214, 15);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6214[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6214->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6214);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6214->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6214->definitionLine = 1539;
// method "pretty(_)"
  struct UserObject *uo6237 = (struct UserObject*)obj6164;
  uo6237->data[16] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6237 = addmethod2pos(obj6164, "pretty(1)", &meth_ast_pretty_40_1_41_6237, 16);
  int argcv_meth_ast_pretty_40_1_41_6237[] = {1};
  meth_meth_ast_pretty_40_1_41_6237->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6237);
  meth_meth_ast_pretty_40_1_41_6237->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6237->definitionLine = 1546;
// method "toGrace(_)"
  struct UserObject *uo6333 = (struct UserObject*)obj6164;
  uo6333->data[17] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6333 = addmethod2pos(obj6164, "toGrace(1)", &meth_ast_toGrace_40_1_41_6333, 17);
  int argcv_meth_ast_toGrace_40_1_41_6333[] = {1};
  meth_meth_ast_toGrace_40_1_41_6333->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6333);
meth_meth_ast_toGrace_40_1_41_6333->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6333->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6333->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6333->definitionLine = 1563;
// method "asString"
  struct UserObject *uo6444 = (struct UserObject*)obj6164;
  uo6444->data[18] = emptyclosure;
  Method *meth_meth_ast_asString6444 = addmethod2pos(obj6164, "asString", &meth_ast_asString6444, 18);
  int argcv_meth_ast_asString6444[] = {0};
  meth_meth_ast_asString6444->type = alloc_MethodType(1, argcv_meth_ast_asString6444);
  meth_meth_ast_asString6444->definitionModule = modulename;
  meth_meth_ast_asString6444->definitionLine = 1580;
// method "asIdentifier"
  block_savedest(obj6164);
  Object closure6464 = createclosure(2, "asIdentifier");
  setclosureframe(closure6464, stackframe);
  addtoclosure(closure6464, var_fakeSymbolTable);
  addtoclosure(closure6464, var_identifierNode);
  struct UserObject *uo6464 = (struct UserObject*)obj6164;
  uo6464->data[19] = (Object)closure6464;
  Method *meth_meth_ast_asIdentifier6464 = addmethod2pos(obj6164, "asIdentifier", &meth_ast_asIdentifier6464, 19);
  int argcv_meth_ast_asIdentifier6464[] = {0};
  meth_meth_ast_asIdentifier6464->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6464);
  meth_meth_ast_asIdentifier6464->definitionModule = modulename;
  meth_meth_ast_asIdentifier6464->definitionLine = 1581;
// method "shallowCopy"
  block_savedest(obj6164);
  Object closure6504 = createclosure(1, "shallowCopy");
  setclosureframe(closure6504, stackframe);
  addtoclosure(closure6504, var_memberNode);
  struct UserObject *uo6504 = (struct UserObject*)obj6164;
  uo6504->data[20] = (Object)closure6504;
  Method *meth_meth_ast_shallowCopy6504 = addmethod2pos(obj6164, "shallowCopy", &meth_ast_shallowCopy6504, 20);
  int argcv_meth_ast_shallowCopy6504[] = {0};
  meth_meth_ast_shallowCopy6504->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6504);
  meth_meth_ast_shallowCopy6504->definitionModule = modulename;
  meth_meth_ast_shallowCopy6504->definitionLine = 1592;
// method "statementName"
  struct UserObject *uo6513 = (struct UserObject*)obj6164;
  uo6513->data[21] = emptyclosure;
  Method *meth_meth_ast_statementName6513 = addmethod2pos(obj6164, "statementName", &meth_ast_statementName6513, 21);
  int argcv_meth_ast_statementName6513[] = {0};
  meth_meth_ast_statementName6513->type = alloc_MethodType(1, argcv_meth_ast_statementName6513);
  meth_meth_ast_statementName6513->definitionModule = modulename;
  meth_meth_ast_statementName6513->definitionLine = 1595;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo6515 = (struct UserObject*)obj6164;
  uo6515->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6515 = addmethod2pos(obj6164, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_6515, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_6515[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6515->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_6515);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6515->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6515->definitionLine = 1596;
  sourceObject = obj6164;
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6526 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6527 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6528 = gc_frame_new();
// call case 3: self.outer request
  Object call6529 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6528);
// compiled member node returning call6529 (depth = 5)
  Object call6530 = callmethodflags(call6529, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6527);
// compiled member node returning call6530 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6531 = callmethodflags(call6530, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6526);
// compiled call node returning call6531 (depth = 3)
  struct UserObject *obj6164_uo = (struct UserObject *)obj6164;
  obj6164_uo->super = call6531;
  sourceObject = obj6164;
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6532 == NULL) {
    strlit6532 = alloc_String("member");
    gc_root(strlit6532);
  }
// compiled string node returning strlit6532 (depth = 3)
  adddatum2(obj6164, strlit6532, 1);
  sourceObject = obj6164;
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6164, *var_request, 2);
  sourceObject = obj6164;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj6164, *var_receiver_39_, 3);
  sourceObject = obj6164;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6533 = alloc_Boolean(0);
// compiled identifier node returning bool6533 (depth = 3)
  adddatum2(obj6164, bool6533, 4);
  sourceObject = obj6164;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6534 = alloc_Boolean(0);
// compiled identifier node returning bool6534 (depth = 3)
  adddatum2(obj6164, bool6534, 5);
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  sourceObject = obj6164;
  objclass6164 = obj6164->class;
  objclass6164->definitionModule = modulename;
  objclass6164->definitionLine = 1509;
  (*(struct UserObject *)self).data[0] = lowerouter6164;
  self = oldself6164;
  selfslot = oldselfslot6164;
  stackframe = oldstackframe6164;
  gc_frame_end(frame);
  return obj6164;
}
Object meth_ast_memberNode6536(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_memberNode (depth = 3)
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_nameString6545(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6546 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6547 = gc_frame_new();
// call case 4: self request
  Object call6548 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6547);
// compiled member node returning call6548 (depth = 4)
  Object call6549 = callmethodflags(call6548, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe6546);
// compiled member node returning call6549 (depth = 3)
  gc_frame_end(frame);
  return call6549;
}
Object meth_ast_asString6550(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6551 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num6552 = alloc_Float64(0);
// compiled num node returning num6552 (depth = 4)
  gc_frame_newslot(num6552);
// call case 4: self request
  params[0] = num6552;
  partcv[0] = 1;
  Object call6553 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6551);
// compiled call node returning call6553 (depth = 3)
  gc_frame_end(frame);
  return call6553;
}
Object meth_ast__apply_40_1_41_6568(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6569 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6570 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6569);
// compiled call node returning call6570 (depth = 6)
  gc_frame_end(frame);
  return call6570;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6554(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6556 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6557 = callmethodflags(*var_visitor, "visitGeneric(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6556);
// compiled call node returning call6557 (depth = 4)
  Object if6555 = done;
  if (istrue(call6557)) {
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6558 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6559 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6558);
// compiled call node returning call6559 (depth = 5)
  *var_newChain = call6559;
  if (call6559 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6560 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6561 = gc_frame_new();
// call case 4: self request
  Object call6562 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6561);
// compiled member node returning call6562 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6563 = callmethodflags(call6562, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6560);
// compiled call node returning call6563 (depth = 4)
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6564 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6565 = gc_frame_new();
// call case 4: self request
  Object call6566 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6565);
// compiled member node returning call6566 (depth = 5)
  gc_frame_newslot(call6566);
// starting to compile block node (depth = 5)
  Object block6567 = alloc_Block(NULL, NULL, "ast", 1619);
  gc_frame_newslot(block6567);
// method "_apply(_)"
  block_savedest(block6567);
  Object closure6568 = createclosure(3, "_apply(1)");
  setclosureframe(closure6568, stackframe);
  addtoclosure(closure6568, var_visitor);
  addtoclosure(closure6568, var_newChain);
  addtoclosure(closure6568, selfslot);
  struct UserObject *uo6568 = (struct UserObject*)block6567;
  uo6568->data[0] = (Object)closure6568;
  Method *meth_meth_ast__apply_40_1_41_6568 = addmethod2pos(block6567, "_apply(1)", &meth_ast__apply_40_1_41_6568, 0);
  int argcv_meth_ast__apply_40_1_41_6568[] = {1};
  meth_meth_ast__apply_40_1_41_6568->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6568);
  meth_meth_ast__apply_40_1_41_6568->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6568->definitionLine = 2969;
// compiled block node returning block6567 (depth = 5)
  gc_frame_newslot(block6567);
// call case 5: prelude request
  params[0] = call6566;
  params[1] = block6567;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6572 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6564);
// compiled call node returning call6572 (depth = 4)
    gc_frame_newslot(call6572);
    if6555 = call6572;
  } else {
  }
// compiled if node returning if6555 (depth = 3)
  gc_frame_end(frame);
  return if6555;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6573(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6574 = gc_frame_new();
// call case 4: self request
  Object call6575 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6574);
// compiled member node returning call6575 (depth = 4)
  *var_n = call6575;
  if (call6575 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6576 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6577 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6576);
// compiled call node returning call6577 (depth = 4)
  *var_newChain = call6577;
  if (call6577 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6578 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6579 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6580 = gc_frame_new();
// call case 4: self request
  Object call6581 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6580);
// compiled member node returning call6581 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6582 = callmethodflags(call6581, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6579);
// compiled call node returning call6582 (depth = 4)
  gc_frame_newslot(call6582);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6582;
  partcv[0] = 1;
  Object call6583 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6578);
// compiled call node returning call6583 (depth = 3)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6584 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6585 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6586 = gc_frame_new();
// call case 4: self request
  Object call6587 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6586);
// compiled member node returning call6587 (depth = 5)
  gc_frame_newslot(call6587);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6588 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6589 = gc_frame_new();
// call case 3: self.outer request
  Object call6590 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6589);
// compiled member node returning call6590 (depth = 6)
  Object call6591 = callmethodflags(call6590, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6588);
// compiled member node returning call6591 (depth = 5)
  params[0] = call6587;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6592 = callmethodflags(call6591, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6585);
// compiled call node returning call6592 (depth = 4)
  gc_frame_newslot(call6592);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6592;
  partcv[0] = 1;
  Object call6593 = callmethodflags(*var_n, "args:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6584);
// compiled call node returning call6593 (depth = 3)
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6594 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6595 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6594);
// compiled call node returning call6595 (depth = 3)
  gc_frame_end(frame);
  return call6595;
}
Object meth_ast__apply_40_1_41_6620(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6622 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6624 = alloc_Float64(2);
// compiled num node returning num6624 (depth = 9)
  int op_slot_right_6623 = gc_frame_newslot(num6624);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6623 = gc_frame_newslot(*var_depth);
  params[0] = num6624;
  partcv[0] = 1;
  Object sum6626 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6626 (depth = 8)
  gc_frame_newslot(sum6626);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum6626;
  partcv[0] = 1;
  Object call6627 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6622);
// compiled call node returning call6627 (depth = 7)
  int op_slot_right_6621 = gc_frame_newslot(call6627);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6621 = gc_frame_newslot(*var_s);
  params[0] = call6627;
  partcv[0] = 1;
  Object opresult6629 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6629 (depth = 6)
  *var_s = opresult6629;
  if (opresult6629 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6633(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6635 == NULL) {
    strlit6635 = alloc_String(", ");
    gc_root(strlit6635);
  }
// compiled string node returning strlit6635 (depth = 7)
  int op_slot_right_6634 = gc_frame_newslot(strlit6635);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6634 = gc_frame_newslot(*var_s);
  params[0] = strlit6635;
  partcv[0] = 1;
  Object opresult6637 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6637 (depth = 6)
  *var_s = opresult6637;
  if (opresult6637 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6596(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6598 == NULL) {
    strlit6598 = alloc_String(")<");
    gc_root(strlit6598);
  }
// compiled string node returning strlit6598 (depth = 5)
  int op_slot_right_6597 = gc_frame_newslot(strlit6598);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6601 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6602 = gc_frame_new();
// call case 4: self request
  Object call6603 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6602);
// compiled member node returning call6603 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6604 = callmethodflags(call6603, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6601);
// compiled call node returning call6604 (depth = 6)
  int op_slot_right_6600 = gc_frame_newslot(call6604);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6607 == NULL) {
    strlit6607 = alloc_String("(");
    gc_root(strlit6607);
  }
// compiled string node returning strlit6607 (depth = 7)
  int op_slot_right_6606 = gc_frame_newslot(strlit6607);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6610 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6611 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6610);
// compiled call node returning call6611 (depth = 8)
  int op_slot_right_6609 = gc_frame_newslot(call6611);
// starting to compile string node (depth = 8)
  if (strlit6613 == NULL) {
    strlit6613 = alloc_String("");
    gc_root(strlit6613);
  }
// compiled string node returning strlit6613 (depth = 8)
  int op_slot_left_6609 = gc_frame_newslot(strlit6613);
  params[0] = call6611;
  partcv[0] = 1;
  Object opresult6614 = callmethod(strlit6613, "++(1)", 1, partcv, params);
// compiled op node returning opresult6614 (depth = 7)
  int op_slot_left_6606 = gc_frame_newslot(opresult6614);
  params[0] = strlit6607;
  partcv[0] = 1;
  Object opresult6615 = callmethod(opresult6614, "++(1)", 1, partcv, params);
// compiled op node returning opresult6615 (depth = 6)
  int op_slot_left_6600 = gc_frame_newslot(opresult6615);
  params[0] = call6604;
  partcv[0] = 1;
  Object opresult6616 = callmethod(opresult6615, "++(1)", 1, partcv, params);
// compiled op node returning opresult6616 (depth = 5)
  int op_slot_left_6597 = gc_frame_newslot(opresult6616);
  params[0] = strlit6598;
  partcv[0] = 1;
  Object opresult6617 = callmethod(opresult6616, "++(1)", 1, partcv, params);
// compiled op node returning opresult6617 (depth = 4)
  *var_s = opresult6617;
  if (opresult6617 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6618 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6619 = alloc_Block(NULL, NULL, "ast", 1633);
  gc_frame_newslot(block6619);
// method "_apply(_)"
  block_savedest(block6619);
  Object closure6620 = createclosure(3, "_apply(1)");
  setclosureframe(closure6620, stackframe);
  addtoclosure(closure6620, var_depth);
  addtoclosure(closure6620, var_s);
  addtoclosure(closure6620, selfslot);
  struct UserObject *uo6620 = (struct UserObject*)block6619;
  uo6620->data[0] = (Object)closure6620;
  Method *meth_meth_ast__apply_40_1_41_6620 = addmethod2pos(block6619, "_apply(1)", &meth_ast__apply_40_1_41_6620, 0);
  int argcv_meth_ast__apply_40_1_41_6620[] = {1};
  meth_meth_ast__apply_40_1_41_6620->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6620);
  meth_meth_ast__apply_40_1_41_6620->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6620->definitionLine = 2969;
// compiled block node returning block6619 (depth = 4)
  gc_frame_newslot(block6619);
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6632 = alloc_Block(NULL, NULL, "ast", 1634);
  gc_frame_newslot(block6632);
// method "_apply"
  block_savedest(block6632);
  Object closure6633 = createclosure(2, "_apply");
  setclosureframe(closure6633, stackframe);
  addtoclosure(closure6633, var_s);
  addtoclosure(closure6633, selfslot);
  struct UserObject *uo6633 = (struct UserObject*)block6632;
  uo6633->data[0] = (Object)closure6633;
  Method *meth_meth_ast__apply6633 = addmethod2pos(block6632, "_apply", &meth_ast__apply6633, 0);
  int argcv_meth_ast__apply6633[] = {0};
  meth_meth_ast__apply6633->type = alloc_MethodType(1, argcv_meth_ast__apply6633);
  meth_meth_ast__apply6633->definitionModule = modulename;
  meth_meth_ast__apply6633->definitionLine = 2969;
// compiled block node returning block6632 (depth = 4)
  gc_frame_newslot(block6632);
// call case 6: other requests
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6640 = gc_frame_new();
// call case 4: self request
  Object call6641 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6640);
// compiled member node returning call6641 (depth = 4)
  params[0] = block6619;
  params[1] = block6632;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6642 = callmethodflags(call6641, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6618);
// compiled call node returning call6642 (depth = 3)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6644 == NULL) {
    strlit6644 = alloc_String(">");
    gc_root(strlit6644);
  }
// compiled string node returning strlit6644 (depth = 4)
  int op_slot_right_6643 = gc_frame_newslot(strlit6644);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6643 = gc_frame_newslot(*var_s);
  params[0] = strlit6644;
  partcv[0] = 1;
  Object opresult6646 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6646 (depth = 3)
  gc_frame_end(frame);
  return opresult6646;
}
Object meth_ast__apply_40_1_41_6656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6658 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6659 = alloc_Float64(0);
// compiled num node returning num6659 (depth = 8)
  gc_frame_newslot(num6659);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = num6659;
  partcv[0] = 1;
  Object call6660 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6658);
// compiled call node returning call6660 (depth = 7)
  int op_slot_right_6657 = gc_frame_newslot(call6660);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6657 = gc_frame_newslot(*var_s);
  params[0] = call6660;
  partcv[0] = 1;
  Object opresult6662 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6662 (depth = 6)
  *var_s = opresult6662;
  if (opresult6662 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6666(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6668 == NULL) {
    strlit6668 = alloc_String(", ");
    gc_root(strlit6668);
  }
// compiled string node returning strlit6668 (depth = 7)
  int op_slot_right_6667 = gc_frame_newslot(strlit6668);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6667 = gc_frame_newslot(*var_s);
  params[0] = strlit6668;
  partcv[0] = 1;
  Object opresult6670 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6670 (depth = 6)
  *var_s = opresult6670;
  if (opresult6670 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_6647(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6649 == NULL) {
    strlit6649 = alloc_String("<");
    gc_root(strlit6649);
  }
// compiled string node returning strlit6649 (depth = 5)
  int op_slot_right_6648 = gc_frame_newslot(strlit6649);
// starting to compile member node (depth = 5)
  int callframe6651 = gc_frame_new();
// call case 4: self request
  Object call6652 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6651);
// compiled member node returning call6652 (depth = 5)
  int op_slot_left_6648 = gc_frame_newslot(call6652);
  params[0] = strlit6649;
  partcv[0] = 1;
  Object opresult6653 = callmethod(call6652, "++(1)", 1, partcv, params);
// compiled op node returning opresult6653 (depth = 4)
  *var_s = opresult6653;
  if (opresult6653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6654 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6655 = alloc_Block(NULL, NULL, "ast", 1639);
  gc_frame_newslot(block6655);
// method "_apply(_)"
  block_savedest(block6655);
  Object closure6656 = createclosure(2, "_apply(1)");
  setclosureframe(closure6656, stackframe);
  addtoclosure(closure6656, var_s);
  addtoclosure(closure6656, selfslot);
  struct UserObject *uo6656 = (struct UserObject*)block6655;
  uo6656->data[0] = (Object)closure6656;
  Method *meth_meth_ast__apply_40_1_41_6656 = addmethod2pos(block6655, "_apply(1)", &meth_ast__apply_40_1_41_6656, 0);
  int argcv_meth_ast__apply_40_1_41_6656[] = {1};
  meth_meth_ast__apply_40_1_41_6656->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6656);
  meth_meth_ast__apply_40_1_41_6656->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6656->definitionLine = 2969;
// compiled block node returning block6655 (depth = 4)
  gc_frame_newslot(block6655);
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6665 = alloc_Block(NULL, NULL, "ast", 1640);
  gc_frame_newslot(block6665);
// method "_apply"
  block_savedest(block6665);
  Object closure6666 = createclosure(2, "_apply");
  setclosureframe(closure6666, stackframe);
  addtoclosure(closure6666, var_s);
  addtoclosure(closure6666, selfslot);
  struct UserObject *uo6666 = (struct UserObject*)block6665;
  uo6666->data[0] = (Object)closure6666;
  Method *meth_meth_ast__apply6666 = addmethod2pos(block6665, "_apply", &meth_ast__apply6666, 0);
  int argcv_meth_ast__apply6666[] = {0};
  meth_meth_ast__apply6666->type = alloc_MethodType(1, argcv_meth_ast__apply6666);
  meth_meth_ast__apply6666->definitionModule = modulename;
  meth_meth_ast__apply6666->definitionLine = 2969;
// compiled block node returning block6665 (depth = 4)
  gc_frame_newslot(block6665);
// call case 6: other requests
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6673 = gc_frame_new();
// call case 4: self request
  Object call6674 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6673);
// compiled member node returning call6674 (depth = 4)
  params[0] = block6655;
  params[1] = block6665;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6675 = callmethodflags(call6674, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6654);
// compiled call node returning call6675 (depth = 3)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6677 == NULL) {
    strlit6677 = alloc_String(">");
    gc_root(strlit6677);
  }
// compiled string node returning strlit6677 (depth = 4)
  int op_slot_right_6676 = gc_frame_newslot(strlit6677);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6676 = gc_frame_newslot(*var_s);
  params[0] = strlit6677;
  partcv[0] = 1;
  Object opresult6679 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6679 (depth = 3)
  gc_frame_end(frame);
  return opresult6679;
}
Object meth_ast_shallowCopy6680(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6681 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6682 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6683 = gc_frame_new();
// call case 4: self request
  Object call6684 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6683);
// compiled member node returning call6684 (depth = 5)
  gc_frame_newslot(call6684);
// starting to compile member node (depth = 5)
  int callframe6685 = gc_frame_new();
// call case 4: self request
  Object call6686 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6685);
// compiled member node returning call6686 (depth = 5)
  gc_frame_newslot(call6686);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericNode (depth = 5)
  params[0] = call6684;
  params[1] = call6686;
  partcv[0] = 2;
  Object call6687 = callmethodflags(*var_genericNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6682);
// compiled call node returning call6687 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6688 = callmethodflags(call6687, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6681);
// compiled call node returning call6688 (depth = 3)
  gc_frame_end(frame);
  return call6688;
}
Object meth_ast_new_40_2_41_6539(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6540 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6540 = alloc_userobj2(12,11, objclass6540);
  gc_frame_newslot(obj6540);
if (objclass6540 == NULL) {
  glfree(obj6540->class->name);
  obj6540->class->name = "genericNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6540, self, 0);
  addmethodreal(obj6540,"outer", &reader_ast_outer_6541);
  Object oldself6540 = self;
  struct StackFrameObject *oldstackframe6540 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6540);
  gc_frame_newslot((Object)stackframe);
  self = obj6540;
  Object *oldselfslot6540 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6540 = (*(struct UserObject *)self).data[0], lowerouter6540 = thisouter6540;
  if (inheritingObject6540) {
    struct UserObject *inho6540 = (struct UserObject *)inheritingObject6540;
    while (inho6540->super != GraceDefaultObject) inho6540 = (struct UserObject *)inho6540->super;
    inho6540->super = obj6540;
    self = inheritingObject6540;
    *selfslot = self;
    lowerouter6540 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6540;
  }
if (objclass6540 == NULL) {
  Method *reader6542 = addmethodrealflags(obj6540, "kind",&reader_ast_kind_6542, MFLAG_DEF);
  reader6542->definitionModule = modulename;
  reader6542->definitionLine = 1608;
}
adddatum2(obj6540, alloc_Undefined(), 1);
if (objclass6540 == NULL) {
  Method *reader6543 = addmethodrealflags(obj6540, "value", &reader_ast_value_6543, 0);
  Method *writer6543 = addmethodrealflags(obj6540, "value:=(1)", &writer_ast_value_6543, 0);
  reader6543->definitionModule = modulename;
  writer6543->definitionModule = modulename;
  reader6543->definitionLine = 1609;
  writer6543->definitionLine = 1609;
}
obj6540->flags |= OFLAG_MUTABLE;
adddatum2(obj6540, alloc_Undefined(), 2);
if (objclass6540 == NULL) {
  Method *reader6544 = addmethodrealflags(obj6540, "args", &reader_ast_args_6544, 0);
  Method *writer6544 = addmethodrealflags(obj6540, "args:=(1)", &writer_ast_args_6544, 0);
  reader6544->definitionModule = modulename;
  writer6544->definitionModule = modulename;
  reader6544->definitionLine = 1612;
  writer6544->definitionLine = 1612;
}
obj6540->flags |= OFLAG_MUTABLE;
adddatum2(obj6540, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo6545 = (struct UserObject*)obj6540;
  uo6545->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6545 = addmethod2pos(obj6540, "nameString", &meth_ast_nameString6545, 4);
  int argcv_meth_ast_nameString6545[] = {0};
  meth_meth_ast_nameString6545->type = alloc_MethodType(1, argcv_meth_ast_nameString6545);
  meth_meth_ast_nameString6545->definitionModule = modulename;
  meth_meth_ast_nameString6545->definitionLine = 1613;
// method "asString"
  struct UserObject *uo6550 = (struct UserObject*)obj6540;
  uo6550->data[5] = emptyclosure;
  Method *meth_meth_ast_asString6550 = addmethod2pos(obj6540, "asString", &meth_ast_asString6550, 5);
  int argcv_meth_ast_asString6550[] = {0};
  meth_meth_ast_asString6550->type = alloc_MethodType(1, argcv_meth_ast_asString6550);
  meth_meth_ast_asString6550->definitionModule = modulename;
  meth_meth_ast_asString6550->definitionLine = 1614;
// method "accept(_)from(_)"
  struct UserObject *uo6554 = (struct UserObject*)obj6540;
  uo6554->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6554 = addmethod2pos(obj6540, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6554, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6554[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6554->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6554);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6554->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6554->definitionLine = 1615;
// method "map(_)ancestors(_)"
  struct UserObject *uo6573 = (struct UserObject*)obj6540;
  uo6573->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6573 = addmethod2pos(obj6540, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6573, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6573[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6573->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6573);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6573->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6573->definitionLine = 1624;
// method "pretty(_)"
  struct UserObject *uo6596 = (struct UserObject*)obj6540;
  uo6596->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6596 = addmethod2pos(obj6540, "pretty(1)", &meth_ast_pretty_40_1_41_6596, 8);
  int argcv_meth_ast_pretty_40_1_41_6596[] = {1};
  meth_meth_ast_pretty_40_1_41_6596->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6596);
  meth_meth_ast_pretty_40_1_41_6596->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6596->definitionLine = 1631;
// method "toGrace(_)"
  struct UserObject *uo6647 = (struct UserObject*)obj6540;
  uo6647->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6647 = addmethod2pos(obj6540, "toGrace(1)", &meth_ast_toGrace_40_1_41_6647, 9);
  int argcv_meth_ast_toGrace_40_1_41_6647[] = {1};
  meth_meth_ast_toGrace_40_1_41_6647->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6647);
meth_meth_ast_toGrace_40_1_41_6647->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6647->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6647->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6647->definitionLine = 1637;
// method "shallowCopy"
  block_savedest(obj6540);
  Object closure6680 = createclosure(1, "shallowCopy");
  setclosureframe(closure6680, stackframe);
  addtoclosure(closure6680, var_genericNode);
  struct UserObject *uo6680 = (struct UserObject*)obj6540;
  uo6680->data[10] = (Object)closure6680;
  Method *meth_meth_ast_shallowCopy6680 = addmethod2pos(obj6540, "shallowCopy", &meth_ast_shallowCopy6680, 10);
  int argcv_meth_ast_shallowCopy6680[] = {0};
  meth_meth_ast_shallowCopy6680->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6680);
  meth_meth_ast_shallowCopy6680->definitionModule = modulename;
  meth_meth_ast_shallowCopy6680->definitionLine = 1643;
  sourceObject = obj6540;
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6689 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6690 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6691 = gc_frame_new();
// call case 3: self.outer request
  Object call6692 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6691);
// compiled member node returning call6692 (depth = 5)
  Object call6693 = callmethodflags(call6692, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6690);
// compiled member node returning call6693 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6694 = callmethodflags(call6693, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6689);
// compiled call node returning call6694 (depth = 3)
  struct UserObject *obj6540_uo = (struct UserObject *)obj6540;
  obj6540_uo->super = call6694;
  sourceObject = obj6540;
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6695 == NULL) {
    strlit6695 = alloc_String("generic");
    gc_root(strlit6695);
  }
// compiled string node returning strlit6695 (depth = 3)
  adddatum2(obj6540, strlit6695, 1);
  sourceObject = obj6540;
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj6540, *var_base, 2);
  sourceObject = obj6540;
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj6540, *var_arguments, 3);
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  objclass6540 = obj6540->class;
  objclass6540->definitionModule = modulename;
  objclass6540->definitionLine = 1605;
  (*(struct UserObject *)self).data[0] = lowerouter6540;
  self = oldself6540;
  selfslot = oldselfslot6540;
  stackframe = oldstackframe6540;
  gc_frame_end(frame);
  return obj6540;
}
Object meth_ast_new_40_2_41_6539_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6540 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6540 = alloc_userobj2(12,11, objclass6540);
  gc_frame_newslot(obj6540);
if (objclass6540 == NULL) {
  glfree(obj6540->class->name);
  obj6540->class->name = "genericNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6540, self, 0);
  addmethodreal(obj6540,"outer", &reader_ast_outer_6541);
  Object oldself6540 = self;
  struct StackFrameObject *oldstackframe6540 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6540);
  gc_frame_newslot((Object)stackframe);
  self = obj6540;
  Object *oldselfslot6540 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6540 = (*(struct UserObject *)self).data[0], lowerouter6540 = thisouter6540;
  if (inheritingObject6540) {
    struct UserObject *inho6540 = (struct UserObject *)inheritingObject6540;
    while (inho6540->super != GraceDefaultObject) inho6540 = (struct UserObject *)inho6540->super;
    inho6540->super = obj6540;
    self = inheritingObject6540;
    *selfslot = self;
    lowerouter6540 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6540;
  }
if (objclass6540 == NULL) {
  Method *reader6542 = addmethodrealflags(obj6540, "kind",&reader_ast_kind_6542, MFLAG_DEF);
  reader6542->definitionModule = modulename;
  reader6542->definitionLine = 1608;
}
adddatum2(obj6540, alloc_Undefined(), 1);
if (objclass6540 == NULL) {
  Method *reader6543 = addmethodrealflags(obj6540, "value", &reader_ast_value_6543, 0);
  Method *writer6543 = addmethodrealflags(obj6540, "value:=(1)", &writer_ast_value_6543, 0);
  reader6543->definitionModule = modulename;
  writer6543->definitionModule = modulename;
  reader6543->definitionLine = 1609;
  writer6543->definitionLine = 1609;
}
obj6540->flags |= OFLAG_MUTABLE;
adddatum2(obj6540, alloc_Undefined(), 2);
if (objclass6540 == NULL) {
  Method *reader6544 = addmethodrealflags(obj6540, "args", &reader_ast_args_6544, 0);
  Method *writer6544 = addmethodrealflags(obj6540, "args:=(1)", &writer_ast_args_6544, 0);
  reader6544->definitionModule = modulename;
  writer6544->definitionModule = modulename;
  reader6544->definitionLine = 1612;
  writer6544->definitionLine = 1612;
}
obj6540->flags |= OFLAG_MUTABLE;
adddatum2(obj6540, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo6545 = (struct UserObject*)obj6540;
  uo6545->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6545 = addmethod2pos(obj6540, "nameString", &meth_ast_nameString6545, 4);
  int argcv_meth_ast_nameString6545[] = {0};
  meth_meth_ast_nameString6545->type = alloc_MethodType(1, argcv_meth_ast_nameString6545);
  meth_meth_ast_nameString6545->definitionModule = modulename;
  meth_meth_ast_nameString6545->definitionLine = 1613;
// method "asString"
  struct UserObject *uo6550 = (struct UserObject*)obj6540;
  uo6550->data[5] = emptyclosure;
  Method *meth_meth_ast_asString6550 = addmethod2pos(obj6540, "asString", &meth_ast_asString6550, 5);
  int argcv_meth_ast_asString6550[] = {0};
  meth_meth_ast_asString6550->type = alloc_MethodType(1, argcv_meth_ast_asString6550);
  meth_meth_ast_asString6550->definitionModule = modulename;
  meth_meth_ast_asString6550->definitionLine = 1614;
// method "accept(_)from(_)"
  struct UserObject *uo6554 = (struct UserObject*)obj6540;
  uo6554->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6554 = addmethod2pos(obj6540, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6554, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6554[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6554->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6554);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6554->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6554->definitionLine = 1615;
// method "map(_)ancestors(_)"
  struct UserObject *uo6573 = (struct UserObject*)obj6540;
  uo6573->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6573 = addmethod2pos(obj6540, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6573, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6573[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6573->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6573);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6573->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6573->definitionLine = 1624;
// method "pretty(_)"
  struct UserObject *uo6596 = (struct UserObject*)obj6540;
  uo6596->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6596 = addmethod2pos(obj6540, "pretty(1)", &meth_ast_pretty_40_1_41_6596, 8);
  int argcv_meth_ast_pretty_40_1_41_6596[] = {1};
  meth_meth_ast_pretty_40_1_41_6596->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6596);
  meth_meth_ast_pretty_40_1_41_6596->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6596->definitionLine = 1631;
// method "toGrace(_)"
  struct UserObject *uo6647 = (struct UserObject*)obj6540;
  uo6647->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6647 = addmethod2pos(obj6540, "toGrace(1)", &meth_ast_toGrace_40_1_41_6647, 9);
  int argcv_meth_ast_toGrace_40_1_41_6647[] = {1};
  meth_meth_ast_toGrace_40_1_41_6647->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6647);
meth_meth_ast_toGrace_40_1_41_6647->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6647->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6647->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6647->definitionLine = 1637;
// method "shallowCopy"
  block_savedest(obj6540);
  Object closure6680 = createclosure(1, "shallowCopy");
  setclosureframe(closure6680, stackframe);
  addtoclosure(closure6680, var_genericNode);
  struct UserObject *uo6680 = (struct UserObject*)obj6540;
  uo6680->data[10] = (Object)closure6680;
  Method *meth_meth_ast_shallowCopy6680 = addmethod2pos(obj6540, "shallowCopy", &meth_ast_shallowCopy6680, 10);
  int argcv_meth_ast_shallowCopy6680[] = {0};
  meth_meth_ast_shallowCopy6680->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6680);
  meth_meth_ast_shallowCopy6680->definitionModule = modulename;
  meth_meth_ast_shallowCopy6680->definitionLine = 1643;
  sourceObject = obj6540;
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6689 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6690 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6691 = gc_frame_new();
// call case 3: self.outer request
  Object call6692 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6691);
// compiled member node returning call6692 (depth = 5)
  Object call6693 = callmethodflags(call6692, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6690);
// compiled member node returning call6693 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6694 = callmethodflags(call6693, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6689);
// compiled call node returning call6694 (depth = 3)
  struct UserObject *obj6540_uo = (struct UserObject *)obj6540;
  obj6540_uo->super = call6694;
  sourceObject = obj6540;
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6695 == NULL) {
    strlit6695 = alloc_String("generic");
    gc_root(strlit6695);
  }
// compiled string node returning strlit6695 (depth = 3)
  adddatum2(obj6540, strlit6695, 1);
  sourceObject = obj6540;
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj6540, *var_base, 2);
  sourceObject = obj6540;
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj6540, *var_arguments, 3);
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  sourceObject = obj6540;
  objclass6540 = obj6540->class;
  objclass6540->definitionModule = modulename;
  objclass6540->definitionLine = 1605;
  (*(struct UserObject *)self).data[0] = lowerouter6540;
  self = oldself6540;
  selfslot = oldselfslot6540;
  stackframe = oldstackframe6540;
  gc_frame_end(frame);
  return obj6540;
}
Object meth_ast_genericNode6697(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericNode (depth = 3)
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast_asString6705(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6706 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num6707 = alloc_Float64(0);
// compiled num node returning num6707 (depth = 4)
  gc_frame_newslot(num6707);
// call case 4: self request
  params[0] = num6707;
  partcv[0] = 1;
  Object call6708 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6706);
// compiled call node returning call6708 (depth = 3)
  gc_frame_end(frame);
  return call6708;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_6709(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6710 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call6711 = callmethodflags(*var_k, "typeparam", 0, partcv, params, 0);
  gc_frame_end(callframe6710);
// compiled member node returning call6711 (depth = 3)
  gc_frame_end(frame);
  return call6711;
}
Object meth_ast__apply_40_1_41_6720(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6721 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6722 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6721);
// compiled call node returning call6722 (depth = 6)
  gc_frame_end(frame);
  return call6722;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6712(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6714 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6715 = callmethodflags(*var_visitor, "visitTypeParameters(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6714);
// compiled call node returning call6715 (depth = 4)
  Object if6713 = done;
  if (istrue(call6715)) {
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6716 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6717 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6716);
// compiled call node returning call6717 (depth = 5)
  *var_newChain = call6717;
  if (call6717 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6718 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6719 = alloc_Block(NULL, NULL, "ast", 1660);
  gc_frame_newslot(block6719);
// method "_apply(_)"
  block_savedest(block6719);
  Object closure6720 = createclosure(3, "_apply(1)");
  setclosureframe(closure6720, stackframe);
  addtoclosure(closure6720, var_visitor);
  addtoclosure(closure6720, var_newChain);
  addtoclosure(closure6720, selfslot);
  struct UserObject *uo6720 = (struct UserObject*)block6719;
  uo6720->data[0] = (Object)closure6720;
  Method *meth_meth_ast__apply_40_1_41_6720 = addmethod2pos(block6719, "_apply(1)", &meth_ast__apply_40_1_41_6720, 0);
  int argcv_meth_ast__apply_40_1_41_6720[] = {1};
  meth_meth_ast__apply_40_1_41_6720->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6720);
  meth_meth_ast__apply_40_1_41_6720->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6720->definitionLine = 2969;
// compiled block node returning block6719 (depth = 5)
  gc_frame_newslot(block6719);
// call case 6: other requests
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6724 = gc_frame_new();
// call case 4: self request
  Object call6725 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6724);
// compiled member node returning call6725 (depth = 5)
  params[0] = block6719;
  partcv[0] = 1;
  Object call6726 = callmethodflags(call6725, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6718);
// compiled call node returning call6726 (depth = 4)
    gc_frame_newslot(call6726);
    if6713 = call6726;
  } else {
  }
// compiled if node returning if6713 (depth = 3)
  gc_frame_end(frame);
  return if6713;
}
Object meth_ast_do_40_1_41_6727(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6728 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  gc_frame_newslot(*var_blk);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6729 = gc_frame_new();
// call case 4: self request
  Object call6730 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6729);
// compiled member node returning call6730 (depth = 4)
  params[0] = *var_blk;
  partcv[0] = 1;
  Object call6731 = callmethodflags(call6730, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6728);
// compiled call node returning call6731 (depth = 3)
  gc_frame_end(frame);
  return call6731;
}
Object meth_ast_size6732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6733 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6734 = gc_frame_new();
// call case 4: self request
  Object call6735 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6734);
// compiled member node returning call6735 (depth = 4)
  Object call6736 = callmethodflags(call6735, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6733);
// compiled member node returning call6736 (depth = 3)
  gc_frame_end(frame);
  return call6736;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6737(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6738 = gc_frame_new();
// call case 4: self request
  Object call6739 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6738);
// compiled member node returning call6739 (depth = 4)
  *var_n = call6739;
  if (call6739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6740 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6741 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6740);
// compiled call node returning call6741 (depth = 4)
  *var_newChain = call6741;
  if (call6741 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6742 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6743 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6744 = gc_frame_new();
// call case 4: self request
  Object call6745 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6744);
// compiled member node returning call6745 (depth = 5)
  gc_frame_newslot(call6745);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6746 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6747 = gc_frame_new();
// call case 3: self.outer request
  Object call6748 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6747);
// compiled member node returning call6748 (depth = 6)
  Object call6749 = callmethodflags(call6748, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6746);
// compiled member node returning call6749 (depth = 5)
  params[0] = call6745;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6750 = callmethodflags(call6749, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6743);
// compiled call node returning call6750 (depth = 4)
  gc_frame_newslot(call6750);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6750;
  partcv[0] = 1;
  Object call6751 = callmethodflags(*var_n, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6742);
// compiled call node returning call6751 (depth = 3)
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6752 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6753 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6752);
// compiled call node returning call6753 (depth = 3)
  gc_frame_end(frame);
  return call6753;
}
Object meth_ast__apply_40_1_41_6762(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6764 == NULL) {
    strlit6764 = alloc_String("  ");
    gc_root(strlit6764);
  }
// compiled string node returning strlit6764 (depth = 7)
  int op_slot_right_6763 = gc_frame_newslot(strlit6764);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6763 = gc_frame_newslot(*var_spc);
  params[0] = strlit6764;
  partcv[0] = 1;
  Object opresult6766 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6766 (depth = 6)
  *var_spc = opresult6766;
  if (opresult6766 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_6781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6783 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6785 = alloc_Float64(2);
// compiled num node returning num6785 (depth = 9)
  int op_slot_right_6784 = gc_frame_newslot(num6785);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6784 = gc_frame_newslot(*var_depth);
  params[0] = num6785;
  partcv[0] = 1;
  Object sum6787 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6787 (depth = 8)
  gc_frame_newslot(sum6787);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum6787;
  partcv[0] = 1;
  Object call6788 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6783);
// compiled call node returning call6788 (depth = 7)
  int op_slot_right_6782 = gc_frame_newslot(call6788);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6782 = gc_frame_newslot(*var_s);
  params[0] = call6788;
  partcv[0] = 1;
  Object opresult6790 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6790 (depth = 6)
  *var_s = opresult6790;
  if (opresult6790 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6794(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6796 == NULL) {
    strlit6796 = alloc_String(", ");
    gc_root(strlit6796);
  }
// compiled string node returning strlit6796 (depth = 7)
  int op_slot_right_6795 = gc_frame_newslot(strlit6796);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6795 = gc_frame_newslot(*var_s);
  params[0] = strlit6796;
  partcv[0] = 1;
  Object opresult6798 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6798 (depth = 6)
  *var_s = opresult6798;
  if (opresult6798 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6754(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6755 == NULL) {
    strlit6755 = alloc_String("");
    gc_root(strlit6755);
  }
// compiled string node returning strlit6755 (depth = 4)
  *var_spc = strlit6755;
  if (strlit6755 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6756 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6757 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6759 = alloc_Float64(0);
// compiled num node returning num6759 (depth = 5)
  int op_slot_left_6757 = gc_frame_newslot(num6759);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6760 = callmethod(num6759, "..(1)", 1, partcv, params);
// compiled op node returning opresult6760 (depth = 4)
  gc_frame_newslot(opresult6760);
// starting to compile block node (depth = 4)
  Object block6761 = alloc_Block(NULL, NULL, "ast", 1677);
  gc_frame_newslot(block6761);
// method "_apply(_)"
  block_savedest(block6761);
  Object closure6762 = createclosure(2, "_apply(1)");
  setclosureframe(closure6762, stackframe);
  addtoclosure(closure6762, var_spc);
  addtoclosure(closure6762, selfslot);
  struct UserObject *uo6762 = (struct UserObject*)block6761;
  uo6762->data[0] = (Object)closure6762;
  Method *meth_meth_ast__apply_40_1_41_6762 = addmethod2pos(block6761, "_apply(1)", &meth_ast__apply_40_1_41_6762, 0);
  int argcv_meth_ast__apply_40_1_41_6762[] = {1};
  meth_meth_ast__apply_40_1_41_6762->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6762);
  meth_meth_ast__apply_40_1_41_6762->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6762->definitionLine = 2969;
// compiled block node returning block6761 (depth = 4)
  gc_frame_newslot(block6761);
// call case 5: prelude request
  params[0] = opresult6760;
  params[1] = block6761;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6769 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6756);
// compiled call node returning call6769 (depth = 3)
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6771 == NULL) {
    strlit6771 = alloc_String("<");
    gc_root(strlit6771);
  }
// compiled string node returning strlit6771 (depth = 5)
  int op_slot_right_6770 = gc_frame_newslot(strlit6771);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6774 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6775 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6774);
// compiled call node returning call6775 (depth = 6)
  int op_slot_right_6773 = gc_frame_newslot(call6775);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_6773 = gc_frame_newslot(*var_spc);
  params[0] = call6775;
  partcv[0] = 1;
  Object opresult6777 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6777 (depth = 5)
  int op_slot_left_6770 = gc_frame_newslot(opresult6777);
  params[0] = strlit6771;
  partcv[0] = 1;
  Object opresult6778 = callmethod(opresult6777, "++(1)", 1, partcv, params);
// compiled op node returning opresult6778 (depth = 4)
  *var_s = opresult6778;
  if (opresult6778 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6779 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6780 = alloc_Block(NULL, NULL, "ast", 1681);
  gc_frame_newslot(block6780);
// method "_apply(_)"
  block_savedest(block6780);
  Object closure6781 = createclosure(3, "_apply(1)");
  setclosureframe(closure6781, stackframe);
  addtoclosure(closure6781, var_depth);
  addtoclosure(closure6781, var_s);
  addtoclosure(closure6781, selfslot);
  struct UserObject *uo6781 = (struct UserObject*)block6780;
  uo6781->data[0] = (Object)closure6781;
  Method *meth_meth_ast__apply_40_1_41_6781 = addmethod2pos(block6780, "_apply(1)", &meth_ast__apply_40_1_41_6781, 0);
  int argcv_meth_ast__apply_40_1_41_6781[] = {1};
  meth_meth_ast__apply_40_1_41_6781->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6781);
  meth_meth_ast__apply_40_1_41_6781->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6781->definitionLine = 2969;
// compiled block node returning block6780 (depth = 4)
  gc_frame_newslot(block6780);
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6793 = alloc_Block(NULL, NULL, "ast", 1682);
  gc_frame_newslot(block6793);
// method "_apply"
  block_savedest(block6793);
  Object closure6794 = createclosure(2, "_apply");
  setclosureframe(closure6794, stackframe);
  addtoclosure(closure6794, var_s);
  addtoclosure(closure6794, selfslot);
  struct UserObject *uo6794 = (struct UserObject*)block6793;
  uo6794->data[0] = (Object)closure6794;
  Method *meth_meth_ast__apply6794 = addmethod2pos(block6793, "_apply", &meth_ast__apply6794, 0);
  int argcv_meth_ast__apply6794[] = {0};
  meth_meth_ast__apply6794->type = alloc_MethodType(1, argcv_meth_ast__apply6794);
  meth_meth_ast__apply6794->definitionModule = modulename;
  meth_meth_ast__apply6794->definitionLine = 2969;
// compiled block node returning block6793 (depth = 4)
  gc_frame_newslot(block6793);
// call case 6: other requests
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6801 = gc_frame_new();
// call case 4: self request
  Object call6802 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6801);
// compiled member node returning call6802 (depth = 4)
  params[0] = block6780;
  params[1] = block6793;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6803 = callmethodflags(call6802, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6779);
// compiled call node returning call6803 (depth = 3)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6805 == NULL) {
    strlit6805 = alloc_String(">");
    gc_root(strlit6805);
  }
// compiled string node returning strlit6805 (depth = 4)
  int op_slot_right_6804 = gc_frame_newslot(strlit6805);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6804 = gc_frame_newslot(*var_s);
  params[0] = strlit6805;
  partcv[0] = 1;
  Object opresult6807 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6807 (depth = 3)
  gc_frame_end(frame);
  return opresult6807;
}
Object meth_ast__apply_40_1_41_6812(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6814 == NULL) {
    strlit6814 = alloc_String("");
    gc_root(strlit6814);
  }
// compiled string node returning strlit6814 (depth = 7)
  int op_slot_right_6813 = gc_frame_newslot(strlit6814);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6817 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6818 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6817);
// compiled call node returning call6818 (depth = 8)
  int op_slot_right_6816 = gc_frame_newslot(call6818);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6821 == NULL) {
    strlit6821 = alloc_String("");
    gc_root(strlit6821);
  }
// compiled string node returning strlit6821 (depth = 9)
  int op_slot_right_6820 = gc_frame_newslot(strlit6821);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_6823 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit6825 == NULL) {
    strlit6825 = alloc_String("");
    gc_root(strlit6825);
  }
// compiled string node returning strlit6825 (depth = 10)
  int op_slot_left_6823 = gc_frame_newslot(strlit6825);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6826 = callmethod(strlit6825, "++(1)", 1, partcv, params);
// compiled op node returning opresult6826 (depth = 9)
  int op_slot_left_6820 = gc_frame_newslot(opresult6826);
  params[0] = strlit6821;
  partcv[0] = 1;
  Object opresult6827 = callmethod(opresult6826, "++(1)", 1, partcv, params);
// compiled op node returning opresult6827 (depth = 8)
  int op_slot_left_6816 = gc_frame_newslot(opresult6827);
  params[0] = call6818;
  partcv[0] = 1;
  Object opresult6828 = callmethod(opresult6827, "++(1)", 1, partcv, params);
// compiled op node returning opresult6828 (depth = 7)
  int op_slot_left_6813 = gc_frame_newslot(opresult6828);
  params[0] = strlit6814;
  partcv[0] = 1;
  Object opresult6829 = callmethod(opresult6828, "++(1)", 1, partcv, params);
// compiled op node returning opresult6829 (depth = 6)
  *var_s = opresult6829;
  if (opresult6829 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6833(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6835 == NULL) {
    strlit6835 = alloc_String(", ");
    gc_root(strlit6835);
  }
// compiled string node returning strlit6835 (depth = 7)
  int op_slot_right_6834 = gc_frame_newslot(strlit6835);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6834 = gc_frame_newslot(*var_s);
  params[0] = strlit6835;
  partcv[0] = 1;
  Object opresult6837 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6837 (depth = 6)
  *var_s = opresult6837;
  if (opresult6837 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_6808(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6809 == NULL) {
    strlit6809 = alloc_String("<");
    gc_root(strlit6809);
  }
// compiled string node returning strlit6809 (depth = 4)
  *var_s = strlit6809;
  if (strlit6809 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6810 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6811 = alloc_Block(NULL, NULL, "ast", 1687);
  gc_frame_newslot(block6811);
// method "_apply(_)"
  block_savedest(block6811);
  Object closure6812 = createclosure(3, "_apply(1)");
  setclosureframe(closure6812, stackframe);
  addtoclosure(closure6812, var_depth);
  addtoclosure(closure6812, var_s);
  addtoclosure(closure6812, selfslot);
  struct UserObject *uo6812 = (struct UserObject*)block6811;
  uo6812->data[0] = (Object)closure6812;
  Method *meth_meth_ast__apply_40_1_41_6812 = addmethod2pos(block6811, "_apply(1)", &meth_ast__apply_40_1_41_6812, 0);
  int argcv_meth_ast__apply_40_1_41_6812[] = {1};
  meth_meth_ast__apply_40_1_41_6812->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6812);
  meth_meth_ast__apply_40_1_41_6812->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6812->definitionLine = 2969;
// compiled block node returning block6811 (depth = 4)
  gc_frame_newslot(block6811);
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6832 = alloc_Block(NULL, NULL, "ast", 1688);
  gc_frame_newslot(block6832);
// method "_apply"
  block_savedest(block6832);
  Object closure6833 = createclosure(2, "_apply");
  setclosureframe(closure6833, stackframe);
  addtoclosure(closure6833, var_s);
  addtoclosure(closure6833, selfslot);
  struct UserObject *uo6833 = (struct UserObject*)block6832;
  uo6833->data[0] = (Object)closure6833;
  Method *meth_meth_ast__apply6833 = addmethod2pos(block6832, "_apply", &meth_ast__apply6833, 0);
  int argcv_meth_ast__apply6833[] = {0};
  meth_meth_ast__apply6833->type = alloc_MethodType(1, argcv_meth_ast__apply6833);
  meth_meth_ast__apply6833->definitionModule = modulename;
  meth_meth_ast__apply6833->definitionLine = 2969;
// compiled block node returning block6832 (depth = 4)
  gc_frame_newslot(block6832);
// call case 6: other requests
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6840 = gc_frame_new();
// call case 4: self request
  Object call6841 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6840);
// compiled member node returning call6841 (depth = 4)
  params[0] = block6811;
  params[1] = block6832;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6842 = callmethodflags(call6841, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6810);
// compiled call node returning call6842 (depth = 3)
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6844 == NULL) {
    strlit6844 = alloc_String(">");
    gc_root(strlit6844);
  }
// compiled string node returning strlit6844 (depth = 4)
  int op_slot_right_6843 = gc_frame_newslot(strlit6844);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6843 = gc_frame_newslot(*var_s);
  params[0] = strlit6844;
  partcv[0] = 1;
  Object opresult6846 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6846 (depth = 3)
  gc_frame_end(frame);
  return opresult6846;
}
Object meth_ast_shallowCopy6847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeParametersNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6848 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6849 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeParametersNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6850 = callmethodflags(*var_typeParametersNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6849);
// compiled call node returning call6850 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6851 = callmethodflags(call6850, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6848);
// compiled call node returning call6851 (depth = 3)
  gc_frame_end(frame);
  return call6851;
}
Object meth_ast_new_40_1_41_6700(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6701 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6701 = alloc_userobj2(12,12, objclass6701);
  gc_frame_newslot(obj6701);
if (objclass6701 == NULL) {
  glfree(obj6701->class->name);
  obj6701->class->name = "typeParametersNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6701, self, 0);
  addmethodreal(obj6701,"outer", &reader_ast_outer_6702);
  Object oldself6701 = self;
  struct StackFrameObject *oldstackframe6701 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6701);
  gc_frame_newslot((Object)stackframe);
  self = obj6701;
  Object *oldselfslot6701 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6701 = (*(struct UserObject *)self).data[0], lowerouter6701 = thisouter6701;
  if (inheritingObject6701) {
    struct UserObject *inho6701 = (struct UserObject *)inheritingObject6701;
    while (inho6701->super != GraceDefaultObject) inho6701 = (struct UserObject *)inho6701->super;
    inho6701->super = obj6701;
    self = inheritingObject6701;
    *selfslot = self;
    lowerouter6701 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6701;
  }
if (objclass6701 == NULL) {
  Method *reader6703 = addmethodrealflags(obj6701, "kind",&reader_ast_kind_6703, MFLAG_DEF);
  reader6703->definitionModule = modulename;
  reader6703->definitionLine = 1652;
}
adddatum2(obj6701, alloc_Undefined(), 1);
if (objclass6701 == NULL) {
  Method *reader6704 = addmethodrealflags(obj6701, "params", &reader_ast_params_6704, 0);
  Method *writer6704 = addmethodrealflags(obj6701, "params:=(1)", &writer_ast_params_6704, 0);
  reader6704->definitionModule = modulename;
  writer6704->definitionModule = modulename;
  reader6704->definitionLine = 1653;
  writer6704->definitionLine = 1653;
}
obj6701->flags |= OFLAG_MUTABLE;
adddatum2(obj6701, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo6705 = (struct UserObject*)obj6701;
  uo6705->data[3] = emptyclosure;
  Method *meth_meth_ast_asString6705 = addmethod2pos(obj6701, "asString", &meth_ast_asString6705, 3);
  int argcv_meth_ast_asString6705[] = {0};
  meth_meth_ast_asString6705->type = alloc_MethodType(1, argcv_meth_ast_asString6705);
  meth_meth_ast_asString6705->definitionModule = modulename;
  meth_meth_ast_asString6705->definitionLine = 1654;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj6701);
  Object closure6709 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure6709, stackframe);
  addtoclosure(closure6709, var_k);
  struct UserObject *uo6709 = (struct UserObject*)obj6701;
  uo6709->data[4] = (Object)closure6709;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_6709 = addmethod2pos(obj6701, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_6709, 4);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_6709[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6709->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_6709);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6709->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6709->definitionLine = 1655;
// method "accept(_)from(_)"
  struct UserObject *uo6712 = (struct UserObject*)obj6701;
  uo6712->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6712 = addmethod2pos(obj6701, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6712, 5);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6712[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6712->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6712);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6712->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6712->definitionLine = 1657;
// method "do(_)"
  struct UserObject *uo6727 = (struct UserObject*)obj6701;
  uo6727->data[6] = emptyclosure;
  Method *meth_meth_ast_do_40_1_41_6727 = addmethod2pos(obj6701, "do(1)", &meth_ast_do_40_1_41_6727, 6);
  int argcv_meth_ast_do_40_1_41_6727[] = {1};
  meth_meth_ast_do_40_1_41_6727->type = alloc_MethodType(1, argcv_meth_ast_do_40_1_41_6727);
  meth_meth_ast_do_40_1_41_6727->definitionModule = modulename;
  meth_meth_ast_do_40_1_41_6727->definitionLine = 1665;
// method "size"
  struct UserObject *uo6732 = (struct UserObject*)obj6701;
  uo6732->data[7] = emptyclosure;
  Method *meth_meth_ast_size6732 = addmethod2pos(obj6701, "size", &meth_ast_size6732, 7);
  int argcv_meth_ast_size6732[] = {0};
  meth_meth_ast_size6732->type = alloc_MethodType(1, argcv_meth_ast_size6732);
  meth_meth_ast_size6732->definitionModule = modulename;
  meth_meth_ast_size6732->definitionLine = 1668;
// method "map(_)ancestors(_)"
  struct UserObject *uo6737 = (struct UserObject*)obj6701;
  uo6737->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6737 = addmethod2pos(obj6701, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6737, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6737[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6737->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6737);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6737->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6737->definitionLine = 1669;
// method "pretty(_)"
  struct UserObject *uo6754 = (struct UserObject*)obj6701;
  uo6754->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6754 = addmethod2pos(obj6701, "pretty(1)", &meth_ast_pretty_40_1_41_6754, 9);
  int argcv_meth_ast_pretty_40_1_41_6754[] = {1};
  meth_meth_ast_pretty_40_1_41_6754->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6754);
  meth_meth_ast_pretty_40_1_41_6754->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6754->definitionLine = 1675;
// method "toGrace(_)"
  struct UserObject *uo6808 = (struct UserObject*)obj6701;
  uo6808->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6808 = addmethod2pos(obj6701, "toGrace(1)", &meth_ast_toGrace_40_1_41_6808, 10);
  int argcv_meth_ast_toGrace_40_1_41_6808[] = {1};
  meth_meth_ast_toGrace_40_1_41_6808->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6808);
meth_meth_ast_toGrace_40_1_41_6808->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6808->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6808->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6808->definitionLine = 1685;
// method "shallowCopy"
  block_savedest(obj6701);
  Object closure6847 = createclosure(2, "shallowCopy");
  setclosureframe(closure6847, stackframe);
  addtoclosure(closure6847, var_emptySeq);
  addtoclosure(closure6847, var_typeParametersNode);
  struct UserObject *uo6847 = (struct UserObject*)obj6701;
  uo6847->data[11] = (Object)closure6847;
  Method *meth_meth_ast_shallowCopy6847 = addmethod2pos(obj6701, "shallowCopy", &meth_ast_shallowCopy6847, 11);
  int argcv_meth_ast_shallowCopy6847[] = {0};
  meth_meth_ast_shallowCopy6847->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6847);
  meth_meth_ast_shallowCopy6847->definitionModule = modulename;
  meth_meth_ast_shallowCopy6847->definitionLine = 1691;
  sourceObject = obj6701;
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6852 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6853 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6854 = gc_frame_new();
// call case 3: self.outer request
  Object call6855 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6854);
// compiled member node returning call6855 (depth = 5)
  Object call6856 = callmethodflags(call6855, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6853);
// compiled member node returning call6856 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6857 = callmethodflags(call6856, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6852);
// compiled call node returning call6857 (depth = 3)
  struct UserObject *obj6701_uo = (struct UserObject *)obj6701;
  obj6701_uo->super = call6857;
  sourceObject = obj6701;
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6858 == NULL) {
    strlit6858 = alloc_String("typeparams");
    gc_root(strlit6858);
  }
// compiled string node returning strlit6858 (depth = 3)
  adddatum2(obj6701, strlit6858, 1);
  sourceObject = obj6701;
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj6701, *var_params_39_, 2);
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  objclass6701 = obj6701->class;
  objclass6701->definitionModule = modulename;
  objclass6701->definitionLine = 1650;
  (*(struct UserObject *)self).data[0] = lowerouter6701;
  self = oldself6701;
  selfslot = oldselfslot6701;
  stackframe = oldstackframe6701;
  gc_frame_end(frame);
  return obj6701;
}
Object meth_ast_new_40_1_41_6700_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6701 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6701 = alloc_userobj2(12,12, objclass6701);
  gc_frame_newslot(obj6701);
if (objclass6701 == NULL) {
  glfree(obj6701->class->name);
  obj6701->class->name = "typeParametersNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6701, self, 0);
  addmethodreal(obj6701,"outer", &reader_ast_outer_6702);
  Object oldself6701 = self;
  struct StackFrameObject *oldstackframe6701 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6701);
  gc_frame_newslot((Object)stackframe);
  self = obj6701;
  Object *oldselfslot6701 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6701 = (*(struct UserObject *)self).data[0], lowerouter6701 = thisouter6701;
  if (inheritingObject6701) {
    struct UserObject *inho6701 = (struct UserObject *)inheritingObject6701;
    while (inho6701->super != GraceDefaultObject) inho6701 = (struct UserObject *)inho6701->super;
    inho6701->super = obj6701;
    self = inheritingObject6701;
    *selfslot = self;
    lowerouter6701 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6701;
  }
if (objclass6701 == NULL) {
  Method *reader6703 = addmethodrealflags(obj6701, "kind",&reader_ast_kind_6703, MFLAG_DEF);
  reader6703->definitionModule = modulename;
  reader6703->definitionLine = 1652;
}
adddatum2(obj6701, alloc_Undefined(), 1);
if (objclass6701 == NULL) {
  Method *reader6704 = addmethodrealflags(obj6701, "params", &reader_ast_params_6704, 0);
  Method *writer6704 = addmethodrealflags(obj6701, "params:=(1)", &writer_ast_params_6704, 0);
  reader6704->definitionModule = modulename;
  writer6704->definitionModule = modulename;
  reader6704->definitionLine = 1653;
  writer6704->definitionLine = 1653;
}
obj6701->flags |= OFLAG_MUTABLE;
adddatum2(obj6701, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo6705 = (struct UserObject*)obj6701;
  uo6705->data[3] = emptyclosure;
  Method *meth_meth_ast_asString6705 = addmethod2pos(obj6701, "asString", &meth_ast_asString6705, 3);
  int argcv_meth_ast_asString6705[] = {0};
  meth_meth_ast_asString6705->type = alloc_MethodType(1, argcv_meth_ast_asString6705);
  meth_meth_ast_asString6705->definitionModule = modulename;
  meth_meth_ast_asString6705->definitionLine = 1654;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj6701);
  Object closure6709 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure6709, stackframe);
  addtoclosure(closure6709, var_k);
  struct UserObject *uo6709 = (struct UserObject*)obj6701;
  uo6709->data[4] = (Object)closure6709;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_6709 = addmethod2pos(obj6701, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_6709, 4);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_6709[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6709->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_6709);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6709->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6709->definitionLine = 1655;
// method "accept(_)from(_)"
  struct UserObject *uo6712 = (struct UserObject*)obj6701;
  uo6712->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6712 = addmethod2pos(obj6701, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6712, 5);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6712[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6712->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6712);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6712->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6712->definitionLine = 1657;
// method "do(_)"
  struct UserObject *uo6727 = (struct UserObject*)obj6701;
  uo6727->data[6] = emptyclosure;
  Method *meth_meth_ast_do_40_1_41_6727 = addmethod2pos(obj6701, "do(1)", &meth_ast_do_40_1_41_6727, 6);
  int argcv_meth_ast_do_40_1_41_6727[] = {1};
  meth_meth_ast_do_40_1_41_6727->type = alloc_MethodType(1, argcv_meth_ast_do_40_1_41_6727);
  meth_meth_ast_do_40_1_41_6727->definitionModule = modulename;
  meth_meth_ast_do_40_1_41_6727->definitionLine = 1665;
// method "size"
  struct UserObject *uo6732 = (struct UserObject*)obj6701;
  uo6732->data[7] = emptyclosure;
  Method *meth_meth_ast_size6732 = addmethod2pos(obj6701, "size", &meth_ast_size6732, 7);
  int argcv_meth_ast_size6732[] = {0};
  meth_meth_ast_size6732->type = alloc_MethodType(1, argcv_meth_ast_size6732);
  meth_meth_ast_size6732->definitionModule = modulename;
  meth_meth_ast_size6732->definitionLine = 1668;
// method "map(_)ancestors(_)"
  struct UserObject *uo6737 = (struct UserObject*)obj6701;
  uo6737->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6737 = addmethod2pos(obj6701, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6737, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6737[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6737->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6737);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6737->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6737->definitionLine = 1669;
// method "pretty(_)"
  struct UserObject *uo6754 = (struct UserObject*)obj6701;
  uo6754->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6754 = addmethod2pos(obj6701, "pretty(1)", &meth_ast_pretty_40_1_41_6754, 9);
  int argcv_meth_ast_pretty_40_1_41_6754[] = {1};
  meth_meth_ast_pretty_40_1_41_6754->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6754);
  meth_meth_ast_pretty_40_1_41_6754->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6754->definitionLine = 1675;
// method "toGrace(_)"
  struct UserObject *uo6808 = (struct UserObject*)obj6701;
  uo6808->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6808 = addmethod2pos(obj6701, "toGrace(1)", &meth_ast_toGrace_40_1_41_6808, 10);
  int argcv_meth_ast_toGrace_40_1_41_6808[] = {1};
  meth_meth_ast_toGrace_40_1_41_6808->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6808);
meth_meth_ast_toGrace_40_1_41_6808->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6808->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6808->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6808->definitionLine = 1685;
// method "shallowCopy"
  block_savedest(obj6701);
  Object closure6847 = createclosure(2, "shallowCopy");
  setclosureframe(closure6847, stackframe);
  addtoclosure(closure6847, var_emptySeq);
  addtoclosure(closure6847, var_typeParametersNode);
  struct UserObject *uo6847 = (struct UserObject*)obj6701;
  uo6847->data[11] = (Object)closure6847;
  Method *meth_meth_ast_shallowCopy6847 = addmethod2pos(obj6701, "shallowCopy", &meth_ast_shallowCopy6847, 11);
  int argcv_meth_ast_shallowCopy6847[] = {0};
  meth_meth_ast_shallowCopy6847->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6847);
  meth_meth_ast_shallowCopy6847->definitionModule = modulename;
  meth_meth_ast_shallowCopy6847->definitionLine = 1691;
  sourceObject = obj6701;
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6852 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6853 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6854 = gc_frame_new();
// call case 3: self.outer request
  Object call6855 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6854);
// compiled member node returning call6855 (depth = 5)
  Object call6856 = callmethodflags(call6855, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6853);
// compiled member node returning call6856 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6857 = callmethodflags(call6856, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6852);
// compiled call node returning call6857 (depth = 3)
  struct UserObject *obj6701_uo = (struct UserObject *)obj6701;
  obj6701_uo->super = call6857;
  sourceObject = obj6701;
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6858 == NULL) {
    strlit6858 = alloc_String("typeparams");
    gc_root(strlit6858);
  }
// compiled string node returning strlit6858 (depth = 3)
  adddatum2(obj6701, strlit6858, 1);
  sourceObject = obj6701;
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj6701, *var_params_39_, 2);
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  sourceObject = obj6701;
  objclass6701 = obj6701->class;
  objclass6701->definitionModule = modulename;
  objclass6701->definitionLine = 1650;
  (*(struct UserObject *)self).data[0] = lowerouter6701;
  self = oldself6701;
  selfslot = oldselfslot6701;
  stackframe = oldstackframe6701;
  gc_frame_end(frame);
  return obj6701;
}
Object meth_ast_typeParametersNode6860(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeParametersNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeParametersNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeParametersNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeParametersNode;
}
Object meth_ast_new_40_2_41_scope_40_1_41_6863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[1]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6864 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call6865 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6864);
// compiled call node returning call6865 (depth = 4)
  *var_result = call6865;
  if (call6865 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6866 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6867 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6866);
// compiled call node returning call6867 (depth = 3)
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_nameString6880(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6881 = gc_frame_new();
// call case 4: self request
  Object call6882 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6881);
// compiled member node returning call6882 (depth = 3)
  gc_frame_end(frame);
  return call6882;
}
Object meth_ast_canonicalName6883(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6884 = gc_frame_new();
// call case 4: self request
  Object call6885 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6884);
// compiled member node returning call6885 (depth = 3)
  gc_frame_end(frame);
  return call6885;
}
Object meth_ast_quoted6886(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "quoted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6887 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6888 = gc_frame_new();
// call case 4: self request
  Object call6889 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6888);
// compiled member node returning call6889 (depth = 4)
  Object call6890 = callmethodflags(call6889, "quoted", 0, partcv, params, 0);
  gc_frame_end(callframe6887);
// compiled member node returning call6890 (depth = 3)
  gc_frame_end(frame);
  return call6890;
}
Object meth_ast_isIdentifier6891(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6892 = alloc_Boolean(1);
// compiled identifier node returning bool6892 (depth = 3)
  gc_frame_end(frame);
  return bool6892;
}
Object meth_ast_isSelf6893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6895 = gc_frame_new();
// call case 4: self request
  Object call6896 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6895);
// compiled member node returning call6896 (depth = 4)
  int op_slot_right_6894 = gc_frame_newslot(call6896);
// starting to compile string node (depth = 4)
  if (strlit6898 == NULL) {
    strlit6898 = alloc_String("self");
    gc_root(strlit6898);
  }
// compiled string node returning strlit6898 (depth = 4)
  int op_slot_left_6894 = gc_frame_newslot(strlit6898);
  params[0] = call6896;
  partcv[0] = 1;
  Object opresult6899 = callmethod(strlit6898, "==(1)", 1, partcv, params);
// compiled op node returning opresult6899 (depth = 3)
  gc_frame_end(frame);
  return opresult6899;
}
Object meth_ast_isSuper6900(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuper");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6902 = gc_frame_new();
// call case 4: self request
  Object call6903 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6902);
// compiled member node returning call6903 (depth = 4)
  int op_slot_right_6901 = gc_frame_newslot(call6903);
// starting to compile string node (depth = 4)
  if (strlit6905 == NULL) {
    strlit6905 = alloc_String("super");
    gc_root(strlit6905);
  }
// compiled string node returning strlit6905 (depth = 4)
  int op_slot_left_6901 = gc_frame_newslot(strlit6905);
  params[0] = call6903;
  partcv[0] = 1;
  Object opresult6906 = callmethod(strlit6905, "==(1)", 1, partcv, params);
// compiled op node returning opresult6906 (depth = 3)
  gc_frame_end(frame);
  return opresult6906;
}
Object meth_ast_isPrelude6907(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPrelude");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6909 = gc_frame_new();
// call case 4: self request
  Object call6910 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6909);
// compiled member node returning call6910 (depth = 4)
  int op_slot_right_6908 = gc_frame_newslot(call6910);
// starting to compile string node (depth = 4)
  if (strlit6912 == NULL) {
    strlit6912 = alloc_String("prelude");
    gc_root(strlit6912);
  }
// compiled string node returning strlit6912 (depth = 4)
  int op_slot_left_6908 = gc_frame_newslot(strlit6912);
  params[0] = call6910;
  partcv[0] = 1;
  Object opresult6913 = callmethod(strlit6912, "==(1)", 1, partcv, params);
// compiled op node returning opresult6913 (depth = 3)
  gc_frame_end(frame);
  return opresult6913;
}
Object meth_ast_isOuter6914(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6916 = gc_frame_new();
// call case 4: self request
  Object call6917 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6916);
// compiled member node returning call6917 (depth = 4)
  int op_slot_right_6915 = gc_frame_newslot(call6917);
// starting to compile string node (depth = 4)
  if (strlit6919 == NULL) {
    strlit6919 = alloc_String("outer");
    gc_root(strlit6919);
  }
// compiled string node returning strlit6919 (depth = 4)
  int op_slot_left_6915 = gc_frame_newslot(strlit6919);
  params[0] = call6917;
  partcv[0] = 1;
  Object opresult6920 = callmethod(strlit6919, "==(1)", 1, partcv, params);
// compiled op node returning opresult6920 (depth = 3)
  gc_frame_end(frame);
  return opresult6920;
}
Object meth_ast_isAppliedOccurenceOfIdentifier6921(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6923 = gc_frame_new();
// call case 4: self request
  Object call6924 = callmethodflags(self, "wildcard", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6923);
// compiled member node returning call6924 (depth = 4)
  Object if6922 = done;
  if (istrue(call6924)) {
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6925 = alloc_Boolean(0);
// compiled identifier node returning bool6925 (depth = 4)
    gc_frame_newslot(bool6925);
    if6922 = bool6925;
  } else {
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6926 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6927 = gc_frame_new();
// call case 4: self request
  Object call6928 = callmethodflags(self, "isBindingOccurrence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6927);
// compiled member node returning call6928 (depth = 5)
  Object call6929 = callmethodflags(call6928, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6926);
// compiled member node returning call6929 (depth = 4)
    gc_frame_newslot(call6929);
    if6922 = call6929;
  }
// compiled if node returning if6922 (depth = 3)
  gc_frame_end(frame);
  return if6922;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_6930(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6931 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6932 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  Object call6933 = callmethodflags(*var_as, "parent", 0, partcv, params, 0);
  gc_frame_end(callframe6932);
// compiled member node returning call6933 (depth = 4)
  params[0] = *var_as;
  partcv[0] = 1;
  Object call6934 = callmethodflags(call6933, "declarationKindWithAncestors(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6931);
// compiled call node returning call6934 (depth = 3)
  gc_frame_end(frame);
  return call6934;
}
Object meth_ast_inTypePositionWithAncestors_40_1_41_6935(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTypePositionWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inTypePositionWithAncestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inTypePositionWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part inTypePositionWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6937 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  Object call6938 = callmethodflags(*var_as, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe6937);
// compiled member node returning call6938 (depth = 4)
  Object if6936 = done;
  if (istrue(call6938)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6939 = alloc_Boolean(0);
// compiled identifier node returning bool6939 (depth = 5)
  return bool6939;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6936 = undefined;
  } else {
  }
// compiled if node returning if6936 (depth = 3)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6940 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6941 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  Object call6942 = callmethodflags(*var_as, "parent", 0, partcv, params, 0);
  gc_frame_end(callframe6941);
// compiled member node returning call6942 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6943 = callmethodflags(call6942, "usesAsType(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6940);
// compiled call node returning call6943 (depth = 3)
  gc_frame_end(frame);
  return call6943;
}
Object meth_ast_usesAsType_40_1_41_6944(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6946 = gc_frame_new();
// call case 4: self request
  Object call6947 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6946);
// compiled member node returning call6947 (depth = 4)
  int op_slot_right_6945 = gc_frame_newslot(call6947);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_6945 = gc_frame_newslot(*var_aNode);
  params[0] = call6947;
  partcv[0] = 1;
  Object opresult6949 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult6949 (depth = 3)
  gc_frame_end(frame);
  return opresult6949;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6950(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6952 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6953 = callmethodflags(*var_visitor, "visitIdentifier(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6952);
// compiled call node returning call6953 (depth = 4)
  Object if6951 = done;
  if (istrue(call6953)) {
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6954 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6955 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6954);
// compiled call node returning call6955 (depth = 5)
  *var_newChain = call6955;
  if (call6955 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6958 = gc_frame_new();
// call case 4: self request
  Object call6959 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6958);
// compiled member node returning call6959 (depth = 6)
  int op_slot_right_6957 = gc_frame_newslot(call6959);
// starting to compile identifier node (depth = 6)
  Object bool6961 = alloc_Boolean(0);
// compiled identifier node returning bool6961 (depth = 6)
  int op_slot_left_6957 = gc_frame_newslot(bool6961);
  params[0] = call6959;
  partcv[0] = 1;
  Object opresult6962 = callmethod(bool6961, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6962 (depth = 5)
  Object if6956 = done;
  if (istrue(opresult6962)) {
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6963 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6964 = gc_frame_new();
// call case 4: self request
  Object call6965 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6964);
// compiled member node returning call6965 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6966 = callmethodflags(call6965, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6963);
// compiled call node returning call6966 (depth = 5)
    gc_frame_newslot(call6966);
    if6956 = call6966;
  } else {
  }
// compiled if node returning if6956 (depth = 4)
    gc_frame_newslot(if6956);
    if6951 = if6956;
  } else {
  }
// compiled if node returning if6951 (depth = 3)
  gc_frame_end(frame);
  return if6951;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6967(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6968 = gc_frame_new();
// call case 4: self request
  Object call6969 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6968);
// compiled member node returning call6969 (depth = 4)
  *var_n = call6969;
  if (call6969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6970 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6971 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6970);
// compiled call node returning call6971 (depth = 4)
  *var_newChain = call6971;
  if (call6971 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6972 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6973 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6974 = gc_frame_new();
// call case 4: self request
  Object call6975 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6974);
// compiled member node returning call6975 (depth = 5)
  gc_frame_newslot(call6975);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6976 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6977 = gc_frame_new();
// call case 3: self.outer request
  Object call6978 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6977);
// compiled member node returning call6978 (depth = 6)
  Object call6979 = callmethodflags(call6978, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6976);
// compiled member node returning call6979 (depth = 5)
  params[0] = call6975;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6980 = callmethodflags(call6979, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6973);
// compiled call node returning call6980 (depth = 4)
  gc_frame_newslot(call6980);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6980;
  partcv[0] = 1;
  Object call6981 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6972);
// compiled call node returning call6981 (depth = 3)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6982 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6983 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6982);
// compiled call node returning call6983 (depth = 3)
  gc_frame_end(frame);
  return call6983;
}
Object meth_ast__apply_40_1_41_6992(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6994 == NULL) {
    strlit6994 = alloc_String("  ");
    gc_root(strlit6994);
  }
// compiled string node returning strlit6994 (depth = 7)
  int op_slot_right_6993 = gc_frame_newslot(strlit6994);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6993 = gc_frame_newslot(*var_spc);
  params[0] = strlit6994;
  partcv[0] = 1;
  Object opresult6996 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6996 (depth = 6)
  *var_spc = opresult6996;
  if (opresult6996 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_7095(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7097 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7099 = alloc_Float64(2);
// compiled num node returning num7099 (depth = 10)
  int op_slot_right_7098 = gc_frame_newslot(num7099);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7098 = gc_frame_newslot(*var_depth);
  params[0] = num7099;
  partcv[0] = 1;
  Object sum7101 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7101 (depth = 9)
  gc_frame_newslot(sum7101);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = sum7101;
  partcv[0] = 1;
  Object call7102 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7097);
// compiled call node returning call7102 (depth = 8)
  int op_slot_right_7096 = gc_frame_newslot(call7102);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7105 == NULL) {
    strlit7105 = alloc_String("  ");
    gc_root(strlit7105);
  }
// compiled string node returning strlit7105 (depth = 9)
  int op_slot_right_7104 = gc_frame_newslot(strlit7105);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_7107 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7110 == NULL) {
    strlit7110 = alloc_String("""\x0a""");
    gc_root(strlit7110);
  }
// compiled string node returning strlit7110 (depth = 11)
  int op_slot_right_7109 = gc_frame_newslot(strlit7110);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_7109 = gc_frame_newslot(*var_s);
  params[0] = strlit7110;
  partcv[0] = 1;
  Object opresult7112 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7112 (depth = 10)
  int op_slot_left_7107 = gc_frame_newslot(opresult7112);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7113 = callmethod(opresult7112, "++(1)", 1, partcv, params);
// compiled op node returning opresult7113 (depth = 9)
  int op_slot_left_7104 = gc_frame_newslot(opresult7113);
  params[0] = strlit7105;
  partcv[0] = 1;
  Object opresult7114 = callmethod(opresult7113, "++(1)", 1, partcv, params);
// compiled op node returning opresult7114 (depth = 8)
  int op_slot_left_7096 = gc_frame_newslot(opresult7114);
  params[0] = call7102;
  partcv[0] = 1;
  Object opresult7115 = callmethod(opresult7114, "++(1)", 1, partcv, params);
// compiled op node returning opresult7115 (depth = 7)
  *var_s = opresult7115;
  if (opresult7115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6984(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6985 == NULL) {
    strlit6985 = alloc_String("");
    gc_root(strlit6985);
  }
// compiled string node returning strlit6985 (depth = 4)
  *var_spc = strlit6985;
  if (strlit6985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6986 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6987 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6989 = alloc_Float64(0);
// compiled num node returning num6989 (depth = 5)
  int op_slot_left_6987 = gc_frame_newslot(num6989);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6990 = callmethod(num6989, "..(1)", 1, partcv, params);
// compiled op node returning opresult6990 (depth = 4)
  gc_frame_newslot(opresult6990);
// starting to compile block node (depth = 4)
  Object block6991 = alloc_Block(NULL, NULL, "ast", 1762);
  gc_frame_newslot(block6991);
// method "_apply(_)"
  block_savedest(block6991);
  Object closure6992 = createclosure(2, "_apply(1)");
  setclosureframe(closure6992, stackframe);
  addtoclosure(closure6992, var_spc);
  addtoclosure(closure6992, selfslot);
  struct UserObject *uo6992 = (struct UserObject*)block6991;
  uo6992->data[0] = (Object)closure6992;
  Method *meth_meth_ast__apply_40_1_41_6992 = addmethod2pos(block6991, "_apply(1)", &meth_ast__apply_40_1_41_6992, 0);
  int argcv_meth_ast__apply_40_1_41_6992[] = {1};
  meth_meth_ast__apply_40_1_41_6992->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6992);
  meth_meth_ast__apply_40_1_41_6992->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6992->definitionLine = 2969;
// compiled block node returning block6991 (depth = 4)
  gc_frame_newslot(block6991);
// call case 5: prelude request
  params[0] = opresult6990;
  params[1] = block6991;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6999 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6986);
// compiled call node returning call6999 (depth = 3)
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7000 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7001 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7000);
// compiled call node returning call7001 (depth = 4)
  *var_s = call7001;
  if (call7001 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7003 = gc_frame_new();
// call case 4: self request
  Object call7004 = callmethodflags(self, "wildcard", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7003);
// compiled member node returning call7004 (depth = 4)
  Object if7002 = done;
  if (istrue(call7004)) {
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7006 == NULL) {
    strlit7006 = alloc_String(" Wildcard");
    gc_root(strlit7006);
  }
// compiled string node returning strlit7006 (depth = 6)
  int op_slot_right_7005 = gc_frame_newslot(strlit7006);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7005 = gc_frame_newslot(*var_s);
  params[0] = strlit7006;
  partcv[0] = 1;
  Object opresult7008 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7008 (depth = 5)
  *var_s = opresult7008;
  if (opresult7008 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7002 = done;
  } else {
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7011 = gc_frame_new();
// call case 4: self request
  Object call7012 = callmethodflags(self, "isBindingOccurrence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7011);
// compiled member node returning call7012 (depth = 5)
  Object if7010 = done;
  if (istrue(call7012)) {
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7015 == NULL) {
    strlit7015 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7015);
  }
// compiled string node returning strlit7015 (depth = 8)
  int op_slot_right_7014 = gc_frame_newslot(strlit7015);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7018 = gc_frame_new();
// call case 4: self request
  Object call7019 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7018);
// compiled member node returning call7019 (depth = 9)
  int op_slot_right_7017 = gc_frame_newslot(call7019);
// starting to compile string node (depth = 9)
  if (strlit7021 == NULL) {
    strlit7021 = alloc_String("Binding""\xe2""""\x80""""\xb9""");
    gc_root(strlit7021);
  }
// compiled string node returning strlit7021 (depth = 9)
  int op_slot_left_7017 = gc_frame_newslot(strlit7021);
  params[0] = call7019;
  partcv[0] = 1;
  Object opresult7022 = callmethod(strlit7021, "++(1)", 1, partcv, params);
// compiled op node returning opresult7022 (depth = 8)
  int op_slot_left_7014 = gc_frame_newslot(opresult7022);
  params[0] = strlit7015;
  partcv[0] = 1;
  Object opresult7023 = callmethod(opresult7022, "++(1)", 1, partcv, params);
// compiled op node returning opresult7023 (depth = 7)
  int op_slot_right_7013 = gc_frame_newslot(opresult7023);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7013 = gc_frame_newslot(*var_s);
  params[0] = opresult7023;
  partcv[0] = 1;
  Object opresult7025 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7025 (depth = 6)
  *var_s = opresult7025;
  if (opresult7025 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7010 = done;
  } else {
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7029 == NULL) {
    strlit7029 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7029);
  }
// compiled string node returning strlit7029 (depth = 8)
  int op_slot_right_7028 = gc_frame_newslot(strlit7029);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7032 = gc_frame_new();
// call case 4: self request
  Object call7033 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7032);
// compiled member node returning call7033 (depth = 9)
  int op_slot_right_7031 = gc_frame_newslot(call7033);
// starting to compile string node (depth = 9)
  if (strlit7035 == NULL) {
    strlit7035 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7035);
  }
// compiled string node returning strlit7035 (depth = 9)
  int op_slot_left_7031 = gc_frame_newslot(strlit7035);
  params[0] = call7033;
  partcv[0] = 1;
  Object opresult7036 = callmethod(strlit7035, "++(1)", 1, partcv, params);
// compiled op node returning opresult7036 (depth = 8)
  int op_slot_left_7028 = gc_frame_newslot(opresult7036);
  params[0] = strlit7029;
  partcv[0] = 1;
  Object opresult7037 = callmethod(opresult7036, "++(1)", 1, partcv, params);
// compiled op node returning opresult7037 (depth = 7)
  int op_slot_right_7027 = gc_frame_newslot(opresult7037);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7027 = gc_frame_newslot(*var_s);
  params[0] = opresult7037;
  partcv[0] = 1;
  Object opresult7039 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7039 (depth = 6)
  *var_s = opresult7039;
  if (opresult7039 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7010 = done;
  }
// compiled if node returning if7010 (depth = 4)
    gc_frame_newslot(if7010);
    if7002 = if7010;
  }
// compiled if node returning if7002 (depth = 3)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7043 = gc_frame_new();
// call case 4: self request
  Object call7044 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7043);
// compiled member node returning call7044 (depth = 5)
  int op_slot_right_7042 = gc_frame_newslot(call7044);
// starting to compile identifier node (depth = 5)
  Object bool7046 = alloc_Boolean(0);
// compiled identifier node returning bool7046 (depth = 5)
  int op_slot_left_7042 = gc_frame_newslot(bool7046);
  params[0] = call7044;
  partcv[0] = 1;
  Object opresult7047 = callmethod(bool7046, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7047 (depth = 4)
  Object if7041 = done;
  if (istrue(opresult7047)) {
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7049 == NULL) {
    strlit7049 = alloc_String("  Type: ");
    gc_root(strlit7049);
  }
// compiled string node returning strlit7049 (depth = 6)
  int op_slot_right_7048 = gc_frame_newslot(strlit7049);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7051 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7054 == NULL) {
    strlit7054 = alloc_String("""\x0a""");
    gc_root(strlit7054);
  }
// compiled string node returning strlit7054 (depth = 8)
  int op_slot_right_7053 = gc_frame_newslot(strlit7054);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7053 = gc_frame_newslot(*var_s);
  params[0] = strlit7054;
  partcv[0] = 1;
  Object opresult7056 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7056 (depth = 7)
  int op_slot_left_7051 = gc_frame_newslot(opresult7056);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7057 = callmethod(opresult7056, "++(1)", 1, partcv, params);
// compiled op node returning opresult7057 (depth = 6)
  int op_slot_left_7048 = gc_frame_newslot(opresult7057);
  params[0] = strlit7049;
  partcv[0] = 1;
  Object opresult7058 = callmethod(opresult7057, "++(1)", 1, partcv, params);
// compiled op node returning opresult7058 (depth = 5)
  *var_s = opresult7058;
  if (opresult7058 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7061 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7063 = alloc_Float64(2);
// compiled num node returning num7063 (depth = 8)
  int op_slot_right_7062 = gc_frame_newslot(num7063);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7062 = gc_frame_newslot(*var_depth);
  params[0] = num7063;
  partcv[0] = 1;
  Object sum7065 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7065 (depth = 7)
  gc_frame_newslot(sum7065);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7066 = gc_frame_new();
// call case 4: self request
  Object call7067 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7066);
// compiled member node returning call7067 (depth = 7)
  params[0] = sum7065;
  partcv[0] = 1;
  Object call7068 = callmethodflags(call7067, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7061);
// compiled call node returning call7068 (depth = 6)
  int op_slot_right_7060 = gc_frame_newslot(call7068);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7060 = gc_frame_newslot(*var_s);
  params[0] = call7068;
  partcv[0] = 1;
  Object opresult7070 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7070 (depth = 5)
  *var_s = opresult7070;
  if (opresult7070 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7041 = done;
  } else {
  }
// compiled if node returning if7041 (depth = 3)
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7074 = gc_frame_new();
// call case 4: self request
  Object call7075 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7074);
// compiled member node returning call7075 (depth = 5)
  int op_slot_right_7073 = gc_frame_newslot(call7075);
// starting to compile identifier node (depth = 5)
  Object bool7077 = alloc_Boolean(0);
// compiled identifier node returning bool7077 (depth = 5)
  int op_slot_left_7073 = gc_frame_newslot(bool7077);
  params[0] = call7075;
  partcv[0] = 1;
  Object opresult7078 = callmethod(bool7077, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7078 (depth = 4)
  Object if7072 = done;
  if (istrue(opresult7078)) {
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7080 == NULL) {
    strlit7080 = alloc_String("Generics:");
    gc_root(strlit7080);
  }
// compiled string node returning strlit7080 (depth = 6)
  int op_slot_right_7079 = gc_frame_newslot(strlit7080);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7082 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7085 == NULL) {
    strlit7085 = alloc_String("""\x0a""");
    gc_root(strlit7085);
  }
// compiled string node returning strlit7085 (depth = 8)
  int op_slot_right_7084 = gc_frame_newslot(strlit7085);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7084 = gc_frame_newslot(*var_s);
  params[0] = strlit7085;
  partcv[0] = 1;
  Object opresult7087 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7087 (depth = 7)
  int op_slot_left_7082 = gc_frame_newslot(opresult7087);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7088 = callmethod(opresult7087, "++(1)", 1, partcv, params);
// compiled op node returning opresult7088 (depth = 6)
  int op_slot_left_7079 = gc_frame_newslot(opresult7088);
  params[0] = strlit7080;
  partcv[0] = 1;
  Object opresult7089 = callmethod(opresult7088, "++(1)", 1, partcv, params);
// compiled op node returning opresult7089 (depth = 5)
  *var_s = opresult7089;
  if (opresult7089 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7091 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7092 = gc_frame_new();
// call case 4: self request
  Object call7093 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7092);
// compiled member node returning call7093 (depth = 5)
  gc_frame_newslot(call7093);
// starting to compile block node (depth = 5)
  Object block7094 = alloc_Block(NULL, NULL, "ast", 1779);
  gc_frame_newslot(block7094);
// method "_apply(_)"
  block_savedest(block7094);
  Object closure7095 = createclosure(4, "_apply(1)");
  setclosureframe(closure7095, stackframe);
  addtoclosure(closure7095, var_depth);
  addtoclosure(closure7095, var_spc);
  addtoclosure(closure7095, var_s);
  addtoclosure(closure7095, selfslot);
  struct UserObject *uo7095 = (struct UserObject*)block7094;
  uo7095->data[0] = (Object)closure7095;
  Method *meth_meth_ast__apply_40_1_41_7095 = addmethod2pos(block7094, "_apply(1)", &meth_ast__apply_40_1_41_7095, 0);
  int argcv_meth_ast__apply_40_1_41_7095[] = {1};
  meth_meth_ast__apply_40_1_41_7095->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7095);
  meth_meth_ast__apply_40_1_41_7095->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7095->definitionLine = 2969;
// compiled block node returning block7094 (depth = 5)
  gc_frame_newslot(block7094);
// call case 5: prelude request
  params[0] = call7093;
  params[1] = block7094;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7118 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7091);
// compiled call node returning call7118 (depth = 4)
    gc_frame_newslot(call7118);
    if7072 = call7118;
  } else {
  }
// compiled if node returning if7072 (depth = 3)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_7177(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7179 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7181 = alloc_Float64(1);
// compiled num node returning num7181 (depth = 10)
  int op_slot_right_7180 = gc_frame_newslot(num7181);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7180 = gc_frame_newslot(*var_depth);
  params[0] = num7181;
  partcv[0] = 1;
  Object sum7183 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7183 (depth = 9)
  gc_frame_newslot(sum7183);
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe7184 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe7185 = gc_frame_new();
// call case 4: self request
  Object call7186 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7185);
// compiled member node returning call7186 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call7187 = callmethodflags(call7186, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7184);
// compiled call node returning call7187 (depth = 9)
  params[0] = sum7183;
  partcv[0] = 1;
  Object call7188 = callmethodflags(call7187, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7179);
// compiled call node returning call7188 (depth = 8)
  int op_slot_right_7178 = gc_frame_newslot(call7188);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7178 = gc_frame_newslot(*var_s);
  params[0] = call7188;
  partcv[0] = 1;
  Object opresult7190 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7190 (depth = 7)
  *var_s = opresult7190;
  if (opresult7190 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_7119(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_s = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7121 = gc_frame_new();
// call case 4: self request
  Object call7122 = callmethodflags(self, "wildcard", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7121);
// compiled member node returning call7122 (depth = 4)
  Object if7120 = done;
  if (istrue(call7122)) {
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7123 == NULL) {
    strlit7123 = alloc_String("_");
    gc_root(strlit7123);
  }
// compiled string node returning strlit7123 (depth = 5)
  *var_s = strlit7123;
  if (strlit7123 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7120 = done;
  } else {
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7125 = gc_frame_new();
// call case 4: self request
  Object call7126 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7125);
// compiled member node returning call7126 (depth = 5)
  *var_s = call7126;
  if (call7126 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7120 = done;
  }
// compiled if node returning if7120 (depth = 3)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7130 = gc_frame_new();
// call case 4: self request
  Object call7131 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7130);
// compiled member node returning call7131 (depth = 5)
  int op_slot_right_7129 = gc_frame_newslot(call7131);
// starting to compile identifier node (depth = 5)
  Object bool7133 = alloc_Boolean(0);
// compiled identifier node returning bool7133 (depth = 5)
  int op_slot_left_7129 = gc_frame_newslot(bool7133);
  params[0] = call7131;
  partcv[0] = 1;
  Object opresult7134 = callmethod(bool7133, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7134 (depth = 4)
  Object if7128 = done;
  if (istrue(opresult7134)) {
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7136 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7138 = alloc_Float64(1);
// compiled num node returning num7138 (depth = 8)
  int op_slot_right_7137 = gc_frame_newslot(num7138);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7137 = gc_frame_newslot(*var_depth);
  params[0] = num7138;
  partcv[0] = 1;
  Object sum7140 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7140 (depth = 7)
  gc_frame_newslot(sum7140);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7141 = gc_frame_new();
// call case 4: self request
  Object call7142 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7141);
// compiled member node returning call7142 (depth = 7)
  params[0] = sum7140;
  partcv[0] = 1;
  Object call7143 = callmethodflags(call7142, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7136);
// compiled call node returning call7143 (depth = 6)
  int op_slot_right_7135 = gc_frame_newslot(call7143);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7146 == NULL) {
    strlit7146 = alloc_String(" : ");
    gc_root(strlit7146);
  }
// compiled string node returning strlit7146 (depth = 7)
  int op_slot_right_7145 = gc_frame_newslot(strlit7146);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7145 = gc_frame_newslot(*var_s);
  params[0] = strlit7146;
  partcv[0] = 1;
  Object opresult7148 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7148 (depth = 6)
  int op_slot_left_7135 = gc_frame_newslot(opresult7148);
  params[0] = call7143;
  partcv[0] = 1;
  Object opresult7149 = callmethod(opresult7148, "++(1)", 1, partcv, params);
// compiled op node returning opresult7149 (depth = 5)
  *var_s = opresult7149;
  if (opresult7149 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7128 = done;
  } else {
  }
// compiled if node returning if7128 (depth = 3)
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7153 = gc_frame_new();
// call case 4: self request
  Object call7154 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7153);
// compiled member node returning call7154 (depth = 5)
  int op_slot_right_7152 = gc_frame_newslot(call7154);
// starting to compile identifier node (depth = 5)
  Object bool7156 = alloc_Boolean(0);
// compiled identifier node returning bool7156 (depth = 5)
  int op_slot_left_7152 = gc_frame_newslot(bool7156);
  params[0] = call7154;
  partcv[0] = 1;
  Object opresult7157 = callmethod(bool7156, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7157 (depth = 4)
  Object if7151 = done;
  if (istrue(opresult7157)) {
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7159 == NULL) {
    strlit7159 = alloc_String("<");
    gc_root(strlit7159);
  }
// compiled string node returning strlit7159 (depth = 6)
  int op_slot_right_7158 = gc_frame_newslot(strlit7159);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7158 = gc_frame_newslot(*var_s);
  params[0] = strlit7159;
  partcv[0] = 1;
  Object opresult7161 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7161 (depth = 5)
  *var_s = opresult7161;
  if (opresult7161 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7163 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7166 = alloc_Float64(1);
// compiled num node returning num7166 (depth = 7)
  int op_slot_right_7165 = gc_frame_newslot(num7166);
// starting to compile member node (depth = 7)
  int callframe7168 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7169 = gc_frame_new();
// call case 4: self request
  Object call7170 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7169);
// compiled member node returning call7170 (depth = 8)
  Object call7171 = callmethodflags(call7170, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7168);
// compiled member node returning call7171 (depth = 7)
  int op_slot_left_7165 = gc_frame_newslot(call7171);
  params[0] = num7166;
  partcv[0] = 1;
  Object diff7172 = callmethod(call7171, "-(1)", 1, partcv, params);
// compiled op node returning diff7172 (depth = 6)
  int op_slot_right_7164 = gc_frame_newslot(diff7172);
// starting to compile num node (depth = 6)
  Object num7174 = alloc_Float64(1);
// compiled num node returning num7174 (depth = 6)
  int op_slot_left_7164 = gc_frame_newslot(num7174);
  params[0] = diff7172;
  partcv[0] = 1;
  Object opresult7175 = callmethod(num7174, "..(1)", 1, partcv, params);
// compiled op node returning opresult7175 (depth = 5)
  gc_frame_newslot(opresult7175);
// starting to compile block node (depth = 5)
  Object block7176 = alloc_Block(NULL, NULL, "ast", 1797);
  gc_frame_newslot(block7176);
// method "_apply(_)"
  block_savedest(block7176);
  Object closure7177 = createclosure(3, "_apply(1)");
  setclosureframe(closure7177, stackframe);
  addtoclosure(closure7177, var_depth);
  addtoclosure(closure7177, var_s);
  addtoclosure(closure7177, selfslot);
  struct UserObject *uo7177 = (struct UserObject*)block7176;
  uo7177->data[0] = (Object)closure7177;
  Method *meth_meth_ast__apply_40_1_41_7177 = addmethod2pos(block7176, "_apply(1)", &meth_ast__apply_40_1_41_7177, 0);
  int argcv_meth_ast__apply_40_1_41_7177[] = {1};
  meth_meth_ast__apply_40_1_41_7177->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7177);
  meth_meth_ast__apply_40_1_41_7177->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7177->definitionLine = 2969;
// compiled block node returning block7176 (depth = 5)
  gc_frame_newslot(block7176);
// call case 5: prelude request
  params[0] = opresult7175;
  params[1] = block7176;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7193 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7163);
// compiled call node returning call7193 (depth = 4)
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7195 == NULL) {
    strlit7195 = alloc_String(">");
    gc_root(strlit7195);
  }
// compiled string node returning strlit7195 (depth = 6)
  int op_slot_right_7194 = gc_frame_newslot(strlit7195);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7198 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7200 = alloc_Float64(1);
// compiled num node returning num7200 (depth = 9)
  int op_slot_right_7199 = gc_frame_newslot(num7200);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7199 = gc_frame_newslot(*var_depth);
  params[0] = num7200;
  partcv[0] = 1;
  Object sum7202 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7202 (depth = 8)
  gc_frame_newslot(sum7202);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7203 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe7204 = gc_frame_new();
// call case 4: self request
  Object call7205 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7204);
// compiled member node returning call7205 (depth = 9)
  Object call7206 = callmethodflags(call7205, "last", 0, partcv, params, 0);
  gc_frame_end(callframe7203);
// compiled member node returning call7206 (depth = 8)
  params[0] = sum7202;
  partcv[0] = 1;
  Object call7207 = callmethodflags(call7206, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7198);
// compiled call node returning call7207 (depth = 7)
  int op_slot_right_7197 = gc_frame_newslot(call7207);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7197 = gc_frame_newslot(*var_s);
  params[0] = call7207;
  partcv[0] = 1;
  Object opresult7209 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7209 (depth = 6)
  int op_slot_left_7194 = gc_frame_newslot(opresult7209);
  params[0] = strlit7195;
  partcv[0] = 1;
  Object opresult7210 = callmethod(opresult7209, "++(1)", 1, partcv, params);
// compiled op node returning opresult7210 (depth = 5)
  *var_s = opresult7210;
  if (opresult7210 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7151 = done;
  } else {
  }
// compiled if node returning if7151 (depth = 3)
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString7212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7214 = gc_frame_new();
// call case 4: self request
  Object call7215 = callmethodflags(self, "isBindingOccurrence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7214);
// compiled member node returning call7215 (depth = 4)
  Object if7213 = done;
  if (istrue(call7215)) {
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7217 == NULL) {
    strlit7217 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7217);
  }
// compiled string node returning strlit7217 (depth = 5)
  int op_slot_right_7216 = gc_frame_newslot(strlit7217);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7220 = gc_frame_new();
// call case 4: self request
  Object call7221 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7220);
// compiled member node returning call7221 (depth = 6)
  int op_slot_right_7219 = gc_frame_newslot(call7221);
// starting to compile string node (depth = 6)
  if (strlit7223 == NULL) {
    strlit7223 = alloc_String("identifierBinding""\xe2""""\x80""""\xb9""");
    gc_root(strlit7223);
  }
// compiled string node returning strlit7223 (depth = 6)
  int op_slot_left_7219 = gc_frame_newslot(strlit7223);
  params[0] = call7221;
  partcv[0] = 1;
  Object opresult7224 = callmethod(strlit7223, "++(1)", 1, partcv, params);
// compiled op node returning opresult7224 (depth = 5)
  int op_slot_left_7216 = gc_frame_newslot(opresult7224);
  params[0] = strlit7217;
  partcv[0] = 1;
  Object opresult7225 = callmethod(opresult7224, "++(1)", 1, partcv, params);
// compiled op node returning opresult7225 (depth = 4)
    gc_frame_newslot(opresult7225);
    if7213 = opresult7225;
  } else {
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7227 == NULL) {
    strlit7227 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7227);
  }
// compiled string node returning strlit7227 (depth = 5)
  int op_slot_right_7226 = gc_frame_newslot(strlit7227);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7230 = gc_frame_new();
// call case 4: self request
  Object call7231 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7230);
// compiled member node returning call7231 (depth = 6)
  int op_slot_right_7229 = gc_frame_newslot(call7231);
// starting to compile string node (depth = 6)
  if (strlit7233 == NULL) {
    strlit7233 = alloc_String("identifier""\xe2""""\x80""""\xb9""");
    gc_root(strlit7233);
  }
// compiled string node returning strlit7233 (depth = 6)
  int op_slot_left_7229 = gc_frame_newslot(strlit7233);
  params[0] = call7231;
  partcv[0] = 1;
  Object opresult7234 = callmethod(strlit7233, "++(1)", 1, partcv, params);
// compiled op node returning opresult7234 (depth = 5)
  int op_slot_left_7226 = gc_frame_newslot(opresult7234);
  params[0] = strlit7227;
  partcv[0] = 1;
  Object opresult7235 = callmethod(opresult7234, "++(1)", 1, partcv, params);
// compiled op node returning opresult7235 (depth = 4)
    gc_frame_newslot(opresult7235);
    if7213 = opresult7235;
  }
// compiled if node returning if7213 (depth = 3)
  gc_frame_end(frame);
  return if7213;
}
Object meth_ast_shallowCopy7236(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7237 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7238 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7239 = gc_frame_new();
// call case 4: self request
  Object call7240 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7239);
// compiled member node returning call7240 (depth = 5)
  gc_frame_newslot(call7240);
// starting to compile identifier node (depth = 5)
  Object bool7241 = alloc_Boolean(0);
// compiled identifier node returning bool7241 (depth = 5)
  gc_frame_newslot(bool7241);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7240;
  params[1] = bool7241;
  partcv[0] = 2;
  Object call7242 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7238);
// compiled call node returning call7242 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7243 = callmethodflags(call7242, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7237);
// compiled call node returning call7243 (depth = 3)
  gc_frame_end(frame);
  return call7243;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_7244(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7245 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call7246 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7245);
// compiled call node returning call7246 (depth = 3)
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7247 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7248 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7249 = callmethodflags(*var_other, "wildcard", 0, partcv, params, 0);
  gc_frame_end(callframe7248);
// compiled member node returning call7249 (depth = 4)
  gc_frame_newslot(call7249);
// call case 4: self request
  params[0] = call7249;
  partcv[0] = 1;
  Object call7250 = callmethodflags(self, "wildcard:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7247);
// compiled call node returning call7250 (depth = 3)
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7251 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7252 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7253 = callmethodflags(*var_other, "isBindingOccurrence", 0, partcv, params, 0);
  gc_frame_end(callframe7252);
// compiled member node returning call7253 (depth = 4)
  gc_frame_newslot(call7253);
// call case 4: self request
  params[0] = call7253;
  partcv[0] = 1;
  Object call7254 = callmethodflags(self, "isBindingOccurrence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7251);
// compiled call node returning call7254 (depth = 3)
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7255 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7256 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7257 = callmethodflags(*var_other, "isDeclaredByParent", 0, partcv, params, 0);
  gc_frame_end(callframe7256);
// compiled member node returning call7257 (depth = 4)
  gc_frame_newslot(call7257);
// call case 4: self request
  params[0] = call7257;
  partcv[0] = 1;
  Object call7258 = callmethodflags(self, "isDeclaredByParent:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7255);
// compiled call node returning call7258 (depth = 3)
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7259 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7260 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7261 = callmethodflags(*var_other, "isAssigned", 0, partcv, params, 0);
  gc_frame_end(callframe7260);
// compiled member node returning call7261 (depth = 4)
  gc_frame_newslot(call7261);
// call case 4: self request
  params[0] = call7261;
  partcv[0] = 1;
  Object call7262 = callmethodflags(self, "isAssigned:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7259);
// compiled call node returning call7262 (depth = 3)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7263 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7264 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7265 = callmethodflags(*var_other, "inRequest", 0, partcv, params, 0);
  gc_frame_end(callframe7264);
// compiled member node returning call7265 (depth = 4)
  gc_frame_newslot(call7265);
// call case 4: self request
  params[0] = call7265;
  partcv[0] = 1;
  Object call7266 = callmethodflags(self, "inRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7263);
// compiled call node returning call7266 (depth = 3)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName7267(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7268 == NULL) {
    strlit7268 = alloc_String("expression");
    gc_root(strlit7268);
  }
// compiled string node returning strlit7268 (depth = 3)
  gc_frame_end(frame);
  return strlit7268;
}
Object meth_ast_new_40_2_41_6868(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6869 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6869 = alloc_userobj2(37,30, objclass6869);
  gc_frame_newslot(obj6869);
if (objclass6869 == NULL) {
  glfree(obj6869->class->name);
  obj6869->class->name = "identifierNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6869, self, 0);
  addmethodreal(obj6869,"outer", &reader_ast_outer_6870);
  Object oldself6869 = self;
  struct StackFrameObject *oldstackframe6869 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6869);
  gc_frame_newslot((Object)stackframe);
  self = obj6869;
  Object *oldselfslot6869 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6869 = (*(struct UserObject *)self).data[0], lowerouter6869 = thisouter6869;
  if (inheritingObject6869) {
    struct UserObject *inho6869 = (struct UserObject *)inheritingObject6869;
    while (inho6869->super != GraceDefaultObject) inho6869 = (struct UserObject *)inho6869->super;
    inho6869->super = obj6869;
    self = inheritingObject6869;
    *selfslot = self;
    lowerouter6869 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6869;
  }
if (objclass6869 == NULL) {
  Method *reader6871 = addmethodrealflags(obj6869, "kind",&reader_ast_kind_6871, MFLAG_DEF);
  reader6871->definitionModule = modulename;
  reader6871->definitionLine = 1706;
}
adddatum2(obj6869, alloc_Undefined(), 1);
if (objclass6869 == NULL) {
  Method *reader6872 = addmethodrealflags(obj6869, "value", &reader_ast_value_6872, 0);
  Method *writer6872 = addmethodrealflags(obj6869, "value:=(1)", &writer_ast_value_6872, 0);
  reader6872->definitionModule = modulename;
  writer6872->definitionModule = modulename;
  reader6872->definitionLine = 1707;
  writer6872->definitionLine = 1707;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 2);
if (objclass6869 == NULL) {
  Method *reader6873 = addmethodrealflags(obj6869, "wildcard", &reader_ast_wildcard_6873, 0);
  Method *writer6873 = addmethodrealflags(obj6869, "wildcard:=(1)", &writer_ast_wildcard_6873, 0);
  reader6873->definitionModule = modulename;
  writer6873->definitionModule = modulename;
  reader6873->definitionLine = 1708;
  writer6873->definitionLine = 1708;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 3);
if (objclass6869 == NULL) {
  Method *reader6874 = addmethodrealflags(obj6869, "dtype", &reader_ast_dtype_6874, 0);
  Method *writer6874 = addmethodrealflags(obj6869, "dtype:=(1)", &writer_ast_dtype_6874, 0);
  reader6874->definitionModule = modulename;
  writer6874->definitionModule = modulename;
  reader6874->definitionLine = 1709;
  writer6874->definitionLine = 1709;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 4);
if (objclass6869 == NULL) {
  Method *reader6875 = addmethodrealflags(obj6869, "isBindingOccurrence", &reader_ast_isBindingOccurrence_6875, 0);
  Method *writer6875 = addmethodrealflags(obj6869, "isBindingOccurrence:=(1)", &writer_ast_isBindingOccurrence_6875, 0);
  reader6875->definitionModule = modulename;
  writer6875->definitionModule = modulename;
  reader6875->definitionLine = 1710;
  writer6875->definitionLine = 1710;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 5);
if (objclass6869 == NULL) {
  Method *reader6876 = addmethodrealflags(obj6869, "isAssigned", &reader_ast_isAssigned_6876, 0);
  Method *writer6876 = addmethodrealflags(obj6869, "isAssigned:=(1)", &writer_ast_isAssigned_6876, 0);
  reader6876->definitionModule = modulename;
  writer6876->definitionModule = modulename;
  reader6876->definitionLine = 1711;
  writer6876->definitionLine = 1711;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 6);
if (objclass6869 == NULL) {
  Method *reader6877 = addmethodrealflags(obj6869, "inRequest", &reader_ast_inRequest_6877, 0);
  Method *writer6877 = addmethodrealflags(obj6869, "inRequest:=(1)", &writer_ast_inRequest_6877, 0);
  reader6877->definitionModule = modulename;
  writer6877->definitionModule = modulename;
  reader6877->definitionLine = 1712;
  writer6877->definitionLine = 1712;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 7);
if (objclass6869 == NULL) {
  Method *reader6878 = addmethodrealflags(obj6869, "generics", &reader_ast_generics_6878, 0);
  Method *writer6878 = addmethodrealflags(obj6869, "generics:=(1)", &writer_ast_generics_6878, 0);
  reader6878->definitionModule = modulename;
  writer6878->definitionModule = modulename;
  reader6878->definitionLine = 1713;
  writer6878->definitionLine = 1713;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 8);
if (objclass6869 == NULL) {
  Method *reader6879 = addmethodrealflags(obj6869, "isDeclaredByParent", &reader_ast_isDeclaredByParent_6879, 0);
  Method *writer6879 = addmethodrealflags(obj6869, "isDeclaredByParent:=(1)", &writer_ast_isDeclaredByParent_6879, 0);
  reader6879->definitionModule = modulename;
  writer6879->definitionModule = modulename;
  reader6879->definitionLine = 1714;
  writer6879->definitionLine = 1714;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 9);
// method "nameString"
  struct UserObject *uo6880 = (struct UserObject*)obj6869;
  uo6880->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6880 = addmethod2pos(obj6869, "nameString", &meth_ast_nameString6880, 10);
  int argcv_meth_ast_nameString6880[] = {0};
  meth_meth_ast_nameString6880->type = alloc_MethodType(1, argcv_meth_ast_nameString6880);
  meth_meth_ast_nameString6880->definitionModule = modulename;
  meth_meth_ast_nameString6880->definitionLine = 1716;
// method "canonicalName"
  struct UserObject *uo6883 = (struct UserObject*)obj6869;
  uo6883->data[11] = emptyclosure;
  Method *meth_meth_ast_canonicalName6883 = addmethod2pos(obj6869, "canonicalName", &meth_ast_canonicalName6883, 11);
  int argcv_meth_ast_canonicalName6883[] = {0};
  meth_meth_ast_canonicalName6883->type = alloc_MethodType(1, argcv_meth_ast_canonicalName6883);
  meth_meth_ast_canonicalName6883->definitionModule = modulename;
  meth_meth_ast_canonicalName6883->definitionLine = 1717;
// method "quoted"
  struct UserObject *uo6886 = (struct UserObject*)obj6869;
  uo6886->data[12] = emptyclosure;
  Method *meth_meth_ast_quoted6886 = addmethod2pos(obj6869, "quoted", &meth_ast_quoted6886, 12);
  int argcv_meth_ast_quoted6886[] = {0};
  meth_meth_ast_quoted6886->type = alloc_MethodType(1, argcv_meth_ast_quoted6886);
  meth_meth_ast_quoted6886->definitionModule = modulename;
  meth_meth_ast_quoted6886->definitionLine = 1718;
// method "isIdentifier"
  struct UserObject *uo6891 = (struct UserObject*)obj6869;
  uo6891->data[13] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6891 = addmethod2pos(obj6869, "isIdentifier", &meth_ast_isIdentifier6891, 13);
  int argcv_meth_ast_isIdentifier6891[] = {0};
  meth_meth_ast_isIdentifier6891->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6891);
  meth_meth_ast_isIdentifier6891->definitionModule = modulename;
  meth_meth_ast_isIdentifier6891->definitionLine = 1719;
// method "isSelf"
  struct UserObject *uo6893 = (struct UserObject*)obj6869;
  uo6893->data[14] = emptyclosure;
  Method *meth_meth_ast_isSelf6893 = addmethod2pos(obj6869, "isSelf", &meth_ast_isSelf6893, 14);
  int argcv_meth_ast_isSelf6893[] = {0};
  meth_meth_ast_isSelf6893->type = alloc_MethodType(1, argcv_meth_ast_isSelf6893);
  meth_meth_ast_isSelf6893->definitionModule = modulename;
  meth_meth_ast_isSelf6893->definitionLine = 1721;
// method "isSuper"
  struct UserObject *uo6900 = (struct UserObject*)obj6869;
  uo6900->data[15] = emptyclosure;
  Method *meth_meth_ast_isSuper6900 = addmethod2pos(obj6869, "isSuper", &meth_ast_isSuper6900, 15);
  int argcv_meth_ast_isSuper6900[] = {0};
  meth_meth_ast_isSuper6900->type = alloc_MethodType(1, argcv_meth_ast_isSuper6900);
  meth_meth_ast_isSuper6900->definitionModule = modulename;
  meth_meth_ast_isSuper6900->definitionLine = 1722;
// method "isPrelude"
  struct UserObject *uo6907 = (struct UserObject*)obj6869;
  uo6907->data[16] = emptyclosure;
  Method *meth_meth_ast_isPrelude6907 = addmethod2pos(obj6869, "isPrelude", &meth_ast_isPrelude6907, 16);
  int argcv_meth_ast_isPrelude6907[] = {0};
  meth_meth_ast_isPrelude6907->type = alloc_MethodType(1, argcv_meth_ast_isPrelude6907);
  meth_meth_ast_isPrelude6907->definitionModule = modulename;
  meth_meth_ast_isPrelude6907->definitionLine = 1723;
// method "isOuter"
  struct UserObject *uo6914 = (struct UserObject*)obj6869;
  uo6914->data[17] = emptyclosure;
  Method *meth_meth_ast_isOuter6914 = addmethod2pos(obj6869, "isOuter", &meth_ast_isOuter6914, 17);
  int argcv_meth_ast_isOuter6914[] = {0};
  meth_meth_ast_isOuter6914->type = alloc_MethodType(1, argcv_meth_ast_isOuter6914);
  meth_meth_ast_isOuter6914->definitionModule = modulename;
  meth_meth_ast_isOuter6914->definitionLine = 1724;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo6921 = (struct UserObject*)obj6869;
  uo6921->data[18] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6921 = addmethod2pos(obj6869, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6921, 18);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6921[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6921->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6921);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6921->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6921->definitionLine = 1726;
// method "declarationKindWithAncestors(_)"
  struct UserObject *uo6930 = (struct UserObject*)obj6869;
  uo6930->data[19] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_6930 = addmethod2pos(obj6869, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_6930, 19);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_6930[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6930->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_6930);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6930->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6930->definitionLine = 1733;
// method "inTypePositionWithAncestors(_)"
  struct UserObject *uo6935 = (struct UserObject*)obj6869;
  uo6935->data[20] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors_40_1_41_6935 = addmethod2pos(obj6869, "inTypePositionWithAncestors(1)", &meth_ast_inTypePositionWithAncestors_40_1_41_6935, 20);
  int argcv_meth_ast_inTypePositionWithAncestors_40_1_41_6935[] = {1};
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6935->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors_40_1_41_6935);
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6935->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6935->definitionLine = 1736;
// method "usesAsType(_)"
  struct UserObject *uo6944 = (struct UserObject*)obj6869;
  uo6944->data[21] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_6944 = addmethod2pos(obj6869, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_6944, 21);
  int argcv_meth_ast_usesAsType_40_1_41_6944[] = {1};
  meth_meth_ast_usesAsType_40_1_41_6944->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_6944);
  meth_meth_ast_usesAsType_40_1_41_6944->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_6944->definitionLine = 1743;
// method "accept(_)from(_)"
  struct UserObject *uo6950 = (struct UserObject*)obj6869;
  uo6950->data[22] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6950 = addmethod2pos(obj6869, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6950, 22);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6950[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6950->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6950);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6950->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6950->definitionLine = 1746;
// method "map(_)ancestors(_)"
  struct UserObject *uo6967 = (struct UserObject*)obj6869;
  uo6967->data[23] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6967 = addmethod2pos(obj6869, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6967, 23);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6967[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6967->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6967);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6967->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6967->definitionLine = 1754;
// method "pretty(_)"
  struct UserObject *uo6984 = (struct UserObject*)obj6869;
  uo6984->data[24] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6984 = addmethod2pos(obj6869, "pretty(1)", &meth_ast_pretty_40_1_41_6984, 24);
  int argcv_meth_ast_pretty_40_1_41_6984[] = {1};
  meth_meth_ast_pretty_40_1_41_6984->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6984);
  meth_meth_ast_pretty_40_1_41_6984->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6984->definitionLine = 1760;
// method "toGrace(_)"
  struct UserObject *uo7119 = (struct UserObject*)obj6869;
  uo7119->data[25] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7119 = addmethod2pos(obj6869, "toGrace(1)", &meth_ast_toGrace_40_1_41_7119, 25);
  int argcv_meth_ast_toGrace_40_1_41_7119[] = {1};
  meth_meth_ast_toGrace_40_1_41_7119->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7119);
meth_meth_ast_toGrace_40_1_41_7119->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7119->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7119->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7119->definitionLine = 1785;
// method "asString"
  struct UserObject *uo7212 = (struct UserObject*)obj6869;
  uo7212->data[26] = emptyclosure;
  Method *meth_meth_ast_asString7212 = addmethod2pos(obj6869, "asString", &meth_ast_asString7212, 26);
  int argcv_meth_ast_asString7212[] = {0};
  meth_meth_ast_asString7212->type = alloc_MethodType(1, argcv_meth_ast_asString7212);
  meth_meth_ast_asString7212->definitionModule = modulename;
  meth_meth_ast_asString7212->definitionLine = 1805;
// method "shallowCopy"
  block_savedest(obj6869);
  Object closure7236 = createclosure(1, "shallowCopy");
  setclosureframe(closure7236, stackframe);
  addtoclosure(closure7236, var_identifierNode);
  struct UserObject *uo7236 = (struct UserObject*)obj6869;
  uo7236->data[27] = (Object)closure7236;
  Method *meth_meth_ast_shallowCopy7236 = addmethod2pos(obj6869, "shallowCopy", &meth_ast_shallowCopy7236, 27);
  int argcv_meth_ast_shallowCopy7236[] = {0};
  meth_meth_ast_shallowCopy7236->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7236);
  meth_meth_ast_shallowCopy7236->definitionModule = modulename;
  meth_meth_ast_shallowCopy7236->definitionLine = 1812;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo7244 = (struct UserObject*)obj6869;
  uo7244->data[28] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7244 = addmethod2pos(obj6869, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_7244, 28);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_7244[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7244->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_7244);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7244->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7244->definitionLine = 1815;
// method "statementName"
  struct UserObject *uo7267 = (struct UserObject*)obj6869;
  uo7267->data[29] = emptyclosure;
  Method *meth_meth_ast_statementName7267 = addmethod2pos(obj6869, "statementName", &meth_ast_statementName7267, 29);
  int argcv_meth_ast_statementName7267[] = {0};
  meth_meth_ast_statementName7267->type = alloc_MethodType(1, argcv_meth_ast_statementName7267);
  meth_meth_ast_statementName7267->definitionModule = modulename;
  meth_meth_ast_statementName7267->definitionLine = 1824;
  sourceObject = obj6869;
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7269 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7270 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7271 = gc_frame_new();
// call case 3: self.outer request
  Object call7272 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7271);
// compiled member node returning call7272 (depth = 5)
  Object call7273 = callmethodflags(call7272, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7270);
// compiled member node returning call7273 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7274 = callmethodflags(call7273, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7269);
// compiled call node returning call7274 (depth = 3)
  struct UserObject *obj6869_uo = (struct UserObject *)obj6869;
  obj6869_uo->super = call7274;
  sourceObject = obj6869;
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7275 == NULL) {
    strlit7275 = alloc_String("identifier");
    gc_root(strlit7275);
  }
// compiled string node returning strlit7275 (depth = 3)
  adddatum2(obj6869, strlit7275, 1);
  sourceObject = obj6869;
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj6869, *var_name, 2);
  sourceObject = obj6869;
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7276 = alloc_Boolean(0);
// compiled identifier node returning bool7276 (depth = 3)
  adddatum2(obj6869, bool7276, 3);
  sourceObject = obj6869;
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj6869, *var_dtype_39_, 4);
  sourceObject = obj6869;
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7277 = alloc_Boolean(0);
// compiled identifier node returning bool7277 (depth = 3)
  adddatum2(obj6869, bool7277, 5);
  sourceObject = obj6869;
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7278 = alloc_Boolean(0);
// compiled identifier node returning bool7278 (depth = 3)
  adddatum2(obj6869, bool7278, 6);
  sourceObject = obj6869;
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7279 = alloc_Boolean(0);
// compiled identifier node returning bool7279 (depth = 3)
  adddatum2(obj6869, bool7279, 7);
  sourceObject = obj6869;
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7280 = alloc_Boolean(0);
// compiled identifier node returning bool7280 (depth = 3)
  adddatum2(obj6869, bool7280, 8);
  sourceObject = obj6869;
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7281 = alloc_Boolean(0);
// compiled identifier node returning bool7281 (depth = 3)
  adddatum2(obj6869, bool7281, 9);
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  objclass6869 = obj6869->class;
  objclass6869->definitionModule = modulename;
  objclass6869->definitionLine = 1704;
  (*(struct UserObject *)self).data[0] = lowerouter6869;
  self = oldself6869;
  selfslot = oldselfslot6869;
  stackframe = oldstackframe6869;
  gc_frame_end(frame);
  return obj6869;
}
Object meth_ast_new_40_2_41_6868_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6869 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6869 = alloc_userobj2(37,30, objclass6869);
  gc_frame_newslot(obj6869);
if (objclass6869 == NULL) {
  glfree(obj6869->class->name);
  obj6869->class->name = "identifierNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6869, self, 0);
  addmethodreal(obj6869,"outer", &reader_ast_outer_6870);
  Object oldself6869 = self;
  struct StackFrameObject *oldstackframe6869 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6869);
  gc_frame_newslot((Object)stackframe);
  self = obj6869;
  Object *oldselfslot6869 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6869 = (*(struct UserObject *)self).data[0], lowerouter6869 = thisouter6869;
  if (inheritingObject6869) {
    struct UserObject *inho6869 = (struct UserObject *)inheritingObject6869;
    while (inho6869->super != GraceDefaultObject) inho6869 = (struct UserObject *)inho6869->super;
    inho6869->super = obj6869;
    self = inheritingObject6869;
    *selfslot = self;
    lowerouter6869 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6869;
  }
if (objclass6869 == NULL) {
  Method *reader6871 = addmethodrealflags(obj6869, "kind",&reader_ast_kind_6871, MFLAG_DEF);
  reader6871->definitionModule = modulename;
  reader6871->definitionLine = 1706;
}
adddatum2(obj6869, alloc_Undefined(), 1);
if (objclass6869 == NULL) {
  Method *reader6872 = addmethodrealflags(obj6869, "value", &reader_ast_value_6872, 0);
  Method *writer6872 = addmethodrealflags(obj6869, "value:=(1)", &writer_ast_value_6872, 0);
  reader6872->definitionModule = modulename;
  writer6872->definitionModule = modulename;
  reader6872->definitionLine = 1707;
  writer6872->definitionLine = 1707;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 2);
if (objclass6869 == NULL) {
  Method *reader6873 = addmethodrealflags(obj6869, "wildcard", &reader_ast_wildcard_6873, 0);
  Method *writer6873 = addmethodrealflags(obj6869, "wildcard:=(1)", &writer_ast_wildcard_6873, 0);
  reader6873->definitionModule = modulename;
  writer6873->definitionModule = modulename;
  reader6873->definitionLine = 1708;
  writer6873->definitionLine = 1708;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 3);
if (objclass6869 == NULL) {
  Method *reader6874 = addmethodrealflags(obj6869, "dtype", &reader_ast_dtype_6874, 0);
  Method *writer6874 = addmethodrealflags(obj6869, "dtype:=(1)", &writer_ast_dtype_6874, 0);
  reader6874->definitionModule = modulename;
  writer6874->definitionModule = modulename;
  reader6874->definitionLine = 1709;
  writer6874->definitionLine = 1709;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 4);
if (objclass6869 == NULL) {
  Method *reader6875 = addmethodrealflags(obj6869, "isBindingOccurrence", &reader_ast_isBindingOccurrence_6875, 0);
  Method *writer6875 = addmethodrealflags(obj6869, "isBindingOccurrence:=(1)", &writer_ast_isBindingOccurrence_6875, 0);
  reader6875->definitionModule = modulename;
  writer6875->definitionModule = modulename;
  reader6875->definitionLine = 1710;
  writer6875->definitionLine = 1710;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 5);
if (objclass6869 == NULL) {
  Method *reader6876 = addmethodrealflags(obj6869, "isAssigned", &reader_ast_isAssigned_6876, 0);
  Method *writer6876 = addmethodrealflags(obj6869, "isAssigned:=(1)", &writer_ast_isAssigned_6876, 0);
  reader6876->definitionModule = modulename;
  writer6876->definitionModule = modulename;
  reader6876->definitionLine = 1711;
  writer6876->definitionLine = 1711;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 6);
if (objclass6869 == NULL) {
  Method *reader6877 = addmethodrealflags(obj6869, "inRequest", &reader_ast_inRequest_6877, 0);
  Method *writer6877 = addmethodrealflags(obj6869, "inRequest:=(1)", &writer_ast_inRequest_6877, 0);
  reader6877->definitionModule = modulename;
  writer6877->definitionModule = modulename;
  reader6877->definitionLine = 1712;
  writer6877->definitionLine = 1712;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 7);
if (objclass6869 == NULL) {
  Method *reader6878 = addmethodrealflags(obj6869, "generics", &reader_ast_generics_6878, 0);
  Method *writer6878 = addmethodrealflags(obj6869, "generics:=(1)", &writer_ast_generics_6878, 0);
  reader6878->definitionModule = modulename;
  writer6878->definitionModule = modulename;
  reader6878->definitionLine = 1713;
  writer6878->definitionLine = 1713;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 8);
if (objclass6869 == NULL) {
  Method *reader6879 = addmethodrealflags(obj6869, "isDeclaredByParent", &reader_ast_isDeclaredByParent_6879, 0);
  Method *writer6879 = addmethodrealflags(obj6869, "isDeclaredByParent:=(1)", &writer_ast_isDeclaredByParent_6879, 0);
  reader6879->definitionModule = modulename;
  writer6879->definitionModule = modulename;
  reader6879->definitionLine = 1714;
  writer6879->definitionLine = 1714;
}
obj6869->flags |= OFLAG_MUTABLE;
adddatum2(obj6869, alloc_Undefined(), 9);
// method "nameString"
  struct UserObject *uo6880 = (struct UserObject*)obj6869;
  uo6880->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6880 = addmethod2pos(obj6869, "nameString", &meth_ast_nameString6880, 10);
  int argcv_meth_ast_nameString6880[] = {0};
  meth_meth_ast_nameString6880->type = alloc_MethodType(1, argcv_meth_ast_nameString6880);
  meth_meth_ast_nameString6880->definitionModule = modulename;
  meth_meth_ast_nameString6880->definitionLine = 1716;
// method "canonicalName"
  struct UserObject *uo6883 = (struct UserObject*)obj6869;
  uo6883->data[11] = emptyclosure;
  Method *meth_meth_ast_canonicalName6883 = addmethod2pos(obj6869, "canonicalName", &meth_ast_canonicalName6883, 11);
  int argcv_meth_ast_canonicalName6883[] = {0};
  meth_meth_ast_canonicalName6883->type = alloc_MethodType(1, argcv_meth_ast_canonicalName6883);
  meth_meth_ast_canonicalName6883->definitionModule = modulename;
  meth_meth_ast_canonicalName6883->definitionLine = 1717;
// method "quoted"
  struct UserObject *uo6886 = (struct UserObject*)obj6869;
  uo6886->data[12] = emptyclosure;
  Method *meth_meth_ast_quoted6886 = addmethod2pos(obj6869, "quoted", &meth_ast_quoted6886, 12);
  int argcv_meth_ast_quoted6886[] = {0};
  meth_meth_ast_quoted6886->type = alloc_MethodType(1, argcv_meth_ast_quoted6886);
  meth_meth_ast_quoted6886->definitionModule = modulename;
  meth_meth_ast_quoted6886->definitionLine = 1718;
// method "isIdentifier"
  struct UserObject *uo6891 = (struct UserObject*)obj6869;
  uo6891->data[13] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6891 = addmethod2pos(obj6869, "isIdentifier", &meth_ast_isIdentifier6891, 13);
  int argcv_meth_ast_isIdentifier6891[] = {0};
  meth_meth_ast_isIdentifier6891->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6891);
  meth_meth_ast_isIdentifier6891->definitionModule = modulename;
  meth_meth_ast_isIdentifier6891->definitionLine = 1719;
// method "isSelf"
  struct UserObject *uo6893 = (struct UserObject*)obj6869;
  uo6893->data[14] = emptyclosure;
  Method *meth_meth_ast_isSelf6893 = addmethod2pos(obj6869, "isSelf", &meth_ast_isSelf6893, 14);
  int argcv_meth_ast_isSelf6893[] = {0};
  meth_meth_ast_isSelf6893->type = alloc_MethodType(1, argcv_meth_ast_isSelf6893);
  meth_meth_ast_isSelf6893->definitionModule = modulename;
  meth_meth_ast_isSelf6893->definitionLine = 1721;
// method "isSuper"
  struct UserObject *uo6900 = (struct UserObject*)obj6869;
  uo6900->data[15] = emptyclosure;
  Method *meth_meth_ast_isSuper6900 = addmethod2pos(obj6869, "isSuper", &meth_ast_isSuper6900, 15);
  int argcv_meth_ast_isSuper6900[] = {0};
  meth_meth_ast_isSuper6900->type = alloc_MethodType(1, argcv_meth_ast_isSuper6900);
  meth_meth_ast_isSuper6900->definitionModule = modulename;
  meth_meth_ast_isSuper6900->definitionLine = 1722;
// method "isPrelude"
  struct UserObject *uo6907 = (struct UserObject*)obj6869;
  uo6907->data[16] = emptyclosure;
  Method *meth_meth_ast_isPrelude6907 = addmethod2pos(obj6869, "isPrelude", &meth_ast_isPrelude6907, 16);
  int argcv_meth_ast_isPrelude6907[] = {0};
  meth_meth_ast_isPrelude6907->type = alloc_MethodType(1, argcv_meth_ast_isPrelude6907);
  meth_meth_ast_isPrelude6907->definitionModule = modulename;
  meth_meth_ast_isPrelude6907->definitionLine = 1723;
// method "isOuter"
  struct UserObject *uo6914 = (struct UserObject*)obj6869;
  uo6914->data[17] = emptyclosure;
  Method *meth_meth_ast_isOuter6914 = addmethod2pos(obj6869, "isOuter", &meth_ast_isOuter6914, 17);
  int argcv_meth_ast_isOuter6914[] = {0};
  meth_meth_ast_isOuter6914->type = alloc_MethodType(1, argcv_meth_ast_isOuter6914);
  meth_meth_ast_isOuter6914->definitionModule = modulename;
  meth_meth_ast_isOuter6914->definitionLine = 1724;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo6921 = (struct UserObject*)obj6869;
  uo6921->data[18] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6921 = addmethod2pos(obj6869, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6921, 18);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6921[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6921->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6921);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6921->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6921->definitionLine = 1726;
// method "declarationKindWithAncestors(_)"
  struct UserObject *uo6930 = (struct UserObject*)obj6869;
  uo6930->data[19] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_6930 = addmethod2pos(obj6869, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_6930, 19);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_6930[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6930->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_6930);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6930->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6930->definitionLine = 1733;
// method "inTypePositionWithAncestors(_)"
  struct UserObject *uo6935 = (struct UserObject*)obj6869;
  uo6935->data[20] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors_40_1_41_6935 = addmethod2pos(obj6869, "inTypePositionWithAncestors(1)", &meth_ast_inTypePositionWithAncestors_40_1_41_6935, 20);
  int argcv_meth_ast_inTypePositionWithAncestors_40_1_41_6935[] = {1};
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6935->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors_40_1_41_6935);
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6935->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6935->definitionLine = 1736;
// method "usesAsType(_)"
  struct UserObject *uo6944 = (struct UserObject*)obj6869;
  uo6944->data[21] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_6944 = addmethod2pos(obj6869, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_6944, 21);
  int argcv_meth_ast_usesAsType_40_1_41_6944[] = {1};
  meth_meth_ast_usesAsType_40_1_41_6944->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_6944);
  meth_meth_ast_usesAsType_40_1_41_6944->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_6944->definitionLine = 1743;
// method "accept(_)from(_)"
  struct UserObject *uo6950 = (struct UserObject*)obj6869;
  uo6950->data[22] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6950 = addmethod2pos(obj6869, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6950, 22);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6950[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6950->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6950);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6950->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6950->definitionLine = 1746;
// method "map(_)ancestors(_)"
  struct UserObject *uo6967 = (struct UserObject*)obj6869;
  uo6967->data[23] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6967 = addmethod2pos(obj6869, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6967, 23);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6967[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6967->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6967);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6967->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6967->definitionLine = 1754;
// method "pretty(_)"
  struct UserObject *uo6984 = (struct UserObject*)obj6869;
  uo6984->data[24] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6984 = addmethod2pos(obj6869, "pretty(1)", &meth_ast_pretty_40_1_41_6984, 24);
  int argcv_meth_ast_pretty_40_1_41_6984[] = {1};
  meth_meth_ast_pretty_40_1_41_6984->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6984);
  meth_meth_ast_pretty_40_1_41_6984->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6984->definitionLine = 1760;
// method "toGrace(_)"
  struct UserObject *uo7119 = (struct UserObject*)obj6869;
  uo7119->data[25] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7119 = addmethod2pos(obj6869, "toGrace(1)", &meth_ast_toGrace_40_1_41_7119, 25);
  int argcv_meth_ast_toGrace_40_1_41_7119[] = {1};
  meth_meth_ast_toGrace_40_1_41_7119->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7119);
meth_meth_ast_toGrace_40_1_41_7119->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7119->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7119->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7119->definitionLine = 1785;
// method "asString"
  struct UserObject *uo7212 = (struct UserObject*)obj6869;
  uo7212->data[26] = emptyclosure;
  Method *meth_meth_ast_asString7212 = addmethod2pos(obj6869, "asString", &meth_ast_asString7212, 26);
  int argcv_meth_ast_asString7212[] = {0};
  meth_meth_ast_asString7212->type = alloc_MethodType(1, argcv_meth_ast_asString7212);
  meth_meth_ast_asString7212->definitionModule = modulename;
  meth_meth_ast_asString7212->definitionLine = 1805;
// method "shallowCopy"
  block_savedest(obj6869);
  Object closure7236 = createclosure(1, "shallowCopy");
  setclosureframe(closure7236, stackframe);
  addtoclosure(closure7236, var_identifierNode);
  struct UserObject *uo7236 = (struct UserObject*)obj6869;
  uo7236->data[27] = (Object)closure7236;
  Method *meth_meth_ast_shallowCopy7236 = addmethod2pos(obj6869, "shallowCopy", &meth_ast_shallowCopy7236, 27);
  int argcv_meth_ast_shallowCopy7236[] = {0};
  meth_meth_ast_shallowCopy7236->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7236);
  meth_meth_ast_shallowCopy7236->definitionModule = modulename;
  meth_meth_ast_shallowCopy7236->definitionLine = 1812;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo7244 = (struct UserObject*)obj6869;
  uo7244->data[28] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7244 = addmethod2pos(obj6869, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_7244, 28);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_7244[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7244->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_7244);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7244->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7244->definitionLine = 1815;
// method "statementName"
  struct UserObject *uo7267 = (struct UserObject*)obj6869;
  uo7267->data[29] = emptyclosure;
  Method *meth_meth_ast_statementName7267 = addmethod2pos(obj6869, "statementName", &meth_ast_statementName7267, 29);
  int argcv_meth_ast_statementName7267[] = {0};
  meth_meth_ast_statementName7267->type = alloc_MethodType(1, argcv_meth_ast_statementName7267);
  meth_meth_ast_statementName7267->definitionModule = modulename;
  meth_meth_ast_statementName7267->definitionLine = 1824;
  sourceObject = obj6869;
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7269 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7270 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7271 = gc_frame_new();
// call case 3: self.outer request
  Object call7272 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7271);
// compiled member node returning call7272 (depth = 5)
  Object call7273 = callmethodflags(call7272, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7270);
// compiled member node returning call7273 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7274 = callmethodflags(call7273, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7269);
// compiled call node returning call7274 (depth = 3)
  struct UserObject *obj6869_uo = (struct UserObject *)obj6869;
  obj6869_uo->super = call7274;
  sourceObject = obj6869;
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7275 == NULL) {
    strlit7275 = alloc_String("identifier");
    gc_root(strlit7275);
  }
// compiled string node returning strlit7275 (depth = 3)
  adddatum2(obj6869, strlit7275, 1);
  sourceObject = obj6869;
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj6869, *var_name, 2);
  sourceObject = obj6869;
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7276 = alloc_Boolean(0);
// compiled identifier node returning bool7276 (depth = 3)
  adddatum2(obj6869, bool7276, 3);
  sourceObject = obj6869;
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj6869, *var_dtype_39_, 4);
  sourceObject = obj6869;
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7277 = alloc_Boolean(0);
// compiled identifier node returning bool7277 (depth = 3)
  adddatum2(obj6869, bool7277, 5);
  sourceObject = obj6869;
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7278 = alloc_Boolean(0);
// compiled identifier node returning bool7278 (depth = 3)
  adddatum2(obj6869, bool7278, 6);
  sourceObject = obj6869;
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7279 = alloc_Boolean(0);
// compiled identifier node returning bool7279 (depth = 3)
  adddatum2(obj6869, bool7279, 7);
  sourceObject = obj6869;
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7280 = alloc_Boolean(0);
// compiled identifier node returning bool7280 (depth = 3)
  adddatum2(obj6869, bool7280, 8);
  sourceObject = obj6869;
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7281 = alloc_Boolean(0);
// compiled identifier node returning bool7281 (depth = 3)
  adddatum2(obj6869, bool7281, 9);
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  sourceObject = obj6869;
  objclass6869 = obj6869->class;
  objclass6869->definitionModule = modulename;
  objclass6869->definitionLine = 1704;
  (*(struct UserObject *)self).data[0] = lowerouter6869;
  self = oldself6869;
  selfslot = oldselfslot6869;
  stackframe = oldstackframe6869;
  gc_frame_end(frame);
  return obj6869;
}
Object meth_ast_identifierNode7283(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_typeType7288(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_end(frame);
  return *var_typeType;
}
Object meth_ast_unknownType7292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unknownType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unknownType (depth = 3)
  gc_frame_end(frame);
  return *var_unknownType;
}
Object meth_ast_new_40_1_41_scope_40_1_41_7295(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7296 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call7297 = callmethodflags(self, "new(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7296);
// compiled call node returning call7297 (depth = 4)
  *var_result = call7297;
  if (call7297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7298 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7299 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7298);
// compiled call node returning call7299 (depth = 3)
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7305(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7306 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7307 = callmethodflags(*var_visitor, "visitString(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7306);
// compiled call node returning call7307 (depth = 3)
  gc_frame_end(frame);
  return call7307;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_7308(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7309 = gc_frame_new();
// call case 4: self request
  Object call7310 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7309);
// compiled member node returning call7310 (depth = 4)
  *var_n = call7310;
  if (call7310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7311 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7312 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7311);
// compiled call node returning call7312 (depth = 4)
  *var_newChain = call7312;
  if (call7312 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7313 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7314 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7313);
// compiled call node returning call7314 (depth = 3)
  gc_frame_end(frame);
  return call7314;
}
Object meth_ast_pretty_40_1_41_7315(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7317 == NULL) {
    strlit7317 = alloc_String(")");
    gc_root(strlit7317);
  }
// compiled string node returning strlit7317 (depth = 4)
  int op_slot_right_7316 = gc_frame_newslot(strlit7317);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7320 = gc_frame_new();
// call case 4: self request
  Object call7321 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7320);
// compiled member node returning call7321 (depth = 5)
  int op_slot_right_7319 = gc_frame_newslot(call7321);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7324 == NULL) {
    strlit7324 = alloc_String("(");
    gc_root(strlit7324);
  }
// compiled string node returning strlit7324 (depth = 6)
  int op_slot_right_7323 = gc_frame_newslot(strlit7324);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7327 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7328 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7327);
// compiled call node returning call7328 (depth = 7)
  int op_slot_right_7326 = gc_frame_newslot(call7328);
// starting to compile string node (depth = 7)
  if (strlit7330 == NULL) {
    strlit7330 = alloc_String("");
    gc_root(strlit7330);
  }
// compiled string node returning strlit7330 (depth = 7)
  int op_slot_left_7326 = gc_frame_newslot(strlit7330);
  params[0] = call7328;
  partcv[0] = 1;
  Object opresult7331 = callmethod(strlit7330, "++(1)", 1, partcv, params);
// compiled op node returning opresult7331 (depth = 6)
  int op_slot_left_7323 = gc_frame_newslot(opresult7331);
  params[0] = strlit7324;
  partcv[0] = 1;
  Object opresult7332 = callmethod(opresult7331, "++(1)", 1, partcv, params);
// compiled op node returning opresult7332 (depth = 5)
  int op_slot_left_7319 = gc_frame_newslot(opresult7332);
  params[0] = call7321;
  partcv[0] = 1;
  Object opresult7333 = callmethod(opresult7332, "++(1)", 1, partcv, params);
// compiled op node returning opresult7333 (depth = 4)
  int op_slot_left_7316 = gc_frame_newslot(opresult7333);
  params[0] = strlit7317;
  partcv[0] = 1;
  Object opresult7334 = callmethod(opresult7333, "++(1)", 1, partcv, params);
// compiled op node returning opresult7334 (depth = 3)
  gc_frame_end(frame);
  return opresult7334;
}
Object meth_ast_toGrace_40_1_41_7335(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_q = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "q");
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7336 == NULL) {
    strlit7336 = alloc_String("""\x22""");
    gc_root(strlit7336);
  }
// compiled string node returning strlit7336 (depth = 4)
  *var_q = strlit7336;
  if (strlit7336 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_q (depth = 4)
  int op_slot_right_7337 = gc_frame_newslot(*var_q);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7340 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7341 = gc_frame_new();
// call case 4: self request
  Object call7342 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7341);
// compiled member node returning call7342 (depth = 6)
  Object call7343 = callmethodflags(call7342, "quoted", 0, partcv, params, 0);
  gc_frame_end(callframe7340);
// compiled member node returning call7343 (depth = 5)
  int op_slot_right_7339 = gc_frame_newslot(call7343);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_q (depth = 5)
  int op_slot_left_7339 = gc_frame_newslot(*var_q);
  params[0] = call7343;
  partcv[0] = 1;
  Object opresult7345 = callmethod(*var_q, "++(1)", 1, partcv, params);
// compiled op node returning opresult7345 (depth = 4)
  int op_slot_left_7337 = gc_frame_newslot(opresult7345);
  params[0] = *var_q;
  partcv[0] = 1;
  Object opresult7346 = callmethod(opresult7345, "++(1)", 1, partcv, params);
// compiled op node returning opresult7346 (depth = 3)
  gc_frame_end(frame);
  return opresult7346;
}
Object meth_ast_asString7347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7349 == NULL) {
    strlit7349 = alloc_String("");
    gc_root(strlit7349);
  }
// compiled string node returning strlit7349 (depth = 4)
  int op_slot_right_7348 = gc_frame_newslot(strlit7349);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7352 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num7353 = alloc_Float64(0);
// compiled num node returning num7353 (depth = 6)
  gc_frame_newslot(num7353);
// call case 4: self request
  params[0] = num7353;
  partcv[0] = 1;
  Object call7354 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7352);
// compiled call node returning call7354 (depth = 5)
  int op_slot_right_7351 = gc_frame_newslot(call7354);
// starting to compile string node (depth = 5)
  if (strlit7356 == NULL) {
    strlit7356 = alloc_String("string ");
    gc_root(strlit7356);
  }
// compiled string node returning strlit7356 (depth = 5)
  int op_slot_left_7351 = gc_frame_newslot(strlit7356);
  params[0] = call7354;
  partcv[0] = 1;
  Object opresult7357 = callmethod(strlit7356, "++(1)", 1, partcv, params);
// compiled op node returning opresult7357 (depth = 4)
  int op_slot_left_7348 = gc_frame_newslot(opresult7357);
  params[0] = strlit7349;
  partcv[0] = 1;
  Object opresult7358 = callmethod(opresult7357, "++(1)", 1, partcv, params);
// compiled op node returning opresult7358 (depth = 3)
  gc_frame_end(frame);
  return opresult7358;
}
Object meth_ast_shallowCopy7359(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7360 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7361 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7362 = gc_frame_new();
// call case 4: self request
  Object call7363 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7362);
// compiled member node returning call7363 (depth = 5)
  gc_frame_newslot(call7363);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_stringNode (depth = 5)
  params[0] = call7363;
  partcv[0] = 1;
  Object call7364 = callmethodflags(*var_stringNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7361);
// compiled call node returning call7364 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7365 = callmethodflags(call7364, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7360);
// compiled call node returning call7365 (depth = 3)
  gc_frame_end(frame);
  return call7365;
}
Object meth_ast_statementName7366(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7367 == NULL) {
    strlit7367 = alloc_String("expression");
    gc_root(strlit7367);
  }
// compiled string node returning strlit7367 (depth = 3)
  gc_frame_end(frame);
  return strlit7367;
}
Object meth_ast_isDelimited7368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7369 = alloc_Boolean(1);
// compiled identifier node returning bool7369 (depth = 3)
  gc_frame_end(frame);
  return bool7369;
}
Object meth_ast_new_40_1_41_7300(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7301 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7301 = alloc_userobj2(11,11, objclass7301);
  gc_frame_newslot(obj7301);
if (objclass7301 == NULL) {
  glfree(obj7301->class->name);
  obj7301->class->name = "stringNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7301, self, 0);
  addmethodreal(obj7301,"outer", &reader_ast_outer_7302);
  Object oldself7301 = self;
  struct StackFrameObject *oldstackframe7301 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7301);
  gc_frame_newslot((Object)stackframe);
  self = obj7301;
  Object *oldselfslot7301 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7301 = (*(struct UserObject *)self).data[0], lowerouter7301 = thisouter7301;
  if (inheritingObject7301) {
    struct UserObject *inho7301 = (struct UserObject *)inheritingObject7301;
    while (inho7301->super != GraceDefaultObject) inho7301 = (struct UserObject *)inho7301->super;
    inho7301->super = obj7301;
    self = inheritingObject7301;
    *selfslot = self;
    lowerouter7301 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7301;
  }
if (objclass7301 == NULL) {
  Method *reader7303 = addmethodrealflags(obj7301, "kind",&reader_ast_kind_7303, MFLAG_DEF);
  reader7303->definitionModule = modulename;
  reader7303->definitionLine = 1840;
}
adddatum2(obj7301, alloc_Undefined(), 1);
if (objclass7301 == NULL) {
  Method *reader7304 = addmethodrealflags(obj7301, "value", &reader_ast_value_7304, 0);
  Method *writer7304 = addmethodrealflags(obj7301, "value:=(1)", &writer_ast_value_7304, 0);
  reader7304->definitionModule = modulename;
  writer7304->definitionModule = modulename;
  reader7304->definitionLine = 1841;
  writer7304->definitionLine = 1841;
}
obj7301->flags |= OFLAG_MUTABLE;
adddatum2(obj7301, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo7305 = (struct UserObject*)obj7301;
  uo7305->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7305 = addmethod2pos(obj7301, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7305, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7305[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7305->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7305);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7305->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7305->definitionLine = 1842;
// method "map(_)ancestors(_)"
  struct UserObject *uo7308 = (struct UserObject*)obj7301;
  uo7308->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7308 = addmethod2pos(obj7301, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7308, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7308[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7308->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7308);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7308->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7308->definitionLine = 1845;
// method "pretty(_)"
  struct UserObject *uo7315 = (struct UserObject*)obj7301;
  uo7315->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7315 = addmethod2pos(obj7301, "pretty(1)", &meth_ast_pretty_40_1_41_7315, 5);
  int argcv_meth_ast_pretty_40_1_41_7315[] = {1};
  meth_meth_ast_pretty_40_1_41_7315->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7315);
  meth_meth_ast_pretty_40_1_41_7315->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7315->definitionLine = 1850;
// method "toGrace(_)"
  struct UserObject *uo7335 = (struct UserObject*)obj7301;
  uo7335->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7335 = addmethod2pos(obj7301, "toGrace(1)", &meth_ast_toGrace_40_1_41_7335, 6);
  int argcv_meth_ast_toGrace_40_1_41_7335[] = {1};
  meth_meth_ast_toGrace_40_1_41_7335->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7335);
meth_meth_ast_toGrace_40_1_41_7335->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7335->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7335->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7335->definitionLine = 1853;
// method "asString"
  struct UserObject *uo7347 = (struct UserObject*)obj7301;
  uo7347->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7347 = addmethod2pos(obj7301, "asString", &meth_ast_asString7347, 7);
  int argcv_meth_ast_asString7347[] = {0};
  meth_meth_ast_asString7347->type = alloc_MethodType(1, argcv_meth_ast_asString7347);
  meth_meth_ast_asString7347->definitionModule = modulename;
  meth_meth_ast_asString7347->definitionLine = 1857;
// method "shallowCopy"
  block_savedest(obj7301);
  Object closure7359 = createclosure(1, "shallowCopy");
  setclosureframe(closure7359, stackframe);
  addtoclosure(closure7359, var_stringNode);
  struct UserObject *uo7359 = (struct UserObject*)obj7301;
  uo7359->data[8] = (Object)closure7359;
  Method *meth_meth_ast_shallowCopy7359 = addmethod2pos(obj7301, "shallowCopy", &meth_ast_shallowCopy7359, 8);
  int argcv_meth_ast_shallowCopy7359[] = {0};
  meth_meth_ast_shallowCopy7359->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7359);
  meth_meth_ast_shallowCopy7359->definitionModule = modulename;
  meth_meth_ast_shallowCopy7359->definitionLine = 1858;
// method "statementName"
  struct UserObject *uo7366 = (struct UserObject*)obj7301;
  uo7366->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7366 = addmethod2pos(obj7301, "statementName", &meth_ast_statementName7366, 9);
  int argcv_meth_ast_statementName7366[] = {0};
  meth_meth_ast_statementName7366->type = alloc_MethodType(1, argcv_meth_ast_statementName7366);
  meth_meth_ast_statementName7366->definitionModule = modulename;
  meth_meth_ast_statementName7366->definitionLine = 1861;
// method "isDelimited"
  struct UserObject *uo7368 = (struct UserObject*)obj7301;
  uo7368->data[10] = emptyclosure;
  Method *meth_meth_ast_isDelimited7368 = addmethod2pos(obj7301, "isDelimited", &meth_ast_isDelimited7368, 10);
  int argcv_meth_ast_isDelimited7368[] = {0};
  meth_meth_ast_isDelimited7368->type = alloc_MethodType(1, argcv_meth_ast_isDelimited7368);
  meth_meth_ast_isDelimited7368->definitionModule = modulename;
  meth_meth_ast_isDelimited7368->definitionLine = 1862;
  sourceObject = obj7301;
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7370 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7371 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7372 = gc_frame_new();
// call case 3: self.outer request
  Object call7373 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7372);
// compiled member node returning call7373 (depth = 5)
  Object call7374 = callmethodflags(call7373, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7371);
// compiled member node returning call7374 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7375 = callmethodflags(call7374, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7370);
// compiled call node returning call7375 (depth = 3)
  struct UserObject *obj7301_uo = (struct UserObject *)obj7301;
  obj7301_uo->super = call7375;
  sourceObject = obj7301;
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7376 == NULL) {
    strlit7376 = alloc_String("string");
    gc_root(strlit7376);
  }
// compiled string node returning strlit7376 (depth = 3)
  adddatum2(obj7301, strlit7376, 1);
  sourceObject = obj7301;
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7301, *var_v, 2);
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  objclass7301 = obj7301->class;
  objclass7301->definitionModule = modulename;
  objclass7301->definitionLine = 1838;
  (*(struct UserObject *)self).data[0] = lowerouter7301;
  self = oldself7301;
  selfslot = oldselfslot7301;
  stackframe = oldstackframe7301;
  gc_frame_end(frame);
  return obj7301;
}
Object meth_ast_new_40_1_41_7300_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7301 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7301 = alloc_userobj2(11,11, objclass7301);
  gc_frame_newslot(obj7301);
if (objclass7301 == NULL) {
  glfree(obj7301->class->name);
  obj7301->class->name = "stringNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7301, self, 0);
  addmethodreal(obj7301,"outer", &reader_ast_outer_7302);
  Object oldself7301 = self;
  struct StackFrameObject *oldstackframe7301 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7301);
  gc_frame_newslot((Object)stackframe);
  self = obj7301;
  Object *oldselfslot7301 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7301 = (*(struct UserObject *)self).data[0], lowerouter7301 = thisouter7301;
  if (inheritingObject7301) {
    struct UserObject *inho7301 = (struct UserObject *)inheritingObject7301;
    while (inho7301->super != GraceDefaultObject) inho7301 = (struct UserObject *)inho7301->super;
    inho7301->super = obj7301;
    self = inheritingObject7301;
    *selfslot = self;
    lowerouter7301 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7301;
  }
if (objclass7301 == NULL) {
  Method *reader7303 = addmethodrealflags(obj7301, "kind",&reader_ast_kind_7303, MFLAG_DEF);
  reader7303->definitionModule = modulename;
  reader7303->definitionLine = 1840;
}
adddatum2(obj7301, alloc_Undefined(), 1);
if (objclass7301 == NULL) {
  Method *reader7304 = addmethodrealflags(obj7301, "value", &reader_ast_value_7304, 0);
  Method *writer7304 = addmethodrealflags(obj7301, "value:=(1)", &writer_ast_value_7304, 0);
  reader7304->definitionModule = modulename;
  writer7304->definitionModule = modulename;
  reader7304->definitionLine = 1841;
  writer7304->definitionLine = 1841;
}
obj7301->flags |= OFLAG_MUTABLE;
adddatum2(obj7301, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo7305 = (struct UserObject*)obj7301;
  uo7305->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7305 = addmethod2pos(obj7301, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7305, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7305[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7305->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7305);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7305->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7305->definitionLine = 1842;
// method "map(_)ancestors(_)"
  struct UserObject *uo7308 = (struct UserObject*)obj7301;
  uo7308->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7308 = addmethod2pos(obj7301, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7308, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7308[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7308->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7308);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7308->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7308->definitionLine = 1845;
// method "pretty(_)"
  struct UserObject *uo7315 = (struct UserObject*)obj7301;
  uo7315->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7315 = addmethod2pos(obj7301, "pretty(1)", &meth_ast_pretty_40_1_41_7315, 5);
  int argcv_meth_ast_pretty_40_1_41_7315[] = {1};
  meth_meth_ast_pretty_40_1_41_7315->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7315);
  meth_meth_ast_pretty_40_1_41_7315->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7315->definitionLine = 1850;
// method "toGrace(_)"
  struct UserObject *uo7335 = (struct UserObject*)obj7301;
  uo7335->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7335 = addmethod2pos(obj7301, "toGrace(1)", &meth_ast_toGrace_40_1_41_7335, 6);
  int argcv_meth_ast_toGrace_40_1_41_7335[] = {1};
  meth_meth_ast_toGrace_40_1_41_7335->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7335);
meth_meth_ast_toGrace_40_1_41_7335->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7335->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7335->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7335->definitionLine = 1853;
// method "asString"
  struct UserObject *uo7347 = (struct UserObject*)obj7301;
  uo7347->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7347 = addmethod2pos(obj7301, "asString", &meth_ast_asString7347, 7);
  int argcv_meth_ast_asString7347[] = {0};
  meth_meth_ast_asString7347->type = alloc_MethodType(1, argcv_meth_ast_asString7347);
  meth_meth_ast_asString7347->definitionModule = modulename;
  meth_meth_ast_asString7347->definitionLine = 1857;
// method "shallowCopy"
  block_savedest(obj7301);
  Object closure7359 = createclosure(1, "shallowCopy");
  setclosureframe(closure7359, stackframe);
  addtoclosure(closure7359, var_stringNode);
  struct UserObject *uo7359 = (struct UserObject*)obj7301;
  uo7359->data[8] = (Object)closure7359;
  Method *meth_meth_ast_shallowCopy7359 = addmethod2pos(obj7301, "shallowCopy", &meth_ast_shallowCopy7359, 8);
  int argcv_meth_ast_shallowCopy7359[] = {0};
  meth_meth_ast_shallowCopy7359->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7359);
  meth_meth_ast_shallowCopy7359->definitionModule = modulename;
  meth_meth_ast_shallowCopy7359->definitionLine = 1858;
// method "statementName"
  struct UserObject *uo7366 = (struct UserObject*)obj7301;
  uo7366->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7366 = addmethod2pos(obj7301, "statementName", &meth_ast_statementName7366, 9);
  int argcv_meth_ast_statementName7366[] = {0};
  meth_meth_ast_statementName7366->type = alloc_MethodType(1, argcv_meth_ast_statementName7366);
  meth_meth_ast_statementName7366->definitionModule = modulename;
  meth_meth_ast_statementName7366->definitionLine = 1861;
// method "isDelimited"
  struct UserObject *uo7368 = (struct UserObject*)obj7301;
  uo7368->data[10] = emptyclosure;
  Method *meth_meth_ast_isDelimited7368 = addmethod2pos(obj7301, "isDelimited", &meth_ast_isDelimited7368, 10);
  int argcv_meth_ast_isDelimited7368[] = {0};
  meth_meth_ast_isDelimited7368->type = alloc_MethodType(1, argcv_meth_ast_isDelimited7368);
  meth_meth_ast_isDelimited7368->definitionModule = modulename;
  meth_meth_ast_isDelimited7368->definitionLine = 1862;
  sourceObject = obj7301;
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7370 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7371 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7372 = gc_frame_new();
// call case 3: self.outer request
  Object call7373 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7372);
// compiled member node returning call7373 (depth = 5)
  Object call7374 = callmethodflags(call7373, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7371);
// compiled member node returning call7374 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7375 = callmethodflags(call7374, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7370);
// compiled call node returning call7375 (depth = 3)
  struct UserObject *obj7301_uo = (struct UserObject *)obj7301;
  obj7301_uo->super = call7375;
  sourceObject = obj7301;
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7376 == NULL) {
    strlit7376 = alloc_String("string");
    gc_root(strlit7376);
  }
// compiled string node returning strlit7376 (depth = 3)
  adddatum2(obj7301, strlit7376, 1);
  sourceObject = obj7301;
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7301, *var_v, 2);
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  sourceObject = obj7301;
  objclass7301 = obj7301->class;
  objclass7301->definitionModule = modulename;
  objclass7301->definitionLine = 1838;
  (*(struct UserObject *)self).data[0] = lowerouter7301;
  self = oldself7301;
  selfslot = oldselfslot7301;
  stackframe = oldstackframe7301;
  gc_frame_end(frame);
  return obj7301;
}
Object meth_ast_stringNode7378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_stringNode (depth = 3)
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7386(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7387 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7388 = callmethodflags(*var_visitor, "visitNum(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7387);
// compiled call node returning call7388 (depth = 3)
  gc_frame_end(frame);
  return call7388;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_7389(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7390 = gc_frame_new();
// call case 4: self request
  Object call7391 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7390);
// compiled member node returning call7391 (depth = 4)
  *var_n = call7391;
  if (call7391 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7392 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7393 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7392);
// compiled call node returning call7393 (depth = 4)
  *var_newChain = call7393;
  if (call7393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7394 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7395 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7394);
// compiled call node returning call7395 (depth = 3)
  gc_frame_end(frame);
  return call7395;
}
Object meth_ast_pretty_40_1_41_7396(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7398 == NULL) {
    strlit7398 = alloc_String(")");
    gc_root(strlit7398);
  }
// compiled string node returning strlit7398 (depth = 4)
  int op_slot_right_7397 = gc_frame_newslot(strlit7398);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7401 = gc_frame_new();
// call case 4: self request
  Object call7402 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7401);
// compiled member node returning call7402 (depth = 5)
  int op_slot_right_7400 = gc_frame_newslot(call7402);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7405 == NULL) {
    strlit7405 = alloc_String("(");
    gc_root(strlit7405);
  }
// compiled string node returning strlit7405 (depth = 6)
  int op_slot_right_7404 = gc_frame_newslot(strlit7405);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7408 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7409 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7408);
// compiled call node returning call7409 (depth = 7)
  int op_slot_right_7407 = gc_frame_newslot(call7409);
// starting to compile string node (depth = 7)
  if (strlit7411 == NULL) {
    strlit7411 = alloc_String("");
    gc_root(strlit7411);
  }
// compiled string node returning strlit7411 (depth = 7)
  int op_slot_left_7407 = gc_frame_newslot(strlit7411);
  params[0] = call7409;
  partcv[0] = 1;
  Object opresult7412 = callmethod(strlit7411, "++(1)", 1, partcv, params);
// compiled op node returning opresult7412 (depth = 6)
  int op_slot_left_7404 = gc_frame_newslot(opresult7412);
  params[0] = strlit7405;
  partcv[0] = 1;
  Object opresult7413 = callmethod(opresult7412, "++(1)", 1, partcv, params);
// compiled op node returning opresult7413 (depth = 5)
  int op_slot_left_7400 = gc_frame_newslot(opresult7413);
  params[0] = call7402;
  partcv[0] = 1;
  Object opresult7414 = callmethod(opresult7413, "++(1)", 1, partcv, params);
// compiled op node returning opresult7414 (depth = 4)
  int op_slot_left_7397 = gc_frame_newslot(opresult7414);
  params[0] = strlit7398;
  partcv[0] = 1;
  Object opresult7415 = callmethod(opresult7414, "++(1)", 1, partcv, params);
// compiled op node returning opresult7415 (depth = 3)
  gc_frame_end(frame);
  return opresult7415;
}
Object meth_ast_toGrace_40_1_41_7416(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7417 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7418 = gc_frame_new();
// call case 4: self request
  Object call7419 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7418);
// compiled member node returning call7419 (depth = 4)
  Object call7420 = callmethodflags(call7419, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe7417);
// compiled member node returning call7420 (depth = 3)
  gc_frame_end(frame);
  return call7420;
}
Object meth_ast_asString7421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7423 == NULL) {
    strlit7423 = alloc_String("");
    gc_root(strlit7423);
  }
// compiled string node returning strlit7423 (depth = 4)
  int op_slot_right_7422 = gc_frame_newslot(strlit7423);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7426 = gc_frame_new();
// call case 4: self request
  Object call7427 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7426);
// compiled member node returning call7427 (depth = 5)
  int op_slot_right_7425 = gc_frame_newslot(call7427);
// starting to compile string node (depth = 5)
  if (strlit7429 == NULL) {
    strlit7429 = alloc_String("num ");
    gc_root(strlit7429);
  }
// compiled string node returning strlit7429 (depth = 5)
  int op_slot_left_7425 = gc_frame_newslot(strlit7429);
  params[0] = call7427;
  partcv[0] = 1;
  Object opresult7430 = callmethod(strlit7429, "++(1)", 1, partcv, params);
// compiled op node returning opresult7430 (depth = 4)
  int op_slot_left_7422 = gc_frame_newslot(opresult7430);
  params[0] = strlit7423;
  partcv[0] = 1;
  Object opresult7431 = callmethod(opresult7430, "++(1)", 1, partcv, params);
// compiled op node returning opresult7431 (depth = 3)
  gc_frame_end(frame);
  return opresult7431;
}
Object meth_ast_shallowCopy7432(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7433 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7434 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7435 = gc_frame_new();
// call case 4: self request
  Object call7436 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7435);
// compiled member node returning call7436 (depth = 5)
  gc_frame_newslot(call7436);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_numNode (depth = 5)
  params[0] = call7436;
  partcv[0] = 1;
  Object call7437 = callmethodflags(*var_numNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7434);
// compiled call node returning call7437 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7438 = callmethodflags(call7437, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7433);
// compiled call node returning call7438 (depth = 3)
  gc_frame_end(frame);
  return call7438;
}
Object meth_ast_statementName7439(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7440 == NULL) {
    strlit7440 = alloc_String("expression");
    gc_root(strlit7440);
  }
// compiled string node returning strlit7440 (depth = 3)
  gc_frame_end(frame);
  return strlit7440;
}
Object meth_ast_isDelimited7441(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7442 = alloc_Boolean(1);
// compiled identifier node returning bool7442 (depth = 3)
  gc_frame_end(frame);
  return bool7442;
}
Object meth_ast_new_40_1_41_7381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7382 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7382 = alloc_userobj2(11,11, objclass7382);
  gc_frame_newslot(obj7382);
if (objclass7382 == NULL) {
  glfree(obj7382->class->name);
  obj7382->class->name = "numNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7382, self, 0);
  addmethodreal(obj7382,"outer", &reader_ast_outer_7383);
  Object oldself7382 = self;
  struct StackFrameObject *oldstackframe7382 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7382);
  gc_frame_newslot((Object)stackframe);
  self = obj7382;
  Object *oldselfslot7382 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7382 = (*(struct UserObject *)self).data[0], lowerouter7382 = thisouter7382;
  if (inheritingObject7382) {
    struct UserObject *inho7382 = (struct UserObject *)inheritingObject7382;
    while (inho7382->super != GraceDefaultObject) inho7382 = (struct UserObject *)inho7382->super;
    inho7382->super = obj7382;
    self = inheritingObject7382;
    *selfslot = self;
    lowerouter7382 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7382;
  }
if (objclass7382 == NULL) {
  Method *reader7384 = addmethodrealflags(obj7382, "kind",&reader_ast_kind_7384, MFLAG_DEF);
  reader7384->definitionModule = modulename;
  reader7384->definitionLine = 1868;
}
adddatum2(obj7382, alloc_Undefined(), 1);
if (objclass7382 == NULL) {
  Method *reader7385 = addmethodrealflags(obj7382, "value", &reader_ast_value_7385, 0);
  Method *writer7385 = addmethodrealflags(obj7382, "value:=(1)", &writer_ast_value_7385, 0);
  reader7385->definitionModule = modulename;
  writer7385->definitionModule = modulename;
  reader7385->definitionLine = 1869;
  writer7385->definitionLine = 1869;
}
obj7382->flags |= OFLAG_MUTABLE;
adddatum2(obj7382, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo7386 = (struct UserObject*)obj7382;
  uo7386->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7386 = addmethod2pos(obj7382, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7386, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7386[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7386->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7386);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7386->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7386->definitionLine = 1870;
// method "map(_)ancestors(_)"
  struct UserObject *uo7389 = (struct UserObject*)obj7382;
  uo7389->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7389 = addmethod2pos(obj7382, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7389, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7389[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7389->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7389);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7389->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7389->definitionLine = 1873;
// method "pretty(_)"
  struct UserObject *uo7396 = (struct UserObject*)obj7382;
  uo7396->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7396 = addmethod2pos(obj7382, "pretty(1)", &meth_ast_pretty_40_1_41_7396, 5);
  int argcv_meth_ast_pretty_40_1_41_7396[] = {1};
  meth_meth_ast_pretty_40_1_41_7396->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7396);
  meth_meth_ast_pretty_40_1_41_7396->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7396->definitionLine = 1878;
// method "toGrace(_)"
  struct UserObject *uo7416 = (struct UserObject*)obj7382;
  uo7416->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7416 = addmethod2pos(obj7382, "toGrace(1)", &meth_ast_toGrace_40_1_41_7416, 6);
  int argcv_meth_ast_toGrace_40_1_41_7416[] = {1};
  meth_meth_ast_toGrace_40_1_41_7416->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7416);
meth_meth_ast_toGrace_40_1_41_7416->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7416->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7416->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7416->definitionLine = 1881;
// method "asString"
  struct UserObject *uo7421 = (struct UserObject*)obj7382;
  uo7421->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7421 = addmethod2pos(obj7382, "asString", &meth_ast_asString7421, 7);
  int argcv_meth_ast_asString7421[] = {0};
  meth_meth_ast_asString7421->type = alloc_MethodType(1, argcv_meth_ast_asString7421);
  meth_meth_ast_asString7421->definitionModule = modulename;
  meth_meth_ast_asString7421->definitionLine = 1884;
// method "shallowCopy"
  block_savedest(obj7382);
  Object closure7432 = createclosure(1, "shallowCopy");
  setclosureframe(closure7432, stackframe);
  addtoclosure(closure7432, var_numNode);
  struct UserObject *uo7432 = (struct UserObject*)obj7382;
  uo7432->data[8] = (Object)closure7432;
  Method *meth_meth_ast_shallowCopy7432 = addmethod2pos(obj7382, "shallowCopy", &meth_ast_shallowCopy7432, 8);
  int argcv_meth_ast_shallowCopy7432[] = {0};
  meth_meth_ast_shallowCopy7432->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7432);
  meth_meth_ast_shallowCopy7432->definitionModule = modulename;
  meth_meth_ast_shallowCopy7432->definitionLine = 1885;
// method "statementName"
  struct UserObject *uo7439 = (struct UserObject*)obj7382;
  uo7439->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7439 = addmethod2pos(obj7382, "statementName", &meth_ast_statementName7439, 9);
  int argcv_meth_ast_statementName7439[] = {0};
  meth_meth_ast_statementName7439->type = alloc_MethodType(1, argcv_meth_ast_statementName7439);
  meth_meth_ast_statementName7439->definitionModule = modulename;
  meth_meth_ast_statementName7439->definitionLine = 1888;
// method "isDelimited"
  struct UserObject *uo7441 = (struct UserObject*)obj7382;
  uo7441->data[10] = emptyclosure;
  Method *meth_meth_ast_isDelimited7441 = addmethod2pos(obj7382, "isDelimited", &meth_ast_isDelimited7441, 10);
  int argcv_meth_ast_isDelimited7441[] = {0};
  meth_meth_ast_isDelimited7441->type = alloc_MethodType(1, argcv_meth_ast_isDelimited7441);
  meth_meth_ast_isDelimited7441->definitionModule = modulename;
  meth_meth_ast_isDelimited7441->definitionLine = 1889;
  sourceObject = obj7382;
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7443 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7444 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7445 = gc_frame_new();
// call case 3: self.outer request
  Object call7446 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7445);
// compiled member node returning call7446 (depth = 5)
  Object call7447 = callmethodflags(call7446, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7444);
// compiled member node returning call7447 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7448 = callmethodflags(call7447, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7443);
// compiled call node returning call7448 (depth = 3)
  struct UserObject *obj7382_uo = (struct UserObject *)obj7382;
  obj7382_uo->super = call7448;
  sourceObject = obj7382;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7449 == NULL) {
    strlit7449 = alloc_String("num");
    gc_root(strlit7449);
  }
// compiled string node returning strlit7449 (depth = 3)
  adddatum2(obj7382, strlit7449, 1);
  sourceObject = obj7382;
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7382, *var_val, 2);
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  objclass7382 = obj7382->class;
  objclass7382->definitionModule = modulename;
  objclass7382->definitionLine = 1866;
  (*(struct UserObject *)self).data[0] = lowerouter7382;
  self = oldself7382;
  selfslot = oldselfslot7382;
  stackframe = oldstackframe7382;
  gc_frame_end(frame);
  return obj7382;
}
Object meth_ast_new_40_1_41_7381_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7382 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7382 = alloc_userobj2(11,11, objclass7382);
  gc_frame_newslot(obj7382);
if (objclass7382 == NULL) {
  glfree(obj7382->class->name);
  obj7382->class->name = "numNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7382, self, 0);
  addmethodreal(obj7382,"outer", &reader_ast_outer_7383);
  Object oldself7382 = self;
  struct StackFrameObject *oldstackframe7382 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7382);
  gc_frame_newslot((Object)stackframe);
  self = obj7382;
  Object *oldselfslot7382 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7382 = (*(struct UserObject *)self).data[0], lowerouter7382 = thisouter7382;
  if (inheritingObject7382) {
    struct UserObject *inho7382 = (struct UserObject *)inheritingObject7382;
    while (inho7382->super != GraceDefaultObject) inho7382 = (struct UserObject *)inho7382->super;
    inho7382->super = obj7382;
    self = inheritingObject7382;
    *selfslot = self;
    lowerouter7382 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7382;
  }
if (objclass7382 == NULL) {
  Method *reader7384 = addmethodrealflags(obj7382, "kind",&reader_ast_kind_7384, MFLAG_DEF);
  reader7384->definitionModule = modulename;
  reader7384->definitionLine = 1868;
}
adddatum2(obj7382, alloc_Undefined(), 1);
if (objclass7382 == NULL) {
  Method *reader7385 = addmethodrealflags(obj7382, "value", &reader_ast_value_7385, 0);
  Method *writer7385 = addmethodrealflags(obj7382, "value:=(1)", &writer_ast_value_7385, 0);
  reader7385->definitionModule = modulename;
  writer7385->definitionModule = modulename;
  reader7385->definitionLine = 1869;
  writer7385->definitionLine = 1869;
}
obj7382->flags |= OFLAG_MUTABLE;
adddatum2(obj7382, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo7386 = (struct UserObject*)obj7382;
  uo7386->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7386 = addmethod2pos(obj7382, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7386, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7386[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7386->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7386);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7386->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7386->definitionLine = 1870;
// method "map(_)ancestors(_)"
  struct UserObject *uo7389 = (struct UserObject*)obj7382;
  uo7389->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7389 = addmethod2pos(obj7382, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7389, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7389[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7389->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7389);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7389->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7389->definitionLine = 1873;
// method "pretty(_)"
  struct UserObject *uo7396 = (struct UserObject*)obj7382;
  uo7396->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7396 = addmethod2pos(obj7382, "pretty(1)", &meth_ast_pretty_40_1_41_7396, 5);
  int argcv_meth_ast_pretty_40_1_41_7396[] = {1};
  meth_meth_ast_pretty_40_1_41_7396->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7396);
  meth_meth_ast_pretty_40_1_41_7396->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7396->definitionLine = 1878;
// method "toGrace(_)"
  struct UserObject *uo7416 = (struct UserObject*)obj7382;
  uo7416->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7416 = addmethod2pos(obj7382, "toGrace(1)", &meth_ast_toGrace_40_1_41_7416, 6);
  int argcv_meth_ast_toGrace_40_1_41_7416[] = {1};
  meth_meth_ast_toGrace_40_1_41_7416->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7416);
meth_meth_ast_toGrace_40_1_41_7416->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7416->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7416->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7416->definitionLine = 1881;
// method "asString"
  struct UserObject *uo7421 = (struct UserObject*)obj7382;
  uo7421->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7421 = addmethod2pos(obj7382, "asString", &meth_ast_asString7421, 7);
  int argcv_meth_ast_asString7421[] = {0};
  meth_meth_ast_asString7421->type = alloc_MethodType(1, argcv_meth_ast_asString7421);
  meth_meth_ast_asString7421->definitionModule = modulename;
  meth_meth_ast_asString7421->definitionLine = 1884;
// method "shallowCopy"
  block_savedest(obj7382);
  Object closure7432 = createclosure(1, "shallowCopy");
  setclosureframe(closure7432, stackframe);
  addtoclosure(closure7432, var_numNode);
  struct UserObject *uo7432 = (struct UserObject*)obj7382;
  uo7432->data[8] = (Object)closure7432;
  Method *meth_meth_ast_shallowCopy7432 = addmethod2pos(obj7382, "shallowCopy", &meth_ast_shallowCopy7432, 8);
  int argcv_meth_ast_shallowCopy7432[] = {0};
  meth_meth_ast_shallowCopy7432->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7432);
  meth_meth_ast_shallowCopy7432->definitionModule = modulename;
  meth_meth_ast_shallowCopy7432->definitionLine = 1885;
// method "statementName"
  struct UserObject *uo7439 = (struct UserObject*)obj7382;
  uo7439->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7439 = addmethod2pos(obj7382, "statementName", &meth_ast_statementName7439, 9);
  int argcv_meth_ast_statementName7439[] = {0};
  meth_meth_ast_statementName7439->type = alloc_MethodType(1, argcv_meth_ast_statementName7439);
  meth_meth_ast_statementName7439->definitionModule = modulename;
  meth_meth_ast_statementName7439->definitionLine = 1888;
// method "isDelimited"
  struct UserObject *uo7441 = (struct UserObject*)obj7382;
  uo7441->data[10] = emptyclosure;
  Method *meth_meth_ast_isDelimited7441 = addmethod2pos(obj7382, "isDelimited", &meth_ast_isDelimited7441, 10);
  int argcv_meth_ast_isDelimited7441[] = {0};
  meth_meth_ast_isDelimited7441->type = alloc_MethodType(1, argcv_meth_ast_isDelimited7441);
  meth_meth_ast_isDelimited7441->definitionModule = modulename;
  meth_meth_ast_isDelimited7441->definitionLine = 1889;
  sourceObject = obj7382;
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7443 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7444 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7445 = gc_frame_new();
// call case 3: self.outer request
  Object call7446 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7445);
// compiled member node returning call7446 (depth = 5)
  Object call7447 = callmethodflags(call7446, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7444);
// compiled member node returning call7447 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7448 = callmethodflags(call7447, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7443);
// compiled call node returning call7448 (depth = 3)
  struct UserObject *obj7382_uo = (struct UserObject *)obj7382;
  obj7382_uo->super = call7448;
  sourceObject = obj7382;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7449 == NULL) {
    strlit7449 = alloc_String("num");
    gc_root(strlit7449);
  }
// compiled string node returning strlit7449 (depth = 3)
  adddatum2(obj7382, strlit7449, 1);
  sourceObject = obj7382;
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7382, *var_val, 2);
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  objclass7382 = obj7382->class;
  objclass7382->definitionModule = modulename;
  objclass7382->definitionLine = 1866;
  (*(struct UserObject *)self).data[0] = lowerouter7382;
  self = oldself7382;
  selfslot = oldselfslot7382;
  stackframe = oldstackframe7382;
  gc_frame_end(frame);
  return obj7382;
}
Object meth_ast_numNode7451(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_numNode (depth = 3)
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_isSimple7461(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7462 = alloc_Boolean(0);
// compiled identifier node returning bool7462 (depth = 3)
  gc_frame_end(frame);
  return bool7462;
}
Object meth_ast_nameString7463(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7465 == NULL) {
    strlit7465 = alloc_String("(1)");
    gc_root(strlit7465);
  }
// compiled string node returning strlit7465 (depth = 4)
  int op_slot_right_7464 = gc_frame_newslot(strlit7465);
// starting to compile member node (depth = 4)
  int callframe7467 = gc_frame_new();
// call case 4: self request
  Object call7468 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7467);
// compiled member node returning call7468 (depth = 4)
  int op_slot_left_7464 = gc_frame_newslot(call7468);
  params[0] = strlit7465;
  partcv[0] = 1;
  Object opresult7469 = callmethod(call7468, "++(1)", 1, partcv, params);
// compiled op node returning opresult7469 (depth = 3)
  gc_frame_end(frame);
  return opresult7469;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7470(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7472 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7473 = callmethodflags(*var_visitor, "visitOp(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7472);
// compiled call node returning call7473 (depth = 4)
  Object if7471 = done;
  if (istrue(call7473)) {
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7474 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7475 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7474);
// compiled call node returning call7475 (depth = 5)
  *var_newChain = call7475;
  if (call7475 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7476 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7477 = gc_frame_new();
// call case 4: self request
  Object call7478 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7477);
// compiled member node returning call7478 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7479 = callmethodflags(call7478, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7476);
// compiled call node returning call7479 (depth = 4)
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7480 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7481 = gc_frame_new();
// call case 4: self request
  Object call7482 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7481);
// compiled member node returning call7482 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7483 = callmethodflags(call7482, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7480);
// compiled call node returning call7483 (depth = 4)
    gc_frame_newslot(call7483);
    if7471 = call7483;
  } else {
  }
// compiled if node returning if7471 (depth = 3)
  gc_frame_end(frame);
  return if7471;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_7484(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7485 = gc_frame_new();
// call case 4: self request
  Object call7486 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7485);
// compiled member node returning call7486 (depth = 4)
  *var_n = call7486;
  if (call7486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7487 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7488 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7487);
// compiled call node returning call7488 (depth = 4)
  *var_newChain = call7488;
  if (call7488 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7489 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7490 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7491 = gc_frame_new();
// call case 4: self request
  Object call7492 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7491);
// compiled member node returning call7492 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7493 = callmethodflags(call7492, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7490);
// compiled call node returning call7493 (depth = 4)
  gc_frame_newslot(call7493);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7493;
  partcv[0] = 1;
  Object call7494 = callmethodflags(*var_n, "left:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7489);
// compiled call node returning call7494 (depth = 3)
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7495 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7496 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7497 = gc_frame_new();
// call case 4: self request
  Object call7498 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7497);
// compiled member node returning call7498 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7499 = callmethodflags(call7498, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7496);
// compiled call node returning call7499 (depth = 4)
  gc_frame_newslot(call7499);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7499;
  partcv[0] = 1;
  Object call7500 = callmethodflags(*var_n, "right:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7495);
// compiled call node returning call7500 (depth = 3)
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7501 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7502 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7501);
// compiled call node returning call7502 (depth = 3)
  gc_frame_end(frame);
  return call7502;
}
Object meth_ast__apply_40_1_41_7511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7513 == NULL) {
    strlit7513 = alloc_String("  ");
    gc_root(strlit7513);
  }
// compiled string node returning strlit7513 (depth = 7)
  int op_slot_right_7512 = gc_frame_newslot(strlit7513);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7512 = gc_frame_newslot(*var_spc);
  params[0] = strlit7513;
  partcv[0] = 1;
  Object opresult7515 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult7515 (depth = 6)
  *var_spc = opresult7515;
  if (opresult7515 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_7503(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7504 == NULL) {
    strlit7504 = alloc_String("");
    gc_root(strlit7504);
  }
// compiled string node returning strlit7504 (depth = 4)
  *var_spc = strlit7504;
  if (strlit7504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7505 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7506 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7508 = alloc_Float64(0);
// compiled num node returning num7508 (depth = 5)
  int op_slot_left_7506 = gc_frame_newslot(num7508);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7509 = callmethod(num7508, "..(1)", 1, partcv, params);
// compiled op node returning opresult7509 (depth = 4)
  gc_frame_newslot(opresult7509);
// starting to compile block node (depth = 4)
  Object block7510 = alloc_Block(NULL, NULL, "ast", 1917);
  gc_frame_newslot(block7510);
// method "_apply(_)"
  block_savedest(block7510);
  Object closure7511 = createclosure(2, "_apply(1)");
  setclosureframe(closure7511, stackframe);
  addtoclosure(closure7511, var_spc);
  addtoclosure(closure7511, selfslot);
  struct UserObject *uo7511 = (struct UserObject*)block7510;
  uo7511->data[0] = (Object)closure7511;
  Method *meth_meth_ast__apply_40_1_41_7511 = addmethod2pos(block7510, "_apply(1)", &meth_ast__apply_40_1_41_7511, 0);
  int argcv_meth_ast__apply_40_1_41_7511[] = {1};
  meth_meth_ast__apply_40_1_41_7511->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7511);
  meth_meth_ast__apply_40_1_41_7511->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7511->definitionLine = 2969;
// compiled block node returning block7510 (depth = 4)
  gc_frame_newslot(block7510);
// call case 5: prelude request
  params[0] = opresult7509;
  params[1] = block7510;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7518 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7505);
// compiled call node returning call7518 (depth = 3)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7520 == NULL) {
    strlit7520 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7520);
  }
// compiled string node returning strlit7520 (depth = 5)
  int op_slot_right_7519 = gc_frame_newslot(strlit7520);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7523 = gc_frame_new();
// call case 4: self request
  Object call7524 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7523);
// compiled member node returning call7524 (depth = 6)
  int op_slot_right_7522 = gc_frame_newslot(call7524);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7527 == NULL) {
    strlit7527 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7527);
  }
// compiled string node returning strlit7527 (depth = 7)
  int op_slot_right_7526 = gc_frame_newslot(strlit7527);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7530 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7531 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7530);
// compiled call node returning call7531 (depth = 8)
  int op_slot_right_7529 = gc_frame_newslot(call7531);
// starting to compile string node (depth = 8)
  if (strlit7533 == NULL) {
    strlit7533 = alloc_String("");
    gc_root(strlit7533);
  }
// compiled string node returning strlit7533 (depth = 8)
  int op_slot_left_7529 = gc_frame_newslot(strlit7533);
  params[0] = call7531;
  partcv[0] = 1;
  Object opresult7534 = callmethod(strlit7533, "++(1)", 1, partcv, params);
// compiled op node returning opresult7534 (depth = 7)
  int op_slot_left_7526 = gc_frame_newslot(opresult7534);
  params[0] = strlit7527;
  partcv[0] = 1;
  Object opresult7535 = callmethod(opresult7534, "++(1)", 1, partcv, params);
// compiled op node returning opresult7535 (depth = 6)
  int op_slot_left_7522 = gc_frame_newslot(opresult7535);
  params[0] = call7524;
  partcv[0] = 1;
  Object opresult7536 = callmethod(opresult7535, "++(1)", 1, partcv, params);
// compiled op node returning opresult7536 (depth = 5)
  int op_slot_left_7519 = gc_frame_newslot(opresult7536);
  params[0] = strlit7520;
  partcv[0] = 1;
  Object opresult7537 = callmethod(opresult7536, "++(1)", 1, partcv, params);
// compiled op node returning opresult7537 (depth = 4)
  *var_s = opresult7537;
  if (opresult7537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7539 == NULL) {
    strlit7539 = alloc_String("""\x0a""");
    gc_root(strlit7539);
  }
// compiled string node returning strlit7539 (depth = 5)
  int op_slot_right_7538 = gc_frame_newslot(strlit7539);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7538 = gc_frame_newslot(*var_s);
  params[0] = strlit7539;
  partcv[0] = 1;
  Object opresult7541 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7541 (depth = 4)
  *var_s = opresult7541;
  if (opresult7541 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7544 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7546 = alloc_Float64(1);
// compiled num node returning num7546 (depth = 7)
  int op_slot_right_7545 = gc_frame_newslot(num7546);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7545 = gc_frame_newslot(*var_depth);
  params[0] = num7546;
  partcv[0] = 1;
  Object sum7548 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7548 (depth = 6)
  gc_frame_newslot(sum7548);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7549 = gc_frame_new();
// call case 4: self request
  Object call7550 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7549);
// compiled member node returning call7550 (depth = 6)
  params[0] = sum7548;
  partcv[0] = 1;
  Object call7551 = callmethodflags(call7550, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7544);
// compiled call node returning call7551 (depth = 5)
  int op_slot_right_7543 = gc_frame_newslot(call7551);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7553 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7553 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7555 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7555 (depth = 5)
  int op_slot_left_7543 = gc_frame_newslot(opresult7555);
  params[0] = call7551;
  partcv[0] = 1;
  Object opresult7556 = callmethod(opresult7555, "++(1)", 1, partcv, params);
// compiled op node returning opresult7556 (depth = 4)
  *var_s = opresult7556;
  if (opresult7556 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7559 == NULL) {
    strlit7559 = alloc_String("""\x0a""");
    gc_root(strlit7559);
  }
// compiled string node returning strlit7559 (depth = 5)
  int op_slot_right_7558 = gc_frame_newslot(strlit7559);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7558 = gc_frame_newslot(*var_s);
  params[0] = strlit7559;
  partcv[0] = 1;
  Object opresult7561 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7561 (depth = 4)
  *var_s = opresult7561;
  if (opresult7561 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7564 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7566 = alloc_Float64(1);
// compiled num node returning num7566 (depth = 7)
  int op_slot_right_7565 = gc_frame_newslot(num7566);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7565 = gc_frame_newslot(*var_depth);
  params[0] = num7566;
  partcv[0] = 1;
  Object sum7568 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7568 (depth = 6)
  gc_frame_newslot(sum7568);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7569 = gc_frame_new();
// call case 4: self request
  Object call7570 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7569);
// compiled member node returning call7570 (depth = 6)
  params[0] = sum7568;
  partcv[0] = 1;
  Object call7571 = callmethodflags(call7570, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7564);
// compiled call node returning call7571 (depth = 5)
  int op_slot_right_7563 = gc_frame_newslot(call7571);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7573 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7573 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7575 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7575 (depth = 5)
  int op_slot_left_7563 = gc_frame_newslot(opresult7575);
  params[0] = call7571;
  partcv[0] = 1;
  Object opresult7576 = callmethod(opresult7575, "++(1)", 1, partcv, params);
// compiled op node returning opresult7576 (depth = 4)
  *var_s = opresult7576;
  if (opresult7576 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7583(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7585 = gc_frame_new();
// call case 4: self request
  Object call7586 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7585);
// compiled member node returning call7586 (depth = 7)
  int op_slot_right_7584 = gc_frame_newslot(call7586);
// starting to compile member node (depth = 7)
  int callframe7588 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7589 = gc_frame_new();
// call case 4: self request
  Object call7590 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7589);
// compiled member node returning call7590 (depth = 8)
  Object call7591 = callmethodflags(call7590, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7588);
// compiled member node returning call7591 (depth = 7)
  int op_slot_left_7584 = gc_frame_newslot(call7591);
  params[0] = call7586;
  partcv[0] = 1;
  Object opresult7592 = callmethod(call7591, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7592 (depth = 6)
  gc_frame_end(frame);
  return opresult7592;
}
Object meth_ast__apply7654(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7656 = gc_frame_new();
// call case 4: self request
  Object call7657 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7656);
// compiled member node returning call7657 (depth = 7)
  int op_slot_right_7655 = gc_frame_newslot(call7657);
// starting to compile member node (depth = 7)
  int callframe7659 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7660 = gc_frame_new();
// call case 4: self request
  Object call7661 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7660);
// compiled member node returning call7661 (depth = 8)
  Object call7662 = callmethodflags(call7661, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7659);
// compiled member node returning call7662 (depth = 7)
  int op_slot_left_7655 = gc_frame_newslot(call7662);
  params[0] = call7657;
  partcv[0] = 1;
  Object opresult7663 = callmethod(call7662, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7663 (depth = 6)
  gc_frame_end(frame);
  return opresult7663;
}
Object meth_ast_toGrace_40_1_41_7578(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7579 == NULL) {
    strlit7579 = alloc_String("");
    gc_root(strlit7579);
  }
// compiled string node returning strlit7579 (depth = 4)
  *var_s = strlit7579;
  if (strlit7579 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block7582 = alloc_Block(NULL, NULL, "ast", 1929);
  gc_frame_newslot(block7582);
// method "_apply"
  block_savedest(block7582);
  Object closure7583 = createclosure(1, "_apply");
  setclosureframe(closure7583, stackframe);
  addtoclosure(closure7583, selfslot);
  struct UserObject *uo7583 = (struct UserObject*)block7582;
  uo7583->data[0] = (Object)closure7583;
  Method *meth_meth_ast__apply7583 = addmethod2pos(block7582, "_apply", &meth_ast__apply7583, 0);
  int argcv_meth_ast__apply7583[] = {0};
  meth_meth_ast__apply7583->type = alloc_MethodType(1, argcv_meth_ast__apply7583);
  meth_meth_ast__apply7583->definitionModule = modulename;
  meth_meth_ast__apply7583->definitionLine = 2969;
// compiled block node returning block7582 (depth = 5)
  int op_slot_right_7581 = gc_frame_newslot(block7582);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7596 == NULL) {
    strlit7596 = alloc_String("op");
    gc_root(strlit7596);
  }
// compiled string node returning strlit7596 (depth = 6)
  int op_slot_right_7595 = gc_frame_newslot(strlit7596);
// starting to compile member node (depth = 6)
  int callframe7598 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7599 = gc_frame_new();
// call case 4: self request
  Object call7600 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7599);
// compiled member node returning call7600 (depth = 7)
  Object call7601 = callmethodflags(call7600, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7598);
// compiled member node returning call7601 (depth = 6)
  int op_slot_left_7595 = gc_frame_newslot(call7601);
  params[0] = strlit7596;
  partcv[0] = 1;
  Object opresult7602 = callmethod(call7601, "==(1)", 1, partcv, params);
// compiled op node returning opresult7602 (depth = 5)
  int op_slot_left_7581 = gc_frame_newslot(opresult7602);
  params[0] = block7582;
  partcv[0] = 1;
  Object opresult7603 = callmethod(opresult7602, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7603 (depth = 4)
  Object if7580 = done;
  if (istrue(opresult7603)) {
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7605 == NULL) {
    strlit7605 = alloc_String(")");
    gc_root(strlit7605);
  }
// compiled string node returning strlit7605 (depth = 6)
  int op_slot_right_7604 = gc_frame_newslot(strlit7605);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7608 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7609 = alloc_Float64(0);
// compiled num node returning num7609 (depth = 8)
  gc_frame_newslot(num7609);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7610 = gc_frame_new();
// call case 4: self request
  Object call7611 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7610);
// compiled member node returning call7611 (depth = 8)
  params[0] = num7609;
  partcv[0] = 1;
  Object call7612 = callmethodflags(call7611, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7608);
// compiled call node returning call7612 (depth = 7)
  int op_slot_right_7607 = gc_frame_newslot(call7612);
// starting to compile string node (depth = 7)
  if (strlit7614 == NULL) {
    strlit7614 = alloc_String("(");
    gc_root(strlit7614);
  }
// compiled string node returning strlit7614 (depth = 7)
  int op_slot_left_7607 = gc_frame_newslot(strlit7614);
  params[0] = call7612;
  partcv[0] = 1;
  Object opresult7615 = callmethod(strlit7614, "++(1)", 1, partcv, params);
// compiled op node returning opresult7615 (depth = 6)
  int op_slot_left_7604 = gc_frame_newslot(opresult7615);
  params[0] = strlit7605;
  partcv[0] = 1;
  Object opresult7616 = callmethod(opresult7615, "++(1)", 1, partcv, params);
// compiled op node returning opresult7616 (depth = 5)
  *var_s = opresult7616;
  if (opresult7616 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7580 = done;
  } else {
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7618 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num7619 = alloc_Float64(0);
// compiled num node returning num7619 (depth = 6)
  gc_frame_newslot(num7619);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7620 = gc_frame_new();
// call case 4: self request
  Object call7621 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7620);
// compiled member node returning call7621 (depth = 6)
  params[0] = num7619;
  partcv[0] = 1;
  Object call7622 = callmethodflags(call7621, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7618);
// compiled call node returning call7622 (depth = 5)
  *var_s = call7622;
  if (call7622 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7580 = done;
  }
// compiled if node returning if7580 (depth = 3)
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7626 == NULL) {
    strlit7626 = alloc_String("..");
    gc_root(strlit7626);
  }
// compiled string node returning strlit7626 (depth = 5)
  int op_slot_right_7625 = gc_frame_newslot(strlit7626);
// starting to compile member node (depth = 5)
  int callframe7628 = gc_frame_new();
// call case 4: self request
  Object call7629 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7628);
// compiled member node returning call7629 (depth = 5)
  int op_slot_left_7625 = gc_frame_newslot(call7629);
  params[0] = strlit7626;
  partcv[0] = 1;
  Object opresult7630 = callmethod(call7629, "==(1)", 1, partcv, params);
// compiled op node returning opresult7630 (depth = 4)
  Object if7624 = done;
  if (istrue(opresult7630)) {
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7632 = gc_frame_new();
// call case 4: self request
  Object call7633 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7632);
// compiled member node returning call7633 (depth = 6)
  int op_slot_right_7631 = gc_frame_newslot(call7633);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7631 = gc_frame_newslot(*var_s);
  params[0] = call7633;
  partcv[0] = 1;
  Object opresult7635 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7635 (depth = 5)
  *var_s = opresult7635;
  if (opresult7635 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7624 = done;
  } else {
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7638 == NULL) {
    strlit7638 = alloc_String(" ");
    gc_root(strlit7638);
  }
// compiled string node returning strlit7638 (depth = 6)
  int op_slot_right_7637 = gc_frame_newslot(strlit7638);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7641 = gc_frame_new();
// call case 4: self request
  Object call7642 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7641);
// compiled member node returning call7642 (depth = 7)
  int op_slot_right_7640 = gc_frame_newslot(call7642);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7645 == NULL) {
    strlit7645 = alloc_String(" ");
    gc_root(strlit7645);
  }
// compiled string node returning strlit7645 (depth = 8)
  int op_slot_right_7644 = gc_frame_newslot(strlit7645);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7644 = gc_frame_newslot(*var_s);
  params[0] = strlit7645;
  partcv[0] = 1;
  Object opresult7647 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7647 (depth = 7)
  int op_slot_left_7640 = gc_frame_newslot(opresult7647);
  params[0] = call7642;
  partcv[0] = 1;
  Object opresult7648 = callmethod(opresult7647, "++(1)", 1, partcv, params);
// compiled op node returning opresult7648 (depth = 6)
  int op_slot_left_7637 = gc_frame_newslot(opresult7648);
  params[0] = strlit7638;
  partcv[0] = 1;
  Object opresult7649 = callmethod(opresult7648, "++(1)", 1, partcv, params);
// compiled op node returning opresult7649 (depth = 5)
  *var_s = opresult7649;
  if (opresult7649 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7624 = done;
  }
// compiled if node returning if7624 (depth = 3)
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block7653 = alloc_Block(NULL, NULL, "ast", 1939);
  gc_frame_newslot(block7653);
// method "_apply"
  block_savedest(block7653);
  Object closure7654 = createclosure(1, "_apply");
  setclosureframe(closure7654, stackframe);
  addtoclosure(closure7654, selfslot);
  struct UserObject *uo7654 = (struct UserObject*)block7653;
  uo7654->data[0] = (Object)closure7654;
  Method *meth_meth_ast__apply7654 = addmethod2pos(block7653, "_apply", &meth_ast__apply7654, 0);
  int argcv_meth_ast__apply7654[] = {0};
  meth_meth_ast__apply7654->type = alloc_MethodType(1, argcv_meth_ast__apply7654);
  meth_meth_ast__apply7654->definitionModule = modulename;
  meth_meth_ast__apply7654->definitionLine = 2969;
// compiled block node returning block7653 (depth = 5)
  int op_slot_right_7652 = gc_frame_newslot(block7653);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7667 == NULL) {
    strlit7667 = alloc_String("op");
    gc_root(strlit7667);
  }
// compiled string node returning strlit7667 (depth = 6)
  int op_slot_right_7666 = gc_frame_newslot(strlit7667);
// starting to compile member node (depth = 6)
  int callframe7669 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7670 = gc_frame_new();
// call case 4: self request
  Object call7671 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7670);
// compiled member node returning call7671 (depth = 7)
  Object call7672 = callmethodflags(call7671, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7669);
// compiled member node returning call7672 (depth = 6)
  int op_slot_left_7666 = gc_frame_newslot(call7672);
  params[0] = strlit7667;
  partcv[0] = 1;
  Object opresult7673 = callmethod(call7672, "==(1)", 1, partcv, params);
// compiled op node returning opresult7673 (depth = 5)
  int op_slot_left_7652 = gc_frame_newslot(opresult7673);
  params[0] = block7653;
  partcv[0] = 1;
  Object opresult7674 = callmethod(opresult7673, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7674 (depth = 4)
  Object if7651 = done;
  if (istrue(opresult7674)) {
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7676 == NULL) {
    strlit7676 = alloc_String(")");
    gc_root(strlit7676);
  }
// compiled string node returning strlit7676 (depth = 6)
  int op_slot_right_7675 = gc_frame_newslot(strlit7676);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7679 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7680 = alloc_Float64(0);
// compiled num node returning num7680 (depth = 8)
  gc_frame_newslot(num7680);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7681 = gc_frame_new();
// call case 4: self request
  Object call7682 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7681);
// compiled member node returning call7682 (depth = 8)
  params[0] = num7680;
  partcv[0] = 1;
  Object call7683 = callmethodflags(call7682, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7679);
// compiled call node returning call7683 (depth = 7)
  int op_slot_right_7678 = gc_frame_newslot(call7683);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7686 == NULL) {
    strlit7686 = alloc_String("(");
    gc_root(strlit7686);
  }
// compiled string node returning strlit7686 (depth = 8)
  int op_slot_right_7685 = gc_frame_newslot(strlit7686);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7685 = gc_frame_newslot(*var_s);
  params[0] = strlit7686;
  partcv[0] = 1;
  Object opresult7688 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7688 (depth = 7)
  int op_slot_left_7678 = gc_frame_newslot(opresult7688);
  params[0] = call7683;
  partcv[0] = 1;
  Object opresult7689 = callmethod(opresult7688, "++(1)", 1, partcv, params);
// compiled op node returning opresult7689 (depth = 6)
  int op_slot_left_7675 = gc_frame_newslot(opresult7689);
  params[0] = strlit7676;
  partcv[0] = 1;
  Object opresult7690 = callmethod(opresult7689, "++(1)", 1, partcv, params);
// compiled op node returning opresult7690 (depth = 5)
  *var_s = opresult7690;
  if (opresult7690 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7651 = done;
  } else {
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7693 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num7694 = alloc_Float64(0);
// compiled num node returning num7694 (depth = 7)
  gc_frame_newslot(num7694);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7695 = gc_frame_new();
// call case 4: self request
  Object call7696 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7695);
// compiled member node returning call7696 (depth = 7)
  params[0] = num7694;
  partcv[0] = 1;
  Object call7697 = callmethodflags(call7696, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7693);
// compiled call node returning call7697 (depth = 6)
  int op_slot_right_7692 = gc_frame_newslot(call7697);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7692 = gc_frame_newslot(*var_s);
  params[0] = call7697;
  partcv[0] = 1;
  Object opresult7699 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7699 (depth = 5)
  *var_s = opresult7699;
  if (opresult7699 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7651 = done;
  }
// compiled if node returning if7651 (depth = 3)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asIdentifier7701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7702 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7703 = gc_frame_new();
// call case 4: self request
  Object call7704 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7703);
// compiled member node returning call7704 (depth = 5)
  gc_frame_newslot(call7704);
// starting to compile identifier node (depth = 5)
  Object bool7705 = alloc_Boolean(0);
// compiled identifier node returning bool7705 (depth = 5)
  gc_frame_newslot(bool7705);
// starting to compile member node (depth = 5)
  int callframe7706 = gc_frame_new();
// call case 4: self request
  Object call7707 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7706);
// compiled member node returning call7707 (depth = 5)
  gc_frame_newslot(call7707);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7704;
  params[1] = bool7705;
  params[2] = call7707;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7708 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7702);
// compiled call node returning call7708 (depth = 4)
  *var_resultNode = call7708;
  if (call7708 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7709 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7710 = alloc_Boolean(1);
// compiled identifier node returning bool7710 (depth = 4)
  gc_frame_newslot(bool7710);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool7710;
  partcv[0] = 1;
  Object call7711 = callmethodflags(*var_resultNode, "inRequest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7709);
// compiled call node returning call7711 (depth = 3)
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7712 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7713 = gc_frame_new();
// call case 4: self request
  Object call7714 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7713);
// compiled member node returning call7714 (depth = 4)
  gc_frame_newslot(call7714);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7714;
  partcv[0] = 1;
  Object call7715 = callmethodflags(*var_resultNode, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7712);
// compiled call node returning call7715 (depth = 3)
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7716 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7717 = gc_frame_new();
// call case 4: self request
  Object call7718 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7717);
// compiled member node returning call7718 (depth = 4)
  gc_frame_newslot(call7718);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7718;
  partcv[0] = 1;
  Object call7719 = callmethodflags(*var_resultNode, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7716);
// compiled call node returning call7719 (depth = 3)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy7720(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_opNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7721 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7722 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7723 = gc_frame_new();
// call case 4: self request
  Object call7724 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7723);
// compiled member node returning call7724 (depth = 5)
  gc_frame_newslot(call7724);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opNode (depth = 5)
  params[0] = call7724;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call7725 = callmethodflags(*var_opNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe7722);
// compiled call node returning call7725 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7726 = callmethodflags(call7725, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7721);
// compiled call node returning call7726 (depth = 3)
  gc_frame_end(frame);
  return call7726;
}
Object meth_ast_new_40_3_41_7454(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7455 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7455 = alloc_userobj2(14,13, objclass7455);
  gc_frame_newslot(obj7455);
if (objclass7455 == NULL) {
  glfree(obj7455->class->name);
  obj7455->class->name = "opNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7455, self, 0);
  addmethodreal(obj7455,"outer", &reader_ast_outer_7456);
  Object oldself7455 = self;
  struct StackFrameObject *oldstackframe7455 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7455);
  gc_frame_newslot((Object)stackframe);
  self = obj7455;
  Object *oldselfslot7455 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7455 = (*(struct UserObject *)self).data[0], lowerouter7455 = thisouter7455;
  if (inheritingObject7455) {
    struct UserObject *inho7455 = (struct UserObject *)inheritingObject7455;
    while (inho7455->super != GraceDefaultObject) inho7455 = (struct UserObject *)inho7455->super;
    inho7455->super = obj7455;
    self = inheritingObject7455;
    *selfslot = self;
    lowerouter7455 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7455;
  }
if (objclass7455 == NULL) {
  Method *reader7457 = addmethodrealflags(obj7455, "kind",&reader_ast_kind_7457, MFLAG_DEF);
  reader7457->definitionModule = modulename;
  reader7457->definitionLine = 1895;
}
adddatum2(obj7455, alloc_Undefined(), 1);
if (objclass7455 == NULL) {
  Method *reader7458 = addmethodrealflags(obj7455, "value",&reader_ast_value_7458, MFLAG_DEF);
  reader7458->definitionModule = modulename;
  reader7458->definitionLine = 1896;
}
adddatum2(obj7455, alloc_Undefined(), 2);
if (objclass7455 == NULL) {
  Method *reader7459 = addmethodrealflags(obj7455, "left", &reader_ast_left_7459, 0);
  Method *writer7459 = addmethodrealflags(obj7455, "left:=(1)", &writer_ast_left_7459, 0);
  reader7459->definitionModule = modulename;
  writer7459->definitionModule = modulename;
  reader7459->definitionLine = 1897;
  writer7459->definitionLine = 1897;
}
obj7455->flags |= OFLAG_MUTABLE;
adddatum2(obj7455, alloc_Undefined(), 3);
if (objclass7455 == NULL) {
  Method *reader7460 = addmethodrealflags(obj7455, "right", &reader_ast_right_7460, 0);
  Method *writer7460 = addmethodrealflags(obj7455, "right:=(1)", &writer_ast_right_7460, 0);
  reader7460->definitionModule = modulename;
  writer7460->definitionModule = modulename;
  reader7460->definitionLine = 1898;
  writer7460->definitionLine = 1898;
}
obj7455->flags |= OFLAG_MUTABLE;
adddatum2(obj7455, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo7461 = (struct UserObject*)obj7455;
  uo7461->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7461 = addmethod2pos(obj7455, "isSimple", &meth_ast_isSimple7461, 5);
  int argcv_meth_ast_isSimple7461[] = {0};
  meth_meth_ast_isSimple7461->type = alloc_MethodType(1, argcv_meth_ast_isSimple7461);
  meth_meth_ast_isSimple7461->definitionModule = modulename;
  meth_meth_ast_isSimple7461->definitionLine = 1899;
// method "nameString"
  struct UserObject *uo7463 = (struct UserObject*)obj7455;
  uo7463->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7463 = addmethod2pos(obj7455, "nameString", &meth_ast_nameString7463, 6);
  int argcv_meth_ast_nameString7463[] = {0};
  meth_meth_ast_nameString7463->type = alloc_MethodType(1, argcv_meth_ast_nameString7463);
  meth_meth_ast_nameString7463->definitionModule = modulename;
  meth_meth_ast_nameString7463->definitionLine = 1900;
// method "accept(_)from(_)"
  struct UserObject *uo7470 = (struct UserObject*)obj7455;
  uo7470->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7470 = addmethod2pos(obj7455, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7470, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7470[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7470->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7470);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7470->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7470->definitionLine = 1901;
// method "map(_)ancestors(_)"
  struct UserObject *uo7484 = (struct UserObject*)obj7455;
  uo7484->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7484 = addmethod2pos(obj7455, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7484, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7484[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7484->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7484);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7484->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7484->definitionLine = 1908;
// method "pretty(_)"
  struct UserObject *uo7503 = (struct UserObject*)obj7455;
  uo7503->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7503 = addmethod2pos(obj7455, "pretty(1)", &meth_ast_pretty_40_1_41_7503, 9);
  int argcv_meth_ast_pretty_40_1_41_7503[] = {1};
  meth_meth_ast_pretty_40_1_41_7503->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7503);
  meth_meth_ast_pretty_40_1_41_7503->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7503->definitionLine = 1915;
// method "toGrace(_)"
  struct UserObject *uo7578 = (struct UserObject*)obj7455;
  uo7578->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7578 = addmethod2pos(obj7455, "toGrace(1)", &meth_ast_toGrace_40_1_41_7578, 10);
  int argcv_meth_ast_toGrace_40_1_41_7578[] = {1};
  meth_meth_ast_toGrace_40_1_41_7578->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7578);
meth_meth_ast_toGrace_40_1_41_7578->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7578->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7578->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7578->definitionLine = 1927;
// method "asIdentifier"
  block_savedest(obj7455);
  Object closure7701 = createclosure(1, "asIdentifier");
  setclosureframe(closure7701, stackframe);
  addtoclosure(closure7701, var_identifierNode);
  struct UserObject *uo7701 = (struct UserObject*)obj7455;
  uo7701->data[11] = (Object)closure7701;
  Method *meth_meth_ast_asIdentifier7701 = addmethod2pos(obj7455, "asIdentifier", &meth_ast_asIdentifier7701, 11);
  int argcv_meth_ast_asIdentifier7701[] = {0};
  meth_meth_ast_asIdentifier7701->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7701);
  meth_meth_ast_asIdentifier7701->definitionModule = modulename;
  meth_meth_ast_asIdentifier7701->definitionLine = 1946;
// method "shallowCopy"
  block_savedest(obj7455);
  Object closure7720 = createclosure(2, "shallowCopy");
  setclosureframe(closure7720, stackframe);
  addtoclosure(closure7720, var_nullNode);
  addtoclosure(closure7720, var_opNode);
  struct UserObject *uo7720 = (struct UserObject*)obj7455;
  uo7720->data[12] = (Object)closure7720;
  Method *meth_meth_ast_shallowCopy7720 = addmethod2pos(obj7455, "shallowCopy", &meth_ast_shallowCopy7720, 12);
  int argcv_meth_ast_shallowCopy7720[] = {0};
  meth_meth_ast_shallowCopy7720->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7720);
  meth_meth_ast_shallowCopy7720->definitionModule = modulename;
  meth_meth_ast_shallowCopy7720->definitionLine = 1954;
  sourceObject = obj7455;
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7727 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7728 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7729 = gc_frame_new();
// call case 3: self.outer request
  Object call7730 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7729);
// compiled member node returning call7730 (depth = 5)
  Object call7731 = callmethodflags(call7730, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7728);
// compiled member node returning call7731 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7732 = callmethodflags(call7731, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7727);
// compiled call node returning call7732 (depth = 3)
  struct UserObject *obj7455_uo = (struct UserObject *)obj7455;
  obj7455_uo->super = call7732;
  sourceObject = obj7455;
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7733 == NULL) {
    strlit7733 = alloc_String("op");
    gc_root(strlit7733);
  }
// compiled string node returning strlit7733 (depth = 3)
  adddatum2(obj7455, strlit7733, 1);
  sourceObject = obj7455;
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj7455, *var_op, 2);
  sourceObject = obj7455;
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj7455, *var_l, 3);
  sourceObject = obj7455;
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj7455, *var_r, 4);
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  objclass7455 = obj7455->class;
  objclass7455->definitionModule = modulename;
  objclass7455->definitionLine = 1893;
  (*(struct UserObject *)self).data[0] = lowerouter7455;
  self = oldself7455;
  selfslot = oldselfslot7455;
  stackframe = oldstackframe7455;
  gc_frame_end(frame);
  return obj7455;
}
Object meth_ast_new_40_3_41_7454_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7455 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7455 = alloc_userobj2(14,13, objclass7455);
  gc_frame_newslot(obj7455);
if (objclass7455 == NULL) {
  glfree(obj7455->class->name);
  obj7455->class->name = "opNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7455, self, 0);
  addmethodreal(obj7455,"outer", &reader_ast_outer_7456);
  Object oldself7455 = self;
  struct StackFrameObject *oldstackframe7455 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7455);
  gc_frame_newslot((Object)stackframe);
  self = obj7455;
  Object *oldselfslot7455 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7455 = (*(struct UserObject *)self).data[0], lowerouter7455 = thisouter7455;
  if (inheritingObject7455) {
    struct UserObject *inho7455 = (struct UserObject *)inheritingObject7455;
    while (inho7455->super != GraceDefaultObject) inho7455 = (struct UserObject *)inho7455->super;
    inho7455->super = obj7455;
    self = inheritingObject7455;
    *selfslot = self;
    lowerouter7455 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7455;
  }
if (objclass7455 == NULL) {
  Method *reader7457 = addmethodrealflags(obj7455, "kind",&reader_ast_kind_7457, MFLAG_DEF);
  reader7457->definitionModule = modulename;
  reader7457->definitionLine = 1895;
}
adddatum2(obj7455, alloc_Undefined(), 1);
if (objclass7455 == NULL) {
  Method *reader7458 = addmethodrealflags(obj7455, "value",&reader_ast_value_7458, MFLAG_DEF);
  reader7458->definitionModule = modulename;
  reader7458->definitionLine = 1896;
}
adddatum2(obj7455, alloc_Undefined(), 2);
if (objclass7455 == NULL) {
  Method *reader7459 = addmethodrealflags(obj7455, "left", &reader_ast_left_7459, 0);
  Method *writer7459 = addmethodrealflags(obj7455, "left:=(1)", &writer_ast_left_7459, 0);
  reader7459->definitionModule = modulename;
  writer7459->definitionModule = modulename;
  reader7459->definitionLine = 1897;
  writer7459->definitionLine = 1897;
}
obj7455->flags |= OFLAG_MUTABLE;
adddatum2(obj7455, alloc_Undefined(), 3);
if (objclass7455 == NULL) {
  Method *reader7460 = addmethodrealflags(obj7455, "right", &reader_ast_right_7460, 0);
  Method *writer7460 = addmethodrealflags(obj7455, "right:=(1)", &writer_ast_right_7460, 0);
  reader7460->definitionModule = modulename;
  writer7460->definitionModule = modulename;
  reader7460->definitionLine = 1898;
  writer7460->definitionLine = 1898;
}
obj7455->flags |= OFLAG_MUTABLE;
adddatum2(obj7455, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo7461 = (struct UserObject*)obj7455;
  uo7461->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7461 = addmethod2pos(obj7455, "isSimple", &meth_ast_isSimple7461, 5);
  int argcv_meth_ast_isSimple7461[] = {0};
  meth_meth_ast_isSimple7461->type = alloc_MethodType(1, argcv_meth_ast_isSimple7461);
  meth_meth_ast_isSimple7461->definitionModule = modulename;
  meth_meth_ast_isSimple7461->definitionLine = 1899;
// method "nameString"
  struct UserObject *uo7463 = (struct UserObject*)obj7455;
  uo7463->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7463 = addmethod2pos(obj7455, "nameString", &meth_ast_nameString7463, 6);
  int argcv_meth_ast_nameString7463[] = {0};
  meth_meth_ast_nameString7463->type = alloc_MethodType(1, argcv_meth_ast_nameString7463);
  meth_meth_ast_nameString7463->definitionModule = modulename;
  meth_meth_ast_nameString7463->definitionLine = 1900;
// method "accept(_)from(_)"
  struct UserObject *uo7470 = (struct UserObject*)obj7455;
  uo7470->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7470 = addmethod2pos(obj7455, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7470, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7470[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7470->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7470);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7470->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7470->definitionLine = 1901;
// method "map(_)ancestors(_)"
  struct UserObject *uo7484 = (struct UserObject*)obj7455;
  uo7484->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7484 = addmethod2pos(obj7455, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7484, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7484[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7484->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7484);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7484->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7484->definitionLine = 1908;
// method "pretty(_)"
  struct UserObject *uo7503 = (struct UserObject*)obj7455;
  uo7503->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7503 = addmethod2pos(obj7455, "pretty(1)", &meth_ast_pretty_40_1_41_7503, 9);
  int argcv_meth_ast_pretty_40_1_41_7503[] = {1};
  meth_meth_ast_pretty_40_1_41_7503->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7503);
  meth_meth_ast_pretty_40_1_41_7503->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7503->definitionLine = 1915;
// method "toGrace(_)"
  struct UserObject *uo7578 = (struct UserObject*)obj7455;
  uo7578->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7578 = addmethod2pos(obj7455, "toGrace(1)", &meth_ast_toGrace_40_1_41_7578, 10);
  int argcv_meth_ast_toGrace_40_1_41_7578[] = {1};
  meth_meth_ast_toGrace_40_1_41_7578->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7578);
meth_meth_ast_toGrace_40_1_41_7578->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7578->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7578->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7578->definitionLine = 1927;
// method "asIdentifier"
  block_savedest(obj7455);
  Object closure7701 = createclosure(1, "asIdentifier");
  setclosureframe(closure7701, stackframe);
  addtoclosure(closure7701, var_identifierNode);
  struct UserObject *uo7701 = (struct UserObject*)obj7455;
  uo7701->data[11] = (Object)closure7701;
  Method *meth_meth_ast_asIdentifier7701 = addmethod2pos(obj7455, "asIdentifier", &meth_ast_asIdentifier7701, 11);
  int argcv_meth_ast_asIdentifier7701[] = {0};
  meth_meth_ast_asIdentifier7701->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7701);
  meth_meth_ast_asIdentifier7701->definitionModule = modulename;
  meth_meth_ast_asIdentifier7701->definitionLine = 1946;
// method "shallowCopy"
  block_savedest(obj7455);
  Object closure7720 = createclosure(2, "shallowCopy");
  setclosureframe(closure7720, stackframe);
  addtoclosure(closure7720, var_nullNode);
  addtoclosure(closure7720, var_opNode);
  struct UserObject *uo7720 = (struct UserObject*)obj7455;
  uo7720->data[12] = (Object)closure7720;
  Method *meth_meth_ast_shallowCopy7720 = addmethod2pos(obj7455, "shallowCopy", &meth_ast_shallowCopy7720, 12);
  int argcv_meth_ast_shallowCopy7720[] = {0};
  meth_meth_ast_shallowCopy7720->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7720);
  meth_meth_ast_shallowCopy7720->definitionModule = modulename;
  meth_meth_ast_shallowCopy7720->definitionLine = 1954;
  sourceObject = obj7455;
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7727 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7728 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7729 = gc_frame_new();
// call case 3: self.outer request
  Object call7730 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7729);
// compiled member node returning call7730 (depth = 5)
  Object call7731 = callmethodflags(call7730, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7728);
// compiled member node returning call7731 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7732 = callmethodflags(call7731, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7727);
// compiled call node returning call7732 (depth = 3)
  struct UserObject *obj7455_uo = (struct UserObject *)obj7455;
  obj7455_uo->super = call7732;
  sourceObject = obj7455;
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7733 == NULL) {
    strlit7733 = alloc_String("op");
    gc_root(strlit7733);
  }
// compiled string node returning strlit7733 (depth = 3)
  adddatum2(obj7455, strlit7733, 1);
  sourceObject = obj7455;
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj7455, *var_op, 2);
  sourceObject = obj7455;
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj7455, *var_l, 3);
  sourceObject = obj7455;
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj7455, *var_r, 4);
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  sourceObject = obj7455;
  objclass7455 = obj7455->class;
  objclass7455->definitionModule = modulename;
  objclass7455->definitionLine = 1893;
  (*(struct UserObject *)self).data[0] = lowerouter7455;
  self = oldself7455;
  selfslot = oldselfslot7455;
  stackframe = oldstackframe7455;
  gc_frame_end(frame);
  return obj7455;
}
Object meth_ast_opNode7735(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_opNode (depth = 3)
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_isBind7744(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7745 = alloc_Boolean(1);
// compiled identifier node returning bool7745 (depth = 3)
  gc_frame_end(frame);
  return bool7745;
}
Object meth_ast_asString7746(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7748 == NULL) {
    strlit7748 = alloc_String("");
    gc_root(strlit7748);
  }
// compiled string node returning strlit7748 (depth = 4)
  int op_slot_right_7747 = gc_frame_newslot(strlit7748);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7751 = gc_frame_new();
// call case 4: self request
  Object call7752 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7751);
// compiled member node returning call7752 (depth = 5)
  int op_slot_right_7750 = gc_frame_newslot(call7752);
// starting to compile string node (depth = 5)
  if (strlit7754 == NULL) {
    strlit7754 = alloc_String("bind ");
    gc_root(strlit7754);
  }
// compiled string node returning strlit7754 (depth = 5)
  int op_slot_left_7750 = gc_frame_newslot(strlit7754);
  params[0] = call7752;
  partcv[0] = 1;
  Object opresult7755 = callmethod(strlit7754, "++(1)", 1, partcv, params);
// compiled op node returning opresult7755 (depth = 4)
  int op_slot_left_7747 = gc_frame_newslot(opresult7755);
  params[0] = strlit7748;
  partcv[0] = 1;
  Object opresult7756 = callmethod(opresult7755, "++(1)", 1, partcv, params);
// compiled op node returning opresult7756 (depth = 3)
  gc_frame_end(frame);
  return opresult7756;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7757(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7759 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7760 = callmethodflags(*var_visitor, "visitBind(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7759);
// compiled call node returning call7760 (depth = 4)
  Object if7758 = done;
  if (istrue(call7760)) {
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7761 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7762 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7761);
// compiled call node returning call7762 (depth = 5)
  *var_newChain = call7762;
  if (call7762 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7763 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7764 = gc_frame_new();
// call case 4: self request
  Object call7765 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7764);
// compiled member node returning call7765 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7766 = callmethodflags(call7765, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7763);
// compiled call node returning call7766 (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7767 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7768 = gc_frame_new();
// call case 4: self request
  Object call7769 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7768);
// compiled member node returning call7769 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7770 = callmethodflags(call7769, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7767);
// compiled call node returning call7770 (depth = 4)
    gc_frame_newslot(call7770);
    if7758 = call7770;
  } else {
  }
// compiled if node returning if7758 (depth = 3)
  gc_frame_end(frame);
  return if7758;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_7771(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7772 = gc_frame_new();
// call case 4: self request
  Object call7773 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7772);
// compiled member node returning call7773 (depth = 4)
  *var_n = call7773;
  if (call7773 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7774 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7775 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7774);
// compiled call node returning call7775 (depth = 4)
  *var_newChain = call7775;
  if (call7775 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7776 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7777 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7778 = gc_frame_new();
// call case 4: self request
  Object call7779 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7778);
// compiled member node returning call7779 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7780 = callmethodflags(call7779, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7777);
// compiled call node returning call7780 (depth = 4)
  gc_frame_newslot(call7780);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7780;
  partcv[0] = 1;
  Object call7781 = callmethodflags(*var_n, "dest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7776);
// compiled call node returning call7781 (depth = 3)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7782 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7783 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7784 = gc_frame_new();
// call case 4: self request
  Object call7785 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7784);
// compiled member node returning call7785 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7786 = callmethodflags(call7785, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7783);
// compiled call node returning call7786 (depth = 4)
  gc_frame_newslot(call7786);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7786;
  partcv[0] = 1;
  Object call7787 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7782);
// compiled call node returning call7787 (depth = 3)
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7788 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7789 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7788);
// compiled call node returning call7789 (depth = 3)
  gc_frame_end(frame);
  return call7789;
}
Object meth_ast__apply_40_1_41_7798(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7800 == NULL) {
    strlit7800 = alloc_String("  ");
    gc_root(strlit7800);
  }
// compiled string node returning strlit7800 (depth = 7)
  int op_slot_right_7799 = gc_frame_newslot(strlit7800);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7799 = gc_frame_newslot(*var_spc);
  params[0] = strlit7800;
  partcv[0] = 1;
  Object opresult7802 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult7802 (depth = 6)
  *var_spc = opresult7802;
  if (opresult7802 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_7790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7791 == NULL) {
    strlit7791 = alloc_String("");
    gc_root(strlit7791);
  }
// compiled string node returning strlit7791 (depth = 4)
  *var_spc = strlit7791;
  if (strlit7791 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7792 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7793 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7795 = alloc_Float64(0);
// compiled num node returning num7795 (depth = 5)
  int op_slot_left_7793 = gc_frame_newslot(num7795);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7796 = callmethod(num7795, "..(1)", 1, partcv, params);
// compiled op node returning opresult7796 (depth = 4)
  gc_frame_newslot(opresult7796);
// starting to compile block node (depth = 4)
  Object block7797 = alloc_Block(NULL, NULL, "ast", 1985);
  gc_frame_newslot(block7797);
// method "_apply(_)"
  block_savedest(block7797);
  Object closure7798 = createclosure(2, "_apply(1)");
  setclosureframe(closure7798, stackframe);
  addtoclosure(closure7798, var_spc);
  addtoclosure(closure7798, selfslot);
  struct UserObject *uo7798 = (struct UserObject*)block7797;
  uo7798->data[0] = (Object)closure7798;
  Method *meth_meth_ast__apply_40_1_41_7798 = addmethod2pos(block7797, "_apply(1)", &meth_ast__apply_40_1_41_7798, 0);
  int argcv_meth_ast__apply_40_1_41_7798[] = {1};
  meth_meth_ast__apply_40_1_41_7798->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7798);
  meth_meth_ast__apply_40_1_41_7798->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7798->definitionLine = 2969;
// compiled block node returning block7797 (depth = 4)
  gc_frame_newslot(block7797);
// call case 5: prelude request
  params[0] = opresult7796;
  params[1] = block7797;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7805 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7792);
// compiled call node returning call7805 (depth = 3)
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7807 == NULL) {
    strlit7807 = alloc_String("""\x0a""");
    gc_root(strlit7807);
  }
// compiled string node returning strlit7807 (depth = 5)
  int op_slot_right_7806 = gc_frame_newslot(strlit7807);
// starting to compile call node (depth = 5)
  int callframe7809 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7810 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7809);
// compiled call node returning call7810 (depth = 5)
  int op_slot_left_7806 = gc_frame_newslot(call7810);
  params[0] = strlit7807;
  partcv[0] = 1;
  Object opresult7811 = callmethod(call7810, "++(1)", 1, partcv, params);
// compiled op node returning opresult7811 (depth = 4)
  *var_s = opresult7811;
  if (opresult7811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7813 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7815 = alloc_Float64(1);
// compiled num node returning num7815 (depth = 7)
  int op_slot_right_7814 = gc_frame_newslot(num7815);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7814 = gc_frame_newslot(*var_depth);
  params[0] = num7815;
  partcv[0] = 1;
  Object sum7817 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7817 (depth = 6)
  gc_frame_newslot(sum7817);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7818 = gc_frame_new();
// call case 4: self request
  Object call7819 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7818);
// compiled member node returning call7819 (depth = 6)
  params[0] = sum7817;
  partcv[0] = 1;
  Object call7820 = callmethodflags(call7819, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7813);
// compiled call node returning call7820 (depth = 5)
  int op_slot_right_7812 = gc_frame_newslot(call7820);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7822 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7822 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7824 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7824 (depth = 5)
  int op_slot_left_7812 = gc_frame_newslot(opresult7824);
  params[0] = call7820;
  partcv[0] = 1;
  Object opresult7825 = callmethod(opresult7824, "++(1)", 1, partcv, params);
// compiled op node returning opresult7825 (depth = 4)
  *var_s = opresult7825;
  if (opresult7825 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7828 == NULL) {
    strlit7828 = alloc_String("""\x0a""");
    gc_root(strlit7828);
  }
// compiled string node returning strlit7828 (depth = 5)
  int op_slot_right_7827 = gc_frame_newslot(strlit7828);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7827 = gc_frame_newslot(*var_s);
  params[0] = strlit7828;
  partcv[0] = 1;
  Object opresult7830 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7830 (depth = 4)
  *var_s = opresult7830;
  if (opresult7830 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7833 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7835 = alloc_Float64(1);
// compiled num node returning num7835 (depth = 7)
  int op_slot_right_7834 = gc_frame_newslot(num7835);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7834 = gc_frame_newslot(*var_depth);
  params[0] = num7835;
  partcv[0] = 1;
  Object sum7837 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7837 (depth = 6)
  gc_frame_newslot(sum7837);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7838 = gc_frame_new();
// call case 4: self request
  Object call7839 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7838);
// compiled member node returning call7839 (depth = 6)
  params[0] = sum7837;
  partcv[0] = 1;
  Object call7840 = callmethodflags(call7839, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7833);
// compiled call node returning call7840 (depth = 5)
  int op_slot_right_7832 = gc_frame_newslot(call7840);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7842 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7842 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7844 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7844 (depth = 5)
  int op_slot_left_7832 = gc_frame_newslot(opresult7844);
  params[0] = call7840;
  partcv[0] = 1;
  Object opresult7845 = callmethod(opresult7844, "++(1)", 1, partcv, params);
// compiled op node returning opresult7845 (depth = 4)
  *var_s = opresult7845;
  if (opresult7845 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_7859(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7861 == NULL) {
    strlit7861 = alloc_String("    ");
    gc_root(strlit7861);
  }
// compiled string node returning strlit7861 (depth = 7)
  int op_slot_right_7860 = gc_frame_newslot(strlit7861);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7860 = gc_frame_newslot(*var_spc);
  params[0] = strlit7861;
  partcv[0] = 1;
  Object opresult7863 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult7863 (depth = 6)
  *var_spc = opresult7863;
  if (opresult7863 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_7847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7848 == NULL) {
    strlit7848 = alloc_String("");
    gc_root(strlit7848);
  }
// compiled string node returning strlit7848 (depth = 4)
  *var_spc = strlit7848;
  if (strlit7848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7849 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7852 = alloc_Float64(1);
// compiled num node returning num7852 (depth = 6)
  int op_slot_right_7851 = gc_frame_newslot(num7852);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7851 = gc_frame_newslot(*var_depth);
  params[0] = num7852;
  partcv[0] = 1;
  Object diff7854 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff7854 (depth = 5)
  int op_slot_right_7850 = gc_frame_newslot(diff7854);
// starting to compile num node (depth = 5)
  Object num7856 = alloc_Float64(0);
// compiled num node returning num7856 (depth = 5)
  int op_slot_left_7850 = gc_frame_newslot(num7856);
  params[0] = diff7854;
  partcv[0] = 1;
  Object opresult7857 = callmethod(num7856, "..(1)", 1, partcv, params);
// compiled op node returning opresult7857 (depth = 4)
  gc_frame_newslot(opresult7857);
// starting to compile block node (depth = 4)
  Object block7858 = alloc_Block(NULL, NULL, "ast", 1996);
  gc_frame_newslot(block7858);
// method "_apply(_)"
  block_savedest(block7858);
  Object closure7859 = createclosure(2, "_apply(1)");
  setclosureframe(closure7859, stackframe);
  addtoclosure(closure7859, var_spc);
  addtoclosure(closure7859, selfslot);
  struct UserObject *uo7859 = (struct UserObject*)block7858;
  uo7859->data[0] = (Object)closure7859;
  Method *meth_meth_ast__apply_40_1_41_7859 = addmethod2pos(block7858, "_apply(1)", &meth_ast__apply_40_1_41_7859, 0);
  int argcv_meth_ast__apply_40_1_41_7859[] = {1};
  meth_meth_ast__apply_40_1_41_7859->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7859);
  meth_meth_ast__apply_40_1_41_7859->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7859->definitionLine = 2969;
// compiled block node returning block7858 (depth = 4)
  gc_frame_newslot(block7858);
// call case 5: prelude request
  params[0] = opresult7857;
  params[1] = block7858;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7866 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7849);
// compiled call node returning call7866 (depth = 3)
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7867 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7869 = alloc_Float64(1);
// compiled num node returning num7869 (depth = 6)
  int op_slot_right_7868 = gc_frame_newslot(num7869);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7868 = gc_frame_newslot(*var_depth);
  params[0] = num7869;
  partcv[0] = 1;
  Object sum7871 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7871 (depth = 5)
  gc_frame_newslot(sum7871);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7872 = gc_frame_new();
// call case 4: self request
  Object call7873 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7872);
// compiled member node returning call7873 (depth = 5)
  params[0] = sum7871;
  partcv[0] = 1;
  Object call7874 = callmethodflags(call7873, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7867);
// compiled call node returning call7874 (depth = 4)
  *var_s = call7874;
  if (call7874 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7876 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7878 = alloc_Float64(1);
// compiled num node returning num7878 (depth = 7)
  int op_slot_right_7877 = gc_frame_newslot(num7878);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7877 = gc_frame_newslot(*var_depth);
  params[0] = num7878;
  partcv[0] = 1;
  Object sum7880 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7880 (depth = 6)
  gc_frame_newslot(sum7880);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7881 = gc_frame_new();
// call case 4: self request
  Object call7882 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7881);
// compiled member node returning call7882 (depth = 6)
  params[0] = sum7880;
  partcv[0] = 1;
  Object call7883 = callmethodflags(call7882, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7876);
// compiled call node returning call7883 (depth = 5)
  int op_slot_right_7875 = gc_frame_newslot(call7883);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7886 == NULL) {
    strlit7886 = alloc_String(" := ");
    gc_root(strlit7886);
  }
// compiled string node returning strlit7886 (depth = 6)
  int op_slot_right_7885 = gc_frame_newslot(strlit7886);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7885 = gc_frame_newslot(*var_s);
  params[0] = strlit7886;
  partcv[0] = 1;
  Object opresult7888 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7888 (depth = 5)
  int op_slot_left_7875 = gc_frame_newslot(opresult7888);
  params[0] = call7883;
  partcv[0] = 1;
  Object opresult7889 = callmethod(opresult7888, "++(1)", 1, partcv, params);
// compiled op node returning opresult7889 (depth = 4)
  *var_s = opresult7889;
  if (opresult7889 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy7891(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7892 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7893 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7894 = gc_frame_new();
// call case 4: self request
  Object call7895 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7894);
// compiled member node returning call7895 (depth = 5)
  gc_frame_newslot(call7895);
// starting to compile member node (depth = 5)
  int callframe7896 = gc_frame_new();
// call case 4: self request
  Object call7897 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7896);
// compiled member node returning call7897 (depth = 5)
  gc_frame_newslot(call7897);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_bindNode (depth = 5)
  params[0] = call7895;
  params[1] = call7897;
  partcv[0] = 2;
  Object call7898 = callmethodflags(*var_bindNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7893);
// compiled call node returning call7898 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7899 = callmethodflags(call7898, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7892);
// compiled call node returning call7899 (depth = 3)
  gc_frame_end(frame);
  return call7899;
}
Object meth_ast_statementName7900(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7901 == NULL) {
    strlit7901 = alloc_String("assignment or assigment request");
    gc_root(strlit7901);
  }
// compiled string node returning strlit7901 (depth = 3)
  gc_frame_end(frame);
  return strlit7901;
}
Object meth_ast_new_40_2_41_7738(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7739 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7739 = alloc_userobj2(13,12, objclass7739);
  gc_frame_newslot(obj7739);
if (objclass7739 == NULL) {
  glfree(obj7739->class->name);
  obj7739->class->name = "bindNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7739, self, 0);
  addmethodreal(obj7739,"outer", &reader_ast_outer_7740);
  Object oldself7739 = self;
  struct StackFrameObject *oldstackframe7739 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7739);
  gc_frame_newslot((Object)stackframe);
  self = obj7739;
  Object *oldselfslot7739 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7739 = (*(struct UserObject *)self).data[0], lowerouter7739 = thisouter7739;
  if (inheritingObject7739) {
    struct UserObject *inho7739 = (struct UserObject *)inheritingObject7739;
    while (inho7739->super != GraceDefaultObject) inho7739 = (struct UserObject *)inho7739->super;
    inho7739->super = obj7739;
    self = inheritingObject7739;
    *selfslot = self;
    lowerouter7739 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7739;
  }
if (objclass7739 == NULL) {
  Method *reader7741 = addmethodrealflags(obj7739, "kind",&reader_ast_kind_7741, MFLAG_DEF);
  reader7741->definitionModule = modulename;
  reader7741->definitionLine = 1963;
}
adddatum2(obj7739, alloc_Undefined(), 1);
if (objclass7739 == NULL) {
  Method *reader7742 = addmethodrealflags(obj7739, "dest", &reader_ast_dest_7742, 0);
  Method *writer7742 = addmethodrealflags(obj7739, "dest:=(1)", &writer_ast_dest_7742, 0);
  reader7742->definitionModule = modulename;
  writer7742->definitionModule = modulename;
  reader7742->definitionLine = 1964;
  writer7742->definitionLine = 1964;
}
obj7739->flags |= OFLAG_MUTABLE;
adddatum2(obj7739, alloc_Undefined(), 2);
if (objclass7739 == NULL) {
  Method *reader7743 = addmethodrealflags(obj7739, "value", &reader_ast_value_7743, 0);
  Method *writer7743 = addmethodrealflags(obj7739, "value:=(1)", &writer_ast_value_7743, 0);
  reader7743->definitionModule = modulename;
  writer7743->definitionModule = modulename;
  reader7743->definitionLine = 1965;
  writer7743->definitionLine = 1965;
}
obj7739->flags |= OFLAG_MUTABLE;
adddatum2(obj7739, alloc_Undefined(), 3);
// method "isBind"
  struct UserObject *uo7744 = (struct UserObject*)obj7739;
  uo7744->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind7744 = addmethod2pos(obj7739, "isBind", &meth_ast_isBind7744, 4);
  int argcv_meth_ast_isBind7744[] = {0};
  meth_meth_ast_isBind7744->type = alloc_MethodType(1, argcv_meth_ast_isBind7744);
  meth_meth_ast_isBind7744->definitionModule = modulename;
  meth_meth_ast_isBind7744->definitionLine = 1967;
// method "asString"
  struct UserObject *uo7746 = (struct UserObject*)obj7739;
  uo7746->data[5] = emptyclosure;
  Method *meth_meth_ast_asString7746 = addmethod2pos(obj7739, "asString", &meth_ast_asString7746, 5);
  int argcv_meth_ast_asString7746[] = {0};
  meth_meth_ast_asString7746->type = alloc_MethodType(1, argcv_meth_ast_asString7746);
  meth_meth_ast_asString7746->definitionModule = modulename;
  meth_meth_ast_asString7746->definitionLine = 1968;
// method "accept(_)from(_)"
  struct UserObject *uo7757 = (struct UserObject*)obj7739;
  uo7757->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7757 = addmethod2pos(obj7739, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7757, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7757[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7757->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7757);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7757->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7757->definitionLine = 1969;
// method "map(_)ancestors(_)"
  struct UserObject *uo7771 = (struct UserObject*)obj7739;
  uo7771->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7771 = addmethod2pos(obj7739, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7771, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7771[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7771->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7771);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7771->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7771->definitionLine = 1976;
// method "pretty(_)"
  struct UserObject *uo7790 = (struct UserObject*)obj7739;
  uo7790->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7790 = addmethod2pos(obj7739, "pretty(1)", &meth_ast_pretty_40_1_41_7790, 8);
  int argcv_meth_ast_pretty_40_1_41_7790[] = {1};
  meth_meth_ast_pretty_40_1_41_7790->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7790);
  meth_meth_ast_pretty_40_1_41_7790->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7790->definitionLine = 1983;
// method "toGrace(_)"
  struct UserObject *uo7847 = (struct UserObject*)obj7739;
  uo7847->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7847 = addmethod2pos(obj7739, "toGrace(1)", &meth_ast_toGrace_40_1_41_7847, 9);
  int argcv_meth_ast_toGrace_40_1_41_7847[] = {1};
  meth_meth_ast_toGrace_40_1_41_7847->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7847);
meth_meth_ast_toGrace_40_1_41_7847->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7847->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7847->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7847->definitionLine = 1994;
// method "shallowCopy"
  block_savedest(obj7739);
  Object closure7891 = createclosure(1, "shallowCopy");
  setclosureframe(closure7891, stackframe);
  addtoclosure(closure7891, var_bindNode);
  struct UserObject *uo7891 = (struct UserObject*)obj7739;
  uo7891->data[10] = (Object)closure7891;
  Method *meth_meth_ast_shallowCopy7891 = addmethod2pos(obj7739, "shallowCopy", &meth_ast_shallowCopy7891, 10);
  int argcv_meth_ast_shallowCopy7891[] = {0};
  meth_meth_ast_shallowCopy7891->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7891);
  meth_meth_ast_shallowCopy7891->definitionModule = modulename;
  meth_meth_ast_shallowCopy7891->definitionLine = 2003;
// method "statementName"
  struct UserObject *uo7900 = (struct UserObject*)obj7739;
  uo7900->data[11] = emptyclosure;
  Method *meth_meth_ast_statementName7900 = addmethod2pos(obj7739, "statementName", &meth_ast_statementName7900, 11);
  int argcv_meth_ast_statementName7900[] = {0};
  meth_meth_ast_statementName7900->type = alloc_MethodType(1, argcv_meth_ast_statementName7900);
  meth_meth_ast_statementName7900->definitionModule = modulename;
  meth_meth_ast_statementName7900->definitionLine = 2006;
  sourceObject = obj7739;
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7902 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7903 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7904 = gc_frame_new();
// call case 3: self.outer request
  Object call7905 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7904);
// compiled member node returning call7905 (depth = 5)
  Object call7906 = callmethodflags(call7905, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7903);
// compiled member node returning call7906 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7907 = callmethodflags(call7906, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7902);
// compiled call node returning call7907 (depth = 3)
  struct UserObject *obj7739_uo = (struct UserObject *)obj7739;
  obj7739_uo->super = call7907;
  sourceObject = obj7739;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7908 == NULL) {
    strlit7908 = alloc_String("bind");
    gc_root(strlit7908);
  }
// compiled string node returning strlit7908 (depth = 3)
  adddatum2(obj7739, strlit7908, 1);
  sourceObject = obj7739;
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj7739, *var_dest_39_, 2);
  sourceObject = obj7739;
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj7739, *var_val_39_, 3);
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  objclass7739 = obj7739->class;
  objclass7739->definitionModule = modulename;
  objclass7739->definitionLine = 1960;
  (*(struct UserObject *)self).data[0] = lowerouter7739;
  self = oldself7739;
  selfslot = oldselfslot7739;
  stackframe = oldstackframe7739;
  gc_frame_end(frame);
  return obj7739;
}
Object meth_ast_new_40_2_41_7738_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7739 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7739 = alloc_userobj2(13,12, objclass7739);
  gc_frame_newslot(obj7739);
if (objclass7739 == NULL) {
  glfree(obj7739->class->name);
  obj7739->class->name = "bindNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7739, self, 0);
  addmethodreal(obj7739,"outer", &reader_ast_outer_7740);
  Object oldself7739 = self;
  struct StackFrameObject *oldstackframe7739 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7739);
  gc_frame_newslot((Object)stackframe);
  self = obj7739;
  Object *oldselfslot7739 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7739 = (*(struct UserObject *)self).data[0], lowerouter7739 = thisouter7739;
  if (inheritingObject7739) {
    struct UserObject *inho7739 = (struct UserObject *)inheritingObject7739;
    while (inho7739->super != GraceDefaultObject) inho7739 = (struct UserObject *)inho7739->super;
    inho7739->super = obj7739;
    self = inheritingObject7739;
    *selfslot = self;
    lowerouter7739 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7739;
  }
if (objclass7739 == NULL) {
  Method *reader7741 = addmethodrealflags(obj7739, "kind",&reader_ast_kind_7741, MFLAG_DEF);
  reader7741->definitionModule = modulename;
  reader7741->definitionLine = 1963;
}
adddatum2(obj7739, alloc_Undefined(), 1);
if (objclass7739 == NULL) {
  Method *reader7742 = addmethodrealflags(obj7739, "dest", &reader_ast_dest_7742, 0);
  Method *writer7742 = addmethodrealflags(obj7739, "dest:=(1)", &writer_ast_dest_7742, 0);
  reader7742->definitionModule = modulename;
  writer7742->definitionModule = modulename;
  reader7742->definitionLine = 1964;
  writer7742->definitionLine = 1964;
}
obj7739->flags |= OFLAG_MUTABLE;
adddatum2(obj7739, alloc_Undefined(), 2);
if (objclass7739 == NULL) {
  Method *reader7743 = addmethodrealflags(obj7739, "value", &reader_ast_value_7743, 0);
  Method *writer7743 = addmethodrealflags(obj7739, "value:=(1)", &writer_ast_value_7743, 0);
  reader7743->definitionModule = modulename;
  writer7743->definitionModule = modulename;
  reader7743->definitionLine = 1965;
  writer7743->definitionLine = 1965;
}
obj7739->flags |= OFLAG_MUTABLE;
adddatum2(obj7739, alloc_Undefined(), 3);
// method "isBind"
  struct UserObject *uo7744 = (struct UserObject*)obj7739;
  uo7744->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind7744 = addmethod2pos(obj7739, "isBind", &meth_ast_isBind7744, 4);
  int argcv_meth_ast_isBind7744[] = {0};
  meth_meth_ast_isBind7744->type = alloc_MethodType(1, argcv_meth_ast_isBind7744);
  meth_meth_ast_isBind7744->definitionModule = modulename;
  meth_meth_ast_isBind7744->definitionLine = 1967;
// method "asString"
  struct UserObject *uo7746 = (struct UserObject*)obj7739;
  uo7746->data[5] = emptyclosure;
  Method *meth_meth_ast_asString7746 = addmethod2pos(obj7739, "asString", &meth_ast_asString7746, 5);
  int argcv_meth_ast_asString7746[] = {0};
  meth_meth_ast_asString7746->type = alloc_MethodType(1, argcv_meth_ast_asString7746);
  meth_meth_ast_asString7746->definitionModule = modulename;
  meth_meth_ast_asString7746->definitionLine = 1968;
// method "accept(_)from(_)"
  struct UserObject *uo7757 = (struct UserObject*)obj7739;
  uo7757->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7757 = addmethod2pos(obj7739, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7757, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7757[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7757->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7757);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7757->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7757->definitionLine = 1969;
// method "map(_)ancestors(_)"
  struct UserObject *uo7771 = (struct UserObject*)obj7739;
  uo7771->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7771 = addmethod2pos(obj7739, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7771, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7771[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7771->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7771);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7771->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7771->definitionLine = 1976;
// method "pretty(_)"
  struct UserObject *uo7790 = (struct UserObject*)obj7739;
  uo7790->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7790 = addmethod2pos(obj7739, "pretty(1)", &meth_ast_pretty_40_1_41_7790, 8);
  int argcv_meth_ast_pretty_40_1_41_7790[] = {1};
  meth_meth_ast_pretty_40_1_41_7790->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7790);
  meth_meth_ast_pretty_40_1_41_7790->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7790->definitionLine = 1983;
// method "toGrace(_)"
  struct UserObject *uo7847 = (struct UserObject*)obj7739;
  uo7847->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7847 = addmethod2pos(obj7739, "toGrace(1)", &meth_ast_toGrace_40_1_41_7847, 9);
  int argcv_meth_ast_toGrace_40_1_41_7847[] = {1};
  meth_meth_ast_toGrace_40_1_41_7847->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7847);
meth_meth_ast_toGrace_40_1_41_7847->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7847->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7847->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7847->definitionLine = 1994;
// method "shallowCopy"
  block_savedest(obj7739);
  Object closure7891 = createclosure(1, "shallowCopy");
  setclosureframe(closure7891, stackframe);
  addtoclosure(closure7891, var_bindNode);
  struct UserObject *uo7891 = (struct UserObject*)obj7739;
  uo7891->data[10] = (Object)closure7891;
  Method *meth_meth_ast_shallowCopy7891 = addmethod2pos(obj7739, "shallowCopy", &meth_ast_shallowCopy7891, 10);
  int argcv_meth_ast_shallowCopy7891[] = {0};
  meth_meth_ast_shallowCopy7891->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7891);
  meth_meth_ast_shallowCopy7891->definitionModule = modulename;
  meth_meth_ast_shallowCopy7891->definitionLine = 2003;
// method "statementName"
  struct UserObject *uo7900 = (struct UserObject*)obj7739;
  uo7900->data[11] = emptyclosure;
  Method *meth_meth_ast_statementName7900 = addmethod2pos(obj7739, "statementName", &meth_ast_statementName7900, 11);
  int argcv_meth_ast_statementName7900[] = {0};
  meth_meth_ast_statementName7900->type = alloc_MethodType(1, argcv_meth_ast_statementName7900);
  meth_meth_ast_statementName7900->definitionModule = modulename;
  meth_meth_ast_statementName7900->definitionLine = 2006;
  sourceObject = obj7739;
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7902 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7903 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7904 = gc_frame_new();
// call case 3: self.outer request
  Object call7905 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7904);
// compiled member node returning call7905 (depth = 5)
  Object call7906 = callmethodflags(call7905, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7903);
// compiled member node returning call7906 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7907 = callmethodflags(call7906, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7902);
// compiled call node returning call7907 (depth = 3)
  struct UserObject *obj7739_uo = (struct UserObject *)obj7739;
  obj7739_uo->super = call7907;
  sourceObject = obj7739;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7908 == NULL) {
    strlit7908 = alloc_String("bind");
    gc_root(strlit7908);
  }
// compiled string node returning strlit7908 (depth = 3)
  adddatum2(obj7739, strlit7908, 1);
  sourceObject = obj7739;
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj7739, *var_dest_39_, 2);
  sourceObject = obj7739;
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj7739, *var_val_39_, 3);
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  sourceObject = obj7739;
  objclass7739 = obj7739->class;
  objclass7739->definitionModule = modulename;
  objclass7739->definitionLine = 1960;
  (*(struct UserObject *)self).data[0] = lowerouter7739;
  self = oldself7739;
  selfslot = oldselfslot7739;
  stackframe = oldstackframe7739;
  gc_frame_end(frame);
  return obj7739;
}
Object meth_ast_bindNode7910(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bindNode (depth = 3)
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_new_40_3_41_scope_40_1_41_7913(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(3)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7914 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name_39_ (depth = 5)
  gc_frame_newslot(*var_name_39_);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype_39_ (depth = 5)
  gc_frame_newslot(*var_dtype_39_);
// call case 4: self request
  params[0] = *var_name_39_;
  params[1] = *var_val;
  params[2] = *var_dtype_39_;
  partcv[0] = 3;
  Object call7915 = callmethodflags(self, "new(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7914);
// compiled call node returning call7915 (depth = 4)
  *var_result = call7915;
  if (call7915 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7916 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7917 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7916);
// compiled call node returning call7917 (depth = 3)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isPublic7928(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7931 = alloc_Float64(0);
// compiled num node returning num7931 (depth = 5)
  int op_slot_right_7930 = gc_frame_newslot(num7931);
// starting to compile member node (depth = 5)
  int callframe7933 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7934 = gc_frame_new();
// call case 4: self request
  Object call7935 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7934);
// compiled member node returning call7935 (depth = 6)
  Object call7936 = callmethodflags(call7935, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7933);
// compiled member node returning call7936 (depth = 5)
  int op_slot_left_7930 = gc_frame_newslot(call7936);
  params[0] = num7931;
  partcv[0] = 1;
  Object opresult7937 = callmethod(call7936, "==(1)", 1, partcv, params);
// compiled op node returning opresult7937 (depth = 4)
  Object if7929 = done;
  if (istrue(opresult7937)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7938 = alloc_Boolean(0);
// compiled identifier node returning bool7938 (depth = 5)
  return bool7938;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7929 = undefined;
  } else {
  }
// compiled if node returning if7929 (depth = 3)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7940 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit7941 == NULL) {
    strlit7941 = alloc_String("public");
    gc_root(strlit7941);
  }
// compiled string node returning strlit7941 (depth = 5)
  gc_frame_newslot(strlit7941);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7942 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7943 = gc_frame_new();
// call case 3: self.outer request
  Object call7944 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7943);
// compiled member node returning call7944 (depth = 6)
  Object call7945 = callmethodflags(call7944, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7942);
// compiled member node returning call7945 (depth = 5)
  params[0] = self;
  params[1] = strlit7941;
  partcv[0] = 2;
  Object call7946 = callmethodflags(call7945, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7940);
// compiled call node returning call7946 (depth = 4)
  Object if7939 = done;
  if (istrue(call7946)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7947 = alloc_Boolean(1);
// compiled identifier node returning bool7947 (depth = 5)
  return bool7947;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7939 = undefined;
  } else {
  }
// compiled if node returning if7939 (depth = 3)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7948 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit7949 == NULL) {
    strlit7949 = alloc_String("readable");
    gc_root(strlit7949);
  }
// compiled string node returning strlit7949 (depth = 4)
  gc_frame_newslot(strlit7949);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7950 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7951 = gc_frame_new();
// call case 3: self.outer request
  Object call7952 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7951);
// compiled member node returning call7952 (depth = 5)
  Object call7953 = callmethodflags(call7952, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7950);
// compiled member node returning call7953 (depth = 4)
  params[0] = self;
  params[1] = strlit7949;
  partcv[0] = 2;
  Object call7954 = callmethodflags(call7953, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7948);
// compiled call node returning call7954 (depth = 3)
  gc_frame_end(frame);
  return call7954;
}
Object meth_ast_isFieldDec7955(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7956 = alloc_Boolean(1);
// compiled identifier node returning bool7956 (depth = 3)
  gc_frame_end(frame);
  return bool7956;
}
Object meth_ast_isWritable7957(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7958 = alloc_Boolean(0);
// compiled identifier node returning bool7958 (depth = 3)
  gc_frame_end(frame);
  return bool7958;
}
Object meth_ast_isReadable7959(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7960 = gc_frame_new();
// call case 4: self request
  Object call7961 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7960);
// compiled member node returning call7961 (depth = 3)
  gc_frame_end(frame);
  return call7961;
}
Object meth_ast_returnsObject7962(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7963 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7964 = gc_frame_new();
// call case 4: self request
  Object call7965 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7964);
// compiled member node returning call7965 (depth = 4)
  Object call7966 = callmethodflags(call7965, "returnsObject", 0, partcv, params, 0);
  gc_frame_end(callframe7963);
// compiled member node returning call7966 (depth = 3)
  gc_frame_end(frame);
  return call7966;
}
Object meth_ast_returnedObjectScope7967(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7968 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7969 = gc_frame_new();
// call case 4: self request
  Object call7970 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7969);
// compiled member node returning call7970 (depth = 4)
  Object call7971 = callmethodflags(call7970, "returnedObjectScope", 0, partcv, params, 0);
  gc_frame_end(callframe7968);
// compiled member node returning call7971 (depth = 3)
  gc_frame_end(frame);
  return call7971;
}
Object meth_ast_usesAsType_40_1_41_7972(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7974 = gc_frame_new();
// call case 4: self request
  Object call7975 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7974);
// compiled member node returning call7975 (depth = 4)
  int op_slot_right_7973 = gc_frame_newslot(call7975);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_7973 = gc_frame_newslot(*var_aNode);
  params[0] = call7975;
  partcv[0] = 1;
  Object opresult7977 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult7977 (depth = 3)
  gc_frame_end(frame);
  return opresult7977;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_7978(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7979 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call7980 = callmethodflags(*var_k, "defdec", 0, partcv, params, 0);
  gc_frame_end(callframe7979);
// compiled member node returning call7980 (depth = 3)
  gc_frame_end(frame);
  return call7980;
}
Object meth_ast__apply_40_1_41_8006(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8007 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8008 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8007);
// compiled call node returning call8008 (depth = 6)
  gc_frame_end(frame);
  return call8008;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7981(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7983 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7984 = callmethodflags(*var_visitor, "visitDefDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7983);
// compiled call node returning call7984 (depth = 4)
  Object if7982 = done;
  if (istrue(call7984)) {
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7985 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7986 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7985);
// compiled call node returning call7986 (depth = 5)
  *var_newChain = call7986;
  if (call7986 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7987 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7988 = gc_frame_new();
// call case 4: self request
  Object call7989 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7988);
// compiled member node returning call7989 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7990 = callmethodflags(call7989, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7987);
// compiled call node returning call7990 (depth = 4)
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7993 = gc_frame_new();
// call case 4: self request
  Object call7994 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7993);
// compiled member node returning call7994 (depth = 6)
  int op_slot_right_7992 = gc_frame_newslot(call7994);
// starting to compile identifier node (depth = 6)
  Object bool7996 = alloc_Boolean(0);
// compiled identifier node returning bool7996 (depth = 6)
  int op_slot_left_7992 = gc_frame_newslot(bool7996);
  params[0] = call7994;
  partcv[0] = 1;
  Object opresult7997 = callmethod(bool7996, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7997 (depth = 5)
  Object if7991 = done;
  if (istrue(opresult7997)) {
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7998 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7999 = gc_frame_new();
// call case 4: self request
  Object call8000 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7999);
// compiled member node returning call8000 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8001 = callmethodflags(call8000, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7998);
// compiled call node returning call8001 (depth = 5)
    gc_frame_newslot(call8001);
    if7991 = call8001;
  } else {
  }
// compiled if node returning if7991 (depth = 4)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8002 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8003 = gc_frame_new();
// call case 4: self request
  Object call8004 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8003);
// compiled member node returning call8004 (depth = 5)
  gc_frame_newslot(call8004);
// starting to compile block node (depth = 5)
  Object block8005 = alloc_Block(NULL, NULL, "ast", 2055);
  gc_frame_newslot(block8005);
// method "_apply(_)"
  block_savedest(block8005);
  Object closure8006 = createclosure(3, "_apply(1)");
  setclosureframe(closure8006, stackframe);
  addtoclosure(closure8006, var_visitor);
  addtoclosure(closure8006, var_newChain);
  addtoclosure(closure8006, selfslot);
  struct UserObject *uo8006 = (struct UserObject*)block8005;
  uo8006->data[0] = (Object)closure8006;
  Method *meth_meth_ast__apply_40_1_41_8006 = addmethod2pos(block8005, "_apply(1)", &meth_ast__apply_40_1_41_8006, 0);
  int argcv_meth_ast__apply_40_1_41_8006[] = {1};
  meth_meth_ast__apply_40_1_41_8006->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8006);
  meth_meth_ast__apply_40_1_41_8006->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8006->definitionLine = 2969;
// compiled block node returning block8005 (depth = 5)
  gc_frame_newslot(block8005);
// call case 5: prelude request
  params[0] = call8004;
  params[1] = block8005;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8010 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8002);
// compiled call node returning call8010 (depth = 4)
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8011 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8012 = gc_frame_new();
// call case 4: self request
  Object call8013 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8012);
// compiled member node returning call8013 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8014 = callmethodflags(call8013, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8011);
// compiled call node returning call8014 (depth = 4)
    gc_frame_newslot(call8014);
    if7982 = call8014;
  } else {
  }
// compiled if node returning if7982 (depth = 3)
  gc_frame_end(frame);
  return if7982;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_8015(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8016 = gc_frame_new();
// call case 4: self request
  Object call8017 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8016);
// compiled member node returning call8017 (depth = 4)
  *var_n = call8017;
  if (call8017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8018 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8019 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8018);
// compiled call node returning call8019 (depth = 4)
  *var_newChain = call8019;
  if (call8019 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8020 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8021 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8022 = gc_frame_new();
// call case 4: self request
  Object call8023 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8022);
// compiled member node returning call8023 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8024 = callmethodflags(call8023, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8021);
// compiled call node returning call8024 (depth = 4)
  gc_frame_newslot(call8024);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8024;
  partcv[0] = 1;
  Object call8025 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8020);
// compiled call node returning call8025 (depth = 3)
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8026 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8027 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8028 = gc_frame_new();
// call case 4: self request
  Object call8029 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8028);
// compiled member node returning call8029 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8030 = callmethodflags(call8029, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8027);
// compiled call node returning call8030 (depth = 4)
  gc_frame_newslot(call8030);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8030;
  partcv[0] = 1;
  Object call8031 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8026);
// compiled call node returning call8031 (depth = 3)
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8032 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8033 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8034 = gc_frame_new();
// call case 4: self request
  Object call8035 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8034);
// compiled member node returning call8035 (depth = 5)
  gc_frame_newslot(call8035);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8036 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8037 = gc_frame_new();
// call case 3: self.outer request
  Object call8038 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8037);
// compiled member node returning call8038 (depth = 6)
  Object call8039 = callmethodflags(call8038, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8036);
// compiled member node returning call8039 (depth = 5)
  params[0] = call8035;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8040 = callmethodflags(call8039, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8033);
// compiled call node returning call8040 (depth = 4)
  gc_frame_newslot(call8040);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8040;
  partcv[0] = 1;
  Object call8041 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8032);
// compiled call node returning call8041 (depth = 3)
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8042 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8043 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8044 = gc_frame_new();
// call case 4: self request
  Object call8045 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8044);
// compiled member node returning call8045 (depth = 5)
  gc_frame_newslot(call8045);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8046 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8047 = gc_frame_new();
// call case 3: self.outer request
  Object call8048 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8047);
// compiled member node returning call8048 (depth = 6)
  Object call8049 = callmethodflags(call8048, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8046);
// compiled member node returning call8049 (depth = 5)
  params[0] = call8045;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8050 = callmethodflags(call8049, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8043);
// compiled call node returning call8050 (depth = 4)
  gc_frame_newslot(call8050);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8050;
  partcv[0] = 1;
  Object call8051 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8042);
// compiled call node returning call8051 (depth = 3)
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8052 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8053 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8052);
// compiled call node returning call8053 (depth = 3)
  gc_frame_end(frame);
  return call8053;
}
Object meth_ast__apply_40_1_41_8062(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8064 == NULL) {
    strlit8064 = alloc_String("  ");
    gc_root(strlit8064);
  }
// compiled string node returning strlit8064 (depth = 7)
  int op_slot_right_8063 = gc_frame_newslot(strlit8064);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8063 = gc_frame_newslot(*var_spc);
  params[0] = strlit8064;
  partcv[0] = 1;
  Object opresult8066 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8066 (depth = 6)
  *var_spc = opresult8066;
  if (opresult8066 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_8168(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8170 == NULL) {
    strlit8170 = alloc_String("");
    gc_root(strlit8170);
  }
// compiled string node returning strlit8170 (depth = 8)
  int op_slot_right_8169 = gc_frame_newslot(strlit8170);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8173 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num8175 = alloc_Float64(2);
// compiled num node returning num8175 (depth = 11)
  int op_slot_right_8174 = gc_frame_newslot(num8175);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_8174 = gc_frame_newslot(*var_depth);
  params[0] = num8175;
  partcv[0] = 1;
  Object sum8177 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8177 (depth = 10)
  gc_frame_newslot(sum8177);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  params[0] = sum8177;
  partcv[0] = 1;
  Object call8178 = callmethodflags(*var_ann, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8173);
// compiled call node returning call8178 (depth = 9)
  int op_slot_right_8172 = gc_frame_newslot(call8178);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8181 == NULL) {
    strlit8181 = alloc_String(" ");
    gc_root(strlit8181);
  }
// compiled string node returning strlit8181 (depth = 10)
  int op_slot_right_8180 = gc_frame_newslot(strlit8181);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_8183 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit8185 == NULL) {
    strlit8185 = alloc_String("");
    gc_root(strlit8185);
  }
// compiled string node returning strlit8185 (depth = 11)
  int op_slot_left_8183 = gc_frame_newslot(strlit8185);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult8186 = callmethod(strlit8185, "++(1)", 1, partcv, params);
// compiled op node returning opresult8186 (depth = 10)
  int op_slot_left_8180 = gc_frame_newslot(opresult8186);
  params[0] = strlit8181;
  partcv[0] = 1;
  Object opresult8187 = callmethod(opresult8186, "++(1)", 1, partcv, params);
// compiled op node returning opresult8187 (depth = 9)
  int op_slot_left_8172 = gc_frame_newslot(opresult8187);
  params[0] = call8178;
  partcv[0] = 1;
  Object opresult8188 = callmethod(opresult8187, "++(1)", 1, partcv, params);
// compiled op node returning opresult8188 (depth = 8)
  int op_slot_left_8169 = gc_frame_newslot(opresult8188);
  params[0] = strlit8170;
  partcv[0] = 1;
  Object opresult8189 = callmethod(opresult8188, "++(1)", 1, partcv, params);
// compiled op node returning opresult8189 (depth = 7)
  *var_s = opresult8189;
  if (opresult8189 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_8054(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8055 == NULL) {
    strlit8055 = alloc_String("");
    gc_root(strlit8055);
  }
// compiled string node returning strlit8055 (depth = 4)
  *var_spc = strlit8055;
  if (strlit8055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8056 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8057 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8059 = alloc_Float64(0);
// compiled num node returning num8059 (depth = 5)
  int op_slot_left_8057 = gc_frame_newslot(num8059);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8060 = callmethod(num8059, "..(1)", 1, partcv, params);
// compiled op node returning opresult8060 (depth = 4)
  gc_frame_newslot(opresult8060);
// starting to compile block node (depth = 4)
  Object block8061 = alloc_Block(NULL, NULL, "ast", 2072);
  gc_frame_newslot(block8061);
// method "_apply(_)"
  block_savedest(block8061);
  Object closure8062 = createclosure(2, "_apply(1)");
  setclosureframe(closure8062, stackframe);
  addtoclosure(closure8062, var_spc);
  addtoclosure(closure8062, selfslot);
  struct UserObject *uo8062 = (struct UserObject*)block8061;
  uo8062->data[0] = (Object)closure8062;
  Method *meth_meth_ast__apply_40_1_41_8062 = addmethod2pos(block8061, "_apply(1)", &meth_ast__apply_40_1_41_8062, 0);
  int argcv_meth_ast__apply_40_1_41_8062[] = {1};
  meth_meth_ast__apply_40_1_41_8062->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8062);
  meth_meth_ast__apply_40_1_41_8062->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8062->definitionLine = 2969;
// compiled block node returning block8061 (depth = 4)
  gc_frame_newslot(block8061);
// call case 5: prelude request
  params[0] = opresult8060;
  params[1] = block8061;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8069 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8056);
// compiled call node returning call8069 (depth = 3)
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8071 == NULL) {
    strlit8071 = alloc_String("""\x0a""");
    gc_root(strlit8071);
  }
// compiled string node returning strlit8071 (depth = 5)
  int op_slot_right_8070 = gc_frame_newslot(strlit8071);
// starting to compile call node (depth = 5)
  int callframe8073 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8074 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8073);
// compiled call node returning call8074 (depth = 5)
  int op_slot_left_8070 = gc_frame_newslot(call8074);
  params[0] = strlit8071;
  partcv[0] = 1;
  Object opresult8075 = callmethod(call8074, "++(1)", 1, partcv, params);
// compiled op node returning opresult8075 (depth = 4)
  *var_s = opresult8075;
  if (opresult8075 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8077 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8078 = gc_frame_new();
// call case 4: self request
  Object call8079 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8078);
// compiled member node returning call8079 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8080 = callmethodflags(call8079, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8077);
// compiled call node returning call8080 (depth = 5)
  int op_slot_right_8076 = gc_frame_newslot(call8080);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8082 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8082 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8084 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8084 (depth = 5)
  int op_slot_left_8076 = gc_frame_newslot(opresult8084);
  params[0] = call8080;
  partcv[0] = 1;
  Object opresult8085 = callmethod(opresult8084, "++(1)", 1, partcv, params);
// compiled op node returning opresult8085 (depth = 4)
  *var_s = opresult8085;
  if (opresult8085 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8089 = gc_frame_new();
// call case 4: self request
  Object call8090 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8089);
// compiled member node returning call8090 (depth = 5)
  int op_slot_right_8088 = gc_frame_newslot(call8090);
// starting to compile identifier node (depth = 5)
  Object bool8092 = alloc_Boolean(0);
// compiled identifier node returning bool8092 (depth = 5)
  int op_slot_left_8088 = gc_frame_newslot(bool8092);
  params[0] = call8090;
  partcv[0] = 1;
  Object opresult8093 = callmethod(bool8092, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8093 (depth = 4)
  Object if8087 = done;
  if (istrue(opresult8093)) {
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8095 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8097 = alloc_Float64(2);
// compiled num node returning num8097 (depth = 8)
  int op_slot_right_8096 = gc_frame_newslot(num8097);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8096 = gc_frame_newslot(*var_depth);
  params[0] = num8097;
  partcv[0] = 1;
  Object sum8099 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8099 (depth = 7)
  gc_frame_newslot(sum8099);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8100 = gc_frame_new();
// call case 4: self request
  Object call8101 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8100);
// compiled member node returning call8101 (depth = 7)
  params[0] = sum8099;
  partcv[0] = 1;
  Object call8102 = callmethodflags(call8101, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8095);
// compiled call node returning call8102 (depth = 6)
  int op_slot_right_8094 = gc_frame_newslot(call8102);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8105 == NULL) {
    strlit8105 = alloc_String("Type: ");
    gc_root(strlit8105);
  }
// compiled string node returning strlit8105 (depth = 7)
  int op_slot_right_8104 = gc_frame_newslot(strlit8105);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8107 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8110 == NULL) {
    strlit8110 = alloc_String("""\x0a""");
    gc_root(strlit8110);
  }
// compiled string node returning strlit8110 (depth = 9)
  int op_slot_right_8109 = gc_frame_newslot(strlit8110);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8109 = gc_frame_newslot(*var_s);
  params[0] = strlit8110;
  partcv[0] = 1;
  Object opresult8112 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8112 (depth = 8)
  int op_slot_left_8107 = gc_frame_newslot(opresult8112);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8113 = callmethod(opresult8112, "++(1)", 1, partcv, params);
// compiled op node returning opresult8113 (depth = 7)
  int op_slot_left_8104 = gc_frame_newslot(opresult8113);
  params[0] = strlit8105;
  partcv[0] = 1;
  Object opresult8114 = callmethod(opresult8113, "++(1)", 1, partcv, params);
// compiled op node returning opresult8114 (depth = 6)
  int op_slot_left_8094 = gc_frame_newslot(opresult8114);
  params[0] = call8102;
  partcv[0] = 1;
  Object opresult8115 = callmethod(opresult8114, "++(1)", 1, partcv, params);
// compiled op node returning opresult8115 (depth = 5)
  *var_s = opresult8115;
  if (opresult8115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8087 = done;
  } else {
  }
// compiled if node returning if8087 (depth = 3)
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8119 = gc_frame_new();
// call case 4: self request
  Object call8120 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8119);
// compiled member node returning call8120 (depth = 5)
  int op_slot_right_8118 = gc_frame_newslot(call8120);
// starting to compile identifier node (depth = 5)
  Object bool8122 = alloc_Boolean(0);
// compiled identifier node returning bool8122 (depth = 5)
  int op_slot_left_8118 = gc_frame_newslot(bool8122);
  params[0] = call8120;
  partcv[0] = 1;
  Object opresult8123 = callmethod(bool8122, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8123 (depth = 4)
  Object if8117 = done;
  if (istrue(opresult8123)) {
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8125 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8127 = alloc_Float64(2);
// compiled num node returning num8127 (depth = 8)
  int op_slot_right_8126 = gc_frame_newslot(num8127);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8126 = gc_frame_newslot(*var_depth);
  params[0] = num8127;
  partcv[0] = 1;
  Object sum8129 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8129 (depth = 7)
  gc_frame_newslot(sum8129);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8130 = gc_frame_new();
// call case 4: self request
  Object call8131 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8130);
// compiled member node returning call8131 (depth = 7)
  params[0] = sum8129;
  partcv[0] = 1;
  Object call8132 = callmethodflags(call8131, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8125);
// compiled call node returning call8132 (depth = 6)
  int op_slot_right_8124 = gc_frame_newslot(call8132);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8135 == NULL) {
    strlit8135 = alloc_String("Value: ");
    gc_root(strlit8135);
  }
// compiled string node returning strlit8135 (depth = 7)
  int op_slot_right_8134 = gc_frame_newslot(strlit8135);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8137 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8140 == NULL) {
    strlit8140 = alloc_String("""\x0a""");
    gc_root(strlit8140);
  }
// compiled string node returning strlit8140 (depth = 9)
  int op_slot_right_8139 = gc_frame_newslot(strlit8140);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8139 = gc_frame_newslot(*var_s);
  params[0] = strlit8140;
  partcv[0] = 1;
  Object opresult8142 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8142 (depth = 8)
  int op_slot_left_8137 = gc_frame_newslot(opresult8142);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8143 = callmethod(opresult8142, "++(1)", 1, partcv, params);
// compiled op node returning opresult8143 (depth = 7)
  int op_slot_left_8134 = gc_frame_newslot(opresult8143);
  params[0] = strlit8135;
  partcv[0] = 1;
  Object opresult8144 = callmethod(opresult8143, "++(1)", 1, partcv, params);
// compiled op node returning opresult8144 (depth = 6)
  int op_slot_left_8124 = gc_frame_newslot(opresult8144);
  params[0] = call8132;
  partcv[0] = 1;
  Object opresult8145 = callmethod(opresult8144, "++(1)", 1, partcv, params);
// compiled op node returning opresult8145 (depth = 5)
  *var_s = opresult8145;
  if (opresult8145 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8117 = done;
  } else {
  }
// compiled if node returning if8117 (depth = 3)
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8148 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8149 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8150 = gc_frame_new();
// call case 4: self request
  Object call8151 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8150);
// compiled member node returning call8151 (depth = 6)
  Object call8152 = callmethodflags(call8151, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe8149);
// compiled member node returning call8152 (depth = 5)
  Object call8153 = callmethodflags(call8152, "not", 0, partcv, params, 0);
  gc_frame_end(callframe8148);
// compiled member node returning call8153 (depth = 4)
  Object if8147 = done;
  if (istrue(call8153)) {
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8156 == NULL) {
    strlit8156 = alloc_String("Annotations:");
    gc_root(strlit8156);
  }
// compiled string node returning strlit8156 (depth = 7)
  int op_slot_right_8155 = gc_frame_newslot(strlit8156);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8158 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit8160 == NULL) {
    strlit8160 = alloc_String("""\x0a""");
    gc_root(strlit8160);
  }
// compiled string node returning strlit8160 (depth = 8)
  int op_slot_left_8158 = gc_frame_newslot(strlit8160);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8161 = callmethod(strlit8160, "++(1)", 1, partcv, params);
// compiled op node returning opresult8161 (depth = 7)
  int op_slot_left_8155 = gc_frame_newslot(opresult8161);
  params[0] = strlit8156;
  partcv[0] = 1;
  Object opresult8162 = callmethod(opresult8161, "++(1)", 1, partcv, params);
// compiled op node returning opresult8162 (depth = 6)
  int op_slot_right_8154 = gc_frame_newslot(opresult8162);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8154 = gc_frame_newslot(*var_s);
  params[0] = opresult8162;
  partcv[0] = 1;
  Object opresult8164 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8164 (depth = 5)
  *var_s = opresult8164;
  if (opresult8164 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8166 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8167 = alloc_Block(NULL, NULL, "ast", 2085);
  gc_frame_newslot(block8167);
// method "_apply(_)"
  block_savedest(block8167);
  Object closure8168 = createclosure(3, "_apply(1)");
  setclosureframe(closure8168, stackframe);
  addtoclosure(closure8168, var_depth);
  addtoclosure(closure8168, var_s);
  addtoclosure(closure8168, selfslot);
  struct UserObject *uo8168 = (struct UserObject*)block8167;
  uo8168->data[0] = (Object)closure8168;
  Method *meth_meth_ast__apply_40_1_41_8168 = addmethod2pos(block8167, "_apply(1)", &meth_ast__apply_40_1_41_8168, 0);
  int argcv_meth_ast__apply_40_1_41_8168[] = {1};
  meth_meth_ast__apply_40_1_41_8168->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8168);
  meth_meth_ast__apply_40_1_41_8168->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8168->definitionLine = 2969;
// compiled block node returning block8167 (depth = 5)
  gc_frame_newslot(block8167);
// call case 6: other requests
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8192 = gc_frame_new();
// call case 4: self request
  Object call8193 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8192);
// compiled member node returning call8193 (depth = 5)
  params[0] = block8167;
  partcv[0] = 1;
  Object call8194 = callmethodflags(call8193, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8166);
// compiled call node returning call8194 (depth = 4)
    gc_frame_newslot(call8194);
    if8147 = call8194;
  } else {
  }
// compiled if node returning if8147 (depth = 3)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8197 = gc_frame_new();
// call case 4: self request
  Object call8198 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8197);
// compiled member node returning call8198 (depth = 5)
  int op_slot_right_8196 = gc_frame_newslot(call8198);
// starting to compile identifier node (depth = 5)
  Object bool8200 = alloc_Boolean(0);
// compiled identifier node returning bool8200 (depth = 5)
  int op_slot_left_8196 = gc_frame_newslot(bool8200);
  params[0] = call8198;
  partcv[0] = 1;
  Object opresult8201 = callmethod(bool8200, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8201 (depth = 4)
  Object if8195 = done;
  if (istrue(opresult8201)) {
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8203 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8205 = alloc_Float64(2);
// compiled num node returning num8205 (depth = 8)
  int op_slot_right_8204 = gc_frame_newslot(num8205);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8204 = gc_frame_newslot(*var_depth);
  params[0] = num8205;
  partcv[0] = 1;
  Object sum8207 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8207 (depth = 7)
  gc_frame_newslot(sum8207);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8208 = gc_frame_new();
// call case 4: self request
  Object call8209 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8208);
// compiled member node returning call8209 (depth = 7)
  params[0] = sum8207;
  partcv[0] = 1;
  Object call8210 = callmethodflags(call8209, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8203);
// compiled call node returning call8210 (depth = 6)
  int op_slot_right_8202 = gc_frame_newslot(call8210);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8202 = gc_frame_newslot(*var_s);
  params[0] = call8210;
  partcv[0] = 1;
  Object opresult8212 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8212 (depth = 5)
  *var_s = opresult8212;
  if (opresult8212 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8195 = done;
  } else {
  }
// compiled if node returning if8195 (depth = 3)
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_8226(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8228 == NULL) {
    strlit8228 = alloc_String("    ");
    gc_root(strlit8228);
  }
// compiled string node returning strlit8228 (depth = 7)
  int op_slot_right_8227 = gc_frame_newslot(strlit8228);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8227 = gc_frame_newslot(*var_spc);
  params[0] = strlit8228;
  partcv[0] = 1;
  Object opresult8230 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8230 (depth = 6)
  *var_spc = opresult8230;
  if (opresult8230 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8250(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8252 == NULL) {
    strlit8252 = alloc_String("Unknown");
    gc_root(strlit8252);
  }
// compiled string node returning strlit8252 (depth = 7)
  int op_slot_right_8251 = gc_frame_newslot(strlit8252);
// starting to compile member node (depth = 7)
  int callframe8254 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8255 = gc_frame_new();
// call case 4: self request
  Object call8256 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8255);
// compiled member node returning call8256 (depth = 8)
  Object call8257 = callmethodflags(call8256, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8254);
// compiled member node returning call8257 (depth = 7)
  int op_slot_left_8251 = gc_frame_newslot(call8257);
  params[0] = strlit8252;
  partcv[0] = 1;
  Object opresult8258 = callmethod(call8257, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8258 (depth = 6)
  gc_frame_end(frame);
  return opresult8258;
}
Object meth_ast__apply_40_2_41_8298(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8300 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8301 = alloc_Float64(0);
// compiled num node returning num8301 (depth = 10)
  gc_frame_newslot(num8301);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8301;
  partcv[0] = 1;
  Object call8302 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8300);
// compiled call node returning call8302 (depth = 9)
  int op_slot_right_8299 = gc_frame_newslot(call8302);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8306 == NULL) {
    strlit8306 = alloc_String("");
    gc_root(strlit8306);
  }
// compiled string node returning strlit8306 (depth = 11)
  int op_slot_right_8305 = gc_frame_newslot(strlit8306);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8305 = gc_frame_newslot(*var_a);
  params[0] = strlit8306;
  partcv[0] = 1;
  Object opresult8308 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8308 (depth = 10)
  Object if8304 = done;
struct StackFrameObject *iftmpstackframe8304 = stackframe;
  if (istrue(opresult8308)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8304);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8310 == NULL) {
    strlit8310 = alloc_String(", ");
    gc_root(strlit8310);
  }
// compiled string node returning strlit8310 (depth = 11)
  int op_slot_right_8309 = gc_frame_newslot(strlit8310);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8309 = gc_frame_newslot(*var_a);
  params[0] = strlit8310;
  partcv[0] = 1;
  Object opresult8312 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult8312 (depth = 10)
    gc_frame_newslot(opresult8312);
    if8304 = opresult8312;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8304);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8313 == NULL) {
    strlit8313 = alloc_String("");
    gc_root(strlit8313);
  }
// compiled string node returning strlit8313 (depth = 10)
    gc_frame_newslot(strlit8313);
    if8304 = strlit8313;
  }
stackframe = iftmpstackframe8304;
// compiled if node returning if8304 (depth = 9)
  int op_slot_left_8299 = gc_frame_newslot(if8304);
  params[0] = call8302;
  partcv[0] = 1;
  Object opresult8314 = callmethod(if8304, "++(1)", 1, partcv, params);
// compiled op node returning opresult8314 (depth = 8)
  gc_frame_end(frame);
  return opresult8314;
}
Object meth_ast_toGrace_40_1_41_8214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8215 == NULL) {
    strlit8215 = alloc_String("");
    gc_root(strlit8215);
  }
// compiled string node returning strlit8215 (depth = 4)
  *var_spc = strlit8215;
  if (strlit8215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8216 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8219 = alloc_Float64(1);
// compiled num node returning num8219 (depth = 6)
  int op_slot_right_8218 = gc_frame_newslot(num8219);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_8218 = gc_frame_newslot(*var_depth);
  params[0] = num8219;
  partcv[0] = 1;
  Object diff8221 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff8221 (depth = 5)
  int op_slot_right_8217 = gc_frame_newslot(diff8221);
// starting to compile num node (depth = 5)
  Object num8223 = alloc_Float64(0);
// compiled num node returning num8223 (depth = 5)
  int op_slot_left_8217 = gc_frame_newslot(num8223);
  params[0] = diff8221;
  partcv[0] = 1;
  Object opresult8224 = callmethod(num8223, "..(1)", 1, partcv, params);
// compiled op node returning opresult8224 (depth = 4)
  gc_frame_newslot(opresult8224);
// starting to compile block node (depth = 4)
  Object block8225 = alloc_Block(NULL, NULL, "ast", 2096);
  gc_frame_newslot(block8225);
// method "_apply(_)"
  block_savedest(block8225);
  Object closure8226 = createclosure(2, "_apply(1)");
  setclosureframe(closure8226, stackframe);
  addtoclosure(closure8226, var_spc);
  addtoclosure(closure8226, selfslot);
  struct UserObject *uo8226 = (struct UserObject*)block8225;
  uo8226->data[0] = (Object)closure8226;
  Method *meth_meth_ast__apply_40_1_41_8226 = addmethod2pos(block8225, "_apply(1)", &meth_ast__apply_40_1_41_8226, 0);
  int argcv_meth_ast__apply_40_1_41_8226[] = {1};
  meth_meth_ast__apply_40_1_41_8226->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8226);
  meth_meth_ast__apply_40_1_41_8226->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8226->definitionLine = 2969;
// compiled block node returning block8225 (depth = 4)
  gc_frame_newslot(block8225);
// call case 5: prelude request
  params[0] = opresult8224;
  params[1] = block8225;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8233 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8216);
// compiled call node returning call8233 (depth = 3)
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8235 == NULL) {
    strlit8235 = alloc_String("");
    gc_root(strlit8235);
  }
// compiled string node returning strlit8235 (depth = 5)
  int op_slot_right_8234 = gc_frame_newslot(strlit8235);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8238 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8239 = alloc_Float64(0);
// compiled num node returning num8239 (depth = 7)
  gc_frame_newslot(num8239);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8240 = gc_frame_new();
// call case 4: self request
  Object call8241 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8240);
// compiled member node returning call8241 (depth = 7)
  params[0] = num8239;
  partcv[0] = 1;
  Object call8242 = callmethodflags(call8241, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8238);
// compiled call node returning call8242 (depth = 6)
  int op_slot_right_8237 = gc_frame_newslot(call8242);
// starting to compile string node (depth = 6)
  if (strlit8244 == NULL) {
    strlit8244 = alloc_String("def ");
    gc_root(strlit8244);
  }
// compiled string node returning strlit8244 (depth = 6)
  int op_slot_left_8237 = gc_frame_newslot(strlit8244);
  params[0] = call8242;
  partcv[0] = 1;
  Object opresult8245 = callmethod(strlit8244, "++(1)", 1, partcv, params);
// compiled op node returning opresult8245 (depth = 5)
  int op_slot_left_8234 = gc_frame_newslot(opresult8245);
  params[0] = strlit8235;
  partcv[0] = 1;
  Object opresult8246 = callmethod(opresult8245, "++(1)", 1, partcv, params);
// compiled op node returning opresult8246 (depth = 4)
  *var_s = opresult8246;
  if (opresult8246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8249 = alloc_Block(NULL, NULL, "ast", 2100);
  gc_frame_newslot(block8249);
// method "_apply"
  block_savedest(block8249);
  Object closure8250 = createclosure(1, "_apply");
  setclosureframe(closure8250, stackframe);
  addtoclosure(closure8250, selfslot);
  struct UserObject *uo8250 = (struct UserObject*)block8249;
  uo8250->data[0] = (Object)closure8250;
  Method *meth_meth_ast__apply8250 = addmethod2pos(block8249, "_apply", &meth_ast__apply8250, 0);
  int argcv_meth_ast__apply8250[] = {0};
  meth_meth_ast__apply8250->type = alloc_MethodType(1, argcv_meth_ast__apply8250);
  meth_meth_ast__apply8250->definitionModule = modulename;
  meth_meth_ast__apply8250->definitionLine = 2969;
// compiled block node returning block8249 (depth = 5)
  int op_slot_right_8248 = gc_frame_newslot(block8249);
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8262 = gc_frame_new();
// call case 4: self request
  Object call8263 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8262);
// compiled member node returning call8263 (depth = 6)
  int op_slot_right_8261 = gc_frame_newslot(call8263);
// starting to compile identifier node (depth = 6)
  Object bool8265 = alloc_Boolean(0);
// compiled identifier node returning bool8265 (depth = 6)
  int op_slot_left_8261 = gc_frame_newslot(bool8265);
  params[0] = call8263;
  partcv[0] = 1;
  Object opresult8266 = callmethod(bool8265, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8266 (depth = 5)
  int op_slot_left_8248 = gc_frame_newslot(opresult8266);
  params[0] = block8249;
  partcv[0] = 1;
  Object opresult8267 = callmethod(opresult8266, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8267 (depth = 4)
  Object if8247 = done;
  if (istrue(opresult8267)) {
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8269 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8270 = alloc_Float64(0);
// compiled num node returning num8270 (depth = 7)
  gc_frame_newslot(num8270);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8271 = gc_frame_new();
// call case 4: self request
  Object call8272 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8271);
// compiled member node returning call8272 (depth = 7)
  params[0] = num8270;
  partcv[0] = 1;
  Object call8273 = callmethodflags(call8272, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8269);
// compiled call node returning call8273 (depth = 6)
  int op_slot_right_8268 = gc_frame_newslot(call8273);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8276 == NULL) {
    strlit8276 = alloc_String(" : ");
    gc_root(strlit8276);
  }
// compiled string node returning strlit8276 (depth = 7)
  int op_slot_right_8275 = gc_frame_newslot(strlit8276);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8275 = gc_frame_newslot(*var_s);
  params[0] = strlit8276;
  partcv[0] = 1;
  Object opresult8278 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8278 (depth = 6)
  int op_slot_left_8268 = gc_frame_newslot(opresult8278);
  params[0] = call8273;
  partcv[0] = 1;
  Object opresult8279 = callmethod(opresult8278, "++(1)", 1, partcv, params);
// compiled op node returning opresult8279 (depth = 5)
  *var_s = opresult8279;
  if (opresult8279 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8247 = done;
  } else {
  }
// compiled if node returning if8247 (depth = 3)
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8283 = alloc_Float64(0);
// compiled num node returning num8283 (depth = 5)
  int op_slot_right_8282 = gc_frame_newslot(num8283);
// starting to compile member node (depth = 5)
  int callframe8285 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8286 = gc_frame_new();
// call case 4: self request
  Object call8287 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8286);
// compiled member node returning call8287 (depth = 6)
  Object call8288 = callmethodflags(call8287, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8285);
// compiled member node returning call8288 (depth = 5)
  int op_slot_left_8282 = gc_frame_newslot(call8288);
  params[0] = num8283;
  partcv[0] = 1;
  Object opresult8289 = callmethod(call8288, ">(1)", 1, partcv, params);
// compiled op node returning opresult8289 (depth = 4)
  Object if8281 = done;
  if (istrue(opresult8289)) {
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8291 == NULL) {
    strlit8291 = alloc_String(" is ");
    gc_root(strlit8291);
  }
// compiled string node returning strlit8291 (depth = 6)
  int op_slot_right_8290 = gc_frame_newslot(strlit8291);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8290 = gc_frame_newslot(*var_s);
  params[0] = strlit8291;
  partcv[0] = 1;
  Object opresult8293 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8293 (depth = 5)
  *var_s = opresult8293;
  if (opresult8293 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8296 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8297 = alloc_Block(NULL, NULL, "ast", 2106);
  gc_frame_newslot(block8297);
// method "_apply(_,_)"
  block_savedest(block8297);
  Object closure8298 = createclosure(1, "_apply(2)");
  setclosureframe(closure8298, stackframe);
  addtoclosure(closure8298, selfslot);
  struct UserObject *uo8298 = (struct UserObject*)block8297;
  uo8298->data[0] = (Object)closure8298;
  Method *meth_meth_ast__apply_40_2_41_8298 = addmethod2pos(block8297, "_apply(2)", &meth_ast__apply_40_2_41_8298, 0);
  int argcv_meth_ast__apply_40_2_41_8298[] = {2};
  meth_meth_ast__apply_40_2_41_8298->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_8298);
  meth_meth_ast__apply_40_2_41_8298->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_8298->definitionLine = 2969;
// compiled block node returning block8297 (depth = 7)
  gc_frame_newslot(block8297);
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8316 == NULL) {
    strlit8316 = alloc_String("");
    gc_root(strlit8316);
  }
// compiled string node returning strlit8316 (depth = 7)
  gc_frame_newslot(strlit8316);
// call case 6: other requests
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8317 = gc_frame_new();
// call case 4: self request
  Object call8318 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8317);
// compiled member node returning call8318 (depth = 7)
  params[0] = block8297;
  params[1] = strlit8316;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8319 = callmethodflags(call8318, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8296);
// compiled call node returning call8319 (depth = 6)
  int op_slot_right_8295 = gc_frame_newslot(call8319);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8295 = gc_frame_newslot(*var_s);
  params[0] = call8319;
  partcv[0] = 1;
  Object opresult8321 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8321 (depth = 5)
  *var_s = opresult8321;
  if (opresult8321 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8281 = done;
  } else {
  }
// compiled if node returning if8281 (depth = 3)
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8325 = gc_frame_new();
// call case 4: self request
  Object call8326 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8325);
// compiled member node returning call8326 (depth = 5)
  int op_slot_right_8324 = gc_frame_newslot(call8326);
// starting to compile identifier node (depth = 5)
  Object bool8328 = alloc_Boolean(0);
// compiled identifier node returning bool8328 (depth = 5)
  int op_slot_left_8324 = gc_frame_newslot(bool8328);
  params[0] = call8326;
  partcv[0] = 1;
  Object opresult8329 = callmethod(bool8328, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8329 (depth = 4)
  Object if8323 = done;
  if (istrue(opresult8329)) {
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8331 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8332 = gc_frame_new();
// call case 4: self request
  Object call8333 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8332);
// compiled member node returning call8333 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8334 = callmethodflags(call8333, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8331);
// compiled call node returning call8334 (depth = 6)
  int op_slot_right_8330 = gc_frame_newslot(call8334);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8337 == NULL) {
    strlit8337 = alloc_String(" = ");
    gc_root(strlit8337);
  }
// compiled string node returning strlit8337 (depth = 7)
  int op_slot_right_8336 = gc_frame_newslot(strlit8337);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8336 = gc_frame_newslot(*var_s);
  params[0] = strlit8337;
  partcv[0] = 1;
  Object opresult8339 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8339 (depth = 6)
  int op_slot_left_8330 = gc_frame_newslot(opresult8339);
  params[0] = call8334;
  partcv[0] = 1;
  Object opresult8340 = callmethod(opresult8339, "++(1)", 1, partcv, params);
// compiled op node returning opresult8340 (depth = 5)
  *var_s = opresult8340;
  if (opresult8340 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8323 = done;
  } else {
  }
// compiled if node returning if8323 (depth = 3)
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8342(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8343 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8344 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8345 = gc_frame_new();
// call case 4: self request
  Object call8346 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8345);
// compiled member node returning call8346 (depth = 5)
  gc_frame_newslot(call8346);
// starting to compile member node (depth = 5)
  int callframe8347 = gc_frame_new();
// call case 4: self request
  Object call8348 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8347);
// compiled member node returning call8348 (depth = 5)
  gc_frame_newslot(call8348);
// starting to compile member node (depth = 5)
  int callframe8349 = gc_frame_new();
// call case 4: self request
  Object call8350 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8349);
// compiled member node returning call8350 (depth = 5)
  gc_frame_newslot(call8350);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defDecNode (depth = 5)
  params[0] = call8346;
  params[1] = call8348;
  params[2] = call8350;
  partcv[0] = 3;
  Object call8351 = callmethodflags(*var_defDecNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe8344);
// compiled call node returning call8351 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8352 = callmethodflags(call8351, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8343);
// compiled call node returning call8352 (depth = 3)
  gc_frame_end(frame);
  return call8352;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_8353(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8354 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call8355 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8354);
// compiled call node returning call8355 (depth = 3)
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8356 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8357 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call8358 = callmethodflags(*var_other, "startToken", 0, partcv, params, 0);
  gc_frame_end(callframe8357);
// compiled member node returning call8358 (depth = 4)
  gc_frame_newslot(call8358);
// call case 4: self request
  params[0] = call8358;
  partcv[0] = 1;
  Object call8359 = callmethodflags(self, "startToken:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8356);
// compiled call node returning call8359 (depth = 3)
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName8360(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8361 == NULL) {
    strlit8361 = alloc_String("definition");
    gc_root(strlit8361);
  }
// compiled string node returning strlit8361 (depth = 3)
  gc_frame_end(frame);
  return strlit8361;
}
Object meth_ast_new_40_3_41_7918(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7919 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7919 = alloc_userobj2(27,23, objclass7919);
  gc_frame_newslot(obj7919);
if (objclass7919 == NULL) {
  glfree(obj7919->class->name);
  obj7919->class->name = "defDecNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7919, self, 0);
  addmethodreal(obj7919,"outer", &reader_ast_outer_7920);
  Object oldself7919 = self;
  struct StackFrameObject *oldstackframe7919 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7919);
  gc_frame_newslot((Object)stackframe);
  self = obj7919;
  Object *oldselfslot7919 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7919 = (*(struct UserObject *)self).data[0], lowerouter7919 = thisouter7919;
  if (inheritingObject7919) {
    struct UserObject *inho7919 = (struct UserObject *)inheritingObject7919;
    while (inho7919->super != GraceDefaultObject) inho7919 = (struct UserObject *)inho7919->super;
    inho7919->super = obj7919;
    self = inheritingObject7919;
    *selfslot = self;
    lowerouter7919 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7919;
  }
if (objclass7919 == NULL) {
  Method *reader7921 = addmethodrealflags(obj7919, "kind",&reader_ast_kind_7921, MFLAG_DEF);
  reader7921->definitionModule = modulename;
  reader7921->definitionLine = 2018;
}
adddatum2(obj7919, alloc_Undefined(), 1);
if (objclass7919 == NULL) {
  Method *reader7922 = addmethodrealflags(obj7919, "name", &reader_ast_name_7922, 0);
  Method *writer7922 = addmethodrealflags(obj7919, "name:=(1)", &writer_ast_name_7922, 0);
  reader7922->definitionModule = modulename;
  writer7922->definitionModule = modulename;
  reader7922->definitionLine = 2019;
  writer7922->definitionLine = 2019;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 2);
if (objclass7919 == NULL) {
  Method *reader7923 = addmethodrealflags(obj7919, "value", &reader_ast_value_7923, 0);
  Method *writer7923 = addmethodrealflags(obj7919, "value:=(1)", &writer_ast_value_7923, 0);
  reader7923->definitionModule = modulename;
  writer7923->definitionModule = modulename;
  reader7923->definitionLine = 2020;
  writer7923->definitionLine = 2020;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 3);
if (objclass7919 == NULL) {
  Method *reader7924 = addmethodrealflags(obj7919, "dtype", &reader_ast_dtype_7924, 0);
  Method *writer7924 = addmethodrealflags(obj7919, "dtype:=(1)", &writer_ast_dtype_7924, 0);
  reader7924->definitionModule = modulename;
  writer7924->definitionModule = modulename;
  reader7924->definitionLine = 2021;
  writer7924->definitionLine = 2021;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 4);
if (objclass7919 == NULL) {
  Method *reader7925 = addmethodrealflags(obj7919, "nameString",&reader_ast_nameString_7925, MFLAG_DEF);
  reader7925->definitionModule = modulename;
  reader7925->definitionLine = 2022;
}
adddatum2(obj7919, alloc_Undefined(), 5);
if (objclass7919 == NULL) {
  Method *reader7926 = addmethodrealflags(obj7919, "annotations", &reader_ast_annotations_7926, 0);
  Method *writer7926 = addmethodrealflags(obj7919, "annotations:=(1)", &writer_ast_annotations_7926, 0);
  reader7926->definitionModule = modulename;
  writer7926->definitionModule = modulename;
  reader7926->definitionLine = 2023;
  writer7926->definitionLine = 2023;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 6);
if (objclass7919 == NULL) {
  Method *reader7927 = addmethodrealflags(obj7919, "startToken", &reader_ast_startToken_7927, 0);
  Method *writer7927 = addmethodrealflags(obj7919, "startToken:=(1)", &writer_ast_startToken_7927, 0);
  reader7927->definitionModule = modulename;
  writer7927->definitionModule = modulename;
  reader7927->definitionLine = 2024;
  writer7927->definitionLine = 2024;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 7);
// method "isPublic"
  struct UserObject *uo7928 = (struct UserObject*)obj7919;
  uo7928->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic7928 = addmethod2pos(obj7919, "isPublic", &meth_ast_isPublic7928, 8);
  int argcv_meth_ast_isPublic7928[] = {0};
  meth_meth_ast_isPublic7928->type = alloc_MethodType(1, argcv_meth_ast_isPublic7928);
  meth_meth_ast_isPublic7928->definitionModule = modulename;
  meth_meth_ast_isPublic7928->definitionLine = 2026;
// method "isFieldDec"
  struct UserObject *uo7955 = (struct UserObject*)obj7919;
  uo7955->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec7955 = addmethod2pos(obj7919, "isFieldDec", &meth_ast_isFieldDec7955, 9);
  int argcv_meth_ast_isFieldDec7955[] = {0};
  meth_meth_ast_isFieldDec7955->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec7955);
  meth_meth_ast_isFieldDec7955->definitionModule = modulename;
  meth_meth_ast_isFieldDec7955->definitionLine = 2032;
// method "isWritable"
  struct UserObject *uo7957 = (struct UserObject*)obj7919;
  uo7957->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable7957 = addmethod2pos(obj7919, "isWritable", &meth_ast_isWritable7957, 10);
  int argcv_meth_ast_isWritable7957[] = {0};
  meth_meth_ast_isWritable7957->type = alloc_MethodType(1, argcv_meth_ast_isWritable7957);
  meth_meth_ast_isWritable7957->definitionModule = modulename;
  meth_meth_ast_isWritable7957->definitionLine = 2033;
// method "isReadable"
  struct UserObject *uo7959 = (struct UserObject*)obj7919;
  uo7959->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable7959 = addmethod2pos(obj7919, "isReadable", &meth_ast_isReadable7959, 11);
  int argcv_meth_ast_isReadable7959[] = {0};
  meth_meth_ast_isReadable7959->type = alloc_MethodType(1, argcv_meth_ast_isReadable7959);
  meth_meth_ast_isReadable7959->definitionModule = modulename;
  meth_meth_ast_isReadable7959->definitionLine = 2034;
// method "returnsObject"
  struct UserObject *uo7962 = (struct UserObject*)obj7919;
  uo7962->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject7962 = addmethod2pos(obj7919, "returnsObject", &meth_ast_returnsObject7962, 12);
  int argcv_meth_ast_returnsObject7962[] = {0};
  meth_meth_ast_returnsObject7962->type = alloc_MethodType(1, argcv_meth_ast_returnsObject7962);
  meth_meth_ast_returnsObject7962->definitionModule = modulename;
  meth_meth_ast_returnsObject7962->definitionLine = 2036;
// method "returnedObjectScope"
  struct UserObject *uo7967 = (struct UserObject*)obj7919;
  uo7967->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope7967 = addmethod2pos(obj7919, "returnedObjectScope", &meth_ast_returnedObjectScope7967, 13);
  int argcv_meth_ast_returnedObjectScope7967[] = {0};
  meth_meth_ast_returnedObjectScope7967->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope7967);
  meth_meth_ast_returnedObjectScope7967->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope7967->definitionLine = 2039;
// method "usesAsType(_)"
  struct UserObject *uo7972 = (struct UserObject*)obj7919;
  uo7972->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_7972 = addmethod2pos(obj7919, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_7972, 14);
  int argcv_meth_ast_usesAsType_40_1_41_7972[] = {1};
  meth_meth_ast_usesAsType_40_1_41_7972->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_7972);
  meth_meth_ast_usesAsType_40_1_41_7972->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_7972->definitionLine = 2043;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj7919);
  Object closure7978 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure7978, stackframe);
  addtoclosure(closure7978, var_k);
  struct UserObject *uo7978 = (struct UserObject*)obj7919;
  uo7978->data[15] = (Object)closure7978;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_7978 = addmethod2pos(obj7919, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_7978, 15);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_7978[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_7978->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_7978);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_7978->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_7978->definitionLine = 2046;
// method "accept(_)from(_)"
  struct UserObject *uo7981 = (struct UserObject*)obj7919;
  uo7981->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7981 = addmethod2pos(obj7919, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7981, 16);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7981[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7981->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7981);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7981->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7981->definitionLine = 2048;
// method "map(_)ancestors(_)"
  struct UserObject *uo8015 = (struct UserObject*)obj7919;
  uo8015->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8015 = addmethod2pos(obj7919, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8015, 17);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8015[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8015->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8015);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8015->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8015->definitionLine = 2061;
// method "pretty(_)"
  struct UserObject *uo8054 = (struct UserObject*)obj7919;
  uo8054->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8054 = addmethod2pos(obj7919, "pretty(1)", &meth_ast_pretty_40_1_41_8054, 18);
  int argcv_meth_ast_pretty_40_1_41_8054[] = {1};
  meth_meth_ast_pretty_40_1_41_8054->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8054);
  meth_meth_ast_pretty_40_1_41_8054->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8054->definitionLine = 2070;
// method "toGrace(_)"
  struct UserObject *uo8214 = (struct UserObject*)obj7919;
  uo8214->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_8214 = addmethod2pos(obj7919, "toGrace(1)", &meth_ast_toGrace_40_1_41_8214, 19);
  int argcv_meth_ast_toGrace_40_1_41_8214[] = {1};
  meth_meth_ast_toGrace_40_1_41_8214->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_8214);
meth_meth_ast_toGrace_40_1_41_8214->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_8214->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_8214->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_8214->definitionLine = 2094;
// method "shallowCopy"
  block_savedest(obj7919);
  Object closure8342 = createclosure(1, "shallowCopy");
  setclosureframe(closure8342, stackframe);
  addtoclosure(closure8342, var_defDecNode);
  struct UserObject *uo8342 = (struct UserObject*)obj7919;
  uo8342->data[20] = (Object)closure8342;
  Method *meth_meth_ast_shallowCopy8342 = addmethod2pos(obj7919, "shallowCopy", &meth_ast_shallowCopy8342, 20);
  int argcv_meth_ast_shallowCopy8342[] = {0};
  meth_meth_ast_shallowCopy8342->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8342);
  meth_meth_ast_shallowCopy8342->definitionModule = modulename;
  meth_meth_ast_shallowCopy8342->definitionLine = 2115;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo8353 = (struct UserObject*)obj7919;
  uo8353->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8353 = addmethod2pos(obj7919, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_8353, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_8353[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8353->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_8353);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8353->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8353->definitionLine = 2118;
// method "statementName"
  struct UserObject *uo8360 = (struct UserObject*)obj7919;
  uo8360->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName8360 = addmethod2pos(obj7919, "statementName", &meth_ast_statementName8360, 22);
  int argcv_meth_ast_statementName8360[] = {0};
  meth_meth_ast_statementName8360->type = alloc_MethodType(1, argcv_meth_ast_statementName8360);
  meth_meth_ast_statementName8360->definitionModule = modulename;
  meth_meth_ast_statementName8360->definitionLine = 2123;
  sourceObject = obj7919;
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8362 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8363 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8364 = gc_frame_new();
// call case 3: self.outer request
  Object call8365 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8364);
// compiled member node returning call8365 (depth = 5)
  Object call8366 = callmethodflags(call8365, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8363);
// compiled member node returning call8366 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8367 = callmethodflags(call8366, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8362);
// compiled call node returning call8367 (depth = 3)
  struct UserObject *obj7919_uo = (struct UserObject *)obj7919;
  obj7919_uo->super = call8367;
  sourceObject = obj7919;
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8368 == NULL) {
    strlit8368 = alloc_String("defdec");
    gc_root(strlit8368);
  }
// compiled string node returning strlit8368 (depth = 3)
  adddatum2(obj7919, strlit8368, 1);
  sourceObject = obj7919;
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7919, *var_name_39_, 2);
  sourceObject = obj7919;
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7919, *var_val, 3);
  sourceObject = obj7919;
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7919, *var_dtype_39_, 4);
  sourceObject = obj7919;
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8369 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8370 = gc_frame_new();
// call case 4: self request
  Object call8371 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8370);
// compiled member node returning call8371 (depth = 4)
  Object call8372 = callmethodflags(call8371, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe8369);
// compiled member node returning call8372 (depth = 3)
  adddatum2(obj7919, call8372, 5);
  sourceObject = obj7919;
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8373 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8373 (depth = 3)
  adddatum2(obj7919, array8373, 6);
  sourceObject = obj7919;
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8374 = alloc_Boolean(0);
// compiled identifier node returning bool8374 (depth = 3)
  adddatum2(obj7919, bool8374, 7);
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  objclass7919 = obj7919->class;
  objclass7919->definitionModule = modulename;
  objclass7919->definitionLine = 2016;
  (*(struct UserObject *)self).data[0] = lowerouter7919;
  self = oldself7919;
  selfslot = oldselfslot7919;
  stackframe = oldstackframe7919;
  gc_frame_end(frame);
  return obj7919;
}
Object meth_ast_new_40_3_41_7918_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7919 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7919 = alloc_userobj2(27,23, objclass7919);
  gc_frame_newslot(obj7919);
if (objclass7919 == NULL) {
  glfree(obj7919->class->name);
  obj7919->class->name = "defDecNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7919, self, 0);
  addmethodreal(obj7919,"outer", &reader_ast_outer_7920);
  Object oldself7919 = self;
  struct StackFrameObject *oldstackframe7919 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7919);
  gc_frame_newslot((Object)stackframe);
  self = obj7919;
  Object *oldselfslot7919 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7919 = (*(struct UserObject *)self).data[0], lowerouter7919 = thisouter7919;
  if (inheritingObject7919) {
    struct UserObject *inho7919 = (struct UserObject *)inheritingObject7919;
    while (inho7919->super != GraceDefaultObject) inho7919 = (struct UserObject *)inho7919->super;
    inho7919->super = obj7919;
    self = inheritingObject7919;
    *selfslot = self;
    lowerouter7919 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7919;
  }
if (objclass7919 == NULL) {
  Method *reader7921 = addmethodrealflags(obj7919, "kind",&reader_ast_kind_7921, MFLAG_DEF);
  reader7921->definitionModule = modulename;
  reader7921->definitionLine = 2018;
}
adddatum2(obj7919, alloc_Undefined(), 1);
if (objclass7919 == NULL) {
  Method *reader7922 = addmethodrealflags(obj7919, "name", &reader_ast_name_7922, 0);
  Method *writer7922 = addmethodrealflags(obj7919, "name:=(1)", &writer_ast_name_7922, 0);
  reader7922->definitionModule = modulename;
  writer7922->definitionModule = modulename;
  reader7922->definitionLine = 2019;
  writer7922->definitionLine = 2019;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 2);
if (objclass7919 == NULL) {
  Method *reader7923 = addmethodrealflags(obj7919, "value", &reader_ast_value_7923, 0);
  Method *writer7923 = addmethodrealflags(obj7919, "value:=(1)", &writer_ast_value_7923, 0);
  reader7923->definitionModule = modulename;
  writer7923->definitionModule = modulename;
  reader7923->definitionLine = 2020;
  writer7923->definitionLine = 2020;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 3);
if (objclass7919 == NULL) {
  Method *reader7924 = addmethodrealflags(obj7919, "dtype", &reader_ast_dtype_7924, 0);
  Method *writer7924 = addmethodrealflags(obj7919, "dtype:=(1)", &writer_ast_dtype_7924, 0);
  reader7924->definitionModule = modulename;
  writer7924->definitionModule = modulename;
  reader7924->definitionLine = 2021;
  writer7924->definitionLine = 2021;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 4);
if (objclass7919 == NULL) {
  Method *reader7925 = addmethodrealflags(obj7919, "nameString",&reader_ast_nameString_7925, MFLAG_DEF);
  reader7925->definitionModule = modulename;
  reader7925->definitionLine = 2022;
}
adddatum2(obj7919, alloc_Undefined(), 5);
if (objclass7919 == NULL) {
  Method *reader7926 = addmethodrealflags(obj7919, "annotations", &reader_ast_annotations_7926, 0);
  Method *writer7926 = addmethodrealflags(obj7919, "annotations:=(1)", &writer_ast_annotations_7926, 0);
  reader7926->definitionModule = modulename;
  writer7926->definitionModule = modulename;
  reader7926->definitionLine = 2023;
  writer7926->definitionLine = 2023;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 6);
if (objclass7919 == NULL) {
  Method *reader7927 = addmethodrealflags(obj7919, "startToken", &reader_ast_startToken_7927, 0);
  Method *writer7927 = addmethodrealflags(obj7919, "startToken:=(1)", &writer_ast_startToken_7927, 0);
  reader7927->definitionModule = modulename;
  writer7927->definitionModule = modulename;
  reader7927->definitionLine = 2024;
  writer7927->definitionLine = 2024;
}
obj7919->flags |= OFLAG_MUTABLE;
adddatum2(obj7919, alloc_Undefined(), 7);
// method "isPublic"
  struct UserObject *uo7928 = (struct UserObject*)obj7919;
  uo7928->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic7928 = addmethod2pos(obj7919, "isPublic", &meth_ast_isPublic7928, 8);
  int argcv_meth_ast_isPublic7928[] = {0};
  meth_meth_ast_isPublic7928->type = alloc_MethodType(1, argcv_meth_ast_isPublic7928);
  meth_meth_ast_isPublic7928->definitionModule = modulename;
  meth_meth_ast_isPublic7928->definitionLine = 2026;
// method "isFieldDec"
  struct UserObject *uo7955 = (struct UserObject*)obj7919;
  uo7955->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec7955 = addmethod2pos(obj7919, "isFieldDec", &meth_ast_isFieldDec7955, 9);
  int argcv_meth_ast_isFieldDec7955[] = {0};
  meth_meth_ast_isFieldDec7955->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec7955);
  meth_meth_ast_isFieldDec7955->definitionModule = modulename;
  meth_meth_ast_isFieldDec7955->definitionLine = 2032;
// method "isWritable"
  struct UserObject *uo7957 = (struct UserObject*)obj7919;
  uo7957->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable7957 = addmethod2pos(obj7919, "isWritable", &meth_ast_isWritable7957, 10);
  int argcv_meth_ast_isWritable7957[] = {0};
  meth_meth_ast_isWritable7957->type = alloc_MethodType(1, argcv_meth_ast_isWritable7957);
  meth_meth_ast_isWritable7957->definitionModule = modulename;
  meth_meth_ast_isWritable7957->definitionLine = 2033;
// method "isReadable"
  struct UserObject *uo7959 = (struct UserObject*)obj7919;
  uo7959->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable7959 = addmethod2pos(obj7919, "isReadable", &meth_ast_isReadable7959, 11);
  int argcv_meth_ast_isReadable7959[] = {0};
  meth_meth_ast_isReadable7959->type = alloc_MethodType(1, argcv_meth_ast_isReadable7959);
  meth_meth_ast_isReadable7959->definitionModule = modulename;
  meth_meth_ast_isReadable7959->definitionLine = 2034;
// method "returnsObject"
  struct UserObject *uo7962 = (struct UserObject*)obj7919;
  uo7962->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject7962 = addmethod2pos(obj7919, "returnsObject", &meth_ast_returnsObject7962, 12);
  int argcv_meth_ast_returnsObject7962[] = {0};
  meth_meth_ast_returnsObject7962->type = alloc_MethodType(1, argcv_meth_ast_returnsObject7962);
  meth_meth_ast_returnsObject7962->definitionModule = modulename;
  meth_meth_ast_returnsObject7962->definitionLine = 2036;
// method "returnedObjectScope"
  struct UserObject *uo7967 = (struct UserObject*)obj7919;
  uo7967->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope7967 = addmethod2pos(obj7919, "returnedObjectScope", &meth_ast_returnedObjectScope7967, 13);
  int argcv_meth_ast_returnedObjectScope7967[] = {0};
  meth_meth_ast_returnedObjectScope7967->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope7967);
  meth_meth_ast_returnedObjectScope7967->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope7967->definitionLine = 2039;
// method "usesAsType(_)"
  struct UserObject *uo7972 = (struct UserObject*)obj7919;
  uo7972->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_7972 = addmethod2pos(obj7919, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_7972, 14);
  int argcv_meth_ast_usesAsType_40_1_41_7972[] = {1};
  meth_meth_ast_usesAsType_40_1_41_7972->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_7972);
  meth_meth_ast_usesAsType_40_1_41_7972->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_7972->definitionLine = 2043;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj7919);
  Object closure7978 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure7978, stackframe);
  addtoclosure(closure7978, var_k);
  struct UserObject *uo7978 = (struct UserObject*)obj7919;
  uo7978->data[15] = (Object)closure7978;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_7978 = addmethod2pos(obj7919, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_7978, 15);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_7978[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_7978->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_7978);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_7978->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_7978->definitionLine = 2046;
// method "accept(_)from(_)"
  struct UserObject *uo7981 = (struct UserObject*)obj7919;
  uo7981->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7981 = addmethod2pos(obj7919, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7981, 16);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7981[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7981->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7981);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7981->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7981->definitionLine = 2048;
// method "map(_)ancestors(_)"
  struct UserObject *uo8015 = (struct UserObject*)obj7919;
  uo8015->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8015 = addmethod2pos(obj7919, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8015, 17);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8015[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8015->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8015);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8015->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8015->definitionLine = 2061;
// method "pretty(_)"
  struct UserObject *uo8054 = (struct UserObject*)obj7919;
  uo8054->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8054 = addmethod2pos(obj7919, "pretty(1)", &meth_ast_pretty_40_1_41_8054, 18);
  int argcv_meth_ast_pretty_40_1_41_8054[] = {1};
  meth_meth_ast_pretty_40_1_41_8054->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8054);
  meth_meth_ast_pretty_40_1_41_8054->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8054->definitionLine = 2070;
// method "toGrace(_)"
  struct UserObject *uo8214 = (struct UserObject*)obj7919;
  uo8214->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_8214 = addmethod2pos(obj7919, "toGrace(1)", &meth_ast_toGrace_40_1_41_8214, 19);
  int argcv_meth_ast_toGrace_40_1_41_8214[] = {1};
  meth_meth_ast_toGrace_40_1_41_8214->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_8214);
meth_meth_ast_toGrace_40_1_41_8214->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_8214->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_8214->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_8214->definitionLine = 2094;
// method "shallowCopy"
  block_savedest(obj7919);
  Object closure8342 = createclosure(1, "shallowCopy");
  setclosureframe(closure8342, stackframe);
  addtoclosure(closure8342, var_defDecNode);
  struct UserObject *uo8342 = (struct UserObject*)obj7919;
  uo8342->data[20] = (Object)closure8342;
  Method *meth_meth_ast_shallowCopy8342 = addmethod2pos(obj7919, "shallowCopy", &meth_ast_shallowCopy8342, 20);
  int argcv_meth_ast_shallowCopy8342[] = {0};
  meth_meth_ast_shallowCopy8342->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8342);
  meth_meth_ast_shallowCopy8342->definitionModule = modulename;
  meth_meth_ast_shallowCopy8342->definitionLine = 2115;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo8353 = (struct UserObject*)obj7919;
  uo8353->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8353 = addmethod2pos(obj7919, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_8353, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_8353[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8353->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_8353);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8353->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8353->definitionLine = 2118;
// method "statementName"
  struct UserObject *uo8360 = (struct UserObject*)obj7919;
  uo8360->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName8360 = addmethod2pos(obj7919, "statementName", &meth_ast_statementName8360, 22);
  int argcv_meth_ast_statementName8360[] = {0};
  meth_meth_ast_statementName8360->type = alloc_MethodType(1, argcv_meth_ast_statementName8360);
  meth_meth_ast_statementName8360->definitionModule = modulename;
  meth_meth_ast_statementName8360->definitionLine = 2123;
  sourceObject = obj7919;
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8362 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8363 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8364 = gc_frame_new();
// call case 3: self.outer request
  Object call8365 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8364);
// compiled member node returning call8365 (depth = 5)
  Object call8366 = callmethodflags(call8365, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8363);
// compiled member node returning call8366 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8367 = callmethodflags(call8366, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8362);
// compiled call node returning call8367 (depth = 3)
  struct UserObject *obj7919_uo = (struct UserObject *)obj7919;
  obj7919_uo->super = call8367;
  sourceObject = obj7919;
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8368 == NULL) {
    strlit8368 = alloc_String("defdec");
    gc_root(strlit8368);
  }
// compiled string node returning strlit8368 (depth = 3)
  adddatum2(obj7919, strlit8368, 1);
  sourceObject = obj7919;
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7919, *var_name_39_, 2);
  sourceObject = obj7919;
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7919, *var_val, 3);
  sourceObject = obj7919;
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7919, *var_dtype_39_, 4);
  sourceObject = obj7919;
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8369 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8370 = gc_frame_new();
// call case 4: self request
  Object call8371 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8370);
// compiled member node returning call8371 (depth = 4)
  Object call8372 = callmethodflags(call8371, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe8369);
// compiled member node returning call8372 (depth = 3)
  adddatum2(obj7919, call8372, 5);
  sourceObject = obj7919;
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8373 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8373 (depth = 3)
  adddatum2(obj7919, array8373, 6);
  sourceObject = obj7919;
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8374 = alloc_Boolean(0);
// compiled identifier node returning bool8374 (depth = 3)
  adddatum2(obj7919, bool8374, 7);
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  sourceObject = obj7919;
  objclass7919 = obj7919->class;
  objclass7919->definitionModule = modulename;
  objclass7919->definitionLine = 2016;
  (*(struct UserObject *)self).data[0] = lowerouter7919;
  self = oldself7919;
  selfslot = oldselfslot7919;
  stackframe = oldstackframe7919;
  gc_frame_end(frame);
  return obj7919;
}
Object meth_ast_defDecNode8376(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_isPublic8388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8391 = alloc_Float64(0);
// compiled num node returning num8391 (depth = 5)
  int op_slot_right_8390 = gc_frame_newslot(num8391);
// starting to compile member node (depth = 5)
  int callframe8393 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8394 = gc_frame_new();
// call case 4: self request
  Object call8395 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8394);
// compiled member node returning call8395 (depth = 6)
  Object call8396 = callmethodflags(call8395, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8393);
// compiled member node returning call8396 (depth = 5)
  int op_slot_left_8390 = gc_frame_newslot(call8396);
  params[0] = num8391;
  partcv[0] = 1;
  Object opresult8397 = callmethod(call8396, "==(1)", 1, partcv, params);
// compiled op node returning opresult8397 (depth = 4)
  Object if8389 = done;
  if (istrue(opresult8397)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8398 = alloc_Boolean(0);
// compiled identifier node returning bool8398 (depth = 5)
  return bool8398;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8389 = undefined;
  } else {
  }
// compiled if node returning if8389 (depth = 3)
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8400 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8401 == NULL) {
    strlit8401 = alloc_String("public");
    gc_root(strlit8401);
  }
// compiled string node returning strlit8401 (depth = 5)
  gc_frame_newslot(strlit8401);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8402 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8403 = gc_frame_new();
// call case 3: self.outer request
  Object call8404 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8403);
// compiled member node returning call8404 (depth = 6)
  Object call8405 = callmethodflags(call8404, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8402);
// compiled member node returning call8405 (depth = 5)
  params[0] = self;
  params[1] = strlit8401;
  partcv[0] = 2;
  Object call8406 = callmethodflags(call8405, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8400);
// compiled call node returning call8406 (depth = 4)
  Object if8399 = done;
  if (istrue(call8406)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8407 = alloc_Boolean(1);
// compiled identifier node returning bool8407 (depth = 5)
  return bool8407;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8399 = undefined;
  } else {
  }
// compiled if node returning if8399 (depth = 3)
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8408 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8409 == NULL) {
    strlit8409 = alloc_String("readable");
    gc_root(strlit8409);
  }
// compiled string node returning strlit8409 (depth = 4)
  gc_frame_newslot(strlit8409);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8410 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8411 = gc_frame_new();
// call case 3: self.outer request
  Object call8412 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8411);
// compiled member node returning call8412 (depth = 5)
  Object call8413 = callmethodflags(call8412, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8410);
// compiled member node returning call8413 (depth = 4)
  params[0] = self;
  params[1] = strlit8409;
  partcv[0] = 2;
  Object call8414 = callmethodflags(call8413, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8408);
// compiled call node returning call8414 (depth = 3)
  gc_frame_end(frame);
  return call8414;
}
Object meth_ast_isWritable8415(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8418 = alloc_Float64(0);
// compiled num node returning num8418 (depth = 5)
  int op_slot_right_8417 = gc_frame_newslot(num8418);
// starting to compile member node (depth = 5)
  int callframe8420 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8421 = gc_frame_new();
// call case 4: self request
  Object call8422 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8421);
// compiled member node returning call8422 (depth = 6)
  Object call8423 = callmethodflags(call8422, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8420);
// compiled member node returning call8423 (depth = 5)
  int op_slot_left_8417 = gc_frame_newslot(call8423);
  params[0] = num8418;
  partcv[0] = 1;
  Object opresult8424 = callmethod(call8423, "==(1)", 1, partcv, params);
// compiled op node returning opresult8424 (depth = 4)
  Object if8416 = done;
  if (istrue(opresult8424)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8425 = alloc_Boolean(0);
// compiled identifier node returning bool8425 (depth = 5)
  return bool8425;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8416 = undefined;
  } else {
  }
// compiled if node returning if8416 (depth = 3)
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8427 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8428 == NULL) {
    strlit8428 = alloc_String("public");
    gc_root(strlit8428);
  }
// compiled string node returning strlit8428 (depth = 5)
  gc_frame_newslot(strlit8428);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8429 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8430 = gc_frame_new();
// call case 3: self.outer request
  Object call8431 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8430);
// compiled member node returning call8431 (depth = 6)
  Object call8432 = callmethodflags(call8431, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8429);
// compiled member node returning call8432 (depth = 5)
  params[0] = self;
  params[1] = strlit8428;
  partcv[0] = 2;
  Object call8433 = callmethodflags(call8432, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8427);
// compiled call node returning call8433 (depth = 4)
  Object if8426 = done;
  if (istrue(call8433)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8434 = alloc_Boolean(1);
// compiled identifier node returning bool8434 (depth = 5)
  return bool8434;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8426 = undefined;
  } else {
  }
// compiled if node returning if8426 (depth = 3)
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8436 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8437 == NULL) {
    strlit8437 = alloc_String("writable");
    gc_root(strlit8437);
  }
// compiled string node returning strlit8437 (depth = 5)
  gc_frame_newslot(strlit8437);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8438 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8439 = gc_frame_new();
// call case 3: self.outer request
  Object call8440 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8439);
// compiled member node returning call8440 (depth = 6)
  Object call8441 = callmethodflags(call8440, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8438);
// compiled member node returning call8441 (depth = 5)
  params[0] = self;
  params[1] = strlit8437;
  partcv[0] = 2;
  Object call8442 = callmethodflags(call8441, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8436);
// compiled call node returning call8442 (depth = 4)
  Object if8435 = done;
  if (istrue(call8442)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8443 = alloc_Boolean(1);
// compiled identifier node returning bool8443 (depth = 5)
  return bool8443;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8435 = undefined;
  } else {
  }
// compiled if node returning if8435 (depth = 3)
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8444 = alloc_Boolean(0);
// compiled identifier node returning bool8444 (depth = 3)
  gc_frame_end(frame);
  return bool8444;
}
Object meth_ast_isReadable8445(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8448 = alloc_Float64(0);
// compiled num node returning num8448 (depth = 5)
  int op_slot_right_8447 = gc_frame_newslot(num8448);
// starting to compile member node (depth = 5)
  int callframe8450 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8451 = gc_frame_new();
// call case 4: self request
  Object call8452 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8451);
// compiled member node returning call8452 (depth = 6)
  Object call8453 = callmethodflags(call8452, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8450);
// compiled member node returning call8453 (depth = 5)
  int op_slot_left_8447 = gc_frame_newslot(call8453);
  params[0] = num8448;
  partcv[0] = 1;
  Object opresult8454 = callmethod(call8453, "==(1)", 1, partcv, params);
// compiled op node returning opresult8454 (depth = 4)
  Object if8446 = done;
  if (istrue(opresult8454)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8455 = alloc_Boolean(0);
// compiled identifier node returning bool8455 (depth = 5)
  return bool8455;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8446 = undefined;
  } else {
  }
// compiled if node returning if8446 (depth = 3)
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8457 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8458 == NULL) {
    strlit8458 = alloc_String("public");
    gc_root(strlit8458);
  }
// compiled string node returning strlit8458 (depth = 5)
  gc_frame_newslot(strlit8458);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8459 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8460 = gc_frame_new();
// call case 3: self.outer request
  Object call8461 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8460);
// compiled member node returning call8461 (depth = 6)
  Object call8462 = callmethodflags(call8461, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8459);
// compiled member node returning call8462 (depth = 5)
  params[0] = self;
  params[1] = strlit8458;
  partcv[0] = 2;
  Object call8463 = callmethodflags(call8462, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8457);
// compiled call node returning call8463 (depth = 4)
  Object if8456 = done;
  if (istrue(call8463)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8464 = alloc_Boolean(1);
// compiled identifier node returning bool8464 (depth = 5)
  return bool8464;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8456 = undefined;
  } else {
  }
// compiled if node returning if8456 (depth = 3)
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8466 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8467 == NULL) {
    strlit8467 = alloc_String("readable");
    gc_root(strlit8467);
  }
// compiled string node returning strlit8467 (depth = 5)
  gc_frame_newslot(strlit8467);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8468 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8469 = gc_frame_new();
// call case 3: self.outer request
  Object call8470 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8469);
// compiled member node returning call8470 (depth = 6)
  Object call8471 = callmethodflags(call8470, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8468);
// compiled member node returning call8471 (depth = 5)
  params[0] = self;
  params[1] = strlit8467;
  partcv[0] = 2;
  Object call8472 = callmethodflags(call8471, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8466);
// compiled call node returning call8472 (depth = 4)
  Object if8465 = done;
  if (istrue(call8472)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8473 = alloc_Boolean(1);
// compiled identifier node returning bool8473 (depth = 5)
  return bool8473;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8465 = undefined;
  } else {
  }
// compiled if node returning if8465 (depth = 3)
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8474 = alloc_Boolean(0);
// compiled identifier node returning bool8474 (depth = 3)
  gc_frame_end(frame);
  return bool8474;
}
Object meth_ast_isFieldDec8475(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8476 = alloc_Boolean(1);
// compiled identifier node returning bool8476 (depth = 3)
  gc_frame_end(frame);
  return bool8476;
}
Object meth_ast_usesAsType_40_1_41_8477(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8479 = gc_frame_new();
// call case 4: self request
  Object call8480 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8479);
// compiled member node returning call8480 (depth = 4)
  int op_slot_right_8478 = gc_frame_newslot(call8480);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8478 = gc_frame_newslot(*var_aNode);
  params[0] = call8480;
  partcv[0] = 1;
  Object opresult8482 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult8482 (depth = 3)
  gc_frame_end(frame);
  return opresult8482;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_8483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8484 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call8485 = callmethodflags(*var_k, "vardec", 0, partcv, params, 0);
  gc_frame_end(callframe8484);
// compiled member node returning call8485 (depth = 3)
  gc_frame_end(frame);
  return call8485;
}
Object meth_ast__apply_40_1_41_8511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8512 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8513 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8512);
// compiled call node returning call8513 (depth = 6)
  gc_frame_end(frame);
  return call8513;
}
Object meth_ast_accept_40_1_41_from_40_1_41_8486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8488 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8489 = callmethodflags(*var_visitor, "visitVarDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8488);
// compiled call node returning call8489 (depth = 4)
  Object if8487 = done;
  if (istrue(call8489)) {
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8490 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8491 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8490);
// compiled call node returning call8491 (depth = 5)
  *var_newChain = call8491;
  if (call8491 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8492 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8493 = gc_frame_new();
// call case 4: self request
  Object call8494 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8493);
// compiled member node returning call8494 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8495 = callmethodflags(call8494, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8492);
// compiled call node returning call8495 (depth = 4)
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8498 = gc_frame_new();
// call case 4: self request
  Object call8499 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8498);
// compiled member node returning call8499 (depth = 6)
  int op_slot_right_8497 = gc_frame_newslot(call8499);
// starting to compile identifier node (depth = 6)
  Object bool8501 = alloc_Boolean(0);
// compiled identifier node returning bool8501 (depth = 6)
  int op_slot_left_8497 = gc_frame_newslot(bool8501);
  params[0] = call8499;
  partcv[0] = 1;
  Object opresult8502 = callmethod(bool8501, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8502 (depth = 5)
  Object if8496 = done;
  if (istrue(opresult8502)) {
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8503 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8504 = gc_frame_new();
// call case 4: self request
  Object call8505 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8504);
// compiled member node returning call8505 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8506 = callmethodflags(call8505, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8503);
// compiled call node returning call8506 (depth = 5)
    gc_frame_newslot(call8506);
    if8496 = call8506;
  } else {
  }
// compiled if node returning if8496 (depth = 4)
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8507 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8508 = gc_frame_new();
// call case 4: self request
  Object call8509 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8508);
// compiled member node returning call8509 (depth = 5)
  gc_frame_newslot(call8509);
// starting to compile block node (depth = 5)
  Object block8510 = alloc_Block(NULL, NULL, "ast", 2169);
  gc_frame_newslot(block8510);
// method "_apply(_)"
  block_savedest(block8510);
  Object closure8511 = createclosure(3, "_apply(1)");
  setclosureframe(closure8511, stackframe);
  addtoclosure(closure8511, var_visitor);
  addtoclosure(closure8511, var_newChain);
  addtoclosure(closure8511, selfslot);
  struct UserObject *uo8511 = (struct UserObject*)block8510;
  uo8511->data[0] = (Object)closure8511;
  Method *meth_meth_ast__apply_40_1_41_8511 = addmethod2pos(block8510, "_apply(1)", &meth_ast__apply_40_1_41_8511, 0);
  int argcv_meth_ast__apply_40_1_41_8511[] = {1};
  meth_meth_ast__apply_40_1_41_8511->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8511);
  meth_meth_ast__apply_40_1_41_8511->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8511->definitionLine = 2969;
// compiled block node returning block8510 (depth = 5)
  gc_frame_newslot(block8510);
// call case 5: prelude request
  params[0] = call8509;
  params[1] = block8510;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8515 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8507);
// compiled call node returning call8515 (depth = 4)
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8518 = gc_frame_new();
// call case 4: self request
  Object call8519 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8518);
// compiled member node returning call8519 (depth = 6)
  int op_slot_right_8517 = gc_frame_newslot(call8519);
// starting to compile identifier node (depth = 6)
  Object bool8521 = alloc_Boolean(0);
// compiled identifier node returning bool8521 (depth = 6)
  int op_slot_left_8517 = gc_frame_newslot(bool8521);
  params[0] = call8519;
  partcv[0] = 1;
  Object opresult8522 = callmethod(bool8521, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8522 (depth = 5)
  Object if8516 = done;
  if (istrue(opresult8522)) {
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8523 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8524 = gc_frame_new();
// call case 4: self request
  Object call8525 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8524);
// compiled member node returning call8525 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8526 = callmethodflags(call8525, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8523);
// compiled call node returning call8526 (depth = 5)
    gc_frame_newslot(call8526);
    if8516 = call8526;
  } else {
  }
// compiled if node returning if8516 (depth = 4)
    gc_frame_newslot(if8516);
    if8487 = if8516;
  } else {
  }
// compiled if node returning if8487 (depth = 3)
  gc_frame_end(frame);
  return if8487;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_8527(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8528 = gc_frame_new();
// call case 4: self request
  Object call8529 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8528);
// compiled member node returning call8529 (depth = 4)
  *var_n = call8529;
  if (call8529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8530 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8531 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8530);
// compiled call node returning call8531 (depth = 4)
  *var_newChain = call8531;
  if (call8531 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8532 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8533 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8534 = gc_frame_new();
// call case 4: self request
  Object call8535 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8534);
// compiled member node returning call8535 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8536 = callmethodflags(call8535, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8533);
// compiled call node returning call8536 (depth = 4)
  gc_frame_newslot(call8536);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8536;
  partcv[0] = 1;
  Object call8537 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8532);
// compiled call node returning call8537 (depth = 3)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8538 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8539 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8540 = gc_frame_new();
// call case 4: self request
  Object call8541 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8540);
// compiled member node returning call8541 (depth = 5)
  gc_frame_newslot(call8541);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8542 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8543 = gc_frame_new();
// call case 3: self.outer request
  Object call8544 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8543);
// compiled member node returning call8544 (depth = 6)
  Object call8545 = callmethodflags(call8544, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8542);
// compiled member node returning call8545 (depth = 5)
  params[0] = call8541;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8546 = callmethodflags(call8545, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8539);
// compiled call node returning call8546 (depth = 4)
  gc_frame_newslot(call8546);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8546;
  partcv[0] = 1;
  Object call8547 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8538);
// compiled call node returning call8547 (depth = 3)
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8548 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8549 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8550 = gc_frame_new();
// call case 4: self request
  Object call8551 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8550);
// compiled member node returning call8551 (depth = 5)
  gc_frame_newslot(call8551);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8552 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8553 = gc_frame_new();
// call case 3: self.outer request
  Object call8554 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8553);
// compiled member node returning call8554 (depth = 6)
  Object call8555 = callmethodflags(call8554, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8552);
// compiled member node returning call8555 (depth = 5)
  params[0] = call8551;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8556 = callmethodflags(call8555, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8549);
// compiled call node returning call8556 (depth = 4)
  gc_frame_newslot(call8556);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8556;
  partcv[0] = 1;
  Object call8557 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8548);
// compiled call node returning call8557 (depth = 3)
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8558 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8559 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8560 = gc_frame_new();
// call case 4: self request
  Object call8561 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8560);
// compiled member node returning call8561 (depth = 5)
  gc_frame_newslot(call8561);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8562 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8563 = gc_frame_new();
// call case 3: self.outer request
  Object call8564 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8563);
// compiled member node returning call8564 (depth = 6)
  Object call8565 = callmethodflags(call8564, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8562);
// compiled member node returning call8565 (depth = 5)
  params[0] = call8561;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8566 = callmethodflags(call8565, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8559);
// compiled call node returning call8566 (depth = 4)
  gc_frame_newslot(call8566);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8566;
  partcv[0] = 1;
  Object call8567 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8558);
// compiled call node returning call8567 (depth = 3)
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8568 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8569 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8568);
// compiled call node returning call8569 (depth = 3)
  gc_frame_end(frame);
  return call8569;
}
Object meth_ast__apply_40_1_41_8578(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8580 == NULL) {
    strlit8580 = alloc_String("  ");
    gc_root(strlit8580);
  }
// compiled string node returning strlit8580 (depth = 7)
  int op_slot_right_8579 = gc_frame_newslot(strlit8580);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8579 = gc_frame_newslot(*var_spc);
  params[0] = strlit8580;
  partcv[0] = 1;
  Object opresult8582 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8582 (depth = 6)
  *var_spc = opresult8582;
  if (opresult8582 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_8570(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8571 == NULL) {
    strlit8571 = alloc_String("");
    gc_root(strlit8571);
  }
// compiled string node returning strlit8571 (depth = 4)
  *var_spc = strlit8571;
  if (strlit8571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8572 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8573 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8575 = alloc_Float64(0);
// compiled num node returning num8575 (depth = 5)
  int op_slot_left_8573 = gc_frame_newslot(num8575);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8576 = callmethod(num8575, "..(1)", 1, partcv, params);
// compiled op node returning opresult8576 (depth = 4)
  gc_frame_newslot(opresult8576);
// starting to compile block node (depth = 4)
  Object block8577 = alloc_Block(NULL, NULL, "ast", 2188);
  gc_frame_newslot(block8577);
// method "_apply(_)"
  block_savedest(block8577);
  Object closure8578 = createclosure(2, "_apply(1)");
  setclosureframe(closure8578, stackframe);
  addtoclosure(closure8578, var_spc);
  addtoclosure(closure8578, selfslot);
  struct UserObject *uo8578 = (struct UserObject*)block8577;
  uo8578->data[0] = (Object)closure8578;
  Method *meth_meth_ast__apply_40_1_41_8578 = addmethod2pos(block8577, "_apply(1)", &meth_ast__apply_40_1_41_8578, 0);
  int argcv_meth_ast__apply_40_1_41_8578[] = {1};
  meth_meth_ast__apply_40_1_41_8578->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8578);
  meth_meth_ast__apply_40_1_41_8578->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8578->definitionLine = 2969;
// compiled block node returning block8577 (depth = 4)
  gc_frame_newslot(block8577);
// call case 5: prelude request
  params[0] = opresult8576;
  params[1] = block8577;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8585 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8572);
// compiled call node returning call8585 (depth = 3)
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8587 == NULL) {
    strlit8587 = alloc_String("""\x0a""");
    gc_root(strlit8587);
  }
// compiled string node returning strlit8587 (depth = 5)
  int op_slot_right_8586 = gc_frame_newslot(strlit8587);
// starting to compile call node (depth = 5)
  int callframe8589 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8590 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8589);
// compiled call node returning call8590 (depth = 5)
  int op_slot_left_8586 = gc_frame_newslot(call8590);
  params[0] = strlit8587;
  partcv[0] = 1;
  Object opresult8591 = callmethod(call8590, "++(1)", 1, partcv, params);
// compiled op node returning opresult8591 (depth = 4)
  *var_s = opresult8591;
  if (opresult8591 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8593 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8595 = alloc_Float64(1);
// compiled num node returning num8595 (depth = 7)
  int op_slot_right_8594 = gc_frame_newslot(num8595);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8594 = gc_frame_newslot(*var_depth);
  params[0] = num8595;
  partcv[0] = 1;
  Object sum8597 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8597 (depth = 6)
  gc_frame_newslot(sum8597);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8598 = gc_frame_new();
// call case 4: self request
  Object call8599 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8598);
// compiled member node returning call8599 (depth = 6)
  params[0] = sum8597;
  partcv[0] = 1;
  Object call8600 = callmethodflags(call8599, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8593);
// compiled call node returning call8600 (depth = 5)
  int op_slot_right_8592 = gc_frame_newslot(call8600);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8602 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8602 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8604 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8604 (depth = 5)
  int op_slot_left_8592 = gc_frame_newslot(opresult8604);
  params[0] = call8600;
  partcv[0] = 1;
  Object opresult8605 = callmethod(opresult8604, "++(1)", 1, partcv, params);
// compiled op node returning opresult8605 (depth = 4)
  *var_s = opresult8605;
  if (opresult8605 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8609 = gc_frame_new();
// call case 4: self request
  Object call8610 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8609);
// compiled member node returning call8610 (depth = 5)
  int op_slot_right_8608 = gc_frame_newslot(call8610);
// starting to compile identifier node (depth = 5)
  Object bool8612 = alloc_Boolean(0);
// compiled identifier node returning bool8612 (depth = 5)
  int op_slot_left_8608 = gc_frame_newslot(bool8612);
  params[0] = call8610;
  partcv[0] = 1;
  Object opresult8613 = callmethod(bool8612, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8613 (depth = 4)
  Object if8607 = done;
  if (istrue(opresult8613)) {
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8615 == NULL) {
    strlit8615 = alloc_String("Type: ");
    gc_root(strlit8615);
  }
// compiled string node returning strlit8615 (depth = 6)
  int op_slot_right_8614 = gc_frame_newslot(strlit8615);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8617 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8620 == NULL) {
    strlit8620 = alloc_String("""\x0a""");
    gc_root(strlit8620);
  }
// compiled string node returning strlit8620 (depth = 8)
  int op_slot_right_8619 = gc_frame_newslot(strlit8620);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8619 = gc_frame_newslot(*var_s);
  params[0] = strlit8620;
  partcv[0] = 1;
  Object opresult8622 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8622 (depth = 7)
  int op_slot_left_8617 = gc_frame_newslot(opresult8622);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8623 = callmethod(opresult8622, "++(1)", 1, partcv, params);
// compiled op node returning opresult8623 (depth = 6)
  int op_slot_left_8614 = gc_frame_newslot(opresult8623);
  params[0] = strlit8615;
  partcv[0] = 1;
  Object opresult8624 = callmethod(opresult8623, "++(1)", 1, partcv, params);
// compiled op node returning opresult8624 (depth = 5)
  *var_s = opresult8624;
  if (opresult8624 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8627 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8629 = alloc_Float64(2);
// compiled num node returning num8629 (depth = 8)
  int op_slot_right_8628 = gc_frame_newslot(num8629);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8628 = gc_frame_newslot(*var_depth);
  params[0] = num8629;
  partcv[0] = 1;
  Object sum8631 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8631 (depth = 7)
  gc_frame_newslot(sum8631);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8632 = gc_frame_new();
// call case 4: self request
  Object call8633 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8632);
// compiled member node returning call8633 (depth = 7)
  params[0] = sum8631;
  partcv[0] = 1;
  Object call8634 = callmethodflags(call8633, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8627);
// compiled call node returning call8634 (depth = 6)
  int op_slot_right_8626 = gc_frame_newslot(call8634);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8626 = gc_frame_newslot(*var_s);
  params[0] = call8634;
  partcv[0] = 1;
  Object opresult8636 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8636 (depth = 5)
  *var_s = opresult8636;
  if (opresult8636 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8607 = done;
  } else {
  }
// compiled if node returning if8607 (depth = 3)
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8640 = gc_frame_new();
// call case 4: self request
  Object call8641 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8640);
// compiled member node returning call8641 (depth = 5)
  int op_slot_right_8639 = gc_frame_newslot(call8641);
// starting to compile identifier node (depth = 5)
  Object bool8643 = alloc_Boolean(0);
// compiled identifier node returning bool8643 (depth = 5)
  int op_slot_left_8639 = gc_frame_newslot(bool8643);
  params[0] = call8641;
  partcv[0] = 1;
  Object opresult8644 = callmethod(bool8643, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8644 (depth = 4)
  Object if8638 = done;
  if (istrue(opresult8644)) {
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8646 == NULL) {
    strlit8646 = alloc_String("Value: ");
    gc_root(strlit8646);
  }
// compiled string node returning strlit8646 (depth = 6)
  int op_slot_right_8645 = gc_frame_newslot(strlit8646);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8648 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8651 == NULL) {
    strlit8651 = alloc_String("""\x0a""");
    gc_root(strlit8651);
  }
// compiled string node returning strlit8651 (depth = 8)
  int op_slot_right_8650 = gc_frame_newslot(strlit8651);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8650 = gc_frame_newslot(*var_s);
  params[0] = strlit8651;
  partcv[0] = 1;
  Object opresult8653 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8653 (depth = 7)
  int op_slot_left_8648 = gc_frame_newslot(opresult8653);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8654 = callmethod(opresult8653, "++(1)", 1, partcv, params);
// compiled op node returning opresult8654 (depth = 6)
  int op_slot_left_8645 = gc_frame_newslot(opresult8654);
  params[0] = strlit8646;
  partcv[0] = 1;
  Object opresult8655 = callmethod(opresult8654, "++(1)", 1, partcv, params);
// compiled op node returning opresult8655 (depth = 5)
  *var_s = opresult8655;
  if (opresult8655 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8658 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8660 = alloc_Float64(2);
// compiled num node returning num8660 (depth = 8)
  int op_slot_right_8659 = gc_frame_newslot(num8660);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8659 = gc_frame_newslot(*var_depth);
  params[0] = num8660;
  partcv[0] = 1;
  Object sum8662 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8662 (depth = 7)
  gc_frame_newslot(sum8662);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8663 = gc_frame_new();
// call case 4: self request
  Object call8664 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8663);
// compiled member node returning call8664 (depth = 7)
  params[0] = sum8662;
  partcv[0] = 1;
  Object call8665 = callmethodflags(call8664, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8658);
// compiled call node returning call8665 (depth = 6)
  int op_slot_right_8657 = gc_frame_newslot(call8665);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8657 = gc_frame_newslot(*var_s);
  params[0] = call8665;
  partcv[0] = 1;
  Object opresult8667 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8667 (depth = 5)
  *var_s = opresult8667;
  if (opresult8667 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8638 = done;
  } else {
  }
// compiled if node returning if8638 (depth = 3)
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8671 = gc_frame_new();
// call case 4: self request
  Object call8672 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8671);
// compiled member node returning call8672 (depth = 5)
  int op_slot_right_8670 = gc_frame_newslot(call8672);
// starting to compile identifier node (depth = 5)
  Object bool8674 = alloc_Boolean(0);
// compiled identifier node returning bool8674 (depth = 5)
  int op_slot_left_8670 = gc_frame_newslot(bool8674);
  params[0] = call8672;
  partcv[0] = 1;
  Object opresult8675 = callmethod(bool8674, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8675 (depth = 4)
  Object if8669 = done;
  if (istrue(opresult8675)) {
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8677 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8679 = alloc_Float64(2);
// compiled num node returning num8679 (depth = 8)
  int op_slot_right_8678 = gc_frame_newslot(num8679);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8678 = gc_frame_newslot(*var_depth);
  params[0] = num8679;
  partcv[0] = 1;
  Object sum8681 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8681 (depth = 7)
  gc_frame_newslot(sum8681);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8682 = gc_frame_new();
// call case 4: self request
  Object call8683 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8682);
// compiled member node returning call8683 (depth = 7)
  params[0] = sum8681;
  partcv[0] = 1;
  Object call8684 = callmethodflags(call8683, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8677);
// compiled call node returning call8684 (depth = 6)
  int op_slot_right_8676 = gc_frame_newslot(call8684);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8676 = gc_frame_newslot(*var_s);
  params[0] = call8684;
  partcv[0] = 1;
  Object opresult8686 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8686 (depth = 5)
  *var_s = opresult8686;
  if (opresult8686 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8669 = done;
  } else {
  }
// compiled if node returning if8669 (depth = 3)
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8692(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8694 == NULL) {
    strlit8694 = alloc_String("    ");
    gc_root(strlit8694);
  }
// compiled string node returning strlit8694 (depth = 7)
  int op_slot_right_8693 = gc_frame_newslot(strlit8694);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8693 = gc_frame_newslot(*var_spc);
  params[0] = strlit8694;
  partcv[0] = 1;
  Object opresult8696 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8696 (depth = 6)
  *var_spc = opresult8696;
  if (opresult8696 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8716(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8718 == NULL) {
    strlit8718 = alloc_String("Unknown");
    gc_root(strlit8718);
  }
// compiled string node returning strlit8718 (depth = 7)
  int op_slot_right_8717 = gc_frame_newslot(strlit8718);
// starting to compile member node (depth = 7)
  int callframe8720 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8721 = gc_frame_new();
// call case 4: self request
  Object call8722 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8721);
// compiled member node returning call8722 (depth = 8)
  Object call8723 = callmethodflags(call8722, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8720);
// compiled member node returning call8723 (depth = 7)
  int op_slot_left_8717 = gc_frame_newslot(call8723);
  params[0] = strlit8718;
  partcv[0] = 1;
  Object opresult8724 = callmethod(call8723, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8724 (depth = 6)
  gc_frame_end(frame);
  return opresult8724;
}
Object meth_ast__apply_40_2_41_8764(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8766 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8767 = alloc_Float64(0);
// compiled num node returning num8767 (depth = 10)
  gc_frame_newslot(num8767);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8767;
  partcv[0] = 1;
  Object call8768 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8766);
// compiled call node returning call8768 (depth = 9)
  int op_slot_right_8765 = gc_frame_newslot(call8768);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8772 == NULL) {
    strlit8772 = alloc_String("");
    gc_root(strlit8772);
  }
// compiled string node returning strlit8772 (depth = 11)
  int op_slot_right_8771 = gc_frame_newslot(strlit8772);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8771 = gc_frame_newslot(*var_a);
  params[0] = strlit8772;
  partcv[0] = 1;
  Object opresult8774 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8774 (depth = 10)
  Object if8770 = done;
struct StackFrameObject *iftmpstackframe8770 = stackframe;
  if (istrue(opresult8774)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8770);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8776 == NULL) {
    strlit8776 = alloc_String(", ");
    gc_root(strlit8776);
  }
// compiled string node returning strlit8776 (depth = 11)
  int op_slot_right_8775 = gc_frame_newslot(strlit8776);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8775 = gc_frame_newslot(*var_a);
  params[0] = strlit8776;
  partcv[0] = 1;
  Object opresult8778 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult8778 (depth = 10)
    gc_frame_newslot(opresult8778);
    if8770 = opresult8778;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8770);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8779 == NULL) {
    strlit8779 = alloc_String("");
    gc_root(strlit8779);
  }
// compiled string node returning strlit8779 (depth = 10)
    gc_frame_newslot(strlit8779);
    if8770 = strlit8779;
  }
stackframe = iftmpstackframe8770;
// compiled if node returning if8770 (depth = 9)
  int op_slot_left_8765 = gc_frame_newslot(if8770);
  params[0] = call8768;
  partcv[0] = 1;
  Object opresult8780 = callmethod(if8770, "++(1)", 1, partcv, params);
// compiled op node returning opresult8780 (depth = 8)
  gc_frame_end(frame);
  return opresult8780;
}
Object meth_ast_toGrace_40_1_41_8688(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8689 == NULL) {
    strlit8689 = alloc_String("");
    gc_root(strlit8689);
  }
// compiled string node returning strlit8689 (depth = 4)
  *var_spc = strlit8689;
  if (strlit8689 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8690 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block8691 = alloc_Block(NULL, NULL, "ast", 2208);
  gc_frame_newslot(block8691);
// method "_apply"
  block_savedest(block8691);
  Object closure8692 = createclosure(2, "_apply");
  setclosureframe(closure8692, stackframe);
  addtoclosure(closure8692, var_spc);
  addtoclosure(closure8692, selfslot);
  struct UserObject *uo8692 = (struct UserObject*)block8691;
  uo8692->data[0] = (Object)closure8692;
  Method *meth_meth_ast__apply8692 = addmethod2pos(block8691, "_apply", &meth_ast__apply8692, 0);
  int argcv_meth_ast__apply8692[] = {0};
  meth_meth_ast__apply8692->type = alloc_MethodType(1, argcv_meth_ast__apply8692);
  meth_meth_ast__apply8692->definitionModule = modulename;
  meth_meth_ast__apply8692->definitionLine = 2969;
// compiled block node returning block8691 (depth = 4)
  gc_frame_newslot(block8691);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block8691;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8699 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8690);
// compiled call node returning call8699 (depth = 3)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8701 == NULL) {
    strlit8701 = alloc_String("");
    gc_root(strlit8701);
  }
// compiled string node returning strlit8701 (depth = 5)
  int op_slot_right_8700 = gc_frame_newslot(strlit8701);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8704 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8705 = alloc_Float64(0);
// compiled num node returning num8705 (depth = 7)
  gc_frame_newslot(num8705);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8706 = gc_frame_new();
// call case 4: self request
  Object call8707 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8706);
// compiled member node returning call8707 (depth = 7)
  params[0] = num8705;
  partcv[0] = 1;
  Object call8708 = callmethodflags(call8707, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8704);
// compiled call node returning call8708 (depth = 6)
  int op_slot_right_8703 = gc_frame_newslot(call8708);
// starting to compile string node (depth = 6)
  if (strlit8710 == NULL) {
    strlit8710 = alloc_String("var ");
    gc_root(strlit8710);
  }
// compiled string node returning strlit8710 (depth = 6)
  int op_slot_left_8703 = gc_frame_newslot(strlit8710);
  params[0] = call8708;
  partcv[0] = 1;
  Object opresult8711 = callmethod(strlit8710, "++(1)", 1, partcv, params);
// compiled op node returning opresult8711 (depth = 5)
  int op_slot_left_8700 = gc_frame_newslot(opresult8711);
  params[0] = strlit8701;
  partcv[0] = 1;
  Object opresult8712 = callmethod(opresult8711, "++(1)", 1, partcv, params);
// compiled op node returning opresult8712 (depth = 4)
  *var_s = opresult8712;
  if (opresult8712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8715 = alloc_Block(NULL, NULL, "ast", 2212);
  gc_frame_newslot(block8715);
// method "_apply"
  block_savedest(block8715);
  Object closure8716 = createclosure(1, "_apply");
  setclosureframe(closure8716, stackframe);
  addtoclosure(closure8716, selfslot);
  struct UserObject *uo8716 = (struct UserObject*)block8715;
  uo8716->data[0] = (Object)closure8716;
  Method *meth_meth_ast__apply8716 = addmethod2pos(block8715, "_apply", &meth_ast__apply8716, 0);
  int argcv_meth_ast__apply8716[] = {0};
  meth_meth_ast__apply8716->type = alloc_MethodType(1, argcv_meth_ast__apply8716);
  meth_meth_ast__apply8716->definitionModule = modulename;
  meth_meth_ast__apply8716->definitionLine = 2969;
// compiled block node returning block8715 (depth = 5)
  int op_slot_right_8714 = gc_frame_newslot(block8715);
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8728 = gc_frame_new();
// call case 4: self request
  Object call8729 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8728);
// compiled member node returning call8729 (depth = 6)
  int op_slot_right_8727 = gc_frame_newslot(call8729);
// starting to compile identifier node (depth = 6)
  Object bool8731 = alloc_Boolean(0);
// compiled identifier node returning bool8731 (depth = 6)
  int op_slot_left_8727 = gc_frame_newslot(bool8731);
  params[0] = call8729;
  partcv[0] = 1;
  Object opresult8732 = callmethod(bool8731, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8732 (depth = 5)
  int op_slot_left_8714 = gc_frame_newslot(opresult8732);
  params[0] = block8715;
  partcv[0] = 1;
  Object opresult8733 = callmethod(opresult8732, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8733 (depth = 4)
  Object if8713 = done;
  if (istrue(opresult8733)) {
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8735 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8736 = alloc_Float64(0);
// compiled num node returning num8736 (depth = 7)
  gc_frame_newslot(num8736);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8737 = gc_frame_new();
// call case 4: self request
  Object call8738 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8737);
// compiled member node returning call8738 (depth = 7)
  params[0] = num8736;
  partcv[0] = 1;
  Object call8739 = callmethodflags(call8738, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8735);
// compiled call node returning call8739 (depth = 6)
  int op_slot_right_8734 = gc_frame_newslot(call8739);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8742 == NULL) {
    strlit8742 = alloc_String(" : ");
    gc_root(strlit8742);
  }
// compiled string node returning strlit8742 (depth = 7)
  int op_slot_right_8741 = gc_frame_newslot(strlit8742);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8741 = gc_frame_newslot(*var_s);
  params[0] = strlit8742;
  partcv[0] = 1;
  Object opresult8744 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8744 (depth = 6)
  int op_slot_left_8734 = gc_frame_newslot(opresult8744);
  params[0] = call8739;
  partcv[0] = 1;
  Object opresult8745 = callmethod(opresult8744, "++(1)", 1, partcv, params);
// compiled op node returning opresult8745 (depth = 5)
  *var_s = opresult8745;
  if (opresult8745 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8713 = done;
  } else {
  }
// compiled if node returning if8713 (depth = 3)
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8749 = alloc_Float64(0);
// compiled num node returning num8749 (depth = 5)
  int op_slot_right_8748 = gc_frame_newslot(num8749);
// starting to compile member node (depth = 5)
  int callframe8751 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8752 = gc_frame_new();
// call case 4: self request
  Object call8753 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8752);
// compiled member node returning call8753 (depth = 6)
  Object call8754 = callmethodflags(call8753, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8751);
// compiled member node returning call8754 (depth = 5)
  int op_slot_left_8748 = gc_frame_newslot(call8754);
  params[0] = num8749;
  partcv[0] = 1;
  Object opresult8755 = callmethod(call8754, ">(1)", 1, partcv, params);
// compiled op node returning opresult8755 (depth = 4)
  Object if8747 = done;
  if (istrue(opresult8755)) {
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8757 == NULL) {
    strlit8757 = alloc_String(" is ");
    gc_root(strlit8757);
  }
// compiled string node returning strlit8757 (depth = 6)
  int op_slot_right_8756 = gc_frame_newslot(strlit8757);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8756 = gc_frame_newslot(*var_s);
  params[0] = strlit8757;
  partcv[0] = 1;
  Object opresult8759 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8759 (depth = 5)
  *var_s = opresult8759;
  if (opresult8759 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8762 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8763 = alloc_Block(NULL, NULL, "ast", 2218);
  gc_frame_newslot(block8763);
// method "_apply(_,_)"
  block_savedest(block8763);
  Object closure8764 = createclosure(1, "_apply(2)");
  setclosureframe(closure8764, stackframe);
  addtoclosure(closure8764, selfslot);
  struct UserObject *uo8764 = (struct UserObject*)block8763;
  uo8764->data[0] = (Object)closure8764;
  Method *meth_meth_ast__apply_40_2_41_8764 = addmethod2pos(block8763, "_apply(2)", &meth_ast__apply_40_2_41_8764, 0);
  int argcv_meth_ast__apply_40_2_41_8764[] = {2};
  meth_meth_ast__apply_40_2_41_8764->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_8764);
  meth_meth_ast__apply_40_2_41_8764->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_8764->definitionLine = 2969;
// compiled block node returning block8763 (depth = 7)
  gc_frame_newslot(block8763);
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8782 == NULL) {
    strlit8782 = alloc_String("");
    gc_root(strlit8782);
  }
// compiled string node returning strlit8782 (depth = 7)
  gc_frame_newslot(strlit8782);
// call case 6: other requests
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8783 = gc_frame_new();
// call case 4: self request
  Object call8784 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8783);
// compiled member node returning call8784 (depth = 7)
  params[0] = block8763;
  params[1] = strlit8782;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8785 = callmethodflags(call8784, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8762);
// compiled call node returning call8785 (depth = 6)
  int op_slot_right_8761 = gc_frame_newslot(call8785);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8761 = gc_frame_newslot(*var_s);
  params[0] = call8785;
  partcv[0] = 1;
  Object opresult8787 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8787 (depth = 5)
  *var_s = opresult8787;
  if (opresult8787 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8747 = done;
  } else {
  }
// compiled if node returning if8747 (depth = 3)
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8791 = gc_frame_new();
// call case 4: self request
  Object call8792 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8791);
// compiled member node returning call8792 (depth = 5)
  int op_slot_right_8790 = gc_frame_newslot(call8792);
// starting to compile identifier node (depth = 5)
  Object bool8794 = alloc_Boolean(0);
// compiled identifier node returning bool8794 (depth = 5)
  int op_slot_left_8790 = gc_frame_newslot(bool8794);
  params[0] = call8792;
  partcv[0] = 1;
  Object opresult8795 = callmethod(bool8794, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8795 (depth = 4)
  Object if8789 = done;
  if (istrue(opresult8795)) {
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8797 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8798 = gc_frame_new();
// call case 4: self request
  Object call8799 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8798);
// compiled member node returning call8799 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8800 = callmethodflags(call8799, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8797);
// compiled call node returning call8800 (depth = 6)
  int op_slot_right_8796 = gc_frame_newslot(call8800);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8803 == NULL) {
    strlit8803 = alloc_String(" := ");
    gc_root(strlit8803);
  }
// compiled string node returning strlit8803 (depth = 7)
  int op_slot_right_8802 = gc_frame_newslot(strlit8803);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8802 = gc_frame_newslot(*var_s);
  params[0] = strlit8803;
  partcv[0] = 1;
  Object opresult8805 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8805 (depth = 6)
  int op_slot_left_8796 = gc_frame_newslot(opresult8805);
  params[0] = call8800;
  partcv[0] = 1;
  Object opresult8806 = callmethod(opresult8805, "++(1)", 1, partcv, params);
// compiled op node returning opresult8806 (depth = 5)
  *var_s = opresult8806;
  if (opresult8806 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8789 = done;
  } else {
  }
// compiled if node returning if8789 (depth = 3)
// Begin line 2225
  setline(2225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8808(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8809 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8810 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8811 = gc_frame_new();
// call case 4: self request
  Object call8812 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8811);
// compiled member node returning call8812 (depth = 5)
  gc_frame_newslot(call8812);
// starting to compile member node (depth = 5)
  int callframe8813 = gc_frame_new();
// call case 4: self request
  Object call8814 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8813);
// compiled member node returning call8814 (depth = 5)
  gc_frame_newslot(call8814);
// starting to compile member node (depth = 5)
  int callframe8815 = gc_frame_new();
// call case 4: self request
  Object call8816 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8815);
// compiled member node returning call8816 (depth = 5)
  gc_frame_newslot(call8816);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_varDecNode (depth = 5)
  params[0] = call8812;
  params[1] = call8814;
  params[2] = call8816;
  partcv[0] = 3;
  Object call8817 = callmethodflags(*var_varDecNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe8810);
// compiled call node returning call8817 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8818 = callmethodflags(call8817, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8809);
// compiled call node returning call8818 (depth = 3)
  gc_frame_end(frame);
  return call8818;
}
Object meth_ast_statementName8819(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8820 == NULL) {
    strlit8820 = alloc_String("variable declaration");
    gc_root(strlit8820);
  }
// compiled string node returning strlit8820 (depth = 3)
  gc_frame_end(frame);
  return strlit8820;
}
Object meth_ast_new_40_3_41_8379(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8380 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8380 = alloc_userobj2(22,19, objclass8380);
  gc_frame_newslot(obj8380);
if (objclass8380 == NULL) {
  glfree(obj8380->class->name);
  obj8380->class->name = "varDecNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8380, self, 0);
  addmethodreal(obj8380,"outer", &reader_ast_outer_8381);
  Object oldself8380 = self;
  struct StackFrameObject *oldstackframe8380 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8380);
  gc_frame_newslot((Object)stackframe);
  self = obj8380;
  Object *oldselfslot8380 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8380 = (*(struct UserObject *)self).data[0], lowerouter8380 = thisouter8380;
  if (inheritingObject8380) {
    struct UserObject *inho8380 = (struct UserObject *)inheritingObject8380;
    while (inho8380->super != GraceDefaultObject) inho8380 = (struct UserObject *)inho8380->super;
    inho8380->super = obj8380;
    self = inheritingObject8380;
    *selfslot = self;
    lowerouter8380 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8380;
  }
if (objclass8380 == NULL) {
  Method *reader8382 = addmethodrealflags(obj8380, "kind",&reader_ast_kind_8382, MFLAG_DEF);
  reader8382->definitionModule = modulename;
  reader8382->definitionLine = 2129;
}
adddatum2(obj8380, alloc_Undefined(), 1);
if (objclass8380 == NULL) {
  Method *reader8383 = addmethodrealflags(obj8380, "name", &reader_ast_name_8383, 0);
  Method *writer8383 = addmethodrealflags(obj8380, "name:=(1)", &writer_ast_name_8383, 0);
  reader8383->definitionModule = modulename;
  writer8383->definitionModule = modulename;
  reader8383->definitionLine = 2130;
  writer8383->definitionLine = 2130;
}
obj8380->flags |= OFLAG_MUTABLE;
adddatum2(obj8380, alloc_Undefined(), 2);
if (objclass8380 == NULL) {
  Method *reader8384 = addmethodrealflags(obj8380, "value", &reader_ast_value_8384, 0);
  Method *writer8384 = addmethodrealflags(obj8380, "value:=(1)", &writer_ast_value_8384, 0);
  reader8384->definitionModule = modulename;
  writer8384->definitionModule = modulename;
  reader8384->definitionLine = 2131;
  writer8384->definitionLine = 2131;
}
obj8380->flags |= OFLAG_MUTABLE;
adddatum2(obj8380, alloc_Undefined(), 3);
if (objclass8380 == NULL) {
  Method *reader8385 = addmethodrealflags(obj8380, "dtype", &reader_ast_dtype_8385, 0);
  Method *writer8385 = addmethodrealflags(obj8380, "dtype:=(1)", &writer_ast_dtype_8385, 0);
  reader8385->definitionModule = modulename;
  writer8385->definitionModule = modulename;
  reader8385->definitionLine = 2132;
  writer8385->definitionLine = 2132;
}
obj8380->flags |= OFLAG_MUTABLE;
adddatum2(obj8380, alloc_Undefined(), 4);
if (objclass8380 == NULL) {
  Method *reader8386 = addmethodrealflags(obj8380, "nameString",&reader_ast_nameString_8386, MFLAG_DEF);
  reader8386->definitionModule = modulename;
  reader8386->definitionLine = 2133;
}
adddatum2(obj8380, alloc_Undefined(), 5);
if (objclass8380 == NULL) {
  Method *reader8387 = addmethodrealflags(obj8380, "annotations", &reader_ast_annotations_8387, 0);
  Method *writer8387 = addmethodrealflags(obj8380, "annotations:=(1)", &writer_ast_annotations_8387, 0);
  reader8387->definitionModule = modulename;
  writer8387->definitionModule = modulename;
  reader8387->definitionLine = 2134;
  writer8387->definitionLine = 2134;
}
obj8380->flags |= OFLAG_MUTABLE;
adddatum2(obj8380, alloc_Undefined(), 6);
// method "isPublic"
  struct UserObject *uo8388 = (struct UserObject*)obj8380;
  uo8388->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8388 = addmethod2pos(obj8380, "isPublic", &meth_ast_isPublic8388, 7);
  int argcv_meth_ast_isPublic8388[] = {0};
  meth_meth_ast_isPublic8388->type = alloc_MethodType(1, argcv_meth_ast_isPublic8388);
  meth_meth_ast_isPublic8388->definitionModule = modulename;
  meth_meth_ast_isPublic8388->definitionLine = 2136;
// method "isWritable"
  struct UserObject *uo8415 = (struct UserObject*)obj8380;
  uo8415->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8415 = addmethod2pos(obj8380, "isWritable", &meth_ast_isWritable8415, 8);
  int argcv_meth_ast_isWritable8415[] = {0};
  meth_meth_ast_isWritable8415->type = alloc_MethodType(1, argcv_meth_ast_isWritable8415);
  meth_meth_ast_isWritable8415->definitionModule = modulename;
  meth_meth_ast_isWritable8415->definitionLine = 2142;
// method "isReadable"
  struct UserObject *uo8445 = (struct UserObject*)obj8380;
  uo8445->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8445 = addmethod2pos(obj8380, "isReadable", &meth_ast_isReadable8445, 9);
  int argcv_meth_ast_isReadable8445[] = {0};
  meth_meth_ast_isReadable8445->type = alloc_MethodType(1, argcv_meth_ast_isReadable8445);
  meth_meth_ast_isReadable8445->definitionModule = modulename;
  meth_meth_ast_isReadable8445->definitionLine = 2148;
// method "isFieldDec"
  struct UserObject *uo8475 = (struct UserObject*)obj8380;
  uo8475->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8475 = addmethod2pos(obj8380, "isFieldDec", &meth_ast_isFieldDec8475, 10);
  int argcv_meth_ast_isFieldDec8475[] = {0};
  meth_meth_ast_isFieldDec8475->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8475);
  meth_meth_ast_isFieldDec8475->definitionModule = modulename;
  meth_meth_ast_isFieldDec8475->definitionLine = 2154;
// method "usesAsType(_)"
  struct UserObject *uo8477 = (struct UserObject*)obj8380;
  uo8477->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8477 = addmethod2pos(obj8380, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8477, 11);
  int argcv_meth_ast_usesAsType_40_1_41_8477[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8477->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8477);
  meth_meth_ast_usesAsType_40_1_41_8477->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8477->definitionLine = 2156;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8380);
  Object closure8483 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8483, stackframe);
  addtoclosure(closure8483, var_k);
  struct UserObject *uo8483 = (struct UserObject*)obj8380;
  uo8483->data[12] = (Object)closure8483;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8483 = addmethod2pos(obj8380, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8483, 12);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8483[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8483->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8483);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8483->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8483->definitionLine = 2160;
// method "accept(_)from(_)"
  struct UserObject *uo8486 = (struct UserObject*)obj8380;
  uo8486->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8486 = addmethod2pos(obj8380, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8486, 13);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8486[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8486->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8486);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8486->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8486->definitionLine = 2162;
// method "map(_)ancestors(_)"
  struct UserObject *uo8527 = (struct UserObject*)obj8380;
  uo8527->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8527 = addmethod2pos(obj8380, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8527, 14);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8527[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8527->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8527);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8527->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8527->definitionLine = 2177;
// method "pretty(_)"
  struct UserObject *uo8570 = (struct UserObject*)obj8380;
  uo8570->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8570 = addmethod2pos(obj8380, "pretty(1)", &meth_ast_pretty_40_1_41_8570, 15);
  int argcv_meth_ast_pretty_40_1_41_8570[] = {1};
  meth_meth_ast_pretty_40_1_41_8570->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8570);
  meth_meth_ast_pretty_40_1_41_8570->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8570->definitionLine = 2186;
// method "toGrace(_)"
  struct UserObject *uo8688 = (struct UserObject*)obj8380;
  uo8688->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_8688 = addmethod2pos(obj8380, "toGrace(1)", &meth_ast_toGrace_40_1_41_8688, 16);
  int argcv_meth_ast_toGrace_40_1_41_8688[] = {1};
  meth_meth_ast_toGrace_40_1_41_8688->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_8688);
meth_meth_ast_toGrace_40_1_41_8688->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_8688->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_8688->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_8688->definitionLine = 2206;
// method "shallowCopy"
  block_savedest(obj8380);
  Object closure8808 = createclosure(1, "shallowCopy");
  setclosureframe(closure8808, stackframe);
  addtoclosure(closure8808, var_varDecNode);
  struct UserObject *uo8808 = (struct UserObject*)obj8380;
  uo8808->data[17] = (Object)closure8808;
  Method *meth_meth_ast_shallowCopy8808 = addmethod2pos(obj8380, "shallowCopy", &meth_ast_shallowCopy8808, 17);
  int argcv_meth_ast_shallowCopy8808[] = {0};
  meth_meth_ast_shallowCopy8808->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8808);
  meth_meth_ast_shallowCopy8808->definitionModule = modulename;
  meth_meth_ast_shallowCopy8808->definitionLine = 2227;
// method "statementName"
  struct UserObject *uo8819 = (struct UserObject*)obj8380;
  uo8819->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName8819 = addmethod2pos(obj8380, "statementName", &meth_ast_statementName8819, 18);
  int argcv_meth_ast_statementName8819[] = {0};
  meth_meth_ast_statementName8819->type = alloc_MethodType(1, argcv_meth_ast_statementName8819);
  meth_meth_ast_statementName8819->definitionModule = modulename;
  meth_meth_ast_statementName8819->definitionLine = 2230;
  sourceObject = obj8380;
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8821 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8822 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8823 = gc_frame_new();
// call case 3: self.outer request
  Object call8824 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8823);
// compiled member node returning call8824 (depth = 5)
  Object call8825 = callmethodflags(call8824, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8822);
// compiled member node returning call8825 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8826 = callmethodflags(call8825, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8821);
// compiled call node returning call8826 (depth = 3)
  struct UserObject *obj8380_uo = (struct UserObject *)obj8380;
  obj8380_uo->super = call8826;
  sourceObject = obj8380;
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8827 == NULL) {
    strlit8827 = alloc_String("vardec");
    gc_root(strlit8827);
  }
// compiled string node returning strlit8827 (depth = 3)
  adddatum2(obj8380, strlit8827, 1);
  sourceObject = obj8380;
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8380, *var_name_39_, 2);
  sourceObject = obj8380;
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8380, *var_val_39_, 3);
  sourceObject = obj8380;
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8380, *var_dtype_39_, 4);
  sourceObject = obj8380;
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8828 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8829 = gc_frame_new();
// call case 4: self request
  Object call8830 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8829);
// compiled member node returning call8830 (depth = 4)
  Object call8831 = callmethodflags(call8830, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8828);
// compiled member node returning call8831 (depth = 3)
  adddatum2(obj8380, call8831, 5);
  sourceObject = obj8380;
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8832 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8832 (depth = 3)
  adddatum2(obj8380, array8832, 6);
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  objclass8380 = obj8380->class;
  objclass8380->definitionModule = modulename;
  objclass8380->definitionLine = 2127;
  (*(struct UserObject *)self).data[0] = lowerouter8380;
  self = oldself8380;
  selfslot = oldselfslot8380;
  stackframe = oldstackframe8380;
  gc_frame_end(frame);
  return obj8380;
}
Object meth_ast_new_40_3_41_8379_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8380 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8380 = alloc_userobj2(22,19, objclass8380);
  gc_frame_newslot(obj8380);
if (objclass8380 == NULL) {
  glfree(obj8380->class->name);
  obj8380->class->name = "varDecNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8380, self, 0);
  addmethodreal(obj8380,"outer", &reader_ast_outer_8381);
  Object oldself8380 = self;
  struct StackFrameObject *oldstackframe8380 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8380);
  gc_frame_newslot((Object)stackframe);
  self = obj8380;
  Object *oldselfslot8380 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8380 = (*(struct UserObject *)self).data[0], lowerouter8380 = thisouter8380;
  if (inheritingObject8380) {
    struct UserObject *inho8380 = (struct UserObject *)inheritingObject8380;
    while (inho8380->super != GraceDefaultObject) inho8380 = (struct UserObject *)inho8380->super;
    inho8380->super = obj8380;
    self = inheritingObject8380;
    *selfslot = self;
    lowerouter8380 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8380;
  }
if (objclass8380 == NULL) {
  Method *reader8382 = addmethodrealflags(obj8380, "kind",&reader_ast_kind_8382, MFLAG_DEF);
  reader8382->definitionModule = modulename;
  reader8382->definitionLine = 2129;
}
adddatum2(obj8380, alloc_Undefined(), 1);
if (objclass8380 == NULL) {
  Method *reader8383 = addmethodrealflags(obj8380, "name", &reader_ast_name_8383, 0);
  Method *writer8383 = addmethodrealflags(obj8380, "name:=(1)", &writer_ast_name_8383, 0);
  reader8383->definitionModule = modulename;
  writer8383->definitionModule = modulename;
  reader8383->definitionLine = 2130;
  writer8383->definitionLine = 2130;
}
obj8380->flags |= OFLAG_MUTABLE;
adddatum2(obj8380, alloc_Undefined(), 2);
if (objclass8380 == NULL) {
  Method *reader8384 = addmethodrealflags(obj8380, "value", &reader_ast_value_8384, 0);
  Method *writer8384 = addmethodrealflags(obj8380, "value:=(1)", &writer_ast_value_8384, 0);
  reader8384->definitionModule = modulename;
  writer8384->definitionModule = modulename;
  reader8384->definitionLine = 2131;
  writer8384->definitionLine = 2131;
}
obj8380->flags |= OFLAG_MUTABLE;
adddatum2(obj8380, alloc_Undefined(), 3);
if (objclass8380 == NULL) {
  Method *reader8385 = addmethodrealflags(obj8380, "dtype", &reader_ast_dtype_8385, 0);
  Method *writer8385 = addmethodrealflags(obj8380, "dtype:=(1)", &writer_ast_dtype_8385, 0);
  reader8385->definitionModule = modulename;
  writer8385->definitionModule = modulename;
  reader8385->definitionLine = 2132;
  writer8385->definitionLine = 2132;
}
obj8380->flags |= OFLAG_MUTABLE;
adddatum2(obj8380, alloc_Undefined(), 4);
if (objclass8380 == NULL) {
  Method *reader8386 = addmethodrealflags(obj8380, "nameString",&reader_ast_nameString_8386, MFLAG_DEF);
  reader8386->definitionModule = modulename;
  reader8386->definitionLine = 2133;
}
adddatum2(obj8380, alloc_Undefined(), 5);
if (objclass8380 == NULL) {
  Method *reader8387 = addmethodrealflags(obj8380, "annotations", &reader_ast_annotations_8387, 0);
  Method *writer8387 = addmethodrealflags(obj8380, "annotations:=(1)", &writer_ast_annotations_8387, 0);
  reader8387->definitionModule = modulename;
  writer8387->definitionModule = modulename;
  reader8387->definitionLine = 2134;
  writer8387->definitionLine = 2134;
}
obj8380->flags |= OFLAG_MUTABLE;
adddatum2(obj8380, alloc_Undefined(), 6);
// method "isPublic"
  struct UserObject *uo8388 = (struct UserObject*)obj8380;
  uo8388->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8388 = addmethod2pos(obj8380, "isPublic", &meth_ast_isPublic8388, 7);
  int argcv_meth_ast_isPublic8388[] = {0};
  meth_meth_ast_isPublic8388->type = alloc_MethodType(1, argcv_meth_ast_isPublic8388);
  meth_meth_ast_isPublic8388->definitionModule = modulename;
  meth_meth_ast_isPublic8388->definitionLine = 2136;
// method "isWritable"
  struct UserObject *uo8415 = (struct UserObject*)obj8380;
  uo8415->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8415 = addmethod2pos(obj8380, "isWritable", &meth_ast_isWritable8415, 8);
  int argcv_meth_ast_isWritable8415[] = {0};
  meth_meth_ast_isWritable8415->type = alloc_MethodType(1, argcv_meth_ast_isWritable8415);
  meth_meth_ast_isWritable8415->definitionModule = modulename;
  meth_meth_ast_isWritable8415->definitionLine = 2142;
// method "isReadable"
  struct UserObject *uo8445 = (struct UserObject*)obj8380;
  uo8445->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8445 = addmethod2pos(obj8380, "isReadable", &meth_ast_isReadable8445, 9);
  int argcv_meth_ast_isReadable8445[] = {0};
  meth_meth_ast_isReadable8445->type = alloc_MethodType(1, argcv_meth_ast_isReadable8445);
  meth_meth_ast_isReadable8445->definitionModule = modulename;
  meth_meth_ast_isReadable8445->definitionLine = 2148;
// method "isFieldDec"
  struct UserObject *uo8475 = (struct UserObject*)obj8380;
  uo8475->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8475 = addmethod2pos(obj8380, "isFieldDec", &meth_ast_isFieldDec8475, 10);
  int argcv_meth_ast_isFieldDec8475[] = {0};
  meth_meth_ast_isFieldDec8475->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8475);
  meth_meth_ast_isFieldDec8475->definitionModule = modulename;
  meth_meth_ast_isFieldDec8475->definitionLine = 2154;
// method "usesAsType(_)"
  struct UserObject *uo8477 = (struct UserObject*)obj8380;
  uo8477->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8477 = addmethod2pos(obj8380, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8477, 11);
  int argcv_meth_ast_usesAsType_40_1_41_8477[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8477->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8477);
  meth_meth_ast_usesAsType_40_1_41_8477->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8477->definitionLine = 2156;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8380);
  Object closure8483 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8483, stackframe);
  addtoclosure(closure8483, var_k);
  struct UserObject *uo8483 = (struct UserObject*)obj8380;
  uo8483->data[12] = (Object)closure8483;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8483 = addmethod2pos(obj8380, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8483, 12);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8483[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8483->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8483);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8483->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8483->definitionLine = 2160;
// method "accept(_)from(_)"
  struct UserObject *uo8486 = (struct UserObject*)obj8380;
  uo8486->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8486 = addmethod2pos(obj8380, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8486, 13);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8486[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8486->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8486);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8486->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8486->definitionLine = 2162;
// method "map(_)ancestors(_)"
  struct UserObject *uo8527 = (struct UserObject*)obj8380;
  uo8527->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8527 = addmethod2pos(obj8380, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8527, 14);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8527[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8527->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8527);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8527->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8527->definitionLine = 2177;
// method "pretty(_)"
  struct UserObject *uo8570 = (struct UserObject*)obj8380;
  uo8570->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8570 = addmethod2pos(obj8380, "pretty(1)", &meth_ast_pretty_40_1_41_8570, 15);
  int argcv_meth_ast_pretty_40_1_41_8570[] = {1};
  meth_meth_ast_pretty_40_1_41_8570->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8570);
  meth_meth_ast_pretty_40_1_41_8570->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8570->definitionLine = 2186;
// method "toGrace(_)"
  struct UserObject *uo8688 = (struct UserObject*)obj8380;
  uo8688->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_8688 = addmethod2pos(obj8380, "toGrace(1)", &meth_ast_toGrace_40_1_41_8688, 16);
  int argcv_meth_ast_toGrace_40_1_41_8688[] = {1};
  meth_meth_ast_toGrace_40_1_41_8688->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_8688);
meth_meth_ast_toGrace_40_1_41_8688->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_8688->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_8688->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_8688->definitionLine = 2206;
// method "shallowCopy"
  block_savedest(obj8380);
  Object closure8808 = createclosure(1, "shallowCopy");
  setclosureframe(closure8808, stackframe);
  addtoclosure(closure8808, var_varDecNode);
  struct UserObject *uo8808 = (struct UserObject*)obj8380;
  uo8808->data[17] = (Object)closure8808;
  Method *meth_meth_ast_shallowCopy8808 = addmethod2pos(obj8380, "shallowCopy", &meth_ast_shallowCopy8808, 17);
  int argcv_meth_ast_shallowCopy8808[] = {0};
  meth_meth_ast_shallowCopy8808->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8808);
  meth_meth_ast_shallowCopy8808->definitionModule = modulename;
  meth_meth_ast_shallowCopy8808->definitionLine = 2227;
// method "statementName"
  struct UserObject *uo8819 = (struct UserObject*)obj8380;
  uo8819->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName8819 = addmethod2pos(obj8380, "statementName", &meth_ast_statementName8819, 18);
  int argcv_meth_ast_statementName8819[] = {0};
  meth_meth_ast_statementName8819->type = alloc_MethodType(1, argcv_meth_ast_statementName8819);
  meth_meth_ast_statementName8819->definitionModule = modulename;
  meth_meth_ast_statementName8819->definitionLine = 2230;
  sourceObject = obj8380;
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8821 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8822 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8823 = gc_frame_new();
// call case 3: self.outer request
  Object call8824 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8823);
// compiled member node returning call8824 (depth = 5)
  Object call8825 = callmethodflags(call8824, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8822);
// compiled member node returning call8825 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8826 = callmethodflags(call8825, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8821);
// compiled call node returning call8826 (depth = 3)
  struct UserObject *obj8380_uo = (struct UserObject *)obj8380;
  obj8380_uo->super = call8826;
  sourceObject = obj8380;
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8827 == NULL) {
    strlit8827 = alloc_String("vardec");
    gc_root(strlit8827);
  }
// compiled string node returning strlit8827 (depth = 3)
  adddatum2(obj8380, strlit8827, 1);
  sourceObject = obj8380;
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8380, *var_name_39_, 2);
  sourceObject = obj8380;
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8380, *var_val_39_, 3);
  sourceObject = obj8380;
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8380, *var_dtype_39_, 4);
  sourceObject = obj8380;
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8828 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8829 = gc_frame_new();
// call case 4: self request
  Object call8830 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8829);
// compiled member node returning call8830 (depth = 4)
  Object call8831 = callmethodflags(call8830, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8828);
// compiled member node returning call8831 (depth = 3)
  adddatum2(obj8380, call8831, 5);
  sourceObject = obj8380;
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8832 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8832 (depth = 3)
  adddatum2(obj8380, array8832, 6);
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  sourceObject = obj8380;
  objclass8380 = obj8380->class;
  objclass8380->definitionModule = modulename;
  objclass8380->definitionLine = 2127;
  (*(struct UserObject *)self).data[0] = lowerouter8380;
  self = oldself8380;
  selfslot = oldselfslot8380;
  stackframe = oldstackframe8380;
  gc_frame_end(frame);
  return obj8380;
}
Object meth_ast_varDecNode8834(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_varDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_isImport8845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8846 = alloc_Boolean(1);
// compiled identifier node returning bool8846 (depth = 3)
  gc_frame_end(frame);
  return bool8846;
}
Object meth_ast_isExternal8847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8848 = alloc_Boolean(1);
// compiled identifier node returning bool8848 (depth = 3)
  gc_frame_end(frame);
  return bool8848;
}
Object meth_ast_isExecutable8849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8850 = alloc_Boolean(0);
// compiled identifier node returning bool8850 (depth = 3)
  gc_frame_end(frame);
  return bool8850;
}
Object meth_ast_name8851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8852 = gc_frame_new();
// call case 4: self request
  Object call8853 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8852);
// compiled member node returning call8853 (depth = 3)
  gc_frame_end(frame);
  return call8853;
}
Object meth_ast_nameString8854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8855 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8856 = gc_frame_new();
// call case 4: self request
  Object call8857 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8856);
// compiled member node returning call8857 (depth = 4)
  Object call8858 = callmethodflags(call8857, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe8855);
// compiled member node returning call8858 (depth = 3)
  gc_frame_end(frame);
  return call8858;
}
Object meth_ast_isPublic8859(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8862 = alloc_Float64(0);
// compiled num node returning num8862 (depth = 5)
  int op_slot_right_8861 = gc_frame_newslot(num8862);
// starting to compile member node (depth = 5)
  int callframe8864 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8865 = gc_frame_new();
// call case 4: self request
  Object call8866 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8865);
// compiled member node returning call8866 (depth = 6)
  Object call8867 = callmethodflags(call8866, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8864);
// compiled member node returning call8867 (depth = 5)
  int op_slot_left_8861 = gc_frame_newslot(call8867);
  params[0] = num8862;
  partcv[0] = 1;
  Object opresult8868 = callmethod(call8867, "==(1)", 1, partcv, params);
// compiled op node returning opresult8868 (depth = 4)
  Object if8860 = done;
  if (istrue(opresult8868)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8869 = alloc_Boolean(0);
// compiled identifier node returning bool8869 (depth = 5)
  return bool8869;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8860 = undefined;
  } else {
  }
// compiled if node returning if8860 (depth = 3)
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8871 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8872 == NULL) {
    strlit8872 = alloc_String("public");
    gc_root(strlit8872);
  }
// compiled string node returning strlit8872 (depth = 5)
  gc_frame_newslot(strlit8872);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8873 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8874 = gc_frame_new();
// call case 3: self.outer request
  Object call8875 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8874);
// compiled member node returning call8875 (depth = 6)
  Object call8876 = callmethodflags(call8875, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8873);
// compiled member node returning call8876 (depth = 5)
  params[0] = self;
  params[1] = strlit8872;
  partcv[0] = 2;
  Object call8877 = callmethodflags(call8876, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8871);
// compiled call node returning call8877 (depth = 4)
  Object if8870 = done;
  if (istrue(call8877)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8878 = alloc_Boolean(1);
// compiled identifier node returning bool8878 (depth = 5)
  return bool8878;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8870 = undefined;
  } else {
  }
// compiled if node returning if8870 (depth = 3)
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8879 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8880 == NULL) {
    strlit8880 = alloc_String("readable");
    gc_root(strlit8880);
  }
// compiled string node returning strlit8880 (depth = 4)
  gc_frame_newslot(strlit8880);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8881 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8882 = gc_frame_new();
// call case 3: self.outer request
  Object call8883 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8882);
// compiled member node returning call8883 (depth = 5)
  Object call8884 = callmethodflags(call8883, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8881);
// compiled member node returning call8884 (depth = 4)
  params[0] = self;
  params[1] = strlit8880;
  partcv[0] = 2;
  Object call8885 = callmethodflags(call8884, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8879);
// compiled call node returning call8885 (depth = 3)
  gc_frame_end(frame);
  return call8885;
}
Object meth_ast__apply_40_1_41_8892(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8895 == NULL) {
    strlit8895 = alloc_String("/");
    gc_root(strlit8895);
  }
// compiled string node returning strlit8895 (depth = 7)
  int op_slot_right_8894 = gc_frame_newslot(strlit8895);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_8894 = gc_frame_newslot(*var_c);
  params[0] = strlit8895;
  partcv[0] = 1;
  Object opresult8897 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult8897 (depth = 6)
  Object if8893 = done;
  if (istrue(opresult8897)) {
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8898 == NULL) {
    strlit8898 = alloc_String("");
    gc_root(strlit8898);
  }
// compiled string node returning strlit8898 (depth = 7)
  *var_bnm = strlit8898;
  if (strlit8898 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8893 = done;
  } else {
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_8900 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_8900 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult8902 = callmethod(*var_bnm, "++(1)", 1, partcv, params);
// compiled op node returning opresult8902 (depth = 7)
  *var_bnm = opresult8902;
  if (opresult8902 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8893 = done;
  }
// compiled if node returning if8893 (depth = 5)
  gc_frame_end(frame);
  return if8893;
}
Object meth_ast_moduleName8886(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8887 == NULL) {
    strlit8887 = alloc_String("");
    gc_root(strlit8887);
  }
// compiled string node returning strlit8887 (depth = 4)
  *var_bnm = strlit8887;
  if (strlit8887 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8888 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8889 = gc_frame_new();
// call case 4: self request
  Object call8890 = callmethodflags(self, "path", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8889);
// compiled member node returning call8890 (depth = 4)
  gc_frame_newslot(call8890);
// starting to compile block node (depth = 4)
  Object block8891 = alloc_Block(NULL, NULL, "ast", 2255);
  gc_frame_newslot(block8891);
// method "_apply(_)"
  block_savedest(block8891);
  Object closure8892 = createclosure(2, "_apply(1)");
  setclosureframe(closure8892, stackframe);
  addtoclosure(closure8892, var_bnm);
  addtoclosure(closure8892, selfslot);
  struct UserObject *uo8892 = (struct UserObject*)block8891;
  uo8892->data[0] = (Object)closure8892;
  Method *meth_meth_ast__apply_40_1_41_8892 = addmethod2pos(block8891, "_apply(1)", &meth_ast__apply_40_1_41_8892, 0);
  int argcv_meth_ast__apply_40_1_41_8892[] = {1};
  meth_meth_ast__apply_40_1_41_8892->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8892);
  meth_meth_ast__apply_40_1_41_8892->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8892->definitionLine = 2969;
// compiled block node returning block8891 (depth = 4)
  gc_frame_newslot(block8891);
// call case 5: prelude request
  params[0] = call8890;
  params[1] = block8891;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8905 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8888);
// compiled call node returning call8905 (depth = 3)
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_isWritable8906(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8907 = alloc_Boolean(0);
// compiled identifier node returning bool8907 (depth = 3)
  gc_frame_end(frame);
  return bool8907;
}
Object meth_ast_isReadable8908(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8909 = gc_frame_new();
// call case 4: self request
  Object call8910 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8909);
// compiled member node returning call8910 (depth = 3)
  gc_frame_end(frame);
  return call8910;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_8911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8912 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call8913 = callmethodflags(*var_k, "defdec", 0, partcv, params, 0);
  gc_frame_end(callframe8912);
// compiled member node returning call8913 (depth = 3)
  gc_frame_end(frame);
  return call8913;
}
Object meth_ast_usesAsType_40_1_41_8914(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8916 = gc_frame_new();
// call case 4: self request
  Object call8917 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8916);
// compiled member node returning call8917 (depth = 4)
  int op_slot_right_8915 = gc_frame_newslot(call8917);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8915 = gc_frame_newslot(*var_aNode);
  params[0] = call8917;
  partcv[0] = 1;
  Object opresult8919 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult8919 (depth = 3)
  gc_frame_end(frame);
  return opresult8919;
}
Object meth_ast__apply_40_1_41_8930(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8931 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8932 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8931);
// compiled call node returning call8932 (depth = 6)
  gc_frame_end(frame);
  return call8932;
}
Object meth_ast_accept_40_1_41_from_40_1_41_8920(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8922 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8923 = callmethodflags(*var_visitor, "visitImport(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8922);
// compiled call node returning call8923 (depth = 4)
  Object if8921 = done;
  if (istrue(call8923)) {
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8924 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8925 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8924);
// compiled call node returning call8925 (depth = 5)
  *var_newChain = call8925;
  if (call8925 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2273
  setline(2273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8926 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8927 = gc_frame_new();
// call case 4: self request
  Object call8928 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8927);
// compiled member node returning call8928 (depth = 5)
  gc_frame_newslot(call8928);
// starting to compile block node (depth = 5)
  Object block8929 = alloc_Block(NULL, NULL, "ast", 2273);
  gc_frame_newslot(block8929);
// method "_apply(_)"
  block_savedest(block8929);
  Object closure8930 = createclosure(3, "_apply(1)");
  setclosureframe(closure8930, stackframe);
  addtoclosure(closure8930, var_visitor);
  addtoclosure(closure8930, var_newChain);
  addtoclosure(closure8930, selfslot);
  struct UserObject *uo8930 = (struct UserObject*)block8929;
  uo8930->data[0] = (Object)closure8930;
  Method *meth_meth_ast__apply_40_1_41_8930 = addmethod2pos(block8929, "_apply(1)", &meth_ast__apply_40_1_41_8930, 0);
  int argcv_meth_ast__apply_40_1_41_8930[] = {1};
  meth_meth_ast__apply_40_1_41_8930->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8930);
  meth_meth_ast__apply_40_1_41_8930->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8930->definitionLine = 2969;
// compiled block node returning block8929 (depth = 5)
  gc_frame_newslot(block8929);
// call case 5: prelude request
  params[0] = call8928;
  params[1] = block8929;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8934 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8926);
// compiled call node returning call8934 (depth = 4)
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8935 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8936 = gc_frame_new();
// call case 4: self request
  Object call8937 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8936);
// compiled member node returning call8937 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8938 = callmethodflags(call8937, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8935);
// compiled call node returning call8938 (depth = 4)
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8941 = gc_frame_new();
// call case 4: self request
  Object call8942 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8941);
// compiled member node returning call8942 (depth = 6)
  int op_slot_right_8940 = gc_frame_newslot(call8942);
// starting to compile identifier node (depth = 6)
  Object bool8944 = alloc_Boolean(0);
// compiled identifier node returning bool8944 (depth = 6)
  int op_slot_left_8940 = gc_frame_newslot(bool8944);
  params[0] = call8942;
  partcv[0] = 1;
  Object opresult8945 = callmethod(bool8944, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8945 (depth = 5)
  Object if8939 = done;
  if (istrue(opresult8945)) {
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8946 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8947 = gc_frame_new();
// call case 4: self request
  Object call8948 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8947);
// compiled member node returning call8948 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8949 = callmethodflags(call8948, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8946);
// compiled call node returning call8949 (depth = 5)
    gc_frame_newslot(call8949);
    if8939 = call8949;
  } else {
  }
// compiled if node returning if8939 (depth = 4)
    gc_frame_newslot(if8939);
    if8921 = if8939;
  } else {
  }
// compiled if node returning if8921 (depth = 3)
  gc_frame_end(frame);
  return if8921;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_8950(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8951 = gc_frame_new();
// call case 4: self request
  Object call8952 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8951);
// compiled member node returning call8952 (depth = 4)
  *var_n = call8952;
  if (call8952 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8953 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8954 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8953);
// compiled call node returning call8954 (depth = 4)
  *var_newChain = call8954;
  if (call8954 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8955 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8956 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8957 = gc_frame_new();
// call case 4: self request
  Object call8958 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8957);
// compiled member node returning call8958 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8959 = callmethodflags(call8958, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8956);
// compiled call node returning call8959 (depth = 4)
  gc_frame_newslot(call8959);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8959;
  partcv[0] = 1;
  Object call8960 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8955);
// compiled call node returning call8960 (depth = 3)
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8961 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8962 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8963 = gc_frame_new();
// call case 4: self request
  Object call8964 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8963);
// compiled member node returning call8964 (depth = 5)
  gc_frame_newslot(call8964);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8965 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8966 = gc_frame_new();
// call case 3: self.outer request
  Object call8967 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8966);
// compiled member node returning call8967 (depth = 6)
  Object call8968 = callmethodflags(call8967, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8965);
// compiled member node returning call8968 (depth = 5)
  params[0] = call8964;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8969 = callmethodflags(call8968, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8962);
// compiled call node returning call8969 (depth = 4)
  gc_frame_newslot(call8969);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8969;
  partcv[0] = 1;
  Object call8970 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8961);
// compiled call node returning call8970 (depth = 3)
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8971 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8972 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8973 = gc_frame_new();
// call case 4: self request
  Object call8974 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8973);
// compiled member node returning call8974 (depth = 5)
  gc_frame_newslot(call8974);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8975 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8976 = gc_frame_new();
// call case 3: self.outer request
  Object call8977 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8976);
// compiled member node returning call8977 (depth = 6)
  Object call8978 = callmethodflags(call8977, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8975);
// compiled member node returning call8978 (depth = 5)
  params[0] = call8974;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8979 = callmethodflags(call8978, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8972);
// compiled call node returning call8979 (depth = 4)
  gc_frame_newslot(call8979);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8979;
  partcv[0] = 1;
  Object call8980 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8971);
// compiled call node returning call8980 (depth = 3)
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8981 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8982 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8981);
// compiled call node returning call8982 (depth = 3)
  gc_frame_end(frame);
  return call8982;
}
Object meth_ast__apply_40_1_41_8991(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8993 == NULL) {
    strlit8993 = alloc_String("  ");
    gc_root(strlit8993);
  }
// compiled string node returning strlit8993 (depth = 7)
  int op_slot_right_8992 = gc_frame_newslot(strlit8993);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8992 = gc_frame_newslot(*var_spc);
  params[0] = strlit8993;
  partcv[0] = 1;
  Object opresult8995 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8995 (depth = 6)
  *var_spc = opresult8995;
  if (opresult8995 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_8983(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8984 == NULL) {
    strlit8984 = alloc_String("");
    gc_root(strlit8984);
  }
// compiled string node returning strlit8984 (depth = 4)
  *var_spc = strlit8984;
  if (strlit8984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8985 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8986 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8988 = alloc_Float64(0);
// compiled num node returning num8988 (depth = 5)
  int op_slot_left_8986 = gc_frame_newslot(num8988);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8989 = callmethod(num8988, "..(1)", 1, partcv, params);
// compiled op node returning opresult8989 (depth = 4)
  gc_frame_newslot(opresult8989);
// starting to compile block node (depth = 4)
  Object block8990 = alloc_Block(NULL, NULL, "ast", 2292);
  gc_frame_newslot(block8990);
// method "_apply(_)"
  block_savedest(block8990);
  Object closure8991 = createclosure(2, "_apply(1)");
  setclosureframe(closure8991, stackframe);
  addtoclosure(closure8991, var_spc);
  addtoclosure(closure8991, selfslot);
  struct UserObject *uo8991 = (struct UserObject*)block8990;
  uo8991->data[0] = (Object)closure8991;
  Method *meth_meth_ast__apply_40_1_41_8991 = addmethod2pos(block8990, "_apply(1)", &meth_ast__apply_40_1_41_8991, 0);
  int argcv_meth_ast__apply_40_1_41_8991[] = {1};
  meth_meth_ast__apply_40_1_41_8991->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8991);
  meth_meth_ast__apply_40_1_41_8991->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8991->definitionLine = 2969;
// compiled block node returning block8990 (depth = 4)
  gc_frame_newslot(block8990);
// call case 5: prelude request
  params[0] = opresult8989;
  params[1] = block8990;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8998 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8985);
// compiled call node returning call8998 (depth = 3)
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9000 == NULL) {
    strlit9000 = alloc_String("""\x0a""");
    gc_root(strlit9000);
  }
// compiled string node returning strlit9000 (depth = 5)
  int op_slot_right_8999 = gc_frame_newslot(strlit9000);
// starting to compile call node (depth = 5)
  int callframe9002 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9003 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9002);
// compiled call node returning call9003 (depth = 5)
  int op_slot_left_8999 = gc_frame_newslot(call9003);
  params[0] = strlit9000;
  partcv[0] = 1;
  Object opresult9004 = callmethod(call9003, "++(1)", 1, partcv, params);
// compiled op node returning opresult9004 (depth = 4)
  *var_s = opresult9004;
  if (opresult9004 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9007 == NULL) {
    strlit9007 = alloc_String("""\x0a""");
    gc_root(strlit9007);
  }
// compiled string node returning strlit9007 (depth = 6)
  int op_slot_right_9006 = gc_frame_newslot(strlit9007);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9010 = gc_frame_new();
// call case 4: self request
  Object call9011 = callmethodflags(self, "path", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9010);
// compiled member node returning call9011 (depth = 7)
  int op_slot_right_9009 = gc_frame_newslot(call9011);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9014 == NULL) {
    strlit9014 = alloc_String("Path: ");
    gc_root(strlit9014);
  }
// compiled string node returning strlit9014 (depth = 8)
  int op_slot_right_9013 = gc_frame_newslot(strlit9014);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9016 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9018 == NULL) {
    strlit9018 = alloc_String("");
    gc_root(strlit9018);
  }
// compiled string node returning strlit9018 (depth = 9)
  int op_slot_left_9016 = gc_frame_newslot(strlit9018);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9019 = callmethod(strlit9018, "++(1)", 1, partcv, params);
// compiled op node returning opresult9019 (depth = 8)
  int op_slot_left_9013 = gc_frame_newslot(opresult9019);
  params[0] = strlit9014;
  partcv[0] = 1;
  Object opresult9020 = callmethod(opresult9019, "++(1)", 1, partcv, params);
// compiled op node returning opresult9020 (depth = 7)
  int op_slot_left_9009 = gc_frame_newslot(opresult9020);
  params[0] = call9011;
  partcv[0] = 1;
  Object opresult9021 = callmethod(opresult9020, "++(1)", 1, partcv, params);
// compiled op node returning opresult9021 (depth = 6)
  int op_slot_left_9006 = gc_frame_newslot(opresult9021);
  params[0] = strlit9007;
  partcv[0] = 1;
  Object opresult9022 = callmethod(opresult9021, "++(1)", 1, partcv, params);
// compiled op node returning opresult9022 (depth = 5)
  int op_slot_right_9005 = gc_frame_newslot(opresult9022);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9005 = gc_frame_newslot(*var_s);
  params[0] = opresult9022;
  partcv[0] = 1;
  Object opresult9024 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9024 (depth = 4)
  *var_s = opresult9024;
  if (opresult9024 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9028 == NULL) {
    strlit9028 = alloc_String("""\x0a""");
    gc_root(strlit9028);
  }
// compiled string node returning strlit9028 (depth = 6)
  int op_slot_right_9027 = gc_frame_newslot(strlit9028);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9031 = gc_frame_new();
// call case 4: self request
  Object call9032 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9031);
// compiled member node returning call9032 (depth = 7)
  int op_slot_right_9030 = gc_frame_newslot(call9032);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9035 == NULL) {
    strlit9035 = alloc_String("Identifier: ");
    gc_root(strlit9035);
  }
// compiled string node returning strlit9035 (depth = 8)
  int op_slot_right_9034 = gc_frame_newslot(strlit9035);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9037 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9039 == NULL) {
    strlit9039 = alloc_String("");
    gc_root(strlit9039);
  }
// compiled string node returning strlit9039 (depth = 9)
  int op_slot_left_9037 = gc_frame_newslot(strlit9039);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9040 = callmethod(strlit9039, "++(1)", 1, partcv, params);
// compiled op node returning opresult9040 (depth = 8)
  int op_slot_left_9034 = gc_frame_newslot(opresult9040);
  params[0] = strlit9035;
  partcv[0] = 1;
  Object opresult9041 = callmethod(opresult9040, "++(1)", 1, partcv, params);
// compiled op node returning opresult9041 (depth = 7)
  int op_slot_left_9030 = gc_frame_newslot(opresult9041);
  params[0] = call9032;
  partcv[0] = 1;
  Object opresult9042 = callmethod(opresult9041, "++(1)", 1, partcv, params);
// compiled op node returning opresult9042 (depth = 6)
  int op_slot_left_9027 = gc_frame_newslot(opresult9042);
  params[0] = strlit9028;
  partcv[0] = 1;
  Object opresult9043 = callmethod(opresult9042, "++(1)", 1, partcv, params);
// compiled op node returning opresult9043 (depth = 5)
  int op_slot_right_9026 = gc_frame_newslot(opresult9043);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9026 = gc_frame_newslot(*var_s);
  params[0] = opresult9043;
  partcv[0] = 1;
  Object opresult9045 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9045 (depth = 4)
  *var_s = opresult9045;
  if (opresult9045 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9049 = alloc_Float64(0);
// compiled num node returning num9049 (depth = 5)
  int op_slot_right_9048 = gc_frame_newslot(num9049);
// starting to compile member node (depth = 5)
  int callframe9051 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9052 = gc_frame_new();
// call case 4: self request
  Object call9053 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9052);
// compiled member node returning call9053 (depth = 6)
  Object call9054 = callmethodflags(call9053, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9051);
// compiled member node returning call9054 (depth = 5)
  int op_slot_left_9048 = gc_frame_newslot(call9054);
  params[0] = num9049;
  partcv[0] = 1;
  Object opresult9055 = callmethod(call9054, ">(1)", 1, partcv, params);
// compiled op node returning opresult9055 (depth = 4)
  Object if9047 = done;
  if (istrue(opresult9055)) {
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9058 == NULL) {
    strlit9058 = alloc_String("""\x0a""");
    gc_root(strlit9058);
  }
// compiled string node returning strlit9058 (depth = 7)
  int op_slot_right_9057 = gc_frame_newslot(strlit9058);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9061 = gc_frame_new();
// call case 4: self request
  Object call9062 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9061);
// compiled member node returning call9062 (depth = 8)
  int op_slot_right_9060 = gc_frame_newslot(call9062);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9065 == NULL) {
    strlit9065 = alloc_String("Anotations: ");
    gc_root(strlit9065);
  }
// compiled string node returning strlit9065 (depth = 9)
  int op_slot_right_9064 = gc_frame_newslot(strlit9065);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9067 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9069 == NULL) {
    strlit9069 = alloc_String("");
    gc_root(strlit9069);
  }
// compiled string node returning strlit9069 (depth = 10)
  int op_slot_left_9067 = gc_frame_newslot(strlit9069);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9070 = callmethod(strlit9069, "++(1)", 1, partcv, params);
// compiled op node returning opresult9070 (depth = 9)
  int op_slot_left_9064 = gc_frame_newslot(opresult9070);
  params[0] = strlit9065;
  partcv[0] = 1;
  Object opresult9071 = callmethod(opresult9070, "++(1)", 1, partcv, params);
// compiled op node returning opresult9071 (depth = 8)
  int op_slot_left_9060 = gc_frame_newslot(opresult9071);
  params[0] = call9062;
  partcv[0] = 1;
  Object opresult9072 = callmethod(opresult9071, "++(1)", 1, partcv, params);
// compiled op node returning opresult9072 (depth = 7)
  int op_slot_left_9057 = gc_frame_newslot(opresult9072);
  params[0] = strlit9058;
  partcv[0] = 1;
  Object opresult9073 = callmethod(opresult9072, "++(1)", 1, partcv, params);
// compiled op node returning opresult9073 (depth = 6)
  int op_slot_right_9056 = gc_frame_newslot(opresult9073);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9056 = gc_frame_newslot(*var_s);
  params[0] = opresult9073;
  partcv[0] = 1;
  Object opresult9075 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9075 (depth = 5)
  *var_s = opresult9075;
  if (opresult9075 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9047 = done;
  } else {
  }
// compiled if node returning if9047 (depth = 3)
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace_40_1_41_9077(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9079 == NULL) {
    strlit9079 = alloc_String("");
    gc_root(strlit9079);
  }
// compiled string node returning strlit9079 (depth = 4)
  int op_slot_right_9078 = gc_frame_newslot(strlit9079);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9082 = gc_frame_new();
// call case 4: self request
  Object call9083 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9082);
// compiled member node returning call9083 (depth = 5)
  int op_slot_right_9081 = gc_frame_newslot(call9083);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9086 == NULL) {
    strlit9086 = alloc_String("""\x22"" as ");
    gc_root(strlit9086);
  }
// compiled string node returning strlit9086 (depth = 6)
  int op_slot_right_9085 = gc_frame_newslot(strlit9086);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9089 = gc_frame_new();
// call case 4: self request
  Object call9090 = callmethodflags(self, "path", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9089);
// compiled member node returning call9090 (depth = 7)
  int op_slot_right_9088 = gc_frame_newslot(call9090);
// starting to compile string node (depth = 7)
  if (strlit9092 == NULL) {
    strlit9092 = alloc_String("import ""\x22""");
    gc_root(strlit9092);
  }
// compiled string node returning strlit9092 (depth = 7)
  int op_slot_left_9088 = gc_frame_newslot(strlit9092);
  params[0] = call9090;
  partcv[0] = 1;
  Object opresult9093 = callmethod(strlit9092, "++(1)", 1, partcv, params);
// compiled op node returning opresult9093 (depth = 6)
  int op_slot_left_9085 = gc_frame_newslot(opresult9093);
  params[0] = strlit9086;
  partcv[0] = 1;
  Object opresult9094 = callmethod(opresult9093, "++(1)", 1, partcv, params);
// compiled op node returning opresult9094 (depth = 5)
  int op_slot_left_9081 = gc_frame_newslot(opresult9094);
  params[0] = call9083;
  partcv[0] = 1;
  Object opresult9095 = callmethod(opresult9094, "++(1)", 1, partcv, params);
// compiled op node returning opresult9095 (depth = 4)
  int op_slot_left_9078 = gc_frame_newslot(opresult9095);
  params[0] = strlit9079;
  partcv[0] = 1;
  Object opresult9096 = callmethod(opresult9095, "++(1)", 1, partcv, params);
// compiled op node returning opresult9096 (depth = 3)
  gc_frame_end(frame);
  return opresult9096;
}
Object meth_ast_shallowCopy9097(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9098 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9099 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9100 = gc_frame_new();
// call case 4: self request
  Object call9101 = callmethodflags(self, "path", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9100);
// compiled member node returning call9101 (depth = 5)
  gc_frame_newslot(call9101);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
  Object bool9102 = alloc_Boolean(0);
// compiled identifier node returning bool9102 (depth = 5)
  gc_frame_newslot(bool9102);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_importNode (depth = 5)
  params[0] = call9101;
  params[1] = *var_nullNode;
  params[2] = bool9102;
  partcv[0] = 3;
  Object call9103 = callmethodflags(*var_importNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe9099);
// compiled call node returning call9103 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9104 = callmethodflags(call9103, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9098);
// compiled call node returning call9104 (depth = 3)
  gc_frame_end(frame);
  return call9104;
}
Object meth_ast_new_40_3_41_8837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8838 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8838 = alloc_userobj2(25,22, objclass8838);
  gc_frame_newslot(obj8838);
if (objclass8838 == NULL) {
  glfree(obj8838->class->name);
  obj8838->class->name = "importNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8838, self, 0);
  addmethodreal(obj8838,"outer", &reader_ast_outer_8839);
  Object oldself8838 = self;
  struct StackFrameObject *oldstackframe8838 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8838);
  gc_frame_newslot((Object)stackframe);
  self = obj8838;
  Object *oldselfslot8838 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8838 = (*(struct UserObject *)self).data[0], lowerouter8838 = thisouter8838;
  if (inheritingObject8838) {
    struct UserObject *inho8838 = (struct UserObject *)inheritingObject8838;
    while (inho8838->super != GraceDefaultObject) inho8838 = (struct UserObject *)inho8838->super;
    inho8838->super = obj8838;
    self = inheritingObject8838;
    *selfslot = self;
    lowerouter8838 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8838;
  }
if (objclass8838 == NULL) {
  Method *reader8840 = addmethodrealflags(obj8838, "kind",&reader_ast_kind_8840, MFLAG_DEF);
  reader8840->definitionModule = modulename;
  reader8840->definitionLine = 2237;
}
adddatum2(obj8838, alloc_Undefined(), 1);
if (objclass8838 == NULL) {
  Method *reader8841 = addmethodrealflags(obj8838, "value", &reader_ast_value_8841, 0);
  Method *writer8841 = addmethodrealflags(obj8838, "value:=(1)", &writer_ast_value_8841, 0);
  reader8841->definitionModule = modulename;
  writer8841->definitionModule = modulename;
  reader8841->definitionLine = 2238;
  writer8841->definitionLine = 2238;
}
obj8838->flags |= OFLAG_MUTABLE;
adddatum2(obj8838, alloc_Undefined(), 2);
if (objclass8838 == NULL) {
  Method *reader8842 = addmethodrealflags(obj8838, "path", &reader_ast_path_8842, 0);
  Method *writer8842 = addmethodrealflags(obj8838, "path:=(1)", &writer_ast_path_8842, 0);
  reader8842->definitionModule = modulename;
  writer8842->definitionModule = modulename;
  reader8842->definitionLine = 2239;
  writer8842->definitionLine = 2239;
}
obj8838->flags |= OFLAG_MUTABLE;
adddatum2(obj8838, alloc_Undefined(), 3);
if (objclass8838 == NULL) {
  Method *reader8843 = addmethodrealflags(obj8838, "annotations", &reader_ast_annotations_8843, 0);
  Method *writer8843 = addmethodrealflags(obj8838, "annotations:=(1)", &writer_ast_annotations_8843, 0);
  reader8843->definitionModule = modulename;
  writer8843->definitionModule = modulename;
  reader8843->definitionLine = 2240;
  writer8843->definitionLine = 2240;
}
obj8838->flags |= OFLAG_MUTABLE;
adddatum2(obj8838, alloc_Undefined(), 4);
if (objclass8838 == NULL) {
  Method *reader8844 = addmethodrealflags(obj8838, "dtype", &reader_ast_dtype_8844, 0);
  Method *writer8844 = addmethodrealflags(obj8838, "dtype:=(1)", &writer_ast_dtype_8844, 0);
  reader8844->definitionModule = modulename;
  writer8844->definitionModule = modulename;
  reader8844->definitionLine = 2241;
  writer8844->definitionLine = 2241;
}
obj8838->flags |= OFLAG_MUTABLE;
adddatum2(obj8838, alloc_Undefined(), 5);
// method "isImport"
  struct UserObject *uo8845 = (struct UserObject*)obj8838;
  uo8845->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport8845 = addmethod2pos(obj8838, "isImport", &meth_ast_isImport8845, 6);
  int argcv_meth_ast_isImport8845[] = {0};
  meth_meth_ast_isImport8845->type = alloc_MethodType(1, argcv_meth_ast_isImport8845);
  meth_meth_ast_isImport8845->definitionModule = modulename;
  meth_meth_ast_isImport8845->definitionLine = 2242;
// method "isExternal"
  struct UserObject *uo8847 = (struct UserObject*)obj8838;
  uo8847->data[7] = emptyclosure;
  Method *meth_meth_ast_isExternal8847 = addmethod2pos(obj8838, "isExternal", &meth_ast_isExternal8847, 7);
  int argcv_meth_ast_isExternal8847[] = {0};
  meth_meth_ast_isExternal8847->type = alloc_MethodType(1, argcv_meth_ast_isExternal8847);
  meth_meth_ast_isExternal8847->definitionModule = modulename;
  meth_meth_ast_isExternal8847->definitionLine = 2243;
// method "isExecutable"
  struct UserObject *uo8849 = (struct UserObject*)obj8838;
  uo8849->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable8849 = addmethod2pos(obj8838, "isExecutable", &meth_ast_isExecutable8849, 8);
  int argcv_meth_ast_isExecutable8849[] = {0};
  meth_meth_ast_isExecutable8849->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8849);
  meth_meth_ast_isExecutable8849->definitionModule = modulename;
  meth_meth_ast_isExecutable8849->definitionLine = 2244;
// method "name"
  struct UserObject *uo8851 = (struct UserObject*)obj8838;
  uo8851->data[9] = emptyclosure;
  Method *meth_meth_ast_name8851 = addmethod2pos(obj8838, "name", &meth_ast_name8851, 9);
  int argcv_meth_ast_name8851[] = {0};
  meth_meth_ast_name8851->type = alloc_MethodType(1, argcv_meth_ast_name8851);
  meth_meth_ast_name8851->definitionModule = modulename;
  meth_meth_ast_name8851->definitionLine = 2245;
// method "nameString"
  struct UserObject *uo8854 = (struct UserObject*)obj8838;
  uo8854->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString8854 = addmethod2pos(obj8838, "nameString", &meth_ast_nameString8854, 10);
  int argcv_meth_ast_nameString8854[] = {0};
  meth_meth_ast_nameString8854->type = alloc_MethodType(1, argcv_meth_ast_nameString8854);
  meth_meth_ast_nameString8854->definitionModule = modulename;
  meth_meth_ast_nameString8854->definitionLine = 2246;
// method "isPublic"
  struct UserObject *uo8859 = (struct UserObject*)obj8838;
  uo8859->data[11] = emptyclosure;
  Method *meth_meth_ast_isPublic8859 = addmethod2pos(obj8838, "isPublic", &meth_ast_isPublic8859, 11);
  int argcv_meth_ast_isPublic8859[] = {0};
  meth_meth_ast_isPublic8859->type = alloc_MethodType(1, argcv_meth_ast_isPublic8859);
  meth_meth_ast_isPublic8859->definitionModule = modulename;
  meth_meth_ast_isPublic8859->definitionLine = 2247;
// method "moduleName"
  struct UserObject *uo8886 = (struct UserObject*)obj8838;
  uo8886->data[12] = emptyclosure;
  Method *meth_meth_ast_moduleName8886 = addmethod2pos(obj8838, "moduleName", &meth_ast_moduleName8886, 12);
  int argcv_meth_ast_moduleName8886[] = {0};
  meth_meth_ast_moduleName8886->type = alloc_MethodType(1, argcv_meth_ast_moduleName8886);
  meth_meth_ast_moduleName8886->definitionModule = modulename;
  meth_meth_ast_moduleName8886->definitionLine = 2253;
// method "isWritable"
  struct UserObject *uo8906 = (struct UserObject*)obj8838;
  uo8906->data[13] = emptyclosure;
  Method *meth_meth_ast_isWritable8906 = addmethod2pos(obj8838, "isWritable", &meth_ast_isWritable8906, 13);
  int argcv_meth_ast_isWritable8906[] = {0};
  meth_meth_ast_isWritable8906->type = alloc_MethodType(1, argcv_meth_ast_isWritable8906);
  meth_meth_ast_isWritable8906->definitionModule = modulename;
  meth_meth_ast_isWritable8906->definitionLine = 2264;
// method "isReadable"
  struct UserObject *uo8908 = (struct UserObject*)obj8838;
  uo8908->data[14] = emptyclosure;
  Method *meth_meth_ast_isReadable8908 = addmethod2pos(obj8838, "isReadable", &meth_ast_isReadable8908, 14);
  int argcv_meth_ast_isReadable8908[] = {0};
  meth_meth_ast_isReadable8908->type = alloc_MethodType(1, argcv_meth_ast_isReadable8908);
  meth_meth_ast_isReadable8908->definitionModule = modulename;
  meth_meth_ast_isReadable8908->definitionLine = 2265;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8838);
  Object closure8911 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8911, stackframe);
  addtoclosure(closure8911, var_k);
  struct UserObject *uo8911 = (struct UserObject*)obj8838;
  uo8911->data[15] = (Object)closure8911;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8911 = addmethod2pos(obj8838, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8911, 15);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8911[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8911->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8911);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8911->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8911->definitionLine = 2266;
// method "usesAsType(_)"
  struct UserObject *uo8914 = (struct UserObject*)obj8838;
  uo8914->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8914 = addmethod2pos(obj8838, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8914, 16);
  int argcv_meth_ast_usesAsType_40_1_41_8914[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8914->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8914);
  meth_meth_ast_usesAsType_40_1_41_8914->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8914->definitionLine = 2267;
// method "accept(_)from(_)"
  struct UserObject *uo8920 = (struct UserObject*)obj8838;
  uo8920->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8920 = addmethod2pos(obj8838, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8920, 17);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8920[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8920->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8920);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8920->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8920->definitionLine = 2270;
// method "map(_)ancestors(_)"
  struct UserObject *uo8950 = (struct UserObject*)obj8838;
  uo8950->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8950 = addmethod2pos(obj8838, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8950, 18);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8950[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8950->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8950);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8950->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8950->definitionLine = 2282;
// method "pretty(_)"
  struct UserObject *uo8983 = (struct UserObject*)obj8838;
  uo8983->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8983 = addmethod2pos(obj8838, "pretty(1)", &meth_ast_pretty_40_1_41_8983, 19);
  int argcv_meth_ast_pretty_40_1_41_8983[] = {1};
  meth_meth_ast_pretty_40_1_41_8983->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8983);
  meth_meth_ast_pretty_40_1_41_8983->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8983->definitionLine = 2290;
// method "toGrace(_)"
  struct UserObject *uo9077 = (struct UserObject*)obj8838;
  uo9077->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9077 = addmethod2pos(obj8838, "toGrace(1)", &meth_ast_toGrace_40_1_41_9077, 20);
  int argcv_meth_ast_toGrace_40_1_41_9077[] = {1};
  meth_meth_ast_toGrace_40_1_41_9077->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9077);
meth_meth_ast_toGrace_40_1_41_9077->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9077->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9077->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9077->definitionLine = 2303;
// method "shallowCopy"
  block_savedest(obj8838);
  Object closure9097 = createclosure(2, "shallowCopy");
  setclosureframe(closure9097, stackframe);
  addtoclosure(closure9097, var_nullNode);
  addtoclosure(closure9097, var_importNode);
  struct UserObject *uo9097 = (struct UserObject*)obj8838;
  uo9097->data[21] = (Object)closure9097;
  Method *meth_meth_ast_shallowCopy9097 = addmethod2pos(obj8838, "shallowCopy", &meth_ast_shallowCopy9097, 21);
  int argcv_meth_ast_shallowCopy9097[] = {0};
  meth_meth_ast_shallowCopy9097->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9097);
  meth_meth_ast_shallowCopy9097->definitionModule = modulename;
  meth_meth_ast_shallowCopy9097->definitionLine = 2306;
  sourceObject = obj8838;
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9105 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9106 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9107 = gc_frame_new();
// call case 3: self.outer request
  Object call9108 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9107);
// compiled member node returning call9108 (depth = 5)
  Object call9109 = callmethodflags(call9108, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9106);
// compiled member node returning call9109 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9110 = callmethodflags(call9109, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9105);
// compiled call node returning call9110 (depth = 3)
  struct UserObject *obj8838_uo = (struct UserObject *)obj8838;
  obj8838_uo->super = call9110;
  sourceObject = obj8838;
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9111 == NULL) {
    strlit9111 = alloc_String("import");
    gc_root(strlit9111);
  }
// compiled string node returning strlit9111 (depth = 3)
  adddatum2(obj8838, strlit9111, 1);
  sourceObject = obj8838;
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8838, *var_name_39_, 2);
  sourceObject = obj8838;
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8838, *var_path_39_, 3);
  sourceObject = obj8838;
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9112 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9112 (depth = 3)
  adddatum2(obj8838, array9112, 4);
  sourceObject = obj8838;
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8838, *var_dtype_39_, 5);
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  objclass8838 = obj8838->class;
  objclass8838->definitionModule = modulename;
  objclass8838->definitionLine = 2235;
  (*(struct UserObject *)self).data[0] = lowerouter8838;
  self = oldself8838;
  selfslot = oldselfslot8838;
  stackframe = oldstackframe8838;
  gc_frame_end(frame);
  return obj8838;
}
Object meth_ast_new_40_3_41_8837_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8838 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8838 = alloc_userobj2(25,22, objclass8838);
  gc_frame_newslot(obj8838);
if (objclass8838 == NULL) {
  glfree(obj8838->class->name);
  obj8838->class->name = "importNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8838, self, 0);
  addmethodreal(obj8838,"outer", &reader_ast_outer_8839);
  Object oldself8838 = self;
  struct StackFrameObject *oldstackframe8838 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8838);
  gc_frame_newslot((Object)stackframe);
  self = obj8838;
  Object *oldselfslot8838 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8838 = (*(struct UserObject *)self).data[0], lowerouter8838 = thisouter8838;
  if (inheritingObject8838) {
    struct UserObject *inho8838 = (struct UserObject *)inheritingObject8838;
    while (inho8838->super != GraceDefaultObject) inho8838 = (struct UserObject *)inho8838->super;
    inho8838->super = obj8838;
    self = inheritingObject8838;
    *selfslot = self;
    lowerouter8838 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8838;
  }
if (objclass8838 == NULL) {
  Method *reader8840 = addmethodrealflags(obj8838, "kind",&reader_ast_kind_8840, MFLAG_DEF);
  reader8840->definitionModule = modulename;
  reader8840->definitionLine = 2237;
}
adddatum2(obj8838, alloc_Undefined(), 1);
if (objclass8838 == NULL) {
  Method *reader8841 = addmethodrealflags(obj8838, "value", &reader_ast_value_8841, 0);
  Method *writer8841 = addmethodrealflags(obj8838, "value:=(1)", &writer_ast_value_8841, 0);
  reader8841->definitionModule = modulename;
  writer8841->definitionModule = modulename;
  reader8841->definitionLine = 2238;
  writer8841->definitionLine = 2238;
}
obj8838->flags |= OFLAG_MUTABLE;
adddatum2(obj8838, alloc_Undefined(), 2);
if (objclass8838 == NULL) {
  Method *reader8842 = addmethodrealflags(obj8838, "path", &reader_ast_path_8842, 0);
  Method *writer8842 = addmethodrealflags(obj8838, "path:=(1)", &writer_ast_path_8842, 0);
  reader8842->definitionModule = modulename;
  writer8842->definitionModule = modulename;
  reader8842->definitionLine = 2239;
  writer8842->definitionLine = 2239;
}
obj8838->flags |= OFLAG_MUTABLE;
adddatum2(obj8838, alloc_Undefined(), 3);
if (objclass8838 == NULL) {
  Method *reader8843 = addmethodrealflags(obj8838, "annotations", &reader_ast_annotations_8843, 0);
  Method *writer8843 = addmethodrealflags(obj8838, "annotations:=(1)", &writer_ast_annotations_8843, 0);
  reader8843->definitionModule = modulename;
  writer8843->definitionModule = modulename;
  reader8843->definitionLine = 2240;
  writer8843->definitionLine = 2240;
}
obj8838->flags |= OFLAG_MUTABLE;
adddatum2(obj8838, alloc_Undefined(), 4);
if (objclass8838 == NULL) {
  Method *reader8844 = addmethodrealflags(obj8838, "dtype", &reader_ast_dtype_8844, 0);
  Method *writer8844 = addmethodrealflags(obj8838, "dtype:=(1)", &writer_ast_dtype_8844, 0);
  reader8844->definitionModule = modulename;
  writer8844->definitionModule = modulename;
  reader8844->definitionLine = 2241;
  writer8844->definitionLine = 2241;
}
obj8838->flags |= OFLAG_MUTABLE;
adddatum2(obj8838, alloc_Undefined(), 5);
// method "isImport"
  struct UserObject *uo8845 = (struct UserObject*)obj8838;
  uo8845->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport8845 = addmethod2pos(obj8838, "isImport", &meth_ast_isImport8845, 6);
  int argcv_meth_ast_isImport8845[] = {0};
  meth_meth_ast_isImport8845->type = alloc_MethodType(1, argcv_meth_ast_isImport8845);
  meth_meth_ast_isImport8845->definitionModule = modulename;
  meth_meth_ast_isImport8845->definitionLine = 2242;
// method "isExternal"
  struct UserObject *uo8847 = (struct UserObject*)obj8838;
  uo8847->data[7] = emptyclosure;
  Method *meth_meth_ast_isExternal8847 = addmethod2pos(obj8838, "isExternal", &meth_ast_isExternal8847, 7);
  int argcv_meth_ast_isExternal8847[] = {0};
  meth_meth_ast_isExternal8847->type = alloc_MethodType(1, argcv_meth_ast_isExternal8847);
  meth_meth_ast_isExternal8847->definitionModule = modulename;
  meth_meth_ast_isExternal8847->definitionLine = 2243;
// method "isExecutable"
  struct UserObject *uo8849 = (struct UserObject*)obj8838;
  uo8849->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable8849 = addmethod2pos(obj8838, "isExecutable", &meth_ast_isExecutable8849, 8);
  int argcv_meth_ast_isExecutable8849[] = {0};
  meth_meth_ast_isExecutable8849->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8849);
  meth_meth_ast_isExecutable8849->definitionModule = modulename;
  meth_meth_ast_isExecutable8849->definitionLine = 2244;
// method "name"
  struct UserObject *uo8851 = (struct UserObject*)obj8838;
  uo8851->data[9] = emptyclosure;
  Method *meth_meth_ast_name8851 = addmethod2pos(obj8838, "name", &meth_ast_name8851, 9);
  int argcv_meth_ast_name8851[] = {0};
  meth_meth_ast_name8851->type = alloc_MethodType(1, argcv_meth_ast_name8851);
  meth_meth_ast_name8851->definitionModule = modulename;
  meth_meth_ast_name8851->definitionLine = 2245;
// method "nameString"
  struct UserObject *uo8854 = (struct UserObject*)obj8838;
  uo8854->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString8854 = addmethod2pos(obj8838, "nameString", &meth_ast_nameString8854, 10);
  int argcv_meth_ast_nameString8854[] = {0};
  meth_meth_ast_nameString8854->type = alloc_MethodType(1, argcv_meth_ast_nameString8854);
  meth_meth_ast_nameString8854->definitionModule = modulename;
  meth_meth_ast_nameString8854->definitionLine = 2246;
// method "isPublic"
  struct UserObject *uo8859 = (struct UserObject*)obj8838;
  uo8859->data[11] = emptyclosure;
  Method *meth_meth_ast_isPublic8859 = addmethod2pos(obj8838, "isPublic", &meth_ast_isPublic8859, 11);
  int argcv_meth_ast_isPublic8859[] = {0};
  meth_meth_ast_isPublic8859->type = alloc_MethodType(1, argcv_meth_ast_isPublic8859);
  meth_meth_ast_isPublic8859->definitionModule = modulename;
  meth_meth_ast_isPublic8859->definitionLine = 2247;
// method "moduleName"
  struct UserObject *uo8886 = (struct UserObject*)obj8838;
  uo8886->data[12] = emptyclosure;
  Method *meth_meth_ast_moduleName8886 = addmethod2pos(obj8838, "moduleName", &meth_ast_moduleName8886, 12);
  int argcv_meth_ast_moduleName8886[] = {0};
  meth_meth_ast_moduleName8886->type = alloc_MethodType(1, argcv_meth_ast_moduleName8886);
  meth_meth_ast_moduleName8886->definitionModule = modulename;
  meth_meth_ast_moduleName8886->definitionLine = 2253;
// method "isWritable"
  struct UserObject *uo8906 = (struct UserObject*)obj8838;
  uo8906->data[13] = emptyclosure;
  Method *meth_meth_ast_isWritable8906 = addmethod2pos(obj8838, "isWritable", &meth_ast_isWritable8906, 13);
  int argcv_meth_ast_isWritable8906[] = {0};
  meth_meth_ast_isWritable8906->type = alloc_MethodType(1, argcv_meth_ast_isWritable8906);
  meth_meth_ast_isWritable8906->definitionModule = modulename;
  meth_meth_ast_isWritable8906->definitionLine = 2264;
// method "isReadable"
  struct UserObject *uo8908 = (struct UserObject*)obj8838;
  uo8908->data[14] = emptyclosure;
  Method *meth_meth_ast_isReadable8908 = addmethod2pos(obj8838, "isReadable", &meth_ast_isReadable8908, 14);
  int argcv_meth_ast_isReadable8908[] = {0};
  meth_meth_ast_isReadable8908->type = alloc_MethodType(1, argcv_meth_ast_isReadable8908);
  meth_meth_ast_isReadable8908->definitionModule = modulename;
  meth_meth_ast_isReadable8908->definitionLine = 2265;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8838);
  Object closure8911 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8911, stackframe);
  addtoclosure(closure8911, var_k);
  struct UserObject *uo8911 = (struct UserObject*)obj8838;
  uo8911->data[15] = (Object)closure8911;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8911 = addmethod2pos(obj8838, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8911, 15);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8911[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8911->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8911);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8911->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8911->definitionLine = 2266;
// method "usesAsType(_)"
  struct UserObject *uo8914 = (struct UserObject*)obj8838;
  uo8914->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8914 = addmethod2pos(obj8838, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8914, 16);
  int argcv_meth_ast_usesAsType_40_1_41_8914[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8914->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8914);
  meth_meth_ast_usesAsType_40_1_41_8914->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8914->definitionLine = 2267;
// method "accept(_)from(_)"
  struct UserObject *uo8920 = (struct UserObject*)obj8838;
  uo8920->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8920 = addmethod2pos(obj8838, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8920, 17);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8920[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8920->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8920);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8920->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8920->definitionLine = 2270;
// method "map(_)ancestors(_)"
  struct UserObject *uo8950 = (struct UserObject*)obj8838;
  uo8950->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8950 = addmethod2pos(obj8838, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8950, 18);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8950[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8950->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8950);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8950->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8950->definitionLine = 2282;
// method "pretty(_)"
  struct UserObject *uo8983 = (struct UserObject*)obj8838;
  uo8983->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8983 = addmethod2pos(obj8838, "pretty(1)", &meth_ast_pretty_40_1_41_8983, 19);
  int argcv_meth_ast_pretty_40_1_41_8983[] = {1};
  meth_meth_ast_pretty_40_1_41_8983->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8983);
  meth_meth_ast_pretty_40_1_41_8983->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8983->definitionLine = 2290;
// method "toGrace(_)"
  struct UserObject *uo9077 = (struct UserObject*)obj8838;
  uo9077->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9077 = addmethod2pos(obj8838, "toGrace(1)", &meth_ast_toGrace_40_1_41_9077, 20);
  int argcv_meth_ast_toGrace_40_1_41_9077[] = {1};
  meth_meth_ast_toGrace_40_1_41_9077->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9077);
meth_meth_ast_toGrace_40_1_41_9077->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9077->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9077->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9077->definitionLine = 2303;
// method "shallowCopy"
  block_savedest(obj8838);
  Object closure9097 = createclosure(2, "shallowCopy");
  setclosureframe(closure9097, stackframe);
  addtoclosure(closure9097, var_nullNode);
  addtoclosure(closure9097, var_importNode);
  struct UserObject *uo9097 = (struct UserObject*)obj8838;
  uo9097->data[21] = (Object)closure9097;
  Method *meth_meth_ast_shallowCopy9097 = addmethod2pos(obj8838, "shallowCopy", &meth_ast_shallowCopy9097, 21);
  int argcv_meth_ast_shallowCopy9097[] = {0};
  meth_meth_ast_shallowCopy9097->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9097);
  meth_meth_ast_shallowCopy9097->definitionModule = modulename;
  meth_meth_ast_shallowCopy9097->definitionLine = 2306;
  sourceObject = obj8838;
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9105 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9106 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9107 = gc_frame_new();
// call case 3: self.outer request
  Object call9108 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9107);
// compiled member node returning call9108 (depth = 5)
  Object call9109 = callmethodflags(call9108, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9106);
// compiled member node returning call9109 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9110 = callmethodflags(call9109, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9105);
// compiled call node returning call9110 (depth = 3)
  struct UserObject *obj8838_uo = (struct UserObject *)obj8838;
  obj8838_uo->super = call9110;
  sourceObject = obj8838;
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9111 == NULL) {
    strlit9111 = alloc_String("import");
    gc_root(strlit9111);
  }
// compiled string node returning strlit9111 (depth = 3)
  adddatum2(obj8838, strlit9111, 1);
  sourceObject = obj8838;
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8838, *var_name_39_, 2);
  sourceObject = obj8838;
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8838, *var_path_39_, 3);
  sourceObject = obj8838;
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9112 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9112 (depth = 3)
  adddatum2(obj8838, array9112, 4);
  sourceObject = obj8838;
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8838, *var_dtype_39_, 5);
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  sourceObject = obj8838;
  objclass8838 = obj8838->class;
  objclass8838->definitionModule = modulename;
  objclass8838->definitionLine = 2235;
  (*(struct UserObject *)self).data[0] = lowerouter8838;
  self = oldself8838;
  selfslot = oldselfslot8838;
  stackframe = oldstackframe8838;
  gc_frame_end(frame);
  return obj8838;
}
Object meth_ast_importNode9114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_importNode (depth = 3)
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_isDialect9122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9123 = alloc_Boolean(1);
// compiled identifier node returning bool9123 (depth = 3)
  gc_frame_end(frame);
  return bool9123;
}
Object meth_ast_isExternal9124(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9125 = alloc_Boolean(1);
// compiled identifier node returning bool9125 (depth = 3)
  gc_frame_end(frame);
  return bool9125;
}
Object meth_ast_isExecutable9126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9127 = alloc_Boolean(0);
// compiled identifier node returning bool9127 (depth = 3)
  gc_frame_end(frame);
  return bool9127;
}
Object meth_ast__apply_40_1_41_9134(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9137 == NULL) {
    strlit9137 = alloc_String("/");
    gc_root(strlit9137);
  }
// compiled string node returning strlit9137 (depth = 7)
  int op_slot_right_9136 = gc_frame_newslot(strlit9137);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_9136 = gc_frame_newslot(*var_c);
  params[0] = strlit9137;
  partcv[0] = 1;
  Object opresult9139 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult9139 (depth = 6)
  Object if9135 = done;
  if (istrue(opresult9139)) {
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9140 == NULL) {
    strlit9140 = alloc_String("");
    gc_root(strlit9140);
  }
// compiled string node returning strlit9140 (depth = 7)
  *var_bnm = strlit9140;
  if (strlit9140 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9135 = done;
  } else {
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_9142 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_9142 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult9144 = callmethod(*var_bnm, "++(1)", 1, partcv, params);
// compiled op node returning opresult9144 (depth = 7)
  *var_bnm = opresult9144;
  if (opresult9144 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9135 = done;
  }
// compiled if node returning if9135 (depth = 5)
  gc_frame_end(frame);
  return if9135;
}
Object meth_ast_moduleName9128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2321
  setline(2321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9129 == NULL) {
    strlit9129 = alloc_String("");
    gc_root(strlit9129);
  }
// compiled string node returning strlit9129 (depth = 4)
  *var_bnm = strlit9129;
  if (strlit9129 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9130 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9131 = gc_frame_new();
// call case 4: self request
  Object call9132 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9131);
// compiled member node returning call9132 (depth = 4)
  gc_frame_newslot(call9132);
// starting to compile block node (depth = 4)
  Object block9133 = alloc_Block(NULL, NULL, "ast", 2322);
  gc_frame_newslot(block9133);
// method "_apply(_)"
  block_savedest(block9133);
  Object closure9134 = createclosure(2, "_apply(1)");
  setclosureframe(closure9134, stackframe);
  addtoclosure(closure9134, var_bnm);
  addtoclosure(closure9134, selfslot);
  struct UserObject *uo9134 = (struct UserObject*)block9133;
  uo9134->data[0] = (Object)closure9134;
  Method *meth_meth_ast__apply_40_1_41_9134 = addmethod2pos(block9133, "_apply(1)", &meth_ast__apply_40_1_41_9134, 0);
  int argcv_meth_ast__apply_40_1_41_9134[] = {1};
  meth_meth_ast__apply_40_1_41_9134->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9134);
  meth_meth_ast__apply_40_1_41_9134->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9134->definitionLine = 2969;
// compiled block node returning block9133 (depth = 4)
  gc_frame_newslot(block9133);
// call case 5: prelude request
  params[0] = call9132;
  params[1] = block9133;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9147 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9130);
// compiled call node returning call9147 (depth = 3)
// Begin line 2329
  setline(2329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_path9148(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "path");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9149 = gc_frame_new();
// call case 4: self request
  Object call9150 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9149);
// compiled member node returning call9150 (depth = 3)
  gc_frame_end(frame);
  return call9150;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9151(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9152 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9153 = callmethodflags(*var_visitor, "visitDialect(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9152);
// compiled call node returning call9153 (depth = 3)
  gc_frame_end(frame);
  return call9153;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9155 = gc_frame_new();
// call case 4: self request
  Object call9156 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9155);
// compiled member node returning call9156 (depth = 4)
  *var_n = call9156;
  if (call9156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9157 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9158 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9157);
// compiled call node returning call9158 (depth = 4)
  *var_newChain = call9158;
  if (call9158 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9159 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9160 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9159);
// compiled call node returning call9160 (depth = 3)
  gc_frame_end(frame);
  return call9160;
}
Object meth_ast__apply_40_1_41_9169(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2345
  setline(2345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9171 == NULL) {
    strlit9171 = alloc_String("  ");
    gc_root(strlit9171);
  }
// compiled string node returning strlit9171 (depth = 7)
  int op_slot_right_9170 = gc_frame_newslot(strlit9171);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9170 = gc_frame_newslot(*var_spc);
  params[0] = strlit9171;
  partcv[0] = 1;
  Object opresult9173 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9173 (depth = 6)
  *var_spc = opresult9173;
  if (opresult9173 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9161(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9162 == NULL) {
    strlit9162 = alloc_String("");
    gc_root(strlit9162);
  }
// compiled string node returning strlit9162 (depth = 4)
  *var_spc = strlit9162;
  if (strlit9162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9163 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9164 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9166 = alloc_Float64(0);
// compiled num node returning num9166 (depth = 5)
  int op_slot_left_9164 = gc_frame_newslot(num9166);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9167 = callmethod(num9166, "..(1)", 1, partcv, params);
// compiled op node returning opresult9167 (depth = 4)
  gc_frame_newslot(opresult9167);
// starting to compile block node (depth = 4)
  Object block9168 = alloc_Block(NULL, NULL, "ast", 2344);
  gc_frame_newslot(block9168);
// method "_apply(_)"
  block_savedest(block9168);
  Object closure9169 = createclosure(2, "_apply(1)");
  setclosureframe(closure9169, stackframe);
  addtoclosure(closure9169, var_spc);
  addtoclosure(closure9169, selfslot);
  struct UserObject *uo9169 = (struct UserObject*)block9168;
  uo9169->data[0] = (Object)closure9169;
  Method *meth_meth_ast__apply_40_1_41_9169 = addmethod2pos(block9168, "_apply(1)", &meth_ast__apply_40_1_41_9169, 0);
  int argcv_meth_ast__apply_40_1_41_9169[] = {1};
  meth_meth_ast__apply_40_1_41_9169->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9169);
  meth_meth_ast__apply_40_1_41_9169->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9169->definitionLine = 2969;
// compiled block node returning block9168 (depth = 4)
  gc_frame_newslot(block9168);
// call case 5: prelude request
  params[0] = opresult9167;
  params[1] = block9168;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9176 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9163);
// compiled call node returning call9176 (depth = 3)
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9178 == NULL) {
    strlit9178 = alloc_String("""\x0a""");
    gc_root(strlit9178);
  }
// compiled string node returning strlit9178 (depth = 5)
  int op_slot_right_9177 = gc_frame_newslot(strlit9178);
// starting to compile call node (depth = 5)
  int callframe9180 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9181 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9180);
// compiled call node returning call9181 (depth = 5)
  int op_slot_left_9177 = gc_frame_newslot(call9181);
  params[0] = strlit9178;
  partcv[0] = 1;
  Object opresult9182 = callmethod(call9181, "++(1)", 1, partcv, params);
// compiled op node returning opresult9182 (depth = 4)
  *var_s = opresult9182;
  if (opresult9182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9185 == NULL) {
    strlit9185 = alloc_String("""\x0a""");
    gc_root(strlit9185);
  }
// compiled string node returning strlit9185 (depth = 6)
  int op_slot_right_9184 = gc_frame_newslot(strlit9185);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9188 = gc_frame_new();
// call case 4: self request
  Object call9189 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9188);
// compiled member node returning call9189 (depth = 7)
  int op_slot_right_9187 = gc_frame_newslot(call9189);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9192 == NULL) {
    strlit9192 = alloc_String("Path: ");
    gc_root(strlit9192);
  }
// compiled string node returning strlit9192 (depth = 8)
  int op_slot_right_9191 = gc_frame_newslot(strlit9192);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9194 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9196 == NULL) {
    strlit9196 = alloc_String("");
    gc_root(strlit9196);
  }
// compiled string node returning strlit9196 (depth = 9)
  int op_slot_left_9194 = gc_frame_newslot(strlit9196);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9197 = callmethod(strlit9196, "++(1)", 1, partcv, params);
// compiled op node returning opresult9197 (depth = 8)
  int op_slot_left_9191 = gc_frame_newslot(opresult9197);
  params[0] = strlit9192;
  partcv[0] = 1;
  Object opresult9198 = callmethod(opresult9197, "++(1)", 1, partcv, params);
// compiled op node returning opresult9198 (depth = 7)
  int op_slot_left_9187 = gc_frame_newslot(opresult9198);
  params[0] = call9189;
  partcv[0] = 1;
  Object opresult9199 = callmethod(opresult9198, "++(1)", 1, partcv, params);
// compiled op node returning opresult9199 (depth = 6)
  int op_slot_left_9184 = gc_frame_newslot(opresult9199);
  params[0] = strlit9185;
  partcv[0] = 1;
  Object opresult9200 = callmethod(opresult9199, "++(1)", 1, partcv, params);
// compiled op node returning opresult9200 (depth = 5)
  int op_slot_right_9183 = gc_frame_newslot(opresult9200);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9183 = gc_frame_newslot(*var_s);
  params[0] = opresult9200;
  partcv[0] = 1;
  Object opresult9202 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9202 (depth = 4)
  *var_s = opresult9202;
  if (opresult9202 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace_40_1_41_9204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9206 == NULL) {
    strlit9206 = alloc_String("""\x22""");
    gc_root(strlit9206);
  }
// compiled string node returning strlit9206 (depth = 4)
  int op_slot_right_9205 = gc_frame_newslot(strlit9206);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9209 = gc_frame_new();
// call case 4: self request
  Object call9210 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9209);
// compiled member node returning call9210 (depth = 5)
  int op_slot_right_9208 = gc_frame_newslot(call9210);
// starting to compile string node (depth = 5)
  if (strlit9212 == NULL) {
    strlit9212 = alloc_String("dialect ""\x22""");
    gc_root(strlit9212);
  }
// compiled string node returning strlit9212 (depth = 5)
  int op_slot_left_9208 = gc_frame_newslot(strlit9212);
  params[0] = call9210;
  partcv[0] = 1;
  Object opresult9213 = callmethod(strlit9212, "++(1)", 1, partcv, params);
// compiled op node returning opresult9213 (depth = 4)
  int op_slot_left_9205 = gc_frame_newslot(opresult9213);
  params[0] = strlit9206;
  partcv[0] = 1;
  Object opresult9214 = callmethod(opresult9213, "++(1)", 1, partcv, params);
// compiled op node returning opresult9214 (depth = 3)
  gc_frame_end(frame);
  return opresult9214;
}
Object meth_ast_shallowCopy9215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9216 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9217 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9218 = gc_frame_new();
// call case 4: self request
  Object call9219 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9218);
// compiled member node returning call9219 (depth = 5)
  gc_frame_newslot(call9219);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dialectNode (depth = 5)
  params[0] = call9219;
  partcv[0] = 1;
  Object call9220 = callmethodflags(*var_dialectNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9217);
// compiled call node returning call9220 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9221 = callmethodflags(call9220, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9216);
// compiled call node returning call9221 (depth = 3)
  gc_frame_end(frame);
  return call9221;
}
Object meth_ast_new_40_1_41_9117(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9118 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9118 = alloc_userobj2(13,13, objclass9118);
  gc_frame_newslot(obj9118);
if (objclass9118 == NULL) {
  glfree(obj9118->class->name);
  obj9118->class->name = "dialectNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9118, self, 0);
  addmethodreal(obj9118,"outer", &reader_ast_outer_9119);
  Object oldself9118 = self;
  struct StackFrameObject *oldstackframe9118 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9118);
  gc_frame_newslot((Object)stackframe);
  self = obj9118;
  Object *oldselfslot9118 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9118 = (*(struct UserObject *)self).data[0], lowerouter9118 = thisouter9118;
  if (inheritingObject9118) {
    struct UserObject *inho9118 = (struct UserObject *)inheritingObject9118;
    while (inho9118->super != GraceDefaultObject) inho9118 = (struct UserObject *)inho9118->super;
    inho9118->super = obj9118;
    self = inheritingObject9118;
    *selfslot = self;
    lowerouter9118 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9118;
  }
if (objclass9118 == NULL) {
  Method *reader9120 = addmethodrealflags(obj9118, "kind",&reader_ast_kind_9120, MFLAG_DEF);
  reader9120->definitionModule = modulename;
  reader9120->definitionLine = 2314;
}
adddatum2(obj9118, alloc_Undefined(), 1);
if (objclass9118 == NULL) {
  Method *reader9121 = addmethodrealflags(obj9118, "value", &reader_ast_value_9121, 0);
  Method *writer9121 = addmethodrealflags(obj9118, "value:=(1)", &writer_ast_value_9121, 0);
  reader9121->definitionModule = modulename;
  writer9121->definitionModule = modulename;
  reader9121->definitionLine = 2315;
  writer9121->definitionLine = 2315;
}
obj9118->flags |= OFLAG_MUTABLE;
adddatum2(obj9118, alloc_Undefined(), 2);
// method "isDialect"
  struct UserObject *uo9122 = (struct UserObject*)obj9118;
  uo9122->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect9122 = addmethod2pos(obj9118, "isDialect", &meth_ast_isDialect9122, 3);
  int argcv_meth_ast_isDialect9122[] = {0};
  meth_meth_ast_isDialect9122->type = alloc_MethodType(1, argcv_meth_ast_isDialect9122);
  meth_meth_ast_isDialect9122->definitionModule = modulename;
  meth_meth_ast_isDialect9122->definitionLine = 2317;
// method "isExternal"
  struct UserObject *uo9124 = (struct UserObject*)obj9118;
  uo9124->data[4] = emptyclosure;
  Method *meth_meth_ast_isExternal9124 = addmethod2pos(obj9118, "isExternal", &meth_ast_isExternal9124, 4);
  int argcv_meth_ast_isExternal9124[] = {0};
  meth_meth_ast_isExternal9124->type = alloc_MethodType(1, argcv_meth_ast_isExternal9124);
  meth_meth_ast_isExternal9124->definitionModule = modulename;
  meth_meth_ast_isExternal9124->definitionLine = 2318;
// method "isExecutable"
  struct UserObject *uo9126 = (struct UserObject*)obj9118;
  uo9126->data[5] = emptyclosure;
  Method *meth_meth_ast_isExecutable9126 = addmethod2pos(obj9118, "isExecutable", &meth_ast_isExecutable9126, 5);
  int argcv_meth_ast_isExecutable9126[] = {0};
  meth_meth_ast_isExecutable9126->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9126);
  meth_meth_ast_isExecutable9126->definitionModule = modulename;
  meth_meth_ast_isExecutable9126->definitionLine = 2319;
// method "moduleName"
  struct UserObject *uo9128 = (struct UserObject*)obj9118;
  uo9128->data[6] = emptyclosure;
  Method *meth_meth_ast_moduleName9128 = addmethod2pos(obj9118, "moduleName", &meth_ast_moduleName9128, 6);
  int argcv_meth_ast_moduleName9128[] = {0};
  meth_meth_ast_moduleName9128->type = alloc_MethodType(1, argcv_meth_ast_moduleName9128);
  meth_meth_ast_moduleName9128->definitionModule = modulename;
  meth_meth_ast_moduleName9128->definitionLine = 2320;
// method "path"
  struct UserObject *uo9148 = (struct UserObject*)obj9118;
  uo9148->data[7] = emptyclosure;
  Method *meth_meth_ast_path9148 = addmethod2pos(obj9118, "path", &meth_ast_path9148, 7);
  int argcv_meth_ast_path9148[] = {0};
  meth_meth_ast_path9148->type = alloc_MethodType(1, argcv_meth_ast_path9148);
  meth_meth_ast_path9148->definitionModule = modulename;
  meth_meth_ast_path9148->definitionLine = 2331;
// method "accept(_)from(_)"
  struct UserObject *uo9151 = (struct UserObject*)obj9118;
  uo9151->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9151 = addmethod2pos(obj9118, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9151, 8);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9151[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9151->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9151);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9151->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9151->definitionLine = 2334;
// method "map(_)ancestors(_)"
  struct UserObject *uo9154 = (struct UserObject*)obj9118;
  uo9154->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9154 = addmethod2pos(obj9118, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9154, 9);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9154[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9154->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9154);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9154->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9154->definitionLine = 2337;
// method "pretty(_)"
  struct UserObject *uo9161 = (struct UserObject*)obj9118;
  uo9161->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9161 = addmethod2pos(obj9118, "pretty(1)", &meth_ast_pretty_40_1_41_9161, 10);
  int argcv_meth_ast_pretty_40_1_41_9161[] = {1};
  meth_meth_ast_pretty_40_1_41_9161->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9161);
  meth_meth_ast_pretty_40_1_41_9161->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9161->definitionLine = 2342;
// method "toGrace(_)"
  struct UserObject *uo9204 = (struct UserObject*)obj9118;
  uo9204->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9204 = addmethod2pos(obj9118, "toGrace(1)", &meth_ast_toGrace_40_1_41_9204, 11);
  int argcv_meth_ast_toGrace_40_1_41_9204[] = {1};
  meth_meth_ast_toGrace_40_1_41_9204->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9204);
meth_meth_ast_toGrace_40_1_41_9204->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9204->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9204->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9204->definitionLine = 2351;
// method "shallowCopy"
  block_savedest(obj9118);
  Object closure9215 = createclosure(1, "shallowCopy");
  setclosureframe(closure9215, stackframe);
  addtoclosure(closure9215, var_dialectNode);
  struct UserObject *uo9215 = (struct UserObject*)obj9118;
  uo9215->data[12] = (Object)closure9215;
  Method *meth_meth_ast_shallowCopy9215 = addmethod2pos(obj9118, "shallowCopy", &meth_ast_shallowCopy9215, 12);
  int argcv_meth_ast_shallowCopy9215[] = {0};
  meth_meth_ast_shallowCopy9215->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9215);
  meth_meth_ast_shallowCopy9215->definitionModule = modulename;
  meth_meth_ast_shallowCopy9215->definitionLine = 2354;
  sourceObject = obj9118;
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9222 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9223 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9224 = gc_frame_new();
// call case 3: self.outer request
  Object call9225 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9224);
// compiled member node returning call9225 (depth = 5)
  Object call9226 = callmethodflags(call9225, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9223);
// compiled member node returning call9226 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9227 = callmethodflags(call9226, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9222);
// compiled call node returning call9227 (depth = 3)
  struct UserObject *obj9118_uo = (struct UserObject *)obj9118;
  obj9118_uo->super = call9227;
  sourceObject = obj9118;
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9228 == NULL) {
    strlit9228 = alloc_String("dialect");
    gc_root(strlit9228);
  }
// compiled string node returning strlit9228 (depth = 3)
  adddatum2(obj9118, strlit9228, 1);
  sourceObject = obj9118;
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj9118, *var_path_39_, 2);
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  objclass9118 = obj9118->class;
  objclass9118->definitionModule = modulename;
  objclass9118->definitionLine = 2312;
  (*(struct UserObject *)self).data[0] = lowerouter9118;
  self = oldself9118;
  selfslot = oldselfslot9118;
  stackframe = oldstackframe9118;
  gc_frame_end(frame);
  return obj9118;
}
Object meth_ast_new_40_1_41_9117_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9118 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9118 = alloc_userobj2(13,13, objclass9118);
  gc_frame_newslot(obj9118);
if (objclass9118 == NULL) {
  glfree(obj9118->class->name);
  obj9118->class->name = "dialectNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9118, self, 0);
  addmethodreal(obj9118,"outer", &reader_ast_outer_9119);
  Object oldself9118 = self;
  struct StackFrameObject *oldstackframe9118 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9118);
  gc_frame_newslot((Object)stackframe);
  self = obj9118;
  Object *oldselfslot9118 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9118 = (*(struct UserObject *)self).data[0], lowerouter9118 = thisouter9118;
  if (inheritingObject9118) {
    struct UserObject *inho9118 = (struct UserObject *)inheritingObject9118;
    while (inho9118->super != GraceDefaultObject) inho9118 = (struct UserObject *)inho9118->super;
    inho9118->super = obj9118;
    self = inheritingObject9118;
    *selfslot = self;
    lowerouter9118 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9118;
  }
if (objclass9118 == NULL) {
  Method *reader9120 = addmethodrealflags(obj9118, "kind",&reader_ast_kind_9120, MFLAG_DEF);
  reader9120->definitionModule = modulename;
  reader9120->definitionLine = 2314;
}
adddatum2(obj9118, alloc_Undefined(), 1);
if (objclass9118 == NULL) {
  Method *reader9121 = addmethodrealflags(obj9118, "value", &reader_ast_value_9121, 0);
  Method *writer9121 = addmethodrealflags(obj9118, "value:=(1)", &writer_ast_value_9121, 0);
  reader9121->definitionModule = modulename;
  writer9121->definitionModule = modulename;
  reader9121->definitionLine = 2315;
  writer9121->definitionLine = 2315;
}
obj9118->flags |= OFLAG_MUTABLE;
adddatum2(obj9118, alloc_Undefined(), 2);
// method "isDialect"
  struct UserObject *uo9122 = (struct UserObject*)obj9118;
  uo9122->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect9122 = addmethod2pos(obj9118, "isDialect", &meth_ast_isDialect9122, 3);
  int argcv_meth_ast_isDialect9122[] = {0};
  meth_meth_ast_isDialect9122->type = alloc_MethodType(1, argcv_meth_ast_isDialect9122);
  meth_meth_ast_isDialect9122->definitionModule = modulename;
  meth_meth_ast_isDialect9122->definitionLine = 2317;
// method "isExternal"
  struct UserObject *uo9124 = (struct UserObject*)obj9118;
  uo9124->data[4] = emptyclosure;
  Method *meth_meth_ast_isExternal9124 = addmethod2pos(obj9118, "isExternal", &meth_ast_isExternal9124, 4);
  int argcv_meth_ast_isExternal9124[] = {0};
  meth_meth_ast_isExternal9124->type = alloc_MethodType(1, argcv_meth_ast_isExternal9124);
  meth_meth_ast_isExternal9124->definitionModule = modulename;
  meth_meth_ast_isExternal9124->definitionLine = 2318;
// method "isExecutable"
  struct UserObject *uo9126 = (struct UserObject*)obj9118;
  uo9126->data[5] = emptyclosure;
  Method *meth_meth_ast_isExecutable9126 = addmethod2pos(obj9118, "isExecutable", &meth_ast_isExecutable9126, 5);
  int argcv_meth_ast_isExecutable9126[] = {0};
  meth_meth_ast_isExecutable9126->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9126);
  meth_meth_ast_isExecutable9126->definitionModule = modulename;
  meth_meth_ast_isExecutable9126->definitionLine = 2319;
// method "moduleName"
  struct UserObject *uo9128 = (struct UserObject*)obj9118;
  uo9128->data[6] = emptyclosure;
  Method *meth_meth_ast_moduleName9128 = addmethod2pos(obj9118, "moduleName", &meth_ast_moduleName9128, 6);
  int argcv_meth_ast_moduleName9128[] = {0};
  meth_meth_ast_moduleName9128->type = alloc_MethodType(1, argcv_meth_ast_moduleName9128);
  meth_meth_ast_moduleName9128->definitionModule = modulename;
  meth_meth_ast_moduleName9128->definitionLine = 2320;
// method "path"
  struct UserObject *uo9148 = (struct UserObject*)obj9118;
  uo9148->data[7] = emptyclosure;
  Method *meth_meth_ast_path9148 = addmethod2pos(obj9118, "path", &meth_ast_path9148, 7);
  int argcv_meth_ast_path9148[] = {0};
  meth_meth_ast_path9148->type = alloc_MethodType(1, argcv_meth_ast_path9148);
  meth_meth_ast_path9148->definitionModule = modulename;
  meth_meth_ast_path9148->definitionLine = 2331;
// method "accept(_)from(_)"
  struct UserObject *uo9151 = (struct UserObject*)obj9118;
  uo9151->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9151 = addmethod2pos(obj9118, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9151, 8);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9151[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9151->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9151);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9151->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9151->definitionLine = 2334;
// method "map(_)ancestors(_)"
  struct UserObject *uo9154 = (struct UserObject*)obj9118;
  uo9154->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9154 = addmethod2pos(obj9118, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9154, 9);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9154[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9154->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9154);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9154->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9154->definitionLine = 2337;
// method "pretty(_)"
  struct UserObject *uo9161 = (struct UserObject*)obj9118;
  uo9161->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9161 = addmethod2pos(obj9118, "pretty(1)", &meth_ast_pretty_40_1_41_9161, 10);
  int argcv_meth_ast_pretty_40_1_41_9161[] = {1};
  meth_meth_ast_pretty_40_1_41_9161->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9161);
  meth_meth_ast_pretty_40_1_41_9161->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9161->definitionLine = 2342;
// method "toGrace(_)"
  struct UserObject *uo9204 = (struct UserObject*)obj9118;
  uo9204->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9204 = addmethod2pos(obj9118, "toGrace(1)", &meth_ast_toGrace_40_1_41_9204, 11);
  int argcv_meth_ast_toGrace_40_1_41_9204[] = {1};
  meth_meth_ast_toGrace_40_1_41_9204->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9204);
meth_meth_ast_toGrace_40_1_41_9204->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9204->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9204->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9204->definitionLine = 2351;
// method "shallowCopy"
  block_savedest(obj9118);
  Object closure9215 = createclosure(1, "shallowCopy");
  setclosureframe(closure9215, stackframe);
  addtoclosure(closure9215, var_dialectNode);
  struct UserObject *uo9215 = (struct UserObject*)obj9118;
  uo9215->data[12] = (Object)closure9215;
  Method *meth_meth_ast_shallowCopy9215 = addmethod2pos(obj9118, "shallowCopy", &meth_ast_shallowCopy9215, 12);
  int argcv_meth_ast_shallowCopy9215[] = {0};
  meth_meth_ast_shallowCopy9215->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9215);
  meth_meth_ast_shallowCopy9215->definitionModule = modulename;
  meth_meth_ast_shallowCopy9215->definitionLine = 2354;
  sourceObject = obj9118;
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9222 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9223 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9224 = gc_frame_new();
// call case 3: self.outer request
  Object call9225 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9224);
// compiled member node returning call9225 (depth = 5)
  Object call9226 = callmethodflags(call9225, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9223);
// compiled member node returning call9226 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9227 = callmethodflags(call9226, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9222);
// compiled call node returning call9227 (depth = 3)
  struct UserObject *obj9118_uo = (struct UserObject *)obj9118;
  obj9118_uo->super = call9227;
  sourceObject = obj9118;
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9228 == NULL) {
    strlit9228 = alloc_String("dialect");
    gc_root(strlit9228);
  }
// compiled string node returning strlit9228 (depth = 3)
  adddatum2(obj9118, strlit9228, 1);
  sourceObject = obj9118;
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj9118, *var_path_39_, 2);
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  sourceObject = obj9118;
  objclass9118 = obj9118->class;
  objclass9118->definitionModule = modulename;
  objclass9118->definitionLine = 2312;
  (*(struct UserObject *)self).data[0] = lowerouter9118;
  self = oldself9118;
  selfslot = oldselfslot9118;
  stackframe = oldstackframe9118;
  gc_frame_end(frame);
  return obj9118;
}
Object meth_ast_dialectNode9230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dialectNode (depth = 3)
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9240 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9241 = callmethodflags(*var_visitor, "visitReturn(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9240);
// compiled call node returning call9241 (depth = 4)
  Object if9239 = done;
  if (istrue(call9241)) {
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9242 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9243 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9242);
// compiled call node returning call9243 (depth = 5)
  *var_newChain = call9243;
  if (call9243 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9244 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9245 = gc_frame_new();
// call case 4: self request
  Object call9246 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9245);
// compiled member node returning call9246 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9247 = callmethodflags(call9246, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9244);
// compiled call node returning call9247 (depth = 4)
    gc_frame_newslot(call9247);
    if9239 = call9247;
  } else {
  }
// compiled if node returning if9239 (depth = 3)
  gc_frame_end(frame);
  return if9239;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9248(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9249 = gc_frame_new();
// call case 4: self request
  Object call9250 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9249);
// compiled member node returning call9250 (depth = 4)
  *var_n = call9250;
  if (call9250 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9251 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9252 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9251);
// compiled call node returning call9252 (depth = 4)
  *var_newChain = call9252;
  if (call9252 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9253 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9254 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9255 = gc_frame_new();
// call case 4: self request
  Object call9256 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9255);
// compiled member node returning call9256 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9257 = callmethodflags(call9256, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9254);
// compiled call node returning call9257 (depth = 4)
  gc_frame_newslot(call9257);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9257;
  partcv[0] = 1;
  Object call9258 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9253);
// compiled call node returning call9258 (depth = 3)
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9259 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9260 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9259);
// compiled call node returning call9260 (depth = 3)
  gc_frame_end(frame);
  return call9260;
}
Object meth_ast__apply_40_1_41_9269(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9271 == NULL) {
    strlit9271 = alloc_String("  ");
    gc_root(strlit9271);
  }
// compiled string node returning strlit9271 (depth = 7)
  int op_slot_right_9270 = gc_frame_newslot(strlit9271);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9270 = gc_frame_newslot(*var_spc);
  params[0] = strlit9271;
  partcv[0] = 1;
  Object opresult9273 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9273 (depth = 6)
  *var_spc = opresult9273;
  if (opresult9273 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9262 == NULL) {
    strlit9262 = alloc_String("");
    gc_root(strlit9262);
  }
// compiled string node returning strlit9262 (depth = 4)
  *var_spc = strlit9262;
  if (strlit9262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9263 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9264 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9266 = alloc_Float64(0);
// compiled num node returning num9266 (depth = 5)
  int op_slot_left_9264 = gc_frame_newslot(num9266);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9267 = callmethod(num9266, "..(1)", 1, partcv, params);
// compiled op node returning opresult9267 (depth = 4)
  gc_frame_newslot(opresult9267);
// starting to compile block node (depth = 4)
  Object block9268 = alloc_Block(NULL, NULL, "ast", 2379);
  gc_frame_newslot(block9268);
// method "_apply(_)"
  block_savedest(block9268);
  Object closure9269 = createclosure(2, "_apply(1)");
  setclosureframe(closure9269, stackframe);
  addtoclosure(closure9269, var_spc);
  addtoclosure(closure9269, selfslot);
  struct UserObject *uo9269 = (struct UserObject*)block9268;
  uo9269->data[0] = (Object)closure9269;
  Method *meth_meth_ast__apply_40_1_41_9269 = addmethod2pos(block9268, "_apply(1)", &meth_ast__apply_40_1_41_9269, 0);
  int argcv_meth_ast__apply_40_1_41_9269[] = {1};
  meth_meth_ast__apply_40_1_41_9269->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9269);
  meth_meth_ast__apply_40_1_41_9269->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9269->definitionLine = 2969;
// compiled block node returning block9268 (depth = 4)
  gc_frame_newslot(block9268);
// call case 5: prelude request
  params[0] = opresult9267;
  params[1] = block9268;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9276 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9263);
// compiled call node returning call9276 (depth = 3)
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9278 == NULL) {
    strlit9278 = alloc_String("""\x0a""");
    gc_root(strlit9278);
  }
// compiled string node returning strlit9278 (depth = 5)
  int op_slot_right_9277 = gc_frame_newslot(strlit9278);
// starting to compile call node (depth = 5)
  int callframe9280 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9281 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9280);
// compiled call node returning call9281 (depth = 5)
  int op_slot_left_9277 = gc_frame_newslot(call9281);
  params[0] = strlit9278;
  partcv[0] = 1;
  Object opresult9282 = callmethod(call9281, "++(1)", 1, partcv, params);
// compiled op node returning opresult9282 (depth = 4)
  *var_s = opresult9282;
  if (opresult9282 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9284 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9286 = alloc_Float64(1);
// compiled num node returning num9286 (depth = 7)
  int op_slot_right_9285 = gc_frame_newslot(num9286);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9285 = gc_frame_newslot(*var_depth);
  params[0] = num9286;
  partcv[0] = 1;
  Object sum9288 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9288 (depth = 6)
  gc_frame_newslot(sum9288);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9289 = gc_frame_new();
// call case 4: self request
  Object call9290 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9289);
// compiled member node returning call9290 (depth = 6)
  params[0] = sum9288;
  partcv[0] = 1;
  Object call9291 = callmethodflags(call9290, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9284);
// compiled call node returning call9291 (depth = 5)
  int op_slot_right_9283 = gc_frame_newslot(call9291);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9293 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9293 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9295 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9295 (depth = 5)
  int op_slot_left_9283 = gc_frame_newslot(opresult9295);
  params[0] = call9291;
  partcv[0] = 1;
  Object opresult9296 = callmethod(opresult9295, "++(1)", 1, partcv, params);
// compiled op node returning opresult9296 (depth = 4)
  *var_s = opresult9296;
  if (opresult9296 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace_40_1_41_9298(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9300 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9301 = gc_frame_new();
// call case 4: self request
  Object call9302 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9301);
// compiled member node returning call9302 (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9303 = callmethodflags(call9302, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9300);
// compiled call node returning call9303 (depth = 4)
  int op_slot_right_9299 = gc_frame_newslot(call9303);
// starting to compile string node (depth = 4)
  if (strlit9305 == NULL) {
    strlit9305 = alloc_String("return ");
    gc_root(strlit9305);
  }
// compiled string node returning strlit9305 (depth = 4)
  int op_slot_left_9299 = gc_frame_newslot(strlit9305);
  params[0] = call9303;
  partcv[0] = 1;
  Object opresult9306 = callmethod(strlit9305, "++(1)", 1, partcv, params);
// compiled op node returning opresult9306 (depth = 3)
  gc_frame_end(frame);
  return opresult9306;
}
Object meth_ast_shallowCopy9307(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9308 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9309 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_returnNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9310 = callmethodflags(*var_returnNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9309);
// compiled call node returning call9310 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9311 = callmethodflags(call9310, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9308);
// compiled call node returning call9311 (depth = 3)
  gc_frame_end(frame);
  return call9311;
}
Object meth_ast_new_40_1_41_9233(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9234 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9234 = alloc_userobj2(8,8, objclass9234);
  gc_frame_newslot(obj9234);
if (objclass9234 == NULL) {
  glfree(obj9234->class->name);
  obj9234->class->name = "returnNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9234, self, 0);
  addmethodreal(obj9234,"outer", &reader_ast_outer_9235);
  Object oldself9234 = self;
  struct StackFrameObject *oldstackframe9234 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9234);
  gc_frame_newslot((Object)stackframe);
  self = obj9234;
  Object *oldselfslot9234 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9234 = (*(struct UserObject *)self).data[0], lowerouter9234 = thisouter9234;
  if (inheritingObject9234) {
    struct UserObject *inho9234 = (struct UserObject *)inheritingObject9234;
    while (inho9234->super != GraceDefaultObject) inho9234 = (struct UserObject *)inho9234->super;
    inho9234->super = obj9234;
    self = inheritingObject9234;
    *selfslot = self;
    lowerouter9234 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9234;
  }
if (objclass9234 == NULL) {
  Method *reader9236 = addmethodrealflags(obj9234, "kind",&reader_ast_kind_9236, MFLAG_DEF);
  reader9236->definitionModule = modulename;
  reader9236->definitionLine = 2362;
}
adddatum2(obj9234, alloc_Undefined(), 1);
if (objclass9234 == NULL) {
  Method *reader9237 = addmethodrealflags(obj9234, "value", &reader_ast_value_9237, 0);
  Method *writer9237 = addmethodrealflags(obj9234, "value:=(1)", &writer_ast_value_9237, 0);
  reader9237->definitionModule = modulename;
  writer9237->definitionModule = modulename;
  reader9237->definitionLine = 2363;
  writer9237->definitionLine = 2363;
}
obj9234->flags |= OFLAG_MUTABLE;
adddatum2(obj9234, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo9238 = (struct UserObject*)obj9234;
  uo9238->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9238 = addmethod2pos(obj9234, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9238, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9238[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9238->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9238);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9238->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9238->definitionLine = 2365;
// method "map(_)ancestors(_)"
  struct UserObject *uo9248 = (struct UserObject*)obj9234;
  uo9248->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9248 = addmethod2pos(obj9234, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9248, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9248[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9248->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9248);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9248->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9248->definitionLine = 2371;
// method "pretty(_)"
  struct UserObject *uo9261 = (struct UserObject*)obj9234;
  uo9261->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9261 = addmethod2pos(obj9234, "pretty(1)", &meth_ast_pretty_40_1_41_9261, 5);
  int argcv_meth_ast_pretty_40_1_41_9261[] = {1};
  meth_meth_ast_pretty_40_1_41_9261->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9261);
  meth_meth_ast_pretty_40_1_41_9261->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9261->definitionLine = 2377;
// method "toGrace(_)"
  struct UserObject *uo9298 = (struct UserObject*)obj9234;
  uo9298->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9298 = addmethod2pos(obj9234, "toGrace(1)", &meth_ast_toGrace_40_1_41_9298, 6);
  int argcv_meth_ast_toGrace_40_1_41_9298[] = {1};
  meth_meth_ast_toGrace_40_1_41_9298->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9298);
meth_meth_ast_toGrace_40_1_41_9298->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9298->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9298->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9298->definitionLine = 2386;
// method "shallowCopy"
  block_savedest(obj9234);
  Object closure9307 = createclosure(2, "shallowCopy");
  setclosureframe(closure9307, stackframe);
  addtoclosure(closure9307, var_nullNode);
  addtoclosure(closure9307, var_returnNode);
  struct UserObject *uo9307 = (struct UserObject*)obj9234;
  uo9307->data[7] = (Object)closure9307;
  Method *meth_meth_ast_shallowCopy9307 = addmethod2pos(obj9234, "shallowCopy", &meth_ast_shallowCopy9307, 7);
  int argcv_meth_ast_shallowCopy9307[] = {0};
  meth_meth_ast_shallowCopy9307->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9307);
  meth_meth_ast_shallowCopy9307->definitionModule = modulename;
  meth_meth_ast_shallowCopy9307->definitionLine = 2389;
  sourceObject = obj9234;
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9312 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9313 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9314 = gc_frame_new();
// call case 3: self.outer request
  Object call9315 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9314);
// compiled member node returning call9315 (depth = 5)
  Object call9316 = callmethodflags(call9315, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9313);
// compiled member node returning call9316 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9317 = callmethodflags(call9316, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9312);
// compiled call node returning call9317 (depth = 3)
  struct UserObject *obj9234_uo = (struct UserObject *)obj9234;
  obj9234_uo->super = call9317;
  sourceObject = obj9234;
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9318 == NULL) {
    strlit9318 = alloc_String("return");
    gc_root(strlit9318);
  }
// compiled string node returning strlit9318 (depth = 3)
  adddatum2(obj9234, strlit9318, 1);
  sourceObject = obj9234;
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9234, *var_expr, 2);
  sourceObject = obj9234;
  sourceObject = obj9234;
  sourceObject = obj9234;
  sourceObject = obj9234;
  sourceObject = obj9234;
  objclass9234 = obj9234->class;
  objclass9234->definitionModule = modulename;
  objclass9234->definitionLine = 2360;
  (*(struct UserObject *)self).data[0] = lowerouter9234;
  self = oldself9234;
  selfslot = oldselfslot9234;
  stackframe = oldstackframe9234;
  gc_frame_end(frame);
  return obj9234;
}
Object meth_ast_new_40_1_41_9233_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9234 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9234 = alloc_userobj2(8,8, objclass9234);
  gc_frame_newslot(obj9234);
if (objclass9234 == NULL) {
  glfree(obj9234->class->name);
  obj9234->class->name = "returnNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9234, self, 0);
  addmethodreal(obj9234,"outer", &reader_ast_outer_9235);
  Object oldself9234 = self;
  struct StackFrameObject *oldstackframe9234 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9234);
  gc_frame_newslot((Object)stackframe);
  self = obj9234;
  Object *oldselfslot9234 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9234 = (*(struct UserObject *)self).data[0], lowerouter9234 = thisouter9234;
  if (inheritingObject9234) {
    struct UserObject *inho9234 = (struct UserObject *)inheritingObject9234;
    while (inho9234->super != GraceDefaultObject) inho9234 = (struct UserObject *)inho9234->super;
    inho9234->super = obj9234;
    self = inheritingObject9234;
    *selfslot = self;
    lowerouter9234 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9234;
  }
if (objclass9234 == NULL) {
  Method *reader9236 = addmethodrealflags(obj9234, "kind",&reader_ast_kind_9236, MFLAG_DEF);
  reader9236->definitionModule = modulename;
  reader9236->definitionLine = 2362;
}
adddatum2(obj9234, alloc_Undefined(), 1);
if (objclass9234 == NULL) {
  Method *reader9237 = addmethodrealflags(obj9234, "value", &reader_ast_value_9237, 0);
  Method *writer9237 = addmethodrealflags(obj9234, "value:=(1)", &writer_ast_value_9237, 0);
  reader9237->definitionModule = modulename;
  writer9237->definitionModule = modulename;
  reader9237->definitionLine = 2363;
  writer9237->definitionLine = 2363;
}
obj9234->flags |= OFLAG_MUTABLE;
adddatum2(obj9234, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo9238 = (struct UserObject*)obj9234;
  uo9238->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9238 = addmethod2pos(obj9234, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9238, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9238[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9238->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9238);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9238->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9238->definitionLine = 2365;
// method "map(_)ancestors(_)"
  struct UserObject *uo9248 = (struct UserObject*)obj9234;
  uo9248->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9248 = addmethod2pos(obj9234, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9248, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9248[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9248->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9248);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9248->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9248->definitionLine = 2371;
// method "pretty(_)"
  struct UserObject *uo9261 = (struct UserObject*)obj9234;
  uo9261->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9261 = addmethod2pos(obj9234, "pretty(1)", &meth_ast_pretty_40_1_41_9261, 5);
  int argcv_meth_ast_pretty_40_1_41_9261[] = {1};
  meth_meth_ast_pretty_40_1_41_9261->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9261);
  meth_meth_ast_pretty_40_1_41_9261->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9261->definitionLine = 2377;
// method "toGrace(_)"
  struct UserObject *uo9298 = (struct UserObject*)obj9234;
  uo9298->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9298 = addmethod2pos(obj9234, "toGrace(1)", &meth_ast_toGrace_40_1_41_9298, 6);
  int argcv_meth_ast_toGrace_40_1_41_9298[] = {1};
  meth_meth_ast_toGrace_40_1_41_9298->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9298);
meth_meth_ast_toGrace_40_1_41_9298->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9298->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9298->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9298->definitionLine = 2386;
// method "shallowCopy"
  block_savedest(obj9234);
  Object closure9307 = createclosure(2, "shallowCopy");
  setclosureframe(closure9307, stackframe);
  addtoclosure(closure9307, var_nullNode);
  addtoclosure(closure9307, var_returnNode);
  struct UserObject *uo9307 = (struct UserObject*)obj9234;
  uo9307->data[7] = (Object)closure9307;
  Method *meth_meth_ast_shallowCopy9307 = addmethod2pos(obj9234, "shallowCopy", &meth_ast_shallowCopy9307, 7);
  int argcv_meth_ast_shallowCopy9307[] = {0};
  meth_meth_ast_shallowCopy9307->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9307);
  meth_meth_ast_shallowCopy9307->definitionModule = modulename;
  meth_meth_ast_shallowCopy9307->definitionLine = 2389;
  sourceObject = obj9234;
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9312 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9313 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9314 = gc_frame_new();
// call case 3: self.outer request
  Object call9315 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9314);
// compiled member node returning call9315 (depth = 5)
  Object call9316 = callmethodflags(call9315, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9313);
// compiled member node returning call9316 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9317 = callmethodflags(call9316, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9312);
// compiled call node returning call9317 (depth = 3)
  struct UserObject *obj9234_uo = (struct UserObject *)obj9234;
  obj9234_uo->super = call9317;
  sourceObject = obj9234;
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9318 == NULL) {
    strlit9318 = alloc_String("return");
    gc_root(strlit9318);
  }
// compiled string node returning strlit9318 (depth = 3)
  adddatum2(obj9234, strlit9318, 1);
  sourceObject = obj9234;
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9234, *var_expr, 2);
  sourceObject = obj9234;
  sourceObject = obj9234;
  sourceObject = obj9234;
  sourceObject = obj9234;
  sourceObject = obj9234;
  objclass9234 = obj9234->class;
  objclass9234->definitionModule = modulename;
  objclass9234->definitionLine = 2360;
  (*(struct UserObject *)self).data[0] = lowerouter9234;
  self = oldself9234;
  selfslot = oldselfslot9234;
  stackframe = oldstackframe9234;
  gc_frame_end(frame);
  return obj9234;
}
Object meth_ast_returnNode9320(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_returnNode (depth = 3)
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_new_40_1_41_scope_40_1_41_9323(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9324 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// call case 4: self request
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call9325 = callmethodflags(self, "new(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9324);
// compiled call node returning call9325 (depth = 4)
  *var_result = call9325;
  if (call9325 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9326 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9327 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9326);
// compiled call node returning call9327 (depth = 3)
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isLegalInTrait9337(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9338 = gc_frame_new();
// call case 4: self request
  Object call9339 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9338);
// compiled member node returning call9339 (depth = 3)
  gc_frame_end(frame);
  return call9339;
}
Object meth_ast_isInherits9340(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9341 = alloc_Boolean(1);
// compiled identifier node returning bool9341 (depth = 3)
  gc_frame_end(frame);
  return bool9341;
}
Object meth_ast_inheritsFromMember9342(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9343 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9344 = gc_frame_new();
// call case 4: self request
  Object call9345 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9344);
// compiled member node returning call9345 (depth = 4)
  Object call9346 = callmethodflags(call9345, "isMember", 0, partcv, params, 0);
  gc_frame_end(callframe9343);
// compiled member node returning call9346 (depth = 3)
  gc_frame_end(frame);
  return call9346;
}
Object meth_ast_inheritsFromCall9347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9348 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9349 = gc_frame_new();
// call case 4: self request
  Object call9350 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9349);
// compiled member node returning call9350 (depth = 4)
  Object call9351 = callmethodflags(call9350, "isCall", 0, partcv, params, 0);
  gc_frame_end(callframe9348);
// compiled member node returning call9351 (depth = 3)
  gc_frame_end(frame);
  return call9351;
}
Object meth_ast_isExecutable9352(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9353 = alloc_Boolean(0);
// compiled identifier node returning bool9353 (depth = 3)
  gc_frame_end(frame);
  return bool9353;
}
Object meth_ast__apply_40_1_41_9366(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9367 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9368 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  Object call9369 = callmethodflags(*var_a, "newName", 0, partcv, params, 0);
  gc_frame_end(callframe9368);
// compiled member node returning call9369 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9370 = callmethodflags(call9369, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9367);
// compiled call node returning call9370 (depth = 6)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9371 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9372 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  Object call9373 = callmethodflags(*var_a, "oldName", 0, partcv, params, 0);
  gc_frame_end(callframe9372);
// compiled member node returning call9373 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9374 = callmethodflags(call9373, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9371);
// compiled call node returning call9374 (depth = 6)
  gc_frame_end(frame);
  return call9374;
}
Object meth_ast__apply_40_1_41_9381(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe9382 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_e (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9383 = callmethodflags(*var_e, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9382);
// compiled call node returning call9383 (depth = 6)
  gc_frame_end(frame);
  return call9383;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9356 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9357 = callmethodflags(*var_visitor, "visitInherits(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9356);
// compiled call node returning call9357 (depth = 4)
  Object if9355 = done;
  if (istrue(call9357)) {
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9358 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9359 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9358);
// compiled call node returning call9359 (depth = 5)
  *var_newChain = call9359;
  if (call9359 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9360 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9361 = gc_frame_new();
// call case 4: self request
  Object call9362 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9361);
// compiled member node returning call9362 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9363 = callmethodflags(call9362, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9360);
// compiled call node returning call9363 (depth = 4)
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9364 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9365 = alloc_Block(NULL, NULL, "ast", 2418);
  gc_frame_newslot(block9365);
// method "_apply(_)"
  block_savedest(block9365);
  Object closure9366 = createclosure(3, "_apply(1)");
  setclosureframe(closure9366, stackframe);
  addtoclosure(closure9366, var_visitor);
  addtoclosure(closure9366, var_newChain);
  addtoclosure(closure9366, selfslot);
  struct UserObject *uo9366 = (struct UserObject*)block9365;
  uo9366->data[0] = (Object)closure9366;
  Method *meth_meth_ast__apply_40_1_41_9366 = addmethod2pos(block9365, "_apply(1)", &meth_ast__apply_40_1_41_9366, 0);
  int argcv_meth_ast__apply_40_1_41_9366[] = {1};
  meth_meth_ast__apply_40_1_41_9366->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9366);
  meth_meth_ast__apply_40_1_41_9366->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9366->definitionLine = 2969;
// compiled block node returning block9365 (depth = 5)
  gc_frame_newslot(block9365);
// call case 6: other requests
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9376 = gc_frame_new();
// call case 4: self request
  Object call9377 = callmethodflags(self, "aliases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9376);
// compiled member node returning call9377 (depth = 5)
  params[0] = block9365;
  partcv[0] = 1;
  Object call9378 = callmethodflags(call9377, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9364);
// compiled call node returning call9378 (depth = 4)
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9379 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9380 = alloc_Block(NULL, NULL, "ast", 2422);
  gc_frame_newslot(block9380);
// method "_apply(_)"
  block_savedest(block9380);
  Object closure9381 = createclosure(3, "_apply(1)");
  setclosureframe(closure9381, stackframe);
  addtoclosure(closure9381, var_visitor);
  addtoclosure(closure9381, var_newChain);
  addtoclosure(closure9381, selfslot);
  struct UserObject *uo9381 = (struct UserObject*)block9380;
  uo9381->data[0] = (Object)closure9381;
  Method *meth_meth_ast__apply_40_1_41_9381 = addmethod2pos(block9380, "_apply(1)", &meth_ast__apply_40_1_41_9381, 0);
  int argcv_meth_ast__apply_40_1_41_9381[] = {1};
  meth_meth_ast__apply_40_1_41_9381->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9381);
  meth_meth_ast__apply_40_1_41_9381->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9381->definitionLine = 2969;
// compiled block node returning block9380 (depth = 5)
  gc_frame_newslot(block9380);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9385 = gc_frame_new();
// call case 4: self request
  Object call9386 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9385);
// compiled member node returning call9386 (depth = 5)
  params[0] = block9380;
  partcv[0] = 1;
  Object call9387 = callmethodflags(call9386, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9379);
// compiled call node returning call9387 (depth = 4)
    gc_frame_newslot(call9387);
    if9355 = call9387;
  } else {
  }
// compiled if node returning if9355 (depth = 3)
  gc_frame_end(frame);
  return if9355;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_9388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9389 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call9390 = callmethodflags(*var_k, "methdec", 0, partcv, params, 0);
  gc_frame_end(callframe9389);
// compiled member node returning call9390 (depth = 3)
  gc_frame_end(frame);
  return call9390;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9391(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9392 = gc_frame_new();
// call case 4: self request
  Object call9393 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9392);
// compiled member node returning call9393 (depth = 4)
  *var_n = call9393;
  if (call9393 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9394 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9395 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9394);
// compiled call node returning call9395 (depth = 4)
  *var_newChain = call9395;
  if (call9395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9396 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9397 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9398 = gc_frame_new();
// call case 4: self request
  Object call9399 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9398);
// compiled member node returning call9399 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9400 = callmethodflags(call9399, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9397);
// compiled call node returning call9400 (depth = 4)
  gc_frame_newslot(call9400);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9400;
  partcv[0] = 1;
  Object call9401 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9396);
// compiled call node returning call9401 (depth = 3)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9402 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9403 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9402);
// compiled call node returning call9403 (depth = 3)
  gc_frame_end(frame);
  return call9403;
}
Object meth_ast__apply_40_1_41_9412(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9414 == NULL) {
    strlit9414 = alloc_String("  ");
    gc_root(strlit9414);
  }
// compiled string node returning strlit9414 (depth = 7)
  int op_slot_right_9413 = gc_frame_newslot(strlit9414);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9413 = gc_frame_newslot(*var_spc);
  params[0] = strlit9414;
  partcv[0] = 1;
  Object opresult9416 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9416 (depth = 6)
  *var_spc = opresult9416;
  if (opresult9416 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9455(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9457 == NULL) {
    strlit9457 = alloc_String("");
    gc_root(strlit9457);
  }
// compiled string node returning strlit9457 (depth = 7)
  int op_slot_right_9456 = gc_frame_newslot(strlit9457);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9460 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9461 = callmethodflags(*var_a, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9460);
// compiled call node returning call9461 (depth = 8)
  int op_slot_right_9459 = gc_frame_newslot(call9461);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9464 == NULL) {
    strlit9464 = alloc_String("""\x0a""");
    gc_root(strlit9464);
  }
// compiled string node returning strlit9464 (depth = 9)
  int op_slot_right_9463 = gc_frame_newslot(strlit9464);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9466 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9468 == NULL) {
    strlit9468 = alloc_String("");
    gc_root(strlit9468);
  }
// compiled string node returning strlit9468 (depth = 10)
  int op_slot_left_9466 = gc_frame_newslot(strlit9468);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9469 = callmethod(strlit9468, "++(1)", 1, partcv, params);
// compiled op node returning opresult9469 (depth = 9)
  int op_slot_left_9463 = gc_frame_newslot(opresult9469);
  params[0] = strlit9464;
  partcv[0] = 1;
  Object opresult9470 = callmethod(opresult9469, "++(1)", 1, partcv, params);
// compiled op node returning opresult9470 (depth = 8)
  int op_slot_left_9459 = gc_frame_newslot(opresult9470);
  params[0] = call9461;
  partcv[0] = 1;
  Object opresult9471 = callmethod(opresult9470, "++(1)", 1, partcv, params);
// compiled op node returning opresult9471 (depth = 7)
  int op_slot_left_9456 = gc_frame_newslot(opresult9471);
  params[0] = strlit9457;
  partcv[0] = 1;
  Object opresult9472 = callmethod(opresult9471, "++(1)", 1, partcv, params);
// compiled op node returning opresult9472 (depth = 6)
  *var_s = opresult9472;
  if (opresult9472 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9503(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9505 == NULL) {
    strlit9505 = alloc_String(" ");
    gc_root(strlit9505);
  }
// compiled string node returning strlit9505 (depth = 7)
  int op_slot_right_9504 = gc_frame_newslot(strlit9505);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_e (depth = 8)
  int op_slot_right_9507 = gc_frame_newslot(*var_e);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9510 == NULL) {
    strlit9510 = alloc_String(" exclude ");
    gc_root(strlit9510);
  }
// compiled string node returning strlit9510 (depth = 9)
  int op_slot_right_9509 = gc_frame_newslot(strlit9510);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9512 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9514 == NULL) {
    strlit9514 = alloc_String("");
    gc_root(strlit9514);
  }
// compiled string node returning strlit9514 (depth = 10)
  int op_slot_left_9512 = gc_frame_newslot(strlit9514);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9515 = callmethod(strlit9514, "++(1)", 1, partcv, params);
// compiled op node returning opresult9515 (depth = 9)
  int op_slot_left_9509 = gc_frame_newslot(opresult9515);
  params[0] = strlit9510;
  partcv[0] = 1;
  Object opresult9516 = callmethod(opresult9515, "++(1)", 1, partcv, params);
// compiled op node returning opresult9516 (depth = 8)
  int op_slot_left_9507 = gc_frame_newslot(opresult9516);
  params[0] = *var_e;
  partcv[0] = 1;
  Object opresult9517 = callmethod(opresult9516, "++(1)", 1, partcv, params);
// compiled op node returning opresult9517 (depth = 7)
  int op_slot_left_9504 = gc_frame_newslot(opresult9517);
  params[0] = strlit9505;
  partcv[0] = 1;
  Object opresult9518 = callmethod(opresult9517, "++(1)", 1, partcv, params);
// compiled op node returning opresult9518 (depth = 6)
  *var_s = opresult9518;
  if (opresult9518 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9404(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9405 == NULL) {
    strlit9405 = alloc_String("");
    gc_root(strlit9405);
  }
// compiled string node returning strlit9405 (depth = 4)
  *var_spc = strlit9405;
  if (strlit9405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9406 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9407 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9409 = alloc_Float64(0);
// compiled num node returning num9409 (depth = 5)
  int op_slot_left_9407 = gc_frame_newslot(num9409);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9410 = callmethod(num9409, "..(1)", 1, partcv, params);
// compiled op node returning opresult9410 (depth = 4)
  gc_frame_newslot(opresult9410);
// starting to compile block node (depth = 4)
  Object block9411 = alloc_Block(NULL, NULL, "ast", 2439);
  gc_frame_newslot(block9411);
// method "_apply(_)"
  block_savedest(block9411);
  Object closure9412 = createclosure(2, "_apply(1)");
  setclosureframe(closure9412, stackframe);
  addtoclosure(closure9412, var_spc);
  addtoclosure(closure9412, selfslot);
  struct UserObject *uo9412 = (struct UserObject*)block9411;
  uo9412->data[0] = (Object)closure9412;
  Method *meth_meth_ast__apply_40_1_41_9412 = addmethod2pos(block9411, "_apply(1)", &meth_ast__apply_40_1_41_9412, 0);
  int argcv_meth_ast__apply_40_1_41_9412[] = {1};
  meth_meth_ast__apply_40_1_41_9412->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9412);
  meth_meth_ast__apply_40_1_41_9412->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9412->definitionLine = 2969;
// compiled block node returning block9411 (depth = 4)
  gc_frame_newslot(block9411);
// call case 5: prelude request
  params[0] = opresult9410;
  params[1] = block9411;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9419 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9406);
// compiled call node returning call9419 (depth = 3)
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9420 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9421 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9420);
// compiled call node returning call9421 (depth = 4)
  *var_s = call9421;
  if (call9421 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9423 = gc_frame_new();
// call case 4: self request
  Object call9424 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9423);
// compiled member node returning call9424 (depth = 4)
  Object if9422 = done;
  if (istrue(call9424)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9426 == NULL) {
    strlit9426 = alloc_String(" (use)");
    gc_root(strlit9426);
  }
// compiled string node returning strlit9426 (depth = 6)
  int op_slot_right_9425 = gc_frame_newslot(strlit9426);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_9428 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 7)
  if (strlit9430 == NULL) {
    strlit9430 = alloc_String("");
    gc_root(strlit9430);
  }
// compiled string node returning strlit9430 (depth = 7)
  int op_slot_left_9428 = gc_frame_newslot(strlit9430);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9431 = callmethod(strlit9430, "++(1)", 1, partcv, params);
// compiled op node returning opresult9431 (depth = 6)
  int op_slot_left_9425 = gc_frame_newslot(opresult9431);
  params[0] = strlit9426;
  partcv[0] = 1;
  Object opresult9432 = callmethod(opresult9431, "++(1)", 1, partcv, params);
// compiled op node returning opresult9432 (depth = 5)
  *var_s = opresult9432;
  if (opresult9432 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9422 = done;
  } else {
  }
// compiled if node returning if9422 (depth = 3)
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9435 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9437 = alloc_Float64(1);
// compiled num node returning num9437 (depth = 7)
  int op_slot_right_9436 = gc_frame_newslot(num9437);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9436 = gc_frame_newslot(*var_depth);
  params[0] = num9437;
  partcv[0] = 1;
  Object sum9439 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9439 (depth = 6)
  gc_frame_newslot(sum9439);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9440 = gc_frame_new();
// call case 4: self request
  Object call9441 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9440);
// compiled member node returning call9441 (depth = 6)
  params[0] = sum9439;
  partcv[0] = 1;
  Object call9442 = callmethodflags(call9441, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9435);
// compiled call node returning call9442 (depth = 5)
  int op_slot_right_9434 = gc_frame_newslot(call9442);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9444 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9447 == NULL) {
    strlit9447 = alloc_String("""\x0a""");
    gc_root(strlit9447);
  }
// compiled string node returning strlit9447 (depth = 7)
  int op_slot_right_9446 = gc_frame_newslot(strlit9447);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9446 = gc_frame_newslot(*var_s);
  params[0] = strlit9447;
  partcv[0] = 1;
  Object opresult9449 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9449 (depth = 6)
  int op_slot_left_9444 = gc_frame_newslot(opresult9449);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9450 = callmethod(opresult9449, "++(1)", 1, partcv, params);
// compiled op node returning opresult9450 (depth = 5)
  int op_slot_left_9434 = gc_frame_newslot(opresult9450);
  params[0] = call9442;
  partcv[0] = 1;
  Object opresult9451 = callmethod(opresult9450, "++(1)", 1, partcv, params);
// compiled op node returning opresult9451 (depth = 4)
  *var_s = opresult9451;
  if (opresult9451 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9453 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9454 = alloc_Block(NULL, NULL, "ast", 2445);
  gc_frame_newslot(block9454);
// method "_apply(_)"
  block_savedest(block9454);
  Object closure9455 = createclosure(3, "_apply(1)");
  setclosureframe(closure9455, stackframe);
  addtoclosure(closure9455, var_depth);
  addtoclosure(closure9455, var_s);
  addtoclosure(closure9455, selfslot);
  struct UserObject *uo9455 = (struct UserObject*)block9454;
  uo9455->data[0] = (Object)closure9455;
  Method *meth_meth_ast__apply_40_1_41_9455 = addmethod2pos(block9454, "_apply(1)", &meth_ast__apply_40_1_41_9455, 0);
  int argcv_meth_ast__apply_40_1_41_9455[] = {1};
  meth_meth_ast__apply_40_1_41_9455->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9455);
  meth_meth_ast__apply_40_1_41_9455->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9455->definitionLine = 2969;
// compiled block node returning block9454 (depth = 4)
  gc_frame_newslot(block9454);
// call case 6: other requests
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9475 = gc_frame_new();
// call case 4: self request
  Object call9476 = callmethodflags(self, "aliases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9475);
// compiled member node returning call9476 (depth = 4)
  params[0] = block9454;
  partcv[0] = 1;
  Object call9477 = callmethodflags(call9476, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9453);
// compiled call node returning call9477 (depth = 3)
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9479 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9480 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9481 = gc_frame_new();
// call case 4: self request
  Object call9482 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9481);
// compiled member node returning call9482 (depth = 6)
  Object call9483 = callmethodflags(call9482, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9480);
// compiled member node returning call9483 (depth = 5)
  Object call9484 = callmethodflags(call9483, "not", 0, partcv, params, 0);
  gc_frame_end(callframe9479);
// compiled member node returning call9484 (depth = 4)
  Object if9478 = done;
  if (istrue(call9484)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9486 == NULL) {
    strlit9486 = alloc_String("");
    gc_root(strlit9486);
  }
// compiled string node returning strlit9486 (depth = 6)
  int op_slot_right_9485 = gc_frame_newslot(strlit9486);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9488 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9491 == NULL) {
    strlit9491 = alloc_String("""\x0a""");
    gc_root(strlit9491);
  }
// compiled string node returning strlit9491 (depth = 8)
  int op_slot_right_9490 = gc_frame_newslot(strlit9491);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9493 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9495 == NULL) {
    strlit9495 = alloc_String("");
    gc_root(strlit9495);
  }
// compiled string node returning strlit9495 (depth = 9)
  int op_slot_left_9493 = gc_frame_newslot(strlit9495);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9496 = callmethod(strlit9495, "++(1)", 1, partcv, params);
// compiled op node returning opresult9496 (depth = 8)
  int op_slot_left_9490 = gc_frame_newslot(opresult9496);
  params[0] = strlit9491;
  partcv[0] = 1;
  Object opresult9497 = callmethod(opresult9496, "++(1)", 1, partcv, params);
// compiled op node returning opresult9497 (depth = 7)
  int op_slot_left_9488 = gc_frame_newslot(opresult9497);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9498 = callmethod(opresult9497, "++(1)", 1, partcv, params);
// compiled op node returning opresult9498 (depth = 6)
  int op_slot_left_9485 = gc_frame_newslot(opresult9498);
  params[0] = strlit9486;
  partcv[0] = 1;
  Object opresult9499 = callmethod(opresult9498, "++(1)", 1, partcv, params);
// compiled op node returning opresult9499 (depth = 5)
  *var_s = opresult9499;
  if (opresult9499 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9478 = done;
  } else {
  }
// compiled if node returning if9478 (depth = 3)
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9501 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9502 = alloc_Block(NULL, NULL, "ast", 2449);
  gc_frame_newslot(block9502);
// method "_apply(_)"
  block_savedest(block9502);
  Object closure9503 = createclosure(2, "_apply(1)");
  setclosureframe(closure9503, stackframe);
  addtoclosure(closure9503, var_s);
  addtoclosure(closure9503, selfslot);
  struct UserObject *uo9503 = (struct UserObject*)block9502;
  uo9503->data[0] = (Object)closure9503;
  Method *meth_meth_ast__apply_40_1_41_9503 = addmethod2pos(block9502, "_apply(1)", &meth_ast__apply_40_1_41_9503, 0);
  int argcv_meth_ast__apply_40_1_41_9503[] = {1};
  meth_meth_ast__apply_40_1_41_9503->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9503);
  meth_meth_ast__apply_40_1_41_9503->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9503->definitionLine = 2969;
// compiled block node returning block9502 (depth = 4)
  gc_frame_newslot(block9502);
// call case 6: other requests
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9521 = gc_frame_new();
// call case 4: self request
  Object call9522 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9521);
// compiled member node returning call9522 (depth = 4)
  params[0] = block9502;
  partcv[0] = 1;
  Object call9523 = callmethodflags(call9522, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9501);
// compiled call node returning call9523 (depth = 3)
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9525 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9526 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9527 = gc_frame_new();
// call case 4: self request
  Object call9528 = callmethodflags(self, "providedNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9527);
// compiled member node returning call9528 (depth = 6)
  Object call9529 = callmethodflags(call9528, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9526);
// compiled member node returning call9529 (depth = 5)
  Object call9530 = callmethodflags(call9529, "not", 0, partcv, params, 0);
  gc_frame_end(callframe9525);
// compiled member node returning call9530 (depth = 4)
  Object if9524 = done;
  if (istrue(call9530)) {
// Begin line 2453
  setline(2453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9533 == NULL) {
    strlit9533 = alloc_String("");
    gc_root(strlit9533);
  }
// compiled string node returning strlit9533 (depth = 7)
  int op_slot_right_9532 = gc_frame_newslot(strlit9533);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9536 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe9537 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe9538 = gc_frame_new();
// call case 4: self request
  Object call9539 = callmethodflags(self, "providedNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9538);
// compiled member node returning call9539 (depth = 10)
  Object call9540 = callmethodflags(call9539, "asList", 0, partcv, params, 0);
  gc_frame_end(callframe9537);
// compiled member node returning call9540 (depth = 9)
  Object call9541 = callmethodflags(call9540, "sort", 0, partcv, params, 0);
  gc_frame_end(callframe9536);
// compiled member node returning call9541 (depth = 8)
  int op_slot_right_9535 = gc_frame_newslot(call9541);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9544 == NULL) {
    strlit9544 = alloc_String("Provided names: ");
    gc_root(strlit9544);
  }
// compiled string node returning strlit9544 (depth = 9)
  int op_slot_right_9543 = gc_frame_newslot(strlit9544);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9546 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9548 == NULL) {
    strlit9548 = alloc_String("""\x0a""");
    gc_root(strlit9548);
  }
// compiled string node returning strlit9548 (depth = 10)
  int op_slot_left_9546 = gc_frame_newslot(strlit9548);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9549 = callmethod(strlit9548, "++(1)", 1, partcv, params);
// compiled op node returning opresult9549 (depth = 9)
  int op_slot_left_9543 = gc_frame_newslot(opresult9549);
  params[0] = strlit9544;
  partcv[0] = 1;
  Object opresult9550 = callmethod(opresult9549, "++(1)", 1, partcv, params);
// compiled op node returning opresult9550 (depth = 8)
  int op_slot_left_9535 = gc_frame_newslot(opresult9550);
  params[0] = call9541;
  partcv[0] = 1;
  Object opresult9551 = callmethod(opresult9550, "++(1)", 1, partcv, params);
// compiled op node returning opresult9551 (depth = 7)
  int op_slot_left_9532 = gc_frame_newslot(opresult9551);
  params[0] = strlit9533;
  partcv[0] = 1;
  Object opresult9552 = callmethod(opresult9551, "++(1)", 1, partcv, params);
// compiled op node returning opresult9552 (depth = 6)
  int op_slot_right_9531 = gc_frame_newslot(opresult9552);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9531 = gc_frame_newslot(*var_s);
  params[0] = opresult9552;
  partcv[0] = 1;
  Object opresult9554 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9554 (depth = 5)
  *var_s = opresult9554;
  if (opresult9554 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9524 = done;
  } else {
  }
// compiled if node returning if9524 (depth = 3)
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply9560(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9562 == NULL) {
    strlit9562 = alloc_String("    ");
    gc_root(strlit9562);
  }
// compiled string node returning strlit9562 (depth = 7)
  int op_slot_right_9561 = gc_frame_newslot(strlit9562);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9561 = gc_frame_newslot(*var_s);
  params[0] = strlit9562;
  partcv[0] = 1;
  Object opresult9564 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9564 (depth = 6)
  *var_s = opresult9564;
  if (opresult9564 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9588(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9590 == NULL) {
    strlit9590 = alloc_String(" ");
    gc_root(strlit9590);
  }
// compiled string node returning strlit9590 (depth = 7)
  int op_slot_right_9589 = gc_frame_newslot(strlit9590);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_right_9592 = gc_frame_newslot(*var_a);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9595 == NULL) {
    strlit9595 = alloc_String(" ");
    gc_root(strlit9595);
  }
// compiled string node returning strlit9595 (depth = 9)
  int op_slot_right_9594 = gc_frame_newslot(strlit9595);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9597 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9599 == NULL) {
    strlit9599 = alloc_String("");
    gc_root(strlit9599);
  }
// compiled string node returning strlit9599 (depth = 10)
  int op_slot_left_9597 = gc_frame_newslot(strlit9599);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9600 = callmethod(strlit9599, "++(1)", 1, partcv, params);
// compiled op node returning opresult9600 (depth = 9)
  int op_slot_left_9594 = gc_frame_newslot(opresult9600);
  params[0] = strlit9595;
  partcv[0] = 1;
  Object opresult9601 = callmethod(opresult9600, "++(1)", 1, partcv, params);
// compiled op node returning opresult9601 (depth = 8)
  int op_slot_left_9592 = gc_frame_newslot(opresult9601);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult9602 = callmethod(opresult9601, "++(1)", 1, partcv, params);
// compiled op node returning opresult9602 (depth = 7)
  int op_slot_left_9589 = gc_frame_newslot(opresult9602);
  params[0] = strlit9590;
  partcv[0] = 1;
  Object opresult9603 = callmethod(opresult9602, "++(1)", 1, partcv, params);
// compiled op node returning opresult9603 (depth = 6)
  *var_s = opresult9603;
  if (opresult9603 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9611(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9613 == NULL) {
    strlit9613 = alloc_String(" ");
    gc_root(strlit9613);
  }
// compiled string node returning strlit9613 (depth = 7)
  int op_slot_right_9612 = gc_frame_newslot(strlit9613);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9616 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_e (depth = 9)
  Object call9617 = callmethodflags(*var_e, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe9616);
// compiled member node returning call9617 (depth = 8)
  int op_slot_right_9615 = gc_frame_newslot(call9617);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9620 == NULL) {
    strlit9620 = alloc_String(" exclude ");
    gc_root(strlit9620);
  }
// compiled string node returning strlit9620 (depth = 9)
  int op_slot_right_9619 = gc_frame_newslot(strlit9620);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9622 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9624 == NULL) {
    strlit9624 = alloc_String("");
    gc_root(strlit9624);
  }
// compiled string node returning strlit9624 (depth = 10)
  int op_slot_left_9622 = gc_frame_newslot(strlit9624);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9625 = callmethod(strlit9624, "++(1)", 1, partcv, params);
// compiled op node returning opresult9625 (depth = 9)
  int op_slot_left_9619 = gc_frame_newslot(opresult9625);
  params[0] = strlit9620;
  partcv[0] = 1;
  Object opresult9626 = callmethod(opresult9625, "++(1)", 1, partcv, params);
// compiled op node returning opresult9626 (depth = 8)
  int op_slot_left_9615 = gc_frame_newslot(opresult9626);
  params[0] = call9617;
  partcv[0] = 1;
  Object opresult9627 = callmethod(opresult9626, "++(1)", 1, partcv, params);
// compiled op node returning opresult9627 (depth = 7)
  int op_slot_left_9612 = gc_frame_newslot(opresult9627);
  params[0] = strlit9613;
  partcv[0] = 1;
  Object opresult9628 = callmethod(opresult9627, "++(1)", 1, partcv, params);
// compiled op node returning opresult9628 (depth = 6)
  *var_s = opresult9628;
  if (opresult9628 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_9556(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9557 == NULL) {
    strlit9557 = alloc_String("");
    gc_root(strlit9557);
  }
// compiled string node returning strlit9557 (depth = 4)
  *var_s = strlit9557;
  if (strlit9557 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9558 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block9559 = alloc_Block(NULL, NULL, "ast", 2459);
  gc_frame_newslot(block9559);
// method "_apply"
  block_savedest(block9559);
  Object closure9560 = createclosure(2, "_apply");
  setclosureframe(closure9560, stackframe);
  addtoclosure(closure9560, var_s);
  addtoclosure(closure9560, selfslot);
  struct UserObject *uo9560 = (struct UserObject*)block9559;
  uo9560->data[0] = (Object)closure9560;
  Method *meth_meth_ast__apply9560 = addmethod2pos(block9559, "_apply", &meth_ast__apply9560, 0);
  int argcv_meth_ast__apply9560[] = {0};
  meth_meth_ast__apply9560->type = alloc_MethodType(1, argcv_meth_ast__apply9560);
  meth_meth_ast__apply9560->definitionModule = modulename;
  meth_meth_ast__apply9560->definitionLine = 2969;
// compiled block node returning block9559 (depth = 4)
  gc_frame_newslot(block9559);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block9559;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9567 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9558);
// compiled call node returning call9567 (depth = 3)
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9570 = gc_frame_new();
// call case 4: self request
  Object call9571 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9570);
// compiled member node returning call9571 (depth = 6)
  Object if9569 = done;
struct StackFrameObject *iftmpstackframe9569 = stackframe;
  if (istrue(call9571)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9569);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit9572 == NULL) {
    strlit9572 = alloc_String("use ");
    gc_root(strlit9572);
  }
// compiled string node returning strlit9572 (depth = 6)
    gc_frame_newslot(strlit9572);
    if9569 = strlit9572;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9569);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit9573 == NULL) {
    strlit9573 = alloc_String("inherit ");
    gc_root(strlit9573);
  }
// compiled string node returning strlit9573 (depth = 6)
    gc_frame_newslot(strlit9573);
    if9569 = strlit9573;
  }
stackframe = iftmpstackframe9569;
// compiled if node returning if9569 (depth = 5)
  int op_slot_right_9568 = gc_frame_newslot(if9569);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9568 = gc_frame_newslot(*var_s);
  params[0] = if9569;
  partcv[0] = 1;
  Object opresult9575 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9575 (depth = 4)
  *var_s = opresult9575;
  if (opresult9575 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9578 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num9579 = alloc_Float64(0);
// compiled num node returning num9579 (depth = 6)
  gc_frame_newslot(num9579);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9580 = gc_frame_new();
// call case 4: self request
  Object call9581 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9580);
// compiled member node returning call9581 (depth = 6)
  params[0] = num9579;
  partcv[0] = 1;
  Object call9582 = callmethodflags(call9581, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9578);
// compiled call node returning call9582 (depth = 5)
  int op_slot_right_9577 = gc_frame_newslot(call9582);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9577 = gc_frame_newslot(*var_s);
  params[0] = call9582;
  partcv[0] = 1;
  Object opresult9584 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9584 (depth = 4)
  *var_s = opresult9584;
  if (opresult9584 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9586 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9587 = alloc_Block(NULL, NULL, "ast", 2464);
  gc_frame_newslot(block9587);
// method "_apply(_)"
  block_savedest(block9587);
  Object closure9588 = createclosure(2, "_apply(1)");
  setclosureframe(closure9588, stackframe);
  addtoclosure(closure9588, var_s);
  addtoclosure(closure9588, selfslot);
  struct UserObject *uo9588 = (struct UserObject*)block9587;
  uo9588->data[0] = (Object)closure9588;
  Method *meth_meth_ast__apply_40_1_41_9588 = addmethod2pos(block9587, "_apply(1)", &meth_ast__apply_40_1_41_9588, 0);
  int argcv_meth_ast__apply_40_1_41_9588[] = {1};
  meth_meth_ast__apply_40_1_41_9588->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9588);
  meth_meth_ast__apply_40_1_41_9588->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9588->definitionLine = 2969;
// compiled block node returning block9587 (depth = 4)
  gc_frame_newslot(block9587);
// call case 6: other requests
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9606 = gc_frame_new();
// call case 4: self request
  Object call9607 = callmethodflags(self, "aliases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9606);
// compiled member node returning call9607 (depth = 4)
  params[0] = block9587;
  partcv[0] = 1;
  Object call9608 = callmethodflags(call9607, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9586);
// compiled call node returning call9608 (depth = 3)
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9609 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9610 = alloc_Block(NULL, NULL, "ast", 2467);
  gc_frame_newslot(block9610);
// method "_apply(_)"
  block_savedest(block9610);
  Object closure9611 = createclosure(2, "_apply(1)");
  setclosureframe(closure9611, stackframe);
  addtoclosure(closure9611, var_s);
  addtoclosure(closure9611, selfslot);
  struct UserObject *uo9611 = (struct UserObject*)block9610;
  uo9611->data[0] = (Object)closure9611;
  Method *meth_meth_ast__apply_40_1_41_9611 = addmethod2pos(block9610, "_apply(1)", &meth_ast__apply_40_1_41_9611, 0);
  int argcv_meth_ast__apply_40_1_41_9611[] = {1};
  meth_meth_ast__apply_40_1_41_9611->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9611);
  meth_meth_ast__apply_40_1_41_9611->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9611->definitionLine = 2969;
// compiled block node returning block9610 (depth = 4)
  gc_frame_newslot(block9610);
// call case 6: other requests
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9631 = gc_frame_new();
// call case 4: self request
  Object call9632 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9631);
// compiled member node returning call9632 (depth = 4)
  params[0] = block9610;
  partcv[0] = 1;
  Object call9633 = callmethodflags(call9632, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9609);
// compiled call node returning call9633 (depth = 3)
// Begin line 2470
  setline(2470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString9634(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9636 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num9637 = alloc_Float64(0);
// compiled num node returning num9637 (depth = 5)
  gc_frame_newslot(num9637);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9638 = gc_frame_new();
// call case 4: self request
  Object call9639 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9638);
// compiled member node returning call9639 (depth = 5)
  params[0] = num9637;
  partcv[0] = 1;
  Object call9640 = callmethodflags(call9639, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9636);
// compiled call node returning call9640 (depth = 4)
  int op_slot_right_9635 = gc_frame_newslot(call9640);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9643 = gc_frame_new();
// call case 4: self request
  Object call9644 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9643);
// compiled member node returning call9644 (depth = 5)
  Object if9642 = done;
struct StackFrameObject *iftmpstackframe9642 = stackframe;
  if (istrue(call9644)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9642);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9645 == NULL) {
    strlit9645 = alloc_String("use ");
    gc_root(strlit9645);
  }
// compiled string node returning strlit9645 (depth = 5)
    gc_frame_newslot(strlit9645);
    if9642 = strlit9645;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9642);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9646 == NULL) {
    strlit9646 = alloc_String("inherit ");
    gc_root(strlit9646);
  }
// compiled string node returning strlit9646 (depth = 5)
    gc_frame_newslot(strlit9646);
    if9642 = strlit9646;
  }
stackframe = iftmpstackframe9642;
// compiled if node returning if9642 (depth = 4)
  int op_slot_left_9635 = gc_frame_newslot(if9642);
  params[0] = call9640;
  partcv[0] = 1;
  Object opresult9647 = callmethod(if9642, "++(1)", 1, partcv, params);
// compiled op node returning opresult9647 (depth = 3)
  gc_frame_end(frame);
  return opresult9647;
}
Object meth_ast_nameString9648(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9649 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num9650 = alloc_Float64(0);
// compiled num node returning num9650 (depth = 4)
  gc_frame_newslot(num9650);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9651 = gc_frame_new();
// call case 4: self request
  Object call9652 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9651);
// compiled member node returning call9652 (depth = 4)
  params[0] = num9650;
  partcv[0] = 1;
  Object call9653 = callmethodflags(call9652, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9649);
// compiled call node returning call9653 (depth = 3)
  gc_frame_end(frame);
  return call9653;
}
Object meth_ast_addAlias_40_1_41_for_40_1_41_9654(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAlias(1)for(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias(_)for(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias(_)for(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addAlias(_)for(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_newName = &(stackframe->slots[0]);
  *var_newName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAlias(_)");
  Object *var_oldName = &(stackframe->slots[1]);
  *var_oldName = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part for(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2477
  setline(2477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9655 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9656 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newName (depth = 5)
  gc_frame_newslot(*var_newName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldName (depth = 5)
  gc_frame_newslot(*var_oldName);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9657 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9658 = gc_frame_new();
// call case 3: self.outer request
  Object call9659 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9658);
// compiled member node returning call9659 (depth = 6)
  Object call9660 = callmethodflags(call9659, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9657);
// compiled member node returning call9660 (depth = 5)
  params[0] = *var_newName;
  params[1] = *var_oldName;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9661 = callmethodflags(call9660, "aliasNew(1)old(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9656);
// compiled call node returning call9661 (depth = 4)
  gc_frame_newslot(call9661);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9662 = gc_frame_new();
// call case 4: self request
  Object call9663 = callmethodflags(self, "aliases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9662);
// compiled member node returning call9663 (depth = 4)
  params[0] = call9661;
  partcv[0] = 1;
  Object call9664 = callmethodflags(call9663, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9655);
// compiled call node returning call9664 (depth = 3)
  gc_frame_end(frame);
  return call9664;
}
Object meth_ast_addExclusion_40_1_41_9665(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addExclusion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addExclusion(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addExclusion(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ident = &(stackframe->slots[0]);
  *var_ident = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addExclusion(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9666 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ident (depth = 4)
  gc_frame_newslot(*var_ident);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9667 = gc_frame_new();
// call case 4: self request
  Object call9668 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9667);
// compiled member node returning call9668 (depth = 4)
  params[0] = *var_ident;
  partcv[0] = 1;
  Object call9669 = callmethodflags(call9668, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9666);
// compiled call node returning call9669 (depth = 3)
  gc_frame_end(frame);
  return call9669;
}
Object meth_ast_shallowCopy9670(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9671 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9672 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inheritsNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9673 = callmethodflags(*var_inheritsNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9672);
// compiled call node returning call9673 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9674 = callmethodflags(call9673, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9671);
// compiled call node returning call9674 (depth = 3)
  gc_frame_end(frame);
  return call9674;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_9675(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9676 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call9677 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9676);
// compiled call node returning call9677 (depth = 3)
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9678 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9679 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call9680 = callmethodflags(*var_other, "providedNames", 0, partcv, params, 0);
  gc_frame_end(callframe9679);
// compiled member node returning call9680 (depth = 4)
  gc_frame_newslot(call9680);
// call case 4: self request
  params[0] = call9680;
  partcv[0] = 1;
  Object call9681 = callmethodflags(self, "providedNames:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9678);
// compiled call node returning call9681 (depth = 3)
// Begin line 2488
  setline(2488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9682 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9683 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call9684 = callmethodflags(*var_other, "aliases", 0, partcv, params, 0);
  gc_frame_end(callframe9683);
// compiled member node returning call9684 (depth = 4)
  gc_frame_newslot(call9684);
// call case 4: self request
  params[0] = call9684;
  partcv[0] = 1;
  Object call9685 = callmethodflags(self, "aliases:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9682);
// compiled call node returning call9685 (depth = 3)
// Begin line 2489
  setline(2489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9686 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9687 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call9688 = callmethodflags(*var_other, "exclusions", 0, partcv, params, 0);
  gc_frame_end(callframe9687);
// compiled member node returning call9688 (depth = 4)
  gc_frame_newslot(call9688);
// call case 4: self request
  params[0] = call9688;
  partcv[0] = 1;
  Object call9689 = callmethodflags(self, "exclusions:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9686);
// compiled call node returning call9689 (depth = 3)
// Begin line 2490
  setline(2490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9690 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9691 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call9692 = callmethodflags(*var_other, "isUse", 0, partcv, params, 0);
  gc_frame_end(callframe9691);
// compiled member node returning call9692 (depth = 4)
  gc_frame_newslot(call9692);
// call case 4: self request
  params[0] = call9692;
  partcv[0] = 1;
  Object call9693 = callmethodflags(self, "isUse:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9690);
// compiled call node returning call9693 (depth = 3)
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName9694(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9696 = gc_frame_new();
// call case 4: self request
  Object call9697 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9696);
// compiled member node returning call9697 (depth = 4)
  Object if9695 = done;
  if (istrue(call9697)) {
// starting to compile string node (depth = 4)
  if (strlit9698 == NULL) {
    strlit9698 = alloc_String("use");
    gc_root(strlit9698);
  }
// compiled string node returning strlit9698 (depth = 4)
    gc_frame_newslot(strlit9698);
    if9695 = strlit9698;
  } else {
// starting to compile string node (depth = 4)
  if (strlit9699 == NULL) {
    strlit9699 = alloc_String("inherit");
    gc_root(strlit9699);
  }
// compiled string node returning strlit9699 (depth = 4)
    gc_frame_newslot(strlit9699);
    if9695 = strlit9699;
  }
// compiled if node returning if9695 (depth = 3)
  gc_frame_end(frame);
  return if9695;
}
Object meth_ast_new_40_1_41_9328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritsNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9329 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9329 = alloc_userobj2(28,24, objclass9329);
  gc_frame_newslot(obj9329);
if (objclass9329 == NULL) {
  glfree(obj9329->class->name);
  obj9329->class->name = "inheritsNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9329, self, 0);
  addmethodreal(obj9329,"outer", &reader_ast_outer_9330);
  Object oldself9329 = self;
  struct StackFrameObject *oldstackframe9329 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9329);
  gc_frame_newslot((Object)stackframe);
  self = obj9329;
  Object *oldselfslot9329 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9329 = (*(struct UserObject *)self).data[0], lowerouter9329 = thisouter9329;
  if (inheritingObject9329) {
    struct UserObject *inho9329 = (struct UserObject *)inheritingObject9329;
    while (inho9329->super != GraceDefaultObject) inho9329 = (struct UserObject *)inho9329->super;
    inho9329->super = obj9329;
    self = inheritingObject9329;
    *selfslot = self;
    lowerouter9329 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9329;
  }
if (objclass9329 == NULL) {
  Method *reader9331 = addmethodrealflags(obj9329, "kind",&reader_ast_kind_9331, MFLAG_DEF);
  reader9331->definitionModule = modulename;
  reader9331->definitionLine = 2402;
}
adddatum2(obj9329, alloc_Undefined(), 1);
if (objclass9329 == NULL) {
  Method *reader9332 = addmethodrealflags(obj9329, "value", &reader_ast_value_9332, 0);
  Method *writer9332 = addmethodrealflags(obj9329, "value:=(1)", &writer_ast_value_9332, 0);
  reader9332->definitionModule = modulename;
  writer9332->definitionModule = modulename;
  reader9332->definitionLine = 2403;
  writer9332->definitionLine = 2403;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 2);
if (objclass9329 == NULL) {
  Method *reader9333 = addmethodrealflags(obj9329, "providedNames", &reader_ast_providedNames_9333, 0);
  Method *writer9333 = addmethodrealflags(obj9329, "providedNames:=(1)", &writer_ast_providedNames_9333, 0);
  reader9333->definitionModule = modulename;
  writer9333->definitionModule = modulename;
  reader9333->definitionLine = 2404;
  writer9333->definitionLine = 2404;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 3);
if (objclass9329 == NULL) {
  Method *reader9334 = addmethodrealflags(obj9329, "aliases", &reader_ast_aliases_9334, 0);
  Method *writer9334 = addmethodrealflags(obj9329, "aliases:=(1)", &writer_ast_aliases_9334, 0);
  reader9334->definitionModule = modulename;
  writer9334->definitionModule = modulename;
  reader9334->definitionLine = 2405;
  writer9334->definitionLine = 2405;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 4);
if (objclass9329 == NULL) {
  Method *reader9335 = addmethodrealflags(obj9329, "exclusions", &reader_ast_exclusions_9335, 0);
  Method *writer9335 = addmethodrealflags(obj9329, "exclusions:=(1)", &writer_ast_exclusions_9335, 0);
  reader9335->definitionModule = modulename;
  writer9335->definitionModule = modulename;
  reader9335->definitionLine = 2406;
  writer9335->definitionLine = 2406;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 5);
if (objclass9329 == NULL) {
  Method *reader9336 = addmethodrealflags(obj9329, "isUse", &reader_ast_isUse_9336, 0);
  Method *writer9336 = addmethodrealflags(obj9329, "isUse:=(1)", &writer_ast_isUse_9336, 0);
  reader9336->definitionModule = modulename;
  writer9336->definitionModule = modulename;
  reader9336->definitionLine = 2407;
  writer9336->definitionLine = 2407;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo9337 = (struct UserObject*)obj9329;
  uo9337->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9337 = addmethod2pos(obj9329, "isLegalInTrait", &meth_ast_isLegalInTrait9337, 7);
  int argcv_meth_ast_isLegalInTrait9337[] = {0};
  meth_meth_ast_isLegalInTrait9337->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9337);
  meth_meth_ast_isLegalInTrait9337->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9337->definitionLine = 2409;
// method "isInherits"
  struct UserObject *uo9340 = (struct UserObject*)obj9329;
  uo9340->data[8] = emptyclosure;
  Method *meth_meth_ast_isInherits9340 = addmethod2pos(obj9329, "isInherits", &meth_ast_isInherits9340, 8);
  int argcv_meth_ast_isInherits9340[] = {0};
  meth_meth_ast_isInherits9340->type = alloc_MethodType(1, argcv_meth_ast_isInherits9340);
  meth_meth_ast_isInherits9340->definitionModule = modulename;
  meth_meth_ast_isInherits9340->definitionLine = 2410;
// method "inheritsFromMember"
  struct UserObject *uo9342 = (struct UserObject*)obj9329;
  uo9342->data[9] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9342 = addmethod2pos(obj9329, "inheritsFromMember", &meth_ast_inheritsFromMember9342, 9);
  int argcv_meth_ast_inheritsFromMember9342[] = {0};
  meth_meth_ast_inheritsFromMember9342->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9342);
  meth_meth_ast_inheritsFromMember9342->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9342->definitionLine = 2411;
// method "inheritsFromCall"
  struct UserObject *uo9347 = (struct UserObject*)obj9329;
  uo9347->data[10] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9347 = addmethod2pos(obj9329, "inheritsFromCall", &meth_ast_inheritsFromCall9347, 10);
  int argcv_meth_ast_inheritsFromCall9347[] = {0};
  meth_meth_ast_inheritsFromCall9347->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9347);
  meth_meth_ast_inheritsFromCall9347->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9347->definitionLine = 2412;
// method "isExecutable"
  struct UserObject *uo9352 = (struct UserObject*)obj9329;
  uo9352->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable9352 = addmethod2pos(obj9329, "isExecutable", &meth_ast_isExecutable9352, 11);
  int argcv_meth_ast_isExecutable9352[] = {0};
  meth_meth_ast_isExecutable9352->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9352);
  meth_meth_ast_isExecutable9352->definitionModule = modulename;
  meth_meth_ast_isExecutable9352->definitionLine = 2413;
// method "accept(_)from(_)"
  struct UserObject *uo9354 = (struct UserObject*)obj9329;
  uo9354->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9354 = addmethod2pos(obj9329, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9354, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9354[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9354->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9354);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9354->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9354->definitionLine = 2414;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9329);
  Object closure9388 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9388, stackframe);
  addtoclosure(closure9388, var_k);
  struct UserObject *uo9388 = (struct UserObject*)obj9329;
  uo9388->data[13] = (Object)closure9388;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_9388 = addmethod2pos(obj9329, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_9388, 13);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_9388[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9388->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_9388);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9388->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9388->definitionLine = 2425;
// method "map(_)ancestors(_)"
  struct UserObject *uo9391 = (struct UserObject*)obj9329;
  uo9391->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9391 = addmethod2pos(obj9329, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9391, 14);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9391[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9391->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9391);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9391->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9391->definitionLine = 2431;
// method "pretty(_)"
  struct UserObject *uo9404 = (struct UserObject*)obj9329;
  uo9404->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9404 = addmethod2pos(obj9329, "pretty(1)", &meth_ast_pretty_40_1_41_9404, 15);
  int argcv_meth_ast_pretty_40_1_41_9404[] = {1};
  meth_meth_ast_pretty_40_1_41_9404->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9404);
  meth_meth_ast_pretty_40_1_41_9404->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9404->definitionLine = 2437;
// method "toGrace(_)"
  struct UserObject *uo9556 = (struct UserObject*)obj9329;
  uo9556->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9556 = addmethod2pos(obj9329, "toGrace(1)", &meth_ast_toGrace_40_1_41_9556, 16);
  int argcv_meth_ast_toGrace_40_1_41_9556[] = {1};
  meth_meth_ast_toGrace_40_1_41_9556->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9556);
meth_meth_ast_toGrace_40_1_41_9556->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9556->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9556->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9556->definitionLine = 2457;
// method "asString"
  struct UserObject *uo9634 = (struct UserObject*)obj9329;
  uo9634->data[17] = emptyclosure;
  Method *meth_meth_ast_asString9634 = addmethod2pos(obj9329, "asString", &meth_ast_asString9634, 17);
  int argcv_meth_ast_asString9634[] = {0};
  meth_meth_ast_asString9634->type = alloc_MethodType(1, argcv_meth_ast_asString9634);
  meth_meth_ast_asString9634->definitionModule = modulename;
  meth_meth_ast_asString9634->definitionLine = 2472;
// method "nameString"
  struct UserObject *uo9648 = (struct UserObject*)obj9329;
  uo9648->data[18] = emptyclosure;
  Method *meth_meth_ast_nameString9648 = addmethod2pos(obj9329, "nameString", &meth_ast_nameString9648, 18);
  int argcv_meth_ast_nameString9648[] = {0};
  meth_meth_ast_nameString9648->type = alloc_MethodType(1, argcv_meth_ast_nameString9648);
  meth_meth_ast_nameString9648->definitionModule = modulename;
  meth_meth_ast_nameString9648->definitionLine = 2475;
// method "addAlias(_)for(_)"
  struct UserObject *uo9654 = (struct UserObject*)obj9329;
  uo9654->data[19] = emptyclosure;
  Method *meth_meth_ast_addAlias_40_1_41_for_40_1_41_9654 = addmethod2pos(obj9329, "addAlias(1)for(1)", &meth_ast_addAlias_40_1_41_for_40_1_41_9654, 19);
  int argcv_meth_ast_addAlias_40_1_41_for_40_1_41_9654[] = {1, 1};
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9654->type = alloc_MethodType(2, argcv_meth_ast_addAlias_40_1_41_for_40_1_41_9654);
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9654->definitionModule = modulename;
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9654->definitionLine = 2476;
// method "addExclusion(_)"
  struct UserObject *uo9665 = (struct UserObject*)obj9329;
  uo9665->data[20] = emptyclosure;
  Method *meth_meth_ast_addExclusion_40_1_41_9665 = addmethod2pos(obj9329, "addExclusion(1)", &meth_ast_addExclusion_40_1_41_9665, 20);
  int argcv_meth_ast_addExclusion_40_1_41_9665[] = {1};
  meth_meth_ast_addExclusion_40_1_41_9665->type = alloc_MethodType(1, argcv_meth_ast_addExclusion_40_1_41_9665);
  meth_meth_ast_addExclusion_40_1_41_9665->definitionModule = modulename;
  meth_meth_ast_addExclusion_40_1_41_9665->definitionLine = 2479;
// method "shallowCopy"
  block_savedest(obj9329);
  Object closure9670 = createclosure(2, "shallowCopy");
  setclosureframe(closure9670, stackframe);
  addtoclosure(closure9670, var_nullNode);
  addtoclosure(closure9670, var_inheritsNode);
  struct UserObject *uo9670 = (struct UserObject*)obj9329;
  uo9670->data[21] = (Object)closure9670;
  Method *meth_meth_ast_shallowCopy9670 = addmethod2pos(obj9329, "shallowCopy", &meth_ast_shallowCopy9670, 21);
  int argcv_meth_ast_shallowCopy9670[] = {0};
  meth_meth_ast_shallowCopy9670->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9670);
  meth_meth_ast_shallowCopy9670->definitionModule = modulename;
  meth_meth_ast_shallowCopy9670->definitionLine = 2482;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo9675 = (struct UserObject*)obj9329;
  uo9675->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9675 = addmethod2pos(obj9329, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_9675, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_9675[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9675->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_9675);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9675->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9675->definitionLine = 2485;
// method "statementName"
  struct UserObject *uo9694 = (struct UserObject*)obj9329;
  uo9694->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName9694 = addmethod2pos(obj9329, "statementName", &meth_ast_statementName9694, 23);
  int argcv_meth_ast_statementName9694[] = {0};
  meth_meth_ast_statementName9694->type = alloc_MethodType(1, argcv_meth_ast_statementName9694);
  meth_meth_ast_statementName9694->definitionModule = modulename;
  meth_meth_ast_statementName9694->definitionLine = 2493;
  sourceObject = obj9329;
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9700 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9701 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9702 = gc_frame_new();
// call case 3: self.outer request
  Object call9703 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9702);
// compiled member node returning call9703 (depth = 5)
  Object call9704 = callmethodflags(call9703, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9701);
// compiled member node returning call9704 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9705 = callmethodflags(call9704, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9700);
// compiled call node returning call9705 (depth = 3)
  struct UserObject *obj9329_uo = (struct UserObject *)obj9329;
  obj9329_uo->super = call9705;
  sourceObject = obj9329;
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9706 == NULL) {
    strlit9706 = alloc_String("inherits");
    gc_root(strlit9706);
  }
// compiled string node returning strlit9706 (depth = 3)
  adddatum2(obj9329, strlit9706, 1);
  sourceObject = obj9329;
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9329, *var_expr, 2);
  sourceObject = obj9329;
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9707 = gc_frame_new();
// call case 5: prelude request
  Object call9708 = callmethodflags(prelude, "emptySet", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9707);
// compiled member node returning call9708 (depth = 3)
  adddatum2(obj9329, call9708, 3);
  sourceObject = obj9329;
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9709 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9709 (depth = 3)
  adddatum2(obj9329, array9709, 4);
  sourceObject = obj9329;
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9710 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9710 (depth = 3)
  adddatum2(obj9329, array9710, 5);
  sourceObject = obj9329;
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9711 = alloc_Boolean(0);
// compiled identifier node returning bool9711 (depth = 3)
  adddatum2(obj9329, bool9711, 6);
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  objclass9329 = obj9329->class;
  objclass9329->definitionModule = modulename;
  objclass9329->definitionLine = 2400;
  (*(struct UserObject *)self).data[0] = lowerouter9329;
  self = oldself9329;
  selfslot = oldselfslot9329;
  stackframe = oldstackframe9329;
  gc_frame_end(frame);
  return obj9329;
}
Object meth_ast_new_40_1_41_9328_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritsNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9329 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9329 = alloc_userobj2(28,24, objclass9329);
  gc_frame_newslot(obj9329);
if (objclass9329 == NULL) {
  glfree(obj9329->class->name);
  obj9329->class->name = "inheritsNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9329, self, 0);
  addmethodreal(obj9329,"outer", &reader_ast_outer_9330);
  Object oldself9329 = self;
  struct StackFrameObject *oldstackframe9329 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9329);
  gc_frame_newslot((Object)stackframe);
  self = obj9329;
  Object *oldselfslot9329 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9329 = (*(struct UserObject *)self).data[0], lowerouter9329 = thisouter9329;
  if (inheritingObject9329) {
    struct UserObject *inho9329 = (struct UserObject *)inheritingObject9329;
    while (inho9329->super != GraceDefaultObject) inho9329 = (struct UserObject *)inho9329->super;
    inho9329->super = obj9329;
    self = inheritingObject9329;
    *selfslot = self;
    lowerouter9329 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9329;
  }
if (objclass9329 == NULL) {
  Method *reader9331 = addmethodrealflags(obj9329, "kind",&reader_ast_kind_9331, MFLAG_DEF);
  reader9331->definitionModule = modulename;
  reader9331->definitionLine = 2402;
}
adddatum2(obj9329, alloc_Undefined(), 1);
if (objclass9329 == NULL) {
  Method *reader9332 = addmethodrealflags(obj9329, "value", &reader_ast_value_9332, 0);
  Method *writer9332 = addmethodrealflags(obj9329, "value:=(1)", &writer_ast_value_9332, 0);
  reader9332->definitionModule = modulename;
  writer9332->definitionModule = modulename;
  reader9332->definitionLine = 2403;
  writer9332->definitionLine = 2403;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 2);
if (objclass9329 == NULL) {
  Method *reader9333 = addmethodrealflags(obj9329, "providedNames", &reader_ast_providedNames_9333, 0);
  Method *writer9333 = addmethodrealflags(obj9329, "providedNames:=(1)", &writer_ast_providedNames_9333, 0);
  reader9333->definitionModule = modulename;
  writer9333->definitionModule = modulename;
  reader9333->definitionLine = 2404;
  writer9333->definitionLine = 2404;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 3);
if (objclass9329 == NULL) {
  Method *reader9334 = addmethodrealflags(obj9329, "aliases", &reader_ast_aliases_9334, 0);
  Method *writer9334 = addmethodrealflags(obj9329, "aliases:=(1)", &writer_ast_aliases_9334, 0);
  reader9334->definitionModule = modulename;
  writer9334->definitionModule = modulename;
  reader9334->definitionLine = 2405;
  writer9334->definitionLine = 2405;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 4);
if (objclass9329 == NULL) {
  Method *reader9335 = addmethodrealflags(obj9329, "exclusions", &reader_ast_exclusions_9335, 0);
  Method *writer9335 = addmethodrealflags(obj9329, "exclusions:=(1)", &writer_ast_exclusions_9335, 0);
  reader9335->definitionModule = modulename;
  writer9335->definitionModule = modulename;
  reader9335->definitionLine = 2406;
  writer9335->definitionLine = 2406;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 5);
if (objclass9329 == NULL) {
  Method *reader9336 = addmethodrealflags(obj9329, "isUse", &reader_ast_isUse_9336, 0);
  Method *writer9336 = addmethodrealflags(obj9329, "isUse:=(1)", &writer_ast_isUse_9336, 0);
  reader9336->definitionModule = modulename;
  writer9336->definitionModule = modulename;
  reader9336->definitionLine = 2407;
  writer9336->definitionLine = 2407;
}
obj9329->flags |= OFLAG_MUTABLE;
adddatum2(obj9329, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo9337 = (struct UserObject*)obj9329;
  uo9337->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9337 = addmethod2pos(obj9329, "isLegalInTrait", &meth_ast_isLegalInTrait9337, 7);
  int argcv_meth_ast_isLegalInTrait9337[] = {0};
  meth_meth_ast_isLegalInTrait9337->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9337);
  meth_meth_ast_isLegalInTrait9337->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9337->definitionLine = 2409;
// method "isInherits"
  struct UserObject *uo9340 = (struct UserObject*)obj9329;
  uo9340->data[8] = emptyclosure;
  Method *meth_meth_ast_isInherits9340 = addmethod2pos(obj9329, "isInherits", &meth_ast_isInherits9340, 8);
  int argcv_meth_ast_isInherits9340[] = {0};
  meth_meth_ast_isInherits9340->type = alloc_MethodType(1, argcv_meth_ast_isInherits9340);
  meth_meth_ast_isInherits9340->definitionModule = modulename;
  meth_meth_ast_isInherits9340->definitionLine = 2410;
// method "inheritsFromMember"
  struct UserObject *uo9342 = (struct UserObject*)obj9329;
  uo9342->data[9] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9342 = addmethod2pos(obj9329, "inheritsFromMember", &meth_ast_inheritsFromMember9342, 9);
  int argcv_meth_ast_inheritsFromMember9342[] = {0};
  meth_meth_ast_inheritsFromMember9342->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9342);
  meth_meth_ast_inheritsFromMember9342->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9342->definitionLine = 2411;
// method "inheritsFromCall"
  struct UserObject *uo9347 = (struct UserObject*)obj9329;
  uo9347->data[10] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9347 = addmethod2pos(obj9329, "inheritsFromCall", &meth_ast_inheritsFromCall9347, 10);
  int argcv_meth_ast_inheritsFromCall9347[] = {0};
  meth_meth_ast_inheritsFromCall9347->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9347);
  meth_meth_ast_inheritsFromCall9347->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9347->definitionLine = 2412;
// method "isExecutable"
  struct UserObject *uo9352 = (struct UserObject*)obj9329;
  uo9352->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable9352 = addmethod2pos(obj9329, "isExecutable", &meth_ast_isExecutable9352, 11);
  int argcv_meth_ast_isExecutable9352[] = {0};
  meth_meth_ast_isExecutable9352->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9352);
  meth_meth_ast_isExecutable9352->definitionModule = modulename;
  meth_meth_ast_isExecutable9352->definitionLine = 2413;
// method "accept(_)from(_)"
  struct UserObject *uo9354 = (struct UserObject*)obj9329;
  uo9354->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9354 = addmethod2pos(obj9329, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9354, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9354[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9354->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9354);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9354->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9354->definitionLine = 2414;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9329);
  Object closure9388 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9388, stackframe);
  addtoclosure(closure9388, var_k);
  struct UserObject *uo9388 = (struct UserObject*)obj9329;
  uo9388->data[13] = (Object)closure9388;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_9388 = addmethod2pos(obj9329, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_9388, 13);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_9388[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9388->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_9388);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9388->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9388->definitionLine = 2425;
// method "map(_)ancestors(_)"
  struct UserObject *uo9391 = (struct UserObject*)obj9329;
  uo9391->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9391 = addmethod2pos(obj9329, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9391, 14);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9391[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9391->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9391);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9391->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9391->definitionLine = 2431;
// method "pretty(_)"
  struct UserObject *uo9404 = (struct UserObject*)obj9329;
  uo9404->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9404 = addmethod2pos(obj9329, "pretty(1)", &meth_ast_pretty_40_1_41_9404, 15);
  int argcv_meth_ast_pretty_40_1_41_9404[] = {1};
  meth_meth_ast_pretty_40_1_41_9404->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9404);
  meth_meth_ast_pretty_40_1_41_9404->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9404->definitionLine = 2437;
// method "toGrace(_)"
  struct UserObject *uo9556 = (struct UserObject*)obj9329;
  uo9556->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9556 = addmethod2pos(obj9329, "toGrace(1)", &meth_ast_toGrace_40_1_41_9556, 16);
  int argcv_meth_ast_toGrace_40_1_41_9556[] = {1};
  meth_meth_ast_toGrace_40_1_41_9556->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9556);
meth_meth_ast_toGrace_40_1_41_9556->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9556->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9556->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9556->definitionLine = 2457;
// method "asString"
  struct UserObject *uo9634 = (struct UserObject*)obj9329;
  uo9634->data[17] = emptyclosure;
  Method *meth_meth_ast_asString9634 = addmethod2pos(obj9329, "asString", &meth_ast_asString9634, 17);
  int argcv_meth_ast_asString9634[] = {0};
  meth_meth_ast_asString9634->type = alloc_MethodType(1, argcv_meth_ast_asString9634);
  meth_meth_ast_asString9634->definitionModule = modulename;
  meth_meth_ast_asString9634->definitionLine = 2472;
// method "nameString"
  struct UserObject *uo9648 = (struct UserObject*)obj9329;
  uo9648->data[18] = emptyclosure;
  Method *meth_meth_ast_nameString9648 = addmethod2pos(obj9329, "nameString", &meth_ast_nameString9648, 18);
  int argcv_meth_ast_nameString9648[] = {0};
  meth_meth_ast_nameString9648->type = alloc_MethodType(1, argcv_meth_ast_nameString9648);
  meth_meth_ast_nameString9648->definitionModule = modulename;
  meth_meth_ast_nameString9648->definitionLine = 2475;
// method "addAlias(_)for(_)"
  struct UserObject *uo9654 = (struct UserObject*)obj9329;
  uo9654->data[19] = emptyclosure;
  Method *meth_meth_ast_addAlias_40_1_41_for_40_1_41_9654 = addmethod2pos(obj9329, "addAlias(1)for(1)", &meth_ast_addAlias_40_1_41_for_40_1_41_9654, 19);
  int argcv_meth_ast_addAlias_40_1_41_for_40_1_41_9654[] = {1, 1};
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9654->type = alloc_MethodType(2, argcv_meth_ast_addAlias_40_1_41_for_40_1_41_9654);
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9654->definitionModule = modulename;
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9654->definitionLine = 2476;
// method "addExclusion(_)"
  struct UserObject *uo9665 = (struct UserObject*)obj9329;
  uo9665->data[20] = emptyclosure;
  Method *meth_meth_ast_addExclusion_40_1_41_9665 = addmethod2pos(obj9329, "addExclusion(1)", &meth_ast_addExclusion_40_1_41_9665, 20);
  int argcv_meth_ast_addExclusion_40_1_41_9665[] = {1};
  meth_meth_ast_addExclusion_40_1_41_9665->type = alloc_MethodType(1, argcv_meth_ast_addExclusion_40_1_41_9665);
  meth_meth_ast_addExclusion_40_1_41_9665->definitionModule = modulename;
  meth_meth_ast_addExclusion_40_1_41_9665->definitionLine = 2479;
// method "shallowCopy"
  block_savedest(obj9329);
  Object closure9670 = createclosure(2, "shallowCopy");
  setclosureframe(closure9670, stackframe);
  addtoclosure(closure9670, var_nullNode);
  addtoclosure(closure9670, var_inheritsNode);
  struct UserObject *uo9670 = (struct UserObject*)obj9329;
  uo9670->data[21] = (Object)closure9670;
  Method *meth_meth_ast_shallowCopy9670 = addmethod2pos(obj9329, "shallowCopy", &meth_ast_shallowCopy9670, 21);
  int argcv_meth_ast_shallowCopy9670[] = {0};
  meth_meth_ast_shallowCopy9670->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9670);
  meth_meth_ast_shallowCopy9670->definitionModule = modulename;
  meth_meth_ast_shallowCopy9670->definitionLine = 2482;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo9675 = (struct UserObject*)obj9329;
  uo9675->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9675 = addmethod2pos(obj9329, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_9675, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_9675[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9675->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_9675);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9675->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9675->definitionLine = 2485;
// method "statementName"
  struct UserObject *uo9694 = (struct UserObject*)obj9329;
  uo9694->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName9694 = addmethod2pos(obj9329, "statementName", &meth_ast_statementName9694, 23);
  int argcv_meth_ast_statementName9694[] = {0};
  meth_meth_ast_statementName9694->type = alloc_MethodType(1, argcv_meth_ast_statementName9694);
  meth_meth_ast_statementName9694->definitionModule = modulename;
  meth_meth_ast_statementName9694->definitionLine = 2493;
  sourceObject = obj9329;
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9700 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9701 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9702 = gc_frame_new();
// call case 3: self.outer request
  Object call9703 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9702);
// compiled member node returning call9703 (depth = 5)
  Object call9704 = callmethodflags(call9703, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9701);
// compiled member node returning call9704 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9705 = callmethodflags(call9704, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9700);
// compiled call node returning call9705 (depth = 3)
  struct UserObject *obj9329_uo = (struct UserObject *)obj9329;
  obj9329_uo->super = call9705;
  sourceObject = obj9329;
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9706 == NULL) {
    strlit9706 = alloc_String("inherits");
    gc_root(strlit9706);
  }
// compiled string node returning strlit9706 (depth = 3)
  adddatum2(obj9329, strlit9706, 1);
  sourceObject = obj9329;
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9329, *var_expr, 2);
  sourceObject = obj9329;
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9707 = gc_frame_new();
// call case 5: prelude request
  Object call9708 = callmethodflags(prelude, "emptySet", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9707);
// compiled member node returning call9708 (depth = 3)
  adddatum2(obj9329, call9708, 3);
  sourceObject = obj9329;
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9709 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9709 (depth = 3)
  adddatum2(obj9329, array9709, 4);
  sourceObject = obj9329;
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9710 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9710 (depth = 3)
  adddatum2(obj9329, array9710, 5);
  sourceObject = obj9329;
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9711 = alloc_Boolean(0);
// compiled identifier node returning bool9711 (depth = 3)
  adddatum2(obj9329, bool9711, 6);
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  sourceObject = obj9329;
  objclass9329 = obj9329->class;
  objclass9329->definitionModule = modulename;
  objclass9329->definitionLine = 2400;
  (*(struct UserObject *)self).data[0] = lowerouter9329;
  self = oldself9329;
  selfslot = oldselfslot9329;
  stackframe = oldstackframe9329;
  gc_frame_end(frame);
  return obj9329;
}
Object meth_ast_inheritsNode9713(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inheritsNode (depth = 3)
  gc_frame_end(frame);
  return *var_inheritsNode;
}
Object meth_ast_AliasPair9716(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AliasPair");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AliasPair (depth = 3)
  gc_frame_end(frame);
  return *var_AliasPair;
}
Object meth_ast_isExecutable9724(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9725 = alloc_Boolean(0);
// compiled identifier node returning bool9725 (depth = 3)
  gc_frame_end(frame);
  return bool9725;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9726(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9727 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9728 = callmethodflags(*var_visitor, "visitBlank(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9727);
// compiled call node returning call9728 (depth = 3)
  gc_frame_end(frame);
  return call9728;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9729(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9730 = gc_frame_new();
// call case 4: self request
  Object call9731 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9730);
// compiled member node returning call9731 (depth = 4)
  *var_n = call9731;
  if (call9731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9732 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9733 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9732);
// compiled call node returning call9733 (depth = 4)
  *var_newChain = call9733;
  if (call9733 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9734 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9735 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9734);
// compiled call node returning call9735 (depth = 3)
  gc_frame_end(frame);
  return call9735;
}
Object meth_ast_nameString9736(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9737 == NULL) {
    strlit9737 = alloc_String("");
    gc_root(strlit9737);
  }
// compiled string node returning strlit9737 (depth = 3)
  gc_frame_end(frame);
  return strlit9737;
}
Object meth_ast_asString9738(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9739 == NULL) {
    strlit9739 = alloc_String("blank");
    gc_root(strlit9739);
  }
// compiled string node returning strlit9739 (depth = 3)
  gc_frame_end(frame);
  return strlit9739;
}
Object meth_ast_toGrace_40_1_41_9740(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9741 == NULL) {
    strlit9741 = alloc_String("");
    gc_root(strlit9741);
  }
// compiled string node returning strlit9741 (depth = 3)
  gc_frame_end(frame);
  return strlit9741;
}
Object meth_ast_shallowCopy9742(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9743 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9744 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankNode (depth = 5)
  Object call9745 = callmethodflags(*var_blankNode, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9744);
// compiled member node returning call9745 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9746 = callmethodflags(call9745, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9743);
// compiled call node returning call9746 (depth = 3)
  gc_frame_end(frame);
  return call9746;
}
Object meth_ast_new9719(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9720 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9720 = alloc_userobj2(9,10, objclass9720);
  gc_frame_newslot(obj9720);
if (objclass9720 == NULL) {
  glfree(obj9720->class->name);
  obj9720->class->name = "blankNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9720, self, 0);
  addmethodreal(obj9720,"outer", &reader_ast_outer_9721);
  Object oldself9720 = self;
  struct StackFrameObject *oldstackframe9720 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9720);
  gc_frame_newslot((Object)stackframe);
  self = obj9720;
  Object *oldselfslot9720 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9720 = (*(struct UserObject *)self).data[0], lowerouter9720 = thisouter9720;
  if (inheritingObject9720) {
    struct UserObject *inho9720 = (struct UserObject *)inheritingObject9720;
    while (inho9720->super != GraceDefaultObject) inho9720 = (struct UserObject *)inho9720->super;
    inho9720->super = obj9720;
    self = inheritingObject9720;
    *selfslot = self;
    lowerouter9720 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9720;
  }
if (objclass9720 == NULL) {
  Method *reader9722 = addmethodrealflags(obj9720, "kind",&reader_ast_kind_9722, MFLAG_DEF);
  reader9722->definitionModule = modulename;
  reader9722->definitionLine = 2525;
}
adddatum2(obj9720, alloc_Undefined(), 1);
if (objclass9720 == NULL) {
  Method *reader9723 = addmethodrealflags(obj9720, "value",&reader_ast_value_9723, MFLAG_DEF);
  reader9723->definitionModule = modulename;
  reader9723->definitionLine = 2526;
}
adddatum2(obj9720, alloc_Undefined(), 2);
// method "isExecutable"
  struct UserObject *uo9724 = (struct UserObject*)obj9720;
  uo9724->data[3] = emptyclosure;
  Method *meth_meth_ast_isExecutable9724 = addmethod2pos(obj9720, "isExecutable", &meth_ast_isExecutable9724, 3);
  int argcv_meth_ast_isExecutable9724[] = {0};
  meth_meth_ast_isExecutable9724->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9724);
  meth_meth_ast_isExecutable9724->definitionModule = modulename;
  meth_meth_ast_isExecutable9724->definitionLine = 2527;
// method "accept(_)from(_)"
  struct UserObject *uo9726 = (struct UserObject*)obj9720;
  uo9726->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9726 = addmethod2pos(obj9720, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9726, 4);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9726[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9726->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9726);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9726->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9726->definitionLine = 2530;
// method "map(_)ancestors(_)"
  struct UserObject *uo9729 = (struct UserObject*)obj9720;
  uo9729->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9729 = addmethod2pos(obj9720, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9729, 5);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9729[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9729->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9729);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9729->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9729->definitionLine = 2533;
// method "nameString"
  struct UserObject *uo9736 = (struct UserObject*)obj9720;
  uo9736->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9736 = addmethod2pos(obj9720, "nameString", &meth_ast_nameString9736, 6);
  int argcv_meth_ast_nameString9736[] = {0};
  meth_meth_ast_nameString9736->type = alloc_MethodType(1, argcv_meth_ast_nameString9736);
  meth_meth_ast_nameString9736->definitionModule = modulename;
  meth_meth_ast_nameString9736->definitionLine = 2538;
// method "asString"
  struct UserObject *uo9738 = (struct UserObject*)obj9720;
  uo9738->data[7] = emptyclosure;
  Method *meth_meth_ast_asString9738 = addmethod2pos(obj9720, "asString", &meth_ast_asString9738, 7);
  int argcv_meth_ast_asString9738[] = {0};
  meth_meth_ast_asString9738->type = alloc_MethodType(1, argcv_meth_ast_asString9738);
  meth_meth_ast_asString9738->definitionModule = modulename;
  meth_meth_ast_asString9738->definitionLine = 2539;
// method "toGrace(_)"
  struct UserObject *uo9740 = (struct UserObject*)obj9720;
  uo9740->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9740 = addmethod2pos(obj9720, "toGrace(1)", &meth_ast_toGrace_40_1_41_9740, 8);
  int argcv_meth_ast_toGrace_40_1_41_9740[] = {1};
  meth_meth_ast_toGrace_40_1_41_9740->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9740);
meth_meth_ast_toGrace_40_1_41_9740->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9740->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9740->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9740->definitionLine = 2540;
// method "shallowCopy"
  block_savedest(obj9720);
  Object closure9742 = createclosure(1, "shallowCopy");
  setclosureframe(closure9742, stackframe);
  addtoclosure(closure9742, var_blankNode);
  struct UserObject *uo9742 = (struct UserObject*)obj9720;
  uo9742->data[9] = (Object)closure9742;
  Method *meth_meth_ast_shallowCopy9742 = addmethod2pos(obj9720, "shallowCopy", &meth_ast_shallowCopy9742, 9);
  int argcv_meth_ast_shallowCopy9742[] = {0};
  meth_meth_ast_shallowCopy9742->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9742);
  meth_meth_ast_shallowCopy9742->definitionModule = modulename;
  meth_meth_ast_shallowCopy9742->definitionLine = 2541;
  sourceObject = obj9720;
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9747 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9748 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9749 = gc_frame_new();
// call case 3: self.outer request
  Object call9750 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9749);
// compiled member node returning call9750 (depth = 5)
  Object call9751 = callmethodflags(call9750, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9748);
// compiled member node returning call9751 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9752 = callmethodflags(call9751, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9747);
// compiled call node returning call9752 (depth = 3)
  struct UserObject *obj9720_uo = (struct UserObject *)obj9720;
  obj9720_uo->super = call9752;
  sourceObject = obj9720;
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9753 == NULL) {
    strlit9753 = alloc_String("blank");
    gc_root(strlit9753);
  }
// compiled string node returning strlit9753 (depth = 3)
  adddatum2(obj9720, strlit9753, 1);
  sourceObject = obj9720;
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9754 == NULL) {
    strlit9754 = alloc_String("blank");
    gc_root(strlit9754);
  }
// compiled string node returning strlit9754 (depth = 3)
  adddatum2(obj9720, strlit9754, 2);
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  objclass9720 = obj9720->class;
  objclass9720->definitionModule = modulename;
  objclass9720->definitionLine = 2523;
  (*(struct UserObject *)self).data[0] = lowerouter9720;
  self = oldself9720;
  selfslot = oldselfslot9720;
  stackframe = oldstackframe9720;
  gc_frame_end(frame);
  return obj9720;
}
Object meth_ast_new9719_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9720 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9720 = alloc_userobj2(9,10, objclass9720);
  gc_frame_newslot(obj9720);
if (objclass9720 == NULL) {
  glfree(obj9720->class->name);
  obj9720->class->name = "blankNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9720, self, 0);
  addmethodreal(obj9720,"outer", &reader_ast_outer_9721);
  Object oldself9720 = self;
  struct StackFrameObject *oldstackframe9720 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9720);
  gc_frame_newslot((Object)stackframe);
  self = obj9720;
  Object *oldselfslot9720 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9720 = (*(struct UserObject *)self).data[0], lowerouter9720 = thisouter9720;
  if (inheritingObject9720) {
    struct UserObject *inho9720 = (struct UserObject *)inheritingObject9720;
    while (inho9720->super != GraceDefaultObject) inho9720 = (struct UserObject *)inho9720->super;
    inho9720->super = obj9720;
    self = inheritingObject9720;
    *selfslot = self;
    lowerouter9720 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9720;
  }
if (objclass9720 == NULL) {
  Method *reader9722 = addmethodrealflags(obj9720, "kind",&reader_ast_kind_9722, MFLAG_DEF);
  reader9722->definitionModule = modulename;
  reader9722->definitionLine = 2525;
}
adddatum2(obj9720, alloc_Undefined(), 1);
if (objclass9720 == NULL) {
  Method *reader9723 = addmethodrealflags(obj9720, "value",&reader_ast_value_9723, MFLAG_DEF);
  reader9723->definitionModule = modulename;
  reader9723->definitionLine = 2526;
}
adddatum2(obj9720, alloc_Undefined(), 2);
// method "isExecutable"
  struct UserObject *uo9724 = (struct UserObject*)obj9720;
  uo9724->data[3] = emptyclosure;
  Method *meth_meth_ast_isExecutable9724 = addmethod2pos(obj9720, "isExecutable", &meth_ast_isExecutable9724, 3);
  int argcv_meth_ast_isExecutable9724[] = {0};
  meth_meth_ast_isExecutable9724->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9724);
  meth_meth_ast_isExecutable9724->definitionModule = modulename;
  meth_meth_ast_isExecutable9724->definitionLine = 2527;
// method "accept(_)from(_)"
  struct UserObject *uo9726 = (struct UserObject*)obj9720;
  uo9726->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9726 = addmethod2pos(obj9720, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9726, 4);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9726[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9726->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9726);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9726->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9726->definitionLine = 2530;
// method "map(_)ancestors(_)"
  struct UserObject *uo9729 = (struct UserObject*)obj9720;
  uo9729->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9729 = addmethod2pos(obj9720, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9729, 5);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9729[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9729->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9729);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9729->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9729->definitionLine = 2533;
// method "nameString"
  struct UserObject *uo9736 = (struct UserObject*)obj9720;
  uo9736->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9736 = addmethod2pos(obj9720, "nameString", &meth_ast_nameString9736, 6);
  int argcv_meth_ast_nameString9736[] = {0};
  meth_meth_ast_nameString9736->type = alloc_MethodType(1, argcv_meth_ast_nameString9736);
  meth_meth_ast_nameString9736->definitionModule = modulename;
  meth_meth_ast_nameString9736->definitionLine = 2538;
// method "asString"
  struct UserObject *uo9738 = (struct UserObject*)obj9720;
  uo9738->data[7] = emptyclosure;
  Method *meth_meth_ast_asString9738 = addmethod2pos(obj9720, "asString", &meth_ast_asString9738, 7);
  int argcv_meth_ast_asString9738[] = {0};
  meth_meth_ast_asString9738->type = alloc_MethodType(1, argcv_meth_ast_asString9738);
  meth_meth_ast_asString9738->definitionModule = modulename;
  meth_meth_ast_asString9738->definitionLine = 2539;
// method "toGrace(_)"
  struct UserObject *uo9740 = (struct UserObject*)obj9720;
  uo9740->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9740 = addmethod2pos(obj9720, "toGrace(1)", &meth_ast_toGrace_40_1_41_9740, 8);
  int argcv_meth_ast_toGrace_40_1_41_9740[] = {1};
  meth_meth_ast_toGrace_40_1_41_9740->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9740);
meth_meth_ast_toGrace_40_1_41_9740->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9740->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9740->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9740->definitionLine = 2540;
// method "shallowCopy"
  block_savedest(obj9720);
  Object closure9742 = createclosure(1, "shallowCopy");
  setclosureframe(closure9742, stackframe);
  addtoclosure(closure9742, var_blankNode);
  struct UserObject *uo9742 = (struct UserObject*)obj9720;
  uo9742->data[9] = (Object)closure9742;
  Method *meth_meth_ast_shallowCopy9742 = addmethod2pos(obj9720, "shallowCopy", &meth_ast_shallowCopy9742, 9);
  int argcv_meth_ast_shallowCopy9742[] = {0};
  meth_meth_ast_shallowCopy9742->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9742);
  meth_meth_ast_shallowCopy9742->definitionModule = modulename;
  meth_meth_ast_shallowCopy9742->definitionLine = 2541;
  sourceObject = obj9720;
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9747 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9748 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9749 = gc_frame_new();
// call case 3: self.outer request
  Object call9750 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9749);
// compiled member node returning call9750 (depth = 5)
  Object call9751 = callmethodflags(call9750, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9748);
// compiled member node returning call9751 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9752 = callmethodflags(call9751, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9747);
// compiled call node returning call9752 (depth = 3)
  struct UserObject *obj9720_uo = (struct UserObject *)obj9720;
  obj9720_uo->super = call9752;
  sourceObject = obj9720;
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9753 == NULL) {
    strlit9753 = alloc_String("blank");
    gc_root(strlit9753);
  }
// compiled string node returning strlit9753 (depth = 3)
  adddatum2(obj9720, strlit9753, 1);
  sourceObject = obj9720;
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9754 == NULL) {
    strlit9754 = alloc_String("blank");
    gc_root(strlit9754);
  }
// compiled string node returning strlit9754 (depth = 3)
  adddatum2(obj9720, strlit9754, 2);
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  sourceObject = obj9720;
  objclass9720 = obj9720->class;
  objclass9720->definitionModule = modulename;
  objclass9720->definitionLine = 2523;
  (*(struct UserObject *)self).data[0] = lowerouter9720;
  self = oldself9720;
  selfslot = oldselfslot9720;
  stackframe = oldstackframe9720;
  gc_frame_end(frame);
  return obj9720;
}
Object meth_ast_blankNode9756(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankNode (depth = 3)
  gc_frame_end(frame);
  return *var_blankNode;
}
Object meth_ast_new9759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9760 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9761 == NULL) {
    strlit9761 = alloc_String("");
    gc_root(strlit9761);
  }
// compiled string node returning strlit9761 (depth = 4)
  gc_frame_newslot(strlit9761);
// starting to compile array node (depth = 4)
  Object array9762 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9762 (depth = 4)
  gc_frame_newslot(array9762);
// call case 4: self request
  params[0] = strlit9761;
  params[1] = array9762;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9763 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9760);
// compiled call node returning call9763 (depth = 3)
  gc_frame_end(frame);
  return call9763;
}
Object meth_ast_partName_40_1_41_scope_40_1_41_9764(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9765 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 5)
  Object array9766 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9766 (depth = 5)
  gc_frame_newslot(array9766);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array9766;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9767 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9765);
// compiled call node returning call9767 (depth = 4)
  *var_result = call9767;
  if (call9767 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9768 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9769 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9768);
// compiled call node returning call9769 (depth = 3)
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9770(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)params(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9771 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ps (depth = 5)
  gc_frame_newslot(*var_ps);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_ps;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9772 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9771);
// compiled call node returning call9772 (depth = 4)
  *var_result = call9772;
  if (call9772 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9773 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9774 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9773);
// compiled call node returning call9774 (depth = 3)
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName_40_1_41_9775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for partName(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9776 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 4)
  Object array9777 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9777 (depth = 4)
  gc_frame_newslot(array9777);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array9777;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9778 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9776);
// compiled call node returning call9778 (depth = 3)
  gc_frame_end(frame);
  return call9778;
}
Object meth_ast_nameString9787(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9789 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9790 = gc_frame_new();
// call case 4: self request
  Object call9791 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9790);
// compiled member node returning call9791 (depth = 5)
  Object call9792 = callmethodflags(call9791, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9789);
// compiled member node returning call9792 (depth = 4)
  Object if9788 = done;
  if (istrue(call9792)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9793 = gc_frame_new();
// call case 4: self request
  Object call9794 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9793);
// compiled member node returning call9794 (depth = 5)
  return call9794;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9788 = undefined;
  } else {
  }
// compiled if node returning if9788 (depth = 3)
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9796 == NULL) {
    strlit9796 = alloc_String(")");
    gc_root(strlit9796);
  }
// compiled string node returning strlit9796 (depth = 4)
  int op_slot_right_9795 = gc_frame_newslot(strlit9796);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9799 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9800 = gc_frame_new();
// call case 4: self request
  Object call9801 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9800);
// compiled member node returning call9801 (depth = 6)
  Object call9802 = callmethodflags(call9801, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9799);
// compiled member node returning call9802 (depth = 5)
  int op_slot_right_9798 = gc_frame_newslot(call9802);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9805 == NULL) {
    strlit9805 = alloc_String("(");
    gc_root(strlit9805);
  }
// compiled string node returning strlit9805 (depth = 6)
  int op_slot_right_9804 = gc_frame_newslot(strlit9805);
// starting to compile member node (depth = 6)
  int callframe9807 = gc_frame_new();
// call case 4: self request
  Object call9808 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9807);
// compiled member node returning call9808 (depth = 6)
  int op_slot_left_9804 = gc_frame_newslot(call9808);
  params[0] = strlit9805;
  partcv[0] = 1;
  Object opresult9809 = callmethod(call9808, "++(1)", 1, partcv, params);
// compiled op node returning opresult9809 (depth = 5)
  int op_slot_left_9798 = gc_frame_newslot(opresult9809);
  params[0] = call9802;
  partcv[0] = 1;
  Object opresult9810 = callmethod(opresult9809, "++(1)", 1, partcv, params);
// compiled op node returning opresult9810 (depth = 4)
  int op_slot_left_9795 = gc_frame_newslot(opresult9810);
  params[0] = strlit9796;
  partcv[0] = 1;
  Object opresult9811 = callmethod(opresult9810, "++(1)", 1, partcv, params);
// compiled op node returning opresult9811 (depth = 3)
  gc_frame_end(frame);
  return opresult9811;
}
Object meth_ast_numParams9812(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9813 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9814 = gc_frame_new();
// call case 4: self request
  Object call9815 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9814);
// compiled member node returning call9815 (depth = 4)
  Object call9816 = callmethodflags(call9815, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9813);
// compiled member node returning call9816 (depth = 3)
  gc_frame_end(frame);
  return call9816;
}
Object meth_ast__apply_40_1_41_9832(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___3 = &(stackframe->slots[0]);
  *var___3 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9834 == NULL) {
    strlit9834 = alloc_String("_");
    gc_root(strlit9834);
  }
// compiled string node returning strlit9834 (depth = 7)
  int op_slot_right_9833 = gc_frame_newslot(strlit9834);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_9833 = gc_frame_newslot(*var_underScores);
  params[0] = strlit9834;
  partcv[0] = 1;
  Object opresult9836 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult9836 (depth = 6)
  *var_underScores = opresult9836;
  if (opresult9836 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9840(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9842 == NULL) {
    strlit9842 = alloc_String(",");
    gc_root(strlit9842);
  }
// compiled string node returning strlit9842 (depth = 7)
  int op_slot_right_9841 = gc_frame_newslot(strlit9842);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_9841 = gc_frame_newslot(*var_underScores);
  params[0] = strlit9842;
  partcv[0] = 1;
  Object opresult9844 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult9844 (depth = 6)
  *var_underScores = opresult9844;
  if (opresult9844 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_canonicalName9817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_underScores = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "underScores");
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9820 = alloc_Float64(0);
// compiled num node returning num9820 (depth = 5)
  int op_slot_right_9819 = gc_frame_newslot(num9820);
// starting to compile member node (depth = 5)
  int callframe9822 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9823 = gc_frame_new();
// call case 4: self request
  Object call9824 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9823);
// compiled member node returning call9824 (depth = 6)
  Object call9825 = callmethodflags(call9824, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9822);
// compiled member node returning call9825 (depth = 5)
  int op_slot_left_9819 = gc_frame_newslot(call9825);
  params[0] = num9820;
  partcv[0] = 1;
  Object opresult9826 = callmethod(call9825, "==(1)", 1, partcv, params);
// compiled op node returning opresult9826 (depth = 4)
  Object if9818 = done;
  if (istrue(opresult9826)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9827 = gc_frame_new();
// call case 4: self request
  Object call9828 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9827);
// compiled member node returning call9828 (depth = 5)
  return call9828;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9818 = undefined;
  } else {
  }
// compiled if node returning if9818 (depth = 3)
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9829 == NULL) {
    strlit9829 = alloc_String("");
    gc_root(strlit9829);
  }
// compiled string node returning strlit9829 (depth = 4)
  *var_underScores = strlit9829;
  if (strlit9829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9830 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9831 = alloc_Block(NULL, NULL, "ast", 2579);
  gc_frame_newslot(block9831);
// method "_apply(_)"
  block_savedest(block9831);
  Object closure9832 = createclosure(2, "_apply(1)");
  setclosureframe(closure9832, stackframe);
  addtoclosure(closure9832, var_underScores);
  addtoclosure(closure9832, selfslot);
  struct UserObject *uo9832 = (struct UserObject*)block9831;
  uo9832->data[0] = (Object)closure9832;
  Method *meth_meth_ast__apply_40_1_41_9832 = addmethod2pos(block9831, "_apply(1)", &meth_ast__apply_40_1_41_9832, 0);
  int argcv_meth_ast__apply_40_1_41_9832[] = {1};
  meth_meth_ast__apply_40_1_41_9832->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9832);
  meth_meth_ast__apply_40_1_41_9832->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9832->definitionLine = 2969;
// compiled block node returning block9831 (depth = 4)
  gc_frame_newslot(block9831);
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block9839 = alloc_Block(NULL, NULL, "ast", 2580);
  gc_frame_newslot(block9839);
// method "_apply"
  block_savedest(block9839);
  Object closure9840 = createclosure(2, "_apply");
  setclosureframe(closure9840, stackframe);
  addtoclosure(closure9840, var_underScores);
  addtoclosure(closure9840, selfslot);
  struct UserObject *uo9840 = (struct UserObject*)block9839;
  uo9840->data[0] = (Object)closure9840;
  Method *meth_meth_ast__apply9840 = addmethod2pos(block9839, "_apply", &meth_ast__apply9840, 0);
  int argcv_meth_ast__apply9840[] = {0};
  meth_meth_ast__apply9840->type = alloc_MethodType(1, argcv_meth_ast__apply9840);
  meth_meth_ast__apply9840->definitionModule = modulename;
  meth_meth_ast__apply9840->definitionLine = 2969;
// compiled block node returning block9839 (depth = 4)
  gc_frame_newslot(block9839);
// call case 6: other requests
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9847 = gc_frame_new();
// call case 4: self request
  Object call9848 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9847);
// compiled member node returning call9848 (depth = 4)
  params[0] = block9831;
  params[1] = block9839;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9849 = callmethodflags(call9848, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9830);
// compiled call node returning call9849 (depth = 3)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9851 == NULL) {
    strlit9851 = alloc_String(")");
    gc_root(strlit9851);
  }
// compiled string node returning strlit9851 (depth = 4)
  int op_slot_right_9850 = gc_frame_newslot(strlit9851);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_underScores (depth = 5)
  int op_slot_right_9853 = gc_frame_newslot(*var_underScores);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9856 == NULL) {
    strlit9856 = alloc_String("(");
    gc_root(strlit9856);
  }
// compiled string node returning strlit9856 (depth = 6)
  int op_slot_right_9855 = gc_frame_newslot(strlit9856);
// starting to compile member node (depth = 6)
  int callframe9858 = gc_frame_new();
// call case 4: self request
  Object call9859 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9858);
// compiled member node returning call9859 (depth = 6)
  int op_slot_left_9855 = gc_frame_newslot(call9859);
  params[0] = strlit9856;
  partcv[0] = 1;
  Object opresult9860 = callmethod(call9859, "++(1)", 1, partcv, params);
// compiled op node returning opresult9860 (depth = 5)
  int op_slot_left_9853 = gc_frame_newslot(opresult9860);
  params[0] = *var_underScores;
  partcv[0] = 1;
  Object opresult9861 = callmethod(opresult9860, "++(1)", 1, partcv, params);
// compiled op node returning opresult9861 (depth = 4)
  int op_slot_left_9850 = gc_frame_newslot(opresult9861);
  params[0] = strlit9851;
  partcv[0] = 1;
  Object opresult9862 = callmethod(opresult9861, "++(1)", 1, partcv, params);
// compiled op node returning opresult9862 (depth = 3)
  gc_frame_end(frame);
  return opresult9862;
}
Object meth_ast__apply_40_1_41_9871(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe9872 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9873 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9872);
// compiled call node returning call9873 (depth = 6)
  gc_frame_end(frame);
  return call9873;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9865 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9866 = callmethodflags(*var_visitor, "visitSignaturePart(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9865);
// compiled call node returning call9866 (depth = 4)
  Object if9864 = done;
  if (istrue(call9866)) {
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9867 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9868 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9867);
// compiled call node returning call9868 (depth = 5)
  *var_newChain = call9868;
  if (call9868 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9869 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9870 = alloc_Block(NULL, NULL, "ast", 2587);
  gc_frame_newslot(block9870);
// method "_apply(_)"
  block_savedest(block9870);
  Object closure9871 = createclosure(3, "_apply(1)");
  setclosureframe(closure9871, stackframe);
  addtoclosure(closure9871, var_visitor);
  addtoclosure(closure9871, var_newChain);
  addtoclosure(closure9871, selfslot);
  struct UserObject *uo9871 = (struct UserObject*)block9870;
  uo9871->data[0] = (Object)closure9871;
  Method *meth_meth_ast__apply_40_1_41_9871 = addmethod2pos(block9870, "_apply(1)", &meth_ast__apply_40_1_41_9871, 0);
  int argcv_meth_ast__apply_40_1_41_9871[] = {1};
  meth_meth_ast__apply_40_1_41_9871->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9871);
  meth_meth_ast__apply_40_1_41_9871->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9871->definitionLine = 2969;
// compiled block node returning block9870 (depth = 5)
  gc_frame_newslot(block9870);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9875 = gc_frame_new();
// call case 4: self request
  Object call9876 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9875);
// compiled member node returning call9876 (depth = 5)
  params[0] = block9870;
  partcv[0] = 1;
  Object call9877 = callmethodflags(call9876, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9869);
// compiled call node returning call9877 (depth = 4)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9880 = gc_frame_new();
// call case 4: self request
  Object call9881 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9880);
// compiled member node returning call9881 (depth = 6)
  int op_slot_right_9879 = gc_frame_newslot(call9881);
// starting to compile identifier node (depth = 6)
  Object bool9883 = alloc_Boolean(0);
// compiled identifier node returning bool9883 (depth = 6)
  int op_slot_left_9879 = gc_frame_newslot(bool9883);
  params[0] = call9881;
  partcv[0] = 1;
  Object opresult9884 = callmethod(bool9883, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9884 (depth = 5)
  Object if9878 = done;
  if (istrue(opresult9884)) {
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9885 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9886 = gc_frame_new();
// call case 4: self request
  Object call9887 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9886);
// compiled member node returning call9887 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9888 = callmethodflags(call9887, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9885);
// compiled call node returning call9888 (depth = 5)
    gc_frame_newslot(call9888);
    if9878 = call9888;
  } else {
  }
// compiled if node returning if9878 (depth = 4)
    gc_frame_newslot(if9878);
    if9864 = if9878;
  } else {
  }
// compiled if node returning if9864 (depth = 3)
  gc_frame_end(frame);
  return if9864;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_9889(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9890 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call9891 = callmethodflags(*var_k, "parameter", 0, partcv, params, 0);
  gc_frame_end(callframe9890);
// compiled member node returning call9891 (depth = 3)
  gc_frame_end(frame);
  return call9891;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9892(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nd");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9893 = gc_frame_new();
// call case 4: self request
  Object call9894 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9893);
// compiled member node returning call9894 (depth = 4)
  *var_nd = call9894;
  if (call9894 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9895 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nd (depth = 5)
  gc_frame_newslot(*var_nd);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_nd;
  partcv[0] = 1;
  Object call9896 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9895);
// compiled call node returning call9896 (depth = 4)
  *var_newChain = call9896;
  if (call9896 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9897 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9898 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9899 = gc_frame_new();
// call case 4: self request
  Object call9900 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9899);
// compiled member node returning call9900 (depth = 5)
  gc_frame_newslot(call9900);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9901 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9902 = gc_frame_new();
// call case 3: self.outer request
  Object call9903 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9902);
// compiled member node returning call9903 (depth = 6)
  Object call9904 = callmethodflags(call9903, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9901);
// compiled member node returning call9904 (depth = 5)
  params[0] = call9900;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9905 = callmethodflags(call9904, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9898);
// compiled call node returning call9905 (depth = 4)
  gc_frame_newslot(call9905);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9905;
  partcv[0] = 1;
  Object call9906 = callmethodflags(*var_nd, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9897);
// compiled call node returning call9906 (depth = 3)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9907 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9908 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9909 = gc_frame_new();
// call case 4: self request
  Object call9910 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9909);
// compiled member node returning call9910 (depth = 5)
  gc_frame_newslot(call9910);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9911 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9912 = gc_frame_new();
// call case 3: self.outer request
  Object call9913 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9912);
// compiled member node returning call9913 (depth = 6)
  Object call9914 = callmethodflags(call9913, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9911);
// compiled member node returning call9914 (depth = 5)
  params[0] = call9910;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9915 = callmethodflags(call9914, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9908);
// compiled call node returning call9915 (depth = 4)
  gc_frame_newslot(call9915);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9915;
  partcv[0] = 1;
  Object call9916 = callmethodflags(*var_nd, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9907);
// compiled call node returning call9916 (depth = 3)
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9917 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_nd;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9918 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9917);
// compiled call node returning call9918 (depth = 3)
  gc_frame_end(frame);
  return call9918;
}
Object meth_ast__apply_40_1_41_9927(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9929 == NULL) {
    strlit9929 = alloc_String("  ");
    gc_root(strlit9929);
  }
// compiled string node returning strlit9929 (depth = 7)
  int op_slot_right_9928 = gc_frame_newslot(strlit9929);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9928 = gc_frame_newslot(*var_spc);
  params[0] = strlit9929;
  partcv[0] = 1;
  Object opresult9931 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9931 (depth = 6)
  *var_spc = opresult9931;
  if (opresult9931 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9981(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9983 == NULL) {
    strlit9983 = alloc_String("");
    gc_root(strlit9983);
  }
// compiled string node returning strlit9983 (depth = 7)
  int op_slot_right_9982 = gc_frame_newslot(strlit9983);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9986 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9988 = alloc_Float64(2);
// compiled num node returning num9988 (depth = 10)
  int op_slot_right_9987 = gc_frame_newslot(num9988);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_9987 = gc_frame_newslot(*var_depth);
  params[0] = num9988;
  partcv[0] = 1;
  Object sum9990 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9990 (depth = 9)
  gc_frame_newslot(sum9990);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = sum9990;
  partcv[0] = 1;
  Object call9991 = callmethodflags(*var_p, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9986);
// compiled call node returning call9991 (depth = 8)
  int op_slot_right_9985 = gc_frame_newslot(call9991);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9994 == NULL) {
    strlit9994 = alloc_String("");
    gc_root(strlit9994);
  }
// compiled string node returning strlit9994 (depth = 9)
  int op_slot_right_9993 = gc_frame_newslot(strlit9994);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9996 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9999 == NULL) {
    strlit9999 = alloc_String("""\x0a""  ");
    gc_root(strlit9999);
  }
// compiled string node returning strlit9999 (depth = 11)
  int op_slot_right_9998 = gc_frame_newslot(strlit9999);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_10001 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit10003 == NULL) {
    strlit10003 = alloc_String("");
    gc_root(strlit10003);
  }
// compiled string node returning strlit10003 (depth = 12)
  int op_slot_left_10001 = gc_frame_newslot(strlit10003);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10004 = callmethod(strlit10003, "++(1)", 1, partcv, params);
// compiled op node returning opresult10004 (depth = 11)
  int op_slot_left_9998 = gc_frame_newslot(opresult10004);
  params[0] = strlit9999;
  partcv[0] = 1;
  Object opresult10005 = callmethod(opresult10004, "++(1)", 1, partcv, params);
// compiled op node returning opresult10005 (depth = 10)
  int op_slot_left_9996 = gc_frame_newslot(opresult10005);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10006 = callmethod(opresult10005, "++(1)", 1, partcv, params);
// compiled op node returning opresult10006 (depth = 9)
  int op_slot_left_9993 = gc_frame_newslot(opresult10006);
  params[0] = strlit9994;
  partcv[0] = 1;
  Object opresult10007 = callmethod(opresult10006, "++(1)", 1, partcv, params);
// compiled op node returning opresult10007 (depth = 8)
  int op_slot_left_9985 = gc_frame_newslot(opresult10007);
  params[0] = call9991;
  partcv[0] = 1;
  Object opresult10008 = callmethod(opresult10007, "++(1)", 1, partcv, params);
// compiled op node returning opresult10008 (depth = 7)
  int op_slot_left_9982 = gc_frame_newslot(opresult10008);
  params[0] = strlit9983;
  partcv[0] = 1;
  Object opresult10009 = callmethod(opresult10008, "++(1)", 1, partcv, params);
// compiled op node returning opresult10009 (depth = 6)
  *var_s = opresult10009;
  if (opresult10009 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9919(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9920 == NULL) {
    strlit9920 = alloc_String("");
    gc_root(strlit9920);
  }
// compiled string node returning strlit9920 (depth = 4)
  *var_spc = strlit9920;
  if (strlit9920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9921 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9922 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9924 = alloc_Float64(0);
// compiled num node returning num9924 (depth = 5)
  int op_slot_left_9922 = gc_frame_newslot(num9924);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9925 = callmethod(num9924, "..(1)", 1, partcv, params);
// compiled op node returning opresult9925 (depth = 4)
  gc_frame_newslot(opresult9925);
// starting to compile block node (depth = 4)
  Object block9926 = alloc_Block(NULL, NULL, "ast", 2603);
  gc_frame_newslot(block9926);
// method "_apply(_)"
  block_savedest(block9926);
  Object closure9927 = createclosure(2, "_apply(1)");
  setclosureframe(closure9927, stackframe);
  addtoclosure(closure9927, var_spc);
  addtoclosure(closure9927, selfslot);
  struct UserObject *uo9927 = (struct UserObject*)block9926;
  uo9927->data[0] = (Object)closure9927;
  Method *meth_meth_ast__apply_40_1_41_9927 = addmethod2pos(block9926, "_apply(1)", &meth_ast__apply_40_1_41_9927, 0);
  int argcv_meth_ast__apply_40_1_41_9927[] = {1};
  meth_meth_ast__apply_40_1_41_9927->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9927);
  meth_meth_ast__apply_40_1_41_9927->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9927->definitionLine = 2969;
// compiled block node returning block9926 (depth = 4)
  gc_frame_newslot(block9926);
// call case 5: prelude request
  params[0] = opresult9925;
  params[1] = block9926;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9934 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9921);
// compiled call node returning call9934 (depth = 3)
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9936 == NULL) {
    strlit9936 = alloc_String("");
    gc_root(strlit9936);
  }
// compiled string node returning strlit9936 (depth = 5)
  int op_slot_right_9935 = gc_frame_newslot(strlit9936);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9939 = gc_frame_new();
// call case 4: self request
  Object call9940 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9939);
// compiled member node returning call9940 (depth = 6)
  int op_slot_right_9938 = gc_frame_newslot(call9940);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9943 == NULL) {
    strlit9943 = alloc_String(": ");
    gc_root(strlit9943);
  }
// compiled string node returning strlit9943 (depth = 7)
  int op_slot_right_9942 = gc_frame_newslot(strlit9943);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9946 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9947 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9946);
// compiled call node returning call9947 (depth = 8)
  int op_slot_right_9945 = gc_frame_newslot(call9947);
// starting to compile string node (depth = 8)
  if (strlit9949 == NULL) {
    strlit9949 = alloc_String("");
    gc_root(strlit9949);
  }
// compiled string node returning strlit9949 (depth = 8)
  int op_slot_left_9945 = gc_frame_newslot(strlit9949);
  params[0] = call9947;
  partcv[0] = 1;
  Object opresult9950 = callmethod(strlit9949, "++(1)", 1, partcv, params);
// compiled op node returning opresult9950 (depth = 7)
  int op_slot_left_9942 = gc_frame_newslot(opresult9950);
  params[0] = strlit9943;
  partcv[0] = 1;
  Object opresult9951 = callmethod(opresult9950, "++(1)", 1, partcv, params);
// compiled op node returning opresult9951 (depth = 6)
  int op_slot_left_9938 = gc_frame_newslot(opresult9951);
  params[0] = call9940;
  partcv[0] = 1;
  Object opresult9952 = callmethod(opresult9951, "++(1)", 1, partcv, params);
// compiled op node returning opresult9952 (depth = 5)
  int op_slot_left_9935 = gc_frame_newslot(opresult9952);
  params[0] = strlit9936;
  partcv[0] = 1;
  Object opresult9953 = callmethod(opresult9952, "++(1)", 1, partcv, params);
// compiled op node returning opresult9953 (depth = 4)
  *var_s = opresult9953;
  if (opresult9953 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9955 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9956 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9957 = gc_frame_new();
// call case 4: self request
  Object call9958 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9957);
// compiled member node returning call9958 (depth = 6)
  Object call9959 = callmethodflags(call9958, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9956);
// compiled member node returning call9959 (depth = 5)
  Object call9960 = callmethodflags(call9959, "not", 0, partcv, params, 0);
  gc_frame_end(callframe9955);
// compiled member node returning call9960 (depth = 4)
  Object if9954 = done;
  if (istrue(call9960)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9962 == NULL) {
    strlit9962 = alloc_String("Parameters:");
    gc_root(strlit9962);
  }
// compiled string node returning strlit9962 (depth = 6)
  int op_slot_right_9961 = gc_frame_newslot(strlit9962);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9964 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9967 == NULL) {
    strlit9967 = alloc_String("""\x0a""");
    gc_root(strlit9967);
  }
// compiled string node returning strlit9967 (depth = 8)
  int op_slot_right_9966 = gc_frame_newslot(strlit9967);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9969 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9971 == NULL) {
    strlit9971 = alloc_String("");
    gc_root(strlit9971);
  }
// compiled string node returning strlit9971 (depth = 9)
  int op_slot_left_9969 = gc_frame_newslot(strlit9971);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9972 = callmethod(strlit9971, "++(1)", 1, partcv, params);
// compiled op node returning opresult9972 (depth = 8)
  int op_slot_left_9966 = gc_frame_newslot(opresult9972);
  params[0] = strlit9967;
  partcv[0] = 1;
  Object opresult9973 = callmethod(opresult9972, "++(1)", 1, partcv, params);
// compiled op node returning opresult9973 (depth = 7)
  int op_slot_left_9964 = gc_frame_newslot(opresult9973);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9974 = callmethod(opresult9973, "++(1)", 1, partcv, params);
// compiled op node returning opresult9974 (depth = 6)
  int op_slot_left_9961 = gc_frame_newslot(opresult9974);
  params[0] = strlit9962;
  partcv[0] = 1;
  Object opresult9975 = callmethod(opresult9974, "++(1)", 1, partcv, params);
// compiled op node returning opresult9975 (depth = 5)
  *var_s = opresult9975;
  if (opresult9975 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9954 = done;
  } else {
  }
// compiled if node returning if9954 (depth = 3)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9977 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9978 = gc_frame_new();
// call case 4: self request
  Object call9979 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9978);
// compiled member node returning call9979 (depth = 4)
  gc_frame_newslot(call9979);
// starting to compile block node (depth = 4)
  Object block9980 = alloc_Block(NULL, NULL, "ast", 2608);
  gc_frame_newslot(block9980);
// method "_apply(_)"
  block_savedest(block9980);
  Object closure9981 = createclosure(4, "_apply(1)");
  setclosureframe(closure9981, stackframe);
  addtoclosure(closure9981, var_depth);
  addtoclosure(closure9981, var_spc);
  addtoclosure(closure9981, var_s);
  addtoclosure(closure9981, selfslot);
  struct UserObject *uo9981 = (struct UserObject*)block9980;
  uo9981->data[0] = (Object)closure9981;
  Method *meth_meth_ast__apply_40_1_41_9981 = addmethod2pos(block9980, "_apply(1)", &meth_ast__apply_40_1_41_9981, 0);
  int argcv_meth_ast__apply_40_1_41_9981[] = {1};
  meth_meth_ast__apply_40_1_41_9981->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9981);
  meth_meth_ast__apply_40_1_41_9981->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9981->definitionLine = 2969;
// compiled block node returning block9980 (depth = 4)
  gc_frame_newslot(block9980);
// call case 5: prelude request
  params[0] = call9979;
  params[1] = block9980;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10012 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9977);
// compiled call node returning call10012 (depth = 3)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_10030(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10031 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10033 = alloc_Float64(1);
// compiled num node returning num10033 (depth = 9)
  int op_slot_right_10032 = gc_frame_newslot(num10033);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_10032 = gc_frame_newslot(*var_depth);
  params[0] = num10033;
  partcv[0] = 1;
  Object sum10035 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10035 (depth = 8)
  gc_frame_newslot(sum10035);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum10035;
  partcv[0] = 1;
  Object call10036 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10031);
// compiled call node returning call10036 (depth = 7)
  *var_s = call10036;
  if (call10036 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10040(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10042 == NULL) {
    strlit10042 = alloc_String(", ");
    gc_root(strlit10042);
  }
// compiled string node returning strlit10042 (depth = 8)
  int op_slot_right_10041 = gc_frame_newslot(strlit10042);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10041 = gc_frame_newslot(*var_s);
  params[0] = strlit10042;
  partcv[0] = 1;
  Object opresult10044 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10044 (depth = 7)
  *var_s = opresult10044;
  if (opresult10044 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_10013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10014 = gc_frame_new();
// call case 4: self request
  Object call10015 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10014);
// compiled member node returning call10015 (depth = 4)
  *var_s = call10015;
  if (call10015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10017 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10018 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10019 = gc_frame_new();
// call case 4: self request
  Object call10020 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10019);
// compiled member node returning call10020 (depth = 6)
  Object call10021 = callmethodflags(call10020, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe10018);
// compiled member node returning call10021 (depth = 5)
  Object call10022 = callmethodflags(call10021, "not", 0, partcv, params, 0);
  gc_frame_end(callframe10017);
// compiled member node returning call10022 (depth = 4)
  Object if10016 = done;
  if (istrue(call10022)) {
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10024 == NULL) {
    strlit10024 = alloc_String("(");
    gc_root(strlit10024);
  }
// compiled string node returning strlit10024 (depth = 6)
  int op_slot_right_10023 = gc_frame_newslot(strlit10024);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10023 = gc_frame_newslot(*var_s);
  params[0] = strlit10024;
  partcv[0] = 1;
  Object opresult10026 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10026 (depth = 5)
  *var_s = opresult10026;
  if (opresult10026 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10028 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10029 = alloc_Block(NULL, NULL, "ast", 2617);
  gc_frame_newslot(block10029);
// method "_apply(_)"
  block_savedest(block10029);
  Object closure10030 = createclosure(3, "_apply(1)");
  setclosureframe(closure10030, stackframe);
  addtoclosure(closure10030, var_depth);
  addtoclosure(closure10030, var_s);
  addtoclosure(closure10030, selfslot);
  struct UserObject *uo10030 = (struct UserObject*)block10029;
  uo10030->data[0] = (Object)closure10030;
  Method *meth_meth_ast__apply_40_1_41_10030 = addmethod2pos(block10029, "_apply(1)", &meth_ast__apply_40_1_41_10030, 0);
  int argcv_meth_ast__apply_40_1_41_10030[] = {1};
  meth_meth_ast__apply_40_1_41_10030->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10030);
  meth_meth_ast__apply_40_1_41_10030->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10030->definitionLine = 2969;
// compiled block node returning block10029 (depth = 5)
  gc_frame_newslot(block10029);
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block10039 = alloc_Block(NULL, NULL, "ast", 2618);
  gc_frame_newslot(block10039);
// method "_apply"
  block_savedest(block10039);
  Object closure10040 = createclosure(2, "_apply");
  setclosureframe(closure10040, stackframe);
  addtoclosure(closure10040, var_s);
  addtoclosure(closure10040, selfslot);
  struct UserObject *uo10040 = (struct UserObject*)block10039;
  uo10040->data[0] = (Object)closure10040;
  Method *meth_meth_ast__apply10040 = addmethod2pos(block10039, "_apply", &meth_ast__apply10040, 0);
  int argcv_meth_ast__apply10040[] = {0};
  meth_meth_ast__apply10040->type = alloc_MethodType(1, argcv_meth_ast__apply10040);
  meth_meth_ast__apply10040->definitionModule = modulename;
  meth_meth_ast__apply10040->definitionLine = 2969;
// compiled block node returning block10039 (depth = 5)
  gc_frame_newslot(block10039);
// call case 6: other requests
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10047 = gc_frame_new();
// call case 4: self request
  Object call10048 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10047);
// compiled member node returning call10048 (depth = 5)
  params[0] = block10029;
  params[1] = block10039;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10049 = callmethodflags(call10048, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10028);
// compiled call node returning call10049 (depth = 4)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10051 == NULL) {
    strlit10051 = alloc_String(")");
    gc_root(strlit10051);
  }
// compiled string node returning strlit10051 (depth = 6)
  int op_slot_right_10050 = gc_frame_newslot(strlit10051);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10050 = gc_frame_newslot(*var_s);
  params[0] = strlit10051;
  partcv[0] = 1;
  Object opresult10053 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10053 (depth = 5)
  *var_s = opresult10053;
  if (opresult10053 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10016 = done;
  } else {
  }
// compiled if node returning if10016 (depth = 3)
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy10055(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10056 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10057 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10058 = gc_frame_new();
// call case 4: self request
  Object call10059 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10058);
// compiled member node returning call10059 (depth = 5)
  gc_frame_newslot(call10059);
// starting to compile member node (depth = 5)
  int callframe10060 = gc_frame_new();
// call case 4: self request
  Object call10061 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10060);
// compiled member node returning call10061 (depth = 5)
  gc_frame_newslot(call10061);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signaturePart (depth = 5)
  params[0] = call10059;
  params[1] = call10061;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10062 = callmethodflags(*var_signaturePart, "partName(1)params(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10057);
// compiled call node returning call10062 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10063 = callmethodflags(call10062, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10056);
// compiled call node returning call10063 (depth = 3)
  gc_frame_end(frame);
  return call10063;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_10064(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10065 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10066 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10065);
// compiled call node returning call10066 (depth = 3)
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10067 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10068 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10069 = callmethodflags(*var_other, "typeParams", 0, partcv, params, 0);
  gc_frame_end(callframe10068);
// compiled member node returning call10069 (depth = 4)
  gc_frame_newslot(call10069);
// call case 4: self request
  params[0] = call10069;
  partcv[0] = 1;
  Object call10070 = callmethodflags(self, "typeParams:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10067);
// compiled call node returning call10070 (depth = 3)
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10071 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10072 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10073 = callmethodflags(*var_other, "lineLength", 0, partcv, params, 0);
  gc_frame_end(callframe10072);
// compiled member node returning call10073 (depth = 4)
  gc_frame_newslot(call10073);
// call case 4: self request
  params[0] = call10073;
  partcv[0] = 1;
  Object call10074 = callmethodflags(self, "lineLength:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10071);
// compiled call node returning call10074 (depth = 3)
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString10075(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10077 == NULL) {
    strlit10077 = alloc_String("");
    gc_root(strlit10077);
  }
// compiled string node returning strlit10077 (depth = 4)
  int op_slot_right_10076 = gc_frame_newslot(strlit10077);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10080 = gc_frame_new();
// call case 4: self request
  Object call10081 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10080);
// compiled member node returning call10081 (depth = 5)
  int op_slot_right_10079 = gc_frame_newslot(call10081);
// starting to compile string node (depth = 5)
  if (strlit10083 == NULL) {
    strlit10083 = alloc_String("part: ");
    gc_root(strlit10083);
  }
// compiled string node returning strlit10083 (depth = 5)
  int op_slot_left_10079 = gc_frame_newslot(strlit10083);
  params[0] = call10081;
  partcv[0] = 1;
  Object opresult10084 = callmethod(strlit10083, "++(1)", 1, partcv, params);
// compiled op node returning opresult10084 (depth = 4)
  int op_slot_left_10076 = gc_frame_newslot(opresult10084);
  params[0] = strlit10077;
  partcv[0] = 1;
  Object opresult10085 = callmethod(opresult10084, "++(1)", 1, partcv, params);
// compiled op node returning opresult10085 (depth = 3)
  gc_frame_end(frame);
  return opresult10085;
}
Object meth_ast_partName_40_1_41_params_40_1_41_9779(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName(1)params(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9780 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9780 = alloc_userobj2(20,17, objclass9780);
  gc_frame_newslot(obj9780);
if (objclass9780 == NULL) {
  glfree(obj9780->class->name);
  obj9780->class->name = "signaturePart.partName(_)params(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9780, self, 0);
  addmethodreal(obj9780,"outer", &reader_ast_outer_9781);
  Object oldself9780 = self;
  struct StackFrameObject *oldstackframe9780 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9780);
  gc_frame_newslot((Object)stackframe);
  self = obj9780;
  Object *oldselfslot9780 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9780 = (*(struct UserObject *)self).data[0], lowerouter9780 = thisouter9780;
  if (inheritingObject9780) {
    struct UserObject *inho9780 = (struct UserObject *)inheritingObject9780;
    while (inho9780->super != GraceDefaultObject) inho9780 = (struct UserObject *)inho9780->super;
    inho9780->super = obj9780;
    self = inheritingObject9780;
    *selfslot = self;
    lowerouter9780 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9780;
  }
if (objclass9780 == NULL) {
  Method *reader9782 = addmethodrealflags(obj9780, "kind",&reader_ast_kind_9782, MFLAG_DEF);
  reader9782->definitionModule = modulename;
  reader9782->definitionLine = 2565;
}
adddatum2(obj9780, alloc_Undefined(), 1);
if (objclass9780 == NULL) {
  Method *reader9783 = addmethodrealflags(obj9780, "name", &reader_ast_name_9783, 0);
  Method *writer9783 = addmethodrealflags(obj9780, "name:=(1)", &writer_ast_name_9783, 0);
  reader9783->definitionModule = modulename;
  writer9783->definitionModule = modulename;
  reader9783->definitionLine = 2566;
  writer9783->definitionLine = 2566;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 2);
if (objclass9780 == NULL) {
  Method *reader9784 = addmethodrealflags(obj9780, "params", &reader_ast_params_9784, 0);
  Method *writer9784 = addmethodrealflags(obj9780, "params:=(1)", &writer_ast_params_9784, 0);
  reader9784->definitionModule = modulename;
  writer9784->definitionModule = modulename;
  reader9784->definitionLine = 2567;
  writer9784->definitionLine = 2567;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 3);
if (objclass9780 == NULL) {
  Method *reader9785 = addmethodrealflags(obj9780, "typeParams", &reader_ast_typeParams_9785, 0);
  Method *writer9785 = addmethodrealflags(obj9780, "typeParams:=(1)", &writer_ast_typeParams_9785, 0);
  reader9785->definitionModule = modulename;
  writer9785->definitionModule = modulename;
  reader9785->definitionLine = 2568;
  writer9785->definitionLine = 2568;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 4);
if (objclass9780 == NULL) {
  Method *reader9786 = addmethodrealflags(obj9780, "lineLength", &reader_ast_lineLength_9786, 0);
  Method *writer9786 = addmethodrealflags(obj9780, "lineLength:=(1)", &writer_ast_lineLength_9786, 0);
  reader9786->definitionModule = modulename;
  writer9786->definitionModule = modulename;
  reader9786->definitionLine = 2569;
  writer9786->definitionLine = 2569;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo9787 = (struct UserObject*)obj9780;
  uo9787->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9787 = addmethod2pos(obj9780, "nameString", &meth_ast_nameString9787, 6);
  int argcv_meth_ast_nameString9787[] = {0};
  meth_meth_ast_nameString9787->type = alloc_MethodType(1, argcv_meth_ast_nameString9787);
  meth_meth_ast_nameString9787->definitionModule = modulename;
  meth_meth_ast_nameString9787->definitionLine = 2571;
// method "numParams"
  struct UserObject *uo9812 = (struct UserObject*)obj9780;
  uo9812->data[7] = emptyclosure;
  Method *meth_meth_ast_numParams9812 = addmethod2pos(obj9780, "numParams", &meth_ast_numParams9812, 7);
  int argcv_meth_ast_numParams9812[] = {0};
  meth_meth_ast_numParams9812->type = alloc_MethodType(1, argcv_meth_ast_numParams9812);
  meth_meth_ast_numParams9812->definitionModule = modulename;
  meth_meth_ast_numParams9812->definitionLine = 2575;
// method "canonicalName"
  struct UserObject *uo9817 = (struct UserObject*)obj9780;
  uo9817->data[8] = emptyclosure;
  Method *meth_meth_ast_canonicalName9817 = addmethod2pos(obj9780, "canonicalName", &meth_ast_canonicalName9817, 8);
  int argcv_meth_ast_canonicalName9817[] = {0};
  meth_meth_ast_canonicalName9817->type = alloc_MethodType(1, argcv_meth_ast_canonicalName9817);
  meth_meth_ast_canonicalName9817->definitionModule = modulename;
  meth_meth_ast_canonicalName9817->definitionLine = 2576;
// method "accept(_)from(_)"
  struct UserObject *uo9863 = (struct UserObject*)obj9780;
  uo9863->data[9] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9863 = addmethod2pos(obj9780, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9863, 9);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9863[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9863->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9863);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9863->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9863->definitionLine = 2584;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9780);
  Object closure9889 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9889, stackframe);
  addtoclosure(closure9889, var_k);
  struct UserObject *uo9889 = (struct UserObject*)obj9780;
  uo9889->data[10] = (Object)closure9889;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_9889 = addmethod2pos(obj9780, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_9889, 10);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_9889[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9889->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_9889);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9889->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9889->definitionLine = 2593;
// method "map(_)ancestors(_)"
  struct UserObject *uo9892 = (struct UserObject*)obj9780;
  uo9892->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9892 = addmethod2pos(obj9780, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9892, 11);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9892[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9892->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9892);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9892->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9892->definitionLine = 2594;
// method "pretty(_)"
  struct UserObject *uo9919 = (struct UserObject*)obj9780;
  uo9919->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9919 = addmethod2pos(obj9780, "pretty(1)", &meth_ast_pretty_40_1_41_9919, 12);
  int argcv_meth_ast_pretty_40_1_41_9919[] = {1};
  meth_meth_ast_pretty_40_1_41_9919->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9919);
  meth_meth_ast_pretty_40_1_41_9919->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9919->definitionLine = 2601;
// method "toGrace(_)"
  struct UserObject *uo10013 = (struct UserObject*)obj9780;
  uo10013->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_10013 = addmethod2pos(obj9780, "toGrace(1)", &meth_ast_toGrace_40_1_41_10013, 13);
  int argcv_meth_ast_toGrace_40_1_41_10013[] = {1};
  meth_meth_ast_toGrace_40_1_41_10013->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10013);
  meth_meth_ast_toGrace_40_1_41_10013->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10013->definitionLine = 2613;
// method "shallowCopy"
  block_savedest(obj9780);
  Object closure10055 = createclosure(1, "shallowCopy");
  setclosureframe(closure10055, stackframe);
  addtoclosure(closure10055, var_signaturePart);
  struct UserObject *uo10055 = (struct UserObject*)obj9780;
  uo10055->data[14] = (Object)closure10055;
  Method *meth_meth_ast_shallowCopy10055 = addmethod2pos(obj9780, "shallowCopy", &meth_ast_shallowCopy10055, 14);
  int argcv_meth_ast_shallowCopy10055[] = {0};
  meth_meth_ast_shallowCopy10055->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10055);
  meth_meth_ast_shallowCopy10055->definitionModule = modulename;
  meth_meth_ast_shallowCopy10055->definitionLine = 2623;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10064 = (struct UserObject*)obj9780;
  uo10064->data[15] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10064 = addmethod2pos(obj9780, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10064, 15);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10064[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10064->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10064);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10064->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10064->definitionLine = 2627;
// method "asString"
  struct UserObject *uo10075 = (struct UserObject*)obj9780;
  uo10075->data[16] = emptyclosure;
  Method *meth_meth_ast_asString10075 = addmethod2pos(obj9780, "asString", &meth_ast_asString10075, 16);
  int argcv_meth_ast_asString10075[] = {0};
  meth_meth_ast_asString10075->type = alloc_MethodType(1, argcv_meth_ast_asString10075);
  meth_meth_ast_asString10075->definitionModule = modulename;
  meth_meth_ast_asString10075->definitionLine = 2633;
  sourceObject = obj9780;
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10086 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10087 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10088 = gc_frame_new();
// call case 3: self.outer request
  Object call10089 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10088);
// compiled member node returning call10089 (depth = 5)
  Object call10090 = callmethodflags(call10089, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10087);
// compiled member node returning call10090 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10091 = callmethodflags(call10090, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10086);
// compiled call node returning call10091 (depth = 3)
  struct UserObject *obj9780_uo = (struct UserObject *)obj9780;
  obj9780_uo->super = call10091;
  sourceObject = obj9780;
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10092 == NULL) {
    strlit10092 = alloc_String("signaturepart");
    gc_root(strlit10092);
  }
// compiled string node returning strlit10092 (depth = 3)
  adddatum2(obj9780, strlit10092, 1);
  sourceObject = obj9780;
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj9780, *var_n, 2);
  sourceObject = obj9780;
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj9780, *var_ps, 3);
  sourceObject = obj9780;
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10093 = alloc_Boolean(0);
// compiled identifier node returning bool10093 (depth = 3)
  adddatum2(obj9780, bool10093, 4);
  sourceObject = obj9780;
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10094 = alloc_Float64(0);
// compiled num node returning num10094 (depth = 3)
  adddatum2(obj9780, num10094, 5);
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  objclass9780 = obj9780->class;
  objclass9780->definitionModule = modulename;
  objclass9780->definitionLine = 2563;
  (*(struct UserObject *)self).data[0] = lowerouter9780;
  self = oldself9780;
  selfslot = oldselfslot9780;
  stackframe = oldstackframe9780;
  gc_frame_end(frame);
  return obj9780;
}
Object meth_ast_partName_40_1_41_params_40_1_41_9779_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName(1)params(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method partName(_)params(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method partName(_)params(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9780 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9780 = alloc_userobj2(20,17, objclass9780);
  gc_frame_newslot(obj9780);
if (objclass9780 == NULL) {
  glfree(obj9780->class->name);
  obj9780->class->name = "signaturePart.partName(_)params(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9780, self, 0);
  addmethodreal(obj9780,"outer", &reader_ast_outer_9781);
  Object oldself9780 = self;
  struct StackFrameObject *oldstackframe9780 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9780);
  gc_frame_newslot((Object)stackframe);
  self = obj9780;
  Object *oldselfslot9780 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9780 = (*(struct UserObject *)self).data[0], lowerouter9780 = thisouter9780;
  if (inheritingObject9780) {
    struct UserObject *inho9780 = (struct UserObject *)inheritingObject9780;
    while (inho9780->super != GraceDefaultObject) inho9780 = (struct UserObject *)inho9780->super;
    inho9780->super = obj9780;
    self = inheritingObject9780;
    *selfslot = self;
    lowerouter9780 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9780;
  }
if (objclass9780 == NULL) {
  Method *reader9782 = addmethodrealflags(obj9780, "kind",&reader_ast_kind_9782, MFLAG_DEF);
  reader9782->definitionModule = modulename;
  reader9782->definitionLine = 2565;
}
adddatum2(obj9780, alloc_Undefined(), 1);
if (objclass9780 == NULL) {
  Method *reader9783 = addmethodrealflags(obj9780, "name", &reader_ast_name_9783, 0);
  Method *writer9783 = addmethodrealflags(obj9780, "name:=(1)", &writer_ast_name_9783, 0);
  reader9783->definitionModule = modulename;
  writer9783->definitionModule = modulename;
  reader9783->definitionLine = 2566;
  writer9783->definitionLine = 2566;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 2);
if (objclass9780 == NULL) {
  Method *reader9784 = addmethodrealflags(obj9780, "params", &reader_ast_params_9784, 0);
  Method *writer9784 = addmethodrealflags(obj9780, "params:=(1)", &writer_ast_params_9784, 0);
  reader9784->definitionModule = modulename;
  writer9784->definitionModule = modulename;
  reader9784->definitionLine = 2567;
  writer9784->definitionLine = 2567;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 3);
if (objclass9780 == NULL) {
  Method *reader9785 = addmethodrealflags(obj9780, "typeParams", &reader_ast_typeParams_9785, 0);
  Method *writer9785 = addmethodrealflags(obj9780, "typeParams:=(1)", &writer_ast_typeParams_9785, 0);
  reader9785->definitionModule = modulename;
  writer9785->definitionModule = modulename;
  reader9785->definitionLine = 2568;
  writer9785->definitionLine = 2568;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 4);
if (objclass9780 == NULL) {
  Method *reader9786 = addmethodrealflags(obj9780, "lineLength", &reader_ast_lineLength_9786, 0);
  Method *writer9786 = addmethodrealflags(obj9780, "lineLength:=(1)", &writer_ast_lineLength_9786, 0);
  reader9786->definitionModule = modulename;
  writer9786->definitionModule = modulename;
  reader9786->definitionLine = 2569;
  writer9786->definitionLine = 2569;
}
obj9780->flags |= OFLAG_MUTABLE;
adddatum2(obj9780, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo9787 = (struct UserObject*)obj9780;
  uo9787->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9787 = addmethod2pos(obj9780, "nameString", &meth_ast_nameString9787, 6);
  int argcv_meth_ast_nameString9787[] = {0};
  meth_meth_ast_nameString9787->type = alloc_MethodType(1, argcv_meth_ast_nameString9787);
  meth_meth_ast_nameString9787->definitionModule = modulename;
  meth_meth_ast_nameString9787->definitionLine = 2571;
// method "numParams"
  struct UserObject *uo9812 = (struct UserObject*)obj9780;
  uo9812->data[7] = emptyclosure;
  Method *meth_meth_ast_numParams9812 = addmethod2pos(obj9780, "numParams", &meth_ast_numParams9812, 7);
  int argcv_meth_ast_numParams9812[] = {0};
  meth_meth_ast_numParams9812->type = alloc_MethodType(1, argcv_meth_ast_numParams9812);
  meth_meth_ast_numParams9812->definitionModule = modulename;
  meth_meth_ast_numParams9812->definitionLine = 2575;
// method "canonicalName"
  struct UserObject *uo9817 = (struct UserObject*)obj9780;
  uo9817->data[8] = emptyclosure;
  Method *meth_meth_ast_canonicalName9817 = addmethod2pos(obj9780, "canonicalName", &meth_ast_canonicalName9817, 8);
  int argcv_meth_ast_canonicalName9817[] = {0};
  meth_meth_ast_canonicalName9817->type = alloc_MethodType(1, argcv_meth_ast_canonicalName9817);
  meth_meth_ast_canonicalName9817->definitionModule = modulename;
  meth_meth_ast_canonicalName9817->definitionLine = 2576;
// method "accept(_)from(_)"
  struct UserObject *uo9863 = (struct UserObject*)obj9780;
  uo9863->data[9] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9863 = addmethod2pos(obj9780, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9863, 9);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9863[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9863->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9863);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9863->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9863->definitionLine = 2584;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9780);
  Object closure9889 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9889, stackframe);
  addtoclosure(closure9889, var_k);
  struct UserObject *uo9889 = (struct UserObject*)obj9780;
  uo9889->data[10] = (Object)closure9889;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_9889 = addmethod2pos(obj9780, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_9889, 10);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_9889[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9889->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_9889);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9889->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9889->definitionLine = 2593;
// method "map(_)ancestors(_)"
  struct UserObject *uo9892 = (struct UserObject*)obj9780;
  uo9892->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9892 = addmethod2pos(obj9780, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9892, 11);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9892[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9892->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9892);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9892->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9892->definitionLine = 2594;
// method "pretty(_)"
  struct UserObject *uo9919 = (struct UserObject*)obj9780;
  uo9919->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9919 = addmethod2pos(obj9780, "pretty(1)", &meth_ast_pretty_40_1_41_9919, 12);
  int argcv_meth_ast_pretty_40_1_41_9919[] = {1};
  meth_meth_ast_pretty_40_1_41_9919->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9919);
  meth_meth_ast_pretty_40_1_41_9919->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9919->definitionLine = 2601;
// method "toGrace(_)"
  struct UserObject *uo10013 = (struct UserObject*)obj9780;
  uo10013->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_10013 = addmethod2pos(obj9780, "toGrace(1)", &meth_ast_toGrace_40_1_41_10013, 13);
  int argcv_meth_ast_toGrace_40_1_41_10013[] = {1};
  meth_meth_ast_toGrace_40_1_41_10013->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10013);
  meth_meth_ast_toGrace_40_1_41_10013->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10013->definitionLine = 2613;
// method "shallowCopy"
  block_savedest(obj9780);
  Object closure10055 = createclosure(1, "shallowCopy");
  setclosureframe(closure10055, stackframe);
  addtoclosure(closure10055, var_signaturePart);
  struct UserObject *uo10055 = (struct UserObject*)obj9780;
  uo10055->data[14] = (Object)closure10055;
  Method *meth_meth_ast_shallowCopy10055 = addmethod2pos(obj9780, "shallowCopy", &meth_ast_shallowCopy10055, 14);
  int argcv_meth_ast_shallowCopy10055[] = {0};
  meth_meth_ast_shallowCopy10055->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10055);
  meth_meth_ast_shallowCopy10055->definitionModule = modulename;
  meth_meth_ast_shallowCopy10055->definitionLine = 2623;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10064 = (struct UserObject*)obj9780;
  uo10064->data[15] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10064 = addmethod2pos(obj9780, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10064, 15);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10064[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10064->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10064);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10064->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10064->definitionLine = 2627;
// method "asString"
  struct UserObject *uo10075 = (struct UserObject*)obj9780;
  uo10075->data[16] = emptyclosure;
  Method *meth_meth_ast_asString10075 = addmethod2pos(obj9780, "asString", &meth_ast_asString10075, 16);
  int argcv_meth_ast_asString10075[] = {0};
  meth_meth_ast_asString10075->type = alloc_MethodType(1, argcv_meth_ast_asString10075);
  meth_meth_ast_asString10075->definitionModule = modulename;
  meth_meth_ast_asString10075->definitionLine = 2633;
  sourceObject = obj9780;
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10086 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10087 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10088 = gc_frame_new();
// call case 3: self.outer request
  Object call10089 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10088);
// compiled member node returning call10089 (depth = 5)
  Object call10090 = callmethodflags(call10089, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10087);
// compiled member node returning call10090 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10091 = callmethodflags(call10090, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10086);
// compiled call node returning call10091 (depth = 3)
  struct UserObject *obj9780_uo = (struct UserObject *)obj9780;
  obj9780_uo->super = call10091;
  sourceObject = obj9780;
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10092 == NULL) {
    strlit10092 = alloc_String("signaturepart");
    gc_root(strlit10092);
  }
// compiled string node returning strlit10092 (depth = 3)
  adddatum2(obj9780, strlit10092, 1);
  sourceObject = obj9780;
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj9780, *var_n, 2);
  sourceObject = obj9780;
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj9780, *var_ps, 3);
  sourceObject = obj9780;
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10093 = alloc_Boolean(0);
// compiled identifier node returning bool10093 (depth = 3)
  adddatum2(obj9780, bool10093, 4);
  sourceObject = obj9780;
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10094 = alloc_Float64(0);
// compiled num node returning num10094 (depth = 3)
  adddatum2(obj9780, num10094, 5);
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  sourceObject = obj9780;
  objclass9780 = obj9780->class;
  objclass9780->definitionModule = modulename;
  objclass9780->definitionLine = 2563;
  (*(struct UserObject *)self).data[0] = lowerouter9780;
  self = oldself9780;
  selfslot = oldselfslot9780;
  stackframe = oldstackframe9780;
  gc_frame_end(frame);
  return obj9780;
}
Object meth_ast_signaturePart10096(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signaturePart (depth = 3)
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast_new10099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10100 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10101 == NULL) {
    strlit10101 = alloc_String("");
    gc_root(strlit10101);
  }
// compiled string node returning strlit10101 (depth = 4)
  gc_frame_newslot(strlit10101);
// starting to compile array node (depth = 4)
  Object array10102 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10102 (depth = 4)
  gc_frame_newslot(array10102);
// call case 4: self request
  params[0] = strlit10101;
  params[1] = array10102;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10103 = callmethodflags(self, "request(1)withArgs(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10100);
// compiled call node returning call10103 (depth = 3)
  gc_frame_end(frame);
  return call10103;
}
Object meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "request(1)withArgs(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_argList = &(stackframe->slots[1]);
  *var_argList = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10105 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_argList (depth = 5)
  gc_frame_newslot(*var_argList);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_argList;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10106 = callmethodflags(self, "request(1)withArgs(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10105);
// compiled call node returning call10106 (depth = 4)
  *var_result = call10106;
  if (call10106 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10107 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10108 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10107);
// compiled call node returning call10108 (depth = 3)
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_nameString10117(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10120 = alloc_Float64(0);
// compiled num node returning num10120 (depth = 5)
  int op_slot_right_10119 = gc_frame_newslot(num10120);
// starting to compile member node (depth = 5)
  int callframe10122 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10123 = gc_frame_new();
// call case 4: self request
  Object call10124 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10123);
// compiled member node returning call10124 (depth = 6)
  Object call10125 = callmethodflags(call10124, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10122);
// compiled member node returning call10125 (depth = 5)
  int op_slot_left_10119 = gc_frame_newslot(call10125);
  params[0] = num10120;
  partcv[0] = 1;
  Object opresult10126 = callmethod(call10125, "==(1)", 1, partcv, params);
// compiled op node returning opresult10126 (depth = 4)
  Object if10118 = done;
  if (istrue(opresult10126)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10127 = gc_frame_new();
// call case 4: self request
  Object call10128 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10127);
// compiled member node returning call10128 (depth = 5)
  return call10128;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10118 = undefined;
  } else {
  }
// compiled if node returning if10118 (depth = 3)
// Begin line 2658
  setline(2658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10130 == NULL) {
    strlit10130 = alloc_String(")");
    gc_root(strlit10130);
  }
// compiled string node returning strlit10130 (depth = 4)
  int op_slot_right_10129 = gc_frame_newslot(strlit10130);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10133 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10134 = gc_frame_new();
// call case 4: self request
  Object call10135 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10134);
// compiled member node returning call10135 (depth = 6)
  Object call10136 = callmethodflags(call10135, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10133);
// compiled member node returning call10136 (depth = 5)
  int op_slot_right_10132 = gc_frame_newslot(call10136);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10139 == NULL) {
    strlit10139 = alloc_String("(");
    gc_root(strlit10139);
  }
// compiled string node returning strlit10139 (depth = 6)
  int op_slot_right_10138 = gc_frame_newslot(strlit10139);
// starting to compile member node (depth = 6)
  int callframe10141 = gc_frame_new();
// call case 4: self request
  Object call10142 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10141);
// compiled member node returning call10142 (depth = 6)
  int op_slot_left_10138 = gc_frame_newslot(call10142);
  params[0] = strlit10139;
  partcv[0] = 1;
  Object opresult10143 = callmethod(call10142, "++(1)", 1, partcv, params);
// compiled op node returning opresult10143 (depth = 5)
  int op_slot_left_10132 = gc_frame_newslot(opresult10143);
  params[0] = call10136;
  partcv[0] = 1;
  Object opresult10144 = callmethod(opresult10143, "++(1)", 1, partcv, params);
// compiled op node returning opresult10144 (depth = 4)
  int op_slot_left_10129 = gc_frame_newslot(opresult10144);
  params[0] = strlit10130;
  partcv[0] = 1;
  Object opresult10145 = callmethod(opresult10144, "++(1)", 1, partcv, params);
// compiled op node returning opresult10145 (depth = 3)
  gc_frame_end(frame);
  return opresult10145;
}
Object meth_ast__apply_40_1_41_10161(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___4 = &(stackframe->slots[0]);
  *var___4 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10163 == NULL) {
    strlit10163 = alloc_String("_");
    gc_root(strlit10163);
  }
// compiled string node returning strlit10163 (depth = 7)
  int op_slot_right_10162 = gc_frame_newslot(strlit10163);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_10162 = gc_frame_newslot(*var_underScores);
  params[0] = strlit10163;
  partcv[0] = 1;
  Object opresult10165 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult10165 (depth = 6)
  *var_underScores = opresult10165;
  if (opresult10165 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10169(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10171 == NULL) {
    strlit10171 = alloc_String(",");
    gc_root(strlit10171);
  }
// compiled string node returning strlit10171 (depth = 7)
  int op_slot_right_10170 = gc_frame_newslot(strlit10171);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_10170 = gc_frame_newslot(*var_underScores);
  params[0] = strlit10171;
  partcv[0] = 1;
  Object opresult10173 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult10173 (depth = 6)
  *var_underScores = opresult10173;
  if (opresult10173 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_canonicalName10146(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_underScores = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "underScores");
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10149 = alloc_Float64(0);
// compiled num node returning num10149 (depth = 5)
  int op_slot_right_10148 = gc_frame_newslot(num10149);
// starting to compile member node (depth = 5)
  int callframe10151 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10152 = gc_frame_new();
// call case 4: self request
  Object call10153 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10152);
// compiled member node returning call10153 (depth = 6)
  Object call10154 = callmethodflags(call10153, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10151);
// compiled member node returning call10154 (depth = 5)
  int op_slot_left_10148 = gc_frame_newslot(call10154);
  params[0] = num10149;
  partcv[0] = 1;
  Object opresult10155 = callmethod(call10154, "==(1)", 1, partcv, params);
// compiled op node returning opresult10155 (depth = 4)
  Object if10147 = done;
  if (istrue(opresult10155)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10156 = gc_frame_new();
// call case 4: self request
  Object call10157 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10156);
// compiled member node returning call10157 (depth = 5)
  return call10157;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10147 = undefined;
  } else {
  }
// compiled if node returning if10147 (depth = 3)
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10158 == NULL) {
    strlit10158 = alloc_String("");
    gc_root(strlit10158);
  }
// compiled string node returning strlit10158 (depth = 4)
  *var_underScores = strlit10158;
  if (strlit10158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10159 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10160 = alloc_Block(NULL, NULL, "ast", 2664);
  gc_frame_newslot(block10160);
// method "_apply(_)"
  block_savedest(block10160);
  Object closure10161 = createclosure(2, "_apply(1)");
  setclosureframe(closure10161, stackframe);
  addtoclosure(closure10161, var_underScores);
  addtoclosure(closure10161, selfslot);
  struct UserObject *uo10161 = (struct UserObject*)block10160;
  uo10161->data[0] = (Object)closure10161;
  Method *meth_meth_ast__apply_40_1_41_10161 = addmethod2pos(block10160, "_apply(1)", &meth_ast__apply_40_1_41_10161, 0);
  int argcv_meth_ast__apply_40_1_41_10161[] = {1};
  meth_meth_ast__apply_40_1_41_10161->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10161);
  meth_meth_ast__apply_40_1_41_10161->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10161->definitionLine = 2969;
// compiled block node returning block10160 (depth = 4)
  gc_frame_newslot(block10160);
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block10168 = alloc_Block(NULL, NULL, "ast", 2665);
  gc_frame_newslot(block10168);
// method "_apply"
  block_savedest(block10168);
  Object closure10169 = createclosure(2, "_apply");
  setclosureframe(closure10169, stackframe);
  addtoclosure(closure10169, var_underScores);
  addtoclosure(closure10169, selfslot);
  struct UserObject *uo10169 = (struct UserObject*)block10168;
  uo10169->data[0] = (Object)closure10169;
  Method *meth_meth_ast__apply10169 = addmethod2pos(block10168, "_apply", &meth_ast__apply10169, 0);
  int argcv_meth_ast__apply10169[] = {0};
  meth_meth_ast__apply10169->type = alloc_MethodType(1, argcv_meth_ast__apply10169);
  meth_meth_ast__apply10169->definitionModule = modulename;
  meth_meth_ast__apply10169->definitionLine = 2969;
// compiled block node returning block10168 (depth = 4)
  gc_frame_newslot(block10168);
// call case 6: other requests
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10176 = gc_frame_new();
// call case 4: self request
  Object call10177 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10176);
// compiled member node returning call10177 (depth = 4)
  params[0] = block10160;
  params[1] = block10168;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10178 = callmethodflags(call10177, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10159);
// compiled call node returning call10178 (depth = 3)
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10180 == NULL) {
    strlit10180 = alloc_String(")");
    gc_root(strlit10180);
  }
// compiled string node returning strlit10180 (depth = 4)
  int op_slot_right_10179 = gc_frame_newslot(strlit10180);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_underScores (depth = 5)
  int op_slot_right_10182 = gc_frame_newslot(*var_underScores);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10185 == NULL) {
    strlit10185 = alloc_String("(");
    gc_root(strlit10185);
  }
// compiled string node returning strlit10185 (depth = 6)
  int op_slot_right_10184 = gc_frame_newslot(strlit10185);
// starting to compile member node (depth = 6)
  int callframe10187 = gc_frame_new();
// call case 4: self request
  Object call10188 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10187);
// compiled member node returning call10188 (depth = 6)
  int op_slot_left_10184 = gc_frame_newslot(call10188);
  params[0] = strlit10185;
  partcv[0] = 1;
  Object opresult10189 = callmethod(call10188, "++(1)", 1, partcv, params);
// compiled op node returning opresult10189 (depth = 5)
  int op_slot_left_10182 = gc_frame_newslot(opresult10189);
  params[0] = *var_underScores;
  partcv[0] = 1;
  Object opresult10190 = callmethod(opresult10189, "++(1)", 1, partcv, params);
// compiled op node returning opresult10190 (depth = 4)
  int op_slot_left_10179 = gc_frame_newslot(opresult10190);
  params[0] = strlit10180;
  partcv[0] = 1;
  Object opresult10191 = callmethod(opresult10190, "++(1)", 1, partcv, params);
// compiled op node returning opresult10191 (depth = 3)
  gc_frame_end(frame);
  return opresult10191;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_10192(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10193 = gc_frame_new();
// call case 4: self request
  Object call10194 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10193);
// compiled member node returning call10194 (depth = 4)
  *var_n = call10194;
  if (call10194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10195 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10196 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10195);
// compiled call node returning call10196 (depth = 4)
  *var_newChain = call10196;
  if (call10196 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10197 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10198 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10199 = gc_frame_new();
// call case 4: self request
  Object call10200 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10199);
// compiled member node returning call10200 (depth = 5)
  gc_frame_newslot(call10200);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10201 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10202 = gc_frame_new();
// call case 3: self.outer request
  Object call10203 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10202);
// compiled member node returning call10203 (depth = 6)
  Object call10204 = callmethodflags(call10203, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10201);
// compiled member node returning call10204 (depth = 5)
  params[0] = call10200;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10205 = callmethodflags(call10204, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10198);
// compiled call node returning call10205 (depth = 4)
  gc_frame_newslot(call10205);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call10205;
  partcv[0] = 1;
  Object call10206 = callmethodflags(*var_n, "args:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10197);
// compiled call node returning call10206 (depth = 3)
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10207 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10208 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10207);
// compiled call node returning call10208 (depth = 3)
  gc_frame_end(frame);
  return call10208;
}
Object meth_ast__apply10217(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10219 == NULL) {
    strlit10219 = alloc_String("  ");
    gc_root(strlit10219);
  }
// compiled string node returning strlit10219 (depth = 7)
  int op_slot_right_10218 = gc_frame_newslot(strlit10219);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_10218 = gc_frame_newslot(*var_spc);
  params[0] = strlit10219;
  partcv[0] = 1;
  Object opresult10221 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult10221 (depth = 6)
  *var_spc = opresult10221;
  if (opresult10221 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_10264(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10266 == NULL) {
    strlit10266 = alloc_String("");
    gc_root(strlit10266);
  }
// compiled string node returning strlit10266 (depth = 7)
  int op_slot_right_10265 = gc_frame_newslot(strlit10266);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10269 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10271 = alloc_Float64(4);
// compiled num node returning num10271 (depth = 10)
  int op_slot_right_10270 = gc_frame_newslot(num10271);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10270 = gc_frame_newslot(*var_depth);
  params[0] = num10271;
  partcv[0] = 1;
  Object sum10273 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10273 (depth = 9)
  gc_frame_newslot(sum10273);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = sum10273;
  partcv[0] = 1;
  Object call10274 = callmethodflags(*var_a, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10269);
// compiled call node returning call10274 (depth = 8)
  int op_slot_right_10268 = gc_frame_newslot(call10274);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10277 == NULL) {
    strlit10277 = alloc_String("");
    gc_root(strlit10277);
  }
// compiled string node returning strlit10277 (depth = 9)
  int op_slot_right_10276 = gc_frame_newslot(strlit10277);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_10279 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10282 == NULL) {
    strlit10282 = alloc_String("""\x0a""    ");
    gc_root(strlit10282);
  }
// compiled string node returning strlit10282 (depth = 11)
  int op_slot_right_10281 = gc_frame_newslot(strlit10282);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_10284 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit10286 == NULL) {
    strlit10286 = alloc_String("");
    gc_root(strlit10286);
  }
// compiled string node returning strlit10286 (depth = 12)
  int op_slot_left_10284 = gc_frame_newslot(strlit10286);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10287 = callmethod(strlit10286, "++(1)", 1, partcv, params);
// compiled op node returning opresult10287 (depth = 11)
  int op_slot_left_10281 = gc_frame_newslot(opresult10287);
  params[0] = strlit10282;
  partcv[0] = 1;
  Object opresult10288 = callmethod(opresult10287, "++(1)", 1, partcv, params);
// compiled op node returning opresult10288 (depth = 10)
  int op_slot_left_10279 = gc_frame_newslot(opresult10288);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10289 = callmethod(opresult10288, "++(1)", 1, partcv, params);
// compiled op node returning opresult10289 (depth = 9)
  int op_slot_left_10276 = gc_frame_newslot(opresult10289);
  params[0] = strlit10277;
  partcv[0] = 1;
  Object opresult10290 = callmethod(opresult10289, "++(1)", 1, partcv, params);
// compiled op node returning opresult10290 (depth = 8)
  int op_slot_left_10268 = gc_frame_newslot(opresult10290);
  params[0] = call10274;
  partcv[0] = 1;
  Object opresult10291 = callmethod(opresult10290, "++(1)", 1, partcv, params);
// compiled op node returning opresult10291 (depth = 7)
  int op_slot_left_10265 = gc_frame_newslot(opresult10291);
  params[0] = strlit10266;
  partcv[0] = 1;
  Object opresult10292 = callmethod(opresult10291, "++(1)", 1, partcv, params);
// compiled op node returning opresult10292 (depth = 6)
  *var_s = opresult10292;
  if (opresult10292 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_10209(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10210 == NULL) {
    strlit10210 = alloc_String("");
    gc_root(strlit10210);
  }
// compiled string node returning strlit10210 (depth = 4)
  *var_spc = strlit10210;
  if (strlit10210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10211 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10213 = alloc_Float64(1);
// compiled num node returning num10213 (depth = 5)
  int op_slot_right_10212 = gc_frame_newslot(num10213);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_10212 = gc_frame_newslot(*var_depth);
  params[0] = num10213;
  partcv[0] = 1;
  Object sum10215 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10215 (depth = 4)
  gc_frame_newslot(sum10215);
// starting to compile block node (depth = 4)
  Object block10216 = alloc_Block(NULL, NULL, "ast", 2677);
  gc_frame_newslot(block10216);
// method "_apply"
  block_savedest(block10216);
  Object closure10217 = createclosure(2, "_apply");
  setclosureframe(closure10217, stackframe);
  addtoclosure(closure10217, var_spc);
  addtoclosure(closure10217, selfslot);
  struct UserObject *uo10217 = (struct UserObject*)block10216;
  uo10217->data[0] = (Object)closure10217;
  Method *meth_meth_ast__apply10217 = addmethod2pos(block10216, "_apply", &meth_ast__apply10217, 0);
  int argcv_meth_ast__apply10217[] = {0};
  meth_meth_ast__apply10217->type = alloc_MethodType(1, argcv_meth_ast__apply10217);
  meth_meth_ast__apply10217->definitionModule = modulename;
  meth_meth_ast__apply10217->definitionLine = 2969;
// compiled block node returning block10216 (depth = 4)
  gc_frame_newslot(block10216);
// call case 5: prelude request
  params[0] = sum10215;
  params[1] = block10216;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10224 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10211);
// compiled call node returning call10224 (depth = 3)
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10226 == NULL) {
    strlit10226 = alloc_String("");
    gc_root(strlit10226);
  }
// compiled string node returning strlit10226 (depth = 5)
  int op_slot_right_10225 = gc_frame_newslot(strlit10226);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10229 = gc_frame_new();
// call case 4: self request
  Object call10230 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10229);
// compiled member node returning call10230 (depth = 6)
  int op_slot_right_10228 = gc_frame_newslot(call10230);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10233 == NULL) {
    strlit10233 = alloc_String(": ");
    gc_root(strlit10233);
  }
// compiled string node returning strlit10233 (depth = 7)
  int op_slot_right_10232 = gc_frame_newslot(strlit10233);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10236 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10237 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10236);
// compiled call node returning call10237 (depth = 8)
  int op_slot_right_10235 = gc_frame_newslot(call10237);
// starting to compile string node (depth = 8)
  if (strlit10239 == NULL) {
    strlit10239 = alloc_String("");
    gc_root(strlit10239);
  }
// compiled string node returning strlit10239 (depth = 8)
  int op_slot_left_10235 = gc_frame_newslot(strlit10239);
  params[0] = call10237;
  partcv[0] = 1;
  Object opresult10240 = callmethod(strlit10239, "++(1)", 1, partcv, params);
// compiled op node returning opresult10240 (depth = 7)
  int op_slot_left_10232 = gc_frame_newslot(opresult10240);
  params[0] = strlit10233;
  partcv[0] = 1;
  Object opresult10241 = callmethod(opresult10240, "++(1)", 1, partcv, params);
// compiled op node returning opresult10241 (depth = 6)
  int op_slot_left_10228 = gc_frame_newslot(opresult10241);
  params[0] = call10230;
  partcv[0] = 1;
  Object opresult10242 = callmethod(opresult10241, "++(1)", 1, partcv, params);
// compiled op node returning opresult10242 (depth = 5)
  int op_slot_left_10225 = gc_frame_newslot(opresult10242);
  params[0] = strlit10226;
  partcv[0] = 1;
  Object opresult10243 = callmethod(opresult10242, "++(1)", 1, partcv, params);
// compiled op node returning opresult10243 (depth = 4)
  *var_s = opresult10243;
  if (opresult10243 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10245 == NULL) {
    strlit10245 = alloc_String("Args:");
    gc_root(strlit10245);
  }
// compiled string node returning strlit10245 (depth = 5)
  int op_slot_right_10244 = gc_frame_newslot(strlit10245);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_10247 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10250 == NULL) {
    strlit10250 = alloc_String("""\x0a""    ");
    gc_root(strlit10250);
  }
// compiled string node returning strlit10250 (depth = 7)
  int op_slot_right_10249 = gc_frame_newslot(strlit10250);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_10252 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit10254 == NULL) {
    strlit10254 = alloc_String("");
    gc_root(strlit10254);
  }
// compiled string node returning strlit10254 (depth = 8)
  int op_slot_left_10252 = gc_frame_newslot(strlit10254);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10255 = callmethod(strlit10254, "++(1)", 1, partcv, params);
// compiled op node returning opresult10255 (depth = 7)
  int op_slot_left_10249 = gc_frame_newslot(opresult10255);
  params[0] = strlit10250;
  partcv[0] = 1;
  Object opresult10256 = callmethod(opresult10255, "++(1)", 1, partcv, params);
// compiled op node returning opresult10256 (depth = 6)
  int op_slot_left_10247 = gc_frame_newslot(opresult10256);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10257 = callmethod(opresult10256, "++(1)", 1, partcv, params);
// compiled op node returning opresult10257 (depth = 5)
  int op_slot_left_10244 = gc_frame_newslot(opresult10257);
  params[0] = strlit10245;
  partcv[0] = 1;
  Object opresult10258 = callmethod(opresult10257, "++(1)", 1, partcv, params);
// compiled op node returning opresult10258 (depth = 4)
  *var_s = opresult10258;
  if (opresult10258 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10260 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10261 = gc_frame_new();
// call case 4: self request
  Object call10262 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10261);
// compiled member node returning call10262 (depth = 4)
  gc_frame_newslot(call10262);
// starting to compile block node (depth = 4)
  Object block10263 = alloc_Block(NULL, NULL, "ast", 2682);
  gc_frame_newslot(block10263);
// method "_apply(_)"
  block_savedest(block10263);
  Object closure10264 = createclosure(4, "_apply(1)");
  setclosureframe(closure10264, stackframe);
  addtoclosure(closure10264, var_depth);
  addtoclosure(closure10264, var_spc);
  addtoclosure(closure10264, var_s);
  addtoclosure(closure10264, selfslot);
  struct UserObject *uo10264 = (struct UserObject*)block10263;
  uo10264->data[0] = (Object)closure10264;
  Method *meth_meth_ast__apply_40_1_41_10264 = addmethod2pos(block10263, "_apply(1)", &meth_ast__apply_40_1_41_10264, 0);
  int argcv_meth_ast__apply_40_1_41_10264[] = {1};
  meth_meth_ast__apply_40_1_41_10264->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10264);
  meth_meth_ast__apply_40_1_41_10264->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10264->definitionLine = 2969;
// compiled block node returning block10263 (depth = 4)
  gc_frame_newslot(block10263);
// call case 5: prelude request
  params[0] = call10262;
  params[1] = block10263;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10295 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10260);
// compiled call node returning call10295 (depth = 3)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_10315(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_tArg = &(stackframe->slots[0]);
  *var_tArg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10317 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10319 = alloc_Float64(1);
// compiled num node returning num10319 (depth = 10)
  int op_slot_right_10318 = gc_frame_newslot(num10319);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10318 = gc_frame_newslot(*var_depth);
  params[0] = num10319;
  partcv[0] = 1;
  Object sum10321 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10321 (depth = 9)
  gc_frame_newslot(sum10321);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tArg (depth = 9)
  params[0] = sum10321;
  partcv[0] = 1;
  Object call10322 = callmethodflags(*var_tArg, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10317);
// compiled call node returning call10322 (depth = 8)
  int op_slot_right_10316 = gc_frame_newslot(call10322);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10316 = gc_frame_newslot(*var_s);
  params[0] = call10322;
  partcv[0] = 1;
  Object opresult10324 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10324 (depth = 7)
  *var_s = opresult10324;
  if (opresult10324 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10328(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10330 == NULL) {
    strlit10330 = alloc_String(", ");
    gc_root(strlit10330);
  }
// compiled string node returning strlit10330 (depth = 8)
  int op_slot_right_10329 = gc_frame_newslot(strlit10330);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10329 = gc_frame_newslot(*var_s);
  params[0] = strlit10330;
  partcv[0] = 1;
  Object opresult10332 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10332 (depth = 7)
  *var_s = opresult10332;
  if (opresult10332 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_10380(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10382 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10383 = callmethodflags(*var_arg, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10382);
// compiled call node returning call10383 (depth = 8)
  int op_slot_right_10381 = gc_frame_newslot(call10383);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10381 = gc_frame_newslot(*var_s);
  params[0] = call10383;
  partcv[0] = 1;
  Object opresult10385 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10385 (depth = 7)
  *var_s = opresult10385;
  if (opresult10385 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10389(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10391 == NULL) {
    strlit10391 = alloc_String(", ");
    gc_root(strlit10391);
  }
// compiled string node returning strlit10391 (depth = 8)
  int op_slot_right_10390 = gc_frame_newslot(strlit10391);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10390 = gc_frame_newslot(*var_s);
  params[0] = strlit10391;
  partcv[0] = 1;
  Object opresult10393 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10393 (depth = 7)
  *var_s = opresult10393;
  if (opresult10393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_10296(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_needsParens = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "needsParens");
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10297 = gc_frame_new();
// call case 4: self request
  Object call10298 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10297);
// compiled member node returning call10298 (depth = 4)
  *var_s = call10298;
  if (call10298 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10301 = alloc_Float64(0);
// compiled num node returning num10301 (depth = 5)
  int op_slot_right_10300 = gc_frame_newslot(num10301);
// starting to compile member node (depth = 5)
  int callframe10303 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10304 = gc_frame_new();
// call case 4: self request
  Object call10305 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10304);
// compiled member node returning call10305 (depth = 6)
  Object call10306 = callmethodflags(call10305, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10303);
// compiled member node returning call10306 (depth = 5)
  int op_slot_left_10300 = gc_frame_newslot(call10306);
  params[0] = num10301;
  partcv[0] = 1;
  Object opresult10307 = callmethod(call10306, ">(1)", 1, partcv, params);
// compiled op node returning opresult10307 (depth = 4)
  Object if10299 = done;
  if (istrue(opresult10307)) {
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10309 == NULL) {
    strlit10309 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit10309);
  }
// compiled string node returning strlit10309 (depth = 6)
  int op_slot_right_10308 = gc_frame_newslot(strlit10309);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10308 = gc_frame_newslot(*var_s);
  params[0] = strlit10309;
  partcv[0] = 1;
  Object opresult10311 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10311 (depth = 5)
  *var_s = opresult10311;
  if (opresult10311 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10313 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10314 = alloc_Block(NULL, NULL, "ast", 2691);
  gc_frame_newslot(block10314);
// method "_apply(_)"
  block_savedest(block10314);
  Object closure10315 = createclosure(3, "_apply(1)");
  setclosureframe(closure10315, stackframe);
  addtoclosure(closure10315, var_depth);
  addtoclosure(closure10315, var_s);
  addtoclosure(closure10315, selfslot);
  struct UserObject *uo10315 = (struct UserObject*)block10314;
  uo10315->data[0] = (Object)closure10315;
  Method *meth_meth_ast__apply_40_1_41_10315 = addmethod2pos(block10314, "_apply(1)", &meth_ast__apply_40_1_41_10315, 0);
  int argcv_meth_ast__apply_40_1_41_10315[] = {1};
  meth_meth_ast__apply_40_1_41_10315->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10315);
  meth_meth_ast__apply_40_1_41_10315->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10315->definitionLine = 2969;
// compiled block node returning block10314 (depth = 5)
  gc_frame_newslot(block10314);
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block10327 = alloc_Block(NULL, NULL, "ast", 2693);
  gc_frame_newslot(block10327);
// method "_apply"
  block_savedest(block10327);
  Object closure10328 = createclosure(2, "_apply");
  setclosureframe(closure10328, stackframe);
  addtoclosure(closure10328, var_s);
  addtoclosure(closure10328, selfslot);
  struct UserObject *uo10328 = (struct UserObject*)block10327;
  uo10328->data[0] = (Object)closure10328;
  Method *meth_meth_ast__apply10328 = addmethod2pos(block10327, "_apply", &meth_ast__apply10328, 0);
  int argcv_meth_ast__apply10328[] = {0};
  meth_meth_ast__apply10328->type = alloc_MethodType(1, argcv_meth_ast__apply10328);
  meth_meth_ast__apply10328->definitionModule = modulename;
  meth_meth_ast__apply10328->definitionLine = 2969;
// compiled block node returning block10327 (depth = 5)
  gc_frame_newslot(block10327);
// call case 6: other requests
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10335 = gc_frame_new();
// call case 4: self request
  Object call10336 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10335);
// compiled member node returning call10336 (depth = 5)
  params[0] = block10314;
  params[1] = block10327;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10337 = callmethodflags(call10336, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10313);
// compiled call node returning call10337 (depth = 4)
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10339 == NULL) {
    strlit10339 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit10339);
  }
// compiled string node returning strlit10339 (depth = 6)
  int op_slot_right_10338 = gc_frame_newslot(strlit10339);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10338 = gc_frame_newslot(*var_s);
  params[0] = strlit10339;
  partcv[0] = 1;
  Object opresult10341 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10341 (depth = 5)
  *var_s = opresult10341;
  if (opresult10341 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10299 = done;
  } else {
  }
// compiled if node returning if10299 (depth = 3)
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10345 = alloc_Float64(0);
// compiled num node returning num10345 (depth = 5)
  int op_slot_right_10344 = gc_frame_newslot(num10345);
// starting to compile member node (depth = 5)
  int callframe10347 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10348 = gc_frame_new();
// call case 4: self request
  Object call10349 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10348);
// compiled member node returning call10349 (depth = 6)
  Object call10350 = callmethodflags(call10349, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10347);
// compiled member node returning call10350 (depth = 5)
  int op_slot_left_10344 = gc_frame_newslot(call10350);
  params[0] = num10345;
  partcv[0] = 1;
  Object opresult10351 = callmethod(call10350, ">(1)", 1, partcv, params);
// compiled op node returning opresult10351 (depth = 4)
  Object if10343 = done;
  if (istrue(opresult10351)) {
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10353 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10354 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10355 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe10356 = gc_frame_new();
// call case 4: self request
  Object call10357 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10356);
// compiled member node returning call10357 (depth = 9)
  Object call10358 = callmethodflags(call10357, "first", 0, partcv, params, 0);
  gc_frame_end(callframe10355);
// compiled member node returning call10358 (depth = 8)
  Object call10359 = callmethodflags(call10358, "isDelimited", 0, partcv, params, 0);
  gc_frame_end(callframe10354);
// compiled member node returning call10359 (depth = 7)
  Object call10360 = callmethodflags(call10359, "not", 0, partcv, params, 0);
  gc_frame_end(callframe10353);
// compiled member node returning call10360 (depth = 6)
  int op_slot_right_10352 = gc_frame_newslot(call10360);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10363 = alloc_Float64(1);
// compiled num node returning num10363 (depth = 7)
  int op_slot_right_10362 = gc_frame_newslot(num10363);
// starting to compile member node (depth = 7)
  int callframe10365 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10366 = gc_frame_new();
// call case 4: self request
  Object call10367 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10366);
// compiled member node returning call10367 (depth = 8)
  Object call10368 = callmethodflags(call10367, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10365);
// compiled member node returning call10368 (depth = 7)
  int op_slot_left_10362 = gc_frame_newslot(call10368);
  params[0] = num10363;
  partcv[0] = 1;
  Object opresult10369 = callmethod(call10368, ">(1)", 1, partcv, params);
// compiled op node returning opresult10369 (depth = 6)
  int op_slot_left_10352 = gc_frame_newslot(opresult10369);
  params[0] = call10360;
  partcv[0] = 1;
  Object opresult10370 = callmethod(opresult10369, "||(1)", 1, partcv, params);
// compiled op node returning opresult10370 (depth = 5)
  *var_needsParens = opresult10370;
  if (opresult10370 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_needsParens (depth = 7)
  Object if10372 = done;
struct StackFrameObject *iftmpstackframe10372 = stackframe;
  if (istrue(*var_needsParens)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10372);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 7)
  if (strlit10373 == NULL) {
    strlit10373 = alloc_String("(");
    gc_root(strlit10373);
  }
// compiled string node returning strlit10373 (depth = 7)
    gc_frame_newslot(strlit10373);
    if10372 = strlit10373;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10372);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 7)
  if (strlit10374 == NULL) {
    strlit10374 = alloc_String(" ");
    gc_root(strlit10374);
  }
// compiled string node returning strlit10374 (depth = 7)
    gc_frame_newslot(strlit10374);
    if10372 = strlit10374;
  }
stackframe = iftmpstackframe10372;
// compiled if node returning if10372 (depth = 6)
  int op_slot_right_10371 = gc_frame_newslot(if10372);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10371 = gc_frame_newslot(*var_s);
  params[0] = if10372;
  partcv[0] = 1;
  Object opresult10376 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10376 (depth = 5)
  *var_s = opresult10376;
  if (opresult10376 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10378 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10379 = alloc_Block(NULL, NULL, "ast", 2699);
  gc_frame_newslot(block10379);
// method "_apply(_)"
  block_savedest(block10379);
  Object closure10380 = createclosure(3, "_apply(1)");
  setclosureframe(closure10380, stackframe);
  addtoclosure(closure10380, var_depth);
  addtoclosure(closure10380, var_s);
  addtoclosure(closure10380, selfslot);
  struct UserObject *uo10380 = (struct UserObject*)block10379;
  uo10380->data[0] = (Object)closure10380;
  Method *meth_meth_ast__apply_40_1_41_10380 = addmethod2pos(block10379, "_apply(1)", &meth_ast__apply_40_1_41_10380, 0);
  int argcv_meth_ast__apply_40_1_41_10380[] = {1};
  meth_meth_ast__apply_40_1_41_10380->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10380);
  meth_meth_ast__apply_40_1_41_10380->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10380->definitionLine = 2969;
// compiled block node returning block10379 (depth = 5)
  gc_frame_newslot(block10379);
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block10388 = alloc_Block(NULL, NULL, "ast", 2701);
  gc_frame_newslot(block10388);
// method "_apply"
  block_savedest(block10388);
  Object closure10389 = createclosure(2, "_apply");
  setclosureframe(closure10389, stackframe);
  addtoclosure(closure10389, var_s);
  addtoclosure(closure10389, selfslot);
  struct UserObject *uo10389 = (struct UserObject*)block10388;
  uo10389->data[0] = (Object)closure10389;
  Method *meth_meth_ast__apply10389 = addmethod2pos(block10388, "_apply", &meth_ast__apply10389, 0);
  int argcv_meth_ast__apply10389[] = {0};
  meth_meth_ast__apply10389->type = alloc_MethodType(1, argcv_meth_ast__apply10389);
  meth_meth_ast__apply10389->definitionModule = modulename;
  meth_meth_ast__apply10389->definitionLine = 2969;
// compiled block node returning block10388 (depth = 5)
  gc_frame_newslot(block10388);
// call case 6: other requests
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10396 = gc_frame_new();
// call case 4: self request
  Object call10397 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10396);
// compiled member node returning call10397 (depth = 5)
  params[0] = block10379;
  params[1] = block10388;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10398 = callmethodflags(call10397, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10378);
// compiled call node returning call10398 (depth = 4)
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_needsParens (depth = 5)
  Object if10399 = done;
  if (istrue(*var_needsParens)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10401 == NULL) {
    strlit10401 = alloc_String(")");
    gc_root(strlit10401);
  }
// compiled string node returning strlit10401 (depth = 7)
  int op_slot_right_10400 = gc_frame_newslot(strlit10401);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_10400 = gc_frame_newslot(*var_s);
  params[0] = strlit10401;
  partcv[0] = 1;
  Object opresult10403 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10403 (depth = 6)
  *var_s = opresult10403;
  if (opresult10403 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10399 = done;
  } else {
  }
// compiled if node returning if10399 (depth = 4)
    gc_frame_newslot(if10399);
    if10343 = if10399;
  } else {
  }
// compiled if node returning if10343 (depth = 3)
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy10405(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10406 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe10407 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10408 = gc_frame_new();
// call case 4: self request
  Object call10409 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10408);
// compiled member node returning call10409 (depth = 5)
  gc_frame_newslot(call10409);
// starting to compile member node (depth = 5)
  int callframe10410 = gc_frame_new();
// call case 4: self request
  Object call10411 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10410);
// compiled member node returning call10411 (depth = 5)
  gc_frame_newslot(call10411);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_requestPart (depth = 5)
  params[0] = call10409;
  params[1] = call10411;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10412 = callmethodflags(*var_requestPart, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10407);
// compiled call node returning call10412 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10413 = callmethodflags(call10412, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10406);
// compiled call node returning call10413 (depth = 3)
  gc_frame_end(frame);
  return call10413;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_10414(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2713
  setline(2713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10415 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10416 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10415);
// compiled call node returning call10416 (depth = 3)
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10417 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10418 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10419 = callmethodflags(*var_other, "lineLength", 0, partcv, params, 0);
  gc_frame_end(callframe10418);
// compiled member node returning call10419 (depth = 4)
  gc_frame_newslot(call10419);
// call case 4: self request
  params[0] = call10419;
  partcv[0] = 1;
  Object call10420 = callmethodflags(self, "lineLength:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10417);
// compiled call node returning call10420 (depth = 3)
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName10421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10422 == NULL) {
    strlit10422 = alloc_String("request");
    gc_root(strlit10422);
  }
// compiled string node returning strlit10422 (depth = 3)
  gc_frame_end(frame);
  return strlit10422;
}
Object meth_ast_request_40_1_41_withArgs_40_1_41_10109(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request(1)withArgs(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10110 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10110 = alloc_userobj2(17,14, objclass10110);
  gc_frame_newslot(obj10110);
if (objclass10110 == NULL) {
  glfree(obj10110->class->name);
  obj10110->class->name = "requestPart.request(_)withArgs(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10110, self, 0);
  addmethodreal(obj10110,"outer", &reader_ast_outer_10111);
  Object oldself10110 = self;
  struct StackFrameObject *oldstackframe10110 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10110);
  gc_frame_newslot((Object)stackframe);
  self = obj10110;
  Object *oldselfslot10110 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10110 = (*(struct UserObject *)self).data[0], lowerouter10110 = thisouter10110;
  if (inheritingObject10110) {
    struct UserObject *inho10110 = (struct UserObject *)inheritingObject10110;
    while (inho10110->super != GraceDefaultObject) inho10110 = (struct UserObject *)inho10110->super;
    inho10110->super = obj10110;
    self = inheritingObject10110;
    *selfslot = self;
    lowerouter10110 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10110;
  }
if (objclass10110 == NULL) {
  Method *reader10112 = addmethodrealflags(obj10110, "kind",&reader_ast_kind_10112, MFLAG_DEF);
  reader10112->definitionModule = modulename;
  reader10112->definitionLine = 2650;
}
adddatum2(obj10110, alloc_Undefined(), 1);
if (objclass10110 == NULL) {
  Method *reader10113 = addmethodrealflags(obj10110, "name", &reader_ast_name_10113, 0);
  Method *writer10113 = addmethodrealflags(obj10110, "name:=(1)", &writer_ast_name_10113, 0);
  reader10113->definitionModule = modulename;
  writer10113->definitionModule = modulename;
  reader10113->definitionLine = 2651;
  writer10113->definitionLine = 2651;
}
obj10110->flags |= OFLAG_MUTABLE;
adddatum2(obj10110, alloc_Undefined(), 2);
if (objclass10110 == NULL) {
  Method *reader10114 = addmethodrealflags(obj10110, "args", &reader_ast_args_10114, 0);
  Method *writer10114 = addmethodrealflags(obj10110, "args:=(1)", &writer_ast_args_10114, 0);
  reader10114->definitionModule = modulename;
  writer10114->definitionModule = modulename;
  reader10114->definitionLine = 2652;
  writer10114->definitionLine = 2652;
}
obj10110->flags |= OFLAG_MUTABLE;
adddatum2(obj10110, alloc_Undefined(), 3);
if (objclass10110 == NULL) {
  Method *reader10115 = addmethodrealflags(obj10110, "typeArgs", &reader_ast_typeArgs_10115, MFLAG_CONFIDENTIAL);
  Method *writer10115 = addmethodrealflags(obj10110, "typeArgs:=(1)", &writer_ast_typeArgs_10115, MFLAG_CONFIDENTIAL);
  reader10115->definitionModule = modulename;
  writer10115->definitionModule = modulename;
  reader10115->definitionLine = 2653;
  writer10115->definitionLine = 2653;
}
obj10110->flags |= OFLAG_MUTABLE;
adddatum2(obj10110, alloc_Undefined(), 4);
if (objclass10110 == NULL) {
  Method *reader10116 = addmethodrealflags(obj10110, "lineLength", &reader_ast_lineLength_10116, 0);
  Method *writer10116 = addmethodrealflags(obj10110, "lineLength:=(1)", &writer_ast_lineLength_10116, 0);
  reader10116->definitionModule = modulename;
  writer10116->definitionModule = modulename;
  reader10116->definitionLine = 2654;
  writer10116->definitionLine = 2654;
}
obj10110->flags |= OFLAG_MUTABLE;
adddatum2(obj10110, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo10117 = (struct UserObject*)obj10110;
  uo10117->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString10117 = addmethod2pos(obj10110, "nameString", &meth_ast_nameString10117, 6);
  int argcv_meth_ast_nameString10117[] = {0};
  meth_meth_ast_nameString10117->type = alloc_MethodType(1, argcv_meth_ast_nameString10117);
  meth_meth_ast_nameString10117->definitionModule = modulename;
  meth_meth_ast_nameString10117->definitionLine = 2656;
// method "canonicalName"
  struct UserObject *uo10146 = (struct UserObject*)obj10110;
  uo10146->data[7] = emptyclosure;
  Method *meth_meth_ast_canonicalName10146 = addmethod2pos(obj10110, "canonicalName", &meth_ast_canonicalName10146, 7);
  int argcv_meth_ast_canonicalName10146[] = {0};
  meth_meth_ast_canonicalName10146->type = alloc_MethodType(1, argcv_meth_ast_canonicalName10146);
  meth_meth_ast_canonicalName10146->definitionModule = modulename;
  meth_meth_ast_canonicalName10146->definitionLine = 2661;
// method "map(_)ancestors(_)"
  struct UserObject *uo10192 = (struct UserObject*)obj10110;
  uo10192->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_10192 = addmethod2pos(obj10110, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_10192, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10192[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10192->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10192);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10192->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10192->definitionLine = 2669;
// method "pretty(_)"
  struct UserObject *uo10209 = (struct UserObject*)obj10110;
  uo10209->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_10209 = addmethod2pos(obj10110, "pretty(1)", &meth_ast_pretty_40_1_41_10209, 9);
  int argcv_meth_ast_pretty_40_1_41_10209[] = {1};
  meth_meth_ast_pretty_40_1_41_10209->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_10209);
  meth_meth_ast_pretty_40_1_41_10209->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_10209->definitionLine = 2675;
// method "toGrace(_)"
  struct UserObject *uo10296 = (struct UserObject*)obj10110;
  uo10296->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_10296 = addmethod2pos(obj10110, "toGrace(1)", &meth_ast_toGrace_40_1_41_10296, 10);
  int argcv_meth_ast_toGrace_40_1_41_10296[] = {1};
  meth_meth_ast_toGrace_40_1_41_10296->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10296);
  meth_meth_ast_toGrace_40_1_41_10296->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10296->definitionLine = 2687;
// method "shallowCopy"
  block_savedest(obj10110);
  Object closure10405 = createclosure(1, "shallowCopy");
  setclosureframe(closure10405, stackframe);
  addtoclosure(closure10405, var_requestPart);
  struct UserObject *uo10405 = (struct UserObject*)obj10110;
  uo10405->data[11] = (Object)closure10405;
  Method *meth_meth_ast_shallowCopy10405 = addmethod2pos(obj10110, "shallowCopy", &meth_ast_shallowCopy10405, 11);
  int argcv_meth_ast_shallowCopy10405[] = {0};
  meth_meth_ast_shallowCopy10405->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10405);
  meth_meth_ast_shallowCopy10405->definitionModule = modulename;
  meth_meth_ast_shallowCopy10405->definitionLine = 2709;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10414 = (struct UserObject*)obj10110;
  uo10414->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10414 = addmethod2pos(obj10110, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10414, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10414[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10414->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10414);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10414->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10414->definitionLine = 2712;
// method "statementName"
  struct UserObject *uo10421 = (struct UserObject*)obj10110;
  uo10421->data[13] = emptyclosure;
  Method *meth_meth_ast_statementName10421 = addmethod2pos(obj10110, "statementName", &meth_ast_statementName10421, 13);
  int argcv_meth_ast_statementName10421[] = {0};
  meth_meth_ast_statementName10421->type = alloc_MethodType(1, argcv_meth_ast_statementName10421);
  meth_meth_ast_statementName10421->definitionModule = modulename;
  meth_meth_ast_statementName10421->definitionLine = 2717;
  sourceObject = obj10110;
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10423 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10424 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10425 = gc_frame_new();
// call case 3: self.outer request
  Object call10426 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10425);
// compiled member node returning call10426 (depth = 5)
  Object call10427 = callmethodflags(call10426, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10424);
// compiled member node returning call10427 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10428 = callmethodflags(call10427, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10423);
// compiled call node returning call10428 (depth = 3)
  struct UserObject *obj10110_uo = (struct UserObject *)obj10110;
  obj10110_uo->super = call10428;
  sourceObject = obj10110;
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10429 == NULL) {
    strlit10429 = alloc_String("callwithpart");
    gc_root(strlit10429);
  }
// compiled string node returning strlit10429 (depth = 3)
  adddatum2(obj10110, strlit10429, 1);
  sourceObject = obj10110;
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj10110, *var_rPart, 2);
  sourceObject = obj10110;
// Begin line 2652
  setline(2652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj10110, *var_xs, 3);
  sourceObject = obj10110;
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  adddatum2(obj10110, *var_emptySeq, 4);
  sourceObject = obj10110;
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10430 = alloc_Float64(0);
// compiled num node returning num10430 (depth = 3)
  adddatum2(obj10110, num10430, 5);
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  objclass10110 = obj10110->class;
  objclass10110->definitionModule = modulename;
  objclass10110->definitionLine = 2648;
  (*(struct UserObject *)self).data[0] = lowerouter10110;
  self = oldself10110;
  selfslot = oldselfslot10110;
  stackframe = oldstackframe10110;
  gc_frame_end(frame);
  return obj10110;
}
Object meth_ast_request_40_1_41_withArgs_40_1_41_10109_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request(1)withArgs(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method request(_)withArgs(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method request(_)withArgs(_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10110 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10110 = alloc_userobj2(17,14, objclass10110);
  gc_frame_newslot(obj10110);
if (objclass10110 == NULL) {
  glfree(obj10110->class->name);
  obj10110->class->name = "requestPart.request(_)withArgs(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10110, self, 0);
  addmethodreal(obj10110,"outer", &reader_ast_outer_10111);
  Object oldself10110 = self;
  struct StackFrameObject *oldstackframe10110 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10110);
  gc_frame_newslot((Object)stackframe);
  self = obj10110;
  Object *oldselfslot10110 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10110 = (*(struct UserObject *)self).data[0], lowerouter10110 = thisouter10110;
  if (inheritingObject10110) {
    struct UserObject *inho10110 = (struct UserObject *)inheritingObject10110;
    while (inho10110->super != GraceDefaultObject) inho10110 = (struct UserObject *)inho10110->super;
    inho10110->super = obj10110;
    self = inheritingObject10110;
    *selfslot = self;
    lowerouter10110 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10110;
  }
if (objclass10110 == NULL) {
  Method *reader10112 = addmethodrealflags(obj10110, "kind",&reader_ast_kind_10112, MFLAG_DEF);
  reader10112->definitionModule = modulename;
  reader10112->definitionLine = 2650;
}
adddatum2(obj10110, alloc_Undefined(), 1);
if (objclass10110 == NULL) {
  Method *reader10113 = addmethodrealflags(obj10110, "name", &reader_ast_name_10113, 0);
  Method *writer10113 = addmethodrealflags(obj10110, "name:=(1)", &writer_ast_name_10113, 0);
  reader10113->definitionModule = modulename;
  writer10113->definitionModule = modulename;
  reader10113->definitionLine = 2651;
  writer10113->definitionLine = 2651;
}
obj10110->flags |= OFLAG_MUTABLE;
adddatum2(obj10110, alloc_Undefined(), 2);
if (objclass10110 == NULL) {
  Method *reader10114 = addmethodrealflags(obj10110, "args", &reader_ast_args_10114, 0);
  Method *writer10114 = addmethodrealflags(obj10110, "args:=(1)", &writer_ast_args_10114, 0);
  reader10114->definitionModule = modulename;
  writer10114->definitionModule = modulename;
  reader10114->definitionLine = 2652;
  writer10114->definitionLine = 2652;
}
obj10110->flags |= OFLAG_MUTABLE;
adddatum2(obj10110, alloc_Undefined(), 3);
if (objclass10110 == NULL) {
  Method *reader10115 = addmethodrealflags(obj10110, "typeArgs", &reader_ast_typeArgs_10115, MFLAG_CONFIDENTIAL);
  Method *writer10115 = addmethodrealflags(obj10110, "typeArgs:=(1)", &writer_ast_typeArgs_10115, MFLAG_CONFIDENTIAL);
  reader10115->definitionModule = modulename;
  writer10115->definitionModule = modulename;
  reader10115->definitionLine = 2653;
  writer10115->definitionLine = 2653;
}
obj10110->flags |= OFLAG_MUTABLE;
adddatum2(obj10110, alloc_Undefined(), 4);
if (objclass10110 == NULL) {
  Method *reader10116 = addmethodrealflags(obj10110, "lineLength", &reader_ast_lineLength_10116, 0);
  Method *writer10116 = addmethodrealflags(obj10110, "lineLength:=(1)", &writer_ast_lineLength_10116, 0);
  reader10116->definitionModule = modulename;
  writer10116->definitionModule = modulename;
  reader10116->definitionLine = 2654;
  writer10116->definitionLine = 2654;
}
obj10110->flags |= OFLAG_MUTABLE;
adddatum2(obj10110, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo10117 = (struct UserObject*)obj10110;
  uo10117->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString10117 = addmethod2pos(obj10110, "nameString", &meth_ast_nameString10117, 6);
  int argcv_meth_ast_nameString10117[] = {0};
  meth_meth_ast_nameString10117->type = alloc_MethodType(1, argcv_meth_ast_nameString10117);
  meth_meth_ast_nameString10117->definitionModule = modulename;
  meth_meth_ast_nameString10117->definitionLine = 2656;
// method "canonicalName"
  struct UserObject *uo10146 = (struct UserObject*)obj10110;
  uo10146->data[7] = emptyclosure;
  Method *meth_meth_ast_canonicalName10146 = addmethod2pos(obj10110, "canonicalName", &meth_ast_canonicalName10146, 7);
  int argcv_meth_ast_canonicalName10146[] = {0};
  meth_meth_ast_canonicalName10146->type = alloc_MethodType(1, argcv_meth_ast_canonicalName10146);
  meth_meth_ast_canonicalName10146->definitionModule = modulename;
  meth_meth_ast_canonicalName10146->definitionLine = 2661;
// method "map(_)ancestors(_)"
  struct UserObject *uo10192 = (struct UserObject*)obj10110;
  uo10192->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_10192 = addmethod2pos(obj10110, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_10192, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10192[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10192->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10192);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10192->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10192->definitionLine = 2669;
// method "pretty(_)"
  struct UserObject *uo10209 = (struct UserObject*)obj10110;
  uo10209->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_10209 = addmethod2pos(obj10110, "pretty(1)", &meth_ast_pretty_40_1_41_10209, 9);
  int argcv_meth_ast_pretty_40_1_41_10209[] = {1};
  meth_meth_ast_pretty_40_1_41_10209->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_10209);
  meth_meth_ast_pretty_40_1_41_10209->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_10209->definitionLine = 2675;
// method "toGrace(_)"
  struct UserObject *uo10296 = (struct UserObject*)obj10110;
  uo10296->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_10296 = addmethod2pos(obj10110, "toGrace(1)", &meth_ast_toGrace_40_1_41_10296, 10);
  int argcv_meth_ast_toGrace_40_1_41_10296[] = {1};
  meth_meth_ast_toGrace_40_1_41_10296->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10296);
  meth_meth_ast_toGrace_40_1_41_10296->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10296->definitionLine = 2687;
// method "shallowCopy"
  block_savedest(obj10110);
  Object closure10405 = createclosure(1, "shallowCopy");
  setclosureframe(closure10405, stackframe);
  addtoclosure(closure10405, var_requestPart);
  struct UserObject *uo10405 = (struct UserObject*)obj10110;
  uo10405->data[11] = (Object)closure10405;
  Method *meth_meth_ast_shallowCopy10405 = addmethod2pos(obj10110, "shallowCopy", &meth_ast_shallowCopy10405, 11);
  int argcv_meth_ast_shallowCopy10405[] = {0};
  meth_meth_ast_shallowCopy10405->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10405);
  meth_meth_ast_shallowCopy10405->definitionModule = modulename;
  meth_meth_ast_shallowCopy10405->definitionLine = 2709;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10414 = (struct UserObject*)obj10110;
  uo10414->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10414 = addmethod2pos(obj10110, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10414, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10414[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10414->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10414);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10414->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10414->definitionLine = 2712;
// method "statementName"
  struct UserObject *uo10421 = (struct UserObject*)obj10110;
  uo10421->data[13] = emptyclosure;
  Method *meth_meth_ast_statementName10421 = addmethod2pos(obj10110, "statementName", &meth_ast_statementName10421, 13);
  int argcv_meth_ast_statementName10421[] = {0};
  meth_meth_ast_statementName10421->type = alloc_MethodType(1, argcv_meth_ast_statementName10421);
  meth_meth_ast_statementName10421->definitionModule = modulename;
  meth_meth_ast_statementName10421->definitionLine = 2717;
  sourceObject = obj10110;
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10423 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10424 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10425 = gc_frame_new();
// call case 3: self.outer request
  Object call10426 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10425);
// compiled member node returning call10426 (depth = 5)
  Object call10427 = callmethodflags(call10426, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10424);
// compiled member node returning call10427 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10428 = callmethodflags(call10427, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10423);
// compiled call node returning call10428 (depth = 3)
  struct UserObject *obj10110_uo = (struct UserObject *)obj10110;
  obj10110_uo->super = call10428;
  sourceObject = obj10110;
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10429 == NULL) {
    strlit10429 = alloc_String("callwithpart");
    gc_root(strlit10429);
  }
// compiled string node returning strlit10429 (depth = 3)
  adddatum2(obj10110, strlit10429, 1);
  sourceObject = obj10110;
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj10110, *var_rPart, 2);
  sourceObject = obj10110;
// Begin line 2652
  setline(2652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj10110, *var_xs, 3);
  sourceObject = obj10110;
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  adddatum2(obj10110, *var_emptySeq, 4);
  sourceObject = obj10110;
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10430 = alloc_Float64(0);
// compiled num node returning num10430 (depth = 3)
  adddatum2(obj10110, num10430, 5);
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  sourceObject = obj10110;
  objclass10110 = obj10110->class;
  objclass10110->definitionModule = modulename;
  objclass10110->definitionLine = 2648;
  (*(struct UserObject *)self).data[0] = lowerouter10110;
  self = oldself10110;
  selfslot = oldselfslot10110;
  stackframe = oldstackframe10110;
  gc_frame_end(frame);
  return obj10110;
}
Object meth_ast_requestPart10432(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "requestPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_requestPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_requestPart (depth = 3)
  gc_frame_end(frame);
  return *var_requestPart;
}
Object meth_ast_isComment10443(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10444 = alloc_Boolean(1);
// compiled identifier node returning bool10444 (depth = 3)
  gc_frame_end(frame);
  return bool10444;
}
Object meth_ast_isLegalInTrait10445(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10446 = alloc_Boolean(1);
// compiled identifier node returning bool10446 (depth = 3)
  gc_frame_end(frame);
  return bool10446;
}
Object meth_ast_isExecutable10447(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10448 = alloc_Boolean(0);
// compiled identifier node returning bool10448 (depth = 3)
  gc_frame_end(frame);
  return bool10448;
}
Object meth_ast_asString10449(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10451 == NULL) {
    strlit10451 = alloc_String("");
    gc_root(strlit10451);
  }
// compiled string node returning strlit10451 (depth = 4)
  int op_slot_right_10450 = gc_frame_newslot(strlit10451);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10454 = gc_frame_new();
// call case 4: self request
  Object call10455 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10454);
// compiled member node returning call10455 (depth = 5)
  int op_slot_right_10453 = gc_frame_newslot(call10455);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10458 == NULL) {
    strlit10458 = alloc_String("): ");
    gc_root(strlit10458);
  }
// compiled string node returning strlit10458 (depth = 6)
  int op_slot_right_10457 = gc_frame_newslot(strlit10458);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10461 = gc_frame_new();
// call case 4: self request
  Object call10462 = callmethodflags(self, "endLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10461);
// compiled member node returning call10462 (depth = 7)
  int op_slot_right_10460 = gc_frame_newslot(call10462);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10465 == NULL) {
    strlit10465 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit10465);
  }
// compiled string node returning strlit10465 (depth = 8)
  int op_slot_right_10464 = gc_frame_newslot(strlit10465);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe10468 = gc_frame_new();
// call case 4: self request
  Object call10469 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10468);
// compiled member node returning call10469 (depth = 9)
  int op_slot_right_10467 = gc_frame_newslot(call10469);
// starting to compile string node (depth = 9)
  if (strlit10471 == NULL) {
    strlit10471 = alloc_String("comment (");
    gc_root(strlit10471);
  }
// compiled string node returning strlit10471 (depth = 9)
  int op_slot_left_10467 = gc_frame_newslot(strlit10471);
  params[0] = call10469;
  partcv[0] = 1;
  Object opresult10472 = callmethod(strlit10471, "++(1)", 1, partcv, params);
// compiled op node returning opresult10472 (depth = 8)
  int op_slot_left_10464 = gc_frame_newslot(opresult10472);
  params[0] = strlit10465;
  partcv[0] = 1;
  Object opresult10473 = callmethod(opresult10472, "++(1)", 1, partcv, params);
// compiled op node returning opresult10473 (depth = 7)
  int op_slot_left_10460 = gc_frame_newslot(opresult10473);
  params[0] = call10462;
  partcv[0] = 1;
  Object opresult10474 = callmethod(opresult10473, "++(1)", 1, partcv, params);
// compiled op node returning opresult10474 (depth = 6)
  int op_slot_left_10457 = gc_frame_newslot(opresult10474);
  params[0] = strlit10458;
  partcv[0] = 1;
  Object opresult10475 = callmethod(opresult10474, "++(1)", 1, partcv, params);
// compiled op node returning opresult10475 (depth = 5)
  int op_slot_left_10453 = gc_frame_newslot(opresult10475);
  params[0] = call10455;
  partcv[0] = 1;
  Object opresult10476 = callmethod(opresult10475, "++(1)", 1, partcv, params);
// compiled op node returning opresult10476 (depth = 4)
  int op_slot_left_10450 = gc_frame_newslot(opresult10476);
  params[0] = strlit10451;
  partcv[0] = 1;
  Object opresult10477 = callmethod(opresult10476, "++(1)", 1, partcv, params);
// compiled op node returning opresult10477 (depth = 3)
  gc_frame_end(frame);
  return opresult10477;
}
Object meth_ast_extendCommentUsing_40_1_41_10478(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extendCommentUsing(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extendCommentUsing(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extendCommentUsing(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extendCommentUsing(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10479 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10481 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cmtNode (depth = 6)
  Object call10482 = callmethodflags(*var_cmtNode, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10481);
// compiled member node returning call10482 (depth = 5)
  int op_slot_right_10480 = gc_frame_newslot(call10482);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10485 == NULL) {
    strlit10485 = alloc_String(" ");
    gc_root(strlit10485);
  }
// compiled string node returning strlit10485 (depth = 6)
  int op_slot_right_10484 = gc_frame_newslot(strlit10485);
// starting to compile member node (depth = 6)
  int callframe10487 = gc_frame_new();
// call case 4: self request
  Object call10488 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10487);
// compiled member node returning call10488 (depth = 6)
  int op_slot_left_10484 = gc_frame_newslot(call10488);
  params[0] = strlit10485;
  partcv[0] = 1;
  Object opresult10489 = callmethod(call10488, "++(1)", 1, partcv, params);
// compiled op node returning opresult10489 (depth = 5)
  int op_slot_left_10480 = gc_frame_newslot(opresult10489);
  params[0] = call10482;
  partcv[0] = 1;
  Object opresult10490 = callmethod(opresult10489, "++(1)", 1, partcv, params);
// compiled op node returning opresult10490 (depth = 4)
  gc_frame_newslot(opresult10490);
// call case 4: self request
  params[0] = opresult10490;
  partcv[0] = 1;
  Object call10491 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10479);
// compiled call node returning call10491 (depth = 3)
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10492 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10493 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cmtNode (depth = 5)
  Object call10494 = callmethodflags(*var_cmtNode, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe10493);
// compiled member node returning call10494 (depth = 4)
  gc_frame_newslot(call10494);
// call case 4: self request
  params[0] = call10494;
  partcv[0] = 1;
  Object call10495 = callmethodflags(self, "endLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10492);
// compiled call node returning call10495 (depth = 3)
  gc_frame_end(frame);
  return call10495;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_10496(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10497 = gc_frame_new();
// call case 4: self request
  Object call10498 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10497);
// compiled member node returning call10498 (depth = 4)
  *var_n = call10498;
  if (call10498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10499 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10500 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10499);
// compiled call node returning call10500 (depth = 4)
  *var_newChain = call10500;
  if (call10500 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10501 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10502 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10501);
// compiled call node returning call10502 (depth = 3)
  gc_frame_end(frame);
  return call10502;
}
Object meth_ast_accept_40_1_41_from_40_1_41_10503(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10504 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10505 = callmethodflags(*var_visitor, "visitComment(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10504);
// compiled call node returning call10505 (depth = 3)
  gc_frame_end(frame);
  return call10505;
}
Object meth_ast__apply10514(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10516 == NULL) {
    strlit10516 = alloc_String("  ");
    gc_root(strlit10516);
  }
// compiled string node returning strlit10516 (depth = 7)
  int op_slot_right_10515 = gc_frame_newslot(strlit10516);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_10515 = gc_frame_newslot(*var_s);
  params[0] = strlit10516;
  partcv[0] = 1;
  Object opresult10518 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10518 (depth = 6)
  *var_s = opresult10518;
  if (opresult10518 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_10506(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_pb = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pb");
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10507 == NULL) {
    strlit10507 = alloc_String("""\x0a""");
    gc_root(strlit10507);
  }
// compiled string node returning strlit10507 (depth = 4)
  *var_s = strlit10507;
  if (strlit10507 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10508 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10510 = alloc_Float64(1);
// compiled num node returning num10510 (depth = 5)
  int op_slot_right_10509 = gc_frame_newslot(num10510);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_10509 = gc_frame_newslot(*var_depth);
  params[0] = num10510;
  partcv[0] = 1;
  Object diff10512 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff10512 (depth = 4)
  gc_frame_newslot(diff10512);
// starting to compile block node (depth = 4)
  Object block10513 = alloc_Block(NULL, NULL, "ast", 2747);
  gc_frame_newslot(block10513);
// method "_apply"
  block_savedest(block10513);
  Object closure10514 = createclosure(2, "_apply");
  setclosureframe(closure10514, stackframe);
  addtoclosure(closure10514, var_s);
  addtoclosure(closure10514, selfslot);
  struct UserObject *uo10514 = (struct UserObject*)block10513;
  uo10514->data[0] = (Object)closure10514;
  Method *meth_meth_ast__apply10514 = addmethod2pos(block10513, "_apply", &meth_ast__apply10514, 0);
  int argcv_meth_ast__apply10514[] = {0};
  meth_meth_ast__apply10514->type = alloc_MethodType(1, argcv_meth_ast__apply10514);
  meth_meth_ast__apply10514->definitionModule = modulename;
  meth_meth_ast__apply10514->definitionLine = 2969;
// compiled block node returning block10513 (depth = 4)
  gc_frame_newslot(block10513);
// call case 5: prelude request
  params[0] = diff10512;
  params[1] = block10513;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10521 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10508);
// compiled call node returning call10521 (depth = 3)
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10523 = gc_frame_new();
// call case 4: self request
  Object call10524 = callmethodflags(self, "isPreceededByBlankLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10523);
// compiled member node returning call10524 (depth = 5)
  Object if10522 = done;
struct StackFrameObject *iftmpstackframe10522 = stackframe;
  if (istrue(call10524)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10522);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit10525 == NULL) {
    strlit10525 = alloc_String(" > blank");
    gc_root(strlit10525);
  }
// compiled string node returning strlit10525 (depth = 5)
    gc_frame_newslot(strlit10525);
    if10522 = strlit10525;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10522);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit10526 == NULL) {
    strlit10526 = alloc_String("");
    gc_root(strlit10526);
  }
// compiled string node returning strlit10526 (depth = 5)
    gc_frame_newslot(strlit10526);
    if10522 = strlit10526;
  }
stackframe = iftmpstackframe10522;
// compiled if node returning if10522 (depth = 4)
  *var_pb = if10522;
  if (if10522 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10528 == NULL) {
    strlit10528 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit10528);
  }
// compiled string node returning strlit10528 (depth = 4)
  int op_slot_right_10527 = gc_frame_newslot(strlit10528);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10531 = gc_frame_new();
// call case 4: self request
  Object call10532 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10531);
// compiled member node returning call10532 (depth = 5)
  int op_slot_right_10530 = gc_frame_newslot(call10532);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10535 == NULL) {
    strlit10535 = alloc_String("): ""\xe2""""\x80""""\xb9""");
    gc_root(strlit10535);
  }
// compiled string node returning strlit10535 (depth = 6)
  int op_slot_right_10534 = gc_frame_newslot(strlit10535);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10538 = gc_frame_new();
// call case 4: self request
  Object call10539 = callmethodflags(self, "endLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10538);
// compiled member node returning call10539 (depth = 7)
  int op_slot_right_10537 = gc_frame_newslot(call10539);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10542 == NULL) {
    strlit10542 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit10542);
  }
// compiled string node returning strlit10542 (depth = 8)
  int op_slot_right_10541 = gc_frame_newslot(strlit10542);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe10545 = gc_frame_new();
// call case 4: self request
  Object call10546 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10545);
// compiled member node returning call10546 (depth = 9)
  int op_slot_right_10544 = gc_frame_newslot(call10546);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10549 == NULL) {
    strlit10549 = alloc_String("(");
    gc_root(strlit10549);
  }
// compiled string node returning strlit10549 (depth = 10)
  int op_slot_right_10548 = gc_frame_newslot(strlit10549);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pb (depth = 11)
  int op_slot_right_10551 = gc_frame_newslot(*var_pb);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit10554 == NULL) {
    strlit10554 = alloc_String("Comment");
    gc_root(strlit10554);
  }
// compiled string node returning strlit10554 (depth = 12)
  int op_slot_right_10553 = gc_frame_newslot(strlit10554);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_10556 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit10558 == NULL) {
    strlit10558 = alloc_String("");
    gc_root(strlit10558);
  }
// compiled string node returning strlit10558 (depth = 13)
  int op_slot_left_10556 = gc_frame_newslot(strlit10558);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10559 = callmethod(strlit10558, "++(1)", 1, partcv, params);
// compiled op node returning opresult10559 (depth = 12)
  int op_slot_left_10553 = gc_frame_newslot(opresult10559);
  params[0] = strlit10554;
  partcv[0] = 1;
  Object opresult10560 = callmethod(opresult10559, "++(1)", 1, partcv, params);
// compiled op node returning opresult10560 (depth = 11)
  int op_slot_left_10551 = gc_frame_newslot(opresult10560);
  params[0] = *var_pb;
  partcv[0] = 1;
  Object opresult10561 = callmethod(opresult10560, "++(1)", 1, partcv, params);
// compiled op node returning opresult10561 (depth = 10)
  int op_slot_left_10548 = gc_frame_newslot(opresult10561);
  params[0] = strlit10549;
  partcv[0] = 1;
  Object opresult10562 = callmethod(opresult10561, "++(1)", 1, partcv, params);
// compiled op node returning opresult10562 (depth = 9)
  int op_slot_left_10544 = gc_frame_newslot(opresult10562);
  params[0] = call10546;
  partcv[0] = 1;
  Object opresult10563 = callmethod(opresult10562, "++(1)", 1, partcv, params);
// compiled op node returning opresult10563 (depth = 8)
  int op_slot_left_10541 = gc_frame_newslot(opresult10563);
  params[0] = strlit10542;
  partcv[0] = 1;
  Object opresult10564 = callmethod(opresult10563, "++(1)", 1, partcv, params);
// compiled op node returning opresult10564 (depth = 7)
  int op_slot_left_10537 = gc_frame_newslot(opresult10564);
  params[0] = call10539;
  partcv[0] = 1;
  Object opresult10565 = callmethod(opresult10564, "++(1)", 1, partcv, params);
// compiled op node returning opresult10565 (depth = 6)
  int op_slot_left_10534 = gc_frame_newslot(opresult10565);
  params[0] = strlit10535;
  partcv[0] = 1;
  Object opresult10566 = callmethod(opresult10565, "++(1)", 1, partcv, params);
// compiled op node returning opresult10566 (depth = 5)
  int op_slot_left_10530 = gc_frame_newslot(opresult10566);
  params[0] = call10532;
  partcv[0] = 1;
  Object opresult10567 = callmethod(opresult10566, "++(1)", 1, partcv, params);
// compiled op node returning opresult10567 (depth = 4)
  int op_slot_left_10527 = gc_frame_newslot(opresult10567);
  params[0] = strlit10528;
  partcv[0] = 1;
  Object opresult10568 = callmethod(opresult10567, "++(1)", 1, partcv, params);
// compiled op node returning opresult10568 (depth = 3)
  gc_frame_end(frame);
  return opresult10568;
}
Object meth_ast__apply10586(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10588 == NULL) {
    strlit10588 = alloc_String("    ");
    gc_root(strlit10588);
  }
// compiled string node returning strlit10588 (depth = 8)
  int op_slot_right_10587 = gc_frame_newslot(strlit10588);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_10587 = gc_frame_newslot(*var_spc);
  params[0] = strlit10588;
  partcv[0] = 1;
  Object opresult10590 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult10590 (depth = 7)
  *var_spc = opresult10590;
  if (opresult10590 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_10569(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[3];
  int partcv[3];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10571 = gc_frame_new();
// call case 4: self request
  Object call10572 = callmethodflags(self, "isPartialLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10571);
// compiled member node returning call10572 (depth = 4)
  Object if10570 = done;
  if (istrue(call10572)) {
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10574 == NULL) {
    strlit10574 = alloc_String("");
    gc_root(strlit10574);
  }
// compiled string node returning strlit10574 (depth = 5)
  int op_slot_right_10573 = gc_frame_newslot(strlit10574);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10577 = gc_frame_new();
// call case 4: self request
  Object call10578 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10577);
// compiled member node returning call10578 (depth = 6)
  int op_slot_right_10576 = gc_frame_newslot(call10578);
// starting to compile string node (depth = 6)
  if (strlit10580 == NULL) {
    strlit10580 = alloc_String("// (partial) ");
    gc_root(strlit10580);
  }
// compiled string node returning strlit10580 (depth = 6)
  int op_slot_left_10576 = gc_frame_newslot(strlit10580);
  params[0] = call10578;
  partcv[0] = 1;
  Object opresult10581 = callmethod(strlit10580, "++(1)", 1, partcv, params);
// compiled op node returning opresult10581 (depth = 5)
  int op_slot_left_10573 = gc_frame_newslot(opresult10581);
  params[0] = strlit10574;
  partcv[0] = 1;
  Object opresult10582 = callmethod(opresult10581, "++(1)", 1, partcv, params);
// compiled op node returning opresult10582 (depth = 4)
    gc_frame_newslot(opresult10582);
    if10570 = opresult10582;
  } else {
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10583 == NULL) {
    strlit10583 = alloc_String("");
    gc_root(strlit10583);
  }
// compiled string node returning strlit10583 (depth = 5)
  *var_spc = strlit10583;
  if (strlit10583 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10584 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 5)
  Object block10585 = alloc_Block(NULL, NULL, "ast", 2760);
  gc_frame_newslot(block10585);
// method "_apply"
  block_savedest(block10585);
  Object closure10586 = createclosure(2, "_apply");
  setclosureframe(closure10586, stackframe);
  addtoclosure(closure10586, var_spc);
  addtoclosure(closure10586, selfslot);
  struct UserObject *uo10586 = (struct UserObject*)block10585;
  uo10586->data[0] = (Object)closure10586;
  Method *meth_meth_ast__apply10586 = addmethod2pos(block10585, "_apply", &meth_ast__apply10586, 0);
  int argcv_meth_ast__apply10586[] = {0};
  meth_meth_ast__apply10586->type = alloc_MethodType(1, argcv_meth_ast__apply10586);
  meth_meth_ast__apply10586->definitionModule = modulename;
  meth_meth_ast__apply10586->definitionLine = 2969;
// compiled block node returning block10585 (depth = 5)
  gc_frame_newslot(block10585);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block10585;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10593 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10584);
// compiled call node returning call10593 (depth = 4)
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10594 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10595 = gc_frame_new();
// call case 4: self request
  Object call10596 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10595);
// compiled member node returning call10596 (depth = 5)
  gc_frame_newslot(call10596);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineLength (depth = 5)
  gc_frame_newslot(*var_lineLength);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10598 == NULL) {
    strlit10598 = alloc_String("// ");
    gc_root(strlit10598);
  }
// compiled string node returning strlit10598 (depth = 6)
  int op_slot_right_10597 = gc_frame_newslot(strlit10598);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_10597 = gc_frame_newslot(*var_spc);
  params[0] = strlit10598;
  partcv[0] = 1;
  Object opresult10600 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult10600 (depth = 5)
  gc_frame_newslot(opresult10600);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10601 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10602 = gc_frame_new();
// call case 3: self.outer request
  Object call10603 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10602);
// compiled member node returning call10603 (depth = 6)
  Object call10604 = callmethodflags(call10603, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10601);
// compiled member node returning call10604 (depth = 5)
  params[0] = call10596;
  params[1] = *var_lineLength;
  params[2] = opresult10600;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10605 = callmethodflags(call10604, "wrap(1)to(1)prefix(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10594);
// compiled call node returning call10605 (depth = 4)
    gc_frame_newslot(call10605);
    if10570 = call10605;
  }
// compiled if node returning if10570 (depth = 3)
  gc_frame_end(frame);
  return if10570;
}
Object meth_ast_shallowCopy10606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_commentNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10607 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe10608 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_commentNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call10609 = callmethodflags(*var_commentNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10608);
// compiled call node returning call10609 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10610 = callmethodflags(call10609, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10607);
// compiled call node returning call10610 (depth = 3)
  gc_frame_end(frame);
  return call10610;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_10611(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10612 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10613 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10612);
// compiled call node returning call10613 (depth = 3)
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10614 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10615 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10616 = callmethodflags(*var_other, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10615);
// compiled member node returning call10616 (depth = 4)
  gc_frame_newslot(call10616);
// call case 4: self request
  params[0] = call10616;
  partcv[0] = 1;
  Object call10617 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10614);
// compiled call node returning call10617 (depth = 3)
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10618 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10619 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10620 = callmethodflags(*var_other, "isPartialLine", 0, partcv, params, 0);
  gc_frame_end(callframe10619);
// compiled member node returning call10620 (depth = 4)
  gc_frame_newslot(call10620);
// call case 4: self request
  params[0] = call10620;
  partcv[0] = 1;
  Object call10621 = callmethodflags(self, "isPartialLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10618);
// compiled call node returning call10621 (depth = 3)
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10622 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10623 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10624 = callmethodflags(*var_other, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe10623);
// compiled member node returning call10624 (depth = 4)
  gc_frame_newslot(call10624);
// call case 4: self request
  params[0] = call10624;
  partcv[0] = 1;
  Object call10625 = callmethodflags(self, "endLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10622);
// compiled call node returning call10625 (depth = 3)
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_1_41_10435(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10436 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10436 = alloc_userobj2(20,17, objclass10436);
  gc_frame_newslot(obj10436);
if (objclass10436 == NULL) {
  glfree(obj10436->class->name);
  obj10436->class->name = "commentNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10436, self, 0);
  addmethodreal(obj10436,"outer", &reader_ast_outer_10437);
  Object oldself10436 = self;
  struct StackFrameObject *oldstackframe10436 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10436);
  gc_frame_newslot((Object)stackframe);
  self = obj10436;
  Object *oldselfslot10436 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10436 = (*(struct UserObject *)self).data[0], lowerouter10436 = thisouter10436;
  if (inheritingObject10436) {
    struct UserObject *inho10436 = (struct UserObject *)inheritingObject10436;
    while (inho10436->super != GraceDefaultObject) inho10436 = (struct UserObject *)inho10436->super;
    inho10436->super = obj10436;
    self = inheritingObject10436;
    *selfslot = self;
    lowerouter10436 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10436;
  }
if (objclass10436 == NULL) {
  Method *reader10438 = addmethodrealflags(obj10436, "kind",&reader_ast_kind_10438, MFLAG_DEF);
  reader10438->definitionModule = modulename;
  reader10438->definitionLine = 2724;
}
adddatum2(obj10436, alloc_Undefined(), 1);
if (objclass10436 == NULL) {
  Method *reader10439 = addmethodrealflags(obj10436, "value", &reader_ast_value_10439, 0);
  Method *writer10439 = addmethodrealflags(obj10436, "value:=(1)", &writer_ast_value_10439, 0);
  reader10439->definitionModule = modulename;
  writer10439->definitionModule = modulename;
  reader10439->definitionLine = 2725;
  writer10439->definitionLine = 2725;
}
obj10436->flags |= OFLAG_MUTABLE;
adddatum2(obj10436, alloc_Undefined(), 2);
if (objclass10436 == NULL) {
  Method *reader10440 = addmethodrealflags(obj10436, "isPartialLine", &reader_ast_isPartialLine_10440, 0);
  Method *writer10440 = addmethodrealflags(obj10436, "isPartialLine:=(1)", &writer_ast_isPartialLine_10440, 0);
  reader10440->definitionModule = modulename;
  writer10440->definitionModule = modulename;
  reader10440->definitionLine = 2726;
  writer10440->definitionLine = 2726;
}
obj10436->flags |= OFLAG_MUTABLE;
adddatum2(obj10436, alloc_Undefined(), 3);
if (objclass10436 == NULL) {
  Method *reader10441 = addmethodrealflags(obj10436, "isPreceededByBlankLine", &reader_ast_isPreceededByBlankLine_10441, 0);
  Method *writer10441 = addmethodrealflags(obj10436, "isPreceededByBlankLine:=(1)", &writer_ast_isPreceededByBlankLine_10441, 0);
  reader10441->definitionModule = modulename;
  writer10441->definitionModule = modulename;
  reader10441->definitionLine = 2727;
  writer10441->definitionLine = 2727;
}
obj10436->flags |= OFLAG_MUTABLE;
adddatum2(obj10436, alloc_Undefined(), 4);
if (objclass10436 == NULL) {
  Method *reader10442 = addmethodrealflags(obj10436, "endLine", &reader_ast_endLine_10442, 0);
  Method *writer10442 = addmethodrealflags(obj10436, "endLine:=(1)", &writer_ast_endLine_10442, 0);
  reader10442->definitionModule = modulename;
  writer10442->definitionModule = modulename;
  reader10442->definitionLine = 2728;
  writer10442->definitionLine = 2728;
}
obj10436->flags |= OFLAG_MUTABLE;
adddatum2(obj10436, alloc_Undefined(), 5);
// method "isComment"
  struct UserObject *uo10443 = (struct UserObject*)obj10436;
  uo10443->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment10443 = addmethod2pos(obj10436, "isComment", &meth_ast_isComment10443, 6);
  int argcv_meth_ast_isComment10443[] = {0};
  meth_meth_ast_isComment10443->type = alloc_MethodType(1, argcv_meth_ast_isComment10443);
  meth_meth_ast_isComment10443->definitionModule = modulename;
  meth_meth_ast_isComment10443->definitionLine = 2729;
// method "isLegalInTrait"
  struct UserObject *uo10445 = (struct UserObject*)obj10436;
  uo10445->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait10445 = addmethod2pos(obj10436, "isLegalInTrait", &meth_ast_isLegalInTrait10445, 7);
  int argcv_meth_ast_isLegalInTrait10445[] = {0};
  meth_meth_ast_isLegalInTrait10445->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait10445);
  meth_meth_ast_isLegalInTrait10445->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait10445->definitionLine = 2730;
// method "isExecutable"
  struct UserObject *uo10447 = (struct UserObject*)obj10436;
  uo10447->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable10447 = addmethod2pos(obj10436, "isExecutable", &meth_ast_isExecutable10447, 8);
  int argcv_meth_ast_isExecutable10447[] = {0};
  meth_meth_ast_isExecutable10447->type = alloc_MethodType(1, argcv_meth_ast_isExecutable10447);
  meth_meth_ast_isExecutable10447->definitionModule = modulename;
  meth_meth_ast_isExecutable10447->definitionLine = 2731;
// method "asString"
  struct UserObject *uo10449 = (struct UserObject*)obj10436;
  uo10449->data[9] = emptyclosure;
  Method *meth_meth_ast_asString10449 = addmethod2pos(obj10436, "asString", &meth_ast_asString10449, 9);
  int argcv_meth_ast_asString10449[] = {0};
  meth_meth_ast_asString10449->type = alloc_MethodType(1, argcv_meth_ast_asString10449);
  meth_meth_ast_asString10449->definitionModule = modulename;
  meth_meth_ast_asString10449->definitionLine = 2732;
// method "extendCommentUsing(_)"
  struct UserObject *uo10478 = (struct UserObject*)obj10436;
  uo10478->data[10] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing_40_1_41_10478 = addmethod2pos(obj10436, "extendCommentUsing(1)", &meth_ast_extendCommentUsing_40_1_41_10478, 10);
  int argcv_meth_ast_extendCommentUsing_40_1_41_10478[] = {1};
  meth_meth_ast_extendCommentUsing_40_1_41_10478->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing_40_1_41_10478);
  meth_meth_ast_extendCommentUsing_40_1_41_10478->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing_40_1_41_10478->definitionLine = 2733;
// method "map(_)ancestors(_)"
  struct UserObject *uo10496 = (struct UserObject*)obj10436;
  uo10496->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_10496 = addmethod2pos(obj10436, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_10496, 11);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10496[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10496->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10496);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10496->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10496->definitionLine = 2737;
// method "accept(_)from(_)"
  struct UserObject *uo10503 = (struct UserObject*)obj10436;
  uo10503->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_10503 = addmethod2pos(obj10436, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_10503, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_10503[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_10503->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_10503);
  meth_meth_ast_accept_40_1_41_from_40_1_41_10503->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_10503->definitionLine = 2742;
// method "pretty(_)"
  struct UserObject *uo10506 = (struct UserObject*)obj10436;
  uo10506->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_10506 = addmethod2pos(obj10436, "pretty(1)", &meth_ast_pretty_40_1_41_10506, 13);
  int argcv_meth_ast_pretty_40_1_41_10506[] = {1};
  meth_meth_ast_pretty_40_1_41_10506->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_10506);
  meth_meth_ast_pretty_40_1_41_10506->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_10506->definitionLine = 2745;
// method "toGrace(_)"
  block_savedest(obj10436);
  Object closure10569 = createclosure(1, "toGrace(1)");
  setclosureframe(closure10569, stackframe);
  addtoclosure(closure10569, var_lineLength);
  struct UserObject *uo10569 = (struct UserObject*)obj10436;
  uo10569->data[14] = (Object)closure10569;
  Method *meth_meth_ast_toGrace_40_1_41_10569 = addmethod2pos(obj10436, "toGrace(1)", &meth_ast_toGrace_40_1_41_10569, 14);
  int argcv_meth_ast_toGrace_40_1_41_10569[] = {1};
  meth_meth_ast_toGrace_40_1_41_10569->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10569);
  meth_meth_ast_toGrace_40_1_41_10569->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10569->definitionLine = 2753;
// method "shallowCopy"
  block_savedest(obj10436);
  Object closure10606 = createclosure(2, "shallowCopy");
  setclosureframe(closure10606, stackframe);
  addtoclosure(closure10606, var_nullNode);
  addtoclosure(closure10606, var_commentNode);
  struct UserObject *uo10606 = (struct UserObject*)obj10436;
  uo10606->data[15] = (Object)closure10606;
  Method *meth_meth_ast_shallowCopy10606 = addmethod2pos(obj10436, "shallowCopy", &meth_ast_shallowCopy10606, 15);
  int argcv_meth_ast_shallowCopy10606[] = {0};
  meth_meth_ast_shallowCopy10606->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10606);
  meth_meth_ast_shallowCopy10606->definitionModule = modulename;
  meth_meth_ast_shallowCopy10606->definitionLine = 2764;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10611 = (struct UserObject*)obj10436;
  uo10611->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10611 = addmethod2pos(obj10436, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10611, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10611[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10611->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10611);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10611->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10611->definitionLine = 2767;
  sourceObject = obj10436;
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10626 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10627 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10628 = gc_frame_new();
// call case 3: self.outer request
  Object call10629 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10628);
// compiled member node returning call10629 (depth = 5)
  Object call10630 = callmethodflags(call10629, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10627);
// compiled member node returning call10630 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10631 = callmethodflags(call10630, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10626);
// compiled call node returning call10631 (depth = 3)
  struct UserObject *obj10436_uo = (struct UserObject *)obj10436;
  obj10436_uo->super = call10631;
  sourceObject = obj10436;
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10632 == NULL) {
    strlit10632 = alloc_String("comment");
    gc_root(strlit10632);
  }
// compiled string node returning strlit10632 (depth = 3)
  adddatum2(obj10436, strlit10632, 1);
  sourceObject = obj10436;
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj10436, *var_val_39_, 2);
  sourceObject = obj10436;
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10633 = alloc_Boolean(0);
// compiled identifier node returning bool10633 (depth = 3)
  adddatum2(obj10436, bool10633, 3);
  sourceObject = obj10436;
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10634 = alloc_Boolean(0);
// compiled identifier node returning bool10634 (depth = 3)
  adddatum2(obj10436, bool10634, 4);
  sourceObject = obj10436;
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10635 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  Object call10636 = callmethodflags(*var_util, "linenum", 0, partcv, params, 0);
  gc_frame_end(callframe10635);
// compiled member node returning call10636 (depth = 3)
  adddatum2(obj10436, call10636, 5);
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  objclass10436 = obj10436->class;
  objclass10436->definitionModule = modulename;
  objclass10436->definitionLine = 2722;
  (*(struct UserObject *)self).data[0] = lowerouter10436;
  self = oldself10436;
  selfslot = oldselfslot10436;
  stackframe = oldstackframe10436;
  gc_frame_end(frame);
  return obj10436;
}
Object meth_ast_new_40_1_41_10435_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10436 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10436 = alloc_userobj2(20,17, objclass10436);
  gc_frame_newslot(obj10436);
if (objclass10436 == NULL) {
  glfree(obj10436->class->name);
  obj10436->class->name = "commentNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10436, self, 0);
  addmethodreal(obj10436,"outer", &reader_ast_outer_10437);
  Object oldself10436 = self;
  struct StackFrameObject *oldstackframe10436 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10436);
  gc_frame_newslot((Object)stackframe);
  self = obj10436;
  Object *oldselfslot10436 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10436 = (*(struct UserObject *)self).data[0], lowerouter10436 = thisouter10436;
  if (inheritingObject10436) {
    struct UserObject *inho10436 = (struct UserObject *)inheritingObject10436;
    while (inho10436->super != GraceDefaultObject) inho10436 = (struct UserObject *)inho10436->super;
    inho10436->super = obj10436;
    self = inheritingObject10436;
    *selfslot = self;
    lowerouter10436 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10436;
  }
if (objclass10436 == NULL) {
  Method *reader10438 = addmethodrealflags(obj10436, "kind",&reader_ast_kind_10438, MFLAG_DEF);
  reader10438->definitionModule = modulename;
  reader10438->definitionLine = 2724;
}
adddatum2(obj10436, alloc_Undefined(), 1);
if (objclass10436 == NULL) {
  Method *reader10439 = addmethodrealflags(obj10436, "value", &reader_ast_value_10439, 0);
  Method *writer10439 = addmethodrealflags(obj10436, "value:=(1)", &writer_ast_value_10439, 0);
  reader10439->definitionModule = modulename;
  writer10439->definitionModule = modulename;
  reader10439->definitionLine = 2725;
  writer10439->definitionLine = 2725;
}
obj10436->flags |= OFLAG_MUTABLE;
adddatum2(obj10436, alloc_Undefined(), 2);
if (objclass10436 == NULL) {
  Method *reader10440 = addmethodrealflags(obj10436, "isPartialLine", &reader_ast_isPartialLine_10440, 0);
  Method *writer10440 = addmethodrealflags(obj10436, "isPartialLine:=(1)", &writer_ast_isPartialLine_10440, 0);
  reader10440->definitionModule = modulename;
  writer10440->definitionModule = modulename;
  reader10440->definitionLine = 2726;
  writer10440->definitionLine = 2726;
}
obj10436->flags |= OFLAG_MUTABLE;
adddatum2(obj10436, alloc_Undefined(), 3);
if (objclass10436 == NULL) {
  Method *reader10441 = addmethodrealflags(obj10436, "isPreceededByBlankLine", &reader_ast_isPreceededByBlankLine_10441, 0);
  Method *writer10441 = addmethodrealflags(obj10436, "isPreceededByBlankLine:=(1)", &writer_ast_isPreceededByBlankLine_10441, 0);
  reader10441->definitionModule = modulename;
  writer10441->definitionModule = modulename;
  reader10441->definitionLine = 2727;
  writer10441->definitionLine = 2727;
}
obj10436->flags |= OFLAG_MUTABLE;
adddatum2(obj10436, alloc_Undefined(), 4);
if (objclass10436 == NULL) {
  Method *reader10442 = addmethodrealflags(obj10436, "endLine", &reader_ast_endLine_10442, 0);
  Method *writer10442 = addmethodrealflags(obj10436, "endLine:=(1)", &writer_ast_endLine_10442, 0);
  reader10442->definitionModule = modulename;
  writer10442->definitionModule = modulename;
  reader10442->definitionLine = 2728;
  writer10442->definitionLine = 2728;
}
obj10436->flags |= OFLAG_MUTABLE;
adddatum2(obj10436, alloc_Undefined(), 5);
// method "isComment"
  struct UserObject *uo10443 = (struct UserObject*)obj10436;
  uo10443->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment10443 = addmethod2pos(obj10436, "isComment", &meth_ast_isComment10443, 6);
  int argcv_meth_ast_isComment10443[] = {0};
  meth_meth_ast_isComment10443->type = alloc_MethodType(1, argcv_meth_ast_isComment10443);
  meth_meth_ast_isComment10443->definitionModule = modulename;
  meth_meth_ast_isComment10443->definitionLine = 2729;
// method "isLegalInTrait"
  struct UserObject *uo10445 = (struct UserObject*)obj10436;
  uo10445->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait10445 = addmethod2pos(obj10436, "isLegalInTrait", &meth_ast_isLegalInTrait10445, 7);
  int argcv_meth_ast_isLegalInTrait10445[] = {0};
  meth_meth_ast_isLegalInTrait10445->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait10445);
  meth_meth_ast_isLegalInTrait10445->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait10445->definitionLine = 2730;
// method "isExecutable"
  struct UserObject *uo10447 = (struct UserObject*)obj10436;
  uo10447->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable10447 = addmethod2pos(obj10436, "isExecutable", &meth_ast_isExecutable10447, 8);
  int argcv_meth_ast_isExecutable10447[] = {0};
  meth_meth_ast_isExecutable10447->type = alloc_MethodType(1, argcv_meth_ast_isExecutable10447);
  meth_meth_ast_isExecutable10447->definitionModule = modulename;
  meth_meth_ast_isExecutable10447->definitionLine = 2731;
// method "asString"
  struct UserObject *uo10449 = (struct UserObject*)obj10436;
  uo10449->data[9] = emptyclosure;
  Method *meth_meth_ast_asString10449 = addmethod2pos(obj10436, "asString", &meth_ast_asString10449, 9);
  int argcv_meth_ast_asString10449[] = {0};
  meth_meth_ast_asString10449->type = alloc_MethodType(1, argcv_meth_ast_asString10449);
  meth_meth_ast_asString10449->definitionModule = modulename;
  meth_meth_ast_asString10449->definitionLine = 2732;
// method "extendCommentUsing(_)"
  struct UserObject *uo10478 = (struct UserObject*)obj10436;
  uo10478->data[10] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing_40_1_41_10478 = addmethod2pos(obj10436, "extendCommentUsing(1)", &meth_ast_extendCommentUsing_40_1_41_10478, 10);
  int argcv_meth_ast_extendCommentUsing_40_1_41_10478[] = {1};
  meth_meth_ast_extendCommentUsing_40_1_41_10478->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing_40_1_41_10478);
  meth_meth_ast_extendCommentUsing_40_1_41_10478->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing_40_1_41_10478->definitionLine = 2733;
// method "map(_)ancestors(_)"
  struct UserObject *uo10496 = (struct UserObject*)obj10436;
  uo10496->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_10496 = addmethod2pos(obj10436, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_10496, 11);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10496[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10496->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10496);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10496->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10496->definitionLine = 2737;
// method "accept(_)from(_)"
  struct UserObject *uo10503 = (struct UserObject*)obj10436;
  uo10503->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_10503 = addmethod2pos(obj10436, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_10503, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_10503[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_10503->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_10503);
  meth_meth_ast_accept_40_1_41_from_40_1_41_10503->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_10503->definitionLine = 2742;
// method "pretty(_)"
  struct UserObject *uo10506 = (struct UserObject*)obj10436;
  uo10506->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_10506 = addmethod2pos(obj10436, "pretty(1)", &meth_ast_pretty_40_1_41_10506, 13);
  int argcv_meth_ast_pretty_40_1_41_10506[] = {1};
  meth_meth_ast_pretty_40_1_41_10506->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_10506);
  meth_meth_ast_pretty_40_1_41_10506->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_10506->definitionLine = 2745;
// method "toGrace(_)"
  block_savedest(obj10436);
  Object closure10569 = createclosure(1, "toGrace(1)");
  setclosureframe(closure10569, stackframe);
  addtoclosure(closure10569, var_lineLength);
  struct UserObject *uo10569 = (struct UserObject*)obj10436;
  uo10569->data[14] = (Object)closure10569;
  Method *meth_meth_ast_toGrace_40_1_41_10569 = addmethod2pos(obj10436, "toGrace(1)", &meth_ast_toGrace_40_1_41_10569, 14);
  int argcv_meth_ast_toGrace_40_1_41_10569[] = {1};
  meth_meth_ast_toGrace_40_1_41_10569->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10569);
  meth_meth_ast_toGrace_40_1_41_10569->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10569->definitionLine = 2753;
// method "shallowCopy"
  block_savedest(obj10436);
  Object closure10606 = createclosure(2, "shallowCopy");
  setclosureframe(closure10606, stackframe);
  addtoclosure(closure10606, var_nullNode);
  addtoclosure(closure10606, var_commentNode);
  struct UserObject *uo10606 = (struct UserObject*)obj10436;
  uo10606->data[15] = (Object)closure10606;
  Method *meth_meth_ast_shallowCopy10606 = addmethod2pos(obj10436, "shallowCopy", &meth_ast_shallowCopy10606, 15);
  int argcv_meth_ast_shallowCopy10606[] = {0};
  meth_meth_ast_shallowCopy10606->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10606);
  meth_meth_ast_shallowCopy10606->definitionModule = modulename;
  meth_meth_ast_shallowCopy10606->definitionLine = 2764;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10611 = (struct UserObject*)obj10436;
  uo10611->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10611 = addmethod2pos(obj10436, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10611, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10611[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10611->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10611);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10611->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10611->definitionLine = 2767;
  sourceObject = obj10436;
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10626 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10627 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10628 = gc_frame_new();
// call case 3: self.outer request
  Object call10629 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10628);
// compiled member node returning call10629 (depth = 5)
  Object call10630 = callmethodflags(call10629, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10627);
// compiled member node returning call10630 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10631 = callmethodflags(call10630, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10626);
// compiled call node returning call10631 (depth = 3)
  struct UserObject *obj10436_uo = (struct UserObject *)obj10436;
  obj10436_uo->super = call10631;
  sourceObject = obj10436;
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10632 == NULL) {
    strlit10632 = alloc_String("comment");
    gc_root(strlit10632);
  }
// compiled string node returning strlit10632 (depth = 3)
  adddatum2(obj10436, strlit10632, 1);
  sourceObject = obj10436;
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj10436, *var_val_39_, 2);
  sourceObject = obj10436;
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10633 = alloc_Boolean(0);
// compiled identifier node returning bool10633 (depth = 3)
  adddatum2(obj10436, bool10633, 3);
  sourceObject = obj10436;
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10634 = alloc_Boolean(0);
// compiled identifier node returning bool10634 (depth = 3)
  adddatum2(obj10436, bool10634, 4);
  sourceObject = obj10436;
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10635 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  Object call10636 = callmethodflags(*var_util, "linenum", 0, partcv, params, 0);
  gc_frame_end(callframe10635);
// compiled member node returning call10636 (depth = 3)
  adddatum2(obj10436, call10636, 5);
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  sourceObject = obj10436;
  objclass10436 = obj10436->class;
  objclass10436->definitionModule = modulename;
  objclass10436->definitionLine = 2722;
  (*(struct UserObject *)self).data[0] = lowerouter10436;
  self = oldself10436;
  selfslot = oldselfslot10436;
  stackframe = oldstackframe10436;
  gc_frame_end(frame);
  return obj10436;
}
Object meth_ast_commentNode10638(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "commentNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_commentNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_commentNode (depth = 3)
  gc_frame_end(frame);
  return *var_commentNode;
}
Object meth_ast_ASTVisitor10641(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ASTVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ASTVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ASTVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_ASTVisitor;
}
Object meth_ast_visitCall_40_1_41_up_40_1_41_10644(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10645 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10646 = alloc_Boolean(1);
// compiled identifier node returning bool10646 (depth = 4)
  gc_frame_newslot(bool10646);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  params[0] = bool10646;
  partcv[0] = 1;
  Object call10647 = callmethodflags(*var_c, "isPattern:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10645);
// compiled call node returning call10647 (depth = 3)
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10648 = alloc_Boolean(1);
// compiled identifier node returning bool10648 (depth = 3)
  gc_frame_end(frame);
  return bool10648;
}
Object meth_ast_patternMarkVisitor10653(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_patternMarkVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(59, 59);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(59, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[2];
  int partcv[2];
  Object *var_util = alloc_var();
  Object *var_k = alloc_var();
  Object *var_lineLength = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineLength");
  Object *var_uninitialized = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "uninitialized");
  Object *var_ancestorChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ancestorChain");
  Object *var_emptySeq = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "emptySeq");
  Object *var_AstNode = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "AstNode");
  Object *var_SymbolTable = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "SymbolTable");
  Object *var_implicit = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "implicit");
  Object *var_nullNode = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "nullNode");
  Object *var_fakeSymbolTable = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "fakeSymbolTable");
  Object *var_ifNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "ifNode");
  Object *var_blockNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "blockNode");
  Object *var_tryCatchNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "tryCatchNode");
  Object *var_matchCaseNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "methodTypeNode");
  Object *var_typeLiteralNode = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "typeLiteralNode");
  Object *var_typeDecNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "typeDecNode");
  Object *var_methodNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "methodNode");
  Object *var_callNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "callNode");
  Object *var_moduleNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "moduleNode");
  Object *var_objectNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "memberNode");
  Object *var_genericNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "genericNode");
  Object *var_typeParametersNode = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "typeParametersNode");
  Object *var_identifierNode = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "identifierNode");
  Object *var_typeType = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "typeType");
  Object *var_unknownType = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "unknownType");
  Object *var_stringNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "stringNode");
  Object *var_numNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "numNode");
  Object *var_opNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "opNode");
  Object *var_bindNode = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "varDecNode");
  Object *var_importNode = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "importNode");
  Object *var_dialectNode = &(stackframe->slots[35]);
  setframeelementname(stackframe, 35, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[36]);
  setframeelementname(stackframe, 36, "returnNode");
  Object *var_inheritsNode = &(stackframe->slots[37]);
  setframeelementname(stackframe, 37, "inheritsNode");
  Object *var_AliasPair = &(stackframe->slots[38]);
  setframeelementname(stackframe, 38, "AliasPair");
  Object *var_blankNode = &(stackframe->slots[39]);
  setframeelementname(stackframe, 39, "blankNode");
  Object *var_signaturePart = &(stackframe->slots[40]);
  setframeelementname(stackframe, 40, "signaturePart");
  Object *var_requestPart = &(stackframe->slots[41]);
  setframeelementname(stackframe, 41, "requestPart");
  Object *var_commentNode = &(stackframe->slots[42]);
  setframeelementname(stackframe, 42, "commentNode");
  Object *var_ASTVisitor = &(stackframe->slots[43]);
  setframeelementname(stackframe, 43, "ASTVisitor");
  Object *var_patternMarkVisitor = &(stackframe->slots[44]);
  setframeelementname(stackframe, 44, "patternMarkVisitor");
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "listMap(_,_)ancestors(_)"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1 = addmethod2pos(self, "listMap(2)ancestors(1)", &meth_ast_listMap_40_2_41_ancestors_40_1_41_1, 1);
  int argcv_meth_ast_listMap_40_2_41_ancestors_40_1_41_1[] = {2, 1};
  meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1->type = alloc_MethodType(2, argcv_meth_ast_listMap_40_2_41_ancestors_40_1_41_1);
  meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1->definitionModule = modulename;
  meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1->definitionLine = 19;
// compiled method node returning  (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeMap(_,_)ancestors(_)"
  struct UserObject *uo12 = (struct UserObject*)self;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12 = addmethod2pos(self, "maybeMap(2)ancestors(1)", &meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12, 2);
  int argcv_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12[] = {2, 1};
  meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12->type = alloc_MethodType(2, argcv_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12);
  meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12->definitionModule = modulename;
  meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12->definitionLine = 24;
// compiled method node returning  (depth = 1)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeListMap(_,_)ancestors(_)"
  struct UserObject *uo20 = (struct UserObject*)self;
  uo20->data[3] = emptyclosure;
  Method *meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20 = addmethod2pos(self, "maybeListMap(2)ancestors(1)", &meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20, 3);
  int argcv_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20[] = {2, 1};
  meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20->type = alloc_MethodType(2, argcv_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20);
  meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20->definitionModule = modulename;
  meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20->definitionLine = 31;
// compiled method node returning  (depth = 1)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseNode"
  block_savedest(self);
  Object closure28 = createclosure(4, "baseNode");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_unknownType);
  addtoclosure(closure28, var_ancestorChain);
  addtoclosure(closure28, var_util);
  addtoclosure(closure28, var_fakeSymbolTable);
  struct UserObject *uo28 = (struct UserObject*)self;
  uo28->data[4] = (Object)closure28;
  Method *meth_meth_ast_baseNode28 = addmethod2pos(self, "baseNode", &meth_ast_baseNode28, 4);
  int argcv_meth_ast_baseNode28[] = {0};
  meth_meth_ast_baseNode28->type = alloc_MethodType(1, argcv_meth_ast_baseNode28);
  meth_meth_ast_baseNode28->definitionModule = modulename;
  meth_meth_ast_baseNode28->definitionLine = 87;
  block_savedest(self);
  Object closure430 = createclosure(4, "baseNode$object(1)");
  setclosureframe(closure430, stackframe);
  addtoclosure(closure430, var_unknownType);
  addtoclosure(closure430, var_ancestorChain);
  addtoclosure(closure430, var_util);
  addtoclosure(closure430, var_fakeSymbolTable);
  Method *meth_meth_ast_baseNode28_object = addmethod2pos(self, "baseNode$object(1)", &meth_ast_baseNode28_object, 4);
  meth_meth_ast_baseNode28_object->definitionModule = modulename;
  meth_meth_ast_baseNode28_object->definitionLine = 87;
// compiled method node returning  (depth = 1)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "aliasNew(_)old(_)"
  block_savedest(self);
  Object closure431 = createclosure(1, "aliasNew(1)old(1)");
  setclosureframe(closure431, stackframe);
  addtoclosure(closure431, var_AliasPair);
  struct UserObject *uo431 = (struct UserObject*)self;
  uo431->data[5] = (Object)closure431;
  Method *meth_meth_ast_aliasNew_40_1_41_old_40_1_41_431 = addmethod2pos(self, "aliasNew(1)old(1)", &meth_ast_aliasNew_40_1_41_old_40_1_41_431, 5);
  int argcv_meth_ast_aliasNew_40_1_41_old_40_1_41_431[] = {1, 1};
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_431->type = alloc_MethodType(2, argcv_meth_ast_aliasNew_40_1_41_old_40_1_41_431);
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_431->definitionModule = modulename;
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_431->definitionLine = 2503;
  block_savedest(self);
  Object closure543 = createclosure(1, "aliasNew(1)old(1)$object(1)");
  setclosureframe(closure543, stackframe);
  addtoclosure(closure543, var_AliasPair);
  Method *meth_meth_ast_aliasNew_40_1_41_old_40_1_41_431_object = addmethod2pos(self, "aliasNew(1)old(1)$object(1)", &meth_ast_aliasNew_40_1_41_old_40_1_41_431_object, 5);
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_431_object->definitionModule = modulename;
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_431_object->definitionLine = 2503;
// compiled method node returning  (depth = 1)
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "wrap(_)to(_)prefix(_)"
  struct UserObject *uo544 = (struct UserObject*)self;
  uo544->data[6] = emptyclosure;
  Method *meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544 = addmethod2pos(self, "wrap(1)to(1)prefix(1)", &meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544, 6);
  int argcv_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544[] = {1, 1, 1};
  meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544->type = alloc_MethodType(3, argcv_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544);
meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544->type->types[1] = type_Number;
meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544->type->names[1] = "l";
  meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544->definitionModule = modulename;
  meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_544->definitionLine = 2777;
// compiled method node returning  (depth = 1)
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseVisitor"
  struct UserObject *uo714 = (struct UserObject*)self;
  uo714->data[7] = emptyclosure;
  Method *meth_meth_ast_baseVisitor714 = addmethod2pos(self, "baseVisitor", &meth_ast_baseVisitor714, 7);
  int argcv_meth_ast_baseVisitor714[] = {0};
  meth_meth_ast_baseVisitor714->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor714);
  meth_meth_ast_baseVisitor714->definitionModule = modulename;
  meth_meth_ast_baseVisitor714->definitionLine = 2844;
  Method *meth_meth_ast_baseVisitor714_object = addmethod2pos(self, "baseVisitor$object(1)", &meth_ast_baseVisitor714_object, 7);
  int argcv_meth_ast_baseVisitor714_object[] = {0};
  meth_meth_ast_baseVisitor714_object->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor714_object);
  meth_meth_ast_baseVisitor714_object->definitionModule = modulename;
  meth_meth_ast_baseVisitor714_object->definitionLine = 2844;
// compiled method node returning  (depth = 1)
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pluggableVisitor(_)"
  struct UserObject *uo870 = (struct UserObject*)self;
  uo870->data[8] = emptyclosure;
  Method *meth_meth_ast_pluggableVisitor_40_1_41_870 = addmethod2pos(self, "pluggableVisitor(1)", &meth_ast_pluggableVisitor_40_1_41_870, 8);
  int argcv_meth_ast_pluggableVisitor_40_1_41_870[] = {1};
  meth_meth_ast_pluggableVisitor_40_1_41_870->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor_40_1_41_870);
  meth_meth_ast_pluggableVisitor_40_1_41_870->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor_40_1_41_870->definitionLine = 2910;
  Method *meth_meth_ast_pluggableVisitor_40_1_41_870_object = addmethod2pos(self, "pluggableVisitor(1)$object(1)", &meth_ast_pluggableVisitor_40_1_41_870_object, 8);
  int argcv_meth_ast_pluggableVisitor_40_1_41_870_object[] = {1};
  meth_meth_ast_pluggableVisitor_40_1_41_870_object->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor_40_1_41_870_object);
  meth_meth_ast_pluggableVisitor_40_1_41_870_object->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor_40_1_41_870_object->definitionLine = 2910;
// compiled method node returning  (depth = 1)
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findAnnotation(_,_)"
  struct UserObject *uo963 = (struct UserObject*)self;
  uo963->data[9] = emptyclosure;
  Method *meth_meth_ast_findAnnotation_40_2_41_963 = addmethod2pos(self, "findAnnotation(2)", &meth_ast_findAnnotation_40_2_41_963, 9);
  int argcv_meth_ast_findAnnotation_40_2_41_963[] = {2};
  meth_meth_ast_findAnnotation_40_2_41_963->type = alloc_MethodType(1, argcv_meth_ast_findAnnotation_40_2_41_963);
  meth_meth_ast_findAnnotation_40_2_41_963->definitionModule = modulename;
  meth_meth_ast_findAnnotation_40_2_41_963->definitionLine = 2959;
// compiled method node returning  (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of identifierKinds as k
  if (module_identifierKinds == NULL)
    module_identifierKinds = LOAD_MODULE(identifierKinds);
  *var_k = module_identifierKinds;
// compiled import node returning done (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num994 = alloc_Float64(80);
// compiled num node returning num994 (depth = 2)
  *var_lineLength = num994;
  if (num994 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lineLength"
  block_savedest(self);
  Object closure995 = createclosure(1, "lineLength");
  setclosureframe(closure995, stackframe);
  addtoclosure(closure995, var_lineLength);
  struct UserObject *uo995 = (struct UserObject*)self;
  uo995->data[10] = (Object)closure995;
  Method *meth_meth_ast_lineLength995 = addmethod2pos(self, "lineLength", &meth_ast_lineLength995, 10);
  int argcv_meth_ast_lineLength995[] = {0};
  meth_meth_ast_lineLength995->type = alloc_MethodType(1, argcv_meth_ast_lineLength995);
  meth_meth_ast_lineLength995->definitionModule = modulename;
  meth_meth_ast_lineLength995->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe996 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit997 == NULL) {
    strlit997 = alloc_String("uninitialized");
    gc_root(strlit997);
  }
// compiled string node returning strlit997 (depth = 3)
  gc_frame_newslot(strlit997);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe998 = gc_frame_new();
// call case 5: prelude request
  Object call999 = callmethodflags(prelude, "Singleton", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe998);
// compiled member node returning call999 (depth = 3)
  params[0] = strlit997;
  partcv[0] = 1;
  Object call1000 = callmethodflags(call999, "named(1)", 1, partcv, params, 0);
  gc_frame_end(callframe996);
// compiled call node returning call1000 (depth = 2)
  *var_uninitialized = call1000;
  if (call1000 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "uninitialized"
  block_savedest(self);
  Object closure1001 = createclosure(1, "uninitialized");
  setclosureframe(closure1001, stackframe);
  addtoclosure(closure1001, var_uninitialized);
  struct UserObject *uo1001 = (struct UserObject*)self;
  uo1001->data[11] = (Object)closure1001;
  Method *meth_meth_ast_uninitialized1001 = addmethod2pos(self, "uninitialized", &meth_ast_uninitialized1001, 11);
  int argcv_meth_ast_uninitialized1001[] = {0};
  meth_meth_ast_uninitialized1001->type = alloc_MethodType(1, argcv_meth_ast_uninitialized1001);
  meth_meth_ast_uninitialized1001->definitionModule = modulename;
  meth_meth_ast_uninitialized1001->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1002 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1002 = alloc_userobj2(5,6, objclass1002);
  gc_frame_newslot(obj1002);
if (objclass1002 == NULL) {
  glfree(obj1002->class->name);
  obj1002->class->name = "ancestorChain";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1002, self, 0);
  addmethodreal(obj1002,"outer", &reader_ast_outer_1003);
  Object oldself1002 = self;
  struct StackFrameObject *oldstackframe1002 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1002);
  gc_frame_newslot((Object)stackframe);
  self = obj1002;
  Object *oldselfslot1002 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1002 = (*(struct UserObject *)self).data[0], lowerouter1002 = thisouter1002;
  if (inheritingObject1002) {
    struct UserObject *inho1002 = (struct UserObject *)inheritingObject1002;
    while (inho1002->super != GraceDefaultObject) inho1002 = (struct UserObject *)inho1002->super;
    inho1002->super = obj1002;
    self = inheritingObject1002;
    *selfslot = self;
    lowerouter1002 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1002;
  }
// method "empty"
  struct UserObject *uo1004 = (struct UserObject*)obj1002;
  uo1004->data[1] = emptyclosure;
  Method *meth_meth_ast_empty1004 = addmethod2pos(obj1002, "empty", &meth_ast_empty1004, 1);
  int argcv_meth_ast_empty1004[] = {0};
  meth_meth_ast_empty1004->type = alloc_MethodType(1, argcv_meth_ast_empty1004);
  meth_meth_ast_empty1004->definitionModule = modulename;
  meth_meth_ast_empty1004->definitionLine = 40;
  Method *meth_meth_ast_empty1004_object = addmethod2pos(obj1002, "empty$object(1)", &meth_ast_empty1004_object, 1);
  int argcv_meth_ast_empty1004_object[] = {0};
  meth_meth_ast_empty1004_object->type = alloc_MethodType(1, argcv_meth_ast_empty1004_object);
  meth_meth_ast_empty1004_object->definitionModule = modulename;
  meth_meth_ast_empty1004_object->definitionLine = 40;
// method "with(_)"
  struct UserObject *uo1017 = (struct UserObject*)obj1002;
  uo1017->data[2] = emptyclosure;
  Method *meth_meth_ast_with_40_1_41_1017 = addmethod2pos(obj1002, "with(1)", &meth_ast_with_40_1_41_1017, 2);
  int argcv_meth_ast_with_40_1_41_1017[] = {1};
  meth_meth_ast_with_40_1_41_1017->type = alloc_MethodType(1, argcv_meth_ast_with_40_1_41_1017);
  meth_meth_ast_with_40_1_41_1017->definitionModule = modulename;
  meth_meth_ast_with_40_1_41_1017->definitionLine = 45;
// method "cons(_)onto(_)"
  struct UserObject *uo1022 = (struct UserObject*)obj1002;
  uo1022->data[3] = emptyclosure;
  Method *meth_meth_ast_cons_40_1_41_onto_40_1_41_1022 = addmethod2pos(obj1002, "cons(1)onto(1)", &meth_ast_cons_40_1_41_onto_40_1_41_1022, 3);
  int argcv_meth_ast_cons_40_1_41_onto_40_1_41_1022[] = {1, 1};
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1022->type = alloc_MethodType(2, argcv_meth_ast_cons_40_1_41_onto_40_1_41_1022);
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1022->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1022->definitionModule = modulename;
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1022->definitionLine = 46;
  Method *meth_meth_ast_cons_40_1_41_onto_40_1_41_1022_object = addmethod2pos(obj1002, "cons(1)onto(1)$object(1)", &meth_ast_cons_40_1_41_onto_40_1_41_1022_object, 3);
  int argcv_meth_ast_cons_40_1_41_onto_40_1_41_1022_object[] = {1, 1};
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1022_object->type = alloc_MethodType(2, argcv_meth_ast_cons_40_1_41_onto_40_1_41_1022_object);
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1022_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1022_object->definitionModule = modulename;
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1022_object->definitionLine = 46;
  sourceObject = obj1002;
  sourceObject = obj1002;
  sourceObject = obj1002;
  objclass1002 = obj1002->class;
  objclass1002->definitionModule = modulename;
  objclass1002->definitionLine = 39;
  (*(struct UserObject *)self).data[0] = lowerouter1002;
  self = oldself1002;
  selfslot = oldselfslot1002;
  stackframe = oldstackframe1002;
// compiled object node returning obj1002 (depth = 2)
  *var_ancestorChain = obj1002;
  if (obj1002 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ancestorChain"
  block_savedest(self);
  Object closure1071 = createclosure(1, "ancestorChain");
  setclosureframe(closure1071, stackframe);
  addtoclosure(closure1071, var_ancestorChain);
  struct UserObject *uo1071 = (struct UserObject*)self;
  uo1071->data[12] = (Object)closure1071;
  Method *meth_meth_ast_ancestorChain1071 = addmethod2pos(self, "ancestorChain", &meth_ast_ancestorChain1071, 12);
  int argcv_meth_ast_ancestorChain1071[] = {0};
  meth_meth_ast_ancestorChain1071->type = alloc_MethodType(1, argcv_meth_ast_ancestorChain1071);
  meth_meth_ast_ancestorChain1071->definitionModule = modulename;
  meth_meth_ast_ancestorChain1071->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
  int callframe1072 = gc_frame_new();
// call case 5: prelude request
  Object call1073 = callmethodflags(prelude, "emptySequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1072);
// compiled member node returning call1073 (depth = 2)
  *var_emptySeq = call1073;
  if (call1073 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "emptySeq"
  block_savedest(self);
  Object closure1074 = createclosure(1, "emptySeq");
  setclosureframe(closure1074, stackframe);
  addtoclosure(closure1074, var_emptySeq);
  struct UserObject *uo1074 = (struct UserObject*)self;
  uo1074->data[13] = (Object)closure1074;
  Method *meth_meth_ast_emptySeq1074 = addmethod2pos(self, "emptySeq", &meth_ast_emptySeq1074, 13);
  int argcv_meth_ast_emptySeq1074[] = {0};
  meth_meth_ast_emptySeq1074->type = alloc_MethodType(1, argcv_meth_ast_emptySeq1074);
  meth_meth_ast_emptySeq1074->definitionModule = modulename;
  meth_meth_ast_emptySeq1074->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AstNode
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type1076 = alloc_Type("AstNode", 9);
    add_Method((ClassData)type1076, "kind", NULL);
    add_Method((ClassData)type1076, "register", NULL);
    add_Method((ClassData)type1076, "line", NULL);
    add_Method((ClassData)type1076, "line:=(1)", NULL);
    add_Method((ClassData)type1076, "linePos", NULL);
    add_Method((ClassData)type1076, "linePos:=(1)", NULL);
    add_Method((ClassData)type1076, "scope", NULL);
    add_Method((ClassData)type1076, "pretty(1)", NULL);
    add_Method((ClassData)type1076, "comments", NULL);
// compiled typeliteral node returning type1076 (depth = 2)
  *var_AstNode = type1076;
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AstNode"
  block_savedest(self);
  Object closure1077 = createclosure(1, "AstNode");
  setclosureframe(closure1077, stackframe);
  addtoclosure(closure1077, var_AstNode);
  struct UserObject *uo1077 = (struct UserObject*)self;
  uo1077->data[14] = (Object)closure1077;
  Method *meth_meth_ast_AstNode1077 = addmethod2pos(self, "AstNode", &meth_ast_AstNode1077, 14);
  int argcv_meth_ast_AstNode1077[] = {0};
  meth_meth_ast_AstNode1077->type = alloc_MethodType(1, argcv_meth_ast_AstNode1077);
  meth_meth_ast_AstNode1077->definitionModule = modulename;
  meth_meth_ast_AstNode1077->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SymbolTable
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SymbolTable = *var_Unknown;
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SymbolTable"
  block_savedest(self);
  Object closure1079 = createclosure(1, "SymbolTable");
  setclosureframe(closure1079, stackframe);
  addtoclosure(closure1079, var_SymbolTable);
  struct UserObject *uo1079 = (struct UserObject*)self;
  uo1079->data[15] = (Object)closure1079;
  Method *meth_meth_ast_SymbolTable1079 = addmethod2pos(self, "SymbolTable", &meth_ast_SymbolTable1079, 15);
  int argcv_meth_ast_SymbolTable1079[] = {0};
  meth_meth_ast_SymbolTable1079->type = alloc_MethodType(1, argcv_meth_ast_SymbolTable1079);
  meth_meth_ast_SymbolTable1079->definitionModule = modulename;
  meth_meth_ast_SymbolTable1079->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1080 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1080 = alloc_userobj2(11,12, objclass1080);
  gc_frame_newslot(obj1080);
if (objclass1080 == NULL) {
  glfree(obj1080->class->name);
  obj1080->class->name = "implicit";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1080, self, 0);
  addmethodreal(obj1080,"outer", &reader_ast_outer_1081);
  Object oldself1080 = self;
  struct StackFrameObject *oldstackframe1080 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1080);
  gc_frame_newslot((Object)stackframe);
  self = obj1080;
  Object *oldselfslot1080 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1080 = (*(struct UserObject *)self).data[0], lowerouter1080 = thisouter1080;
  if (inheritingObject1080) {
    struct UserObject *inho1080 = (struct UserObject *)inheritingObject1080;
    while (inho1080->super != GraceDefaultObject) inho1080 = (struct UserObject *)inho1080->super;
    inho1080->super = obj1080;
    self = inheritingObject1080;
    *selfslot = self;
    lowerouter1080 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1080;
  }
if (objclass1080 == NULL) {
  Method *reader1082 = addmethodrealflags(obj1080, "kind",&reader_ast_kind_1082, MFLAG_DEF);
  reader1082->definitionModule = modulename;
  reader1082->definitionLine = 209;
}
adddatum2(obj1080, alloc_Undefined(), 1);
if (objclass1080 == NULL) {
  Method *reader1083 = addmethodrealflags(obj1080, "nameString",&reader_ast_nameString_1083, MFLAG_DEF);
  reader1083->definitionModule = modulename;
  reader1083->definitionLine = 210;
}
adddatum2(obj1080, alloc_Undefined(), 2);
// method "isImplicit"
  struct UserObject *uo1084 = (struct UserObject*)obj1080;
  uo1084->data[3] = emptyclosure;
  Method *meth_meth_ast_isImplicit1084 = addmethod2pos(obj1080, "isImplicit", &meth_ast_isImplicit1084, 3);
  int argcv_meth_ast_isImplicit1084[] = {0};
  meth_meth_ast_isImplicit1084->type = alloc_MethodType(1, argcv_meth_ast_isImplicit1084);
  meth_meth_ast_isImplicit1084->definitionModule = modulename;
  meth_meth_ast_isImplicit1084->definitionLine = 211;
// method "toGrace(_)"
  struct UserObject *uo1086 = (struct UserObject*)obj1080;
  uo1086->data[4] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1086 = addmethod2pos(obj1080, "toGrace(1)", &meth_ast_toGrace_40_1_41_1086, 4);
  int argcv_meth_ast_toGrace_40_1_41_1086[] = {1};
  meth_meth_ast_toGrace_40_1_41_1086->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1086);
  meth_meth_ast_toGrace_40_1_41_1086->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1086->definitionLine = 212;
// method "asString"
  struct UserObject *uo1088 = (struct UserObject*)obj1080;
  uo1088->data[5] = emptyclosure;
  Method *meth_meth_ast_asString1088 = addmethod2pos(obj1080, "asString", &meth_ast_asString1088, 5);
  int argcv_meth_ast_asString1088[] = {0};
  meth_meth_ast_asString1088->type = alloc_MethodType(1, argcv_meth_ast_asString1088);
  meth_meth_ast_asString1088->definitionModule = modulename;
  meth_meth_ast_asString1088->definitionLine = 213;
// method "==(_)"
  struct UserObject *uo1090 = (struct UserObject*)obj1080;
  uo1090->data[6] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_1090 = addmethod2pos(obj1080, "==(1)", &meth_ast__61__61__40_1_41_1090, 6);
  int argcv_meth_ast__61__61__40_1_41_1090[] = {1};
  meth_meth_ast__61__61__40_1_41_1090->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_1090);
  meth_meth_ast__61__61__40_1_41_1090->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_1090->definitionLine = 214;
// method "map(_)ancestors(_)"
  struct UserObject *uo1093 = (struct UserObject*)obj1080;
  uo1093->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1093 = addmethod2pos(obj1080, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1093, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1093[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1093->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1093);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1093->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1093->definitionLine = 215;
// method "accept(_)from(_)"
  struct UserObject *uo1094 = (struct UserObject*)obj1080;
  uo1094->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1094 = addmethod2pos(obj1080, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1094, 8);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1094[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1094->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1094);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1094->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1094->definitionLine = 216;
// method "pretty(_)"
  struct UserObject *uo1097 = (struct UserObject*)obj1080;
  uo1097->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_1097 = addmethod2pos(obj1080, "pretty(1)", &meth_ast_pretty_40_1_41_1097, 9);
  int argcv_meth_ast_pretty_40_1_41_1097[] = {1};
  meth_meth_ast_pretty_40_1_41_1097->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1097);
  meth_meth_ast_pretty_40_1_41_1097->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1097->definitionLine = 219;
  sourceObject = obj1080;
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1099 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1100 = gc_frame_new();
// call case 3: self.outer request
  Object call1101 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1100);
// compiled member node returning call1101 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1102 = callmethodflags(call1101, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1099);
// compiled call node returning call1102 (depth = 3)
  struct UserObject *obj1080_uo = (struct UserObject *)obj1080;
  obj1080_uo->super = call1102;
  sourceObject = obj1080;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1103 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num1104 = alloc_Float64(0);
// compiled num node returning num1104 (depth = 4)
  gc_frame_newslot(num1104);
// call case 4: self request
  params[0] = num1104;
  partcv[0] = 1;
  Object call1105 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1103);
// compiled call node returning call1105 (depth = 3)
  sourceObject = obj1080;
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1106 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num1107 = alloc_Float64(0);
// compiled num node returning num1107 (depth = 4)
  gc_frame_newslot(num1107);
// call case 4: self request
  params[0] = num1107;
  partcv[0] = 1;
  Object call1108 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1106);
// compiled call node returning call1108 (depth = 3)
  sourceObject = obj1080;
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1109 == NULL) {
    strlit1109 = alloc_String("implicit");
    gc_root(strlit1109);
  }
// compiled string node returning strlit1109 (depth = 3)
  adddatum2(obj1080, strlit1109, 1);
  sourceObject = obj1080;
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1110 == NULL) {
    strlit1110 = alloc_String("implicit");
    gc_root(strlit1110);
  }
// compiled string node returning strlit1110 (depth = 3)
  adddatum2(obj1080, strlit1110, 2);
  sourceObject = obj1080;
  sourceObject = obj1080;
  sourceObject = obj1080;
  sourceObject = obj1080;
  sourceObject = obj1080;
  sourceObject = obj1080;
  sourceObject = obj1080;
  objclass1080 = obj1080->class;
  objclass1080->definitionModule = modulename;
  objclass1080->definitionLine = 205;
  (*(struct UserObject *)self).data[0] = lowerouter1080;
  self = oldself1080;
  selfslot = oldselfslot1080;
  stackframe = oldstackframe1080;
// compiled object node returning obj1080 (depth = 2)
  *var_implicit = obj1080;
  if (obj1080 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "implicit"
  block_savedest(self);
  Object closure1111 = createclosure(1, "implicit");
  setclosureframe(closure1111, stackframe);
  addtoclosure(closure1111, var_implicit);
  struct UserObject *uo1111 = (struct UserObject*)self;
  uo1111->data[16] = (Object)closure1111;
  Method *meth_meth_ast_implicit1111 = addmethod2pos(self, "implicit", &meth_ast_implicit1111, 16);
  int argcv_meth_ast_implicit1111[] = {0};
  meth_meth_ast_implicit1111->type = alloc_MethodType(1, argcv_meth_ast_implicit1111);
  meth_meth_ast_implicit1111->definitionModule = modulename;
  meth_meth_ast_implicit1111->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1112 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1112 = alloc_userobj2(4,5, objclass1112);
  gc_frame_newslot(obj1112);
if (objclass1112 == NULL) {
  glfree(obj1112->class->name);
  obj1112->class->name = "nullNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1112, self, 0);
  addmethodreal(obj1112,"outer", &reader_ast_outer_1113);
  Object oldself1112 = self;
  struct StackFrameObject *oldstackframe1112 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1112);
  gc_frame_newslot((Object)stackframe);
  self = obj1112;
  Object *oldselfslot1112 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1112 = (*(struct UserObject *)self).data[0], lowerouter1112 = thisouter1112;
  if (inheritingObject1112) {
    struct UserObject *inho1112 = (struct UserObject *)inheritingObject1112;
    while (inho1112->super != GraceDefaultObject) inho1112 = (struct UserObject *)inho1112->super;
    inho1112->super = obj1112;
    self = inheritingObject1112;
    *selfslot = self;
    lowerouter1112 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1112;
  }
if (objclass1112 == NULL) {
  Method *reader1114 = addmethodrealflags(obj1112, "kind",&reader_ast_kind_1114, MFLAG_DEF);
  reader1114->definitionModule = modulename;
  reader1114->definitionLine = 224;
}
adddatum2(obj1112, alloc_Undefined(), 1);
// method "toGrace(_)"
  struct UserObject *uo1115 = (struct UserObject*)obj1112;
  uo1115->data[2] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1115 = addmethod2pos(obj1112, "toGrace(1)", &meth_ast_toGrace_40_1_41_1115, 2);
  int argcv_meth_ast_toGrace_40_1_41_1115[] = {1};
  meth_meth_ast_toGrace_40_1_41_1115->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1115);
  meth_meth_ast_toGrace_40_1_41_1115->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1115->definitionLine = 225;
// method "asString"
  struct UserObject *uo1117 = (struct UserObject*)obj1112;
  uo1117->data[3] = emptyclosure;
  Method *meth_meth_ast_asString1117 = addmethod2pos(obj1112, "asString", &meth_ast_asString1117, 3);
  int argcv_meth_ast_asString1117[] = {0};
  meth_meth_ast_asString1117->type = alloc_MethodType(1, argcv_meth_ast_asString1117);
  meth_meth_ast_asString1117->definitionModule = modulename;
  meth_meth_ast_asString1117->definitionLine = 228;
// method "==(_)"
  struct UserObject *uo1119 = (struct UserObject*)obj1112;
  uo1119->data[4] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_1119 = addmethod2pos(obj1112, "==(1)", &meth_ast__61__61__40_1_41_1119, 4);
  int argcv_meth_ast__61__61__40_1_41_1119[] = {1};
  meth_meth_ast__61__61__40_1_41_1119->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_1119);
  meth_meth_ast__61__61__40_1_41_1119->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_1119->definitionLine = 229;
  sourceObject = obj1112;
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1122 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1123 = gc_frame_new();
// call case 3: self.outer request
  Object call1124 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1123);
// compiled member node returning call1124 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1125 = callmethodflags(call1124, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1122);
// compiled call node returning call1125 (depth = 3)
  struct UserObject *obj1112_uo = (struct UserObject *)obj1112;
  obj1112_uo->super = call1125;
  sourceObject = obj1112;
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1126 == NULL) {
    strlit1126 = alloc_String("null");
    gc_root(strlit1126);
  }
// compiled string node returning strlit1126 (depth = 3)
  adddatum2(obj1112, strlit1126, 1);
  sourceObject = obj1112;
  sourceObject = obj1112;
  sourceObject = obj1112;
  objclass1112 = obj1112->class;
  objclass1112->definitionModule = modulename;
  objclass1112->definitionLine = 222;
  (*(struct UserObject *)self).data[0] = lowerouter1112;
  self = oldself1112;
  selfslot = oldselfslot1112;
  stackframe = oldstackframe1112;
// compiled object node returning obj1112 (depth = 2)
  *var_nullNode = obj1112;
  if (obj1112 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "nullNode"
  block_savedest(self);
  Object closure1127 = createclosure(1, "nullNode");
  setclosureframe(closure1127, stackframe);
  addtoclosure(closure1127, var_nullNode);
  struct UserObject *uo1127 = (struct UserObject*)self;
  uo1127->data[17] = (Object)closure1127;
  Method *meth_meth_ast_nullNode1127 = addmethod2pos(self, "nullNode", &meth_ast_nullNode1127, 17);
  int argcv_meth_ast_nullNode1127[] = {0};
  meth_meth_ast_nullNode1127->type = alloc_MethodType(1, argcv_meth_ast_nullNode1127);
  meth_meth_ast_nullNode1127->definitionModule = modulename;
  meth_meth_ast_nullNode1127->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1128 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1128 = alloc_userobj2(8,8, objclass1128);
  gc_frame_newslot(obj1128);
if (objclass1128 == NULL) {
  glfree(obj1128->class->name);
  obj1128->class->name = "fakeSymbolTable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1128, self, 0);
  addmethodreal(obj1128,"outer", &reader_ast_outer_1129);
  Object oldself1128 = self;
  struct StackFrameObject *oldstackframe1128 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1128);
  gc_frame_newslot((Object)stackframe);
  self = obj1128;
  Object *oldselfslot1128 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1128 = (*(struct UserObject *)self).data[0], lowerouter1128 = thisouter1128;
  if (inheritingObject1128) {
    struct UserObject *inho1128 = (struct UserObject *)inheritingObject1128;
    while (inho1128->super != GraceDefaultObject) inho1128 = (struct UserObject *)inho1128->super;
    inho1128->super = obj1128;
    self = inheritingObject1128;
    *selfslot = self;
    lowerouter1128 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1128;
  }
if (objclass1128 == NULL) {
  Method *reader1130 = addmethodrealflags(obj1128, "node", &reader_ast_node_1130, 0);
  Method *writer1130 = addmethodrealflags(obj1128, "node:=(1)", &writer_ast_node_1130, 0);
  reader1130->definitionModule = modulename;
  writer1130->definitionModule = modulename;
  reader1130->definitionLine = 233;
  writer1130->definitionLine = 233;
}
obj1128->flags |= OFLAG_MUTABLE;
adddatum2(obj1128, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo1131 = (struct UserObject*)obj1128;
  uo1131->data[2] = emptyclosure;
  Method *meth_meth_ast_asString1131 = addmethod2pos(obj1128, "asString", &meth_ast_asString1131, 2);
  int argcv_meth_ast_asString1131[] = {0};
  meth_meth_ast_asString1131->type = alloc_MethodType(1, argcv_meth_ast_asString1131);
  meth_meth_ast_asString1131->definitionModule = modulename;
  meth_meth_ast_asString1131->definitionLine = 234;
// method "addNode(_)as(_)"
  struct UserObject *uo1133 = (struct UserObject*)obj1128;
  uo1133->data[3] = emptyclosure;
  Method *meth_meth_ast_addNode_40_1_41_as_40_1_41_1133 = addmethod2pos(obj1128, "addNode(1)as(1)", &meth_ast_addNode_40_1_41_as_40_1_41_1133, 3);
  int argcv_meth_ast_addNode_40_1_41_as_40_1_41_1133[] = {1, 1};
  meth_meth_ast_addNode_40_1_41_as_40_1_41_1133->type = alloc_MethodType(2, argcv_meth_ast_addNode_40_1_41_as_40_1_41_1133);
  meth_meth_ast_addNode_40_1_41_as_40_1_41_1133->definitionModule = modulename;
  meth_meth_ast_addNode_40_1_41_as_40_1_41_1133->definitionLine = 235;
// method "thatDefines(_)ifNone(_)"
  struct UserObject *uo1162 = (struct UserObject*)obj1128;
  uo1162->data[4] = emptyclosure;
  Method *meth_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1162 = addmethod2pos(obj1128, "thatDefines(1)ifNone(1)", &meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1162, 4);
  int argcv_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1162[] = {1, 1};
  meth_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1162->type = alloc_MethodType(2, argcv_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1162);
  meth_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1162->definitionModule = modulename;
  meth_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1162->definitionLine = 238;
// method "enclosingObjectScope"
  struct UserObject *uo1175 = (struct UserObject*)obj1128;
  uo1175->data[5] = emptyclosure;
  Method *meth_meth_ast_enclosingObjectScope1175 = addmethod2pos(obj1128, "enclosingObjectScope", &meth_ast_enclosingObjectScope1175, 5);
  int argcv_meth_ast_enclosingObjectScope1175[] = {0};
  meth_meth_ast_enclosingObjectScope1175->type = alloc_MethodType(1, argcv_meth_ast_enclosingObjectScope1175);
  meth_meth_ast_enclosingObjectScope1175->definitionModule = modulename;
  meth_meth_ast_enclosingObjectScope1175->definitionLine = 241;
// method "variety"
  struct UserObject *uo1190 = (struct UserObject*)obj1128;
  uo1190->data[6] = emptyclosure;
  Method *meth_meth_ast_variety1190 = addmethod2pos(obj1128, "variety", &meth_ast_variety1190, 6);
  int argcv_meth_ast_variety1190[] = {0};
  meth_meth_ast_variety1190->type = alloc_MethodType(1, argcv_meth_ast_variety1190);
  meth_meth_ast_variety1190->definitionModule = modulename;
  meth_meth_ast_variety1190->definitionLine = 244;
// method "==(_)"
  struct UserObject *uo1192 = (struct UserObject*)obj1128;
  uo1192->data[7] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_1192 = addmethod2pos(obj1128, "==(1)", &meth_ast__61__61__40_1_41_1192, 7);
  int argcv_meth_ast__61__61__40_1_41_1192[] = {1};
  meth_meth_ast__61__61__40_1_41_1192->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_1192);
  meth_meth_ast__61__61__40_1_41_1192->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_1192->definitionLine = 245;
  sourceObject = obj1128;
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  adddatum2(obj1128, *var_nullNode, 1);
  sourceObject = obj1128;
  sourceObject = obj1128;
  sourceObject = obj1128;
  sourceObject = obj1128;
  sourceObject = obj1128;
  sourceObject = obj1128;
  objclass1128 = obj1128->class;
  objclass1128->definitionModule = modulename;
  objclass1128->definitionLine = 232;
  (*(struct UserObject *)self).data[0] = lowerouter1128;
  self = oldself1128;
  selfslot = oldselfslot1128;
  stackframe = oldstackframe1128;
// compiled object node returning obj1128 (depth = 2)
  *var_fakeSymbolTable = obj1128;
  if (obj1128 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "fakeSymbolTable"
  block_savedest(self);
  Object closure1195 = createclosure(1, "fakeSymbolTable");
  setclosureframe(closure1195, stackframe);
  addtoclosure(closure1195, var_fakeSymbolTable);
  struct UserObject *uo1195 = (struct UserObject*)self;
  uo1195->data[18] = (Object)closure1195;
  Method *meth_meth_ast_fakeSymbolTable1195 = addmethod2pos(self, "fakeSymbolTable", &meth_ast_fakeSymbolTable1195, 18);
  int argcv_meth_ast_fakeSymbolTable1195[] = {0};
  meth_meth_ast_fakeSymbolTable1195->type = alloc_MethodType(1, argcv_meth_ast_fakeSymbolTable1195);
  meth_meth_ast_fakeSymbolTable1195->definitionModule = modulename;
  meth_meth_ast_fakeSymbolTable1195->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1196 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1196 = alloc_userobj2(2,4, objclass1196);
  gc_frame_newslot(obj1196);
if (objclass1196 == NULL) {
  glfree(obj1196->class->name);
  obj1196->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1196, self, 0);
  addmethodreal(obj1196,"outer", &reader_ast_outer_1197);
  Object oldself1196 = self;
  struct StackFrameObject *oldstackframe1196 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1196);
  gc_frame_newslot((Object)stackframe);
  self = obj1196;
  Object *oldselfslot1196 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1196 = (*(struct UserObject *)self).data[0], lowerouter1196 = thisouter1196;
  if (inheritingObject1196) {
    struct UserObject *inho1196 = (struct UserObject *)inheritingObject1196;
    while (inho1196->super != GraceDefaultObject) inho1196 = (struct UserObject *)inho1196->super;
    inho1196->super = obj1196;
    self = inheritingObject1196;
    *selfslot = self;
    lowerouter1196 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1196;
  }
// method "new(_,_,_)"
  block_savedest(obj1196);
  Object closure1198 = createclosure(3, "new(3)");
  setclosureframe(closure1198, stackframe);
  addtoclosure(closure1198, var_util);
  addtoclosure(closure1198, var_nullNode);
  addtoclosure(closure1198, var_ifNode);
  struct UserObject *uo1198 = (struct UserObject*)obj1196;
  uo1198->data[1] = (Object)closure1198;
  Method *meth_meth_ast_new_40_3_41_1198 = addmethod2pos(obj1196, "new(3)", &meth_ast_new_40_3_41_1198, 1);
  int argcv_meth_ast_new_40_3_41_1198[] = {3};
  meth_meth_ast_new_40_3_41_1198->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_1198);
  meth_meth_ast_new_40_3_41_1198->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_1198->definitionLine = 249;
  block_savedest(obj1196);
  Object closure1553 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure1553, stackframe);
  addtoclosure(closure1553, var_util);
  addtoclosure(closure1553, var_nullNode);
  addtoclosure(closure1553, var_ifNode);
  Method *meth_meth_ast_new_40_3_41_1198_object = addmethod2pos(obj1196, "new(3)$object(1)", &meth_ast_new_40_3_41_1198_object, 1);
  meth_meth_ast_new_40_3_41_1198_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_1198_object->definitionLine = 249;
  sourceObject = obj1196;
  objclass1196 = obj1196->class;
  objclass1196->definitionModule = modulename;
  objclass1196->definitionLine = 248;
  (*(struct UserObject *)self).data[0] = lowerouter1196;
  self = oldself1196;
  selfslot = oldselfslot1196;
  stackframe = oldstackframe1196;
// compiled object node returning obj1196 (depth = 2)
  *var_ifNode = obj1196;
  if (obj1196 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ifNode"
  block_savedest(self);
  Object closure1554 = createclosure(1, "ifNode");
  setclosureframe(closure1554, stackframe);
  addtoclosure(closure1554, var_ifNode);
  struct UserObject *uo1554 = (struct UserObject*)self;
  uo1554->data[19] = (Object)closure1554;
  Method *meth_meth_ast_ifNode1554 = addmethod2pos(self, "ifNode", &meth_ast_ifNode1554, 19);
  int argcv_meth_ast_ifNode1554[] = {0};
  meth_meth_ast_ifNode1554->type = alloc_MethodType(1, argcv_meth_ast_ifNode1554);
  meth_meth_ast_ifNode1554->definitionModule = modulename;
  meth_meth_ast_ifNode1554->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1555 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1555 = alloc_userobj2(2,4, objclass1555);
  gc_frame_newslot(obj1555);
if (objclass1555 == NULL) {
  glfree(obj1555->class->name);
  obj1555->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1555, self, 0);
  addmethodreal(obj1555,"outer", &reader_ast_outer_1556);
  Object oldself1555 = self;
  struct StackFrameObject *oldstackframe1555 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1555);
  gc_frame_newslot((Object)stackframe);
  self = obj1555;
  Object *oldselfslot1555 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1555 = (*(struct UserObject *)self).data[0], lowerouter1555 = thisouter1555;
  if (inheritingObject1555) {
    struct UserObject *inho1555 = (struct UserObject *)inheritingObject1555;
    while (inho1555->super != GraceDefaultObject) inho1555 = (struct UserObject *)inho1555->super;
    inho1555->super = obj1555;
    self = inheritingObject1555;
    *selfslot = self;
    lowerouter1555 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1555;
  }
// method "new(_,_)"
  block_savedest(obj1555);
  Object closure1557 = createclosure(4, "new(2)");
  setclosureframe(closure1557, stackframe);
  addtoclosure(closure1557, var_k);
  addtoclosure(closure1557, var_blockNode);
  addtoclosure(closure1557, var_patternMarkVisitor);
  addtoclosure(closure1557, var_ancestorChain);
  struct UserObject *uo1557 = (struct UserObject*)obj1555;
  uo1557->data[1] = (Object)closure1557;
  Method *meth_meth_ast_new_40_2_41_1557 = addmethod2pos(obj1555, "new(2)", &meth_ast_new_40_2_41_1557, 1);
  int argcv_meth_ast_new_40_2_41_1557[] = {2};
  meth_meth_ast_new_40_2_41_1557->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_1557);
  meth_meth_ast_new_40_2_41_1557->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_1557->definitionLine = 326;
  block_savedest(obj1555);
  Object closure2015 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure2015, stackframe);
  addtoclosure(closure2015, var_k);
  addtoclosure(closure2015, var_blockNode);
  addtoclosure(closure2015, var_patternMarkVisitor);
  addtoclosure(closure2015, var_ancestorChain);
  Method *meth_meth_ast_new_40_2_41_1557_object = addmethod2pos(obj1555, "new(2)$object(1)", &meth_ast_new_40_2_41_1557_object, 1);
  meth_meth_ast_new_40_2_41_1557_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_1557_object->definitionLine = 326;
  sourceObject = obj1555;
  objclass1555 = obj1555->class;
  objclass1555->definitionModule = modulename;
  objclass1555->definitionLine = 325;
  (*(struct UserObject *)self).data[0] = lowerouter1555;
  self = oldself1555;
  selfslot = oldselfslot1555;
  stackframe = oldstackframe1555;
// compiled object node returning obj1555 (depth = 2)
  *var_blockNode = obj1555;
  if (obj1555 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blockNode"
  block_savedest(self);
  Object closure2016 = createclosure(1, "blockNode");
  setclosureframe(closure2016, stackframe);
  addtoclosure(closure2016, var_blockNode);
  struct UserObject *uo2016 = (struct UserObject*)self;
  uo2016->data[20] = (Object)closure2016;
  Method *meth_meth_ast_blockNode2016 = addmethod2pos(self, "blockNode", &meth_ast_blockNode2016, 20);
  int argcv_meth_ast_blockNode2016[] = {0};
  meth_meth_ast_blockNode2016->type = alloc_MethodType(1, argcv_meth_ast_blockNode2016);
  meth_meth_ast_blockNode2016->definitionModule = modulename;
  meth_meth_ast_blockNode2016->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2017 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2017 = alloc_userobj2(2,4, objclass2017);
  gc_frame_newslot(obj2017);
if (objclass2017 == NULL) {
  glfree(obj2017->class->name);
  obj2017->class->name = "tryCatchNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2017, self, 0);
  addmethodreal(obj2017,"outer", &reader_ast_outer_2018);
  Object oldself2017 = self;
  struct StackFrameObject *oldstackframe2017 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2017);
  gc_frame_newslot((Object)stackframe);
  self = obj2017;
  Object *oldselfslot2017 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2017 = (*(struct UserObject *)self).data[0], lowerouter2017 = thisouter2017;
  if (inheritingObject2017) {
    struct UserObject *inho2017 = (struct UserObject *)inheritingObject2017;
    while (inho2017->super != GraceDefaultObject) inho2017 = (struct UserObject *)inho2017->super;
    inho2017->super = obj2017;
    self = inheritingObject2017;
    *selfslot = self;
    lowerouter2017 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2017;
  }
// method "new(_,_,_)"
  block_savedest(obj2017);
  Object closure2019 = createclosure(3, "new(3)");
  setclosureframe(closure2019, stackframe);
  addtoclosure(closure2019, var_nullNode);
  addtoclosure(closure2019, var_emptySeq);
  addtoclosure(closure2019, var_tryCatchNode);
  struct UserObject *uo2019 = (struct UserObject*)obj2017;
  uo2019->data[1] = (Object)closure2019;
  Method *meth_meth_ast_new_40_3_41_2019 = addmethod2pos(obj2017, "new(3)", &meth_ast_new_40_3_41_2019, 1);
  int argcv_meth_ast_new_40_3_41_2019[] = {3};
  meth_meth_ast_new_40_3_41_2019->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_2019);
  meth_meth_ast_new_40_3_41_2019->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_2019->definitionLine = 445;
  block_savedest(obj2017);
  Object closure2327 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure2327, stackframe);
  addtoclosure(closure2327, var_nullNode);
  addtoclosure(closure2327, var_emptySeq);
  addtoclosure(closure2327, var_tryCatchNode);
  Method *meth_meth_ast_new_40_3_41_2019_object = addmethod2pos(obj2017, "new(3)$object(1)", &meth_ast_new_40_3_41_2019_object, 1);
  meth_meth_ast_new_40_3_41_2019_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_2019_object->definitionLine = 445;
  sourceObject = obj2017;
  objclass2017 = obj2017->class;
  objclass2017->definitionModule = modulename;
  objclass2017->definitionLine = 444;
  (*(struct UserObject *)self).data[0] = lowerouter2017;
  self = oldself2017;
  selfslot = oldselfslot2017;
  stackframe = oldstackframe2017;
// compiled object node returning obj2017 (depth = 2)
  *var_tryCatchNode = obj2017;
  if (obj2017 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tryCatchNode"
  block_savedest(self);
  Object closure2328 = createclosure(1, "tryCatchNode");
  setclosureframe(closure2328, stackframe);
  addtoclosure(closure2328, var_tryCatchNode);
  struct UserObject *uo2328 = (struct UserObject*)self;
  uo2328->data[21] = (Object)closure2328;
  Method *meth_meth_ast_tryCatchNode2328 = addmethod2pos(self, "tryCatchNode", &meth_ast_tryCatchNode2328, 21);
  int argcv_meth_ast_tryCatchNode2328[] = {0};
  meth_meth_ast_tryCatchNode2328->type = alloc_MethodType(1, argcv_meth_ast_tryCatchNode2328);
  meth_meth_ast_tryCatchNode2328->definitionModule = modulename;
  meth_meth_ast_tryCatchNode2328->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2329 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2329 = alloc_userobj2(2,4, objclass2329);
  gc_frame_newslot(obj2329);
if (objclass2329 == NULL) {
  glfree(obj2329->class->name);
  obj2329->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2329, self, 0);
  addmethodreal(obj2329,"outer", &reader_ast_outer_2330);
  Object oldself2329 = self;
  struct StackFrameObject *oldstackframe2329 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2329);
  gc_frame_newslot((Object)stackframe);
  self = obj2329;
  Object *oldselfslot2329 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2329 = (*(struct UserObject *)self).data[0], lowerouter2329 = thisouter2329;
  if (inheritingObject2329) {
    struct UserObject *inho2329 = (struct UserObject *)inheritingObject2329;
    while (inho2329->super != GraceDefaultObject) inho2329 = (struct UserObject *)inho2329->super;
    inho2329->super = obj2329;
    self = inheritingObject2329;
    *selfslot = self;
    lowerouter2329 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2329;
  }
// method "new(_,_,_)"
  block_savedest(obj2329);
  Object closure2331 = createclosure(3, "new(3)");
  setclosureframe(closure2331, stackframe);
  addtoclosure(closure2331, var_nullNode);
  addtoclosure(closure2331, var_emptySeq);
  addtoclosure(closure2331, var_matchCaseNode);
  struct UserObject *uo2331 = (struct UserObject*)obj2329;
  uo2331->data[1] = (Object)closure2331;
  Method *meth_meth_ast_new_40_3_41_2331 = addmethod2pos(obj2329, "new(3)", &meth_ast_new_40_3_41_2331, 1);
  int argcv_meth_ast_new_40_3_41_2331[] = {3};
  meth_meth_ast_new_40_3_41_2331->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_2331);
  meth_meth_ast_new_40_3_41_2331->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_2331->definitionLine = 508;
  block_savedest(obj2329);
  Object closure2635 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure2635, stackframe);
  addtoclosure(closure2635, var_nullNode);
  addtoclosure(closure2635, var_emptySeq);
  addtoclosure(closure2635, var_matchCaseNode);
  Method *meth_meth_ast_new_40_3_41_2331_object = addmethod2pos(obj2329, "new(3)$object(1)", &meth_ast_new_40_3_41_2331_object, 1);
  meth_meth_ast_new_40_3_41_2331_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_2331_object->definitionLine = 508;
  sourceObject = obj2329;
  objclass2329 = obj2329->class;
  objclass2329->definitionModule = modulename;
  objclass2329->definitionLine = 507;
  (*(struct UserObject *)self).data[0] = lowerouter2329;
  self = oldself2329;
  selfslot = oldselfslot2329;
  stackframe = oldstackframe2329;
// compiled object node returning obj2329 (depth = 2)
  *var_matchCaseNode = obj2329;
  if (obj2329 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "matchCaseNode"
  block_savedest(self);
  Object closure2636 = createclosure(1, "matchCaseNode");
  setclosureframe(closure2636, stackframe);
  addtoclosure(closure2636, var_matchCaseNode);
  struct UserObject *uo2636 = (struct UserObject*)self;
  uo2636->data[22] = (Object)closure2636;
  Method *meth_meth_ast_matchCaseNode2636 = addmethod2pos(self, "matchCaseNode", &meth_ast_matchCaseNode2636, 22);
  int argcv_meth_ast_matchCaseNode2636[] = {0};
  meth_meth_ast_matchCaseNode2636->type = alloc_MethodType(1, argcv_meth_ast_matchCaseNode2636);
  meth_meth_ast_matchCaseNode2636->definitionModule = modulename;
  meth_meth_ast_matchCaseNode2636->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2637 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2637 = alloc_userobj2(2,4, objclass2637);
  gc_frame_newslot(obj2637);
if (objclass2637 == NULL) {
  glfree(obj2637->class->name);
  obj2637->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2637, self, 0);
  addmethodreal(obj2637,"outer", &reader_ast_outer_2638);
  Object oldself2637 = self;
  struct StackFrameObject *oldstackframe2637 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2637);
  gc_frame_newslot((Object)stackframe);
  self = obj2637;
  Object *oldselfslot2637 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2637 = (*(struct UserObject *)self).data[0], lowerouter2637 = thisouter2637;
  if (inheritingObject2637) {
    struct UserObject *inho2637 = (struct UserObject *)inheritingObject2637;
    while (inho2637->super != GraceDefaultObject) inho2637 = (struct UserObject *)inho2637->super;
    inho2637->super = obj2637;
    self = inheritingObject2637;
    *selfslot = self;
    lowerouter2637 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2637;
  }
// method "new(_,_)"
  block_savedest(obj2637);
  Object closure2639 = createclosure(4, "new(2)");
  setclosureframe(closure2639, stackframe);
  addtoclosure(closure2639, var_uninitialized);
  addtoclosure(closure2639, var_identifierNode);
  addtoclosure(closure2639, var_k);
  addtoclosure(closure2639, var_methodTypeNode);
  struct UserObject *uo2639 = (struct UserObject*)obj2637;
  uo2639->data[1] = (Object)closure2639;
  Method *meth_meth_ast_new_40_2_41_2639 = addmethod2pos(obj2637, "new(2)", &meth_ast_new_40_2_41_2639, 1);
  int argcv_meth_ast_new_40_2_41_2639[] = {2};
  meth_meth_ast_new_40_2_41_2639->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_2639);
  meth_meth_ast_new_40_2_41_2639->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_2639->definitionLine = 571;
  block_savedest(obj2637);
  Object closure3018 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure3018, stackframe);
  addtoclosure(closure3018, var_uninitialized);
  addtoclosure(closure3018, var_identifierNode);
  addtoclosure(closure3018, var_k);
  addtoclosure(closure3018, var_methodTypeNode);
  Method *meth_meth_ast_new_40_2_41_2639_object = addmethod2pos(obj2637, "new(2)$object(1)", &meth_ast_new_40_2_41_2639_object, 1);
  meth_meth_ast_new_40_2_41_2639_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_2639_object->definitionLine = 571;
  sourceObject = obj2637;
  objclass2637 = obj2637->class;
  objclass2637->definitionModule = modulename;
  objclass2637->definitionLine = 570;
  (*(struct UserObject *)self).data[0] = lowerouter2637;
  self = oldself2637;
  selfslot = oldselfslot2637;
  stackframe = oldstackframe2637;
// compiled object node returning obj2637 (depth = 2)
  *var_methodTypeNode = obj2637;
  if (obj2637 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "methodTypeNode"
  block_savedest(self);
  Object closure3019 = createclosure(1, "methodTypeNode");
  setclosureframe(closure3019, stackframe);
  addtoclosure(closure3019, var_methodTypeNode);
  struct UserObject *uo3019 = (struct UserObject*)self;
  uo3019->data[23] = (Object)closure3019;
  Method *meth_meth_ast_methodTypeNode3019 = addmethod2pos(self, "methodTypeNode", &meth_ast_methodTypeNode3019, 23);
  int argcv_meth_ast_methodTypeNode3019[] = {0};
  meth_meth_ast_methodTypeNode3019->type = alloc_MethodType(1, argcv_meth_ast_methodTypeNode3019);
  meth_meth_ast_methodTypeNode3019->definitionModule = modulename;
  meth_meth_ast_methodTypeNode3019->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3020 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3020 = alloc_userobj2(2,4, objclass3020);
  gc_frame_newslot(obj3020);
if (objclass3020 == NULL) {
  glfree(obj3020->class->name);
  obj3020->class->name = "typeLiteralNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3020, self, 0);
  addmethodreal(obj3020,"outer", &reader_ast_outer_3021);
  Object oldself3020 = self;
  struct StackFrameObject *oldstackframe3020 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3020);
  gc_frame_newslot((Object)stackframe);
  self = obj3020;
  Object *oldselfslot3020 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3020 = (*(struct UserObject *)self).data[0], lowerouter3020 = thisouter3020;
  if (inheritingObject3020) {
    struct UserObject *inho3020 = (struct UserObject *)inheritingObject3020;
    while (inho3020->super != GraceDefaultObject) inho3020 = (struct UserObject *)inho3020->super;
    inho3020->super = obj3020;
    self = inheritingObject3020;
    *selfslot = self;
    lowerouter3020 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3020;
  }
// method "new(_,_)"
  block_savedest(obj3020);
  Object closure3022 = createclosure(3, "new(2)");
  setclosureframe(closure3022, stackframe);
  addtoclosure(closure3022, var_k);
  addtoclosure(closure3022, var_emptySeq);
  addtoclosure(closure3022, var_typeLiteralNode);
  struct UserObject *uo3022 = (struct UserObject*)obj3020;
  uo3022->data[1] = (Object)closure3022;
  Method *meth_meth_ast_new_40_2_41_3022 = addmethod2pos(obj3020, "new(2)", &meth_ast_new_40_2_41_3022, 1);
  int argcv_meth_ast_new_40_2_41_3022[] = {2};
  meth_meth_ast_new_40_2_41_3022->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_3022);
  meth_meth_ast_new_40_2_41_3022->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_3022->definitionLine = 662;
  block_savedest(obj3020);
  Object closure3331 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure3331, stackframe);
  addtoclosure(closure3331, var_k);
  addtoclosure(closure3331, var_emptySeq);
  addtoclosure(closure3331, var_typeLiteralNode);
  Method *meth_meth_ast_new_40_2_41_3022_object = addmethod2pos(obj3020, "new(2)$object(1)", &meth_ast_new_40_2_41_3022_object, 1);
  meth_meth_ast_new_40_2_41_3022_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_3022_object->definitionLine = 662;
  sourceObject = obj3020;
  objclass3020 = obj3020->class;
  objclass3020->definitionModule = modulename;
  objclass3020->definitionLine = 661;
  (*(struct UserObject *)self).data[0] = lowerouter3020;
  self = oldself3020;
  selfslot = oldselfslot3020;
  stackframe = oldstackframe3020;
// compiled object node returning obj3020 (depth = 2)
  *var_typeLiteralNode = obj3020;
  if (obj3020 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeLiteralNode"
  block_savedest(self);
  Object closure3332 = createclosure(1, "typeLiteralNode");
  setclosureframe(closure3332, stackframe);
  addtoclosure(closure3332, var_typeLiteralNode);
  struct UserObject *uo3332 = (struct UserObject*)self;
  uo3332->data[24] = (Object)closure3332;
  Method *meth_meth_ast_typeLiteralNode3332 = addmethod2pos(self, "typeLiteralNode", &meth_ast_typeLiteralNode3332, 24);
  int argcv_meth_ast_typeLiteralNode3332[] = {0};
  meth_meth_ast_typeLiteralNode3332->type = alloc_MethodType(1, argcv_meth_ast_typeLiteralNode3332);
  meth_meth_ast_typeLiteralNode3332->definitionModule = modulename;
  meth_meth_ast_typeLiteralNode3332->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3333 = alloc_userobj2(2,4, objclass3333);
  gc_frame_newslot(obj3333);
if (objclass3333 == NULL) {
  glfree(obj3333->class->name);
  obj3333->class->name = "typeDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3333, self, 0);
  addmethodreal(obj3333,"outer", &reader_ast_outer_3334);
  Object oldself3333 = self;
  struct StackFrameObject *oldstackframe3333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3333);
  gc_frame_newslot((Object)stackframe);
  self = obj3333;
  Object *oldselfslot3333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3333 = (*(struct UserObject *)self).data[0], lowerouter3333 = thisouter3333;
  if (inheritingObject3333) {
    struct UserObject *inho3333 = (struct UserObject *)inheritingObject3333;
    while (inho3333->super != GraceDefaultObject) inho3333 = (struct UserObject *)inho3333->super;
    inho3333->super = obj3333;
    self = inheritingObject3333;
    *selfslot = self;
    lowerouter3333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3333;
  }
// method "new(_,_)"
  block_savedest(obj3333);
  Object closure3335 = createclosure(3, "new(2)");
  setclosureframe(closure3335, stackframe);
  addtoclosure(closure3335, var_k);
  addtoclosure(closure3335, var_nullNode);
  addtoclosure(closure3335, var_typeDecNode);
  struct UserObject *uo3335 = (struct UserObject*)obj3333;
  uo3335->data[1] = (Object)closure3335;
  Method *meth_meth_ast_new_40_2_41_3335 = addmethod2pos(obj3333, "new(2)", &meth_ast_new_40_2_41_3335, 1);
  int argcv_meth_ast_new_40_2_41_3335[] = {2};
  meth_meth_ast_new_40_2_41_3335->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_3335);
  meth_meth_ast_new_40_2_41_3335->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_3335->definitionLine = 746;
  block_savedest(obj3333);
  Object closure3661 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure3661, stackframe);
  addtoclosure(closure3661, var_k);
  addtoclosure(closure3661, var_nullNode);
  addtoclosure(closure3661, var_typeDecNode);
  Method *meth_meth_ast_new_40_2_41_3335_object = addmethod2pos(obj3333, "new(2)$object(1)", &meth_ast_new_40_2_41_3335_object, 1);
  meth_meth_ast_new_40_2_41_3335_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_3335_object->definitionLine = 746;
  sourceObject = obj3333;
  objclass3333 = obj3333->class;
  objclass3333->definitionModule = modulename;
  objclass3333->definitionLine = 745;
  (*(struct UserObject *)self).data[0] = lowerouter3333;
  self = oldself3333;
  selfslot = oldselfslot3333;
  stackframe = oldstackframe3333;
// compiled object node returning obj3333 (depth = 2)
  *var_typeDecNode = obj3333;
  if (obj3333 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeDecNode"
  block_savedest(self);
  Object closure3662 = createclosure(1, "typeDecNode");
  setclosureframe(closure3662, stackframe);
  addtoclosure(closure3662, var_typeDecNode);
  struct UserObject *uo3662 = (struct UserObject*)self;
  uo3662->data[25] = (Object)closure3662;
  Method *meth_meth_ast_typeDecNode3662 = addmethod2pos(self, "typeDecNode", &meth_ast_typeDecNode3662, 25);
  int argcv_meth_ast_typeDecNode3662[] = {0};
  meth_meth_ast_typeDecNode3662->type = alloc_MethodType(1, argcv_meth_ast_typeDecNode3662);
  meth_meth_ast_typeDecNode3662->definitionModule = modulename;
  meth_meth_ast_typeDecNode3662->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3663 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3663 = alloc_userobj2(3,4, objclass3663);
  gc_frame_newslot(obj3663);
if (objclass3663 == NULL) {
  glfree(obj3663->class->name);
  obj3663->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3663, self, 0);
  addmethodreal(obj3663,"outer", &reader_ast_outer_3664);
  Object oldself3663 = self;
  struct StackFrameObject *oldstackframe3663 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3663);
  gc_frame_newslot((Object)stackframe);
  self = obj3663;
  Object *oldselfslot3663 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3663 = (*(struct UserObject *)self).data[0], lowerouter3663 = thisouter3663;
  if (inheritingObject3663) {
    struct UserObject *inho3663 = (struct UserObject *)inheritingObject3663;
    while (inho3663->super != GraceDefaultObject) inho3663 = (struct UserObject *)inho3663->super;
    inho3663->super = obj3663;
    self = inheritingObject3663;
    *selfslot = self;
    lowerouter3663 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3663;
  }
// method "new(_,_,_)scope(_)"
  struct UserObject *uo3665 = (struct UserObject*)obj3663;
  uo3665->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_3_41_scope_40_1_41_3665 = addmethod2pos(obj3663, "new(3)scope(1)", &meth_ast_new_40_3_41_scope_40_1_41_3665, 1);
  int argcv_meth_ast_new_40_3_41_scope_40_1_41_3665[] = {3, 1};
  meth_meth_ast_new_40_3_41_scope_40_1_41_3665->type = alloc_MethodType(2, argcv_meth_ast_new_40_3_41_scope_40_1_41_3665);
  meth_meth_ast_new_40_3_41_scope_40_1_41_3665->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_scope_40_1_41_3665->definitionLine = 831;
// method "new(_,_,_)"
  block_savedest(obj3663);
  Object closure3670 = createclosure(4, "new(3)");
  setclosureframe(closure3670, stackframe);
  addtoclosure(closure3670, var_uninitialized);
  addtoclosure(closure3670, var_identifierNode);
  addtoclosure(closure3670, var_k);
  addtoclosure(closure3670, var_methodNode);
  struct UserObject *uo3670 = (struct UserObject*)obj3663;
  uo3670->data[2] = (Object)closure3670;
  Method *meth_meth_ast_new_40_3_41_3670 = addmethod2pos(obj3663, "new(3)", &meth_ast_new_40_3_41_3670, 2);
  int argcv_meth_ast_new_40_3_41_3670[] = {3};
  meth_meth_ast_new_40_3_41_3670->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_3670);
  meth_meth_ast_new_40_3_41_3670->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_3670->definitionLine = 837;
  block_savedest(obj3663);
  Object closure4780 = createclosure(4, "new(3)$object(1)");
  setclosureframe(closure4780, stackframe);
  addtoclosure(closure4780, var_uninitialized);
  addtoclosure(closure4780, var_identifierNode);
  addtoclosure(closure4780, var_k);
  addtoclosure(closure4780, var_methodNode);
  Method *meth_meth_ast_new_40_3_41_3670_object = addmethod2pos(obj3663, "new(3)$object(1)", &meth_ast_new_40_3_41_3670_object, 2);
  meth_meth_ast_new_40_3_41_3670_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_3670_object->definitionLine = 837;
  sourceObject = obj3663;
  sourceObject = obj3663;
  objclass3663 = obj3663->class;
  objclass3663->definitionModule = modulename;
  objclass3663->definitionLine = 830;
  (*(struct UserObject *)self).data[0] = lowerouter3663;
  self = oldself3663;
  selfslot = oldselfslot3663;
  stackframe = oldstackframe3663;
// compiled object node returning obj3663 (depth = 2)
  *var_methodNode = obj3663;
  if (obj3663 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "methodNode"
  block_savedest(self);
  Object closure4781 = createclosure(1, "methodNode");
  setclosureframe(closure4781, stackframe);
  addtoclosure(closure4781, var_methodNode);
  struct UserObject *uo4781 = (struct UserObject*)self;
  uo4781->data[26] = (Object)closure4781;
  Method *meth_meth_ast_methodNode4781 = addmethod2pos(self, "methodNode", &meth_ast_methodNode4781, 26);
  int argcv_meth_ast_methodNode4781[] = {0};
  meth_meth_ast_methodNode4781->type = alloc_MethodType(1, argcv_meth_ast_methodNode4781);
  meth_meth_ast_methodNode4781->definitionModule = modulename;
  meth_meth_ast_methodNode4781->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject4782 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4782 = alloc_userobj2(3,4, objclass4782);
  gc_frame_newslot(obj4782);
if (objclass4782 == NULL) {
  glfree(obj4782->class->name);
  obj4782->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4782, self, 0);
  addmethodreal(obj4782,"outer", &reader_ast_outer_4783);
  Object oldself4782 = self;
  struct StackFrameObject *oldstackframe4782 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4782);
  gc_frame_newslot((Object)stackframe);
  self = obj4782;
  Object *oldselfslot4782 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4782 = (*(struct UserObject *)self).data[0], lowerouter4782 = thisouter4782;
  if (inheritingObject4782) {
    struct UserObject *inho4782 = (struct UserObject *)inheritingObject4782;
    while (inho4782->super != GraceDefaultObject) inho4782 = (struct UserObject *)inho4782->super;
    inho4782->super = obj4782;
    self = inheritingObject4782;
    *selfslot = self;
    lowerouter4782 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4782;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo4784 = (struct UserObject*)obj4782;
  uo4784->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_2_41_scope_40_1_41_4784 = addmethod2pos(obj4782, "new(2)scope(1)", &meth_ast_new_40_2_41_scope_40_1_41_4784, 1);
  int argcv_meth_ast_new_40_2_41_scope_40_1_41_4784[] = {2, 1};
  meth_meth_ast_new_40_2_41_scope_40_1_41_4784->type = alloc_MethodType(2, argcv_meth_ast_new_40_2_41_scope_40_1_41_4784);
  meth_meth_ast_new_40_2_41_scope_40_1_41_4784->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_scope_40_1_41_4784->definitionLine = 1084;
// method "new(_,_)"
  block_savedest(obj4782);
  Object closure4789 = createclosure(3, "new(2)");
  setclosureframe(closure4789, stackframe);
  addtoclosure(closure4789, var_fakeSymbolTable);
  addtoclosure(closure4789, var_identifierNode);
  addtoclosure(closure4789, var_callNode);
  struct UserObject *uo4789 = (struct UserObject*)obj4782;
  uo4789->data[2] = (Object)closure4789;
  Method *meth_meth_ast_new_40_2_41_4789 = addmethod2pos(obj4782, "new(2)", &meth_ast_new_40_2_41_4789, 2);
  int argcv_meth_ast_new_40_2_41_4789[] = {2};
  meth_meth_ast_new_40_2_41_4789->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_4789);
  meth_meth_ast_new_40_2_41_4789->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_4789->definitionLine = 1089;
  block_savedest(obj4782);
  Object closure5316 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure5316, stackframe);
  addtoclosure(closure5316, var_fakeSymbolTable);
  addtoclosure(closure5316, var_identifierNode);
  addtoclosure(closure5316, var_callNode);
  Method *meth_meth_ast_new_40_2_41_4789_object = addmethod2pos(obj4782, "new(2)$object(1)", &meth_ast_new_40_2_41_4789_object, 2);
  meth_meth_ast_new_40_2_41_4789_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_4789_object->definitionLine = 1089;
  sourceObject = obj4782;
  sourceObject = obj4782;
  objclass4782 = obj4782->class;
  objclass4782->definitionModule = modulename;
  objclass4782->definitionLine = 1083;
  (*(struct UserObject *)self).data[0] = lowerouter4782;
  self = oldself4782;
  selfslot = oldselfslot4782;
  stackframe = oldstackframe4782;
// compiled object node returning obj4782 (depth = 2)
  *var_callNode = obj4782;
  if (obj4782 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "callNode"
  block_savedest(self);
  Object closure5317 = createclosure(1, "callNode");
  setclosureframe(closure5317, stackframe);
  addtoclosure(closure5317, var_callNode);
  struct UserObject *uo5317 = (struct UserObject*)self;
  uo5317->data[27] = (Object)closure5317;
  Method *meth_meth_ast_callNode5317 = addmethod2pos(self, "callNode", &meth_ast_callNode5317, 27);
  int argcv_meth_ast_callNode5317[] = {0};
  meth_meth_ast_callNode5317->type = alloc_MethodType(1, argcv_meth_ast_callNode5317);
  meth_meth_ast_callNode5317->definitionModule = modulename;
  meth_meth_ast_callNode5317->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5318 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5318 = alloc_userobj2(4,5, objclass5318);
  gc_frame_newslot(obj5318);
if (objclass5318 == NULL) {
  glfree(obj5318->class->name);
  obj5318->class->name = "moduleNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5318, self, 0);
  addmethodreal(obj5318,"outer", &reader_ast_outer_5319);
  Object oldself5318 = self;
  struct StackFrameObject *oldstackframe5318 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5318);
  gc_frame_newslot((Object)stackframe);
  self = obj5318;
  Object *oldselfslot5318 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5318 = (*(struct UserObject *)self).data[0], lowerouter5318 = thisouter5318;
  if (inheritingObject5318) {
    struct UserObject *inho5318 = (struct UserObject *)inheritingObject5318;
    while (inho5318->super != GraceDefaultObject) inho5318 = (struct UserObject *)inho5318->super;
    inho5318->super = obj5318;
    self = inheritingObject5318;
    *selfslot = self;
    lowerouter5318 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5318;
  }
// method "body(_)named(_)scope(_)"
  struct UserObject *uo5320 = (struct UserObject*)obj5318;
  uo5320->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5320 = addmethod2pos(obj5318, "body(1)named(1)scope(1)", &meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5320, 1);
  int argcv_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5320[] = {1, 1, 1};
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5320->type = alloc_MethodType(3, argcv_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5320);
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5320->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5320->definitionLine = 1233;
// method "body(_)named(_)"
  struct UserObject *uo5327 = (struct UserObject*)obj5318;
  uo5327->data[2] = emptyclosure;
  Method *meth_meth_ast_body_40_1_41_named_40_1_41_5327 = addmethod2pos(obj5318, "body(1)named(1)", &meth_ast_body_40_1_41_named_40_1_41_5327, 2);
  int argcv_meth_ast_body_40_1_41_named_40_1_41_5327[] = {1, 1};
  meth_meth_ast_body_40_1_41_named_40_1_41_5327->type = alloc_MethodType(2, argcv_meth_ast_body_40_1_41_named_40_1_41_5327);
  meth_meth_ast_body_40_1_41_named_40_1_41_5327->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_named_40_1_41_5327->definitionLine = 1239;
// method "body(_)"
  block_savedest(obj5318);
  Object closure5332 = createclosure(4, "body(1)");
  setclosureframe(closure5332, stackframe);
  addtoclosure(closure5332, var_emptySeq);
  addtoclosure(closure5332, var_moduleNode);
  addtoclosure(closure5332, var_objectNode);
  addtoclosure(closure5332, var_util);
  struct UserObject *uo5332 = (struct UserObject*)obj5318;
  uo5332->data[3] = (Object)closure5332;
  Method *meth_meth_ast_body_40_1_41_5332 = addmethod2pos(obj5318, "body(1)", &meth_ast_body_40_1_41_5332, 3);
  int argcv_meth_ast_body_40_1_41_5332[] = {1};
  meth_meth_ast_body_40_1_41_5332->type = alloc_MethodType(1, argcv_meth_ast_body_40_1_41_5332);
  meth_meth_ast_body_40_1_41_5332->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_5332->definitionLine = 1244;
  block_savedest(obj5318);
  Object closure5406 = createclosure(4, "body(1)$object(1)");
  setclosureframe(closure5406, stackframe);
  addtoclosure(closure5406, var_emptySeq);
  addtoclosure(closure5406, var_moduleNode);
  addtoclosure(closure5406, var_objectNode);
  addtoclosure(closure5406, var_util);
  Method *meth_meth_ast_body_40_1_41_5332_object = addmethod2pos(obj5318, "body(1)$object(1)", &meth_ast_body_40_1_41_5332_object, 3);
  meth_meth_ast_body_40_1_41_5332_object->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_5332_object->definitionLine = 1244;
  sourceObject = obj5318;
  sourceObject = obj5318;
  sourceObject = obj5318;
  objclass5318 = obj5318->class;
  objclass5318->definitionModule = modulename;
  objclass5318->definitionLine = 1232;
  (*(struct UserObject *)self).data[0] = lowerouter5318;
  self = oldself5318;
  selfslot = oldselfslot5318;
  stackframe = oldstackframe5318;
// compiled object node returning obj5318 (depth = 2)
  *var_moduleNode = obj5318;
  if (obj5318 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleNode"
  block_savedest(self);
  Object closure5407 = createclosure(1, "moduleNode");
  setclosureframe(closure5407, stackframe);
  addtoclosure(closure5407, var_moduleNode);
  struct UserObject *uo5407 = (struct UserObject*)self;
  uo5407->data[28] = (Object)closure5407;
  Method *meth_meth_ast_moduleNode5407 = addmethod2pos(self, "moduleNode", &meth_ast_moduleNode5407, 28);
  int argcv_meth_ast_moduleNode5407[] = {0};
  meth_meth_ast_moduleNode5407->type = alloc_MethodType(1, argcv_meth_ast_moduleNode5407);
  meth_meth_ast_moduleNode5407->definitionModule = modulename;
  meth_meth_ast_moduleNode5407->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5408 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5408 = alloc_userobj2(4,5, objclass5408);
  gc_frame_newslot(obj5408);
if (objclass5408 == NULL) {
  glfree(obj5408->class->name);
  obj5408->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5408, self, 0);
  addmethodreal(obj5408,"outer", &reader_ast_outer_5409);
  Object oldself5408 = self;
  struct StackFrameObject *oldstackframe5408 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5408);
  gc_frame_newslot((Object)stackframe);
  self = obj5408;
  Object *oldselfslot5408 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5408 = (*(struct UserObject *)self).data[0], lowerouter5408 = thisouter5408;
  if (inheritingObject5408) {
    struct UserObject *inho5408 = (struct UserObject *)inheritingObject5408;
    while (inho5408->super != GraceDefaultObject) inho5408 = (struct UserObject *)inho5408->super;
    inho5408->super = obj5408;
    self = inheritingObject5408;
    *selfslot = self;
    lowerouter5408 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5408;
  }
// method "body(_)named(_)scope(_)"
  struct UserObject *uo5410 = (struct UserObject*)obj5408;
  uo5410->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5410 = addmethod2pos(obj5408, "body(1)named(1)scope(1)", &meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5410, 1);
  int argcv_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5410[] = {1, 1, 1};
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5410->type = alloc_MethodType(3, argcv_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5410);
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5410->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5410->definitionLine = 1281;
// method "body(_)named(_)"
  block_savedest(obj5408);
  Object closure5418 = createclosure(1, "body(1)named(1)");
  setclosureframe(closure5418, stackframe);
  addtoclosure(closure5418, var_fakeSymbolTable);
  struct UserObject *uo5418 = (struct UserObject*)obj5408;
  uo5418->data[2] = (Object)closure5418;
  Method *meth_meth_ast_body_40_1_41_named_40_1_41_5418 = addmethod2pos(obj5408, "body(1)named(1)", &meth_ast_body_40_1_41_named_40_1_41_5418, 2);
  int argcv_meth_ast_body_40_1_41_named_40_1_41_5418[] = {1, 1};
  meth_meth_ast_body_40_1_41_named_40_1_41_5418->type = alloc_MethodType(2, argcv_meth_ast_body_40_1_41_named_40_1_41_5418);
  meth_meth_ast_body_40_1_41_named_40_1_41_5418->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_named_40_1_41_5418->definitionLine = 1287;
// method "new(_,_)"
  block_savedest(obj5408);
  Object closure5421 = createclosure(2, "new(2)");
  setclosureframe(closure5421, stackframe);
  addtoclosure(closure5421, var_emptySeq);
  addtoclosure(closure5421, var_objectNode);
  struct UserObject *uo5421 = (struct UserObject*)obj5408;
  uo5421->data[3] = (Object)closure5421;
  Method *meth_meth_ast_new_40_2_41_5421 = addmethod2pos(obj5408, "new(2)", &meth_ast_new_40_2_41_5421, 3);
  int argcv_meth_ast_new_40_2_41_5421[] = {2};
  meth_meth_ast_new_40_2_41_5421->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_5421);
  meth_meth_ast_new_40_2_41_5421->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_5421->definitionLine = 1290;
  block_savedest(obj5408);
  Object closure6019 = createclosure(2, "new(2)$object(1)");
  setclosureframe(closure6019, stackframe);
  addtoclosure(closure6019, var_emptySeq);
  addtoclosure(closure6019, var_objectNode);
  Method *meth_meth_ast_new_40_2_41_5421_object = addmethod2pos(obj5408, "new(2)$object(1)", &meth_ast_new_40_2_41_5421_object, 3);
  meth_meth_ast_new_40_2_41_5421_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_5421_object->definitionLine = 1290;
  sourceObject = obj5408;
  sourceObject = obj5408;
  sourceObject = obj5408;
  objclass5408 = obj5408->class;
  objclass5408->definitionModule = modulename;
  objclass5408->definitionLine = 1280;
  (*(struct UserObject *)self).data[0] = lowerouter5408;
  self = oldself5408;
  selfslot = oldselfslot5408;
  stackframe = oldstackframe5408;
// compiled object node returning obj5408 (depth = 2)
  *var_objectNode = obj5408;
  if (obj5408 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "objectNode"
  block_savedest(self);
  Object closure6020 = createclosure(1, "objectNode");
  setclosureframe(closure6020, stackframe);
  addtoclosure(closure6020, var_objectNode);
  struct UserObject *uo6020 = (struct UserObject*)self;
  uo6020->data[29] = (Object)closure6020;
  Method *meth_meth_ast_objectNode6020 = addmethod2pos(self, "objectNode", &meth_ast_objectNode6020, 29);
  int argcv_meth_ast_objectNode6020[] = {0};
  meth_meth_ast_objectNode6020->type = alloc_MethodType(1, argcv_meth_ast_objectNode6020);
  meth_meth_ast_objectNode6020->definitionModule = modulename;
  meth_meth_ast_objectNode6020->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6021 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6021 = alloc_userobj2(2,4, objclass6021);
  gc_frame_newslot(obj6021);
if (objclass6021 == NULL) {
  glfree(obj6021->class->name);
  obj6021->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6021, self, 0);
  addmethodreal(obj6021,"outer", &reader_ast_outer_6022);
  Object oldself6021 = self;
  struct StackFrameObject *oldstackframe6021 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6021);
  gc_frame_newslot((Object)stackframe);
  self = obj6021;
  Object *oldselfslot6021 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6021 = (*(struct UserObject *)self).data[0], lowerouter6021 = thisouter6021;
  if (inheritingObject6021) {
    struct UserObject *inho6021 = (struct UserObject *)inheritingObject6021;
    while (inho6021->super != GraceDefaultObject) inho6021 = (struct UserObject *)inho6021->super;
    inho6021->super = obj6021;
    self = inheritingObject6021;
    *selfslot = self;
    lowerouter6021 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6021;
  }
// method "new(_)"
  block_savedest(obj6021);
  Object closure6023 = createclosure(2, "new(1)");
  setclosureframe(closure6023, stackframe);
  addtoclosure(closure6023, var_emptySeq);
  addtoclosure(closure6023, var_arrayNode);
  struct UserObject *uo6023 = (struct UserObject*)obj6021;
  uo6023->data[1] = (Object)closure6023;
  Method *meth_meth_ast_new_40_1_41_6023 = addmethod2pos(obj6021, "new(1)", &meth_ast_new_40_1_41_6023, 1);
  int argcv_meth_ast_new_40_1_41_6023[] = {1};
  meth_meth_ast_new_40_1_41_6023->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_6023);
  meth_meth_ast_new_40_1_41_6023->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_6023->definitionLine = 1457;
  block_savedest(obj6021);
  Object closure6154 = createclosure(2, "new(1)$object(1)");
  setclosureframe(closure6154, stackframe);
  addtoclosure(closure6154, var_emptySeq);
  addtoclosure(closure6154, var_arrayNode);
  Method *meth_meth_ast_new_40_1_41_6023_object = addmethod2pos(obj6021, "new(1)$object(1)", &meth_ast_new_40_1_41_6023_object, 1);
  meth_meth_ast_new_40_1_41_6023_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_6023_object->definitionLine = 1457;
  sourceObject = obj6021;
  objclass6021 = obj6021->class;
  objclass6021->definitionModule = modulename;
  objclass6021->definitionLine = 1456;
  (*(struct UserObject *)self).data[0] = lowerouter6021;
  self = oldself6021;
  selfslot = oldselfslot6021;
  stackframe = oldstackframe6021;
// compiled object node returning obj6021 (depth = 2)
  *var_arrayNode = obj6021;
  if (obj6021 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "arrayNode"
  block_savedest(self);
  Object closure6155 = createclosure(1, "arrayNode");
  setclosureframe(closure6155, stackframe);
  addtoclosure(closure6155, var_arrayNode);
  struct UserObject *uo6155 = (struct UserObject*)self;
  uo6155->data[30] = (Object)closure6155;
  Method *meth_meth_ast_arrayNode6155 = addmethod2pos(self, "arrayNode", &meth_ast_arrayNode6155, 30);
  int argcv_meth_ast_arrayNode6155[] = {0};
  meth_meth_ast_arrayNode6155->type = alloc_MethodType(1, argcv_meth_ast_arrayNode6155);
  meth_meth_ast_arrayNode6155->definitionModule = modulename;
  meth_meth_ast_arrayNode6155->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6156 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6156 = alloc_userobj2(3,4, objclass6156);
  gc_frame_newslot(obj6156);
if (objclass6156 == NULL) {
  glfree(obj6156->class->name);
  obj6156->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6156, self, 0);
  addmethodreal(obj6156,"outer", &reader_ast_outer_6157);
  Object oldself6156 = self;
  struct StackFrameObject *oldstackframe6156 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6156);
  gc_frame_newslot((Object)stackframe);
  self = obj6156;
  Object *oldselfslot6156 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6156 = (*(struct UserObject *)self).data[0], lowerouter6156 = thisouter6156;
  if (inheritingObject6156) {
    struct UserObject *inho6156 = (struct UserObject *)inheritingObject6156;
    while (inho6156->super != GraceDefaultObject) inho6156 = (struct UserObject *)inho6156->super;
    inho6156->super = obj6156;
    self = inheritingObject6156;
    *selfslot = self;
    lowerouter6156 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6156;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo6158 = (struct UserObject*)obj6156;
  uo6158->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_2_41_scope_40_1_41_6158 = addmethod2pos(obj6156, "new(2)scope(1)", &meth_ast_new_40_2_41_scope_40_1_41_6158, 1);
  int argcv_meth_ast_new_40_2_41_scope_40_1_41_6158[] = {2, 1};
  meth_meth_ast_new_40_2_41_scope_40_1_41_6158->type = alloc_MethodType(2, argcv_meth_ast_new_40_2_41_scope_40_1_41_6158);
  meth_meth_ast_new_40_2_41_scope_40_1_41_6158->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_scope_40_1_41_6158->definitionLine = 1503;
// method "new(_,_)"
  block_savedest(obj6156);
  Object closure6163 = createclosure(4, "new(2)");
  setclosureframe(closure6163, stackframe);
  addtoclosure(closure6163, var_emptySeq);
  addtoclosure(closure6163, var_fakeSymbolTable);
  addtoclosure(closure6163, var_identifierNode);
  addtoclosure(closure6163, var_memberNode);
  struct UserObject *uo6163 = (struct UserObject*)obj6156;
  uo6163->data[2] = (Object)closure6163;
  Method *meth_meth_ast_new_40_2_41_6163 = addmethod2pos(obj6156, "new(2)", &meth_ast_new_40_2_41_6163, 2);
  int argcv_meth_ast_new_40_2_41_6163[] = {2};
  meth_meth_ast_new_40_2_41_6163->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_6163);
  meth_meth_ast_new_40_2_41_6163->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6163->definitionLine = 1509;
  block_savedest(obj6156);
  Object closure6535 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure6535, stackframe);
  addtoclosure(closure6535, var_emptySeq);
  addtoclosure(closure6535, var_fakeSymbolTable);
  addtoclosure(closure6535, var_identifierNode);
  addtoclosure(closure6535, var_memberNode);
  Method *meth_meth_ast_new_40_2_41_6163_object = addmethod2pos(obj6156, "new(2)$object(1)", &meth_ast_new_40_2_41_6163_object, 2);
  meth_meth_ast_new_40_2_41_6163_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6163_object->definitionLine = 1509;
  sourceObject = obj6156;
  sourceObject = obj6156;
  objclass6156 = obj6156->class;
  objclass6156->definitionModule = modulename;
  objclass6156->definitionLine = 1502;
  (*(struct UserObject *)self).data[0] = lowerouter6156;
  self = oldself6156;
  selfslot = oldselfslot6156;
  stackframe = oldstackframe6156;
// compiled object node returning obj6156 (depth = 2)
  *var_memberNode = obj6156;
  if (obj6156 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "memberNode"
  block_savedest(self);
  Object closure6536 = createclosure(1, "memberNode");
  setclosureframe(closure6536, stackframe);
  addtoclosure(closure6536, var_memberNode);
  struct UserObject *uo6536 = (struct UserObject*)self;
  uo6536->data[31] = (Object)closure6536;
  Method *meth_meth_ast_memberNode6536 = addmethod2pos(self, "memberNode", &meth_ast_memberNode6536, 31);
  int argcv_meth_ast_memberNode6536[] = {0};
  meth_meth_ast_memberNode6536->type = alloc_MethodType(1, argcv_meth_ast_memberNode6536);
  meth_meth_ast_memberNode6536->definitionModule = modulename;
  meth_meth_ast_memberNode6536->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6537 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6537 = alloc_userobj2(2,4, objclass6537);
  gc_frame_newslot(obj6537);
if (objclass6537 == NULL) {
  glfree(obj6537->class->name);
  obj6537->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6537, self, 0);
  addmethodreal(obj6537,"outer", &reader_ast_outer_6538);
  Object oldself6537 = self;
  struct StackFrameObject *oldstackframe6537 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6537);
  gc_frame_newslot((Object)stackframe);
  self = obj6537;
  Object *oldselfslot6537 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6537 = (*(struct UserObject *)self).data[0], lowerouter6537 = thisouter6537;
  if (inheritingObject6537) {
    struct UserObject *inho6537 = (struct UserObject *)inheritingObject6537;
    while (inho6537->super != GraceDefaultObject) inho6537 = (struct UserObject *)inho6537->super;
    inho6537->super = obj6537;
    self = inheritingObject6537;
    *selfslot = self;
    lowerouter6537 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6537;
  }
// method "new(_,_)"
  block_savedest(obj6537);
  Object closure6539 = createclosure(1, "new(2)");
  setclosureframe(closure6539, stackframe);
  addtoclosure(closure6539, var_genericNode);
  struct UserObject *uo6539 = (struct UserObject*)obj6537;
  uo6539->data[1] = (Object)closure6539;
  Method *meth_meth_ast_new_40_2_41_6539 = addmethod2pos(obj6537, "new(2)", &meth_ast_new_40_2_41_6539, 1);
  int argcv_meth_ast_new_40_2_41_6539[] = {2};
  meth_meth_ast_new_40_2_41_6539->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_6539);
  meth_meth_ast_new_40_2_41_6539->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6539->definitionLine = 1605;
  block_savedest(obj6537);
  Object closure6696 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure6696, stackframe);
  addtoclosure(closure6696, var_genericNode);
  Method *meth_meth_ast_new_40_2_41_6539_object = addmethod2pos(obj6537, "new(2)$object(1)", &meth_ast_new_40_2_41_6539_object, 1);
  meth_meth_ast_new_40_2_41_6539_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6539_object->definitionLine = 1605;
  sourceObject = obj6537;
  objclass6537 = obj6537->class;
  objclass6537->definitionModule = modulename;
  objclass6537->definitionLine = 1604;
  (*(struct UserObject *)self).data[0] = lowerouter6537;
  self = oldself6537;
  selfslot = oldselfslot6537;
  stackframe = oldstackframe6537;
// compiled object node returning obj6537 (depth = 2)
  *var_genericNode = obj6537;
  if (obj6537 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "genericNode"
  block_savedest(self);
  Object closure6697 = createclosure(1, "genericNode");
  setclosureframe(closure6697, stackframe);
  addtoclosure(closure6697, var_genericNode);
  struct UserObject *uo6697 = (struct UserObject*)self;
  uo6697->data[32] = (Object)closure6697;
  Method *meth_meth_ast_genericNode6697 = addmethod2pos(self, "genericNode", &meth_ast_genericNode6697, 32);
  int argcv_meth_ast_genericNode6697[] = {0};
  meth_meth_ast_genericNode6697->type = alloc_MethodType(1, argcv_meth_ast_genericNode6697);
  meth_meth_ast_genericNode6697->definitionModule = modulename;
  meth_meth_ast_genericNode6697->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6698 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6698 = alloc_userobj2(2,4, objclass6698);
  gc_frame_newslot(obj6698);
if (objclass6698 == NULL) {
  glfree(obj6698->class->name);
  obj6698->class->name = "typeParametersNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6698, self, 0);
  addmethodreal(obj6698,"outer", &reader_ast_outer_6699);
  Object oldself6698 = self;
  struct StackFrameObject *oldstackframe6698 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6698);
  gc_frame_newslot((Object)stackframe);
  self = obj6698;
  Object *oldselfslot6698 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6698 = (*(struct UserObject *)self).data[0], lowerouter6698 = thisouter6698;
  if (inheritingObject6698) {
    struct UserObject *inho6698 = (struct UserObject *)inheritingObject6698;
    while (inho6698->super != GraceDefaultObject) inho6698 = (struct UserObject *)inho6698->super;
    inho6698->super = obj6698;
    self = inheritingObject6698;
    *selfslot = self;
    lowerouter6698 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6698;
  }
// method "new(_)"
  block_savedest(obj6698);
  Object closure6700 = createclosure(3, "new(1)");
  setclosureframe(closure6700, stackframe);
  addtoclosure(closure6700, var_k);
  addtoclosure(closure6700, var_emptySeq);
  addtoclosure(closure6700, var_typeParametersNode);
  struct UserObject *uo6700 = (struct UserObject*)obj6698;
  uo6700->data[1] = (Object)closure6700;
  Method *meth_meth_ast_new_40_1_41_6700 = addmethod2pos(obj6698, "new(1)", &meth_ast_new_40_1_41_6700, 1);
  int argcv_meth_ast_new_40_1_41_6700[] = {1};
  meth_meth_ast_new_40_1_41_6700->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_6700);
  meth_meth_ast_new_40_1_41_6700->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_6700->definitionLine = 1650;
  block_savedest(obj6698);
  Object closure6859 = createclosure(3, "new(1)$object(1)");
  setclosureframe(closure6859, stackframe);
  addtoclosure(closure6859, var_k);
  addtoclosure(closure6859, var_emptySeq);
  addtoclosure(closure6859, var_typeParametersNode);
  Method *meth_meth_ast_new_40_1_41_6700_object = addmethod2pos(obj6698, "new(1)$object(1)", &meth_ast_new_40_1_41_6700_object, 1);
  meth_meth_ast_new_40_1_41_6700_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_6700_object->definitionLine = 1650;
  sourceObject = obj6698;
  objclass6698 = obj6698->class;
  objclass6698->definitionModule = modulename;
  objclass6698->definitionLine = 1649;
  (*(struct UserObject *)self).data[0] = lowerouter6698;
  self = oldself6698;
  selfslot = oldselfslot6698;
  stackframe = oldstackframe6698;
// compiled object node returning obj6698 (depth = 2)
  *var_typeParametersNode = obj6698;
  if (obj6698 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeParametersNode"
  block_savedest(self);
  Object closure6860 = createclosure(1, "typeParametersNode");
  setclosureframe(closure6860, stackframe);
  addtoclosure(closure6860, var_typeParametersNode);
  struct UserObject *uo6860 = (struct UserObject*)self;
  uo6860->data[33] = (Object)closure6860;
  Method *meth_meth_ast_typeParametersNode6860 = addmethod2pos(self, "typeParametersNode", &meth_ast_typeParametersNode6860, 33);
  int argcv_meth_ast_typeParametersNode6860[] = {0};
  meth_meth_ast_typeParametersNode6860->type = alloc_MethodType(1, argcv_meth_ast_typeParametersNode6860);
  meth_meth_ast_typeParametersNode6860->definitionModule = modulename;
  meth_meth_ast_typeParametersNode6860->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6861 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6861 = alloc_userobj2(3,4, objclass6861);
  gc_frame_newslot(obj6861);
if (objclass6861 == NULL) {
  glfree(obj6861->class->name);
  obj6861->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6861, self, 0);
  addmethodreal(obj6861,"outer", &reader_ast_outer_6862);
  Object oldself6861 = self;
  struct StackFrameObject *oldstackframe6861 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6861);
  gc_frame_newslot((Object)stackframe);
  self = obj6861;
  Object *oldselfslot6861 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6861 = (*(struct UserObject *)self).data[0], lowerouter6861 = thisouter6861;
  if (inheritingObject6861) {
    struct UserObject *inho6861 = (struct UserObject *)inheritingObject6861;
    while (inho6861->super != GraceDefaultObject) inho6861 = (struct UserObject *)inho6861->super;
    inho6861->super = obj6861;
    self = inheritingObject6861;
    *selfslot = self;
    lowerouter6861 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6861;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo6863 = (struct UserObject*)obj6861;
  uo6863->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_2_41_scope_40_1_41_6863 = addmethod2pos(obj6861, "new(2)scope(1)", &meth_ast_new_40_2_41_scope_40_1_41_6863, 1);
  int argcv_meth_ast_new_40_2_41_scope_40_1_41_6863[] = {2, 1};
  meth_meth_ast_new_40_2_41_scope_40_1_41_6863->type = alloc_MethodType(2, argcv_meth_ast_new_40_2_41_scope_40_1_41_6863);
  meth_meth_ast_new_40_2_41_scope_40_1_41_6863->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_scope_40_1_41_6863->definitionLine = 1698;
// method "new(_,_)"
  block_savedest(obj6861);
  Object closure6868 = createclosure(1, "new(2)");
  setclosureframe(closure6868, stackframe);
  addtoclosure(closure6868, var_identifierNode);
  struct UserObject *uo6868 = (struct UserObject*)obj6861;
  uo6868->data[2] = (Object)closure6868;
  Method *meth_meth_ast_new_40_2_41_6868 = addmethod2pos(obj6861, "new(2)", &meth_ast_new_40_2_41_6868, 2);
  int argcv_meth_ast_new_40_2_41_6868[] = {2};
  meth_meth_ast_new_40_2_41_6868->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_6868);
  meth_meth_ast_new_40_2_41_6868->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6868->definitionLine = 1704;
  block_savedest(obj6861);
  Object closure7282 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure7282, stackframe);
  addtoclosure(closure7282, var_identifierNode);
  Method *meth_meth_ast_new_40_2_41_6868_object = addmethod2pos(obj6861, "new(2)$object(1)", &meth_ast_new_40_2_41_6868_object, 2);
  meth_meth_ast_new_40_2_41_6868_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6868_object->definitionLine = 1704;
  sourceObject = obj6861;
  sourceObject = obj6861;
  objclass6861 = obj6861->class;
  objclass6861->definitionModule = modulename;
  objclass6861->definitionLine = 1696;
  (*(struct UserObject *)self).data[0] = lowerouter6861;
  self = oldself6861;
  selfslot = oldselfslot6861;
  stackframe = oldstackframe6861;
// compiled object node returning obj6861 (depth = 2)
  *var_identifierNode = obj6861;
  if (obj6861 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "identifierNode"
  block_savedest(self);
  Object closure7283 = createclosure(1, "identifierNode");
  setclosureframe(closure7283, stackframe);
  addtoclosure(closure7283, var_identifierNode);
  struct UserObject *uo7283 = (struct UserObject*)self;
  uo7283->data[34] = (Object)closure7283;
  Method *meth_meth_ast_identifierNode7283 = addmethod2pos(self, "identifierNode", &meth_ast_identifierNode7283, 34);
  int argcv_meth_ast_identifierNode7283[] = {0};
  meth_meth_ast_identifierNode7283->type = alloc_MethodType(1, argcv_meth_ast_identifierNode7283);
  meth_meth_ast_identifierNode7283->definitionModule = modulename;
  meth_meth_ast_identifierNode7283->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7284 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7285 == NULL) {
    strlit7285 = alloc_String("Type");
    gc_root(strlit7285);
  }
// compiled string node returning strlit7285 (depth = 3)
  gc_frame_newslot(strlit7285);
// starting to compile identifier node (depth = 3)
  Object bool7286 = alloc_Boolean(0);
// compiled identifier node returning bool7286 (depth = 3)
  gc_frame_newslot(bool7286);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7285;
  params[1] = bool7286;
  partcv[0] = 2;
  Object call7287 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7284);
// compiled call node returning call7287 (depth = 2)
  *var_typeType = call7287;
  if (call7287 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeType"
  block_savedest(self);
  Object closure7288 = createclosure(1, "typeType");
  setclosureframe(closure7288, stackframe);
  addtoclosure(closure7288, var_typeType);
  struct UserObject *uo7288 = (struct UserObject*)self;
  uo7288->data[35] = (Object)closure7288;
  Method *meth_meth_ast_typeType7288 = addmethod2pos(self, "typeType", &meth_ast_typeType7288, 35);
  int argcv_meth_ast_typeType7288[] = {0};
  meth_meth_ast_typeType7288->type = alloc_MethodType(1, argcv_meth_ast_typeType7288);
  meth_meth_ast_typeType7288->definitionModule = modulename;
  meth_meth_ast_typeType7288->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7289 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7290 == NULL) {
    strlit7290 = alloc_String("Unknown");
    gc_root(strlit7290);
  }
// compiled string node returning strlit7290 (depth = 3)
  gc_frame_newslot(strlit7290);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_newslot(*var_typeType);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7290;
  params[1] = *var_typeType;
  partcv[0] = 2;
  Object call7291 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7289);
// compiled call node returning call7291 (depth = 2)
  *var_unknownType = call7291;
  if (call7291 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unknownType"
  block_savedest(self);
  Object closure7292 = createclosure(1, "unknownType");
  setclosureframe(closure7292, stackframe);
  addtoclosure(closure7292, var_unknownType);
  struct UserObject *uo7292 = (struct UserObject*)self;
  uo7292->data[36] = (Object)closure7292;
  Method *meth_meth_ast_unknownType7292 = addmethod2pos(self, "unknownType", &meth_ast_unknownType7292, 36);
  int argcv_meth_ast_unknownType7292[] = {0};
  meth_meth_ast_unknownType7292->type = alloc_MethodType(1, argcv_meth_ast_unknownType7292);
  meth_meth_ast_unknownType7292->definitionModule = modulename;
  meth_meth_ast_unknownType7292->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7293 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7293 = alloc_userobj2(3,4, objclass7293);
  gc_frame_newslot(obj7293);
if (objclass7293 == NULL) {
  glfree(obj7293->class->name);
  obj7293->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7293, self, 0);
  addmethodreal(obj7293,"outer", &reader_ast_outer_7294);
  Object oldself7293 = self;
  struct StackFrameObject *oldstackframe7293 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7293);
  gc_frame_newslot((Object)stackframe);
  self = obj7293;
  Object *oldselfslot7293 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7293 = (*(struct UserObject *)self).data[0], lowerouter7293 = thisouter7293;
  if (inheritingObject7293) {
    struct UserObject *inho7293 = (struct UserObject *)inheritingObject7293;
    while (inho7293->super != GraceDefaultObject) inho7293 = (struct UserObject *)inho7293->super;
    inho7293->super = obj7293;
    self = inheritingObject7293;
    *selfslot = self;
    lowerouter7293 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7293;
  }
// method "new(_)scope(_)"
  struct UserObject *uo7295 = (struct UserObject*)obj7293;
  uo7295->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_1_41_scope_40_1_41_7295 = addmethod2pos(obj7293, "new(1)scope(1)", &meth_ast_new_40_1_41_scope_40_1_41_7295, 1);
  int argcv_meth_ast_new_40_1_41_scope_40_1_41_7295[] = {1, 1};
  meth_meth_ast_new_40_1_41_scope_40_1_41_7295->type = alloc_MethodType(2, argcv_meth_ast_new_40_1_41_scope_40_1_41_7295);
  meth_meth_ast_new_40_1_41_scope_40_1_41_7295->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_scope_40_1_41_7295->definitionLine = 1832;
// method "new(_)"
  block_savedest(obj7293);
  Object closure7300 = createclosure(1, "new(1)");
  setclosureframe(closure7300, stackframe);
  addtoclosure(closure7300, var_stringNode);
  struct UserObject *uo7300 = (struct UserObject*)obj7293;
  uo7300->data[2] = (Object)closure7300;
  Method *meth_meth_ast_new_40_1_41_7300 = addmethod2pos(obj7293, "new(1)", &meth_ast_new_40_1_41_7300, 2);
  int argcv_meth_ast_new_40_1_41_7300[] = {1};
  meth_meth_ast_new_40_1_41_7300->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_7300);
  meth_meth_ast_new_40_1_41_7300->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_7300->definitionLine = 1838;
  block_savedest(obj7293);
  Object closure7377 = createclosure(1, "new(1)$object(1)");
  setclosureframe(closure7377, stackframe);
  addtoclosure(closure7377, var_stringNode);
  Method *meth_meth_ast_new_40_1_41_7300_object = addmethod2pos(obj7293, "new(1)$object(1)", &meth_ast_new_40_1_41_7300_object, 2);
  meth_meth_ast_new_40_1_41_7300_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_7300_object->definitionLine = 1838;
  sourceObject = obj7293;
  sourceObject = obj7293;
  objclass7293 = obj7293->class;
  objclass7293->definitionModule = modulename;
  objclass7293->definitionLine = 1831;
  (*(struct UserObject *)self).data[0] = lowerouter7293;
  self = oldself7293;
  selfslot = oldselfslot7293;
  stackframe = oldstackframe7293;
// compiled object node returning obj7293 (depth = 2)
  *var_stringNode = obj7293;
  if (obj7293 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "stringNode"
  block_savedest(self);
  Object closure7378 = createclosure(1, "stringNode");
  setclosureframe(closure7378, stackframe);
  addtoclosure(closure7378, var_stringNode);
  struct UserObject *uo7378 = (struct UserObject*)self;
  uo7378->data[37] = (Object)closure7378;
  Method *meth_meth_ast_stringNode7378 = addmethod2pos(self, "stringNode", &meth_ast_stringNode7378, 37);
  int argcv_meth_ast_stringNode7378[] = {0};
  meth_meth_ast_stringNode7378->type = alloc_MethodType(1, argcv_meth_ast_stringNode7378);
  meth_meth_ast_stringNode7378->definitionModule = modulename;
  meth_meth_ast_stringNode7378->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7379 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7379 = alloc_userobj2(2,4, objclass7379);
  gc_frame_newslot(obj7379);
if (objclass7379 == NULL) {
  glfree(obj7379->class->name);
  obj7379->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7379, self, 0);
  addmethodreal(obj7379,"outer", &reader_ast_outer_7380);
  Object oldself7379 = self;
  struct StackFrameObject *oldstackframe7379 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7379);
  gc_frame_newslot((Object)stackframe);
  self = obj7379;
  Object *oldselfslot7379 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7379 = (*(struct UserObject *)self).data[0], lowerouter7379 = thisouter7379;
  if (inheritingObject7379) {
    struct UserObject *inho7379 = (struct UserObject *)inheritingObject7379;
    while (inho7379->super != GraceDefaultObject) inho7379 = (struct UserObject *)inho7379->super;
    inho7379->super = obj7379;
    self = inheritingObject7379;
    *selfslot = self;
    lowerouter7379 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7379;
  }
// method "new(_)"
  block_savedest(obj7379);
  Object closure7381 = createclosure(1, "new(1)");
  setclosureframe(closure7381, stackframe);
  addtoclosure(closure7381, var_numNode);
  struct UserObject *uo7381 = (struct UserObject*)obj7379;
  uo7381->data[1] = (Object)closure7381;
  Method *meth_meth_ast_new_40_1_41_7381 = addmethod2pos(obj7379, "new(1)", &meth_ast_new_40_1_41_7381, 1);
  int argcv_meth_ast_new_40_1_41_7381[] = {1};
  meth_meth_ast_new_40_1_41_7381->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_7381);
  meth_meth_ast_new_40_1_41_7381->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_7381->definitionLine = 1866;
  block_savedest(obj7379);
  Object closure7450 = createclosure(1, "new(1)$object(1)");
  setclosureframe(closure7450, stackframe);
  addtoclosure(closure7450, var_numNode);
  Method *meth_meth_ast_new_40_1_41_7381_object = addmethod2pos(obj7379, "new(1)$object(1)", &meth_ast_new_40_1_41_7381_object, 1);
  meth_meth_ast_new_40_1_41_7381_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_7381_object->definitionLine = 1866;
  sourceObject = obj7379;
  objclass7379 = obj7379->class;
  objclass7379->definitionModule = modulename;
  objclass7379->definitionLine = 1865;
  (*(struct UserObject *)self).data[0] = lowerouter7379;
  self = oldself7379;
  selfslot = oldselfslot7379;
  stackframe = oldstackframe7379;
// compiled object node returning obj7379 (depth = 2)
  *var_numNode = obj7379;
  if (obj7379 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "numNode"
  block_savedest(self);
  Object closure7451 = createclosure(1, "numNode");
  setclosureframe(closure7451, stackframe);
  addtoclosure(closure7451, var_numNode);
  struct UserObject *uo7451 = (struct UserObject*)self;
  uo7451->data[38] = (Object)closure7451;
  Method *meth_meth_ast_numNode7451 = addmethod2pos(self, "numNode", &meth_ast_numNode7451, 38);
  int argcv_meth_ast_numNode7451[] = {0};
  meth_meth_ast_numNode7451->type = alloc_MethodType(1, argcv_meth_ast_numNode7451);
  meth_meth_ast_numNode7451->definitionModule = modulename;
  meth_meth_ast_numNode7451->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7452 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7452 = alloc_userobj2(2,4, objclass7452);
  gc_frame_newslot(obj7452);
if (objclass7452 == NULL) {
  glfree(obj7452->class->name);
  obj7452->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7452, self, 0);
  addmethodreal(obj7452,"outer", &reader_ast_outer_7453);
  Object oldself7452 = self;
  struct StackFrameObject *oldstackframe7452 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7452);
  gc_frame_newslot((Object)stackframe);
  self = obj7452;
  Object *oldselfslot7452 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7452 = (*(struct UserObject *)self).data[0], lowerouter7452 = thisouter7452;
  if (inheritingObject7452) {
    struct UserObject *inho7452 = (struct UserObject *)inheritingObject7452;
    while (inho7452->super != GraceDefaultObject) inho7452 = (struct UserObject *)inho7452->super;
    inho7452->super = obj7452;
    self = inheritingObject7452;
    *selfslot = self;
    lowerouter7452 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7452;
  }
// method "new(_,_,_)"
  block_savedest(obj7452);
  Object closure7454 = createclosure(3, "new(3)");
  setclosureframe(closure7454, stackframe);
  addtoclosure(closure7454, var_identifierNode);
  addtoclosure(closure7454, var_nullNode);
  addtoclosure(closure7454, var_opNode);
  struct UserObject *uo7454 = (struct UserObject*)obj7452;
  uo7454->data[1] = (Object)closure7454;
  Method *meth_meth_ast_new_40_3_41_7454 = addmethod2pos(obj7452, "new(3)", &meth_ast_new_40_3_41_7454, 1);
  int argcv_meth_ast_new_40_3_41_7454[] = {3};
  meth_meth_ast_new_40_3_41_7454->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_7454);
  meth_meth_ast_new_40_3_41_7454->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_7454->definitionLine = 1893;
  block_savedest(obj7452);
  Object closure7734 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure7734, stackframe);
  addtoclosure(closure7734, var_identifierNode);
  addtoclosure(closure7734, var_nullNode);
  addtoclosure(closure7734, var_opNode);
  Method *meth_meth_ast_new_40_3_41_7454_object = addmethod2pos(obj7452, "new(3)$object(1)", &meth_ast_new_40_3_41_7454_object, 1);
  meth_meth_ast_new_40_3_41_7454_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_7454_object->definitionLine = 1893;
  sourceObject = obj7452;
  objclass7452 = obj7452->class;
  objclass7452->definitionModule = modulename;
  objclass7452->definitionLine = 1892;
  (*(struct UserObject *)self).data[0] = lowerouter7452;
  self = oldself7452;
  selfslot = oldselfslot7452;
  stackframe = oldstackframe7452;
// compiled object node returning obj7452 (depth = 2)
  *var_opNode = obj7452;
  if (obj7452 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "opNode"
  block_savedest(self);
  Object closure7735 = createclosure(1, "opNode");
  setclosureframe(closure7735, stackframe);
  addtoclosure(closure7735, var_opNode);
  struct UserObject *uo7735 = (struct UserObject*)self;
  uo7735->data[39] = (Object)closure7735;
  Method *meth_meth_ast_opNode7735 = addmethod2pos(self, "opNode", &meth_ast_opNode7735, 39);
  int argcv_meth_ast_opNode7735[] = {0};
  meth_meth_ast_opNode7735->type = alloc_MethodType(1, argcv_meth_ast_opNode7735);
  meth_meth_ast_opNode7735->definitionModule = modulename;
  meth_meth_ast_opNode7735->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7736 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7736 = alloc_userobj2(2,4, objclass7736);
  gc_frame_newslot(obj7736);
if (objclass7736 == NULL) {
  glfree(obj7736->class->name);
  obj7736->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7736, self, 0);
  addmethodreal(obj7736,"outer", &reader_ast_outer_7737);
  Object oldself7736 = self;
  struct StackFrameObject *oldstackframe7736 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7736);
  gc_frame_newslot((Object)stackframe);
  self = obj7736;
  Object *oldselfslot7736 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7736 = (*(struct UserObject *)self).data[0], lowerouter7736 = thisouter7736;
  if (inheritingObject7736) {
    struct UserObject *inho7736 = (struct UserObject *)inheritingObject7736;
    while (inho7736->super != GraceDefaultObject) inho7736 = (struct UserObject *)inho7736->super;
    inho7736->super = obj7736;
    self = inheritingObject7736;
    *selfslot = self;
    lowerouter7736 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7736;
  }
// method "new(_,_)"
  block_savedest(obj7736);
  Object closure7738 = createclosure(1, "new(2)");
  setclosureframe(closure7738, stackframe);
  addtoclosure(closure7738, var_bindNode);
  struct UserObject *uo7738 = (struct UserObject*)obj7736;
  uo7738->data[1] = (Object)closure7738;
  Method *meth_meth_ast_new_40_2_41_7738 = addmethod2pos(obj7736, "new(2)", &meth_ast_new_40_2_41_7738, 1);
  int argcv_meth_ast_new_40_2_41_7738[] = {2};
  meth_meth_ast_new_40_2_41_7738->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_7738);
  meth_meth_ast_new_40_2_41_7738->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_7738->definitionLine = 1960;
  block_savedest(obj7736);
  Object closure7909 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure7909, stackframe);
  addtoclosure(closure7909, var_bindNode);
  Method *meth_meth_ast_new_40_2_41_7738_object = addmethod2pos(obj7736, "new(2)$object(1)", &meth_ast_new_40_2_41_7738_object, 1);
  meth_meth_ast_new_40_2_41_7738_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_7738_object->definitionLine = 1960;
  sourceObject = obj7736;
  objclass7736 = obj7736->class;
  objclass7736->definitionModule = modulename;
  objclass7736->definitionLine = 1959;
  (*(struct UserObject *)self).data[0] = lowerouter7736;
  self = oldself7736;
  selfslot = oldselfslot7736;
  stackframe = oldstackframe7736;
// compiled object node returning obj7736 (depth = 2)
  *var_bindNode = obj7736;
  if (obj7736 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "bindNode"
  block_savedest(self);
  Object closure7910 = createclosure(1, "bindNode");
  setclosureframe(closure7910, stackframe);
  addtoclosure(closure7910, var_bindNode);
  struct UserObject *uo7910 = (struct UserObject*)self;
  uo7910->data[40] = (Object)closure7910;
  Method *meth_meth_ast_bindNode7910 = addmethod2pos(self, "bindNode", &meth_ast_bindNode7910, 40);
  int argcv_meth_ast_bindNode7910[] = {0};
  meth_meth_ast_bindNode7910->type = alloc_MethodType(1, argcv_meth_ast_bindNode7910);
  meth_meth_ast_bindNode7910->definitionModule = modulename;
  meth_meth_ast_bindNode7910->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7911 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7911 = alloc_userobj2(3,4, objclass7911);
  gc_frame_newslot(obj7911);
if (objclass7911 == NULL) {
  glfree(obj7911->class->name);
  obj7911->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7911, self, 0);
  addmethodreal(obj7911,"outer", &reader_ast_outer_7912);
  Object oldself7911 = self;
  struct StackFrameObject *oldstackframe7911 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7911);
  gc_frame_newslot((Object)stackframe);
  self = obj7911;
  Object *oldselfslot7911 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7911 = (*(struct UserObject *)self).data[0], lowerouter7911 = thisouter7911;
  if (inheritingObject7911) {
    struct UserObject *inho7911 = (struct UserObject *)inheritingObject7911;
    while (inho7911->super != GraceDefaultObject) inho7911 = (struct UserObject *)inho7911->super;
    inho7911->super = obj7911;
    self = inheritingObject7911;
    *selfslot = self;
    lowerouter7911 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7911;
  }
// method "new(_,_,_)scope(_)"
  struct UserObject *uo7913 = (struct UserObject*)obj7911;
  uo7913->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_3_41_scope_40_1_41_7913 = addmethod2pos(obj7911, "new(3)scope(1)", &meth_ast_new_40_3_41_scope_40_1_41_7913, 1);
  int argcv_meth_ast_new_40_3_41_scope_40_1_41_7913[] = {3, 1};
  meth_meth_ast_new_40_3_41_scope_40_1_41_7913->type = alloc_MethodType(2, argcv_meth_ast_new_40_3_41_scope_40_1_41_7913);
  meth_meth_ast_new_40_3_41_scope_40_1_41_7913->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_scope_40_1_41_7913->definitionLine = 2010;
// method "new(_,_,_)"
  block_savedest(obj7911);
  Object closure7918 = createclosure(2, "new(3)");
  setclosureframe(closure7918, stackframe);
  addtoclosure(closure7918, var_k);
  addtoclosure(closure7918, var_defDecNode);
  struct UserObject *uo7918 = (struct UserObject*)obj7911;
  uo7918->data[2] = (Object)closure7918;
  Method *meth_meth_ast_new_40_3_41_7918 = addmethod2pos(obj7911, "new(3)", &meth_ast_new_40_3_41_7918, 2);
  int argcv_meth_ast_new_40_3_41_7918[] = {3};
  meth_meth_ast_new_40_3_41_7918->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_7918);
  meth_meth_ast_new_40_3_41_7918->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_7918->definitionLine = 2016;
  block_savedest(obj7911);
  Object closure8375 = createclosure(2, "new(3)$object(1)");
  setclosureframe(closure8375, stackframe);
  addtoclosure(closure8375, var_k);
  addtoclosure(closure8375, var_defDecNode);
  Method *meth_meth_ast_new_40_3_41_7918_object = addmethod2pos(obj7911, "new(3)$object(1)", &meth_ast_new_40_3_41_7918_object, 2);
  meth_meth_ast_new_40_3_41_7918_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_7918_object->definitionLine = 2016;
  sourceObject = obj7911;
  sourceObject = obj7911;
  objclass7911 = obj7911->class;
  objclass7911->definitionModule = modulename;
  objclass7911->definitionLine = 2009;
  (*(struct UserObject *)self).data[0] = lowerouter7911;
  self = oldself7911;
  selfslot = oldselfslot7911;
  stackframe = oldstackframe7911;
// compiled object node returning obj7911 (depth = 2)
  *var_defDecNode = obj7911;
  if (obj7911 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defDecNode"
  block_savedest(self);
  Object closure8376 = createclosure(1, "defDecNode");
  setclosureframe(closure8376, stackframe);
  addtoclosure(closure8376, var_defDecNode);
  struct UserObject *uo8376 = (struct UserObject*)self;
  uo8376->data[41] = (Object)closure8376;
  Method *meth_meth_ast_defDecNode8376 = addmethod2pos(self, "defDecNode", &meth_ast_defDecNode8376, 41);
  int argcv_meth_ast_defDecNode8376[] = {0};
  meth_meth_ast_defDecNode8376->type = alloc_MethodType(1, argcv_meth_ast_defDecNode8376);
  meth_meth_ast_defDecNode8376->definitionModule = modulename;
  meth_meth_ast_defDecNode8376->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8377 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8377 = alloc_userobj2(2,4, objclass8377);
  gc_frame_newslot(obj8377);
if (objclass8377 == NULL) {
  glfree(obj8377->class->name);
  obj8377->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8377, self, 0);
  addmethodreal(obj8377,"outer", &reader_ast_outer_8378);
  Object oldself8377 = self;
  struct StackFrameObject *oldstackframe8377 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8377);
  gc_frame_newslot((Object)stackframe);
  self = obj8377;
  Object *oldselfslot8377 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8377 = (*(struct UserObject *)self).data[0], lowerouter8377 = thisouter8377;
  if (inheritingObject8377) {
    struct UserObject *inho8377 = (struct UserObject *)inheritingObject8377;
    while (inho8377->super != GraceDefaultObject) inho8377 = (struct UserObject *)inho8377->super;
    inho8377->super = obj8377;
    self = inheritingObject8377;
    *selfslot = self;
    lowerouter8377 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8377;
  }
// method "new(_,_,_)"
  block_savedest(obj8377);
  Object closure8379 = createclosure(2, "new(3)");
  setclosureframe(closure8379, stackframe);
  addtoclosure(closure8379, var_k);
  addtoclosure(closure8379, var_varDecNode);
  struct UserObject *uo8379 = (struct UserObject*)obj8377;
  uo8379->data[1] = (Object)closure8379;
  Method *meth_meth_ast_new_40_3_41_8379 = addmethod2pos(obj8377, "new(3)", &meth_ast_new_40_3_41_8379, 1);
  int argcv_meth_ast_new_40_3_41_8379[] = {3};
  meth_meth_ast_new_40_3_41_8379->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_8379);
  meth_meth_ast_new_40_3_41_8379->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_8379->definitionLine = 2127;
  block_savedest(obj8377);
  Object closure8833 = createclosure(2, "new(3)$object(1)");
  setclosureframe(closure8833, stackframe);
  addtoclosure(closure8833, var_k);
  addtoclosure(closure8833, var_varDecNode);
  Method *meth_meth_ast_new_40_3_41_8379_object = addmethod2pos(obj8377, "new(3)$object(1)", &meth_ast_new_40_3_41_8379_object, 1);
  meth_meth_ast_new_40_3_41_8379_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_8379_object->definitionLine = 2127;
  sourceObject = obj8377;
  objclass8377 = obj8377->class;
  objclass8377->definitionModule = modulename;
  objclass8377->definitionLine = 2126;
  (*(struct UserObject *)self).data[0] = lowerouter8377;
  self = oldself8377;
  selfslot = oldselfslot8377;
  stackframe = oldstackframe8377;
// compiled object node returning obj8377 (depth = 2)
  *var_varDecNode = obj8377;
  if (obj8377 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "varDecNode"
  block_savedest(self);
  Object closure8834 = createclosure(1, "varDecNode");
  setclosureframe(closure8834, stackframe);
  addtoclosure(closure8834, var_varDecNode);
  struct UserObject *uo8834 = (struct UserObject*)self;
  uo8834->data[42] = (Object)closure8834;
  Method *meth_meth_ast_varDecNode8834 = addmethod2pos(self, "varDecNode", &meth_ast_varDecNode8834, 42);
  int argcv_meth_ast_varDecNode8834[] = {0};
  meth_meth_ast_varDecNode8834->type = alloc_MethodType(1, argcv_meth_ast_varDecNode8834);
  meth_meth_ast_varDecNode8834->definitionModule = modulename;
  meth_meth_ast_varDecNode8834->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8835 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8835 = alloc_userobj2(2,4, objclass8835);
  gc_frame_newslot(obj8835);
if (objclass8835 == NULL) {
  glfree(obj8835->class->name);
  obj8835->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8835, self, 0);
  addmethodreal(obj8835,"outer", &reader_ast_outer_8836);
  Object oldself8835 = self;
  struct StackFrameObject *oldstackframe8835 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8835);
  gc_frame_newslot((Object)stackframe);
  self = obj8835;
  Object *oldselfslot8835 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8835 = (*(struct UserObject *)self).data[0], lowerouter8835 = thisouter8835;
  if (inheritingObject8835) {
    struct UserObject *inho8835 = (struct UserObject *)inheritingObject8835;
    while (inho8835->super != GraceDefaultObject) inho8835 = (struct UserObject *)inho8835->super;
    inho8835->super = obj8835;
    self = inheritingObject8835;
    *selfslot = self;
    lowerouter8835 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8835;
  }
// method "new(_,_,_)"
  block_savedest(obj8835);
  Object closure8837 = createclosure(3, "new(3)");
  setclosureframe(closure8837, stackframe);
  addtoclosure(closure8837, var_k);
  addtoclosure(closure8837, var_nullNode);
  addtoclosure(closure8837, var_importNode);
  struct UserObject *uo8837 = (struct UserObject*)obj8835;
  uo8837->data[1] = (Object)closure8837;
  Method *meth_meth_ast_new_40_3_41_8837 = addmethod2pos(obj8835, "new(3)", &meth_ast_new_40_3_41_8837, 1);
  int argcv_meth_ast_new_40_3_41_8837[] = {3};
  meth_meth_ast_new_40_3_41_8837->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_8837);
  meth_meth_ast_new_40_3_41_8837->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_8837->definitionLine = 2235;
  block_savedest(obj8835);
  Object closure9113 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure9113, stackframe);
  addtoclosure(closure9113, var_k);
  addtoclosure(closure9113, var_nullNode);
  addtoclosure(closure9113, var_importNode);
  Method *meth_meth_ast_new_40_3_41_8837_object = addmethod2pos(obj8835, "new(3)$object(1)", &meth_ast_new_40_3_41_8837_object, 1);
  meth_meth_ast_new_40_3_41_8837_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_8837_object->definitionLine = 2235;
  sourceObject = obj8835;
  objclass8835 = obj8835->class;
  objclass8835->definitionModule = modulename;
  objclass8835->definitionLine = 2234;
  (*(struct UserObject *)self).data[0] = lowerouter8835;
  self = oldself8835;
  selfslot = oldselfslot8835;
  stackframe = oldstackframe8835;
// compiled object node returning obj8835 (depth = 2)
  *var_importNode = obj8835;
  if (obj8835 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "importNode"
  block_savedest(self);
  Object closure9114 = createclosure(1, "importNode");
  setclosureframe(closure9114, stackframe);
  addtoclosure(closure9114, var_importNode);
  struct UserObject *uo9114 = (struct UserObject*)self;
  uo9114->data[43] = (Object)closure9114;
  Method *meth_meth_ast_importNode9114 = addmethod2pos(self, "importNode", &meth_ast_importNode9114, 43);
  int argcv_meth_ast_importNode9114[] = {0};
  meth_meth_ast_importNode9114->type = alloc_MethodType(1, argcv_meth_ast_importNode9114);
  meth_meth_ast_importNode9114->definitionModule = modulename;
  meth_meth_ast_importNode9114->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9115 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9115 = alloc_userobj2(2,4, objclass9115);
  gc_frame_newslot(obj9115);
if (objclass9115 == NULL) {
  glfree(obj9115->class->name);
  obj9115->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9115, self, 0);
  addmethodreal(obj9115,"outer", &reader_ast_outer_9116);
  Object oldself9115 = self;
  struct StackFrameObject *oldstackframe9115 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9115);
  gc_frame_newslot((Object)stackframe);
  self = obj9115;
  Object *oldselfslot9115 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9115 = (*(struct UserObject *)self).data[0], lowerouter9115 = thisouter9115;
  if (inheritingObject9115) {
    struct UserObject *inho9115 = (struct UserObject *)inheritingObject9115;
    while (inho9115->super != GraceDefaultObject) inho9115 = (struct UserObject *)inho9115->super;
    inho9115->super = obj9115;
    self = inheritingObject9115;
    *selfslot = self;
    lowerouter9115 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9115;
  }
// method "new(_)"
  block_savedest(obj9115);
  Object closure9117 = createclosure(1, "new(1)");
  setclosureframe(closure9117, stackframe);
  addtoclosure(closure9117, var_dialectNode);
  struct UserObject *uo9117 = (struct UserObject*)obj9115;
  uo9117->data[1] = (Object)closure9117;
  Method *meth_meth_ast_new_40_1_41_9117 = addmethod2pos(obj9115, "new(1)", &meth_ast_new_40_1_41_9117, 1);
  int argcv_meth_ast_new_40_1_41_9117[] = {1};
  meth_meth_ast_new_40_1_41_9117->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_9117);
  meth_meth_ast_new_40_1_41_9117->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9117->definitionLine = 2312;
  block_savedest(obj9115);
  Object closure9229 = createclosure(1, "new(1)$object(1)");
  setclosureframe(closure9229, stackframe);
  addtoclosure(closure9229, var_dialectNode);
  Method *meth_meth_ast_new_40_1_41_9117_object = addmethod2pos(obj9115, "new(1)$object(1)", &meth_ast_new_40_1_41_9117_object, 1);
  meth_meth_ast_new_40_1_41_9117_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9117_object->definitionLine = 2312;
  sourceObject = obj9115;
  objclass9115 = obj9115->class;
  objclass9115->definitionModule = modulename;
  objclass9115->definitionLine = 2311;
  (*(struct UserObject *)self).data[0] = lowerouter9115;
  self = oldself9115;
  selfslot = oldselfslot9115;
  stackframe = oldstackframe9115;
// compiled object node returning obj9115 (depth = 2)
  *var_dialectNode = obj9115;
  if (obj9115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "dialectNode"
  block_savedest(self);
  Object closure9230 = createclosure(1, "dialectNode");
  setclosureframe(closure9230, stackframe);
  addtoclosure(closure9230, var_dialectNode);
  struct UserObject *uo9230 = (struct UserObject*)self;
  uo9230->data[44] = (Object)closure9230;
  Method *meth_meth_ast_dialectNode9230 = addmethod2pos(self, "dialectNode", &meth_ast_dialectNode9230, 44);
  int argcv_meth_ast_dialectNode9230[] = {0};
  meth_meth_ast_dialectNode9230->type = alloc_MethodType(1, argcv_meth_ast_dialectNode9230);
  meth_meth_ast_dialectNode9230->definitionModule = modulename;
  meth_meth_ast_dialectNode9230->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9231 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9231 = alloc_userobj2(2,4, objclass9231);
  gc_frame_newslot(obj9231);
if (objclass9231 == NULL) {
  glfree(obj9231->class->name);
  obj9231->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9231, self, 0);
  addmethodreal(obj9231,"outer", &reader_ast_outer_9232);
  Object oldself9231 = self;
  struct StackFrameObject *oldstackframe9231 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9231);
  gc_frame_newslot((Object)stackframe);
  self = obj9231;
  Object *oldselfslot9231 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9231 = (*(struct UserObject *)self).data[0], lowerouter9231 = thisouter9231;
  if (inheritingObject9231) {
    struct UserObject *inho9231 = (struct UserObject *)inheritingObject9231;
    while (inho9231->super != GraceDefaultObject) inho9231 = (struct UserObject *)inho9231->super;
    inho9231->super = obj9231;
    self = inheritingObject9231;
    *selfslot = self;
    lowerouter9231 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9231;
  }
// method "new(_)"
  block_savedest(obj9231);
  Object closure9233 = createclosure(2, "new(1)");
  setclosureframe(closure9233, stackframe);
  addtoclosure(closure9233, var_nullNode);
  addtoclosure(closure9233, var_returnNode);
  struct UserObject *uo9233 = (struct UserObject*)obj9231;
  uo9233->data[1] = (Object)closure9233;
  Method *meth_meth_ast_new_40_1_41_9233 = addmethod2pos(obj9231, "new(1)", &meth_ast_new_40_1_41_9233, 1);
  int argcv_meth_ast_new_40_1_41_9233[] = {1};
  meth_meth_ast_new_40_1_41_9233->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_9233);
  meth_meth_ast_new_40_1_41_9233->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9233->definitionLine = 2360;
  block_savedest(obj9231);
  Object closure9319 = createclosure(2, "new(1)$object(1)");
  setclosureframe(closure9319, stackframe);
  addtoclosure(closure9319, var_nullNode);
  addtoclosure(closure9319, var_returnNode);
  Method *meth_meth_ast_new_40_1_41_9233_object = addmethod2pos(obj9231, "new(1)$object(1)", &meth_ast_new_40_1_41_9233_object, 1);
  meth_meth_ast_new_40_1_41_9233_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9233_object->definitionLine = 2360;
  sourceObject = obj9231;
  objclass9231 = obj9231->class;
  objclass9231->definitionModule = modulename;
  objclass9231->definitionLine = 2359;
  (*(struct UserObject *)self).data[0] = lowerouter9231;
  self = oldself9231;
  selfslot = oldselfslot9231;
  stackframe = oldstackframe9231;
// compiled object node returning obj9231 (depth = 2)
  *var_returnNode = obj9231;
  if (obj9231 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "returnNode"
  block_savedest(self);
  Object closure9320 = createclosure(1, "returnNode");
  setclosureframe(closure9320, stackframe);
  addtoclosure(closure9320, var_returnNode);
  struct UserObject *uo9320 = (struct UserObject*)self;
  uo9320->data[45] = (Object)closure9320;
  Method *meth_meth_ast_returnNode9320 = addmethod2pos(self, "returnNode", &meth_ast_returnNode9320, 45);
  int argcv_meth_ast_returnNode9320[] = {0};
  meth_meth_ast_returnNode9320->type = alloc_MethodType(1, argcv_meth_ast_returnNode9320);
  meth_meth_ast_returnNode9320->definitionModule = modulename;
  meth_meth_ast_returnNode9320->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9321 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9321 = alloc_userobj2(3,4, objclass9321);
  gc_frame_newslot(obj9321);
if (objclass9321 == NULL) {
  glfree(obj9321->class->name);
  obj9321->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9321, self, 0);
  addmethodreal(obj9321,"outer", &reader_ast_outer_9322);
  Object oldself9321 = self;
  struct StackFrameObject *oldstackframe9321 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9321);
  gc_frame_newslot((Object)stackframe);
  self = obj9321;
  Object *oldselfslot9321 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9321 = (*(struct UserObject *)self).data[0], lowerouter9321 = thisouter9321;
  if (inheritingObject9321) {
    struct UserObject *inho9321 = (struct UserObject *)inheritingObject9321;
    while (inho9321->super != GraceDefaultObject) inho9321 = (struct UserObject *)inho9321->super;
    inho9321->super = obj9321;
    self = inheritingObject9321;
    *selfslot = self;
    lowerouter9321 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9321;
  }
// method "new(_)scope(_)"
  struct UserObject *uo9323 = (struct UserObject*)obj9321;
  uo9323->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_1_41_scope_40_1_41_9323 = addmethod2pos(obj9321, "new(1)scope(1)", &meth_ast_new_40_1_41_scope_40_1_41_9323, 1);
  int argcv_meth_ast_new_40_1_41_scope_40_1_41_9323[] = {1, 1};
  meth_meth_ast_new_40_1_41_scope_40_1_41_9323->type = alloc_MethodType(2, argcv_meth_ast_new_40_1_41_scope_40_1_41_9323);
  meth_meth_ast_new_40_1_41_scope_40_1_41_9323->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_scope_40_1_41_9323->definitionLine = 2395;
// method "new(_)"
  block_savedest(obj9321);
  Object closure9328 = createclosure(3, "new(1)");
  setclosureframe(closure9328, stackframe);
  addtoclosure(closure9328, var_k);
  addtoclosure(closure9328, var_nullNode);
  addtoclosure(closure9328, var_inheritsNode);
  struct UserObject *uo9328 = (struct UserObject*)obj9321;
  uo9328->data[2] = (Object)closure9328;
  Method *meth_meth_ast_new_40_1_41_9328 = addmethod2pos(obj9321, "new(1)", &meth_ast_new_40_1_41_9328, 2);
  int argcv_meth_ast_new_40_1_41_9328[] = {1};
  meth_meth_ast_new_40_1_41_9328->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_9328);
  meth_meth_ast_new_40_1_41_9328->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9328->definitionLine = 2400;
  block_savedest(obj9321);
  Object closure9712 = createclosure(3, "new(1)$object(1)");
  setclosureframe(closure9712, stackframe);
  addtoclosure(closure9712, var_k);
  addtoclosure(closure9712, var_nullNode);
  addtoclosure(closure9712, var_inheritsNode);
  Method *meth_meth_ast_new_40_1_41_9328_object = addmethod2pos(obj9321, "new(1)$object(1)", &meth_ast_new_40_1_41_9328_object, 2);
  meth_meth_ast_new_40_1_41_9328_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9328_object->definitionLine = 2400;
  sourceObject = obj9321;
  sourceObject = obj9321;
  objclass9321 = obj9321->class;
  objclass9321->definitionModule = modulename;
  objclass9321->definitionLine = 2394;
  (*(struct UserObject *)self).data[0] = lowerouter9321;
  self = oldself9321;
  selfslot = oldselfslot9321;
  stackframe = oldstackframe9321;
// compiled object node returning obj9321 (depth = 2)
  *var_inheritsNode = obj9321;
  if (obj9321 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "inheritsNode"
  block_savedest(self);
  Object closure9713 = createclosure(1, "inheritsNode");
  setclosureframe(closure9713, stackframe);
  addtoclosure(closure9713, var_inheritsNode);
  struct UserObject *uo9713 = (struct UserObject*)self;
  uo9713->data[46] = (Object)closure9713;
  Method *meth_meth_ast_inheritsNode9713 = addmethod2pos(self, "inheritsNode", &meth_ast_inheritsNode9713, 46);
  int argcv_meth_ast_inheritsNode9713[] = {0};
  meth_meth_ast_inheritsNode9713->type = alloc_MethodType(1, argcv_meth_ast_inheritsNode9713);
  meth_meth_ast_inheritsNode9713->definitionModule = modulename;
  meth_meth_ast_inheritsNode9713->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AliasPair
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type9715 = alloc_Type("AliasPair", 2);
    add_Method((ClassData)type9715, "newName", NULL);
    add_Method((ClassData)type9715, "oldName", NULL);
// compiled typeliteral node returning type9715 (depth = 2)
  *var_AliasPair = type9715;
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AliasPair"
  block_savedest(self);
  Object closure9716 = createclosure(1, "AliasPair");
  setclosureframe(closure9716, stackframe);
  addtoclosure(closure9716, var_AliasPair);
  struct UserObject *uo9716 = (struct UserObject*)self;
  uo9716->data[47] = (Object)closure9716;
  Method *meth_meth_ast_AliasPair9716 = addmethod2pos(self, "AliasPair", &meth_ast_AliasPair9716, 47);
  int argcv_meth_ast_AliasPair9716[] = {0};
  meth_meth_ast_AliasPair9716->type = alloc_MethodType(1, argcv_meth_ast_AliasPair9716);
  meth_meth_ast_AliasPair9716->definitionModule = modulename;
  meth_meth_ast_AliasPair9716->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9717 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9717 = alloc_userobj2(2,4, objclass9717);
  gc_frame_newslot(obj9717);
if (objclass9717 == NULL) {
  glfree(obj9717->class->name);
  obj9717->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9717, self, 0);
  addmethodreal(obj9717,"outer", &reader_ast_outer_9718);
  Object oldself9717 = self;
  struct StackFrameObject *oldstackframe9717 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9717);
  gc_frame_newslot((Object)stackframe);
  self = obj9717;
  Object *oldselfslot9717 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9717 = (*(struct UserObject *)self).data[0], lowerouter9717 = thisouter9717;
  if (inheritingObject9717) {
    struct UserObject *inho9717 = (struct UserObject *)inheritingObject9717;
    while (inho9717->super != GraceDefaultObject) inho9717 = (struct UserObject *)inho9717->super;
    inho9717->super = obj9717;
    self = inheritingObject9717;
    *selfslot = self;
    lowerouter9717 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9717;
  }
// method "new"
  block_savedest(obj9717);
  Object closure9719 = createclosure(1, "new");
  setclosureframe(closure9719, stackframe);
  addtoclosure(closure9719, var_blankNode);
  struct UserObject *uo9719 = (struct UserObject*)obj9717;
  uo9719->data[1] = (Object)closure9719;
  Method *meth_meth_ast_new9719 = addmethod2pos(obj9717, "new", &meth_ast_new9719, 1);
  int argcv_meth_ast_new9719[] = {0};
  meth_meth_ast_new9719->type = alloc_MethodType(1, argcv_meth_ast_new9719);
  meth_meth_ast_new9719->definitionModule = modulename;
  meth_meth_ast_new9719->definitionLine = 2523;
  block_savedest(obj9717);
  Object closure9755 = createclosure(1, "new$object(1)");
  setclosureframe(closure9755, stackframe);
  addtoclosure(closure9755, var_blankNode);
  Method *meth_meth_ast_new9719_object = addmethod2pos(obj9717, "new$object(1)", &meth_ast_new9719_object, 1);
  meth_meth_ast_new9719_object->definitionModule = modulename;
  meth_meth_ast_new9719_object->definitionLine = 2523;
  sourceObject = obj9717;
  objclass9717 = obj9717->class;
  objclass9717->definitionModule = modulename;
  objclass9717->definitionLine = 2522;
  (*(struct UserObject *)self).data[0] = lowerouter9717;
  self = oldself9717;
  selfslot = oldselfslot9717;
  stackframe = oldstackframe9717;
// compiled object node returning obj9717 (depth = 2)
  *var_blankNode = obj9717;
  if (obj9717 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankNode"
  block_savedest(self);
  Object closure9756 = createclosure(1, "blankNode");
  setclosureframe(closure9756, stackframe);
  addtoclosure(closure9756, var_blankNode);
  struct UserObject *uo9756 = (struct UserObject*)self;
  uo9756->data[48] = (Object)closure9756;
  Method *meth_meth_ast_blankNode9756 = addmethod2pos(self, "blankNode", &meth_ast_blankNode9756, 48);
  int argcv_meth_ast_blankNode9756[] = {0};
  meth_meth_ast_blankNode9756->type = alloc_MethodType(1, argcv_meth_ast_blankNode9756);
  meth_meth_ast_blankNode9756->definitionModule = modulename;
  meth_meth_ast_blankNode9756->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9757 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9757 = alloc_userobj2(6,7, objclass9757);
  gc_frame_newslot(obj9757);
if (objclass9757 == NULL) {
  glfree(obj9757->class->name);
  obj9757->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9757, self, 0);
  addmethodreal(obj9757,"outer", &reader_ast_outer_9758);
  Object oldself9757 = self;
  struct StackFrameObject *oldstackframe9757 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9757);
  gc_frame_newslot((Object)stackframe);
  self = obj9757;
  Object *oldselfslot9757 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9757 = (*(struct UserObject *)self).data[0], lowerouter9757 = thisouter9757;
  if (inheritingObject9757) {
    struct UserObject *inho9757 = (struct UserObject *)inheritingObject9757;
    while (inho9757->super != GraceDefaultObject) inho9757 = (struct UserObject *)inho9757->super;
    inho9757->super = obj9757;
    self = inheritingObject9757;
    *selfslot = self;
    lowerouter9757 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9757;
  }
// method "new"
  struct UserObject *uo9759 = (struct UserObject*)obj9757;
  uo9759->data[1] = emptyclosure;
  Method *meth_meth_ast_new9759 = addmethod2pos(obj9757, "new", &meth_ast_new9759, 1);
  int argcv_meth_ast_new9759[] = {0};
  meth_meth_ast_new9759->type = alloc_MethodType(1, argcv_meth_ast_new9759);
  meth_meth_ast_new9759->definitionModule = modulename;
  meth_meth_ast_new9759->definitionLine = 2547;
// method "partName(_)scope(_)"
  struct UserObject *uo9764 = (struct UserObject*)obj9757;
  uo9764->data[2] = emptyclosure;
  Method *meth_meth_ast_partName_40_1_41_scope_40_1_41_9764 = addmethod2pos(obj9757, "partName(1)scope(1)", &meth_ast_partName_40_1_41_scope_40_1_41_9764, 2);
  int argcv_meth_ast_partName_40_1_41_scope_40_1_41_9764[] = {1, 1};
  meth_meth_ast_partName_40_1_41_scope_40_1_41_9764->type = alloc_MethodType(2, argcv_meth_ast_partName_40_1_41_scope_40_1_41_9764);
  meth_meth_ast_partName_40_1_41_scope_40_1_41_9764->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_scope_40_1_41_9764->definitionLine = 2550;
// method "partName(_)params(_)scope(_)"
  struct UserObject *uo9770 = (struct UserObject*)obj9757;
  uo9770->data[3] = emptyclosure;
  Method *meth_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9770 = addmethod2pos(obj9757, "partName(1)params(1)scope(1)", &meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9770, 3);
  int argcv_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9770[] = {1, 1, 1};
  meth_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9770->type = alloc_MethodType(3, argcv_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9770);
  meth_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9770->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9770->definitionLine = 2555;
// method "partName(_)"
  struct UserObject *uo9775 = (struct UserObject*)obj9757;
  uo9775->data[4] = emptyclosure;
  Method *meth_meth_ast_partName_40_1_41_9775 = addmethod2pos(obj9757, "partName(1)", &meth_ast_partName_40_1_41_9775, 4);
  int argcv_meth_ast_partName_40_1_41_9775[] = {1};
  meth_meth_ast_partName_40_1_41_9775->type = alloc_MethodType(1, argcv_meth_ast_partName_40_1_41_9775);
  meth_meth_ast_partName_40_1_41_9775->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_9775->definitionLine = 2560;
// method "partName(_)params(_)"
  block_savedest(obj9757);
  Object closure9779 = createclosure(2, "partName(1)params(1)");
  setclosureframe(closure9779, stackframe);
  addtoclosure(closure9779, var_k);
  addtoclosure(closure9779, var_signaturePart);
  struct UserObject *uo9779 = (struct UserObject*)obj9757;
  uo9779->data[5] = (Object)closure9779;
  Method *meth_meth_ast_partName_40_1_41_params_40_1_41_9779 = addmethod2pos(obj9757, "partName(1)params(1)", &meth_ast_partName_40_1_41_params_40_1_41_9779, 5);
  int argcv_meth_ast_partName_40_1_41_params_40_1_41_9779[] = {1, 1};
  meth_meth_ast_partName_40_1_41_params_40_1_41_9779->type = alloc_MethodType(2, argcv_meth_ast_partName_40_1_41_params_40_1_41_9779);
  meth_meth_ast_partName_40_1_41_params_40_1_41_9779->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_params_40_1_41_9779->definitionLine = 2563;
  block_savedest(obj9757);
  Object closure10095 = createclosure(2, "partName(1)params(1)$object(1)");
  setclosureframe(closure10095, stackframe);
  addtoclosure(closure10095, var_k);
  addtoclosure(closure10095, var_signaturePart);
  Method *meth_meth_ast_partName_40_1_41_params_40_1_41_9779_object = addmethod2pos(obj9757, "partName(1)params(1)$object(1)", &meth_ast_partName_40_1_41_params_40_1_41_9779_object, 5);
  meth_meth_ast_partName_40_1_41_params_40_1_41_9779_object->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_params_40_1_41_9779_object->definitionLine = 2563;
  sourceObject = obj9757;
  sourceObject = obj9757;
  sourceObject = obj9757;
  sourceObject = obj9757;
  sourceObject = obj9757;
  objclass9757 = obj9757->class;
  objclass9757->definitionModule = modulename;
  objclass9757->definitionLine = 2546;
  (*(struct UserObject *)self).data[0] = lowerouter9757;
  self = oldself9757;
  selfslot = oldselfslot9757;
  stackframe = oldstackframe9757;
// compiled object node returning obj9757 (depth = 2)
  *var_signaturePart = obj9757;
  if (obj9757 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "signaturePart"
  block_savedest(self);
  Object closure10096 = createclosure(1, "signaturePart");
  setclosureframe(closure10096, stackframe);
  addtoclosure(closure10096, var_signaturePart);
  struct UserObject *uo10096 = (struct UserObject*)self;
  uo10096->data[49] = (Object)closure10096;
  Method *meth_meth_ast_signaturePart10096 = addmethod2pos(self, "signaturePart", &meth_ast_signaturePart10096, 49);
  int argcv_meth_ast_signaturePart10096[] = {0};
  meth_meth_ast_signaturePart10096->type = alloc_MethodType(1, argcv_meth_ast_signaturePart10096);
  meth_meth_ast_signaturePart10096->definitionModule = modulename;
  meth_meth_ast_signaturePart10096->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10097 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10097 = alloc_userobj2(4,5, objclass10097);
  gc_frame_newslot(obj10097);
if (objclass10097 == NULL) {
  glfree(obj10097->class->name);
  obj10097->class->name = "requestPart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10097, self, 0);
  addmethodreal(obj10097,"outer", &reader_ast_outer_10098);
  Object oldself10097 = self;
  struct StackFrameObject *oldstackframe10097 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10097);
  gc_frame_newslot((Object)stackframe);
  self = obj10097;
  Object *oldselfslot10097 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10097 = (*(struct UserObject *)self).data[0], lowerouter10097 = thisouter10097;
  if (inheritingObject10097) {
    struct UserObject *inho10097 = (struct UserObject *)inheritingObject10097;
    while (inho10097->super != GraceDefaultObject) inho10097 = (struct UserObject *)inho10097->super;
    inho10097->super = obj10097;
    self = inheritingObject10097;
    *selfslot = self;
    lowerouter10097 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10097;
  }
// method "new"
  struct UserObject *uo10099 = (struct UserObject*)obj10097;
  uo10099->data[1] = emptyclosure;
  Method *meth_meth_ast_new10099 = addmethod2pos(obj10097, "new", &meth_ast_new10099, 1);
  int argcv_meth_ast_new10099[] = {0};
  meth_meth_ast_new10099->type = alloc_MethodType(1, argcv_meth_ast_new10099);
  meth_meth_ast_new10099->definitionModule = modulename;
  meth_meth_ast_new10099->definitionLine = 2640;
// method "request(_)withArgs(_)scope(_)"
  struct UserObject *uo10104 = (struct UserObject*)obj10097;
  uo10104->data[2] = emptyclosure;
  Method *meth_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10104 = addmethod2pos(obj10097, "request(1)withArgs(1)scope(1)", &meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10104, 2);
  int argcv_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10104[] = {1, 1, 1};
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10104->type = alloc_MethodType(3, argcv_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10104);
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10104->definitionModule = modulename;
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10104->definitionLine = 2643;
// method "request(_)withArgs(_)"
  block_savedest(obj10097);
  Object closure10109 = createclosure(2, "request(1)withArgs(1)");
  setclosureframe(closure10109, stackframe);
  addtoclosure(closure10109, var_requestPart);
  addtoclosure(closure10109, var_emptySeq);
  struct UserObject *uo10109 = (struct UserObject*)obj10097;
  uo10109->data[3] = (Object)closure10109;
  Method *meth_meth_ast_request_40_1_41_withArgs_40_1_41_10109 = addmethod2pos(obj10097, "request(1)withArgs(1)", &meth_ast_request_40_1_41_withArgs_40_1_41_10109, 3);
  int argcv_meth_ast_request_40_1_41_withArgs_40_1_41_10109[] = {1, 1};
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10109->type = alloc_MethodType(2, argcv_meth_ast_request_40_1_41_withArgs_40_1_41_10109);
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10109->definitionModule = modulename;
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10109->definitionLine = 2648;
  block_savedest(obj10097);
  Object closure10431 = createclosure(2, "request(1)withArgs(1)$object(1)");
  setclosureframe(closure10431, stackframe);
  addtoclosure(closure10431, var_requestPart);
  addtoclosure(closure10431, var_emptySeq);
  Method *meth_meth_ast_request_40_1_41_withArgs_40_1_41_10109_object = addmethod2pos(obj10097, "request(1)withArgs(1)$object(1)", &meth_ast_request_40_1_41_withArgs_40_1_41_10109_object, 3);
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10109_object->definitionModule = modulename;
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10109_object->definitionLine = 2648;
  sourceObject = obj10097;
  sourceObject = obj10097;
  sourceObject = obj10097;
  objclass10097 = obj10097->class;
  objclass10097->definitionModule = modulename;
  objclass10097->definitionLine = 2639;
  (*(struct UserObject *)self).data[0] = lowerouter10097;
  self = oldself10097;
  selfslot = oldselfslot10097;
  stackframe = oldstackframe10097;
// compiled object node returning obj10097 (depth = 2)
  *var_requestPart = obj10097;
  if (obj10097 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "requestPart"
  block_savedest(self);
  Object closure10432 = createclosure(1, "requestPart");
  setclosureframe(closure10432, stackframe);
  addtoclosure(closure10432, var_requestPart);
  struct UserObject *uo10432 = (struct UserObject*)self;
  uo10432->data[50] = (Object)closure10432;
  Method *meth_meth_ast_requestPart10432 = addmethod2pos(self, "requestPart", &meth_ast_requestPart10432, 50);
  int argcv_meth_ast_requestPart10432[] = {0};
  meth_meth_ast_requestPart10432->type = alloc_MethodType(1, argcv_meth_ast_requestPart10432);
  meth_meth_ast_requestPart10432->definitionModule = modulename;
  meth_meth_ast_requestPart10432->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10433 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10433 = alloc_userobj2(2,4, objclass10433);
  gc_frame_newslot(obj10433);
if (objclass10433 == NULL) {
  glfree(obj10433->class->name);
  obj10433->class->name = "commentNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10433, self, 0);
  addmethodreal(obj10433,"outer", &reader_ast_outer_10434);
  Object oldself10433 = self;
  struct StackFrameObject *oldstackframe10433 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10433);
  gc_frame_newslot((Object)stackframe);
  self = obj10433;
  Object *oldselfslot10433 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10433 = (*(struct UserObject *)self).data[0], lowerouter10433 = thisouter10433;
  if (inheritingObject10433) {
    struct UserObject *inho10433 = (struct UserObject *)inheritingObject10433;
    while (inho10433->super != GraceDefaultObject) inho10433 = (struct UserObject *)inho10433->super;
    inho10433->super = obj10433;
    self = inheritingObject10433;
    *selfslot = self;
    lowerouter10433 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10433;
  }
// method "new(_)"
  block_savedest(obj10433);
  Object closure10435 = createclosure(4, "new(1)");
  setclosureframe(closure10435, stackframe);
  addtoclosure(closure10435, var_lineLength);
  addtoclosure(closure10435, var_nullNode);
  addtoclosure(closure10435, var_commentNode);
  addtoclosure(closure10435, var_util);
  struct UserObject *uo10435 = (struct UserObject*)obj10433;
  uo10435->data[1] = (Object)closure10435;
  Method *meth_meth_ast_new_40_1_41_10435 = addmethod2pos(obj10433, "new(1)", &meth_ast_new_40_1_41_10435, 1);
  int argcv_meth_ast_new_40_1_41_10435[] = {1};
  meth_meth_ast_new_40_1_41_10435->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_10435);
  meth_meth_ast_new_40_1_41_10435->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_10435->definitionLine = 2722;
  block_savedest(obj10433);
  Object closure10637 = createclosure(4, "new(1)$object(1)");
  setclosureframe(closure10637, stackframe);
  addtoclosure(closure10637, var_lineLength);
  addtoclosure(closure10637, var_nullNode);
  addtoclosure(closure10637, var_commentNode);
  addtoclosure(closure10637, var_util);
  Method *meth_meth_ast_new_40_1_41_10435_object = addmethod2pos(obj10433, "new(1)$object(1)", &meth_ast_new_40_1_41_10435_object, 1);
  meth_meth_ast_new_40_1_41_10435_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_10435_object->definitionLine = 2722;
  sourceObject = obj10433;
  objclass10433 = obj10433->class;
  objclass10433->definitionModule = modulename;
  objclass10433->definitionLine = 2721;
  (*(struct UserObject *)self).data[0] = lowerouter10433;
  self = oldself10433;
  selfslot = oldselfslot10433;
  stackframe = oldstackframe10433;
// compiled object node returning obj10433 (depth = 2)
  *var_commentNode = obj10433;
  if (obj10433 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "commentNode"
  block_savedest(self);
  Object closure10638 = createclosure(1, "commentNode");
  setclosureframe(closure10638, stackframe);
  addtoclosure(closure10638, var_commentNode);
  struct UserObject *uo10638 = (struct UserObject*)self;
  uo10638->data[51] = (Object)closure10638;
  Method *meth_meth_ast_commentNode10638 = addmethod2pos(self, "commentNode", &meth_ast_commentNode10638, 51);
  int argcv_meth_ast_commentNode10638[] = {0};
  meth_meth_ast_commentNode10638->type = alloc_MethodType(1, argcv_meth_ast_commentNode10638);
  meth_meth_ast_commentNode10638->definitionModule = modulename;
  meth_meth_ast_commentNode10638->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ASTVisitor
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type10640 = alloc_Type("ASTVisitor", 30);
    add_Method((ClassData)type10640, "visitIf(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitBlock(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitMatchCase(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitTryCatch(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitMethodType(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitSignaturePart(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitTypeLiteral(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitTypeParameters(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitTypeDec(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitMethod(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitCall(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitObject(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitModule(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitArray(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitMember(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitGeneric(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitIdentifier(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitString(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitNum(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitOp(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitBind(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitDefDec(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitVarDec(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitImport(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitReturn(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitInherits(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitDialect(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitBlank(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitComment(1)up(1)", NULL);
    add_Method((ClassData)type10640, "visitImplicit(1)up(1)", NULL);
// compiled typeliteral node returning type10640 (depth = 2)
  *var_ASTVisitor = type10640;
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ASTVisitor"
  block_savedest(self);
  Object closure10641 = createclosure(1, "ASTVisitor");
  setclosureframe(closure10641, stackframe);
  addtoclosure(closure10641, var_ASTVisitor);
  struct UserObject *uo10641 = (struct UserObject*)self;
  uo10641->data[52] = (Object)closure10641;
  Method *meth_meth_ast_ASTVisitor10641 = addmethod2pos(self, "ASTVisitor", &meth_ast_ASTVisitor10641, 52);
  int argcv_meth_ast_ASTVisitor10641[] = {0};
  meth_meth_ast_ASTVisitor10641->type = alloc_MethodType(1, argcv_meth_ast_ASTVisitor10641);
  meth_meth_ast_ASTVisitor10641->definitionModule = modulename;
  meth_meth_ast_ASTVisitor10641->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10642 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10642 = alloc_userobj2(1,2, objclass10642);
  gc_frame_newslot(obj10642);
if (objclass10642 == NULL) {
  glfree(obj10642->class->name);
  obj10642->class->name = "patternMarkVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10642, self, 0);
  addmethodreal(obj10642,"outer", &reader_ast_outer_10643);
  Object oldself10642 = self;
  struct StackFrameObject *oldstackframe10642 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10642);
  gc_frame_newslot((Object)stackframe);
  self = obj10642;
  Object *oldselfslot10642 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10642 = (*(struct UserObject *)self).data[0], lowerouter10642 = thisouter10642;
  if (inheritingObject10642) {
    struct UserObject *inho10642 = (struct UserObject *)inheritingObject10642;
    while (inho10642->super != GraceDefaultObject) inho10642 = (struct UserObject *)inho10642->super;
    inho10642->super = obj10642;
    self = inheritingObject10642;
    *selfslot = self;
    lowerouter10642 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10642;
  }
// method "visitCall(_)up(_)"
  struct UserObject *uo10644 = (struct UserObject*)obj10642;
  uo10644->data[1] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_10644 = addmethod2pos(obj10642, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_10644, 1);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_10644[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_10644->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_10644);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_10644->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_10644->definitionLine = 2953;
  sourceObject = obj10642;
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10649 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10650 = gc_frame_new();
// call case 3: self.outer request
  Object call10651 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10650);
// compiled member node returning call10651 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10652 = callmethodflags(call10651, "baseVisitor$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10649);
// compiled call node returning call10652 (depth = 3)
  struct UserObject *obj10642_uo = (struct UserObject *)obj10642;
  obj10642_uo->super = call10652;
  sourceObject = obj10642;
  objclass10642 = obj10642->class;
  objclass10642->definitionModule = modulename;
  objclass10642->definitionLine = 2951;
  (*(struct UserObject *)self).data[0] = lowerouter10642;
  self = oldself10642;
  selfslot = oldselfslot10642;
  stackframe = oldstackframe10642;
// compiled object node returning obj10642 (depth = 2)
  *var_patternMarkVisitor = obj10642;
  if (obj10642 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "patternMarkVisitor"
  block_savedest(self);
  Object closure10653 = createclosure(1, "patternMarkVisitor");
  setclosureframe(closure10653, stackframe);
  addtoclosure(closure10653, var_patternMarkVisitor);
  struct UserObject *uo10653 = (struct UserObject*)self;
  uo10653->data[53] = (Object)closure10653;
  Method *meth_meth_ast_patternMarkVisitor10653 = addmethod2pos(self, "patternMarkVisitor", &meth_ast_patternMarkVisitor10653, 53);
  int argcv_meth_ast_patternMarkVisitor10653[] = {0};
  meth_meth_ast_patternMarkVisitor10653->type = alloc_MethodType(1, argcv_meth_ast_patternMarkVisitor10653);
  meth_meth_ast_patternMarkVisitor10653->definitionModule = modulename;
  meth_meth_ast_patternMarkVisitor10653->definitionLine = 2969;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
